/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/event","vs/editor/common/core/range","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Q=function(y){for(var n=[],R=0,T=y.length;R<T;R++)n[R]=Y[y[R]];return n},Ne=this,Ee=typeof global=="object"?global:{},ee;(function(y){y.global=Ne;var n=function(){function R(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(R.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),R.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=R._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof y.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},R._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},R}();y.Environment=n})(ee||(ee={}));var ee;(function(y){var n=function(){function D(u,L,f){this.type=u,this.detail=L,this.timestamp=f}return D}();y.LoaderEvent=n;var R=function(){function D(u){this._events=[new n(1,"",u)]}return D.prototype.record=function(u,L){this._events.push(new n(u,L,y.Utilities.getHighPerformanceTimestamp()))},D.prototype.getEvents=function(){return this._events},D}();y.LoaderEventRecorder=R;var T=function(){function D(){}return D.prototype.record=function(u,L){},D.prototype.getEvents=function(){return[]},D.INSTANCE=new D,D}();y.NullLoaderEventRecorder=T})(ee||(ee={}));var ee;(function(y){var n=function(){function R(){}return R.fileUriToFilePath=function(T,D){if(D=decodeURI(D).replace(/%23/g,"#"),T){if(/^file:\/\/\//.test(D))return D.substr(8);if(/^file:\/\//.test(D))return D.substr(5)}else if(/^file:\/\//.test(D))return D.substr(7);return D},R.startsWith=function(T,D){return T.length>=D.length&&T.substr(0,D.length)===D},R.endsWith=function(T,D){return T.length>=D.length&&T.substr(T.length-D.length)===D},R.containsQueryString=function(T){return/^[^\#]*\?/gi.test(T)},R.isAbsolutePath=function(T){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(T)},R.forEachProperty=function(T,D){if(T){var u=void 0;for(u in T)T.hasOwnProperty(u)&&D(u,T[u])}},R.isEmpty=function(T){var D=!0;return R.forEachProperty(T,function(){D=!1}),D},R.recursiveClone=function(T){if(!T||typeof T!="object"||T instanceof RegExp||!Array.isArray(T)&&Object.getPrototypeOf(T)!==Object.prototype)return T;var D=Array.isArray(T)?[]:{};return R.forEachProperty(T,function(u,L){L&&typeof L=="object"?D[u]=R.recursiveClone(L):D[u]=L}),D},R.generateAnonymousModule=function(){return"===anonymous"+R.NEXT_ANONYMOUS_ID+++"==="},R.isAnonymousModule=function(T){return R.startsWith(T,"===anonymous")},R.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=y.global.performance&&typeof y.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?y.global.performance.now():Date.now()},R.NEXT_ANONYMOUS_ID=1,R.PERFORMANCE_NOW_PROBED=!1,R.HAS_PERFORMANCE_NOW=!1,R}();y.Utilities=n})(ee||(ee={}));var ee;(function(y){function n(D){if(D instanceof Error)return D;var u=new Error(D.message||String(D)||"Unknown Error");return D.stack&&(u.stack=D.stack),u}y.ensureError=n;var R=function(){function D(){}return D.validateConfigurationOptions=function(u){function L(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory method of "'+a.moduleId+'" has thrown an exception'),console.error(a);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError=="undefined"&&(u.catchError=!1),typeof u.recordStats=="undefined"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=L),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(y.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags=="undefined"&&(u.preferScriptTags=!1),Array.isArray(u.nodeModules)||(u.nodeModules=[]),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){var f=n(new Error("INVALID cached data configuration, 'path' MUST be set"));f.phase="configuration",u.onError(f),u.nodeCachedData=void 0}return u},D.mergeConfigurationOptions=function(u,L){u===void 0&&(u=null),L===void 0&&(L=null);var f=y.Utilities.recursiveClone(L||{});return y.Utilities.forEachProperty(u,function(a,c){a==="ignoreDuplicateModules"&&typeof f.ignoreDuplicateModules!="undefined"?f.ignoreDuplicateModules=f.ignoreDuplicateModules.concat(c):a==="paths"&&typeof f.paths!="undefined"?y.Utilities.forEachProperty(c,function(v,A){return f.paths[v]=A}):a==="config"&&typeof f.config!="undefined"?y.Utilities.forEachProperty(c,function(v,A){return f.config[v]=A}):f[a]=y.Utilities.recursiveClone(c)}),D.validateConfigurationOptions(f)},D}();y.ConfigurationOptionsUtil=R;var T=function(){function D(u,L){if(this._env=u,this.options=R.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var f=this.options.nodeRequire.main.filename,a=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,a+1)}if(this.options.nodeMain&&this._env.isNode){var f=this.options.nodeMain,a=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,a+1)}}}return D.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0},D.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var u=0,L=this.options.nodeModules;u<L.length;u++){var f=L[u];this.nodeModulesMap[f]=!0}},D.prototype._createSortedPathsRules=function(){var u=this;this.sortedPathsRules=[],y.Utilities.forEachProperty(this.options.paths,function(L,f){Array.isArray(f)?u.sortedPathsRules.push({from:L,to:f}):u.sortedPathsRules.push({from:L,to:[f]})}),this.sortedPathsRules.sort(function(L,f){return f.from.length-L.from.length})},D.prototype.cloneAndMerge=function(u){return new D(this._env,R.mergeConfigurationOptions(u,this.options))},D.prototype.getOptionsLiteral=function(){return this.options},D.prototype._applyPaths=function(u){for(var L,f=0,a=this.sortedPathsRules.length;f<a;f++)if(L=this.sortedPathsRules[f],y.Utilities.startsWith(u,L.from)){for(var c=[],v=0,A=L.to.length;v<A;v++)c.push(L.to[v]+u.substr(L.from.length));return c}return[u]},D.prototype._addUrlArgsToUrl=function(u){return y.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs},D.prototype._addUrlArgsIfNecessaryToUrl=function(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u},D.prototype._addUrlArgsIfNecessaryToUrls=function(u){if(this.options.urlArgs)for(var L=0,f=u.length;L<f;L++)u[L]=this._addUrlArgsToUrl(u[L]);return u},D.prototype.moduleIdToPaths=function(u){if(this._env.isNode){var L=this.nodeModulesMap[u]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u);if(L)return this.isBuild()?["empty:"]:["node|"+u]}var f=u,a;if(!y.Utilities.endsWith(f,".js")&&!y.Utilities.isAbsolutePath(f)){a=this._applyPaths(f);for(var c=0,v=a.length;c<v;c++)this.isBuild()&&a[c]==="empty:"||(y.Utilities.isAbsolutePath(a[c])||(a[c]=this.options.baseUrl+a[c]),!y.Utilities.endsWith(a[c],".js")&&!y.Utilities.containsQueryString(a[c])&&(a[c]=a[c]+".js"))}else!y.Utilities.endsWith(f,".js")&&!y.Utilities.containsQueryString(f)&&(f=f+".js"),a=[f];return this._addUrlArgsIfNecessaryToUrls(a)},D.prototype.requireToUrl=function(u){var L=u;return y.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],y.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)},D.prototype.isBuild=function(){return this.options.isBuild},D.prototype.isDuplicateMessageIgnoredFor=function(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)},D.prototype.getConfigForModule=function(u){if(this.options.config)return this.options.config[u]},D.prototype.shouldCatchError=function(){return this.options.catchError},D.prototype.shouldRecordStats=function(){return this.options.recordStats},D.prototype.onError=function(u){this.options.onError(u)},D}();y.Configuration=T})(ee||(ee={}));var ee;(function(y){var n=function(){function a(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(c,v,A,g){var d=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){var e=c.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new R:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new R;var w={callback:A,errorback:g};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(w);return}this._callbackMap[v]=[w],this._scriptLoader.load(c,v,function(){return d.triggerCallback(v)},function(p){return d.triggerErrorback(v,p)})},a.prototype.triggerCallback=function(c){var v=this._callbackMap[c];delete this._callbackMap[c];for(var A=0;A<v.length;A++)v[A].callback()},a.prototype.triggerErrorback=function(c,v){var A=this._callbackMap[c];delete this._callbackMap[c];for(var g=0;g<A.length;g++)A[g].errorback(v)},a}(),R=function(){function a(){}return a.prototype.attachListeners=function(c,v,A){var g=function(){c.removeEventListener("load",d),c.removeEventListener("error",e)},d=function(w){g(),v()},e=function(w){g(),A(w)};c.addEventListener("load",d),c.addEventListener("error",e)},a.prototype.load=function(c,v,A,g){if(/^node\|/.test(v)){var d=c.getConfig().getOptionsLiteral(),e=L(c.getRecorder(),d.nodeRequire||y.global.nodeRequire),w=v.split("|"),p=null;try{p=e(w[1])}catch(r){g(r);return}c.enqueueDefineAnonymousModule([],function(){return p}),A()}else{var N=document.createElement("script");N.setAttribute("async","async"),N.setAttribute("type","text/javascript"),this.attachListeners(N,A,g);var M=c.getConfig().getOptionsLiteral().trustedTypesPolicy;M&&(v=M.createScriptURL(v)),N.setAttribute("src",v);var i=c.getConfig().getOptionsLiteral().cspNonce;i&&N.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(N)}},a}();function T(a){var c=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var v=c?self.eval(c.createScript("","true")):new Function("true");return v.call(self),!0}catch(A){return!1}}var D=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=T(c)),this._cachedCanUseEval},a.prototype.load=function(c,v,A,g){if(/^node\|/.test(v)){var d=c.getConfig().getOptionsLiteral(),e=L(c.getRecorder(),d.nodeRequire||y.global.nodeRequire),w=v.split("|"),p=null;try{p=e(w[1])}catch(i){g(i);return}c.enqueueDefineAnonymousModule([],function(){return p}),A()}else{var N=c.getConfig().getOptionsLiteral().trustedTypesPolicy,M=/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin;if(!M&&this._canUseEval(c)){fetch(v).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+v;var r=N?self.eval(N.createScript("",i)):new Function(i);r.call(self),A()}).then(void 0,g);return}try{N&&(v=N.createScriptURL(v)),importScripts(v),A()}catch(i){g(i)}}},a}(),u=function(){function a(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},a.prototype._initNodeRequire=function(c,v){var A=v.getConfig().getOptionsLiteral().nodeCachedData;if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var g=this,d=c("module");function e(w){var p=w.constructor,N=function(i){try{return w.require(i)}finally{}};return N.resolve=function(i,r){return p._resolveFilename(i,w,!1,r)},N.resolve.paths=function(i){return p._resolveLookupPaths(i,w)},N.main=process.mainModule,N.extensions=p._extensions,N.cache=p._cache,N}d.prototype._compile=function(w,p){var N=d.wrap(w.replace(/^#!.*/,"")),M=v.getRecorder(),i=g._getCachedDataPath(A,p),r={filename:p},s;try{var m=g._fs.readFileSync(i);s=m.slice(0,16),r.cachedData=m.slice(16),M.record(60,i)}catch(F){M.record(61,i)}var _=new g._vm.Script(N,r),o=_.runInThisContext(r),l=g._path.dirname(p),h=e(this),b=[this.exports,h,this,p,l,process,Ee,Buffer],P=o.apply(this.exports,b);return g._handleCachedData(_,N,i,!r.cachedData,v),g._verifyCachedData(_,N,i,s,v),P}},a.prototype.load=function(c,v,A,g){var d=this,e=c.getConfig().getOptionsLiteral(),w=L(c.getRecorder(),e.nodeRequire||y.global.nodeRequire),p=e.nodeInstrumenter||function(o){return o};this._init(w),this._initNodeRequire(w,c);var N=c.getRecorder();if(/^node\|/.test(v)){var M=v.split("|"),i=null;try{i=w(M[1])}catch(o){g(o);return}c.enqueueDefineAnonymousModule([],function(){return i}),A()}else{v=y.Utilities.fileUriToFilePath(this._env.isWindows,v);var r=this._path.normalize(v),s=this._getElectronRendererScriptPathOrUri(r),m=Boolean(e.nodeCachedData),_=m?this._getCachedDataPath(e.nodeCachedData,v):void 0;this._readSourceAndCachedData(r,_,N,function(o,l,h,b){if(o){g(o);return}var P;l.charCodeAt(0)===a._BOM?P=a._PREFIX+l.substring(1)+a._SUFFIX:P=a._PREFIX+l+a._SUFFIX,P=p(P,r);var F={filename:s,cachedData:h},I=d._createAndEvalScript(c,P,F,A,g);d._handleCachedData(I,P,_,m&&!h,c),d._verifyCachedData(I,P,_,b,c)})}},a.prototype._createAndEvalScript=function(c,v,A,g,d){var e=c.getRecorder();e.record(31,A.filename);var w=new this._vm.Script(v,A),p=w.runInThisContext(A),N=c.getGlobalAMDDefineFunc(),M=!1,i=function(){return M=!0,N.apply(null,arguments)};return i.amd=N.amd,p.call(y.global,c.getGlobalAMDRequireFunc(),i,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),M?g():d(new Error("Didn't receive define call in "+A.filename+"!")),w},a.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var v=c.match(/^([a-z])\:(.*)/i);return v?"file:///"+(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/"):"file://"+c},a.prototype._getCachedDataPath=function(c,v){var A=this._crypto.createHash("md5").update(v,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(v).replace(/\.js$/,"");return this._path.join(c.path,g+"-"+A+".code")},a.prototype._handleCachedData=function(c,v,A,g,d){var e=this;c.cachedDataRejected?this._fs.unlink(A,function(w){d.getRecorder().record(62,A),e._createAndWriteCachedData(c,v,A,d),w&&d.getConfig().onError(w)}):g&&this._createAndWriteCachedData(c,v,A,d)},a.prototype._createAndWriteCachedData=function(c,v,A,g){var d=this,e=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),w=-1,p=0,N=void 0,M=function(){setTimeout(function(){N||(N=d._crypto.createHash("md5").update(v,"utf8").digest());var i=c.createCachedData();if(!(i.length===0||i.length===w||p>=5)){if(i.length<w){M();return}w=i.length,d._fs.writeFile(A,Buffer.concat([N,i]),function(r){r&&g.getConfig().onError(r),g.getRecorder().record(63,A),M()})}},e*Math.pow(4,p++))};M()},a.prototype._readSourceAndCachedData=function(c,v,A,g){if(!v)this._fs.readFile(c,{encoding:"utf8"},g);else{var d=void 0,e=void 0,w=void 0,p=2,N=function(M){M?g(M):--p==0&&g(void 0,d,e,w)};this._fs.readFile(c,{encoding:"utf8"},function(M,i){d=i,N(M)}),this._fs.readFile(v,function(M,i){!M&&i&&i.length>0?(w=i.slice(0,16),e=i.slice(16),A.record(60,v)):A.record(61,v),N()})}},a.prototype._verifyCachedData=function(c,v,A,g,d){var e=this;!g||c.cachedDataRejected||setTimeout(function(){var w=e._crypto.createHash("md5").update(v,"utf8").digest();g.equals(w)||(d.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+A+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(A,function(p){p&&d.getConfig().onError(p)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function L(a,c){if(c.__$__isRecorded)return c;var v=function(g){a.record(33,g);try{return c(g)}finally{a.record(34,g)}};return v.__$__isRecorded=!0,v}y.ensureRecordedNodeRequire=L;function f(a){return new n(a)}y.createScriptLoader=f})(ee||(ee={}));var ee;(function(y){var n=function(){function f(a){var c=a.lastIndexOf("/");c!==-1?this.fromModulePath=a.substr(0,c+1):this.fromModulePath=""}return f._normalizeModuleId=function(a){var c=a,v;for(v=/\/\.\//;v.test(c);)c=c.replace(v,"/");for(c=c.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(c);)c=c.replace(v,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},f.prototype.resolveModule=function(a){var c=a;return y.Utilities.isAbsolutePath(c)||(y.Utilities.startsWith(c,"./")||y.Utilities.startsWith(c,"../"))&&(c=f._normalizeModuleId(this.fromModulePath+c)),c},f.ROOT=new f(""),f}();y.ModuleIdResolver=n;var R=function(){function f(a,c,v,A,g,d){this.id=a,this.strId=c,this.dependencies=v,this._callback=A,this._errorback=g,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return f._safeInvokeFunction=function(a,c){try{return{returnedValue:a.apply(y.global,c),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}},f._invokeFactory=function(a,c,v,A){return a.isBuild()&&!y.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:a.shouldCatchError()?this._safeInvokeFunction(v,A):{returnedValue:v.apply(y.global,A),producedError:null}},f.prototype.complete=function(a,c,v){this._isComplete=!0;var A=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var g=f._invokeFactory(c,this.strId,this._callback,v);A=g.producedError,a.record(22,this.strId),!A&&typeof g.returnedValue!="undefined"&&(!this.exportsPassedIn||y.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(A){var d=y.ensureError(A);d.phase="factory",d.moduleId=this.strId,this.error=d,c.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},f.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},f.prototype.isComplete=function(){return this._isComplete},f}();y.Module=R;var T=function(){function f(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return f.prototype.getMaxModuleId=function(){return this._nextId},f.prototype.getModuleId=function(a){var c=this._strModuleIdToIntModuleId.get(a);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(a,c),this._intModuleIdToStrModuleId[c]=a),c},f.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},f}(),D=function(){function f(a){this.id=a}return f.EXPORTS=new f(0),f.MODULE=new f(1),f.REQUIRE=new f(2),f}();y.RegularDependency=D;var u=function(){function f(a,c,v){this.id=a,this.pluginId=c,this.pluginParam=v}return f}();y.PluginDependency=u;var L=function(){function f(a,c,v,A,g){g===void 0&&(g=0),this._env=a,this._scriptLoader=c,this._loaderAvailableTimestamp=g,this._defineFunc=v,this._requireFunc=A,this._moduleIdProvider=new T,this._config=new y.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return f.prototype.reset=function(){return new f(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},f.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},f.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},f._findRelevantLocationInStack=function(a,c){for(var v=function(r){return r.replace(/\\/g,"/")},A=v(a),g=c.split(/\n/),d=0;d<g.length;d++){var e=g[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){var w=e[1],p=e[2],N=e[3],M=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(M),w=v(w),w===A){var i={line:parseInt(p,10),col:parseInt(N,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+a)},f.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],c=0,v=0,A=this._modules2.length;v<A;v++){var g=this._modules2[v];if(!!g){var d=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,w=this._buildInfoDependencies[g.id];a[c++]={id:g.strId,path:d,defineLocation:d&&e?f._findRelevantLocationInStack(d,e):null,dependencies:w,shim:null,exports:g.exports}}}return a},f.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new y.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=y.NullLoaderEventRecorder.INSTANCE),this._recorder},f.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},f.prototype.enqueueDefineAnonymousModule=function(a,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:a,callback:c}},f.prototype.defineModule=function(a,c,v,A,g,d){var e=this;d===void 0&&(d=new n(a));var w=this._moduleIdProvider.getModuleId(a);if(this._modules2[w]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var p=new R(w,a,this._normalizeDependencies(c,d),v,A,d);this._modules2[w]=p,this._config.isBuild()&&(this._buildInfoDefineStack[w]=g,this._buildInfoDependencies[w]=(p.dependencies||[]).map(function(N){return e._moduleIdProvider.getStrModuleId(N.id)})),this._resolve(p)},f.prototype._normalizeDependency=function(a,c){if(a==="exports")return D.EXPORTS;if(a==="module")return D.MODULE;if(a==="require")return D.REQUIRE;var v=a.indexOf("!");if(v>=0){var A=c.resolveModule(a.substr(0,v)),g=c.resolveModule(a.substr(v+1)),d=this._moduleIdProvider.getModuleId(A+"!"+g),e=this._moduleIdProvider.getModuleId(A);return new u(d,e,g)}return new D(this._moduleIdProvider.getModuleId(c.resolveModule(a)))},f.prototype._normalizeDependencies=function(a,c){for(var v=[],A=0,g=0,d=a.length;g<d;g++)v[A++]=this._normalizeDependency(a[g],c);return v},f.prototype._relativeRequire=function(a,c,v,A){if(typeof c=="string")return this.synchronousRequire(c,a);this.defineModule(y.Utilities.generateAnonymousModule(),c,v,A,null,a)},f.prototype.synchronousRequire=function(a,c){c===void 0&&(c=new n(a));var v=this._normalizeDependency(a,c),A=this._modules2[v.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports},f.prototype.configure=function(a,c){var v=this._config.shouldRecordStats();c?this._config=new y.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!v&&(this._recorder=null)},f.prototype.getConfig=function(){return this._config},f.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),c.dependencies,c.callback,null,c.stack)}},f.prototype._createLoadError=function(a,c){var v=this,A=this._moduleIdProvider.getStrModuleId(a),g=(this._inverseDependencies2[a]||[]).map(function(e){return v._moduleIdProvider.getStrModuleId(e)}),d=y.ensureError(c);return d.phase="loading",d.moduleId=A,d.neededBy=g,d},f.prototype._onLoadError=function(a,c){var v=this._createLoadError(a,c);this._modules2[a]||(this._modules2[a]=new R(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var A=[],g=0,d=this._moduleIdProvider.getMaxModuleId();g<d;g++)A[g]=!1;var e=!1,w=[];for(w.push(a),A[a]=!0;w.length>0;){var p=w.shift(),N=this._modules2[p];N&&(e=N.onDependencyError(v)||e);var M=this._inverseDependencies2[p];if(M)for(var g=0,d=M.length;g<d;g++){var i=M[g];A[i]||(w.push(i),A[i]=!0)}}e||this._config.onError(v)},f.prototype._hasDependencyPath=function(a,c){var v=this._modules2[a];if(!v)return!1;for(var A=[],g=0,d=this._moduleIdProvider.getMaxModuleId();g<d;g++)A[g]=!1;var e=[];for(e.push(v),A[a]=!0;e.length>0;){var w=e.shift(),p=w.dependencies;if(p)for(var g=0,d=p.length;g<d;g++){var N=p[g];if(N.id===c)return!0;var M=this._modules2[N.id];M&&!A[N.id]&&(A[N.id]=!0,e.push(M))}}return!1},f.prototype._findCyclePath=function(a,c,v){if(a===c||v===50)return[a];var A=this._modules2[a];if(!A)return null;var g=A.dependencies;if(g)for(var d=0,e=g.length;d<e;d++){var w=this._findCyclePath(g[d].id,c,v+1);if(w!==null)return w.push(a),w}return null},f.prototype._createRequire=function(a){var c=this,v=function(A,g,d){return c._relativeRequire(a,A,g,d)};return v.toUrl=function(A){return c._config.requireToUrl(a.resolveModule(A))},v.getStats=function(){return c.getLoaderEvents()},v.hasDependencyCycle=function(){return c._hasDependencyCycle},v.config=function(A,g){g===void 0&&(g=!1),c.configure(A,g)},v.__$__nodeRequire=y.global.nodeRequire,v},f.prototype._loadModule=function(a){var c=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var v=this._moduleIdProvider.getStrModuleId(a),A=this._config.moduleIdToPaths(v),g=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(v.indexOf("/")===-1||g.test(v))&&A.push("node|"+v);var d=-1,e=function(w){if(d++,d>=A.length)c._onLoadError(a,w);else{var p=A[d],N=c.getRecorder();if(c._config.isBuild()&&p==="empty:"){c._buildInfoPath[a]=p,c.defineModule(c._moduleIdProvider.getStrModuleId(a),[],null,null,null),c._onLoad(a);return}N.record(10,p),c._scriptLoader.load(c,p,function(){c._config.isBuild()&&(c._buildInfoPath[a]=p),N.record(11,p),c._onLoad(a)},function(M){N.record(12,p),e(M)})}};e(null)}},f.prototype._loadPluginDependency=function(a,c){var v=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var A=function(g){v.defineModule(v._moduleIdProvider.getStrModuleId(c.id),[],g,null,null)};A.error=function(g){v._config.onError(v._createLoadError(c.id,g))},a.load(c.pluginParam,this._createRequire(n.ROOT),A,this._config.getOptionsLiteral())}},f.prototype._resolve=function(a){var c=this,v=a.dependencies;if(v)for(var A=0,g=v.length;A<g;A++){var d=v[A];if(d===D.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(d===D.MODULE){a.unresolvedDependenciesCount--;continue}if(d===D.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[d.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var w=this._findCyclePath(d.id,a.id,0)||[];w.reverse(),w.push(d.id),console.warn(w.map(function(M){return c._moduleIdProvider.getStrModuleId(M)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(a.id),d instanceof u){var p=this._modules2[d.pluginId];if(p&&p.isComplete()){this._loadPluginDependency(p.exports,d);continue}var N=this._inversePluginDependencies2.get(d.pluginId);N||(N=[],this._inversePluginDependencies2.set(d.pluginId,N)),N.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},f.prototype._onModuleComplete=function(a){var c=this,v=this.getRecorder();if(!a.isComplete()){var A=a.dependencies,g=[];if(A)for(var d=0,e=A.length;d<e;d++){var w=A[d];if(w===D.EXPORTS){g[d]=a.exports;continue}if(w===D.MODULE){g[d]={id:a.strId,config:function(){return c._config.getConfigForModule(a.strId)}};continue}if(w===D.REQUIRE){g[d]=this._createRequire(a.moduleIdResolver);continue}var p=this._modules2[w.id];if(p){g[d]=p.exports;continue}g[d]=null}a.complete(v,this._config,g);var N=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,N)for(var d=0,e=N.length;d<e;d++){var M=N[d],i=this._modules2[M];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(a.id);if(r){this._inversePluginDependencies2.delete(a.id);for(var d=0,e=r.length;d<e;d++)this._loadPluginDependency(a.exports,r[d])}}},f}();y.ModuleManager=L})(ee||(ee={}));var G,ee;(function(y){var n=new y.Environment,R=null,T=function(f,a,c){typeof f!="string"&&(c=a,a=f,f=null),(typeof a!="object"||!Array.isArray(a))&&(c=a,a=null),a||(a=["require","exports","module"]),f?R.defineModule(f,a,c,null,null):R.enqueueDefineAnonymousModule(a,c)};T.amd={jQuery:!0};var D=function(f,a){a===void 0&&(a=!1),R.configure(f,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){D(arguments[0]);return}if(typeof arguments[0]=="string")return R.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){R.defineModule(y.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=D,u.getConfig=function(){return R.getConfig().getOptionsLiteral()},u.reset=function(){R=R.reset()},u.getBuildInfo=function(){return R.getBuildInfo()},u.getStats=function(){return R.getLoaderEvents()},u.define=T;function L(){if(typeof y.global.require!="undefined"||typeof require!="undefined"){var f=y.global.require||require;if(typeof f=="function"&&typeof f.resolve=="function"){var a=y.ensureRecordedNodeRequire(R.getRecorder(),f);y.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=u,require=u):(n.isElectronRenderer||(y.global.define=T),y.global.require=u)}y.init=L,(typeof y.global.define!="function"||!y.global.define.amd)&&(R=new y.ModuleManager(n,y.createScriptLoader(n),T,u,y.Utilities.getHighPerformanceTimestamp()),typeof y.global.require!="undefined"&&typeof y.global.require!="function"&&u.config(y.global.require),G=function(){return T.apply(null,arguments)},G.amd=T.amd,typeof doNotInitLoader=="undefined"&&L())})(ee||(ee={}));var pe=this,me;(function(y){var n=pe||{},R=n.Plugin&&n.Plugin.Resources?n.Plugin.Resources:void 0,T=n&&n.document&&n.document.location&&n.document.location.hash.indexOf("pseudo=true")>=0;function D(c,v){var A;return v.length===0?A=c:A=c.replace(/\{(\d+)\}/g,function(g,d){var e=d[0];return typeof v[e]!="undefined"?v[e]:g}),T&&(A="\uFF3B"+A.replace(/[aouei]/g,"$&$&")+"\uFF3D"),A}function u(c,v){var A=c[v];return A||(A=c["*"],A)?A:null}function L(c,v){for(var A=[],g=0;g<arguments.length-2;g++)A[g]=arguments[g+2];return D(v,A)}function f(c){return function(v,A){var g=Array.prototype.slice.call(arguments,2);return D(c[v],g)}}var a=function(){function c(){this.localize=L}return c.prototype.setPseudoTranslation=function(v){T=v},c.prototype.create=function(v,A){return{localize:f(A[v])}},c.prototype.load=function(v,A,g,d){if(d=d||{},!v||v.length===0)g({localize:L});else{var e=void 0;if(R&&R.getString)e=".nls.keys",A([v+e],function(N){g({localize:function(M,i){if(!N[M])return"NLS error: unknown key "+M;var r=N[M].keys;if(i>=r.length)return"NLS error unknown index "+i;var s=r[i],m=[];m[0]=M+"_"+s;for(var _=0;_<arguments.length-2;_++)m[_+1]=arguments[_+2];return R.getString.apply(R,m)}})});else if(d.isBuild)A([v+".nls",v+".nls.keys"],function(N,M){c.BUILD_MAP[v]=N,c.BUILD_MAP_KEYS[v]=M,g(N)});else{var w=d["vs/nls"]||{},p=w.availableLanguages?u(w.availableLanguages,v):null;e=".nls",p!==null&&p!==c.DEFAULT_TAG&&(e=e+"."+p),A([v+e],function(N){Array.isArray(N)?N.localize=f(N):N.localize=f(N[v]),g(N)})}}},c.prototype._getEntryPointsMap=function(){return n.nlsPluginEntryPoints=n.nlsPluginEntryPoints||{},n.nlsPluginEntryPoints},c.prototype.write=function(v,A,g){var d=g.getEntryPoint(),e=this._getEntryPointsMap();e[d]=e[d]||[],e[d].push(A),A!==d&&g.asModule(v+"!"+A,"define(['vs/nls', 'vs/nls!"+d+`'], function(nls, data) { return nls.create("`+A+'", data); });')},c.prototype.writeFile=function(v,A,g,d,e){var w=this._getEntryPointsMap();if(w.hasOwnProperty(A)){for(var p=g.toUrl(A+".nls.js"),N=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],M=w[A],i={},r=0;r<M.length;r++)i[M[r]]=c.BUILD_MAP[M[r]];N.push('define("'+A+'.nls", '+JSON.stringify(i,null,"	")+");"),d(p,N.join(`\r
`))}},c.prototype.finishBuild=function(v){v("nls.metadata.json",JSON.stringify({keys:c.BUILD_MAP_KEYS,messages:c.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},c.DEFAULT_TAG="i-default",c.BUILD_MAP={},c.BUILD_MAP_KEYS={},c}();y.NLSPlugin=a,function(){G("vs/nls",new a)}()})(me||(me={})),G(Y[15],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class R{constructor(D,u,L,f){this.originalStart=D,this.originalLength=u,this.modifiedStart=L,this.modifiedLength=f}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=R}),G(Y[7],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createErrorWithActions=n.isErrorWithActions=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isPromiseCanceledError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(m){setTimeout(()=>{throw m.stack?new Error(m.message+`

`+m.stack):m},0)}}addListener(m){return this.listeners.push(m),()=>{this._removeListener(m)}}emit(m){this.listeners.forEach(_=>{_(m)})}_removeListener(m){this.listeners.splice(this.listeners.indexOf(m),1)}setUnexpectedErrorHandler(m){this.unexpectedErrorHandler=m}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(m){this.unexpectedErrorHandler(m),this.emit(m)}onUnexpectedExternalError(m){this.unexpectedErrorHandler(m)}}n.ErrorHandler=R,n.errorHandler=new R;function T(s){n.errorHandler.setUnexpectedErrorHandler(s)}n.setUnexpectedErrorHandler=T;function D(s){a(s)||n.errorHandler.onUnexpectedError(s)}n.onUnexpectedError=D;function u(s){a(s)||n.errorHandler.onUnexpectedExternalError(s)}n.onUnexpectedExternalError=u;function L(s){if(s instanceof Error){let{name:m,message:_}=s;const o=s.stacktrace||s.stack;return{$isError:!0,name:m,message:_,stack:o}}return s}n.transformErrorForSerialization=L;const f="Canceled";function a(s){return s instanceof Error&&s.name===f&&s.message===f}n.isPromiseCanceledError=a;class c extends Error{constructor(){super(f);this.name=this.message}}n.CancellationError=c;function v(){const s=new Error(f);return s.name=s.message,s}n.canceled=v;function A(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}n.illegalArgument=A;function g(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}n.illegalState=g;function d(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=d;function e(s){const m=new Error(`${s} has been disposed`);return m.name="DISPOSED",m}n.disposed=e;function w(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}n.getErrorMessage=w;class p extends Error{constructor(m){super("NotImplemented");m&&(this.message=m)}}n.NotImplementedError=p;class N extends Error{constructor(m){super("NotSupported");m&&(this.message=m)}}n.NotSupportedError=N;class M extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=M;function i(s){const m=s;return m instanceof Error&&Array.isArray(m.actions)}n.isErrorWithActions=i;function r(s,m=Object.create(null)){const _=new Error(s);return m.actions&&(_.actions=m.actions),_}n.createErrorWithActions=r}),G(Y[8],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function R(T){const D=this;let u=!1,L;return function(){return u||(u=!0,L=T.apply(D,arguments)),L}}n.once=R}),G(Y[16],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var R;(function(T){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}T.is=D;const u=Object.freeze([]);function L(){return u}T.empty=L;function*f(s){yield s}T.single=f;function a(s){return s||u}T.from=a;function c(s){return!s||s[Symbol.iterator]().next().done===!0}T.isEmpty=c;function v(s){return s[Symbol.iterator]().next().value}T.first=v;function A(s,m){for(const _ of s)if(m(_))return!0;return!1}T.some=A;function g(s,m){for(const _ of s)if(m(_))return _}T.find=g;function*d(s,m){for(const _ of s)m(_)&&(yield _)}T.filter=d;function*e(s,m){let _=0;for(const o of s)yield m(o,_++)}T.map=e;function*w(...s){for(const m of s)for(const _ of m)yield _}T.concat=w;function*p(s){for(const m of s)for(const _ of m)yield _}T.concatNested=p;function N(s,m,_){let o=_;for(const l of s)o=m(o,l);return o}T.reduce=N;function*M(s,m,_=s.length){for(m<0&&(m+=s.length),_<0?_+=s.length:_>s.length&&(_=s.length);m<_;m++)yield s[m]}T.slice=M;function i(s,m=Number.POSITIVE_INFINITY){const _=[];if(m===0)return[_,s];const o=s[Symbol.iterator]();for(let l=0;l<m;l++){const h=o.next();if(h.done)return[_,T.empty()];_.push(h.value)}return[_,{[Symbol.iterator](){return o}}]}T.consume=i;function r(s,m,_=(o,l)=>o===l){const o=s[Symbol.iterator](),l=m[Symbol.iterator]();for(;;){const h=o.next(),b=l.next();if(h.done!==b.done)return!1;if(h.done)return!0;if(!_(h.value,b.value))return!1}}T.equals=r})(R=n.Iterable||(n.Iterable={}))}),G(Y[17],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var R;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.MAX_VALUE=126]="MAX_VALUE"})(R=n.KeyCode||(n.KeyCode={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T=n.ScanCode||(n.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,p){this._keyCodeToStr[w]=p,this._strToKeyCode[p.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const u=new D,L=new D,f=new D;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],c=Object.create(null),v=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>v[e]||0,toEnum:e=>c[e]||0,toString:e=>a[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let p=[],N=[];for(const M of w){const[i,r,s,m,_,o,l,h,b,P]=M;if(N[s]||(N[s]=!0,a[s]=m,c[m]=s,v[m.toLowerCase()]=s,r&&(n.IMMUTABLE_CODE_TO_KEY_CODE[s]=_,_!==0&&_!==3&&_!==5&&_!==4&&_!==6&&_!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[_]=s))),!p[_]){if(p[_]=!0,!o)throw new Error(`String representation missing for key code ${_} around scan code ${m}`);u.define(_,o),L.define(_,b||o),f.define(_,P||b||o)}l&&(n.EVENT_KEY_CODE_MAP[l]=_),h&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[h]=_)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var A;(function(e){function w(s){return u.keyCodeToStr(s)}e.toString=w;function p(s){return u.strToKeyCode(s)}e.fromString=p;function N(s){return L.keyCodeToStr(s)}e.toUserSettingsUS=N;function M(s){return f.keyCodeToStr(s)}e.toUserSettingsGeneral=M;function i(s){return L.strToKeyCode(s)||f.strToKeyCode(s)}e.fromUserSettings=i;function r(s){if(s>=93&&s<=108)return null;switch(s){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(s)}e.toElectronAccelerator=r})(A=n.KeyCodeUtils||(n.KeyCodeUtils={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g=n.KeyMod||(n.KeyMod={}));function d(e,w){const p=(w&65535)<<16>>>0;return(e|p)>>>0}n.KeyChord=d}),G(Y[9],Q([0,1,8,16]),function(y,n,R,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const D=!1;let u=null;function L(l){u=l}if(n.setDisposableTracker=L,D){const l="__is_disposable_tracked__";L(new class{trackDisposable(h){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[l]||console.log(b)},3e3)}setParent(h,b){if(h&&h!==M.None)try{h[l]=!0}catch{}}markAsDisposed(h){if(h&&h!==M.None)try{h[l]=!0}catch{}}markAsSingleton(h){}})}function f(l){return u?.trackDisposable(l),l}function a(l){u?.markAsDisposed(l)}function c(l,h){u?.setParent(l,h)}function v(l,h){if(!!u)for(const b of l)u.setParent(b,h)}function A(l){return u?.markAsSingleton(l),l}n.markAsSingleton=A;class g extends Error{constructor(h){super(`Encountered errors while disposing of store. Errors: [${h.join(", ")}]`);this.errors=h}}n.MultiDisposeError=g;function d(l){return typeof l.dispose=="function"&&l.dispose.length===0}n.isDisposable=d;function e(l){if(T.Iterable.is(l)){let h=[];for(const b of l)if(b)try{b.dispose()}catch(P){h.push(P)}if(h.length===1)throw h[0];if(h.length>1)throw new g(h);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}n.dispose=e;function w(...l){const h=p(()=>e(l));return v(l,h),h}n.combinedDisposable=w;function p(l){const h=f({dispose:(0,R.once)(()=>{a(h),l()})});return h}n.toDisposable=p;class N{constructor(){this._toDispose=new Set,this._isDisposed=!1,f(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return c(h,this),this._isDisposed?N.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(h),h}}n.DisposableStore=N,N.DISABLE_DISPOSED_WARNING=!1;class M{constructor(){this._store=new N,f(this),c(this._store,this)}dispose(){a(this),this._store.dispose()}_register(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(h)}}n.Disposable=M,M.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(h){this._isDisposed||h===this._value||(this._value?.dispose(),h&&c(h,this),this._value=h)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,a(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const h=this._value;return this._value=void 0,h&&c(h,null),h}}n.MutableDisposable=i;class r{constructor(h){this._disposable=h,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=r;class s{constructor(){this.references=new Map}acquire(h,...b){let P=this.references.get(h);P||(P={counter:0,object:this.createReferencedObject(h,...b)},this.references.set(h,P));const{object:F}=P,I=(0,R.once)(()=>{--P.counter==0&&(this.destroyReferencedObject(h,P.object),this.references.delete(h))});return P.counter++,{object:F,dispose:I}}}n.ReferenceCollection=s;class m{constructor(h){this.referenceCollection=h}async acquire(h,...b){const P=this.referenceCollection.acquire(h,...b);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(F){throw P.dispose(),F}}}n.AsyncReferenceCollection=m;class _{constructor(h){this.object=h}dispose(){}}n.ImmortalReference=_;function o(l){const h=new N;try{l(h)}finally{h.dispose()}}n.disposeOnReturn=o}),G(Y[18],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class R{constructor(u){this.element=u,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class T{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let u=this._first;for(;u!==R.Undefined;){const L=u.next;u.prev=R.Undefined,u.next=R.Undefined,u=L}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,L){const f=new R(u);if(this._first===R.Undefined)this._first=f,this._last=f;else if(L){const c=this._last;this._last=f,f.prev=c,c.next=f}else{const c=this._first;this._first=f,f.next=c,c.prev=f}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(f))}}shift(){if(this._first!==R.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==R.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==R.Undefined&&u.next!==R.Undefined){const L=u.prev;L.next=u.next,u.next.prev=L}else u.prev===R.Undefined&&u.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):u.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):u.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==R.Undefined;)yield u.element,u=u.next}}n.LinkedList=T}),G(Y[2],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isLittleEndian=n.OS=n.OperatingSystem=n.setImmediate=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isIOS=n.isWeb=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.isElectronSandboxed=n.globals=void 0;const R="en";let T=!1,D=!1,u=!1,L=!1,f=!1,a=!1,c=!1,v,A=R,g,d;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let e;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?e=n.globals.vscode.process:typeof process!="undefined"&&(e=process);const w=typeof e?.versions?.electron=="string"&&e.type==="renderer";if(n.isElectronSandboxed=w&&e?.sandboxed,typeof navigator=="object"&&!w)d=navigator.userAgent,T=d.indexOf("Windows")>=0,D=d.indexOf("Macintosh")>=0,c=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=d.indexOf("Linux")>=0,a=!0,v=navigator.language,A=v;else if(typeof e=="object"){T=e.platform==="win32",D=e.platform==="darwin",u=e.platform==="linux",L=u&&!!e.env.SNAP&&!!e.env.SNAP_REVISION,v=R,A=R;const o=e.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),h=l.availableLanguages["*"];v=l.locale,A=h||R,g=l._translationsConfigFile}catch(l){}f=!0}else console.error("Unable to resolve platform.");var p;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(p=n.Platform||(n.Platform={}));function N(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=N;let M=0;D?M=1:T?M=3:u&&(M=2),n.isWindows=T,n.isMacintosh=D,n.isLinux=u,n.isLinuxSnap=L,n.isNative=f,n.isWeb=a,n.isIOS=c,n.platform=M,n.userAgent=d,n.language=A;var i;(function(o){function l(){return n.language}o.value=l;function h(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}o.isDefaultVariant=h;function b(){return n.language==="en"}o.isDefault=b})(i=n.Language||(n.Language={})),n.locale=v,n.translationsConfigFile=g,n.setImmediate=function(){if(n.globals.setImmediate)return n.globals.setImmediate.bind(n.globals);if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let h=[];n.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let F=0,I=h.length;F<I;F++){const S=h[F];if(S.id===P.data.vscodeSetImmediateId){h.splice(F,1),S.callback();return}}});let b=0;return P=>{const F=++b;h.push({id:F,callback:P}),n.globals.postMessage({vscodeSetImmediateId:F},"*")}}if(typeof e?.nextTick=="function")return e.nextTick.bind(e);const l=Promise.resolve();return h=>l.then(h)}();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=n.OperatingSystem||(n.OperatingSystem={})),n.OS=D||c?2:T?1:3;let s=!0,m=!1;function _(){if(!m){m=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}n.isLittleEndian=_}),G(Y[19],Q([0,1,2]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.nextTick=n.platform=n.env=n.cwd=void 0;let T;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;T={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(u){return(0,R.setImmediate)(u)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:T={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};n.cwd=T.cwd,n.env=T.env,n.platform=T.platform,n.nextTick=T.nextTick,n.arch=T.arch}),G(Y[20],Q([0,1,19]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const T=65,D=97,u=90,L=122,f=46,a=47,c=92,v=58,A=63;class g extends Error{constructor(r,s,m){let _;typeof s=="string"&&s.indexOf("not ")===0?(_="must not be",s=s.replace(/^not /,"")):_="must be";const o=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${o} ${_} of type ${s}`;l+=`. Received type ${typeof m}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,r){if(typeof i!="string")throw new g(r,"string",i)}function e(i){return i===a||i===c}function w(i){return i===a}function p(i){return i>=T&&i<=u||i>=D&&i<=L}function N(i,r,s,m){let _="",o=0,l=-1,h=0,b=0;for(let P=0;P<=i.length;++P){if(P<i.length)b=i.charCodeAt(P);else{if(m(b))break;b=a}if(m(b)){if(!(l===P-1||h===1))if(h===2){if(_.length<2||o!==2||_.charCodeAt(_.length-1)!==f||_.charCodeAt(_.length-2)!==f){if(_.length>2){const F=_.lastIndexOf(s);F===-1?(_="",o=0):(_=_.slice(0,F),o=_.length-1-_.lastIndexOf(s)),l=P,h=0;continue}else if(_.length!==0){_="",o=0,l=P,h=0;continue}}r&&(_+=_.length>0?`${s}..`:"..",o=2)}else _.length>0?_+=`${s}${i.slice(l+1,P)}`:_=i.slice(l+1,P),o=P-l-1;l=P,h=0}else b===f&&h!==-1?++h:h=-1}return _}function M(i,r){if(r===null||typeof r!="object")throw new g("pathObject","Object",r);const s=r.dir||r.root,m=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${m}`:`${s}${i}${m}`:m}n.win32={resolve(...i){let r="",s="",m=!1;for(let _=i.length-1;_>=-1;_--){let o;if(_>=0){if(o=i[_],d(o,"path"),o.length===0)continue}else r.length===0?o=R.cwd():(o=R.env[`=${r}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===c)&&(o=`${r}\\`));const l=o.length;let h=0,b="",P=!1;const F=o.charCodeAt(0);if(l===1)e(F)&&(h=1,P=!0);else if(e(F))if(P=!0,e(o.charCodeAt(1))){let I=2,S=I;for(;I<l&&!e(o.charCodeAt(I));)I++;if(I<l&&I!==S){const V=o.slice(S,I);for(S=I;I<l&&e(o.charCodeAt(I));)I++;if(I<l&&I!==S){for(S=I;I<l&&!e(o.charCodeAt(I));)I++;(I===l||I!==S)&&(b=`\\\\${V}\\${o.slice(S,I)}`,h=I)}}}else h=1;else p(F)&&o.charCodeAt(1)===v&&(b=o.slice(0,2),h=2,l>2&&e(o.charCodeAt(2))&&(P=!0,h=3));if(b.length>0)if(r.length>0){if(b.toLowerCase()!==r.toLowerCase())continue}else r=b;if(m){if(r.length>0)break}else if(s=`${o.slice(h)}\\${s}`,m=P,P&&r.length>0)break}return s=N(s,!m,"\\",e),m?`${r}\\${s}`:`${r}${s}`||"."},normalize(i){d(i,"path");const r=i.length;if(r===0)return".";let s=0,m,_=!1;const o=i.charCodeAt(0);if(r===1)return w(o)?"\\":i;if(e(o))if(_=!0,e(i.charCodeAt(1))){let h=2,b=h;for(;h<r&&!e(i.charCodeAt(h));)h++;if(h<r&&h!==b){const P=i.slice(b,h);for(b=h;h<r&&e(i.charCodeAt(h));)h++;if(h<r&&h!==b){for(b=h;h<r&&!e(i.charCodeAt(h));)h++;if(h===r)return`\\\\${P}\\${i.slice(b)}\\`;h!==b&&(m=`\\\\${P}\\${i.slice(b,h)}`,s=h)}}}else s=1;else p(o)&&i.charCodeAt(1)===v&&(m=i.slice(0,2),s=2,r>2&&e(i.charCodeAt(2))&&(_=!0,s=3));let l=s<r?N(i.slice(s),!_,"\\",e):"";return l.length===0&&!_&&(l="."),l.length>0&&e(i.charCodeAt(r-1))&&(l+="\\"),m===void 0?_?`\\${l}`:l:_?`${m}\\${l}`:`${m}${l}`},isAbsolute(i){d(i,"path");const r=i.length;if(r===0)return!1;const s=i.charCodeAt(0);return e(s)||r>2&&p(s)&&i.charCodeAt(1)===v&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,s;for(let o=0;o<i.length;++o){const l=i[o];d(l,"path"),l.length>0&&(r===void 0?r=s=l:r+=`\\${l}`)}if(r===void 0)return".";let m=!0,_=0;if(typeof s=="string"&&e(s.charCodeAt(0))){++_;const o=s.length;o>1&&e(s.charCodeAt(1))&&(++_,o>2&&(e(s.charCodeAt(2))?++_:m=!1))}if(m){for(;_<r.length&&e(r.charCodeAt(_));)_++;_>=2&&(r=`\\${r.slice(_)}`)}return n.win32.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r)return"";const s=n.win32.resolve(i),m=n.win32.resolve(r);if(s===m||(i=s.toLowerCase(),r=m.toLowerCase(),i===r))return"";let _=0;for(;_<i.length&&i.charCodeAt(_)===c;)_++;let o=i.length;for(;o-1>_&&i.charCodeAt(o-1)===c;)o--;const l=o-_;let h=0;for(;h<r.length&&r.charCodeAt(h)===c;)h++;let b=r.length;for(;b-1>h&&r.charCodeAt(b-1)===c;)b--;const P=b-h,F=l<P?l:P;let I=-1,S=0;for(;S<F;S++){const O=i.charCodeAt(_+S);if(O!==r.charCodeAt(h+S))break;O===c&&(I=S)}if(S!==F){if(I===-1)return m}else{if(P>F){if(r.charCodeAt(h+S)===c)return m.slice(h+S+1);if(S===2)return m.slice(h+S)}l>F&&(i.charCodeAt(_+S)===c?I=S:S===2&&(I=3)),I===-1&&(I=0)}let V="";for(S=_+I+1;S<=o;++S)(S===o||i.charCodeAt(S)===c)&&(V+=V.length===0?"..":"\\..");return h+=I,V.length>0?`${V}${m.slice(h,b)}`:(m.charCodeAt(h)===c&&++h,m.slice(h,b))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=n.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===c){if(r.charCodeAt(1)===c){const s=r.charCodeAt(2);if(s!==A&&s!==f)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(p(r.charCodeAt(0))&&r.charCodeAt(1)===v&&r.charCodeAt(2)===c)return`\\\\?\\${r}`;return i},dirname(i){d(i,"path");const r=i.length;if(r===0)return".";let s=-1,m=0;const _=i.charCodeAt(0);if(r===1)return e(_)?i:".";if(e(_)){if(s=m=1,e(i.charCodeAt(1))){let h=2,b=h;for(;h<r&&!e(i.charCodeAt(h));)h++;if(h<r&&h!==b){for(b=h;h<r&&e(i.charCodeAt(h));)h++;if(h<r&&h!==b){for(b=h;h<r&&!e(i.charCodeAt(h));)h++;if(h===r)return i;h!==b&&(s=m=h+1)}}}}else p(_)&&i.charCodeAt(1)===v&&(s=r>2&&e(i.charCodeAt(2))?3:2,m=s);let o=-1,l=!0;for(let h=r-1;h>=m;--h)if(e(i.charCodeAt(h))){if(!l){o=h;break}}else l=!1;if(o===-1){if(s===-1)return".";o=s}return i.slice(0,o)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let s=0,m=-1,_=!0,o;if(i.length>=2&&p(i.charCodeAt(0))&&i.charCodeAt(1)===v&&(s=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let l=r.length-1,h=-1;for(o=i.length-1;o>=s;--o){const b=i.charCodeAt(o);if(e(b)){if(!_){s=o+1;break}}else h===-1&&(_=!1,h=o+1),l>=0&&(b===r.charCodeAt(l)?--l==-1&&(m=o):(l=-1,m=h))}return s===m?m=h:m===-1&&(m=i.length),i.slice(s,m)}for(o=i.length-1;o>=s;--o)if(e(i.charCodeAt(o))){if(!_){s=o+1;break}}else m===-1&&(_=!1,m=o+1);return m===-1?"":i.slice(s,m)},extname(i){d(i,"path");let r=0,s=-1,m=0,_=-1,o=!0,l=0;i.length>=2&&i.charCodeAt(1)===v&&p(i.charCodeAt(0))&&(r=m=2);for(let h=i.length-1;h>=r;--h){const b=i.charCodeAt(h);if(e(b)){if(!o){m=h+1;break}continue}_===-1&&(o=!1,_=h+1),b===f?s===-1?s=h:l!==1&&(l=1):s!==-1&&(l=-1)}return s===-1||_===-1||l===0||l===1&&s===_-1&&s===m+1?"":i.slice(s,_)},format:M.bind(null,"\\"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.length;let m=0,_=i.charCodeAt(0);if(s===1)return e(_)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(e(_)){if(m=1,e(i.charCodeAt(1))){let I=2,S=I;for(;I<s&&!e(i.charCodeAt(I));)I++;if(I<s&&I!==S){for(S=I;I<s&&e(i.charCodeAt(I));)I++;if(I<s&&I!==S){for(S=I;I<s&&!e(i.charCodeAt(I));)I++;I===s?m=I:I!==S&&(m=I+1)}}}}else if(p(_)&&i.charCodeAt(1)===v){if(s<=2)return r.root=r.dir=i,r;if(m=2,e(i.charCodeAt(2))){if(s===3)return r.root=r.dir=i,r;m=3}}m>0&&(r.root=i.slice(0,m));let o=-1,l=m,h=-1,b=!0,P=i.length-1,F=0;for(;P>=m;--P){if(_=i.charCodeAt(P),e(_)){if(!b){l=P+1;break}continue}h===-1&&(b=!1,h=P+1),_===f?o===-1?o=P:F!==1&&(F=1):o!==-1&&(F=-1)}return h!==-1&&(o===-1||F===0||F===1&&o===h-1&&o===l+1?r.base=r.name=i.slice(l,h):(r.name=i.slice(l,o),r.base=i.slice(l,h),r.ext=i.slice(o,h))),l>0&&l!==m?r.dir=i.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let r="",s=!1;for(let m=i.length-1;m>=-1&&!s;m--){const _=m>=0?i[m]:R.cwd();d(_,"path"),_.length!==0&&(r=`${_}/${r}`,s=_.charCodeAt(0)===a)}return r=N(r,!s,"/",w),s?`/${r}`:r.length>0?r:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===a,s=i.charCodeAt(i.length-1)===a;return i=N(i,!r,"/",w),i.length===0?r?"/":s?"./":".":(s&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===a},join(...i){if(i.length===0)return".";let r;for(let s=0;s<i.length;++s){const m=i[s];d(m,"path"),m.length>0&&(r===void 0?r=m:r+=`/${m}`)}return r===void 0?".":n.posix.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r||(i=n.posix.resolve(i),r=n.posix.resolve(r),i===r))return"";const s=1,m=i.length,_=m-s,o=1,l=r.length-o,h=_<l?_:l;let b=-1,P=0;for(;P<h;P++){const I=i.charCodeAt(s+P);if(I!==r.charCodeAt(o+P))break;I===a&&(b=P)}if(P===h)if(l>h){if(r.charCodeAt(o+P)===a)return r.slice(o+P+1);if(P===0)return r.slice(o+P)}else _>h&&(i.charCodeAt(s+P)===a?b=P:P===0&&(b=0));let F="";for(P=s+b+1;P<=m;++P)(P===m||i.charCodeAt(P)===a)&&(F+=F.length===0?"..":"/..");return`${F}${r.slice(o+b)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===a;let s=-1,m=!0;for(let _=i.length-1;_>=1;--_)if(i.charCodeAt(_)===a){if(!m){s=_;break}}else m=!1;return s===-1?r?"/":".":r&&s===1?"//":i.slice(0,s)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let s=0,m=-1,_=!0,o;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let l=r.length-1,h=-1;for(o=i.length-1;o>=0;--o){const b=i.charCodeAt(o);if(b===a){if(!_){s=o+1;break}}else h===-1&&(_=!1,h=o+1),l>=0&&(b===r.charCodeAt(l)?--l==-1&&(m=o):(l=-1,m=h))}return s===m?m=h:m===-1&&(m=i.length),i.slice(s,m)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===a){if(!_){s=o+1;break}}else m===-1&&(_=!1,m=o+1);return m===-1?"":i.slice(s,m)},extname(i){d(i,"path");let r=-1,s=0,m=-1,_=!0,o=0;for(let l=i.length-1;l>=0;--l){const h=i.charCodeAt(l);if(h===a){if(!_){s=l+1;break}continue}m===-1&&(_=!1,m=l+1),h===f?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||m===-1||o===0||o===1&&r===m-1&&r===s+1?"":i.slice(r,m)},format:M.bind(null,"/"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.charCodeAt(0)===a;let m;s?(r.root="/",m=1):m=0;let _=-1,o=0,l=-1,h=!0,b=i.length-1,P=0;for(;b>=m;--b){const F=i.charCodeAt(b);if(F===a){if(!h){o=b+1;break}continue}l===-1&&(h=!1,l=b+1),F===f?_===-1?_=b:P!==1&&(P=1):_!==-1&&(P=-1)}if(l!==-1){const F=o===0&&s?1:o;_===-1||P===0||P===1&&_===l-1&&_===o+1?r.base=r.name=i.slice(F,l):(r.name=i.slice(F,_),r.base=i.slice(F,l),r.ext=i.slice(_,l))}return o>0?r.dir=i.slice(0,o-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=R.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=R.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=R.platform==="win32"?n.win32.join:n.posix.join,n.resolve=R.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=R.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=R.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=R.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=R.platform==="win32"?n.win32.extname:n.posix.extname,n.format=R.platform==="win32"?n.win32.format:n.posix.format,n.parse=R.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=R.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=R.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=R.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),G(Y[10],Q([0,1,2]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const T=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(L){this._highResolution=T&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new D(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}n.StopWatch=D}),G(Y[5],Q([0,1,7,8,9,18,10]),function(y,n,R,T,D,u,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;var f;(function(r){r.None=()=>D.Disposable.None;function s(q){return(B,j=null,$)=>{let X=!1,Z;return Z=q(x=>{if(!X)return Z?Z.dispose():X=!0,B.call(j,x)},null,$),X&&Z.dispose(),Z}}r.once=s;function m(q,B){return P((j,$=null,X)=>q(Z=>j.call($,B(Z)),null,X))}r.map=m;function _(q,B){return P((j,$=null,X)=>q(Z=>{B(Z),j.call($,Z)},null,X))}r.forEach=_;function o(q,B){return P((j,$=null,X)=>q(Z=>B(Z)&&j.call($,Z),null,X))}r.filter=o;function l(q){return q}r.signal=l;function h(...q){return(B,j=null,$)=>(0,D.combinedDisposable)(...q.map(X=>X(Z=>B.call(j,Z),null,$)))}r.any=h;function b(q,B,j){let $=j;return m(q,X=>($=B($,X),$))}r.reduce=b;function P(q){let B;const j=new g({onFirstListenerAdd(){B=q(j.fire,j)},onLastListenerRemove(){B.dispose()}});return j.event}function F(q,B,j=100,$=!1,X){let Z,x,te,ae=0;const oe=new g({leakWarningThreshold:X,onFirstListenerAdd(){Z=q(he=>{ae++,x=B(x,he),$&&!te&&(oe.fire(x),x=void 0),clearTimeout(te),te=setTimeout(()=>{const de=x;x=void 0,te=void 0,(!$||ae>1)&&oe.fire(de),ae=0},j)})},onLastListenerRemove(){Z.dispose()}});return oe.event}r.debounce=F;function I(q,B=(j,$)=>j===$){let j=!0,$;return o(q,X=>{const Z=j||!B(X,$);return j=!1,$=X,Z})}r.latch=I;function S(q,B){return[r.filter(q,B),r.filter(q,j=>!B(j))]}r.split=S;function V(q,B=!1,j=[]){let $=j.slice(),X=q(te=>{$?$.push(te):x.fire(te)});const Z=()=>{$&&$.forEach(te=>x.fire(te)),$=null},x=new g({onFirstListenerAdd(){X||(X=q(te=>x.fire(te)))},onFirstListenerDidAdd(){$&&(B?setTimeout(Z):Z())},onLastListenerRemove(){X&&X.dispose(),X=null}});return x.event}r.buffer=V;class O{constructor(B){this.event=B}map(B){return new O(m(this.event,B))}forEach(B){return new O(_(this.event,B))}filter(B){return new O(o(this.event,B))}reduce(B,j){return new O(b(this.event,B,j))}latch(){return new O(I(this.event))}debounce(B,j=100,$=!1,X){return new O(F(this.event,B,j,$,X))}on(B,j,$){return this.event(B,j,$)}once(B,j,$){return s(this.event)(B,j,$)}}function z(q){return new O(q)}r.chain=z;function C(q,B,j=$=>$){const $=(...te)=>x.fire(j(...te)),X=()=>q.on(B,$),Z=()=>q.removeListener(B,$),x=new g({onFirstListenerAdd:X,onLastListenerRemove:Z});return x.event}r.fromNodeEventEmitter=C;function K(q,B,j=$=>$){const $=(...te)=>x.fire(j(...te)),X=()=>q.addEventListener(B,$),Z=()=>q.removeEventListener(B,$),x=new g({onFirstListenerAdd:X,onLastListenerRemove:Z});return x.event}r.fromDOMEventEmitter=K;function t(q){return new Promise(B=>s(q)(B))}r.toPromise=t})(f=n.Event||(n.Event={}));class a{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${a._idPool++}`}start(s){this._stopWatch=new L.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}a._idPool=0;let c=-1;function v(r){const s=c;return c=r,{dispose(){c=s}}}n.setGlobalLeakWarningThreshold=v;class A{constructor(s,m=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let m=c;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),m<=0||s<m)return;this._stacks||(this._stacks=new Map);const _=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(_)||0;if(this._stacks.set(_,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let l,h=0;for(const[b,P]of this._stacks)(!l||h<P)&&(l=b,h=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${h}):`),console.warn(l)}return()=>{const l=this._stacks.get(_)||0;this._stacks.set(_,l-1)}}}class g{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=c>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new a(this._options._profName):void 0}get event(){return this._event||(this._event=(s,m,_)=>{this._listeners||(this._listeners=new u.LinkedList);const o=this._listeners.isEmpty();o&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const l=this._listeners.push(m?[s,m]:s);o&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,m);const h=this._leakageMon?.check(this._listeners.size),b=(0,D.toDisposable)(()=>{h&&h(),this._disposed||(l(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return _ instanceof D.DisposableStore?_.add(b):Array.isArray(_)&&_.push(b),b}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new u.LinkedList);for(let m of this._listeners)this._deliveryQueue.push([m,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[m,_]=this._deliveryQueue.shift();try{typeof m=="function"?m.call(void 0,_):m[0].call(m[1],_)}catch(o){(0,R.onUnexpectedError)(o)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}n.Emitter=g;class d extends g{async fireAsync(s,m,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new u.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,s]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[o,l]=this._asyncDeliveryQueue.shift(),h=[],b={...l,waitUntil:P=>{if(Object.isFrozen(h))throw new Error("waitUntil can NOT be called asynchronous");_&&(P=_(P,typeof o=="function"?o:o[0])),h.push(P)}};try{typeof o=="function"?o.call(void 0,b):o[0].call(o[1],b)}catch(P){(0,R.onUnexpectedError)(P);continue}Object.freeze(h),await Promise.allSettled(h).then(P=>{for(const F of P)F.status==="rejected"&&(0,R.onUnexpectedError)(F.reason)})}}}}n.AsyncEmitter=d;class e extends g{constructor(s){super(s);this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}n.PauseableEmitter=e;class w extends e{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}n.DebounceEmitter=w;class p extends g{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]})}}n.MicrotaskEmitter=p;class N{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const m={event:s,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const _=()=>{this.hasListeners&&this.unhook(m);const o=this.events.indexOf(m);this.events.splice(o,1)};return(0,D.toDisposable)((0,T.once)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(m=>this.emitter.fire(m))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=N;class M{constructor(){this.buffers=[]}wrapEvent(s){return(m,_,o)=>s(l=>{const h=this.buffers[this.buffers.length-1];h?h.push(()=>m.call(_,l)):m.call(_,l)},void 0,o)}bufferEvents(s){const m=[];this.buffers.push(m);const _=s();return this.buffers.pop(),m.forEach(o=>o()),_}}n.EventBufferer=M;class i{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=D.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=i}),G(Y[21],Q([0,1,5]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const T=Object.freeze(function(f,a){const c=setTimeout(f.bind(a),0);return{dispose(){clearTimeout(c)}}});var D;(function(f){function a(c){return c===f.None||c===f.Cancelled||c instanceof u?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}f.isCancellationToken=a,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D=n.CancellationToken||(n.CancellationToken={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=D.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=D.None}}n.CancellationTokenSource=L}),G(Y[4],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getLeftDeleteOffset=n.GraphemeBreakType=n.breakBetweenGraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsEmoji=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function R(E){return!E||typeof E!="string"?!0:E.trim().length===0}n.isFalsyOrWhitespace=R;const T=/{(\d+)}/g;function D(E,...U){return U.length===0?E:E.replace(T,function(k,W){const H=parseInt(W,10);return isNaN(H)||H<0||H>=U.length?k:U[H]})}n.format=D;const u=/{([^}]+)}/g;function L(E,U){return E.replace(u,(k,W)=>U[W]??k)}n.format2=L;function f(E){return E.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}n.escape=f;function a(E){return E.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=a;function c(E,U){let k=0;const W=U.charCodeAt(0);for(let H=E.length-1;H>=0;H--)E.charCodeAt(H)===W&&k++;return k}n.count=c;function v(E,U,k="\u2026"){return E.length<=U?E:`${E.substr(0,U)}${k}`}n.truncate=v;function A(E,U=" "){const k=g(E,U);return d(k,U)}n.trim=A;function g(E,U){if(!E||!U)return E;const k=U.length;if(k===0||E.length===0)return E;let W=0;for(;E.indexOf(U,W)===W;)W=W+k;return E.substring(W)}n.ltrim=g;function d(E,U){if(!E||!U)return E;const k=U.length,W=E.length;if(k===0||W===0)return E;let H=W,J=-1;for(;J=E.lastIndexOf(U,H-1),!(J===-1||J+k!==H);){if(J===0)return"";H=J}return E.substring(0,H)}n.rtrim=d;function e(E){return E.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=e;function w(E){return E.replace(/\*/g,"")}n.stripWildcards=w;function p(E,U,k={}){if(!E)throw new Error("Cannot create regex from empty string");U||(E=a(E)),k.wholeWord&&(/\B/.test(E.charAt(0))||(E="\\b"+E),/\B/.test(E.charAt(E.length-1))||(E=E+"\\b"));let W="";return k.global&&(W+="g"),k.matchCase||(W+="i"),k.multiline&&(W+="m"),k.unicode&&(W+="u"),new RegExp(E,W)}n.createRegExp=p;function N(E){return E.source==="^"||E.source==="^$"||E.source==="$"||E.source==="^\\s*$"?!1:!!(E.exec("")&&E.lastIndex===0)}n.regExpLeadsToEndlessLoop=N;function M(E){return!!E.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=M;function i(E){return(E.global?"g":"")+(E.ignoreCase?"i":"")+(E.multiline?"m":"")+(E.unicode?"u":"")}n.regExpFlags=i;function r(E){return E.split(/\r\n|\r|\n/)}n.splitLines=r;function s(E){for(let U=0,k=E.length;U<k;U++){const W=E.charCodeAt(U);if(W!==32&&W!==9)return U}return-1}n.firstNonWhitespaceIndex=s;function m(E,U=0,k=E.length){for(let W=U;W<k;W++){const H=E.charCodeAt(W);if(H!==32&&H!==9)return E.substring(U,W)}return E.substring(U,k)}n.getLeadingWhitespace=m;function _(E,U=E.length-1){for(let k=U;k>=0;k--){const W=E.charCodeAt(k);if(W!==32&&W!==9)return k}return-1}n.lastNonWhitespaceIndex=_;function o(E,U){return E<U?-1:E>U?1:0}n.compare=o;function l(E,U,k=0,W=E.length,H=0,J=U.length){for(;k<W&&H<J;k++,H++){let se=E.charCodeAt(k),re=U.charCodeAt(H);if(se<re)return-1;if(se>re)return 1}const ne=W-k,ie=J-H;return ne<ie?-1:ne>ie?1:0}n.compareSubstring=l;function h(E,U){return b(E,U,0,E.length,0,U.length)}n.compareIgnoreCase=h;function b(E,U,k=0,W=E.length,H=0,J=U.length){for(;k<W&&H<J;k++,H++){let se=E.charCodeAt(k),re=U.charCodeAt(H);if(se===re)continue;if(se>=128||re>=128)return l(E.toLowerCase(),U.toLowerCase(),k,W,H,J);P(se)&&(se-=32),P(re)&&(re-=32);const le=se-re;if(le!==0)return le}const ne=W-k,ie=J-H;return ne<ie?-1:ne>ie?1:0}n.compareSubstringIgnoreCase=b;function P(E){return E>=97&&E<=122}n.isLowerAsciiLetter=P;function F(E){return E>=65&&E<=90}n.isUpperAsciiLetter=F;function I(E,U){return E.length===U.length&&b(E,U)===0}n.equalsIgnoreCase=I;function S(E,U){const k=U.length;return U.length>E.length?!1:b(E,U,0,k)===0}n.startsWithIgnoreCase=S;function V(E,U){let k,W=Math.min(E.length,U.length);for(k=0;k<W;k++)if(E.charCodeAt(k)!==U.charCodeAt(k))return k;return W}n.commonPrefixLength=V;function O(E,U){let k,W=Math.min(E.length,U.length);const H=E.length-1,J=U.length-1;for(k=0;k<W;k++)if(E.charCodeAt(H-k)!==U.charCodeAt(J-k))return k;return W}n.commonSuffixLength=O;function z(E){return 55296<=E&&E<=56319}n.isHighSurrogate=z;function C(E){return 56320<=E&&E<=57343}n.isLowSurrogate=C;function K(E,U){return(E-55296<<10)+(U-56320)+65536}n.computeCodePoint=K;function t(E,U,k){const W=E.charCodeAt(k);if(z(W)&&k+1<U){const H=E.charCodeAt(k+1);if(C(H))return K(W,H)}return W}n.getNextCodePoint=t;function q(E,U){const k=E.charCodeAt(U-1);if(C(k)&&U>1){const W=E.charCodeAt(U-2);if(z(W))return K(W,k)}return k}function B(E,U){const k=ue.getInstance(),W=U,H=E.length,J=t(E,H,U);U+=J>=65536?2:1;let ne=k.getGraphemeBreakType(J);for(;U<H;){const ie=t(E,H,U),se=k.getGraphemeBreakType(ie);if(ce(ne,se))break;U+=ie>=65536?2:1,ne=se}return U-W}n.nextCharLength=B;function j(E,U){const k=ue.getInstance(),W=U,H=q(E,U);U-=H>=65536?2:1;let J=k.getGraphemeBreakType(H);for(;U>0;){const ne=q(E,U),ie=k.getGraphemeBreakType(ne);if(ce(ie,J))break;U-=ne>=65536?2:1,J=ie}return W-U}n.prevCharLength=j;function $(E,U){const k=ue.getInstance(),W=E.length,H=U,J=t(E,W,U),ne=k.getGraphemeBreakType(J);U+=J>=65536?2:1;let ie=ne;for(;U<W;){const re=t(E,W,U),le=k.getGraphemeBreakType(re);if(ce(ie,le))break;U+=re>=65536?2:1,ie=le}const se=U;for(U=H,ie=ne;U>0;){const re=q(E,U),le=k.getGraphemeBreakType(re);if(ce(le,ie))break;U-=re>=65536?2:1,ie=le}return[U,se]}function X(E,U){return U>0&&C(E.charCodeAt(U))?$(E,U-1):$(E,U)}n.getCharContainingOffset=X;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(E){return Z.test(E)}n.containsRTL=x;const te=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ae(E){return te.test(E)}n.containsEmoji=ae;const oe=/^[\t\n\r\x20-\x7E]*$/;function he(E){return oe.test(E)}n.isBasicASCII=he,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(E){return n.UNUSUAL_LINE_TERMINATORS.test(E)}n.containsUnusualLineTerminators=de;function be(E){for(let U=0,k=E.length;U<k;U++)if(ge(E.charCodeAt(U)))return!0;return!1}n.containsFullWidthCharacter=be;function ge(E){return E=+E,E>=11904&&E<=55215||E>=63744&&E<=64255||E>=65281&&E<=65374}n.isFullWidthCharacter=ge;function _e(E){return E>=127462&&E<=127487||E===8986||E===8987||E===9200||E===9203||E>=9728&&E<=10175||E===11088||E===11093||E>=127744&&E<=128591||E>=128640&&E<=128764||E>=128992&&E<=129003||E>=129280&&E<=129535||E>=129648&&E<=129750}n.isEmojiImprecise=_e;function we(E,U){if(E.length<U)return E;const k=/\b/g;let W=0;for(;k.test(E)&&!(E.length-k.lastIndex<U);)W=k.lastIndex,k.lastIndex+=1;return E.substring(W).replace(/^\s/,"")}n.lcut=we;const Ae=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Pe(E){return E&&(E=E.replace(Ae,""),E=E.replace(Me,""),E=E.replace(De,"")),E}n.removeAnsiEscapeCodes=Pe,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(E){return!!(E&&E.length>0&&E.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ve;function Re(E){return ve(E)?E.substr(1):E}n.stripUTF8BOM=Re;function Fe(E,U){if(!E||!U||E.length<U.length)return!1;const k=U.length,W=E.toLowerCase();let H=0,J=-1;for(;H<k;){const ne=W.indexOf(U[H],J+1);if(ne<0)return!1;J=ne,H++}return!0}n.fuzzyContains=Fe;function Ie(E,U=!1){return E?(U&&(E=E.replace(/\\./g,"")),E.toLowerCase()!==E):!1}n.containsUppercaseCharacter=Ie;function Te(E){return E.charAt(0).toUpperCase()+E.slice(1)}n.uppercaseFirstLetter=Te;function Ue(E,U=1){if(U===0)return"";let k=-1;do k=E.indexOf(`
`,k+1),U--;while(U>0&&k>=0);return k===-1?E:(E[k-1]==="\r"&&k--,E.substr(0,k))}n.getNLines=Ue;function ye(E){const U=90-65+1;return E=E%(2*U),E<U?String.fromCharCode(97+E):String.fromCharCode(65+E-U)}n.singleLetterHash=ye;function ke(E){return ue.getInstance().getGraphemeBreakType(E)}n.getGraphemeBreakType=ke;function ce(E,U){return E===0?U!==5&&U!==7:E===2&&U===3?!1:E===4||E===2||E===3||U===4||U===2||U===3?!0:!(E===8&&(U===8||U===9||U===11||U===12)||(E===11||E===9)&&(U===9||U===10)||(E===12||E===10)&&U===10||U===5||U===13||U===7||E===1||E===13&&U===14||E===6&&U===6)}n.breakBetweenGraphemeBreakType=ce;var Se;(function(E){E[E.Other=0]="Other",E[E.Prepend=1]="Prepend",E[E.CR=2]="CR",E[E.LF=3]="LF",E[E.Control=4]="Control",E[E.Extend=5]="Extend",E[E.Regional_Indicator=6]="Regional_Indicator",E[E.SpacingMark=7]="SpacingMark",E[E.L=8]="L",E[E.V=9]="V",E[E.T=10]="T",E[E.LV=11]="LV",E[E.LVT=12]="LVT",E[E.ZWJ=13]="ZWJ",E[E.Extended_Pictographic=14]="Extended_Pictographic"})(Se=n.GraphemeBreakType||(n.GraphemeBreakType={}));class ue{constructor(){this._data=Be()}static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const k=this._data,W=k.length/3;let H=1;for(;H<=W;)if(U<k[3*H])H=2*H;else if(U>k[3*H+1])H=2*H+1;else return k[3*H+2];return 0}}ue._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Oe(E,U){if(E===0)return 0;const k=Ve(E,U);if(k!==void 0)return k;const W=q(U,E);return E-=fe(W),E}n.getLeftDeleteOffset=Oe;function Ve(E,U){let k=q(U,E);for(E-=fe(k);We(k)||k===65039||k===8419;){if(E===0)return;k=q(U,E),E-=fe(k)}if(!!_e(k)){if(E>=0){const W=q(U,E);W===8205&&(E-=fe(W))}return E}}function fe(E){return E>=65536?2:1}function We(E){return 127995<=E&&E<=127999}var Le;(function(E){E[E.zwj=8205]="zwj",E[E.emojiVariantSelector=65039]="emojiVariantSelector",E[E.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={}))}),G(Y[22],Q([0,1,4]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function T(N){return D(N,0)}n.hash=T;function D(N,M){switch(typeof N){case"object":return N===null?u(349,M):Array.isArray(N)?a(N,M):c(N,M);case"string":return f(N,M);case"boolean":return L(N,M);case"number":return u(N,M);case"undefined":return u(937,M);default:return u(617,M)}}n.doHash=D;function u(N,M){return(M<<5)-M+N|0}n.numberHash=u;function L(N,M){return u(N?433:863,M)}function f(N,M){M=u(149417,M);for(let i=0,r=N.length;i<r;i++)M=u(N.charCodeAt(i),M);return M}n.stringHash=f;function a(N,M){return M=u(104579,M),N.reduce((i,r)=>D(r,i),M)}function c(N,M){return M=u(181387,M),Object.keys(N).sort().reduce((i,r)=>(i=f(r,i),D(N[r],i)),M)}class v{constructor(){this._value=0}get value(){return this._value}hash(M){return this._value=D(M,this._value),this._value}}n.Hasher=v;var A;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function g(N,M,i=32){const r=i-M,s=~((1<<r)-1);return(N<<M|(s&N)>>>r)>>>0}function d(N,M=0,i=N.byteLength,r=0){for(let s=0;s<i;s++)N[M+s]=r}function e(N,M,i="0"){for(;N.length<M;)N=i+N;return N}function w(N,M=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),M/4)}n.toHexString=w;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(M){const i=M.length;if(i===0)return;const r=this._buff;let s=this._buffLen,m=this._leftoverHighSurrogate,_,o;for(m!==0?(_=m,o=-1,m=0):(_=M.charCodeAt(0),o=0);;){let l=_;if(R.isHighSurrogate(_))if(o+1<i){const h=M.charCodeAt(o+1);R.isLowSurrogate(h)?(o++,l=R.computeCodePoint(_,h)):l=65533}else{m=_;break}else R.isLowSurrogate(_)&&(l=65533);if(s=this._push(r,s,l),o++,o<i)_=M.charCodeAt(o);else break}this._buffLen=s,this._leftoverHighSurrogate=m}_push(M,i,r){return r<128?M[i++]=r:r<2048?(M[i++]=192|(r&1984)>>>6,M[i++]=128|(r&63)>>>0):r<65536?(M[i++]=224|(r&61440)>>>12,M[i++]=128|(r&4032)>>>6,M[i++]=128|(r&63)>>>0):(M[i++]=240|(r&1835008)>>>18,M[i++]=128|(r&258048)>>>12,M[i++]=128|(r&4032)>>>6,M[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,M[0]=M[64+0],M[1]=M[64+1],M[2]=M[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const M=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(M/4294967296),!1),this._buffDV.setUint32(60,M%4294967296,!1),this._step()}_step(){const M=p._bigBlock32,i=this._buffDV;for(let P=0;P<64;P+=4)M.setUint32(P,i.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)M.setUint32(P,g(M.getUint32(P-12,!1)^M.getUint32(P-32,!1)^M.getUint32(P-56,!1)^M.getUint32(P-64,!1),1),!1);let r=this._h0,s=this._h1,m=this._h2,_=this._h3,o=this._h4,l,h,b;for(let P=0;P<80;P++)P<20?(l=s&m|~s&_,h=1518500249):P<40?(l=s^m^_,h=1859775393):P<60?(l=s&m|s&_|m&_,h=2400959708):(l=s^m^_,h=3395469782),b=g(r,5)+l+o+h+M.getUint32(P*4,!1)&4294967295,o=_,_=m,m=g(s,30),s=r,r=b;this._h0=this._h0+r&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+m&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+o&4294967295}}n.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),G(Y[11],Q([0,1,15,22]),function(y,n,R,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class D{constructor(g){this.source=g}getElements(){const g=this.source,d=new Int32Array(g.length);for(let e=0,w=g.length;e<w;e++)d[e]=g.charCodeAt(e);return d}}n.StringDiffSequence=D;function u(A,g,d){return new v(new D(A),new D(g)).ComputeDiff(d).changes}n.stringDiff=u;class L{static Assert(g,d){if(!g)throw new Error(d)}}n.Debug=L;class f{static Copy(g,d,e,w,p){for(let N=0;N<p;N++)e[w+N]=g[d+N]}static Copy2(g,d,e,w,p){for(let N=0;N<p;N++)e[w+N]=g[d+N]}}n.MyArray=f;var a;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new R.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(g,d){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(g,d){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class v{constructor(g,d,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=g,this._modifiedSequence=d;const[w,p,N]=v._getElements(g),[M,i,r]=v._getElements(d);this._hasStrings=N&&r,this._originalStringElements=w,this._originalElementsOrHash=p,this._modifiedStringElements=M,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(g){return g.length>0&&typeof g[0]=="string"}static _getElements(g){const d=g.getElements();if(v._isStringArray(d)){const e=new Int32Array(d.length);for(let w=0,p=d.length;w<p;w++)e[w]=(0,T.stringHash)(d[w],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(g,d){return this._originalElementsOrHash[g]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[g]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(g,d){if(!this.ElementsAreEqual(g,d))return!1;const e=v._getStrictElement(this._originalSequence,g),w=v._getStrictElement(this._modifiedSequence,d);return e===w}static _getStrictElement(g,d){return typeof g.getStrictElement=="function"?g.getStrictElement(d):null}OriginalElementsAreEqual(g,d){return this._originalElementsOrHash[g]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[g]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(g,d){return this._modifiedElementsOrHash[g]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[g]===this._modifiedStringElements[d]:!0}ComputeDiff(g){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,g)}_ComputeDiff(g,d,e,w,p){const N=[!1];let M=this.ComputeDiffRecursive(g,d,e,w,N);return p&&(M=this.PrettifyChanges(M)),{quitEarly:N[0],changes:M}}ComputeDiffRecursive(g,d,e,w,p){for(p[0]=!1;g<=d&&e<=w&&this.ElementsAreEqual(g,e);)g++,e++;for(;d>=g&&w>=e&&this.ElementsAreEqual(d,w);)d--,w--;if(g>d||e>w){let m;return e<=w?(L.Assert(g===d+1,"originalStart should only be one more than originalEnd"),m=[new R.DiffChange(g,0,e,w-e+1)]):g<=d?(L.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),m=[new R.DiffChange(g,d-g+1,e,0)]):(L.Assert(g===d+1,"originalStart should only be one more than originalEnd"),L.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),m=[]),m}const N=[0],M=[0],i=this.ComputeRecursionPoint(g,d,e,w,N,M,p),r=N[0],s=M[0];if(i!==null)return i;if(!p[0]){const m=this.ComputeDiffRecursive(g,r,e,s,p);let _=[];return p[0]?_=[new R.DiffChange(r+1,d-(r+1)+1,s+1,w-(s+1)+1)]:_=this.ComputeDiffRecursive(r+1,d,s+1,w,p),this.ConcatenateChanges(m,_)}return[new R.DiffChange(g,d-g+1,e,w-e+1)]}WALKTRACE(g,d,e,w,p,N,M,i,r,s,m,_,o,l,h,b,P,F){let I=null,S=null,V=new c,O=d,z=e,C=o[0]-b[0]-w,K=-1073741824,t=this.m_forwardHistory.length-1;do{const q=C+g;q===O||q<z&&r[q-1]<r[q+1]?(m=r[q+1],l=m-C-w,m<K&&V.MarkNextChange(),K=m,V.AddModifiedElement(m+1,l),C=q+1-g):(m=r[q-1]+1,l=m-C-w,m<K&&V.MarkNextChange(),K=m-1,V.AddOriginalElement(m,l+1),C=q-1-g),t>=0&&(r=this.m_forwardHistory[t],g=r[0],O=1,z=r.length-1)}while(--t>=-1);if(I=V.getReverseChanges(),F[0]){let q=o[0]+1,B=b[0]+1;if(I!==null&&I.length>0){const j=I[I.length-1];q=Math.max(q,j.getOriginalEnd()),B=Math.max(B,j.getModifiedEnd())}S=[new R.DiffChange(q,_-q+1,B,h-B+1)]}else{V=new c,O=N,z=M,C=o[0]-b[0]-i,K=1073741824,t=P?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const q=C+p;q===O||q<z&&s[q-1]>=s[q+1]?(m=s[q+1]-1,l=m-C-i,m>K&&V.MarkNextChange(),K=m+1,V.AddOriginalElement(m+1,l+1),C=q+1-p):(m=s[q-1],l=m-C-i,m>K&&V.MarkNextChange(),K=m,V.AddModifiedElement(m+1,l+1),C=q-1-p),t>=0&&(s=this.m_reverseHistory[t],p=s[0],O=1,z=s.length-1)}while(--t>=-1);S=V.getChanges()}return this.ConcatenateChanges(I,S)}ComputeRecursionPoint(g,d,e,w,p,N,M){let i=0,r=0,s=0,m=0,_=0,o=0;g--,e--,p[0]=0,N[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const l=d-g+(w-e),h=l+1,b=new Int32Array(h),P=new Int32Array(h),F=w-e,I=d-g,S=g-e,V=d-w,z=(I-F)%2==0;b[F]=g,P[I]=d,M[0]=!1;for(let C=1;C<=l/2+1;C++){let K=0,t=0;s=this.ClipDiagonalBound(F-C,C,F,h),m=this.ClipDiagonalBound(F+C,C,F,h);for(let B=s;B<=m;B+=2){B===s||B<m&&b[B-1]<b[B+1]?i=b[B+1]:i=b[B-1]+1,r=i-(B-F)-S;const j=i;for(;i<d&&r<w&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(b[B]=i,i+r>K+t&&(K=i,t=r),!z&&Math.abs(B-I)<=C-1&&i>=P[B])return p[0]=i,N[0]=r,j<=P[B]&&1447>0&&C<=1447+1?this.WALKTRACE(F,s,m,S,I,_,o,V,b,P,i,d,p,r,w,N,z,M):null}const q=(K-g+(t-e)-C)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(K,q))return M[0]=!0,p[0]=K,N[0]=t,q>0&&1447>0&&C<=1447+1?this.WALKTRACE(F,s,m,S,I,_,o,V,b,P,i,d,p,r,w,N,z,M):(g++,e++,[new R.DiffChange(g,d-g+1,e,w-e+1)]);_=this.ClipDiagonalBound(I-C,C,I,h),o=this.ClipDiagonalBound(I+C,C,I,h);for(let B=_;B<=o;B+=2){B===_||B<o&&P[B-1]>=P[B+1]?i=P[B+1]-1:i=P[B-1],r=i-(B-I)-V;const j=i;for(;i>g&&r>e&&this.ElementsAreEqual(i,r);)i--,r--;if(P[B]=i,z&&Math.abs(B-F)<=C&&i<=b[B])return p[0]=i,N[0]=r,j>=b[B]&&1447>0&&C<=1447+1?this.WALKTRACE(F,s,m,S,I,_,o,V,b,P,i,d,p,r,w,N,z,M):null}if(C<=1447){let B=new Int32Array(m-s+2);B[0]=F-s+1,f.Copy2(b,s,B,1,m-s+1),this.m_forwardHistory.push(B),B=new Int32Array(o-_+2),B[0]=I-_+1,f.Copy2(P,_,B,1,o-_+1),this.m_reverseHistory.push(B)}}return this.WALKTRACE(F,s,m,S,I,_,o,V,b,P,i,d,p,r,w,N,z,M)}PrettifyChanges(g){for(let d=0;d<g.length;d++){const e=g[d],w=d<g.length-1?g[d+1].originalStart:this._originalElementsOrHash.length,p=d<g.length-1?g[d+1].modifiedStart:this._modifiedElementsOrHash.length,N=e.originalLength>0,M=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<p&&(!N||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!M||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const r=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!r)break;e.originalStart++,e.modifiedStart++}let i=[null];if(d<g.length-1&&this.ChangesOverlap(g[d],g[d+1],i)){g[d]=i[0],g.splice(d+1,1),d--;continue}}for(let d=g.length-1;d>=0;d--){const e=g[d];let w=0,p=0;if(d>0){const m=g[d-1];w=m.originalStart+m.originalLength,p=m.modifiedStart+m.modifiedLength}const N=e.originalLength>0,M=e.modifiedLength>0;let i=0,r=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let m=1;;m++){const _=e.originalStart-m,o=e.modifiedStart-m;if(_<w||o<p||N&&!this.OriginalElementsAreEqual(_,_+e.originalLength)||M&&!this.ModifiedElementsAreEqual(o,o+e.modifiedLength))break;const h=(_===w&&o===p?5:0)+this._boundaryScore(_,e.originalLength,o,e.modifiedLength);h>r&&(r=h,i=m)}e.originalStart-=i,e.modifiedStart-=i;const s=[null];if(d>0&&this.ChangesOverlap(g[d-1],g[d],s)){g[d-1]=s[0],g.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,e=g.length;d<e;d++){const w=g[d-1],p=g[d],N=p.originalStart-w.originalStart-w.originalLength,M=w.originalStart,i=p.originalStart+p.originalLength,r=i-M,s=w.modifiedStart,m=p.modifiedStart+p.modifiedLength,_=m-s;if(N<5&&r<20&&_<20){const o=this._findBetterContiguousSequence(M,r,s,_,N);if(o){const[l,h]=o;(l!==w.originalStart+w.originalLength||h!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=l-w.originalStart,w.modifiedLength=h-w.modifiedStart,p.originalStart=l+N,p.modifiedStart=h+N,p.originalLength=i-p.originalStart,p.modifiedLength=m-p.modifiedStart)}}}return g}_findBetterContiguousSequence(g,d,e,w,p){if(d<p||w<p)return null;const N=g+d-p+1,M=e+w-p+1;let i=0,r=0,s=0;for(let m=g;m<N;m++)for(let _=e;_<M;_++){const o=this._contiguousSequenceScore(m,_,p);o>0&&o>i&&(i=o,r=m,s=_)}return i>0?[r,s]:null}_contiguousSequenceScore(g,d,e){let w=0;for(let p=0;p<e;p++){if(!this.ElementsAreEqual(g+p,d+p))return 0;w+=this._originalStringElements[g+p].length}return w}_OriginalIsBoundary(g){return g<=0||g>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[g])}_OriginalRegionIsBoundary(g,d){if(this._OriginalIsBoundary(g)||this._OriginalIsBoundary(g-1))return!0;if(d>0){const e=g+d;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(g){return g<=0||g>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[g])}_ModifiedRegionIsBoundary(g,d){if(this._ModifiedIsBoundary(g)||this._ModifiedIsBoundary(g-1))return!0;if(d>0){const e=g+d;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(g,d,e,w){const p=this._OriginalRegionIsBoundary(g,d)?1:0,N=this._ModifiedRegionIsBoundary(e,w)?1:0;return p+N}ConcatenateChanges(g,d){let e=[];if(g.length===0||d.length===0)return d.length>0?d:g;if(this.ChangesOverlap(g[g.length-1],d[0],e)){const w=new Array(g.length+d.length-1);return f.Copy(g,0,w,0,g.length-1),w[g.length-1]=e[0],f.Copy(d,1,w,g.length,d.length-1),w}else{const w=new Array(g.length+d.length);return f.Copy(g,0,w,0,g.length),f.Copy(d,0,w,g.length,d.length),w}}ChangesOverlap(g,d,e){if(L.Assert(g.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),L.Assert(g.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=d.originalStart||g.modifiedStart+g.modifiedLength>=d.modifiedStart){const w=g.originalStart;let p=g.originalLength;const N=g.modifiedStart;let M=g.modifiedLength;return g.originalStart+g.originalLength>=d.originalStart&&(p=d.originalStart+d.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=d.modifiedStart&&(M=d.modifiedStart+d.modifiedLength-g.modifiedStart),e[0]=new R.DiffChange(w,p,N,M),!0}else return e[0]=null,!1}ClipDiagonalBound(g,d,e,w){if(g>=0&&g<w)return g;const p=e,N=w-e-1,M=d%2==0;if(g<0){const i=p%2==0;return M===i?0:1}else{const i=N%2==0;return M===i?w-1:w-2}}}n.LcsDiff=v}),G(Y[12],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isPromise=n.assertNever=n.NotImplementedProxy=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function R(F){return Array.isArray(F)}n.isArray=R;function T(F){return typeof F=="string"}n.isString=T;function D(F){return Array.isArray(F)&&F.every(I=>T(I))}n.isStringArray=D;function u(F){return typeof F=="object"&&F!==null&&!Array.isArray(F)&&!(F instanceof RegExp)&&!(F instanceof Date)}n.isObject=u;function L(F){return typeof F=="number"&&!isNaN(F)}n.isNumber=L;function f(F){return!!F&&typeof F[Symbol.iterator]=="function"}n.isIterable=f;function a(F){return F===!0||F===!1}n.isBoolean=a;function c(F){return typeof F=="undefined"}n.isUndefined=c;function v(F){return!A(F)}n.isDefined=v;function A(F){return c(F)||F===null}n.isUndefinedOrNull=A;function g(F,I){if(!F)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}n.assertType=g;function d(F){if(A(F))throw new Error("Assertion Failed: argument is undefined or null");return F}n.assertIsDefined=d;function e(...F){const I=[];for(let S=0;S<F.length;S++){const V=F[S];if(A(V))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);I.push(V)}return I}n.assertAllDefined=e;const w=Object.prototype.hasOwnProperty;function p(F){if(!u(F))return!1;for(let I in F)if(w.call(F,I))return!1;return!0}n.isEmptyObject=p;function N(F){return typeof F=="function"}n.isFunction=N;function M(...F){return F.length>0&&F.every(N)}n.areFunctions=M;function i(F,I){const S=Math.min(F.length,I.length);for(let V=0;V<S;V++)r(F[V],I[V])}n.validateConstraints=i;function r(F,I){if(T(I)){if(typeof F!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(N(I)){try{if(F instanceof I)return}catch{}if(!A(F)&&F.constructor===I||I.length===1&&I.call(void 0,F)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=r;function s(F){let I=[],S=Object.getPrototypeOf(F);for(;Object.prototype!==S;)I=I.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return I}n.getAllPropertyNames=s;function m(F){const I=[];for(const S of s(F))typeof F[S]=="function"&&I.push(S);return I}n.getAllMethodNames=m;function _(F,I){const S=O=>function(){const z=Array.prototype.slice.call(arguments,0);return I(O,z)};let V={};for(const O of F)V[O]=S(O);return V}n.createProxyObject=_;function o(F){return F===null?void 0:F}n.withNullAsUndefined=o;function l(F){return typeof F=="undefined"?null:F}n.withUndefinedAsNull=l;function h(F){return class{constructor(){return new Proxy({},{get(I,S){if(I[S])return I[S];throw new Error(`Not Implemented: ${F}->${String(S)}`)}})}}}n.NotImplementedProxy=h;function b(F,I="Unreachable"){throw new Error(I)}n.assertNever=b;function P(F){return!!F&&typeof F.then=="function"&&typeof F.catch=="function"}n.isPromise=P}),G(Y[13],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var R;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R=n.Constants||(n.Constants={}));function T(u){return u<0?0:u>255?255:u|0}n.toUint8=T;function D(u){return u<0?0:u>4294967295?4294967295:u|0}n.toUint32=D}),G(Y[14],Q([0,1,20,2]),function(y,n,R,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const D=/^\w[\w\d+.-]*$/,u=/^\//,L=/^\/\//;function f(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!D.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!u.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(o,l){return!o&&!l?"file":o}function c(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==A&&(l=A+l):l=A;break}return l}const v="",A="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(l,h,b,P,F,I=!1){typeof l=="object"?(this.scheme=l.scheme||v,this.authority=l.authority||v,this.path=l.path||v,this.query=l.query||v,this.fragment=l.fragment||v):(this.scheme=a(l,I),this.authority=h||v,this.path=c(this.scheme,b||v),this.query=P||v,this.fragment=F||v,f(this,I))}static isUri(l){return l instanceof d?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return i(this,!1)}with(l){if(!l)return this;let{scheme:h,authority:b,path:P,query:F,fragment:I}=l;return h===void 0?h=this.scheme:h===null&&(h=v),b===void 0?b=this.authority:b===null&&(b=v),P===void 0?P=this.path:P===null&&(P=v),F===void 0?F=this.query:F===null&&(F=v),I===void 0?I=this.fragment:I===null&&(I=v),h===this.scheme&&b===this.authority&&P===this.path&&F===this.query&&I===this.fragment?this:new w(h,b,P,F,I)}static parse(l,h=!1){const b=g.exec(l);return b?new w(b[2]||v,_(b[4]||v),_(b[5]||v),_(b[7]||v),_(b[9]||v),h):new w(v,v,v,v,v)}static file(l){let h=v;if(T.isWindows&&(l=l.replace(/\\/g,A)),l[0]===A&&l[1]===A){const b=l.indexOf(A,2);b===-1?(h=l.substring(2),l=A):(h=l.substring(2,b),l=l.substring(b)||A)}return new w("file",h,l,v,v)}static from(l){const h=new w(l.scheme,l.authority,l.path,l.query,l.fragment);return f(h,!0),h}static joinPath(l,...h){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return T.isWindows&&l.scheme==="file"?b=d.file(R.win32.join(i(l,!0),...h)).path:b=R.posix.join(l.path,...h),l.with({path:b})}toString(l=!1){return r(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof d)return l;{const h=new w(l);return h._formatted=l.external,h._fsPath=l._sep===e?l.fsPath:null,h}}else return l}}n.URI=d;const e=T.isWindows?1:void 0;class w extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(l=!1){return l?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=e),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function N(o,l){let h,b=-1;for(let P=0;P<o.length;P++){const F=o.charCodeAt(P);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||l&&F===47)b!==-1&&(h+=encodeURIComponent(o.substring(b,P)),b=-1),h!==void 0&&(h+=o.charAt(P));else{h===void 0&&(h=o.substr(0,P));const I=p[F];I!==void 0?(b!==-1&&(h+=encodeURIComponent(o.substring(b,P)),b=-1),h+=I):b===-1&&(b=P)}}return b!==-1&&(h+=encodeURIComponent(o.substring(b))),h!==void 0?h:o}function M(o){let l;for(let h=0;h<o.length;h++){const b=o.charCodeAt(h);b===35||b===63?(l===void 0&&(l=o.substr(0,h)),l+=p[b]):l!==void 0&&(l+=o[h])}return l!==void 0?l:o}function i(o,l){let h;return o.authority&&o.path.length>1&&o.scheme==="file"?h=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?l?h=o.path.substr(1):h=o.path[1].toLowerCase()+o.path.substr(2):h=o.path,T.isWindows&&(h=h.replace(/\//g,"\\")),h}n.uriToFsPath=i;function r(o,l){const h=l?M:N;let b="",{scheme:P,authority:F,path:I,query:S,fragment:V}=o;if(P&&(b+=P,b+=":"),(F||P==="file")&&(b+=A,b+=A),F){let O=F.indexOf("@");if(O!==-1){const z=F.substr(0,O);F=F.substr(O+1),O=z.indexOf(":"),O===-1?b+=h(z,!1):(b+=h(z.substr(0,O),!1),b+=":",b+=h(z.substr(O+1),!1)),b+="@"}F=F.toLowerCase(),O=F.indexOf(":"),O===-1?b+=h(F,!1):(b+=h(F.substr(0,O),!1),b+=F.substr(O))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const O=I.charCodeAt(1);O>=65&&O<=90&&(I=`/${String.fromCharCode(O+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const O=I.charCodeAt(0);O>=65&&O<=90&&(I=`${String.fromCharCode(O+32)}:${I.substr(2)}`)}b+=h(I,!0)}return S&&(b+="?",b+=h(S,!1)),V&&(b+="#",b+=l?V:N(V,!1)),b}function s(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const m=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function _(o){return o.match(m)?o.replace(m,l=>s(l)):o}}),G(Y[34],Q([0,1,7,5,9,2,12,4]),function(y,n,R,T,D,u,L,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let c=!1;function v(o){!u.isWeb||(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}n.logOnceWebWorkerWarning=v;var A;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class g{constructor(l,h,b,P){this.vsWorker=l,this.req=h,this.method=b,this.args=P,this.type=0}}class d{constructor(l,h,b,P){this.vsWorker=l,this.seq=h,this.res=b,this.err=P,this.type=1}}class e{constructor(l,h,b,P){this.vsWorker=l,this.req=h,this.eventName=b,this.arg=P,this.type=2}}class w{constructor(l,h,b){this.vsWorker=l,this.req=h,this.event=b,this.type=3}}class p{constructor(l,h){this.vsWorker=l,this.req=h,this.type=4}}class N{constructor(l){this._workerId=-1,this._handler=l,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(l){this._workerId=l}sendMessage(l,h){const b=String(++this._lastSentReq);return new Promise((P,F)=>{this._pendingReplies[b]={resolve:P,reject:F},this._send(new g(this._workerId,b,l,h))})}listen(l,h){let b=null;const P=new T.Emitter({onFirstListenerAdd:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,P),this._send(new e(this._workerId,b,l,h))},onLastListenerRemove:()=>{this._pendingEmitters.delete(b),this._send(new p(this._workerId,b)),b=null}});return P.event}handleMessage(l){!l||!l.vsWorker||this._workerId!==-1&&l.vsWorker!==this._workerId||this._handleMessage(l)}_handleMessage(l){switch(l.type){case 1:return this._handleReplyMessage(l);case 0:return this._handleRequestMessage(l);case 2:return this._handleSubscribeEventMessage(l);case 3:return this._handleEventMessage(l);case 4:return this._handleUnsubscribeEventMessage(l)}}_handleReplyMessage(l){if(!this._pendingReplies[l.seq]){console.warn("Got reply to unknown seq");return}let h=this._pendingReplies[l.seq];if(delete this._pendingReplies[l.seq],l.err){let b=l.err;l.err.$isError&&(b=new Error,b.name=l.err.name,b.message=l.err.message,b.stack=l.err.stack),h.reject(b);return}h.resolve(l.res)}_handleRequestMessage(l){let h=l.req;this._handler.handleMessage(l.method,l.args).then(P=>{this._send(new d(this._workerId,h,P,void 0))},P=>{P.detail instanceof Error&&(P.detail=(0,R.transformErrorForSerialization)(P.detail)),this._send(new d(this._workerId,h,void 0,(0,R.transformErrorForSerialization)(P)))})}_handleSubscribeEventMessage(l){const h=l.req,b=this._handler.handleEvent(l.eventName,l.arg)(P=>{this._send(new w(this._workerId,h,P))});this._pendingEvents.set(h,b)}_handleEventMessage(l){if(!this._pendingEmitters.has(l.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(l.req).fire(l.event)}_handleUnsubscribeEventMessage(l){if(!this._pendingEvents.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(l.req).dispose(),this._pendingEvents.delete(l.req)}_send(l){let h=[];if(l.type===0)for(let b=0;b<l.args.length;b++)l.args[b]instanceof ArrayBuffer&&h.push(l.args[b]);else l.type===1&&l.res instanceof ArrayBuffer&&h.push(l.res);this._handler.sendMessage(l,h)}}class M extends D.Disposable{constructor(l,h,b){super();let P=null;this._worker=this._register(l.create("vs/base/common/worker/simpleWorker",O=>{this._protocol.handleMessage(O)},O=>{P&&P(O)})),this._protocol=new N({sendMessage:(O,z)=>{this._worker.postMessage(O,z)},handleMessage:(O,z)=>{if(typeof b[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(b[O].apply(b,z))}catch(C){return Promise.reject(C)}},handleEvent:(O,z)=>{if(r(O)){const C=b[O].call(b,z);if(typeof C!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return C}if(i(O)){const C=b[O];if(typeof C!="function")throw new Error(`Missing event ${O} on main thread host.`);return C}throw new Error(`Malformed event name ${O}`)}}),this._protocol.setWorkerId(this._worker.getId());let F=null;typeof u.globals.require!="undefined"&&typeof u.globals.require.getConfig=="function"?F=u.globals.require.getConfig():typeof u.globals.requirejs!="undefined"&&(F=u.globals.requirejs.s.contexts._.config);const I=L.getAllMethodNames(b);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(F)),h,I]);const S=(O,z)=>this._request(O,z),V=(O,z)=>this._protocol.listen(O,z);this._lazyProxy=new Promise((O,z)=>{P=z,this._onModuleLoaded.then(C=>{O(s(C,S,V))},C=>{z(C),this._onError("Worker failed to load "+h,C)})})}getProxyObject(){return this._lazyProxy}_request(l,h){return new Promise((b,P)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(l,h).then(b,P)},P)})}_onError(l,h){console.error(l),console.info(h)}}n.SimpleWorkerClient=M;function i(o){return o[0]==="o"&&o[1]==="n"&&f.isUpperAsciiLetter(o.charCodeAt(2))}function r(o){return/^onDynamic/.test(o)&&f.isUpperAsciiLetter(o.charCodeAt(9))}function s(o,l,h){const b=I=>function(){const S=Array.prototype.slice.call(arguments,0);return l(I,S)},P=I=>function(S){return h(I,S)};let F={};for(const I of o){if(r(I)){F[I]=P(I);continue}if(i(I)){F[I]=h(I,void 0);continue}F[I]=b(I)}return F}class m{constructor(l,h){this._requestHandlerFactory=h,this._requestHandler=null,this._protocol=new N({sendMessage:(b,P)=>{l(b,P)},handleMessage:(b,P)=>this._handleMessage(b,P),handleEvent:(b,P)=>this._handleEvent(b,P)})}onmessage(l){this._protocol.handleMessage(l)}_handleMessage(l,h){if(l===a)return this.initialize(h[0],h[1],h[2],h[3]);if(!this._requestHandler||typeof this._requestHandler[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._requestHandler[l].apply(this._requestHandler,h))}catch(b){return Promise.reject(b)}}_handleEvent(l,h){if(!this._requestHandler)throw new Error("Missing requestHandler");if(r(l)){const b=this._requestHandler[l].call(this._requestHandler,h);if(typeof b!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return b}if(i(l)){const b=this._requestHandler[l];if(typeof b!="function")throw new Error(`Missing event ${l} on request handler.`);return b}throw new Error(`Malformed event name ${l}`)}initialize(l,h,b,P){this._protocol.setWorkerId(l);const S=s(P,(V,O)=>this._protocol.sendMessage(V,O),(V,O)=>this._protocol.listen(V,O));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(S),Promise.resolve(L.getAllMethodNames(this._requestHandler))):(h&&(typeof h.baseUrl!="undefined"&&delete h.baseUrl,typeof h.paths!="undefined"&&typeof h.paths.vs!="undefined"&&delete h.paths.vs,typeof h.trustedTypesPolicy!==void 0&&delete h.trustedTypesPolicy,h.catchError=!0,u.globals.require.config(h)),new Promise((V,O)=>{(u.globals.require||y)([b],C=>{if(this._requestHandler=C.create(S),!this._requestHandler){O(new Error("No RequestHandler!"));return}V(L.getAllMethodNames(this._requestHandler))},O)}))}}n.SimpleWorkerServer=m;function _(o){return new m(o,null)}n.create=_}),G(Y[23],Q([0,1,13]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class T{constructor(f){let a=(0,R.toUint8)(f);this._defaultValue=a,this._asciiMap=T._createAsciiMap(a),this._map=new Map}static _createAsciiMap(f){let a=new Uint8Array(256);for(let c=0;c<256;c++)a[c]=f;return a}set(f,a){let c=(0,R.toUint8)(a);f>=0&&f<256?this._asciiMap[f]=c:this._map.set(f,c)}get(f){return f>=0&&f<256?this._asciiMap[f]:this._map.get(f)||this._defaultValue}}n.CharacterClassifier=T;var D;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(D||(D={}));class u{constructor(){this._actual=new T(0)}add(f){this._actual.set(f,1)}has(f){return this._actual.get(f)===1}}n.CharacterSet=u}),G(Y[3],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class R{constructor(D,u){this.lineNumber=D,this.column=u}with(D=this.lineNumber,u=this.column){return D===this.lineNumber&&u===this.column?this:new R(D,u)}delta(D=0,u=0){return this.with(this.lineNumber+D,this.column+u)}equals(D){return R.equals(this,D)}static equals(D,u){return!D&&!u?!0:!!D&&!!u&&D.lineNumber===u.lineNumber&&D.column===u.column}isBefore(D){return R.isBefore(this,D)}static isBefore(D,u){return D.lineNumber<u.lineNumber?!0:u.lineNumber<D.lineNumber?!1:D.column<u.column}isBeforeOrEqual(D){return R.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,u){return D.lineNumber<u.lineNumber?!0:u.lineNumber<D.lineNumber?!1:D.column<=u.column}static compare(D,u){let L=D.lineNumber|0,f=u.lineNumber|0;if(L===f){let a=D.column|0,c=u.column|0;return a-c}return L-f}clone(){return new R(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new R(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}n.Position=R}),G(Y[6],Q([0,1,3]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class T{constructor(u,L,f,a){u>f||u===f&&L>a?(this.startLineNumber=f,this.startColumn=a,this.endLineNumber=u,this.endColumn=L):(this.startLineNumber=u,this.startColumn=L,this.endLineNumber=f,this.endColumn=a)}isEmpty(){return T.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return T.containsPosition(this,u)}static containsPosition(u,L){return!(L.lineNumber<u.startLineNumber||L.lineNumber>u.endLineNumber||L.lineNumber===u.startLineNumber&&L.column<u.startColumn||L.lineNumber===u.endLineNumber&&L.column>u.endColumn)}containsRange(u){return T.containsRange(this,u)}static containsRange(u,L){return!(L.startLineNumber<u.startLineNumber||L.endLineNumber<u.startLineNumber||L.startLineNumber>u.endLineNumber||L.endLineNumber>u.endLineNumber||L.startLineNumber===u.startLineNumber&&L.startColumn<u.startColumn||L.endLineNumber===u.endLineNumber&&L.endColumn>u.endColumn)}strictContainsRange(u){return T.strictContainsRange(this,u)}static strictContainsRange(u,L){return!(L.startLineNumber<u.startLineNumber||L.endLineNumber<u.startLineNumber||L.startLineNumber>u.endLineNumber||L.endLineNumber>u.endLineNumber||L.startLineNumber===u.startLineNumber&&L.startColumn<=u.startColumn||L.endLineNumber===u.endLineNumber&&L.endColumn>=u.endColumn)}plusRange(u){return T.plusRange(this,u)}static plusRange(u,L){let f,a,c,v;return L.startLineNumber<u.startLineNumber?(f=L.startLineNumber,a=L.startColumn):L.startLineNumber===u.startLineNumber?(f=L.startLineNumber,a=Math.min(L.startColumn,u.startColumn)):(f=u.startLineNumber,a=u.startColumn),L.endLineNumber>u.endLineNumber?(c=L.endLineNumber,v=L.endColumn):L.endLineNumber===u.endLineNumber?(c=L.endLineNumber,v=Math.max(L.endColumn,u.endColumn)):(c=u.endLineNumber,v=u.endColumn),new T(f,a,c,v)}intersectRanges(u){return T.intersectRanges(this,u)}static intersectRanges(u,L){let f=u.startLineNumber,a=u.startColumn,c=u.endLineNumber,v=u.endColumn,A=L.startLineNumber,g=L.startColumn,d=L.endLineNumber,e=L.endColumn;return f<A?(f=A,a=g):f===A&&(a=Math.max(a,g)),c>d?(c=d,v=e):c===d&&(v=Math.min(v,e)),f>c||f===c&&a>v?null:new T(f,a,c,v)}equalsRange(u){return T.equalsRange(this,u)}static equalsRange(u,L){return!!u&&!!L&&u.startLineNumber===L.startLineNumber&&u.startColumn===L.startColumn&&u.endLineNumber===L.endLineNumber&&u.endColumn===L.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(u){return new R.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(u){return new R.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,L){return new T(this.startLineNumber,this.startColumn,u,L)}setStartPosition(u,L){return new T(u,L,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(u){return new T(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}static fromPositions(u,L=u){return new T(u.lineNumber,u.column,L.lineNumber,L.column)}static lift(u){return u?new T(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,L){return!(u.endLineNumber<L.startLineNumber||u.endLineNumber===L.startLineNumber&&u.endColumn<L.startColumn||L.endLineNumber<u.startLineNumber||L.endLineNumber===u.startLineNumber&&L.endColumn<u.startColumn)}static areIntersecting(u,L){return!(u.endLineNumber<L.startLineNumber||u.endLineNumber===L.startLineNumber&&u.endColumn<=L.startColumn||L.endLineNumber<u.startLineNumber||L.endLineNumber===u.startLineNumber&&L.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,L){if(u&&L){const c=u.startLineNumber|0,v=L.startLineNumber|0;if(c===v){const A=u.startColumn|0,g=L.startColumn|0;if(A===g){const d=u.endLineNumber|0,e=L.endLineNumber|0;if(d===e){const w=u.endColumn|0,p=L.endColumn|0;return w-p}return d-e}return A-g}return c-v}return(u?1:0)-(L?1:0)}static compareRangesUsingEnds(u,L){return u.endLineNumber===L.endLineNumber?u.endColumn===L.endColumn?u.startLineNumber===L.startLineNumber?u.startColumn-L.startColumn:u.startLineNumber-L.startLineNumber:u.endColumn-L.endColumn:u.endLineNumber-L.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}}n.Range=T}),G(Y[24],Q([0,1,3,6]),function(y,n,R,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var D;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(D=n.SelectionDirection||(n.SelectionDirection={}));class u extends T.Range{constructor(f,a,c,v){super(f,a,c,v);this.selectionStartLineNumber=f,this.selectionStartColumn=a,this.positionLineNumber=c,this.positionColumn=v}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return u.selectionsEqual(this,f)}static selectionsEqual(f,a){return f.selectionStartLineNumber===a.selectionStartLineNumber&&f.selectionStartColumn===a.selectionStartColumn&&f.positionLineNumber===a.positionLineNumber&&f.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,a){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,f,a):new u(f,a,this.startLineNumber,this.startColumn)}getPosition(){return new R.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(f,a){return this.getDirection()===0?new u(f,a,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,f,a)}static fromPositions(f,a=f){return new u(f.lineNumber,f.column,a.lineNumber,a.column)}static liftSelection(f){return new u(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,a){if(f&&!a||!f&&a)return!1;if(!f&&!a)return!0;if(f.length!==a.length)return!1;for(let c=0,v=f.length;c<v;c++)if(!this.selectionsEqual(f[c],a[c]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,a,c,v,A){return A===0?new u(f,a,c,v):new u(c,v,f,a)}}n.Selection=u}),G(Y[25],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationResult2=n.TokenizationResult=n.Token=void 0;class R{constructor(L,f,a){this._tokenBrand=void 0,this.offset=L|0,this.type=f,this.language=a}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=R;class T{constructor(L,f){this._tokenizationResultBrand=void 0,this.tokens=L,this.endState=f}}n.TokenizationResult=T;class D{constructor(L,f){this._tokenizationResult2Brand=void 0,this.tokens=L,this.endState=f}}n.TokenizationResult2=D}),G(Y[26],Q([0,1,11,4]),function(y,n,R,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const D=3;function u(w,p,N,M){return new R.LcsDiff(w,p,N).ComputeDiff(M)}class L{constructor(p){const N=[],M=[];for(let i=0,r=p.length;i<r;i++)N[i]=g(p[i],1),M[i]=d(p[i],1);this.lines=p,this._startColumns=N,this._endColumns=M}getElements(){const p=[];for(let N=0,M=this.lines.length;N<M;N++)p[N]=this.lines[N].substring(this._startColumns[N]-1,this._endColumns[N]-1);return p}getStrictElement(p){return this.lines[p]}getStartLineNumber(p){return p+1}getEndLineNumber(p){return p+1}createCharSequence(p,N,M){const i=[],r=[],s=[];let m=0;for(let _=N;_<=M;_++){const o=this.lines[_],l=p?this._startColumns[_]:1,h=p?this._endColumns[_]:o.length+1;for(let b=l;b<h;b++)i[m]=o.charCodeAt(b-1),r[m]=_+1,s[m]=b,m++}return new f(i,r,s)}}class f{constructor(p,N,M){this._charCodes=p,this._lineNumbers=N,this._columns=M}getElements(){return this._charCodes}getStartLineNumber(p){return this._lineNumbers[p]}getStartColumn(p){return this._columns[p]}getEndLineNumber(p){return this._lineNumbers[p]}getEndColumn(p){return this._columns[p]+1}}class a{constructor(p,N,M,i,r,s,m,_){this.originalStartLineNumber=p,this.originalStartColumn=N,this.originalEndLineNumber=M,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=s,this.modifiedEndLineNumber=m,this.modifiedEndColumn=_}static createFromDiffChange(p,N,M){let i,r,s,m,_,o,l,h;return p.originalLength===0?(i=0,r=0,s=0,m=0):(i=N.getStartLineNumber(p.originalStart),r=N.getStartColumn(p.originalStart),s=N.getEndLineNumber(p.originalStart+p.originalLength-1),m=N.getEndColumn(p.originalStart+p.originalLength-1)),p.modifiedLength===0?(_=0,o=0,l=0,h=0):(_=M.getStartLineNumber(p.modifiedStart),o=M.getStartColumn(p.modifiedStart),l=M.getEndLineNumber(p.modifiedStart+p.modifiedLength-1),h=M.getEndColumn(p.modifiedStart+p.modifiedLength-1)),new a(i,r,s,m,_,o,l,h)}}function c(w){if(w.length<=1)return w;const p=[w[0]];let N=p[0];for(let M=1,i=w.length;M<i;M++){const r=w[M],s=r.originalStart-(N.originalStart+N.originalLength),m=r.modifiedStart-(N.modifiedStart+N.modifiedLength);Math.min(s,m)<D?(N.originalLength=r.originalStart+r.originalLength-N.originalStart,N.modifiedLength=r.modifiedStart+r.modifiedLength-N.modifiedStart):(p.push(r),N=r)}return p}class v{constructor(p,N,M,i,r){this.originalStartLineNumber=p,this.originalEndLineNumber=N,this.modifiedStartLineNumber=M,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(p,N,M,i,r,s,m){let _,o,l,h,b;if(N.originalLength===0?(_=M.getStartLineNumber(N.originalStart)-1,o=0):(_=M.getStartLineNumber(N.originalStart),o=M.getEndLineNumber(N.originalStart+N.originalLength-1)),N.modifiedLength===0?(l=i.getStartLineNumber(N.modifiedStart)-1,h=0):(l=i.getStartLineNumber(N.modifiedStart),h=i.getEndLineNumber(N.modifiedStart+N.modifiedLength-1)),s&&N.originalLength>0&&N.originalLength<20&&N.modifiedLength>0&&N.modifiedLength<20&&r()){const P=M.createCharSequence(p,N.originalStart,N.originalStart+N.originalLength-1),F=i.createCharSequence(p,N.modifiedStart,N.modifiedStart+N.modifiedLength-1);let I=u(P,F,r,!0).changes;m&&(I=c(I)),b=[];for(let S=0,V=I.length;S<V;S++)b.push(a.createFromDiffChange(I[S],P,F))}return new v(_,o,l,h,b)}}class A{constructor(p,N,M){this.shouldComputeCharChanges=M.shouldComputeCharChanges,this.shouldPostProcessCharChanges=M.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=M.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=M.shouldMakePrettyDiff,this.originalLines=p,this.modifiedLines=N,this.original=new L(p),this.modified=new L(N),this.continueLineDiff=e(M.maxComputationTime),this.continueCharDiff=e(M.maxComputationTime===0?0:Math.min(M.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const p=u(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),N=p.changes,M=p.quitEarly;if(this.shouldIgnoreTrimWhitespace){const m=[];for(let _=0,o=N.length;_<o;_++)m.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,N[_],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:M,changes:m}}const i=[];let r=0,s=0;for(let m=-1,_=N.length;m<_;m++){const o=m+1<_?N[m+1]:null,l=o?o.originalStart:this.originalLines.length,h=o?o.modifiedStart:this.modifiedLines.length;for(;r<l&&s<h;){const b=this.originalLines[r],P=this.modifiedLines[s];if(b!==P){{let F=g(b,1),I=g(P,1);for(;F>1&&I>1;){const S=b.charCodeAt(F-2),V=P.charCodeAt(I-2);if(S!==V)break;F--,I--}(F>1||I>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,F,s+1,1,I)}{let F=d(b,1),I=d(P,1);const S=b.length+1,V=P.length+1;for(;F<S&&I<V;){const O=b.charCodeAt(F-1),z=b.charCodeAt(I-1);if(O!==z)break;F++,I++}(F<S||I<V)&&this._pushTrimWhitespaceCharChange(i,r+1,F,S,s+1,I,V)}}r++,s++}o&&(i.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,o,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=o.originalLength,s+=o.modifiedLength)}return{quitEarly:M,changes:i}}_pushTrimWhitespaceCharChange(p,N,M,i,r,s,m){if(this._mergeTrimWhitespaceCharChange(p,N,M,i,r,s,m))return;let _;this.shouldComputeCharChanges&&(_=[new a(N,M,N,i,r,s,r,m)]),p.push(new v(N,N,r,r,_))}_mergeTrimWhitespaceCharChange(p,N,M,i,r,s,m){const _=p.length;if(_===0)return!1;const o=p[_-1];return o.originalEndLineNumber===0||o.modifiedEndLineNumber===0?!1:o.originalEndLineNumber+1===N&&o.modifiedEndLineNumber+1===r?(o.originalEndLineNumber=N,o.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&o.charChanges&&o.charChanges.push(new a(N,M,N,i,r,s,r,m)),!0):!1}}n.DiffComputer=A;function g(w,p){const N=T.firstNonWhitespaceIndex(w);return N===-1?p:N+1}function d(w,p){const N=T.lastNonWhitespaceIndex(w);return N===-1?p:N+2}function e(w){if(w===0)return()=>!0;const p=Date.now();return()=>Date.now()-p<w}}),G(Y[27],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(f=""){let a="(-?\\d*\\.\\d\\w*)|([^";for(const c of n.USUAL_WORD_SEPARATORS)f.indexOf(c)>=0||(a+="\\"+c);return a+="\\s]+)",new RegExp(a,"g")}n.DEFAULT_WORD_REGEXP=R();function T(f){let a=n.DEFAULT_WORD_REGEXP;if(f&&f instanceof RegExp)if(f.global)a=f;else{let c="g";f.ignoreCase&&(c+="i"),f.multiline&&(c+="m"),f.unicode&&(c+="u"),a=new RegExp(f.source,c)}return a.lastIndex=0,a}n.ensureValidWordDefinition=T;const D={maxLen:1e3,windowSize:15,timeBudget:150};function u(f,a,c,v,A=D){if(c.length>A.maxLen){let p=f-A.maxLen/2;return p<0?p=0:v+=p,c=c.substring(p,f+A.maxLen/2),u(f,a,c,v,A)}const g=Date.now(),d=f-1-v;let e=-1,w=null;for(let p=1;!(Date.now()-g>=A.timeBudget);p++){const N=d-A.windowSize*p;a.lastIndex=Math.max(0,N);const M=L(a,c,d,e);if(!M&&w||(w=M,N<=0))break;e=N}if(w){let p={word:w[0],startColumn:v+1+w.index,endColumn:v+1+w.index+w[0].length};return a.lastIndex=0,p}return null}n.getWordAtText=u;function L(f,a,c,v){let A;for(;A=f.exec(a);){const g=A.index||0;if(g<=c&&f.lastIndex>=c)return A;if(v>0&&g>v)return null}return null}}),G(Y[28],Q([0,1,23]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var T;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(T=n.State||(n.State={}));class D{constructor(e,w,p){const N=new Uint8Array(e*w);for(let M=0,i=e*w;M<i;M++)N[M]=p;this._data=N,this.rows=e,this.cols=w}get(e,w){return this._data[e*this.cols+w]}set(e,w,p){this._data[e*this.cols+w]=p}}n.Uint8Matrix=D;class u{constructor(e){let w=0,p=0;for(let M=0,i=e.length;M<i;M++){let[r,s,m]=e[M];s>w&&(w=s),r>p&&(p=r),m>p&&(p=m)}w++,p++;let N=new D(p,w,0);for(let M=0,i=e.length;M<i;M++){let[r,s,m]=e[M];N.set(r,s,m)}this._states=N,this._maxCharCode=w}nextState(e,w){return w<0||w>=this._maxCharCode?0:this._states.get(e,w)}}n.StateMachine=u;let L=null;function f(){return L===null&&(L=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var a;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let c=null;function v(){if(c===null){c=new R.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<d.length;w++)c.set(d.charCodeAt(w),1);const e=".,;";for(let w=0;w<e.length;w++)c.set(e.charCodeAt(w),2)}return c}class A{static _createLink(e,w,p,N,M){let i=M-1;do{const r=w.charCodeAt(i);if(e.get(r)!==2)break;i--}while(i>N);if(N>0){const r=w.charCodeAt(N-1),s=w.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:p,startColumn:N+1,endLineNumber:p,endColumn:i+2},url:w.substring(N,i+1)}}static computeLinks(e,w=f()){const p=v();let N=[];for(let M=1,i=e.getLineCount();M<=i;M++){const r=e.getLineContent(M),s=r.length;let m=0,_=0,o=0,l=1,h=!1,b=!1,P=!1,F=!1;for(;m<s;){let I=!1;const S=r.charCodeAt(m);if(l===13){let V;switch(S){case 40:h=!0,V=0;break;case 41:V=h?0:1;break;case 91:P=!0,b=!0,V=0;break;case 93:P=!1,V=b?0:1;break;case 123:F=!0,V=0;break;case 125:V=F?0:1;break;case 39:V=o===34||o===96?0:1;break;case 34:V=o===39||o===96?0:1;break;case 96:V=o===39||o===34?0:1;break;case 42:V=o===42?1:0;break;case 124:V=o===124?1:0;break;case 32:V=P?0:1;break;default:V=p.get(S)}V===1&&(N.push(A._createLink(p,r,M,_,m)),I=!0)}else if(l===12){let V;S===91?(b=!0,V=0):V=p.get(S),V===1?I=!0:l=13}else l=w.nextState(l,S),l===0&&(I=!0);I&&(l=1,h=!1,b=!1,F=!1,_=m+1,o=S),m++}l===13&&N.push(A._createLink(p,r,M,_,s))}return N}}n.LinkComputer=A;function g(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:A.computeLinks(d)}n.computeLinks=g}),G(Y[29],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class R{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(D,u,L,f,a){if(D&&u){let c=this.doNavigateValueSet(u,a);if(c)return{range:D,value:c}}if(L&&f){let c=this.doNavigateValueSet(f,a);if(c)return{range:L,value:c}}return null}doNavigateValueSet(D,u){let L=this.numberReplace(D,u);return L!==null?L:this.textReplace(D,u)}numberReplace(D,u){let L=Math.pow(10,D.length-(D.lastIndexOf(".")+1)),f=Number(D),a=parseFloat(D);return!isNaN(f)&&!isNaN(a)&&f===a?f===0&&!u?null:(f=Math.floor(f*L),f+=u?L:-L,String(f/L)):null}textReplace(D,u){return this.valueSetsReplace(this._defaultValueSet,D,u)}valueSetsReplace(D,u,L){let f=null;for(let a=0,c=D.length;f===null&&a<c;a++)f=this.valueSetReplace(D[a],u,L);return f}valueSetReplace(D,u,L){let f=D.indexOf(u);return f>=0?(f+=L?1:-1,f<0?f=D.length-1:f%=D.length,D[f]):null}}n.BasicInplaceReplace=R,R.INSTANCE=new R}),G(Y[30],Q([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var R;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(R=n.AccessibilitySupport||(n.AccessibilitySupport={}));var T;(function(t){t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(T=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var D;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(D=n.CompletionItemKind||(n.CompletionItemKind={}));var u;(function(t){t[t.Deprecated=1]="Deprecated"})(u=n.CompletionItemTag||(n.CompletionItemTag={}));var L;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var f;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(f=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var a;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(a=n.CursorChangeReason||(n.CursorChangeReason={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var v;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(v=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var A;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(A=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var g;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.columnSelection=18]="columnSelection",t[t.comments=19]="comments",t[t.contextmenu=20]="contextmenu",t[t.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",t[t.cursorBlinking=22]="cursorBlinking",t[t.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",t[t.cursorStyle=24]="cursorStyle",t[t.cursorSurroundingLines=25]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",t[t.cursorWidth=27]="cursorWidth",t[t.disableLayerHinting=28]="disableLayerHinting",t[t.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",t[t.domReadOnly=30]="domReadOnly",t[t.dragAndDrop=31]="dragAndDrop",t[t.emptySelectionClipboard=32]="emptySelectionClipboard",t[t.extraEditorClassName=33]="extraEditorClassName",t[t.fastScrollSensitivity=34]="fastScrollSensitivity",t[t.find=35]="find",t[t.fixedOverflowWidgets=36]="fixedOverflowWidgets",t[t.folding=37]="folding",t[t.foldingStrategy=38]="foldingStrategy",t[t.foldingHighlight=39]="foldingHighlight",t[t.foldingImportsByDefault=40]="foldingImportsByDefault",t[t.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=42]="fontFamily",t[t.fontInfo=43]="fontInfo",t[t.fontLigatures=44]="fontLigatures",t[t.fontSize=45]="fontSize",t[t.fontWeight=46]="fontWeight",t[t.formatOnPaste=47]="formatOnPaste",t[t.formatOnType=48]="formatOnType",t[t.glyphMargin=49]="glyphMargin",t[t.gotoLocation=50]="gotoLocation",t[t.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",t[t.hover=52]="hover",t[t.inDiffEditor=53]="inDiffEditor",t[t.inlineSuggest=54]="inlineSuggest",t[t.letterSpacing=55]="letterSpacing",t[t.lightbulb=56]="lightbulb",t[t.lineDecorationsWidth=57]="lineDecorationsWidth",t[t.lineHeight=58]="lineHeight",t[t.lineNumbers=59]="lineNumbers",t[t.lineNumbersMinChars=60]="lineNumbersMinChars",t[t.linkedEditing=61]="linkedEditing",t[t.links=62]="links",t[t.matchBrackets=63]="matchBrackets",t[t.minimap=64]="minimap",t[t.mouseStyle=65]="mouseStyle",t[t.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=67]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",t[t.multiCursorModifier=69]="multiCursorModifier",t[t.multiCursorPaste=70]="multiCursorPaste",t[t.occurrencesHighlight=71]="occurrencesHighlight",t[t.overviewRulerBorder=72]="overviewRulerBorder",t[t.overviewRulerLanes=73]="overviewRulerLanes",t[t.padding=74]="padding",t[t.parameterHints=75]="parameterHints",t[t.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",t[t.quickSuggestions=78]="quickSuggestions",t[t.quickSuggestionsDelay=79]="quickSuggestionsDelay",t[t.readOnly=80]="readOnly",t[t.renameOnType=81]="renameOnType",t[t.renderControlCharacters=82]="renderControlCharacters",t[t.renderFinalNewline=83]="renderFinalNewline",t[t.renderLineHighlight=84]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=86]="renderValidationDecorations",t[t.renderWhitespace=87]="renderWhitespace",t[t.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",t[t.roundedSelection=89]="roundedSelection",t[t.rulers=90]="rulers",t[t.scrollbar=91]="scrollbar",t[t.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=93]="scrollBeyondLastLine",t[t.scrollPredominantAxis=94]="scrollPredominantAxis",t[t.selectionClipboard=95]="selectionClipboard",t[t.selectionHighlight=96]="selectionHighlight",t[t.selectOnLineNumbers=97]="selectOnLineNumbers",t[t.showFoldingControls=98]="showFoldingControls",t[t.showUnused=99]="showUnused",t[t.snippetSuggestions=100]="snippetSuggestions",t[t.smartSelect=101]="smartSelect",t[t.smoothScrolling=102]="smoothScrolling",t[t.stickyTabStops=103]="stickyTabStops",t[t.stopRenderingLineAfter=104]="stopRenderingLineAfter",t[t.suggest=105]="suggest",t[t.suggestFontSize=106]="suggestFontSize",t[t.suggestLineHeight=107]="suggestLineHeight",t[t.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",t[t.suggestSelection=109]="suggestSelection",t[t.tabCompletion=110]="tabCompletion",t[t.tabIndex=111]="tabIndex",t[t.unusualLineTerminators=112]="unusualLineTerminators",t[t.useShadowDOM=113]="useShadowDOM",t[t.useTabStops=114]="useTabStops",t[t.wordSeparators=115]="wordSeparators",t[t.wordWrap=116]="wordWrap",t[t.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=119]="wordWrapColumn",t[t.wordWrapOverride1=120]="wordWrapOverride1",t[t.wordWrapOverride2=121]="wordWrapOverride2",t[t.wrappingIndent=122]="wrappingIndent",t[t.wrappingStrategy=123]="wrappingStrategy",t[t.showDeprecated=124]="showDeprecated",t[t.inlayHints=125]="inlayHints",t[t.editorClassName=126]="editorClassName",t[t.pixelRatio=127]="pixelRatio",t[t.tabFocusMode=128]="tabFocusMode",t[t.layoutInfo=129]="layoutInfo",t[t.wrappingInfo=130]="wrappingInfo"})(g=n.EditorOption||(n.EditorOption={}));var d;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(d=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var w;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(w=n.IndentAction||(n.IndentAction={}));var p;(function(t){t[t.Other=0]="Other",t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(p=n.InlayHintKind||(n.InlayHintKind={}));var N;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(N=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var M;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(M=n.KeyCode||(n.KeyCode={}));var i;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var r;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(r=n.MarkerTag||(n.MarkerTag={}));var s;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(s=n.MinimapPosition||(n.MinimapPosition={}));var m;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m=n.MouseTargetType||(n.MouseTargetType={}));var _;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(_=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var o;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(o=n.OverviewRulerLane||(n.OverviewRulerLane={}));var l;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(l=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var h;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(h=n.RenderMinimap||(n.RenderMinimap={}));var b;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(b=n.ScrollType||(n.ScrollType={}));var P;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(P=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var F;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(F=n.SelectionDirection||(n.SelectionDirection={}));var I;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(I=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var S;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(S=n.SymbolKind||(n.SymbolKind={}));var V;(function(t){t[t.Deprecated=1]="Deprecated"})(V=n.SymbolTag||(n.SymbolTag={}));var O;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(O=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var z;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(z=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var C;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var K;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(K=n.WrappingIndent||(n.WrappingIndent={}))}),G(Y[31],Q([0,1,21,5,17,14,3,6,24,25,30]),function(y,n,R,T,D,u,L,f,a,c,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class A{static chord(e,w){return(0,D.KeyChord)(e,w)}}n.KeyMod=A,A.CtrlCmd=2048,A.Shift=1024,A.Alt=512,A.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:R.CancellationTokenSource,Emitter:T.Emitter,KeyCode:v.KeyCode,KeyMod:A,Position:L.Position,Range:f.Range,Selection:a.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:u.URI,Token:c.Token}}n.createMonacoBaseAPI=g}),G(Y[32],Q([0,1,13]),function(y,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumComputer=n.PrefixSumIndexOfResult=void 0;class T{constructor(L,f){this._prefixSumIndexOfResultBrand=void 0,this.index=L,this.remainder=f}}n.PrefixSumIndexOfResult=T;class D{constructor(L){this.values=L,this.prefixSum=new Uint32Array(L.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(L,f){L=(0,R.toUint32)(L);const a=this.values,c=this.prefixSum,v=f.length;return v===0?!1:(this.values=new Uint32Array(a.length+v),this.values.set(a.subarray(0,L),0),this.values.set(a.subarray(L),L+v),this.values.set(f,L),L-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=L-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(L,f){return L=(0,R.toUint32)(L),f=(0,R.toUint32)(f),this.values[L]===f?!1:(this.values[L]=f,L-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=L-1),!0)}removeValues(L,f){L=(0,R.toUint32)(L),f=(0,R.toUint32)(f);const a=this.values,c=this.prefixSum;if(L>=a.length)return!1;let v=a.length-L;return f>=v&&(f=v),f===0?!1:(this.values=new Uint32Array(a.length-f),this.values.set(a.subarray(0,L),0),this.values.set(a.subarray(L+f),L),this.prefixSum=new Uint32Array(this.values.length),L-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=L-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(L){return L<0?0:(L=(0,R.toUint32)(L),this._getPrefixSum(L))}_getPrefixSum(L){if(L<=this.prefixSumValidIndex[0])return this.prefixSum[L];let f=this.prefixSumValidIndex[0]+1;f===0&&(this.prefixSum[0]=this.values[0],f++),L>=this.values.length&&(L=this.values.length-1);for(let a=f;a<=L;a++)this.prefixSum[a]=this.prefixSum[a-1]+this.values[a];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],L),this.prefixSum[L]}getIndexOf(L){L=Math.floor(L),this.getTotalSum();let f=0,a=this.values.length-1,c=0,v=0,A=0;for(;f<=a;)if(c=f+(a-f)/2|0,v=this.prefixSum[c],A=v-this.values[c],L<A)a=c-1;else if(L>=v)f=c+1;else break;return new T(c,L-A)}}n.PrefixSumComputer=D}),G(Y[33],Q([0,1,4,3,32]),function(y,n,R,T,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class u{constructor(f,a,c,v){this._uri=f,this._lines=a,this._eol=c,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(f){f.eol&&f.eol!==this._eol&&(this._eol=f.eol,this._lineStarts=null);const a=f.changes;for(const c of a)this._acceptDeleteRange(c.range),this._acceptInsertText(new T.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=f.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const f=this._eol.length,a=this._lines.length,c=new Uint32Array(a);for(let v=0;v<a;v++)c[v]=this._lines[v].length+f;this._lineStarts=new D.PrefixSumComputer(c)}}_setLineText(f,a){this._lines[f]=a,this._lineStarts&&this._lineStarts.changeValue(f,this._lines[f].length+this._eol.length)}_acceptDeleteRange(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this._setLineText(f.startLineNumber-1,this._lines[f.startLineNumber-1].substring(0,f.startColumn-1)+this._lines[f.startLineNumber-1].substring(f.endColumn-1));return}this._setLineText(f.startLineNumber-1,this._lines[f.startLineNumber-1].substring(0,f.startColumn-1)+this._lines[f.endLineNumber-1].substring(f.endColumn-1)),this._lines.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}_acceptInsertText(f,a){if(a.length===0)return;let c=(0,R.splitLines)(a);if(c.length===1){this._setLineText(f.lineNumber-1,this._lines[f.lineNumber-1].substring(0,f.column-1)+c[0]+this._lines[f.lineNumber-1].substring(f.column-1));return}c[c.length-1]+=this._lines[f.lineNumber-1].substring(f.column-1),this._setLineText(f.lineNumber-1,this._lines[f.lineNumber-1].substring(0,f.column-1)+c[0]);let v=new Uint32Array(c.length-1);for(let A=1;A<c.length;A++)this._lines.splice(f.lineNumber+A-1,0,c[A]),v[A-1]=c[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(f.lineNumber,v)}}n.MirrorTextModel=u}),G(Y[35],Q([0,1,11,2,14,3,6,26,33,27,28,29,31,12,10]),function(y,n,R,T,D,u,L,f,a,c,v,A,g,d,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class w extends a.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let s=(0,c.getWordAtText)(i.column,(0,c.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return s?new L.Range(i.lineNumber,s.startColumn,i.lineNumber,s.endColumn):null}getWordUntilPosition(i,r){const s=this.getWordAtPosition(i,r);return s?{word:this._lines[i.lineNumber-1].substring(s.startColumn-1,i.column-1),startColumn:s.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,s=this._wordenize.bind(this);let m=0,_="",o=0,l=[];return{*[Symbol.iterator](){for(;;)if(o<l.length){const h=_.substring(l[o].start,l[o].end);o+=1,yield h}else if(m<r.length)_=r[m],l=s(_,i),o=0,m+=1;else break}}}getLineWords(i,r){let s=this._lines[i-1],m=this._wordenize(s,r),_=[];for(const o of m)_.push({word:s.substring(o.start,o.end),startColumn:o.start+1,endColumn:o.end+1});return _}_wordenize(i,r){const s=[];let m;for(r.lastIndex=0;(m=r.exec(i))&&m[0].length!==0;)s.push({start:m.index,end:m.index+m[0].length});return s}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,s=i.startLineNumber-1,m=i.endLineNumber-1,_=[];_.push(this._lines[s].substring(i.startColumn-1));for(let o=s+1;o<m;o++)_.push(this._lines[o]);return _.push(this._lines[m].substring(0,i.endColumn-1)),_.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),s=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||s.lineNumber!==i.endLineNumber||s.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:i}_validatePosition(i){if(!u.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:s}=i,m=!1;if(r<1)r=1,s=1,m=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,m=!0;else{let _=this._lines[r-1].length+1;s<1?(s=1,m=!0):s>_&&(s=_,m=!0)}return m?{lineNumber:r,column:s}:i}}n.MirrorModel=w;class p{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new w(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,s,m){const _=this._getModel(i),o=this._getModel(r);if(!_||!o)return null;const l=_.getLinesContent(),h=o.getLinesContent(),P=new f.DiffComputer(l,h,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:m}).computeDiff(),F=P.changes.length>0?!1:this._modelsAreIdentical(_,o);return{quitEarly:P.quitEarly,identical:F,changes:P.changes}}_modelsAreIdentical(i,r){const s=i.getLineCount(),m=r.getLineCount();if(s!==m)return!1;for(let _=1;_<=s;_++){const o=i.getLineContent(_),l=r.getLineContent(_);if(o!==l)return!1}return!0}async computeDirtyDiff(i,r,s){let m=this._getModel(i),_=this._getModel(r);if(!m||!_)return null;let o=m.getLinesContent(),l=_.getLinesContent();return new f.DiffComputer(o,l,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const s=this._getModel(i);if(!s)return r;const m=[];let _;r=r.slice(0).sort((o,l)=>{if(o.range&&l.range)return L.Range.compareRangesUsingStarts(o.range,l.range);let h=o.range?0:1,b=l.range?0:1;return h-b});for(let{range:o,text:l,eol:h}of r){if(typeof h=="number"&&(_=h),L.Range.isEmpty(o)&&!l)continue;const b=s.getValueInRange(o);if(l=l.replace(/\r\n|\n|\r/g,s.eol),b===l)continue;if(Math.max(l.length,b.length)>p._diffLimit){m.push({range:o,text:l});continue}const P=(0,R.stringDiff)(b,l,!1),F=s.offsetAt(L.Range.lift(o).getStartPosition());for(const I of P){const S=s.positionAt(F+I.originalStart),V=s.positionAt(F+I.originalStart+I.originalLength),O={text:l.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:V.lineNumber,endColumn:V.column}};s.getValueInRange(O.range)!==O.text&&m.push(O)}}return typeof _=="number"&&m.push({eol:_,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),m}async computeLinks(i){let r=this._getModel(i);return r?(0,v.computeLinks)(r):null}async textualSuggest(i,r,s,m){const _=new e.StopWatch(!0),o=new RegExp(s,m),l=new Set;e:for(let h of i){const b=this._getModel(h);if(!!b){for(let P of b.words(o))if(!(P===r||!isNaN(Number(P)))&&(l.add(P),l.size>p._suggestionsLimit))break e}}return{words:Array.from(l),duration:_.elapsed()}}async computeWordRanges(i,r,s,m){let _=this._getModel(i);if(!_)return Object.create(null);const o=new RegExp(s,m),l=Object.create(null);for(let h=r.startLineNumber;h<r.endLineNumber;h++){let b=_.getLineWords(h,o);for(const P of b){if(!isNaN(Number(P.word)))continue;let F=l[P.word];F||(F=[],l[P.word]=F),F.push({startLineNumber:h,startColumn:P.startColumn,endLineNumber:h,endColumn:P.endColumn})}}return l}async navigateValueSet(i,r,s,m,_){let o=this._getModel(i);if(!o)return null;let l=new RegExp(m,_);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let h=o.getValueInRange(r),b=o.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},l);if(!b)return null;let P=o.getValueInRange(b);return A.BasicInplaceReplace.INSTANCE.navigateValueSet(r,h,b,P,s)}loadForeignModule(i,r,s){const m=(l,h)=>this._host.fhr(l,h);let o={host:d.createProxyObject(s,m),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(o,r),Promise.resolve(d.getAllMethodNames(this._foreignModule))):new Promise((l,h)=>{y([i],b=>{this._foreignModule=b.create(o,r),l(d.getAllMethodNames(this._foreignModule))},h)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}n.EditorSimpleWorker=p,p._diffLimit=1e5,p._suggestionsLimit=1e4;function N(M){return new p(M,null)}n.create=N,typeof importScripts=="function"&&(T.globals.monaco=(0,g.createMonacoBaseAPI)())}),function(){const y=self.MonacoEnvironment,n=y&&y.baseUrl?y.baseUrl:"../../../",R=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:a=>a,createScript:(a,...c)=>{const v=c.slice(0,-1).join(","),A=c.pop().toString();return`(function anonymous(${v}) {
${A}
})`}}):void 0;function T(){try{return(R?self.eval(R.createScript("","true")):new Function("true")).call(self),!0}catch(a){return!1}}function D(){return new Promise((a,c)=>{if(typeof self.define=="function"&&self.define.amd)return a();const v=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&T()){fetch(v).then(g=>{if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(g=>{g=`${g}
//# sourceURL=${v}`,(R?self.eval(R.createScript("",g)):new Function(g)).call(self),a()}).then(void 0,c);return}R?importScripts(R.createScriptURL(v)):importScripts(v),a()})}const u=function(a){D().then(()=>{require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:R,amdModulesPattern:/^vs\//}),require([a],function(c){setTimeout(function(){let v=c.create((A,g)=>{self.postMessage(A,g)},null);for(self.onmessage=A=>v.onmessage(A.data,A.ports);f.length>0;)self.onmessage(f.shift())},0)})})};let L=!0,f=[];self.onmessage=a=>{if(!L){f.push(a);return}L=!1,u(a.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc1a6699060423b8c4d2ced736ad70195378fddf/core/vs/base/worker/workerMain.js.map
