/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/path","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/json","os","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","child_process","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(J){for(var e=[],R=0,L=J.length;R<L;R++)e[R]=te[J[R]];return e};define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let m in i)R.call(i,m)&&I.push(i[m]);return I}e.values=L;function D(i,I){for(let m in i)if(R.call(i,m)&&I({key:m,value:i[m]},function(){delete i[m]})===!1)return}e.forEach=D;function k(i,I){const m=Object.create(null);for(const E of i){const h=I(E);let S=m[h];S||(S=m[h]=[]),S.push(E)}return m}e.groupBy=k;function T(i){const I=Object.create(null);return i&&i.forEach((m,E)=>{I[E]=m}),I}e.fromMap=T;function C(i,I){const m=[],E=[];for(let h of i)I.has(h)||m.push(h);for(let h of I)i.has(h)||E.push(h);return{removed:m,added:E}}e.diffSets=C;function w(i,I){const m=[],E=[];for(let[h,S]of i)I.has(h)||m.push(S);for(let[h,S]of I)i.has(h)||E.push(S);return{removed:m,added:E}}e.diffMaps=w;class b{constructor(){this.map=new Map}add(I,m){let E=this.map.get(I);E||(E=new Set,this.map.set(I,E)),E.add(m)}delete(I,m){const E=this.map.get(I);!E||(E.delete(m),E.size===0&&this.map.delete(I))}forEach(I,m){const E=this.map.get(I);!E||E.forEach(m)}}e.SetMap=b}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(T){return(C,w,b)=>{let i=null,I=null;if(typeof b.value=="function"?(i="value",I=b.value):typeof b.get=="function"&&(i="get",I=b.get),!I)throw new Error("not supported");b[i]=T(I,w)}}e.createDecorator=R;function L(T,C,w){let b=null,i=null;if(typeof w.value=="function"?(b="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(b="get",i=w.get),!i)throw new Error("not supported");const I=`$memoize$${C}`;w[b]=function(...m){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,m)}),this[I]}}e.memoize=L;function D(T,C,w){return R((b,i)=>{const I=`$debounce$${i}`,m=`$debounce$result$${i}`;return function(...E){this[m]||(this[m]=w?w():void 0),clearTimeout(this[I]),C&&(this[m]=C(this[m],...E),E=[this[m]]),this[I]=setTimeout(()=>{b.apply(this,E),this[m]=w?w():void 0},T)}})}e.debounce=D;function k(T,C,w){return R((b,i)=>{const I=`$throttle$timer$${i}`,m=`$throttle$result$${i}`,E=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...S){if(this[m]||(this[m]=w?w():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),C&&(this[m]=C(this[m],...S)),this[h])return;const d=this[E]+T;d<=Date.now()?(this[E]=Date.now(),b.apply(this,[this[m]]),this[m]=w?w():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),b.apply(this,[this[m]]),this[m]=w?w():void 0},d-Date.now()))}})}e.throttle=k}),define(te[7],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=R,e.errorHandler=new R;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function D(c){w(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function k(c){w(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=k;function T(c){if(c instanceof Error){let{name:n,message:s}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:n,message:s,stack:r}}return c}e.transformErrorForSerialization=T;const C="Canceled";function w(c){return c instanceof Error&&c.name===C&&c.message===C}e.isPromiseCanceledError=w;class b extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=b;function i(){const c=new Error(C);return c.name=c.message,c}e.canceled=i;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=m;function E(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function S(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=S;class d extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=d;class v extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=v;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function g(c){const n=c;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=g;function l(c,n=Object.create(null)){const s=new Error(c);return n.actions&&(s.actions=n.actions),s}e.createErrorWithActions=l}),define(te[17],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(U,B=0){return U[U.length-(1+B)]}e.tail=L;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=D;function k(U,B,W=(Q,Z)=>Q===Z){if(U===B)return!0;if(!U||!B||U.length!==B.length)return!1;for(let Q=0,Z=U.length;Q<Z;Q++)if(!W(U[Q],B[Q]))return!1;return!0}e.equals=k;function T(U,B,W){let Q=0,Z=U.length-1;for(;Q<=Z;){const G=(Q+Z)/2|0,V=W(U[G],B);if(V<0)Q=G+1;else if(V>0)Z=G-1;else return G}return-(Q+1)}e.binarySearch=T;function C(U,B){let W=0,Q=U.length;if(Q===0)return 0;for(;W<Q;){const Z=Math.floor((W+Q)/2);B(U[Z])?Q=Z:W=Z+1}return W}e.findFirstInSorted=C;function w(U,B,W){if(U=U|0,U>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],G=[],V=[];for(let re of B){const ie=W(re,Q);ie<0?Z.push(re):ie>0?G.push(re):V.push(re)}return U<Z.length?w(U,Z,W):U<Z.length+V.length?V[0]:w(U-(Z.length+V.length),G,W)}e.quickSelect=w;function b(U,B){const W=[];let Q;for(const Z of U.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],W.push(Q)):Q.push(Z);return W}e.groupBy=b;function i(U,B,W){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let G=0,V=0;for(;;){if(G===U.length){Z(G,0,B.slice(V));break}if(V===B.length){Z(G,U.length-G,[]);break}const re=U[G],ie=B[V],ce=W(re,ie);ce===0?(G+=1,V+=1):ce<0?(Z(G,1,[]),G+=1):ce>0&&(Z(G,0,[ie]),V+=1)}return Q}e.sortedDiff=i;function I(U,B,W){const Q=i(U,B,W),Z=[],G=[];for(const V of Q)Z.push(...U.slice(V.start,V.start+V.deleteCount)),G.push(...V.toInsert);return{removed:Z,added:G}}e.delta=I;function m(U,B,W){if(W===0)return[];const Q=U.slice(0,W).sort(B);return h(U,B,Q,W,U.length),Q}e.top=m;function E(U,B,W,Q,Z){return W===0?Promise.resolve([]):new Promise((G,V)=>{(async()=>{const re=U.length,ie=U.slice(0,W).sort(B);for(let ce=W,le=Math.min(W+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>W&&await new Promise(de=>setTimeout(de)),Z&&Z.isCancellationRequested)throw(0,R.canceled)();h(U,B,ie,ce,le)}return ie})().then(G,V)})}e.topAsync=E;function h(U,B,W,Q,Z){for(const G=W.length;Q<Z;Q++){const V=U[Q];if(B(V,W[G-1])<0){W.pop();const re=C(W,ie=>B(V,ie)<0);W.splice(re,0,V)}}}function S(U){return U.filter(B=>!!B)}e.coalesce=S;function d(U){let B=0;for(let W=0;W<U.length;W++)U[W]&&(U[B]=U[W],B+=1);U.length=B}e.coalesceInPlace=d;function v(U,B,W){U.splice(W,0,U.splice(B,1)[0])}e.move=v;function y(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=y;function g(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=g;function l(U,B=W=>W){const W=new Set;return U.filter(Q=>{const Z=B(Q);return W.has(Z)?!1:(W.add(Z),!0)})}e.distinct=l;function c(U){const B=Object.create(null);return W=>{const Q=U(W);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=c;function n(U,B){const W=s(U,B);if(W!==-1)return U[W]}e.findLast=n;function s(U,B){for(let W=U.length-1;W>=0;W--){const Q=U[W];if(B(Q))return W}return-1}e.lastIndex=s;function r(U,B){return U.length>0?U[0]:B}e.firstOrDefault=r;function t(U,B,W=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,G=Math.min(U.length,B.length);Z<G&&W(U[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=t;function a(U){return[].concat(...U)}e.flatten=a;function o(U,B){let W=typeof B=="number"?U:0;typeof B=="number"?W=U:(W=0,B=U);const Q=[];if(W<=B)for(let Z=W;Z<B;Z++)Q.push(Z);else for(let Z=W;Z>B;Z--)Q.push(Z);return Q}e.range=o;function u(U,B,W){return U.reduce((Q,Z)=>(Q[B(Z)]=W?W(Z):Z,Q),Object.create(null))}e.index=u;function f(U,B){return U.push(B),()=>p(U,B)}e.insert=f;function p(U,B){const W=U.indexOf(B);if(W>-1)return U.splice(W,1),B}e.remove=p;function A(U,B,W){const Q=U.slice(0,B),Z=U.slice(B);return Q.concat(W,Z)}e.arrayInsert=A;function O(U,B){let W;if(typeof B=="number"){let Q=B;W=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else W=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const Z=Math.floor(W()*(Q+1)),G=U[Q];U[Q]=U[Z],U[Z]=G}}e.shuffle=O;function M(U,B){const W=U.indexOf(B);W>-1&&(U.splice(W,1),U.unshift(B))}e.pushToStart=M;function N(U,B){const W=U.indexOf(B);W>-1&&(U.splice(W,1),U.push(B))}e.pushToEnd=N;function P(U,B){return Array.isArray(U)?U.map(B):B(U)}e.mapArrayOrNot=P;function F(U){return Array.isArray(U)?U:[U]}e.asArray=F;function q(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=q;function _(U,B){for(const W of U){const Q=B(W);if(Q!==void 0)return Q}}e.mapFind=_;function $(U,B,W){const Q=j(U,B),Z=U.length,G=W.length;U.length=Z+G;for(let V=Z-1;V>=Q;V--)U[V+G]=U[V];for(let V=0;V<G;V++)U[V+Q]=W[V]}e.insertInto=$;function H(U,B,W,Q){const Z=j(U,B),G=U.splice(Z,W);return $(U,Z,Q),G}e.splice=H;function j(U,B){return B<0?Math.max(B+U.length,0):Math.min(B,U.length)}function x(U,B){let W=Number.MAX_SAFE_INTEGER,Q=0;return U.forEach((Z,G)=>{const V=B(Z);V<W&&(W=V,Q=G)}),Q}e.minIndex=x;function z(U,B){let W=Number.MIN_SAFE_INTEGER,Q=0;return U.forEach((Z,G)=>{const V=B(Z);V>W&&(W=V,Q=G)}),Q}e.maxIndex=z;class Y{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let W=this.firstIdx;for(;W<this.items.length&&B(this.items[W]);)W++;const Q=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,Q}takeFromEndWhile(B){let W=this.lastIdx;for(;W>=0&&B(this.items[W]);)W--;const Q=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,Q}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=Y}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(L){const D=this;let k=!1,T;return function(){return k||(k=!0,T=L.apply(D,arguments)),T}}e.once=R}),define(te[55],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(L){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=D;const k=Object.freeze([]);function T(){return k}L.empty=T;function*C(c){yield c}L.single=C;function w(c){return c||k}L.from=w;function b(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=b;function i(c){return c[Symbol.iterator]().next().value}L.first=i;function I(c,n){for(const s of c)if(n(s))return!0;return!1}L.some=I;function m(c,n){for(const s of c)if(n(s))return s}L.find=m;function*E(c,n){for(const s of c)n(s)&&(yield s)}L.filter=E;function*h(c,n){let s=0;for(const r of c)yield n(r,s++)}L.map=h;function*S(...c){for(const n of c)for(const s of n)yield s}L.concat=S;function*d(c){for(const n of c)for(const s of n)yield s}L.concatNested=d;function v(c,n,s){let r=s;for(const t of c)r=n(r,t);return r}L.reduce=v;function*y(c,n,s=c.length){for(n<0&&(n+=c.length),s<0?s+=c.length:s>c.length&&(s=c.length);n<s;n++)yield c[n]}L.slice=y;function g(c,n=Number.POSITIVE_INFINITY){const s=[];if(n===0)return[s,c];const r=c[Symbol.iterator]();for(let t=0;t<n;t++){const a=r.next();if(a.done)return[s,L.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=g;function l(c,n,s=(r,t)=>r===t){const r=c[Symbol.iterator](),t=n[Symbol.iterator]();for(;;){const a=r.next(),o=t.next();if(a.done!==o.done)return!1;if(a.done)return!0;if(!s(a.value,o.value))return!1}}L.equals=l})(R=e.Iterable||(e.Iterable={}))}),define(te[33],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(n){n.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function T(n,s=!1){let r=0,t=n.length,a="",o=0,u=16,f=0;function p(q){let _=0,$=0;for(;_<q;){const H=n.charCodeAt(r);if(H>=48&&H<=57)$=$*16+H-48;else if(H>=65&&H<=70)$=$*16+H-65+10;else if(H>=97&&H<=102)$=$*16+H-97+10;else break;r++,_++}return _<q&&($=-1),$}function A(q){r=q,a="",o=0,u=16,f=0}function O(){const q=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&b(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&b(n.charCodeAt(r)))for(r++;r<n.length&&b(n.charCodeAt(r));)r++;else return f=3,n.substring(q,r);let _=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&b(n.charCodeAt(r))){for(r++;r<n.length&&b(n.charCodeAt(r));)r++;_=r}else f=3;return n.substring(q,_)}function M(){let q="",_=r;for(;;){if(r>=t){q+=n.substring(_,r),f=2;break}const $=n.charCodeAt(r);if($===34){q+=n.substring(_,r),r++;break}if($===92){if(q+=n.substring(_,r),r++,r>=t){f=2;break}switch(n.charCodeAt(r++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const j=p(4);j>=0?q+=String.fromCharCode(j):f=4;break;default:f=5}_=r;continue}if($>=0&&$<=31)if(w($)){q+=n.substring(_,r),f=2;break}else f=6;r++}return q}function N(){if(a="",f=0,o=r,r>=t)return o=t,u=17;let q=n.charCodeAt(r);if(C(q)){do r++,a+=String.fromCharCode(q),q=n.charCodeAt(r);while(C(q));return u=15}if(w(q))return r++,a+=String.fromCharCode(q),q===13&&n.charCodeAt(r)===10&&(r++,a+=`
`),u=14;switch(q){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,a=M(),u=10;case 47:const _=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<t&&!w(n.charCodeAt(r));)r++;return a=n.substring(_,r),u=12}if(n.charCodeAt(r+1)===42){r+=2;const $=t-1;let H=!1;for(;r<$;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,f=1),a=n.substring(_,r),u=13}return a+=String.fromCharCode(q),r++,u=16;case 45:if(a+=String.fromCharCode(q),r++,r===t||!b(n.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=O(),u=11;default:for(;r<t&&P(q);)r++,q=n.charCodeAt(r);if(o!==r){switch(a=n.substring(o,r),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode(q),r++,u=16}}function P(q){if(C(q)||w(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let q;do q=N();while(q>=12&&q<=15);return q}return{setPosition:A,getPosition:()=>r,scan:s?F:N,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>f}}e.createScanner=T;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function w(n){return n===10||n===13||n===8232||n===8233}function b(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,s){const r=[],t=new Object;let a;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function f(p,A,O,M){o.value=p,o.offset=A,o.length=O,o.type=M,o.colonOffset=void 0,a=o}try{g(n,{onObjectBegin:(p,A)=>{if(s<=p)throw t;a=void 0,u=s>p,r.push("")},onObjectProperty:(p,A,O)=>{if(s<A||(f(p,A,O,"property"),r[r.length-1]=p,s<=A+O))throw t},onObjectEnd:(p,A)=>{if(s<=p)throw t;a=void 0,r.pop()},onArrayBegin:(p,A)=>{if(s<=p)throw t;a=void 0,r.push(0)},onArrayEnd:(p,A)=>{if(s<=p)throw t;a=void 0,r.pop()},onLiteralValue:(p,A,O)=>{if(s<A||(f(p,A,O,c(p)),s<=A+O))throw t},onSeparator:(p,A,O)=>{if(s<=A)throw t;if(p===":"&&a&&a.type==="property")a.colonOffset=A,u=!1,a=void 0;else if(p===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(u=!0,r[r.length-1]=""),a=void 0}}})}catch(p){if(p!==t)throw p}return{path:r,previousNode:a,isAtPropertyKey:u,matches:p=>{let A=0;for(let O=0;A<p.length&&O<r.length;O++)if(p[A]===r[O]||p[A]==="*")A++;else if(p[A]!=="**")return!1;return A===p.length}}}e.getLocation=I;function m(n,s=[],r=k.DEFAULT){let t=null,a=[];const o=[];function u(p){Array.isArray(a)?a.push(p):t!==null&&(a[t]=p)}return g(n,{onObjectBegin:()=>{const p={};u(p),o.push(a),a=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const p=[];u(p),o.push(a),a=p,t=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:u,onError:(p,A,O)=>{s.push({error:p,offset:A,length:O})}},r),a[0]}e.parse=m;function E(n,s=[],r=k.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){t.type==="property"&&(t.length=p-t.offset,t=t.parent)}function o(p){return t.children.push(p),p}g(n,{onObjectBegin:p=>{t=o({type:"object",offset:p,length:-1,parent:t,children:[]})},onObjectProperty:(p,A,O)=>{t=o({type:"property",offset:A,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:p,offset:A,length:O,parent:t})},onObjectEnd:(p,A)=>{t.length=p+A-t.offset,t=t.parent,a(p+A)},onArrayBegin:(p,A)=>{t=o({type:"array",offset:p,length:-1,parent:t,children:[]})},onArrayEnd:(p,A)=>{t.length=p+A-t.offset,t=t.parent,a(p+A)},onLiteralValue:(p,A,O)=>{o({type:c(p),offset:A,length:O,parent:t,value:p}),a(A+O)},onSeparator:(p,A,O)=>{t.type==="property"&&(p===":"?t.colonOffset=A:p===","&&a(A))},onError:(p,A,O)=>{s.push({error:p,offset:A,length:O})}},r);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=E;function h(n,s){if(!n)return;let r=n;for(let t of s)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===t){r=o.children[1],a=!0;break}if(!a)return}else{const a=t;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=h;function S(n){if(!n.parent||!n.parent.children)return[];const s=S(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;s.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&s.push(r)}return s}e.getNodePath=S;function d(n){switch(n.type){case"array":return n.children.map(d);case"object":const s=Object.create(null);for(let r of n.children){const t=r.children[1];t&&(s[r.children[0].value]=d(t))}return s;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=d;function v(n,s,r=!1){return s>=n.offset&&s<n.offset+n.length||r&&s===n.offset+n.length}e.contains=v;function y(n,s,r=!1){if(v(n,s,r)){const t=n.children;if(Array.isArray(t))for(let a=0;a<t.length&&t[a].offset<=s;a++){const o=y(t[a],s,r);if(o)return o}return n}}e.findNodeAtOffset=y;function g(n,s,r=k.DEFAULT){const t=T(n,!1);function a(W){return W?()=>W(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(W){return W?Q=>W(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),f=o(s.onObjectProperty),p=a(s.onObjectEnd),A=a(s.onArrayBegin),O=a(s.onArrayEnd),M=o(s.onLiteralValue),N=o(s.onSeparator),P=a(s.onComment),F=o(s.onError),q=r&&r.disallowComments,_=r&&r.allowTrailingComma;function $(){for(;;){const W=t.scan();switch(t.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:q||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(W){case 12:case 13:q?H(10):P();break;case 16:H(1);break;case 15:case 14:break;default:return W}}}function H(W,Q=[],Z=[]){if(F(W),Q.length+Z.length>0){let G=t.getToken();for(;G!==17;){if(Q.indexOf(G)!==-1){$();break}else if(Z.indexOf(G)!==-1)break;G=$()}}}function j(W){const Q=t.getTokenValue();return W?M(Q):f(Q),$(),!0}function x(){switch(t.getToken()){case 11:let W=0;try{W=JSON.parse(t.getTokenValue()),typeof W!="number"&&(H(2),W=0)}catch(Q){H(2)}M(W);break;case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return $(),!0}function z(){return t.getToken()!==10?(H(3,[],[2,5]),!1):(j(!1),t.getToken()===6?(N(":"),$(),B()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){u(),$();let W=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(W||H(4,[],[]),N(","),$(),t.getToken()===2&&_)break}else W&&H(6,[],[]);z()||H(4,[],[2,5]),W=!0}return p(),t.getToken()!==2?H(7,[2],[]):$(),!0}function U(){A(),$();let W=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(W||H(4,[],[]),N(","),$(),t.getToken()===4&&_)break}else W&&H(6,[],[]);B()||H(4,[],[4,5]),W=!0}return O(),t.getToken()!==4?H(8,[4],[]):$(),!0}function B(){switch(t.getToken()){case 3:return U();case 1:return Y();case 10:return j(!0);default:return x()}}return $(),t.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):B()?(t.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=g;function l(n,s){let r=T(n),t=[],a,o=0,u;do switch(u=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:o!==u&&t.push(n.substring(o,u)),s!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(a!==17);return t.join("")}e.stripComments=l;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(te[49],ne([0,1,33]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,b,i){let I,m,E,h,S;if(b){for(h=b.offset,S=h+b.length,E=h;E>0&&!C(w,E-1);)E--;let o=S;for(;o<w.length&&!C(w,o);)o++;m=w.substring(E,o),I=k(m,i)}else m=w,I=0,E=0,h=0,S=w.length;const d=T(i,w);let v=!1,y=0,g;i.insertSpaces?g=D(" ",i.tabSize||4):g="	";const l=(0,R.createScanner)(m,!1);let c=!1;function n(){return d+D(g,I+y)}function s(){let o=l.scan();for(v=!1;o===15||o===14;)v=v||o===14,o=l.scan();return c=o===16||l.getTokenError()!==0,o}const r=[];function t(o,u,f){!c&&u<S&&f>h&&w.substring(u,f)!==o&&r.push({offset:u,length:f-u,content:o})}let a=s();if(a!==17){const o=l.getTokenOffset()+E,u=D(g,I);t(u,E,o)}for(;a!==17;){let o=l.getTokenOffset()+l.getTokenLength()+E,u=s(),f="";for(;!v&&(u===12||u===13);){const A=l.getTokenOffset()+E;t(" ",o,A),o=l.getTokenOffset()+l.getTokenLength()+E,f=u===12?n():"",u=s()}if(u===2)a!==1&&(y--,f=n());else if(u===4)a!==3&&(y--,f=n());else{switch(a){case 3:case 1:y++,f=n();break;case 5:case 12:f=n();break;case 13:v?f=n():f=" ";break;case 6:f=" ";break;case 10:if(u===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?f=" ":u!==5&&u!==17&&(c=!0);break;case 16:c=!0;break}v&&(u===12||u===13)&&(f=n())}const p=l.getTokenOffset()+E;t(f,o,p),a=u}return r}e.format=L;function D(w,b){let i="";for(let I=0;I<b;I++)i+=w;return i}function k(w,b){let i=0,I=0;const m=b.tabSize||4;for(;i<w.length;){const E=w.charAt(i);if(E===" ")I++;else if(E==="	")I+=m;else break;i++}return Math.floor(I/m)}function T(w,b){for(let i=0;i<b.length;i++){const I=b.charAt(i);if(I==="\r")return i+1<b.length&&b.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=T;function C(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=C}),define(te[39],ne([0,1,33,49]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,i,I){return k(b,i,void 0,I)}e.removeProperty=D;function k(b,i,I,m,E){const h=i.slice(),S=[],d=(0,R.parseTree)(b,S);let v,y;for(;h.length>0&&(y=h.pop(),v=(0,R.findNodeAtLocation)(d,h),v===void 0&&I!==void 0);)typeof y=="string"?I={[y]:I}:I=[I];if(v)if(v.type==="object"&&typeof y=="string"&&Array.isArray(v.children)){const g=(0,R.findNodeAtLocation)(v,[y]);if(g!==void 0)if(I===void 0){if(!g.parent)throw new Error("Malformed AST");const l=v.children.indexOf(g.parent);let c,n=g.parent.offset+g.parent.length;if(l>0){const s=v.children[l-1];c=s.offset+s.length}else c=v.offset+1,v.children.length>1&&(n=v.children[1].offset);return T(b,{offset:c,length:n-c,content:""},m)}else return T(b,{offset:g.offset,length:g.length,content:JSON.stringify(I)},m);else{if(I===void 0)return[];const l=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,c=E?E(v.children.map(s=>s.children[0].value)):v.children.length;let n;if(c>0){const s=v.children[c-1];n={offset:s.offset+s.length,length:0,content:","+l}}else v.children.length===0?n={offset:v.offset+1,length:0,content:l}:n={offset:v.offset+1,length:0,content:l+","};return T(b,n,m)}}else if(v.type==="array"&&typeof y=="number"&&Array.isArray(v.children))if(I!==void 0){const g=`${JSON.stringify(I)}`;let l;if(v.children.length===0||y===0)l={offset:v.offset+1,length:0,content:v.children.length===0?g:g+","};else{const c=y===-1||y>v.children.length?v.children.length:y,n=v.children[c-1];l={offset:n.offset+n.length,length:0,content:","+g}}return T(b,l,m)}else{const g=y,l=v.children[g];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===g){const n=v.children[g-1],s=n.offset+n.length,r=v.offset+v.length;c={offset:s,length:r-2-s,content:""}}else c={offset:l.offset,length:v.children[g+1].offset-l.offset,content:""};return T(b,c,m)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${v.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return T(b,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(I)},m)}}e.setProperty=k;function T(b,i,I){let m=C(b,i),E=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;E>0&&!(0,L.isEOL)(m,E-1);)E--;for(;h<m.length&&!(0,L.isEOL)(m,h);)h++}const S=(0,L.format)(m,{offset:E,length:h-E},I);for(let v=S.length-1;v>=0;v--){const y=S[v];m=C(m,y),E=Math.min(E,y.offset),h=Math.max(h,y.offset+y.length),h+=y.content.length-y.length}const d=b.length-(m.length-h)-E;return[{offset:E,length:d,content:m.substring(E,h)}]}e.withFormatting=T;function C(b,i){return b.substring(0,i.offset)+i.content+b.substring(i.offset+i.length)}e.applyEdit=C;function w(b,i){let I=i.slice(0).sort((E,h)=>{const S=E.offset-h.offset;return S===0?E.length-h.length:S}),m=b.length;for(let E=I.length-1;E>=0;E--){let h=I[E];if(h.offset+h.length<=m)b=C(b,h);else throw new Error("Overlapping edit");m=h.offset}return b}e.applyEdits=w}),define(te[2],ne([0,1,68,55]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function T(t){k=t}if(e.setDisposableTracker=T,D){const t="__is_disposable_tracked__";T(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[t]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==y.None)try{a[t]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[t]=!0}catch{}}markAsSingleton(a){}})}function C(t){return k?.trackDisposable(t),t}function w(t){k?.markAsDisposed(t)}function b(t,a){k?.setParent(t,a)}function i(t,a){if(!!k)for(const o of t)k.setParent(o,a)}function I(t){return k?.markAsSingleton(t),t}e.markAsSingleton=I;class m extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=m;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function h(t){if(L.Iterable.is(t)){let a=[];for(const o of t)if(o)try{o.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new m(a);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function S(...t){const a=d(()=>h(t));return i(t,a),a}e.combinedDisposable=S;function d(t){const a=C({dispose:(0,R.once)(()=>{w(a),t()})});return a}e.toDisposable=d;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new v,C(this),b(this._store,this)}dispose(){w(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&b(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&b(a,null),a}}e.MutableDisposable=g;class l{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.references=new Map}acquire(a,...o){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,u));const{object:f}=u,p=(0,R.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:f,dispose:p}}}e.ReferenceCollection=c;class n{constructor(a){this.referenceCollection=a}async acquire(a,...o){const u=this.referenceCollection.acquire(a,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(f){throw u.dispose(),f}}}e.AsyncReferenceCollection=n;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function r(t){const a=new v;try{t(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(k){this.element=k,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class L{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let k=this._first;for(;k!==R.Undefined;){const T=k.next;k.prev=R.Undefined,k.next=R.Undefined,k=T}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,T){const C=new R(k);if(this._first===R.Undefined)this._first=C,this._last=C;else if(T){const b=this._last;this._last=C,C.prev=b,b.next=C}else{const b=this._first;this._first=C,C.next=b,b.prev=C}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(C))}}shift(){if(this._first!==R.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==R.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==R.Undefined&&k.next!==R.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===R.Undefined&&k.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):k.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):k.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==R.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function J(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function T(w){k.push(w,Date.now())}function C(){const w=[];for(let b=0;b<k.length;b+=2)w.push({name:k[b],startTime:k[b+1]});return w}return{mark:T,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(D+T.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=R(L))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,D=!1,k=!1,T=!1,C=!1,w=!1,b=!1,i,I=R,m,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&h?.sandboxed,typeof navigator=="object"&&!S)E=navigator.userAgent,L=E.indexOf("Windows")>=0,D=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=E.indexOf("Linux")>=0,w=!0,i=navigator.language,I=i;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",k=h.platform==="linux",T=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=R,I=R;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const t=JSON.parse(r),a=t.availableLanguages["*"];i=t.locale,I=a||R,m=t._translationsConfigFile}catch(t){}C=!0}else console.error("Unable to resolve platform.");var d;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function v(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let y=0;D?y=1:L?y=3:k&&(y=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=T,e.isNative=C,e.isWeb=w,e.isIOS=b,e.platform=y,e.userAgent=E,e.language=I;var g;(function(r){function t(){return e.language}r.value=t;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function o(){return e.language==="en"}r.isDefault=o})(g=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let f=0,p=a.length;f<p;f++){const A=a[f];if(A.id===u.data.vscodeSetImmediateId){a.splice(f,1),A.callback();return}}});let o=0;return u=>{const f=++o;a.push({id:f,callback:u}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return a=>t.then(a)}();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:L?1:3;let c=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(k){return(0,R.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[8],ne([0,1,31]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,k=90,T=122,C=46,w=47,b=92,i=58,I=63;class m extends Error{constructor(l,c,n){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const r=l.indexOf(".")!==-1?"property":"argument";let t=`The "${l}" ${r} ${s} of type ${c}`;t+=`. Received type ${typeof n}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function E(g,l){if(typeof g!="string")throw new m(l,"string",g)}function h(g){return g===w||g===b}function S(g){return g===w}function d(g){return g>=L&&g<=k||g>=D&&g<=T}function v(g,l,c,n){let s="",r=0,t=-1,a=0,o=0;for(let u=0;u<=g.length;++u){if(u<g.length)o=g.charCodeAt(u);else{if(n(o))break;o=w}if(n(o)){if(!(t===u-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const f=s.lastIndexOf(c);f===-1?(s="",r=0):(s=s.slice(0,f),r=s.length-1-s.lastIndexOf(c)),t=u,a=0;continue}else if(s.length!==0){s="",r=0,t=u,a=0;continue}}l&&(s+=s.length>0?`${c}..`:"..",r=2)}else s.length>0?s+=`${c}${g.slice(t+1,u)}`:s=g.slice(t+1,u),r=u-t-1;t=u,a=0}else o===C&&a!==-1?++a:a=-1}return s}function y(g,l){if(l===null||typeof l!="object")throw new m("pathObject","Object",l);const c=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${n}`:`${c}${g}${n}`:n}e.win32={resolve(...g){let l="",c="",n=!1;for(let s=g.length-1;s>=-1;s--){let r;if(s>=0){if(r=g[s],E(r,"path"),r.length===0)continue}else l.length===0?r=R.cwd():(r=R.env[`=${l}`]||R.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${l}\\`));const t=r.length;let a=0,o="",u=!1;const f=r.charCodeAt(0);if(t===1)h(f)&&(a=1,u=!0);else if(h(f))if(u=!0,h(r.charCodeAt(1))){let p=2,A=p;for(;p<t&&!h(r.charCodeAt(p));)p++;if(p<t&&p!==A){const O=r.slice(A,p);for(A=p;p<t&&h(r.charCodeAt(p));)p++;if(p<t&&p!==A){for(A=p;p<t&&!h(r.charCodeAt(p));)p++;(p===t||p!==A)&&(o=`\\\\${O}\\${r.slice(A,p)}`,a=p)}}}else a=1;else d(f)&&r.charCodeAt(1)===i&&(o=r.slice(0,2),a=2,t>2&&h(r.charCodeAt(2))&&(u=!0,a=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(n){if(l.length>0)break}else if(c=`${r.slice(a)}\\${c}`,n=u,u&&l.length>0)break}return c=v(c,!n,"\\",h),n?`${l}\\${c}`:`${l}${c}`||"."},normalize(g){E(g,"path");const l=g.length;if(l===0)return".";let c=0,n,s=!1;const r=g.charCodeAt(0);if(l===1)return S(r)?"\\":g;if(h(r))if(s=!0,h(g.charCodeAt(1))){let a=2,o=a;for(;a<l&&!h(g.charCodeAt(a));)a++;if(a<l&&a!==o){const u=g.slice(o,a);for(o=a;a<l&&h(g.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!h(g.charCodeAt(a));)a++;if(a===l)return`\\\\${u}\\${g.slice(o)}\\`;a!==o&&(n=`\\\\${u}\\${g.slice(o,a)}`,c=a)}}}else c=1;else d(r)&&g.charCodeAt(1)===i&&(n=g.slice(0,2),c=2,l>2&&h(g.charCodeAt(2))&&(s=!0,c=3));let t=c<l?v(g.slice(c),!s,"\\",h):"";return t.length===0&&!s&&(t="."),t.length>0&&h(g.charCodeAt(l-1))&&(t+="\\"),n===void 0?s?`\\${t}`:t:s?`${n}\\${t}`:`${n}${t}`},isAbsolute(g){E(g,"path");const l=g.length;if(l===0)return!1;const c=g.charCodeAt(0);return h(c)||l>2&&d(c)&&g.charCodeAt(1)===i&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let l,c;for(let r=0;r<g.length;++r){const t=g[r];E(t,"path"),t.length>0&&(l===void 0?l=c=t:l+=`\\${t}`)}if(l===void 0)return".";let n=!0,s=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++s;const r=c.length;r>1&&h(c.charCodeAt(1))&&(++s,r>2&&(h(c.charCodeAt(2))?++s:n=!1))}if(n){for(;s<l.length&&h(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(g,l){if(E(g,"from"),E(l,"to"),g===l)return"";const c=e.win32.resolve(g),n=e.win32.resolve(l);if(c===n||(g=c.toLowerCase(),l=n.toLowerCase(),g===l))return"";let s=0;for(;s<g.length&&g.charCodeAt(s)===b;)s++;let r=g.length;for(;r-1>s&&g.charCodeAt(r-1)===b;)r--;const t=r-s;let a=0;for(;a<l.length&&l.charCodeAt(a)===b;)a++;let o=l.length;for(;o-1>a&&l.charCodeAt(o-1)===b;)o--;const u=o-a,f=t<u?t:u;let p=-1,A=0;for(;A<f;A++){const M=g.charCodeAt(s+A);if(M!==l.charCodeAt(a+A))break;M===b&&(p=A)}if(A!==f){if(p===-1)return n}else{if(u>f){if(l.charCodeAt(a+A)===b)return n.slice(a+A+1);if(A===2)return n.slice(a+A)}t>f&&(g.charCodeAt(s+A)===b?p=A:A===2&&(p=3)),p===-1&&(p=0)}let O="";for(A=s+p+1;A<=r;++A)(A===r||g.charCodeAt(A)===b)&&(O+=O.length===0?"..":"\\..");return a+=p,O.length>0?`${O}${n.slice(a,o)}`:(n.charCodeAt(a)===b&&++a,n.slice(a,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const l=e.win32.resolve(g);if(l.length<=2)return g;if(l.charCodeAt(0)===b){if(l.charCodeAt(1)===b){const c=l.charCodeAt(2);if(c!==I&&c!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(d(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===b)return`\\\\?\\${l}`;return g},dirname(g){E(g,"path");const l=g.length;if(l===0)return".";let c=-1,n=0;const s=g.charCodeAt(0);if(l===1)return h(s)?g:".";if(h(s)){if(c=n=1,h(g.charCodeAt(1))){let a=2,o=a;for(;a<l&&!h(g.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&h(g.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!h(g.charCodeAt(a));)a++;if(a===l)return g;a!==o&&(c=n=a+1)}}}}else d(s)&&g.charCodeAt(1)===i&&(c=l>2&&h(g.charCodeAt(2))?3:2,n=c);let r=-1,t=!0;for(let a=l-1;a>=n;--a)if(h(g.charCodeAt(a))){if(!t){r=a;break}}else t=!1;if(r===-1){if(c===-1)return".";r=c}return g.slice(0,r)},basename(g,l){l!==void 0&&E(l,"ext"),E(g,"path");let c=0,n=-1,s=!0,r;if(g.length>=2&&d(g.charCodeAt(0))&&g.charCodeAt(1)===i&&(c=2),l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let t=l.length-1,a=-1;for(r=g.length-1;r>=c;--r){const o=g.charCodeAt(r);if(h(o)){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=a))}return c===n?n=a:n===-1&&(n=g.length),g.slice(c,n)}for(r=g.length-1;r>=c;--r)if(h(g.charCodeAt(r))){if(!s){c=r+1;break}}else n===-1&&(s=!1,n=r+1);return n===-1?"":g.slice(c,n)},extname(g){E(g,"path");let l=0,c=-1,n=0,s=-1,r=!0,t=0;g.length>=2&&g.charCodeAt(1)===i&&d(g.charCodeAt(0))&&(l=n=2);for(let a=g.length-1;a>=l;--a){const o=g.charCodeAt(a);if(h(o)){if(!r){n=a+1;break}continue}s===-1&&(r=!1,s=a+1),o===C?c===-1?c=a:t!==1&&(t=1):c!==-1&&(t=-1)}return c===-1||s===-1||t===0||t===1&&c===s-1&&c===n+1?"":g.slice(c,s)},format:y.bind(null,"\\"),parse(g){E(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const c=g.length;let n=0,s=g.charCodeAt(0);if(c===1)return h(s)?(l.root=l.dir=g,l):(l.base=l.name=g,l);if(h(s)){if(n=1,h(g.charCodeAt(1))){let p=2,A=p;for(;p<c&&!h(g.charCodeAt(p));)p++;if(p<c&&p!==A){for(A=p;p<c&&h(g.charCodeAt(p));)p++;if(p<c&&p!==A){for(A=p;p<c&&!h(g.charCodeAt(p));)p++;p===c?n=p:p!==A&&(n=p+1)}}}}else if(d(s)&&g.charCodeAt(1)===i){if(c<=2)return l.root=l.dir=g,l;if(n=2,h(g.charCodeAt(2))){if(c===3)return l.root=l.dir=g,l;n=3}}n>0&&(l.root=g.slice(0,n));let r=-1,t=n,a=-1,o=!0,u=g.length-1,f=0;for(;u>=n;--u){if(s=g.charCodeAt(u),h(s)){if(!o){t=u+1;break}continue}a===-1&&(o=!1,a=u+1),s===C?r===-1?r=u:f!==1&&(f=1):r!==-1&&(f=-1)}return a!==-1&&(r===-1||f===0||f===1&&r===a-1&&r===t+1?l.base=l.name=g.slice(t,a):(l.name=g.slice(t,r),l.base=g.slice(t,a),l.ext=g.slice(r,a))),t>0&&t!==n?l.dir=g.slice(0,t-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let l="",c=!1;for(let n=g.length-1;n>=-1&&!c;n--){const s=n>=0?g[n]:R.cwd();E(s,"path"),s.length!==0&&(l=`${s}/${l}`,c=s.charCodeAt(0)===w)}return l=v(l,!c,"/",S),c?`/${l}`:l.length>0?l:"."},normalize(g){if(E(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===w,c=g.charCodeAt(g.length-1)===w;return g=v(g,!l,"/",S),g.length===0?l?"/":c?"./":".":(c&&(g+="/"),l?`/${g}`:g)},isAbsolute(g){return E(g,"path"),g.length>0&&g.charCodeAt(0)===w},join(...g){if(g.length===0)return".";let l;for(let c=0;c<g.length;++c){const n=g[c];E(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.posix.normalize(l)},relative(g,l){if(E(g,"from"),E(l,"to"),g===l||(g=e.posix.resolve(g),l=e.posix.resolve(l),g===l))return"";const c=1,n=g.length,s=n-c,r=1,t=l.length-r,a=s<t?s:t;let o=-1,u=0;for(;u<a;u++){const p=g.charCodeAt(c+u);if(p!==l.charCodeAt(r+u))break;p===w&&(o=u)}if(u===a)if(t>a){if(l.charCodeAt(r+u)===w)return l.slice(r+u+1);if(u===0)return l.slice(r+u)}else s>a&&(g.charCodeAt(c+u)===w?o=u:u===0&&(o=0));let f="";for(u=c+o+1;u<=n;++u)(u===n||g.charCodeAt(u)===w)&&(f+=f.length===0?"..":"/..");return`${f}${l.slice(r+o)}`},toNamespacedPath(g){return g},dirname(g){if(E(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===w;let c=-1,n=!0;for(let s=g.length-1;s>=1;--s)if(g.charCodeAt(s)===w){if(!n){c=s;break}}else n=!1;return c===-1?l?"/":".":l&&c===1?"//":g.slice(0,c)},basename(g,l){l!==void 0&&E(l,"ext"),E(g,"path");let c=0,n=-1,s=!0,r;if(l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let t=l.length-1,a=-1;for(r=g.length-1;r>=0;--r){const o=g.charCodeAt(r);if(o===w){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=a))}return c===n?n=a:n===-1&&(n=g.length),g.slice(c,n)}for(r=g.length-1;r>=0;--r)if(g.charCodeAt(r)===w){if(!s){c=r+1;break}}else n===-1&&(s=!1,n=r+1);return n===-1?"":g.slice(c,n)},extname(g){E(g,"path");let l=-1,c=0,n=-1,s=!0,r=0;for(let t=g.length-1;t>=0;--t){const a=g.charCodeAt(t);if(a===w){if(!s){c=t+1;break}continue}n===-1&&(s=!1,n=t+1),a===C?l===-1?l=t:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||n===-1||r===0||r===1&&l===n-1&&l===c+1?"":g.slice(l,n)},format:y.bind(null,"/"),parse(g){E(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const c=g.charCodeAt(0)===w;let n;c?(l.root="/",n=1):n=0;let s=-1,r=0,t=-1,a=!0,o=g.length-1,u=0;for(;o>=n;--o){const f=g.charCodeAt(o);if(f===w){if(!a){r=o+1;break}continue}t===-1&&(a=!1,t=o+1),f===C?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}if(t!==-1){const f=r===0&&c?1:r;s===-1||u===0||u===1&&s===t-1&&s===r+1?l.base=l.name=g.slice(f,t):(l.name=g.slice(f,s),l.base=g.slice(f,t),l.ext=g.slice(s,t))}return r>0?l.dir=g.slice(0,r-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(k,...T){const C=T.reduce((i,I)=>(i[I]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(i=>!C[i]).forEach(i=>{for(let I=0;I<w.length;I++)if(i.search(w[I])!==-1){delete k[i];break}})}e.sanitizeProcessEnvironment=D}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var L in R)(typeof exports=="object"?exports:J)[L]=R[L]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function R(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return J[L].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=J,R.c=e,R.d=function(L,D,k){R.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:k})},R.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},R.t=function(L,D){if(1&D&&(L=R(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(R.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var T in L)R.d(k,T,function(C){return L[C]}.bind(null,T));return k},R.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return R.d(D,"a",D),D},R.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},R.p="",R(R.s=0)}([function(J,e,R){(function(L){var D;e=J.exports=Z,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],w=e.src=[],b=0,i=b++;w[i]="0|[1-9]\\d*";var I=b++;w[I]="[0-9]+";var m=b++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=b++;w[E]="("+w[i]+")\\.("+w[i]+")\\.("+w[i]+")";var h=b++;w[h]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var S=b++;w[S]="(?:"+w[i]+"|"+w[m]+")";var d=b++;w[d]="(?:"+w[I]+"|"+w[m]+")";var v=b++;w[v]="(?:-("+w[S]+"(?:\\."+w[S]+")*))";var y=b++;w[y]="(?:-?("+w[d]+"(?:\\."+w[d]+")*))";var g=b++;w[g]="[0-9A-Za-z-]+";var l=b++;w[l]="(?:\\+("+w[g]+"(?:\\."+w[g]+")*))";var c=b++,n="v?"+w[E]+w[v]+"?"+w[l]+"?";w[c]="^"+n+"$";var s="[v=\\s]*"+w[h]+w[y]+"?"+w[l]+"?",r=b++;w[r]="^"+s+"$";var t=b++;w[t]="((?:<|>)?=?)";var a=b++;w[a]=w[I]+"|x|X|\\*";var o=b++;w[o]=w[i]+"|x|X|\\*";var u=b++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[v]+")?"+w[l]+"?)?)?";var f=b++;w[f]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[y]+")?"+w[l]+"?)?)?";var p=b++;w[p]="^"+w[t]+"\\s*"+w[u]+"$";var A=b++;w[A]="^"+w[t]+"\\s*"+w[f]+"$";var O=b++;w[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=b++;w[M]="(?:~>?)";var N=b++;w[N]="(\\s*)"+w[M]+"\\s+",C[N]=new RegExp(w[N],"g");var P=b++;w[P]="^"+w[M]+w[u]+"$";var F=b++;w[F]="^"+w[M]+w[f]+"$";var q=b++;w[q]="(?:\\^)";var _=b++;w[_]="(\\s*)"+w[q]+"\\s+",C[_]=new RegExp(w[_],"g");var $=b++;w[$]="^"+w[q]+w[u]+"$";var H=b++;w[H]="^"+w[q]+w[f]+"$";var j=b++;w[j]="^"+w[t]+"\\s*("+s+")$|^$";var x=b++;w[x]="^"+w[t]+"\\s*("+n+")$|^$";var z=b++;w[z]="(\\s*)"+w[t]+"\\s*("+s+"|"+w[u]+")",C[z]=new RegExp(w[z],"g");var Y=b++;w[Y]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var U=b++;w[U]="^\\s*("+w[f]+")\\s+-\\s+("+w[f]+")\\s*$";var B=b++;w[B]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)D(W,w[W]),C[W]||(C[W]=new RegExp(w[W]));function Q(ee,ae){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>k||!(ae?C[r]:C[c]).test(ee))return null;try{return new Z(ee,ae)}catch(oe){return null}}function Z(ee,ae){if(ee instanceof Z){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Z))return new Z(ee,ae);D("SemVer",ee,ae),this.loose=ae;var oe=ee.trim().match(ae?C[r]:C[c]);if(!oe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<T)return Se}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,ae){var oe=Q(ee,ae);return oe?oe.version:null},e.clean=function(ee,ae){var oe=Q(ee.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),V(this.major,ee.major)||V(this.minor,ee.minor)||V(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=ee.prerelease[ae];if(D("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return V(oe,pe)}while(++ae)},Z.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new Z(ee,oe).inc(ae,pe).version}catch(Se){return null}},e.diff=function(ee,ae){if(le(ee,ae))return null;var oe=Q(ee),pe=Q(ae);if(oe.prerelease.length||pe.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return Se},e.compareIdentifiers=V;var G=/^[0-9]+$/;function V(ee,ae){var oe=G.test(ee),pe=G.test(ae);return oe&&pe&&(ee=+ee,ae=+ae),oe&&!pe?-1:pe&&!oe?1:ee<ae?-1:ee>ae?1:0}function re(ee,ae,oe){return new Z(ee,oe).compare(new Z(ae,oe))}function ie(ee,ae,oe){return re(ee,ae,oe)>0}function ce(ee,ae,oe){return re(ee,ae,oe)<0}function le(ee,ae,oe){return re(ee,ae,oe)===0}function de(ee,ae,oe){return re(ee,ae,oe)!==0}function fe(ee,ae,oe){return re(ee,ae,oe)>=0}function be(ee,ae,oe){return re(ee,ae,oe)<=0}function Ce(ee,ae,oe,pe){var Se;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee===oe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee!==oe;break;case"":case"=":case"==":Se=le(ee,oe,pe);break;case"!=":Se=de(ee,oe,pe);break;case">":Se=ie(ee,oe,pe);break;case">=":Se=fe(ee,oe,pe);break;case"<":Se=ce(ee,oe,pe);break;case"<=":Se=be(ee,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(ee,ae){if(ee instanceof Ee){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,ae);D("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,ae){return V(ae,ee)},e.major=function(ee,ae){return new Z(ee,ae).major},e.minor=function(ee,ae){return new Z(ee,ae).minor},e.patch=function(ee,ae){return new Z(ee,ae).patch},e.compare=re,e.compareLoose=function(ee,ae){return re(ee,ae,!0)},e.rcompare=function(ee,ae,oe){return re(ae,ee,oe)},e.sort=function(ee,ae){return ee.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(ee,ae){return ee.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=de,e.gte=fe,e.lte=be,e.cmp=Ce,e.Comparator=Ee;var Ae={};function Pe(ee,ae){if(ee instanceof Pe)return ee.loose===ae?ee:new Pe(ee.raw,ae);if(ee instanceof Ee)return new Pe(ee.value,ae);if(!(this instanceof Pe))return new Pe(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,ae,oe,pe,Se,_e,Re,K,se,ue,ge,me,Ie){return((ae=Le(oe)?"":Le(pe)?">="+oe+".0.0":Le(Se)?">="+oe+"."+pe+".0":">="+ae)+" "+(K=Le(se)?"":Le(ue)?"<"+(+se+1)+".0.0":Le(ge)?"<"+se+"."+(+ue+1)+".0":me?"<="+se+"."+ue+"."+ge+"-"+me:"<="+K)).trim()}function Ne(ee,ae){for(var oe=0;oe<ee.length;oe++)if(!ee[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<ee.length;oe++)if(D(ee[oe].semver),ee[oe].semver!==Ae&&ee[oe].semver.prerelease.length>0){var pe=ee[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function $e(ee,ae,oe){try{ae=new Pe(ae,oe)}catch(pe){return!1}return ae.test(ee)}function xe(ee,ae,oe,pe){var Se,_e,Re,K,se;switch(ee=new Z(ee,pe),ae=new Pe(ae,pe),oe){case">":Se=ie,_e=be,Re=ce,K=">",se=">=";break;case"<":Se=ce,_e=fe,Re=ie,K="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,ae,pe))return!1;for(var ue=0;ue<ae.set.length;++ue){var ge=ae.set[ue],me=null,Ie=null;if(ge.forEach(function(ke){ke.semver===Ae&&(ke=new Ee(">=0.0.0")),me=me||ke,Ie=Ie||ke,Se(ke.semver,me.semver,pe)?me=ke:Re(ke.semver,Ie.semver,pe)&&(Ie=ke)}),me.operator===K||me.operator===se||(!Ie.operator||Ie.operator===K)&&_e(ee,Ie.semver)||Ie.operator===se&&Re(ee,Ie.semver))return!1}return!0}Ee.prototype.parse=function(ee){var ae=this.loose?C[j]:C[x],oe=ee.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+ee);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new Z(oe[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===Ae||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,ae){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(ee.value,ae),$e(this.value,oe,ae);if(ee.operator==="")return oe=new Pe(this.value,ae),$e(ee.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),K=Ce(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||Se||_e&&Re||K||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),D("range",ee,ae);var oe=ae?C[U]:C[Y];ee=ee.replace(oe,Fe),D("hyphen replace",ee),ee=ee.replace(C[z],"$1$2$3"),D("comparator trim",ee,C[z]),ee=(ee=(ee=ee.replace(C[N],"$1~")).replace(C[_],"$1^")).split(/\s+/).join(" ");var pe=ae?C[j]:C[x],Se=ee.split(" ").map(function(_e){return function(Re,K){return D("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){D("caret",me,Ie);var ke=Ie?C[H]:C[$];return me.replace(ke,function(Te,ye,we,De,Oe){var Ue;return D("caret",me,Te,ye,we,De,Oe),Le(ye)?Ue="":Le(we)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Ue=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+Oe+" <"+(+ye+1)+".0.0"):(D("no pr"),Ue=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+" <"+(+ye+1)+".0.0"),D("caret return",Ue),Ue})}(ge,ue)}).join(" ")}(Re,K),D("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){var ke=Ie?C[F]:C[P];return me.replace(ke,function(Te,ye,we,De,Oe){var Ue;return D("tilde",me,Te,ye,we,De,Oe),Le(ye)?Ue="":Le(we)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Ue=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0"):Ue=">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0",D("tilde return",Ue),Ue})}(ge,ue)}).join(" ")}(Re,K),D("tildes",Re),Re=function(se,ue){return D("replaceXRanges",se,ue),se.split(/\s+/).map(function(ge){return function(me,Ie){me=me.trim();var ke=Ie?C[A]:C[p];return me.replace(ke,function(Te,ye,we,De,Oe,Ue){D("xRange",me,Te,ye,we,De,Oe,Ue);var Qe=Le(we),Ye=Qe||Le(De),We=Ye||Le(Oe);return ye==="="&&We&&(ye=""),Qe?Te=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(Ye&&(De=0),We&&(Oe=0),ye===">"?(ye=">=",Ye?(we=+we+1,De=0,Oe=0):We&&(De=+De+1,Oe=0)):ye==="<="&&(ye="<",Ye?we=+we+1:De=+De+1),Te=ye+we+"."+De+"."+Oe):Ye?Te=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(Te=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),D("xRange return",Te),Te})}(ge,ue)}).join(" ")}(Re,K),D("xrange",Re),Re=function(se,ue){return D("replaceStars",se,ue),se.trim().replace(C[B],"")}(Re,K),D("stars",Re),Re}(_e,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(_e){return!!_e.match(pe)})),Se=Se.map(function(_e){return new Ee(_e,ae)})},Pe.prototype.intersects=function(ee,ae){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return ee.set.some(function(Se){return Se.every(function(_e){return pe.intersects(_e,ae)})})})})},e.toComparators=function(ee,ae){return new Pe(ee,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ne(this.set[ae],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==-1||(Se=new Z(pe=Re,oe)))}),pe},e.minSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==1||(Se=new Z(pe=Re,oe)))}),pe},e.validRange=function(ee,ae){try{return new Pe(ee,ae).range||"*"}catch(oe){return null}},e.ltr=function(ee,ae,oe){return xe(ee,ae,"<",oe)},e.gtr=function(ee,ae,oe){return xe(ee,ae,">",oe)},e.outside=xe,e.prerelease=function(ee,ae){var oe=Q(ee,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(ee,ae,oe){return ee=new Pe(ee,oe),ae=new Pe(ae,oe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var ae=ee.match(C[O]);return ae==null?null:Q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,R(1))},function(J,e){var R,L,D=J.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function C(d){if(R===setTimeout)return setTimeout(d,0);if((R===k||!R)&&setTimeout)return R=setTimeout,setTimeout(d,0);try{return R(d,0)}catch(v){try{return R.call(null,d,0)}catch(y){return R.call(this,d,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:k}catch(d){R=k}try{L=typeof clearTimeout=="function"?clearTimeout:T}catch(d){L=T}})();var w,b=[],i=!1,I=-1;function m(){i&&w&&(i=!1,w.length?b=w.concat(b):I=-1,b.length&&E())}function E(){if(!i){var d=C(m);i=!0;for(var v=b.length;v;){for(w=b,b=[];++I<v;)w&&w[I].run();I=-1,v=b.length}w=null,i=!1,function(y){if(L===clearTimeout)return clearTimeout(y);if((L===T||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(y);try{L(y)}catch(g){try{return L.call(null,y)}catch(l){return L.call(this,y)}}}(d)}}function h(d,v){this.fun=d,this.array=v}function S(){}D.nextTick=function(d){var v=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)v[y-1]=arguments[y];b.push(new h(d,v)),b.length!==1||i||C(E)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=S,D.addListener=S,D.once=S,D.off=S,D.removeListener=S,D.removeAllListeners=S,D.emit=S,D.prependListener=S,D.prependOnceListener=S,D.listeners=function(d){return[]},D.binding=function(d){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(d){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[103],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new D(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,7,68,2,101,103]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(l){l.None=()=>D.Disposable.None;function c(_){return($,H=null,j)=>{let x=!1,z;return z=_(Y=>{if(!x)return z?z.dispose():x=!0,$.call(H,Y)},null,j),x&&z.dispose(),z}}l.once=c;function n(_,$){return u((H,j=null,x)=>_(z=>H.call(j,$(z)),null,x))}l.map=n;function s(_,$){return u((H,j=null,x)=>_(z=>{$(z),H.call(j,z)},null,x))}l.forEach=s;function r(_,$){return u((H,j=null,x)=>_(z=>$(z)&&H.call(j,z),null,x))}l.filter=r;function t(_){return _}l.signal=t;function a(..._){return($,H=null,j)=>(0,D.combinedDisposable)(..._.map(x=>x(z=>$.call(H,z),null,j)))}l.any=a;function o(_,$,H){let j=H;return n(_,x=>(j=$(j,x),j))}l.reduce=o;function u(_){let $;const H=new m({onFirstListenerAdd(){$=_(H.fire,H)},onLastListenerRemove(){$.dispose()}});return H.event}function f(_,$,H=100,j=!1,x){let z,Y,U,B=0;const W=new m({leakWarningThreshold:x,onFirstListenerAdd(){z=_(Q=>{B++,Y=$(Y,Q),j&&!U&&(W.fire(Y),Y=void 0),clearTimeout(U),U=setTimeout(()=>{const Z=Y;Y=void 0,U=void 0,(!j||B>1)&&W.fire(Z),B=0},H)})},onLastListenerRemove(){z.dispose()}});return W.event}l.debounce=f;function p(_,$=(H,j)=>H===j){let H=!0,j;return r(_,x=>{const z=H||!$(x,j);return H=!1,j=x,z})}l.latch=p;function A(_,$){return[l.filter(_,$),l.filter(_,H=>!$(H))]}l.split=A;function O(_,$=!1,H=[]){let j=H.slice(),x=_(U=>{j?j.push(U):Y.fire(U)});const z=()=>{j&&j.forEach(U=>Y.fire(U)),j=null},Y=new m({onFirstListenerAdd(){x||(x=_(U=>Y.fire(U)))},onFirstListenerDidAdd(){j&&($?setTimeout(z):z())},onLastListenerRemove(){x&&x.dispose(),x=null}});return Y.event}l.buffer=O;class M{constructor($){this.event=$}map($){return new M(n(this.event,$))}forEach($){return new M(s(this.event,$))}filter($){return new M(r(this.event,$))}reduce($,H){return new M(o(this.event,$,H))}latch(){return new M(p(this.event))}debounce($,H=100,j=!1,x){return new M(f(this.event,$,H,j,x))}on($,H,j){return this.event($,H,j)}once($,H,j){return c(this.event)($,H,j)}}function N(_){return new M(_)}l.chain=N;function P(_,$,H=j=>j){const j=(...U)=>Y.fire(H(...U)),x=()=>_.on($,j),z=()=>_.removeListener($,j),Y=new m({onFirstListenerAdd:x,onLastListenerRemove:z});return Y.event}l.fromNodeEventEmitter=P;function F(_,$,H=j=>j){const j=(...U)=>Y.fire(H(...U)),x=()=>_.addEventListener($,j),z=()=>_.removeEventListener($,j),Y=new m({onFirstListenerAdd:x,onLastListenerRemove:z});return Y.event}l.fromDOMEventEmitter=F;function q(_){return new Promise($=>c(_)($))}l.toPromise=q})(C=e.Event||(e.Event={}));class w{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${w._idPool++}`}start(c){this._stopWatch=new T.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let b=-1;function i(l){const c=b;return b=l,{dispose(){b=c}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(c,n=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let n=b;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||c<n)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let t,a=0;for(const[o,u]of this._stacks)(!t||a<u)&&(t=o,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${a}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}class m{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=b>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(c,n,s)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(n?[c,n]:c);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,n);const a=this._leakageMon?.check(this._listeners.size),o=(0,D.toDisposable)(()=>{a&&a(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof D.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,s]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,s):n[0].call(n[1],s)}catch(r){(0,R.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class E extends m{async fireAsync(c,n,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,c]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),a=[],o={...t,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),a.push(u)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(u){(0,R.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const f of u)f.status==="rejected"&&(0,R.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=E;class h extends m{constructor(c){super(c);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=h;class S extends h{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=S;class d extends m{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const n={event:c,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const s=()=>{this.hasListeners&&this.unhook(n);const r=this.events.indexOf(n);this.events.splice(r,1)};return(0,D.toDisposable)((0,L.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(n=>this.emitter.fire(n))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class y{constructor(){this.buffers=[]}wrapEvent(c){return(n,s,r)=>c(t=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>n.call(s,t)):n.call(s,t)},void 0,r)}bufferEvents(c){const n=[];this.buffers.push(n);const s=c();return this.buffers.pop(),n.forEach(r=>r()),s}}e.EventBufferer=y;class g{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(te[27],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,w){const b=setTimeout(C.bind(w),0);return{dispose(){clearTimeout(b)}}});var D;(function(C){function w(b){return b===C.None||b===C.Cancelled||b instanceof k?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}C.isCancellationToken=w,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=T}),define(te[50],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(I){const m=this._icons.get(I.id);m?I.description?m.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function k(i,I){return new C(i,I)}e.registerCodicon=k;function T(i){return i?i.replace(/\$\((.*?)\)/g,(I,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=T;class C{constructor(I,m,E){this.id=I,this.definition=m,this.description=E,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function w(i,I){const m=["codicon","codicon-"+i];return I&&m.push("codicon-modifier-"+I),m}e.getClassNamesArray=w;var b;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function m(S){if(S instanceof C)return["codicon","codicon-"+S.id];const d=I.exec(S.id);if(!d)return m(C.error);let[,v,y]=d;const g=["codicon","codicon-"+v];return y&&g.push("codicon-modifier-"+y.substr(1)),g}i.asClassNameArray=m;function E(S){return m(S).join(" ")}i.asClassName=E;function h(S){return"."+m(S).join(".")}i.asCSSSelector=h})(b=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(C=e.Codicon||(e.Codicon={}))}),define(te[51],ne([0,1,7,2]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(g){const l=g;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function k(g){const l=g;return l?D(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=k;function T(g,l){return new C(g,l)}e.newWriteableStream=T;class C{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,R.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(this.state.destroyed)return;let n;switch(l){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const s=n.indexOf(c);s>=0&&n.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(g,l){const c=[];let n;for(;(n=g.read())!==null;)c.push(n);return l(c)}e.consumeReadable=w;function b(g,l,c){const n=[];let s;for(;(s=g.read())!==null&&n.length<c;)n.push(s);return s===null&&n.length>0?l(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return g.read()}}}e.peekReadable=b;function i(g,l){return new Promise((c,n)=>{const s=[];I(g,{onData:r=>{l&&s.push(r)},onError:r=>{l?n(r):c(void 0)},onEnd:()=>{c(l?l(s):void 0)}})})}e.consumeStream=i;function I(g,l){g.on("error",c=>l.onError(c)),g.on("end",()=>l.onEnd()),g.on("data",c=>l.onData(c))}e.listenStream=I;function m(g,l){return new Promise((c,n)=>{const s=new L.DisposableStore,r=[],t=u=>{if(r.push(u),r.length>l)return s.dispose(),g.pause(),c({stream:g,buffer:r,ended:!1})},a=u=>n(u),o=()=>c({stream:g,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>g.removeListener("error",a))),g.on("error",a),s.add((0,L.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),s.add((0,L.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=m;function E(g,l){const c=T(l);return c.end(g),c}e.toStream=E;function h(){const g=T(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function S(g){let l=!1;return{read:()=>l?null:(l=!0,g)}}e.toReadable=S;function d(g,l,c){const n=T(c);return I(g,{onData:s=>n.write(l.data(s)),onError:s=>n.error(l.error?l.error(s):s),onEnd:()=>n.end()}),n}e.transform=d;function v(g,l,c){let n=!1;return{read:()=>{const s=l.read();return n?s:(n=!0,s!==null?c([g,s]):g)}}}e.prefixedReadable=v;function y(g,l,c){let n=!1;const s=T(c);return I(l,{onData:r=>n?s.write(r):(n=!0,s.write(c([g,r]))),onError:r=>s.error(r),onEnd:()=>{n||(n=!0,s.write(g)),s.end()}}),s}e.prefixedStream=y}),define(te[19],ne([0,1,51]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,k;class T{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new T(Buffer.allocUnsafe(t)):new T(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new T(t)}static fromString(t,a){return!(a?.dontUseNodeBuffer||!1)&&L?new T(Buffer.from(t)):(D||(D=new TextEncoder),new T(D.encode(t)))}static concat(t,a){if(typeof a=="undefined"){a=0;for(let f=0,p=t.length;f<p;f++)a+=t[f].byteLength}const o=T.alloc(a);let u=0;for(let f=0,p=t.length;f<p;f++){const A=t[f];o.set(A,u),u+=A.byteLength}return o}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(t,a){return new T(this.buffer.subarray(t,a))}set(t,a){t instanceof T?this.buffer.set(t.buffer,a):this.buffer.set(t,a)}readUInt32BE(t){return b(this.buffer,t)}writeUInt32BE(t,a){i(this.buffer,t,a)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,a){m(this.buffer,t,a)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,a){h(this.buffer,t,a)}}e.VSBuffer=T;function C(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=C;function w(r,t,a){r[a+0]=t&255,t=t>>>8,r[a+1]=t&255}e.writeUInt16LE=w;function b(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=b;function i(r,t,a){r[a+3]=t,t=t>>>8,r[a+2]=t,t=t>>>8,r[a+1]=t,t=t>>>8,r[a]=t}e.writeUInt32BE=i;function I(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=I;function m(r,t,a){r[a+0]=t&255,t=t>>>8,r[a+1]=t&255,t=t>>>8,r[a+2]=t&255,t=t>>>8,r[a+3]=t&255}e.writeUInt32LE=m;function E(r,t){return r[t]}e.readUInt8=E;function h(r,t,a){r[a]=t}e.writeUInt8=h;function S(r){return R.consumeReadable(r,t=>T.concat(t))}e.readableToBuffer=S;function d(r){return R.toReadable(r)}e.bufferToReadable=d;function v(r){return R.consumeStream(r,t=>T.concat(t))}e.streamToBuffer=v;async function y(r){return r.ended?T.concat(r.buffer):T.concat([...r.buffer,await v(r.stream)])}e.bufferedStreamToBuffer=y;function g(r){return R.toStream(r,t=>T.concat(t))}e.bufferToStream=g;function l(r){return R.transform(r,{data:t=>typeof t=="string"?T.fromString(t):T.wrap(t)},t=>T.concat(t))}e.streamToBufferReadableStream=l;function c(r){return R.newWriteableStream(t=>T.concat(t),r)}e.newWriteableBufferStream=c;function n(r,t){return R.prefixedReadable(r,t,a=>T.concat(a))}e.prefixedBufferReadable=n;function s(r,t){return R.prefixedStream(r,t,a=>T.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const L=/{(\d+)}/g;function D(K,...se){return se.length===0?K:K.replace(L,function(ue,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?ue:se[me]})}e.format=D;const k=/{([^}]+)}/g;function T(K,se){return K.replace(k,(ue,ge)=>se[ge]??ue)}e.format2=T;function C(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=C;function w(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function b(K,se){let ue=0;const ge=se.charCodeAt(0);for(let me=K.length-1;me>=0;me--)K.charCodeAt(me)===ge&&ue++;return ue}e.count=b;function i(K,se,ue="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${ue}`}e.truncate=i;function I(K,se=" "){const ue=m(K,se);return E(ue,se)}e.trim=I;function m(K,se){if(!K||!se)return K;const ue=se.length;if(ue===0||K.length===0)return K;let ge=0;for(;K.indexOf(se,ge)===ge;)ge=ge+ue;return K.substring(ge)}e.ltrim=m;function E(K,se){if(!K||!se)return K;const ue=se.length,ge=K.length;if(ue===0||ge===0)return K;let me=ge,Ie=-1;for(;Ie=K.lastIndexOf(se,me-1),!(Ie===-1||Ie+ue!==me);){if(Ie===0)return"";me=Ie}return K.substring(0,me)}e.rtrim=E;function h(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function S(K){return K.replace(/\*/g,"")}e.stripWildcards=S;function d(K,se,ue={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=w(K)),ue.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(K,ge)}e.createRegExp=d;function v(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function y(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function g(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=g;function l(K){return K.split(/\r\n|\r|\n/)}e.splitLines=l;function c(K){for(let se=0,ue=K.length;se<ue;se++){const ge=K.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function n(K,se=0,ue=K.length){for(let ge=se;ge<ue;ge++){const me=K.charCodeAt(ge);if(me!==32&&me!==9)return K.substring(se,ge)}return K.substring(se,ue)}e.getLeadingWhitespace=n;function s(K,se=K.length-1){for(let ue=se;ue>=0;ue--){const ge=K.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function r(K,se){return K<se?-1:K>se?1:0}e.compare=r;function t(K,se,ue=0,ge=K.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=K.charCodeAt(ue),we=se.charCodeAt(me);if(ye<we)return-1;if(ye>we)return 1}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstring=t;function a(K,se){return o(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=a;function o(K,se,ue=0,ge=K.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=K.charCodeAt(ue),we=se.charCodeAt(me);if(ye===we)continue;if(ye>=128||we>=128)return t(K.toLowerCase(),se.toLowerCase(),ue,ge,me,Ie);u(ye)&&(ye-=32),u(we)&&(we-=32);const De=ye-we;if(De!==0)return De}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstringIgnoreCase=o;function u(K){return K>=97&&K<=122}e.isLowerAsciiLetter=u;function f(K){return K>=65&&K<=90}e.isUpperAsciiLetter=f;function p(K,se){return K.length===se.length&&o(K,se)===0}e.equalsIgnoreCase=p;function A(K,se){const ue=se.length;return se.length>K.length?!1:o(K,se,0,ue)===0}e.startsWithIgnoreCase=A;function O(K,se){let ue,ge=Math.min(K.length,se.length);for(ue=0;ue<ge;ue++)if(K.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return ge}e.commonPrefixLength=O;function M(K,se){let ue,ge=Math.min(K.length,se.length);const me=K.length-1,Ie=se.length-1;for(ue=0;ue<ge;ue++)if(K.charCodeAt(me-ue)!==se.charCodeAt(Ie-ue))return ue;return ge}e.commonSuffixLength=M;function N(K){return 55296<=K&&K<=56319}e.isHighSurrogate=N;function P(K){return 56320<=K&&K<=57343}e.isLowSurrogate=P;function F(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=F;function q(K,se,ue){const ge=K.charCodeAt(ue);if(N(ge)&&ue+1<se){const me=K.charCodeAt(ue+1);if(P(me))return F(ge,me)}return ge}e.getNextCodePoint=q;function _(K,se){const ue=K.charCodeAt(se-1);if(P(ue)&&se>1){const ge=K.charCodeAt(se-2);if(N(ge))return F(ge,ue)}return ue}function $(K,se){const ue=ee.getInstance(),ge=se,me=K.length,Ie=q(K,me,se);se+=Ie>=65536?2:1;let ke=ue.getGraphemeBreakType(Ie);for(;se<me;){const Te=q(K,me,se),ye=ue.getGraphemeBreakType(Te);if($e(ke,ye))break;se+=Te>=65536?2:1,ke=ye}return se-ge}e.nextCharLength=$;function H(K,se){const ue=ee.getInstance(),ge=se,me=_(K,se);se-=me>=65536?2:1;let Ie=ue.getGraphemeBreakType(me);for(;se>0;){const ke=_(K,se),Te=ue.getGraphemeBreakType(ke);if($e(Te,Ie))break;se-=ke>=65536?2:1,Ie=Te}return ge-se}e.prevCharLength=H;function j(K,se){const ue=ee.getInstance(),ge=K.length,me=se,Ie=q(K,ge,se),ke=ue.getGraphemeBreakType(Ie);se+=Ie>=65536?2:1;let Te=ke;for(;se<ge;){const we=q(K,ge,se),De=ue.getGraphemeBreakType(we);if($e(Te,De))break;se+=we>=65536?2:1,Te=De}const ye=se;for(se=me,Te=ke;se>0;){const we=_(K,se),De=ue.getGraphemeBreakType(we);if($e(De,Te))break;se-=we>=65536?2:1,Te=De}return[se,ye]}function x(K,se){return se>0&&P(K.charCodeAt(se))?j(K,se-1):j(K,se)}e.getCharContainingOffset=x;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(K){return z.test(K)}e.containsRTL=Y;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(K){return U.test(K)}e.containsEmoji=B;const W=/^[\t\n\r\x20-\x7E]*$/;function Q(K){return W.test(K)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Z;function G(K){for(let se=0,ue=K.length;se<ue;se++)if(V(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=G;function V(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=V;function re(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=re;function ie(K,se){if(K.length<se)return K;const ue=/\b/g;let ge=0;for(;ue.test(K)&&!(K.length-ue.lastIndex<se);)ge=ue.lastIndex,ue.lastIndex+=1;return K.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function fe(K){return K&&(K=K.replace(ce,""),K=K.replace(le,""),K=K.replace(de,"")),K}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ce(K){return be(K)?K.substr(1):K}e.stripUTF8BOM=Ce;function Ee(K,se){if(!K||!se||K.length<se.length)return!1;const ue=se.length,ge=K.toLowerCase();let me=0,Ie=-1;for(;me<ue;){const ke=ge.indexOf(se[me],Ie+1);if(ke<0)return!1;Ie=ke,me++}return!0}e.fuzzyContains=Ee;function Ae(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ae;function Pe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Pe;function Le(K,se=1){if(se===0)return"";let ue=-1;do ue=K.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?K:(K[ue-1]==="\r"&&ue--,K.substr(0,ue))}e.getNLines=Le;function Fe(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=Fe;function Ne(K){return ee.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ne;function $e(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=$e;var xe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=ae()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,ge=ue.length/3;let me=1;for(;me<=ge;)if(se<ue[3*me])me=2*me;else if(se>ue[3*me+1])me=2*me+1;else return ue[3*me+2];return 0}}ee._INSTANCE=null;function ae(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function oe(K,se){if(K===0)return 0;const ue=pe(K,se);if(ue!==void 0)return ue;const ge=_(se,K);return K-=Se(ge),K}e.getLeftDeleteOffset=oe;function pe(K,se){let ue=_(se,K);for(K-=Se(ue);_e(ue)||ue===65039||ue===8419;){if(K===0)return;ue=_(se,K),K-=Se(ue)}if(!!re(ue)){if(K>=0){const ge=_(se,K);ge===8205&&(K-=Se(ge))}return K}}function Se(K){return K>=65536?2:1}function _e(K){return 127995<=K&&K<=127999}var Re;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={}))}),define(te[104],ne([0,1,25]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(v){return D(v,0)}e.hash=L;function D(v,y){switch(typeof v){case"object":return v===null?k(349,y):Array.isArray(v)?w(v,y):b(v,y);case"string":return C(v,y);case"boolean":return T(v,y);case"number":return k(v,y);case"undefined":return k(937,y);default:return k(617,y)}}e.doHash=D;function k(v,y){return(y<<5)-y+v|0}e.numberHash=k;function T(v,y){return k(v?433:863,y)}function C(v,y){y=k(149417,y);for(let g=0,l=v.length;g<l;g++)y=k(v.charCodeAt(g),y);return y}e.stringHash=C;function w(v,y){return y=k(104579,y),v.reduce((g,l)=>D(l,g),y)}function b(v,y){return y=k(181387,y),Object.keys(v).sort().reduce((g,l)=>(g=C(l,g),D(v[l],g)),y)}class i{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=D(y,this._value),this._value}}e.Hasher=i;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function m(v,y,g=32){const l=g-y,c=~((1<<l)-1);return(v<<y|(c&v)>>>l)>>>0}function E(v,y=0,g=v.byteLength,l=0){for(let c=0;c<g;c++)v[y+c]=l}function h(v,y,g="0"){for(;v.length<y;)v=g+v;return v}function S(v,y=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((v>>>0).toString(16),y/4)}e.toHexString=S;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const g=y.length;if(g===0)return;const l=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,s,r;for(n!==0?(s=n,r=-1,n=0):(s=y.charCodeAt(0),r=0);;){let t=s;if(R.isHighSurrogate(s))if(r+1<g){const a=y.charCodeAt(r+1);R.isLowSurrogate(a)?(r++,t=R.computeCodePoint(s,a)):t=65533}else{n=s;break}else R.isLowSurrogate(s)&&(t=65533);if(c=this._push(l,c,t),r++,r<g)s=y.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(y,g,l){return l<128?y[g++]=l:l<2048?(y[g++]=192|(l&1984)>>>6,y[g++]=128|(l&63)>>>0):l<65536?(y[g++]=224|(l&61440)>>>12,y[g++]=128|(l&4032)>>>6,y[g++]=128|(l&63)>>>0):(y[g++]=240|(l&1835008)>>>18,y[g++]=128|(l&258048)>>>12,y[g++]=128|(l&4032)>>>6,y[g++]=128|(l&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=d._bigBlock32,g=this._buffDV;for(let u=0;u<64;u+=4)y.setUint32(u,g.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)y.setUint32(u,m(y.getUint32(u-12,!1)^y.getUint32(u-32,!1)^y.getUint32(u-56,!1)^y.getUint32(u-64,!1),1),!1);let l=this._h0,c=this._h1,n=this._h2,s=this._h3,r=this._h4,t,a,o;for(let u=0;u<80;u++)u<20?(t=c&n|~c&s,a=1518500249):u<40?(t=c^n^s,a=1859775393):u<60?(t=c&n|c&s|n&s,a=2400959708):(t=c^n^s,a=3395469782),o=m(l,5)+t+r+a+y.getUint32(u*4,!1)&4294967295,r=s,s=n,n=m(c,30),c=l,l=o;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var wt=this&&this.__classPrivateFieldSet||function(J,e,R,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(J,R):D?D.value=R:e.set(J,R),R},Be=this&&this.__classPrivateFieldGet||function(J,e,R,L){if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?L:R==="a"?L.call(J):L?L.value:e.get(J)};define(te[40],ne([0,1,17,25]),function(J,e,R,L){"use strict";var D,k,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(r,t,a){let o=r.get(t);return o===void 0&&(o=a,r.set(t,o)),o}e.getOrSet=C;function w(r){const t=[];return r.forEach((a,o)=>{t.push(`${o} => ${a}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=w;function b(r){const t=[];return r.forEach(a=>{t.push(a)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=b;class i{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const a=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class m{constructor(t=!0,a=!0){this._splitOnBackslash=t,this._caseSensitive=a}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var E;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class v{constructor(t){this._iter=t}static forUris(t=()=>!1){return new v(new h(t))}static forPaths(){return new v(new m)}static forStrings(){return new v(new i)}static forConfigKeys(){return new v(new I)}clear(){this._root=void 0}fill(t,a){if(a){const o=a.slice(0);(0,R.shuffle)(o);for(let u of o)this.set(u,t)}else{const o=t.slice(0);(0,R.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(t,a){const o=this._iter.reset(t);let u;this._root||(this._root=new S,this._root.segment=o.value());const f=[];for(u=this._root;;){const A=o.cmp(u.segment);if(A>0)u.left||(u.left=new S,u.left.segment=o.value()),f.push([-1,u]),u=u.left;else if(A<0)u.right||(u.right=new S,u.right.segment=o.value()),f.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new S,u.mid.segment=o.value()),f.push([0,u]),u=u.mid;else break}const p=u.value;u.value=a,u.key=t;for(let A=f.length-1;A>=0;A--){const O=f[A][1];O.updateHeight();const M=O.balanceFactor();if(M<-1||M>1){const N=f[A][0],P=f[A+1][0];if(N===1&&P===1)f[A][1]=O.rotateLeft();else if(N===-1&&P===-1)f[A][1]=O.rotateRight();else if(N===1&&P===-1)O.right=f[A+1][1]=f[A+1][1].rotateRight(),f[A][1]=O.rotateLeft();else if(N===-1&&P===1)O.left=f[A+1][1]=f[A+1][1].rotateLeft(),f[A][1]=O.rotateRight();else throw new Error;if(A>0)switch(f[A-1][0]){case-1:f[A-1][1].left=f[A][1];break;case 1:f[A-1][1].right=f[A][1];break;case 0:f[A-1][1].mid=f[A][1];break}else this._root=f[0][1]}}return p}get(t){return this._getNode(t)?.value}_getNode(t){const a=this._iter.reset(t);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(t){const a=this._getNode(t);return!(a?.value===void 0&&a?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,a){const o=this._iter.reset(t),u=[];let f=this._root;for(;f;){const p=o.cmp(f.segment);if(p>0)u.push([-1,f]),f=f.left;else if(p<0)u.push([1,f]),f=f.right;else if(o.hasNext())o.next(),u.push([0,f]),f=f.mid;else break}if(!!f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this._min(f.right),{key:A,value:O,segment:M}=p;this._delete(p.key,!1),f.key=A,f.value=O,f.segment=M}else{const p=f.left??f.right;if(u.length>0){const[A,O]=u[u.length-1];switch(A){case-1:O.left=p;break;case 0:O.mid=p;break;case 1:O.right=p;break}}else this._root=p}for(let p=u.length-1;p>=0;p--){const A=u[p][1];A.updateHeight();const O=A.balanceFactor();if(O>1?(A.right.balanceFactor()>=0||(A.right=u[p+1][1]=u[p+1][1].rotateRight()),u[p][1]=A.rotateLeft()):O<-1&&(A.left.balanceFactor()<=0||(A.left=u[p+1][1]=u[p+1][1].rotateLeft()),u[p][1]=A.rotateRight()),p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const a=this._iter.reset(t);let o=this._root,u;for(;o;){const f=a.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(a.hasNext())a.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(t){const a=this._iter.reset(t);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[a,o]of this)t(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=a=>{if(!a)return!0;const o=a.balanceFactor();return o<-1||o>1?!1:t(a.left)&&t(a.right)};return t(this._root)}}e.TernarySearchTree=v;class y{constructor(t,a){this.uri=t,this.value=a}}class g{constructor(t,a){this[D]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=a??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,a){return this.map.set(this.toKey(t),new y(t,a)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,a){typeof a!="undefined"&&(t=t.bind(a));for(let[o,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=r=>r.toString();var l;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class c{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,a=0){const o=this._map.get(t);if(!!o)return a!==0&&this.touch(o,a),o.value}set(t,a,o=0){let u=this._map.get(t);if(u)u.value=a,o!==0&&this.touch(u,o);else{switch(u={key:t,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this._map.get(t);if(!!a)return this._map.delete(t),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,a){const o=this._state;let u=this._head;for(;u;){if(a?t.bind(a)(u.value,u.key,this):t(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}values(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}entries(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>t;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const a=t.next,o=t.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}t.next=void 0,t.previous=void 0,this._state++}touch(t,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this._head)return;const o=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(a===2){if(t===this._tail)return;const o=t.next,u=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((a,o)=>{t.push([o,a])}),t}fromJSON(t){this.clear();for(const[a,o]of t)this.set(a,o)}}e.LinkedMap=c;class n extends c{constructor(t,a=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class s{constructor(t){T.set(this,void 0),wt(this,T,t,"f")}get size(){return Be(this,T,"f").size}forEach(t,a){Be(this,T,"f").forEach(t,a)}get(t){return Be(this,T,"f").get(t)}has(t){return Be(this,T,"f").has(t)}entries(){return Be(this,T,"f").entries()}keys(){return Be(this,T,"f").keys()}values(){return Be(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Be(this,T,"f").entries()}}e.ReadonlyMapView=s}),define(te[69],ne([0,1,40]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new R.LRUCache(1e4);function D(b){return w(b,"NFC",L)}e.normalizeNFC=D;const k=new R.LRUCache(1e4);function T(b){return w(b,"NFD",k)}e.normalizeNFD=T;const C=/[^\u0000-\u0080]/;function w(b,i,I){if(!b)return b;const m=I.get(b);if(m)return m;let E;return C.test(b)?E=b.normalize(i):E=b,I.set(b,E),E}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(i){return T(i).replace(b,"")}}()}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(f){return Array.isArray(f)}e.isArray=R;function L(f){return typeof f=="string"}e.isString=L;function D(f){return Array.isArray(f)&&f.every(p=>L(p))}e.isStringArray=D;function k(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=k;function T(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=T;function C(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=C;function w(f){return f===!0||f===!1}e.isBoolean=w;function b(f){return typeof f=="undefined"}e.isUndefined=b;function i(f){return!I(f)}e.isDefined=i;function I(f){return b(f)||f===null}e.isUndefinedOrNull=I;function m(f,p){if(!f)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=m;function E(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=E;function h(...f){const p=[];for(let A=0;A<f.length;A++){const O=f[A];if(I(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);p.push(O)}return p}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function d(f){if(!k(f))return!1;for(let p in f)if(S.call(f,p))return!1;return!0}e.isEmptyObject=d;function v(f){return typeof f=="function"}e.isFunction=v;function y(...f){return f.length>0&&f.every(v)}e.areFunctions=y;function g(f,p){const A=Math.min(f.length,p.length);for(let O=0;O<A;O++)l(f[O],p[O])}e.validateConstraints=g;function l(f,p){if(L(p)){if(typeof f!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(v(p)){try{if(f instanceof p)return}catch{}if(!I(f)&&f.constructor===p||p.length===1&&p.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(f){let p=[],A=Object.getPrototypeOf(f);for(;Object.prototype!==A;)p=p.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return p}e.getAllPropertyNames=c;function n(f){const p=[];for(const A of c(f))typeof f[A]=="function"&&p.push(A);return p}e.getAllMethodNames=n;function s(f,p){const A=M=>function(){const N=Array.prototype.slice.call(arguments,0);return p(M,N)};let O={};for(const M of f)O[M]=A(M);return O}e.createProxyObject=s;function r(f){return f===null?void 0:f}e.withNullAsUndefined=r;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function a(f){return class{constructor(){return new Proxy({},{get(p,A){if(p[A])return p[A];throw new Error(`Not Implemented: ${f}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function o(f,p="Unreachable"){throw new Error(p)}e.assertNever=o;function u(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=u}),define(te[41],ne([0,1,8,4,25,18]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function C(r){return r.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=C;function w(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function b(r,t=R.posix.sep){if(!r)return"";const a=r.length,o=r.charCodeAt(0);if(T(o)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let f=3;const p=f;for(;f<a&&!T(r.charCodeAt(f));f++);if(p!==f&&!T(r.charCodeAt(f+1))){for(f+=1;f<a;f++)if(T(r.charCodeAt(f)))return r.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(v(o)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(T(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=b;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let a=2;const o=a;for(;a<r.length&&(t=r.charCodeAt(a),t!==92);a++);return!(o===a||(t=r.charCodeAt(a+1),isNaN(t)||t===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,t=L.isWindows){const a=t?I:m;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||t&&E.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function S(r,t,a){const o=r===t;return!a||o?o:!r||!t?!1:(0,D.equalsIgnoreCase)(r,t)}e.isEqual=S;function d(r,t,a,o=R.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let f=t.length;return t.charAt(t.length-1)===o&&f--,r.charAt(f)===o}return t.charAt(t.length-1)!==o&&(t+=o),r.indexOf(t)===0}e.isEqualOrParent=d;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function y(r,t){return L.isWindows&&r.endsWith(":")&&(r+=R.sep),(0,R.isAbsolute)(r)||(r=(0,R.join)(t,r)),r=(0,R.normalize)(r),L.isWindows?(r=(0,D.rtrim)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,D.rtrim)(r,R.sep),r||(r=R.sep)),r}e.sanitizeFilePath=y;function g(r){const t=(0,R.normalize)(r);return L.isWindows?r.length>3?!1:l(t)&&(r.length===2||t.charCodeAt(2)===92):t===R.posix.sep}e.isRootOrDriveLetter=g;function l(r){return L.isWindows?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(r){return l(r)?r[0]:void 0}e.getDriveLetter=c;function n(r,t,a){return t.length>r.length?-1:r===t?0:(a&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=n;function s(r){const t=r.split(":");let a,o,u;if(t.forEach(f=>{const p=Number(f);(0,k.isNumber)(p)?o===void 0?o=p:u===void 0&&(u=p):a=a?[a,f].join(":"):f}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const d=Array.isArray(S)?[]:{};return Object.keys(S).forEach(v=>{S[v]&&typeof S[v]=="object"?d[v]=L(S[v]):d[v]=S[v]}),d}e.deepClone=L;function D(S){if(!S||typeof S!="object")return S;const d=[S];for(;d.length>0;){const v=d.shift();Object.freeze(v);for(const y in v)if(k.call(v,y)){const g=v[y];typeof g=="object"&&!Object.isFrozen(g)&&d.push(g)}}return S}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function T(S,d){return C(S,d,new Set)}e.cloneAndChange=T;function C(S,d,v){if((0,R.isUndefinedOrNull)(S))return S;const y=d(S);if(typeof y!="undefined")return y;if((0,R.isArray)(S)){const g=[];for(const l of S)g.push(C(l,d,v));return g}if((0,R.isObject)(S)){if(v.has(S))throw new Error("Cannot clone recursive data-structure");v.add(S);const g={};for(let l in S)k.call(S,l)&&(g[l]=C(S[l],d,v));return v.delete(S),g}return S}function w(S,d,v=!0){return(0,R.isObject)(S)?((0,R.isObject)(d)&&Object.keys(d).forEach(y=>{y in S?v&&((0,R.isObject)(S[y])&&(0,R.isObject)(d[y])?w(S[y],d[y],v):S[y]=d[y]):S[y]=d[y]}),S):d}e.mixin=w;function b(S,d){if(S===d)return!0;if(S==null||d===null||d===void 0||typeof S!=typeof d||typeof S!="object"||Array.isArray(S)!==Array.isArray(d))return!1;let v,y;if(Array.isArray(S)){if(S.length!==d.length)return!1;for(v=0;v<S.length;v++)if(!b(S[v],d[v]))return!1}else{const g=[];for(y in S)g.push(y);g.sort();const l=[];for(y in d)l.push(y);if(l.sort(),!b(g,l))return!1;for(v=0;v<g.length;v++)if(!b(S[g[v]],d[g[v]]))return!1}return!0}e.equals=b;function i(S){const d=new Set;return JSON.stringify(S,(v,y)=>{if((0,R.isObject)(y)||Array.isArray(y)){if(d.has(y))return"[Circular]";d.add(y)}return y})}e.safeStringify=i;function I(S,d,v){const y=d(S);return typeof y=="undefined"?v:y}e.getOrDefault=I;function m(S,d){const v=Object.create(null);return!S||!d||Object.keys(d).forEach(g=>{const l=S[g],c=d[g];b(l,c)||(v[g]=c)}),v}e.distinct=m;function E(S,d){const v=d.toLowerCase(),y=Object.keys(S).find(g=>g.toLowerCase()===v);return y?S[y]:S[d]}e.getCaseInsensitive=E;function h(S,d){const v=Object.create(null);for(const y of Object.keys(S))d(y,S[y])&&(v[y]=S[y]);return v}e.filter=h}),define(te[9],ne([0,1,8,4]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,T=/^\/\//;function C(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,t){return!r&&!t?"file":r}function b(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const i="",I="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,a,o,u,f,p=!1){typeof t=="object"?(this.scheme=t.scheme||i,this.authority=t.authority||i,this.path=t.path||i,this.query=t.query||i,this.fragment=t.fragment||i):(this.scheme=w(t,p),this.authority=a||i,this.path=b(this.scheme,o||i),this.query=u||i,this.fragment=f||i,C(this,p))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:a,authority:o,path:u,query:f,fragment:p}=t;return a===void 0?a=this.scheme:a===null&&(a=i),o===void 0?o=this.authority:o===null&&(o=i),u===void 0?u=this.path:u===null&&(u=i),f===void 0?f=this.query:f===null&&(f=i),p===void 0?p=this.fragment:p===null&&(p=i),a===this.scheme&&o===this.authority&&u===this.path&&f===this.query&&p===this.fragment?this:new S(a,o,u,f,p)}static parse(t,a=!1){const o=m.exec(t);return o?new S(o[2]||i,s(o[4]||i),s(o[5]||i),s(o[7]||i),s(o[9]||i),a):new S(i,i,i,i,i)}static file(t){let a=i;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const o=t.indexOf(I,2);o===-1?(a=t.substring(2),t=I):(a=t.substring(2,o),t=t.substring(o)||I)}return new S("file",a,t,i,i)}static from(t){const a=new S(t.scheme,t.authority,t.path,t.query,t.fragment);return C(a,!0),a}static joinPath(t,...a){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return L.isWindows&&t.scheme==="file"?o=E.file(R.win32.join(g(t,!0),...a)).path:o=R.posix.join(t.path,...a),t.with({path:o})}toString(t=!1){return l(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const a=new S(t);return a._formatted=t.external,a._fsPath=t._sep===h?t.fsPath:null,a}}else return t}}e.URI=E;const h=L.isWindows?1:void 0;class S extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,t){let a,o=-1;for(let u=0;u<r.length;u++){const f=r.charCodeAt(u);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a!==void 0&&(a+=r.charAt(u));else{a===void 0&&(a=r.substr(0,u));const p=d[f];p!==void 0?(o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a+=p):o===-1&&(o=u)}}return o!==-1&&(a+=encodeURIComponent(r.substring(o))),a!==void 0?a:r}function y(r){let t;for(let a=0;a<r.length;a++){const o=r.charCodeAt(a);o===35||o===63?(t===void 0&&(t=r.substr(0,a)),t+=d[o]):t!==void 0&&(t+=r[a])}return t!==void 0?t:r}function g(r,t){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=g;function l(r,t){const a=t?y:v;let o="",{scheme:u,authority:f,path:p,query:A,fragment:O}=r;if(u&&(o+=u,o+=":"),(f||u==="file")&&(o+=I,o+=I),f){let M=f.indexOf("@");if(M!==-1){const N=f.substr(0,M);f=f.substr(M+1),M=N.indexOf(":"),M===-1?o+=a(N,!1):(o+=a(N.substr(0,M),!1),o+=":",o+=a(N.substr(M+1),!1)),o+="@"}f=f.toLowerCase(),M=f.indexOf(":"),M===-1?o+=a(f,!1):(o+=a(f.substr(0,M),!1),o+=f.substr(M))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const M=p.charCodeAt(1);M>=65&&M<=90&&(p=`/${String.fromCharCode(M+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const M=p.charCodeAt(0);M>=65&&M<=90&&(p=`${String.fromCharCode(M+32)}:${p.substr(2)}`)}o+=a(p,!0)}return A&&(o+="?",o+=a(A,!1)),O&&(o+="#",o+=t?O:v(O,!1)),o}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(n)?r.replace(n,t=>c(t)):r}}),define(te[105],ne([0,1,9]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(b){const i=b;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function D(b){const i=[];let I;try{const m=JSON.parse(b.arguments),E=m[m.length-1];E&&E.__$stack&&(m.pop(),I=E.__$stack),i.push(...m)}catch(m){i.push("Unable to log remote console arguments",b.arguments)}return{args:i,stack:I}}e.parse=D;function k(b){if(typeof b!="string")return k(D(b).stack);const i=b;if(i){const I=T(i),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function T(b){if(!b)return b;const i=b.indexOf(`
`);return i===-1?b:b.substring(0,i)}function C(b,i){const{args:I,stack:m}=D(b),E=typeof I[0]=="string"&&I.length===1;let h=T(m);h&&(h=`(${h.trim()})`);let S=[];if(typeof I[0]=="string"?h&&E?S=[`%c[${i}] %c${I[0]} %c${h}`,w("blue"),w(""),w("grey")]:S=[`%c[${i}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:S=[`%c[${i}]%`,w("blue"),...I],h&&!E&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=C;function w(b){return`color: ${b}`}}),define(te[106],ne([0,1,19,25,9]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(i){return JSON.stringify(i,w)}e.stringify=k;function T(i){let I=JSON.parse(i);return I=b(I),I}e.parse=T;var C;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function w(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function b(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof R.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let m=0;m<i.length;++m)i[m]=b(i[m],I+1);else for(const m in i)Object.hasOwnProperty.call(i,m)&&(i[m]=b(i[m],I+1))}return i}e.revive=b}),define(te[15],ne([0,1,4,9]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,b,i){this._hosts[w]=b,this._ports[w]=i}setConnectionToken(w,b){this._connectionTokens[w]=b}rewrite(w){if(this._delegate)return this._delegate(w);const b=w.authority;let i=this._hosts[b];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[b],m=this._connectionTokens[b];let E=`path=${encodeURIComponent(w.path)}`;return typeof m=="string"&&(E+=`&tkn=${encodeURIComponent(m)}`),L.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new k;class T{asBrowserUri(w,b){const i=this.toUri(w,b);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(w,b){const i=this.toUri(w,b);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==T.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,b){return L.URI.isUri(w)?w:L.URI.parse(b.toUrl(w))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(te[16],ne([0,1,41,15,8,4,25,9]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(E){return(0,C.uriToFsPath)(E,!0)}e.originalFSPath=w;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,d=!1){return h===S?0:(0,T.compare)(this.getComparisonKey(h,d),this.getComparisonKey(S,d))}isEqual(h,S,d=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,d)===this.getComparisonKey(S,d)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,d=!1){if(h.scheme===S.scheme){if(h.scheme===L.Schemas.file)return R.isEqualOrParent(w(h),w(S),this._ignorePathCasing(h))&&h.query===S.query&&(d||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return R.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(d||h.fragment===S.fragment)}return!1}joinPath(h,...S){return C.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===L.Schemas.file?S=C.URI.file(D.dirname(w(h))).path:(S=D.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===L.Schemas.file?S=C.URI.file(D.normalize(w(h))).path:S=D.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===L.Schemas.file){const y=D.relative(w(h),w(S));return k.isWindows?R.toSlashes(y):y}let d=h.path||"/",v=S.path||"/";if(this._ignorePathCasing(h)){let y=0;for(const g=Math.min(d.length,v.length);y<g&&!(d.charCodeAt(y)!==v.charCodeAt(y)&&d.charAt(y).toLowerCase()!==v.charAt(y).toLowerCase());y++);d=v.substr(0,y)+d.substr(y)}return D.posix.relative(d,v)}resolvePath(h,S){if(h.scheme===L.Schemas.file){const d=C.URI.file(D.resolve(w(h),S));return h.with({authority:d.authority,path:d.path})}return S=R.toPosixPath(S),h.with({path:D.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||(0,T.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=D.sep){if(h.scheme===L.Schemas.file){const d=w(h);return d.length>R.getRoot(d).length&&d[d.length-1]===S}else{const d=h.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=D.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=D.sep){let d=!1;if(h.scheme===L.Schemas.file){const v=w(h);d=v!==void 0&&v.length===R.getRoot(v).length&&v[v.length-1]===S}else{S="/";const v=h.path;d=v.length===1&&v.charCodeAt(v.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(E=>E.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new b(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(E,h){const S=[];for(let d=0;d<E.length;d++){const v=h(E[d]);E.some((y,g)=>g===d?!1:(0,e.isEqualOrParent)(v,h(y)))||S.push(E[d])}return S}e.distinctParents=i;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(S){const d=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(g=>{const[l,c]=g.split(":");l&&c&&d.set(l,c)});const y=S.path.substring(0,S.path.indexOf(";"));return y&&d.set(E.META_DATA_MIME,y),d}E.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function m(E,h,S){if(h){let d=E.path;return d&&d[0]!==D.posix.sep&&(d=D.posix.sep+d),E.with({scheme:S,authority:h,path:d})}return E.with({scheme:S})}e.toLocalResource=m}),define(te[5],ne([0,1,27,7,3,2,16]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(H){return!!H&&typeof H.then=="function"}e.isThenable=C;function w(H){const j=new R.CancellationTokenSource,x=H(j.token),z=new Promise((Y,U)=>{const B=j.token.onCancellationRequested(()=>{B.dispose(),j.dispose(),U((0,L.canceled)())});Promise.resolve(x).then(W=>{B.dispose(),j.dispose(),Y(W)},W=>{B.dispose(),j.dispose(),U(W)})});return new class{cancel(){j.cancel()}then(Y,U){return z.then(Y,U)}catch(Y){return this.then(void 0,Y)}finally(Y){return z.finally(Y)}}}e.createCancelablePromise=w;function b(H,j,x){return Promise.race([H,new Promise(z=>j.onCancellationRequested(()=>z(x)))])}e.raceCancellation=b;async function i(H){let j=-1;const x=H.map((Y,U)=>Y.then(B=>(j=U,B))),z=await Promise.race(x);return H.forEach((Y,U)=>{U!==j&&Y.cancel()}),z}e.raceCancellablePromises=i;function I(H,j,x){let z;const Y=setTimeout(()=>{z?.(void 0),x?.()},j);return Promise.race([H.finally(()=>clearTimeout(Y)),new Promise(U=>z=U)])}e.raceTimeout=I;function m(H){return new Promise((j,x)=>{const z=H();C(z)?z.then(j,x):j(z)})}e.asPromise=m;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(x,x).then(z)})}return new Promise((x,z)=>{this.queuedPromise.then(x,z)})}return this.activePromise=j(),new Promise((x,z)=>{this.activePromise.then(Y=>{this.activePromise=null,x(Y)},Y=>{this.activePromise=null,z(Y)})})}}e.Throttler=E;class h{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(j,x){const Y=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(j)===Y&&this.promiseMap.delete(j)});return this.promiseMap.set(j,Y),Y}}e.SequencerByKey=S;class d{constructor(j){this.defaultDelay=j,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,x=this.defaultDelay){return this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,Y)=>{this.doResolve=z,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=d;class v{constructor(j){this.delayer=new d(j),this.throttler=new E}trigger(j,x){return this.delayer.trigger(()=>this.throttler.queue(j),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class y{constructor(){this._isOpen=!1,this._promise=new Promise((j,x)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class g extends y{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function l(H,j){return j?new Promise((x,z)=>{const Y=setTimeout(()=>{U.dispose(),x()},H),U=j.onCancellationRequested(()=>{clearTimeout(Y),U.dispose(),z((0,L.canceled)())})}):w(x=>l(H,x))}e.timeout=l;function c(H,j=0){const x=setTimeout(H,j);return(0,k.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=c;function n(H){const j=[];let x=0;const z=H.length;function Y(){return x<z?H[x++]():null}function U(B){B!=null&&j.push(B);const W=Y();return W?W.then(U):Promise.resolve(j)}return Promise.resolve(null).then(U)}e.sequence=n;function s(H,j=z=>!!z,x=null){let z=0;const Y=H.length,U=()=>{if(z>=Y)return Promise.resolve(x);const B=H[z++];return Promise.resolve(B()).then(Q=>j(Q)?Promise.resolve(Q):U())};return U()}e.first=s;function r(H,j=z=>!!z,x=null){if(H.length===0)return Promise.resolve(x);let z=H.length;const Y=()=>{z=-1;for(const U of H)U.cancel?.()};return new Promise((U,B)=>{for(const W of H)W.then(Q=>{--z>=0&&j(Q)?(Y(),U(Q)):z===0&&U(x)}).catch(Q=>{--z>=0&&(Y(),B(Q))})})}e.firstParallel=r;class t{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((x,z)=>{this.outstandingPromises.push({factory:j,c:x,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const x=j.factory();x.then(j.c,j.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class a extends t{constructor(){super(1)}}e.Queue=a;class o{constructor(){this.queues=new Map}queueFor(j,x=T.extUri){const z=x.getComparisonKey(j);let Y=this.queues.get(z);return Y||(Y=new a,D.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(z)}),this.queues.set(z,Y)),Y}dispose(){this.queues.forEach(j=>j.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(j,x){this._token=-1,typeof j=="function"&&typeof x=="number"&&this.setIfNotSet(j,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},x)}setIfNotSet(j,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},x))}}e.TimeoutTimer=u;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,x){this.cancel(),this._token=setInterval(()=>{j()},x)}}e.IntervalTimer=f;class p{constructor(j,x){this.timeoutToken=-1,this.runner=j,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=p;class A{constructor(j,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends p{constructor(j,x){super(j,x);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class M extends k.Disposable{constructor(j,x,z,Y){super();this.maxWorkChunkSize=j,this.maxPendingWork=x,this.throttleDelay=z,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new p(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const j=setTimeout(()=>{const z=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(j))}}}:e.runWhenIdle=(H,j)=>{const x=requestIdleCallback(H,typeof j=="number"?{timeout:j}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(x))}}}}();class N{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function P(H,j,x){let z;for(let Y=0;Y<x;Y++)try{return await H()}catch(U){z=U,await l(j)}throw z}e.retry=P;class F{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,x,z){return this._pending={taskId:j,cancel:()=>z?.(),promise:x},x.then(()=>this.donePending(j),()=>this.donePending(j)),x}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let x,z;const Y=new Promise((U,B)=>{x=U,z=B});this._next={run:j,promise:Y,promiseResolve:x,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=F;class q{constructor(j){this.interval=j,this.lastIncrementTime=0,this.value=0}increment(){const j=Date.now();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,x)=>{this.completeCallback=j,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(x=>{this.completeCallback(j),this.resolved=!0,x()})}error(j){return new Promise(x=>{this.errorCallback(j),this.rejected=!0,x()})}cancel(){new Promise(j=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,j()})}}e.DeferredPromise=_;var $;(function(H){async function j(z){let Y;const U=await Promise.all(z.map(B=>B.then(W=>W,W=>{Y||(Y=W)})));if(typeof Y!="undefined")throw Y;return U}H.settled=j;function x(z){return new Promise(async(Y,U)=>{try{await z(Y,U)}catch(B){U(B)}})}H.withAsyncBody=x})($=e.Promises||(e.Promises={}))}),define(te[107],ne([0,1,5,41,40,8,25]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const w="**",b="/",i="[/\\\\]",I="[^/\\\\]",m=/\//g;function E(z){switch(z){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h(z,Y){if(!z)return[];const U=[];let B=!1,W=!1,Q="";for(const Z of z){switch(Z){case Y:if(!B&&!W){U.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":W=!0;break;case"]":W=!1;break}Q+=Z}return Q&&U.push(Q),U}e.splitGlobAware=h;function S(z){if(!z)return"";let Y="";const U=h(z,b);if(U.every(B=>B===w))Y=".*";else{let B=!1;U.forEach((W,Q)=>{if(W===w){B||(Y+=E(2),B=!0);return}let Z=!1,G="",V=!1,re="";for(const ie of W){if(ie!=="}"&&Z){G+=ie;continue}if(V&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===b?ce="":ce=T.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":V=!0;continue;case"}":Y+=`(?:${h(G,",").map(de=>S(de)).join("|")})`,Z=!1,G="";break;case"]":Y+="["+re+"]",V=!1,re="";break;case"?":Y+=I;continue;case"*":Y+=E(1);continue;default:Y+=T.escapeRegExpCharacters(ie)}}Q<U.length-1&&(U[Q+1]!==w||Q+2<U.length)&&(Y+=i),B=!1})}return Y}const d=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new D.LRUCache(1e4),s=function(){return!1},r=function(){return null};function t(z,Y){if(!z)return r;let U;typeof z!="string"?U=z.pattern:U=z,U=U.trim();const B=`${U}_${!!Y.trimForExclusions}`;let W=n.get(B);if(W)return a(W,z);let Q;if(d.test(U)){const Z=U.substr(4);W=function(G,V){return typeof G=="string"&&G.endsWith(Z)?U:null}}else(Q=v.exec(o(U,Y)))?W=u(Q[1],U):(Y.trimForExclusions?g:y).test(U)?W=f(U,Y):(Q=l.exec(o(U,Y)))?W=p(Q[1].substr(1),U,!0):(Q=c.exec(o(U,Y)))?W=p(Q[1],U,!1):W=A(U);return n.set(B,W),a(W,z)}function a(z,Y){return typeof Y=="string"?z:function(U,B){return L.isEqualOrParent(U,Y.base)?z(k.relative(Y.base,U),B):null}}function o(z,Y){return Y.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function u(z,Y){const U=`/${z}`,B=`\\${z}`,W=function(Z,G){return typeof Z!="string"?null:G?G===z?Y:null:Z===z||Z.endsWith(U)||Z.endsWith(B)?Y:null},Q=[z];return W.basenames=Q,W.patterns=[Y],W.allBasenames=Q,W}function f(z,Y){const U=x(z.slice(1,-1).split(",").map(G=>t(G,Y)).filter(G=>G!==r),z),B=U.length;if(!B)return r;if(B===1)return U[0];const W=function(G,V){for(let re=0,ie=U.length;re<ie;re++)if(U[re](G,V))return z;return null},Q=U.find(G=>!!G.allBasenames);Q&&(W.allBasenames=Q.allBasenames);const Z=U.reduce((G,V)=>V.allPaths?G.concat(V.allPaths):G,[]);return Z.length&&(W.allPaths=Z),W}function p(z,Y,U){const B=k.sep===k.posix.sep,W=B?z:z.replace(m,k.sep),Q=k.sep+W,Z=k.posix.sep+z,G=U?function(V,re){return typeof V=="string"&&(V===W||V.endsWith(Q)||!B&&(V===z||V.endsWith(Z)))?Y:null}:function(V,re){return typeof V=="string"&&(V===W||!B&&V===z)?Y:null};return G.allPaths=[(U?"*/":"./")+z],G}function A(z){try{const Y=new RegExp(`^${S(z)}$`);return function(U){return Y.lastIndex=0,typeof U=="string"&&Y.test(U)?z:null}}catch(Y){return r}}function O(z,Y,U){return!z||typeof Y!="string"?!1:M(z)(Y,void 0,U)}e.match=O;function M(z,Y={}){if(!z)return s;if(typeof z=="string"||q(z)){const U=t(z,Y);if(U===r)return s;const B=function(W,Q){return!!U(W,Q)};return U.allBasenames&&(B.allBasenames=U.allBasenames),U.allPaths&&(B.allPaths=U.allPaths),B}return H(z,Y)}e.parse=M;function N(z){if(!z)return;let Y;return U=>(Y||(Y=(z()||Promise.resolve([])).then(B=>B?F(B):{})),Y.then(B=>!!B[U]))}e.hasSiblingPromiseFn=N;function P(z){if(!z)return;let Y;return U=>{if(!Y){const B=z();Y=B?F(B):{}}return!!Y[U]}}e.hasSiblingFn=P;function F(z){const Y={};for(const U of z)Y[U]=!0;return Y}function q(z){const Y=z;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=q;function _(z){return z.allBasenames||[]}e.getBasenameTerms=_;function $(z){return z.allPaths||[]}e.getPathTerms=$;function H(z,Y){const U=x(Object.getOwnPropertyNames(z).map(G=>j(G,z[G],Y)).filter(G=>G!==r)),B=U.length;if(!B)return r;if(!U.some(G=>!!G.requiresSiblings)){if(B===1)return U[0];const G=function(ie,ce){for(let le=0,de=U.length;le<de;le++){const fe=U[le](ie,ce);if(fe)return fe}return null},V=U.find(ie=>!!ie.allBasenames);V&&(G.allBasenames=V.allBasenames);const re=U.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(G.allPaths=re),G}const W=function(G,V,re){let ie;for(let ce=0,le=U.length;ce<le;ce++){const de=U[ce];de.requiresSiblings&&re&&(V||(V=k.basename(G)),ie||(ie=V.substr(0,V.length-k.extname(G).length)));const fe=de(G,V,ie,re);if(fe)return fe}return null},Q=U.find(G=>!!G.allBasenames);Q&&(W.allBasenames=Q.allBasenames);const Z=U.reduce((G,V)=>V.allPaths?G.concat(V.allPaths):G,[]);return Z.length&&(W.allPaths=Z),W}function j(z,Y,U){if(Y===!1)return r;const B=t(z,U);if(B===r)return r;if(typeof Y=="boolean")return B;if(Y){const W=Y.when;if(typeof W=="string"){const Q=(Z,G,V,re)=>{if(!re||!B(Z,G))return null;const ie=W.replace("$(basename)",V),ce=re(ie);return(0,R.isThenable)(ce)?ce.then(le=>le?z:null):ce?z:null};return Q.requiresSiblings=!0,Q}}return B}function x(z,Y){const U=z.filter(G=>!!G.basenames);if(U.length<2)return z;const B=U.reduce((G,V)=>{const re=V.basenames;return re?G.concat(re):G},[]);let W;if(Y){W=[];for(let G=0,V=B.length;G<V;G++)W.push(Y)}else W=U.reduce((G,V)=>{const re=V.patterns;return re?G.concat(re):G},[]);const Q=function(G,V){if(typeof G!="string")return null;if(!V){let ie;for(ie=G.length;ie>0;ie--){const ce=G.charCodeAt(ie-1);if(ce===47||ce===92)break}V=G.substr(ie)}const re=B.indexOf(V);return re!==-1?W[re]:null};Q.basenames=B,Q.patterns=W,Q.allBasenames=B;const Z=z.filter(G=>!G.basenames);return Z.push(Q),Z}}),define(te[108],ne([0,1,107,15,8,16,25]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let w=[],b=[],i=[];function I(t,a=!1){const o=m(t);w.push(o),o.userConfigured?i.push(o):b.push(o),a&&!o.userConfigured&&w.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=I;function m(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,R.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function E(t){t?(w=w.filter(a=>!a.userConfigured),i=[]):(w=[],b=[],i=[])}e.clearTextMimes=E;function h(t,a){let o;if(t)switch(t.scheme){case L.Schemas.file:o=t.fsPath;break;case L.Schemas.data:o=k.DataUri.parseMetaData(t).get(k.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[C.unknown];o=o.toLowerCase();const u=(0,D.basename)(o),f=S(o,u,i);if(f)return[f,C.text];const p=S(o,u,b);if(p)return[p,C.text];if(a){const A=d(a);if(A)return[A,C.text]}return[C.unknown]}e.guessMimeTypes=h;function S(t,a,o){let u=null,f=null,p=null;for(let A=o.length-1;A>=0;A--){const O=o[A];if(a===O.filenameLowercase){u=O;break}if(O.filepattern&&(!f||O.filepattern.length>f.filepattern.length)){const M=O.filepatternOnPath?t:a;O.filepatternLowercase?.(M)&&(f=O)}O.extension&&(!p||O.extension.length>p.extension.length)&&a.endsWith(O.extensionLowercase)&&(p=O)}return u?u.mime:f?f.mime:p?p.mime:null}function d(t){if((0,T.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let a=w.length-1;a>=0;a--){const o=w[a];if(!o.firstline)continue;const u=t.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function v(t){return t?typeof t=="string"?t===C.binary||t===C.text||t===C.unknown:t.length===1&&v(t[0]):!0}e.isUnspecific=v;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(t){const a=(0,D.extname)(t),o=y[a.toLowerCase()];return o!==void 0?o:c(t)}e.getMediaOrTextMime=l;function c(t){const a=(0,D.extname)(t);return g[a.toLowerCase()]}e.getMediaMime=c;function n(t){for(const a in g)if(g[a]===t)return a}e.getExtensionForMimeType=n;const s=/^(.+)\/(.+?)(;.+)?$/;function r(t,a){const o=s.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:a?void 0:t}e.normalizeMimeType=r}),define(te[109],ne([0,1,9]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const m=this._uriTransformer.transformIncoming(I);return m===I?I:L(R.URI.from(m))}transformOutgoing(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:L(R.URI.from(m))}transformOutgoingURI(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:R.URI.from(m)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function k(i,I,m){if(!i||m>200)return null;if(typeof i=="object"){if(i instanceof R.URI)return I.transformOutgoing(i);for(let E in i)if(Object.hasOwnProperty.call(i,E)){const h=k(i[E],I,m+1);h!==null&&(i[E]=h)}}return null}function T(i,I){const m=k(i,I,0);return m===null?i:m}e.transformOutgoingURIs=T;function C(i,I,m,E){if(!i||E>200)return null;if(typeof i=="object"){if(i.$mid===1)return m?R.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const S=C(i[h],I,m,E+1);S!==null&&(i[h]=S)}}return null}function w(i,I){const m=C(i,I,!1,0);return m===null?i:m}e.transformIncomingURIs=w;function b(i,I){const m=C(i,I,!0,0);return m===null?i:m}e.transformAndReviveIncomingURIs=b}),define(te[29],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return R.test(w)}e.isUUID=L;const D=new Uint8Array(16),k=[];for(let w=0;w<256;w++)k.push(w.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};function C(){T(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let w=0,b="";return b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b}e.generateUuid=C}),define(te[110],ne([0,1,111]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new R.StringDecoder(k),this.remaining=null}write(k){const T=[],C=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(C.length<1)return T;let w=0,b,i=w;for(;i<C.length;)if(b=C.charCodeAt(i),b===13||b===10){if(T.push(C.substring(w,i)),i++,i<C.length){const I=b;b=C.charCodeAt(i),(I===13&&b===10||I===10&&b===13)&&i++}w=i}else i++;return this.remaining=w<C.length?C.substr(w):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(te[112],ne([0,1,34]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(C){const w=C.replace(/\-/g,":").toLowerCase();return!L.has(w)}function k(){return new Promise(async(C,w)=>{const b=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{C(await T())}catch(i){w(i)}finally{clearTimeout(b)}})}e.getMac=k;function T(){return new Promise((C,w)=>{try{const b=(0,R.networkInterfaces)();for(let i in b){const I=b[i];if(I){for(const{mac:m}of I)if(D(m))return C(m)}}w("Unable to retrieve mac address (unexpected format)")}catch(b){w(b)}})}}),define(te[113],ne([0,1,34,7,40,29,112]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const m=(0,R.networkInterfaces)();for(let E in m){const h=m[E];if(h)for(const{mac:S,internal:d}of h)d||(I+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let C;async function w(){return C||(C=(async()=>await b()||k.generateUuid())()),C}e.getMachineId=w;async function b(){try{const i=await new Promise((m,E)=>{J(["crypto"],m,E)}),I=await(0,T.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(te[20],ne([0,1,52,34,241,5,41,69,8,4,16,9,29]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(_,$=E.UNLINK){if((0,T.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return $===E.UNLINK?d(_):S(_)}async function S(_){try{const $=(0,w.join)((0,L.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(_,$)}catch(H){return d(_)}d($).catch(H=>{})}catch($){if($.code!=="ENOENT")throw $}}async function d(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function v(_){if((0,T.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(_,{recursive:!0})}e.rimrafSync=v;async function y(_,$){return c(await($?g(_):(0,D.promisify)(R.readdir)(_)))}async function g(_){try{return await(0,D.promisify)(R.readdir)(_,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const $=[],H=await y(_);for(const j of H){let x=!1,z=!1,Y=!1;try{const U=await e.Promises.lstat((0,w.join)(_,j));x=U.isFile(),z=U.isDirectory(),Y=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}$.push({name:j,isFile:()=>x,isDirectory:()=>z,isSymbolicLink:()=>Y})}return $}function l(_){return c(R.readdirSync(_))}e.readdirSync=l;function c(_){return _.map($=>typeof $=="string"?b.isMacintosh?(0,C.normalizeNFC)($):$:($.name=b.isMacintosh?(0,C.normalizeNFC)($.name):$.name,$))}async function n(_){const $=await y(_),H=[];for(const j of $)await r.existsDirectory((0,w.join)(_,j))&&H.push(j);return H}function s(_,$=1e3){return new Promise(H=>{let j=!1;const x=setInterval(()=>{j||(j=!0,R.access(_,z=>{j=!1,z&&(clearInterval(x),H(void 0))}))},$)})}e.whenDeleted=s;var r;(function(_){async function $(x){let z;try{if(z=await e.Promises.lstat(x),!z.isSymbolicLink())return{stat:z}}catch(Y){}try{return{stat:await e.Promises.stat(x),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(b.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw U}throw Y}}_.stat=$;async function H(x){try{const{stat:z,symbolicLink:Y}=await _.stat(x);return z.isFile()&&Y?.dangling!==!0}catch(z){}return!1}_.existsFile=H;async function j(x){try{const{stat:z,symbolicLink:Y}=await _.stat(x);return z.isDirectory()&&Y?.dangling!==!0}catch(z){}return!1}_.existsDirectory=j})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function a(_,$,H){return t.queueFor(I.URI.file(_),i.extUriBiasedIgnorePathCase).queue(()=>{const j=p(H);return new Promise((x,z)=>u(_,$,j,Y=>Y?z(Y):x()))})}let o=!0;function u(_,$,H,j){if(!o)return R.writeFile(_,$,{mode:H.mode,flag:H.flag},j);R.open(_,H.flag,H.mode,(x,z)=>{if(x)return j(x);R.writeFile(z,$,Y=>{if(Y)return R.close(z,()=>j(Y));R.fdatasync(z,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),o=!1),R.close(z,B=>j(B))))})})}function f(_,$,H){const j=p(H);if(!o)return R.writeFileSync(_,$,{mode:j.mode,flag:j.flag});const x=R.openSync(_,j.flag,j.mode);try{R.writeFileSync(x,$);try{R.fdatasyncSync(x)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o=!1}}finally{R.closeSync(x)}}e.writeFileSync=f;function p(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function A(_,$){if(_===$)return;async function H(j){try{const x=await e.Promises.lstat(j);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(j,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(_,$),await H($)}catch(j){if(_.toLowerCase()!==$.toLowerCase()&&j.code==="EXDEV"||_.endsWith("."))await O(_,$,{preserveSymlinks:!1}),await h(_,E.MOVE),await H($);else throw j}}async function O(_,$,H){return N(_,$,{root:{source:_,target:$},options:H,handledSourcePaths:new Set})}const M=511;async function N(_,$,H){if(H.handledSourcePaths.has(_))return;H.handledSourcePaths.add(_);const{stat:j,symbolicLink:x}=await r.stat(_);if(x){if(H.options.preserveSymlinks)try{return await q(_,$,H)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(x.dangling)return}return j.isDirectory()?P(_,$,j.mode&M,H):F(_,$,j.mode&M)}async function P(_,$,H,j){await e.Promises.mkdir($,{recursive:!0,mode:H});const x=await y(_);for(const z of x)await N((0,w.join)(_,z),(0,w.join)($,z),j)}async function F(_,$,H){await e.Promises.copyFile(_,$),await e.Promises.chmod($,H)}async function q(_,$,H){let j=await e.Promises.readlink(_);(0,T.isEqualOrParent)(j,H.root.source,!b.isLinux)&&(j=(0,w.join)(H.root.target,j.substr(H.root.source.length+1))),await e.Promises.symlink(j,$)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return n}get writeFile(){return a}get rm(){return h}get move(){return A}get copy(){return O}}}),define(te[114],ne([0,1,52,8,25,20]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const I=(0,L.dirname)(i);if(i===I)return i;const m=((0,L.basename)(i)||i).toLowerCase();try{const h=(0,k.readdirSync)(I).filter(S=>S.toLowerCase()===m);if(h.length===1){const S=T(I);if(S)return(0,L.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(m);if(S>=0){const d=T(I);if(d)return(0,L.join)(d,h[S])}}}catch(E){}return null}e.realcaseSync=T;async function C(i){try{return await k.Promises.realpath(i)}catch(I){const m=b(i);return await k.Promises.access(m,R.constants.R_OK),m}}e.realpath=C;function w(i){try{return R.realpathSync(i)}catch(I){const m=b(i);return R.accessSync(m,R.constants.R_OK),m}}e.realpathSync=w;function b(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}}),define(te[115],ne([0,1,56]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(C,w,b,i=1){let I=!1;return new Promise(m=>{const E=setTimeout(()=>{if(!I)return I=!0,m(0)},b);D(C,w,i,h=>{if(!I)return I=!0,clearTimeout(E),m(h)})})}e.findFreePort=L;function D(C,w,b,i){if(w===0)return i(0);const I=new R.Socket;I.once("connect",()=>(T(I),D(C+b,w-1,b,i))),I.once("data",()=>{}),I.once("error",m=>(T(I),m.code!=="ECONNREFUSED"?D(C+b,w-1,b,i):i(C))),I.connect(C,"127.0.0.1")}function k(C,w,b){let i=!1,I,m=1;const E=R.createServer({pauseOnConnect:!0});function h(S,d){i||(i=!0,E.removeAllListeners(),E.close(),I&&clearTimeout(I),d(S))}return new Promise(S=>{I=setTimeout(()=>{h(0,S)},b),E.on("listening",()=>{h(C,S)}),E.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&m<w?(C++,m++,E.listen(C,"127.0.0.1")):h(0,S)}),E.on("close",()=>{h(0,S)}),E.listen(C,"127.0.0.1")})}e.findFreePortFaster=k;function T(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(w){console.error(w)}}}),define(te[70],ne([0,1,34,8,20]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,T=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var w;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(w||(w={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(c,n,s){this.exePath=c,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:l=!1}={}){return l?b===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:l=!1,findPreview:c=!1}={}){const n=m({useAlternateBitness:l});if(!n)return null;const s=L.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let r=-1,t=null;for(const u of await D.Promises.readdir(s)){let f=-1;if(c){const A=u.indexOf("-");if(A<0)continue;const O=u.substring(0,A);if(!k.test(O)||u.substring(A+1)!=="preview")continue;f=parseInt(O,10)}else{if(!k.test(u))continue;f=parseInt(u,10)}if(f<=r)continue;const p=L.join(s,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(p)||(t=p,r=f)}if(!t)return null;const a=n.includes("x86")?" (x86)":"",o=c?" Preview":"";return new I(t,`PowerShell${o}${a}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=l?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const r of await D.Promises.readdir(c))if(n.test(r)){const t=L.join(c,r,"pwsh.exe");return new I(t,s)}return null}function S(){const l=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function d(){const l=L.join(process.env.windir,b===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}async function*v(){let l=await E();l&&(yield l),l=await E({useAlternateBitness:!0}),l&&(yield l),l=await h(),l&&(yield l),l=S(),l&&(yield l),l=await E({findPreview:!0}),l&&(yield l),l=await h({findPreview:!0}),l&&(yield l),l=await E({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=d(),l&&(yield l)}async function*y(){for await(const l of v())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=y;async function g(){for await(const l of y())return l;return null}e.getFirstAvailablePowerShellInstallation=g}),define(te[116],ne([0,1,42,15]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((C,w)=>{let b;const i=new Map;function I(E,h,S,d,v){const y=i.get(h);if(E===T||y){const g={name:m(S),cmd:S,pid:E,ppid:h,load:d,mem:v};i.set(E,g),E===T&&(b=g),y&&(y.children||(y.children=[]),y.children.push(g),y.children.length>1&&(y.children=y.children.sort((l,c)=>l.pid-c.pid)))}}function m(E){const h=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,d=/--crashes-directory/,v=/\\pipe\\winpty-control/,y=/conhost\.exe/,g=/--type=([a-zA-Z-]+)/;if(S.exec(E))return"watcherService ";if(d.exec(E))return"electron-crash-reporter";if(v.exec(E))return"winpty-process";if(y.exec(E))return"console-window-host (Windows internal process)";let l=g.exec(E);if(l&&l.length===2)return l[1]==="renderer"?h.exec(E)?"shared-process":"window":l[1];const c=/[a-zA-Z-]+\.js/g;let n="";do l=c.exec(E),l&&(n+=l+" ");while(l);return n&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${n}`:E}if(process.platform==="win32"){const E=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{J(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(T,S=>{h.getProcessCpuUsage(S,d=>{const v=new Map;d.forEach(y=>{const g=E(y.commandLine||"");v.set(y.pid,{name:m(g),cmd:g,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),b=v.get(T),b?(v.forEach(y=>{const g=v.get(y.ppid);g&&(g.children||(g.children=[]),g.children.push(y))}),v.forEach(y=>{y.children&&(y.children=y.children.sort((g,l)=>g.pid-l.pid))}),C(b)):w(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let E=function(){let h=[b];const S=[];for(;h.length;){const v=h.shift();v&&(S.push(v.pid),v.children&&(h=h.concat(v.children)))}let d=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);d+=" "+S.join(" "),(0,R.exec)(d,{},(v,y,g)=>{if(v||g)w(v||new Error(g.toString()));else{const l=y.toString().split(`
`);for(let c=0;c<S.length;c++){const n=i.get(S[c]);n.load=parseFloat(l[c])}if(!b){w(new Error(`Root process ${T} not found`));return}C(b)}})};(0,R.exec)("which ps",{},(h,S,d)=>{if(h||d)if(process.platform!=="linux")w(h||new Error(d.toString()));else{const v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,R.exec)(v,{},(y,g,l)=>{y||l?w(y||new Error(l.toString())):(k(g,I),E())})}else{const v=S.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${v} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,l,c)=>{g||c&&!c.includes("screen size is bogus")?w(g||new Error(c.toString())):(k(l,I),process.platform==="linux"?E():b?C(b):w(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function k(T,C){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const i of b){const I=w.exec(i.trim());I&&I.length===6&&C(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[117],ne([0,1,52,27,41,2,69,8,4,20]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(h,S,d){return m({path:h,isDirectory:!1},S,d)}e.watchFile=i;function I(h,S,d){return m({path:h,isDirectory:!0},S,d)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function m(h,S,d){if(w.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return d(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const v=(0,C.basename)(h.path),y=new Map;let g=!1,l=[(0,k.toDisposable)(()=>{y.forEach(c=>(0,k.dispose)(c)),y.clear()})];try{const c=(0,R.watch)(h.path);l.push((0,k.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const n=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(s=>s.forEach(r=>n.add(r))),c.on("error",(s,r)=>{g||d(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${r})`)}),c.on("change",(s,r)=>{if(g)return;let t="";if(r&&(t=r.toString(),w.isMacintosh&&(t=(0,T.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const a=h.isDirectory?(0,C.join)(h.path,t):h.path;if(h.isDirectory)if(s==="rename"){const o=y.get(a);o&&(0,k.dispose)(o);const u=setTimeout(async()=>{y.delete(a);const f=await b.Promises.exists(a);if(g)return;let p;f?n.has(t)?p="changed":(p="added",n.add(t)):(n.delete(t),p="deleted"),S(p,a)},e.CHANGE_BUFFER_DELAY);y.set(a,(0,k.toDisposable)(()=>clearTimeout(u)))}else{let o;n.has(t)?o="changed":(o="added",n.add(t)),S(o,a)}else if(s==="rename"||t!==v){const o=setTimeout(async()=>{const u=await b.Promises.exists(a);g||(u?(S("changed",a),l=[m(h,S,d)]):S("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(l),l=[(0,k.toDisposable)(()=>clearTimeout(o))]}else S("changed",a)})}catch(c){b.Promises.exists(h.path).then(n=>{n&&!g&&d(`Failed to watch ${h.path} for changes using fs.watch() (${c.toString()})`)})}return(0,k.toDisposable)(()=>{g=!0,l=(0,k.dispose)(l)})}async function E(h,S,d,v=512){const y=await b.Promises.open(h,"r"),g=Buffer.allocUnsafe(v),l=new L.CancellationTokenSource(d);let c,n=!1;const s=i(h,async r=>{if(r==="changed"){if(n)return;n=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:t}=await b.Promises.read(y,g,0,v,null);if(!t||l.token.isCancellationRequested)break;S(g.slice(0,t))}}catch(t){c=new Error(t),l.dispose(!0)}finally{n=!1}}},r=>{c=new Error(r),l.dispose(!0)});return new Promise((r,t)=>{l.token.onCancellationRequested(async()=>{s.dispose(),await b.Promises.close(y),c?t(c):r()})})}e.watchFileContents=E});var he=this&&this.__decorate||function(J,e,R,L){var D=arguments.length,k=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,R):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,R,L);else for(var C=J.length-1;C>=0;C--)(T=J[C])&&(k=(D<3?T(k):D>3?T(e,R,k):T(e,R))||k);return D>3&&k&&Object.defineProperty(e,R,k),k};define(te[32],ne([0,1,17,5,19,27,67,7,3,2,106,25,18]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function d(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(v||(v={}));class y{constructor(z){this.buffer=z,this.pos=0}read(z){const Y=this.buffer.slice(this.pos,this.pos+z);return this.pos+=Y.byteLength,Y}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var l;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(l||(l={}));function c(x){const z=D.VSBuffer.alloc(4);return z.writeUInt32BE(x,0),z}function n(x){return x.read(4).readUInt32BE(0)}function s(x){const z=D.VSBuffer.alloc(1);return z.writeUInt8(x,0),z}const r={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object)},t=typeof Buffer!="undefined";function a(x,z){if(typeof z=="undefined")x.write(r.Undefined);else if(typeof z=="string"){const Y=D.VSBuffer.fromString(z);x.write(r.String),x.write(c(Y.byteLength)),x.write(Y)}else if(t&&Buffer.isBuffer(z)){const Y=D.VSBuffer.wrap(z);x.write(r.Buffer),x.write(c(Y.byteLength)),x.write(Y)}else if(z instanceof D.VSBuffer)x.write(r.VSBuffer),x.write(c(z.byteLength)),x.write(z);else if(Array.isArray(z)){x.write(r.Array),x.write(c(z.length));for(const Y of z)a(x,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(z));x.write(r.Object),x.write(c(Y.byteLength)),x.write(Y)}}function o(x){switch(x.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return x.read(n(x)).toString();case l.Buffer:return x.read(n(x)).buffer;case l.VSBuffer:return x.read(n(x));case l.Array:{const Y=n(x),U=[];for(let B=0;B<Y;B++)U.push(o(x));return U}case l.Object:return JSON.parse(x.read(n(x)).toString())}}class u{constructor(z,Y,U=null,B=1e3){this.protocol=z,this.ctx=Y,this.logger=U,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(z,Y){this.channels.set(z,Y),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const Y=this.send([z.type]);this.logger&&this.logger.logOutgoing(Y,0,1,d(z.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(Y,z.id,1,d(z.type),z.data);return}}}send(z,Y=void 0){const U=new g;return a(U,z),a(U,Y),this.sendBuffer(U.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(Y){return 0}}onRawMessage(z){const Y=new y(z),U=o(Y),B=o(Y),W=U[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(W)}: ${U[2]}.${U[3]}`,B),this.onPromise({type:W,id:U[1],channelName:U[2],name:U[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(W)}: ${U[2]}.${U[3]}`,B),this.onEventListen({type:W,id:U[1],channelName:U[2],name:U[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:U[1]})}}onPromise(z){const Y=this.channels.get(z.channelName);if(!Y){this.collectPendingRequest(z);return}const U=new k.CancellationTokenSource;let B;try{B=Y.call(this.ctx,z.name,z.arg,U.token)}catch(Z){B=Promise.reject(Z)}const W=z.id;B.then(Z=>{this.sendResponse({id:W,data:Z,type:201}),this.activeRequests.delete(z.id)},Z=>{Z instanceof Error?this.sendResponse({id:W,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:W,data:Z,type:203}),this.activeRequests.delete(z.id)});const Q=(0,b.toDisposable)(()=>U.cancel());this.activeRequests.set(z.id,Q)}onEventListen(z){const Y=this.channels.get(z.channelName);if(!Y){this.collectPendingRequest(z);return}const U=z.id,W=Y.listen(this.ctx,z.name,z.arg)(Q=>this.sendResponse({id:U,data:Q,type:204}));this.activeRequests.set(z.id,W)}disposeActiveRequest(z){const Y=this.activeRequests.get(z.id);Y&&(Y.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let Y=this.pendingRequests.get(z.channelName);Y||(Y=[],this.pendingRequests.set(z.channelName,Y));const U=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:z,timeoutTimer:U})}flushPendingRequests(z){const Y=this.pendingRequests.get(z);if(Y){for(const U of Y)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var f;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(z,Y=null){this.protocol=z,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=Y}getChannel(z){const Y=this;return{call(U,B,W){return Y.isDisposed?Promise.reject(C.canceled()):Y.requestPromise(z,U,B,W)},listen(U,B){return Y.isDisposed?Promise.reject(C.canceled()):Y.requestEvent(z,U,B)}}}requestPromise(z,Y,U,B=k.CancellationToken.None){const W=this.lastRequestId++,Z={id:W,type:100,channelName:z,name:Y,arg:U};if(B.isCancellationRequested)return Promise.reject(C.canceled());let G;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(C.canceled());const ce=()=>{const be=Ce=>{switch(Ce.type){case 201:this.handlers.delete(W),re(Ce.data);break;case 202:this.handlers.delete(W);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,ie(Ee);break;case 203:this.handlers.delete(W),ie(Ce.data);break}};this.handlers.set(W,be),this.sendRequest(Z)};let le=null;this.state===v.Idle?ce():(le=(0,L.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:W,type:101}),ie(C.canceled())},fe=B.onCancellationRequested(de);G=(0,b.combinedDisposable)((0,b.toDisposable)(de),fe),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(z,Y,U){const B=this.lastRequestId++,Q={id:B,type:102,channelName:z,name:Y,arg:U};let Z=null;const G=new w.Emitter({onFirstListenerAdd:()=>{Z=(0,L.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(G),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(G),this.sendRequest({id:B,type:103}))}}),V=re=>G.fire(re.data);return this.handlers.set(B,V),G.event}sendRequest(z){switch(z.type){case 100:case 102:{const Y=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(Y,z.id,0,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const Y=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(Y,z.id,0,h(z.type));return}}}send(z,Y=void 0){const U=new g;return a(U,z),a(U,Y),this.sendBuffer(U.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(Y){return 0}}onBuffer(z){const Y=new y(z),U=o(Y),B=o(Y),W=U[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,d(W)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,U[1],0,d(W),B),this.onResponse({type:U[0],id:U[1],data:B})}}onResponse(z){if(z.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(z.id);Y&&Y(z)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}he([T.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class A{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:Y,onDidClientDisconnect:U})=>{w.Event.once(Y.onMessage)(W=>{const Q=new y(W),Z=o(Q),G=new u(Y,Z),V=new p(Y);this.channels.forEach((ie,ce)=>G.registerChannel(ce,ie));const re={channelServer:G,channelClient:V,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),U(()=>{G.dispose(),V.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const z=[];return this._connections.forEach(Y=>z.push(Y)),z}getChannel(z,Y){const U=this;return{call(B,W,Q){let Z;if((0,m.isFunction)(Y)){let V=(0,R.getRandomElement)(U.connections.filter(Y));Z=V?Promise.resolve(V):w.Event.toPromise(w.Event.filter(U.onDidAddConnection,Y))}else Z=Y.routeCall(U,B,W);const G=Z.then(V=>V.channelClient.getChannel(z));return M(G).call(B,W,Q)},listen(B,W){if((0,m.isFunction)(Y))return U.getMulticastEvent(z,Y,B,W);const Q=Y.routeEvent(U,B,W).then(Z=>Z.channelClient.getChannel(z));return M(Q).listen(B,W)}}}getMulticastEvent(z,Y,U,B){const W=this;let Q=new b.DisposableStore;const Z=new w.Emitter({onFirstListenerAdd:()=>{Q=new b.DisposableStore;const G=new w.EventMultiplexer,V=new Map,re=ce=>{const de=ce.channelClient.getChannel(z).listen(U,B),fe=G.add(de);V.set(ce,fe)},ie=ce=>{const le=V.get(ce);!le||(le.dispose(),V.delete(ce))};W.connections.filter(Y).forEach(re),w.Event.filter(W.onDidAddConnection,Y)(re,void 0,Q),W.onDidRemoveConnection(ie,void 0,Q),G.event(Z.fire,Z,Q),Q.add(G)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel(z,Y){this.channels.set(z,Y),this._connections.forEach(U=>{U.channelServer.registerChannel(z,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(z,Y,U=null){const B=new g;a(B,Y),z.send(B.buffer),this.channelClient=new p(z,U),this.channelServer=new u(z,Y,U)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,Y){this.channelServer.registerChannel(z,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function M(x){return{call(z,Y,U){return x.then(B=>B.call(z,Y,U))},listen(z,Y){const U=new w.Relay;return x.then(B=>U.input=B.listen(z,Y)),U.event}}}e.getDelayedChannel=M;function N(x){let z=!1;return{call(Y,U,B){return z?x.call(Y,U,B):(0,L.timeout)(0).then(()=>z=!0).then(()=>x.call(Y,U,B))},listen(Y,U){if(z)return x.listen(Y,U);const B=new w.Relay;return(0,L.timeout)(0).then(()=>z=!0).then(()=>B.input=x.listen(Y,U)),B.event}}}e.getNextTickChannel=N;class P{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const Y of z.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await w.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=P;var F;(function(x){function z(W,Q){const Z=W,G=Q&&Q.disableMarshalling,V=new Map;for(const re in Z)U(re)&&V.set(re,w.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=V.get(ie);if(le)return le;if(B(ie)){const de=Z[ie];if(typeof de=="function")return de.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!G&&Array.isArray(ce))for(let de=0;de<ce.length;de++)ce[de]=(0,i.revive)(ce[de]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=z;function Y(W,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(G,V){if(typeof V=="string")return Q?.properties?.has(V)?Q.properties.get(V):B(V)?function(re){return W.listen(V,re)}:U(V)?W.listen(V):async function(...re){let ie;Q&&!(0,m.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await W.call(V,ie);return Z?ce:(0,i.revive)(ce)};throw new Error(`Property not found: ${String(V)}`)}})}x.toService=Y;function U(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}function B(W){return/^onDynamic/.test(W)&&I.isUpperAsciiLetter(W.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let z=x.toString();if(z!=="[object Object]")return z}return x}function $(x){return Array.isArray(x)?x.map(_):_(x)}function H(x,z,Y,U,B,W,Q){Q=$(Q);const Z=q[B],G=Z[U%Z.length];let V=[`%c[${x}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(W)?(V=V.concat(Q),V.push(")")):V.push(Q),console.log.apply(console,V)}e.logWithColors=H;class j{constructor(z,Y){this._outgoingPrefix=z,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,Y,U,B,W){this._totalOutgoing+=z,H(this._outgoingPrefix,this._totalOutgoing,z,Y,U,B,W)}logIncoming(z,Y,U,B,W){this._totalIncoming+=z,H(this._incomingPrefix,this._totalIncoming,z,Y,U,B,W)}}e.IPCLogger=j}),define(te[118],ne([0,1,19,3,32]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(w){this.port=w,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",b=>R.VSBuffer.wrap(b.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class T extends D.IPCClient{constructor(w,b){const i=new k(w);super(i,b);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=T}),define(te[71],ne([0,1,19,3,2,4,31,32]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function i(){return b||(b=R.VSBuffer.alloc(0)),b}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,a){if(t===0)return i();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const p=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=t),p}if(this._chunks[0].byteLength>t){const p=this._chunks[0].slice(0,t);return a&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),p}let o=R.VSBuffer.alloc(t),u=0,f=0;for(;t>0;){const p=this._chunks[f];if(p.byteLength>t){const A=p.slice(0,t);o.set(A,u),u+=t,a&&(this._chunks[f]=p.slice(t),this._totalLength-=t),t-=t}else o.set(p,u),u+=p.byteLength,a?(this._chunks.shift(),this._totalLength-=p.byteLength):f++,t-=p.byteLength}return o}}e.ChunkStream=I;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(m||(m={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,a,o,u){this.type=t,this.id=a,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends D.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const o=this._state.messageType,u=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(o,u,f,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=R.VSBuffer.alloc(13);a.writeUInt8(t.type,0),a.writeUInt32BE(t.id,1),a.writeUInt32BE(t.ack,5),a.writeUInt32BE(t.data.byteLength,9),this._writeSoon(a,t.data)}_bufferAdd(t,a){const o=this._totalLength===0;return this._data.push(t,a),this._totalLength+=t.byteLength+a.byteLength,o}_bufferTake(){const t=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,a){this._bufferAdd(t,a)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends D.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new S(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=v;class y extends C.IPCClient{constructor(t,a,o=null){super(t,a,o);this.protocol=t}static fromSocket(t,a){return new y(new v(t),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=y;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,T.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class l{constructor(t){this.data=t,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],a=0,o=this._first;for(;o;)t[a++]=o.data,o=o.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const a=new l(t);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class n{constructor(){this.lastRuns=[];const t=Date.now();for(let a=0;a<n._HISTORY_LENGTH;a++)this.lastRuns[a]=t-1e3*a;setInterval(()=>{for(let a=n._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const t=Date.now(),a=(1+n._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<n._HISTORY_LENGTH;u++)t-this.lastRuns[u]<=a&&o++;return 1-o/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class s{constructor(t,a=null,o=n.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,i());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const a=new h(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let a=0,o=t.length;a<o;a++)this._socketWriter.write(t[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new h(1,a,this._incomingAckId,t);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(t){const a=new h(2,0,0,t);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),a=Date.now()-t.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,i());this._socketWriter.write(t)}}e.PersistentProtocol=s}),define(te[119],ne([0,1,72,3,32,118]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends D.IPCServer{static getOnDidClientConnect(){const w=L.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(b,i)=>i);return L.Event.map(w,b=>{const{port1:i,port2:I}=new MessageChannel,E={protocol:new k.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[I]),E})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(te[120],ne([0,1,19,7]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(C,w){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((i,I)=>{b.open(C.type||"GET",C.url||"",!0,C.user,C.password),k(b,C),b.responseType="arraybuffer",b.onerror=m=>I(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=m=>{i({res:{statusCode:b.status,headers:T(b)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=m=>I(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(b.timeout=C.timeout),b.send(C.data),w.onCancellationRequested(()=>{b.abort(),I((0,L.canceled)())})})}e.request=D;function k(C,w){if(w.headers){e:for(let b in w.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(b,w.headers[b])}}}function T(C){const w=Object.create(null);for(const b of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const i=b.indexOf(":");w[b.substr(0,i).trim().toLowerCase()]=b.substr(i+1).trim()}return w}}),define(te[73],ne([0,1,5,3,2,18]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function C(I){const m=I;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var w;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(w||(w={}));class b extends D.Disposable{constructor(m,E=Object.create(null)){super();this.database=m,this.options=E,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((E,h)=>this.accept(h,E)),m.deleted?.forEach(E=>this.accept(E,void 0))}accept(m,E){if(this.state===w.Closed)return;let h=!1;(0,k.isUndefinedOrNull)(E)?h=this.cache.delete(m):this.cache.get(m)!==E&&(this.cache.set(m,E),h=!0),h&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,E){const h=this.cache.get(m);return(0,k.isUndefinedOrNull)(h)?E:h}getBoolean(m,E){const h=this.get(m);return(0,k.isUndefinedOrNull)(h)?E:h==="true"}getNumber(m,E){const h=this.get(m);return(0,k.isUndefinedOrNull)(h)?E:parseInt(h,10)}async set(m,E){if(this.state===w.Closed)return;if((0,k.isUndefinedOrNull)(E))return this.delete(m);const h=String(E);if(this.cache.get(m)!==h)return this.cache.set(m,h),this.pendingInserts.set(m,h),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===w.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((E,h)=>this.items.set(h,E)),m.delete&&m.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(te[121],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[57],ne([0,1,121]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,k=D*24,T=k*7,C=k*30,w=k*365;function b(I,m){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,R.localize)(0,null,b(new Date().getTime()+E*1e3,!1));if(E<30)return(0,R.localize)(1,null);let h;return E<L?(h=E,m?h===1?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):h===1?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h)):E<D?(h=Math.floor(E/L),m?h===1?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):h===1?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):E<k?(h=Math.floor(E/D),m?h===1?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):h===1?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h)):E<T?(h=Math.floor(E/k),m?h===1?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):h===1?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):E<C?(h=Math.floor(E/T),m?h===1?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):h===1?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h)):E<w?(h=Math.floor(E/C),m?h===1?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):h===1?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):(h=Math.floor(E/w),m?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h))}e.fromNow=b;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,17,18,122]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(b,i){return i&&(b.stack||b.stacktrace)?D.localize(0,null,C(b),T(b.stack)||T(b.stacktrace)):C(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function C(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function w(b=null,i=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const I=R.coalesce(b),m=w(I[0],i);return I.length>1?D.localize(4,null,m,I.length):m}if(L.isString(b))return b;if(b.detail){const I=b.detail;if(I.error)return k(I.error,i);if(I.exception)return k(I.exception,i)}return b.stack?k(b,i):b.message?b.message:D.localize(5,null)}e.toErrorMessage=w}),define(te[123],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,42,41,15,26,8,4,31,102,18,110,20,123]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(n,s){if(C.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const t=R.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],r);return new Promise(a=>{t.once("error",o=>{a({success:!1,error:o})}),t.once("exit",(o,u)=>{a(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(C.isLinux||C.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{R.execFile(r,[n.pid.toString()],{encoding:"utf8",shell:!0},(a,o,u)=>{t(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function d(n){!n||(delete n.DEBUG,C.isMacintosh&&delete n.DYLD_LIBRARY_PATH,C.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=d;function v(n=w.env){return n.comspec||"cmd.exe"}e.getWindowsShell=v;class y{constructor(s,r,t,a){if(r!==void 0&&t!==void 0&&a!==void 0)this.cmd=s,this.args=r,this.shell=t,this.options=a;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(w.env).forEach(u=>{o[u]=w.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(T.sep);return r!==-1&&(s=s.substring(r+1)),y.WellKnowCommands[s]?s:"other"}start(s){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(w.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(r=>{let t,a;const o=new Promise((u,f)=>{t=u,a=f});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=R.exec(u,this.options,(f,p,A)=>{this.childProcess=null;const O=f;O&&O.killed?a({killed:this.terminateRequested,stdout:p.toString(),stderr:A.toString()}):this.handleExec(t,s,f,p,A)})}else{let u=null;const f=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,s,a);const A={terminated:this.terminateRequested};i.isNumber(p)&&(A.cmdCode=p),t(A)};if(this.shell&&C.isWindows){const p=k.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let A=!1,O=!1;const M=[];let N=this.ensureQuotes(this.cmd);M.push(N.value),A=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),M.push(N.value),O=O&&N.quoted});const P=["/s","/c"];A?O?P.push('"'+M.join(" ")+'"'):M.length>1?P.push('"'+M[0]+'" '+M.slice(1).join(" ")):P.push('"'+M[0]+'"'):P.push(M.join(" ")),u=R.spawn(v(),P,p)}else this.cmd&&(u=R.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(i.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",p=>{this.childProcess=null,a({terminated:this.terminateRequested,error:p})}),u.pid&&(this.childProcess.on("close",f),this.handleSpawn(u,t,s,a,!0)))}return o})}handleClose(s,r,t,a){}ensureQuotes(s){return y.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,S(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!C.isWindows)return s(!1);const r=R.spawn(v(),["/s","/c"]);r.on("error",t=>s(!0)),r.on("exit",t=>s(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class g extends y{constructor(s,r,t,a){super(s,r,t,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,t,a,o){[a,o].forEach((u,f)=>{const p=new I.LineDecoder;p.write(u).forEach(M=>{r({line:M,source:f===0?0:1})});const O=p.end();O&&r({line:O,source:f===0?0:1})}),s({terminated:this.terminateRequested,error:t})}handleSpawn(s,r,t,a,o){const u=new I.LineDecoder,f=new I.LineDecoder;s.stdout.on("data",p=>{u.write(p).forEach(O=>t({line:O,source:0}))}),s.stderr.on("data",p=>{f.write(p).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=f}handleClose(s,r,t,a){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=g;function l(n){let s=[],r=!1;const t=function(a){if(r){s.push(a);return}(!n.send(a,u=>{if(u&&console.error(u),r=!1,s.length>0){const f=s.slice(0);s=[],f.forEach(p=>t(p))}})||C.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=l;var c;(function(n){async function s(r,t,a){if(T.isAbsolute(r))return r;if(t===void 0&&(t=w.cwd()),T.dirname(r)!=="."||(a===void 0&&i.isString(w.env.PATH)&&(a=w.env.PATH.split(T.delimiter)),a===void 0||a.length===0))return T.join(t,r);async function u(f){if(await m.Promises.exists(f)){let p;try{p=await m.Promises.stat(f)}catch(A){A.message.startsWith("EACCES")&&(p=await m.Promises.lstat(f))}return p?!p.isDirectory():!1}return!1}for(let f of a){let p;if(T.isAbsolute(f)?p=T.join(f,r):p=T.join(t,f,r),await u(p))return p;let A=p+".com";if(await u(A)||(A=p+".exe",await u(A)))return A}return T.join(t,r)}n.findExecutable=s})(c=e.win32||(e.win32={}))}),define(te[124],ne([0,1,34,4,70,74]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(E,h){return E===1?L.isWindows?I():k.getWindowsShell(h):b(E,h)}e.getSystemShell=T;function C(E,h){return E===1?L.isWindows?m(h):k.getWindowsShell(h):b(E,h)}e.getSystemShellSync=C;let w=null;function b(E,h){if(L.isLinux&&E===2||L.isMacintosh&&E===3)return"/bin/bash";if(!w){let S;if(L.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,R.userInfo)().shell}catch(d){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}w=S}return w}let i=null;async function I(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function m(E){if(i)return i;const h=L.isWindows&&parseFloat((0,R.release)())>=10,S=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${E.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?d:k.getWindowsShell(E)}}),define(te[44],ne([0,1,42,5,19,27,105,7,3,2,26,74,32]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends m.ChannelServer{constructor(d){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(y){}},onMessage:w.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=E;class h{constructor(d,v){this.modulePath=d,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new L.Delayer(y),this.child=null,this._client=null}getChannel(d){const v=this;return{call(y,g,l){return v.requestPromise(d,y,g,l)},listen(y,g){return v.requestEvent(d,y,g)}}}requestPromise(d,v,y,g=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(d),c=(0,L.createCancelablePromise)(r=>l.call(v,y,r)),n=g.onCancellationRequested(()=>c.cancel()),s=(0,b.toDisposable)(()=>c.cancel());return this.activeRequests.add(s),c.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(d,v,y){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let g;const l=new w.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(d).listen(v,y)(l.fire,l),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,I.removeDangerousEnvVariables)(v.env),this.child=(0,R.fork)(this.modulePath,d,v);const y=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}y.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const l=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,c=t=>this.child&&this.child.connected&&l.send(t.buffer.toString("base64")),n=y.event,s={send:c,onMessage:n};this._client=new m.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),t!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:a})})}return this._client}getCachedChannel(d){let v=this.channels.get(d);return v||(v=this.client.getChannel(d),this.channels.set(d,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,57,67,15,8,31,16,9]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,d,v){this._args=S,this.paths=d,this.productService=v}get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(w.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=T.env.VSCODE_PORTABLE;return S?w.URI.file((0,k.join)(S,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,k.resolve)(S):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,k.resolve)(S):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,k.resolve)(S);const d=T.env.VSCODE_EXTENSIONS;if(d)return d;const v=T.env.VSCODE_PORTABLE;return v?(0,k.join)(v,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(d=>/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,k.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?w.URI.parse(S):w.URI.file((0,k.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],b.prototype,"appRoot",null),he([L.memoize],b.prototype,"userHome",null),he([L.memoize],b.prototype,"userDataPath",null),he([L.memoize],b.prototype,"appSettingsHome",null),he([L.memoize],b.prototype,"tmpDir",null),he([L.memoize],b.prototype,"userRoamingDataHome",null),he([L.memoize],b.prototype,"settingsResource",null),he([L.memoize],b.prototype,"userDataSyncHome",null),he([L.memoize],b.prototype,"userDataSyncLogResource",null),he([L.memoize],b.prototype,"sync",null),he([L.memoize],b.prototype,"machineSettingsResource",null),he([L.memoize],b.prototype,"globalStorageHome",null),he([L.memoize],b.prototype,"workspaceStorageHome",null),he([L.memoize],b.prototype,"keybindingsResource",null),he([L.memoize],b.prototype,"keyboardLayoutResource",null),he([L.memoize],b.prototype,"argvResource",null),he([L.memoize],b.prototype,"snippetsHome",null),he([L.memoize],b.prototype,"isExtensionDevelopment",null),he([L.memoize],b.prototype,"untitledWorkspacesHome",null),he([L.memoize],b.prototype,"installSourcePath",null),he([L.memoize],b.prototype,"builtinExtensionsPath",null),he([L.memoize],b.prototype,"extensionsPath",null),he([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],b.prototype,"extensionDevelopmentKind",null),he([L.memoize],b.prototype,"extensionTestsLocationURI",null),he([L.memoize],b.prototype,"debugExtensionHost",null),he([L.memoize],b.prototype,"serviceMachineIdResource",null),he([L.memoize],b.prototype,"telemetryLogResource",null),he([L.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function i(h,S){return E(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=i;function I(h,S){return E(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=I;function m(h,S){return E(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=m;function E(h,S,d,v,y,g){const c=Number(S||h)||(v?null:d),n=c?Boolean(!!S):!1;let s;if(g)try{s=JSON.parse(g)}catch{}return{port:c,break:n,debugId:y,env:s}}}),define(te[150],ne([0,1,242,4,127]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(h,S,d=T){const v={},y=[],g=[];for(let s in S){const r=S[s];r.alias&&(v[s]=r.alias),r.type==="string"||r.type==="string[]"?(y.push(s),r.deprecates&&y.push(r.deprecates)):r.type==="boolean"&&(g.push(s),r.deprecates&&g.push(r.deprecates))}const l=R(h,{string:y,boolean:g,alias:v}),c={},n=l;c._=l._.map(s=>String(s)).filter(s=>s.length>0),delete n._;for(let s in S){const r=S[s];r.alias&&delete n[r.alias];let t=n[s];r.deprecates&&n.hasOwnProperty(r.deprecates)&&(t||(t=n[r.deprecates]),delete n[r.deprecates]),typeof t!="undefined"&&(r.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):r.type==="string"&&Array.isArray(t)&&(t=t.pop(),d.onMultipleValues(s,t)),c[s]=t),delete n[s]}for(let s in n)d.onUnknownOption(s);return c}e.parseArgs=C;function w(h,S){let d="";return S.args&&(Array.isArray(S.args)?d=` <${S.args.join("> <")}>`:d=` <${S.args}>`),S.alias?`-${S.alias} --${h}${d}`:`--${h}${d}`}function b(h,S){let d=0,v=[];for(const c in h){const n=h[c],s=w(c,n);d=Math.max(d,s.length),v.push([s,n.description])}let y=d+2+1;if(S-y<25)return v.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let g=S-y-1,l=[];for(const c of v){let n=c[0],s=I(c[1],g),r=i(y-n.length-2);l.push("  "+n+r+s[0]);for(let t=1;t<s.length;t++)l.push(i(y)+s[t])}return l}e.formatOptions=b;function i(h){return" ".repeat(h)}function I(h,S){let d=[];for(;h.length;){let v=h.length<S?h.length:h.lastIndexOf(" ",S),y=h.slice(0,v).trim();h=h.slice(v),d.push(y)}return d}function m(h,S,d,v,y=!0){const g=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${h} ${d}`];l.push(""),l.push(`${(0,D.localize)(32,null)}: ${S} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),l.push(""),y&&(L.isWindows?l.push((0,D.localize)(35,null,S)):l.push((0,D.localize)(36,null,S)),l.push(""));const c={};for(const n in v){const s=v[n];if(s.description&&s.cat){let r=c[s.cat];r||(c[s.cat]=r={}),r[n]=s}}for(let n in c){const s=n;let r=c[s];r&&(l.push(k[s]),l.push(...b(r,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=m;function E(h,S){return`${h||(0,D.localize)(37,null)}
${S||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=E}),function(){"use strict";function J(e,R,L,D){function k(C){const w=T(C),b=[w];return e.isAbsolute(w)||b.unshift(D),e.resolve(...b)}function T(C){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,L);const i=C["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(R.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,L)}return{getUserDataPath:k}}if(typeof define=="function")define(te[151],ne([0,243,34,15,16,31]),function(e,R,L,D,k,T){const C=k.dirname(D.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(k.joinPath(C,"package.json").fsPath);return J(R,L,w.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),L=require("os");module.exports=J(R,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[152],ne([0,1,34,75,151]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(C,w){super(C,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(C)},w)}}e.NativeEnvironmentService=k}),define(te[153],ne([0,1,9]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,C=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(d){const v=d.match(T);return v?v[1]:null}function i(d){if(d.indexOf("://")===-1){const v=d.match(L);return v?b(v[2]):null}try{const v=R.URI.parse(d);if(v.authority)return b(v.authority)}catch(v){}return null}function I(d,v){const y=new Set;let g;for(;g=C.exec(d);){const c=i(g[1]);c&&y.add(c)}const l=new Set(v);return Array.from(y).map(c=>l.has(c)?c:c.replace(w,"a"))}e.getDomainsOfRemotes=I;function m(d){const v=d.match(k);return v?v[2]:null}function E(d,v,y){return d&&v?(y&&v.endsWith(".git")&&(v=v.substr(0,v.length-4)),v.indexOf("/")===0?`${d}${v}`:`${d}/${v}`):null}function h(d,v){if(d.indexOf("://")===-1){const y=d.match(D);if(y)return E(y[2],y[3],v)}try{const y=R.URI.parse(d);if(y.authority)return E(m(y.authority),y.path,v)}catch(y){}return null}function S(d,v=!1){const y=[];let g;for(;g=C.exec(d);){const l=h(g[1],v);l&&y.push(l)}return y}e.getRemotes=S}),define(te[154],ne([0,1,26]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function D(k,T){const C=w=>{if(typeof w!="string")return;const b=L.exec(w);if(!b)return;const i=T[b[1]]??w;return typeof i=="string"?i:typeof i.message=="string"?i.message:w};return(0,R.cloneAndChange)(k,C)}e.localizeManifest=D}),define(te[155],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,T,C,w){return this.channel.call("promptImportantExtensionsInstallNotification",[k,T,C,w])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class L{constructor(k){this.service=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,C){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(C[0],C[1],C[2],C[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[76],ne([0,1,136]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||L.test(m)}e.isValidVersionStr=k;function T(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=m.match(L);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=T;function C(m){if(!m)return null;let E=m.majorBase,h=m.majorMustEqual,S=m.minorBase,d=m.minorMustEqual,v=m.patchBase,y=m.patchMustEqual;m.hasCaret&&(E===0||(d=!1),y=!1);let g=0;if(m.preRelease){const l=D.exec(m.preRelease);if(l){const[,c,n,s]=l;g=Date.UTC(Number(c),Number(n)-1,Number(s))}}return{majorBase:E,majorMustEqual:h,minorBase:S,minorMustEqual:d,patchBase:v,patchMustEqual:y,isMinimum:m.hasGreaterEquals,notBefore:g}}e.normalizeVersion=C;function w(m,E,h){let S;typeof m=="string"?S=C(T(m)):S=m;let d;E instanceof Date?d=E.getTime():typeof E=="string"&&(d=new Date(E).getTime());let v;if(typeof h=="string"?v=C(T(h)):v=h,!S||!v)return!1;let y=S.majorBase,g=S.minorBase,l=S.patchBase,c=v.majorBase,n=v.minorBase,s=v.patchBase,r=v.notBefore,t=v.majorMustEqual,a=v.minorMustEqual,o=v.patchMustEqual;return v.isMinimum?y>c?!0:y<c?!1:g>n?!0:g<n||d&&d<r?!1:l>=s:(y===1&&c===0&&(!t||!a||!o)&&(c=1,n=0,s=0,t=!0,a=!1,o=!1),y<c?!1:y>c?!t:g<n?!1:g>n?!a:l<s?!1:l>s?!o:!(d&&d<r))}e.isValidVersion=w;function b(m,E,h,S){return h.isBuiltin||typeof h.main=="undefined"?!0:I(m,E,h.engines.vscode,S)}e.isValidExtensionVersion=b;function i(m,E,h){return m==="*"||I(E,h,m)}e.isEngineValid=i;function I(m,E,h,S=[]){let d=C(T(h));if(!d)return S.push(R.localize(0,null,h)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return S.push(R.localize(1,null,h)),!1}else if(!d.majorMustEqual)return S.push(R.localize(2,null,h)),!1;return w(m,E,d)?!0:(S.push(R.localize(3,null,m,h)),!1)}}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,k=[],T=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=R}),define(te[77],ne([0,1,53]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(T,C,w){C instanceof R.SyncDescriptor||(C=new R.SyncDescriptor(C,[],w)),L.push([T,C])}e.registerSingleton=D;function k(){return L}e.getSingletonServiceDescriptors=k}),define(te[156],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=R;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let T of this._nodes.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const C=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(T);C.outgoing.set(this._hashFn(T),w),w.incoming.set(this._hashFn(k),C)}removeNode(k){const T=this._hashFn(k);this._nodes.delete(T);for(let C of this._nodes.values())C.outgoing.delete(T),C.incoming.delete(T)}lookupOrInsertNode(k){const T=this._hashFn(k);let C=this._nodes.get(T);return C||(C=new R(k),this._nodes.set(T,C)),C}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[T,C]of this._nodes)k.push(`${T}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,T]of this._nodes){const C=new Set([k]),w=this._findCycle(T,C);if(w)return w}}_findCycle(k,T){for(let[C,w]of k.outgoing){if(T.has(C))return[...T,C].join(" -> ");T.add(C);const b=this._findCycle(w,T);if(b)return b;T.delete(C)}}}e.Graph=L}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function w(b){return b[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=w})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(C,w,b,i){w[R.DI_TARGET]===w?w[R.DI_DEPENDENCIES].push({id:C,index:b,optional:i}):(w[R.DI_DEPENDENCIES]=[{id:C,index:b,optional:i}],w[R.DI_TARGET]=w)}function D(C){if(R.serviceIds.has(C))return R.serviceIds.get(C);const w=function(b,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,b,I,!1)};return w.toString=()=>C,R.serviceIds.set(C,w),w}e.createDecorator=D;function k(C){return C}e.refineServiceDecorator=k;function T(C){return function(w,b,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,w,i,!0)}}e.optional=T}),define(te[157],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(te[158],ne([0,1,4,25,6]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=R.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",R.isMacintosh),T.set("isLinux",R.isLinux),T.set("isWindows",R.isWindows),T.set("isWeb",R.isWeb),T.set("isMacNative",R.isMacintosh&&!R.isWeb),T.set("isEdge",k.indexOf("Edg/")>=0),T.set("isFirefox",k.indexOf("Firefox")>=0),T.set("isChrome",k.indexOf("Chrome")>=0),T.set("isSafari",k.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var w;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return m.INSTANCE}static true(){return E.INSTANCE}static has(P){return h.create(P)}static equals(P,F){return S.create(P,F)}static notEquals(P,F){return y.create(P,F)}static regex(P,F){return r.create(P,F)}static in(P,F){return d.create(P,F)}static not(P){return g.create(P)}static and(...P){return o.create(P,null)}static or(...P){return u.create(P,null,!0)}static greater(P,F){return l.create(P,F)}static less(P,F){return n.create(P,F)}static deserialize(P,F=!1){if(!!P)return this._deserializeOrExpression(P,F)}static _deserializeOrExpression(P,F){let q=P.split("||");return u.create(q.map(_=>this._deserializeAndExpression(_,F)),null,!0)}static _deserializeAndExpression(P,F){let q=P.split("&&");return o.create(q.map(_=>this._deserializeOne(_,F)),null)}static _deserializeOne(P,F){if(P=P.trim(),P.indexOf("!=")>=0){let q=P.split("!=");return y.create(q[0].trim(),this._deserializeValue(q[1],F))}if(P.indexOf("==")>=0){let q=P.split("==");return S.create(q[0].trim(),this._deserializeValue(q[1],F))}if(P.indexOf("=~")>=0){let q=P.split("=~");return r.create(q[0].trim(),this._deserializeRegexValue(q[1],F))}if(P.indexOf(" in ")>=0){let q=P.split(" in ");return d.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const q=P.split(">=");return c.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const q=P.split(">");return l.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const q=P.split("<=");return s.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const q=P.split("<");return n.create(q[0].trim(),q[1].trim())}return/^\!\s*/.test(P)?g.create(P.substr(1).trim()):h.create(P)}static _deserializeValue(P,F){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;let q=/^'([^']*)'$/.exec(P);return q?q[1].trim():P}static _deserializeRegexValue(P,F){if((0,L.isFalsyOrWhitespace)(P)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let q=P.indexOf("/"),_=P.lastIndexOf("/");if(q===_||q<0){if(F)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}let $=P.slice(q+1,_),H=P[_+1]==="i"?"i":"";try{return new RegExp($,H)}catch(j){if(F)throw new Error(`bad regexp-value '${P}', parse error: ${j}`);return console.warn(`bad regexp-value '${P}', parse error: ${j}`),null}}}e.ContextKeyExpr=b;function i(N,P){const F=N?N.substituteConstants():void 0,q=P?P.substituteConstants():void 0;return!F&&!q?!0:!F||!q?!1:F.equals(q)}e.expressionsAreEqualWithConstantSubstitution=i;function I(N,P){return N.cmp(P)}class m{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class E{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(P,F){this.key=P,this.negated=F,this.type=2}static create(P,F=null){const q=T.get(P);return typeof q=="boolean"?q?E.INSTANCE:m.INSTANCE:new h(P,F)}cmp(P){return P.type!==this.type?this.type-P.type:p(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=T.get(this.key);return typeof P=="boolean"?P?E.INSTANCE:m.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class S{constructor(P,F,q){this.key=P,this.value=F,this.negated=q,this.type=4}static create(P,F,q=null){if(typeof F=="boolean")return F?h.create(P,q):g.create(P,q);const _=T.get(P);return typeof _=="boolean"?F===(_?"true":"false")?E.INSTANCE:m.INSTANCE:new S(P,F,q)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=T.get(this.key);if(typeof P=="boolean"){const F=P?"true":"false";return this.value===F?E.INSTANCE:m.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class d{constructor(P,F){this.key=P,this.valueKey=F,this.type=10,this.negated=null}static create(P,F){return new d(P,F)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const F=P.getValue(this.valueKey),q=P.getValue(this.key);return Array.isArray(F)?F.indexOf(q)>=0:typeof q=="string"&&typeof F=="object"&&F!==null?C.call(F,q):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=d;class v{constructor(P){this._actual=P,this.type=11}static create(P){return new v(P)}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new v(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class y{constructor(P,F,q){this.key=P,this.value=F,this.negated=q,this.type=5}static create(P,F,q=null){if(typeof F=="boolean")return F?g.create(P,q):h.create(P,q);const _=T.get(P);return typeof _=="boolean"?F===(_?"true":"false")?m.INSTANCE:E.INSTANCE:new y(P,F,q)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=T.get(this.key);if(typeof P=="boolean"){const F=P?"true":"false";return this.value===F?m.INSTANCE:E.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class g{constructor(P,F){this.key=P,this.negated=F,this.type=3}static create(P,F=null){const q=T.get(P);return typeof q=="boolean"?q?m.INSTANCE:E.INSTANCE:new g(P,F)}cmp(P){return P.type!==this.type?this.type-P.type:p(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=T.get(this.key);return typeof P=="boolean"?P?m.INSTANCE:E.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;class l{constructor(P,F,q){this.key=P,this.value=F,this.negated=q,this.type=12}static create(P,F,q=null){return new l(P,F,q)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class c{constructor(P,F,q){this.key=P,this.value=F,this.negated=q,this.type=13}static create(P,F,q=null){return new c(P,F,q)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class n{constructor(P,F,q){this.key=P,this.value=F,this.negated=q,this.type=14}static create(P,F,q=null){return new n(P,F,q)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class s{constructor(P,F,q){this.key=P,this.value=F,this.negated=q,this.type=15}static create(P,F,q=null){return new s(P,F,q)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class r{constructor(P,F){this.key=P,this.regexp=F,this.type=7,this.negated=null}static create(P,F){return new r(P,F)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const F=this.regexp?this.regexp.source:"",q=P.regexp?P.regexp.source:"";return F<q?-1:F>q?1:0}equals(P){if(P.type===this.type){const F=this.regexp?this.regexp.source:"",q=P.regexp?P.regexp.source:"";return this.key===P.key&&F===q}return!1}substituteConstants(){return this}evaluate(P){let F=P.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class t{constructor(P){this._actual=P,this.type=8}static create(P){return new t(P)}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new t(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function a(N){let P=null;for(let F=0,q=N.length;F<q;F++){const _=N[F].substituteConstants();if(N[F]!==_&&P===null){P=[];for(let $=0;$<F;$++)P[$]=N[$]}P!==null&&(P[F]=_)}return P===null?N:P}class o{constructor(P,F){this.expr=P,this.negated=F,this.type=6}static create(P,F){return o._normalizeArr(P,F)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,q=this.expr.length;F<q;F++){const _=I(this.expr[F],P.expr[F]);if(_!==0)return _}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,q=this.expr.length;F<q;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=a(this.expr);return P===this.expr?this:o.create(P,this.negated)}evaluate(P){for(let F=0,q=this.expr.length;F<q;F++)if(!this.expr[F].evaluate(P))return!1;return!0}static _normalizeArr(P,F){const q=[];let _=!1;for(const $ of P)if(!!$){if($.type===1){_=!0;continue}if($.type===0)return m.INSTANCE;if($.type===6){q.push(...$.expr);continue}q.push($)}if(q.length===0&&_)return E.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(I);for(let $=1;$<q.length;$++)q[$-1].equals(q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0];for(;q.length>1;){const $=q[q.length-1];if($.type!==9)break;q.pop();const H=q.pop(),j=q.length===0,x=u.create($.expr.map(z=>o.create([z,H],null)),null,j);x&&(q.push(x),q.sort(I))}return q.length===1?q[0]:new o(q,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(let F of this.expr)P.push(...F.keys());return P}map(P){return new o(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.negated){const P=[];for(let F of this.expr)P.push(F.negate());this.negated=u.create(P,this,!0)}return this.negated}}class u{constructor(P,F){this.expr=P,this.negated=F,this.type=9}static create(P,F,q){return u._normalizeArr(P,F,q)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,q=this.expr.length;F<q;F++){const _=I(this.expr[F],P.expr[F]);if(_!==0)return _}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,q=this.expr.length;F<q;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=a(this.expr);return P===this.expr?this:u.create(P,this.negated,!1)}evaluate(P){for(let F=0,q=this.expr.length;F<q;F++)if(this.expr[F].evaluate(P))return!0;return!1}static _normalizeArr(P,F,q){let _=[],$=!1;if(P){for(let H=0,j=P.length;H<j;H++){const x=P[H];if(!!x){if(x.type===0){$=!0;continue}if(x.type===1)return E.INSTANCE;if(x.type===9){_=_.concat(x.expr);continue}_.push(x)}}if(_.length===0&&$)return m.INSTANCE;_.sort(I)}if(_.length!==0){if(_.length===1)return _[0];for(let H=1;H<_.length;H++)_[H-1].equals(_[H])&&(_.splice(H,1),H--);if(_.length===1)return _[0];if(q){for(let H=0;H<_.length;H++)for(let j=H+1;j<_.length;j++)O(_[H],_[j])&&(_.splice(j,1),j--);if(_.length===1)return _[0]}return new u(_,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(let F of this.expr)P.push(...F.keys());return P}map(P){return new u(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.negated){let P=[];for(let F of this.expr)P.push(F.negate());for(;P.length>1;){const F=P.shift(),q=P.shift(),_=[];for(const H of M(F))for(const j of M(q))_.push(o.create([H,j],null));const $=P.length===0;P.unshift(u.create(_,null,$))}this.negated=P[0]}return this.negated}}class f extends h{constructor(P,F,q){super(P,null);this._defaultValue=F,typeof q=="object"?f._info.push({...q,key:P}):q!==!0&&f._info.push({key:P,description:q,type:F!=null?typeof F:void 0})}static all(){return f._info.values()}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return S.create(this.key,P)}notEqualsTo(P){return y.create(this.key,P)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(N,P){return N<P?-1:N>P?1:0}function A(N,P,F,q){return N<F?-1:N>F?1:P<q?-1:P>q?1:0}function O(N,P){if(P.type===6&&N.type!==9&&N.type!==6){for(const _ of P.expr)if(N.equals(_))return!0}const F=N.negate(),q=M(F).concat(M(P));q.sort(I);for(let _=0;_<q.length;_++){const H=q[_].negate();for(let j=_+1;j<q.length;j++){const x=q[j];if(H.equals(x))return!0}}return!1}e.implies=O;function M(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(te[79],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(te[13],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,15,131,6]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function T(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function C(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function w(g,l){switch(g){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function b(g,l){return l==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function i(g,l,c){return b(l,c)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===c?!0:I(c).includes(g)}e.isTargetPlatformCompatible=i;function I(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function m(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=m;var E;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var S;(function(g){g.Install="install",g.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var d;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var v;(function(g){g.Unsupported="Unsupported",g.Malicious="Malicious",g.Incompatible="Incompatible",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(l,c){super(l);this.code=c,this.name=c}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(J,e){return function(R,L){e(R,L,J)}};define(te[159],ne([0,1,2,30]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(T){super();this.extensionManagementService=T,this._register(T),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([X(0,L.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[160],ne([0,1,3,2,26,9,109,30]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(S,d){return k.URI.revive(d?d.transformIncoming(S):S)}function b(S,d){return d?d.transformOutgoingURI(S):S}function i(S,d){d=d||T.DefaultURITransformer;const v=S.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...S,manifest:void 0},d),manifest:v}}function I(S,d){return d?(0,D.cloneAndChange)(S,v=>v instanceof k.URI?d.transformOutgoingURI(v):void 0):S}class m{constructor(d,v){this.service=d,this.getUriTransformer=v,this.onInstallExtension=R.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,v){const y=this.getUriTransformer(d);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,g=>g.map(l=>({...l,local:l.local?I(l.local,y):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,v,y){const g=this.getUriTransformer(d);switch(v){case"zip":return this.service.zip(i(y[0],g)).then(l=>b(l,g));case"unzip":return this.service.unzip(w(y[0],g));case"install":return this.service.install(w(y[0],g),y[1]);case"getManifest":return this.service.getManifest(w(y[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(i(y[0],g),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(y[0],g));case"getInstalled":return this.service.getInstalled(y[0]).then(l=>l.map(c=>I(c,g)));case"updateMetadata":return this.service.updateMetadata(i(y[0],g),y[1]).then(l=>I(l,g));case"updateExtensionScope":return this.service.updateExtensionScope(i(y[0],g),y[1]).then(l=>I(l,g));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class E extends L.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(v=>this._onInstallExtension.fire({identifier:v.identifier,source:this.isUriComponents(v.source)?k.URI.revive(v.source):v.source}))),this._register(this.channel.listen("onDidInstallExtensions")(v=>this._onDidInstallExtensions.fire(v.map(y=>({...y,local:y.local?i(y.local,null):y.local,source:this.isUriComponents(y.source)?k.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(v=>this._onUninstallExtension.fire(v))),this._register(this.channel.listen("onDidUninstallExtension")(v=>this._onDidUninstallExtension.fire(v)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const v=await this.getTargetPlatform();return d.allTargetPlatforms.some(y=>(0,C.isTargetPlatformCompatible)(y,d.allTargetPlatforms,v))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(v=>k.URI.revive(v)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,v){return Promise.resolve(this.channel.call("install",[d,v])).then(y=>i(y,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,v){return Promise.resolve(this.channel.call("installFromGallery",[d,v])).then(y=>i(y,null))}uninstall(d,v){return Promise.resolve(this.channel.call("uninstall",[d,v]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(v=>v.map(y=>i(y,null)))}updateMetadata(d,v){return Promise.resolve(this.channel.call("updateMetadata",[d,v])).then(y=>i(y,null))}updateExtensionScope(d,v){return Promise.resolve(this.channel.call("updateExtensionScope",[d,v])).then(y=>i(y,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class h{constructor(d){this.service=d}listen(d,v){throw new Error("Invalid listen")}call(d,v,y){switch(v){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function D(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,R.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,40,8,25,18,9,138,6]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function b(_){return _.create===!0}e.isFileOpenForWriteOptions=b;var i;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(_){_[_.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var m;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=E;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function d(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=d;var v;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor($,H){super($);this.code=H}}e.FileSystemProviderError=y;function g(_,$){const H=new y(_.toString(),$);return c(H,$),H}e.createFileSystemProviderError=g;function l(_){return _||g((0,C.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=l;function c(_,$){return _.name=$?`${$} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=c;function n(_){if(!_)return v.Unknown;if(_ instanceof y)return _.code;const $=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!$)return v.Unknown;switch($[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=n;function s(_){if(_ instanceof f)return _.fileOperationResult;switch(n(_)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor($,H,j){this.resource=$,this.operation=H,this.target=j}isOperation($){return this.operation===$}}e.FileOperationEvent=t;var a;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class o{constructor($,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const j=new Map;for(const x of $){const z=j.get(x.type);z?z.push([x.resource,x]):j.set(x.type,[[x.resource,x]])}for(const[x,z]of j)switch(x){case 1:this.added=R.TernarySearchTree.forUris(()=>H),this.added.fill(z);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>H),this.updated.fill(z);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>H),this.deleted.fill(z);break}}contains($,...H){return this.doContains($,{includeChildren:!1},...H)}affects($,...H){return this.doContains($,{includeChildren:!0},...H)}doContains($,H,...j){if(!$)return!1;const x=j.length>0;return!!((!x||j.includes(1))&&(this.added?.get($)||H.includeChildren&&this.added?.findSuperstr($))||(!x||j.includes(0))&&(this.updated?.get($)||H.includeChildren&&this.updated?.findSuperstr($))||(!x||j.includes(2))&&(this.deleted?.findSubstr($)||H.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(_,$,H){return!_||!$||_===$||$.length>_.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),H?(0,D.startsWithIgnoreCase)(_,$):_.indexOf($)===0)}e.isParent=u;class f extends Error{constructor($,H,j){super($);this.fileOperationResult=H,this.options=j}}e.FileOperationError=f;class p extends f{constructor($,H,j){super($,2,j);this.stat=H}}e.NotModifiedSinceFileOperationError=p;var A;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=M;async function N(_,$){if(!$.hasProvider(T.URI.from({scheme:_.scheme})))return new Promise(H=>{const j=$.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===_.scheme&&x.added&&(j.dispose(),H())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class P{static formatSize($){return(0,k.isNumber)($)||($=0),$<P.KB?(0,C.localize)(1,null,$.toFixed(0)):$<P.MB?(0,C.localize)(2,null,($/P.KB).toFixed(2)):$<P.GB?(0,C.localize)(3,null,($/P.MB).toFixed(2)):$<P.TB?(0,C.localize)(4,null,($/P.GB).toFixed(2)):(0,C.localize)(5,null,($/P.TB).toFixed(2))}}e.ByteSize=P,P.KB=1024,P.MB=P.KB*P.KB,P.GB=P.MB*P.KB,P.TB=P.GB*P.KB;var F;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function q(_){return{maxFileSize:_===0?300*P.MB:16*P.GB,maxHeapSize:_===0?700*P.MB:2*700*P.MB}}e.getPlatformLimits=q}),define(te[161],ne([0,1,82,51,14]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(C){this.fileService=C}async checksum(C){const w=(await this.fileService.readFileStream(C)).value;return new Promise((b,i)=>{const I=(0,R.createHash)("md5");(0,L.listenStream)(w,{onData:m=>I.update(m.buffer),onError:m=>i(m),onEnd:()=>b(I.digest("base64").replace(/=+$/,""))})})}};k=he([X(0,D.IFileService)],k),e.ChecksumService=k}),define(te[162],ne([0,1,244,128,150,14]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function T(m,E){const h={onUnknownOption:d=>{console.warn((0,L.localize)(0,null,d))},onMultipleValues:(d,v)=>{console.warn((0,L.localize)(1,null,d,v))}},S=(0,D.parseArgs)(m,D.OPTIONS,E?h:void 0);return S.goto&&S._.forEach(d=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,L.localize)(2,null))),S["max-memory"]&&R(parseInt(S["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function C(m){const E=m.findIndex(h=>!/^-/.test(h));if(E>-1)return[...m.slice(0,E),...m.slice(E+1)]}function w(m){let[,...E]=m;process.env.VSCODE_DEV&&(E=C(E)||[]);const h=!I(process.env);return T(E,h)}e.parseMainProcessArgv=w;function b(m){const[,,...E]=m;return T(E,!0)}e.parseCLIProcessArgv=b;function i(m,...E){const h=m.indexOf("--");return h===-1?m.push(...E):m.splice(h,0,...E),m}e.addArg=i;function I(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[163],ne([0,1,42,8,129,27,37,7,4,29,124,162,5]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const E=1e4;let h;async function S(v,y,g){return y["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(g)&&!y["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(g)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(l,c)=>{const n=new k.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),c(new Error((0,D.localize)(0,null)))},E);try{l(await d(v,n.token))}catch(r){!(0,C.isPromiseCanceledError)(r)&&!n.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(r)))):l({})}finally{clearTimeout(s),n.dispose()}})),h)}e.resolveShellEnv=S;async function d(v,y){const g=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",g);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",l);const c=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",s);const r=await(0,i.getSystemShell)(w.OS,s);return v.trace("getUnixShellEnvironment#shell",r),new Promise((t,a)=>{if(y.isCancellationRequested)return a((0,C.canceled)());const o=(0,L.basename)(r);let u,f;/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,f=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,f=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),u);const p=(0,R.spawn)(r,[...f,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});y.onCancellationRequested(()=>(p.kill(),a((0,C.canceled)()))),p.on("error",M=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(M)),a(M)});const A=[];p.stdout.on("data",M=>A.push(M));const O=[];p.stderr.on("data",M=>O.push(M)),p.on("close",(M,N)=>{const P=Buffer.concat(A).toString("utf8");v.trace("getUnixShellEnvironment#raw",P);const F=Buffer.concat(O).toString("utf8");if(F.trim()&&v.trace("getUnixShellEnvironment#stderr",F),M||N)return a(new Error((0,D.localize)(2,null,M,N)));const q=n.exec(P),_=q?q[1]:"{}";try{const $=JSON.parse(_);g?$.ELECTRON_RUN_AS_NODE=g:delete $.ELECTRON_RUN_AS_NODE,l?$.ELECTRON_NO_ATTACH_CONSOLE=l:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",$),t($)}catch($){v.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)($)),a($)}})})}}),define(te[83],ne([0,1,19,7,139,14]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(i,I,m,E,h,S){let d;try{await C(i,I,m,E,h,S)}catch(v){d=v}finally{d&&h.errorTransformer&&(d=h.errorTransformer(d)),typeof d!="undefined"&&m.error(d),m.end()}}e.readFileIntoStream=T;async function C(i,I,m,E,h,S){w(S);const d=await i.open(I,{create:!1});try{w(S);let v=0,y=0,g=h&&typeof h.length=="number"?h.length:void 0,l=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),c=h&&typeof h.position=="number"?h.position:0,n=0;do y=await i.read(d,c,l.buffer,n,l.byteLength-n),c+=y,n+=y,v+=y,typeof g=="number"&&(g-=y),n===l.byteLength&&(await m.write(E(l)),l=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),n=0);while(y>0&&(typeof g!="number"||g>0)&&w(S)&&b(v,h));if(n>0){let s=n;typeof g=="number"&&(s=Math.min(n,g)),m.write(E(l.slice(0,s)))}}catch(v){throw(0,k.ensureFileSystemProviderError)(v)}finally{await i.close(d)}}function w(i){if(i.isCancellationRequested)throw(0,L.canceled)();return!0}function b(i,I){if(I?.limits){if(typeof I.limits.memory=="number"&&i>I.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&i>I.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[45],ne([0,1,2,4,9,14]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=void 0;class T extends R.Disposable{}e.WatcherService=T;function C(i){return i.map(I=>({type:I.type,resource:D.URI.file(I.path)}))}e.toFileChanges=C;function w(i){const I=new b;for(const m of i)I.processEvent(m);return I.normalize()}e.normalizeFileChanges=w;class b{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return L.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const m=this.mapPathToChange.get(this.toKey(I));let E=!1;if(m){const h=m.type,S=I.type;m.path!==I.path&&I.type===2?E=!0:h===1&&S===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(m)):h===2&&S===1?m.type=0:h===1&&S===0||(m.type=S)}else E=!0;E&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],m=[];return Array.from(this.normalized).filter(E=>E.type!==2?(I.push(E),!1):!0).sort((E,h)=>E.path.length-h.path.length).filter(E=>m.some(h=>(0,k.isParent)(E.path,h,!L.isLinux))?!1:(m.push(E.path),!0)).concat(I)}}}),define(te[164],ne([0,1,5,2,8,114,20,117,45]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends L.Disposable{constructor(I,m,E,h){super();this.path=I,this.onDidFilesChange=m,this.onLogMessage=E,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:m}=await T.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(m)try{E=await(0,k.realpath)(E)}catch(h){if(this.onError(h),m.dangling)return}I.isDirectory()?this._register((0,C.watchFolder)(E,(h,S)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(S))})},h=>this.onError(h))):this._register((0,C.watchFile)(E,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,w.normalizeFileChanges)(m);if(this.verboseLogging)for(const h of E)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(te[165],ne([0,1,15,32,44,45]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T extends k.WatcherService{constructor(w,b,i){super();this.onDidFilesChange=w,this.onLogMessage=b,this.verboseLogging=i,this.isDisposed=!1,this.startWatching()}startWatching(){const w=this._register(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}async watch(w){this.isDisposed||await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=T}),define(te[166],ne([0,1,2,15,32,44,45]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends T.WatcherService{constructor(b,i,I){super();this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=I,this.serviceDisposables=this._register(new R.MutableDisposable),this.requests=void 0,this.restartCounter=0,this.init()}init(){const b=new R.DisposableStore;this.serviceDisposables.value=b;const i=b.add(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));b.add(i.onDidProcessExit(()=>{this.restartCounter<=C.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restart(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!")})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(i.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),b.add(this.service.onDidChangeFile(I=>this.onDidFilesChange(I))),b.add(this.service.onDidLogMessage(I=>this.onLogMessage(I)))}restart(b){this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.init(),this.watch(b)}async watch(b){this.requests=b,await this.service?.watch(b)}async setVerboseLogging(b){this.verboseLogging=b,await this.service?.setVerboseLogging(b)}error(b){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${b}`})}dispose(){return this.service=void 0,super.dispose()}}e.FileWatcher=C,C.MAX_RESTARTS=5}),define(te[167],ne([0,1,15,32,44,45]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T extends k.WatcherService{constructor(w,b,i,I={}){super();this.onDidFilesChange=w,this.onLogMessage=b,this.verboseLogging=i,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const w=this._register(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}async watch(w){this.requests=w,await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=T,T.MAX_RESTARTS=5}),define(te[84],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[k,T]of D)this.set(k,T)}set(D,k){const T=this._entries.get(D);return this._entries.set(D,k),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(te[168],ne([0,1,5,7,53,156,6,84]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new C.ServiceCollection,S=!1,d){this._activeInstantiations=new Set,this._services=h,this._strict=S,this._parent=d,this._services.set(T.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...S){let d=m.traceInvocation(h),v=!1;try{return h({get:(g,l)=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(g,d);if(!c&&l!==T.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return c}},...S)}finally{v=!0,d.stop()}}createInstance(h,...S){let d,v;return h instanceof D.SyncDescriptor?(d=m.traceCreation(h.ctor),v=this._createInstance(h.ctor,h.staticArguments.concat(S),d)):(d=m.traceCreation(h),v=this._createInstance(h,S,d)),d.stop(),v}_createInstance(h,S=[],d){let v=T._util.getServiceDependencies(h).sort((l,c)=>l.index-c.index),y=[];for(const l of v){let c=this._getOrCreateServiceInstance(l.id,d);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`);y.push(c)}let g=v.length>0?v[0].index:S.length;if(S.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${S.length} static arguments`);let l=g-S.length;l>0?S=S.concat(new Array(l)):S=S.slice(0,g)}return new h(...[...S,...y])}_setServiceInstance(h,S){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){let d=this._getServiceInstanceOrDescriptor(h);return d instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,d,S.branch(h,!0)):(S.branch(h,!1),d)}_safeCreateAndCacheServiceInstance(h,S,d){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,d)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,d){const v=new k.Graph(l=>l.id.toString());let y=0;const g=[{id:h,desc:S,_trace:d}];for(;g.length;){const l=g.pop();if(v.lookupOrInsertNode(l),y++>1e3)throw new b(v);for(let c of T._util.getServiceDependencies(l.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(c.id);if(!n&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const s={id:c.id,desc:n,_trace:l._trace.branch(c.id,!0)};v.insertEdge(l,s),g.push(s)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new b(v);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,d=[],v,y){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(S,d,v,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,d,v,y);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S=[],d,v){if(d){const y=new R.IdleValue(()=>this._createInstance(h,S,v));return new Proxy(Object.create(null),{get(g,l){if(l in g)return g[l];let c=y.value,n=c[l];return typeof n!="function"||(n=n.bind(c),g[l]=n),n},set(g,l,c){return y.value[l]=c,!0}})}else return this._createInstance(h,S,v)}}e.InstantiationService=i;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class m{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return w?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return w?new m(0,h.name):m._None}branch(h,S){let d=new m(2,h.toString());return this._dep.push([h,S,d]),d}stop(){let h=Date.now()-this._start;m._totals+=h;let S=!1;function d(y,g){let l=[],c=new Array(y+1).join("	");for(const[n,s,r]of g._dep)if(s&&r){S=!0,l.push(`${c}CREATES -> ${n}`);let t=d(y+1,r);t&&l.push(t)}else l.push(`${c}uses -> ${n}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||S)&&console.log(v.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(te[169],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,k){this.server=D,this.router=k}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,k){this.server.registerChannel(D,k)}}e.MessagePortMainProcessService=R}),define(te[170],ne([0,1,32,53,77,6]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(E,h,S){const d=S.getChannel(E);return C(h)?new h.channelClientCtor(d):R.ProxyChannel.toService(d,h?.proxyOptions)}}function C(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let w=class extends T{constructor(E,h,S){super(E,h,S)}};w=he([X(2,e.IMainProcessService)],w);function b(m,E,h){(0,D.registerSingleton)(m,new L.SyncDescriptor(w,[E,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let i=class extends T{constructor(E,h,S){super(E,h,S)}};i=he([X(2,e.ISharedProcessService)],i);function I(m,E,h){(0,D.registerSingleton)(m,new L.SyncDescriptor(i,[E,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[58],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function L(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const k of D.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[171],ne([0,1,2,58]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([X(0,L.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[10],ne([0,1,37,3,2,4,6]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function C(){return new Date().toISOString()}var w;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class b extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...s){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([n,...s]))}debug(n,...s){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([n,...s]))}info(n,...s){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([n,...s]))}warn(n,...s){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([n,...s]))}error(n,...s){if(this.checkLogLevel(w.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(w.Error,this.format(r))}else this.log(w.Error,this.format([n,...s]))}critical(n,...s){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([n,...s]))}flush(){}format(n){let s="";for(let r=0;r<n.length;r++){let t=n[r];if(typeof t=="object")try{t=JSON.stringify(t)}catch(a){}s+=(r>0?" ":"")+t}return s}}e.AbstractMessageLogger=i;class I extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!k.isWindows}trace(n,...s){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,n,...s):console.log(`[main ${C()}]`,n,...s))}debug(n,...s){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,n,...s):console.log(`[main ${C()}]`,n,...s))}info(n,...s){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,n,...s):console.log(`[main ${C()}]`,n,...s))}warn(n,...s){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,n,...s):console.warn(`[main ${C()}]`,n,...s))}error(n,...s){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,n,...s):console.error(`[main ${C()}]`,n,...s))}critical(n,...s){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,n,...s):console.error(`[main ${C()}]`,n,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class m extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...s){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",n,...s)}debug(n,...s){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...s)}info(n,...s){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",n,...s)}warn(n,...s){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",n,...s)}error(n,...s){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",n,...s)}critical(n,...s){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...s)}dispose(){}flush(){}}e.ConsoleLogger=m;class E extends b{constructor(n,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(s)}trace(n,...s){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(n),...s])}debug(n,...s){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(n),...s])}info(n,...s){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(n),...s])}warn(n,...s){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(n),...s])}error(n,...s){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(n),...s])}critical(n,...s){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(n),...s])}extractMessage(n){return typeof n=="string"?n:(0,R.toErrorMessage)(n,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class h extends b{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const s of this.logServices)s.setLevel(n);super.setLevel(n)}trace(n,...s){for(const r of this.logServices)r.trace(n,...s)}debug(n,...s){for(const r of this.logServices)r.debug(n,...s)}info(n,...s){for(const r of this.logServices)r.info(n,...s)}warn(n,...s){for(const r of this.logServices)r.warn(n,...s)}error(n,...s){for(const r of this.logServices)r.error(n,...s)}critical(n,...s){for(const r of this.logServices)r.critical(n,...s)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=h;class S extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...s){this.logger.trace(n,...s)}debug(n,...s){this.logger.debug(n,...s)}info(n,...s){this.logger.info(n,...s)}warn(n,...s){this.logger.warn(n,...s)}error(n,...s){this.logger.error(n,...s)}critical(n,...s){this.logger.critical(n,...s)}flush(){this.logger.flush()}}e.LogService=S;class d extends D.Disposable{constructor(n,s){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,s){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,s?.always?w.Trace:this.logLevel,s),this.loggers.set(n.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=d;class v{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return w.Info}trace(n,...s){}debug(n,...s){}info(n,...s){}warn(n,...s){}error(n,...s){}critical(n,...s){}dispose(){}flush(){}}e.NullLogService=v;function y(c){if(c.verbose)return w.Trace;if(typeof c.logLevel=="string"){const n=g(c.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function g(c){switch(c){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=g;function l(c){switch(c){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=l}),define(te[172],ne([0,1,5,7,2,8,20,13,10]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(I,m){super();this.environmentService=I,this.logService=m,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,k.basename)(this.environmentService.logsPath),m=(0,k.dirname)(this.environmentService.logsPath),S=(await T.Promises.readdir(m)).filter(v=>/^\d{8}T\d{6}$/.test(v)).sort().filter(v=>v!==I),d=S.slice(0,Math.max(0,S.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(v=>T.Promises.rm((0,k.join)(m,v)))))}catch(I){(0,L.onUnexpectedError)(I)}}};b=he([X(0,C.IEnvironmentService),X(1,w.ILogService)],b),e.LogsDataCleaner=b}),define(te[173],ne([0,1,5,7,2,8,20,13,10]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class pt extends D.Disposable{constructor(I,m,E){super();this.backupWorkspacesPath=I,this.environmentService=m,this.logService=E,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const I=await T.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(I).emptyWorkspaceInfos.map(S=>S.backupFolder),h=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async S=>{S.length!==pt.NON_EMPTY_WORKSPACE_ID_LENGTH&&E.indexOf(S)===-1&&(this.logService.trace(`[storage cleanup]: Deleting storage folder ${S}.`),await T.Promises.rm((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(I){(0,L.onUnexpectedError)(I)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=he([X(1,C.INativeEnvironmentService),X(2,w.ILogService)],b),e.StorageDataCleaner=b}),define(te[85],ne([0,1,5,19,33,39,13,14,6,10]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,w.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(E,h,S){this.environmentService=E,this.fileService=h,this.logService=S,this.queue=new R.Queue}async updateSettings(E,h){return this.queue.queue(()=>this.doWrite(E,h))}async doWrite(E,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),E);const{value:S,mtime:d,etag:v}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let y=S.toString();const g=[];if((0,D.parse)(y,g,{allowTrailingComma:!0,allowEmptyContent:!0}),g.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(E,y,h)[0];if(l){y=y.substring(0,l.offset)+l.content+y.substring(l.offset+l.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(y),{etag:v,mtime:d})}catch(c){if(c.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(E,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,E,h)})}getEdits({value:E,path:h},S,d){return h.length?(0,k.setProperty)(S,h,E,d):[{content:JSON.stringify(E,null,d.insertSpaces&&d.tabSize?" ".repeat(d.tabSize):"	"),length:S.length,offset:0}]}};I=he([X(0,T.IEnvironmentService),X(1,C.IFileService),X(2,b.ILogService)],I),e.UserConfigurationFileService=I}),define(te[174],ne([0,1,42,5,37,3,2,15,8,20,13,10]),function(J,e,R,L,D,k,T,C,w,b,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends T.Disposable{constructor(h,S){super();this.environmentService=h,this.logService=S,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${d}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(h,S){const d=`vscode:${S}`;if(h.location.scheme===C.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[d]=="string"){const v=h.manifest.scripts[d].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${d} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(h,S,d,v,y){return new Promise((g,l)=>{const c=this.start(h,S,d,y);let n;const s=r=>{n&&(clearTimeout(n),n=null),r?l(r):g(void 0)};c.on("error",r=>{s((0,D.toErrorMessage)(r)||"Unknown")}),c.on("exit",(r,t)=>{s(r?`post-${S} process exited with code ${r}`:void 0)}),v&&(n=setTimeout(()=>{n=null,c.kill(),l("timed out")},5e3))})}start(h,S,d,v){const y={silent:!0,execArgv:void 0},g=(0,R.fork)(h,[`--type=extension-post-${S}`,...d],y);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const l=k.Event.fromNodeEventEmitter(g.stdout,"data"),c=k.Event.fromNodeEventEmitter(g.stderr,"data");l(r=>this.logService.info(v.identifier.id,v.manifest.version,`post-${S}`,r)),c(r=>this.logService.error(v.identifier.id,v.manifest.version,`post-${S}`,r));const n=k.Event.any(k.Event.map(l,r=>({data:`%c${r}`,format:[""]})),k.Event.map(c,r=>({data:`%c${r}`,format:["color: red"]})));return k.Event.debounce(n,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100)(r=>{console.group(v.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,w.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=he([X(0,i.IEnvironmentService),X(1,I.ILogService)],m),e.ExtensionsLifecycle=m}),define(te[175],ne([0,1,7,2,81,3,42,15,111,4,10,77,26,31]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let h=class extends L.Disposable{constructor(v,y){super();this.id=v,this._logService=y,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null}register(v){this._register(v)}start(v){this._process=(0,T.fork)(C.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,m.mixin)({cwd:(0,E.cwd)()},v));const y=this._process.pid;this._logService.info(`Starting extension host with pid ${y}.`);const g=new w.StringDecoder("utf-8");this._process.stdout?.on("data",c=>{const n=typeof c=="string"?c:g.write(c);this._onStdout.fire(n)});const l=new w.StringDecoder("utf-8");return this._process.stderr?.on("data",c=>{const n=typeof c=="string"?c:l.write(c);this._onStderr.fire(n)}),this._process.on("message",c=>{this._onMessage.fire(c)}),this._process.on("error",c=>{this._onError.fire({error:(0,R.transformErrorForSerialization)(c)})}),this._process.on("exit",(c,n)=>{this._onExit.fire({pid:y,code:c,signal:n})}),{pid:y}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):b.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};h=he([X(1,i.ILogService)],h);let S=class yt{constructor(v){this._logService=v,this._extHosts=new Map}dispose(){}_getExtHost(v){const y=this._extHosts.get(v);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(v){return this._getExtHost(v).onStdout}onDynamicStderr(v){return this._getExtHost(v).onStderr}onDynamicMessage(v){return this._getExtHost(v).onMessage}onDynamicError(v){return this._getExtHost(v).onError}onDynamicExit(v){return this._getExtHost(v).onExit}async createExtensionHost(){const v=String(++yt._lastId),y=new h(v,this._logService);return this._extHosts.set(v,y),y.onExit(({pid:g,code:l,signal:c})=>{this._logService.info(`Extension host with pid ${g} exited with code: ${l}, signal: ${c}.`),setTimeout(()=>{y.dispose(),this._extHosts.delete(v)})}),{id:v}}async start(v,y){return this._getExtHost(v).start(y)}async enableInspectPort(v){const y=this._extHosts.get(v);return y?y.enableInspectPort():!1}async kill(v){const y=this._extHosts.get(v);!y||y.kill()}};S._lastId=0,S=he([X(0,i.ILogService)],S),e.ExtensionHostStarter=S,(0,I.registerSingleton)(D.IExtensionHostStarter,S,!0)}),define(te[176],ne([0,1,17,5,7,3,2,8,45,10]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class i extends T.Disposable{constructor(m){super();this.logService=m,this._onDidErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(m,E){return E.recursive?this.watchRecursive(m,E):this.watchNonRecursive(m)}watchRecursive(m,E){const h={path:this.toFilePath(m),excludes:E.excludes},S=(0,R.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,m=>this._onDidChangeFile.fire((0,w.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,E){return m.watch(E)}watchNonRecursive(m){const E=this.createNonRecursiveWatcher(this.toFilePath(m),S=>this._onDidChangeFile.fire((0,w.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===b.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,T.combinedDisposable)(E,h)}onWatcherLogMessage(m){m.type==="error"&&this._onDidErrorOccur.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,C.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=i}),define(te[177],ne([0,1,17,5,19,27,3,55,2,40,15,178,16,51,137,14,83,10]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Ke extends w.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new S.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new S.FileChangesEvent(c,!0)))),this.watchedResources=b.TernarySearchTree.forUris(c=>{const n=this.getProvider(c.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const n=new w.DisposableStore;return n.add(c.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(c)))),n.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&n.add(c.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,w.dispose)(n)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(n){c.push(n)}}),!this.provider.has(l)&&await L.Promises.settled(c)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,c){const n=this.provider.get(l.scheme);return!!(n&&n.capabilities&c)}listCapabilities(){return C.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,m.isAbsolutePath)(l))throw new S.FileOperationError((0,h.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const n=new Error;throw n.name="ENOPRO",n.message=(0,h.localize)(1,null,l.toString()),n}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasReadWriteCapability)(c)||(0,S.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(n){throw(0,S.toFileSystemProviderErrorCode)(n)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,h.localize)(2,null,this.resourceForError(l)),1):(0,S.ensureFileSystemProviderError)(n)}}async doResolveFile(l,c){const n=await this.withProvider(l),s=this.isPathCaseSensitive(n),r=c?.resolveTo,t=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,o=await n.stat(l);let u;return this.toFileStat(n,l,o,void 0,!!a,(f,p)=>(u||(u=b.TernarySearchTree.forUris(()=>!s),u.set(l,!0),r&&u.fill(!0,r)),u.get(f.resource)||u.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&t?p===1:!1))}async toFileStat(l,c,n,s,r,t){const{providerExtUri:a}=this.getExtUri(l),o={resource:c,name:a.basename(c),isFile:(n.type&S.FileType.File)!=0,isDirectory:(n.type&S.FileType.Directory)!=0,isSymbolicLink:(n.type&S.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&S.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,S.etag)({mtime:n.mtime,size:n.size})};if(o.isDirectory&&t(o,s)){try{const u=await l.readdir(c),f=await L.Promises.settled(u.map(async([p,A])=>{try{const O=a.joinPath(c,p),M=r?await l.stat(O):{type:A};return await this.toFileStat(l,O,M,u.length,r,t)}catch(O){return this.logService.trace(O),null}}));o.children=(0,R.coalesce)(f)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(l){return L.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(n){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(n){return n}return!0}async doValidateCreateFile(l,c){if(!c?.overwrite&&await this.exists(l))throw new S.FileOperationError((0,h.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(l,n);const s=await this.writeFile(l,c);return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,s)),s}async writeFile(l,c,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,l,n)||await this.mkdirp(s,r.dirname(l));let a;if((0,S.hasReadWriteCapability)(s)&&!(c instanceof D.VSBuffer))if((0,E.isReadableStream)(c)){const o=await(0,E.peekStream)(c,3);o.ended?a=D.VSBuffer.concat(o.buffer):a=o}else a=(0,E.peekReadable)(c,o=>D.VSBuffer.concat(o),3);else a=c;!(0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(s,l,n,a):await this.doWriteBuffered(s,l,n,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(t){throw new S.FileOperationError((0,h.localize)(4,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),n)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,n){if(!!n?.unlock&&!(l.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(c)));let r;try{r=await l.stat(c)}catch(t){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,h.localize)(6,null,this.resourceForError(c)),0,n);if(this.throwIfFileIsReadonly(c,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,S.etag)({mtime:n.mtime,size:r.size}))throw new S.FileOperationError((0,h.localize)(7,null),3,n);return r}async readFile(l,c){const n=await this.withReadProvider(l);return c?.atomic?this.doReadFileAtomic(n,l,c):this.doReadFile(n,l,c)}async doReadFileAtomic(l,c,n){return new Promise((s,r)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(l,c,n);s(t)}catch(t){r(t)}})})}async doReadFile(l,c,n){const s=await this.doReadFileStream(l,c,{...n,preferUnbuffered:!0});return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(l,c){const n=await this.withReadProvider(l);return this.doReadFileStream(n,l,c)}async doReadFileStream(l,c,n){const s=new k.CancellationTokenSource,r=this.validateReadFile(c,n).then(a=>a,a=>{throw s.cancel(),a});let t;try{return typeof n?.etag=="string"&&n.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasFileReadStreamCapability)(l))||(0,S.hasReadWriteCapability)(l)&&n?.preferUnbuffered?t=this.readFileUnbuffered(l,c,n):(0,S.hasFileReadStreamCapability)(l)?t=this.readFileStreamed(l,c,s.token,n):t=this.readFileBuffered(l,c,s.token,n),{...await r,value:t}}catch(a){t&&await(0,E.consumeStream)(t);const o=(0,h.localize)(8,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(a).toString());throw a instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(o,a.stat,n):new S.FileOperationError(o,(0,S.toFileOperationResult)(a),n)}}readFileStreamed(l,c,n,s=Object.create(null)){const r=l.readFileStream(c,s,n);return(0,E.transform)(r,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new S.FileOperationError((0,h.localize)(9,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),s)},t=>D.VSBuffer.concat(t))}readFileBuffered(l,c,n,s=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,d.readFileIntoStream)(l,c,r,t=>t,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new S.FileOperationError((0,h.localize)(10,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),s)},n),r}readFileUnbuffered(l,c,n){const s=(0,E.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r=await l.readFile(c);typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(c,r.byteLength,n),s.end(D.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(l,c){const n=await this.resolve(l,{resolveMetadata:!0});if(n.isDirectory)throw new S.FileOperationError((0,h.localize)(11,null,this.resourceForError(l)),0,c);if(typeof c?.etag=="string"&&c.etag!==S.ETAG_DISABLED&&c.etag===n.etag)throw new S.NotModifiedSinceFileOperationError((0,h.localize)(12,null),n,c);return this.validateReadFileLimits(l,n.size,c),n}validateReadFileLimits(l,c,n){if(n?.limits){let s;if(typeof n.limits.memory=="number"&&c>n.limits.memory&&(s=9),typeof n.limits.size=="number"&&c>n.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError((0,h.localize)(13,null,this.resourceForError(l)),s)}}async canMove(l,c,n){return this.doCanMoveCopy(l,c,"move",n)}async canCopy(l,c,n){return this.doCanMoveCopy(l,c,"copy",n)}async doCanMoveCopy(l,c,n,s){if(l.toString()!==c.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,l,t,c,n,s)}catch(r){return r}return!0}async move(l,c,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),t=await this.doMoveCopy(s,l,r,c,"move",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,t==="move"?2:3,a)),a}async copy(l,c,n){const s=await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),t=await this.doMoveCopy(s,l,r,c,"copy",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,t==="copy"?3:2,a)),a}async doMoveCopy(l,c,n,s,r,t){if(c.toString()===s.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,c,n,s,r,t);if(a&&!o&&t&&await this.del(s,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),r==="copy"){if(l===n&&(0,S.hasFileFolderCopyCapability)(l))await l.copy(c,s,{overwrite:t});else{const u=await this.resolve(c);u.isDirectory?await this.doCopyFolder(l,u,n,s):await this.doCopyFile(l,c,n,s)}return r}else return l===n?(await l.rename(c,s,{overwrite:t}),r):(await this.doMoveCopy(l,c,n,s,"copy",t),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,n,s){if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(l,c,n,s);if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(l,c,n,s);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(l,c,n,s);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasReadWriteCapability)(n))return this.doPipeUnbuffered(l,c,n,s)}async doCopyFolder(l,c,n,s){await n.mkdir(s),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async r=>{const t=this.getExtUri(n).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(l,await this.resolve(r.resource),n,t):this.doCopyFile(l,r.resource,n,t)}))}async doValidateMoveCopy(l,c,n,s,r,t){let a=!1;if(l===n){const{providerExtUri:u,isPathCaseSensitive:f}=this.getExtUri(l);if(f||(a=u.isEqual(c,s)),a&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(c),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,c))throw new Error((0,h.localize)(15,null,this.resourceForError(c),this.resourceForError(s)))}const o=await this.exists(s);if(o&&!a){if(!t)throw new S.FileOperationError((0,h.localize)(16,null,this.resourceForError(c),this.resourceForError(s)),4);if(l===n){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(c,s))throw new Error((0,h.localize)(17,null,this.resourceForError(c),this.resourceForError(s)))}}return{exists:o,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const n=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,n)),n}async mkdirp(l,c){const n=[],{providerExtUri:s}=this.getExtUri(l);for(;!s.isEqual(c,s.dirname(c));)try{if(((await l.stat(c)).type&S.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(s.basename(c)),c=s.dirname(c)}for(let r=n.length-1;r>=0;r--){c=s.joinPath(c,n[r]);try{await l.mkdir(c)}catch(t){if((0,S.toFileSystemProviderErrorCode)(t)!==S.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(n){return n}return!0}async doValidateDelete(l,c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!c?.useTrash&&!(n.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(l)));let r;try{r=await n.stat(l)}catch(a){}if(r)this.throwIfFileIsReadonly(l,r);else throw new S.FileOperationError((0,h.localize)(20,null,this.resourceForError(l)),1);if(!!!c?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(l)))}return n}async del(l,c){const n=await this.doValidateDelete(l,c),s=!!c?.useTrash,r=!!c?.recursive;await n.delete(l,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(l,1))}onDidChangeFile(l,c){this._onDidChangeFilesRaw.fire({changes:l});let n,s;{for(const r of l)this.watchedResources.has(r.resource)?(n||(n=[]),n.push(r)):(s||(s=[]),s.push(r));n&&this._onDidFilesChange.fire(new S.FileChangesEvent(n,!c))}if(s){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,c={recursive:!1,excludes:[]}){const n=new w.DisposableStore;let s=!1,r=()=>{s=!0};return n.add((0,w.toDisposable)(()=>r())),this.doWatch(l,c).then(t=>{s?(0,w.dispose)(t):r=()=>(0,w.dispose)(t)},t=>this.logService.error(t)),c.recursive||(this.watchedResources.set(l,(this.watchedResources.get(l)??0)+1),n.add((0,w.toDisposable)(()=>{const t=this.watchedResources.get(l);typeof t=="number"&&(t<=1?this.watchedResources.delete(l):this.watchedResources.set(l,t-1))}))),n}async doWatch(l,c){const n=await this.withProvider(l),s=this.toWatchKey(n,l,c);let r=this.activeWatchers.get(s);return r||(r={count:0,disposable:n.watch(l,c)},this.activeWatchers.set(s,r)),r.count+=1,(0,w.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(s)))})}toWatchKey(l,c,n){const{providerExtUri:s}=this.getExtUri(l);return[s.getComparisonKey(c),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,w.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,c,n,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{const r=await l.open(c,{create:!0,unlock:n?.unlock??!1});try{(0,E.isReadableStream)(s)||(0,E.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(l,r,s):await this.doWriteReadableBufferedQueued(l,r,s)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await l.close(r)}})}async doWriteStreamBufferedQueued(l,c,n){let s=0,r;if((0,E.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(l,c,t,t.byteLength,s,0),s+=t.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((t,a)=>{(0,E.listenStream)(r,{onData:async o=>{r.pause();try{await this.doWriteBuffer(l,c,o,o.byteLength,s,0)}catch(u){return a(u)}s+=o.byteLength,setTimeout(()=>r.resume())},onError:o=>a(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(l,c,n){let s=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(l,c,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(l,c,n,s,r,t){let a=0;for(;a<s;)a+=await l.write(c,r+a,n.buffer,t+a,s-a)}async doWriteUnbuffered(l,c,n,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,n,s))}async doWriteUnbufferedQueued(l,c,n,s){let r;s instanceof D.VSBuffer?r=s:(0,E.isReadableStream)(s)?r=await(0,D.streamToBuffer)(s):(0,E.isReadableBufferedStream)(s)?r=await(0,D.bufferedStreamToBuffer)(s):r=(0,D.readableToBuffer)(s),await l.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(l,c,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,n,s))}async doPipeBufferedQueued(l,c,n,s){let r,t;try{r=await l.open(c,{create:!1}),t=await n.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,f=0;do f=await l.read(r,o,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(n,t,a,f,o,u),o+=f,u+=f,u===a.byteLength&&(u=0);while(f>0)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof r=="number"?l.close(r):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(l,c,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,n,s))}async doPipeUnbufferedQueued(l,c,n,s){return n.writeFile(s,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,n,s))}async doPipeUnbufferedToBufferedQueued(l,c,n,s){const r=await n.open(s,{create:!0,unlock:!1});try{const t=await l.readFile(c);await this.doWriteBuffer(n,r,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(l,c,n,s){const r=await(0,D.streamToBuffer)(this.readFileBuffered(l,c,k.CancellationToken.None));await this.doWriteUnbuffered(n,s,void 0,r)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new S.FileOperationError((0,h.localize)(22,null,this.resourceForError(c)),6);return l}throwIfFileIsReadonly(l,c){if((c.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,h.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===i.Schemas.file?l.fsPath:l.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=he([X(0,v.ILogService)],y),e.FileService=y}),define(te[86],ne([0,1,3,9,10]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=R.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=k;class T{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){T.setLevel(this.channel,m)}static setLevel(m,E){return m.call("setLevel",E)}}e.LogLevelChannelClient=T;class C{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,E){throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${E}`)}createLogger(m,E){this.loggers.set(m.toString(),this.loggerService.createLogger(m,E))}consoleLog(m,E){let h=console.log;switch(m){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...E)}log(m,E){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,d]of E)switch(S){case D.LogLevel.Trace:h.trace(d);break;case D.LogLevel.Debug:h.debug(d);break;case D.LogLevel.Info:h.info(d);break;case D.LogLevel.Warning:h.warn(d);break;case D.LogLevel.Error:h.error(d);break;case D.LogLevel.Critical:h.critical(d);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=C;class w extends D.AbstractLoggerService{constructor(m,E,h){super(m,E);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(m,E)=>{this.channel.call("consoleLog",[m,E])}})}doCreateLogger(m,E,h){return new b(this.channel,m,E,h)}}e.LoggerChannelClient=w;class b extends D.AbstractMessageLogger{constructor(m,E,h,S){super(S?.always);this.channel=m,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[E,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,E){const h=[[m,E]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class i extends D.LogService{constructor(m,E){super(E);this.parent=m,this._register(m.onDidChangeLogLevel(h=>E.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=i}),define(te[59],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(te[60],ne([0,1,15,4,31,16]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)T=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,k.dirname)(R.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,k.joinPath)(C,"product.json").fsPath);const w=J.__$__nodeRequire((0,k.joinPath)(C,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:w.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(te[179],ne([0,1,52,245,5,19,3,41,8,4,16,51,20,140,14,83,164,165,166,167,60,176,37]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(r)}`)}})();class s extends c.AbstractDiskFileSystemProvider{constructor(t,a){super(t);this.options=a,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:a,symbolicLink:o}=await m.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(a,o),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(t){try{const a=await m.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(a.map(async u=>{try{let f;u.isSymbolicLink()?f=(await this.stat((0,i.joinPath)(t,u.name))).type:f=this.toType(u),o.push([u.name,f])}catch(f){this.logService.trace(f)}})),o}catch(a){throw this.toFileSystemProviderError(a)}}toType(t,a){let o;return a?.dangling?o=h.FileType.Unknown:t.isFile()?o=h.FileType.File:t.isDirectory()?o=h.FileType.Directory:o=h.FileType.Unknown,a&&(o|=h.FileType.SymbolicLink),o}async readFile(t){try{const a=this.toFilePath(t);return await m.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(t,a,o){const u=(0,I.newWriteableStream)(f=>k.VSBuffer.concat(f.map(p=>k.VSBuffer.wrap(p))).buffer);return(0,S.readFileIntoStream)(this,t,u,f=>f.buffer,{...a,bufferSize:256*1024},o),u}async writeFile(t,a,o){let u;try{const f=this.toFilePath(t);if(!o.create||!o.overwrite){if(await m.Promises.exists(f)){if(!o.overwrite)throw(0,h.createFileSystemProviderError)((0,E.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,h.createFileSystemProviderError)((0,E.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,a,0,a.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(t,f)}finally{typeof u=="number"&&await this.close(u)}}async open(t,a){try{const o=this.toFilePath(t);if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await m.SymlinkSupport.stat(o);p.mode&128||await m.Promises.chmod(o,p.mode|128)}catch(p){this.logService.trace(p)}let u;if((0,h.isFileOpenForWriteOptions)(a)){if(b.isWindows)try{await m.Promises.truncate(o,0),u="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}u||(u="w")}else u="r";const f=await m.Promises.open(o,u);return this.mapHandleToPos.set(f,0),(0,h.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(f,t),f}catch(o){throw(0,h.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(t,o):this.toFileSystemProviderError(o)}}async close(t){try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&this.canFlush)try{await m.Promises.fdatasync(t)}catch(a){this.canFlush=!1,this.logService.error(a)}return await m.Promises.close(t)}catch(a){throw this.toFileSystemProviderError(a)}}async read(t,a,o,u,f){const p=this.normalizePos(t,a);let A=null;try{const O=await m.Promises.read(t,o,u,f,p);return typeof O=="number"?A=O:A=O.bytesRead,A}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(t,p,A)}}normalizePos(t,a){return a===this.mapHandleToPos.get(t)?null:a}updatePos(t,a,o){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof a=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,u+o):this.mapHandleToPos.delete(t)))}async write(t,a,o,u,f){return(0,D.retry)(()=>this.doWrite(t,a,o,u,f),100,3)}async doWrite(t,a,o,u,f){const p=this.normalizePos(t,a);let A=null;try{const O=await m.Promises.write(t,o,u,f,p);return typeof O=="number"?A=O:A=O.bytesWritten,A}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),O)}finally{this.updatePos(t,p,A)}}async mkdir(t){try{await m.Promises.mkdir(this.toFilePath(t))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(t,a){try{const o=this.toFilePath(t);await this.doDelete(o,a)}catch(o){throw this.toFileSystemProviderError(o)}}async doDelete(t,a){a.recursive?await m.Promises.rm(t,m.RimRafMode.MOVE):await m.Promises.unlink(t)}async rename(t,a,o){const u=this.toFilePath(t),f=this.toFilePath(a);if(u!==f)try{await this.validateTargetDeleted(t,a,"move",o.overwrite),await m.Promises.move(u,f)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(2,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(f)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(t,a,o){const u=this.toFilePath(t),f=this.toFilePath(a);if(u!==f)try{await this.validateTargetDeleted(t,a,"copy",o.overwrite),await m.Promises.copy(u,f,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(3,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(f)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(t,a,o,u){const f=this.toFilePath(t),p=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,C.isEqual)(f,p,!0)),A&&o==="copy")throw(0,h.createFileSystemProviderError)((0,E.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!A&&await m.Promises.exists(p)){if(!u)throw(0,h.createFileSystemProviderError)((0,E.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(t,a,o,u){let f,p=!1;return this.options?.watcher?.usePolling?p=!1:this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?p=this.options.legacyWatcher==="on":l.default.quality==="stable"&&(p=t===1),p?b.isLinux?f=g.FileWatcher:f=v.FileWatcher:f=y.FileWatcher,new f(A=>a(A),A=>o(A),u,this.options?.watcher)}doWatch(t,a){const o=this.options?.watcher?.usePolling;if(o===!0)for(const u of a)u.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(o))for(const u of a)o.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(t,a)}createNonRecursiveWatcher(t,a,o,u){return new d.FileWatcher(t,f=>a(f),f=>o(f),u)}toFileSystemProviderError(t){if(t instanceof h.FileSystemProviderError)return t;let a;switch(t.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(t,a)}async toFileSystemProviderWriteError(t,a){let o=this.toFileSystemProviderError(a);if(t&&o.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(o=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}e.DiskFileSystemProvider=s}),define(te[28],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(te[180],ne([0,1,5,7,2,8,20,10,28]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(I,m,E){super();this.productService=m,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),E=(0,k.dirname)(I),h=(0,k.basename)(I),S=await T.Promises.readdir(E);await Promise.all(S.map(async d=>{if(d===h)return;const v=(0,k.join)(E,d),y=await T.Promises.stat(v);if(y.isDirectory()&&m-y.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),T.Promises.rm(v)}))}catch(m){(0,L.onUnexpectedError)(m)}}};b=he([X(1,w.IProductService),X(2,C.ILogService)],b),e.CodeCacheCleaner=b}),define(te[181],ne([0,1,5,7,2,8,20,13,10,28]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends D.Disposable{constructor(m,E,h){super();this.environmentService=m,this.logService=E,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),E=JSON.parse(await T.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(E)){const g=E[y];m[`${g.hash}.${y}`]=!0}const h=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const d=await T.Promises.readdir(h);for(const y of d){if(m[y]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await T.Promises.rm((0,k.join)(h,y))}const v=Date.now();for(const y of Object.keys(m)){const g=(0,k.join)(h,y),l=await T.Promises.readdir(g);for(const c of l){if(c==="tcf.json")continue;const n=(0,k.join)(g,c),s=await T.Promises.stat(n);s.isDirectory()&&v-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(y,c)}`),await T.Promises.rm(n))}}}catch(m){(0,L.onUnexpectedError)(m)}}};i=he([X(0,C.INativeEnvironmentService),X(1,w.ILogService),X(2,b.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[35],ne([0,1,100,18]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,C){R.ok(L.isString(T)),R.ok(L.isObject(C)),R.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,C)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(te[87],ne([0,1,3,35]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,b){this.schemasById[D(w)]=b,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new k;L.Registry.add(e.Extensions.JSONContribution,T)}),define(te[38],ne([0,1,17,3,18,126,87,35]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=C.Registry.as(T.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,l=!0){this.registerConfigurations([g],l)}registerConfigurations(g,l=!0){const c=this.doRegisterConfigurations(g,l);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(g){const l=this.doDeregisterConfigurations(g);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}updateConfigurations({add:g,remove:l}){const c=[];c.push(...this.doDeregisterConfigurations(l)),c.push(...this.doRegisterConfigurations(g,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(c))}registerDefaultConfigurations(g){const l=[],c=[];for(const n of g)for(const s in n)if(l.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...n[s]};const r={type:"object",default:this.defaultValues[s],description:k.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(E(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=n[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(g){const l=[];for(const c of g)for(const n in c)if(l.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const s=this.configurationProperties[n];s&&(this.updatePropertyDefaultValue(n,s),this.updateSchema(n,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const l of g)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,l){const c=[];return g.forEach(n=>{c.push(...this.validateAndRegisterProperties(n,l,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),c}doDeregisterConfigurations(g){const l=[],c=n=>{if(n.properties)for(const s in n.properties)l.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s]);n.allOf&&n.allOf.forEach(s=>c(s))};for(const n of g){c(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return l}validateAndRegisterProperties(g,l=!0,c,n=3){n=D.isUndefinedOrNull(g.scope)?n:g.scope;let s=[],r=g.properties;if(r)for(let a in r){if(l&&d(a)){delete r[a];continue}const o=r[a];if(this.updatePropertyDefaultValue(a,o),e.OVERRIDE_PROPERTY_PATTERN.test(a)?o.scope=void 0:(o.scope=D.isUndefinedOrNull(o.scope)?n:o.scope,o.restricted=D.isUndefinedOrNull(o.restricted)?!!c?.restrictedConfigurations?.includes(a):o.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),s.push(a)}let t=g.allOf;if(t)for(let a of t)s.push(...this.validateAndRegisterProperties(a,l,c,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const l=c=>{let n=c.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let s=c.allOf;s&&s.forEach(l)};l(g)}updateSchema(g,l){switch(e.allSettings.properties[g]=l,l.scope){case 1:e.applicationSettings.properties[g]=l;break;case 2:e.machineSettings.properties[g]=l;break;case 6:e.machineOverridableSettings.properties[g]=l;break;case 3:e.windowSettings.properties[g]=l;break;case 4:e.resourceSettings.properties[g]=l;break;case 5:e.resourceSettings.properties[g]=l,this.resourceLanguageSettingsSchema.properties[g]=l;break}}removeFromSchema(g,l){switch(delete e.allSettings.properties[g],l.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const l=`[${g}]`,c={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,c),e.allSettings.properties[l]=c,e.applicationSettings.properties[l]=c,e.machineSettings.properties[l]=c,e.machineOverridableSettings.properties[l]=c,e.windowSettings.properties[l]=c,e.resourceSettings.properties[l]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,l){let c=this.defaultValues[g];D.isUndefined(c)&&(c=l.default),D.isUndefined(c)&&(c=h(l.type)),l.default=c}}const m="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(m);function E(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=E;function h(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const S=new I;C.Registry.add(e.Extensions.Configuration,S);function d(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?k.localize(5,null,y):S.getConfigurationProperties()[y]!==void 0?k.localize(6,null,y):null:k.localize(4,null)}e.validateProperty=d;function v(){const y=[],g=S.getConfigurationProperties();for(const l of Object.keys(g))y.push([l,g[l].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=v}),define(te[21],ne([0,1,26,18,9,38,6,35]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=w;var b;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(s,r){const t=r?s?r.keys.filter(O=>s.keys.indexOf(O)===-1):[...r.keys]:[],a=s?r?s.keys.filter(O=>r.keys.indexOf(O)===-1):[...s.keys]:[],o=[];if(r&&s){for(const O of s.keys)if(r.keys.indexOf(O)!==-1){const M=v(s.contents,O),N=v(r.contents,O);R.equals(M,N)||o.push(O)}}const u=[],f=O=>{const M={};for(const N of O)for(const P of N.identifiers)M[c(P)]=N;return M},p=r?f(r.overrides):{},A=s?f(s.overrides):{};if(Object.keys(p).length)for(const O of t){const M=p[O];M&&u.push([(0,k.overrideIdentifierFromKey)(O),M.keys])}if(Object.keys(A).length)for(const O of a){const M=A[O];M&&u.push([(0,k.overrideIdentifierFromKey)(O),M.keys])}if(Object.keys(p).length&&Object.keys(A).length)for(const O of o){const M=A[O],N=p[O];if(M&&N){const P=I({contents:M.contents,keys:M.keys,overrides:[]},{contents:N.contents,keys:N.keys,overrides:[]});u.push([(0,k.overrideIdentifierFromKey)(O),[...P.added,...P.removed,...P.updated]])}}return{added:t,removed:a,updated:o,overrides:u}}e.compare=I;function m(s,r){const t=[];for(const a of Object.keys(s))if(k.OVERRIDE_PROPERTY_PATTERN.test(a)){const o={};for(const u in s[a])o[u]=s[a][u];t.push({identifiers:[(0,k.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(o),contents:E(o,r)})}return t}e.toOverrides=m;function E(s,r){const t=Object.create(null);for(let a in s)h(t,a,s[a],r);return t}e.toValuesTree=E;function h(s,r,t,a){const o=r.split("."),u=o.pop();let f=s;for(let p=0;p<o.length;p++){let A=o[p],O=f[A];switch(typeof O){case"undefined":O=f[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${o.slice(0,p+1).join(".")} is ${JSON.stringify(O)}`);return}f=O}if(typeof f=="object"&&f!==null)try{f[u]=t}catch(p){a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(f)}`)}else a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=h;function S(s,r){const t=r.split(".");d(s,t)}e.removeFromValueTree=S;function d(s,r){const t=r.shift();if(r.length===0){delete s[t];return}if(Object.keys(s).indexOf(t)!==-1){const a=s[t];typeof a=="object"&&!Array.isArray(a)&&(d(a,r),Object.keys(a).length===0&&delete s[t])}}function v(s,r,t){function a(f,p){let A=f;for(const O of p){if(typeof A!="object"||A===null)return;A=A[O]}return A}const o=r.split("."),u=a(s,o);return typeof u=="undefined"?t:u}e.getConfigurationValue=v;function y(s,r,t){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?L.isObject(s[a])&&L.isObject(r[a])?y(s[a],r[a],t):t&&(s[a]=r[a]):s[a]=r[a])})}e.merge=y;function g(){const s=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=g;function l(){const s=Object.create(null),r=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let t in r){let a=r[t].default;h(s,t,a,o=>console.error(`Conflict in default settings: ${o}`))}return s}e.getDefaultValues=l;function c(s){return`[${s}]`}e.keyFromOverrideIdentifier=c;function n(s,r,t){const a=s.inspect(r),o=s.inspect(t);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:a.defaultValue}e.getMigratedSettingValue=n}),define(te[88],ne([0,1,17,3,33,2,40,26,18,9,21,38,35]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(n={},s=[],r=[]){this._contents=n,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,s){const r=this.getContentsForOverrideIdentifer(s);return r?n?(0,i.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){for(const s of this.overrides)if(s.identifiers.indexOf(n)!==-1)return s.keys;return[]}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=C.deepClone(this.contents),r=C.deepClone(this.overrides),t=[...this.keys];for(const a of n){this.mergeContents(s,a.contents);for(const o of a.overrides){const[u]=r.filter(f=>R.equals(f.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):r.push(C.deepClone(o))}for(const o of a.keys)t.indexOf(o)===-1&&t.push(o)}return new E(s,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const t of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[t],o=s[t];o&&(typeof a=="object"&&typeof o=="object"?(a=C.deepClone(a),this.mergeContents(a,o)):a=o),r[t]=a}return new E(r,this.keys,this.overrides)}mergeContents(n,s){for(const r of Object.keys(s)){if(r in n&&w.isObject(n[r])&&w.isObject(s[r])){this.mergeContents(n[r],s[r]);continue}n[r]=C.deepClone(s[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?C.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const s of this.overrides)if(s.identifiers.indexOf(n)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,s){this.addKey(n),(0,i.addToValueTree)(this.contents,n,s,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let s=this.keys.length;for(let r=0;r<s;r++)n.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,n)}removeKey(n){let s=this.keys.indexOf(n);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(){const n=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),r=[];for(const t of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(t)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(n[t]),contents:(0,i.toValuesTree)(n[t],a=>console.error(`Conflict in default settings file: ${a}`))});super(n,s,r)}}e.DefaultConfigurationModel=h;class S{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!w.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:r,keys:t,overrides:a,restricted:o}=this.doParseRaw(n,s);this._configurationModel=new E(r,t,a),this._restrictedConfigurations=o||[]}doParseContent(n){let s={},r=null,t=[],a=[],o=[];function u(p){Array.isArray(t)?t.push(p):r!==null&&(t[r]=p)}let f={onObjectBegin:()=>{let p={};u(p),a.push(t),t=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{let p=[];u(p),a.push(t),t=p,r=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:u,onError:(p,A,O)=>{o.push({error:p,offset:A,length:O})}};if(n)try{D.visit(n,f),s=t[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return s}doParseRaw(n,s){const r=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(n,r,!0,s);n=t.raw;const a=(0,i.toValuesTree)(n,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),o=Object.keys(n),u=(0,i.toOverrides)(n,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:a,keys:o,overrides:u,restricted:t.restricted}}filter(n,s,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:n,restricted:[]};const a={},o=[];for(let u in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const f=this.filter(n[u],s,!1,t);a[u]=f.raw,o.push(...f.restricted)}else{const f=s[u],p=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&o.push(u),(p===void 0||t.scopes===void 0||t.scopes.includes(p))&&(t.skipRestricted&&f?.restricted||(a[u]=n[u]))}return{raw:a,restricted:o}}}e.ConfigurationModelParser=S;class d extends k.Disposable{constructor(n,s,r,t){super();this.userSettingsResource=n,this.scopes=s,this.fileService=t,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class v{constructor(n,s,r=new E,t=new E,a=new T.ResourceMap,o=new E,u=new T.ResourceMap,f=!0){this._defaultConfiguration=n,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=a,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(n)}updateValue(n,s,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new E,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,s===void 0?t.removeValue(n):t.setValue(n,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,r){const t=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),o=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),f=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),p=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),O=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,M=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(n):a.freeze().getValue(n):void 0,N=s.overrideIdentifier?o.override(s.overrideIdentifier).getValue(n):o.getValue(n),P=t.getValue(n),F=R.distinct(R.flatten(t.overrides.map(q=>q.identifiers))).filter(q=>t.getOverrideValue(n,q)!==void 0);return{defaultValue:u,userValue:f,userLocalValue:p,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:M,memoryValue:N,value:P,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,user:f!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspaceFolder:M!==void 0?{value:a?.freeze().getValue(n),override:s.overrideIdentifier?a?.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:o.getValue(n),override:s.overrideIdentifier?o.getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const r=s.filter(t=>I.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const a=(0,I.overrideIdentifierFromKey)(t),o=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=n.getKeysForOverrideIdentifier(a),f=[...u.filter(p=>o.indexOf(p)===-1),...o.filter(p=>u.indexOf(p)===-1),...o.filter(p=>!C.equals(this._defaultConfiguration.override(a).getValue(p),n.override(a).getValue(p)))];return[a,f]});return this.updateDefaultConfiguration(n),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:r,removed:t,overrides:a}=(0,i.compare)(this.localUserConfiguration,n),o=[...s,...r,...t];return o.length&&this.updateLocalUserConfiguration(n),{keys:o,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:r,removed:t,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,n);let o=[...s,...r,...t];return o.length&&this.updateRemoteUserConfiguration(n),{keys:o,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:r,removed:t,overrides:a}=(0,i.compare)(this.workspaceConfiguration,n);let o=[...s,...r,...t];return o.length&&this.updateWorkspaceConfiguration(n),{keys:o,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const r=this.folderConfigurations.get(n),{added:t,updated:a,removed:o,overrides:u}=(0,i.compare)(r,s);let f=[...t,...a,...o];return(f.length||!r)&&this.updateFolderConfiguration(n,s),{keys:f,overrides:u}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:t,removed:a,overrides:o}=(0,i.compare)(s,void 0);return{keys:[...r,...t,...a],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,s){let r=this.getConsolidatedConfigurationModelForResource(n,s);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const t=s.getFolder(n);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const a=this._memoryConfigurationByResource.get(n);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(n);t?(s=r.merge(t),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(n,s)):s=r}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const r=s.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:r,overrides:t,keys:a}=this._folderConfigurations.get(s);return n.push([s,{contents:r,overrides:t,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>n.add(s)),this.userConfiguration.freeze().keys.forEach(s=>n.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),t=this.parseConfigurationModel(n.workspace),a=n.folders.reduce((o,u)=>(o.set(b.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new T.ResourceMap);return new v(s,r,new E,t,a,new E,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=v;function y(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,s=new Map;for(const t of c)t.keys.forEach(a=>n.add(a)),t.overrides.forEach(([a,o])=>{const u=(0,T.getOrSet)(s,a,new Set);o.forEach(f=>u.add(f))});const r=[];return s.forEach((t,a)=>r.push([a,[...t.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=y;class g{constructor(n,s,r,t){this.change=n,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const a=new Set;n.keys.forEach(u=>a.add(u)),n.overrides.forEach(([,u])=>u.forEach(f=>a.add(f))),this.affectedKeys=[...a.values()];const o=new E;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!C.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(n,s){let r=(0,i.toValuesTree)({[s]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(n=n[t],!n)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=g;class l extends g{constructor(n,s,r,t){super({keys:n.allKeys(),overrides:[]},void 0,n,s);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=l}),define(te[182],ne([0,1,5,3,2,16,21,88,38,35]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(m,E){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,E)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,E){const h=typeof m=="string"?m:void 0,S=(0,T.isConfigurationOverrides)(m)?m:(0,T.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(h,S,void 0)}updateValue(m,E,h,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,E,1)}onDidDefaultConfigurationChange(m){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,m);this.trigger(h,E,6)}trigger(m,E,h){const S=new C.ConfigurationChangeEvent(m,{data:E},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[183],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(T,C=L.Unknown,w){super(T);this._message=T,this._code=C,this._detail=w,this.isHandled=C===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(T){return T instanceof D&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof D&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof D&&T.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[184],ne([0,1,5,19,27,7,3,2,29,71,183]),function(J,e,R,L,D,k,T,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var m;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function E(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const B=new D.CancellationTokenSource;return setTimeout(()=>B.cancel(),U),B.token}function S(U,B){if(U.isCancellationRequested||B.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return U.onCancellationRequested(()=>W.cancel()),B.onCancellationRequested(()=>W.cancel()),W.token}class d{constructor(B){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((W,Q)=>{this._resolvePromise=W,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function v(U,B){const W=new d(B);return W.registerDisposable(U.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),G=H(Z);G?W.reject(G):W.resolve(Z)})),W.promise}function y(U,B,W,Q,Z,G){const V=new d(G);return B.connect(W,Q,Z,(re,ie)=>{V.didTimeout?(re&&U.error(re),ie?.dispose()):re||!ie?V.reject(re):V.resolve(ie)}),V.promise}function g(U,B){const W=new d(B);return U.then(Q=>{W.didTimeout||W.resolve(Q)},Q=>{W.didTimeout||W.reject(Q)}),W.promise}async function l(U,B,W,Q){const Z=z(U,B);U.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let G;try{G=await y(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw U.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),U.logService.error(le),le}U.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let V,re;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(G,null),V=U.reconnectionProtocol,re=!1):(V=new b.PersistentProtocol(G,null),re=!0),U.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await g(U.signService.createNewMessage((0,w.generateUuid)()),Q),ce={type:"auth",auth:U.connectionToken||"00000000000000000000",data:ie.data};V.sendControl(L.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await v(V,S(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(U.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await g(U.signService.validate(ie,le.signedData),Q)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await g(U.signService.sign(le.data),Q),be={type:"connectionType",commit:U.commit,signedData:fe,desiredConnectionType:B};return W&&(be.args=W),U.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(L.VSBuffer.fromString(JSON.stringify(be))),{protocol:V,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(U.logService.error(`${Z} the handshake timed out. Error:`),U.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${Z} received error control message when negotiating connection. Error:`),U.logService.error(le)),re&&$(V),le}}async function c(U,B,W,Q){const Z=Date.now(),G=z(U,B),{protocol:V,ownsProtocol:re}=await l(U,B,W,Q),ie=new d(Q);return ie.registerDisposable(V.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),de=H(le);de?(U.logService.error(`${G} received error control message when negotiating connection. Error:`),U.logService.error(de),re&&$(V),ie.reject(de)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${Y(Z)}!`),ie.resolve({protocol:V,firstMessage:le}))})),ie.promise}async function n(U,B){const{protocol:W}=await c(U,1,void 0,B);return{protocol:W}}async function s(U,B,W){const{protocol:Q,firstMessage:Z}=await c(U,2,B,W),G=Z&&Z.debugPort;return{protocol:Q,debugPort:G}}async function r(U,B,W){const Q=Date.now(),Z=z(U,3),{protocol:G}=await l(U,3,B,W);return U.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${Y(Q)}!`),G}async function t(U,B,W){const{host:Q,port:Z,connectionToken:G}=await U.addressProvider.getAddress();return{commit:U.commit,host:Q,port:Z,connectionToken:G,reconnectionToken:B,reconnectionProtocol:W,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function a(U,B,W){try{const Q=(0,w.generateUuid)(),Z=await t(U,Q,null),{protocol:G}=await n(Z,D.CancellationToken.None);return new q(U,B,W,Q,G)}catch(Q){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(Q),F.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=a;async function o(U,B){try{const W=(0,w.generateUuid)(),Q=await t(U,W,null),{protocol:Z,debugPort:G}=await s(Q,B,D.CancellationToken.None);return new _(U,B,W,Z,G)}catch(W){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(W),F.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=o;async function u(U,B,W){const Q=await t(U,(0,w.generateUuid)(),null);return await r(Q,{host:B,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function f(U){return(0,R.createCancelablePromise)(B=>new Promise((W,Q)=>{const Z=setTimeout(W,U*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),W()})}))}var p;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(p=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(B,W){this.reconnectionToken=B,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=A;class O{constructor(B,W,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=W,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class M{constructor(B,W,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=W,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=M;class N{constructor(B,W,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=W,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=N;class P{constructor(B,W,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=W,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=P;class F extends C.Disposable{constructor(B,W,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(G=>{const V=x(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${V} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${V} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${V} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const G=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),F._instances.push(this),F._permanentFailure&&this._gotoPermanentFailure(F._permanentFailureMillisSinceLastIncomingData,F._permanentFailureAttempt,F._permanentFailureHandled)}static triggerPermanentFailure(B,W,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=W,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(F._permanentFailure)return;const B=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<W.length?W[Q]:W[W.length-1];try{if(Z>0){const V=f(Z);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,V)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await V}catch{}}if(F._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const G=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(I)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,k.isPromiseCanceledError)(G)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,i.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!F._permanentFailure)}_gotoPermanentFailure(B,W,Q){this._onDidStateChange.fire(new P(this.reconnectionToken,B,W,Q)),$(this.protocol)}}F._permanentFailure=!1,F._permanentFailureMillisSinceLastIncomingData=0,F._permanentFailureAttempt=0,F._permanentFailureHandled=!1,F._instances=[];class q extends F{constructor(B,W,Q,Z,G){super(1,B,Z,G);this.client=this._register(new b.Client(G,{remoteAuthority:W,clientId:Q},B.ipcLogger))}async _reconnect(B,W){await n(B,W)}}e.ManagementPersistentConnection=q;class _ extends F{constructor(B,W,Q,Z,G){super(2,B,Q,Z);this._startArguments=W,this.debugPort=G}async _reconnect(B,W){await s(B,this._startArguments,W)}}e.ExtensionHostPersistentConnection=_;function $(U){try{U.acceptDisconnect();const B=U.getSocket();U.dispose(),B.dispose()}catch(B){(0,k.onUnexpectedError)(B)}}function H(U){if(U&&U.type==="error"){const B=new Error(`Connection error: ${U.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function j(U,B){for(;U.length<B;)U+=" ";return U}function x(U,B,W){return`[remote-connection][${j(E(U),13)}][${B.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function z(U,B){return`${x(B,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function Y(U){return`${Date.now()-U} ms`}}),define(te[185],ne([0,1,15]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(b){return b.scheme===R.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=L;function D(b){if(!b)return;const i=b.indexOf("+");return i<0?b:b.substr(0,i)}e.getRemoteName=D;function k(b){return b.scheme!==R.Schemas.file&&b.scheme!==R.Schemas.vscodeRemote}e.isVirtualResource=k;function T(b){if(b.folders.length)return b.folders.every(i=>k(i.uri))?b.folders[0].uri:void 0;if(b.configuration&&k(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=T;function C(b){return T(b)?.scheme}e.getVirtualWorkspaceScheme=C;function w(b){return T(b)!==void 0}e.isVirtualWorkspace=w}),define(te[89],ne([0,1,25,6,185]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=k;function T(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class w{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let S=typeof E=="string"?E:E.value,d=typeof h=="string"?h:h.value;return R.equalsIgnoreCase(S,d)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=w;function b(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function i(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(m,E){if(E&&m.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(E)}`;return m.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,89]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,S){return h.uuid&&S.uuid?h.uuid===S.uuid:h.id===S.id?!0:(0,R.compareIgnoreCase)(h.id,S.id)===0}e.areSameExtensions=D;class k{constructor(S,d){this.version=d,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof k?D(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=k;function T(h,S){return`${h}.${S}`}e.getExtensionId=T;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function w(h,S){return C(T(h,S))}e.getGalleryExtensionId=w;function b(h,S){const d=[],v=y=>{for(const g of d)if(g.some(l=>D(S(l),S(y))))return g;return null};for(const y of h){const g=v(y);g?g.push(y):d.push([y])}return d}e.groupByExtension=b;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function m(h){const S=new Set;for(const d of h)d.malicious&&S.add(d.id.id);return S}e.getMaliciousExtensionsSet=m;function E(h,S){const d=[],v=S.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const y=v.shift();if(y&&d.every(g=>!D(g.identifier,{id:y}))){const g=h.filter(l=>D(l.identifier,{id:y}));g.length===1&&(d.push(g[0]),v.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=E}),define(te[186],ne([0,1,5,7,2,4,16,61,9,29,20,13,30,36,14,10]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends D.Disposable{constructor(g,l,c,n){super();this.fileService=l,this.extensionGalleryService=c,this.logService=n,this.extensionsDownloadDir=w.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,l){await this.cleanUpPromise;const c=this.getName(g),n=(0,T.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(n)){const s=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(g,s,l);try{await this.rename(s,n,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(t){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return n}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,l,c){try{await i.Promises.rename(g.fsPath,l.fsPath)}catch(n){if(k.isWindows&&n&&n.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${g} to ${l} with 'EPERM' error. Trying again...`),this.rename(g,l,c);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const l=[],c=[];for(const r of g.children){const t=this.parse(r.name);t&&c.push([t,r])}const n=(0,E.groupByExtension)(c,([r])=>r),s=[];for(const r of n)r.sort((t,a)=>C.rcompare(t[0].version,a[0].version)),l.push(...r.slice(1).map(t=>t[1].resource)),s.push(r[0][1]);s.sort((r,t)=>r.mtime-t.mtime),l.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await R.Promises.settled(l.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new E.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(g){const l=d.exec(g);return l&&l[1]&&l[2]?new E.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};v=he([X(0,I.INativeEnvironmentService),X(1,h.IFileService),X(2,m.IExtensionGalleryService),X(3,S.ILogService)],v),e.ExtensionsDownloader=v}),define(te[187],ne([0,1,2,8,20,89]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends R.Disposable{constructor(w,b){super();this.environmentService=w,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(b.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(w){w.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(te[188],ne([0,1,3,2,16,9,13,36,14,10]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(m,E,h,S){super();this.extensionsManagementService=m,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(y=>this.onInstallExtension(y))),this._register(m.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(m.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const d=k.URI.file(h.extensionsPath),v=new D.ExtUri(y=>!E.hasCapability(y,1024));this._register(E.watch(d)),this._register(R.Event.filter(E.onDidChangeFilesRaw,y=>y.changes.some(g=>this.doesChangeAffects(g,d,v)))(()=>this.onDidChange()))}doesChangeAffects(m,E,h){return h.isEqual(h.dirname(m.resource),E)?h.isEqual(m.resource,h.joinPath(E,".obsolete"))?!0:!(m.type!==1&&m.type!==2||h.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const E of m)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(E=>!(0,C.areSameExtensions)(E,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,C.areSameExtensions)(E,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),E=m.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,C.areSameExtensions)(d,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(d=>(0,C.areSameExtensions)(d,S))?!1:m.every(d=>!(0,C.areSameExtensions)(d.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=m.map(S=>S.identifier),(E.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:h})}}};i=he([X(1,w.IFileService),X(2,T.INativeEnvironmentService),X(3,b.ILogService)],i),e.ExtensionsWatcher=i}),define(te[189],ne([0,1,82,17,5,2,15,8,20,13,30,36,58,10]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(v,y,g){super();this.extensionManagementService=v,this.logService=g,this.cache=this._register(new S(y,g)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),y=["en",...Object.keys(v)];return(0,L.distinct)(y)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const y=await this.cache.getLanguagePacks();Object.keys(y).some(g=>y[g]&&y[g].extensions.some(l=>(0,I.areSameExtensions)(l.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(y);return!(0,L.equals)(Object.keys(v),Object.keys(g))}};h=he([X(0,i.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,E.ILogService)],h),e.LocalizationsService=h;let S=class extends k.Disposable{constructor(v,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(y=>{Object.keys(y).forEach(g=>delete y[g]),this.createLanguagePacksFromExtensions(y,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...y){for(const g of y)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,g);Object.keys(v).forEach(g=>this.updateHash(v[g]))}createLanguagePacksFromExtension(v,y){const g=y.identifier,l=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const c of l)if(y.location.scheme===T.Schemas.file&&(0,m.isValidLocalization)(c)){let n=v[c.languageId];n||(n={hash:"",extensions:[],translations:{}},v[c.languageId]=n);let s=n.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,g))[0];s?s.version=y.manifest.version:n.extensions.push({extensionIdentifier:g,version:y.manifest.version});for(const r of c.translations)n.translations[r.id]=(0,C.join)(y.location.fsPath,r.path)}}updateHash(v){if(v){const y=(0,R.createHash)("md5");for(const g of v.extensions)y.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);v.hash=y.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch(l){return{}}}).then(g=>(y=v(g),g)).then(g=>{for(const c of Object.keys(g))g[c]||delete g[c];this.languagePacks=g,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),w.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>y,g=>this.logService.error(g))})}};S=he([X(0,b.INativeEnvironmentService),X(1,E.ILogService)],S)}),define(te[190],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,10]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var T;(function(h){h.Http="http",h.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function m(h,S){return S?S!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=m;let E=class{constructor(S){this.logService=S,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S,d){return this._tunnelProvider=S,S?(this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],d=Array.from(this._tunnels.values());for(let v of d){const y=Array.from(v.values());for(let g of y){const l=await g.value;l&&S.push(l)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:d}of S.values())await d.then(v=>v?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,d,v,y,g=!1,l=C.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${v} on local port ${y}.`),!S)return;d||(d="localhost");const n=this.retainOrCreateTunnel(S,d,v,y,g,l,c);return n?n.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==d||s.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const d=this._tunnels.get(S.tunnelRemoteHost);if(d){const v=d.get(S.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,v))}}}}async tryDisposeTunnel(S,d,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${d}.`);const y=v.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(d),y}}async closeTunnel(S,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${d} `);const v=this._tunnels.get(S);if(v&&v.has(d)){const y=v.get(d);y.refcount=0,await this.tryDisposeTunnel(S,d,y)}}addTunnelToMap(S,d,v){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(d,{refcount:1,value:v})}async removeEmptyTunnelFromMap(S,d){const v=this._tunnels.get(S);v&&(await v.get(d)||v.delete(d),v.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,d){let v=[S];i(S)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(S)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const y=v.map(g=>this._tunnels.get(g));for(const g of y){const l=g?.get(d);if(l)return l}}canTunnel(S){return!!b(S)}createWithProvider(S,d,v,y,g,l,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${v} on local port ${y}.`);const s={elevationRequired:g?m(y===void 0?v:y):!1},r={remoteAddress:{host:d,port:v},localAddressPort:y,privacy:l,public:l!==C.Private,protocol:c},t=S.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,v,t),t}};E=he([X(0,k.ILogService)],E),e.AbstractTunnelService=E}),define(te[191],ne([0,1,10,62,2,7,5]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class C extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(i){this._address=i,this._addressPromise&&(this._addressPromise.complete(i),this._addressPromise=null)}setTunnel(i){this._register(i)}}let w=class St extends D.Disposable{constructor(i,I){super();this._tunnelService=i,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(i=>i.dispose())}async createTunnel(){return{id:String(++St._lastId)}}async startTunnel(i,I,m,E,h){const S=new C,d=await Promise.resolve(this._tunnelService.openTunnel(S,I,m,E,h));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${I}:${m} (remote).`),S.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(i))throw this._disposedTunnels.delete(i),S.dispose(),await d.dispose(),(0,k.canceled)();return S.setTunnel(d),this._tunnels.set(i,S),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${i}: ${d.localAddress} (local) to ${I}:${m} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(i,I){const m=this._tunnels.get(i);!m||m.setAddress(I)}async destroyTunnel(i){const I=this._tunnels.get(i);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${i}.`),this._tunnels.delete(i),await I.dispose();return}this._disposedTunnels.add(i)}};w._lastId=0,w=he([X(0,L.ITunnelService),X(1,R.ILogService)],w),e.SharedProcessTunnelService=w}),define(te[192],ne([0,1,120,21,10]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(C,w){this.configurationService=C,this.logService=w}request(C,w){return this.logService.trace("RequestService#request",C.url),C.proxyAuthorization||(C.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(C,w)}async resolveProxy(C){}};k=he([X(0,L.IConfigurationService),X(1,D.ILogService)],k),e.RequestService=k}),define(te[43],ne([0,1,19,141,38,6,35]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function C(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=C;function w(h){return h.res.statusCode===204}async function b(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);return w(h)?null:(await(0,R.streamToBuffer)(h.stream)).toString()}e.asText=b;async function i(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const d=(await(0,R.streamToBuffer)(h.stream)).toString();try{return JSON.parse(d)}catch(v){throw v.message+=`:
`+d,v}}e.asJson=i;function I(h){E(h)}e.updateProxyConfigurationsScope=I;let m;function E(h){const S=T.Registry.as(D.Extensions.Configuration),d=m;m={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[m],remove:d?[d]:[]})}E(2)}),define(te[193],ne([0,1,27,15,14,43]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(w,b){this.requestService=w,this.fileService=b}async download(w,b,i=R.CancellationToken.None){if(w.scheme===L.Schemas.file||w.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(w,b);return}const I={type:"GET",url:w.toString()},m=await this.requestService.request(I,i);if(m.res.statusCode===200)await this.fileService.writeFile(b,m.stream);else{const E=await(0,k.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${E}`)}}};T=he([X(0,k.IRequestService),X(1,D.IFileService)],T),e.DownloadService=T}),define(te[194],ne([0,1,17,27,66,2,16,153,14,10,28,43]),function(J,e,R,L,D,k,T,C,w,b,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends k.Disposable{constructor(h,S,d,v){super();this.fileService=h,this.productService=S,this.requestService=d,this.logService=v,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const S=[];for(const[d,v]of this.allConfigBasedTips)if(!(v.configScheme&&v.configScheme!==h.scheme))try{const y=await this.fileService.readFile((0,T.joinPath)(h,d)),g=new Map;(0,D.forEach)(v.recommendations,({key:c,value:n})=>{if((0,R.isNonEmptyArray)(n.remotes))for(const s of n.remotes)g.set(s,{extensionId:c,extensionName:n.name,configName:v.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack});else S.push({extensionId:c,extensionName:n.name,configName:v.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack})});const l=(0,C.getDomainsOfRemotes)(y.value.toString(),[...g.keys()]);for(const c of l){const n=g.get(c);n&&S.push(n)}}catch(y){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(h.res.statusCode!==200)return[];const S=await(0,I.asJson)(h);return S?S.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};m=he([X(0,w.IFileService),X(1,i.IProductService),X(2,I.IRequestService),X(3,b.ILogService)],m),e.ExtensionTipsService=m}),define(te[46],ne([0,1,19,29]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,T,C){let w=C&&C.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await T.readFile(k.serviceMachineIdResource)).value.toString();w=(0,L.isUUID)(i)?i:null}catch(b){w=null}if(!w){w=(0,L.generateUuid)();try{await T.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(w))}catch(b){}}return C&&C.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=D}),define(te[90],ne([0,1,104,6]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(k){return(0,R.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,L.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[195],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(L){L.Spawn="vscode:shared-process->shared-process-worker=spawn",L.Terminate="vscode:shared-process->shared-process-worker=terminate",L.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",L.Ready="vscode:shared-process-worker->shared-process=ready",L.Ack="vscode:shared-process-worker->shared-process=ack",L.Trace="vscode:shared-process-worker->shared-process=trace",L.Info="vscode:shared-process-worker->shared-process=info",L.Warn="vscode:shared-process-worker->shared-process=warn",L.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[196],ne([0,1,72,27,3,2,15,29,10,90,195]),function(J,e,R,L,D,k,T,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let I=class{constructor(h){this.logService=h,this.workers=new Map,this.processes=new Map}async createWorker(h){const S=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${S})`);const d=(0,b.hash)(h);this.processes.has(d)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${S})`),this.disposeWorker(h));const v=new L.CancellationTokenSource;let y,g,l;if(this.processes.set(d,(0,k.toDisposable)(()=>{v.dispose(!0),y?.terminate(h,L.CancellationToken.None),g?.close(),l?.close(),this.processes.delete(d)})),y=await this.getOrCreateWebWorker(h),v.token.isCancellationRequested)return;const{port1:c,port2:n}=new MessageChannel;g=c,l=n,await y.spawn(h,l,v.token),!v.token.isCancellationRequested&&(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${S})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",h,[g]))}getOrCreateWebWorker(h){let S=this.workers.get(h.process.moduleId);if(!S){this.logService.trace(`SharedProcess: creating new web worker (${h.process.moduleId})`);const d=new m(h.process.type,this.logService);S=d.init(),d.onDidProcessSelfTerminate(v=>{this.disposeWorker(v)}),this.workers.set(h.process.moduleId,S)}return S}async disposeWorker(h){const S=this.processes.get((0,b.hash)(h));S&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),S.dispose())}};I=he([X(0,w.ILogService)],I),e.SharedProcessWorkerService=I;class m extends k.Disposable{constructor(h,S){super();this.type=h,this.logService=S,this._onDidProcessSelfTerminate=this._register(new D.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let h;const S=new Promise(v=>h=v),d=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return d.onerror=v=>{this.logService.error(`SharedProcess: worker error (${this.type})`,v.message)},d.onmessageerror=v=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,v)},d.onmessage=v=>{const{id:y,message:g,configuration:l,nonce:c}=v.data;switch(y){case i.SharedProcessWorkerMessages.Ready:h(d);break;case i.SharedProcessWorkerMessages.Ack:if(c){const n=this.mapMessageNonceToPendingMessageResolve.get(c);n&&(this.mapMessageNonceToPendingMessageResolve.delete(c),n())}break;case i.SharedProcessWorkerMessages.SelfTerminated:l&&this._onDidProcessSelfTerminate.fire(l);break;case i.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,g);break;case i.SharedProcessWorkerMessages.Info:g&&this.logService.info(g);break;case i.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,g);break;case i.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,g);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,v)}},d.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S}async send(h,S,d){const v=await this.workerReady;if(!S.isCancellationRequested)return new Promise(y=>{const g=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(g,y);const l={...h,nonce:g};d?v.postMessage(l,[d]):v.postMessage(l),S.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(g)&&y()})})}spawn(h,S,d){const v={id:i.SharedProcessWorkerMessages.Spawn,configuration:h,environment:{bootstrapPath:T.FileAccess.asFileUri("bootstrap-fork",J).fsPath}};return this.send(v,d,S)}terminate(h,S){const d={id:i.SharedProcessWorkerMessages.Terminate,configuration:h};return this.send(d,S)}}}),define(te[91],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[197],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((D,k)=>J(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.vsda(),T=new k.validator;if(T){const C=String(R._nextId++);return this.validators.set(C,T),{id:C,data:T.createNewMessage(D)}}}catch(k){}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const T=this.validators.get(D.id);if(!T)return!1;this.validators.delete(D.id);try{return T.validate(k)==="ok"}catch(C){return!1}}async sign(D){try{const k=await this.vsda(),T=new k.signer;if(T)return T.sign(D)}catch(k){}return D}}e.SignService=R,R._nextId=1}),define(te[23],ne([0,1,5,3,2,18,73,6]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var b;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class m extends D.Disposable{constructor(d={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,v){v===w?(d===0?this._globalKeyTargets=void 0:d===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:d})):this._onDidChangeValue.fire({scope:d,key:v,target:this.getKeyTargets(d)[v]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,v,y){return this.getStorage(v)?.get(d,y)}getBoolean(d,v,y){return this.getStorage(v)?.getBoolean(d,y)}getNumber(d,v,y){return this.getStorage(v)?.getNumber(d,y)}store(d,v,y,g){if((0,k.isUndefinedOrNull)(v)){this.remove(d,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,y,g),this.getStorage(y)?.set(d,v)})}remove(d,v){this.withPausedEmitters(()=>{this.updateKeyTarget(d,v,void 0),this.getStorage(v)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,v){const y=[],g=this.getKeyTargets(d);for(const l of Object.keys(g))g[l]===v&&y.push(l);return y}updateKeyTarget(d,v,y){const g=this.getKeyTargets(v);typeof y=="number"?g[d]!==y&&(g[d]=y,this.getStorage(v)?.set(w,JSON.stringify(g))):typeof g[d]=="number"&&(delete g[d],this.getStorage(v)?.set(w,JSON.stringify(g)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(d){return d===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(d){const v=this.get(w,d);if(v)try{return JSON.parse(v)}catch(y){}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=b.NONE){this._onWillSaveState.fire({reason:d}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const d=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return h(d,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends m{constructor(){super();this.globalStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.globalStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d)))}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(d){}}e.InMemoryStorageService=E;async function h(S,d,v,y){const g=a=>{try{return JSON.parse(a)}catch(o){return a}},l=new Map,c=new Map;S.forEach((a,o)=>{l.set(o,a),c.set(o,g(a))});const n=new Map,s=new Map;d.forEach((a,o)=>{n.set(o,a),s.set(o,g(a))}),console.group(`Storage: Global (path: ${v})`);let r=[];l.forEach((a,o)=>{r.push({key:o,value:a})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${y})`);let t=[];n.forEach((a,o)=>{t.push({key:o,value:a})}),console.table(t),console.groupEnd(),console.log(s)}e.logStorage=h}),define(te[198],ne([0,1,3,2,18,30,36,23]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends L.Disposable{constructor(I){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(I)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(I,m){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:m}),!0):!1}async disableExtension(I,m){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let m=this.getDisabledExtensions();return m.every(E=>!(0,T.areSameExtensions)(E,I))?(m.push(I),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(I){let m=this.getDisabledExtensions();for(let E=0;E<m.length;E++){const h=m[E];if((0,T.areSameExtensions)(h,I))return m.splice(E,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(I){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,m){this.storageManger.set(I,m,0)}};w=he([X(0,C.IStorageService)],w),e.GlobalExtensionEnablementService=w;class b extends L.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(I,m){let E;return m===0?((0,D.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,m)),E=this.storage[I]):E=this._get(I,m),JSON.parse(E)}set(I,m,E){let h=JSON.stringify(m.map(({id:d,uuid:v})=>({id:d,uuid:v})));this._get(I,E)!==h&&(E===0&&(m.length?this.storage[I]=h:delete this.storage[I]),this._set(I,m.length?h:void 0,E))}onDidStorageChange(I){if(I.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const E=this.get(I.key,I.scope);delete this.storage[I.key];const h=this.get(I.key,I.scope),S=E.filter(v=>!h.some(y=>(0,T.areSameExtensions)(v,y))),d=h.filter(v=>!E.some(y=>(0,T.areSameExtensions)(y,v)));(S.length||d.length)&&this._onDidChange.fire([...S,...d])}}_get(I,m){return this.storageService.get(I,m,"[]")}_set(I,m,E){m?this.storageService.store(I,m,E,1):this.storageService.remove(I,E)}}e.StorageManager=b}),define(te[199],ne([0,1,3,2]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i}async getItems(){const b={workspace:this.workspace},i=await this.channel.call("getItems",b);return new Map(i)}updateItems(b){const i={workspace:this.workspace};return b.insert&&(i.insert=Array.from(b.insert.entries())),b.delete&&(i.delete=Array.from(b.delete.values())),this.channel.call("updateItems",i)}}class k extends D{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class T extends D{constructor(b,i){super(b,i);this.onDidChangeItemsExternal=R.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class C extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=C}),define(te[200],ne([0,1,5,2,178,16,73,23,199]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends C.AbstractStorageService{constructor(I,m,E){super();this.mainProcessService=m,this.environmentService=E,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new w.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new T.Storage(I.globalStorage);return this._register(m.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),m}createWorkspaceStorage(I){const m=new w.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(m.workspaceStorage){const E=new T.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=E.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=I?.id,E}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,D.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,D.mark)("code/didInitStorage")}}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(C.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const m=this.workspaceStorage,E=m?.items??new Map;m&&(await m.close(),m.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[h,S]of E)this.workspaceStorage.set(h,S)}}e.NativeStorageService=b}),define(te[201],ne([0,1,4,31,9,29]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(R.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function C(b,i,I,m,E,h,S,d,v,y){const g=Object.create(null);g["common.machineId"]=S,g.sessionID=(0,k.generateUuid)()+Date.now(),g.commitHash=E,g.version=h,g["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,R.PlatformToString)(R.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=m,g["common.product"]=y||"desktop";const l=w(d||[]);l&&(g["common.msftInternal"]=l);let c=0;const n=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),R.isLinuxSnap&&(g["common.snap"]="true");const s=T(I);s&&(g["common.platformDetail"]=s);try{const r=await b.readFile(D.URI.file(v));g["common.source"]=r.value.toString().slice(0,30)}catch(r){}return g}e.resolveCommonProperties=C;function w(b){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return b.some(m=>I===m)}e.verifyMicrosoftInternalDomain=w}),define(te[22],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[202],ne([0,1,34,55,5,33,15,8,4,9,113,20,116,78,14,28,22]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(n,s){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],t=new Map,a=new Map,o=2e4;function u(A,O,M,N){const P=O.substring(A.length+1);return D.Promises.withAsyncBody(async F=>{let q;try{q=await I.Promises.readdir(O,{withFileTypes:!0})}catch(H){F();return}if(N.count>=o){N.count+=q.length,N.maxReached=!0,F();return}let _=q.length;if(_===0){F();return}let $=q;N.count+q.length>o&&(N.maxReached=!0,_=o-N.count,$=q.slice(0,_)),N.count+=q.length;for(const H of $)if(H.isDirectory()){if(M.includes(H.name)||await u(A,(0,C.join)(O,H.name),M,N),--_==0){F();return}}else{const j=H.name.lastIndexOf(".");if(j>=0){const x=H.name.substring(j+1);x&&t.set(x,(t.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(P)!==!1&&x.filePattern.test(H.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--_==0){F();return}}})}const f={count:0,maxReached:!1};await u(n,n,s,f);const p=await l(n);return{configFiles:y(a),fileTypes:y(t),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:p}}e.collectWorkspaceStats=v;function y(n){return[...L.Iterable.map(n.entries(),([s,r])=>({name:s,count:r}))].sort((s,r)=>r.count-s.count)}function g(){const n={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},s=R.cpus();return s&&s.length>0&&(n.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),n}e.getMachineInfo=g;async function l(n){try{const s=new Map,r=(0,C.join)(n,".vscode","launch.json"),t=await I.Promises.readFile(r),a=[],o=(0,k.parse)(t.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,k.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const f=u.type;f&&(s.has(f)?s.set(f,s.get(f)+1):s.set(f,1))}return y(s)}catch(s){return[]}}e.collectLaunchConfigs=l;let c=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const t=R.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${R.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,m.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async t=>{let[a,o]=t,u=this.formatProcessList(s,a);return r.forEach(f=>{if((0,E.isRemoteDiagnosticError)(f))u+=`
${f.errorMessage}`,o+=`
${f.errorMessage}`;else if(u+=`

Remote: ${f.hostName}`,f.processes&&(u+=`
${this.formatProcessList(s,f.processes)}`),f.workspaceMetadata){o+=`
|  Remote: ${f.hostName}`;for(const p of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[p];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${p}): ${O}`,o+=this.formatWorkspaceStats(A)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(s,r){const{memory:t,vmHint:a,os:o,cpus:u}=g(),f={os:o,memory:t,cpus:u,vmHint:a,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(f.load=`${R.loadavg().map(p=>Math.round(p)).join(", ")}`),w.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(s,r){const t=[];return(0,m.listProcesses)(s.mainPID).then(async a=>(t.push(""),t.push(this.formatEnvironment(s)),t.push(""),t.push(this.formatProcessList(s,a)),s.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(s))),r.forEach(o=>{if((0,E.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(s,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const f=o.workspaceMetadata[u];let p=`${f.fileCount} files`;f.maxFilesReached&&(p=`more than ${p}`),t.push(`Folder (${u}): ${p}`),t.push(this.formatWorkspaceStats(f))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(s){const r=[],t=60;let a=0;const o=(A,O)=>{const M=` ${A}(${O})`;a+M.length>t?(r.push(u),u="|                 ",a=u.length):a+=M.length,u+=M};let u="|      File types:";const f=10;let p=s.fileTypes.length>f?f:s.fileTypes.length;for(let A=0;A<p;A++){const O=s.fileTypes[A];o(O.name,O.count)}if(r.push(u),s.configFiles.length>=0&&(u="|      Conf files:",a=0,s.configFiles.forEach(A=>{o(A.name,A.count)}),r.push(u)),s.launchConfigFiles.length>0){let A="|      Launch Configs:";s.launchConfigFiles.forEach(O=>{A+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),r.push(A)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(t=>t.length));return Object.keys(s).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${s[t]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],t=[];return s.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(o=>{const u=b.URI.revive(o);if(u.scheme===T.Schemas.file){const f=u.fsPath;t.push(v(f,["node_modules",".git"]).then(p=>{let A=`${p.fileCount} files`;p.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${(0,C.basename)(f)}): ${A}`),r.push(this.formatWorkspaceStats(p))}).catch(p=>{r.push(`|      Error: Unable to collect workspace stats for folder ${f} (${p.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(s,r){const t=new Map;s.windows.forEach(o=>t.set(o.pid,o.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,t,a,r,0),a.join(`
`)}formatProcessItem(s,r,t,a,o){const u=o===0;let f;u?f=a.pid===s?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(o)} ${a.name}`,a.name==="window"&&(f=`${f} (${r.get(a.pid)})`));const p=process.platform==="win32"?a.mem:R.totalmem()*(a.mem/100);t.push(`${a.load.toFixed(0).padStart(5," ")}	${(p/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(s,r,t,A,o+1))}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const t=b.URI.revive(r);if(t.scheme!==T.Schemas.file)continue;const a=t.fsPath;try{const o=await v(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};c=he([X(0,d.ITelemetryService),X(1,S.IProductService)],c),e.DiagnosticsService=c}),define(te[203],ne([0,1,17,5,27,7,3,2,4,9,130,30,36,10,28,22]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends C.Disposable{constructor(c,n,s,r){super();this.galleryService=c,this.telemetryService=n,this.logService=s,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(t=>t.cancel()),this.uninstallingExtensions.forEach(t=>t.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const n=await this.getTargetPlatform();return c.allTargetPlatforms.some(s=>(0,I.isTargetPlatformCompatible)(s,c.allTargetPlatforms,n))}async installFromGallery(c,n={}){if(!this.galleryService.isEnabled())throw new I.ExtensionManagementError(i.localize(0,null),I.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(c)){const r=await this.getTargetPlatform(),t=new I.ExtensionManagementError(i.localize(1,null,c.identifier.id,this.productService.nameLong,(0,I.TargetPlatformToString)(r)),I.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",c.identifier.id,t.message),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(c),void 0,t),t}try{c=await this.checkAndGetCompatibleVersion(c,!n.installGivenVersion)}catch(r){throw this.logService.error((0,k.getErrorMessage)(r)),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(c),void 0,r),r}const s=await this.galleryService.getManifest(c,D.CancellationToken.None);if(s===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",c.identifier.id,r.message),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(c),void 0,r),r}if(s.version!==c.version){const r=new I.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);throw this.logService.error(r.message),y(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(c),void 0,r),r}return this.installExtension(s,c,n)}async uninstall(c,n={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,n)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const n=await this.findGalleryExtension(c);if(!n)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsReport(){const c=new Date().getTime();return(!this.reportedExtensions||c-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=c),this.reportedExtensions}registerParticipant(c){this.participants.push(c)}async installExtension(c,n,s){if(!b.URI.isUri(n)){let u=this.installingExtensions.get(new m.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(u)return this.logService.info("Extensions is already requested to install",n.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],t=[],a=this.createInstallExtensionTask(c,n,s);b.URI.isUri(n)||this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:n}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:c});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const f=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:A}of f)if(o=o||!!A.extensionDependencies?.some(O=>(0,m.areSameExtensions)({id:O},a.identifier)),this.installingExtensions.has(new m.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const O=this.createInstallExtensionTask(A,p,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(O.identifier,A.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:p}),this.logService.info("Installing extension:",O.identifier.id),r.push({task:O,manifest:A})}}catch(f){if(b.URI.isUri(a.source))(0,R.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,f.message),(0,R.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,f.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(f),f}const u=r.reduce((f,{task:p,manifest:A})=>(f.set(p.identifier.id.toLowerCase(),{task:p,manifest:A}),f),new Map);for(;u.size;){let f;const p=[...u.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(O=>u.has(O.toLowerCase())));p.length?f=u.size===1?p:p.filter(({task:A})=>!(A===a&&!o)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:A})=>A.identifier.id)),f=[...u.values()]),await this.joinAllSettled(f.map(async({task:A})=>{const O=new Date().getTime();try{const M=await A.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(M,A.source,s,D.CancellationToken.None))),!b.URI.isUri(A.source)&&(y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,void 0),w.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch(N){}t.push({local:M,identifier:A.identifier,operation:A.operation,source:A.source})}catch(M){throw b.URI.isUri(A.source)||y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,M),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(M),M}finally{u.delete(A.identifier.id.toLowerCase())}}))}return t.forEach(({identifier:f})=>this.logService.info("Extension installed successfully:",f.id)),this._onDidInstallExtensions.fire(t),t.filter(({identifier:f})=>(0,m.areSameExtensions)(f,a.identifier))[0].local}catch(u){if(r.forEach(({task:f})=>f.cancel()),t.length)try{const f=await Promise.allSettled(t.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<f.length;p++){const A=f[p],{identifier:O}=t[p];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,k.getErrorMessage)(A.reason))}}catch(f){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(f),t.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,k.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:f})=>({identifier:f.identifier,operation:1,source:f.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:I.ExtensionManagementErrorCode.Internal),u}finally{for(const{task:u,manifest:f}of r)if(!b.URI.isUri(u.source)){const p=new m.ExtensionIdentifierWithVersion(u.identifier,f.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(c){const n=[],s=[],r=await Promise.allSettled(c);for(const t of r)t.status==="fulfilled"?n.push(t.value):s.push(t.reason);if(s.length)throw v(s);return n}async getAllDepsAndPackExtensionsToInstall(c,n,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const t=[c,...r.map(u=>u.identifier)],a=[],o=async(u,f)=>{const p=f.extensionDependencies||[],A=[...p];if(f.extensionPack){const O=s?r.find(M=>(0,m.areSameExtensions)(M.identifier,u)):void 0;for(const M of f.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(N=>(0,m.areSameExtensions)({id:N},{id:M}))||A.every(N=>!(0,m.areSameExtensions)({id:N},{id:M}))&&A.push(M)}if(A.length){const O=[...t,...a.map(N=>N.gallery.identifier)],M=A.filter(N=>O.every(P=>!(0,m.areSameExtensions)(P,{id:N})));if(M.length){const N=await this.galleryService.query({names:M,pageSize:A.length},D.CancellationToken.None);for(const P of N.firstPage){if(O.find($=>(0,m.areSameExtensions)($,P.identifier)))continue;if(!p.some($=>(0,m.areSameExtensions)({id:$},P.identifier))&&!await this.canInstall(P)){this.logService.info("Skipping the packed extension as it cannot be installed",P.identifier.id);continue}const q=await this.checkAndGetCompatibleVersion(P,!0),_=await this.galleryService.getManifest(q,D.CancellationToken.None);if(_===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${q.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);a.push({gallery:q,manifest:_}),await o(q.identifier,_)}}}};return await o(c,n),r=await this.getInstalled(),a.filter(u=>!r.some(f=>(0,m.areSameExtensions)(f.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(c,n){if(await this.isMalicious(c))throw new I.ExtensionManagementError(i.localize(4,null,c.identifier.id),I.ExtensionManagementErrorCode.Malicious);const s=await this.getCompatibleVersion(c,n);if(!s)throw new I.ExtensionManagementError(i.localize(5,null,c.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.Incompatible);return s}async getCompatibleVersion(c,n){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(c,s)&&(r=c),!r&&n&&(r=await this.galleryService.getCompatibleExtension(c,s)),r}async isMalicious(c){const n=await this.getExtensionsReport();return(0,m.getMaliciousExtensionsSet)(n).has(c.identifier.id)}async unininstallExtension(c,n){const s=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),s.waitUntilTaskIsFinished();const r=(u,f)=>{const p=this.createUninstallExtensionTask(u,f);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),p},t=(u,f)=>{f?this.logService.error("Failed to uninstall extension:",u.identifier.id,f.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,m.getLocalExtensionTelemetryData)(u),void 0,f),this._onDidUninstallExtension.fire({identifier:u.identifier,error:f?.code})},a=[],o=[];try{a.push(r(c,{}));const u=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const f=this.getAllPackExtensionsToUninstall(c,u);for(const p of f)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(r(p,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(f=>f.extension),u,c),await this.joinAllSettled(a.map(async f=>{try{if(await f.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(f.extension,n,D.CancellationToken.None))),f.extension.identifier.uuid)try{await this.galleryService.reportStatistic(f.extension.manifest.publisher,f.extension.manifest.name,f.extension.manifest.version,"uninstall")}catch(p){}t(f.extension)}catch(p){const A=p instanceof I.ExtensionManagementError?p:new I.ExtensionManagementError((0,k.getErrorMessage)(p),I.ExtensionManagementErrorCode.Internal);throw t(f.extension,A),A}finally{o.push(f)}}))}catch(u){const f=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,k.getErrorMessage)(u),I.ExtensionManagementErrorCode.Internal);for(const p of a){try{p.cancel()}catch(A){}o.includes(p)||t(p.extension,f)}throw f}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(c,n,s){for(const r of c){const t=this.getDependents(r,n);if(t.length){const a=t.filter(o=>!c.some(u=>(0,m.areSameExtensions)(u.identifier,o.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,s))}}}getDependentsErrorMessage(c,n,s){return s===c?n.length===1?i.localize(6,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?i.localize(7,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):i.localize(8,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?i.localize(9,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?i.localize(10,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):i.localize(11,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(c,n,s=[]){if(s.indexOf(c)!==-1)return[];s.push(c);const r=c.manifest.extensionPack?c.manifest.extensionPack:[];if(r.length){const t=n.filter(o=>!o.isBuiltin&&r.some(u=>(0,m.areSameExtensions)({id:u},o.identifier))),a=[];for(const o of t)a.push(...this.getAllPackExtensionsToUninstall(o,n,s));return[...t,...a]}return[]}getDependents(c,n){return n.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,m.areSameExtensions)({id:r},c.identifier)))}async findGalleryExtension(c){if(c.identifier.uuid){const n=await this.findGalleryExtensionById(c.identifier.uuid);return n||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${c.length} reported extensions from service`),c}catch(c){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};d=he([X(0,I.IExtensionGalleryService),X(1,S.ITelemetryService),X(2,E.ILogService),X(3,h.IProductService)],d),e.AbstractExtensionManagementService=d;function v(l){const c=Array.isArray(l)?l:[l];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((n,s)=>new Error(`${n.message}${n.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=v;function y(l,c,n,s,r){const t=r?r instanceof I.ExtensionManagementError?r.code:I.ExtensionManagementErrorCode.Internal:void 0;l.publicLogError(c,{...n,success:!r,duration:s,errorcode:t})}e.reportTelemetry=y;class g{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(c=>new Promise((n,s)=>{const r=c.onCancellationRequested(()=>{r.dispose(),s((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=g}),define(te[204],ne([0,1,17,5,66,3,8,4,31,9,132,13,30,194,80,14,10,59,28,43,23,22]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends E.ExtensionTipsService{constructor(a,o,u,f,p,A,O,M,N,P){super(O,M,N,P);this.environmentService=a,this.telemetryService=o,this.extensionManagementService=u,this.storageService=f,this.nativeHostService=p,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,M.exeBasedExtensionTips&&(0,D.forEach)(M.exeBasedExtensionTips,({key:F,value:q})=>{const _=[],$=[],H=[];(0,D.forEach)(q.recommendations,({key:j,value:x})=>{x.important?q.important?_.push({extensionId:j,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):$.push({extensionId:j,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):H.push({extensionId:j,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(F,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:_}),$.length&&this.mediumImportanceExecutableTips.set(F,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:$}),H.length&&this.allOtherExecutableTips.set(F,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:H})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(a,o){const u=new Map;a.forEach(M=>u.set(M.extensionId.toLowerCase(),M));const{installed:f,uninstalled:p}=this.groupByInstalled([...u.keys()],o);for(const M of f){const N=u.get(M);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:M,exeName:N.exeName})}for(const M of p){const N=u.get(M);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:M,exeName:N.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const M of p){const N=u.get(M);if(N&&(!A[N.exeName]||!A[N.exeName].includes(N.extensionId))){let P=O.get(N.exeName);P||(P=[],O.set(N.exeName,P)),P.push(N)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const f=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,L.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),o=Date.now()-a,u=7*24*60*60*1e3;if(o<u){const A=this._register((0,L.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[f,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(p[0].exeName,p);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const M=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(M(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const N=this._register((0,L.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const o=a.map(({extensionId:f})=>f.toLowerCase()),u=(0,i.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,0,"{}"))}addToRecommendedExecutables(a,o){const u=this.getPromptedExecutableTips();u[a]=o.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(n,JSON.stringify(u),0,0)}groupByInstalled(a,o){const u=[],f=[],p=o.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return a.forEach(A=>{p.has(A.toLowerCase())?u.push(A):f.push(A)}),{installed:u,uninstalled:f}}async getValidExecutableBasedExtensionTips(a){const o=[],u=new Map;for(const f of a.keys()){const p=a.get(f);if(!p||!(0,R.isNonEmptyArray)(p.recommendations))continue;const A=[];C.isWindows?p.windowsPath&&A.push(p.windowsPath.replace("%USERPROFILE%",w.env.USERPROFILE).replace("%ProgramFiles(x86)%",w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",w.env.ProgramFiles).replace("%APPDATA%",w.env.APPDATA).replace("%WINDIR%",w.env.WINDIR)):(A.push((0,T.join)("/usr/local/bin",f)),A.push((0,T.join)("/usr/bin",f)),A.push((0,T.join)(this.environmentService.userHome.fsPath,f)));for(const O of A){let M=u.get(O);if(M===void 0&&(M=await this.fileService.exists(b.URI.file(O)),u.set(O,M)),M)for(const{extensionId:N,extensionName:P,isExtensionPack:F}of p.recommendations)o.push({extensionId:N,extensionName:P,isExtensionPack:F,exeName:f,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return o}};r=he([X(0,I.INativeEnvironmentService),X(1,c.ITelemetryService),X(2,m.IExtensionManagementService),X(3,l.IStorageService),X(4,v.INativeHostService),X(5,h.IExtensionRecommendationNotificationService),X(6,S.IFileService),X(7,y.IProductService),X(8,g.IRequestService),X(9,d.ILogService)],r),e.ExtensionTipsService=r}),define(te[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(k){this.appenders=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,{eventName:C,data:w}){return this.appenders.forEach(b=>b.log(C,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class L{constructor(k){this.channel=k}log(k,T){return this.channel.call("log",{eventName:k,data:T}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[47],ne([0,1,26,18,21,22]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,y){return Promise.resolve(void 0)}publicLog2(v,y){return this.publicLog(v,y)}publicLogError(v,y){return Promise.resolve(void 0)}publicLogError2(v,y){return this.publicLogError(v,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class C{async publicLog(v,y,g){}async publicLogError(v,y,g){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(d,v){return v.onDidChangeConfiguration(y=>{y.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(y.source),configurationKeys:h(y.sourceConfig)})})}e.configurationTelemetry=w;function b(d,v){return!(v.disableTelemetry||!d.enableTelemetry)}e.supportsTelemetry=b;function i(d){const v=d.getValue(k.TELEMETRY_SETTING_ID),y=d.getValue("telemetry.enableCrashReporter");if(d.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function I(d){const v=Object.create(null),y=Object.create(null),g=Object.create(null);E(d,g);for(let l in g){l=l.length>150?l.substr(l.length-149):l;const c=g[l];typeof c=="number"?y[l]=c:typeof c=="boolean"?y[l]=c?1:0:typeof c=="string"?v[l]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(v[l]=c)}return{properties:v,measurements:y}}e.validateTelemetryData=I;function m(d){if(!d)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{d.indexOf(`${g}+`)===0&&(v=g)}),v}e.cleanRemoteAuthority=m;function E(d,v,y=0,g){if(!!d)for(let l of Object.getOwnPropertyNames(d)){const c=d[l],n=g?g+l:l;Array.isArray(c)?v[n]=(0,R.safeStringify)(c):c instanceof Date?v[n]=c.toISOString():(0,L.isObject)(c)?y<2?E(c,v,y+1,n+"."):v[n]=(0,R.safeStringify)(c):v[n]=c}}function h(d){if(!d)return[];const v=[];return S(v,"",d),v}function S(d,v,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(g=>S(d,v?`${v}.${g}`:g,y[g])):d.push(v)}}),define(te[205],ne([0,1,17,27,7,26,4,31,9,21,13,30,36,76,14,10,28,43,46,23,22,47]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=T.isWeb?"web":(0,I.getTargetPlatform)(T.platform,C.arch);var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...G){return String(G.reduce((V,re)=>V|re,0))}var t;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},f={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class p{constructor(V=f){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,re=this.state.pageSize){return new p({...this.state,pageNumber:V,pageSize:re})}withFilter(V,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:V,value:ce})):[{filterType:V}]];return new p({...this.state,criteria:ie})}withSortBy(V){return new p({...this.state,sortBy:V})}withSortOrder(V){return new p({...this.state,sortOrder:V})}withFlags(...V){return new p({...this.state,flags:V.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...V){return new p({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:de,assetTypes:fe}=this.state;return{filters:[{criteria:V,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:fe,flags:de}}get searchText(){const V=this.state.criteria.filter(re=>re.filterType===t.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(G,V){const re=(G||[]).filter(ie=>ie.statisticName===V)[0];return re?re.value:0}function O(G){const V="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(ie=>ie.assetType.indexOf(V)===0).reduce((ie,ce)=>{const le=F(G,ce.assetType);return le&&ie.push([ce.assetType.substring(V.length),le]),ie},[])}function M(G){if(G.properties){const V=G.properties.filter(ce=>ce.key===a.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=V.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return F(G,a.Repository)}function N(G){return{uri:`${G.fallbackAssetUri}/${a.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${a.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function P(G){const V=F(G,a.Icon);if(V)return V;const re=I.DefaultIconPath;return{uri:re,fallbackUri:re}}function F(G,V){return G.files.filter(ie=>ie.assetType===V)[0]?{uri:`${G.assetUri}/${V}`,fallbackUri:`${G.fallbackAssetUri}/${V}`}:null}function q(G,V){const re=G.properties?G.properties.filter(ce=>ce.key===V):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,m.adoptToGalleryExtensionId)(ce)):[]}function _(G){const V=G.properties?G.properties.filter(re=>re.key===o.Engine):[];return V.length>0&&V[0].value||""}function $(G){const V=G.properties?G.properties.filter(ie=>ie.key===o.LocalizedLanguages):[],re=V.length>0&&V[0].value||"";return re?re.split(","):[]}function H(G){return G.indexOf("preview")!==-1}function j(G){return G.targetPlatform?(0,I.toTargetPlatform)(G.targetPlatform):"undefined"}function x(G){const V=(0,R.distinct)(G.versions.map(j)),re=!!G.tags?.includes(I.WEB_EXTENSION_TAG),ie=V.indexOf("web");return re?ie===-1&&V.push("web"):ie!==-1&&V.splice(ie,1),V}function z(G,V){const re=(0,I.getFallbackTargetPlarforms)(V);for(let ie=0;ie<G.length;ie++){const ce=G[ie];if(ce.version===G[ie-1]?.version){let le=ie;const de=j(ce);if(de===V)for(;le>0&&G[le-1].version===ce.version;)le--;else if(re.includes(de))for(;le>0&&G[le-1].version===ce.version&&j(G[le-1])!==V;)le--;le!==ie&&(G.splice(ie,1),G.splice(le,0,ce))}}return G}e.sortExtensionVersions=z;function Y(G,V,re,ie,ce){const le=x(G);let de=G.versions[0];return de=G.versions.find(fe=>fe.version===de.version&&(0,I.isTargetPlatformCompatible)(j(fe),le,ce))||de,U(G,de,le,V,re,ie)}function U(G,V,re,ie,ce,le){const de={manifest:F(V,a.Manifest),readme:F(V,a.Details),changelog:F(V,a.Changelog),license:F(V,a.License),repository:M(V),download:N(V),icon:P(V),coreTranslations:O(V)};return{identifier:{id:(0,m.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:V.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,description:G.shortDescription||"",installCount:A(G.statistics,"install"),rating:A(G.statistics,"averagerating"),ratingCount:A(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:re,assets:de,properties:{dependencies:q(V,o.Dependency),extensionPack:q(V,o.ExtensionPack),engine:_(V),localizedLanguages:$(V),targetPlatform:j(V)},preview:H(G.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let B=class{constructor(V,re,ie,ce,le,de,fe,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=de,this.productService=fe,this.configurationService=be;const Ce=fe.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(fe.version,fe,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,re){const ie=[];let ce=new p().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,V.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,...V.map(({id:de})=>de.toLowerCase()));V.every(de=>!de.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,n,L.CancellationToken.None);for(let de=0;de<le.length;de++){const fe=le[de];if(!fe.versions.length)continue;const be=(0,m.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),Ce=V.find(Ee=>(0,m.areSameExtensions)(Ee,{id:be}))?.version;if(Ce){const Ee=fe.versions.find(Ae=>Ae.version===Ce);Ee&&ie.push(U(fe,Ee,x(fe),de,ce))}else ie.push(Y(fe,de,ce,void 0,n))}return ie}async getCompatibleExtension(V,re){const ie=(0,I.isIExtensionIdentifier)(V)?null:V;if(ie){if((0,I.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:V;let de=new p().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?de=de.withFilter(t.ExtensionId,le):de=de.withFilter(t.ExtensionName,ce);const{galleryExtensions:fe}=await this.queryGallery(de,re,L.CancellationToken.None),[be]=fe;if(!be||!be.versions.length)return null;const Ce=x(be);if((0,I.isNotWebExtensionInWebTargetPlatform)(Ce,re))return null;for(let Ee of be.versions){if(!_(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:o.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,re))return U(be,Ee,Ce,0,de)}return null}async isExtensionCompatible(V,re){if(!(0,I.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,re))return!1;let ie=V.properties.engine;if(!ie){const ce=await this.getManifest(V,L.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,E.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(V,re,ie){if(!(0,I.isTargetPlatformCompatible)(j(V),re,ie))return!1;const ce=await this.getEngine(V);return(0,E.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(V,re){const ie=L.CancellationToken.isCancellationToken(V)?{}:V,ce=L.CancellationToken.isCancellationToken(V)?V:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const de=(0,k.getOrDefault)(ie,Pe=>Pe.pageSize,50);let fe=new p().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,de).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(t.Category,Fe||Le),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(t.Tag,Fe||Le),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(t.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),fe=fe.withFilter(t.SearchText,le)),fe=fe.withSortBy(0)):ie.ids?fe=fe.withFilter(t.ExtensionId,...ie.ids):ie.names?fe=fe.withFilter(t.ExtensionName,...ie.names):fe=fe.withSortBy(4),typeof ie.sortBy=="number"&&(fe=fe.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(fe=fe.withSortOrder(ie.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(fe,n,ce),Ee=be.map((Pe,Le)=>Y(Pe,Le,fe,ie.source,n)),Ae=async(Pe,Le)=>{if(Le.isCancellationRequested)throw(0,D.canceled)();const Fe=fe.withPage(Pe+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,n,Le);return Ne.map(($e,xe)=>Y($e,xe,Fe,ie.source,n))};return{firstPage:Ee,total:Ce,pageSize:fe.pageSize,getPage:Ae}}async queryGallery(V,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,s.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,r(s.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(V.raw),de={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},fe=new Date().getTime();let be,Ce,Ee=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:de},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,v.asJson)(be);if(Ae){const Pe=Ae.results[0],Le=Pe.extensions;Le.forEach(Ne=>z(Ne.versions,re));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Ce=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-fe,success:!!be&&(0,v.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ce?(0,D.isPromiseCanceledError)(Ce)?"canceled":(0,D.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(V,re,ie,ce){if(!this.isEnabled())return;const le=T.isWeb?this.api(`/itemName/${V}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${re}/${ie}/stats?statType=${ce}`),de=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:le,headers:be},L.CancellationToken.None)}catch(Ce){}}async download(V,re,ie){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const ce=(0,m.getGalleryExtensionTelemetryData)(V),le=new Date().getTime(),de=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),fe=ie===1?"install":ie===2?"update":"",be=fe?{uri:`${V.assets.download.uri}${w.URI.parse(V.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${V.assets.download.fallbackUri}${w.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:V.assets.download,Ce=await this.getAsset(be);await this.fileService.writeFile(re,Ce.stream),de(new Date().getTime()-le)}async getReadme(V,re){if(V.assets.readme){const ie=await this.getAsset(V.assets.readme,{},re);return await(0,v.asText)(ie)||""}return""}async getManifest(V,re){if(V.assets.manifest){const ie=await this.getAsset(V.assets.manifest,{},re),ce=await(0,v.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(V,re){const ie=F(V,a.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,v.asJson)(le)}async getCoreTranslation(V,re){const ie=V.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,v.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(V,re){if(V.assets.changelog){const ie=await this.getAsset(V.assets.changelog,{},re);return await(0,v.asText)(ie)||""}return""}async getAllCompatibleVersions(V,re){let ie=new p().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");V.identifier.uuid?ie=ie.withFilter(t.ExtensionId,V.identifier.uuid):ie=ie.withFilter(t.ExtensionName,V.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,L.CancellationToken.None);if(!ce.length)return[];const le=x(ce[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const de=[];for(const fe of ce[0].versions)try{de[de.length-1]?.version!==fe.version&&await this.isRawExtensionVersionCompatible(fe,le,re)&&de.push({version:fe.version,date:fe.lastUpdated})}catch(be){}return de}async getAsset(V,re={},ie=L.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},de={...ce,...re.headers||{}};re={...re,...le,headers:de};const fe=V.uri,be=V.fallbackUri,Ce={...re,url:fe};try{const Ee=await this.requestService.request(Ce,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,v.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:Ae});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(V){let re=_(V);if(!re){const ie=await this.getManifestFromRawExtensionVersion(V,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,v.asJson)(V),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};B=he([X(1,v.IRequestService),X(2,S.ILogService),X(3,i.IEnvironmentService),X(4,l.ITelemetryService),X(5,h.IFileService),X(6,d.IProductService),X(7,b.IConfigurationService)],B);let W=class extends B{constructor(V,re,ie,ce,le,de,fe,be){super(V,re,ie,ce,le,de,fe,be)}};W=he([X(0,g.IStorageService),X(1,v.IRequestService),X(2,S.ILogService),X(3,i.IEnvironmentService),X(4,l.ITelemetryService),X(5,h.IFileService),X(6,d.IProductService),X(7,b.IConfigurationService)],W),e.ExtensionGalleryService=W;let Q=class extends B{constructor(V,re,ie,ce,le,de,fe){super(void 0,V,re,ie,ce,le,de,fe)}};Q=he([X(0,v.IRequestService),X(1,S.ILogService),X(2,i.IEnvironmentService),X(3,l.ITelemetryService),X(4,h.IFileService),X(5,d.IProductService),X(6,b.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(G,V,re,ie,ce,le){const de={"X-Market-Client-Id":`VSCode ${G}`,"User-Agent":`VSCode ${G}`},fe=await(0,y.getServiceMachineId)(re,ce,le);return(0,c.supportsTelemetry)(V,re)&&(0,c.getTelemetryLevel)(ie)===3&&(de["X-Market-User-Id"]=fe),de}e.resolveMarketplaceHeaders=Z}),define(te[93],ne([0,1,2,13,10,47]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends R.Disposable{constructor(w,b,i=""){super();this.prefix=i;const I=w.getLogger(b.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(w.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,b){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,k.validateTelemetryData)(b))}};T=he([X(0,D.ILoggerService),X(1,L.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(te[94],ne([0,1,2,26,4,25,142,21,38,60,35,22,47]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(d,v){this._configurationService=v,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const g=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(d,v){this._experimentProperties[d]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let v=d.sessionID,y=d["common.instanceId"],g=d["common.machineId"],l=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:v,instanceId:y,machineId:g,firstSessionDate:l,msftInternal:c}}dispose(){this._disposables.dispose()}_log(d,v,y,g){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(l=>{y=(0,L.mixin)(y,l),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,c=>{if(typeof c=="string")return this._cleanupInfo(c,g)}),this._appenders.forEach(c=>c.log(d,y))},l=>{console.error(l)})}publicLog(d,v,y){return this._log(d,3,v,y)}publicLog2(d,v,y){return this.publicLog(d,v,y)}publicLogError(d,v){return this.sendErrorTelemetry?this._log(d,2,v,!0):Promise.resolve(void 0)}publicLogError2(d,v){return this.publicLogError(d,v)}_anonymizeFilePaths(d){let v=d;const y=[];for(let n of this._cleanupPatterns)for(;;){const s=n.exec(d);if(!s)break;y.push([s.index,n.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const n=l.exec(d);if(!n)break;!g.test(n[0])&&y.every(([s,r])=>n.index<s||n.index>=r)&&(v+=d.substring(c,n.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}return c<d.length&&(v+=d.substr(c)),v}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const v=d.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":y.test(v)?"<REDACTED: email>":d}_cleanupInfo(d,v){let y=d;v&&(y=this._anonymizeFilePaths(y));for(let g of this._cleanupPatterns)y=y.replace(g,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([X(1,C.IConfigurationService)],E),e.TelemetryService=E;function h(){const S=(0,T.localize)(0,null,b.default.nameLong),d=b.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,T.localize)(3,null),y=(0,T.localize)(4,null),g=(0,T.localize)(5,null),l=(0,T.localize)(6,null),c=(0,T.localize)(7,null),n=`
|       | ${y} | ${g} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,T.localize)(8,null);return`
${S} ${d} ${v}

&nbsp;

${c}
${n}

&nbsp;

${s}
`}i.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,T.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,T.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[206],ne([0,1,7,26,47]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(C){const w=await new Promise((i,I)=>{J(["applicationinsights"],i,I)});let b;return w.defaultClient?(b=new w.TelemetryClient(C),b.channel.setUseDiskRetryCaching(!0)):(w.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=w.defaultClient),C.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class T{constructor(w,b,i){this._eventPrefix=w,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(w){if(!!this._aiClient){if(typeof this._aiClient!="string"){w(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(b=>{w(b)},b=>{(0,R.onUnexpectedError)(b),console.error(b)})}}log(w,b){!this._aiClient||(b=(0,L.mixin)(b,this._defaultData),b=(0,D.validateTelemetryData)(b),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+w,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(w=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,w(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(te[207],ne([0,1,15,44,21,13,10,22,92,93,94]),function(J,e,R,L,D,k,T,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let I=class{constructor(E,h,S,d){this.configurationService=E,this.telemetryService=h,this.loggerService=S,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(E){if(!this.customTelemetryServices.has(E.id)){const{machineId:h,sessionId:S}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=h,d["common.vscodesessionid"]=S;const v=[E.id,JSON.stringify(d),E.aiKey],g=new L.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new w.TelemetryAppenderClient(g),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${E.id}] `)];this.customTelemetryServices.set(E.id,new i.TelemetryService({appenders:l,sendErrorTelemetry:E.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(E.id)}async publicLog(E,h,S){await(await this.getCustomTelemetryService(E)).publicLog(h,S)}async publicLogError(E,h,S){await(await this.getCustomTelemetryService(E)).publicLogError(h,S)}};I=he([X(0,D.IConfigurationService),X(1,C.ITelemetryService),X(2,T.ILoggerService),X(3,k.IEnvironmentService)],I),e.CustomEndpointTelemetryService=I}),define(te[208],ne([0,1,5,27,3,2,10]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends k.Disposable{constructor(b,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((i,I)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,i),this._onCreateRequest.fire({requestId:m,...b});const E=new L.CancellationTokenSource;(0,R.timeout)(this._timeout,E.token).then(()=>I(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,k.toDisposable)(()=>E.cancel())])})}acceptReply(b,i){const I=this._pendingRequests.get(b);I?(this._pendingRequests.delete(b),(0,k.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),I(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};C=he([X(1,T.ILogService)],C),e.RequestStore=C}),define(te[95],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(T=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var w;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions"})(w=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(d){d.TerminalView="view",d.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(d){d.CwdDetection="cwdDetection"})(m=e.ProcessCapability||(e.ProcessCapability={}));var E;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(te[209],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(te[210],ne([0,1,34,26,8,4,31,18,20]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let m=0;return I&&I.length===4&&(m=parseInt(I[3])),m}e.getWindowsBuildNumber=b;async function i(I,m,E,h=T.env,S=w.Promises.exists){if(D.isAbsolute(I))return await S(I)?I:void 0;if(m===void 0&&(m=T.cwd()),D.dirname(I)!=="."){const g=D.join(m,I);return await S(g)?g:void 0}const v=(0,L.getCaseInsensitive)(h,"PATH");if(E===void 0&&(0,C.isString)(v)&&(E=v.split(D.delimiter)),E===void 0||E.length===0){const g=D.join(m,I);return await S(g)?g:void 0}for(let g of E){let l;if(D.isAbsolute(g)?l=D.join(g,I):l=D.join(m,g,I),await S(l))return l;if(k.isWindows){let c=l+".com";if(await S(c)||(c=l+".exe",await S(c)))return c}}const y=D.join(m,I);return await S(y)?y:void 0}e.findExecutable=i}),define(te[211],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,50,3,2,6,35,211]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var w;(function(d){function v(y){return y&&typeof y=="object"&&typeof y.id=="string"}d.isThemeColor=v})(w=e.ThemeColor||(e.ThemeColor={}));function b(d){return{id:d}}e.themeColorFromId=b;var i;(function(d){function v(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}d.isThemeIcon=v;const y=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function g(s){const r=y.exec(s);if(!r)return;let[,t]=r;return{id:t}}d.fromString=g;function l(s,r){let t=s.id;const a=t.lastIndexOf("~");return a!==-1&&(t=t.substring(0,a)),r&&(t=`${t}~${r}`),{id:t}}d.modify=l;function c(s,r){return s.id===r.id&&s.color?.id===r.color?.id}d.isEqual=c;function n(s,r){return{id:s.id,color:r?b(r):void 0}}d.asThemeIcon=n,d.asClassNameArray=R.CSSIcon.asClassNameArray,d.asClassName=R.CSSIcon.asClassName,d.asCSSSelector=R.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function I(d){switch(d){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const y=this.themingParticipants.indexOf(v);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new m;T.Registry.add(e.Extensions.ThemingContribution,E);function h(d){return E.onColorThemeChange(d)}e.registerThemingParticipant=h;class S extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,y){let g=this.theme.getColor(v);return g&&y&&(g=y(g,this.theme)),g?g.toString():null}}e.Themable=S}),define(te[212],ne([0,1,50,96]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function D(C,w){const b=C.map(i=>({name:i.profileName,description:k(i)}));return w&&b.push(...w.map(i=>({name:i.title,description:T(i)}))),{values:b.map(i=>i.name),markdownDescriptions:b.map(i=>i.description)}}e.createProfileSchemaEnums=D;function k(C){let w=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:R.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?w+=`
- args: "${C.args}"`:w+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(w+=`
- overrideName: ${C.overrideName}`),C.color&&(w+=`
- color: ${C.color}`),C.env&&(w+=`
- env: ${JSON.stringify(C.env)}`),w}function T(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:R.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}}),define(te[213],ne([0,1,50,143,38,35,212]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const C={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,d=>d.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,d=>`$(${d.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},b=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,L.localize)(38,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function E(){k.Registry.as(D.Extensions.Configuration).registerConfiguration(m),S()}e.registerTerminalPlatformConfiguration=E;let h;function S(d,v){const y=k.Registry.as(D.Extensions.Configuration);let g;d&&(g=(0,T.createProfileSchemaEnums)(d?.profiles,v));const l=h;h={id:"terminal",order:100,title:(0,L.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?g?.values:void 0,markdownEnumDescriptions:d?.os===3?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?g?.values:void 0,markdownEnumDescriptions:d?.os===2?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?g?.values:void 0,markdownEnumDescriptions:d?.os===1?g?.markdownDescriptions:void 0}}},y.updateConfigurations({add:[h],remove:l?[l]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(te[214],ne([0,1,42,50,8,4,20,70,210,96]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i,I=!0;function m(s,r,t,a,o=process.env,u,f,p,A){return u=u||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},k.isWindows?E(t,u,o,f,a.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),A,p):l(u,f,t,s&&typeof s=="object"?{...s}:a.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,p,o)}e.detectAvailableProfiles=m;async function E(s,r,t,a,o,u,f,p,A){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let N=!1;(0,w.getWindowsBuildNumber)()>=16299&&(N=!0),await d(p);const P=new Map;s&&(P.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),P.set("Windows PowerShell",{path:`${M}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),P.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),P.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),P.set("Command Prompt",{path:`${M}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),c(u,P);const F=await h(P.entries(),f,r,t,a,A);if(s||!s&&o)try{const q=await y(`${M}\\${N?"wsl":"bash"}.exe`,f);for(const _ of q)(!u||!(_.profileName in u))&&F.push(_)}catch(q){I&&(a?.info("WSL is not installed, so could not detect WSL profiles"),I=!1)}return F}async function h(s,r,t,a=process.env,o,u){const f=[];for(const[p,A]of s){if(A===null)continue;let O,M,N;if("source"in A){const q=i?.get(A.source);if(!q)continue;O=q.paths,M=A.args||q.args,A.icon?N=S(A.icon):q.icon&&(N=q.icon)}else O=Array.isArray(A.path)?A.path:[A.path],M=k.isWindows||Array.isArray(A.args)?A.args:void 0,N=S(A.icon)||void 0;const P=await u?.(O)||O.slice(),F=await n(p,r,P,t,a,M,A.env,A.overrideName,A.isAutoDetected,o);F?(F.isAutoDetected=A.isAutoDetected,F.icon=N,F.color=A.color,f.push(F)):o?.trace("profile not validated",p,O)}return f}function S(s){return typeof s=="string"?{id:s}:s}async function d(s){i&&!s||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:s||await v(),icon:b.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function v(){const s=[];for await(const r of(0,C.enumeratePowerShellInstallations)())s.push(r.exePath);return s}async function y(s,r){const t=[],a=await new Promise((f,p)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le"},(A,O)=>{if(A)return p("Problem occurred when getting wsl distros");f(O)})});if(!a)return[];const o=new RegExp(/[\r?\n]/),u=a.split(o).filter(f=>f.trim().length>0&&f!=="");for(const f of u){if(f===""||f.startsWith("docker-desktop"))continue;const p=`${f} (WSL)`,A={profileName:p,path:s,args:["-d",`${f}`],isDefault:p===r,icon:g(f)};t.push(A)}return t}function g(s){return s.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):s.includes("Debian")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function l(s,r,t,a,o,u,f,p){const A=new Map;if(t){const O=(await s.readFile("/etc/shells")).toString(),M=u||O.split(`
`).filter(P=>P.trim().indexOf("#")!==0&&P.trim().length>0),N=new Map;for(const P of M){let F=(0,D.basename)(P),q=N.get(F)||0;q++,q>1&&(F=`${F} (${q})`),N.set(F,q),A.set(F,{path:P,isAutoDetected:!0})}}return c(a,A),await h(A.entries(),o,s,p,r,f)}function c(s,r){if(!!s)for(const[t,a]of Object.entries(s))a===null||!("path"in a)&&!("source"in a)?r.delete(t):r.set(t,a)}async function n(s,r,t,a,o,u,f,p,A,O){if(t.length===0)return Promise.resolve(void 0);const M=t.shift();if(M==="")return n(s,r,t,a,o,u,f,p,A);const N={profileName:s,path:M,args:u,env:f,overrideName:p,isAutoDetected:A,isDefault:s===r};if((0,D.basename)(M)===M){const F=o.PATH?o.PATH.split(D.delimiter):void 0;return await(0,w.findExecutable)(M,void 0,F,void 0,a.existsFile)?N:n(s,r,t,a,o,u)}return await a.existsFile((0,D.normalize)(M))?N:n(s,r,t,a,o,u,f,p,A)}}),define(te[215],ne([0,1,3,2,15,4,32,44,21,13,75,163,10,86,22,208,95,213,214]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(n){n[n.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let l=0,c=class extends L.Disposable{constructor(s,r,t,a,o){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=t,this._logService=a,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new R.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new R.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new R.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new R.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new R.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,i.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const t=new C.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const o=t.getChannel(d.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(f=>this._onProcessData.fire(f))),this._register(u.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(u.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(u.onProcessTitleChanged(f=>this._onProcessTitleChanged.fire(f))),this._register(u.onProcessShellTypeChanged(f=>this._onProcessShellTypeChanged.fire(f))),this._register(u.onProcessOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f))),this._register(u.onProcessResolvedShellLaunchConfig(f=>this._onProcessResolvedShellLaunchConfig.fire(f))),this._register(u.onProcessDidChangeHasChildProcesses(f=>this._onProcessDidChangeHasChildProcesses.fire(f))),this._register(u.onDidChangeProperty(f=>this._onDidChangeProperty.fire(f))),this._register(u.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(u.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),this._register(u.onDidRequestDetach(f=>this._onDidRequestDetach.fire(f))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,t,a,o,u,f,p,A,O,M){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),P=await this._proxy.createProcess(s,r,t,a,o,u,f,p,A,O,M);return clearTimeout(N),l=Math.max(l,P),P}updateTitle(s,r,t){return this._proxy.updateTitle(s,r,t)}updateIcon(s,r,t){return this._proxy.updateIcon(s,r,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,t){return this._proxy.resize(s,r,t)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,t,a=!1){const o=await this._shellEnv;return(0,y.detectAvailableProfiles)(r,t,a,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,t){return this._proxy.updateProperty(s,r,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};c=he([X(1,w.IConfigurationService),X(2,b.IEnvironmentService),X(3,m.ILogService),X(4,h.ITelemetryService)],c),e.PtyHostService=c}),define(te[54],ne([0,1,39]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(T,C,w,b){const i=(0,R.setProperty)(T,C,w,b)[0];return i&&(T=T.substring(0,i.offset)+i.content+T.substring(i.offset+i.length)),T}e.edit=L;function D(T,C,w){let b=w;for(;b>=0;){if(T.charAt(b)===C.charAt(C.length-1)&&C.length===1)return b+1;if(b--,C.length===2&&b>=0&&T.charAt(b)===C.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function k(T,C,w){let b=w;for(;b>=0;)if(T.charAt(b)===C.charAt(C.length-1)&&C.length===1||(b++,C.length===2&&b>=0&&T.charAt(b)===C.charAt(1)))return b;return T.length-1}e.getLineEndOffset=k}),define(te[216],ne([0,1,26,61]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(I,m,E,h,S){const d=[],v=[],y=[];if(!m){const O=I.filter(({identifier:M})=>S.every(N=>N.toLowerCase()!==M.id.toLowerCase()));return{local:{added:d,removed:v,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}I=I.map(b),m=m.map(b),E=E?E.map(b):null;const g=new Map,l=O=>{O.uuid&&g.set(O.id.toLowerCase(),O.uuid)};I.forEach(({identifier:O})=>l(O)),m.forEach(({identifier:O})=>l(O)),E&&E.forEach(({identifier:O})=>l(O));const c=O=>{const M=O.identifier.uuid||g.get(O.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${O.identifier.id.toLowerCase()}`},n=(O,M)=>(O.set(c(M),M),O),s=I.reduce(n,new Map),r=m.reduce(n,new Map),t=m.reduce((O,M)=>{const N=c(M);M=(0,R.deepClone)(M);const P=s.get(N);return P&&(P.installed&&(M.installed=!0),M.version||(M.version=P.version)),n(O,M)},new Map),a=E?E.reduce(n,new Map):null,o=h.reduce(n,new Map),u=S.reduce((O,M)=>{const N=g.get(M.toLowerCase());return O.add(N?`uuid:${N}`:`id:${M.toLowerCase()}`)},new Set),f=k(s,r,u);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const O=k(a,s,u),M=k(a,r,u),N=(P,F)=>{const q=s.get(P);if(q){const _=r.get(P);return{...F?_:q,version:(_.version&&L.gt(_.version,q.version),q.version),state:T(q,_,a?.get(P))}}};for(const P of M.removed.values()){const F=s.get(P);F&&v.push(F.identifier)}for(const P of M.added.values())if(O.added.has(P)){if(f.updated.has(P)){const F=N(P,!0);F&&(y.push(i(F,P)),t.set(P,F))}}else{const F=r.get(P);F.installed&&d.push(i(F,P))}for(const P of M.updated.values()){const F=N(P,!0);F&&(y.push(i(F,P)),t.set(P,F))}for(const P of O.added.values())M.added.has(P)||t.set(P,s.get(P));for(const P of O.updated.values())if(!M.removed.has(P)&&!M.updated.has(P)){const F=N(P,!1);F&&(t.get(P)?.installed&&(F.installed=!0),t.set(P,F))}for(const P of O.removed.values())!o.has(P)&&!M.updated.has(P)&&a?.get(P)?.installed&&t.delete(P)}const p=[],A=k(r,t,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&t.forEach((O,M)=>p.push(i(O,M))),{local:{added:d,removed:v,updated:y},remote:p.length?{added:[...A.added].map(O=>t.get(O)),updated:[...A.updated].map(O=>t.get(O)),removed:[...A.removed].map(O=>r.get(O)),all:p}:null}}e.merge=D;function k(I,m,E,{checkInstalledProperty:h,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const d=I?[...I.keys()].filter(c=>!E.has(c)):[],v=[...m.keys()].filter(c=>!E.has(c)),y=v.filter(c=>d.indexOf(c)===-1).reduce((c,n)=>(c.add(n),c),new Set),g=d.filter(c=>v.indexOf(c)===-1).reduce((c,n)=>(c.add(n),c),new Set),l=new Set;for(const c of d){if(g.has(c))continue;const n=I.get(c),s=m.get(c);(!s||n.disabled!==s.disabled||!w(n.state,s.state)||S&&n.version!==s.version||h&&n.installed!==s.installed)&&l.add(c)}return{added:y,removed:g,updated:l}}function T(I,m,E){const h=I.state,S=m.state,d=E?.state;if(!m.version||h&&L.gt(I.version,m.version))return h;if(S&&L.gt(m.version,I.version)||!h)return S;if(!S)return h;const v=(0,R.deepClone)(h),y=d?C(d,S):{added:Object.keys(S).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set},g=d?C(d,h):{added:Object.keys(h).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set};for(const l of[...y.added.values(),...y.updated.values()])v[l]=S[l];for(const l of y.removed.values())g.updated.has(l)||delete v[l];return v}function C(I,m){const E=Object.keys(I),h=Object.keys(m),S=h.filter(y=>E.indexOf(y)===-1).reduce((y,g)=>(y.add(g),y),new Set),d=E.filter(y=>h.indexOf(y)===-1).reduce((y,g)=>(y.add(g),y),new Set),v=new Set;for(const y of E){if(d.has(y))continue;const g=I[y],l=m[y];(0,R.equals)(g,l)||v.add(y)}return{added:S,removed:d,updated:v}}function w(I={},m={}){const{added:E,removed:h,updated:S}=C(I,m);return E.size===0&&h.size===0&&S.size===0}function b(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function i(I,m){const E={identifier:{id:I.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return I.version&&(E.version=I.version),I.disabled&&(E.disabled=!0),I.installed&&(E.installed=!0),I.state&&(E.state=I.state),E}}),define(te[97],ne([0,1,17,3,2,36,6,28,23]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,T.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class it extends D.Disposable{constructor(m,E){super();this.storageService=m,this.productService=E,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(m){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const E=b.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}initialize(){const m=this.storageService.keys(0,1);for(const E of m){const h=it.fromKey(E);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const E=it.fromKey(m.key);if(E){this.extensionsWithKeysForSync.add(E.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,E){this.storageService.store(it.toKey(m),JSON.stringify(E),0,1)}getKeysForSync(m){const E=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],h=this.storageService.get(it.toKey(m),0),S=h?JSON.parse(h):void 0;return S&&E?(0,R.distinct)([...S,...E]):S||E}};i=he([X(0,w.IStorageService),X(1,C.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[98],ne([0,1,17,21,6]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(C){this.configurationService=C}hasToNeverSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==C&&i!==`-${C}`),w&&b.push(C.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(C,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==C&&i!==`-${C}`),w&&b.push(`-${C.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(C){const w=C.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),i=[],I=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?I.push(m.substring(1)):i.push(m);return(0,R.distinct)([...w,...i].filter(m=>I.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let C=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.configurationService.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};k=he([X(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(te[217],ne([0,1,17,33,26,158,54]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function C(l){return(0,L.parse)(l)||[]}e.parseKeybindings=C;async function w(l,c,n,s,r){const t=C(l),a=C(c),o=n?C(n):null,u=[...t,...a,...o||[]].map($=>$.key),f=await r.resolveUserBindings(u);let p=i(t,a,o,f);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const A=m(t),O=m(a),M=o?m(o):null,N=h(A,O,f),P=M?h(M,A,f):{added:[...A.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set},F=M?h(M,O,f):{added:[...O.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set},q=b(N,P,F);let _=l;for(const $ of q.removed.values())q.conflicts.has($)||(_=y(_,$,s));for(const $ of q.added.values()){if(q.conflicts.has($))continue;const H=O.get($);if(H.some(j=>j.command!==`-${$}`&&p.conflicts.has(f[j.key]))){q.conflicts.add($);continue}_=v(_,H,s)}for(const $ of q.updated.values()){if(q.conflicts.has($))continue;const H=O.get($);if(H.some(j=>j.command!==`-${$}`&&p.conflicts.has(f[j.key]))){q.conflicts.add($);continue}_=g(_,$,H,s)}return{mergeContent:_,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=w;function b(l,c,n){const s=new Set,r=new Set,t=new Set,a=new Set;for(const o of c.removed.values())n.updated.has(o)&&a.add(o);for(const o of n.removed.values())a.has(o)||(c.updated.has(o)?a.add(o):r.add(o));for(const o of c.added.values())a.has(o)||n.added.has(o)&&l.updated.has(o)&&a.add(o);for(const o of n.added.values())a.has(o)||(c.added.has(o)?l.updated.has(o)&&a.add(o):s.add(o));for(const o of c.updated.values())a.has(o)||n.updated.has(o)&&l.updated.has(o)&&a.add(o);for(const o of n.updated.values())a.has(o)||(c.updated.has(o)?l.updated.has(o)&&a.add(o):t.add(o));return{added:s,removed:r,updated:t,conflicts:a}}function i(l,c,n,s){const r=new Set,t=I(l,s),a=I(c,s),o=n?I(n,s):null,u=E(t,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const f=o?E(o,t):{added:[...t.keys()].reduce((P,F)=>(P.add(F),P),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const p=o?E(o,a):{added:[...a.keys()].reduce((P,F)=>(P.add(F),P),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:A,removed:O,updated:M,conflicts:N}=b(u,f,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:M,conflicts:N}}function I(l,c){const n=new Map;for(const s of l){const r=c[s.key];let t=n.get(r);t||(t=[],n.set(r,t)),t.push(s)}return n}function m(l){const c=new Map;for(const n of l){const s=n.command[0]==="-"?n.command.substring(1):n.command;let r=c.get(s);r||(r=[],c.set(s,r)),r.push(n)}return c}function E(l,c){const n=[...l.keys()],s=[...c.keys()],r=s.filter(o=>n.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),t=n.filter(o=>s.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=new Set;for(const o of n){if(t.has(o))continue;const u=l.get(o).map(p=>({...p,key:o})),f=c.get(o).map(p=>({...p,key:o}));(0,R.equals)(u,f,(p,A)=>d(p,A))||a.add(o)}return{added:r,removed:t,updated:a}}function h(l,c,n){const s=[...l.keys()],r=[...c.keys()],t=r.filter(u=>s.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),a=s.filter(u=>r.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),o=new Set;for(const u of s){if(a.has(u))continue;const f=l.get(u).map(A=>({...A,key:n[A.key]})),p=c.get(u).map(A=>({...A,key:n[A.key]}));S(f,p)||o.add(u)}return{added:t,removed:a,updated:o}}function S(l,c){return!(!(0,R.equals)(l.filter(({command:n})=>n[0]!=="-"),c.filter(({command:n})=>n[0]!=="-"),(n,s)=>d(n,s))||!(0,R.equals)(l.filter(({command:n})=>n[0]==="-"),c.filter(({command:n})=>n[0]==="-"),(n,s)=>d(n,s)))}function d(l,c){if(l.command!==c.command||l.key!==c.key)return!1;const n=k.ContextKeyExpr.deserialize(l.when),s=k.ContextKeyExpr.deserialize(c.when);return!(n&&!s||!n&&s||n&&s&&!n.equals(s)||!D.equals(l.args,c.args))}function v(l,c,n){for(const s of c)l=T.edit(l,[-1],s,n);return l}function y(l,c,n){const s=C(l);for(let r=s.length-1;r>=0;r--)(s[r].command===c||s[r].command===`-${c}`)&&(l=T.edit(l,[r],void 0,n));return l}function g(l,c,n,s){const r=C(l),t=r.findIndex(a=>a.command===c||a.command===`-${c}`);for(let a=r.length-1;a>=0;a--)(r[a].command===c||r[a].command===`-${c}`)&&(l=T.edit(l,[a],void 0,s));for(let a=n.length-1;a>=0;a--)l=T.edit(l,[t],n[a],s);return l}}),define(te[218],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(k,T,C){const w={},b={},i=new Set;if(!T)return{local:{added:w,updated:b,removed:[...i.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const I=L(k,T);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:w,updated:b,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=L(C,k),E=L(C,T),h={},S={},d=new Set,v=new Set;for(const y of m.removed.values())E.updated.has(y)?w[y]=T[y]:d.add(y);for(const y of E.removed.values())v.has(y)||(m.updated.has(y)?v.add(y):i.add(y));for(const y of m.updated.values())v.has(y)||(E.updated.has(y)?I.updated.has(y)&&v.add(y):S[y]=k[y]);for(const y of E.updated.values())v.has(y)||(m.updated.has(y)?I.updated.has(y)&&v.add(y):k[y]!==void 0&&(b[y]=T[y]));for(const y of m.added.values())v.has(y)||(E.added.has(y)?I.updated.has(y)&&v.add(y):h[y]=k[y]);for(const y of E.added.values())v.has(y)||(m.added.has(y)?I.updated.has(y)&&v.add(y):w[y]=T[y]);return{local:{added:w,removed:[...i.values()],updated:b},remote:{added:h,removed:[...d.values()],updated:S},conflicts:[...v.values()]}}e.merge=R;function L(k,T){const C=k?Object.keys(k):[],w=T?Object.keys(T):[],b=w.filter(m=>C.indexOf(m)===-1).reduce((m,E)=>(m.add(E),m),new Set),i=C.filter(m=>w.indexOf(m)===-1).reduce((m,E)=>(m.add(E),m),new Set),I=new Set;for(const m of C){if(i.has(m))continue;const E=k[m],h=T[m];E!==h&&I.add(m)}return{added:b,removed:i,updated:I}}function D(k,T){const{added:C,removed:w,updated:b}=L(k,T);return C.size===0&&w.size===0&&b.size===0}e.areSame=D}),define(te[24],ne([0,1,17,16,18,148,38,30,6,87,35]),function(J,e,R,L,D,k,T,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const o=i.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function m(){const o=i.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(A=>!!o[A].ignoreSync),f=Object.keys(o).filter(A=>o[A].scope===2||o[A].scope===6),p=I();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...f,...p])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function E(){const o="vscode://schemas/ignoredSettings",u=i.Registry.as(T.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=i.Registry.as(b.Extensions.JSONContribution),p=()=>{const A=I(),O=m().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),M=Object.keys(T.allSettings.properties).filter(F=>O.indexOf(F)===-1),N=O.filter(F=>A.indexOf(F)===-1),P={items:{type:"string",enum:[...M,...N.map(F=>`-${F}`)]}};f.registerSchema(o,P)};return u.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=E;function h(o){return o&&(0,D.isObject)(o)&&(0,D.isString)(o.id)&&(0,D.isArray)(o.scopes)}e.isAuthenticationProvider=h;var S;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(o,u,f){return f.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function v(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=v;var y;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(u,f,p,A){super(u);this.code=f,this.resource=p,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class l extends g{constructor(u,f,p,A,O){super(u,p,void 0,O);this.url=f,this.serverCode=A}}e.UserDataSyncStoreError=l;class c extends g{constructor(u,f){super(u,f)}}e.UserDataAutoSyncError=c,function(o){function u(f){if(f instanceof o)return f;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(p&&p[1]){const A=p[2]==="unknown"?void 0:p[2],O=p[3]==="unknown"?void 0:p[3];return new o(f.message,p[1],A,O)}return new o(f.message,"Unknown")}o.toUserDataSyncError=u}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var s;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,L.isEqualOrParent)(o,(0,L.joinPath)(u.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[48],ne([0,1,17,5,19,27,3,33,2,16,25,18,9,144,21,13,14,46,23,22,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=c;let n=class extends w.Disposable{constructor(o,u,f,p,A,O,M,N,P,F){super();this.resource=o,this.fileService=u,this.environmentService=f,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=M,this.telemetryService=N,this.logService=P,this.configurationService=F,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(f.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(o,f,this.extUri),this.currentMachineIdPromise=(0,v.getServiceMachineId)(f,u,p)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,this.getUserDataSyncConfiguration(),k.CancellationToken.None)).resourcePreviews.some(({remoteChange:f})=>f!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,this.getUserDataSyncConfiguration(),u)}async preview(o,u,f={}){return this._sync(o,!1,u,f)}async apply(o,u={}){try{this.syncHeaders={...u};const f=await this.doApply(o);return this.setStatus(f),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,f,p){try{if(this.syncHeaders={...p},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const O=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(o,O);return A=await this.performSync(M,O,u,f),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const f=this.parseSyncData(u);if(!f)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const p=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,p),O=await this.isRemoteDataFromCurrentMachine(A),M=await this.generateSyncPreview({ref:A.ref,syncData:f},p,O,this.getUserDataSyncConfiguration(),k.CancellationToken.None),N=[];for(const P of M){const F=await this.getAcceptResult(P,P.remoteResource,void 0,k.CancellationToken.None),{remoteChange:q}=await this.getAcceptResult(P,P.previewResource,P.remoteContent,k.CancellationToken.None);N.push([P,{...F,remoteChange:q!==0?q:2}])}await this.applyResult(A,p,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const f=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===f||f===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,f,p){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(o,u,f,p)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,f,p);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,f,p)}throw A}}async doSync(o,u,f,p){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(o,u,f,p,O)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":f?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const f=await this.getMergeResult(u,k.CancellationToken.None);await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(f?.content||""));const p=f&&!f.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,k.CancellationToken.None):void 0;return u.acceptResult=p,u.mergeState=f.hasConflicts?"conflict":p?"accepted":"preview",u.localChange=p?p.localChange:f.localChange,u.remoteChange=p?p.remoteChange:f.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async f=>{const p=await this.getAcceptResult(f,o,u,k.CancellationToken.None);return f.acceptResult=p,f.mergeState="accepted",f.localChange=p.localChange,f.remoteChange=p.remoteChange,f}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const f=await this.getMergeResult(u,k.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(f.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=f.localChange,u.remoteChange=f.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let f=await this.syncPreviewPromise;const p=f.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:M})=>this.extUri.isEqual(A,o)||this.extUri.isEqual(O,o)||this.extUri.isEqual(M,o));p!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async A=>{const O=[...f.resourcePreviews];return O[p]=await u(O[p]),{...f,resourcePreviews:O}}),f=await this.syncPreviewPromise,this.updateConflicts(f.resourcePreviews),f.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:f})=>f!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(f=>[f,f.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:f})=>f==="conflict");(0,R.equals)(this._conflicts,u,(f,p)=>this.extUri.isEqual(f.previewResource,p.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:f})=>({created:u,uri:this.toRemoteBackupResource(f)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:f})=>({created:u,uri:this.toLocalBackupResource(f)}))}toRemoteBackupResource(o){return m.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return m.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:f}=await this.getUserData(u);if(f)return this.parseSyncData(f)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:f}=await this.getUserData(u);return f}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const f of u.resourcePreviews){if(this.extUri.isEqual(f.acceptedResource,o))return f.acceptResult?f.acceptResult.content:null;if(this.extUri.isEqual(f.remoteResource,o))return f.remoteContent;if(this.extUri.isEqual(f.localResource,o))return f.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,f,p,A){const O=await this.isRemoteDataFromCurrentMachine(o),M=await this.generateSyncPreview(o,u,O,p,A),N=[];for(const P of M){const F=P.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(P.localChange===0&&P.remoteChange===0)N.push({...P,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const q=f?await this.getMergeResult(P,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(P.previewResource,D.VSBuffer.fromString(q?.content||""));const _=q&&!q.hasConflicts?await this.getAcceptResult(P,P.previewResource,void 0,A):void 0;N.push({...P,acceptResult:_,mergeState:q?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:q?q.localChange:P.localChange,remoteChange:_?_.remoteChange:q?q.remoteChange:P.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:N,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&f&&u.version!==f,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${f}.`),await this.resetLocal(),null;const p=u;if(p.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(p.content);if(c(A))return{...u,syncData:A,content:void 0}}catch(o){o instanceof d.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),p={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:f,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(p)))}async getRemoteUserData(o){const{ref:u,content:f}=await this.getUserData(o);let p=null;return f!==null&&(p=this.parseSyncData(f)),{ref:u,syncData:p}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(o){if((0,I.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const f=await this.currentMachineIdPromise,p={version:this.version,machineId:f,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(p),u,this.syncHeaders),{ref:u,syncData:p}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=he([X(1,d.IFileService),X(2,S.IEnvironmentService),X(3,y.IStorageService),X(4,l.IUserDataSyncStoreService),X(5,l.IUserDataSyncBackupStoreService),X(6,l.IUserDataSyncResourceEnablementService),X(7,g.ITelemetryService),X(8,l.IUserDataSyncLogService),X(9,h.IConfigurationService)],n),e.AbstractSynchroniser=n;let s=class extends n{constructor(o,u,f,p,A,O,M,N,P,F,q){super(u,f,p,A,O,M,N,P,F,q);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(_=>this.onFileChanges(_)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,f){try{u?await this.writeFileContent(o,u,f):await this.fileService.createFile(this.file,D.VSBuffer.fromString(o),{overwrite:f})}catch(p){throw p instanceof d.FileOperationError&&p.fileOperationResult===1||p instanceof d.FileOperationError&&p.fileOperationResult===3?new l.UserDataSyncError(p.message,"LocalPreconditionFailed"):p}}async writeFileContent(o,u,f){await this.fileService.writeFile(this.file,D.VSBuffer.fromString(o),f?void 0:u)}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};s=he([X(2,d.IFileService),X(3,S.IEnvironmentService),X(4,y.IStorageService),X(5,l.IUserDataSyncStoreService),X(6,l.IUserDataSyncBackupStoreService),X(7,l.IUserDataSyncResourceEnablementService),X(8,g.ITelemetryService),X(9,l.IUserDataSyncLogService),X(10,h.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(o,u,f,p,A,O,M,N,P,F,q,_){super(o,u,f,p,A,O,M,N,P,F,_);this.userDataSyncUtilService=q,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,C.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([X(2,d.IFileService),X(3,S.IEnvironmentService),X(4,y.IStorageService),X(5,l.IUserDataSyncStoreService),X(6,l.IUserDataSyncBackupStoreService),X(7,l.IUserDataSyncResourceEnablementService),X(8,g.ITelemetryService),X(9,l.IUserDataSyncLogService),X(10,l.IUserDataSyncUtilService),X(11,h.IConfigurationService)],r),e.AbstractJsonFileSynchroniser=r;let t=class{constructor(o,u,f,p){this.resource=o,this.environmentService=u,this.logService=f,this.fileService=p,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,b.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const f=this.parseSyncData(u);if(!f)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:f})}catch(A){this.logService.error(A)}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const f={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(f)))}};t=he([X(1,S.IEnvironmentService),X(2,l.IUserDataSyncLogService),X(3,d.IFileService)],t),e.AbstractInitializer=t}),define(te[219],ne([0,1,5,27,7,3,39,49,25,9,21,13,30,36,14,23,22,48,216,97,98,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(o,u){const f=JSON.parse(o.content);if(o.version===1||o.version===2){const p=(await u.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of f)o.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),o.version===2&&p.every(O=>!(0,E.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return f}function s(o,u,f){const p=f.get((0,E.getExtensionId)(o,u),0)||"{}";return JSON.parse(p)}e.getExtensionStorageState=s;function r(o,u,f,p){p.store((0,E.getExtensionId)(o,u),JSON.stringify(f),0,1)}e.storeExtensionStorageState=r;let t=class ht extends v.AbstractSynchroniser{constructor(u,f,p,A,O,M,N,P,F,q,_,$,H,j){super("extensions",f,u,p,A,O,$,H,F,_);this.storageService=p,this.extensionManagementService=M,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=P,this.extensionGalleryService=q,this.extensionsStorageSyncService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:z})=>!!z)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,f){const p=u.syncData?await n(u.syncData,this.extensionManagementService):null,A=f?.skippedExtensions||[],O=f?.syncData?await n(f.syncData,this.extensionManagementService):null,M=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(M),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(M);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:q}=(0,y.merge)(N,p,O,A,P),_={local:F,remote:q,content:this.getPreviewContent(N,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:q!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:p?this.format(p):null,previewResource:this.previewResource,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,f,p,A){const O=[...f,...p],M=new Set,N=P=>{M.add(P.id.toLowerCase()),P.uuid&&M.add(P.uuid)};O.forEach(({identifier:P})=>N(P)),A.forEach(N);for(const P of u)M.has(P.identifier.id.toLowerCase())||P.identifier.uuid&&M.has(P.identifier.uuid)||O.push(P);return this.format(O)}async getMergeResult(u,f){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,f,p,A){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(f,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(u){const f=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),A=(0,y.merge)(u.localExtensions,null,null,u.skippedExtensions,p),{local:O,remote:M}=A;return{content:u.localContent,local:O,remote:M,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:M!==null?2:0}}async acceptRemote(u){const f=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),A=u.remoteContent?JSON.parse(u.remoteContent):null;if(A!==null){const O=(0,y.merge)(u.localExtensions,A,u.localExtensions,[],p),{local:M,remote:N}=O;return{content:u.remoteContent,local:M,remote:N,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,f,p,A){let{skippedExtensions:O,localExtensions:M}=p[0][0],{local:N,remote:P,localChange:F,remoteChange:q}=p[0][1];if(F===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(M)),O=await this.updateLocalExtensions(N.added,N.removed,N.updated,O)),P){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const _=JSON.stringify(P.all);u=await this.updateRemoteUserData(_,A?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${P.added.length?` Added: ${JSON.stringify(P.added.map($=>$.identifier.id))}.`:""}${P.updated.length?` Updated: ${JSON.stringify(P.updated.map($=>$.identifier.id))}.`:""}${P.removed.length?` Removed: ${JSON.stringify(P.removed.map($=>$.identifier.id))}.`:""}`)}f?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(_=>_.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ht.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ht.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),O=this.getLocalExtensions(p).filter(M=>!A.some(N=>(0,E.areSameExtensions)({id:N},M.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let f=await super.resolveContent(u);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(u)),f){const p=this.parseSyncData(f);if(p)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(p))}}return null}format(u){u.sort((A,O)=>!A.identifier.uuid&&O.identifier.uuid?-1:A.identifier.uuid&&!O.identifier.uuid?1:(0,w.compare)(A.identifier.id,O.identifier.id));const f=JSON.stringify(u),p=(0,C.format)(f,void 0,{});return(0,T.applyEdits)(f,p)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(p=>p.installed||p.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,f,p,A){const O=[],M=[],N=await this.extensionManagementService.getInstalled();if(f.length){const F=N.filter(({identifier:q,isBuiltin:_})=>!_&&f.some($=>(0,E.areSameExtensions)(q,$)));await R.Promises.settled(F.map(async q=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,q.identifier.id),await this.extensionManagementService.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,q.identifier.id),O.push(q.identifier)}))}(u.length||p.length)&&await R.Promises.settled([...u,...p].map(async F=>{const q=N.find($=>(0,E.areSameExtensions)($.identifier,F.identifier));if(q&&q.isBuiltin){F.state&&q.manifest.version===F.version&&this.updateExtensionState(F.state,q.manifest.publisher,q.manifest.name,q.manifest.version),F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id)),O.push(F.identifier);return}const _=(await this.extensionGalleryService.getExtensions([F.identifier],L.CancellationToken.None))[0];if(F.state&&(q?q.manifest.version===F.version:!!_)){const $=q?q.manifest.publisher:_.publisher,H=q?q.manifest.name:_.name;this.updateExtensionState(F.state,$,H,q?.manifest.version)}if(_)try{F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,_.version),await this.extensionEnablementService.disableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,_.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,_.version),await this.extensionEnablementService.enableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,_.version)),q||(await this.extensionManagementService.canInstall(_)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,_.version),await this.extensionManagementService.installFromGallery(_,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,_.version),O.push(_.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,_.displayName||_.identifier.id),M.push(F)))}catch($){M.push(F),$ instanceof m.ExtensionManagementError&&$.code===m.ExtensionManagementErrorCode.Incompatible?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,_.displayName||_.identifier.id):(this.logService.error($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,_.displayName||_.identifier.id))}else M.push(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,F.identifier.id)}));const P=[];for(const F of A)O.some(q=>(0,E.areSameExtensions)(q,F.identifier))||P.push(F);for(const F of M)P.some(q=>(0,E.areSameExtensions)(q.identifier,F.identifier))||P.push(F);return P}updateExtensionState(u,f,p,A){const O=s(f,p,this.storageService),M=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(f,p),version:A}):void 0;M?M.forEach(N=>{O[N]=u[N]}):Object.keys(u).forEach(N=>O[N]=u[N]),r(f,p,O,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const f=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:p,isBuiltin:A,manifest:O})=>{const M={identifier:p,version:O.version};f.some(N=>(0,E.areSameExtensions)(N,p))&&(M.disabled=!0),A||(M.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:p.id,version:O.version});if(N){const P=s(O.publisher,O.name,this.storageService);M.state=Object.keys(P).reduce((F,q)=>(N.includes(q)&&(F[q]=P[q]),F),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(N))}return M})}};t.EXTENSIONS_DATA_URI=b.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),t=he([X(0,I.IEnvironmentService),X(1,h.IFileService),X(2,S.IStorageService),X(3,c.IUserDataSyncStoreService),X(4,c.IUserDataSyncBackupStoreService),X(5,m.IExtensionManagementService),X(6,m.IGlobalExtensionEnablementService),X(7,l.IIgnoredExtensionsManagementService),X(8,c.IUserDataSyncLogService),X(9,m.IExtensionGalleryService),X(10,i.IConfigurationService),X(11,c.IUserDataSyncResourceEnablementService),X(12,d.ITelemetryService),X(13,g.IExtensionsStorageSyncService)],t),e.ExtensionsSynchroniser=t;let a=class extends v.AbstractInitializer{constructor(u,f,p,A,O){super("extensions",A,O,p);this.extensionManagementService=u,this.ignoredExtensionsManagementService=f}async parseExtensions(u){return u.syncData?await n(u.syncData,this.extensionManagementService):null}generatePreview(u,f){const p=[],A=[],O=[];for(const M of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(M.identifier.id))continue;const N=f.find(P=>(0,E.areSameExtensions)(P.identifier,M.identifier));N?(p.push(N),M.disabled&&O.push(M.identifier)):M.installed&&(A.push(M.identifier),M.disabled&&O.push(M.identifier))}return{installedExtensions:p,newExtensions:A,disabledExtensions:O,remoteExtensions:u}}};a=he([X(0,m.IExtensionManagementService),X(1,l.IIgnoredExtensionsManagementService),X(2,h.IFileService),X(3,I.IEnvironmentService),X(4,c.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(te[220],ne([0,1,26,24]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(C,w,b,i,I){if(!w)return{remote:Object.keys(C).length>0?C:null,local:{added:{},removed:[],updated:{}}};const m=k(C,w);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=b?k(b,w):{added:Object.keys(w).reduce((y,g)=>(y.add(g),y),new Set),removed:new Set,updated:new Set},h=b?k(b,C):{added:Object.keys(C).reduce((y,g)=>(y.add(g),y),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},d=R.deepClone(w),v=!b;for(const y of h.added.values())y!==L.SYNC_SERVICE_URL_TYPE&&v&&E.added.has(y)||(d[y]=C[y]);for(const y of h.updated.values())d[y]=C[y];for(const y of h.removed.values())i.unregistered.includes(y)||delete d[y];for(const y of E.added.values()){const g=w[y];if(i.machine.includes(y)){I.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(y))continue;const l=C[y];l&&l.value===g.value||y===L.SYNC_SERVICE_URL_TYPE&&v&&h.added.has(y)||(l?S.updated[y]=g:S.added[y]=g)}for(const y of E.updated.values()){const g=w[y];if(i.machine.includes(y)){I.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(y)||h.removed.has(y))continue;const l=C[y];l&&l.value===g.value||(S.updated[y]=g)}for(const y of E.removed.values()){if(i.machine.includes(y)){I.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}h.updated.has(y)||h.removed.has(y)||S.removed.push(y)}return{local:S,remote:T(d,w)?null:d}}e.merge=D;function k(C,w){const b=Object.keys(C),i=Object.keys(w),I=i.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),m=b.filter(h=>i.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),E=new Set;for(const h of b){if(m.has(h))continue;const S=C[h],d=w[h];R.equals(S,d)||E.add(h)}return{added:I,removed:m,updated:E}}function T(C,w){const{added:b,removed:i,updated:I}=k(C,w);return b.size===0&&i.size===0&&I.size===0}}),define(te[221],ne([0,1,19,7,3,33,39,49,4,9,29,21,13,14,10,46,23,22,48,54,220,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const n="globalState.argv.",s=["locale"];function r(f){const p=f.storage?Object.keys(f.storage).sort():[],A={};p.forEach(N=>A[N]=f.storage[N]),f.storage=A;const O=JSON.stringify(f),M=(0,C.format)(O,void 0,{});return(0,T.applyEdits)(O,M)}const t=1;let a=class ft extends y.AbstractSynchroniser{constructor(p,A,O,M,N,P,F,q,_){super("globalState",p,N,_,A,O,P,F,M,q);this.storageService=_,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(p.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(p.onDidFilesChange,$=>$.contains(this.environmentService.argvResource)),D.Event.filter(_.onDidChangeValue,$=>$.scope===0&&$.target!==void 0?$.target===0:_.keys(0,0).includes($.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(p,A,O){const M=p.syncData?JSON.parse(p.syncData.content):null;A=A===null&&O?p:A;const N=A&&A.syncData?JSON.parse(A.syncData.content):null,P=await this.getLocalGlobalState();M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const F=this.getStorageKeys(N),{local:q,remote:_}=(0,l.merge)(P.storage,M?M.storage:null,N?N.storage:null,F,this.logService),$={content:null,local:q,remote:_,localChange:Object.keys(q.added).length>0||Object.keys(q.updated).length>0||q.removed.length>0?2:0,remoteChange:_!==null?2:0};return[{localResource:this.localResource,localContent:r(P),localUserData:P,remoteResource:this.remoteResource,remoteContent:M?r(M):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:F}]}async getMergeResult(p,A){return{...p.previewResult,hasConflicts:!1}}async getAcceptResult(p,A,O,M){if(this.extUri.isEqual(A,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(A,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(A,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async acceptLocal(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:p.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(p){if(p.remoteContent!==null){const A=JSON.parse(p.remoteContent),{local:O,remote:M}=(0,l.merge)(p.localUserData.storage,A.storage,null,p.storageKeys,this.logService);return{content:p.remoteContent,local:O,remote:M,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(p,A,O,M){let{localUserData:N}=O[0][0],{local:P,remote:F,localChange:q,remoteChange:_}=O[0][1];if(q===0&&_===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(P),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),_!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const $=JSON.stringify({storage:F});p=await this.updateRemoteUserData($,M?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}A?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:p}){return[{resource:this.extUri.joinPath(p,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(p){if(this.extUri.isEqual(p,ft.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return r(O)}if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let A=await super.resolveContent(p);if(A)return A;if(A=await super.resolveContent(this.extUri.dirname(p)),A){const O=this.parseSyncData(A);if(O)switch(this.extUri.basename(p)){case"globalState.json":return r(JSON.parse(O.content))}}return null}async hasLocalData(){try{const{storage:p}=await this.getLocalGlobalState();if(Object.keys(p).length>1||p[`${n}.locale`]?.value!=="en")return!0}catch(p){}return!1}async getLocalGlobalState(){const p={},A=await this.getLocalArgvContent(),O=(0,k.parse)(A);for(const M of s)O[M]!==void 0&&(p[`${n}${M}`]={version:1,value:O[M]});for(const M of this.storageService.keys(0,0)){const N=this.storageService.get(M,0);N&&(p[M]={version:1,value:N})}return{storage:p}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const p=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),p.value.toString()}catch(p){this.logService.debug((0,L.getErrorMessage)(p))}return"{}"}async writeLocalGlobalState({added:p,removed:A,updated:O}){const M={},N={},P=(q,_)=>{for(const $ of q){if($.startsWith(n)){M[$.substring(n.length)]=_?_[$].value:void 0;continue}if(_){const H=_[$];H.value!==String(this.storageService.get($,0))&&(N[$]=H.value)}else this.storageService.get($,0)!==void 0&&(N[$]=void 0)}};if(P(Object.keys(p),p),P(Object.keys(O),O),P(A),Object.keys(M).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(M),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const q of Object.keys(N))this.storageService.store(q,N[q],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(p){const A=await this.getLocalArgvContent();let O=A;for(const M of Object.keys(p))O=(0,g.edit)(O,[M],p[M],{});A!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(p){const A=this.storageService.keys(0,0),O=this.storageService.keys(0,1),M=[...A,...O],N=p?.storage?Object.keys(p.storage).filter(P=>!P.startsWith(n)&&!M.includes(P)&&this.storageService.get(P,0)!==void 0):[];if(!w.isWeb){const P=[...c.ALL_SYNC_RESOURCES.map(F=>(0,c.getEnablementKey)(F)),c.SYNC_SERVICE_URL_TYPE];N.push(...P),O.push(...P)}return{user:A,machine:O,unregistered:N}}};a.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=he([X(0,E.IFileService),X(1,c.IUserDataSyncStoreService),X(2,c.IUserDataSyncBackupStoreService),X(3,c.IUserDataSyncLogService),X(4,m.IEnvironmentService),X(5,c.IUserDataSyncResourceEnablementService),X(6,v.ITelemetryService),X(7,I.IConfigurationService),X(8,d.IStorageService)],a),e.GlobalStateSynchroniser=a;let o=class extends y.AbstractInitializer{constructor(p,A,O,M){super("globalState",O,M,A);this.storageService=p}async doInitialize(p){const A=p.syncData?JSON.parse(p.syncData.content):null;if(!A){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},M={};for(const N of Object.keys(A.storage))N.startsWith(n)?O[N.substring(n.length)]=A.storage[N].value:this.storageService.get(N,0)===void 0&&(M[N]=A.storage[N].value);if(Object.keys(O).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(P){}for(const P of Object.keys(O))N=(0,g.edit)(N,[P],O[P],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(N))}if(Object.keys(M).length)for(const N of Object.keys(M))this.storageService.store(N,M[N],0,0)}};o=he([X(0,d.IStorageService),X(1,E.IFileService),X(2,m.IEnvironmentService),X(3,c.IUserDataSyncLogService)],o),e.GlobalStateInitializer=o;let u=class{constructor(p,A,O,M,N){this.userDataSyncStoreClient=p,this.storageService=A,this.environmentService=O,this.fileService=M,this.logService=N}getSyncStoreType(p){return this.parseGlobalState(p)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(p){const A=(0,c.createSyncHeaders)((0,i.generateUuid)());try{return await this.doSync(p,A)}catch(O){if(O instanceof c.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(p,A)}throw O}}async doSync(p,A){const O=await this.userDataSyncStoreClient.read("globalState",null,A),M=this.parseGlobalState(O)||{storage:{}};M.storage[c.SYNC_SERVICE_URL_TYPE]={value:p,version:t};const N=await(0,S.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),P={version:t,machineId:N,content:r(M)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(P),O.ref,A)}parseGlobalState({content:p}){if(!p)return null;const A=JSON.parse(p);if((0,y.isSyncData)(A))return A?JSON.parse(A.content):null;throw new Error("Invalid remote data")}};u=he([X(1,d.IStorageService),X(2,m.IEnvironmentService),X(3,E.IFileService),X(4,h.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(te[222],ne([0,1,17,19,3,33,4,18,145,21,13,14,23,22,48,217,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(l,c,n){try{const s=JSON.parse(l);if(!c)return(0,C.isUndefined)(s.all)?null:s.all;switch(T.OS){case 2:return(0,C.isUndefined)(s.mac)?null:s.mac;case 3:return(0,C.isUndefined)(s.linux)?null:s.linux;case 1:return(0,C.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.getKeybindingsContentFromSyncContent=v;let y=class extends h.AbstractJsonFileSynchroniser{constructor(c,n,s,r,t,a,o,u,f,p){super(o.keybindingsResource,"keybindings",a,o,u,c,n,t,p,s,f,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(r.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,n,s,r){const t=c.syncData?v(c.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?c:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,o=await this.getLocalFileContent(),u=await this.getFormattingOptions();let f=null,p=!1,A=!1,O=!1;if(t){let N=o?o.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new d.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==N||a!==t){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const P=await(0,S.merge)(N,t,a,u,this.userDataSyncUtilService);P.hasChanges&&(f=P.mergeContent,O=P.hasConflicts,p=O||P.mergeContent!==N,A=O||P.mergeContent!==t)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=o.value.toString(),A=!0);const M={content:f,localChange:p?o?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:t,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async getMergeResult(c,n){return c.previewResult}async getAcceptResult(c,n,s,r){if(this.extUri.isEqual(n,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(c,n,s,r){const{fileContent:t}=s[0][0];let{content:a,localChange:o,remoteChange:u}=s[0][1];if(o===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new d.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),t&&await this.backupLocal(this.toSyncContent(t.value.toString())),await this.updateLocalFileContent(a||"[]",t,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const f=this.toSyncContent(a||"[]",c.syncData?.content);c=await this.updateRemoteUserData(f,r?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(f){}n?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(c,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.getLocalFileContent();if(c){const n=(0,k.parse)(c.value.toString());if((0,R.isNonEmptyArray)(n))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:c}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(c,"keybindings.json"),comparableResource:n}]}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let n=await super.resolveContent(c);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(c)),n){const s=this.parseSyncData(n);if(s)switch(this.extUri.basename(c)){case"keybindings.json":return v(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(c.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(c,n){let s={};try{s=JSON.parse(n||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=c,T.OS){case 2:s.mac=c;break;case 3:s.linux=c;break;case 1:s.windows=c;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=he([X(0,d.IUserDataSyncStoreService),X(1,d.IUserDataSyncBackupStoreService),X(2,d.IUserDataSyncLogService),X(3,b.IConfigurationService),X(4,d.IUserDataSyncResourceEnablementService),X(5,I.IFileService),X(6,i.IEnvironmentService),X(7,m.IStorageService),X(8,d.IUserDataSyncUtilService),X(9,E.ITelemetryService)],y),e.KeybindingsSynchroniser=y;let g=class extends h.AbstractInitializer{constructor(c,n,s){super("keybindings",n,s,c)}async doInitialize(c){const n=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(n)),await this.updateLastSyncUserData(c)}async isEmpty(){try{const c=await this.fileService.readFile(this.environmentService.settingsResource),n=(0,k.parse)(c.value.toString());return!(0,R.isNonEmptyArray)(n)}catch(c){return c.fileOperationResult===1}}getKeybindingsContentFromSyncContent(c){try{return v(c,!0,this.logService)}catch(n){return this.logService.error(n),null}}};g=he([X(0,I.IFileService),X(1,i.IEnvironmentService),X(2,d.IUserDataSyncLogService)],g),e.KeybindingsInitializer=g}),define(te[223],ne([0,1,17,33,39,49,26,54,24]),function(J,e,R,L,D,k,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(o,u,f){let p=[];f?p=I(f):p=i(u);const A=[],O=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const M of p)M.startsWith("-")?O.push(M.substring(1)):A.push(M);return(0,R.distinct)([...o,...A].filter(M=>O.indexOf(M)===-1))}e.getIgnoredSettings=b;function i(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function I(o){const u=(0,L.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(o,u,f,p){if(f.length){const A=a(u),O=(0,L.parse)(u),M=(0,L.parse)(o),N=[];for(const P of f){const F=O[P],q=M[P];F===void 0?o=C.edit(o,[P],void 0,p):q!==void 0?o=C.edit(o,[P],F,p):N.push(c(P,A))}N.sort((P,F)=>P.startOffset-F.startOffset),N.forEach(P=>o=v(P.setting.key,u,o,p))}return o}e.updateIgnoredSettings=m;function E(o,u,f,p,A,O){const M=m(o,u,p,O),N=f!==M,P=f!==u;if(!N&&!P)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!P)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(P&&!N)return{conflictsSettings:[],localContent:m(u,o,p,O),remoteContent:null,hasConflicts:!1};if(f===null&&S(o)){const V=h(o,u,p)?null:m(u,o,p,O);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let F=o,q=u;const _=(0,L.parse)(o),$=(0,L.parse)(u),H=f?(0,L.parse)(f):null,j=p.reduce((V,re)=>(V.add(re),V),new Set),x=d(_,$,j),z=d(H,_,j),Y=d(H,$,j),U=new Map,B=new Set,W=V=>{B.add(V);const re=A.filter(({key:ie})=>ie===V)[0];re?(F=C.edit(F,[V],re.value,O),q=C.edit(q,[V],re.value,O)):U.set(V,{key:V,localValue:_[V],remoteValue:$[V]})};for(const V of z.removed.values())Y.updated.has(V)?W(V):q=C.edit(q,[V],void 0,O);for(const V of Y.removed.values())B.has(V)||(z.updated.has(V)?W(V):F=C.edit(F,[V],void 0,O));for(const V of z.updated.values())B.has(V)||(Y.updated.has(V)?x.updated.has(V)&&W(V):q=C.edit(q,[V],_[V],O));for(const V of Y.updated.values())B.has(V)||(z.updated.has(V)?x.updated.has(V)&&W(V):F=C.edit(F,[V],$[V],O));for(const V of z.added.values())B.has(V)||(Y.added.has(V)?x.updated.has(V)&&W(V):q=v(V,F,q,O));for(const V of Y.added.values())B.has(V)||(z.added.has(V)?x.updated.has(V)&&W(V):F=v(V,q,F,O));const Q=U.size>0||!h(F,q,p),Z=Q||!h(F,o,[]),G=Q||!h(q,u,[]);return{localContent:Z?F:null,remoteContent:G?q:null,conflictsSettings:[...U.values()],hasConflicts:Q}}e.merge=E;function h(o,u,f){if(o===u)return!0;const p=(0,L.parse)(o),A=(0,L.parse)(u),O=f.reduce((P,F)=>(P.add(F),P),new Set),M=a(o).filter(P=>!(P.setting&&O.has(P.setting.key))),N=a(u).filter(P=>!(P.setting&&O.has(P.setting.key)));if(M.length!==N.length)return!1;for(let P=0;P<M.length;P++){const F=M[P],q=N[P];if(F.setting&&q.setting){if(F.setting.key!==q.setting.key||!T.equals(p[F.setting.key],A[F.setting.key]))return!1}else if(!F.setting&&!q.setting){if(F.value!==q.value)return!1}else return!1}return!0}e.areSame=h;function S(o){return o?a(o).length===0:!0}e.isEmpty=S;function d(o,u,f){const p=o?Object.keys(o).filter(P=>!f.has(P)):[],A=Object.keys(u).filter(P=>!f.has(P)),O=A.filter(P=>p.indexOf(P)===-1).reduce((P,F)=>(P.add(F),P),new Set),M=p.filter(P=>A.indexOf(P)===-1).reduce((P,F)=>(P.add(F),P),new Set),N=new Set;if(o)for(const P of p){if(M.has(P))continue;const F=o[P],q=u[P];T.equals(F,q)||N.add(P)}return{added:O,removed:M,updated:N}}function v(o,u,f,p){const A=(0,L.parse)(u),O=a(u),M=a(f),N=y(o,O,M);return g(f,o,A[o],N,M,p)}e.addSetting=v;function y(o,u,f){const p=u.findIndex(O=>O.setting?.key===o),A=u[p-1];if(A){if(A.setting){const M=c(A.setting.key,f);if(M)return{index:f.indexOf(M),insertAfter:!0}}else{const M=n(p,u);if(M){const N=c(M.setting.key,f);if(N){const P=s(f.indexOf(N),f),F=r(u,M,u[p]);if(P){const q=r(f,N,P),_=t(F,q);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.indexOf(P),insertAfter:!1}}else{const q=r(f,N,f[f.length-1]),_=t(F,q);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const O=u[p+1];if(O)if(O.setting){const M=c(O.setting.key,f);if(M)return{index:f.indexOf(M),insertAfter:!1}}else{const M=s(p,u);if(M){const N=c(M.setting.key,f);if(N){const P=n(f.indexOf(N),f),F=r(u,u[p],M);if(P){const q=r(f,P,N),_=t(F.reverse(),q.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:f.indexOf(P),insertAfter:!0}}else{const q=r(f,f[0],N),_=t(F.reverse(),q.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function g(o,u,f,p,A,O){let M;return p.index===-1?M=(0,D.setProperty)(o,[u],f,O):M=l(o,u,f,p,A,O).map(N=>(0,D.withFormatting)(o,N,O)[0]),(0,D.applyEdits)(o,M)}function l(o,u,f,p,A,O){const M=`${JSON.stringify(u)}: ${JSON.stringify(f)}`,N=(0,k.getEOL)(O,o),P=A[p.index];if(p.insertAfter){const F=[];if(P.setting)F.push({offset:P.endOffset,length:0,content:","+M});else{const q=s(p.index,A),_=n(p.index,A),$=_?.setting?.commaOffset;_&&$===void 0&&F.push({offset:_.endOffset,length:0,content:","});const H=$!==void 0&&$>P.endOffset;F.push({offset:H?$+1:P.endOffset,length:0,content:q?N+M+",":N+M})}return F}else{if(P.setting)return[{offset:P.startOffset,length:0,content:M+","}];const F=(A[p.index-1]&&!A[p.index-1].setting?N:"")+M+(s(p.index,A)?",":"")+N;return[{offset:P.startOffset,length:0,content:F}]}}function c(o,u){return u.filter(f=>f.setting?.key===o)[0]}function n(o,u){for(let f=o-1;f>=0;f--)if(u[f].setting)return u[f]}function s(o,u){for(let f=o+1;f<u.length;f++)if(u[f].setting)return u[f]}function r(o,u,f){const p=o.indexOf(u),A=o.indexOf(f);return o.filter((O,M)=>p<M&&M<A)}function t(o,u){if(o.length&&u.length){let f=0;for(;f<u.length&&f<o.length;f++)if(o[f].value!==u[f].value)return u[f-1];return u[f-1]}}function a(o){const u=[];let f=-1,p,A;const O={onObjectBegin:M=>{f++},onObjectProperty:(M,N,P)=>{f===0&&(p=N,A=M)},onObjectEnd:(M,N)=>{f--,f===0&&u.push({startOffset:p,endOffset:M+N,value:o.substring(p,M+N),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(M,N)=>{f++},onArrayEnd:(M,N)=>{f--,f===0&&u.push({startOffset:p,endOffset:M+N,value:o.substring(p,M+N),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(M,N,P)=>{f===0&&u.push({startOffset:p,endOffset:N+P,value:o.substring(p,N+P),setting:{key:A,commaOffset:void 0}})},onSeparator:(M,N,P)=>{if(f===0&&M===","){let F=u.length-1;for(;F>=0&&!u[F].setting;F--);const q=u[F];q&&u.splice(F,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:N}})}},onComment:(M,N)=>{f===0&&u.push({startOffset:M,endOffset:M+N,value:o.substring(M,M+N)})}};return(0,L.visit)(o,O),u}}),define(te[224],ne([0,1,19,3,39,146,21,88,85,13,30,14,23,22,48,54,223,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function y(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function g(s){const r=JSON.parse(s);return y(r)?r:{settings:s}}e.parseSettingsSyncContent=g;let l=class extends h.AbstractJsonFileSynchroniser{constructor(r,t,a,o,u,f,p,A,O,M,N,P){super(t.settingsResource,"settings",r,t,a,o,u,O,M,f,p,A);this.extensionManagementService=N,this.userConfigurationFileService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(r,t),o=this.getSettingsSyncContent(a),u=new C.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&u.parse(o.settings),u.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,t,a){const o=await this.getLocalFileContent(),u=await this.getFormattingOptions(),f=this.getSettingsSyncContent(r);t=t===null&&a?r:t;const p=t?this.getSettingsSyncContent(t):null,A=await this.getIgnoredSettings();let O=null,M=!1,N=!1,P=!1;if(f){let q=o?o.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const _=(0,d.merge)(q,f.settings,p?p.settings:null,A,[],u);O=_.localContent||_.remoteContent,M=_.localContent!==null,N=_.remoteContent!==null,P=_.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),O=o.value.toString(),N=!0);const F={content:O,localChange:M?2:0,remoteChange:N?2:0,hasConflicts:P};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:f?f.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(r,t){const a=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,d.updateIgnoredSettings)(r.previewResult.content,"{}",o,a):null}}async getAcceptResult(r,t,a,o){const u=await this.getFormattingOptions(),f=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?(0,d.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",f,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,d.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",f,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,d.updateIgnoredSettings)(a,r.fileContent?r.fileContent.value.toString():"{}",f,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,a,o){const{fileContent:u}=a[0][0];let{content:f,localChange:p,remoteChange:A}=a[0][1];if(p===0&&A===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),f=f?f.trim():"{}",f=f||"{}",this.validateContent(f),p!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(f,u,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),A!==0){const O=await this.getFormattingOptions(),M=this.getSettingsSyncContent(r),N=await this.getIgnoredSettings(f);f=(0,d.updateIgnoredSettings)(f,M?M.settings:"{}",N,O),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(f)),o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(O){}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=await this.getFormattingOptions(),a=(0,S.edit)(r.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,d.isEmpty)(a)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const a=this.parseSyncData(t);if(a){const o=this.parseSettingsSyncContent(a.content);if(o)switch(this.extUri.basename(r)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(r){let t=await super.resolvePreviewContent(r);if(t){const a=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,d.updateIgnoredSettings)(t,"{}",o,a)}return t}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return g(r)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const a=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:u})=>!!u)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{a.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,d.getIgnoredSettings)(t,this.configurationService,r)}async writeFileContent(r,t,a){await this.userConfigurationFileService.write(R.VSBuffer.fromString(r),a?void 0:{etag:t.etag,mtime:t.mtime})}validateContent(r){if(this.hasErrors(r))throw new v.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const r=await this.getLocalFileContent();if(!r)return;const t=JSON.parse(r.value.toString());if(!n(t))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const a=this.parseSettingsSyncContent(t.content);if(!a||!a.settings)return;let o=a.settings;const u=await this.getFormattingOptions();for(const f in t)if(["version","content","machineId"].indexOf(f)===-1&&t[f]!==void 0){const p=(0,D.setProperty)(o,[f],t[f],u);p.length&&(o=(0,D.applyEdits)(o,p))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(o))}catch(r){}}};l=he([X(0,I.IFileService),X(1,b.IEnvironmentService),X(2,m.IStorageService),X(3,v.IUserDataSyncStoreService),X(4,v.IUserDataSyncBackupStoreService),X(5,v.IUserDataSyncLogService),X(6,v.IUserDataSyncUtilService),X(7,T.IConfigurationService),X(8,v.IUserDataSyncResourceEnablementService),X(9,E.ITelemetryService),X(10,i.IExtensionManagementService),X(11,w.IUserConfigurationFileService)],l),e.SettingsSynchroniser=l;let c=class extends h.AbstractInitializer{constructor(r,t,a){super("settings",t,a,r)}async doInitialize(r){const t=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,d.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return g(r)}catch(t){this.logService.error(t)}return null}};c=he([X(0,I.IFileService),X(1,b.IEnvironmentService),X(2,v.IUserDataSyncLogService)],c),e.SettingsInitializer=c;function n(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(te[225],ne([0,1,19,3,26,21,13,14,23,22,48,218,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let E=class extends i.AbstractSynchroniser{constructor(d,v,y,g,l,c,n,s,r){super("snippets",v,d,y,g,l,s,r,c,n);this.version=1,this.snippetsFolder=d.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,t=>t.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(d,v,y){const g=await this.getSnippetsFileContents(),l=this.toSnippetsContents(g),c=d.syncData?this.parseSnippets(d.syncData):null;v=v===null&&y?d:v;const n=v&&v.syncData?this.parseSnippets(v.syncData):null;c?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,I.merge)(l,c,n);return this.getResourcePreviews(s,g,c||{})}async getMergeResult(d,v){return d.previewResult}async getAcceptResult(d,v,y,g){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder))return y===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:y,localChange:y===null?d.fileContent!==null?3:0:2,remoteChange:y===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(d,v,y,g){const l=y.map(([c,n])=>({...c,acceptResult:n}));l.every(({localChange:c,remoteChange:n})=>c===0&&n===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:c})=>c!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,g)),l.some(({remoteChange:c})=>c!==0)&&(d=await this.updateRemoteSnippets(l,d,g)),v?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:c}of l)try{await this.fileService.del(c)}catch(n){}}getResourcePreviews(d,v,y){const g=new Map;for(const l of Object.keys(d.local.added)){const c={content:d.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};g.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(d.local.updated)){const c={content:d.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};g.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of d.local.removed){const c={content:null,hasConflicts:!1,localChange:3,remoteChange:0};g.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(d.remote.added)){const c={content:d.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};g.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(d.remote.updated)){const c={content:d.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};g.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of d.remote.removed){const c={content:null,hasConflicts:!1,localChange:0,remoteChange:3};g.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of d.conflicts){const c={content:v[l]?v[l].value.toString():null,hasConflicts:!0,localChange:v[l]?2:1,remoteChange:y[l]?2:1};g.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l]||null,localContent:v[l]?v[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(v))if(!g.has(l)){const c={content:v[l]?v[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};g.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l]||null,localContent:v[l]?v[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...g.values()]}async getAssociatedResources({uri:d}){let v=await super.resolveContent(d);if(v){const y=this.parseSyncData(v);if(y){const g=this.parseSnippets(y),l=[];for(const c of Object.keys(g)){const n=this.extUri.joinPath(d,c),s=this.extUri.joinPath(this.snippetsFolder,c),r=await this.fileService.exists(s);l.push({resource:n,comparableResource:r?s:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(d){if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(d);let v=await super.resolveContent(d);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(d)),v){const y=this.parseSyncData(v);if(y)return this.parseSnippets(y)[this.extUri.basename(d)]||null}return null}async hasLocalData(){try{const d=await this.getSnippetsFileContents();if(Object.keys(d).length)return!0}catch(d){}return!1}async updateLocalBackup(d){const v={};for(const y of d)y.fileContent&&(v[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(v)))}async updateLocalSnippets(d,v){for(const{fileContent:y,acceptResult:g,localResource:l,remoteResource:c,localChange:n}of d)if(n!==0){const s=c?this.extUri.basename(c):this.extUri.basename(l),r=this.extUri.joinPath(this.snippetsFolder,s);n===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):n===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,R.VSBuffer.fromString(g.content),{overwrite:v}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,R.VSBuffer.fromString(g.content),v?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(d,v,y){const g=v.syncData?this.parseSnippets(v.syncData):{},l=(0,D.deepClone)(g);for(const{acceptResult:c,localResource:n,remoteResource:s,remoteChange:r}of d)if(r!==0){const t=n?this.extUri.basename(n):this.extUri.basename(s);r===3?delete l[t]:l[t]=c.content}return(0,I.areSame)(g,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),v=await this.updateRemoteUserData(JSON.stringify(l),y?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),v}parseSnippets(d){return JSON.parse(d.content)}toSnippetsContents(d){const v={};for(const y of Object.keys(d))v[y]=d[y].value.toString();return v}async getSnippetsFileContents(){const d={};let v;try{v=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof C.FileOperationError&&y.fileOperationResult===1)return d;throw y}for(const y of v.children||[]){const g=y.resource,l=this.extUri.extname(g);if(l===".json"||l===".code-snippets"){const c=this.extUri.relativePath(this.snippetsFolder,g),n=await this.fileService.readFile(g);d[c]=n}}return d}};E=he([X(0,T.IEnvironmentService),X(1,C.IFileService),X(2,w.IStorageService),X(3,m.IUserDataSyncStoreService),X(4,m.IUserDataSyncBackupStoreService),X(5,m.IUserDataSyncLogService),X(6,k.IConfigurationService),X(7,m.IUserDataSyncResourceEnablementService),X(8,b.ITelemetryService)],E),e.SnippetsSynchroniser=E;let h=class extends i.AbstractInitializer{constructor(d,v,y){super("snippets",v,y,d)}async doInitialize(d){const v=d.syncData?JSON.parse(d.syncData.content):null;if(!v){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const g of Object.keys(v)){const l=v[g];if(l){const c=this.extUri.joinPath(this.environmentService.snippetsHome,g);await this.fileService.createFile(c,R.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(c))}}await this.updateLastSyncUserData(d)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};h=he([X(0,C.IFileService),X(1,T.IEnvironmentService),X(2,m.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let T=class extends L.Disposable{constructor(w){super();this.userDataSyncStoreService=w,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};T=he([X(0,k.IUserDataSyncStoreService)],T),e.UserDataSyncAccountService=T}),define(te[226],ne([0,1,5,19,57,2,16,21,13,14,24]),function(J,e,R,L,D,k,T,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends k.Disposable{constructor(E,h,S,d){super();this.environmentService=E,this.fileService=h,this.configurationService=S,this.logService=d,i.ALL_SYNC_RESOURCES.forEach(v=>this.cleanUpBackup(v))}async getAllRefs(E){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,E),S=await this.fileService.resolve(h);return S.children?S.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort().reverse().map(v=>({ref:v.name,created:this.getCreationTime(v)})):[]}async resolveContent(E,h){if(!h){const S=await this.getAllRefs(E);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,E,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(E,h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,E),d=(0,T.joinPath)(S,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,L.VSBuffer.fromString(h))}catch(v){this.logService.error(v)}try{this.cleanUpBackup(E)}catch(v){}}async cleanUpBackup(E){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(h))return}catch(d){return}const S=await this.fileService.resolve(h);if(S.children){const d=S.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),v=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=d.filter(l=>Date.now()-this.getCreationTime(l)>v);const g=d.length-y.length;g<10&&(y=y.slice(10-g)),await R.Promises.settled(y.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};I=he([X(0,w.IEnvironmentService),X(1,b.IFileService),X(2,C.IConfigurationService),X(3,i.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[227],ne([0,1,2,9]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(m){this.service=m}listen(m,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(m){this.service=m}listen(m,E){throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class T{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=T;class C{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=C;class w{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class b{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class i extends R.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:L.URI.revive(m.url),type:m.type,defaultUrl:L.URI.revive(m.defaultUrl),insidersUrl:L.URI.revive(m.insidersUrl),stableUrl:L.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[228],ne([0,1,13,10]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends L.AbstractLogger{constructor(T,C){super();this.logger=this._register(T.createLogger(C.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...C){this.logger.trace(T,...C)}debug(T,...C){this.logger.debug(T,...C)}info(T,...C){this.logger.info(T,...C)}warn(T,...C){this.logger.warn(T,...C)}error(T,...C){this.logger.error(T,...C)}critical(T,...C){this.logger.critical(T,...C)}flush(){this.logger.flush()}};D=he([X(0,L.ILoggerService),X(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[64],ne([0,1,3,2,4,25,149,13,14,6,28,46,23,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let S=class tt extends L.Disposable{constructor(v,y,g,l,c,n){super();this.storageService=g,this.userDataSyncStoreService=l,this.logService=c,this.productService=n,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(v,y,g)}async getMachines(v){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(v)).machines.map(l=>({...l,isCurrent:l.id===y}))}async addCurrentMachine(v){const y=await this.currentMachineIdPromise,g=await this.readMachinesData(v);g.machines.some(({id:l})=>l===y)||(g.machines.push({id:y,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(v){const y=await this.currentMachineIdPromise,g=await this.readMachinesData(v),l=g.machines.filter(({id:c})=>c!==y);l.length!==g.machines.length&&(g.machines=l,await this.writeMachinesData(g))}async renameMachine(v,y,g){const l=await this.currentMachineIdPromise,c=await this.readMachinesData(g),n=c.machines.find(({id:s})=>s===v);n&&(n.name=y,await this.writeMachinesData(c),c.machines.some(({id:s})=>s===l)&&this.storageService.store(h,y,0,1))}async setEnablement(v,y){const g=await this.readMachinesData(),l=g.machines.find(({id:c})=>c===v);l&&(l.disabled=y?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(v){const y=this.storageService.get(h,0);if(y)return y;const g=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,l=new RegExp(`${(0,k.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let c=0;for(const n of v){const s=l.exec(n.name),r=s?parseInt(s[1]):0;c=r>c?r:c}return`${g} #${c+1}`}async readMachinesData(v){this.userData=await this.readUserData(v);const y=this.parse(this.userData);if(y.version!==tt.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(v){const y=JSON.stringify(v),g=await this.userDataSyncStoreService.write(tt.RESOURCE,y,this.userData?.ref||null);this.userData={ref:g,content:y},this._onDidChange.fire()}async readUserData(v){if(this.userData){const y=v&&v.latest?v.latest[tt.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(v){if(v.content!==null)try{return JSON.parse(v.content)}catch(y){this.logService.error(y)}return{version:tt.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=he([X(0,C.IEnvironmentService),X(1,w.IFileService),X(2,m.IStorageService),X(3,E.IUserDataSyncStoreService),X(4,E.IUserDataSyncLogService),X(5,i.IProductService)],S),e.UserDataSyncMachinesService=S}),define(te[99],ne([0,1,5,57,37,7,3,2,4,16,9,147,13,28,23,22,24,63,64]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const g="sync.enable",l="sync.disableMachineEventually",c="sync.sessionId",n="sync.storeUrl",s="sync.productQuality";let r=class extends C.Disposable{constructor(u,f,p){super();this.storageService=u,this.environmentService=f,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(g,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(g,u,0,1)}onDidStorageChange(u){if(u.scope===0&&g===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([X(0,h.IStorageService),X(1,m.IEnvironmentService),X(2,d.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let t=class extends C.Disposable{constructor(u,f,p,A,O,M,N,P,F,q,_){super();this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=p,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=O,this.logService=M,this.userDataSyncAccountService=N,this.telemetryService=P,this.userDataSyncMachinesService=F,this.storageService=q,this.autoSync=this._register(new C.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(f.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,f.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(N.onDidChangeAccount(()=>this.updateAutoSync())),this._register(p.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(O.onDidChangeLocal,($,H)=>$?[...$,H]:[H],1e3)($=>this.triggerSync($,!1,!1))),this._register(T.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(n,0);return u?i.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(n,u.toString(),0,1):this.storageService.remove(n,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:f}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(p=>this.onDidFinishSync(p))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(f&&this.logService.info(f),this.autoSync.clear()):f&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(f))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,f,p){try{this.userDataSyncAccountService.account&&!p&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(f)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(g,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const f=d.UserDataSyncError.toUserDataSyncError(u);f instanceof d.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:f.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),f.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):f.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):f.code==="LocalTooManyRequests"||f.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):f.code==="UpgradeRequired"||f.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):f.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with newer version than of client. Requires client upgrade.`)):f.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with older version than of client. Requires server reset.`)):f.code==="ServiceChanged"||f.code==="DefaultServiceChanged"?w.isWeb&&f.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(f),this.successiveFailures++),this._onError.fire(f)}async disableMachineEventually(){this.storageService.store(l,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(l,0,!1)}stopDisableMachineEventually(){this.storageService.remove(l,0)}async triggerSync(u,f,p){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(f&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",p)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=he([X(0,E.IProductService),X(1,d.IUserDataSyncStoreManagementService),X(2,d.IUserDataSyncStoreService),X(3,d.IUserDataSyncResourceEnablementService),X(4,d.IUserDataSyncService),X(5,d.IUserDataSyncLogService),X(6,v.IUserDataSyncAccountService),X(7,S.ITelemetryService),X(8,y.IUserDataSyncMachinesService),X(9,h.IStorageService),X(10,d.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class a extends C.Disposable{constructor(u,f,p,A,O,M,N,P){super();this.lastSyncUrl=u,this.interval=f,this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=A,this.userDataSyncService=O,this.userDataSyncMachinesService=M,this.logService=N,this.storageService=P,this.intervalHandler=this._register(new C.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,C.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,f){const p=(0,R.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,k.isPromiseCanceledError)(O))return}return this.doSync(u,f,A)});return this.syncPromise=p,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),f=this.userDataSyncStoreManagementService.userDataSyncStore;return!!f&&!!u&&(!(0,b.isEqual)(f.defaultUrl,u.defaultUrl)||!(0,b.isEqual)(f.insidersUrl,u.insidersUrl)||!(0,b.isEqual)(f.stableUrl,u.stableUrl))}async doSync(u,f,p){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,f),p.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new d.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const O=this.storageService.get(c,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new d.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const M=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(p.isCancellationRequested)return;const N=M.find(P=>P.isCurrent);if(N?.disabled)throw new d.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(P){throw new d.UserDataAutoSyncError((0,D.toErrorMessage)(P),P instanceof d.UserDataSyncError?P.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(c,this.manifest.session,0,1),p.isCancellationRequested)return;N||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),A=O}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[229],ne([0,1,3,2,4,23,22,24]),function(J,e,R,L,D,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let w=class extends L.Disposable{constructor(i,I){super();this.storageService=i,this.telemetryService=I,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(i){return this.storageService.getBoolean((0,C.getEnablementKey)(i),0,!0)}setResourceEnablement(i,I){if(this.isResourceEnabled(i)!==I){const m=(0,C.getEnablementKey)(i);this.telemetryService.publicLog2(m,{enabled:I}),this.storeResourceEnablement(m,I)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,I){this.storageService.store(i,I,0,D.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const I=C.ALL_SYNC_RESOURCES.filter(m=>(0,C.getEnablementKey)(m)===i.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};w=he([X(0,k.IStorageService),X(1,T.ITelemetryService)],w),e.UserDataSyncResourceEnablementService=w}),define(te[230],ne([0,1,17,5,37,7,3,2,16,29,21,6,23,22,219,221,222,224,225,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let c=class extends C.Disposable{constructor(t,a,o,u,f,p,A){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=a,this.instantiationService=o,this.configurationService=u,this.logService=f,this.telemetryService=p,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(v.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(d.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(y.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(T.Event.any(...this.synchronisers.map(O=>T.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(T.Event.any(...this.synchronisers.map(O=>T.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(l,0,void 0),this.onDidChangeLocal=T.Event.any(...this.synchronisers.map(O=>T.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,a){await this.checkEnablement();const o=(0,b.generateUuid)();try{const A=(0,g.createSyncHeaders)(o);a&&(A["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,A)}catch(A){const O=g.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(O,o),O}let u=!1;const f=this;let p;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return p=(0,L.createCancelablePromise)(A=>f.sync(t,o,A)),p.finally(()=>p=void 0)},async stop(){if(p&&p.cancel(),f.status!=="idle")return f.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,b.generateUuid)(),a=(0,g.createSyncHeaders)(t);let o;try{o=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const f=g.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(f,t),f}return new n(t,o,a,this.synchronisers,this.configurationService,this.logService)}async sync(t,a,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const f=(0,g.createSyncHeaders)(a);for(const p of this.synchronisers){if(o.isCancellationRequested)return;try{await p.sync(t,f)}catch(A){let O=!1;if(A instanceof g.UserDataSyncError)switch(A.code){case"TooLarge":A=new g.UserDataSyncError(A.message,A.code,p.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const M=g.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(M,a),O)throw M;this.logService.error(A),this.logService.error(`${p.resource}: ${(0,D.toErrorMessage)(A)}`),this._syncErrors.push([p.resource,M])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(f){const p=g.UserDataSyncError.toUserDataSyncError(f);throw this.reportUserDataSyncError(p,a),p}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(a){this.logService.error(a)}}async replace(t){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(t))return}async accept(t,a,o,u){await this.checkEnablement();const f=this.getSynchroniser(t);await f.accept(a,o),u&&await f.apply(!1,(0,g.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(t){for(const a of this.synchronisers){const o=await a.resolveContent(t);if(o)return o}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,a){return this.getSynchroniser(t).getAssociatedResources(a)}getMachineId(t,a){return this.getSynchroniser(t).getMachineId(a)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of t)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(l,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(a){this.logService.error(`${t.resource}: ${(0,D.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const a=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,R.equals)(this._conflicts,t,([a,o],[u,f])=>a===a&&(0,R.equals)(o,f,(p,A)=>(0,w.isEqual)(p.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,a){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof g.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof g.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(s)])}getSynchroniser(t){return this.synchronisers.find(a=>a.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([X(0,g.IUserDataSyncStoreService),X(1,g.IUserDataSyncStoreManagementService),X(2,I.IInstantiationService),X(3,i.IConfigurationService),X(4,g.IUserDataSyncLogService),X(5,E.ITelemetryService),X(6,m.IStorageService)],c),e.UserDataSyncService=c;class n extends C.Disposable{constructor(t,a,o,u,f,p){super();this.id=t,this.manifest=a,this.syncHeaders=o,this.synchronisers=u,this.configurationService=f,this.logService=p,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,a){try{return await this.performAction(t,o=>o.accept(t,a))}catch(o){throw this.logService.error(o),o}}async merge(t){try{return t?await this.performAction(t,a=>a.merge(t)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(t){try{return await this.performAction(t,a=>a.discard(t))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,a]of this.previews)for(const o of a.resourcePreviews)o.mergeState==="conflict"&&t.push(o.previewResource);for(const a of t)await this.discard(a);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===a);for(const p of o.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&await u.merge(p.previewResource);const f=await u.apply(!1,this.syncHeaders);f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,a]of this.previews){this.synchronizingResources.push([t,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of a.resourcePreviews)await o.accept(u.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,a]of this.previews){this.synchronizingResources.push([t,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of a.resourcePreviews)await o.accept(u.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(a){(0,k.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(t,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,P])=>P.resourcePreviews.some(({localResource:F,previewResource:q,remoteResource:_})=>(0,w.isEqual)(t,F)||(0,w.isEqual)(t,q)||(0,w.isEqual)(t,_)));if(o===-1)return this.previews;const[u,f]=this.previews[o],p=f.resourcePreviews.find(({localResource:P,remoteResource:F,previewResource:q})=>(0,w.isEqual)(P,t)||(0,w.isEqual)(F,t)||(0,w.isEqual)(q,t));if(!p)return this.previews;let A=this.synchronizingResources.find(P=>P[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(P=>(0,w.isEqual)(P,p.localResource))||(A[1].push(p.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find(P=>P.resource===this.previews[o][0]),M=await a(O);M?this.previews.splice(o,1,this.toSyncResourcePreview(O.resource,M)):this.previews.splice(o,1);const N=this.synchronizingResources.findIndex(P=>P[0]===u);return this.synchronizingResources[N][1].splice(A[1].findIndex(P=>(0,w.isEqual)(P,p.localResource)),1),A[1].length||(this.synchronizingResources.splice(N,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===a);let f=o;for(const p of o.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&(f=await u.merge(p.previewResource));f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const a=[],o=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const f=await u.preview(this.manifest,o,this.syncHeaders);f&&a.push(this.toSyncResourcePreview(u.resource,f))}return a}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(g.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(o=>o instanceof v.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...a}}toSyncResourcePreview(t,a){return[t,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[231],ne([0,1,3,2,18,9,24]),function(J,e,R,L,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class C{constructor(I,m){this.service=I,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(I,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(I,m,E){try{return await this._call(I,m,E)}catch(h){throw this.logService.error(h),h}}async _call(I,m,E){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],k.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:k.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:k.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const h=m.substring("manualSync/".length),S=E[0],d=this.getManualSyncTask(S);switch(E=E.slice(1),h){case"preview":return d.preview();case"accept":return d.accept(k.URI.revive(E[0]),E[1]);case"merge":return d.merge(k.URI.revive(E[0]));case"discard":return d.discard(k.URI.revive(E[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(I){const m=this.manualSyncTasks.get(this.createKey(I));if(!m)throw new Error(`Manual sync taks not found: ${I}`);return m.manualSyncTask}async createManualSyncTask(){const I=new L.DisposableStore,m=I.add(await this.service.createManualSyncTask());return I.add(m.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:E}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:I}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(I){I.dispose();const m=this.createKey(I.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=C;class w extends L.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,E,h){return I.call(m,E,h).then(null,S=>{throw T.UserDataSyncError.toUserDataSyncError(S)})},listen(m,E){return I.listen(m,E)}},this.channel.call("_getInitialData").then(([m,E,h])=>{this.updateStatus(m),this.updateConflicts(E),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([E,h])=>[E,T.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:m,status:E}=await this.channel.call("createManualSyncTask"),h=this,S=new b(I,m,E,{async call(d,v,y){return h.channel.call(`manualSync/${d}`,[I,...(0,D.isArray)(v)?v:[v]],y)},listen(d,v){return R.Event.map(R.Event.filter(h.channel.listen(`manualSync/${d}`,v),y=>!S.isDiposed()&&y.manualSyncTaskId===I),y=>y.data)}});return S}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,m,E,h){return this.channel.call("accept",[I,m,E,h])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:k.URI.revive(h)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:k.URI.revive(h)}))}async getAssociatedResources(I,m){return(await this.channel.call("getAssociatedResources",[I,m])).map(({resource:h,comparableResource:S})=>({resource:k.URI.revive(h),comparableResource:k.URI.revive(S)}))}async getMachineId(I,m){return this.channel.call("getMachineId",[I,m])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([m,E])=>[m,E.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=w;class b extends L.Disposable{constructor(I,m,E,h){super();this.id=I,this.manifest=m,this._disposed=!1,this._status=E;const S=this;this.channel={async call(d,v,y){try{const g=await h.call(d,v,y);return S.isDiposed()||(S._status=await h.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(d,v){return h.listen(d,v)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,m){const E=await this.channel.call("accept",[I,m]);return this.deserializePreviews(E)}async merge(I){const m=await this.channel.call("merge",[I]);return this.deserializePreviews(m)}async discard(I){const m=await this.channel.call("discard",[I]);return this.deserializePreviews(m)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([m,E])=>[m,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource),acceptedResource:k.URI.revive(h.acceptedResource)}))}])}}}),define(te[232],ne([0,1,5,27,7,3,2,108,4,16,18,9,29,21,13,14,28,43,46,23,24]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",n="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",t=100,a=1e3*60*5;let o=class extends T.Disposable{constructor(M,N,P){super();this.productService=M,this.configurationService=N,this.storageService=P,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(P.onDidChangeValue,F=>F.key===l.SYNC_SERVICE_URL_TYPE&&F.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(M){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,M,0,w.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[l.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(l.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(M,N){M=w.isWeb&&M?.web?{...M,...M.web}:M;const P={...M||{},...N||{}};if(P&&(0,i.isString)(P.url)&&(0,i.isObject)(P.authenticationProviders)&&Object.keys(P.authenticationProviders).every(F=>(0,i.isArray)(P.authenticationProviders[F].scopes))){const F=P,q=!!F.canSwitch&&!N?.url,_=F.url===F.insidersUrl?"insiders":"stable",$=(q?this.userDataSyncStoreType:void 0)||_,H=N?.url||($==="insiders"?F.insidersUrl:$==="stable"?F.stableUrl:F.url);return{url:I.URI.parse(H),type:$,defaultType:_,defaultUrl:I.URI.parse(F.url),stableUrl:I.URI.parse(F.stableUrl),insidersUrl:I.URI.parse(F.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(F.authenticationProviders).reduce((j,x)=>(j.push({id:x,scopes:F.authenticationProviders[x].scopes}),j),[])}}}};o=he([X(0,d.IProductService),X(1,E.IConfigurationService),X(2,g.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(M,N,P){super(M,N,P);const F=this.storageService.get(c,0);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const q=this.productService[l.CONFIGURATION_SYNC_STORE_KEY];q?this.storageService.store(c,JSON.stringify(q),0,1):this.storageService.remove(c,0)}async switch(M){M!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=M,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([X(0,d.IProductService),X(1,E.IConfigurationService),X(2,g.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let f=class extends T.Disposable{constructor(M,N,P,F,q,_,$){super();this.requestService=P,this.logService=F,this.storageService=$,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(M),this.commonHeadersPromise=(0,y.getServiceMachineId)(q,_,$).then(H=>{const j={"X-Client-Name":`${N.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(j["X-Client-Commit"]=N.commit),j}),this.session=new A(t,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(M,N){this.authToken={token:M,type:N}}updateUserDataSyncStoreUrl(M){this.userDataSyncStoreUrl=M?(0,b.joinPath)(M,"v1"):void 0}initDonotMakeRequestsUntil(){const M=this.storageService.getNumber(n,0);M&&Date.now()<M&&this.setDonotMakeRequestsUntil(new Date(M))}setDonotMakeRequestsUntil(M){this._donotMakeRequestsUntil?.getTime()!==M?.getTime()&&(this._donotMakeRequestsUntil=M,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(N=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(n,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M),P={},F=await this.request(N.toString(),{type:"GET",headers:P},[],L.CancellationToken.None);return(await(0,v.asJson)(F)||[]).map(({url:_,created:$})=>({ref:(0,b.relativePath)(N,N.with({path:_})),created:$*1e3}))}async resolveContent(M,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M,N).toString(),F={};F["Cache-Control"]="no-cache";const q=await this.request(P,{type:"GET",headers:F},[],L.CancellationToken.None);return await(0,v.asText)(q)}async delete(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString(),P={};await this.request(N,{type:"DELETE",headers:P},[],L.CancellationToken.None)}async read(M,N,P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M,"latest").toString();P={...P},P["Cache-Control"]="no-cache",N&&(P["If-None-Match"]=N.ref);const q=await this.request(F,{type:"GET",headers:P},[304],L.CancellationToken.None);let _=null;if(q.res.statusCode===304&&(_=N),_===null){const $=q.res.headers.etag;if(!$)throw new l.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",q.res.statusCode,q.res.headers[l.HEADER_OPERATION_ID]);const H=await(0,v.asText)(q);if(!H&&q.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",F,"EmptyResponse",q.res.statusCode,q.res.headers[l.HEADER_OPERATION_ID]);_={ref:$,content:H}}return _}async write(M,N,P,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString();F={...F},F["Content-Type"]=C.Mimes.text,P&&(F["If-Match"]=P);const _=await this.request(q,{type:"POST",data:N,headers:F},[],L.CancellationToken.None),$=_.res.headers.etag;if(!$)throw new l.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",_.res.statusCode,_.res.headers[l.HEADER_OPERATION_ID]);return $}async manifest(M,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",M&&(N["If-None-Match"]=M.ref);const F=await this.request(P,{type:"GET",headers:N},[304],L.CancellationToken.None);let q=null;if(F.res.statusCode===304&&(q=M),!q){const $=F.res.headers.etag;if(!$)throw new l.UserDataSyncStoreError("Server did not return the ref",P,"NoRef",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);const H=await(0,v.asText)(F);if(!H&&F.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",P,"EmptyResponse",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);H&&(q={...JSON.parse(H),ref:$})}const _=this.storageService.get(s,0);return _&&q&&_!==q.session&&this.clearSession(),q===null&&_&&this.clearSession(),q&&this.storageService.store(s,q.session,0,1),q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":C.Mimes.text};await this.request(M,{type:"DELETE",headers:N},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(M,N,P,F){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${N.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const q=await this.commonHeadersPromise;N.headers={...N.headers||{},...q,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:M,type:N.type,headers:{...N.headers,authorization:void 0}});let _;try{_=await this.session.request(M,N,F)}catch(x){if(!(x instanceof l.UserDataSyncStoreError)){let z="RequestFailed";const Y=(0,D.getErrorMessage)(x).toLowerCase();Y.includes("xhr timeout")?z="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?z="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":Y.includes("headers must be an object")?z="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(x)&&(z="RequestCanceled"),x=new l.UserDataSyncStoreError(`Connection refused for the request '${M}'.`,M,z,void 0,void 0)}throw this.logService.info("Request failed",M),x}const $=_.res.headers[l.HEADER_OPERATION_ID],H={url:M,status:_.res.statusCode,"execution-id":N.headers[l.HEADER_EXECUTION_ID],"operation-id":$},j=(0,v.isSuccess)(_)||_.res.statusCode&&P.indexOf(_.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",H):this.logService.info("Request failed",H),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new l.UserDataSyncStoreError(`Request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",_.res.statusCode,$);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new l.UserDataSyncStoreError(`${N.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",_.res.statusCode,$);if(_.res.statusCode===410)throw new l.UserDataSyncStoreError(`${N.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",_.res.statusCode,$);if(_.res.statusCode===412)throw new l.UserDataSyncStoreError(`${N.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",_.res.statusCode,$);if(_.res.statusCode===413)throw new l.UserDataSyncStoreError(`${N.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",_.res.statusCode,$);if(_.res.statusCode===426)throw new l.UserDataSyncStoreError(`${N.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",_.res.statusCode,$);if(_.res.statusCode===429){const x=_.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new l.UserDataSyncStoreError(`${N.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",_.res.statusCode,$)):new l.UserDataSyncStoreError(`${N.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",_.res.statusCode,$)}if(!j)throw new l.UserDataSyncStoreError("Server returned "+_.res.statusCode,M,"Unknown",_.res.statusCode,$);return _}addSessionHeaders(M){let N=this.storageService.get(r,0);N===void 0&&(N=(0,m.generateUuid)(),this.storageService.store(r,N,0,1)),M["X-Machine-Session-Id"]=N;const P=this.storageService.get(s,0);P!==void 0&&(M["X-User-Session-Id"]=P)}};f=he([X(1,d.IProductService),X(2,v.IRequestService),X(3,l.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,g.IStorageService)],f),e.UserDataSyncStoreClient=f;let p=class extends f{constructor(M,N,P,F,q,_,$){super(M.userDataSyncStore?.url,N,P,F,q,_,$);this._register(M.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(M.userDataSyncStore?.url)))}};p=he([X(0,l.IUserDataSyncStoreManagementService),X(1,d.IProductService),X(2,v.IRequestService),X(3,l.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,g.IStorageService)],p),e.UserDataSyncStoreService=p;class A{constructor(M,N,P,F){this.limit=M,this.interval=N,this.requestService=P,this.logService=F,this.requests=[],this.startTime=void 0}request(M,N,P){if(this.isExpired()&&this.reset(),N.url=M,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(M),this.requestService.request(N,P)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[233],ne([0,1,3,59,28,23,22,99,24,63,64]),function(J,e,R,L,D,k,T,C,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends C.UserDataAutoSyncService{constructor(E,h,S,d,v,y,g,l,c,n,s,r){super(E,h,S,d,v,g,l,c,n,s,r);this._register(R.Event.debounce(R.Event.any(R.Event.map(y.onDidFocusWindow,()=>"windowFocus"),R.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(t,a)=>t?[...t,a]:[a],1e3)(t=>this.triggerSync(t,!0,!1)))}};I=he([X(0,D.IProductService),X(1,w.IUserDataSyncStoreManagementService),X(2,w.IUserDataSyncStoreService),X(3,w.IUserDataSyncResourceEnablementService),X(4,w.IUserDataSyncService),X(5,L.INativeHostService),X(6,w.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,T.ITelemetryService),X(9,i.IUserDataSyncMachinesService),X(10,k.IStorageService),X(11,w.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[234],ne([0,1,5,3,2]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:w,getActiveWindowId:b}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(C,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>b()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(te[65],ne([0,1,52,5,8,18,20,125,246,247]),function(J,e,R,L,D,k,T,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(n,s){let r=s.message;switch(n){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=n,this.cause=s}}e.ExtractError=i;function I(c){const n=c.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,r)=>s+r,n&61440)}function m(c){if(c instanceof i)return c;let n;return/end of central directory record signature not found/.test(c.message)&&(n="CorruptZip"),new i(n,c)}function E(c,n,s,r,t,a){const o=D.dirname(n),u=D.join(r,o);if(!u.startsWith(r))return Promise.reject(new Error(C.localize(0,null,n)));const f=D.join(r,n);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(T.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!a.isCancellationRequested)try{p=(0,R.createWriteStream)(f,{mode:s}),p.once("close",()=>A()),p.once("error",O),c.once("error",O),c.pipe(p)}catch(M){O(M)}}))}function h(c,n,s,r){let t=(0,L.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{t.cancel(),c.close()}),new Promise((o,u)=>{const f=new L.Sequencer,p=A=>{A.isCancellationRequested||(a++,c.readEntry())};c.once("error",u),c.once("close",()=>t.then(()=>{r.isCancellationRequested||c.entryCount===a?o():u(new i("Incomplete",new Error(C.localize(1,null,a,c.entryCount))))},u)),c.readEntry(),c.on("entry",A=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){p(r);return}const O=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const P=D.join(n,O);t=(0,L.createCancelablePromise)(F=>T.Promises.mkdir(P,{recursive:!0}).then(()=>p(F)).then(void 0,u));return}const M=d(c,A),N=I(A);t=(0,L.createCancelablePromise)(P=>f.queue(()=>M.then(F=>E(F,O,N,n,s,P).then(()=>p(P)))).then(null,u))})})}function S(c,n=!1){return new Promise((s,r)=>{(0,w.open)(c,n?{lazyEntries:!0}:void 0,(t,a)=>{t?r(m(t)):s((0,k.assertIsDefined)(a))})})}function d(c,n){return new Promise((s,r)=>{c.openReadStream(n,(t,a)=>{t?r(m(t)):s((0,k.assertIsDefined)(a))})})}function v(c,n){return new Promise((s,r)=>{const t=new b.ZipFile;n.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const a=(0,R.createWriteStream)(c);t.outputStream.pipe(a),t.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>s(c))})}e.zip=v;function y(c,n,s={},r){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=S(c,!0);return s.overwrite&&(a=a.then(o=>T.Promises.rm(n).then(()=>o))),a.then(o=>h(o,n,{sourcePathRegex:t},r))}e.extract=y;function g(c,n){return S(c).then(s=>new Promise((r,t)=>{s.on("entry",a=>{a.fileName===n&&d(s,a).then(o=>r(o),o=>t(o))}),s.once("close",()=>t(new Error(C.localize(2,null,n))))}))}function l(c,n){return g(c,n).then(s=>new Promise((r,t)=>{const a=[];s.once("error",t),s.on("data",o=>a.push(o)),s.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=l}),define(te[235],ne([0,1,65,134]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,R.buffer)(k,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(C){throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(te[236],ne([0,1,17,5,7,2,15,8,4,16,61,9,29,20,65,135,13,30,36,154,14,10,28]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let s=class extends k.Disposable{constructor(t,a,o,u,f){super();this.beforeRemovingExtension=t,this.fileService=a,this.logService=o,this.environmentService=u,this.productService=f,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const a=[];(t===null||t===0)&&a.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&a.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(a);return(0,R.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[a,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(u=>!a[new y.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(o=(0,y.groupByExtension)(o,f=>f.identifier).map(f=>f.sort((p,A)=>i.rcompare(p.manifest.version,A.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,a,o,u){const f=t.key(),p=C.join(this.extensionsPath,`.${(0,m.generateUuid)()}`),A=C.join(this.extensionsPath,f);try{await E.Promises.rm(A)}catch(M){try{await E.Promises.rm(A)}catch(N){}throw new v.ExtensionManagementError((0,S.localize)(0,null,A,t.id),v.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,a,p,u);let O=await this.scanExtension(I.URI.file(p),1);if(!O)throw new Error((0,S.localize)(1,null,p));await this.storeMetadata(O,{...o,installedTimestamp:Date.now()});try{await this.rename(t,p,A,Date.now()+2*60*1e3),this.logService.info("Renamed to",A)}catch(M){try{await E.Promises.rm(p)}catch(N){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(M)}. Deleted from extracted location`,p),M}try{O=await this.scanExtension(I.URI.file(A),1)}catch(M){}if(O)return O;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,a){return this.setMetadata(t,a),await this.storeMetadata(t,{...a,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const o=C.join(t.location.fsPath,"package.json"),u=await E.Promises.readFile(o,"utf8"),{manifest:f}=await this.parseManifest(u);return f.__metadata=a,await E.Promises.writeFile(o,JSON.stringify(f,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const a=t.map(o=>new y.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{a.forEach(u=>o[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const o=(await this.scanExtensions(1)).find(u=>new y.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let o={};if(a)try{o=JSON.parse(a)}catch(u){}return t&&(t(o),Object.keys(o).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await E.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,a){this.logService.trace(`Deleting ${a} extension from disk`,t.identifier.id,t.location.fsPath),await E.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new y.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,a,o,u){this.logService.trace(`Started extracting the extension from ${a} to ${o}`);try{await E.Promises.rm(o)}catch(f){throw new v.ExtensionManagementError(this.joinErrors(f).message,v.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(a,o,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(f){try{await E.Promises.rm(o)}catch(A){}let p=v.ExtensionManagementErrorCode.Extract;throw f instanceof h.ExtractError&&(f.type==="CorruptZip"?p=v.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(p=v.ExtensionManagementErrorCode.IncompleteZip)),new v.ExtensionManagementError(f.message,p)}}async rename(t,a,o,u){try{await E.Promises.rename(a,o)}catch(f){if(w.isWindows&&f&&f.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${a} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,a,o,u);throw new v.ExtensionManagementError(f.message||(0,S.localize)(3,null,a,o),f.code||v.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const a=this.scanDevSystemExtensions(),[o,u]=await Promise.all([t,a]);return[...o,...u]}async scanExtensionsInDir(t,a){const o=new L.Limiter(10),u=await this.fileService.resolve(I.URI.file(t));return u.children?(await Promise.all(u.children.filter(p=>p.isDirectory).map(p=>o.queue(async()=>a===1&&(0,b.basename)(p.resource).indexOf(".")===0?null:this.scanExtension(p.resource,a))))).filter(p=>p&&p.identifier):[]}async scanExtension(t,a){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:u,metadata:f}=await this.readManifest(t.fsPath),p=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,A=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,O={id:(0,y.getGalleryExtensionId)(u.publisher,u.name)},M={type:a,identifier:O,manifest:u,location:t,readmeUrl:p,changelogUrl:A,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return f&&(this.setMetadata(M,f),M.installedTimestamp=f.installedTimestamp),M}}catch(o){a!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(o=>t.some(u=>(0,y.areSameExtensions)(o.identifier,{id:u})))}else return[]}setMetadata(t,a){t.publisherDisplayName=a.publisherDisplayName||null,t.publisherId=a.publisherId||null,t.identifier.uuid=a.id,t.isMachineScoped=!!a.isMachineScoped,t.isBuiltin=t.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),o=new Set;for(const p of a)t[new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]||o.add(p.identifier.id.toLowerCase());const u=(0,y.groupByExtension)(a,p=>p.identifier);await L.Promises.settled(u.map(async p=>{const A=p.sort((O,M)=>i.rcompare(O.manifest.version,M.manifest.version))[0];o.has(A.identifier.id.toLowerCase())||await this.beforeRemovingExtension(A)}));const f=a.filter(p=>t[new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]);await L.Promises.settled(f.map(p=>this.removeUninstalledExtension(p)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),a=[],o=(0,y.groupByExtension)(t,u=>u.identifier);a.push(...(0,R.flatten)(o.map(u=>u.sort((f,p)=>i.rcompare(f.manifest.version,p.manifest.version)).slice(1)))),await L.Promises.settled(a.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const a=Array.isArray(t)?t:[t];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(T.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const a=[E.Promises.readFile(C.join(t,"package.json"),"utf8").then(p=>this.parseManifest(p)),E.Promises.readFile(C.join(t,"package.nls.json"),"utf8").then(void 0,p=>p.code!=="ENOENT"?Promise.reject(p):"{}").then(p=>JSON.parse(p))],[{manifest:o,metadata:u},f]=await Promise.all(a);return{manifest:(0,g.localizeManifest)(o,f),metadata:u}}parseManifest(t){return new Promise((a,o)=>{try{const u=JSON.parse(t),f=u.__metadata||null;a({manifest:u,metadata:f})}catch(u){o(new Error((0,S.localize)(4,null)))}})}};s=he([X(1,l.IFileService),X(2,c.ILogService),X(3,d.INativeEnvironmentService),X(4,n.IProductService)],s),e.ExtensionsScanner=s}),define(te[237],ne([0,1,37,7,15,8,4,31,16,61,9,29,20,65,133,79,13,203,30,36,186,174,235,187,236,188,76,14,6,10,28,22]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c,n,s,r,t,a,o,u,f,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends v.AbstractExtensionManagementService{constructor(_,$,H,j,x,z,Y,U){super(_,$,H,U);this.environmentService=j,this.downloadService=x,this.fileService=Y;const B=this._register(z.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(z.createInstance(r.ExtensionsScanner,Q=>B.postUninstall(Q))),this.manifestCache=this._register(new s.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(z.createInstance(l.ExtensionsDownloader));const W=this._register(new t.ExtensionsWatcher(this,Y,j,H));this._register(W.onDidChangeExtensionsByAnotherSource(({added:Q,removed:Z})=>{Q.length&&this._onDidInstallExtensions.fire(Q.map(G=>({identifier:G.identifier,operation:0,local:G}))),Z.forEach(G=>this._onDidUninstallExtension.fire({identifier:G}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const _=await this.isAlpineLinux(),$=(0,y.getTargetPlatform)(_?"alpine":T.platform,C.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",$),$})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let _;try{_=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch($){try{_=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch(H){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(H))}}return!!_&&(_.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const $=await this.collectFiles(_),H=await(0,E.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,$);return i.URI.file(H)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const $=await this.downloadVsix(_),H=k.resolve($.fsPath);return(0,n.getManifest)(H)}getInstalled(_=null){return this.extensionsScanner.scanExtensions(_)}async install(_,$={}){this.logService.trace("ExtensionManagementService#install",_.toString());const H=await this.downloadVsix(_),j=await(0,n.getManifest)(k.resolve(H.fsPath));if(j.engines&&j.engines.vscode&&!(0,a.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return this.installExtension(j,H,$)}async updateMetadata(_,$){return this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),_}async updateExtensionScope(_,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),_}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(_){if(_.scheme===D.Schemas.file)return _;const $=(0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(_,$),$}createInstallExtensionTask(_,$,H){return i.URI.isUri($)?new P(_,$,H,this.galleryService,this.extensionsScanner,this.logService):new N($,H,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(_,$){return new F(_,$,this.extensionsScanner)}async collectFiles(_){const $=async j=>{let x=await m.Promises.readdir(j);x=x.map(U=>k.join(j,U));const z=await Promise.all(x.map(U=>m.Promises.stat(U)));let Y=Promise.resolve([]);return z.forEach((U,B)=>{const W=x[B];U.isFile()&&(Y=Y.then(Q=>[...Q,W])),U.isDirectory()&&(Y=Y.then(Q=>$(W).then(Z=>[...Q,...Z])))}),Y};return(await $(_.location.fsPath)).map(j=>({path:`extension/${k.relative(_.location.fsPath,j)}`,localPath:j}))}};O=he([X(0,y.IExtensionGalleryService),X(1,A.ITelemetryService),X(2,f.ILogService),X(3,d.INativeEnvironmentService),X(4,S.IDownloadService),X(5,u.IInstantiationService),X(6,o.IFileService),X(7,p.IProductService)],O),e.ExtensionManagementService=O;class M extends v.AbstractExtensionTask{constructor(_,$,H,j){super();this.identifier=_,this.source=$,this.extensionsScanner=H,this.logService=j,this._operation=1}get operation(){return this._operation}async installExtension(_,$){try{const H=await this.unsetUninstalledAndGetLocal(_.identifierWithVersion);if(H)return _.metadata?this.extensionsScanner.saveMetadataForLocalExtension(H,_.metadata):H}catch(H){throw T.isMacintosh?new y.ExtensionManagementError(h.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(h.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(_,$)}async unsetUninstalledAndGetLocal(_){if(!await this.isUninstalled(_))return null;this.logService.trace("Removing the extension from uninstalled list:",_.id);const H=await this.extensionsScanner.setInstalled(_);return this.logService.info("Removed the extension from uninstalled list:",_.id),H}async isUninstalled(_){return!!(await this.extensionsScanner.getUninstalledExtensions())[_.key()]}async extract({zipPath:_,identifierWithVersion:$,metadata:H},j){let x=await this.extensionsScanner.extractUserExtension($,_,H,j);return this.logService.info("Extracting completed.",$.id),x}}class N extends M{constructor(_,$,H,j,x){super(_.identifier,_,j,x);this.gallery=_,this.options=$,this.extensionsDownloader=H}async doRun(_){const H=(await this.extensionsScanner.scanExtensions(null)).find(x=>(0,g.areSameExtensions)(x.identifier,this.gallery.identifier));H&&(this._operation=2);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||H?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||H?.isBuiltin;try{const x=await this.installExtension(j,_);return H&&b.neq(H.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(H),x}catch(x){throw await this.deleteDownloadedVSIX(j.zipPath),x}}async deleteDownloadedVSIX(_){try{await this.extensionsDownloader.delete(i.URI.file(_))}catch($){this.logService.warn("Error while deleting the downloaded vsix",_.toString(),(0,L.getErrorMessage)($))}}async downloadInstallableExtension(_,$){const H={id:_.identifier.uuid,publisherId:_.publisherId,publisherDisplayName:_.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",_.identifier.id),j=(await this.extensionsDownloader.downloadExtension(_,$)).fsPath,this.logService.info("Downloaded extension:",_.identifier.id,j)}catch(x){throw new y.ExtensionManagementError((0,v.joinErrors)(x).message,y.ExtensionManagementErrorCode.Download)}try{const x=await(0,n.getManifest)(j);return{zipPath:j,identifierWithVersion:new g.ExtensionIdentifierWithVersion(_.identifier,x.version),metadata:H}}catch(x){throw await this.deleteDownloadedVSIX(j),new y.ExtensionManagementError((0,v.joinErrors)(x).message,y.ExtensionManagementErrorCode.Invalid)}}}class P extends M{constructor(_,$,H,j,x,z){super({id:(0,g.getGalleryExtensionId)(_.publisher,_.name)},$,x,z);this.manifest=_,this.location=$,this.options=H,this.galleryService=j}async doRun(_){const $=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(z=>(0,g.areSameExtensions)(this.identifier,z.identifier)),x=await this.getMetadata(this.identifier.id,_);if(x.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||j?.isBuiltin,j)if(this._operation=2,$.equals(new g.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch(z){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const z=await this.unsetUninstalledAndGetLocal($);if(z)try{await this.extensionsScanner.removeExtension(z,"existing")}catch(Y){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:k.resolve(this.location.fsPath),identifierWithVersion:$,metadata:x},_)}async getMetadata(_,$){try{const H=(await this.galleryService.query({names:[_],pageSize:1},$)).firstPage[0];if(H)return{id:H.identifier.uuid,publisherDisplayName:H.publisherDisplayName,publisherId:H.publisherId}}catch(H){}return{}}}class F extends v.AbstractExtensionTask{constructor(_,$,H){super();this.extension=_,this.options=$,this.extensionsScanner=H}async doRun(_){const $=[],H=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...H.filter(x=>j.equals(new g.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version))))}else $.push(...H.filter(j=>(0,g.areSameExtensions)(j.identifier,this.extension.identifier)));if(!$.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const j of $)try{_.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(x){throw new Error(h.localize(6,null,(0,R.toErrorMessage)(x)))}}}}),define(te[238],ne([0,1,82,56,34,19,7,3,2,8,4,29,32,71,248]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(u){this.socket=u,this._errorListener=f=>{if(f){if(f.code==="EPIPE")return;(0,T.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const f=p=>u(k.VSBuffer.wrap(p));return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(u){const f=p=>{u({type:0,hadError:p,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,T.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,T.onUnexpectedError)(f)}}end(){this.socket.end()}drain(){return new Promise((u,f)=>{if(this.socket.bufferSize===0){u();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),u()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=S;var d;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var v;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(v||(v={}));class y extends w.Disposable{constructor(u,f,p,A){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=f,this._recordInflateBytes=A,f?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,T.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),p&&(this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,T.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let f=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.length-4),this._isEnded||this._write(k.VSBuffer.wrap(f),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,f){let p=2;u.byteLength<126?p+=0:u.byteLength<2**16?p+=2:p+=8;const A=k.VSBuffer.alloc(p);if(f?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(u.byteLength>>>24&255,++O),A.writeUInt8(u.byteLength>>>16&255,++O),A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(k.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),p=f.readUInt8(0),A=(p&128)>>>7,O=(p&64)>>>6,M=f.readUInt8(1),N=(M&128)>>>7,P=M&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(P===126?2:0)+(P===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),p=f.readUInt8(1),A=(p&128)>>>7;let O=p&127,M=1;O===126?O=f.readUInt8(++M)*2**8+f.readUInt8(++M):O===127&&(O=f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*2**24+f.readUInt8(++M)*2**16+f.readUInt8(++M)*2**8+f.readUInt8(++M));let N=0;A&&(N=f.readUInt8(++M)*2**24+f.readUInt8(++M)*2**16+f.readUInt8(++M)*2**8+f.readUInt8(++M)),this._state.state=3,this._state.readLen=O,this._state.mask=N}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);g(f,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(f.buffer)),this._zlibInflate.write(f.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const p=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=p.length,this._onData.fire(k.VSBuffer.wrap(p))})):(this._totalIncomingDataBytes+=f.byteLength,this._onData.fire(f))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=y;function g(o,u){if(u===0)return;let f=o.byteLength>>>2;for(let P=0;P<f;P++){const F=o.readUInt32BE(P*4);o.writeUInt32BE(F^u,P*4)}let p=f*4,A=o.byteLength-p;const O=u>>>24&255,M=u>>>16&255,N=u>>>8&255;A>=1&&o.writeUInt8(o.readUInt8(p)^O,p),A>=2&&o.writeUInt8(o.readUInt8(p+1)^M,p+1),A>=3&&o.writeUInt8(o.readUInt8(p+2)^N,p+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):u=(0,b.join)((0,D.tmpdir)(),`vscode-ipc-${o}.sock`),s(u),u}e.createRandomIPCHandle=c;function n(o,u,f){const p=(0,R.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${f}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${f}-${u}.sock`):A=(0,b.join)(o,`${f}-${u}.sock`),s(A),A}e.createStaticIPCHandle=n;function s(o){const u=l[i.platform];typeof u=="number"&&o.length>=u&&console.warn(`WARNING: IPC handle "${o}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends m.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const f=C.Event.fromNodeEventEmitter(u,"connection");return C.Event.map(f,p=>({protocol:new E.Protocol(new S(p)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(p,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function t(o){return new Promise((u,f)=>{const p=(0,L.createServer)();p.on("error",f),p.listen(o,()=>{p.removeListener("error",f),u(new r(p))})})}e.serve=t;function a(o,u){return new Promise((f,p)=>{const A=(0,L.createConnection)(o,()=>{A.removeListener("error",p),f(E.Client.fromSocket(new S(A),u))});A.once("error",p)})}e.connect=a}),define(te[239],ne([0,1,56,238]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,T,C){const w=i=>C(i,void 0),b=R.createConnection({host:D,port:k},()=>{b.removeListener("error",w);const i=Buffer.alloc(16);for(let h=0;h<16;h++)i[h]=Math.round(Math.random()*256);const I=i.toString("base64");let m=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}/?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];b.write(m.join(`\r
`)+`\r
\r
`);const E=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",E),C(void 0,new L.NodeSocket(b)))};b.on("data",E)});b.once("error",w)}}}),define(te[240],ne([0,1,56,115,239,5,2,21,10,28,184,62,91]),function(J,e,R,L,D,k,T,C,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(v,y,g,l,c){return new h(v,y,g,l,c).waitForReady()}class h extends T.Disposable{constructor(y,g,l,c,n){super();this.defaultTunnelHost=g,this.suggestedLocalPort=n,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=R.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(g=>{g()})}async waitForReady(){let y=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),g=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(y){y.pause();const g=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,i.connectRemoteAgentTunnel)(this._options,g,this.tunnelRemotePort),c=l.getSocket().socket,n=l.readEntireBuffer();l.dispose(),n.byteLength>0&&y.write(n.buffer),y.on("end",()=>{this._socketsDispose.delete(y.localAddress),c.end()}),y.on("close",()=>c.end()),y.on("error",()=>{this._socketsDispose.delete(y.localAddress),c.destroy()}),c.on("end",()=>y.end()),c.on("close",()=>y.end()),c.on("error",()=>{y.destroy()}),y.pipe(c),c.pipe(y),this._socketsDispose.set(y.localAddress,()=>{y.end(),c.end()})}}let S=class extends I.AbstractTunnelService{constructor(y,g,l,c,n){super(g);this.socketFactory=y,this.signService=l,this.productService=c,this.configurationService=n}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,g,l,c,n,s,r){const t=this.getTunnelFromMap(g,l);if(t)return++t.refcount,t.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,g,l,c,n,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${g}:${l} on local port ${c}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},o=E(a,this.defaultTunnelHost,g,l,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(g,l,o),o}}};S=he([X(1,w.ILogService),X(2,m.ISignService),X(3,b.IProductService),X(4,C.IConfigurationService)],S),e.BaseTunnelService=S;let d=class extends S{constructor(y,g,l,c){super(D.nodeSocketFactory,y,g,l,c)}};d=he([X(0,w.ILogService),X(1,m.ISignService),X(2,b.IProductService),X(3,C.IConfigurationService)],d),e.TunnelService=d}),define(te[249],ne([0,1,72,34,37,7,2,15,16,9,32,119,180,159,181,171,172,173,157,161,21,182,78,202,79,193,13,152,198,205,30,160,204,237,80,155,14,177,179,53,6,168,84,169,170,58,189,10,86,59,60,28,192,43,23,200,201,22,92,93,94,47,206,207,95,209,215,97,98,99,24,63,226,227,228,64,229,230,231,232,233,234,81,175,91,197,62,240,190,191,90,196,85]),function(J,e,R,L,D,k,T,C,w,b,i,I,m,E,h,S,d,v,y,g,l,c,n,s,r,t,a,o,u,f,p,A,O,M,N,P,F,q,_,$,H,j,x,z,Y,U,B,W,Q,Z,G,V,re,ie,ce,le,de,fe,be,Ce,Ee,Ae,Pe,Le,Fe,Ne,$e,xe,ee,ae,oe,pe,Se,_e,Re,K,se,ue,ge,me,Ie,ke,Te,ye,we,De,Oe,Ue,Qe,Ye,We,Et,dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class bt extends T.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new I.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",ze=(Ve,qe)=>this.onDisposeWorker(qe);R.ipcRenderer.on(Me,ze),this._register((0,T.toDisposable)(()=>R.ipcRenderer.removeListener(Me,ze)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,oe.registerConfiguration)(),ve.invokeFunction(Me=>{const ze=Me.get(W.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(ze)}),this._register((0,T.combinedDisposable)(ve.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(d.LogsDataCleaner),ve.createInstance(S.LocalizationsUpdater),ve.createInstance(E.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new x.ServiceCollection,Me={_serviceBrand:void 0,...G.default};ve.set(V.IProductService,Me);const ze=new i.StaticRouter(je=>je==="main"),Ve=new z.MessagePortMainProcessService(this.server,ze);ve.set(Y.IMainProcessService,Ve);const qe=new o.NativeEnvironmentService(this.configuration.args,Me);ve.set(a.INativeEnvironmentService,qe);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),Ze=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ve.getChannel("logger"));ve.set(W.ILoggerService,Ze);const at=this._register(new W.MultiplexLogService([this._register(new W.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,w.joinPath)(b.URI.file(qe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),He=this._register(new Q.FollowerLogService(rt,at));ve.set(W.ILogService,He),this.sharedProcessWorkerService=new Et.SharedProcessWorkerService(He),ve.set(We.ISharedProcessWorkerService,this.sharedProcessWorkerService);const et=this._register(new q.FileService(He));ve.set(F.IFileService,et);const ot=this._register(new _.DiskFileSystemProvider(He));et.registerProvider(C.Schemas.file,ot);const Ge=this._register(new c.ConfigurationService(qe.settingsResource,et));ve.set(l.IConfigurationService,Ge);const nt=new le.NativeStorageService(void 0,Ve,qe);ve.set(ce.IStorageService,nt),this._register((0,T.toDisposable)(()=>nt.flush())),await Promise.all([Ge.initialize(),nt.initialize()]),ve.set(dt.IUserConfigurationFileService,i.ProxyChannel.toService(Ve.getChannel(dt.UserConfigurationFileServiceId))),ve.set(ie.IRequestService,new $.SyncDescriptor(re.RequestService)),ve.set(y.IChecksumService,new $.SyncDescriptor(g.ChecksumService));const st=i.ProxyChannel.toService(Ve.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(Z.INativeHostService,st),ve.set(r.IDownloadService,new $.SyncDescriptor(t.DownloadService));const ct=this._register(new ke.ActiveWindowManager(st)),lt=new i.StaticRouter(je=>ct.getActiveClientId().then(ut=>je===ut));ve.set(N.IExtensionRecommendationNotificationService,new P.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Je;const Xe=[];if((0,Ae.supportsTelemetry)(Me,qe)){const je=new Ce.TelemetryLogAppender(Ze,qe);Xe.push(je);const{appRoot:ut,extensionsPath:Pt,installSourcePath:Dt}=qe;if(Me.aiConfig&&Me.aiConfig.asimovKey){const vt=new Pe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>vt.flush())),Xe.push(vt)}Je=new Ee.TelemetryService({appenders:Xe,commonProperties:(0,de.resolveCommonProperties)(et,(0,L.release)(),(0,L.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Dt),sendErrorTelemetry:!0,piiPaths:[ut,Pt]},Ge)}else{Je=Ae.NullTelemetryService;const je=Ae.NullAppender;Xe.push(je)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(Xe)),ve.set(fe.ITelemetryService,Je);const Ct=new Le.CustomEndpointTelemetryService(Ge,Je,Ze,qe);ve.set(fe.ICustomEndpointTelemetryService,Ct),ve.set(p.IExtensionManagementService,new $.SyncDescriptor(M.ExtensionManagementService)),ve.set(p.IExtensionGalleryService,new $.SyncDescriptor(f.ExtensionGalleryService)),ve.set(p.IExtensionTipsService,new $.SyncDescriptor(O.ExtensionTipsService)),ve.set(U.ILocalizationsService,new $.SyncDescriptor(B.LocalizationsService)),ve.set(n.IDiagnosticsService,new $.SyncDescriptor(s.DiagnosticsService)),ve.set(pe.IUserDataSyncAccountService,new $.SyncDescriptor(pe.UserDataSyncAccountService)),ve.set(oe.IUserDataSyncLogService,new $.SyncDescriptor(Re.UserDataSyncLogService)),ve.set(oe.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),ve.set(p.IGlobalExtensionEnablementService,new $.SyncDescriptor(u.GlobalExtensionEnablementService)),ve.set(ee.IIgnoredExtensionsManagementService,new $.SyncDescriptor(ee.IgnoredExtensionsManagementService)),ve.set(xe.IExtensionsStorageSyncService,new $.SyncDescriptor(xe.ExtensionsStorageSyncService)),ve.set(oe.IUserDataSyncStoreManagementService,new $.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(oe.IUserDataSyncStoreService,new $.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(K.IUserDataSyncMachinesService,new $.SyncDescriptor(K.UserDataSyncMachinesService)),ve.set(oe.IUserDataSyncBackupStoreService,new $.SyncDescriptor(Se.UserDataSyncBackupStoreService)),ve.set(oe.IUserDataAutoSyncEnablementService,new $.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),ve.set(oe.IUserDataSyncResourceEnablementService,new $.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(oe.IUserDataSyncService,new $.SyncDescriptor(ue.UserDataSyncService));const mt=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ge.getValue("terminal.integrated.persistentSessionScrollback")??100},Ge,qe,He,Je);return await mt.initialize(),ve.set(Ne.ILocalPtyService,this._register(mt)),ve.set(Te.IExtensionHostStarter,this._register(new ye.ExtensionHostStarter(He))),ve.set(we.ISignService,new $.SyncDescriptor(De.SignService)),ve.set(Oe.ITunnelService,new $.SyncDescriptor(Ue.TunnelService)),ve.set(Qe.ISharedProcessTunnelService,new $.SyncDescriptor(Ye.SharedProcessTunnelService)),new j.InstantiationService(ve)}initChannels(ve){const Me=new A.ExtensionManagementChannel(ve.get(p.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const ze=i.ProxyChannel.fromService(ve.get(U.ILocalizationsService));this.server.registerChannel("localizations",ze);const Ve=i.ProxyChannel.fromService(ve.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Ve);const qe=new A.ExtensionTipsChannel(ve.get(p.IExtensionTipsService));this.server.registerChannel("extensionTipsService",qe);const rt=i.ProxyChannel.fromService(ve.get(y.IChecksumService));this.server.registerChannel("checksum",rt);const Ze=new _e.UserDataSyncMachinesServiceChannel(ve.get(K.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const at=i.ProxyChannel.fromService(ve.get(fe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const He=new _e.UserDataSyncAccountServiceChannel(ve.get(pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const et=new _e.UserDataSyncStoreManagementServiceChannel(ve.get(oe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",et);const ot=new ge.UserDataSyncChannel(ve.get(oe.IUserDataSyncService),ve.get(W.ILogService));this.server.registerChannel("userDataSync",ot);const Ge=this._register(ve.get(H.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),nt=new _e.UserDataAutoSyncChannel(Ge);this.server.registerChannel("userDataAutoSync",nt);const st=ve.get(Ne.ILocalPtyService),ct=i.ProxyChannel.fromService(st);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,ct);const lt=i.ProxyChannel.fromService(ve.get(Te.IExtensionHostStarter));this.server.registerChannel(Te.ipcExtensionHostStarterChannelName,lt);const Je=i.ProxyChannel.fromService(ve.get(Qe.ISharedProcessTunnelService));this.server.registerChannel(Qe.ipcSharedProcessTunnelChannelName,Je);const Xe=i.ProxyChannel.fromService(ve.get(We.ISharedProcessWorkerService));this.server.registerChannel(We.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,k.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Me=>{const ze=(0,D.toErrorMessage)(Me,!0);!ze||ve.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function It(gt){const ve=new bt(gt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=It})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc1a6699060423b8c4d2ced736ad70195378fddf/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
