/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","electron","vs/base/common/types","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/errorMessage","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","vs/code/electron-main/main"],x=function(j){for(var e=[],p=0,L=j.length;p<L;p++)e[p]=Z[j[p]];return e};define(Z[104],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(Z[46],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(P){return(E,h,d)=>{let i=null,S=null;if(typeof d.value=="function"?(i="value",S=d.value):typeof d.get=="function"&&(i="get",S=d.get),!S)throw new Error("not supported");d[i]=P(S,h)}}e.createDecorator=p;function L(P,E,h){let d=null,i=null;if(typeof h.value=="function"?(d="value",i=h.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(d="get",i=h.get),!i)throw new Error("not supported");const S=`$memoize$${E}`;h[d]=function(...v){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,v)}),this[S]}}e.memoize=L;function D(P,E,h){return p((d,i)=>{const S=`$debounce$${i}`,v=`$debounce$result$${i}`;return function(...m){this[v]||(this[v]=h?h():void 0),clearTimeout(this[S]),E&&(this[v]=E(this[v],...m),m=[this[v]]),this[S]=setTimeout(()=>{d.apply(this,m),this[v]=h?h():void 0},P)}})}e.debounce=D;function M(P,E,h){return p((d,i)=>{const S=`$throttle$timer$${i}`,v=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,t=`$throttle$pending$${i}`;return function(...g){if(this[v]||(this[v]=h?h():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),E&&(this[v]=E(this[v],...g)),this[t])return;const b=this[m]+P;b<=Date.now()?(this[m]=Date.now(),d.apply(this,[this[v]]),this[v]=h?h():void 0):(this[t]=!0,this[S]=setTimeout(()=>{this[t]=!1,this[m]=Date.now(),d.apply(this,[this[v]]),this[v]=h?h():void 0},b-Date.now()))}})}e.throttle=M}),define(Z[16],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(l=>{l(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=p,e.errorHandler=new p;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function D(u){h(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function M(u){h(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function P(u){if(u instanceof Error){let{name:n,message:l}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:n,message:l,stack:s}}return u}e.transformErrorForSerialization=P;const E="Canceled";function h(u){return u instanceof Error&&u.name===E&&u.message===E}e.isPromiseCanceledError=h;class d extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=d;function i(){const u=new Error(E);return u.name=u.message,u}e.canceled=i;function S(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=S;function v(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=v;function m(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function t(u){const n=new Error(`${u} has been disposed`);return n.name="DISPOSED",n}e.disposed=t;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class b extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=b;class y extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=y;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function c(u){const n=u;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=c;function o(u,n=Object.create(null)){const l=new Error(u);return n.actions&&(l.actions=n.actions),l}e.createErrorWithActions=o}),define(Z[31],x([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,z=0){return W[W.length-(1+z)]}e.tail=L;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function M(W,z,K=(O,q)=>O===q){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let O=0,q=W.length;O<q;O++)if(!K(W[O],z[O]))return!1;return!0}e.equals=M;function P(W,z,K){let O=0,q=W.length-1;for(;O<=q;){const C=(O+q)/2|0,$=K(W[C],z);if($<0)O=C+1;else if($>0)q=C-1;else return C}return-(O+1)}e.binarySearch=P;function E(W,z){let K=0,O=W.length;if(O===0)return 0;for(;K<O;){const q=Math.floor((K+O)/2);z(W[q])?O=q:K=q+1}return K}e.findFirstInSorted=E;function h(W,z,K){if(W=W|0,W>=z.length)throw new TypeError("invalid index");let O=z[Math.floor(z.length*Math.random())],q=[],C=[],$=[];for(let J of z){const Q=K(J,O);Q<0?q.push(J):Q>0?C.push(J):$.push(J)}return W<q.length?h(W,q,K):W<q.length+$.length?$[0]:h(W-(q.length+$.length),C,K)}e.quickSelect=h;function d(W,z){const K=[];let O;for(const q of W.slice(0).sort(z))!O||z(O[0],q)!==0?(O=[q],K.push(O)):O.push(q);return K}e.groupBy=d;function i(W,z,K){const O=[];function q(J,Q,ne){if(Q===0&&ne.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===J?(le.deleteCount+=Q,le.toInsert.push(...ne)):O.push({start:J,deleteCount:Q,toInsert:ne})}let C=0,$=0;for(;;){if(C===W.length){q(C,0,z.slice($));break}if($===z.length){q(C,W.length-C,[]);break}const J=W[C],Q=z[$],ne=K(J,Q);ne===0?(C+=1,$+=1):ne<0?(q(C,1,[]),C+=1):ne>0&&(q(C,0,[Q]),$+=1)}return O}e.sortedDiff=i;function S(W,z,K){const O=i(W,z,K),q=[],C=[];for(const $ of O)q.push(...W.slice($.start,$.start+$.deleteCount)),C.push(...$.toInsert);return{removed:q,added:C}}e.delta=S;function v(W,z,K){if(K===0)return[];const O=W.slice(0,K).sort(z);return t(W,z,O,K,W.length),O}e.top=v;function m(W,z,K,O,q){return K===0?Promise.resolve([]):new Promise((C,$)=>{(async()=>{const J=W.length,Q=W.slice(0,K).sort(z);for(let ne=K,le=Math.min(K+O,J);ne<J;ne=le,le=Math.min(le+O,J)){if(ne>K&&await new Promise(oe=>setTimeout(oe)),q&&q.isCancellationRequested)throw(0,p.canceled)();t(W,z,Q,ne,le)}return Q})().then(C,$)})}e.topAsync=m;function t(W,z,K,O,q){for(const C=K.length;O<q;O++){const $=W[O];if(z($,K[C-1])<0){K.pop();const J=E(K,Q=>z($,Q)<0);K.splice(J,0,$)}}}function g(W){return W.filter(z=>!!z)}e.coalesce=g;function b(W){let z=0;for(let K=0;K<W.length;K++)W[K]&&(W[z]=W[K],z+=1);W.length=z}e.coalesceInPlace=b;function y(W,z,K){W.splice(K,0,W.splice(z,1)[0])}e.move=y;function I(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=I;function c(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=c;function o(W,z=K=>K){const K=new Set;return W.filter(O=>{const q=z(O);return K.has(q)?!1:(K.add(q),!0)})}e.distinct=o;function u(W){const z=Object.create(null);return K=>{const O=W(K);return z[O]?!1:(z[O]=!0,!0)}}e.uniqueFilter=u;function n(W,z){const K=l(W,z);if(K!==-1)return W[K]}e.findLast=n;function l(W,z){for(let K=W.length-1;K>=0;K--){const O=W[K];if(z(O))return K}return-1}e.lastIndex=l;function s(W,z){return W.length>0?W[0]:z}e.firstOrDefault=s;function r(W,z,K=(O,q)=>O===q){let O=0;for(let q=0,C=Math.min(W.length,z.length);q<C&&K(W[q],z[q]);q++)O++;return O}e.commonPrefixLength=r;function a(W){return[].concat(...W)}e.flatten=a;function f(W,z){let K=typeof z=="number"?W:0;typeof z=="number"?K=W:(K=0,z=W);const O=[];if(K<=z)for(let q=K;q<z;q++)O.push(q);else for(let q=K;q>z;q--)O.push(q);return O}e.range=f;function w(W,z,K){return W.reduce((O,q)=>(O[z(q)]=K?K(q):q,O),Object.create(null))}e.index=w;function k(W,z){return W.push(z),()=>R(W,z)}e.insert=k;function R(W,z){const K=W.indexOf(z);if(K>-1)return W.splice(K,1),z}e.remove=R;function A(W,z,K){const O=W.slice(0,z),q=W.slice(z);return O.concat(K,q)}e.arrayInsert=A;function F(W,z){let K;if(typeof z=="number"){let O=z;K=()=>{const q=Math.sin(O++)*179426549;return q-Math.floor(q)}}else K=Math.random;for(let O=W.length-1;O>0;O-=1){const q=Math.floor(K()*(O+1)),C=W[O];W[O]=W[q],W[q]=C}}e.shuffle=F;function H(W,z){const K=W.indexOf(z);K>-1&&(W.splice(K,1),W.unshift(z))}e.pushToStart=H;function ie(W,z){const K=W.indexOf(z);K>-1&&(W.splice(K,1),W.push(z))}e.pushToEnd=ie;function re(W,z){return Array.isArray(W)?W.map(z):z(W)}e.mapArrayOrNot=re;function G(W){return Array.isArray(W)?W:[W]}e.asArray=G;function ee(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=ee;function T(W,z){for(const K of W){const O=z(K);if(O!==void 0)return O}}e.mapFind=T;function V(W,z,K){const O=B(W,z),q=W.length,C=K.length;W.length=q+C;for(let $=q-1;$>=O;$--)W[$+C]=W[$];for(let $=0;$<C;$++)W[$+O]=K[$]}e.insertInto=V;function U(W,z,K,O){const q=B(W,z),C=W.splice(q,K);return V(W,q,O),C}e.splice=U;function B(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}function N(W,z){let K=Number.MAX_SAFE_INTEGER,O=0;return W.forEach((q,C)=>{const $=z(q);$<K&&(K=$,O=C)}),O}e.minIndex=N;function _(W,z){let K=Number.MIN_SAFE_INTEGER,O=0;return W.forEach((q,C)=>{const $=z(q);$>K&&(K=$,O=C)}),O}e.maxIndex=_;class X{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let K=this.firstIdx;for(;K<this.items.length&&z(this.items[K]);)K++;const O=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,O}takeFromEndWhile(z){let K=this.lastIdx;for(;K>=0&&z(this.items[K]);)K--;const O=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,O}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=X}),define(Z[42],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const D=this;let M=!1,P;return function(){return M||(M=!0,P=L.apply(D,arguments)),P}}e.once=p}),define(Z[68],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=D;const M=Object.freeze([]);function P(){return M}L.empty=P;function*E(u){yield u}L.single=E;function h(u){return u||M}L.from=h;function d(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=d;function i(u){return u[Symbol.iterator]().next().value}L.first=i;function S(u,n){for(const l of u)if(n(l))return!0;return!1}L.some=S;function v(u,n){for(const l of u)if(n(l))return l}L.find=v;function*m(u,n){for(const l of u)n(l)&&(yield l)}L.filter=m;function*t(u,n){let l=0;for(const s of u)yield n(s,l++)}L.map=t;function*g(...u){for(const n of u)for(const l of n)yield l}L.concat=g;function*b(u){for(const n of u)for(const l of n)yield l}L.concatNested=b;function y(u,n,l){let s=l;for(const r of u)s=n(s,r);return s}L.reduce=y;function*I(u,n,l=u.length){for(n<0&&(n+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);n<l;n++)yield u[n]}L.slice=I;function c(u,n=Number.POSITIVE_INFINITY){const l=[];if(n===0)return[l,u];const s=u[Symbol.iterator]();for(let r=0;r<n;r++){const a=s.next();if(a.done)return[l,L.empty()];l.push(a.value)}return[l,{[Symbol.iterator](){return s}}]}L.consume=c;function o(u,n,l=(s,r)=>s===r){const s=u[Symbol.iterator](),r=n[Symbol.iterator]();for(;;){const a=s.next(),f=r.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!l(a.value,f.value))return!1}}L.equals=o})(p=e.Iterable||(e.Iterable={}))}),define(Z[39],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function P(n,l=!1){let s=0,r=n.length,a="",f=0,w=16,k=0;function R(ee){let T=0,V=0;for(;T<ee;){const U=n.charCodeAt(s);if(U>=48&&U<=57)V=V*16+U-48;else if(U>=65&&U<=70)V=V*16+U-65+10;else if(U>=97&&U<=102)V=V*16+U-97+10;else break;s++,T++}return T<ee&&(V=-1),V}function A(ee){s=ee,a="",f=0,w=16,k=0}function F(){const ee=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&d(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&d(n.charCodeAt(s)))for(s++;s<n.length&&d(n.charCodeAt(s));)s++;else return k=3,n.substring(ee,s);let T=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&d(n.charCodeAt(s))){for(s++;s<n.length&&d(n.charCodeAt(s));)s++;T=s}else k=3;return n.substring(ee,T)}function H(){let ee="",T=s;for(;;){if(s>=r){ee+=n.substring(T,s),k=2;break}const V=n.charCodeAt(s);if(V===34){ee+=n.substring(T,s),s++;break}if(V===92){if(ee+=n.substring(T,s),s++,s>=r){k=2;break}switch(n.charCodeAt(s++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const B=R(4);B>=0?ee+=String.fromCharCode(B):k=4;break;default:k=5}T=s;continue}if(V>=0&&V<=31)if(h(V)){ee+=n.substring(T,s),k=2;break}else k=6;s++}return ee}function ie(){if(a="",k=0,f=s,s>=r)return f=r,w=17;let ee=n.charCodeAt(s);if(E(ee)){do s++,a+=String.fromCharCode(ee),ee=n.charCodeAt(s);while(E(ee));return w=15}if(h(ee))return s++,a+=String.fromCharCode(ee),ee===13&&n.charCodeAt(s)===10&&(s++,a+=`
`),w=14;switch(ee){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,a=H(),w=10;case 47:const T=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<r&&!h(n.charCodeAt(s));)s++;return a=n.substring(T,s),w=12}if(n.charCodeAt(s+1)===42){s+=2;const V=r-1;let U=!1;for(;s<V;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,k=1),a=n.substring(T,s),w=13}return a+=String.fromCharCode(ee),s++,w=16;case 45:if(a+=String.fromCharCode(ee),s++,s===r||!d(n.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=F(),w=11;default:for(;s<r&&re(ee);)s++,ee=n.charCodeAt(s);if(f!==s){switch(a=n.substring(f,s),a){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return a+=String.fromCharCode(ee),s++,w=16}}function re(ee){if(E(ee)||h(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let ee;do ee=ie();while(ee>=12&&ee<=15);return ee}return{setPosition:A,getPosition:()=>s,scan:l?G:ie,getToken:()=>w,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>k}}e.createScanner=P;function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function h(n){return n===10||n===13||n===8232||n===8233}function d(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function S(n,l){const s=[],r=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(R,A,F,H){f.value=R,f.offset=A,f.length=F,f.type=H,f.colonOffset=void 0,a=f}try{c(n,{onObjectBegin:(R,A)=>{if(l<=R)throw r;a=void 0,w=l>R,s.push("")},onObjectProperty:(R,A,F)=>{if(l<A||(k(R,A,F,"property"),s[s.length-1]=R,l<=A+F))throw r},onObjectEnd:(R,A)=>{if(l<=R)throw r;a=void 0,s.pop()},onArrayBegin:(R,A)=>{if(l<=R)throw r;a=void 0,s.push(0)},onArrayEnd:(R,A)=>{if(l<=R)throw r;a=void 0,s.pop()},onLiteralValue:(R,A,F)=>{if(l<A||(k(R,A,F,u(R)),l<=A+F))throw r},onSeparator:(R,A,F)=>{if(l<=A)throw r;if(R===":"&&a&&a.type==="property")a.colonOffset=A,w=!1,a=void 0;else if(R===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(w=!0,s[s.length-1]=""),a=void 0}}})}catch(R){if(R!==r)throw R}return{path:s,previousNode:a,isAtPropertyKey:w,matches:R=>{let A=0;for(let F=0;A<R.length&&F<s.length;F++)if(R[A]===s[F]||R[A]==="*")A++;else if(R[A]!=="**")return!1;return A===R.length}}}e.getLocation=S;function v(n,l=[],s=M.DEFAULT){let r=null,a=[];const f=[];function w(R){Array.isArray(a)?a.push(R):r!==null&&(a[r]=R)}return c(n,{onObjectBegin:()=>{const R={};w(R),f.push(a),a=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const R=[];w(R),f.push(a),a=R,r=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:w,onError:(R,A,F)=>{l.push({error:R,offset:A,length:F})}},s),a[0]}e.parse=v;function m(n,l=[],s=M.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function f(R){return r.children.push(R),R}c(n,{onObjectBegin:R=>{r=f({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,A,F)=>{r=f({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:A,length:F,parent:r})},onObjectEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,a(R+A)},onArrayBegin:(R,A)=>{r=f({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,a(R+A)},onLiteralValue:(R,A,F)=>{f({type:u(R),offset:A,length:F,parent:r,value:R}),a(A+F)},onSeparator:(R,A,F)=>{r.type==="property"&&(R===":"?r.colonOffset=A:R===","&&a(A))},onError:(R,A,F)=>{l.push({error:R,offset:A,length:F})}},s);const k=r.children[0];return k&&delete k.parent,k}e.parseTree=m;function t(n,l){if(!n)return;let s=n;for(let r of l)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===r){s=f.children[1],a=!0;break}if(!a)return}else{const a=r;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=t;function g(n){if(!n.parent||!n.parent.children)return[];const l=g(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;l.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&l.push(s)}return l}e.getNodePath=g;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":const l=Object.create(null);for(let s of n.children){const r=s.children[1];r&&(l[s.children[0].value]=b(r))}return l;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=b;function y(n,l,s=!1){return l>=n.offset&&l<n.offset+n.length||s&&l===n.offset+n.length}e.contains=y;function I(n,l,s=!1){if(y(n,l,s)){const r=n.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=l;a++){const f=I(r[a],l,s);if(f)return f}return n}}e.findNodeAtOffset=I;function c(n,l,s=M.DEFAULT){const r=P(n,!1);function a(K){return K?()=>K(r.getTokenOffset(),r.getTokenLength()):()=>!0}function f(K){return K?O=>K(O,r.getTokenOffset(),r.getTokenLength()):()=>!0}const w=a(l.onObjectBegin),k=f(l.onObjectProperty),R=a(l.onObjectEnd),A=a(l.onArrayBegin),F=a(l.onArrayEnd),H=f(l.onLiteralValue),ie=f(l.onSeparator),re=a(l.onComment),G=f(l.onError),ee=s&&s.disallowComments,T=s&&s.allowTrailingComma;function V(){for(;;){const K=r.scan();switch(r.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:ee||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(K){case 12:case 13:ee?U(10):re();break;case 16:U(1);break;case 15:case 14:break;default:return K}}}function U(K,O=[],q=[]){if(G(K),O.length+q.length>0){let C=r.getToken();for(;C!==17;){if(O.indexOf(C)!==-1){V();break}else if(q.indexOf(C)!==-1)break;C=V()}}}function B(K){const O=r.getTokenValue();return K?H(O):k(O),V(),!0}function N(){switch(r.getToken()){case 11:let K=0;try{K=JSON.parse(r.getTokenValue()),typeof K!="number"&&(U(2),K=0)}catch(O){U(2)}H(K);break;case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return V(),!0}function _(){return r.getToken()!==10?(U(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(ie(":"),V(),z()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function X(){w(),V();let K=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(K||U(4,[],[]),ie(","),V(),r.getToken()===2&&T)break}else K&&U(6,[],[]);_()||U(4,[],[2,5]),K=!0}return R(),r.getToken()!==2?U(7,[2],[]):V(),!0}function W(){A(),V();let K=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(K||U(4,[],[]),ie(","),V(),r.getToken()===4&&T)break}else K&&U(6,[],[]);z()||U(4,[],[4,5]),K=!0}return F(),r.getToken()!==4?U(8,[4],[]):V(),!0}function z(){switch(r.getToken()){case 3:return W();case 1:return X();case 10:return B(!0);default:return N()}}return V(),r.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):z()?(r.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=c;function o(n,l){let s=P(n),r=[],a,f=0,w;do switch(w=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:f!==w&&r.push(n.substring(f,w)),l!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,l)),f=s.getPosition();break}while(a!==17);return r.join("")}e.stripComments=o;function u(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[105],x([0,1,39]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(h,d,i){let S,v,m,t,g;if(d){for(t=d.offset,g=t+d.length,m=t;m>0&&!E(h,m-1);)m--;let f=g;for(;f<h.length&&!E(h,f);)f++;v=h.substring(m,f),S=M(v,i)}else v=h,S=0,m=0,t=0,g=h.length;const b=P(i,h);let y=!1,I=0,c;i.insertSpaces?c=D(" ",i.tabSize||4):c="	";const o=(0,p.createScanner)(v,!1);let u=!1;function n(){return b+D(c,S+I)}function l(){let f=o.scan();for(y=!1;f===15||f===14;)y=y||f===14,f=o.scan();return u=f===16||o.getTokenError()!==0,f}const s=[];function r(f,w,k){!u&&w<g&&k>t&&h.substring(w,k)!==f&&s.push({offset:w,length:k-w,content:f})}let a=l();if(a!==17){const f=o.getTokenOffset()+m,w=D(c,S);r(w,m,f)}for(;a!==17;){let f=o.getTokenOffset()+o.getTokenLength()+m,w=l(),k="";for(;!y&&(w===12||w===13);){const A=o.getTokenOffset()+m;r(" ",f,A),f=o.getTokenOffset()+o.getTokenLength()+m,k=w===12?n():"",w=l()}if(w===2)a!==1&&(I--,k=n());else if(w===4)a!==3&&(I--,k=n());else{switch(a){case 3:case 1:I++,k=n();break;case 5:case 12:k=n();break;case 13:y?k=n():k=" ";break;case 6:k=" ";break;case 10:if(w===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?k=" ":w!==5&&w!==17&&(u=!0);break;case 16:u=!0;break}y&&(w===12||w===13)&&(k=n())}const R=o.getTokenOffset()+m;r(k,f,R),a=w}return s}e.format=L;function D(h,d){let i="";for(let S=0;S<d;S++)i+=h;return i}function M(h,d){let i=0,S=0;const v=d.tabSize||4;for(;i<h.length;){const m=h.charAt(i);if(m===" ")S++;else if(m==="	")S+=v;else break;i++}return Math.floor(S/v)}function P(h,d){for(let i=0;i<d.length;i++){const S=d.charAt(i);if(S==="\r")return i+1<d.length&&d.charAt(i+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=P;function E(h,d){return`\r
`.indexOf(h.charAt(d))!==-1}e.isEOL=E}),define(Z[79],x([0,1,39,105]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(d,i,S){return M(d,i,void 0,S)}e.removeProperty=D;function M(d,i,S,v,m){const t=i.slice(),g=[],b=(0,p.parseTree)(d,g);let y,I;for(;t.length>0&&(I=t.pop(),y=(0,p.findNodeAtLocation)(b,t),y===void 0&&S!==void 0);)typeof I=="string"?S={[I]:S}:S=[S];if(y)if(y.type==="object"&&typeof I=="string"&&Array.isArray(y.children)){const c=(0,p.findNodeAtLocation)(y,[I]);if(c!==void 0)if(S===void 0){if(!c.parent)throw new Error("Malformed AST");const o=y.children.indexOf(c.parent);let u,n=c.parent.offset+c.parent.length;if(o>0){const l=y.children[o-1];u=l.offset+l.length}else u=y.offset+1,y.children.length>1&&(n=y.children[1].offset);return P(d,{offset:u,length:n-u,content:""},v)}else return P(d,{offset:c.offset,length:c.length,content:JSON.stringify(S)},v);else{if(S===void 0)return[];const o=`${JSON.stringify(I)}: ${JSON.stringify(S)}`,u=m?m(y.children.map(l=>l.children[0].value)):y.children.length;let n;if(u>0){const l=y.children[u-1];n={offset:l.offset+l.length,length:0,content:","+o}}else y.children.length===0?n={offset:y.offset+1,length:0,content:o}:n={offset:y.offset+1,length:0,content:o+","};return P(d,n,v)}}else if(y.type==="array"&&typeof I=="number"&&Array.isArray(y.children))if(S!==void 0){const c=`${JSON.stringify(S)}`;let o;if(y.children.length===0||I===0)o={offset:y.offset+1,length:0,content:y.children.length===0?c:c+","};else{const u=I===-1||I>y.children.length?y.children.length:I,n=y.children[u-1];o={offset:n.offset+n.length,length:0,content:","+c}}return P(d,o,v)}else{const c=I,o=y.children[c];let u;if(y.children.length===1)u={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===c){const n=y.children[c-1],l=n.offset+n.length,s=y.offset+y.length;u={offset:l,length:s-2-l,content:""}}else u={offset:o.offset,length:y.children[c+1].offset-o.offset,content:""};return P(d,u,v)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${y.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return P(d,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(S)},v)}}e.setProperty=M;function P(d,i,S){let v=E(d,i),m=i.offset,t=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,L.isEOL)(v,m-1);)m--;for(;t<v.length&&!(0,L.isEOL)(v,t);)t++}const g=(0,L.format)(v,{offset:m,length:t-m},S);for(let y=g.length-1;y>=0;y--){const I=g[y];v=E(v,I),m=Math.min(m,I.offset),t=Math.max(t,I.offset+I.length),t+=I.content.length-I.length}const b=d.length-(v.length-t)-m;return[{offset:m,length:b,content:v.substring(m,t)}]}e.withFormatting=P;function E(d,i){return d.substring(0,i.offset)+i.content+d.substring(i.offset+i.length)}e.applyEdit=E;function h(d,i){let S=i.slice(0).sort((m,t)=>{const g=m.offset-t.offset;return g===0?m.length-t.length:g}),v=d.length;for(let m=S.length-1;m>=0;m--){let t=S[m];if(t.offset+t.length<=v)d=E(d,t);else throw new Error("Overlapping edit");v=t.offset}return d}e.applyEdits=h}),define(Z[80],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var L;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(L=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,b){this._keyCodeToStr[g]=b,this._strToKeyCode[b.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const M=new D,P=new D,E=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],d=Object.create(null),i=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>i[t]||0,toEnum:t=>d[t]||0,toString:t=>h[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let b=[],y=[];for(const I of g){const[c,o,u,n,l,s,r,a,f,w]=I;if(y[u]||(y[u]=!0,h[u]=n,d[n]=u,i[n.toLowerCase()]=u,o&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[l]=u))),!b[l]){if(b[l]=!0,!s)throw new Error(`String representation missing for key code ${l} around scan code ${n}`);M.define(l,s),P.define(l,f||s),E.define(l,w||f||s)}r&&(e.EVENT_KEY_CODE_MAP[r]=l),a&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[a]=l)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var S;(function(t){function g(u){return M.keyCodeToStr(u)}t.toString=g;function b(u){return M.strToKeyCode(u)}t.fromString=b;function y(u){return P.keyCodeToStr(u)}t.toUserSettingsUS=y;function I(u){return E.keyCodeToStr(u)}t.toUserSettingsGeneral=I;function c(u){return P.strToKeyCode(u)||E.strToKeyCode(u)}t.fromUserSettings=c;function o(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(u)}t.toElectronAccelerator=o})(S=e.KeyCodeUtils||(e.KeyCodeUtils={}));var v;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(v=e.KeyMod||(e.KeyMod={}));function m(t,g){const b=(g&65535)<<16>>>0;return(t|b)>>>0}e.KeyChord=m}),define(Z[59],x([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var L;(function(S){S[S.CtrlCmd=2048]="CtrlCmd",S[S.Shift=1024]="Shift",S[S.Alt=512]="Alt",S[S.WinCtrl=256]="WinCtrl",S[S.KeyCode=255]="KeyCode"})(L||(L={}));function D(S,v){if(S===0)return null;const m=(S&65535)>>>0,t=(S&4294901760)>>>16;return t!==0?new E([M(m,v),M(t,v)]):new E([M(m,v)])}e.createKeybinding=D;function M(S,v){const m=!!(S&2048),t=!!(S&256),g=v===2?t:m,b=!!(S&1024),y=!!(S&512),I=v===2?m:t,c=S&255;return new P(g,b,y,I,c)}e.createSimpleKeybinding=M;class P{constructor(v,m,t,g,b){this.ctrlKey=v,this.shiftKey=m,this.altKey=t,this.metaKey=g,this.keyCode=b}equals(v){return this.ctrlKey===v.ctrlKey&&this.shiftKey===v.shiftKey&&this.altKey===v.altKey&&this.metaKey===v.metaKey&&this.keyCode===v.keyCode}getHashCode(){const v=this.ctrlKey?"1":"0",m=this.shiftKey?"1":"0",t=this.altKey?"1":"0",g=this.metaKey?"1":"0";return`${v}${m}${t}${g}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new E([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=P;class E{constructor(v){if(v.length===0)throw(0,p.illegalArgument)("parts");this.parts=v}getHashCode(){let v="";for(let m=0,t=this.parts.length;m<t;m++)m!==0&&(v+=";"),v+=this.parts[m].getHashCode();return v}equals(v){if(v===null||this.parts.length!==v.parts.length)return!1;for(let m=0;m<this.parts.length;m++)if(!this.parts[m].equals(v.parts[m]))return!1;return!0}}e.ChordKeybinding=E;class h{constructor(v,m,t,g,b){this.ctrlKey=v,this.shiftKey=m,this.altKey=t,this.metaKey=g,this.scanCode=b}equals(v){return this.ctrlKey===v.ctrlKey&&this.shiftKey===v.shiftKey&&this.altKey===v.altKey&&this.metaKey===v.metaKey&&this.scanCode===v.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=h;class d{constructor(v,m,t,g,b,y){this.ctrlKey=v,this.shiftKey=m,this.altKey=t,this.metaKey=g,this.keyLabel=b,this.keyAriaLabel=y}}e.ResolvedKeybindingPart=d;class i{}e.ResolvedKeybinding=i}),define(Z[106],x([0,1,80,59]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(P){P=P.toLowerCase().trim();let E=!1,h=!1,d=!1,i=!1,S;do S=!1,/^ctrl(\+|\-)/.test(P)&&(E=!0,P=P.substr("ctrl-".length),S=!0),/^shift(\+|\-)/.test(P)&&(h=!0,P=P.substr("shift-".length),S=!0),/^alt(\+|\-)/.test(P)&&(d=!0,P=P.substr("alt-".length),S=!0),/^meta(\+|\-)/.test(P)&&(i=!0,P=P.substr("meta-".length),S=!0),/^win(\+|\-)/.test(P)&&(i=!0,P=P.substr("win-".length),S=!0),/^cmd(\+|\-)/.test(P)&&(i=!0,P=P.substr("cmd-".length),S=!0);while(S);let v;const m=P.indexOf(" ");return m>0?(v=P.substring(0,m),P=P.substring(m)):(v=P,P=""),{remains:P,ctrl:E,shift:h,alt:d,meta:i,key:v}}static parseSimpleKeybinding(P){const E=this._readModifiers(P),h=p.KeyCodeUtils.fromUserSettings(E.key);return[new L.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,h),E.remains]}static parseKeybinding(P,E){if(!P)return null;const h=[];let d;do[d,P]=this.parseSimpleKeybinding(P),h.push(d);while(P.length>0);return new L.ChordKeybinding(h)}static parseSimpleUserBinding(P){const E=this._readModifiers(P),h=E.key.match(/^\[([^\]]+)\]$/);if(h){const i=h[1],S=p.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(E.ctrl,E.shift,E.alt,E.meta,S),E.remains]}const d=p.KeyCodeUtils.fromUserSettings(E.key);return[new L.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,d),E.remains]}static parseUserBinding(P){if(!P)return[];const E=[];let h;for(;P.length>0;)[h,P]=this.parseSimpleUserBinding(P),E.push(h);return E}}e.KeybindingParser=D}),define(Z[2],x([0,1,42,68]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let M=null;function P(r){M=r}if(e.setDisposableTracker=P,D){const r="__is_disposable_tracked__";P(new class{trackDisposable(a){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(f)},3e3)}setParent(a,f){if(a&&a!==I.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==I.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function E(r){return M?.trackDisposable(r),r}function h(r){M?.markAsDisposed(r)}function d(r,a){M?.setParent(r,a)}function i(r,a){if(!!M)for(const f of r)M.setParent(f,a)}function S(r){return M?.markAsSingleton(r),r}e.markAsSingleton=S;class v extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=v;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=m;function t(r){if(L.Iterable.is(r)){let a=[];for(const f of r)if(f)try{f.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new v(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function g(...r){const a=b(()=>t(r));return i(r,a),a}e.combinedDisposable=g;function b(r){const a=E({dispose:(0,p.once)(()=>{h(a),r()})});return a}e.toDisposable=b;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return d(a,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new y,E(this),d(this._store,this)}dispose(){h(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&d(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&d(a,null),a}}e.MutableDisposable=c;class o{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class u{constructor(){this.references=new Map}acquire(a,...f){let w=this.references.get(a);w||(w={counter:0,object:this.createReferencedObject(a,...f)},this.references.set(a,w));const{object:k}=w,R=(0,p.once)(()=>{--w.counter==0&&(this.destroyReferencedObject(a,w.object),this.references.delete(a))});return w.counter++,{object:k,dispose:R}}}e.ReferenceCollection=u;class n{constructor(a){this.referenceCollection=a}async acquire(a,...f){const w=this.referenceCollection.acquire(a,...f);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(k){throw w.dispose(),k}}}e.AsyncReferenceCollection=n;class l{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=l;function s(r){const a=new y;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=s}),define(Z[107],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(M){this.element=M,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let M=this._first;for(;M!==p.Undefined;){const P=M.next;M.prev=p.Undefined,M.next=p.Undefined,M=P}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,P){const E=new p(M);if(this._first===p.Undefined)this._first=E,this._last=E;else if(P){const d=this._last;this._last=E,E.prev=d,d.next=E}else{const d=this._first;this._first=E,E.next=d,d.prev=E}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(E))}}shift(){if(this._first!==p.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==p.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==p.Undefined&&M.next!==p.Undefined){const P=M.prev;P.next=M.next,M.next.prev=P}else M.prev===p.Undefined&&M.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):M.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):M.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==p.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function j(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function P(h){M.push(h,Date.now())}function E(){const h=[];for(let d=0;d<M.length;d+=2)h.push({name:M[d],startTime:M[d+1]});return h}return{mark:P,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(D+P.startTime)});return M}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Z[3],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,D=!1,M=!1,P=!1,E=!1,h=!1,d=!1,i,S=p,v,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const g=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=g&&t?.sandboxed,typeof navigator=="object"&&!g)m=navigator.userAgent,L=m.indexOf("Windows")>=0,D=m.indexOf("Macintosh")>=0,d=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,h=!0,i=navigator.language,S=i;else if(typeof t=="object"){L=t.platform==="win32",D=t.platform==="darwin",M=t.platform==="linux",P=M&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,i=p,S=p;const s=t.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),a=r.availableLanguages["*"];i=r.locale,S=a||p,v=r._translationsConfigFile}catch(r){}E=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let I=0;D?I=1:L?I=3:M&&(I=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=M,e.isLinuxSnap=P,e.isNative=E,e.isWeb=h,e.isIOS=d,e.platform=I,e.userAgent=m,e.language=S;var c;(function(s){function r(){return e.language}s.value=r;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=a;function f(){return e.language==="en"}s.isDefault=f})(c=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let k=0,R=a.length;k<R;k++){const A=a[k];if(A.id===w.data.vscodeSetImmediateId){a.splice(k,1),A.callback();return}}});let f=0;return w=>{const k=++f;a.push({id:k,callback:w}),e.globals.postMessage({vscodeSetImmediateId:k},"*")}}if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const r=Promise.resolve();return a=>r.then(a)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||d?2:L?1:3;let u=!0,n=!1;function l(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=l}),define(Z[32],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(M){return(0,p.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,p.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,32]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,M=90,P=122,E=46,h=47,d=92,i=58,S=63;class v extends Error{constructor(o,u,n){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const s=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${s} ${l} of type ${u}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,o){if(typeof c!="string")throw new v(o,"string",c)}function t(c){return c===h||c===d}function g(c){return c===h}function b(c){return c>=L&&c<=M||c>=D&&c<=P}function y(c,o,u,n){let l="",s=0,r=-1,a=0,f=0;for(let w=0;w<=c.length;++w){if(w<c.length)f=c.charCodeAt(w);else{if(n(f))break;f=h}if(n(f)){if(!(r===w-1||a===1))if(a===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==E||l.charCodeAt(l.length-2)!==E){if(l.length>2){const k=l.lastIndexOf(u);k===-1?(l="",s=0):(l=l.slice(0,k),s=l.length-1-l.lastIndexOf(u)),r=w,a=0;continue}else if(l.length!==0){l="",s=0,r=w,a=0;continue}}o&&(l+=l.length>0?`${u}..`:"..",s=2)}else l.length>0?l+=`${u}${c.slice(r+1,w)}`:l=c.slice(r+1,w),s=w-r-1;r=w,a=0}else f===E&&a!==-1?++a:a=-1}return l}function I(c,o){if(o===null||typeof o!="object")throw new v("pathObject","Object",o);const u=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${n}`:`${u}${c}${n}`:n}e.win32={resolve(...c){let o="",u="",n=!1;for(let l=c.length-1;l>=-1;l--){let s;if(l>=0){if(s=c[l],m(s,"path"),s.length===0)continue}else o.length===0?s=p.cwd():(s=p.env[`=${o}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===d)&&(s=`${o}\\`));const r=s.length;let a=0,f="",w=!1;const k=s.charCodeAt(0);if(r===1)t(k)&&(a=1,w=!0);else if(t(k))if(w=!0,t(s.charCodeAt(1))){let R=2,A=R;for(;R<r&&!t(s.charCodeAt(R));)R++;if(R<r&&R!==A){const F=s.slice(A,R);for(A=R;R<r&&t(s.charCodeAt(R));)R++;if(R<r&&R!==A){for(A=R;R<r&&!t(s.charCodeAt(R));)R++;(R===r||R!==A)&&(f=`\\\\${F}\\${s.slice(A,R)}`,a=R)}}}else a=1;else b(k)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),a=2,r>2&&t(s.charCodeAt(2))&&(w=!0,a=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(n){if(o.length>0)break}else if(u=`${s.slice(a)}\\${u}`,n=w,w&&o.length>0)break}return u=y(u,!n,"\\",t),n?`${o}\\${u}`:`${o}${u}`||"."},normalize(c){m(c,"path");const o=c.length;if(o===0)return".";let u=0,n,l=!1;const s=c.charCodeAt(0);if(o===1)return g(s)?"\\":c;if(t(s))if(l=!0,t(c.charCodeAt(1))){let a=2,f=a;for(;a<o&&!t(c.charCodeAt(a));)a++;if(a<o&&a!==f){const w=c.slice(f,a);for(f=a;a<o&&t(c.charCodeAt(a));)a++;if(a<o&&a!==f){for(f=a;a<o&&!t(c.charCodeAt(a));)a++;if(a===o)return`\\\\${w}\\${c.slice(f)}\\`;a!==f&&(n=`\\\\${w}\\${c.slice(f,a)}`,u=a)}}}else u=1;else b(s)&&c.charCodeAt(1)===i&&(n=c.slice(0,2),u=2,o>2&&t(c.charCodeAt(2))&&(l=!0,u=3));let r=u<o?y(c.slice(u),!l,"\\",t):"";return r.length===0&&!l&&(r="."),r.length>0&&t(c.charCodeAt(o-1))&&(r+="\\"),n===void 0?l?`\\${r}`:r:l?`${n}\\${r}`:`${n}${r}`},isAbsolute(c){m(c,"path");const o=c.length;if(o===0)return!1;const u=c.charCodeAt(0);return t(u)||o>2&&b(u)&&c.charCodeAt(1)===i&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let o,u;for(let s=0;s<c.length;++s){const r=c[s];m(r,"path"),r.length>0&&(o===void 0?o=u=r:o+=`\\${r}`)}if(o===void 0)return".";let n=!0,l=0;if(typeof u=="string"&&t(u.charCodeAt(0))){++l;const s=u.length;s>1&&t(u.charCodeAt(1))&&(++l,s>2&&(t(u.charCodeAt(2))?++l:n=!1))}if(n){for(;l<o.length&&t(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(c,o){if(m(c,"from"),m(o,"to"),c===o)return"";const u=e.win32.resolve(c),n=e.win32.resolve(o);if(u===n||(c=u.toLowerCase(),o=n.toLowerCase(),c===o))return"";let l=0;for(;l<c.length&&c.charCodeAt(l)===d;)l++;let s=c.length;for(;s-1>l&&c.charCodeAt(s-1)===d;)s--;const r=s-l;let a=0;for(;a<o.length&&o.charCodeAt(a)===d;)a++;let f=o.length;for(;f-1>a&&o.charCodeAt(f-1)===d;)f--;const w=f-a,k=r<w?r:w;let R=-1,A=0;for(;A<k;A++){const H=c.charCodeAt(l+A);if(H!==o.charCodeAt(a+A))break;H===d&&(R=A)}if(A!==k){if(R===-1)return n}else{if(w>k){if(o.charCodeAt(a+A)===d)return n.slice(a+A+1);if(A===2)return n.slice(a+A)}r>k&&(c.charCodeAt(l+A)===d?R=A:A===2&&(R=3)),R===-1&&(R=0)}let F="";for(A=l+R+1;A<=s;++A)(A===s||c.charCodeAt(A)===d)&&(F+=F.length===0?"..":"\\..");return a+=R,F.length>0?`${F}${n.slice(a,f)}`:(n.charCodeAt(a)===d&&++a,n.slice(a,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const o=e.win32.resolve(c);if(o.length<=2)return c;if(o.charCodeAt(0)===d){if(o.charCodeAt(1)===d){const u=o.charCodeAt(2);if(u!==S&&u!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===d)return`\\\\?\\${o}`;return c},dirname(c){m(c,"path");const o=c.length;if(o===0)return".";let u=-1,n=0;const l=c.charCodeAt(0);if(o===1)return t(l)?c:".";if(t(l)){if(u=n=1,t(c.charCodeAt(1))){let a=2,f=a;for(;a<o&&!t(c.charCodeAt(a));)a++;if(a<o&&a!==f){for(f=a;a<o&&t(c.charCodeAt(a));)a++;if(a<o&&a!==f){for(f=a;a<o&&!t(c.charCodeAt(a));)a++;if(a===o)return c;a!==f&&(u=n=a+1)}}}}else b(l)&&c.charCodeAt(1)===i&&(u=o>2&&t(c.charCodeAt(2))?3:2,n=u);let s=-1,r=!0;for(let a=o-1;a>=n;--a)if(t(c.charCodeAt(a))){if(!r){s=a;break}}else r=!1;if(s===-1){if(u===-1)return".";s=u}return c.slice(0,s)},basename(c,o){o!==void 0&&m(o,"ext"),m(c,"path");let u=0,n=-1,l=!0,s;if(c.length>=2&&b(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(u=2),o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let r=o.length-1,a=-1;for(s=c.length-1;s>=u;--s){const f=c.charCodeAt(s);if(t(f)){if(!l){u=s+1;break}}else a===-1&&(l=!1,a=s+1),r>=0&&(f===o.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=a))}return u===n?n=a:n===-1&&(n=c.length),c.slice(u,n)}for(s=c.length-1;s>=u;--s)if(t(c.charCodeAt(s))){if(!l){u=s+1;break}}else n===-1&&(l=!1,n=s+1);return n===-1?"":c.slice(u,n)},extname(c){m(c,"path");let o=0,u=-1,n=0,l=-1,s=!0,r=0;c.length>=2&&c.charCodeAt(1)===i&&b(c.charCodeAt(0))&&(o=n=2);for(let a=c.length-1;a>=o;--a){const f=c.charCodeAt(a);if(t(f)){if(!s){n=a+1;break}continue}l===-1&&(s=!1,l=a+1),f===E?u===-1?u=a:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||l===-1||r===0||r===1&&u===l-1&&u===n+1?"":c.slice(u,l)},format:I.bind(null,"\\"),parse(c){m(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const u=c.length;let n=0,l=c.charCodeAt(0);if(u===1)return t(l)?(o.root=o.dir=c,o):(o.base=o.name=c,o);if(t(l)){if(n=1,t(c.charCodeAt(1))){let R=2,A=R;for(;R<u&&!t(c.charCodeAt(R));)R++;if(R<u&&R!==A){for(A=R;R<u&&t(c.charCodeAt(R));)R++;if(R<u&&R!==A){for(A=R;R<u&&!t(c.charCodeAt(R));)R++;R===u?n=R:R!==A&&(n=R+1)}}}}else if(b(l)&&c.charCodeAt(1)===i){if(u<=2)return o.root=o.dir=c,o;if(n=2,t(c.charCodeAt(2))){if(u===3)return o.root=o.dir=c,o;n=3}}n>0&&(o.root=c.slice(0,n));let s=-1,r=n,a=-1,f=!0,w=c.length-1,k=0;for(;w>=n;--w){if(l=c.charCodeAt(w),t(l)){if(!f){r=w+1;break}continue}a===-1&&(f=!1,a=w+1),l===E?s===-1?s=w:k!==1&&(k=1):s!==-1&&(k=-1)}return a!==-1&&(s===-1||k===0||k===1&&s===a-1&&s===r+1?o.base=o.name=c.slice(r,a):(o.name=c.slice(r,s),o.base=c.slice(r,a),o.ext=c.slice(s,a))),r>0&&r!==n?o.dir=c.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let o="",u=!1;for(let n=c.length-1;n>=-1&&!u;n--){const l=n>=0?c[n]:p.cwd();m(l,"path"),l.length!==0&&(o=`${l}/${o}`,u=l.charCodeAt(0)===h)}return o=y(o,!u,"/",g),u?`/${o}`:o.length>0?o:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===h,u=c.charCodeAt(c.length-1)===h;return c=y(c,!o,"/",g),c.length===0?o?"/":u?"./":".":(u&&(c+="/"),o?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===h},join(...c){if(c.length===0)return".";let o;for(let u=0;u<c.length;++u){const n=c[u];m(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(c,o){if(m(c,"from"),m(o,"to"),c===o||(c=e.posix.resolve(c),o=e.posix.resolve(o),c===o))return"";const u=1,n=c.length,l=n-u,s=1,r=o.length-s,a=l<r?l:r;let f=-1,w=0;for(;w<a;w++){const R=c.charCodeAt(u+w);if(R!==o.charCodeAt(s+w))break;R===h&&(f=w)}if(w===a)if(r>a){if(o.charCodeAt(s+w)===h)return o.slice(s+w+1);if(w===0)return o.slice(s+w)}else l>a&&(c.charCodeAt(u+w)===h?f=w:w===0&&(f=0));let k="";for(w=u+f+1;w<=n;++w)(w===n||c.charCodeAt(w)===h)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(s+f)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===h;let u=-1,n=!0;for(let l=c.length-1;l>=1;--l)if(c.charCodeAt(l)===h){if(!n){u=l;break}}else n=!1;return u===-1?o?"/":".":o&&u===1?"//":c.slice(0,u)},basename(c,o){o!==void 0&&m(o,"ext"),m(c,"path");let u=0,n=-1,l=!0,s;if(o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let r=o.length-1,a=-1;for(s=c.length-1;s>=0;--s){const f=c.charCodeAt(s);if(f===h){if(!l){u=s+1;break}}else a===-1&&(l=!1,a=s+1),r>=0&&(f===o.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=a))}return u===n?n=a:n===-1&&(n=c.length),c.slice(u,n)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===h){if(!l){u=s+1;break}}else n===-1&&(l=!1,n=s+1);return n===-1?"":c.slice(u,n)},extname(c){m(c,"path");let o=-1,u=0,n=-1,l=!0,s=0;for(let r=c.length-1;r>=0;--r){const a=c.charCodeAt(r);if(a===h){if(!l){u=r+1;break}continue}n===-1&&(l=!1,n=r+1),a===E?o===-1?o=r:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||n===-1||s===0||s===1&&o===n-1&&o===u+1?"":c.slice(o,n)},format:I.bind(null,"/"),parse(c){m(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const u=c.charCodeAt(0)===h;let n;u?(o.root="/",n=1):n=0;let l=-1,s=0,r=-1,a=!0,f=c.length-1,w=0;for(;f>=n;--f){const k=c.charCodeAt(f);if(k===h){if(!a){s=f+1;break}continue}r===-1&&(a=!1,r=f+1),k===E?l===-1?l=f:w!==1&&(w=1):l!==-1&&(w=-1)}if(r!==-1){const k=s===0&&u?1:s;l===-1||w===0||w===1&&l===r-1&&l===s+1?o.base=o.name=c.slice(k,r):(o.name=c.slice(k,l),o.base=c.slice(k,r),o.ext=c.slice(l,r))}return s>0?o.dir=c.slice(0,s-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[81],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(M,...P){const E=P.reduce((i,S)=>(i[S]=!0,i),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(i=>!E[i]).forEach(i=>{for(let S=0;S<h.length;S++)if(i.search(h[S])!==-1){delete M[i];break}})}e.sanitizeProcessEnvironment=D}),define(Z[108],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(P){this._highResolution=L&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Z[4],x([0,1,16,42,2,107,108]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(o){o.None=()=>D.Disposable.None;function u(T){return(V,U=null,B)=>{let N=!1,_;return _=T(X=>{if(!N)return _?_.dispose():N=!0,V.call(U,X)},null,B),N&&_.dispose(),_}}o.once=u;function n(T,V){return w((U,B=null,N)=>T(_=>U.call(B,V(_)),null,N))}o.map=n;function l(T,V){return w((U,B=null,N)=>T(_=>{V(_),U.call(B,_)},null,N))}o.forEach=l;function s(T,V){return w((U,B=null,N)=>T(_=>V(_)&&U.call(B,_),null,N))}o.filter=s;function r(T){return T}o.signal=r;function a(...T){return(V,U=null,B)=>(0,D.combinedDisposable)(...T.map(N=>N(_=>V.call(U,_),null,B)))}o.any=a;function f(T,V,U){let B=U;return n(T,N=>(B=V(B,N),B))}o.reduce=f;function w(T){let V;const U=new v({onFirstListenerAdd(){V=T(U.fire,U)},onLastListenerRemove(){V.dispose()}});return U.event}function k(T,V,U=100,B=!1,N){let _,X,W,z=0;const K=new v({leakWarningThreshold:N,onFirstListenerAdd(){_=T(O=>{z++,X=V(X,O),B&&!W&&(K.fire(X),X=void 0),clearTimeout(W),W=setTimeout(()=>{const q=X;X=void 0,W=void 0,(!B||z>1)&&K.fire(q),z=0},U)})},onLastListenerRemove(){_.dispose()}});return K.event}o.debounce=k;function R(T,V=(U,B)=>U===B){let U=!0,B;return s(T,N=>{const _=U||!V(N,B);return U=!1,B=N,_})}o.latch=R;function A(T,V){return[o.filter(T,V),o.filter(T,U=>!V(U))]}o.split=A;function F(T,V=!1,U=[]){let B=U.slice(),N=T(W=>{B?B.push(W):X.fire(W)});const _=()=>{B&&B.forEach(W=>X.fire(W)),B=null},X=new v({onFirstListenerAdd(){N||(N=T(W=>X.fire(W)))},onFirstListenerDidAdd(){B&&(V?setTimeout(_):_())},onLastListenerRemove(){N&&N.dispose(),N=null}});return X.event}o.buffer=F;class H{constructor(V){this.event=V}map(V){return new H(n(this.event,V))}forEach(V){return new H(l(this.event,V))}filter(V){return new H(s(this.event,V))}reduce(V,U){return new H(f(this.event,V,U))}latch(){return new H(R(this.event))}debounce(V,U=100,B=!1,N){return new H(k(this.event,V,U,B,N))}on(V,U,B){return this.event(V,U,B)}once(V,U,B){return u(this.event)(V,U,B)}}function ie(T){return new H(T)}o.chain=ie;function re(T,V,U=B=>B){const B=(...W)=>X.fire(U(...W)),N=()=>T.on(V,B),_=()=>T.removeListener(V,B),X=new v({onFirstListenerAdd:N,onLastListenerRemove:_});return X.event}o.fromNodeEventEmitter=re;function G(T,V,U=B=>B){const B=(...W)=>X.fire(U(...W)),N=()=>T.addEventListener(V,B),_=()=>T.removeEventListener(V,B),X=new v({onFirstListenerAdd:N,onLastListenerRemove:_});return X.event}o.fromDOMEventEmitter=G;function ee(T){return new Promise(V=>u(T)(V))}o.toPromise=ee})(E=e.Event||(e.Event={}));class h{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${h._idPool++}`}start(u){this._stopWatch=new P.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let d=-1;function i(o){const u=d;return d=o,{dispose(){d=u}}}e.setGlobalLeakWarningThreshold=i;class S{constructor(u,n=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let n=d;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||u<n)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let r,a=0;for(const[f,w]of this._stacks)(!r||a<w)&&(r=f,a=w);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(l)||0;this._stacks.set(l,r-1)}}}class v{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=d>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(u,n,l)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(n?[u,n]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,n);const a=this._leakageMon?.check(this._listeners.size),f=(0,D.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof D.DisposableStore?l.add(f):Array.isArray(l)&&l.push(f),f}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,l]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,l):n[0].call(n[1],l)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=v;class m extends v{async fireAsync(u,n,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),a=[],f={...r,waitUntil:w=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");l&&(w=l(w,typeof s=="function"?s:s[0])),a.push(w)}};try{typeof s=="function"?s.call(void 0,f):s[0].call(s[1],f)}catch(w){(0,p.onUnexpectedError)(w);continue}Object.freeze(a),await Promise.allSettled(a).then(w=>{for(const k of w)k.status==="rejected"&&(0,p.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=m;class t extends v{constructor(u){super(u);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=t;class g extends t{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=g;class b extends v{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const n={event:u,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const l=()=>{this.hasListeners&&this.unhook(n);const s=this.events.indexOf(n);this.events.splice(s,1)};return(0,D.toDisposable)((0,L.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(n=>this.emitter.fire(n))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=y;class I{constructor(){this.buffers=[]}wrapEvent(u){return(n,l,s)=>u(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>n.call(l,r)):n.call(l,r)},void 0,s)}bufferEvents(u){const n=[];this.buffers.push(n);const l=u();return this.buffers.pop(),n.forEach(s=>s()),l}}e.EventBufferer=I;class c{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=D.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Z[23],x([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(E,h){const d=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(d)}}});var D;(function(E){function h(d){return d===E.None||d===E.Cancelled||d instanceof M?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=D.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(Z[109],x([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(S){const v=this._icons.get(S.id);v?S.description?v.description=S.description:console.error(`Duplicate registration of codicon ${S.id}`):(this._icons.set(S.id,S),this._onDidRegister.fire(S))}get(S){return this._icons.get(S)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function M(i,S){return new E(i,S)}e.registerCodicon=M;function P(i){return i?i.replace(/\$\((.*?)\)/g,(S,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=P;class E{constructor(S,v,m){this.id=S,this.definition=v,this.description=m,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function h(i,S){const v=["codicon","codicon-"+i];return S&&v.push("codicon-modifier-"+S),v}e.getClassNamesArray=h;var d;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const S=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function v(g){if(g instanceof E)return["codicon","codicon-"+g.id];const b=S.exec(g.id);if(!b)return v(E.error);let[,y,I]=b;const c=["codicon","codicon-"+y];return I&&c.push("codicon-modifier-"+I.substr(1)),c}i.asClassNameArray=v;function m(g){return v(g).join(" ")}i.asClassName=m;function t(g){return"."+v(g).join(".")}i.asCSSSelector=t})(d=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(E=e.Codicon||(e.Codicon={}))}),define(Z[60],x([0,1,16,2]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const o=c;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function M(c){const o=c;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function P(c,o){return new E(c,o)}e.newWriteableStream=P;class E{constructor(o,u){this.reducer=o,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(u=>u(o))}emitError(o){this.listeners.error.length===0?(0,p.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(u=>u(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,u){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(o,u){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const l=n.indexOf(u);l>=0&&n.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(c,o){const u=[];let n;for(;(n=c.read())!==null;)u.push(n);return o(u)}e.consumeReadable=h;function d(c,o,u){const n=[];let l;for(;(l=c.read())!==null&&n.length<u;)n.push(l);return l===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return c.read()}}}e.peekReadable=d;function i(c,o){return new Promise((u,n)=>{const l=[];S(c,{onData:s=>{o&&l.push(s)},onError:s=>{o?n(s):u(void 0)},onEnd:()=>{u(o?o(l):void 0)}})})}e.consumeStream=i;function S(c,o){c.on("error",u=>o.onError(u)),c.on("end",()=>o.onEnd()),c.on("data",u=>o.onData(u))}e.listenStream=S;function v(c,o){return new Promise((u,n)=>{const l=new L.DisposableStore,s=[],r=w=>{if(s.push(w),s.length>o)return l.dispose(),c.pause(),u({stream:c,buffer:s,ended:!1})},a=w=>n(w),f=()=>u({stream:c,buffer:s,ended:!0});l.add((0,L.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),l.add((0,L.toDisposable)(()=>c.removeListener("end",f))),c.on("end",f),l.add((0,L.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=v;function m(c,o){const u=P(o);return u.end(c),u}e.toStream=m;function t(){const c=P(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function g(c){let o=!1;return{read:()=>o?null:(o=!0,c)}}e.toReadable=g;function b(c,o,u){const n=P(u);return S(c,{onData:l=>n.write(o.data(l)),onError:l=>n.error(o.error?o.error(l):l),onEnd:()=>n.end()}),n}e.transform=b;function y(c,o,u){let n=!1;return{read:()=>{const l=o.read();return n?l:(n=!0,l!==null?u([c,l]):c)}}}e.prefixedReadable=y;function I(c,o,u){let n=!1;const l=P(u);return S(o,{onData:s=>n?l.write(s):(n=!0,l.write(u([c,s]))),onError:s=>l.error(s),onEnd:()=>{n||(n=!0,l.write(c)),l.end()}}),l}e.prefixedStream=I}),define(Z[17],x([0,1,60]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,M;class P{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new P(Buffer.allocUnsafe(r)):new P(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new P(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(r)):(D||(D=new TextEncoder),new P(D.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let k=0,R=r.length;k<R;k++)a+=r[k].byteLength}const f=P.alloc(a);let w=0;for(let k=0,R=r.length;k<R;k++){const A=r[k];f.set(A,w),w+=A.byteLength}return f}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(r,a){return new P(this.buffer.subarray(r,a))}set(r,a){r instanceof P?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,a){i(this.buffer,r,a)}readUInt32LE(r){return S(this.buffer,r)}writeUInt32LE(r,a){v(this.buffer,r,a)}readUInt8(r){return m(this.buffer,r)}writeUInt8(r,a){t(this.buffer,r,a)}}e.VSBuffer=P;function E(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=E;function h(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255}e.writeUInt16LE=h;function d(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=d;function i(s,r,a){s[a+3]=r,r=r>>>8,s[a+2]=r,r=r>>>8,s[a+1]=r,r=r>>>8,s[a]=r}e.writeUInt32BE=i;function S(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=S;function v(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255,r=r>>>8,s[a+2]=r&255,r=r>>>8,s[a+3]=r&255}e.writeUInt32LE=v;function m(s,r){return s[r]}e.readUInt8=m;function t(s,r,a){s[a]=r}e.writeUInt8=t;function g(s){return p.consumeReadable(s,r=>P.concat(r))}e.readableToBuffer=g;function b(s){return p.toReadable(s)}e.bufferToReadable=b;function y(s){return p.consumeStream(s,r=>P.concat(r))}e.streamToBuffer=y;async function I(s){return s.ended?P.concat(s.buffer):P.concat([...s.buffer,await y(s.stream)])}e.bufferedStreamToBuffer=I;function c(s){return p.toStream(s,r=>P.concat(r))}e.bufferToStream=c;function o(s){return p.transform(s,{data:r=>typeof r=="string"?P.fromString(r):P.wrap(r)},r=>P.concat(r))}e.streamToBufferReadableStream=o;function u(s){return p.newWriteableStream(r=>P.concat(r),s)}e.newWriteableBufferStream=u;function n(s,r){return p.prefixedReadable(s,r,a=>P.concat(a))}e.prefixedBufferReadable=n;function l(s,r){return p.prefixedStream(s,r,a=>P.concat(a))}e.prefixedBufferStream=l}),define(Z[25],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function D(Y,...ae){return ae.length===0?Y:Y.replace(L,function(ue,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=ae.length?ue:ae[be]})}e.format=D;const M=/{([^}]+)}/g;function P(Y,ae){return Y.replace(M,(ue,me)=>ae[me]??ue)}e.format2=P;function E(Y){return Y.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=E;function h(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=h;function d(Y,ae){let ue=0;const me=ae.charCodeAt(0);for(let be=Y.length-1;be>=0;be--)Y.charCodeAt(be)===me&&ue++;return ue}e.count=d;function i(Y,ae,ue="\u2026"){return Y.length<=ae?Y:`${Y.substr(0,ae)}${ue}`}e.truncate=i;function S(Y,ae=" "){const ue=v(Y,ae);return m(ue,ae)}e.trim=S;function v(Y,ae){if(!Y||!ae)return Y;const ue=ae.length;if(ue===0||Y.length===0)return Y;let me=0;for(;Y.indexOf(ae,me)===me;)me=me+ue;return Y.substring(me)}e.ltrim=v;function m(Y,ae){if(!Y||!ae)return Y;const ue=ae.length,me=Y.length;if(ue===0||me===0)return Y;let be=me,Te=-1;for(;Te=Y.lastIndexOf(ae,be-1),!(Te===-1||Te+ue!==be);){if(Te===0)return"";be=Te}return Y.substring(0,be)}e.rtrim=m;function t(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=t;function g(Y){return Y.replace(/\*/g,"")}e.stripWildcards=g;function b(Y,ae,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");ae||(Y=h(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(Y,me)}e.createRegExp=b;function y(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function I(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function c(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=c;function o(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=o;function u(Y){for(let ae=0,ue=Y.length;ae<ue;ae++){const me=Y.charCodeAt(ae);if(me!==32&&me!==9)return ae}return-1}e.firstNonWhitespaceIndex=u;function n(Y,ae=0,ue=Y.length){for(let me=ae;me<ue;me++){const be=Y.charCodeAt(me);if(be!==32&&be!==9)return Y.substring(ae,me)}return Y.substring(ae,ue)}e.getLeadingWhitespace=n;function l(Y,ae=Y.length-1){for(let ue=ae;ue>=0;ue--){const me=Y.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=l;function s(Y,ae){return Y<ae?-1:Y>ae?1:0}e.compare=s;function r(Y,ae,ue=0,me=Y.length,be=0,Te=ae.length){for(;ue<me&&be<Te;ue++,be++){let Be=Y.charCodeAt(ue),Ce=ae.charCodeAt(be);if(Be<Ce)return-1;if(Be>Ce)return 1}const _e=me-ue,Ue=Te-be;return _e<Ue?-1:_e>Ue?1:0}e.compareSubstring=r;function a(Y,ae){return f(Y,ae,0,Y.length,0,ae.length)}e.compareIgnoreCase=a;function f(Y,ae,ue=0,me=Y.length,be=0,Te=ae.length){for(;ue<me&&be<Te;ue++,be++){let Be=Y.charCodeAt(ue),Ce=ae.charCodeAt(be);if(Be===Ce)continue;if(Be>=128||Ce>=128)return r(Y.toLowerCase(),ae.toLowerCase(),ue,me,be,Te);w(Be)&&(Be-=32),w(Ce)&&(Ce-=32);const ze=Be-Ce;if(ze!==0)return ze}const _e=me-ue,Ue=Te-be;return _e<Ue?-1:_e>Ue?1:0}e.compareSubstringIgnoreCase=f;function w(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=w;function k(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=k;function R(Y,ae){return Y.length===ae.length&&f(Y,ae)===0}e.equalsIgnoreCase=R;function A(Y,ae){const ue=ae.length;return ae.length>Y.length?!1:f(Y,ae,0,ue)===0}e.startsWithIgnoreCase=A;function F(Y,ae){let ue,me=Math.min(Y.length,ae.length);for(ue=0;ue<me;ue++)if(Y.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return me}e.commonPrefixLength=F;function H(Y,ae){let ue,me=Math.min(Y.length,ae.length);const be=Y.length-1,Te=ae.length-1;for(ue=0;ue<me;ue++)if(Y.charCodeAt(be-ue)!==ae.charCodeAt(Te-ue))return ue;return me}e.commonSuffixLength=H;function ie(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ie;function re(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=re;function G(Y,ae){return(Y-55296<<10)+(ae-56320)+65536}e.computeCodePoint=G;function ee(Y,ae,ue){const me=Y.charCodeAt(ue);if(ie(me)&&ue+1<ae){const be=Y.charCodeAt(ue+1);if(re(be))return G(me,be)}return me}e.getNextCodePoint=ee;function T(Y,ae){const ue=Y.charCodeAt(ae-1);if(re(ue)&&ae>1){const me=Y.charCodeAt(ae-2);if(ie(me))return G(me,ue)}return ue}function V(Y,ae){const ue=Ae.getInstance(),me=ae,be=Y.length,Te=ee(Y,be,ae);ae+=Te>=65536?2:1;let _e=ue.getGraphemeBreakType(Te);for(;ae<be;){const Ue=ee(Y,be,ae),Be=ue.getGraphemeBreakType(Ue);if(ke(_e,Be))break;ae+=Ue>=65536?2:1,_e=Be}return ae-me}e.nextCharLength=V;function U(Y,ae){const ue=Ae.getInstance(),me=ae,be=T(Y,ae);ae-=be>=65536?2:1;let Te=ue.getGraphemeBreakType(be);for(;ae>0;){const _e=T(Y,ae),Ue=ue.getGraphemeBreakType(_e);if(ke(Ue,Te))break;ae-=_e>=65536?2:1,Te=Ue}return me-ae}e.prevCharLength=U;function B(Y,ae){const ue=Ae.getInstance(),me=Y.length,be=ae,Te=ee(Y,me,ae),_e=ue.getGraphemeBreakType(Te);ae+=Te>=65536?2:1;let Ue=_e;for(;ae<me;){const Ce=ee(Y,me,ae),ze=ue.getGraphemeBreakType(Ce);if(ke(Ue,ze))break;ae+=Ce>=65536?2:1,Ue=ze}const Be=ae;for(ae=be,Ue=_e;ae>0;){const Ce=T(Y,ae),ze=ue.getGraphemeBreakType(Ce);if(ke(ze,Ue))break;ae-=Ce>=65536?2:1,Ue=ze}return[ae,Be]}function N(Y,ae){return ae>0&&re(Y.charCodeAt(ae))?B(Y,ae-1):B(Y,ae)}e.getCharContainingOffset=N;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(Y){return _.test(Y)}e.containsRTL=X;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(Y){return W.test(Y)}e.containsEmoji=z;const K=/^[\t\n\r\x20-\x7E]*$/;function O(Y){return K.test(Y)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=q;function C(Y){for(let ae=0,ue=Y.length;ae<ue;ae++)if($(Y.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=C;function $(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=$;function J(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=J;function Q(Y,ae){if(Y.length<ae)return Y;const ue=/\b/g;let me=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<ae);)me=ue.lastIndex,ue.lastIndex+=1;return Y.substring(me).replace(/^\s/,"")}e.lcut=Q;const ne=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function se(Y){return Y&&(Y=Y.replace(ne,""),Y=Y.replace(le,""),Y=Y.replace(oe,"")),Y}e.removeAnsiEscapeCodes=se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function ge(Y){return ce(Y)?Y.substr(1):Y}e.stripUTF8BOM=ge;function de(Y,ae){if(!Y||!ae||Y.length<ae.length)return!1;const ue=ae.length,me=Y.toLowerCase();let be=0,Te=-1;for(;be<ue;){const _e=me.indexOf(ae[be],Te+1);if(_e<0)return!1;Te=_e,be++}return!0}e.fuzzyContains=de;function Ee(Y,ae=!1){return Y?(ae&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ee;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Ie(Y,ae=1){if(ae===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Ie;function ve(Y){const ae=90-65+1;return Y=Y%(2*ae),Y<ae?String.fromCharCode(97+Y):String.fromCharCode(65+Y-ae)}e.singleLetterHash=ve;function ye(Y){return Ae.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=ye;function ke(Y,ae){return Y===0?ae!==5&&ae!==7:Y===2&&ae===3?!1:Y===4||Y===2||Y===3||ae===4||ae===2||ae===3?!0:!(Y===8&&(ae===8||ae===9||ae===11||ae===12)||(Y===11||Y===9)&&(ae===9||ae===10)||(Y===12||Y===10)&&ae===10||ae===5||ae===13||ae===7||Y===1||Y===13&&ae===14||Y===6&&ae===6)}e.breakBetweenGraphemeBreakType=ke;var We;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{constructor(){this._data=Ve()}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,me=ue.length/3;let be=1;for(;be<=me;)if(ae<ue[3*be])be=2*be;else if(ae>ue[3*be+1])be=2*be+1;else return ue[3*be+2];return 0}}Ae._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function xe(Y,ae){if(Y===0)return 0;const ue=st(Y,ae);if(ue!==void 0)return ue;const me=T(ae,Y);return Y-=Ke(me),Y}e.getLeftDeleteOffset=xe;function st(Y,ae){let ue=T(ae,Y);for(Y-=Ke(ue);ht(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=T(ae,Y),Y-=Ke(ue)}if(!!J(ue)){if(Y>=0){const me=T(ae,Y);me===8205&&(Y-=Ke(me))}return Y}}function Ke(Y){return Y>=65536?2:1}function ht(Y){return 127995<=Y&&Y<=127999}var et;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(Z[82],x([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(y){return D(y,0)}e.hash=L;function D(y,I){switch(typeof y){case"object":return y===null?M(349,I):Array.isArray(y)?h(y,I):d(y,I);case"string":return E(y,I);case"boolean":return P(y,I);case"number":return M(y,I);case"undefined":return M(937,I);default:return M(617,I)}}e.doHash=D;function M(y,I){return(I<<5)-I+y|0}e.numberHash=M;function P(y,I){return M(y?433:863,I)}function E(y,I){I=M(149417,I);for(let c=0,o=y.length;c<o;c++)I=M(y.charCodeAt(c),I);return I}e.stringHash=E;function h(y,I){return I=M(104579,I),y.reduce((c,o)=>D(o,c),I)}function d(y,I){return I=M(181387,I),Object.keys(y).sort().reduce((c,o)=>(c=E(o,c),D(y[o],c)),I)}class i{constructor(){this._value=0}get value(){return this._value}hash(I){return this._value=D(I,this._value),this._value}}e.Hasher=i;var S;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function v(y,I,c=32){const o=c-I,u=~((1<<o)-1);return(y<<I|(u&y)>>>o)>>>0}function m(y,I=0,c=y.byteLength,o=0){for(let u=0;u<c;u++)y[I+u]=o}function t(y,I,c="0"){for(;y.length<I;)y=c+y;return y}function g(y,I=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((y>>>0).toString(16),I/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(I){const c=I.length;if(c===0)return;const o=this._buff;let u=this._buffLen,n=this._leftoverHighSurrogate,l,s;for(n!==0?(l=n,s=-1,n=0):(l=I.charCodeAt(0),s=0);;){let r=l;if(p.isHighSurrogate(l))if(s+1<c){const a=I.charCodeAt(s+1);p.isLowSurrogate(a)?(s++,r=p.computeCodePoint(l,a)):r=65533}else{n=l;break}else p.isLowSurrogate(l)&&(r=65533);if(u=this._push(o,u,r),s++,s<c)l=I.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=n}_push(I,c,o){return o<128?I[c++]=o:o<2048?(I[c++]=192|(o&1984)>>>6,I[c++]=128|(o&63)>>>0):o<65536?(I[c++]=224|(o&61440)>>>12,I[c++]=128|(o&4032)>>>6,I[c++]=128|(o&63)>>>0):(I[c++]=240|(o&1835008)>>>18,I[c++]=128|(o&258048)>>>12,I[c++]=128|(o&4032)>>>6,I[c++]=128|(o&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,I[0]=I[64+0],I[1]=I[64+1],I[2]=I[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const I=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(I/4294967296),!1),this._buffDV.setUint32(60,I%4294967296,!1),this._step()}_step(){const I=b._bigBlock32,c=this._buffDV;for(let w=0;w<64;w+=4)I.setUint32(w,c.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)I.setUint32(w,v(I.getUint32(w-12,!1)^I.getUint32(w-32,!1)^I.getUint32(w-56,!1)^I.getUint32(w-64,!1),1),!1);let o=this._h0,u=this._h1,n=this._h2,l=this._h3,s=this._h4,r,a,f;for(let w=0;w<80;w++)w<20?(r=u&n|~u&l,a=1518500249):w<40?(r=u^n^l,a=1859775393):w<60?(r=u&n|u&l|n&l,a=2400959708):(r=u^n^l,a=3395469782),f=v(o,5)+r+s+a+I.getUint32(w*4,!1)&4294967295,s=l,l=n,n=v(u,30),u=o,o=f;this._h0=this._h0+o&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))});var Et=this&&this.__classPrivateFieldSet||function(j,e,p,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(j,p):D?D.value=p:e.set(j,p),p},He=this&&this.__classPrivateFieldGet||function(j,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!L:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(j):L?L.value:e.get(j)};define(Z[40],x([0,1,31,25]),function(j,e,p,L){"use strict";var D,M,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(s,r,a){let f=s.get(r);return f===void 0&&(f=a,s.set(r,f)),f}e.getOrSet=E;function h(s){const r=[];return s.forEach((a,f)=>{r.push(`${f} => ${a}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=h;function d(s){const r=[];return s.forEach(a=>{r.push(a)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=d;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),f=this._value.charCodeAt(this._pos);return a-f}value(){return this._value[this._pos]}}e.StringIterator=i;class S{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class v{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var m;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(m||(m={}));class t{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(b||(b={}));class y{constructor(r){this._iter=r}static forUris(r=()=>!1){return new y(new t(r))}static forPaths(){return new y(new v)}static forStrings(){return new y(new i)}static forConfigKeys(){return new y(new S)}clear(){this._root=void 0}fill(r,a){if(a){const f=a.slice(0);(0,p.shuffle)(f);for(let w of f)this.set(w,r)}else{const f=r.slice(0);(0,p.shuffle)(f);for(let w of f)this.set(w[0],w[1])}}set(r,a){const f=this._iter.reset(r);let w;this._root||(this._root=new g,this._root.segment=f.value());const k=[];for(w=this._root;;){const A=f.cmp(w.segment);if(A>0)w.left||(w.left=new g,w.left.segment=f.value()),k.push([-1,w]),w=w.left;else if(A<0)w.right||(w.right=new g,w.right.segment=f.value()),k.push([1,w]),w=w.right;else if(f.hasNext())f.next(),w.mid||(w.mid=new g,w.mid.segment=f.value()),k.push([0,w]),w=w.mid;else break}const R=w.value;w.value=a,w.key=r;for(let A=k.length-1;A>=0;A--){const F=k[A][1];F.updateHeight();const H=F.balanceFactor();if(H<-1||H>1){const ie=k[A][0],re=k[A+1][0];if(ie===1&&re===1)k[A][1]=F.rotateLeft();else if(ie===-1&&re===-1)k[A][1]=F.rotateRight();else if(ie===1&&re===-1)F.right=k[A+1][1]=k[A+1][1].rotateRight(),k[A][1]=F.rotateLeft();else if(ie===-1&&re===1)F.left=k[A+1][1]=k[A+1][1].rotateLeft(),k[A][1]=F.rotateRight();else throw new Error;if(A>0)switch(k[A-1][0]){case-1:k[A-1][1].left=k[A][1];break;case 1:k[A-1][1].right=k[A][1];break;case 0:k[A-1][1].mid=k[A][1];break}else this._root=k[0][1]}}return R}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let f=this._root;for(;f;){const w=a.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else break}return f}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const f=this._iter.reset(r),w=[];let k=this._root;for(;k;){const R=f.cmp(k.segment);if(R>0)w.push([-1,k]),k=k.left;else if(R<0)w.push([1,k]),k=k.right;else if(f.hasNext())f.next(),w.push([0,k]),k=k.mid;else break}if(!!k){if(a?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const R=this._min(k.right),{key:A,value:F,segment:H}=R;this._delete(R.key,!1),k.key=A,k.value=F,k.segment=H}else{const R=k.left??k.right;if(w.length>0){const[A,F]=w[w.length-1];switch(A){case-1:F.left=R;break;case 0:F.mid=R;break;case 1:F.right=R;break}}else this._root=R}for(let R=w.length-1;R>=0;R--){const A=w[R][1];A.updateHeight();const F=A.balanceFactor();if(F>1?(A.right.balanceFactor()>=0||(A.right=w[R+1][1]=w[R+1][1].rotateRight()),w[R][1]=A.rotateLeft()):F<-1&&(A.left.balanceFactor()<=0||(A.left=w[R+1][1]=w[R+1][1].rotateLeft()),w[R][1]=A.rotateRight()),R>0)switch(w[R-1][0]){case-1:w[R-1][1].left=w[R][1];break;case 1:w[R-1][1].right=w[R][1];break;case 0:w[R-1][1].mid=w[R][1];break}else this._root=w[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const a=this._iter.reset(r);let f=this._root,w;for(;f;){const k=a.cmp(f.segment);if(k>0)f=f.left;else if(k<0)f=f.right;else if(a.hasNext())a.next(),w=f.value||w,f=f.mid;else break}return f&&f.value||w}findSuperstr(r){const a=this._iter.reset(r);let f=this._root;for(;f;){const w=a.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(r){for(const[a,f]of this)r(f,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=a=>{if(!a)return!0;const f=a.balanceFactor();return f<-1||f>1?!1:r(a.left)&&r(a.right)};return r(this._root)}}e.TernarySearchTree=y;class I{constructor(r,a){this.uri=r,this.value=a}}class c{constructor(r,a){this[D]="ResourceMap",r instanceof c?(this.map=new Map(r.map),this.toKey=a??c.defaultToKey):(this.map=new Map,this.toKey=r??c.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),new I(r,a)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[f,w]of this.map)r(w.value,w.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=c,c.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class u{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const f=this._map.get(r);if(!!f)return a!==0&&this.touch(f,a),f.value}set(r,a,f=0){let w=this._map.get(r);if(w)w.value=a,f!==0&&this.touch(w,f);else{switch(w={key:r,value:a,next:void 0,previous:void 0},f){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(r,w),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const f=this._state;let w=this._head;for(;w;){if(a?r.bind(a)(w.value,w.key,this):r(w.value,w.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const r=this,a=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.key,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}values(){const r=this,a=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.value,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}entries(){const r=this,a=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:[f.key,f.value],done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,f=this.size;for(;a&&f>r;)this._map.delete(a.key),a=a.next,f--;this._head=a,this._size=f,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,f=r.previous;if(!a||!f)throw new Error("Invalid list");a.previous=f,f.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const f=r.next,w=r.previous;r===this._tail?(w.next=void 0,this._tail=w):(f.previous=w,w.next=f),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const f=r.next,w=r.previous;r===this._head?(f.previous=void 0,this._head=f):(f.previous=w,w.next=f),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,f)=>{r.push([f,a])}),r}fromJSON(r){this.clear();for(const[a,f]of r)this.set(a,f)}}e.LinkedMap=u;class n extends u{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class l{constructor(r){P.set(this,void 0),Et(this,P,r,"f")}get size(){return He(this,P,"f").size}forEach(r,a){He(this,P,"f").forEach(r,a)}get(r){return He(this,P,"f").get(r)}has(r){return He(this,P,"f").has(r)}entries(){return He(this,P,"f").entries()}keys(){return He(this,P,"f").keys()}values(){return He(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return He(this,P,"f").entries()}}e.ReadonlyMapView=l}),define(Z[69],x([0,1,40]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function D(d){return h(d,"NFC",L)}e.normalizeNFC=D;const M=new p.LRUCache(1e4);function P(d){return h(d,"NFD",M)}e.normalizeNFD=P;const E=/[^\u0000-\u0080]/;function h(d,i,S){if(!d)return d;const v=S.get(d);if(v)return v;let m;return E.test(d)?m=d.normalize(i):m=d,S.set(d,m),m}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(i){return P(i).replace(d,"")}}()}),define(Z[14],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(k){return Array.isArray(k)}e.isArray=p;function L(k){return typeof k=="string"}e.isString=L;function D(k){return Array.isArray(k)&&k.every(R=>L(R))}e.isStringArray=D;function M(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=M;function P(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=P;function E(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=E;function h(k){return k===!0||k===!1}e.isBoolean=h;function d(k){return typeof k=="undefined"}e.isUndefined=d;function i(k){return!S(k)}e.isDefined=i;function S(k){return d(k)||k===null}e.isUndefinedOrNull=S;function v(k,R){if(!k)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=v;function m(k){if(S(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=m;function t(...k){const R=[];for(let A=0;A<k.length;A++){const F=k[A];if(S(F))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);R.push(F)}return R}e.assertAllDefined=t;const g=Object.prototype.hasOwnProperty;function b(k){if(!M(k))return!1;for(let R in k)if(g.call(k,R))return!1;return!0}e.isEmptyObject=b;function y(k){return typeof k=="function"}e.isFunction=y;function I(...k){return k.length>0&&k.every(y)}e.areFunctions=I;function c(k,R){const A=Math.min(k.length,R.length);for(let F=0;F<A;F++)o(k[F],R[F])}e.validateConstraints=c;function o(k,R){if(L(R)){if(typeof k!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(y(R)){try{if(k instanceof R)return}catch{}if(!S(k)&&k.constructor===R||R.length===1&&R.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function u(k){let R=[],A=Object.getPrototypeOf(k);for(;Object.prototype!==A;)R=R.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return R}e.getAllPropertyNames=u;function n(k){const R=[];for(const A of u(k))typeof k[A]=="function"&&R.push(A);return R}e.getAllMethodNames=n;function l(k,R){const A=H=>function(){const ie=Array.prototype.slice.call(arguments,0);return R(H,ie)};let F={};for(const H of k)F[H]=A(H);return F}e.createProxyObject=l;function s(k){return k===null?void 0:k}e.withNullAsUndefined=s;function r(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=r;function a(k){return class{constructor(){return new Proxy({},{get(R,A){if(R[A])return R[A];throw new Error(`Not Implemented: ${k}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function f(k,R="Unreachable"){throw new Error(R)}e.assertNever=f;function w(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=w}),define(Z[33],x([0,1,8,3,25,14]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(s){return s===47||s===92}e.isPathSeparator=P;function E(s){return s.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=E;function h(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=h;function d(s,r=p.posix.sep){if(!s)return"";const a=s.length,f=s.charCodeAt(0);if(P(f)){if(P(s.charCodeAt(1))&&!P(s.charCodeAt(2))){let k=3;const R=k;for(;k<a&&!P(s.charCodeAt(k));k++);if(R!==k&&!P(s.charCodeAt(k+1))){for(k+=1;k<a;k++)if(P(s.charCodeAt(k)))return s.slice(0,k+1).replace(/[\\/]/g,r)}}return r}else if(y(f)&&s.charCodeAt(1)===58)return P(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let w=s.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(P(s.charCodeAt(w)))return s.slice(0,w+1)}return""}e.getRoot=d;function i(s){if(!L.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let a=2;const f=a;for(;a<s.length&&(r=s.charCodeAt(a),r!==92);a++);return!(f===a||(r=s.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=i;const S=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,r=L.isWindows){const a=r?S:v;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||r&&m.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function g(s,r,a){const f=s===r;return!a||f?f:!s||!r?!1:(0,D.equalsIgnoreCase)(s,r)}e.isEqual=g;function b(s,r,a,f=p.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let k=r.length;return r.charAt(r.length-1)===f&&k--,s.charAt(k)===f}return r.charAt(r.length-1)!==f&&(r+=f),s.indexOf(r)===0}e.isEqualOrParent=b;function y(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=y;function I(s,r){return L.isWindows&&s.endsWith(":")&&(s+=p.sep),(0,p.isAbsolute)(s)||(s=(0,p.join)(r,s)),s=(0,p.normalize)(s),L.isWindows?(s=(0,D.rtrim)(s,p.sep),s.endsWith(":")&&(s+=p.sep)):(s=(0,D.rtrim)(s,p.sep),s||(s=p.sep)),s}e.sanitizeFilePath=I;function c(s){const r=(0,p.normalize)(s);return L.isWindows?s.length>3?!1:o(r)&&(s.length===2||r.charCodeAt(2)===92):r===p.posix.sep}e.isRootOrDriveLetter=c;function o(s){return L.isWindows?y(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function u(s){return o(s)?s[0]:void 0}e.getDriveLetter=u;function n(s,r,a){return r.length>s.length?-1:s===r?0:(a&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=n;function l(s){const r=s.split(":");let a,f,w;if(r.forEach(k=>{const R=Number(k);(0,M.isNumber)(R)?f===void 0?f=R:w===void 0&&(w=R):a=a?[a,k].join(":"):k}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(Z[43],x([0,1,14]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.keys(g).forEach(y=>{g[y]&&typeof g[y]=="object"?b[y]=L(g[y]):b[y]=g[y]}),b}e.deepClone=L;function D(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const y=b.shift();Object.freeze(y);for(const I in y)if(M.call(y,I)){const c=y[I];typeof c=="object"&&!Object.isFrozen(c)&&b.push(c)}}return g}e.deepFreeze=D;const M=Object.prototype.hasOwnProperty;function P(g,b){return E(g,b,new Set)}e.cloneAndChange=P;function E(g,b,y){if((0,p.isUndefinedOrNull)(g))return g;const I=b(g);if(typeof I!="undefined")return I;if((0,p.isArray)(g)){const c=[];for(const o of g)c.push(E(o,b,y));return c}if((0,p.isObject)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const c={};for(let o in g)M.call(g,o)&&(c[o]=E(g[o],b,y));return y.delete(g),c}return g}function h(g,b,y=!0){return(0,p.isObject)(g)?((0,p.isObject)(b)&&Object.keys(b).forEach(I=>{I in g?y&&((0,p.isObject)(g[I])&&(0,p.isObject)(b[I])?h(g[I],b[I],y):g[I]=b[I]):g[I]=b[I]}),g):b}e.mixin=h;function d(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let y,I;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(y=0;y<g.length;y++)if(!d(g[y],b[y]))return!1}else{const c=[];for(I in g)c.push(I);c.sort();const o=[];for(I in b)o.push(I);if(o.sort(),!d(c,o))return!1;for(y=0;y<c.length;y++)if(!d(g[c[y]],b[c[y]]))return!1}return!0}e.equals=d;function i(g){const b=new Set;return JSON.stringify(g,(y,I)=>{if((0,p.isObject)(I)||Array.isArray(I)){if(b.has(I))return"[Circular]";b.add(I)}return I})}e.safeStringify=i;function S(g,b,y){const I=b(g);return typeof I=="undefined"?y:I}e.getOrDefault=S;function v(g,b){const y=Object.create(null);return!g||!b||Object.keys(b).forEach(c=>{const o=g[c],u=b[c];d(o,u)||(y[c]=u)}),y}e.distinct=v;function m(g,b){const y=b.toLowerCase(),I=Object.keys(g).find(c=>c.toLowerCase()===y);return I?g[I]:g[b]}e.getCaseInsensitive=m;function t(g,b){const y=Object.create(null);for(const I of Object.keys(g))b(I,g[I])&&(y[I]=g[I]);return y}e.filter=t}),define(Z[7],x([0,1,8,3]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,M=/^\//,P=/^\/\//;function E(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!M.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(s,r){return!s&&!r?"file":s}function d(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==S&&(r=S+r):r=S;break}return r}const i="",S="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(r,a,f,w,k,R=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=h(r,R),this.authority=a||i,this.path=d(this.scheme,f||i),this.query=w||i,this.fragment=k||i,E(this,R))}static isUri(r){return r instanceof m?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:f,path:w,query:k,fragment:R}=r;return a===void 0?a=this.scheme:a===null&&(a=i),f===void 0?f=this.authority:f===null&&(f=i),w===void 0?w=this.path:w===null&&(w=i),k===void 0?k=this.query:k===null&&(k=i),R===void 0?R=this.fragment:R===null&&(R=i),a===this.scheme&&f===this.authority&&w===this.path&&k===this.query&&R===this.fragment?this:new g(a,f,w,k,R)}static parse(r,a=!1){const f=v.exec(r);return f?new g(f[2]||i,l(f[4]||i),l(f[5]||i),l(f[7]||i),l(f[9]||i),a):new g(i,i,i,i,i)}static file(r){let a=i;if(L.isWindows&&(r=r.replace(/\\/g,S)),r[0]===S&&r[1]===S){const f=r.indexOf(S,2);f===-1?(a=r.substring(2),r=S):(a=r.substring(2,f),r=r.substring(f)||S)}return new g("file",a,r,i,i)}static from(r){const a=new g(r.scheme,r.authority,r.path,r.query,r.fragment);return E(a,!0),a}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return L.isWindows&&r.scheme==="file"?f=m.file(p.win32.join(c(r,!0),...a)).path:f=p.posix.join(r.path,...a),r.with({path:f})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof m)return r;{const a=new g(r);return a._formatted=r.external,a._fsPath=r._sep===t?r.fsPath:null,a}}else return r}}e.URI=m;const t=L.isWindows?1:void 0;class g extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=t),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(s,r){let a,f=-1;for(let w=0;w<s.length;w++){const k=s.charCodeAt(w);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||r&&k===47)f!==-1&&(a+=encodeURIComponent(s.substring(f,w)),f=-1),a!==void 0&&(a+=s.charAt(w));else{a===void 0&&(a=s.substr(0,w));const R=b[k];R!==void 0?(f!==-1&&(a+=encodeURIComponent(s.substring(f,w)),f=-1),a+=R):f===-1&&(f=w)}}return f!==-1&&(a+=encodeURIComponent(s.substring(f))),a!==void 0?a:s}function I(s){let r;for(let a=0;a<s.length;a++){const f=s.charCodeAt(a);f===35||f===63?(r===void 0&&(r=s.substr(0,a)),r+=b[f]):r!==void 0&&(r+=s[a])}return r!==void 0?r:s}function c(s,r){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=c;function o(s,r){const a=r?I:y;let f="",{scheme:w,authority:k,path:R,query:A,fragment:F}=s;if(w&&(f+=w,f+=":"),(k||w==="file")&&(f+=S,f+=S),k){let H=k.indexOf("@");if(H!==-1){const ie=k.substr(0,H);k=k.substr(H+1),H=ie.indexOf(":"),H===-1?f+=a(ie,!1):(f+=a(ie.substr(0,H),!1),f+=":",f+=a(ie.substr(H+1),!1)),f+="@"}k=k.toLowerCase(),H=k.indexOf(":"),H===-1?f+=a(k,!1):(f+=a(k.substr(0,H),!1),f+=k.substr(H))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const H=R.charCodeAt(1);H>=65&&H<=90&&(R=`/${String.fromCharCode(H+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const H=R.charCodeAt(0);H>=65&&H<=90&&(R=`${String.fromCharCode(H+32)}:${R.substr(2)}`)}f+=a(R,!0)}return A&&(f+="?",f+=a(A,!1)),F&&(f+="#",f+=r?F:y(F,!1)),f}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(n)?s.replace(n,r=>u(r)):s}}),define(Z[110],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(d){const i=d;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function D(d){const i=[];let S;try{const v=JSON.parse(d.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),S=m.__$stack),i.push(...v)}catch(v){i.push("Unable to log remote console arguments",d.arguments)}return{args:i,stack:S}}e.parse=D;function M(d){if(typeof d!="string")return M(D(d).stack);const i=d;if(i){const S=P(i),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(v&&v.length===4)return{uri:p.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=M;function P(d){if(!d)return d;const i=d.indexOf(`
`);return i===-1?d:d.substring(0,i)}function E(d,i){const{args:S,stack:v}=D(d),m=typeof S[0]=="string"&&S.length===1;let t=P(v);t&&(t=`(${t.trim()})`);let g=[];if(typeof S[0]=="string"?t&&m?g=[`%c[${i}] %c${S[0]} %c${t}`,h("blue"),h(""),h("grey")]:g=[`%c[${i}] %c${S[0]}`,h("blue"),h(""),...S.slice(1)]:g=[`%c[${i}]%`,h("blue"),...S],t&&!m&&g.push(t),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,g)}e.log=E;function h(d){return`color: ${d}`}}),define(Z[111],x([0,1,17,25,7]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(i){return JSON.stringify(i,h)}e.stringify=M;function P(i){let S=JSON.parse(i);return S=d(S),S}e.parse=P;var E;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(E=e.MarshalledId||(e.MarshalledId={}));function h(i,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,L.regExpFlags)(S)}:S}function d(i,S=0){if(!i||S>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let v=0;v<i.length;++v)i[v]=d(i[v],S+1);else for(const v in i)Object.hasOwnProperty.call(i,v)&&(i[v]=d(i[v],S+1))}return i}e.revive=d}),define(Z[10],x([0,1,3,7]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,d,i){this._hosts[h]=d,this._ports[h]=i}setConnectionToken(h,d){this._connectionTokens[h]=d}rewrite(h){if(this._delegate)return this._delegate(h);const d=h.authority;let i=this._hosts[d];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const S=this._ports[d],v=this._connectionTokens[d];let m=`path=${encodeURIComponent(h.path)}`;return typeof v=="string"&&(m+=`&tkn=${encodeURIComponent(v)}`),L.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${S}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new M;class P{asBrowserUri(h,d){const i=this.toUri(h,d);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(h,d){const i=this.toUri(h,d);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==P.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(h,d){return L.URI.isUri(h)?h:L.URI.parse(d.toUrl(h))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Z[15],x([0,1,33,10,8,3,25,7]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(m){return(0,E.uriToFsPath)(m,!0)}e.originalFSPath=h;class d{constructor(t){this._ignorePathCasing=t}compare(t,g,b=!1){return t===g?0:(0,P.compare)(this.getComparisonKey(t,b),this.getComparisonKey(g,b))}isEqual(t,g,b=!1){return t===g?!0:!t||!g?!1:this.getComparisonKey(t,b)===this.getComparisonKey(g,b)}getComparisonKey(t,g=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,g,b=!1){if(t.scheme===g.scheme){if(t.scheme===L.Schemas.file)return p.isEqualOrParent(h(t),h(g),this._ignorePathCasing(t))&&t.query===g.query&&(b||t.fragment===g.fragment);if((0,e.isEqualAuthority)(t.authority,g.authority))return p.isEqualOrParent(t.path,g.path,this._ignorePathCasing(t),"/")&&t.query===g.query&&(b||t.fragment===g.fragment)}return!1}joinPath(t,...g){return E.URI.joinPath(t,...g)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let g;return t.scheme===L.Schemas.file?g=E.URI.file(D.dirname(h(t))).path:(g=D.posix.dirname(t.path),t.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),g="/")),t.with({path:g})}normalizePath(t){if(!t.path.length)return t;let g;return t.scheme===L.Schemas.file?g=E.URI.file(D.normalize(h(t))).path:g=D.posix.normalize(t.path),t.with({path:g})}relativePath(t,g){if(t.scheme!==g.scheme||!(0,e.isEqualAuthority)(t.authority,g.authority))return;if(t.scheme===L.Schemas.file){const I=D.relative(h(t),h(g));return M.isWindows?p.toSlashes(I):I}let b=t.path||"/",y=g.path||"/";if(this._ignorePathCasing(t)){let I=0;for(const c=Math.min(b.length,y.length);I<c&&!(b.charCodeAt(I)!==y.charCodeAt(I)&&b.charAt(I).toLowerCase()!==y.charAt(I).toLowerCase());I++);b=y.substr(0,I)+b.substr(I)}return D.posix.relative(b,y)}resolvePath(t,g){if(t.scheme===L.Schemas.file){const b=E.URI.file(D.resolve(h(t),g));return t.with({authority:b.authority,path:b.path})}return g=p.toPosixPath(g),t.with({path:D.posix.resolve(t.path,g)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,g){return t===g||(0,P.equalsIgnoreCase)(t,g)}hasTrailingPathSeparator(t,g=D.sep){if(t.scheme===L.Schemas.file){const b=h(t);return b.length>p.getRoot(b).length&&b[b.length-1]===g}else{const b=t.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,g=D.sep){return(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,g=D.sep){let b=!1;if(t.scheme===L.Schemas.file){const y=h(t);b=y!==void 0&&y.length===p.getRoot(y).length&&y[y.length-1]===g}else{g="/";const y=t.path;b=y.length===1&&y.charCodeAt(y.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path+"/"}):t}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(m=>m.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new d(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,t){const g=[];for(let b=0;b<m.length;b++){const y=t(m[b]);m.some((I,c)=>c===b?!1:(0,e.isEqualOrParent)(y,t(I)))||g.push(m[b])}return g}e.distinctParents=i;var S;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function t(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,u]=c.split(":");o&&u&&b.set(o,u)});const I=g.path.substring(0,g.path.indexOf(";"));return I&&b.set(m.META_DATA_MIME,I),b}m.parseMetaData=t})(S=e.DataUri||(e.DataUri={}));function v(m,t,g){if(t){let b=m.path;return b&&b[0]!==D.posix.sep&&(b=D.posix.sep+b),m.with({scheme:g,authority:t,path:b})}return m.with({scheme:g})}e.toLocalResource=v}),define(Z[9],x([0,1,23,16,4,2,15]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(U){return!!U&&typeof U.then=="function"}e.isThenable=E;function h(U){const B=new p.CancellationTokenSource,N=U(B.token),_=new Promise((X,W)=>{const z=B.token.onCancellationRequested(()=>{z.dispose(),B.dispose(),W((0,L.canceled)())});Promise.resolve(N).then(K=>{z.dispose(),B.dispose(),X(K)},K=>{z.dispose(),B.dispose(),W(K)})});return new class{cancel(){B.cancel()}then(X,W){return _.then(X,W)}catch(X){return this.then(void 0,X)}finally(X){return _.finally(X)}}}e.createCancelablePromise=h;function d(U,B,N){return Promise.race([U,new Promise(_=>B.onCancellationRequested(()=>_(N)))])}e.raceCancellation=d;async function i(U){let B=-1;const N=U.map((X,W)=>X.then(z=>(B=W,z))),_=await Promise.race(N);return U.forEach((X,W)=>{W!==B&&X.cancel()}),_}e.raceCancellablePromises=i;function S(U,B,N){let _;const X=setTimeout(()=>{_?.(void 0),N?.()},B);return Promise.race([U.finally(()=>clearTimeout(X)),new Promise(W=>_=W)])}e.raceTimeout=S;function v(U){return new Promise((B,N)=>{const _=U();E(_)?_.then(B,N):B(_)})}e.asPromise=v;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(N,N).then(_)})}return new Promise((N,_)=>{this.queuedPromise.then(N,_)})}return this.activePromise=B(),new Promise((N,_)=>{this.activePromise.then(X=>{this.activePromise=null,N(X)},X=>{this.activePromise=null,_(X)})})}}e.Throttler=m;class t{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=t;class g{constructor(){this.promiseMap=new Map}queue(B,N){const X=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(B)===X&&this.promiseMap.delete(B)});return this.promiseMap.set(B,X),X}}e.SequencerByKey=g;class b{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,N=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,X)=>{this.doResolve=_,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class y{constructor(B){this.delayer=new b(B),this.throttler=new m}trigger(B,N){return this.delayer.trigger(()=>this.throttler.queue(B),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class I{constructor(){this._isOpen=!1,this._promise=new Promise((B,N)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class c extends I{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function o(U,B){return B?new Promise((N,_)=>{const X=setTimeout(()=>{W.dispose(),N()},U),W=B.onCancellationRequested(()=>{clearTimeout(X),W.dispose(),_((0,L.canceled)())})}):h(N=>o(U,N))}e.timeout=o;function u(U,B=0){const N=setTimeout(U,B);return(0,M.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=u;function n(U){const B=[];let N=0;const _=U.length;function X(){return N<_?U[N++]():null}function W(z){z!=null&&B.push(z);const K=X();return K?K.then(W):Promise.resolve(B)}return Promise.resolve(null).then(W)}e.sequence=n;function l(U,B=_=>!!_,N=null){let _=0;const X=U.length,W=()=>{if(_>=X)return Promise.resolve(N);const z=U[_++];return Promise.resolve(z()).then(O=>B(O)?Promise.resolve(O):W())};return W()}e.first=l;function s(U,B=_=>!!_,N=null){if(U.length===0)return Promise.resolve(N);let _=U.length;const X=()=>{_=-1;for(const W of U)W.cancel?.()};return new Promise((W,z)=>{for(const K of U)K.then(O=>{--_>=0&&B(O)?(X(),W(O)):_===0&&W(N)}).catch(O=>{--_>=0&&(X(),z(O))})})}e.firstParallel=s;class r{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((N,_)=>{this.outstandingPromises.push({factory:B,c:N,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const N=B.factory();N.then(B.c,B.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class a extends r{constructor(){super(1)}}e.Queue=a;class f{constructor(){this.queues=new Map}queueFor(B,N=P.extUri){const _=N.getComparisonKey(B);let X=this.queues.get(_);return X||(X=new a,D.Event.once(X.onFinished)(()=>{X?.dispose(),this.queues.delete(_)}),this.queues.set(_,X)),X}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=f;class w{constructor(B,N){this._token=-1,typeof B=="function"&&typeof N=="number"&&this.setIfNotSet(B,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},N)}setIfNotSet(B,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},N))}}e.TimeoutTimer=w;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,N){this.cancel(),this._token=setInterval(()=>{B()},N)}}e.IntervalTimer=k;class R{constructor(B,N){this.timeoutToken=-1,this.runner=B,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class A{constructor(B,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class F extends R{constructor(B,N){super(B,N);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class H extends M.Disposable{constructor(B,N,_,X){super();this.maxWorkChunkSize=B,this.maxPendingWork=N,this.throttleDelay=_,this.handler=X,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{const B=setTimeout(()=>{const _=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0,clearTimeout(B))}}}:e.runWhenIdle=(U,B)=>{const N=requestIdleCallback(U,typeof B=="number"?{timeout:B}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(N))}}}}();class ie{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ie;async function re(U,B,N){let _;for(let X=0;X<N;X++)try{return await U()}catch(W){_=W,await o(B)}throw _}e.retry=re;class G{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,N,_){return this._pending={taskId:B,cancel:()=>_?.(),promise:N},N.then(()=>this.donePending(B),()=>this.donePending(B)),N}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let N,_;const X=new Promise((W,z)=>{N=W,_=z});this._next={run:B,promise:X,promiseResolve:N,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=G;class ee{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class T{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,N)=>{this.completeCallback=B,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(N=>{this.completeCallback(B),this.resolved=!0,N()})}error(B){return new Promise(N=>{this.errorCallback(B),this.rejected=!0,N()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=T;var V;(function(U){async function B(_){let X;const W=await Promise.all(_.map(z=>z.then(K=>K,K=>{X||(X=K)})));if(typeof X!="undefined")throw X;return W}U.settled=B;function N(_){return new Promise(async(X,W)=>{try{await _(X,W)}catch(z){W(z)}})}U.withAsyncBody=N})(V=e.Promises||(e.Promises={}))}),define(Z[34],x([0,1,33,10,8,3,15,25,7]),function(j,e,p,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function d(r,a,f){if(typeof r=="string"&&(r=h.URI.file(r)),f){const k=f.getWorkspaceFolder(r);if(k){const R=f.getWorkspace().folders.length>1;let A;if((0,P.isEqual)(k.uri,r)?A="":A=(0,P.relativePath)(k.uri,r),R){const F=k.name?k.name:(0,P.basename)(k.uri);A=A?F+" \u2022 "+A:F}return A}}if(r.scheme!==L.Schemas.file&&r.scheme!==L.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(r.fsPath))return(0,D.normalize)(S(r.fsPath));let w=(0,D.normalize)(r.fsPath);return!M.isWindows&&a?.userHome&&(w=m(w,a.userHome.fsPath)),w}e.getPathLabel=d;function i(r){if(!r)return;typeof r=="string"&&(r=h.URI.file(r));const a=(0,P.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return M.isWindows&&(0,p.isRootOrDriveLetter)(a)?S(a):a}e.getBaseLabel=i;function S(r){return(0,p.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=S;let v=Object.create(null);function m(r,a){if(M.isWindows||!r||!a)return r;let f=v.original===a?v.normalized:void 0;return f||(f=`${(0,E.rtrim)(a,D.posix.sep)}${D.posix.sep}`,v={original:a,normalized:f}),(M.isLinux?r.startsWith(f):(0,E.startsWithIgnoreCase)(r,f))&&(r=`~/${r.substr(f.length)}`),r}e.tildify=m;function t(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=t;const g="\u2026",b="\\\\",y="~";function I(r,a=D.sep){const f=new Array(r.length);let w=!1;for(let k=0;k<r.length;k++){let R=r[k];if(R===""){f[k]=`.${a}`;continue}if(!R){f[k]=R;continue}w=!0;let A="";R.indexOf(b)===0?(A=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length)):R.indexOf(a)===0?(A=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(y)===0&&(A=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length));const F=R.split(a);for(let H=1;w&&H<=F.length;H++)for(let ie=F.length-H;w&&ie>=0;ie--){w=!1;let re=F.slice(ie,ie+H).join(a);for(let G=0;!w&&G<r.length;G++)if(G!==k&&r[G]&&r[G].indexOf(re)>-1){const ee=ie+H===F.length,T=ie>0&&r[G].indexOf(a)>-1?a+re:re,V=r[G].endsWith(T);w=!ee||V}if(!w){let G="";(F[0].endsWith(":")||A!=="")&&(ie===1&&(ie=0,H++,re=F[0]+a+re),ie>0&&(G=F[0]+a),G=A+G),ie>0&&(G=G+g+a),G=G+re,ie+H<F.length&&(G=G+a+g),f[k]=G}}w&&(f[k]=R)}return f}e.shorten=I;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function o(r,a=Object.create(null)){const f=[];let w=!1,k="";for(const R of r)if(R==="$"||w&&R==="{")k&&f.push({value:k,type:c.TEXT}),k="",w=!0;else if(R==="}"&&w){const A=a[k];if(typeof A=="string")A.length&&f.push({value:A,type:c.VARIABLE});else if(A){const F=f[f.length-1];(!F||F.type!==c.SEPARATOR)&&f.push({value:A.label,type:c.SEPARATOR})}k="",w=!1}else k+=R;return k&&!w&&f.push({value:k,type:c.TEXT}),f.filter((R,A)=>{if(R.type===c.SEPARATOR){const F=f[A-1],H=f[A+1];return[F,H].every(ie=>ie&&(ie.type===c.VARIABLE||ie.type===c.TEXT)&&ie.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function u(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function n(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,f=>f==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function l(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=l;function s(r){const a=r.indexOf("/")!==-1?D.posix:D.win32,f=a.basename(r),w=a.dirname(r);return f.length?{name:f,parentPath:w}:{name:w,parentPath:""}}e.splitName=s}),define(Z[112],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class D{constructor(S){this._uriTransformer=S}transformIncoming(S){const v=this._uriTransformer.transformIncoming(S);return v===S?S:L(p.URI.from(v))}transformOutgoing(S){const v=this._uriTransformer.transformOutgoing(S);return v===S?S:L(p.URI.from(v))}transformOutgoingURI(S){const v=this._uriTransformer.transformOutgoing(S);return v===S?S:p.URI.from(v)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function M(i,S,v){if(!i||v>200)return null;if(typeof i=="object"){if(i instanceof p.URI)return S.transformOutgoing(i);for(let m in i)if(Object.hasOwnProperty.call(i,m)){const t=M(i[m],S,v+1);t!==null&&(i[m]=t)}}return null}function P(i,S){const v=M(i,S,0);return v===null?i:v}e.transformOutgoingURIs=P;function E(i,S,v,m){if(!i||m>200)return null;if(typeof i=="object"){if(i.$mid===1)return v?p.URI.revive(S.transformIncoming(i)):S.transformIncoming(i);for(let t in i)if(Object.hasOwnProperty.call(i,t)){const g=E(i[t],S,v,m+1);g!==null&&(i[t]=g)}}return null}function h(i,S){const v=E(i,S,!1,0);return v===null?i:v}e.transformIncomingURIs=h;function d(i,S){const v=E(i,S,!0,0);return v===null?i:v}e.transformAndReviveIncomingURIs=d}),define(Z[28],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(h){return p.test(h)}e.isUUID=L;const D=new Uint8Array(16),M=[];for(let h=0;h<256;h++)M.push(h.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(h){for(let d=0;d<h.length;d++)h[d]=Math.floor(Math.random()*256);return h};function E(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let h=0,d="";return d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+="-",d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d+=M[D[h++]],d}e.generateUuid=E}),define(Z[113],x([0,1,61,29,42]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(P,E){if(await new Promise((i,S)=>{const v=L.createReadStream(P),m=p.createHash("sha1");v.pipe(m);const t=(0,D.once)((g,b)=>{v.removeAllListeners(),m.removeAllListeners(),g?S(g):i(b)});v.once("error",t),v.once("end",t),m.once("error",t),m.once("data",g=>t(void 0,g.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[114],x([0,1,243]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new p.StringDecoder(M),this.remaining=null}write(M){const P=[],E=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(E.length<1)return P;let h=0,d,i=h;for(;i<E.length;)if(d=E.charCodeAt(i),d===13||d===10){if(P.push(E.substring(h,i)),i++,i<E.length){const S=d;d=E.charCodeAt(i),(S===13&&d===10||S===10&&d===13)&&i++}h=i}else i++;return this.remaining=h<E.length?E.substr(h):null,P}end(){return this.remaining}}e.LineDecoder=L}),define(Z[115],x([0,1,26]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(E){const h=E.replace(/\-/g,":").toLowerCase();return!L.has(h)}function M(){return new Promise(async(E,h)=>{const d=setTimeout(()=>h("Unable to retrieve mac address (timeout after 10s)"),1e4);try{E(await P())}catch(i){h(i)}finally{clearTimeout(d)}})}e.getMac=M;function P(){return new Promise((E,h)=>{try{const d=(0,p.networkInterfaces)();for(let i in d){const S=d[i];if(S){for(const{mac:v}of S)if(D(v))return E(v)}}h("Unable to retrieve mac address (unexpected format)")}catch(d){h(d)}})}}),define(Z[70],x([0,1,26,16,40,28,115]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,S=0;const v=(0,p.networkInterfaces)();for(let m in v){const t=v[m];if(t)for(const{mac:g,internal:b}of t)b||(S+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(i+=1))}this._value=S>0?i/S:0}return this._value}};let E;async function h(){return E||(E=(async()=>await d()||M.generateUuid())()),E}e.getMachineId=h;async function d(){try{const i=await new Promise((v,m)=>{j(["crypto"],v,m)}),S=await(0,P.getMac)();return i.createHash("sha256").update(S,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[20],x([0,1,29,26,116,9,33,69,8,3,15,7,28]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function t(T,V=m.UNLINK){if((0,P.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");return V===m.UNLINK?b(T):g(T)}async function g(T){try{const V=(0,h.join)((0,L.tmpdir)(),(0,v.generateUuid)());try{await e.Promises.rename(T,V)}catch(U){return b(T)}b(V).catch(U=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function b(T){return e.Promises.rmdir(T,{recursive:!0,maxRetries:3})}function y(T){if((0,P.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(T,{recursive:!0})}e.rimrafSync=y;async function I(T,V){return u(await(V?c(T):(0,D.promisify)(p.readdir)(T)))}async function c(T){try{return await(0,D.promisify)(p.readdir)(T,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const V=[],U=await I(T);for(const B of U){let N=!1,_=!1,X=!1;try{const W=await e.Promises.lstat((0,h.join)(T,B));N=W.isFile(),_=W.isDirectory(),X=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}V.push({name:B,isFile:()=>N,isDirectory:()=>_,isSymbolicLink:()=>X})}return V}function o(T){return u(p.readdirSync(T))}e.readdirSync=o;function u(T){return T.map(V=>typeof V=="string"?d.isMacintosh?(0,E.normalizeNFC)(V):V:(V.name=d.isMacintosh?(0,E.normalizeNFC)(V.name):V.name,V))}async function n(T){const V=await I(T),U=[];for(const B of V)await s.existsDirectory((0,h.join)(T,B))&&U.push(B);return U}function l(T,V=1e3){return new Promise(U=>{let B=!1;const N=setInterval(()=>{B||(B=!0,p.access(T,_=>{B=!1,_&&(clearInterval(N),U(void 0))}))},V)})}e.whenDeleted=l;var s;(function(T){async function V(N){let _;try{if(_=await e.Promises.lstat(N),!_.isSymbolicLink())return{stat:_}}catch(X){}try{return{stat:await e.Promises.stat(N),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(d.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw W}throw X}}T.stat=V;async function U(N){try{const{stat:_,symbolicLink:X}=await T.stat(N);return _.isFile()&&X?.dangling!==!0}catch(_){}return!1}T.existsFile=U;async function B(N){try{const{stat:_,symbolicLink:X}=await T.stat(N);return _.isDirectory()&&X?.dangling!==!0}catch(_){}return!1}T.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new M.ResourceQueue;function a(T,V,U){return r.queueFor(S.URI.file(T),i.extUriBiasedIgnorePathCase).queue(()=>{const B=R(U);return new Promise((N,_)=>w(T,V,B,X=>X?_(X):N()))})}let f=!0;function w(T,V,U,B){if(!f)return p.writeFile(T,V,{mode:U.mode,flag:U.flag},B);p.open(T,U.flag,U.mode,(N,_)=>{if(N)return B(N);p.writeFile(_,V,X=>{if(X)return p.close(_,()=>B(X));p.fdatasync(_,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),f=!1),p.close(_,z=>B(z))))})})}function k(T,V,U){const B=R(U);if(!f)return p.writeFileSync(T,V,{mode:B.mode,flag:B.flag});const N=p.openSync(T,B.flag,B.mode);try{p.writeFileSync(N,V);try{p.fdatasyncSync(N)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),f=!1}}finally{p.closeSync(N)}}e.writeFileSync=k;function R(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function A(T,V){if(T===V)return;async function U(B){try{const N=await e.Promises.lstat(B);if(N.isDirectory()||N.isSymbolicLink())return;await e.Promises.utimes(B,N.atime,new Date)}catch(N){}}try{await e.Promises.rename(T,V),await U(V)}catch(B){if(T.toLowerCase()!==V.toLowerCase()&&B.code==="EXDEV"||T.endsWith("."))await F(T,V,{preserveSymlinks:!1}),await t(T,m.MOVE),await U(V);else throw B}}async function F(T,V,U){return ie(T,V,{root:{source:T,target:V},options:U,handledSourcePaths:new Set})}const H=511;async function ie(T,V,U){if(U.handledSourcePaths.has(T))return;U.handledSourcePaths.add(T);const{stat:B,symbolicLink:N}=await s.stat(T);if(N){if(U.options.preserveSymlinks)try{return await ee(T,V,U)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(N.dangling)return}return B.isDirectory()?re(T,V,B.mode&H,U):G(T,V,B.mode&H)}async function re(T,V,U,B){await e.Promises.mkdir(V,{recursive:!0,mode:U});const N=await I(T);for(const _ of N)await ie((0,h.join)(T,_),(0,h.join)(V,_),B)}async function G(T,V,U){await e.Promises.copyFile(T,V),await e.Promises.chmod(V,U)}async function ee(T,V,U){let B=await e.Promises.readlink(T);(0,P.isEqualOrParent)(B,U.root.source,!d.isLinux)&&(B=(0,h.join)(U.root.target,B.substr(U.root.source.length+1))),await e.Promises.symlink(B,V)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(0,D.promisify)(p.read)}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(0,D.promisify)(p.write)}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return n}get writeFile(){return a}get rm(){return t}get move(){return A}get copy(){return F}}}),define(Z[83],x([0,1,29,8,25,20]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(i){const S=(0,L.dirname)(i);if(i===S)return i;const v=((0,L.basename)(i)||i).toLowerCase();try{const t=(0,M.readdirSync)(S).filter(g=>g.toLowerCase()===v);if(t.length===1){const g=P(S);if(g)return(0,L.join)(g,t[0])}else if(t.length>1){const g=t.indexOf(v);if(g>=0){const b=P(S);if(b)return(0,L.join)(b,t[g])}}}catch(m){}return null}e.realcaseSync=P;async function E(i){try{return await M.Promises.realpath(i)}catch(S){const v=d(i);return await M.Promises.access(v,p.constants.R_OK),v}}e.realpath=E;function h(i){try{return p.realpathSync(i)}catch(S){const v=d(i);return p.accessSync(v,p.constants.R_OK),v}}e.realpathSync=h;function d(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[117],x([0,1,62]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(E,h,d,i=1){let S=!1;return new Promise(v=>{const m=setTimeout(()=>{if(!S)return S=!0,v(0)},d);D(E,h,i,t=>{if(!S)return S=!0,clearTimeout(m),v(t)})})}e.findFreePort=L;function D(E,h,d,i){if(h===0)return i(0);const S=new p.Socket;S.once("connect",()=>(P(S),D(E+d,h-1,d,i))),S.once("data",()=>{}),S.once("error",v=>(P(S),v.code!=="ECONNREFUSED"?D(E+d,h-1,d,i):i(E))),S.connect(E,"127.0.0.1")}function M(E,h,d){let i=!1,S,v=1;const m=p.createServer({pauseOnConnect:!0});function t(g,b){i||(i=!0,m.removeAllListeners(),m.close(),S&&clearTimeout(S),b(g))}return new Promise(g=>{S=setTimeout(()=>{t(0,g)},d),m.on("listening",()=>{t(E,g)}),m.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&v<h?(E++,v++,m.listen(E,"127.0.0.1")):t(0,g)}),m.on("close",()=>{t(0,g)}),m.listen(E,"127.0.0.1")})}e.findFreePortFaster=M;function P(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),define(Z[118],x([0,1,26,8,20]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,P=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(h||(h={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class S{constructor(u,n,l){this.exePath=u,this.displayName=n,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:o=!1,findPreview:u=!1}={}){const n=v({useAlternateBitness:o});if(!n)return null;const l=L.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(l))return null;let s=-1,r=null;for(const w of await D.Promises.readdir(l)){let k=-1;if(u){const A=w.indexOf("-");if(A<0)continue;const F=w.substring(0,A);if(!M.test(F)||w.substring(A+1)!=="preview")continue;k=parseInt(F,10)}else{if(!M.test(w))continue;k=parseInt(w,10)}if(k<=s)continue;const R=L.join(l,w,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(r=R,s=k)}if(!r)return null;const a=n.includes("x86")?" (x86)":"",f=u?" Preview":"";return new S(r,`PowerShell${f}${a}`,!0)}async function t({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:n,pwshMsixName:l}=o?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(u))if(n.test(s)){const r=L.join(u,s,"pwsh.exe");return new S(r,l)}return null}function g(){const o=L.join(p.homedir(),".dotnet","tools","pwsh.exe");return new S(o,".NET Core PowerShell Global Tool")}function b(){const o=L.join(process.env.windir,d===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(o,"Windows PowerShell",!0)}async function*y(){let o=await m();o&&(yield o),o=await m({useAlternateBitness:!0}),o&&(yield o),o=await t(),o&&(yield o),o=g(),o&&(yield o),o=await m({findPreview:!0}),o&&(yield o),o=await t({findPreview:!0}),o&&(yield o),o=await m({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=b(),o&&(yield o)}async function*I(){for await(const o of y())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=I;async function c(){for await(const o of I())return o;return null}e.getFirstAvailablePowerShellInstallation=c}),define(Z[84],x([0,1,44,10]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((E,h)=>{let d;const i=new Map;function S(m,t,g,b,y){const I=i.get(t);if(m===P||I){const c={name:v(g),cmd:g,pid:m,ppid:t,load:b,mem:y};i.set(m,c),m===P&&(d=c),I&&(I.children||(I.children=[]),I.children.push(c),I.children.length>1&&(I.children=I.children.sort((o,u)=>o.pid-u.pid)))}}function v(m){const t=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,y=/\\pipe\\winpty-control/,I=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(g.exec(m))return"watcherService ";if(b.exec(m))return"electron-crash-reporter";if(y.exec(m))return"winpty-process";if(I.exec(m))return"console-window-host (Windows internal process)";let o=c.exec(m);if(o&&o.length===2)return o[1]==="renderer"?t.exec(m)?"shared-process":"window":o[1];const u=/[a-zA-Z-]+\.js/g;let n="";do o=u.exec(m),o&&(n+=o+" ");while(o);return n&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${n}`:m}if(process.platform==="win32"){const m=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,g)=>{j(["windows-process-tree"],t,g)}).then(t=>{t.getProcessList(P,g=>{t.getProcessCpuUsage(g,b=>{const y=new Map;b.forEach(I=>{const c=m(I.commandLine||"");y.set(I.pid,{name:v(c),cmd:c,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),d=y.get(P),d?(y.forEach(I=>{const c=y.get(I.ppid);c&&(c.children||(c.children=[]),c.children.push(I))}),y.forEach(I=>{I.children&&(I.children=I.children.sort((c,o)=>c.pid-o.pid))}),E(d)):h(new Error(`Root process ${P} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let m=function(){let t=[d];const g=[];for(;t.length;){const y=t.shift();y&&(g.push(y.pid),y.children&&(t=t.concat(y.children)))}let b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);b+=" "+g.join(" "),(0,p.exec)(b,{},(y,I,c)=>{if(y||c)h(y||new Error(c.toString()));else{const o=I.toString().split(`
`);for(let u=0;u<g.length;u++){const n=i.get(g[u]);n.load=parseFloat(o[u])}if(!d){h(new Error(`Root process ${P} not found`));return}E(d)}})};(0,p.exec)("which ps",{},(t,g,b)=>{if(t||b)if(process.platform!=="linux")h(t||new Error(b.toString()));else{const y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(y,{},(I,c,o)=>{I||o?h(I||new Error(o.toString())):(M(c,S),m())})}else{const y=g.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${y} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,o,u)=>{c||u&&!u.includes("screen size is bogus")?h(c||new Error(u.toString())):(M(o,S),process.platform==="linux"?m():d?E(d):h(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function M(P,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=P.toString().split(`
`);for(const i of d){const S=h.exec(i.trim());S&&S.length===6&&E(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(Z[119],x([0,1,29,23,33,2,69,8,3,20]),function(j,e,p,L,D,M,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(t,g,b){return v({path:t,isDirectory:!1},g,b)}e.watchFile=i;function S(t,g,b){return v({path:t,isDirectory:!0},g,b)}e.watchFolder=S,e.CHANGE_BUFFER_DELAY=100;function v(t,g,b){if(h.isMacintosh&&(0,D.isEqualOrParent)(t.path,"/Volumes/"))return b(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const y=(0,E.basename)(t.path),I=new Map;let c=!1,o=[(0,M.toDisposable)(()=>{I.forEach(u=>(0,M.dispose)(u)),I.clear()})];try{const u=(0,p.watch)(t.path);o.push((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const n=new Set;t.isDirectory&&d.Promises.readdir(t.path).then(l=>l.forEach(s=>n.add(s))),u.on("error",(l,s)=>{c||b(`Failed to watch ${t.path} for changes using fs.watch() (${l}, ${s})`)}),u.on("change",(l,s)=>{if(c)return;let r="";if(s&&(r=s.toString(),h.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!r||l!=="change"&&l!=="rename")return;const a=t.isDirectory?(0,E.join)(t.path,r):t.path;if(t.isDirectory)if(l==="rename"){const f=I.get(a);f&&(0,M.dispose)(f);const w=setTimeout(async()=>{I.delete(a);const k=await d.Promises.exists(a);if(c)return;let R;k?n.has(r)?R="changed":(R="added",n.add(r)):(n.delete(r),R="deleted"),g(R,a)},e.CHANGE_BUFFER_DELAY);I.set(a,(0,M.toDisposable)(()=>clearTimeout(w)))}else{let f;n.has(r)?f="changed":(f="added",n.add(r)),g(f,a)}else if(l==="rename"||r!==y){const f=setTimeout(async()=>{const w=await d.Promises.exists(a);c||(w?(g("changed",a),o=[v(t,g,b)]):g("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(o),o=[(0,M.toDisposable)(()=>clearTimeout(f))]}else g("changed",a)})}catch(u){d.Promises.exists(t.path).then(n=>{n&&!c&&b(`Failed to watch ${t.path} for changes using fs.watch() (${u.toString()})`)})}return(0,M.toDisposable)(()=>{c=!0,o=(0,M.dispose)(o)})}async function m(t,g,b,y=512){const I=await d.Promises.open(t,"r"),c=Buffer.allocUnsafe(y),o=new L.CancellationTokenSource(b);let u,n=!1;const l=i(t,async s=>{if(s==="changed"){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await d.Promises.read(I,c,0,y,null);if(!r||o.token.isCancellationRequested)break;g(c.slice(0,r))}}catch(r){u=new Error(r),o.dispose(!0)}finally{n=!1}}},s=>{u=new Error(s),o.dispose(!0)});return new Promise((s,r)=>{o.token.onCancellationRequested(async()=>{l.dispose(),await d.Promises.close(I),u?r(u):s()})})}e.watchFileContents=m}),define(Z[120],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[121],x([0,1,13,14,120]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(E,h,d,i,S)=>{const v=P(E,i,d);v.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(E.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{v&&E.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=M;function P(E,h,d){const i=new p.Menu;return d.forEach(S=>{let v;S.type==="separator"?v=new p.MenuItem({type:S.type}):Array.isArray(S.submenu)?v=new p.MenuItem({submenu:P(E,h,S.submenu),label:S.label}):v=new p.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(m,t,g)=>E.sender.send(h,S.id,g)}),i.append(v)}),i}});var he=this&&this.__decorate||function(j,e,p,L){var D=arguments.length,M=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(j,e,p,L);else for(var E=j.length-1;E>=0;E--)(P=j[E])&&(M=(D<3?P(M):D>3?P(e,p,M):P(e,p))||M);return D>3&&M&&Object.defineProperty(e,p,M),M};define(Z[35],x([0,1,31,9,17,23,46,16,4,2,111,25,14]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function t(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function b(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(y||(y={}));class I{constructor(_){this.buffer=_,this.pos=0}read(_){const X=this.buffer.slice(this.pos,this.pos+_);return this.pos+=X.byteLength,X}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var o;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(o||(o={}));function u(N){const _=D.VSBuffer.alloc(4);return _.writeUInt32BE(N,0),_}function n(N){return N.read(4).readUInt32BE(0)}function l(N){const _=D.VSBuffer.alloc(1);return _.writeUInt8(N,0),_}const s={Undefined:l(o.Undefined),String:l(o.String),Buffer:l(o.Buffer),VSBuffer:l(o.VSBuffer),Array:l(o.Array),Object:l(o.Object)},r=typeof Buffer!="undefined";function a(N,_){if(typeof _=="undefined")N.write(s.Undefined);else if(typeof _=="string"){const X=D.VSBuffer.fromString(_);N.write(s.String),N.write(u(X.byteLength)),N.write(X)}else if(r&&Buffer.isBuffer(_)){const X=D.VSBuffer.wrap(_);N.write(s.Buffer),N.write(u(X.byteLength)),N.write(X)}else if(_ instanceof D.VSBuffer)N.write(s.VSBuffer),N.write(u(_.byteLength)),N.write(_);else if(Array.isArray(_)){N.write(s.Array),N.write(u(_.length));for(const X of _)a(N,X)}else{const X=D.VSBuffer.fromString(JSON.stringify(_));N.write(s.Object),N.write(u(X.byteLength)),N.write(X)}}function f(N){switch(N.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return N.read(n(N)).toString();case o.Buffer:return N.read(n(N)).buffer;case o.VSBuffer:return N.read(n(N));case o.Array:{const X=n(N),W=[];for(let z=0;z<X;z++)W.push(f(N));return W}case o.Object:return JSON.parse(N.read(n(N)).toString())}}class w{constructor(_,X,W=null,z=1e3){this.protocol=_,this.ctx=X,this.logger=W,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(_,X){this.channels.set(_,X),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const X=this.send([_.type]);this.logger&&this.logger.logOutgoing(X,0,1,b(_.type));return}case 201:case 202:case 204:case 203:{const X=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(X,_.id,1,b(_.type),_.data);return}}}send(_,X=void 0){const W=new c;return a(W,_),a(W,X),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(X){return 0}}onRawMessage(_){const X=new I(_),W=f(X),z=f(X),K=W[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}: ${W[2]}.${W[3]}`,z),this.onPromise({type:K,id:W[1],channelName:W[2],name:W[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}: ${W[2]}.${W[3]}`,z),this.onEventListen({type:K,id:W[1],channelName:W[2],name:W[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}`),this.disposeActiveRequest({type:K,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${t(K)}`),this.disposeActiveRequest({type:K,id:W[1]})}}onPromise(_){const X=this.channels.get(_.channelName);if(!X){this.collectPendingRequest(_);return}const W=new M.CancellationTokenSource;let z;try{z=X.call(this.ctx,_.name,_.arg,W.token)}catch(q){z=Promise.reject(q)}const K=_.id;z.then(q=>{this.sendResponse({id:K,data:q,type:201}),this.activeRequests.delete(_.id)},q=>{q instanceof Error?this.sendResponse({id:K,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:K,data:q,type:203}),this.activeRequests.delete(_.id)});const O=(0,d.toDisposable)(()=>W.cancel());this.activeRequests.set(_.id,O)}onEventListen(_){const X=this.channels.get(_.channelName);if(!X){this.collectPendingRequest(_);return}const W=_.id,K=X.listen(this.ctx,_.name,_.arg)(O=>this.sendResponse({id:W,data:O,type:204}));this.activeRequests.set(_.id,K)}disposeActiveRequest(_){const X=this.activeRequests.get(_.id);X&&(X.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let X=this.pendingRequests.get(_.channelName);X||(X=[],this.pendingRequests.set(_.channelName,X));const W=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:_,timeoutTimer:W})}flushPendingRequests(_){const X=this.pendingRequests.get(_);if(X){for(const W of X)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var k;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(_,X=null){this.protocol=_,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=X}getChannel(_){const X=this;return{call(W,z,K){return X.isDisposed?Promise.reject(E.canceled()):X.requestPromise(_,W,z,K)},listen(W,z){return X.isDisposed?Promise.reject(E.canceled()):X.requestEvent(_,W,z)}}}requestPromise(_,X,W,z=M.CancellationToken.None){const K=this.lastRequestId++,q={id:K,type:100,channelName:_,name:X,arg:W};if(z.isCancellationRequested)return Promise.reject(E.canceled());let C;return new Promise((J,Q)=>{if(z.isCancellationRequested)return Q(E.canceled());const ne=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(K),J(ge.data);break;case 202:this.handlers.delete(K);const de=new Error(ge.data.message);de.stack=ge.data.stack,de.name=ge.data.name,Q(de);break;case 203:this.handlers.delete(K),Q(ge.data);break}};this.handlers.set(K,ce),this.sendRequest(q)};let le=null;this.state===y.Idle?ne():(le=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),le.then(()=>{le=null,ne()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:K,type:101}),Q(E.canceled())},se=z.onCancellationRequested(oe);C=(0,d.combinedDisposable)((0,d.toDisposable)(oe),se),this.activeRequests.add(C)}).finally(()=>{this.activeRequests.delete(C)})}requestEvent(_,X,W){const z=this.lastRequestId++,O={id:z,type:102,channelName:_,name:X,arg:W};let q=null;const C=new h.Emitter({onFirstListenerAdd:()=>{q=(0,L.createCancelablePromise)(J=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(C),this.sendRequest(O)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(C),this.sendRequest({id:z,type:103}))}}),$=J=>C.fire(J.data);return this.handlers.set(z,$),C.event}sendRequest(_){switch(_.type){case 100:case 102:{const X=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(X,_.id,0,`${t(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const X=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(X,_.id,0,t(_.type));return}}}send(_,X=void 0){const W=new c;return a(W,_),a(W,X),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(X){return 0}}onBuffer(_){const X=new I(_),W=f(X),z=f(X),K=W[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,b(K)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],0,b(K),z),this.onResponse({type:W[0],id:W[1],data:z})}}onResponse(_){if(_.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(_.id);X&&X(_)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}he([P.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class A{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:X,onDidClientDisconnect:W})=>{h.Event.once(X.onMessage)(K=>{const O=new I(K),q=f(O),C=new w(X,q),$=new R(X);this.channels.forEach((Q,ne)=>C.registerChannel(ne,Q));const J={channelServer:C,channelClient:$,ctx:q};this._connections.add(J),this._onDidAddConnection.fire(J),W(()=>{C.dispose(),$.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const _=[];return this._connections.forEach(X=>_.push(X)),_}getChannel(_,X){const W=this;return{call(z,K,O){let q;if((0,v.isFunction)(X)){let $=(0,p.getRandomElement)(W.connections.filter(X));q=$?Promise.resolve($):h.Event.toPromise(h.Event.filter(W.onDidAddConnection,X))}else q=X.routeCall(W,z,K);const C=q.then($=>$.channelClient.getChannel(_));return H(C).call(z,K,O)},listen(z,K){if((0,v.isFunction)(X))return W.getMulticastEvent(_,X,z,K);const O=X.routeEvent(W,z,K).then(q=>q.channelClient.getChannel(_));return H(O).listen(z,K)}}}getMulticastEvent(_,X,W,z){const K=this;let O=new d.DisposableStore;const q=new h.Emitter({onFirstListenerAdd:()=>{O=new d.DisposableStore;const C=new h.EventMultiplexer,$=new Map,J=ne=>{const oe=ne.channelClient.getChannel(_).listen(W,z),se=C.add(oe);$.set(ne,se)},Q=ne=>{const le=$.get(ne);!le||(le.dispose(),$.delete(ne))};K.connections.filter(X).forEach(J),h.Event.filter(K.onDidAddConnection,X)(J,void 0,O),K.onDidRemoveConnection(Q,void 0,O),C.event(q.fire,q,O),O.add(C)},onLastListenerRemove:()=>{O.dispose()}});return q.event}registerChannel(_,X){this.channels.set(_,X),this._connections.forEach(W=>{W.channelServer.registerChannel(_,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class F{constructor(_,X,W=null){const z=new c;a(z,X),_.send(z.buffer),this.channelClient=new R(_,W),this.channelServer=new w(_,X,W)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,X){this.channelServer.registerChannel(_,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function H(N){return{call(_,X,W){return N.then(z=>z.call(_,X,W))},listen(_,X){const W=new h.Relay;return N.then(z=>W.input=z.listen(_,X)),W.event}}}e.getDelayedChannel=H;function ie(N){let _=!1;return{call(X,W,z){return _?N.call(X,W,z):(0,L.timeout)(0).then(()=>_=!0).then(()=>N.call(X,W,z))},listen(X,W){if(_)return N.listen(X,W);const z=new h.Relay;return(0,L.timeout)(0).then(()=>_=!0).then(()=>z.input=N.listen(X,W)),z.event}}}e.getNextTickChannel=ie;class re{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const X of _.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await h.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=re;var G;(function(N){function _(K,O){const q=K,C=O&&O.disableMarshalling,$=new Map;for(const J in q)W(J)&&$.set(J,h.Event.buffer(q[J],!0));return new class{listen(J,Q,ne){const le=$.get(Q);if(le)return le;if(z(Q)){const oe=q[Q];if(typeof oe=="function")return oe.call(q,ne)}throw new Error(`Event not found: ${Q}`)}call(J,Q,ne){const le=q[Q];if(typeof le=="function"){if(!C&&Array.isArray(ne))for(let oe=0;oe<ne.length;oe++)ne[oe]=(0,i.revive)(ne[oe]);return le.apply(q,ne)}throw new Error(`Method not found: ${Q}`)}}}N.fromService=_;function X(K,O){const q=O&&O.disableMarshalling;return new Proxy({},{get(C,$){if(typeof $=="string")return O?.properties?.has($)?O.properties.get($):z($)?function(J){return K.listen($,J)}:W($)?K.listen($):async function(...J){let Q;O&&!(0,v.isUndefinedOrNull)(O.context)?Q=[O.context,...J]:Q=J;const ne=await K.call($,Q);return q?ne:(0,i.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}N.toService=X;function W(K){return K[0]==="o"&&K[1]==="n"&&S.isUpperAsciiLetter(K.charCodeAt(2))}function z(K){return/^onDynamic/.test(K)&&S.isUpperAsciiLetter(K.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let _=N.toString();if(_!=="[object Object]")return _}return N}function V(N){return Array.isArray(N)?N.map(T):T(N)}function U(N,_,X,W,z,K,O){O=V(O);const q=ee[z],C=q[W%q.length];let $=[`%c[${N}]%c[${String(_).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(K)?($=$.concat(O),$.push(")")):$.push(O),console.log.apply(console,$)}e.logWithColors=U;class B{constructor(_,X){this._outgoingPrefix=_,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,X,W,z,K){this._totalOutgoing+=_,U(this._outgoingPrefix,this._totalOutgoing,_,X,W,z,K)}logIncoming(_,X,W,z,K){this._totalIncoming+=_,U(this._incomingPrefix,this._totalIncoming,_,X,W,z,K)}}e.IPCLogger=B}),define(Z[122],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,M){this.sender=D,this.onMessage=M}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[123],x([0,1,17,4,35]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",d=>p.VSBuffer.wrap(d.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class P extends D.IPCClient{constructor(h,d){const i=new M(h);super(i,d);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Z[85],x([0,1,17,4,2,3,32,35]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var h;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let d=null;function i(){return d||(d=p.VSBuffer.alloc(0)),d}class S{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let f=p.VSBuffer.alloc(r),w=0,k=0;for(;r>0;){const R=this._chunks[k];if(R.byteLength>r){const A=R.slice(0,r);f.set(A,w),w+=r,a&&(this._chunks[k]=R.slice(r),this._totalLength-=r),r-=r}else f.set(R,w),w+=R.byteLength,a?(this._chunks.shift(),this._totalLength-=R.byteLength):k++,r-=R.byteLength}return f}}e.ChunkStream=S;var v;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(v||(v={}));var m;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class t{constructor(r,a,f,w){this.type=r,this.id=a,this.ack=f,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends D.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const f=this._state.messageType,w=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new t(f,w,k,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=p.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._writeSoon(a,r.data)}_bufferAdd(r,a){const f=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,f}_bufferTake(){const r=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends D.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new t(1,0,0,r))}}e.Protocol=y;class I extends E.IPCClient{constructor(r,a,f=null){super(r,a,f);this.protocol=r}static fromSocket(r,a){return new I(new y(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=I;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class o{constructor(r){this.data=r,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,f=this._first;for(;f;)r[a++]=f.data,f=f.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new o(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class n{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<n._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=n._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const r=Date.now(),a=(1+n._HISTORY_LENGTH)*1e3;let f=0;for(let w=0;w<n._HISTORY_LENGTH;w++)r-this.lastRuns[w]<=a&&f++;return 1-f/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class l{constructor(r,a=null,f=n.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=f,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new t(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const a=new t(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let a=0,f=r.length;a<f;a++)this._socketWriter.write(r[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new t(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const a=this._outgoingUnackMsg.toArray();for(let f=0,w=a.length;f<w;f++)this._socketWriter.write(a[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new t(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(r){const a=new t(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new t(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=l}),define(Z[124],x([0,1,13,17,4,2,35,122]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(i,S){const v=D.Event.fromNodeEventEmitter(p.ipcMain,S,(t,g)=>({event:t,message:g})),m=D.Event.filter(v,({event:t})=>t.sender.id===i);return D.Event.map(m,({message:t})=>t&&L.VSBuffer.wrap(t))}class d extends P.IPCServer{constructor(){super(d.getOnDidClientConnect())}static getOnDidClientConnect(){const S=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:v})=>v);return D.Event.map(S,v=>{const m=v.id,t=d.Clients.get(m);t&&t.dispose();const g=new D.Emitter;d.Clients.set(m,(0,M.toDisposable)(()=>g.fire()));const b=h(m,"vscode:message"),y=D.Event.any(D.Event.signal(h(m,"vscode:disconnect")),g.event);return{protocol:new E.Protocol(v,b),onDidClientDisconnect:y}})}}e.Server=d,d.Clients=new Map}),define(Z[86],x([0,1,13,4,28,123]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends M.Client{constructor(d,i){super({addEventListener:(S,v)=>d.addListener(S,v),removeEventListener:(S,v)=>d.removeListener(S,v),postMessage:S=>d.postMessage(S),start:()=>d.start(),close:()=>d.close()},i)}}e.Client=P;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,D.generateUuid)();h.webContents.send("vscode:createMessageChannel",d);const i=L.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(v,m)=>({nonce:m,port:v.ports[0]})),{port:S}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,v=>v.nonce===d)));return S}e.connect=E}),define(Z[87],x([0,1,9,4,2,14]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function E(S){const v=S;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var h;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(h||(h={}));class d extends D.Disposable{constructor(v,m=Object.create(null)){super();this.database=v,this.options=m,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((m,t)=>this.accept(t,m)),v.deleted?.forEach(m=>this.accept(m,void 0))}accept(v,m){if(this.state===h.Closed)return;let t=!1;(0,M.isUndefinedOrNull)(m)?t=this.cache.delete(v):this.cache.get(v)!==m&&(this.cache.set(v,m),t=!0),t&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,m){const t=this.cache.get(v);return(0,M.isUndefinedOrNull)(t)?m:t}getBoolean(v,m){const t=this.get(v);return(0,M.isUndefinedOrNull)(t)?m:t==="true"}getNumber(v,m){const t=this.get(v);return(0,M.isUndefinedOrNull)(t)?m:parseInt(t,10)}async set(v,m){if(this.state===h.Closed)return;if((0,M.isUndefinedOrNull)(m))return this.delete(v);const t=String(m);if(this.cache.get(v)!==t)return this.cache.set(v,t),this.pendingInserts.set(v,t),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===h.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((m,t)=>this.items.set(t,m)),v.delete&&v.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[125],x([0,1,9,4,40,8,20]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(i,S=Object.create(null)){this.path=i,this.options=S,this.name=(0,M.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,S=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(m=>S.set(m.key,m.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${S.size} rows`),S}async updateItems(i){const S=await this.whenConnected;return this.doUpdateItems(S,i)}doUpdateItems(i,S){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${S.insert?(0,D.mapToString)(S.insert):"0"}), delete(${S.delete?(0,D.setToString)(S.delete):"0"})`),this.transaction(i,()=>{const v=S.insert,m=S.delete;if(v&&v.size>0){const t=[];t.push([]);let g=0;v.forEach((b,y)=>{let I=t[g];I.length>E.MAX_HOST_PARAMETERS&&(g++,I=[],t.push(I)),I.push(y,b)}),t.forEach(b=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,y=>y.run(b),()=>{const y=[];let I=0;return v.forEach((c,o)=>{y.push(o),I+=c.length}),`Keys: ${y.join(", ")} Length: ${I}`})})}if(m&&m.size){const t=[];t.push([]);let g=0;m.forEach(b=>{let y=t[g];y.length>E.MAX_HOST_PARAMETERS&&(g++,y=[],t.push(y)),y.push(b)}),t.forEach(b=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,y=>y.run(b),()=>{const y=[];return m.forEach(I=>{y.push(I)}),`Keys: ${y.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const S=await this.whenConnected;return this.doClose(S,i)}doClose(i,S){return new Promise((v,m)=>{i.db.close(t=>(t&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${t}`),this.path===E.IN_MEMORY_PATH?v():!i.isErroneous&&!i.isInMemory?this.backup().then(v,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),v())):typeof S=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const b=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:S()}).then(()=>b(),y=>(b(),Promise.reject(y)))})).then(v,m):m(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return P.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const S=await this.whenConnected,v=await this.get(S,i?"PRAGMA integrity_check":"PRAGMA quick_check"),m=i?v.integrity_check:v.quick_check;return S.isErroneous?`${m} (last error: ${S.lastError})`:S.isInMemory?`${m} (in-memory!)`:m}async connect(i,S=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${S})`);try{return await this.doConnect(i)}catch(v){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&S)return await(0,p.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await P.Promises.unlink(i);try{await P.Promises.rename(this.toBackupPath(i),i)}catch(m){}return await this.doConnect(i)}catch(m){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${m}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(i,S){i.isErroneous=!0,i.lastError=S,this.logger.error(S)}doConnect(i){return new Promise((S,v)=>{new Promise((m,t)=>{j(["@vscode/sqlite3"],m,t)}).then(m=>{const t={db:new(this.logger.isTracing?m.verbose().Database:m.Database)(i,g=>g?t.db?t.db.close(()=>v(g)):v(g):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(t),b=>t.db.close(()=>v(b)))),isInMemory:i===E.IN_MEMORY_PATH};t.db.on("error",g=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&t.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},v)})}exec(i,S){return new Promise((v,m)=>{i.db.exec(S,t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${t}`),m(t)):v())})}get(i,S){return new Promise((v,m)=>{i.db.get(S,(t,g)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${t}`),m(t)):v(g))})}all(i,S){return new Promise((v,m)=>{i.db.all(S,(t,g)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${t}`),m(t)):v(g))})}transaction(i,S){return new Promise((v,m)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),S(),i.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${t}`),m(t)):v())})})}prepare(i,S,v,m){const t=i.db.prepare(S),g=b=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${b} (${S}). Details: ${m()}`)};t.on("error",g),v(t),t.finalize(b=>{b&&g(b),t.removeListener("error",g)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class h{constructor(i){i&&typeof i.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[126],x([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Z[127],x([0,1,126]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,M=D*24,P=M*7,E=M*30,h=M*365;function d(S,v){typeof S!="number"&&(S=S.getTime());const m=Math.round((new Date().getTime()-S)/1e3);if(m<-30)return(0,p.localize)(0,null,d(new Date().getTime()+m*1e3,!1));if(m<30)return(0,p.localize)(1,null);let t;return m<L?(t=m,v?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):m<D?(t=Math.floor(m/L),v?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):m<M?(t=Math.floor(m/D),v?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):m<P?(t=Math.floor(m/M),v?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):m<E?(t=Math.floor(m/P),v?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):m<h?(t=Math.floor(m/E),v?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(m/h),v?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=d;function i(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[128],x([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Z[55],x([0,1,31,14,128]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(d,i){return i&&(d.stack||d.stacktrace)?D.localize(0,null,E(d),P(d.stack)||P(d.stacktrace)):E(d)}function P(d){return Array.isArray(d)?d.join(`
`):d}function E(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?D.localize(1,null,d.message):d.message||D.localize(2,null)}function h(d=null,i=!1){if(!d)return D.localize(3,null);if(Array.isArray(d)){const S=p.coalesce(d),v=h(S[0],i);return S.length>1?D.localize(4,null,v,S.length):v}if(L.isString(d))return d;if(d.detail){const S=d.detail;if(S.error)return M(S.error,i);if(S.exception)return M(S.exception,i)}return d.stack?M(d,i):d.message?d.message:D.localize(5,null)}e.toErrorMessage=h}),define(Z[129],x([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Z[130],x([0,1,129]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(P,E,h=E){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=E,this.modifierLabels[3]=h}toLabel(P,E,h){if(E.length===0)return null;const d=[];for(let i=0,S=E.length;i<S;i++){const v=E[i],m=h(v);if(m===null)return null;d[i]=D(v,m,this.modifierLabels[P])}return d.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(M,P,E){if(P===null)return"";const h=[];return M.ctrlKey&&h.push(E.ctrlKey),M.shiftKey&&h.push(E.shiftKey),M.altKey&&h.push(E.altKey),M.metaKey&&h.push(E.metaKey),P!==""&&h.push(P),h.join(E.separator)}}),define(Z[131],x([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Z[71],x([0,1,44,33,10,43,8,3,32,81,14,114,20,131]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function t(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(n,l){if(E.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};l&&(s.cwd=l);const r=p.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],s);return new Promise(a=>{r.once("error",f=>{a({success:!1,error:f})}),r.once("exit",(f,w)=>{a(f===0?{success:!0}:{success:!1,code:f!==null?f:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(E.isLinux||E.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(r=>{p.execFile(s,[n.pid.toString()],{encoding:"utf8",shell:!0},(a,f,w)=>{r(a?{success:!1,error:a}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function b(n){!n||(delete n.DEBUG,E.isMacintosh&&delete n.DYLD_LIBRARY_PATH,E.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function y(n=h.env){return n.comspec||"cmd.exe"}e.getWindowsShell=y;class I{constructor(l,s,r,a){if(s!==void 0&&r!==void 0&&a!==void 0)this.cmd=l,this.args=s,this.shell=r,this.options=a;else{const f=l;this.cmd=f.command,this.shell=f.isShellCommand,this.args=f.args.slice(0),this.options=f.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const f=Object.create(null);Object.keys(h.env).forEach(w=>{f[w]=h.env[w]}),Object.keys(this.options.env).forEach(w=>{f[w]=this.options.env[w]}),this.options.env=f}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const s=l.lastIndexOf(P.sep);return s!==-1&&(l=l.substring(s+1)),I.WellKnowCommands[l]?l:"other"}start(l){return E.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(h.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(s=>{let r,a;const f=new Promise((w,k)=>{r=w,a=k});if(s){let w=this.cmd;this.args&&(w=w+" "+this.args.join(" ")),this.childProcess=p.exec(w,this.options,(k,R,A)=>{this.childProcess=null;const F=k;F&&F.killed?a({killed:this.terminateRequested,stdout:R.toString(),stderr:A.toString()}):this.handleExec(r,l,k,R,A)})}else{let w=null;const k=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,r,l,a);const A={terminated:this.terminateRequested};i.isNumber(R)&&(A.cmdCode=R),r(A)};if(this.shell&&E.isWindows){const R=M.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let A=!1,F=!1;const H=[];let ie=this.ensureQuotes(this.cmd);H.push(ie.value),A=ie.quoted,this.args&&this.args.forEach(G=>{ie=this.ensureQuotes(G),H.push(ie.value),F=F&&ie.quoted});const re=["/s","/c"];A?F?re.push('"'+H.join(" ")+'"'):H.length>1?re.push('"'+H[0]+'" '+H.slice(1).join(" ")):re.push('"'+H[0]+'"'):re.push(H.join(" ")),w=p.spawn(y(),re,R)}else this.cmd&&(w=p.spawn(this.cmd,this.args,this.options));w&&(this.childProcess=w,this.childProcessPromise=Promise.resolve(w),this.pidResolve&&(this.pidResolve(i.isNumber(w.pid)?w.pid:-1),this.pidResolve=void 0),w.on("error",R=>{this.childProcess=null,a({terminated:this.terminateRequested,error:R})}),w.pid&&(this.childProcess.on("close",k),this.handleSpawn(w,r,l,a,!0)))}return f})}handleClose(l,s,r,a){}ensureQuotes(l){return I.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,g(l,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!E.isWindows)return l(!1);const s=p.spawn(y(),["/s","/c"]);s.on("error",r=>l(!0)),s.on("exit",r=>l(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class c extends I{constructor(l,s,r,a){super(l,s,r,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,s,r,a,f){[a,f].forEach((w,k)=>{const R=new S.LineDecoder;R.write(w).forEach(H=>{s({line:H,source:k===0?0:1})});const F=R.end();F&&s({line:F,source:k===0?0:1})}),l({terminated:this.terminateRequested,error:r})}handleSpawn(l,s,r,a,f){const w=new S.LineDecoder,k=new S.LineDecoder;l.stdout.on("data",R=>{w.write(R).forEach(F=>r({line:F,source:0}))}),l.stderr.on("data",R=>{k.write(R).forEach(F=>r({line:F,source:1}))}),this.stdoutLineDecoder=w,this.stderrLineDecoder=k}handleClose(l,s,r,a){const f=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;f&&r({line:f,source:0});const w=this.stderrLineDecoder?this.stderrLineDecoder.end():null;w&&r({line:w,source:1})}}e.LineProcess=c;function o(n){let l=[],s=!1;const r=function(a){if(s){l.push(a);return}(!n.send(a,w=>{if(w&&console.error(w),s=!1,l.length>0){const k=l.slice(0);l=[],k.forEach(R=>r(R))}})||E.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=o;var u;(function(n){async function l(s,r,a){if(P.isAbsolute(s))return s;if(r===void 0&&(r=h.cwd()),P.dirname(s)!=="."||(a===void 0&&i.isString(h.env.PATH)&&(a=h.env.PATH.split(P.delimiter)),a===void 0||a.length===0))return P.join(r,s);async function w(k){if(await v.Promises.exists(k)){let R;try{R=await v.Promises.stat(k)}catch(A){A.message.startsWith("EACCES")&&(R=await v.Promises.lstat(k))}return R?!R.isDirectory():!1}return!1}for(let k of a){let R;if(P.isAbsolute(k)?R=P.join(k,s):R=P.join(r,k,s),await w(R))return R;let A=R+".com";if(await w(A)||(A=R+".exe",await w(A)))return A}return P.join(r,s)}n.findExecutable=l})(u=e.win32||(e.win32={}))}),define(Z[132],x([0,1,26,3,118,71]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(m,t){return m===1?L.isWindows?S():M.getWindowsShell(t):d(m,t)}e.getSystemShell=P;function E(m,t){return m===1?L.isWindows?v(t):M.getWindowsShell(t):d(m,t)}e.getSystemShellSync=E;let h=null;function d(m,t){if(L.isLinux&&m===2||L.isMacintosh&&m===3)return"/bin/bash";if(!h){let g;if(L.isWindows)g="/bin/bash";else{if(g=t.SHELL,!g)try{g=(0,p.userInfo)().shell}catch(b){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}h=g}return h}let i=null;async function S(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function v(m){if(i)return i;const t=L.isWindows&&parseFloat((0,p.release)())>=10,g=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${m.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?b:M.getWindowsShell(m)}}),define(Z[72],x([0,1,44,9,17,23,110,16,4,2,43,71,35]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends v.ChannelServer{constructor(b){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(I){}},onMessage:h.Event.fromNodeEventEmitter(process,"message",y=>D.VSBuffer.wrap(Buffer.from(y,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=m;class t{constructor(b,y){this.modulePath=b,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const I=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new L.Delayer(I),this.child=null,this._client=null}getChannel(b){const y=this;return{call(I,c,o){return y.requestPromise(b,I,c,o)},listen(I,c){return y.requestEvent(b,I,c)}}}requestPromise(b,y,I,c=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(b),u=(0,L.createCancelablePromise)(s=>o.call(y,I,s)),n=c.onCancellationRequested(()=>u.cancel()),l=(0,d.toDisposable)(()=>u.cancel());return this.activeRequests.add(l),u.finally(()=>{n.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(b,y,I){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let c;const o=new h.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(b).listen(y,I)(o.fire,o),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,S.removeDangerousEnvVariables)(y.env),this.child=(0,p.fork)(this.modulePath,b,y);const I=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,P.isRemoteConsoleLog)(r)){(0,P.log)(r,`IPC Library: ${this.options.serverName}`);return}I.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const o=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,u=r=>this.child&&this.child.connected&&o.send(r.buffer.toString("base64")),n=I.event,l={send:u,onMessage:n};this._client=new v.ChannelClient(l);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",s),this.activeRequests.forEach(f=>(0,d.dispose)(f)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(b){let y=this.channels.get(b);return y||(y=this.client.getChannel(b),this.channels.set(b,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[133],x([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Z[134],x([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[135],x([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[136],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Z[137],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Z[138],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(Z[139],x([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[140],x([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[141],x([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[142],x([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Z[143],x([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Z[144],x([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Z[145],x([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Z[146],x([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[147],x([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[148],x([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[149],x([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[150],x([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Z[151],x([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[152],x([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[153],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Z[154],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[155],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[156],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[157],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[158],x([0,1,4,2]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(E,h,d){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(E,h,d){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,h,d){this.channel.call("attach",[E,h,d])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,h){this.channel.call("terminate",[E,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.channel.call("openExtensionDevelopmentHostWindow",[E,h])}}e.ExtensionHostDebugChannelClient=M}),define(Z[159],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(P){this.driver=P}listen(P,E){throw new Error(`No event found: ${E}`)}call(P,E,h){switch(E){case"click":return this.driver.click(h[0],h[1],h[2]);case"doubleClick":return this.driver.doubleClick(h);case"setValue":return this.driver.setValue(h[0],h[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(h);case"getElements":return this.driver.getElements(h[0],h[1]);case"getElementXY":return this.driver.getElementXY(h[0],h[1],h[2]);case"typeInEditor":return this.driver.typeInEditor(h[0],h[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(h);case"writeInTerminal":return this.driver.writeInTerminal(h[0],h[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=p;class L{constructor(P){this.channel=P}click(P,E,h){return this.channel.call("click",[P,E,h])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,E){return this.channel.call("setValue",[P,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,E){return this.channel.call("getElements",[P,E])}getElementXY(P,E,h){return this.channel.call("getElementXY",[P,E,h])}typeInEditor(P,E){return this.channel.call("typeInEditor",[P,E])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,E){return this.channel.call("writeInTerminal",[P,E])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class D{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=D}),define(Z[160],x([0,1,127,46,10,8,32,15,7]),function(j,e,p,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class d{constructor(g,b,y){this._args=g,this.paths=b,this.productService=y}get appRoot(){return(0,M.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(h.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=P.env.VSCODE_PORTABLE;return g?h.URI.file((0,M.join)(g,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,M.resolve)(g):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const b=P.env.VSCODE_EXTENSIONS;if(b)return b;const y=P.env.VSCODE_PORTABLE;return y?(0,M.join)(y,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(b=>/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,M.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return h.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],d.prototype,"appRoot",null),he([L.memoize],d.prototype,"userHome",null),he([L.memoize],d.prototype,"userDataPath",null),he([L.memoize],d.prototype,"appSettingsHome",null),he([L.memoize],d.prototype,"tmpDir",null),he([L.memoize],d.prototype,"userRoamingDataHome",null),he([L.memoize],d.prototype,"settingsResource",null),he([L.memoize],d.prototype,"userDataSyncHome",null),he([L.memoize],d.prototype,"userDataSyncLogResource",null),he([L.memoize],d.prototype,"sync",null),he([L.memoize],d.prototype,"machineSettingsResource",null),he([L.memoize],d.prototype,"globalStorageHome",null),he([L.memoize],d.prototype,"workspaceStorageHome",null),he([L.memoize],d.prototype,"keybindingsResource",null),he([L.memoize],d.prototype,"keyboardLayoutResource",null),he([L.memoize],d.prototype,"argvResource",null),he([L.memoize],d.prototype,"snippetsHome",null),he([L.memoize],d.prototype,"isExtensionDevelopment",null),he([L.memoize],d.prototype,"untitledWorkspacesHome",null),he([L.memoize],d.prototype,"installSourcePath",null),he([L.memoize],d.prototype,"builtinExtensionsPath",null),he([L.memoize],d.prototype,"extensionsPath",null),he([L.memoize],d.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],d.prototype,"extensionDevelopmentKind",null),he([L.memoize],d.prototype,"extensionTestsLocationURI",null),he([L.memoize],d.prototype,"debugExtensionHost",null),he([L.memoize],d.prototype,"serviceMachineIdResource",null),he([L.memoize],d.prototype,"telemetryLogResource",null),he([L.memoize],d.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=d;function i(t,g){return m(t["inspect-extensions"],t["inspect-brk-extensions"],5870,g,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=i;function S(t,g){return m(t["inspect-search"],t["inspect-brk-search"],5876,g,t.extensionEnvironment)}e.parseSearchPort=S;function v(t,g){return m(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,g,t.extensionEnvironment)}e.parsePtyHostPort=v;function m(t,g,b,y,I,c){const u=Number(g||t)||(y?null:b),n=u?Boolean(!!g):!1;let l;if(c)try{l=JSON.parse(c)}catch{}return{port:u,break:n,debugId:I,env:l}}}),define(Z[88],x([0,1,244,3,136]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function E(t,g,b=P){const y={},I=[],c=[];for(let l in g){const s=g[l];s.alias&&(y[l]=s.alias),s.type==="string"||s.type==="string[]"?(I.push(l),s.deprecates&&I.push(s.deprecates)):s.type==="boolean"&&(c.push(l),s.deprecates&&c.push(s.deprecates))}const o=p(t,{string:I,boolean:c,alias:y}),u={},n=o;u._=o._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(let l in g){const s=g[l];s.alias&&delete n[s.alias];let r=n[l];s.deprecates&&n.hasOwnProperty(s.deprecates)&&(r||(r=n[s.deprecates]),delete n[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),b.onMultipleValues(l,r)),u[l]=r),delete n[l]}for(let l in n)b.onUnknownOption(l);return u}e.parseArgs=E;function h(t,g){let b="";return g.args&&(Array.isArray(g.args)?b=` <${g.args.join("> <")}>`:b=` <${g.args}>`),g.alias?`-${g.alias} --${t}${b}`:`--${t}${b}`}function d(t,g){let b=0,y=[];for(const u in t){const n=t[u],l=h(u,n);b=Math.max(b,l.length),y.push([l,n.description])}let I=b+2+1;if(g-I<25)return y.reduce((u,n)=>u.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let c=g-I-1,o=[];for(const u of y){let n=u[0],l=S(u[1],c),s=i(I-n.length-2);o.push("  "+n+s+l[0]);for(let r=1;r<l.length;r++)o.push(i(I)+l[r])}return o}e.formatOptions=d;function i(t){return" ".repeat(t)}function S(t,g){let b=[];for(;t.length;){let y=t.length<g?t.length:t.lastIndexOf(" ",g),I=t.slice(0,y).trim();t=t.slice(y),b.push(I)}return b}function v(t,g,b,y,I=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${t} ${b}`];o.push(""),o.push(`${(0,D.localize)(32,null)}: ${g} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),o.push(""),I&&(L.isWindows?o.push((0,D.localize)(35,null,g)):o.push((0,D.localize)(36,null,g)),o.push(""));const u={};for(const n in y){const l=y[n];if(l.description&&l.cat){let s=u[l.cat];s||(u[l.cat]=s={}),s[n]=l}}for(let n in u){const l=n;let s=u[l];s&&(o.push(M[l]),o.push(...d(s,c)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=v;function m(t,g){return`${t||(0,D.localize)(37,null)}
${g||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=m}),define(Z[161],x([0,1,62,158,88]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(E){super();this.windowsMainService=E}call(E,h,d){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(d[0],d[1]):super.call(E,h,d)}async openExtensionDevelopmentHostWindow(E,h){const d=(0,D.parseArgs)(E,D.OPTIONS);d.debugRenderer=h;const i=d.extensionDevelopmentPath;if(!i)return{success:!1};const[S]=this.windowsMainService.openExtensionDevelopmentHostWindow(i,{context:5,cli:d});if(!h)return{success:!0};const v=S.win;if(!v)return{success:!0};const m=v.webContents.debugger;let t=m.isAttached()?Infinity:0;const g=(0,p.createServer)(b=>{t++==0&&m.attach();let y=!1;const I=u=>{y||b.write(JSON.stringify(u)+"\0")},c=(u,n,l,s)=>I({method:n,params:l,sessionId:s});v.on("close",()=>{m.removeListener("message",c),b.end(),y=!0}),m.addListener("message",c);let o=Buffer.alloc(0);b.on("data",u=>{o=Buffer.concat([o,u]);for(let n=o.indexOf(0);n!==-1;n=o.indexOf(0)){let l;try{const s=o.slice(0,n).toString("utf8");o=o.slice(n+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}m.sendCommand(l.method,l.params,l.sessionId).then(s=>I({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>I({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{y=!0,--t==0&&m.detach()})});return await new Promise(b=>g.listen(0,b)),v.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function j(e,p,L,D){function M(E){const h=P(E),d=[h];return e.isAbsolute(h)||d.unshift(D),e.resolve(...d)}function P(E){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,L);const i=E["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(S,"AppData","Roaming")}break;case"darwin":d=e.join(p.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[162],x([0,245,26,10,15,32]),function(e,p,L,D,M,P){const E=M.dirname(D.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(M.joinPath(E,"package.json").fsPath);return j(p,L,h.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=j(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[163],x([0,1,26,160,162]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(E,h){super(E,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E)},h)}}e.NativeEnvironmentService=M}),define(Z[164],x([0,1,29,26,8]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(P){const E=(0,D.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(E,""),P&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){P&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=M}),define(Z[165],x([0,1,140]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function M(v){return v=v.trim(),v==="*"||L.test(v)}e.isValidVersionStr=M;function P(v){if(!M(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=v.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=P;function E(v){if(!v)return null;let m=v.majorBase,t=v.majorMustEqual,g=v.minorBase,b=v.minorMustEqual,y=v.patchBase,I=v.patchMustEqual;v.hasCaret&&(m===0||(b=!1),I=!1);let c=0;if(v.preRelease){const o=D.exec(v.preRelease);if(o){const[,u,n,l]=o;c=Date.UTC(Number(u),Number(n)-1,Number(l))}}return{majorBase:m,majorMustEqual:t,minorBase:g,minorMustEqual:b,patchBase:y,patchMustEqual:I,isMinimum:v.hasGreaterEquals,notBefore:c}}e.normalizeVersion=E;function h(v,m,t){let g;typeof v=="string"?g=E(P(v)):g=v;let b;m instanceof Date?b=m.getTime():typeof m=="string"&&(b=new Date(m).getTime());let y;if(typeof t=="string"?y=E(P(t)):y=t,!g||!y)return!1;let I=g.majorBase,c=g.minorBase,o=g.patchBase,u=y.majorBase,n=y.minorBase,l=y.patchBase,s=y.notBefore,r=y.majorMustEqual,a=y.minorMustEqual,f=y.patchMustEqual;return y.isMinimum?I>u?!0:I<u?!1:c>n?!0:c<n||b&&b<s?!1:o>=l:(I===1&&u===0&&(!r||!a||!f)&&(u=1,n=0,l=0,r=!0,a=!1,f=!1),I<u?!1:I>u?!r:c<n?!1:c>n?!a:o<l?!1:o>l?!f:!(b&&b<s))}e.isValidVersion=h;function d(v,m,t,g){return t.isBuiltin||typeof t.main=="undefined"?!0:S(v,m,t.engines.vscode,g)}e.isValidExtensionVersion=d;function i(v,m,t){return v==="*"||S(m,t,v)}e.isEngineValid=i;function S(v,m,t,g=[]){let b=E(P(t));if(!b)return g.push(p.localize(0,null,t)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(p.localize(1,null,t)),!1}else if(!b.majorMustEqual)return g.push(p.localize(2,null,t)),!1;return h(v,m,b)?!0:(g.push(p.localize(3,null,v,t)),!1)}}),define(Z[166],x([0,1,4,2,17,60,23]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class E extends L.Disposable{constructor(d,i){super();this.provider=d,this.logService=i,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(d,i,S){const v=this.getUriTransformer(d);switch(i){case"stat":return this.stat(v,S[0]);case"readdir":return this.readdir(v,S[0]);case"open":return this.open(v,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(v,S[0]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(v,S[0],S[1],S[2]);case"rename":return this.rename(v,S[0],S[1],S[2]);case"copy":return this.copy(v,S[0],S[1],S[2]);case"mkdir":return this.mkdir(v,S[0]);case"delete":return this.delete(v,S[0],S[1]);case"watch":return this.watch(v,S[0],S[1],S[2],S[3]);case"unwatch":return this.unwatch(S[0],S[1])}throw new Error(`IPC Command ${i} not found`)}listen(d,i,S){const v=this.getUriTransformer(d);switch(i){case"fileChange":return this.onFileChange(v,S[0]);case"readFileStream":return this.onReadFileStream(v,S[0],S[1])}throw new Error(`Unknown event ${i}`)}stat(d,i){const S=this.transformIncoming(d,i,!0);return this.provider.stat(S)}readdir(d,i){const S=this.transformIncoming(d,i);return this.provider.readdir(S)}async readFile(d,i){const S=this.transformIncoming(d,i,!0),v=await this.provider.readFile(S);return D.VSBuffer.wrap(v)}onReadFileStream(d,i,S){const v=this.transformIncoming(d,i,!0),m=new P.CancellationTokenSource,t=new p.Emitter({onLastListenerRemove:()=>{m.cancel()}}),g=this.provider.readFileStream(v,S,m.token);return(0,M.listenStream)(g,{onData:b=>t.fire(D.VSBuffer.wrap(b)),onError:b=>t.fire(b),onEnd:()=>{t.fire("end"),t.dispose(),m.dispose()}}),t.event}writeFile(d,i,S,v){const m=this.transformIncoming(d,i);return this.provider.writeFile(m,S.buffer,v)}open(d,i,S){const v=this.transformIncoming(d,i,!0);return this.provider.open(v,S)}close(d){return this.provider.close(d)}async read(d,i,S){const v=D.VSBuffer.alloc(S),m=0,t=await this.provider.read(d,i,v.buffer,m,S);return[v,t]}write(d,i,S,v,m){return this.provider.write(d,i,S.buffer,v,m)}mkdir(d,i){const S=this.transformIncoming(d,i);return this.provider.mkdir(S)}delete(d,i,S){const v=this.transformIncoming(d,i);return this.provider.delete(v,S)}rename(d,i,S,v){const m=this.transformIncoming(d,i),t=this.transformIncoming(d,S);return this.provider.rename(m,t,v)}copy(d,i,S,v){const m=this.transformIncoming(d,i),t=this.transformIncoming(d,S);return this.provider.copy(m,t,v)}onFileChange(d,i){const S=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(i,this.createSessionFileWatcher(d,S))},onLastListenerRemove:()=>{(0,L.dispose)(this.sessionToWatcher.get(i)),this.sessionToWatcher.delete(i)}});return S.event}async watch(d,i,S,v,m){const t=this.sessionToWatcher.get(i);if(t){const g=this.transformIncoming(d,v),b=t.watch(S,g,m);this.watchRequests.set(i+S,b)}}async unwatch(d,i){const S=d+i,v=this.watchRequests.get(S);v&&((0,L.dispose)(v),this.watchRequests.delete(S))}dispose(){super.dispose(),this.watchRequests.forEach(d=>(0,L.dispose)(d)),this.watchRequests.clear(),this.sessionToWatcher.forEach(d=>(0,L.dispose)(d)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=E}),define(Z[73],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,M=[],P=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p}),define(Z[167],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=p;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let P of this._nodes.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const E=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(P);E.outgoing.set(this._hashFn(P),h),h.incoming.set(this._hashFn(M),E)}removeNode(M){const P=this._hashFn(M);this._nodes.delete(P);for(let E of this._nodes.values())E.outgoing.delete(P),E.incoming.delete(P)}lookupOrInsertNode(M){const P=this._hashFn(M);let E=this._nodes.get(P);return E||(E=new p(M),this._nodes.set(P,E)),E}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[P,E]of this._nodes)M.push(`${P}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,P]of this._nodes){const E=new Set([M]),h=this._findCycle(P,E);if(h)return h}}_findCycle(M,P){for(let[E,h]of M.outgoing){if(P.has(E))return[...P,E].join(" -> ");P.add(E);const d=this._findCycle(h,P);if(d)return d;P.delete(E)}}}e.Graph=L}),define(Z[5],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function h(d){return d[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=h})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(E,h,d,i){h[p.DI_TARGET]===h?h[p.DI_DEPENDENCIES].push({id:E,index:d,optional:i}):(h[p.DI_DEPENDENCIES]=[{id:E,index:d,optional:i}],h[p.DI_TARGET]=h)}function D(E){if(p.serviceIds.has(E))return p.serviceIds.get(E);const h=function(d,i,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(h,d,S,!1)};return h.toString=()=>E,p.serviceIds.set(E,h),h}e.createDecorator=D;function M(E){return E}e.refineServiceDecorator=M;function P(E){return function(h,d,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(E,h,i,!0)}}e.optional=P}),define(Z[74],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[89],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,P)=>j(["vscode-encrypt"],M,P))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(P){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(P){return M}}}e.EncryptionMainService=L}),define(Z[47],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,139,5]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function P(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function E(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=E;function h(c,o){switch(c){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=h;function d(c,o){return o==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=d;function i(c,o,u){return d(o,u)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===u?!0:S(u).includes(c)}e.isTargetPlatformCompatible=i;function S(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function v(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=v;var m;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var b;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var y;(function(c){c.Unsupported="Unsupported",c.Malicious="Malicious",c.Incompatible="Incompatible",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class I extends Error{constructor(o,u){super(o);this.code=u,this.name=u}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[90],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[170],x([0,1,44,10,8,3,81,20,71,141,90]),function(j,e,p,L,D,M,P,E,h,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const S=d.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends v{openTerminal(o,u){return this.spawnTerminal(p,o,h.getWindowsShell(),u)}spawnTerminal(o,u,n,l){const s=u.windowsExec||m.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const r=D.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return o.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),(r==="wt"||r==="wt.exe")&&a.push("-d ."),new Promise((f,w)=>{const k=b(process),R=o.spawn(n,a,{cwd:l,env:k});R.on("error",w),R.on("exit",()=>f())})}runInTerminal(o,u,n,l,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,f)=>{const w=`"${u} - ${S}"`,k=`""${n.join('" "')}" & pause"`,R=["/c","start",w,"/wait",r,"/c",k],A=Object.assign({},b(process),l);Object.keys(A).filter(ie=>A[ie]===null).forEach(ie=>delete A[ie]);const F={cwd:u,env:A,windowsVerbatimArguments:!0};p.spawn(m.CMD,R,F).on("error",ie=>{f(y(ie))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class t extends v{openTerminal(o,u){return this.spawnTerminal(p,o,u)}runInTerminal(o,u,n,l,s){const r=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((a,f)=>{if(r===i.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const w=r===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`,j).fsPath,"-t",o||S,"-w",u];for(let H of n)R.push("-a"),R.push(H);if(l){const H=Object.assign({},b(process),l);for(let ie in H){const re=H[ie];re===null?(R.push("-u"),R.push(ie)):(R.push("-e"),R.push(`${ie}=${re}`))}}let A="";const F=p.spawn(t.OSASCRIPT,R);F.on("error",H=>{f(y(H))}),F.stderr.on("data",H=>{A+=H.toString()}),F.on("exit",H=>{if(H===0)a(void 0);else if(A){const ie=A.split(`
`,1);f(new Error(ie[0]))}else f(new Error(d.localize(1,null,w,H)))})}else f(new Error(d.localize(2,null,r)))})}spawnTerminal(o,u,n){const l=u.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const a=["-a",l];n&&a.push(n);const f=b(process),w=o.spawn("/usr/bin/open",a,{cwd:n,env:f});w.on("error",r),w.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class g extends v{openTerminal(o,u){return this.spawnTerminal(p,o,u)}runInTerminal(o,u,n,l,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((a,f)=>{let w=[];r.then(k=>{k.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const R=`${I(n)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;w.push(`''${R}''`);const A=Object.assign({},b(process),l);Object.keys(A).filter(re=>A[re]===null).forEach(re=>delete A[re]);const F={cwd:u,env:A};let H="";const ie=p.spawn(k,w,F);ie.on("error",re=>{f(y(re))}),ie.stderr.on("data",re=>{H+=re.toString()}),ie.on("exit",re=>{if(re===0)a(void 0);else if(H){const G=H.split(`
`,1);f(new Error(G[0]))}else f(new Error(d.localize(4,null,k,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await E.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{o?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,u,n){const l=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{l.then(a=>{const f=b(process),w=o.spawn(a,[],{cwd:n,env:f});w.on("error",r),w.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=d.localize(3,null);function b(c){const o={...c.env};return(0,P.sanitizeProcessEnvironment)(o),o}function y(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(d.localize(5,null,c.path)):c}function I(c){let o="";for(let u of c)u.indexOf(" ")>=0?o+='"'+u+'"':o+=u,o+=" ";return o}}),define(Z[18],x([0,1,40,8,25,14,7,143,5]),function(j,e,p,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function d(T){return T.create===!0}e.isFileOpenForWriteOptions=d;var i;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var S;(function(T){T[T.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var v;(function(T){T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=m;function t(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=t;function g(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=b;var y;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(V,U){super(V);this.code=U}}e.FileSystemProviderError=I;function c(T,V){const U=new I(T.toString(),V);return u(U,V),U}e.createFileSystemProviderError=c;function o(T){return T||c((0,E.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=o;function u(T,V){return T.name=V?`${V} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=u;function n(T){if(!T)return y.Unknown;if(T instanceof I)return T.code;const V=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!V)return y.Unknown;switch(V[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=n;function l(T){if(T instanceof k)return T.fileOperationResult;switch(n(T)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var s;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(V,U,B){this.resource=V,this.operation=U,this.target=B}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var a;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class f{constructor(V,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const N of V){const _=B.get(N.type);_?_.push([N.resource,N]):B.set(N.type,[[N.resource,N]])}for(const[N,_]of B)switch(N){case 1:this.added=p.TernarySearchTree.forUris(()=>U),this.added.fill(_);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>U),this.updated.fill(_);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>U),this.deleted.fill(_);break}}contains(V,...U){return this.doContains(V,{includeChildren:!1},...U)}affects(V,...U){return this.doContains(V,{includeChildren:!0},...U)}doContains(V,U,...B){if(!V)return!1;const N=B.length>0;return!!((!N||B.includes(1))&&(this.added?.get(V)||U.includeChildren&&this.added?.findSuperstr(V))||(!N||B.includes(0))&&(this.updated?.get(V)||U.includeChildren&&this.updated?.findSuperstr(V))||(!N||B.includes(2))&&(this.deleted?.findSubstr(V)||U.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function w(T,V,U){return!T||!V||T===V||V.length>T.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),U?(0,D.startsWithIgnoreCase)(T,V):T.indexOf(V)===0)}e.isParent=w;class k extends Error{constructor(V,U,B){super(V);this.fileOperationResult=U,this.options=B}}e.FileOperationError=k;class R extends k{constructor(V,U,B){super(V,2,B);this.stat=U}}e.NotModifiedSinceFileOperationError=R;var A;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function H(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=H;async function ie(T,V){if(!V.hasProvider(P.URI.from({scheme:T.scheme})))return new Promise(U=>{const B=V.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===T.scheme&&N.added&&(B.dispose(),U())})})}e.whenProviderRegistered=ie,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(V){return(0,M.isNumber)(V)||(V=0),V<re.KB?(0,E.localize)(1,null,V.toFixed(0)):V<re.MB?(0,E.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,E.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,E.localize)(4,null,(V/re.GB).toFixed(2)):(0,E.localize)(5,null,(V/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var G;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function ee(T){return{maxFileSize:T===0?300*re.MB:16*re.GB,maxHeapSize:T===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=ee}),define(Z[56],x([0,1,246,137,88,18]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(v,m){const t={onUnknownOption:b=>{console.warn((0,L.localize)(0,null,b))},onMultipleValues:(b,y)=>{console.warn((0,L.localize)(1,null,b,y))}},g=(0,D.parseArgs)(v,D.OPTIONS,m?t:void 0);return g.goto&&g._.forEach(b=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(2,null))),g["max-memory"]&&p(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function E(v){const m=v.findIndex(t=>!/^-/.test(t));if(m>-1)return[...v.slice(0,m),...v.slice(m+1)]}function h(v){let[,...m]=v;process.env.VSCODE_DEV&&(m=E(m)||[]);const t=!S(process.env);return P(m,t)}e.parseMainProcessArgv=h;function d(v){const[,,...m]=v;return P(m,!0)}e.parseCLIProcessArgv=d;function i(v,...m){const t=v.indexOf("--");return t===-1?v.push(...m):v.splice(t,0,...m),v}e.addArg=i;function S(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),define(Z[91],x([0,1,44,8,138,23,55,16,3,28,132,56,9]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const m=1e4;let t;async function g(y,I,c){return I["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(c)&&!I["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(c)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=v.Promises.withAsyncBody(async(o,u)=>{const n=new M.CancellationTokenSource,l=setTimeout(()=>{n.dispose(!0),u(new Error((0,D.localize)(0,null)))},m);try{o(await b(y,n.token))}catch(s){!(0,E.isPromiseCanceledError)(s)&&!n.token.isCancellationRequested?u(new Error((0,D.localize)(1,null,(0,P.toErrorMessage)(s)))):o({})}finally{clearTimeout(l),n.dispose()}})),t)}e.resolveShellEnv=g;async function b(y,I){const c=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",c);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",o);const u=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(u+"(.*)"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",l);const s=await(0,i.getSystemShell)(h.OS,l);return y.trace("getUnixShellEnvironment#shell",s),new Promise((r,a)=>{if(I.isCancellationRequested)return a((0,E.canceled)());const f=(0,L.basename)(s);let w,k;/^pwsh(-preview)?$/.test(f)?(w=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,k=["-Login","-Command"]):(w=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,k=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),w);const R=(0,p.spawn)(s,[...k,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});I.onCancellationRequested(()=>(R.kill(),a((0,E.canceled)()))),R.on("error",H=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(H)),a(H)});const A=[];R.stdout.on("data",H=>A.push(H));const F=[];R.stderr.on("data",H=>F.push(H)),R.on("close",(H,ie)=>{const re=Buffer.concat(A).toString("utf8");y.trace("getUnixShellEnvironment#raw",re);const G=Buffer.concat(F).toString("utf8");if(G.trim()&&y.trace("getUnixShellEnvironment#stderr",G),H||ie)return a(new Error((0,D.localize)(2,null,H,ie)));const ee=n.exec(re),T=ee?ee[1]:"{}";try{const V=JSON.parse(T);c?V.ELECTRON_RUN_AS_NODE=c:delete V.ELECTRON_RUN_AS_NODE,o?V.ELECTRON_NO_ATTACH_CONSOLE=o:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",V),r(V)}catch(V){y.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(V)),a(V)}})})}}),define(Z[92],x([0,1,17,16,144,18]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(i,S,v,m,t,g){let b;try{await E(i,S,v,m,t,g)}catch(y){b=y}finally{b&&t.errorTransformer&&(b=t.errorTransformer(b)),typeof b!="undefined"&&v.error(b),v.end()}}e.readFileIntoStream=P;async function E(i,S,v,m,t,g){h(g);const b=await i.open(S,{create:!1});try{h(g);let y=0,I=0,c=t&&typeof t.length=="number"?t.length:void 0,o=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),u=t&&typeof t.position=="number"?t.position:0,n=0;do I=await i.read(b,u,o.buffer,n,o.byteLength-n),u+=I,n+=I,y+=I,typeof c=="number"&&(c-=I),n===o.byteLength&&(await v.write(m(o)),o=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),n=0);while(I>0&&(typeof c!="number"||c>0)&&h(g)&&d(y,t));if(n>0){let l=n;typeof c=="number"&&(l=Math.min(n,c)),v.write(m(o.slice(0,l)))}}catch(y){throw(0,M.ensureFileSystemProviderError)(y)}finally{await i.close(b)}}function h(i){if(i.isCancellationRequested)throw(0,L.canceled)();return!0}function d(i,S){if(S?.limits){if(typeof S.limits.memory=="number"&&i>S.limits.memory)throw(0,M.createFileSystemProviderError)((0,D.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&i>S.limits.size)throw(0,M.createFileSystemProviderError)((0,D.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[48],x([0,1,2,3,7,18]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=void 0;class P extends p.Disposable{}e.WatcherService=P;function E(i){return i.map(S=>({type:S.type,resource:D.URI.file(S.path)}))}e.toFileChanges=E;function h(i){const S=new d;for(const v of i)S.processEvent(v);return S.normalize()}e.normalizeFileChanges=h;class d{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(S){return L.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const v=this.mapPathToChange.get(this.toKey(S));let m=!1;if(v){const t=v.type,g=S.type;v.path!==S.path&&S.type===2?m=!0:t===1&&g===2?(this.mapPathToChange.delete(this.toKey(S)),this.normalized.delete(v)):t===2&&g===1?v.type=0:t===1&&g===0||(v.type=g)}else m=!0;m&&(this.normalized.add(S),this.mapPathToChange.set(this.toKey(S),S))}normalize(){const S=[],v=[];return Array.from(this.normalized).filter(m=>m.type!==2?(S.push(m),!1):!0).sort((m,t)=>m.path.length-t.path.length).filter(m=>v.some(t=>(0,M.isParent)(m.path,t,!L.isLinux))?!1:(v.push(m.path),!0)).concat(S)}}}),define(Z[93],x([0,1,9,2,8,83,20,119,48]),function(j,e,p,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class d extends L.Disposable{constructor(S,v,m,t){super();this.path=S,this.onDidFilesChange=v,this.onLogMessage=m,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(S){this.verboseLogging=S}async startWatching(){try{const{stat:S,symbolicLink:v}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(v)try{m=await(0,M.realpath)(m)}catch(t){if(this.onError(t),v.dangling)return}S.isDirectory()?this._register((0,E.watchFolder)(m,(t,g)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(g))})},t=>this.onError(t))):this._register((0,E.watchFile)(m,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(S){S.code!=="ENOENT"&&this.onError(S)}}onFileChange(S){this.fileChangesBuffer.push(S),this.verboseLogging&&this.onVerbose(`${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,h.normalizeFileChanges)(v);if(this.verboseLogging)for(const t of m)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);m.length>0&&this.onDidFilesChange(m)})}onError(S){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${S}`})}onVerbose(S){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${S}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=d}),define(Z[171],x([0,1,10,35,72,48]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(h,d,i){super();this.onDidFilesChange=h,this.onLogMessage=d,this.verboseLogging=i,this.isDisposed=!1,this.startWatching()}startWatching(){const h=this._register(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}async watch(h){this.isDisposed||await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P}),define(Z[172],x([0,1,2,10,35,72,48]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends P.WatcherService{constructor(d,i,S){super();this.onDidFilesChange=d,this.onLogMessage=i,this.verboseLogging=S,this.serviceDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0,this.init()}init(){const d=new p.DisposableStore;this.serviceDisposables.value=d;const i=d.add(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));d.add(i.onDidProcessExit(()=>{this.restartCounter<=E.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restart(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!")})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(i.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(S=>this.onDidFilesChange(S))),d.add(this.service.onDidLogMessage(S=>this.onLogMessage(S)))}restart(d){this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[173],x([0,1,10,35,72,48]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(h,d,i,S={}){super();this.onDidFilesChange=h,this.onLogMessage=d,this.verboseLogging=i,this.watcherOptions=S,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const h=this._register(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(h.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}async watch(h){this.requests=h,await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Z[75],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[M,P]of D)this.set(M,P)}set(D,M){const P=this._entries.get(D);return this._entries.set(D,M),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(Z[174],x([0,1,9,16,73,167,5,75]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class d extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class i{constructor(t=new E.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=t,this._strict=g,this._parent=b,this._services.set(P.IInstantiationService,this)}createChild(t){return new i(t,this._strict,this)}invokeFunction(t,...g){let b=v.traceInvocation(t),y=!1;try{return t({get:(c,o)=>{if(y)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(c,b);if(!u&&o!==P.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return u}},...g)}finally{y=!0,b.stop()}}createInstance(t,...g){let b,y;return t instanceof D.SyncDescriptor?(b=v.traceCreation(t.ctor),y=this._createInstance(t.ctor,t.staticArguments.concat(g),b)):(b=v.traceCreation(t),y=this._createInstance(t,g,b)),b.stop(),y}_createInstance(t,g=[],b){let y=P._util.getServiceDependencies(t).sort((o,u)=>o.index-u.index),I=[];for(const o of y){let u=this._getOrCreateServiceInstance(o.id,b);if(!u&&this._strict&&!o.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${o.id}.`);I.push(u)}let c=y.length>0?y[0].index:g.length;if(g.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${g.length} static arguments`);let o=c-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,c)}return new t(...[...g,...I])}_setServiceInstance(t,g){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,g);else if(this._parent)this._parent._setServiceInstance(t,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let g=this._services.get(t);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):g}_getOrCreateServiceInstance(t,g){let b=this._getServiceInstanceOrDescriptor(t);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,b,g.branch(t,!0)):(g.branch(t,!1),b)}_safeCreateAndCacheServiceInstance(t,g,b){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,g,b)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,g,b){const y=new M.Graph(o=>o.id.toString());let I=0;const c=[{id:t,desc:g,_trace:b}];for(;c.length;){const o=c.pop();if(y.lookupOrInsertNode(o),I++>1e3)throw new d(y);for(let u of P._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(u.id);if(!n&&!u.optional&&console.warn(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const l={id:u.id,desc:n,_trace:o._trace.branch(u.id,!0)};y.insertEdge(o,l),c.push(l)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new d(y);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}y.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,g,b=[],y,I){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(g,b,y,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,g,b,y,I);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(t,g=[],b,y){if(b){const I=new p.IdleValue(()=>this._createInstance(t,g,y));return new Proxy(Object.create(null),{get(c,o){if(o in c)return c[o];let u=I.value,n=u[o];return typeof n!="function"||(n=n.bind(u),c[o]=n),n},set(c,o,u){return I.value[o]=u,!0}})}else return this._createInstance(t,g,y)}}e.InstantiationService=i;var S;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(S||(S={}));class v{constructor(t,g){this.type=t,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return h?new v(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(t){return h?new v(0,t.name):v._None}branch(t,g){let b=new v(2,t.toString());return this._dep.push([t,g,b]),b}stop(){let t=Date.now()-this._start;v._totals+=t;let g=!1;function b(I,c){let o=[],u=new Array(I+1).join("	");for(const[n,l,s]of c._dep)if(l&&s){g=!0,o.push(`${u}CREATES -> ${n}`);let r=b(I+1,s);r&&o.push(r)}else o.push(`${u}uses -> ${n}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(t>2||g)&&console.log(y.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(Z[175],x([0,1,16,130,59]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends D.ResolvedKeybinding{constructor(E,h){super();if(h.length===0)throw(0,p.illegalArgument)("parts");this._os=E,this._parts=h}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,E=>this._getLabel(E))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,E=>this._getAriaLabel(E))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,E=>this._getElectronAccelerator(E))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,E=>this._getUserSettingsLabel(E))}isWYSIWYG(){return this._parts.every(E=>this._isWYSIWYG(E))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(E=>this._getPart(E))}_getPart(E){return new D.ResolvedKeybindingPart(E.ctrlKey,E.shiftKey,E.altKey,E.metaKey,this._getLabel(E),this._getAriaLabel(E))}getDispatchParts(){return this._parts.map(E=>this._getDispatchPart(E))}getSingleModifierDispatchParts(){return this._parts.map(E=>this._getSingleModifierDispatchPart(E))}}e.BaseResolvedKeybinding=M}),define(Z[176],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(M,P,E,h,d,i,S){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=M,this.keypressParts=M?L(M.getDispatchParts()):[],M&&this.keypressParts.length===0&&(this.keypressParts=L(M.getSingleModifierDispatchParts())),this.bubble=P?P.charCodeAt(0)===94:!1,this.command=this.bubble?P.substr(1):P,this.commandArgs=E,this.when=h,this.isDefault=d,this.extensionId=i,this.isBuiltinExtension=S}}e.ResolvedKeybindingItem=p;function L(D){let M=[];for(let P=0,E=D.length;P<E;P++){const h=D[P];if(!h)return M;M.push(h)}return M}e.removeElementsAfterNulls=L}),define(Z[177],x([0,1,80,59,175,176]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class P extends D.BaseResolvedKeybinding{constructor(h,d){super(d,h.parts)}_keyCodeToUILabel(h){if(this._os===2)switch(h){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(h)}_getLabel(h){return h.isDuplicateModifierCase()?"":this._keyCodeToUILabel(h.keyCode)}_getAriaLabel(h){return h.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(h.keyCode)}_getElectronAccelerator(h){return p.KeyCodeUtils.toElectronAccelerator(h.keyCode)}_getUserSettingsLabel(h){if(h.isDuplicateModifierCase())return"";const d=p.KeyCodeUtils.toUserSettingsUS(h.keyCode);return d&&d.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(h){return P.getDispatchStr(h)}static getDispatchStr(h){if(h.isModifierKey())return null;let d="";return h.ctrlKey&&(d+="ctrl+"),h.shiftKey&&(d+="shift+"),h.altKey&&(d+="alt+"),h.metaKey&&(d+="meta+"),d+=p.KeyCodeUtils.toString(h.keyCode),d}_getSingleModifierDispatchPart(h){return h.keyCode===5&&!h.shiftKey&&!h.altKey&&!h.metaKey?"ctrl":h.keyCode===4&&!h.ctrlKey&&!h.altKey&&!h.metaKey?"shift":h.keyCode===6&&!h.ctrlKey&&!h.shiftKey&&!h.metaKey?"alt":h.keyCode===57&&!h.ctrlKey&&!h.shiftKey&&!h.altKey?"meta":null}static _scanCodeToKeyCode(h){const d=p.IMMUTABLE_CODE_TO_KEY_CODE[h];if(d!==-1)return d;switch(h){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(h){if(!h)return null;if(h instanceof L.SimpleKeybinding)return h;const d=this._scanCodeToKeyCode(h.scanCode);return d===0?null:new L.SimpleKeybinding(h.ctrlKey,h.shiftKey,h.altKey,h.metaKey,d)}static resolveUserBinding(h,d){const i=(0,M.removeElementsAfterNulls)(h.map(S=>this._resolveSimpleUserBinding(S)));return i.length>0?[new P(new L.ChordKeybinding(i),d)]:[]}}e.USLayoutResolvedKeybinding=P}),define(Z[178],x([0,1,9]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(D,M){if(D.length===0)return Promise.resolve(!1);const P=[];let E=!1;for(let h of D){if(h===!0)return Promise.resolve(!0);(0,p.isThenable)(h)&&P.push(h.then(d=>{d&&(E=!0)},d=>{M(d),E=!0}))}return p.Promises.settled(P).then(()=>E)}e.handleVetos=L}),define(Z[6],x([0,1,55,4,2,3,5]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function E(){return new Date().toISOString()}var h;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;class d extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=d;class i extends d{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...l){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([n,...l]))}debug(n,...l){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([n,...l]))}info(n,...l){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([n,...l]))}warn(n,...l){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([n,...l]))}error(n,...l){if(this.checkLogLevel(h.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(h.Error,this.format(s))}else this.log(h.Error,this.format([n,...l]))}critical(n,...l){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([n,...l]))}flush(){}format(n){let l="";for(let s=0;s<n.length;s++){let r=n[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}l+=(s>0?" ":"")+r}return l}}e.AbstractMessageLogger=i;class S extends d{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!M.isWindows}trace(n,...l){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...l):console.log(`[main ${E()}]`,n,...l))}debug(n,...l){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...l):console.log(`[main ${E()}]`,n,...l))}info(n,...l){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...l):console.log(`[main ${E()}]`,n,...l))}warn(n,...l){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,n,...l):console.warn(`[main ${E()}]`,n,...l))}error(n,...l){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,n,...l):console.error(`[main ${E()}]`,n,...l))}critical(n,...l){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,n,...l):console.error(`[main ${E()}]`,n,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class v extends d{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...l){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",n,...l)}debug(n,...l){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...l)}info(n,...l){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",n,...l)}warn(n,...l){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",n,...l)}error(n,...l){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",n,...l)}critical(n,...l){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...l)}dispose(){}flush(){}}e.ConsoleLogger=v;class m extends d{constructor(n,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(l)}trace(n,...l){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(n),...l])}debug(n,...l){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(n),...l])}info(n,...l){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(n),...l])}warn(n,...l){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(n),...l])}error(n,...l){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(n),...l])}critical(n,...l){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(n),...l])}extractMessage(n){return typeof n=="string"?n:(0,p.toErrorMessage)(n,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class t extends d{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const l of this.logServices)l.setLevel(n);super.setLevel(n)}trace(n,...l){for(const s of this.logServices)s.trace(n,...l)}debug(n,...l){for(const s of this.logServices)s.debug(n,...l)}info(n,...l){for(const s of this.logServices)s.info(n,...l)}warn(n,...l){for(const s of this.logServices)s.warn(n,...l)}error(n,...l){for(const s of this.logServices)s.error(n,...l)}critical(n,...l){for(const s of this.logServices)s.critical(n,...l)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=t;class g extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...l){this.logger.trace(n,...l)}debug(n,...l){this.logger.debug(n,...l)}info(n,...l){this.logger.info(n,...l)}warn(n,...l){this.logger.warn(n,...l)}error(n,...l){this.logger.error(n,...l)}critical(n,...l){this.logger.critical(n,...l)}flush(){this.logger.flush()}}e.LogService=g;class b extends D.Disposable{constructor(n,l){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,l){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,l?.always?h.Trace:this.logLevel,l),this.loggers.set(n.toString(),s),l?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class y{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return h.Info}trace(n,...l){}debug(n,...l){}info(n,...l){}warn(n,...l){}error(n,...l){}critical(n,...l){}dispose(){}flush(){}}e.NullLogService=y;function I(u){if(u.verbose)return h.Trace;if(typeof u.logLevel=="string"){const n=c(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function c(u){switch(u){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function o(u){switch(u){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(j,e){return function(p,L){e(p,L,j)}};define(Z[179],x([0,1,9,17,39,79,47,18,5,6]),function(j,e,p,L,D,M,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(v){v.ERROR_INVALID_FILE="ERROR_INVALID_FILE",v.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,h.createDecorator)(e.UserConfigurationFileServiceId);let S=class{constructor(m,t,g){this.environmentService=m,this.fileService=t,this.logService=g,this.queue=new p.Queue}async updateSettings(m,t){return this.queue.queue(()=>this.doWrite(m,t))}async doWrite(m,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),m);const{value:g,mtime:b,etag:y}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let I=g.toString();const c=[];if((0,D.parse)(I,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const o=this.getEdits(m,I,t)[0];if(o){I=I.substring(0,o.offset)+o.content+I.substring(o.offset+o.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(I),{etag:y,mtime:b})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(m,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,m,t)})}getEdits({value:m,path:t},g,b){return t.length?(0,M.setProperty)(g,t,m,b):[{content:JSON.stringify(m,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:g.length,offset:0}]}};S=he([te(0,P.IEnvironmentService),te(1,E.IFileService),te(2,d.ILogService)],S),e.UserConfigurationFileService=S}),define(Z[180],x([0,1,31,9,16,4,2,8,48,6]),function(j,e,p,L,D,M,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class i extends P.Disposable{constructor(v){super();this.logService=v,this._onDidErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(v,m){return m.recursive?this.watchRecursive(v,m):this.watchNonRecursive(v)}watchRecursive(v,m){const t={path:this.toFilePath(v),excludes:m.excludes},g=(0,p.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(v=>(0,D.onUnexpectedError)(v))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,v=>this._onDidChangeFile.fire((0,h.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(v,m){return v.watch(m)}watchNonRecursive(v){const m=this.createNonRecursiveWatcher(this.toFilePath(v),g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===d.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{m.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)});return(0,P.combinedDisposable)(m,t)}onWatcherLogMessage(v){v.type==="error"&&this._onDidErrorOccur.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,E.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=i}),define(Z[181],x([0,1,31,9,17,23,4,68,2,40,10,76,15,60,142,18,92,6]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class je extends h.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new P.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=d.TernarySearchTree.forUris(u=>{const n=this.getProvider(u.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,u){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:u});const n=new h.DisposableStore;return n.add(u.onDidChangeFile(l=>this.onDidChangeFile(l,this.isPathCaseSensitive(u)))),n.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:o}))),typeof u.onDidErrorOccur=="function"&&n.add(u.onDidErrorOccur(l=>this._onError.fire(new Error(l)))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:u}),this.provider.delete(o),(0,h.dispose)(n)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(n){u.push(n)}}),!this.provider.has(o)&&await L.Promises.settled(u)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,u){const n=this.provider.get(o.scheme);return!!(n&&n.capabilities&u)}listCapabilities(){return E.Iterable.map(this.provider,([o,u])=>({scheme:o,capabilities:u.capabilities}))}async withProvider(o){if(!(0,v.isAbsolutePath)(o))throw new g.FileOperationError((0,t.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const u=this.provider.get(o.scheme);if(!u){const n=new Error;throw n.name="ENOPRO",n.message=(0,t.localize)(1,null,o.toString()),n}return u}async withReadProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,u){try{return await this.doResolveFile(o,u)}catch(n){throw(0,g.toFileSystemProviderErrorCode)(n)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,t.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(n)}}async doResolveFile(o,u){const n=await this.withProvider(o),l=this.isPathCaseSensitive(n),s=u?.resolveTo,r=u?.resolveSingleChildDescendants,a=u?.resolveMetadata,f=await n.stat(o);let w;return this.toFileStat(n,o,f,void 0,!!a,(k,R)=>(w||(w=d.TernarySearchTree.forUris(()=>!l),w.set(o,!0),s&&w.fill(!0,s)),w.get(k.resource)||w.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&r?R===1:!1))}async toFileStat(o,u,n,l,s,r){const{providerExtUri:a}=this.getExtUri(o),f={resource:u,name:a.basename(u),isFile:(n.type&g.FileType.File)!=0,isDirectory:(n.type&g.FileType.Directory)!=0,isSymbolicLink:(n.type&g.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:n.mtime,size:n.size})};if(f.isDirectory&&r(f,l)){try{const w=await o.readdir(u),k=await L.Promises.settled(w.map(async([R,A])=>{try{const F=a.joinPath(u,R),H=s?await o.stat(F):{type:A};return await this.toFileStat(o,F,H,w.length,s,r)}catch(F){return this.logService.trace(F),null}}));f.children=(0,p.coalesce)(k)}catch(w){this.logService.trace(w),f.children=[]}return f}return f}async resolveAll(o){return L.Promises.settled(o.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(o){const u=await this.withProvider(o);try{return!!await u.stat(o)}catch(n){return!1}}async canCreateFile(o,u){try{await this.doValidateCreateFile(o,u)}catch(n){return n}return!0}async doValidateCreateFile(o,u){if(!u?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,t.localize)(3,null,this.resourceForError(o)),3,u)}async createFile(o,u=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(o,n);const l=await this.writeFile(o,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,l)),l}async writeFile(o,u,n){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(l);try{await this.validateWriteFile(l,o,n)||await this.mkdirp(l,s.dirname(o));let a;if((0,g.hasReadWriteCapability)(l)&&!(u instanceof D.VSBuffer))if((0,m.isReadableStream)(u)){const f=await(0,m.peekStream)(u,3);f.ended?a=D.VSBuffer.concat(f.buffer):a=f}else a=(0,m.peekReadable)(u,f=>D.VSBuffer.concat(f),3);else a=u;!(0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(l,o,n,a):await this.doWriteBuffered(l,o,n,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new g.FileOperationError((0,t.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),n)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,u,n){if(!!n?.unlock&&!(o.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(u)));let s;try{s=await o.stat(u)}catch(r){return}if((s.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,t.localize)(6,null,this.resourceForError(u)),0,n);if(this.throwIfFileIsReadonly(u,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==g.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,g.etag)({mtime:n.mtime,size:s.size}))throw new g.FileOperationError((0,t.localize)(7,null),3,n);return s}async readFile(o,u){const n=await this.withReadProvider(o);return u?.atomic?this.doReadFileAtomic(n,o,u):this.doReadFile(n,o,u)}async doReadFileAtomic(o,u,n){return new Promise((l,s)=>{this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,u,n);l(r)}catch(r){s(r)}})})}async doReadFile(o,u,n){const l=await this.doReadFileStream(o,u,{...n,preferUnbuffered:!0});return{...l,value:await(0,D.streamToBuffer)(l.value)}}async readFileStream(o,u){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,u)}async doReadFileStream(o,u,n){const l=new M.CancellationTokenSource,s=this.validateReadFile(u,n).then(a=>a,a=>{throw l.cancel(),a});let r;try{return typeof n?.etag=="string"&&n.etag!==g.ETAG_DISABLED&&await s,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&n?.preferUnbuffered?r=this.readFileUnbuffered(o,u,n):(0,g.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,u,l.token,n):r=this.readFileBuffered(o,u,l.token,n),{...await s,value:r}}catch(a){r&&await(0,m.consumeStream)(r);const f=(0,t.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(a).toString());throw a instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(f,a.stat,n):new g.FileOperationError(f,(0,g.toFileOperationResult)(a),n)}}readFileStreamed(o,u,n,l=Object.create(null)){const s=o.readFileStream(u,l,n);return(0,m.transform)(s,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new g.FileOperationError((0,t.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),l)},r=>D.VSBuffer.concat(r))}readFileBuffered(o,u,n,l=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,u,s,r=>r,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new g.FileOperationError((0,t.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),l)},n),s}readFileUnbuffered(o,u,n){const l=(0,m.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(u);typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.validateReadFileLimits(u,s.byteLength,n),l.end(D.VSBuffer.wrap(s))}catch(s){l.error(s),l.end()}})(),l}async validateReadFile(o,u){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new g.FileOperationError((0,t.localize)(11,null,this.resourceForError(o)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===n.etag)throw new g.NotModifiedSinceFileOperationError((0,t.localize)(12,null),n,u);return this.validateReadFileLimits(o,n.size,u),n}validateReadFileLimits(o,u,n){if(n?.limits){let l;if(typeof n.limits.memory=="number"&&u>n.limits.memory&&(l=9),typeof n.limits.size=="number"&&u>n.limits.size&&(l=7),typeof l=="number")throw new g.FileOperationError((0,t.localize)(13,null,this.resourceForError(o)),l)}}async canMove(o,u,n){return this.doCanMoveCopy(o,u,"move",n)}async canCopy(o,u,n){return this.doCanMoveCopy(o,u,"copy",n)}async doCanMoveCopy(o,u,n,l){if(o.toString()!==u.toString())try{const s=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,o,r,u,n,l)}catch(s){return s}return!0}async move(o,u,n){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(l,o,s,u,"move",!!n),a=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,u,n){const l=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(l,o,s,u,"copy",!!n),a=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,u,n,l,s,r){if(u.toString()===l.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,u,n,l,s,r);if(a&&!f&&r&&await this.del(l,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(l)),s==="copy"){if(o===n&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(u,l,{overwrite:r});else{const w=await this.resolve(u);w.isDirectory?await this.doCopyFolder(o,w,n,l):await this.doCopyFile(o,u,n,l)}return s}else return o===n?(await o.rename(u,l,{overwrite:r}),s):(await this.doMoveCopy(o,u,n,l,"copy",r),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(o,u,n,l){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(o,u,n,l);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(o,u,n,l);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(o,u,n,l);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(n))return this.doPipeUnbuffered(o,u,n,l)}async doCopyFolder(o,u,n,l){await n.mkdir(l),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async s=>{const r=this.getExtUri(n).providerExtUri.joinPath(l,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),n,r):this.doCopyFile(o,s.resource,n,r)}))}async doValidateMoveCopy(o,u,n,l,s,r){let a=!1;if(o===n){const{providerExtUri:w,isPathCaseSensitive:k}=this.getExtUri(o);if(k||(a=w.isEqual(u,l)),a&&s==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(u),this.resourceForError(l)));if(!a&&w.isEqualOrParent(l,u))throw new Error((0,t.localize)(15,null,this.resourceForError(u),this.resourceForError(l)))}const f=await this.exists(l);if(f&&!a){if(!r)throw new g.FileOperationError((0,t.localize)(16,null,this.resourceForError(u),this.resourceForError(l)),4);if(o===n){const{providerExtUri:w}=this.getExtUri(o);if(w.isEqualOrParent(u,l))throw new Error((0,t.localize)(17,null,this.resourceForError(u),this.resourceForError(l)))}}return{exists:f,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const u=this.isPathCaseSensitive(o);return{providerExtUri:u?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(u,o);const n=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,n)),n}async mkdirp(o,u){const n=[],{providerExtUri:l}=this.getExtUri(o);for(;!l.isEqual(u,l.dirname(u));)try{if(((await o.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(l.basename(u)),u=l.dirname(u)}for(let s=n.length-1;s>=0;s--){u=l.joinPath(u,n[s]);try{await o.mkdir(u)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,u){try{await this.doValidateDelete(o,u)}catch(n){return n}return!0}async doValidateDelete(o,u){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!u?.useTrash&&!(n.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(o)));let s;try{s=await n.stat(o)}catch(a){}if(s)this.throwIfFileIsReadonly(o,s);else throw new g.FileOperationError((0,t.localize)(20,null,this.resourceForError(o)),1);if(!!!u?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(o)))}return n}async del(o,u){const n=await this.doValidateDelete(o,u),l=!!u?.useTrash,s=!!u?.recursive;await n.delete(o,{recursive:s,useTrash:l}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,u){this._onDidChangeFilesRaw.fire({changes:o});let n,l;{for(const s of o)this.watchedResources.has(s.resource)?(n||(n=[]),n.push(s)):(l||(l=[]),l.push(s));n&&this._onDidFilesChange.fire(new g.FileChangesEvent(n,!u))}if(l){const s=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(l)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,u={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let l=!1,s=()=>{l=!0};return n.add((0,h.toDisposable)(()=>s())),this.doWatch(o,u).then(r=>{l?(0,h.dispose)(r):s=()=>(0,h.dispose)(r)},r=>this.logService.error(r)),u.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),n.add((0,h.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),n}async doWatch(o,u){const n=await this.withProvider(o),l=this.toWatchKey(n,o,u);let s=this.activeWatchers.get(l);return s||(s={count:0,disposable:n.watch(o,u)},this.activeWatchers.set(l,s)),s.count+=1,(0,h.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,h.dispose)(s.disposable),this.activeWatchers.delete(l)))})}toWatchKey(o,u,n){const{providerExtUri:l}=this.getExtUri(o);return[l.getComparisonKey(u),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,h.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,u,n,l){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{const s=await o.open(u,{create:!0,unlock:n?.unlock??!1});try{(0,m.isReadableStream)(l)||(0,m.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(o,s,l):await this.doWriteReadableBufferedQueued(o,s,l)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,u,n){let l=0,s;if((0,m.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(o,u,r,r.byteLength,l,0),l+=r.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((r,a)=>{(0,m.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,u,f,f.byteLength,l,0)}catch(w){return a(w)}l+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>a(f),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,u,n){let l=0,s;for(;(s=n.read())!==null;)await this.doWriteBuffer(o,u,s,s.byteLength,l,0),l+=s.byteLength}async doWriteBuffer(o,u,n,l,s,r){let a=0;for(;a<l;)a+=await o.write(u,s+a,n.buffer,r+a,l-a)}async doWriteUnbuffered(o,u,n,l){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,u,n,l))}async doWriteUnbufferedQueued(o,u,n,l){let s;l instanceof D.VSBuffer?s=l:(0,m.isReadableStream)(l)?s=await(0,D.streamToBuffer)(l):(0,m.isReadableBufferedStream)(l)?s=await(0,D.bufferedStreamToBuffer)(l):s=(0,D.readableToBuffer)(l),await o.writeFile(u,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(o,u,n,l){return this.writeQueue.queueFor(l,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,u,n,l))}async doPipeBufferedQueued(o,u,n,l){let s,r;try{s=await o.open(u,{create:!1}),r=await n.open(l,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,w=0,k=0;do k=await o.read(s,f,a.buffer,w,a.byteLength-w),await this.doWriteBuffer(n,r,a,k,f,w),f+=k,w+=k,w===a.byteLength&&(w=0);while(k>0)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,u,n,l){return this.writeQueue.queueFor(l,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,u,n,l))}async doPipeUnbufferedQueued(o,u,n,l){return n.writeFile(l,await o.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,u,n,l){return this.writeQueue.queueFor(l,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,u,n,l))}async doPipeUnbufferedToBufferedQueued(o,u,n,l){const s=await n.open(l,{create:!0,unlock:!1});try{const r=await o.readFile(u);await this.doWriteBuffer(n,s,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(o,u,n,l){const s=await(0,D.streamToBuffer)(this.readFileBuffered(o,u,M.CancellationToken.None));await this.doWriteUnbuffered(n,l,void 0,s)}throwIfFileSystemIsReadonly(o,u){if(o.capabilities&2048)throw new g.FileOperationError((0,t.localize)(22,null,this.resourceForError(u)),6);return o}throwIfFileIsReadonly(o,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,t.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=he([te(0,y.ILogService)],I),e.FileService=I}),define(Z[182],x([0,1,13,145,3,7,18,93,8,2,48,6,166,112]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends v.AbstractDiskFileSystemProviderChannel{constructor(y,I){super(y,I)}getUriTransformer(y){return m.DefaultURITransformer}transformIncoming(y,I){return M.URI.revive(I)}async delete(y,I,c){if(!c.useTrash)return super.delete(y,I,c);const o=this.transformIncoming(y,I),u=(0,h.normalize)(o.fsPath);try{await p.shell.trashItem(u)}catch(n){throw(0,P.createFileSystemProviderError)(D.isWindows?(0,L.localize)(0,null,(0,h.basename)(u)):(0,L.localize)(1,null,(0,h.basename)(u)),P.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(y,I){return new g(I,this.logService)}}e.DiskFileSystemProviderChannel=t;class g extends d.Disposable{constructor(y,I){super();this.sessionEmitter=y,this.logService=I,this.watcherRequests=new Map}watch(y,I,c){if(c.recursive)throw(0,P.createFileSystemProviderError)("Recursive watcher is not supported from main process",P.FileSystemProviderErrorCode.Unavailable);const o=new d.DisposableStore;this.watcherRequests.set(y,o),o.add((0,d.toDisposable)(()=>this.watcherRequests.delete(y)));const u=o.add(new E.FileWatcher((0,h.normalize)(I.fsPath),n=>this.sessionEmitter.fire((0,i.toFileChanges)(n)),n=>this.onWatcherLogMessage(n),this.logService.getLevel()===S.LogLevel.Trace));return o.add(this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})),o}onWatcherLogMessage(y){y.type==="error"&&this.sessionEmitter.fire(y.message),this.logService[y.type](y.message)}dispose(){super.dispose(),this.watcherRequests.forEach(y=>(0,d.dispose)(y)),this.watcherRequests.clear()}}}),define(Z[94],x([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,P){switch(P){case p.LogLevel.Trace:return M.trace;case p.LogLevel.Debug:return M.debug;case p.LogLevel.Info:return M.info;case p.LogLevel.Warning:return M.warn;case p.LogLevel.Error:return M.error;case p.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(P=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}set logger(P){this._logger=P;for(const{level:E,args:h}of this.buffer)L(P,E).apply(P,h);this.buffer=[]}_log(P,...E){this._logger?L(this._logger,P).apply(this._logger,E):this.getLevel()<=P&&this.buffer.push({level:P,args:E})}trace(P,...E){this._log(p.LogLevel.Trace,P,...E)}debug(P,...E){this._log(p.LogLevel.Debug,P,...E)}info(P,...E){this._log(p.LogLevel.Info,P,...E)}warn(P,...E){this._log(p.LogLevel.Warning,P,...E)}error(P,...E){this._log(p.LogLevel.Error,P,...E)}critical(P,...E){this._log(p.LogLevel.Critical,P,...E)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Z[183],x([0,1,9,17,15,18,5,94,6]),function(j,e,p,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const d=5*M.ByteSize.MB;let i=class extends h.AbstractLogger{constructor(m,t,g,b,y){super();this.name=m,this.resource=t,this.donotUseFormatters=b,this.fileService=y,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const m=arguments[0];if(m instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=m.stack,this._log(h.LogLevel.Error,this.format(t))}else this._log(h.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,this.format(arguments))}flush(){}log(m,t){this._log(m,this.format(t))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(m){if(m.fileOperationResult!==3)throw m}}_log(m,t){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>d&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=t:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(m)}] ${t}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const m=b=>b<10?`0${b}`:b,t=b=>b<10?`00${b}`:b<100?`0${b}`:b,g=new Date;return`${g.getFullYear()}-${m(g.getMonth()+1)}-${m(g.getDate())} ${m(g.getHours())}:${m(g.getMinutes())}:${m(g.getSeconds())}.${t(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(m){return""}}stringifyLogLevel(m){switch(m){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}format(m){let t="";for(let g=0;g<m.length;g++){let b=m[g];if(typeof b=="object")try{b=JSON.stringify(b)}catch(y){}t+=(g>0?" ":"")+b}return t}};i=he([te(4,M.IFileService)],i),e.FileLogger=i;let S=class extends h.AbstractLoggerService{constructor(m,t,g){super(m.getLevel(),m.onDidChangeLogLevel);this.instantiationService=t,this.fileService=g}doCreateLogger(m,t,g){const b=new E.BufferLogService(t);return(0,M.whenProviderRegistered)(m,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(i,(0,D.basename)(m),m,b.getLevel(),!!g?.donotUseFormatters)),b}};S=he([te(0,h.ILogService),te(1,P.IInstantiationService),te(2,M.IFileService)],S),e.FileLoggerService=S}),define(Z[184],x([0,1,4,7,6]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(v){this.service=v,this.onDidChangeLogLevel=p.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(v,m,t){switch(m){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=M;class P{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){P.setLevel(this.channel,v)}static setLevel(v,m){return v.call("setLevel",m)}}e.LogLevelChannelClient=P;class E{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,m){throw new Error(`Event not found: ${m}`)}async call(v,m,t){switch(m){case"createLogger":this.createLogger(L.URI.revive(t[0]),t[1]);return;case"log":return this.log(L.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${m}`)}createLogger(v,m){this.loggers.set(v.toString(),this.loggerService.createLogger(v,m))}consoleLog(v,m){let t=console.log;switch(v){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...m)}log(v,m){const t=this.loggers.get(v.toString());if(!t)throw new Error("Create the logger before logging");for(const[g,b]of m)switch(g){case D.LogLevel.Trace:t.trace(b);break;case D.LogLevel.Debug:t.debug(b);break;case D.LogLevel.Info:t.info(b);break;case D.LogLevel.Warning:t.warn(b);break;case D.LogLevel.Error:t.error(b);break;case D.LogLevel.Critical:t.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=E;class h extends D.AbstractLoggerService{constructor(v,m,t){super(v,m);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(v,m)=>{this.channel.call("consoleLog",[v,m])}})}doCreateLogger(v,m,t){return new d(this.channel,v,m,t)}}e.LoggerChannelClient=h;class d extends D.AbstractMessageLogger{constructor(v,m,t,g){super(g?.always);this.channel=v,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[m,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,m){const t=[[v,m]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(v){this.channel.call("log",[this.file,v])}}class i extends D.LogService{constructor(v,m){super(m);this.parent=v,this._register(v.onDidChangeLogLevel(t=>m.setLevel(t)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=i}),define(Z[95],x([0,1,18,6]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(h,d,i,S){try{const v=await new Promise((m,t)=>{j(["spdlog"],m,t)});return v.setFlushOn(L.LogLevel.Trace),v.createAsyncRotatingLogger(h,d,i,S)}catch(v){console.error(v)}return null}function M(h,d,i,S){const v=j.__$__nodeRequire("spdlog");return v.setFlushOn(L.LogLevel.Trace),v.createRotatingLogger(h,d,i,S)}e.createRotatingLogger=M;function P(h,d,i){switch(d){case L.LogLevel.Trace:h.trace(i);break;case L.LogLevel.Debug:h.debug(i);break;case L.LogLevel.Info:h.info(i);break;case L.LogLevel.Warning:h.warn(i);break;case L.LogLevel.Error:h.error(i);break;case L.LogLevel.Critical:h.critical(i);break;default:throw new Error("Invalid log level")}}class E extends L.AbstractMessageLogger{constructor(d,i,S,v){super();this.name=d,this.filepath=i,this.rotating=S,this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const d=this.rotating?6:1,i=30/d*p.ByteSize.MB;return D(this.name,this.filepath,i,d).then(S=>{if(S){this._logger=S,this._logger.setLevel(this.getLevel());for(const{level:v,message:m}of this.buffer)P(this._logger,v,m);this.buffer=[]}})}log(d,i){this._logger?P(this._logger,d,i):this.getLevel()<=d&&this.buffer.push({level:d,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=E}),define(Z[185],x([0,1,10,15,28,18,183,6,95]),function(j,e,p,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let d=class extends E.AbstractLoggerService{constructor(S,v){super(S.getLevel(),S.onDidChangeLogLevel);this.fileService=v}doCreateLogger(S,v,m){if(S.scheme===p.Schemas.file){const t=new h.SpdLogLogger(m?.name||(0,D.generateUuid)(),S.fsPath,!m?.donotRotate,v);return m?.donotUseFormatters&&t.clearFormatters(),t}else return new P.FileLogger(m?.name??(0,L.basename)(S),S,v,!!m?.donotUseFormatters,this.fileService)}};d=he([te(0,E.ILogService),te(1,M.IFileService)],d),e.LoggerService=d}),define(Z[186],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function L(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function D(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function M(P){return!p(P)&&!L(P)&&!D(P)}e.isMenubarMenuItemAction=M}),define(Z[49],x([0,1,10,3,32,15]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const E=L.globals.vscode.context.configuration();if(E)P=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const E=(0,M.dirname)(p.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,M.joinPath)(E,"product.json").fsPath);const h=j.__$__nodeRequire((0,M.joinPath)(E,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:h.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(Z[96],x([0,1,29,247,9,17,4,33,8,3,15,60,20,146,18,92,93,171,172,173,49,180,55]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(p)}catch(s){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(s)}`)}})();class l extends u.AbstractDiskFileSystemProvider{constructor(r,a){super(r);this.options=a,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:f}=await v.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,f),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await v.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),f=[];return await Promise.all(a.map(async w=>{try{let k;w.isSymbolicLink()?k=(await this.stat((0,i.joinPath)(r,w.name))).type:k=this.toType(w),f.push([w.name,k])}catch(k){this.logService.trace(k)}})),f}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let f;return a?.dangling?f=t.FileType.Unknown:r.isFile()?f=t.FileType.File:r.isDirectory()?f=t.FileType.Directory:f=t.FileType.Unknown,a&&(f|=t.FileType.SymbolicLink),f}async readFile(r){try{const a=this.toFilePath(r);return await v.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,f){const w=(0,S.newWriteableStream)(k=>M.VSBuffer.concat(k.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,r,w,k=>k.buffer,{...a,bufferSize:256*1024},f),w}async writeFile(r,a,f){let w;try{const k=this.toFilePath(r);if(!f.create||!f.overwrite){if(await v.Promises.exists(k)){if(!f.overwrite)throw(0,t.createFileSystemProviderError)((0,m.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,t.createFileSystemProviderError)((0,m.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:f.unlock}),await this.write(w,0,a,0,a.byteLength)}catch(k){throw await this.toFileSystemProviderWriteError(r,k)}finally{typeof w=="number"&&await this.close(w)}}async open(r,a){try{const f=this.toFilePath(r);if((0,t.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:R}=await v.SymlinkSupport.stat(f);R.mode&128||await v.Promises.chmod(f,R.mode|128)}catch(R){this.logService.trace(R)}let w;if((0,t.isFileOpenForWriteOptions)(a)){if(d.isWindows)try{await v.Promises.truncate(f,0),w="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}w||(w="w")}else w="r";const k=await v.Promises.open(f,w);return this.mapHandleToPos.set(k,0),(0,t.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(k,r),k}catch(f){throw(0,t.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,f):this.toFileSystemProviderError(f)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await v.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await v.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,f,w,k){const R=this.normalizePos(r,a);let A=null;try{const F=await v.Promises.read(r,f,w,k,R);return typeof F=="number"?A=F:A=F.bytesRead,A}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(r,R,A)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,f){const w=this.mapHandleToPos.get(r);typeof w=="number"&&(typeof a=="number"||(typeof f=="number"?this.mapHandleToPos.set(r,w+f):this.mapHandleToPos.delete(r)))}async write(r,a,f,w,k){return(0,D.retry)(()=>this.doWrite(r,a,f,w,k),100,3)}async doWrite(r,a,f,w,k){const R=this.normalizePos(r,a);let A=null;try{const F=await v.Promises.write(r,f,w,k,R);return typeof F=="number"?A=F:A=F.bytesWritten,A}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),F)}finally{this.updatePos(r,R,A)}}async mkdir(r){try{await v.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const f=this.toFilePath(r);await this.doDelete(f,a)}catch(f){throw this.toFileSystemProviderError(f)}}async doDelete(r,a){a.recursive?await v.Promises.rm(r,v.RimRafMode.MOVE):await v.Promises.unlink(r)}async rename(r,a,f){const w=this.toFilePath(r),k=this.toFilePath(a);if(w!==k)try{await this.validateTargetDeleted(r,a,"move",f.overwrite),await v.Promises.move(w,k)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,m.localize)(2,null,(0,h.basename)(w),(0,h.basename)((0,h.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(r,a,f){const w=this.toFilePath(r),k=this.toFilePath(a);if(w!==k)try{await this.validateTargetDeleted(r,a,"copy",f.overwrite),await v.Promises.copy(w,k,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,m.localize)(3,null,(0,h.basename)(w),(0,h.basename)((0,h.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(r,a,f,w){const k=this.toFilePath(r),R=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,E.isEqual)(k,R,!0)),A&&f==="copy")throw(0,t.createFileSystemProviderError)((0,m.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!A&&await v.Promises.exists(R)){if(!w)throw(0,t.createFileSystemProviderError)((0,m.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,a,f,w){let k,R=!1;return this.options?.watcher?.usePolling?R=!1:this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?R=this.options.legacyWatcher==="on":o.default.quality==="stable"&&(R=r===1),R?d.isLinux?k=c.FileWatcher:k=y.FileWatcher:k=I.FileWatcher,new k(A=>a(A),A=>f(A),w,this.options?.watcher)}doWatch(r,a){const f=this.options?.watcher?.usePolling;if(f===!0)for(const w of a)w.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(f))for(const w of a)f.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,a)}createNonRecursiveWatcher(r,a,f,w){return new b.FileWatcher(r,k=>a(k),k=>f(k),w)}toFileSystemProviderError(r){if(r instanceof t.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=t.FileSystemProviderErrorCode.NoPermissions;break;default:a=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let f=this.toFileSystemProviderError(a);if(r&&f.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await v.SymlinkSupport.stat(this.toFilePath(r));w.mode&128||(f=(0,t.createFileSystemProviderError)(a,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return f}}e.DiskFileSystemProvider=l}),define(Z[21],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[187],x([0,1,61,6,21]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(E,h){this.productService=E,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(h);if(!d)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,i,S]=d;let v=this.trustedExtensionUrlPublicKeys.get(E);if(!v){if(v=this.productService.trustedExtensionUrlPublicKeys[E],!v||v.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...v])}const m=Buffer.from(decodeURIComponent(S),"base64");if(m.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const t=m.slice(0,6),g=m.readUIntBE(0,6),b=Date.now()-g;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const y=m.slice(6),I=p.createVerify("SHA256");I.write(t),I.write(Buffer.from(i)),I.end();for(let c=0;c<v.length;c++){let o=v[c];if(o!==null){if(typeof o=="string")try{o=p.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),v[c]=o}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${E}:`,u),v[c]=null;continue}if(I.verify(o,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};M=he([te(0,D.IProductService),te(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[57],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[188],x([0,1,13,2,40,10,3,15,7,28,47,6]),function(j,e,p,L,D,M,P,E,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let v=class extends L.Disposable{constructor(t,g){super();this.logService=g,this.validRoots=D.TernarySearchTree.forUris(()=>!P.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(h.URI.file(t.appRoot)),this.addValidFileRoot(h.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,b)=>this.handleResourceRequest(g,b)),t.protocol.interceptFileProtocol(M.Schemas.file,(g,b)=>this.handleFileRequest(g,b)),this._register((0,L.toDisposable)(()=>{t.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?L.Disposable.None:(this.validRoots.set(t,!0),(0,L.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,g){const b=h.URI.parse(t.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${M.Schemas.file}: protocol (original URL: ${t.url})`),g({error:-3})}handleResourceRequest(t,g){const b=h.URI.parse(t.url),y=M.FileAccess.asFileUri(b);return this.validRoots.findSubstr(y)?g({path:y.fsPath}):this.validExtensions.has((0,E.extname)(y))?g({path:y.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${y.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),g({error:-3}))}createIPCObjectUrl(){let t;const g=h.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),b=g.toString(),y=async()=>t;return p.ipcMain.handle(b,y),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:g,update:I=>t=I,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),p.ipcMain.removeHandler(b)}}}};v=he([te(0,i.INativeEnvironmentService),te(1,S.ILogService)],v),e.ProtocolMainService=v}),define(Z[37],x([0,1,104,14]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,E){p.ok(L.isString(P)),p.ok(L.isObject(E)),p.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,E)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(Z[189],x([0,1,4,37]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class M{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,d){this.schemasById[D(h)]=d,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new M;L.Registry.add(e.Extensions.JSONContribution,P)}),define(Z[50],x([0,1,31,4,14,134,189,37]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var d;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=E.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const u=this.doRegisterConfigurations(c,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:c,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(c,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(u))}registerDefaultConfigurations(c){const o=[],u=[];for(const n of c)for(const l in n)if(o.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]={...this.defaultValues[l]||{},...n[l]};const s={type:"object",default:this.defaultValues[l],description:M.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(m(l)),this.configurationProperties[l]=s,this.defaultLanguageConfigurationOverridesNode.properties[l]=s}else{this.defaultValues[l]=n[l];const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(c){const o=[];for(const u of c)for(const n in u)if(o.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const l=this.configurationProperties[n];l&&(this.updatePropertyDefaultValue(n,l),this.updateSchema(n,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const u=[];return c.forEach(n=>{u.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),u}doDeregisterConfigurations(c){const o=[],u=n=>{if(n.properties)for(const l in n.properties)o.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,n.properties[l]);n.allOf&&n.allOf.forEach(l=>u(l))};for(const n of c){u(n);const l=this.configurationContributors.indexOf(n);l!==-1&&this.configurationContributors.splice(l,1)}return o}validateAndRegisterProperties(c,o=!0,u,n=3){n=D.isUndefinedOrNull(c.scope)?n:c.scope;let l=[],s=c.properties;if(s)for(let a in s){if(o&&b(a)){delete s[a];continue}const f=s[a];if(this.updatePropertyDefaultValue(a,f),e.OVERRIDE_PROPERTY_PATTERN.test(a)?f.scope=void 0:(f.scope=D.isUndefinedOrNull(f.scope)?n:f.scope,f.restricted=D.isUndefinedOrNull(f.restricted)?!!u?.restrictedConfigurations?.includes(a):f.restricted),s[a].hasOwnProperty("included")&&!s[a].included){this.excludedConfigurationProperties[a]=s[a],delete s[a];continue}else this.configurationProperties[a]=s[a];!s[a].deprecationMessage&&s[a].markdownDeprecationMessage&&(s[a].deprecationMessage=s[a].markdownDeprecationMessage),l.push(a)}let r=c.allOf;if(r)for(let a of r)l.push(...this.validateAndRegisterProperties(a,o,u,n));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const o=u=>{let n=u.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let l=u.allOf;l&&l.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){let u=this.defaultValues[c];D.isUndefined(u)&&(u=o.default),D.isUndefined(u)&&(u=t(o.type)),o.default=u}}const v="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(v);function m(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=m;function t(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const g=new S;E.Registry.add(e.Extensions.Configuration,g);function b(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?M.localize(5,null,I):g.getConfigurationProperties()[I]!==void 0?M.localize(6,null,I):null:M.localize(4,null)}e.validateProperty=b;function y(){const I=[],c=g.getConfigurationProperties();for(const o of Object.keys(c))I.push([o,c[o].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=y}),define(Z[19],x([0,1,43,14,7,50,5,37]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function h(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationOverrides=h;var d;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(d=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function S(l,s){const r=s?l?s.keys.filter(F=>l.keys.indexOf(F)===-1):[...s.keys]:[],a=l?s?l.keys.filter(F=>s.keys.indexOf(F)===-1):[...l.keys]:[],f=[];if(s&&l){for(const F of l.keys)if(s.keys.indexOf(F)!==-1){const H=y(l.contents,F),ie=y(s.contents,F);p.equals(H,ie)||f.push(F)}}const w=[],k=F=>{const H={};for(const ie of F)for(const re of ie.identifiers)H[u(re)]=ie;return H},R=s?k(s.overrides):{},A=l?k(l.overrides):{};if(Object.keys(R).length)for(const F of r){const H=R[F];H&&w.push([(0,M.overrideIdentifierFromKey)(F),H.keys])}if(Object.keys(A).length)for(const F of a){const H=A[F];H&&w.push([(0,M.overrideIdentifierFromKey)(F),H.keys])}if(Object.keys(R).length&&Object.keys(A).length)for(const F of f){const H=A[F],ie=R[F];if(H&&ie){const re=S({contents:H.contents,keys:H.keys,overrides:[]},{contents:ie.contents,keys:ie.keys,overrides:[]});w.push([(0,M.overrideIdentifierFromKey)(F),[...re.added,...re.removed,...re.updated]])}}return{added:r,removed:a,updated:f,overrides:w}}e.compare=S;function v(l,s){const r=[];for(const a of Object.keys(l))if(M.OVERRIDE_PROPERTY_PATTERN.test(a)){const f={};for(const w in l[a])f[w]=l[a][w];r.push({identifiers:[(0,M.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(f),contents:m(f,s)})}return r}e.toOverrides=v;function m(l,s){const r=Object.create(null);for(let a in l)t(r,a,l[a],s);return r}e.toValuesTree=m;function t(l,s,r,a){const f=s.split("."),w=f.pop();let k=l;for(let R=0;R<f.length;R++){let A=f[R],F=k[A];switch(typeof F){case"undefined":F=k[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${f.slice(0,R+1).join(".")} is ${JSON.stringify(F)}`);return}k=F}if(typeof k=="object"&&k!==null)try{k[w]=r}catch(R){a(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}else a(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=t;function g(l,s){const r=s.split(".");b(l,r)}e.removeFromValueTree=g;function b(l,s){const r=s.shift();if(s.length===0){delete l[r];return}if(Object.keys(l).indexOf(r)!==-1){const a=l[r];typeof a=="object"&&!Array.isArray(a)&&(b(a,s),Object.keys(a).length===0&&delete l[r])}}function y(l,s,r){function a(k,R){let A=k;for(const F of R){if(typeof A!="object"||A===null)return;A=A[F]}return A}const f=s.split("."),w=a(l,f);return typeof w=="undefined"?r:w}e.getConfigurationValue=y;function I(l,s,r){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in l?L.isObject(l[a])&&L.isObject(s[a])?I(l[a],s[a],r):r&&(l[a]=s[a]):l[a]=s[a])})}e.merge=I;function c(){const l=E.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=c;function o(){const l=Object.create(null),s=E.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let r in s){let a=s[r].default;t(l,r,a,f=>console.error(`Conflict in default settings: ${f}`))}return l}e.getDefaultValues=o;function u(l){return`[${l}]`}e.keyFromOverrideIdentifier=u;function n(l,s,r){const a=l.inspect(s),f=l.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:a.defaultValue}e.getMigratedSettingValue=n}),define(Z[190],x([0,1,31,4,39,2,40,43,14,7,19,50,37]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(n={},l=[],s=[]){this._contents=n,this._keys=l,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,l){const s=this.getContentsForOverrideIdentifer(l);return s?n?(0,i.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){for(const l of this.overrides)if(l.identifiers.indexOf(n)!==-1)return l.keys;return[]}override(n){let l=this.overrideConfigurations.get(n);return l||(l=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,l)),l}merge(...n){const l=E.deepClone(this.contents),s=E.deepClone(this.overrides),r=[...this.keys];for(const a of n){this.mergeContents(l,a.contents);for(const f of a.overrides){const[w]=s.filter(k=>p.equals(k.identifiers,f.identifiers));w?this.mergeContents(w.contents,f.contents):s.push(E.deepClone(f))}for(const f of a.keys)r.indexOf(f)===-1&&r.push(f)}return new m(l,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const l=this.getContentsForOverrideIdentifer(n);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let s={};for(const r of p.distinct([...Object.keys(this.contents),...Object.keys(l)])){let a=this.contents[r],f=l[r];f&&(typeof a=="object"&&typeof f=="object"?(a=E.deepClone(a),this.mergeContents(a,f)):a=f),s[r]=a}return new m(s,this.keys,this.overrides)}mergeContents(n,l){for(const s of Object.keys(l)){if(s in n&&h.isObject(n[s])&&h.isObject(l[s])){this.mergeContents(n[s],l[s]);continue}n[s]=E.deepClone(l[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?E.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const l of this.overrides)if(l.identifiers.indexOf(n)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,l){this.addKey(n),(0,i.addToValueTree)(this.contents,n,l,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let l=this.keys.length;for(let s=0;s<l;s++)n.indexOf(this.keys[s])===0&&(l=s);this.keys.splice(l,1,n)}removeKey(n){let l=this.keys.indexOf(n);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=m;class t extends m{constructor(){const n=(0,i.getDefaultValues)(),l=(0,i.getConfigurationKeys)(),s=[];for(const r of Object.keys(n))S.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(n[r]),contents:(0,i.toValuesTree)(n[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(n,l,s)}}e.DefaultConfigurationModel=t;class g{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,l){if(!h.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,l)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,l){this._raw=n;const{contents:s,keys:r,overrides:a,restricted:f}=this.doParseRaw(n,l);this._configurationModel=new m(s,r,a),this._restrictedConfigurations=f||[]}doParseContent(n){let l={},s=null,r=[],a=[],f=[];function w(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}let k={onObjectBegin:()=>{let R={};w(R),a.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let R=[];w(R),a.push(r),r=R,s=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(R,A,F)=>{f.push({error:R,offset:A,length:F})}};if(n)try{D.visit(n,k),l=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return l}doParseRaw(n,l){const s=v.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,s,!0,l);n=r.raw;const a=(0,i.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),f=Object.keys(n),w=(0,i.toOverrides)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:a,keys:f,overrides:w,restricted:r.restricted}}filter(n,l,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const a={},f=[];for(let w in n)if(S.OVERRIDE_PROPERTY_PATTERN.test(w)&&s){const k=this.filter(n[w],l,!1,r);a[w]=k.raw,f.push(...k.restricted)}else{const k=l[w],R=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&f.push(w),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&k?.restricted||(a[w]=n[w]))}return{raw:a,restricted:f}}}e.ConfigurationModelParser=g;class b extends M.Disposable{constructor(n,l,s,r){super();this.userSettingsResource=n,this.scopes=l,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class y{constructor(n,l,s=new m,r=new m,a=new P.ResourceMap,f=new m,w=new P.ResourceMap,k=!0){this._defaultConfiguration=n,this._localUserConfiguration=l,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=w,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,l,s){return this.getConsolidateConfigurationModel(l,s).getValue(n)}updateValue(n,l,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new m,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,l===void 0?r.removeValue(n):r.setValue(n,l),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,l,s){const r=this.getConsolidateConfigurationModel(l,s),a=this.getFolderConfigurationModelForResource(l.resource,s),f=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,w=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),R=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),F=s?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,H=a?l.overrideIdentifier?a.freeze().override(l.overrideIdentifier).getValue(n):a.freeze().getValue(n):void 0,ie=l.overrideIdentifier?f.override(l.overrideIdentifier).getValue(n):f.getValue(n),re=r.getValue(n),G=p.distinct(p.flatten(r.overrides.map(ee=>ee.identifiers))).filter(ee=>r.getOverrideValue(n,ee)!==void 0);return{defaultValue:w,userValue:k,userLocalValue:R,userRemoteValue:A,workspaceValue:F,workspaceFolderValue:H,memoryValue:ie,value:re,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,l.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,l.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,l.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,l.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,l.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:a?.freeze().getValue(n),override:l.overrideIdentifier?a?.freeze().getOverrideValue(n,l.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:f.getValue(n),override:l.overrideIdentifier?f.getOverrideValue(n,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(n){const l=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,l){this._folderConfigurations.set(n,l),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,l){const s=l.filter(r=>S.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,S.overrideIdentifierFromKey)(r),f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),k=[...w.filter(R=>f.indexOf(R)===-1),...f.filter(R=>w.indexOf(R)===-1),...f.filter(R=>!E.equals(this._defaultConfiguration.override(a).getValue(R),n.override(a).getValue(R)))];return[a,k]});return this.updateDefaultConfiguration(n),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:l,updated:s,removed:r,overrides:a}=(0,i.compare)(this.localUserConfiguration,n),f=[...l,...s,...r];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:l,updated:s,removed:r,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,n);let f=[...l,...s,...r];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:l,updated:s,removed:r,overrides:a}=(0,i.compare)(this.workspaceConfiguration,n);let f=[...l,...s,...r];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(n,l){const s=this.folderConfigurations.get(n),{added:r,updated:a,removed:f,overrides:w}=(0,i.compare)(s,l);let k=[...r,...a,...f];return(k.length||!s)&&this.updateFolderConfiguration(n,l),{keys:k,overrides:w}}compareAndDeleteFolderConfiguration(n){const l=this.folderConfigurations.get(n);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:r,removed:a,overrides:f}=(0,i.compare)(l,void 0);return{keys:[...s,...r,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,l){let s=this.getConsolidatedConfigurationModelForResource(n,l);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},l){let s=this.getWorkspaceConsolidatedConfiguration();if(l&&n){const r=l.getFolder(n);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const a=this._memoryConfigurationByResource.get(n);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let l=this._foldersConsolidatedConfigurations.get(n);if(!l){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(l=s.merge(r),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(n,l)):l=s}return l}getFolderConfigurationModelForResource(n,l){if(l&&n){const s=l.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,l)=>{const{contents:s,overrides:r,keys:a}=this._folderConfigurations.get(l);return n.push([l,{contents:s,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>n.add(l)),this.userConfiguration.freeze().keys.forEach(l=>n.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>n.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>l.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>l.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>l.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(r=>l.add(r))),[...l.values()]}static parse(n){const l=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),r=this.parseConfigurationModel(n.workspace),a=n.folders.reduce((f,w)=>(f.set(d.URI.revive(w[0]),this.parseConfigurationModel(w[1])),f),new P.ResourceMap);return new y(l,s,new m,r,a,new m,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new m(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=y;function I(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const n=new Set,l=new Map;for(const r of u)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,f])=>{const w=(0,P.getOrSet)(l,a,new Set);f.forEach(k=>w.add(k))});const s=[];return l.forEach((r,a)=>s.push([a,[...r.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=I;class c{constructor(n,l,s,r){this.change=n,this.previous=l,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;n.keys.forEach(w=>a.add(w)),n.overrides.forEach(([,w])=>w.forEach(k=>a.add(k))),this.affectedKeys=[...a.values()];const f=new m;this.affectedKeys.forEach(w=>f.setValue(w,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(l){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,l,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,l,this.currentWorkspace);return!E.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(n,l){let s=(0,i.toValuesTree)({[l]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(n=n[r],!n)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=c;class o extends c{constructor(n,l,s,r){super({keys:n.allKeys(),overrides:[]},void 0,n,l);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Z[191],x([0,1,9,4,2,15,19,190,50,37]),function(j,e,p,L,D,M,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(v,m){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,m)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,m){const t=typeof v=="string"?v:void 0,g=(0,P.isConfigurationOverrides)(v)?v:(0,P.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(t,g,void 0)}updateValue(v,m,t,g){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const m=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(t,m,1)}onDidDefaultConfigurationChange(v){const m=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,v);this.trigger(t,m,6)}trigger(v,m,t){const g=new E.ConfigurationChangeEvent(v,{data:m},this.configuration);g.source=t,g.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[192],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,E=L.Unknown,h){super(P);this._message=P,this._code=E,this._detail=h,this.isHandled=E===L.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===L.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===L.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(Z[193],x([0,1,9,17,23,16,4,2,28,85,192]),function(j,e,p,L,D,M,P,E,h,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var v;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function m(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(W){const z=new D.CancellationTokenSource;return setTimeout(()=>z.cancel(),W),z.token}function g(W,z){if(W.isCancellationRequested||z.isCancellationRequested)return D.CancellationToken.Cancelled;const K=new D.CancellationTokenSource;return W.onCancellationRequested(()=>K.cancel()),z.onCancellationRequested(()=>K.cancel()),K.token}class b{constructor(z){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((K,O)=>{this._resolvePromise=K,this._rejectPromise=O}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function y(W,z){const K=new b(z);return K.registerDisposable(W.onControlMessage(O=>{const q=JSON.parse(O.toString()),C=U(q);C?K.reject(C):K.resolve(q)})),K.promise}function I(W,z,K,O,q,C){const $=new b(C);return z.connect(K,O,q,(J,Q)=>{$.didTimeout?(J&&W.error(J),Q?.dispose()):J||!Q?$.reject(J):$.resolve(Q)}),$.promise}function c(W,z){const K=new b(z);return W.then(O=>{K.didTimeout||K.resolve(O)},O=>{K.didTimeout||K.reject(O)}),K.promise}async function o(W,z,K,O){const q=_(W,z);W.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let C;try{C=await I(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,O)}catch(le){throw W.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),W.logService.error(le),le}W.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let $,J;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(C,null),$=W.reconnectionProtocol,J=!1):($=new d.PersistentProtocol(C,null),J=!0),W.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const Q=await c(W.signService.createNewMessage((0,h.generateUuid)()),O),ne={type:"auth",auth:W.connectionToken||"00000000000000000000",data:Q.data};$.sendControl(L.VSBuffer.fromString(JSON.stringify(ne)));try{const le=await y($,g(O,t(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(W.logService.trace(`${q} 4/6. received SignRequest control message.`),!await c(W.signService.validate(Q,le.signedData),O)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const se=await c(W.signService.sign(le.data),O),ce={type:"connectionType",commit:W.commit,signedData:se,desiredConnectionType:z};return K&&(ce.args=K),W.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(L.VSBuffer.fromString(JSON.stringify(ce))),{protocol:$,ownsProtocol:J}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(W.logService.error(`${q} the handshake timed out. Error:`),W.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${q} received error control message when negotiating connection. Error:`),W.logService.error(le)),J&&V($),le}}async function u(W,z,K,O){const q=Date.now(),C=_(W,z),{protocol:$,ownsProtocol:J}=await o(W,z,K,O),Q=new b(O);return Q.registerDisposable($.onControlMessage(ne=>{const le=JSON.parse(ne.toString()),oe=U(le);oe?(W.logService.error(`${C} received error control message when negotiating connection. Error:`),W.logService.error(oe),J&&V($),Q.reject(oe)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${C} 6/6. handshake finished, connection is up and running after ${X(q)}!`),Q.resolve({protocol:$,firstMessage:le}))})),Q.promise}async function n(W,z){const{protocol:K}=await u(W,1,void 0,z);return{protocol:K}}async function l(W,z,K){const{protocol:O,firstMessage:q}=await u(W,2,z,K),C=q&&q.debugPort;return{protocol:O,debugPort:C}}async function s(W,z,K){const O=Date.now(),q=_(W,3),{protocol:C}=await o(W,3,z,K);return W.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${X(O)}!`),C}async function r(W,z,K){const{host:O,port:q,connectionToken:C}=await W.addressProvider.getAddress();return{commit:W.commit,host:O,port:q,connectionToken:C,reconnectionToken:z,reconnectionProtocol:K,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function a(W,z,K){try{const O=(0,h.generateUuid)(),q=await r(W,O,null),{protocol:C}=await n(q,D.CancellationToken.None);return new ee(W,z,K,O,C)}catch(O){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(O),G.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentManagement=a;async function f(W,z){try{const K=(0,h.generateUuid)(),O=await r(W,K,null),{protocol:q,debugPort:C}=await l(O,z,D.CancellationToken.None);return new T(W,z,K,q,C)}catch(K){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(K),G.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentExtensionHost=f;async function w(W,z,K){const O=await r(W,(0,h.generateUuid)(),null);return await s(O,{host:z,port:K},D.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function k(W){return(0,p.createCancelablePromise)(z=>new Promise((K,O)=>{const q=setTimeout(K,W*1e3);z.onCancellationRequested(()=>{clearTimeout(q),K()})}))}var R;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(z,K){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.type=0}}e.ConnectionLostEvent=A;class F{constructor(z,K,O,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.durationSeconds=O,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class H{constructor(z,K,O){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=H;class ie{constructor(z,K,O){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.type=4}}e.ConnectionGainEvent=ie;class re{constructor(z,K,O,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=O,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class G extends E.Disposable{constructor(z,K,O,q){super();this._connectionType=z,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=K,this.reconnectionToken=O,this.protocol=q,this._isReconnecting=!1,this._onDidStateChange.fire(new ie(this.reconnectionToken,0,0)),this._register(q.onSocketClose(C=>{const $=N(this._connectionType,this.reconnectionToken,!0);C?C.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${C.hadError}).`),C.error&&this._options.logService.error(C.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${C.wasClean}, code: ${C.code}, reason: ${C.reason}).`),C.event&&this._options.logService.error(C.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(()=>{const C=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${C} received socket timeout event.`),this._beginReconnecting()})),G._instances.push(this),G._permanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}static triggerPermanentFailure(z,K,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=K,this._permanentFailureHandled=O,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(G._permanentFailure)return;const z=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const q=O<K.length?K[O]:K[K.length-1];try{if(q>0){const $=k(q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,$)),this._options.logService.info(`${z} waiting for ${q} seconds before reconnecting...`);try{await $}catch{}}if(G._permanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${z} resolving connection...`);const C=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${C.host}:${C.port}...`),await this._reconnect(C,t(S)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(C){if(C.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(C)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((C.code==="ETIMEDOUT"||C.code==="ENETUNREACH"||C.code==="ECONNREFUSED"||C.code==="ECONNRESET")&&C.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((0,M.isPromiseCanceledError)(C)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if(C instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,i.RemoteAuthorityResolverError.isHandled(C));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!G._permanentFailure)}_gotoPermanentFailure(z,K,O){this._onDidStateChange.fire(new re(this.reconnectionToken,z,K,O)),V(this.protocol)}}G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class ee extends G{constructor(z,K,O,q,C){super(1,z,q,C);this.client=this._register(new d.Client(C,{remoteAuthority:K,clientId:O},z.ipcLogger))}async _reconnect(z,K){await n(z,K)}}e.ManagementPersistentConnection=ee;class T extends G{constructor(z,K,O,q,C){super(2,z,O,q);this._startArguments=K,this.debugPort=C}async _reconnect(z,K){await l(z,this._startArguments,K)}}e.ExtensionHostPersistentConnection=T;function V(W){try{W.acceptDisconnect();const z=W.getSocket();W.dispose(),z.dispose()}catch(z){(0,M.onUnexpectedError)(z)}}function U(W){if(W&&W.type==="error"){const z=new Error(`Connection error: ${W.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function B(W,z){for(;W.length<z;)W+=" ";return W}function N(W,z,K){return`[remote-connection][${B(m(W),13)}][${z.substr(0,5)}\u2026][${K?"reconnect":"initial"}]`}function _(W,z){return`${N(z,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function X(W){return`${Date.now()-W} ms`}}),define(Z[63],x([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(d){return d.scheme===p.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=L;function D(d){if(!d)return;const i=d.indexOf("+");return i<0?d:d.substr(0,i)}e.getRemoteName=D;function M(d){return d.scheme!==p.Schemas.file&&d.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=M;function P(d){if(d.folders.length)return d.folders.every(i=>M(i.uri))?d.folders[0].uri:void 0;if(d.configuration&&M(d.configuration))return d.configuration}e.getVirtualWorkspaceLocation=P;function E(d){return P(d)?.scheme}e.getVirtualWorkspaceScheme=E;function h(d){return P(d)!==void 0}e.isVirtualWorkspace=h}),define(Z[194],x([0,1,25,5,63]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=M;function P(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class h{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,t){if(typeof m=="undefined"||m===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof m=="string"||typeof t=="string"){let g=typeof m=="string"?m:m.value,b=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(g,b)}return m._lower===t._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=h;function d(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function i(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function S(v,m){if(m&&v.enableProposedApi){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(m)}`;return v.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[195],x([0,1,25,194]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,g){return t.uuid&&g.uuid?t.uuid===g.uuid:t.id===g.id?!0:(0,p.compareIgnoreCase)(t.id,g.id)===0}e.areSameExtensions=D;class M{constructor(g,b){this.version=b,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?D(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function P(t,g){return`${t}.${g}`}e.getExtensionId=P;function E(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function h(t,g){return E(P(t,g))}e.getGalleryExtensionId=h;function d(t,g){const b=[],y=I=>{for(const c of b)if(c.some(o=>D(g(o),g(I))))return c;return null};for(const I of t){const c=y(I);c?c.push(I):b.push([I])}return b}e.groupByExtension=d;function i(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function S(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function v(t){const g=new Set;for(const b of t)b.malicious&&g.add(b.id.id);return g}e.getMaliciousExtensionsSet=v;function m(t,g){const b=[],y=g.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const I=y.shift();if(I&&b.every(c=>!D(c.identifier,{id:I}))){const c=t.filter(o=>D(o.identifier,{id:I}));c.length===1&&(b.push(c[0]),y.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=m}),define(Z[97],x([0,1,4,3,5,6]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var P;(function(t){t.Http="http",t.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function d(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=d,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=S;function v(t,g){return g?g!==1&&t<1024:!L.isWindows&&t<1024}e.isPortPrivileged=v;let m=class{constructor(g){this.logService=g,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,b){return this._tunnelProvider=g,g?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],b=Array.from(this._tunnels.values());for(let y of b){const I=Array.from(y.values());for(let c of I){const o=await c.value;o&&g.push(o)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:b}of g.values())await b.then(y=>y?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,b,y,I,c=!1,o=E.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${y} on local port ${I}.`),!g)return;b||(b="localhost");const n=this.retainOrCreateTunnel(g,b,y,I,c,o,u);return n?n.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==b||l.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const b=this._tunnels.get(g.tunnelRemoteHost);if(b){const y=b.get(g.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,y))}}}}async tryDisposeTunnel(g,b,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${b}.`);const I=y.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(b),I}}async closeTunnel(g,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${b} `);const y=this._tunnels.get(g);if(y&&y.has(b)){const I=y.get(b);I.refcount=0,await this.tryDisposeTunnel(g,b,I)}}addTunnelToMap(g,b,y){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(b,{refcount:1,value:y})}async removeEmptyTunnelFromMap(g,b){const y=this._tunnels.get(g);y&&(await y.get(b)||y.delete(b),y.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,b){let y=[g];i(g)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):S(g)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const I=y.map(c=>this._tunnels.get(c));for(const c of I){const o=c?.get(b);if(o)return o}}canTunnel(g){return!!d(g)}createWithProvider(g,b,y,I,c,o,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${y} on local port ${I}.`);const l={elevationRequired:c?v(I===void 0?y:I):!1},s={remoteAddress:{host:b,port:y},localAddressPort:I,privacy:o,public:o!==E.Private,protocol:u},r=g.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(b,y,r),r}};m=he([te(0,M.ILogService)],m),e.AbstractTunnelService=m}),define(Z[51],x([0,1,17,150,50,5,37]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function E(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=E;function h(t){return t.res.statusCode===204}async function d(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);return h(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=d;async function i(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);if(h(t))return null;const b=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(b)}catch(y){throw y.message+=`:
`+b,y}}e.asJson=i;function S(t){m(t)}e.updateProxyConfigurationsScope=S;let v;function m(t){const g=P.Registry.as(D.Extensions.Configuration),b=v;v={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[v],remove:b?[b]:[]})}m(2)}),define(Z[196],x([0,1,197,14]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,E){return P.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:P.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function M(P,E,h={}){const d=(0,p.parse)(P),i=h.proxyUrl||D(d,E);if(!i)return null;const S=(0,p.parse)(i);if(!/^https?:$/.test(S.protocol||""))return null;const v={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((m,t)=>{j(["http-proxy-agent"],m,t)}))(v):new(await new Promise((m,t)=>{j(["https-proxy-agent"],m,t)}))(v)}e.getProxyAgent=M}),define(Z[198],x([0,1,17,28]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(M,P,E){let h=E&&E.get("storage.serviceMachineId",0)||null;if(h)return h;try{const i=(await P.readFile(M.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(i)?i:null}catch(d){h=null}if(!h){h=(0,L.generateUuid)();try{await P.writeFile(M.serviceMachineIdResource,p.VSBuffer.fromString(h))}catch(d){}}return E&&E.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=D}),define(Z[77],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[199],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((D,M)=>j(["vsda"],D,M))}async createNewMessage(D){try{const M=await this.vsda(),P=new M.validator;if(P){const E=String(p._nextId++);return this.validators.set(E,P),{id:E,data:P.createNewMessage(D)}}}catch(M){}return{id:"",data:D}}async validate(D,M){if(!D.id)return!0;const P=this.validators.get(D.id);if(!P)return!1;this.validators.delete(D.id);try{return P.validate(M)==="ok"}catch(E){return!1}}async sign(D){try{const M=await this.vsda(),P=new M.signer;if(P)return P.sign(D)}catch(M){}return D}}e.SignService=p,p._nextId=1}),define(Z[38],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[22],x([0,1,13,9,4,2,3,32,14,5,178,6,38]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,d.createDecorator)("lifecycleMainService");var m;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(m=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class ct extends M.Disposable{constructor(b,y){super();this.logService=b,this.stateMainService=y,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",b);const y=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",y),p.app.once("will-quit",I=>{this.logService.trace("Lifecycle#app.on(will-quit)"),I.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",b),p.app.removeListener("window-all-closed",y),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(y){b.push(y)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(b)}catch(y){this.logService.error(y)}try{await this.stateMainService.close()}catch(y){this.logService.error(y)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let y=this.phaseWhen.get(b);y||(y=new L.Barrier,this.phaseWhen.set(b,y)),await y.wait()}registerWindow(b){const y=new M.DisposableStore;this.windowCounter++,y.add(b.onWillLoad(c=>this._onWillLoadWindow.fire({window:b,workspace:c.workspace,reason:c.reason})));const I=(0,h.assertIsDefined)(b.win);I.on("close",c=>{const o=b.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),c.preventDefault(),this.unload(b,1).then(u=>{if(u){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(b),b.close()})}),I.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,y){await this.unload(b,3)||b.reload(y)}async unload(b,y){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const I=this._quitRequested?2:y;let c=await this.onBeforeUnloadWindowInRenderer(b,I);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(b,I),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,I),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,y){return new Promise(I=>{const c=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${c}`,u=`vscode:cancel${c}`;p.ipcMain.once(o,()=>{I(!1)}),p.ipcMain.once(u,()=>{I(!0)}),b.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:u,reason:y})})}onBeforeUnloadWindowInMain(b,y){const I=[];return this._onBeforeUnloadWindow.fire({reason:y,window:b,veto(c){I.push(c)}}),(0,i.handleVetos)(I,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(b,y){return new Promise(I=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(o,()=>I()),b.send("vscode:onWillUnload",{replyChannel:o,reason:y})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(b?.addArgs&&y.push(...b.addArgs),b?.removeArgs)for(const o of b.removeArgs){const u=y.indexOf(o);u>=0&&y.splice(u,1)}const I=()=>{try{if(P.isWindows){const o=(0,E.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:y})};p.app.once("quit",I),await this.quit(!0)&&p.app.removeListener("quit",I)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const y of p.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let I;y.webContents&&!y.webContents.isDestroyed()?I=new Promise(c=>y.once("closed",c)):I=Promise.resolve(),y.destroy(),await I}})()]),p.app.exit(b)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=he([te(0,S.ILogService),te(1,v.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[200],x([0,1,4,2,5,22]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let P=class extends L.Disposable{constructor(d){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,d.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const d=await new Promise((i,S)=>{j(["native-keymap"],i,S)});this._keyboardLayoutData=E(d),d.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=E(d),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=he([te(0,M.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function E(h){const d=h.getKeyMap(),i=h.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:i}}}),define(Z[98],x([0,1,9,4,2,14,87,5]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var d;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(d=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var S;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));class v extends D.Disposable{constructor(b={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,y){y===h?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:y,target:this.getKeyTargets(b)[y]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,y,I){return this.getStorage(y)?.get(b,I)}getBoolean(b,y,I){return this.getStorage(y)?.getBoolean(b,I)}getNumber(b,y,I){return this.getStorage(y)?.getNumber(b,I)}store(b,y,I,c){if((0,M.isUndefinedOrNull)(y)){this.remove(b,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,I,c),this.getStorage(I)?.set(b,y)})}remove(b,y){this.withPausedEmitters(()=>{this.updateKeyTarget(b,y,void 0),this.getStorage(y)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,y){const I=[],c=this.getKeyTargets(b);for(const o of Object.keys(c))c[o]===y&&I.push(o);return I}updateKeyTarget(b,y,I){const c=this.getKeyTargets(y);typeof I=="number"?c[b]!==I&&(c[b]=I,this.getStorage(y)?.set(h,JSON.stringify(c))):typeof c[b]=="number"&&(delete c[b],this.getStorage(y)?.set(h,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const y=this.get(h,b);if(y)try{return JSON.parse(y)}catch(I){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=d.NONE){this._onWillSaveState.fire({reason:b}),await p.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return t(b,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends v{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=m;async function t(g,b,y,I){const c=a=>{try{return JSON.parse(a)}catch(f){return a}},o=new Map,u=new Map;g.forEach((a,f)=>{o.set(f,a),u.set(f,c(a))});const n=new Map,l=new Map;b.forEach((a,f)=>{n.set(f,a),l.set(f,c(a))}),console.group(`Storage: Global (path: ${y})`);let s=[];o.forEach((a,f)=>{s.push({key:f,value:a})}),console.table(s),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${I})`);let r=[];n.forEach((a,f)=>{r.push({key:f,value:a})}),console.table(r),console.groupEnd(),console.log(l)}e.logStorage=t}),define(Z[201],x([0,1,3,32,7,28]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(d){if(p.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function E(d,i,S,v,m,t,g,b,y,I){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,M.generateUuid)()+Date.now(),c.commitHash=m,c.version=t,c["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,p.PlatformToString)(p.platform),c["common.nodePlatform"]=L.platform,c["common.nodeArch"]=v,c["common.product"]=I||"desktop";const o=h(b||[]);o&&(c["common.msftInternal"]=o);let u=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),p.isLinuxSnap&&(c["common.snap"]="true");const l=P(S);l&&(c["common.platformDetail"]=l);try{const s=await d.readFile(D.URI.file(y));c["common.source"]=s.value.toString().slice(0,30)}catch(s){}return c}e.resolveCommonProperties=E;function h(d){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const S=i.toLowerCase();return d.some(v=>S===v)}e.verifyMicrosoftInternalDomain=h}),define(Z[30],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[202],x([0,1,26,68,9,39,10,8,3,7,70,20,84,74,18,21,30]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function y(n,l){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,a=new Map,f=2e4;function w(A,F,H,ie){const re=F.substring(A.length+1);return D.Promises.withAsyncBody(async G=>{let ee;try{ee=await S.Promises.readdir(F,{withFileTypes:!0})}catch(U){G();return}if(ie.count>=f){ie.count+=ee.length,ie.maxReached=!0,G();return}let T=ee.length;if(T===0){G();return}let V=ee;ie.count+ee.length>f&&(ie.maxReached=!0,T=f-ie.count,V=ee.slice(0,T)),ie.count+=ee.length;for(const U of V)if(U.isDirectory()){if(H.includes(U.name)||await w(A,(0,E.join)(F,U.name),H,ie),--T==0){G();return}}else{const B=U.name.lastIndexOf(".");if(B>=0){const N=U.name.substring(B+1);N&&r.set(N,(r.get(N)??0)+1)}for(const N of s)N.relativePathPattern?.test(re)!==!1&&N.filePattern.test(U.name)&&a.set(N.tag,(a.get(N.tag)??0)+1);if(--T==0){G();return}}})}const k={count:0,maxReached:!1};await w(n,n,l,k);const R=await o(n);return{configFiles:I(a),fileTypes:I(r),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=y;function I(n){return[...L.Iterable.map(n.entries(),([l,s])=>({name:l,count:s}))].sort((l,s)=>s.count-l.count)}function c(){const n={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},l=p.cpus();return l&&l.length>0&&(n.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),n}e.getMachineInfo=c;async function o(n){try{const l=new Map,s=(0,E.join)(n,".vscode","launch.json"),r=await S.Promises.readFile(s),a=[],f=(0,M.parse)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,M.getNodeType)(f)==="object"&&f.configurations)for(const w of f.configurations){const k=w.type;k&&(l.has(k)?l.set(k,l.get(k)+1):l.set(k,1))}return I(l)}catch(l){return[]}}e.collectLaunchConfigs=o;let u=class{constructor(l,s){this.telemetryService=l,this.productService=s}formatMachineInfo(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}formatEnvironment(l){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const r=p.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||s.push(`Load (avg):       ${p.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,v.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async r=>{let[a,f]=r,w=this.formatProcessList(l,a);return s.forEach(k=>{if((0,m.isRemoteDiagnosticError)(k))w+=`
${k.errorMessage}`,f+=`
${k.errorMessage}`;else if(w+=`

Remote: ${k.hostName}`,k.processes&&(w+=`
${this.formatProcessList(l,k.processes)}`),k.workspaceMetadata){f+=`
|  Remote: ${k.hostName}`;for(const R of Object.keys(k.workspaceMetadata)){const A=k.workspaceMetadata[R];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),f+=`|    Folder (${R}): ${F}`,f+=this.formatWorkspaceStats(A)}}}),{processInfo:w,workspaceInfo:f}})}async getSystemInfo(l,s){const{memory:r,vmHint:a,os:f,cpus:w}=c(),k={os:f,memory:r,cpus:w,vmHint:a,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return h.isWindows||(k.load=`${p.loadavg().map(R=>Math.round(R)).join(", ")}`),h.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(l,s){const r=[];return(0,v.listProcesses)(l.mainPID).then(async a=>(r.push(""),r.push(this.formatEnvironment(l)),r.push(""),r.push(this.formatProcessList(l,a)),l.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(l))),s.forEach(f=>{if((0,m.isRemoteDiagnosticError)(f))r.push(`
${f.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${f.hostName}`),r.push(this.formatMachineInfo(f.machineInfo)),f.processes&&r.push(this.formatProcessList(l,f.processes)),f.workspaceMetadata)for(const w of Object.keys(f.workspaceMetadata)){const k=f.workspaceMetadata[w];let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),r.push(`Folder (${w}): ${R}`),r.push(this.formatWorkspaceStats(k))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(l){const s=[],r=60;let a=0;const f=(A,F)=>{const H=` ${A}(${F})`;a+H.length>r?(s.push(w),w="|                 ",a=w.length):a+=H.length,w+=H};let w="|      File types:";const k=10;let R=l.fileTypes.length>k?k:l.fileTypes.length;for(let A=0;A<R;A++){const F=l.fileTypes[A];f(F.name,F.count)}if(s.push(w),l.configFiles.length>=0&&(w="|      Conf files:",a=0,l.configFiles.forEach(A=>{f(A.name,A.count)}),s.push(w)),l.launchConfigFiles.length>0){let A="|      Launch Configs:";l.launchConfigFiles.forEach(F=>{A+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),s.push(A)}return s.join(`
`)}expandGPUFeatures(l){const s=Math.max(...Object.keys(l).map(r=>r.length));return Object.keys(l).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${l[r]}`).join(`
                  `)}formatWorkspaceMetadata(l){const s=[],r=[];return l.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(f=>{const w=d.URI.revive(f);if(w.scheme===P.Schemas.file){const k=w.fsPath;r.push(y(k,["node_modules",".git"]).then(R=>{let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),s.push(`|    Folder (${(0,E.basename)(k)}): ${A}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${R.toString()})`)}))}else s.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(l,s){const r=new Map;l.windows.forEach(f=>r.set(f.pid,f.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(l.mainPID,r,a,s,0),a.join(`
`)}formatProcessItem(l,s,r,a,f){const w=f===0;let k;w?k=a.pid===l?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(f)} ${a.name}`,a.name==="window"&&(k=`${k} (${s.get(a.pid)})`));const R=process.platform==="win32"?a.mem:p.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(l,s,r,A,f+1))}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const r=d.URI.revive(s);if(r.scheme!==P.Schemas.file)continue;const a=r.fsPath;try{const f=await y(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),f.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})}),f.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})}),f.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};u=he([te(0,b.ITelemetryService),te(1,g.IProductService)],u),e.DiagnosticsService=u}),define(Z[203],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(M){this.appenders=M}listen(M,P){throw new Error(`Event not found: ${P}`)}call(M,P,{eventName:E,data:h}){return this.appenders.forEach(d=>d.log(E,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(M){this.channel=M}log(M,P){return this.channel.call("log",{eventName:M,data:P}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[64],x([0,1,43,14,19,30]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,I){return Promise.resolve(void 0)}publicLog2(y,I){return this.publicLog(y,I)}publicLogError(y,I){return Promise.resolve(void 0)}publicLogError2(y,I){return this.publicLogError(y,I)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class E{async publicLog(y,I,c){}async publicLogError(y,I,c){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(b,y){return y.onDidChangeConfiguration(I=>{I.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(I.source),configurationKeys:t(I.sourceConfig)})})}e.configurationTelemetry=h;function d(b,y){return!(y.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=d;function i(b){const y=b.getValue(M.TELEMETRY_SETTING_ID),I=b.getValue("telemetry.enableCrashReporter");if(b.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||I===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function S(b){const y=Object.create(null),I=Object.create(null),c=Object.create(null);m(b,c);for(let o in c){o=o.length>150?o.substr(o.length-149):o;const u=c[o];typeof u=="number"?I[o]=u:typeof u=="boolean"?I[o]=u?1:0:typeof u=="string"?y[o]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(y[o]=u)}return{properties:y,measurements:I}}e.validateTelemetryData=S;function v(b){if(!b)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{b.indexOf(`${c}+`)===0&&(y=c)}),y}e.cleanRemoteAuthority=v;function m(b,y,I=0,c){if(!!b)for(let o of Object.getOwnPropertyNames(b)){const u=b[o],n=c?c+o:o;Array.isArray(u)?y[n]=(0,p.safeStringify)(u):u instanceof Date?y[n]=u.toISOString():(0,L.isObject)(u)?I<2?m(u,y,I+1,n+"."):y[n]=(0,p.safeStringify)(u):y[n]=u}}function t(b){if(!b)return[];const y=[];return g(y,"",b),y}function g(b,y,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(c=>g(b,y?`${y}.${c}`:c,I[c])):b.push(y)}}),define(Z[204],x([0,1,31,23,16,43,3,32,7,19,47,168,195,165,18,6,21,51,198,98,30,64]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=P.isWeb?"web":(0,S.getTargetPlatform)(P.platform,E.arch);var l;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished"})(l||(l={}));function s(...C){return String(C.reduce(($,J)=>$|J,0))}var r;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class R{constructor($=k){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,J=this.state.pageSize){return new R({...this.state,pageNumber:$,pageSize:J})}withFilter($,...J){const Q=[...this.state.criteria,...J.length?J.map(ne=>({filterType:$,value:ne})):[{filterType:$}]];return new R({...this.state,criteria:Q})}withSortBy($){return new R({...this.state,sortBy:$})}withSortOrder($){return new R({...this.state,sortOrder:$})}withFlags(...$){return new R({...this.state,flags:$.reduce((J,Q)=>J|Q,0)})}withAssetTypes(...$){return new R({...this.state,assetTypes:$})}get raw(){const{criteria:$,pageNumber:J,pageSize:Q,sortBy:ne,sortOrder:le,flags:oe,assetTypes:se}=this.state;return{filters:[{criteria:$,pageNumber:J,pageSize:Q,sortBy:ne,sortOrder:le}],assetTypes:se,flags:oe}}get searchText(){const $=this.state.criteria.filter(J=>J.filterType===r.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(C,$){const J=(C||[]).filter(Q=>Q.statisticName===$)[0];return J?J.value:0}function F(C){const $="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(Q=>Q.assetType.indexOf($)===0).reduce((Q,ne)=>{const le=G(C,ne.assetType);return le&&Q.push([ne.assetType.substring($.length),le]),Q},[])}function H(C){if(C.properties){const $=C.properties.filter(ne=>ne.key===a.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=$.filter(ne=>J.test(ne.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return G(C,a.Repository)}function ie(C){return{uri:`${C.fallbackAssetUri}/${a.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${a.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function re(C){const $=G(C,a.Icon);if($)return $;const J=S.DefaultIconPath;return{uri:J,fallbackUri:J}}function G(C,$){return C.files.filter(Q=>Q.assetType===$)[0]?{uri:`${C.assetUri}/${$}`,fallbackUri:`${C.fallbackAssetUri}/${$}`}:null}function ee(C,$){const J=C.properties?C.properties.filter(ne=>ne.key===$):[],Q=J.length>0&&J[0].value;return Q?Q.split(",").map(ne=>(0,v.adoptToGalleryExtensionId)(ne)):[]}function T(C){const $=C.properties?C.properties.filter(J=>J.key===f.Engine):[];return $.length>0&&$[0].value||""}function V(C){const $=C.properties?C.properties.filter(Q=>Q.key===f.LocalizedLanguages):[],J=$.length>0&&$[0].value||"";return J?J.split(","):[]}function U(C){return C.indexOf("preview")!==-1}function B(C){return C.targetPlatform?(0,S.toTargetPlatform)(C.targetPlatform):"undefined"}function N(C){const $=(0,p.distinct)(C.versions.map(B)),J=!!C.tags?.includes(S.WEB_EXTENSION_TAG),Q=$.indexOf("web");return J?Q===-1&&$.push("web"):Q!==-1&&$.splice(Q,1),$}function _(C,$){const J=(0,S.getFallbackTargetPlarforms)($);for(let Q=0;Q<C.length;Q++){const ne=C[Q];if(ne.version===C[Q-1]?.version){let le=Q;const oe=B(ne);if(oe===$)for(;le>0&&C[le-1].version===ne.version;)le--;else if(J.includes(oe))for(;le>0&&C[le-1].version===ne.version&&B(C[le-1])!==$;)le--;le!==Q&&(C.splice(Q,1),C.splice(le,0,ne))}}return C}e.sortExtensionVersions=_;function X(C,$,J,Q,ne){const le=N(C);let oe=C.versions[0];return oe=C.versions.find(se=>se.version===oe.version&&(0,S.isTargetPlatformCompatible)(B(se),le,ne))||oe,W(C,oe,le,$,J,Q)}function W(C,$,J,Q,ne,le){const oe={manifest:G($,a.Manifest),readme:G($,a.Details),changelog:G($,a.Changelog),license:G($,a.License),repository:H($),download:ie($),icon:re($),coreTranslations:F($)};return{identifier:{id:(0,v.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:$.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,publisherDomain:C.publisher.domain?{link:C.publisher.domain,verified:!!C.publisher.isDomainVerified}:void 0,description:C.shortDescription||"",installCount:A(C.statistics,"install"),rating:A(C.statistics,"averagerating"),ratingCount:A(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:J,assets:oe,properties:{dependencies:ee($,f.Dependency),extensionPack:ee($,f.ExtensionPack),engine:T($),localizedLanguages:V($),targetPlatform:B($)},preview:U(C.flags),telemetryData:{index:(ne.pageNumber-1)*ne.pageSize+Q,querySource:le}}}let z=class{constructor($,J,Q,ne,le,oe,se,ce){this.requestService=J,this.logService=Q,this.environmentService=ne,this.telemetryService=le,this.fileService=oe,this.productService=se,this.configurationService=ce;const ge=se.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=q(se.version,se,this.environmentService,this.configurationService,this.fileService,$)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,J){const Q=[];let ne=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,$.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...$.map(({id:oe})=>oe.toLowerCase()));$.every(oe=>!oe.version)&&(ne=ne.withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties,l.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ne,n,L.CancellationToken.None);for(let oe=0;oe<le.length;oe++){const se=le[oe];if(!se.versions.length)continue;const ce=(0,v.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),ge=$.find(de=>(0,v.areSameExtensions)(de,{id:ce}))?.version;if(ge){const de=se.versions.find(Ee=>Ee.version===ge);de&&Q.push(W(se,de,N(se),oe,ne))}else Q.push(X(se,oe,ne,void 0,n))}return Q}async getCompatibleExtension($,J){const Q=(0,S.isIExtensionIdentifier)($)?null:$;if(Q){if((0,S.isNotWebExtensionInWebTargetPlatform)(Q.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(Q,J))return Q}const{id:ne,uuid:le}=Q?Q.identifier:$;let oe=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?oe=oe.withFilter(r.ExtensionId,le):oe=oe.withFilter(r.ExtensionName,ne);const{galleryExtensions:se}=await this.queryGallery(oe,J,L.CancellationToken.None),[ce]=se;if(!ce||!ce.versions.length)return null;const ge=N(ce);if((0,S.isNotWebExtensionInWebTargetPlatform)(ge,J))return null;for(let de of ce.versions){if(!T(de)){const Ee=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:f.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(de,ge,J))return W(ce,de,ge,0,oe)}return null}async isExtensionCompatible($,J){if(!(0,S.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,J))return!1;let Q=$.properties.engine;if(!Q){const ne=await this.getManifest($,L.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");Q=ne.engines.vscode}return(0,m.isEngineValid)(Q,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible($,J,Q){if(!(0,S.isTargetPlatformCompatible)(B($),J,Q))return!1;const ne=await this.getEngine($);return(0,m.isEngineValid)(ne,this.productService.version,this.productService.date)}async query($,J){const Q=L.CancellationToken.isCancellationToken($)?{}:$,ne=L.CancellationToken.isCancellationToken($)?$:J;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=Q.text||"";const oe=(0,M.getOrDefault)(Q,Pe=>Pe.pageSize,50);let se=new R().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,oe).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Ie,ve)=>(se=se.withFilter(r.Category,ve||Ie),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Ie,ve)=>(se=se.withFilter(r.Tag,ve||Ie),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(r.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),se=se.withFilter(r.SearchText,le)),se=se.withSortBy(0)):Q.ids?se=se.withFilter(r.ExtensionId,...Q.ids):Q.names?se=se.withFilter(r.ExtensionName,...Q.names):se=se.withSortBy(4),typeof Q.sortBy=="number"&&(se=se.withSortBy(Q.sortBy)),typeof Q.sortOrder=="number"&&(se=se.withSortOrder(Q.sortOrder));const{galleryExtensions:ce,total:ge}=await this.queryGallery(se,n,ne),de=ce.map((Pe,Ie)=>X(Pe,Ie,se,Q.source,n)),Ee=async(Pe,Ie)=>{if(Ie.isCancellationRequested)throw(0,D.canceled)();const ve=se.withPage(Pe+1),{galleryExtensions:ye}=await this.queryGallery(ve,n,Ie);return ye.map((ke,We)=>X(ke,We,ve,Q.source,n))};return{firstPage:de,total:ge,pageSize:se.pageSize,getPage:Ee}}async queryGallery($,J,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,l.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(l.Unpublished));const ne=await this.commonHeadersPromise,le=JSON.stringify($.raw),oe={...ne,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},se=new Date().getTime();let ce,ge,de=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:oe},Q),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:de};const Ee=await(0,y.asJson)(ce);if(Ee){const Pe=Ee.results[0],Ie=Pe.extensions;Ie.forEach(ye=>_(ye.versions,J));const ve=Pe.resultMetadata&&Pe.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return de=ve&&ve.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:Ie,total:de}}return{galleryExtensions:[],total:de}}catch(Ee){throw ge=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-se,success:!!ce&&(0,y.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ge?(0,D.isPromiseCanceledError)(ge)?"canceled":(0,D.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic($,J,Q,ne){if(!this.isEnabled())return;const le=P.isWeb?this.api(`/itemName/${$}.${J}/version/${Q}/statType/${ne==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${J}/${Q}/stats?statType=${ne}`),oe=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:le,headers:ce},L.CancellationToken.None)}catch(ge){}}async download($,J,Q){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const ne=(0,v.getGalleryExtensionTelemetryData)($),le=new Date().getTime(),oe=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ne,duration:de}),se=Q===1?"install":Q===2?"update":"",ce=se?{uri:`${$.assets.download.uri}${h.URI.parse($.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${$.assets.download.fallbackUri}${h.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:$.assets.download,ge=await this.getAsset(ce);await this.fileService.writeFile(J,ge.stream),oe(new Date().getTime()-le)}async getReadme($,J){if($.assets.readme){const Q=await this.getAsset($.assets.readme,{},J);return await(0,y.asText)(Q)||""}return""}async getManifest($,J){if($.assets.manifest){const Q=await this.getAsset($.assets.manifest,{},J),ne=await(0,y.asText)(Q);return ne?JSON.parse(ne):null}return null}async getManifestFromRawExtensionVersion($,J){const Q=G($,a.Manifest);if(!Q)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},le=await this.getAsset(Q,{headers:ne});return await(0,y.asJson)(le)}async getCoreTranslation($,J){const Q=$.assets.coreTranslations.filter(ne=>ne[0]===J.toUpperCase())[0];if(Q){const ne=await this.getAsset(Q[1]),le=await(0,y.asText)(ne);return le?JSON.parse(le):null}return null}async getChangelog($,J){if($.assets.changelog){const Q=await this.getAsset($.assets.changelog,{},J);return await(0,y.asText)(Q)||""}return""}async getAllCompatibleVersions($,J){let Q=new R().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");$.identifier.uuid?Q=Q.withFilter(r.ExtensionId,$.identifier.uuid):Q=Q.withFilter(r.ExtensionName,$.identifier.id);const{galleryExtensions:ne}=await this.queryGallery(Q,J,L.CancellationToken.None);if(!ne.length)return[];const le=N(ne[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(le,J))return[];const oe=[];for(const se of ne[0].versions)try{oe[oe.length-1]?.version!==se.version&&await this.isRawExtensionVersionCompatible(se,le,J)&&oe.push({version:se.version,date:se.lastUpdated})}catch(ce){}return oe}async getAsset($,J={},Q=L.CancellationToken.None){const ne=await this.commonHeadersPromise,le={type:"GET"},oe={...ne,...J.headers||{}};J={...J,...le,headers:oe};const se=$.uri,ce=$.fallbackUri,ge={...J,url:se};try{const de=await this.requestService.request(ge,Q);if(de.res.statusCode===200)return de;const Ee=await(0,y.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Ee}`)}catch(de){if((0,D.isPromiseCanceledError)(de))throw de;const Ee=(0,D.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:se,message:Ee});const Pe={...J,url:ce};return this.requestService.request(Pe,Q)}}async getEngine($){let J=T($);if(!J){const Q=await this.getManifestFromRawExtensionVersion($,L.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");J=Q.engines.vscode}return J}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,y.asJson)($),Q=new Map;if(J)for(const ne of J.malicious){const le=Q.get(ne)||{id:{id:ne},malicious:!0,slow:!1};le.malicious=!0,Q.set(ne,le)}return[...Q.values()]}};z=he([te(1,y.IRequestService),te(2,g.ILogService),te(3,i.IEnvironmentService),te(4,o.ITelemetryService),te(5,t.IFileService),te(6,b.IProductService),te(7,d.IConfigurationService)],z);let K=class extends z{constructor($,J,Q,ne,le,oe,se,ce){super($,J,Q,ne,le,oe,se,ce)}};K=he([te(0,c.IStorageService),te(1,y.IRequestService),te(2,g.ILogService),te(3,i.IEnvironmentService),te(4,o.ITelemetryService),te(5,t.IFileService),te(6,b.IProductService),te(7,d.IConfigurationService)],K),e.ExtensionGalleryService=K;let O=class extends z{constructor($,J,Q,ne,le,oe,se){super(void 0,$,J,Q,ne,le,oe,se)}};O=he([te(0,y.IRequestService),te(1,g.ILogService),te(2,i.IEnvironmentService),te(3,o.ITelemetryService),te(4,t.IFileService),te(5,b.IProductService),te(6,d.IConfigurationService)],O),e.ExtensionGalleryServiceWithNoStorageService=O;async function q(C,$,J,Q,ne,le){const oe={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C}`},se=await(0,I.getServiceMachineId)(J,ne,le);return(0,u.supportsTelemetry)($,J)&&(0,u.getTelemetryLevel)(Q)===3&&(oe["X-Market-User-Id"]=se),oe}e.resolveMarketplaceHeaders=q}),define(Z[205],x([0,1,2,43,3,25,151,19,50,49,37,30,64]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(b,y){this._configurationService=y,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(I),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(I=>{const c=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(b,y){this._experimentProperties[b]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,v.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let y=b.sessionID,I=b["common.instanceId"],c=b["common.machineId"],o=b["common.firstSessionDate"],u=b["common.msftInternal"];return{sessionId:y,instanceId:I,machineId:c,firstSessionDate:o,msftInternal:u}}dispose(){this._disposables.dispose()}_log(b,y,I,c){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(o=>{I=(0,L.mixin)(I,o),I=(0,L.mixin)(I,this._experimentProperties),I=(0,L.cloneAndChange)(I,u=>{if(typeof u=="string")return this._cleanupInfo(u,c)}),this._appenders.forEach(u=>u.log(b,I))},o=>{console.error(o)})}publicLog(b,y,I){return this._log(b,3,y,I)}publicLog2(b,y,I){return this.publicLog(b,y,I)}publicLogError(b,y){return this.sendErrorTelemetry?this._log(b,2,y,!0):Promise.resolve(void 0)}publicLogError2(b,y){return this.publicLogError(b,y)}_anonymizeFilePaths(b){let y=b;const I=[];for(let n of this._cleanupPatterns)for(;;){const l=n.exec(b);if(!l)break;I.push([l.index,n.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(y="";;){const n=o.exec(b);if(!n)break;!c.test(n[0])&&I.every(([l,s])=>n.index<l||n.index>=s)&&(y+=b.substring(u,n.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<b.length&&(y+=b.substr(u)),y}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const y=b.toLowerCase(),I=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(y)?"<REDACTED: secret>":I.test(y)?"<REDACTED: email>":b}_cleanupInfo(b,y){let I=b;y&&(I=this._anonymizeFilePaths(I));for(let c of this._cleanupPatterns)I=I.replace(c,"");return I=this._removePropertiesWithPossibleUserInfo(I),I}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=he([te(1,E.IConfigurationService)],m),e.TelemetryService=m;function t(){const g=(0,P.localize)(0,null,d.default.nameLong),b=d.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=D.isWeb?"":(0,P.localize)(3,null),I=(0,P.localize)(4,null),c=(0,P.localize)(5,null),o=(0,P.localize)(6,null),u=(0,P.localize)(7,null),n=`
|       | ${I} | ${c} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,P.localize)(8,null);return`
${g} ${b} ${y}

&nbsp;

${u}
${n}

&nbsp;

${l}
`}i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,P.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,P.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[206],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[207],x([0,1,109,4,2,5,37,206]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var h;(function(b){function y(I){return I&&typeof I=="object"&&typeof I.id=="string"}b.isThemeColor=y})(h=e.ThemeColor||(e.ThemeColor={}));function d(b){return{id:b}}e.themeColorFromId=d;var i;(function(b){function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||h.isThemeColor(l.color))}b.isThemeIcon=y;const I=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function c(l){const s=I.exec(l);if(!s)return;let[,r]=s;return{id:r}}b.fromString=c;function o(l,s){let r=l.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),s&&(r=`${r}~${s}`),{id:r}}b.modify=o;function u(l,s){return l.id===s.id&&l.color?.id===s.color?.id}b.isEqual=u;function n(l,s){return{id:l.id,color:s?d(s):void 0}}b.asThemeIcon=n,b.asClassNameArray=p.CSSIcon.asClassNameArray,b.asClassName=p.CSSIcon.asClassName,b.asCSSSelector=p.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function S(b){switch(b){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,D.toDisposable)(()=>{const I=this.themingParticipants.indexOf(y);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new v;P.Registry.add(e.Extensions.ThemingContribution,m);function t(b){return m.onColorThemeChange(b)}e.registerThemingParticipant=t;class g extends D.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,I){let c=this.theme.getColor(y);return c&&I&&(c=I(c,this.theme)),c?c.toString():null}}e.Themable=g}),define(Z[65],x([0,1,13,3,5,38]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",E="#1E1E1E",h="#000000",d="theme",i="themeBackground",S="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let v=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return h;let t=this.stateMainService.getItem(i,null);if(!t){let g;(L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(d,"vs-dark").split(" ")[0],t=g==="hc-black"?h:g==="vs"?P:E}return L.isMacintosh&&t.toUpperCase()===E&&(t="#171717"),t}saveWindowSplash(t,g){this.stateMainService.setItems([{key:d,data:g.baseTheme},{key:i,data:g.colorInfo.background},{key:S,data:g}]),typeof t=="number"&&this.updateBackgroundColor(t,g)}updateBackgroundColor(t,g){for(const b of p.BrowserWindow.getAllWindows())if(b.id===t){b.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(S)}};v=he([te(0,M.IStateMainService)],v),e.ThemeMainService=v}),define(Z[41],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var D;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,P)=>({type:"idle",updateType:M,error:P}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[208],x([0,1,3,152,50,37]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[209],x([0,1,4,41]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(E){this.service=E}listen(E,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,d){switch(h){case"checkForUpdates":return this.service.checkForUpdates(d);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=D;class M{constructor(E){this.channel=E,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[99],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[210],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(E){this.handler=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,d){switch(h){case"handleURL":return this.handler.handleURL(p.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class D{constructor(E){this.channel=E}handleURL(E,h){return this.channel.call("handleURL",[E.toJSON(),h])}}e.URLHandlerChannelClient=D;class M{constructor(E){this.next=E}async routeCall(E,h,d,i){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(d){const S=p.URI.revive(d);if(S&&S.query){const v=/\bwindowId=(\d+)/.exec(S.query);if(v){const m=v[1],t=new RegExp(`window:${m}`),g=E.connections.find(b=>t.test(b.ctx));if(g)return g}}}return this.next.routeCall(E,h,d,i)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=M}),define(Z[211],x([0,1,9,2,7,21]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(d,i){const S=[...this.handlers.values()];return(0,p.first)(S.map(v=>()=>v.handleURL(d,i)),void 0,!1).then(v=>v||!1)}registerHandler(d){return this.handlers.add(d),(0,L.toDisposable)(()=>this.handlers.delete(d))}}e.AbstractURLService=P;let E=class extends P{constructor(d){super();this.productService=d}create(d){let{authority:i,path:S,query:v,fragment:m}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&S&&S.indexOf("/")!==0&&(S=`/${S}`),D.URI.from({scheme:this.productService.urlProtocol,authority:i,path:S,query:v,fragment:m})}};E=he([te(0,M.IProductService)],E),e.NativeURLService=E}),define(Z[212],x([0,1,13,9,4,2,3,7]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(i){try{return E.URI.parse(i)}catch(S){return null}}class d{constructor(S,v,m,t,g){if(this.urlService=v,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=S,P.isWindows){const I=t.isBuilt?[]:[`"${t.appRoot}"`];I.push("--open-url","--"),p.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,I)}const b=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(I,c)=>({event:I,url:c})),({event:I,url:c})=>(I.preventDefault(),c));this.disposables.add(b(I=>{const c=h(I);!c||this.urlService.open(c,{originalUrl:I})})),m.getWindows().filter(I=>I.isReady).length>0?this.flush():D.Event.once(m.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const S=[];for(const v of this.uris)await this.urlService.open(v.uri,{originalUrl:v.url})||S.push(v);S.length!==0&&(this.uris=S,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=d}),define(Z[213],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[214],x([0,1,13,2,10,7]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class P extends L.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,h)}handleWebviewRequest(h,d){try{const i=M.URI.parse(h.url),S=P.validWebviewFilePaths.get(i.path);if(typeof S=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${S}`,m=D.FileAccess.asFileUri(v,j);return d(decodeURIComponent(m.fsPath))}else return d({error:-10})}catch{}return d({error:-2})}}e.WebviewProtocolProvider=P,P.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[66],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(d){return!!d.workspaceUri}e.isWorkspaceToOpen=L;function D(d){return!!d.folderUri}e.isFolderToOpen=D;function M(d){return!!d.fileUri}e.isFileToOpen=M;function P(d){const i=E(d),S=d.getValue("window.menuBarVisibility");return S==="default"||i==="native"&&S==="compact"||p.isMacintosh&&p.isNative?"classic":S}e.getMenuBarVisibility=P;function E(d){if(p.isWeb)return"custom";const i=d.getValue("window");if(i){if(p.isMacintosh&&i.nativeTabs===!0||p.isMacintosh&&i.nativeFullScreen===!1)return"native";const m=d.getValue("workbench.colorCustomizations");if(m?.["window.activeBorder"]||m?.["window.inactiveBorder"])return"custom";const t=i.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=E;function h(d=0){return Math.pow(1.2,d)}e.zoomLevelToZoomFactor=h}),define(Z[36],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(d){d[d.INITIAL=1]="INITIAL",d[d.LOAD=2]="LOAD",d[d.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var D;(function(d){d[d.CLOSE=1]="CLOSE",d[d.QUIT=2]="QUIT",d[d.RELOAD=3]="RELOAD",d[d.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var M;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const P=function(d=1){return{width:1024,height:768,mode:d}};e.defaultWindowState=P;var E;(function(d){d[d.Maximized=0]="Maximized",d[d.Normal=1]="Normal",d[d.Minimized=2]="Minimized",d[d.Fullscreen=3]="Fullscreen"})(E=e.WindowMode||(e.WindowMode={}));var h;(function(d){d[d.UNRESPONSIVE=1]="UNRESPONSIVE",d[d.CRASHED=2]="CRASHED",d[d.LOAD=3]="LOAD"})(h=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[215],x([0,1,13,4,2,214,36]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends D.Disposable{constructor(d){super();this.windowsMainService=d,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,i){let S;if(typeof d.windowId=="number"){const{windowId:v}=d,m=this.windowsMainService.getWindowById(v);if(!m?.win)throw new Error(`Invalid windowId: ${v}`);S=m.win.webContents}else{const{webContentsId:v}=d;if(S=p.webContents.fromId(v),!S)throw new Error(`Invalid webContentsId: ${v}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(i)}async findInFrame(d,i,S,v){const m=this.getFrameByName(d,i),t=m;if(typeof t.findInFrame=="function"){t.findInFrame(S,{findNext:v.findNext,forward:v.forward});const g=(b,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),m.removeListener("found-in-frame",g))};m.on("found-in-frame",g)}}async stopFindInFrame(d,i,S){const m=this.getFrameByName(d,i);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(S.keepSelection?"keepSelection":"clearSelection")}getFrameByName(d,i){const S=this.windowsMainService.getWindowById(d.windowId);if(!S?.win)throw new Error(`Invalid windowId: ${d}`);const v=S.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===i);if(!v)throw new Error(`Unknown frame: ${i}`);return v}};E=he([te(0,P.IWindowsMainService)],E),e.WebviewMainService=E}),define(Z[216],x([0,1,9,4,2]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends D.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:h,getActiveWindowId:d}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(E,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>d()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch(S){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[217],x([0,1,40,15,7,5]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var P;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function E(v){const m=v;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=E;function h(v){const m=v;return!!(m&&typeof m=="object"&&D.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(m,t,g,b,y){this._id=m,this._transient=g,this._configuration=b,this._ignorePathCasing=y,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class i{constructor(m,t){this.raw=t,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function S(v){return new i({uri:v,index:0,name:(0,L.basenameOrAuthority)(v)},{uri:v.toString()})}e.toWorkspaceFolder=S}),define(Z[27],x([0,1,33,39,79,34,10,8,3,15,7,155,5,63,217]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(T){return(typeof T=="string"?(0,E.extname)(T):(0,d.extname)(T))===g}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function y(T){return T.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function I(T){return T.hasOwnProperty("folderUri")}e.isRecentFolder=I;function c(T){return T.hasOwnProperty("fileUri")}e.isRecentFile=c;function o(T){const V=T;return typeof V?.id=="string"&&i.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(T){if(T.configuration)return{id:T.id,configPath:T.configuration};if(T.folders.length===1)return{id:T.id,uri:T.folders[0].uri}}e.toWorkspaceIdentifier=u;function n(T){const V=T;return typeof V?.id=="string"&&i.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=n;function l(T){const V=T;if(V?.uri)return{id:V.id,uri:i.URI.revive(V.uri)};const U=T;if(U?.configPath)return{id:U.id,configPath:i.URI.revive(U.configPath)};if(T?.id)return{id:T.id}}e.reviveIdentifier=l;function s(T,V){return d.extUriBiasedIgnorePathCase.isEqualOrParent(T,V.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(T){return a(T)||f(T)}e.isStoredWorkspaceFolder=r;function a(T){const V=T;return typeof V?.path=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=a;function f(T){const V=T;return typeof V?.uri=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=f;function w(T,V,U,B,N=!h.isWindows,_){if(T.scheme!==B.scheme)return{name:U,uri:T.toString(!0)};let X=V?void 0:_.relativePath(B,T);if(X!==void 0)X.length===0?X=".":h.isWindows&&T.scheme===P.Schemas.file&&!N&&(X=X.replace(/\//g,"\\"));else if(T.scheme===P.Schemas.file)X=T.fsPath,h.isWindows&&(X=(0,M.normalizeDriveLetter)(X),N&&(X=(0,p.toSlashes)(X)));else{if(!_.isEqualAuthority(T.authority,B.authority))return{name:U,uri:T.toString(!0)};X=T.path}return{name:U,path:X}}e.getStoredWorkspaceFolder=w;function k(T,V,U){let B=[],N=new Set;const _=U.dirname(V);for(let X of T){let W;if(a(X))X.path&&(W=U.resolvePath(_,X.path));else if(f(X))try{W=i.URI.parse(X.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(z){console.warn(z)}if(W){let z=U.getComparisonKey(W);if(!N.has(z)){N.add(z);const K=X.name||U.basenameOrAuthority(W);B.push(new t.WorkspaceFolder({uri:W,name:K,index:B.length},X))}}}return B}e.toWorkspaceFolders=k;function R(T,V,U,B,N){let _=A(V,T);const X=N.dirname(V),W=N.dirname(B),z=[],K=F(_.folders);for(const $ of _.folders){const J=a($)?N.resolvePath(X,$.path):i.URI.parse($.uri);let Q;U?Q=!1:Q=!a($)||(0,E.isAbsolute)($.path),z.push(w(J,Q,$.name,W,K,N))}const O={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},q=D.setProperty(T,["folders"],z,O);let C=D.applyEdits(T,q);return _.remoteAuthority===(0,m.getRemoteAuthority)(B)&&(C=D.applyEdits(C,D.removeProperty(C,["remoteAuthority"],O))),C}e.rewriteWorkspaceFileForNewLocation=R;function A(T,V){let U=L.parse(V);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(B=>r(B));else throw new Error(`${T} looks like an invalid workspace file.`);return U}function F(T){return h.isWindows?T.some(V=>a(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function H(T){return T.workspace&&typeof T.workspace=="object"&&typeof T.workspace.id=="string"&&typeof T.workspace.configPath=="string"}function ie(T){return typeof T.folderUri=="string"}function re(T){return typeof T.fileUri=="string"}function G(T,V){const U={workspaces:[],files:[]};if(T){const B=function(_,X){for(let W=0;W<_.length;W++)try{X(_[W],W)}catch(z){V.warn(`Error restoring recent entry ${JSON.stringify(_[W])}: ${z.toString()}. Skip entry.`)}},N=T;if(Array.isArray(N.entries))B(N.entries,_=>{const X=_.label,W=_.remoteAuthority;H(_)?U.workspaces.push({label:X,remoteAuthority:W,workspace:{id:_.workspace.id,configPath:i.URI.parse(_.workspace.configPath)}}):ie(_)?U.workspaces.push({label:X,remoteAuthority:W,folderUri:i.URI.parse(_.folderUri)}):re(_)&&U.files.push({label:X,remoteAuthority:W,fileUri:i.URI.parse(_.fileUri)})});else{const _=T;Array.isArray(_.workspaces3)&&B(_.workspaces3,(X,W)=>{const z=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[W]||void 0;typeof X=="object"&&typeof X.id=="string"&&typeof X.configURIPath=="string"?U.workspaces.push({label:z,workspace:{id:X.id,configPath:i.URI.parse(X.configURIPath)}}):typeof X=="string"&&U.workspaces.push({label:z,folderUri:i.URI.parse(X)})}),Array.isArray(_.files2)&&B(_.files2,(X,W)=>{const z=Array.isArray(_.fileLabels)&&_.fileLabels[W]||void 0;typeof X=="string"&&U.files.push({label:z,fileUri:i.URI.parse(X)})})}}return U}e.restoreRecentlyOpened=G;function ee(T){const V={entries:[]};for(const U of T.workspaces)I(U)?V.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):V.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of T.files)V.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return V}e.toStoreData=ee}),define(Z[52],x([0,1,5,27]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function D(M){const P=M;return P&&(0,L.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=D}),define(Z[53],x([0,1,13,9,82,34,2,69,8,3,14,20,135,5,6,38,27]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let y=class mt{constructor(c,o){this.stateMainService=c,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(c,o){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},o)}pickFolder(c,o){return this.doPick({...c,pickFolders:!0,title:(0,v.localize)(1,null)},o)}pickFile(c,o){return this.doPick({...c,pickFiles:!0,title:(0,v.localize)(2,null)},o)}pickWorkspace(c,o){const u=(0,v.localize)(3,null),n=(0,M.mnemonicButtonLabel)((0,v.localize)(4,null)),l=b.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:u,filters:l,buttonLabel:n},o)}async doPick(c,o){const u={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};u.defaultPath=c.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(u.properties=void 0,c.pickFiles&&c.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&u.properties.push("treatPackageAsDirectory");const n=o||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(u,(0,i.withNullAsUndefined)(n));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,h.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(c){if(c){let o=this.windowDialogQueues.get(c.id);return o||(o=new L.Queue,this.windowDialogQueues.set(c.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(c,o){return this.getWindowDialogQueue(o).queue(async()=>o?p.dialog.showMessageBox(o,c):p.dialog.showMessageBox(c))}async showSaveDialog(c,o){const u=this.acquireFileDialogLock(c,o);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let n;return o?n=await p.dialog.showSaveDialog(o,c):n=await p.dialog.showSaveDialog(c),n.filePath=this.normalizePath(n.filePath),n})}finally{(0,P.dispose)(u)}}normalizePath(c){return c&&d.isMacintosh&&(c=(0,E.normalizeNFC)(c)),c}normalizePaths(c){return c.map(o=>this.normalizePath(o))}async showOpenDialog(c,o){c.defaultPath&&(await S.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const u=this.acquireFileDialogLock(c,o);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let n;return o?n=await p.dialog.showOpenDialog(o,c):n=await p.dialog.showOpenDialog(c),n.filePaths=this.normalizePaths(n.filePaths),n})}finally{(0,P.dispose)(u)}}acquireFileDialogLock(c,o){if(!o)return P.Disposable.None;let u=this.windowFileDialogLocks.get(o.id);u||(u=new Set,this.windowFileDialogLocks.set(o.id,u));const n=(0,D.hash)(c);if(!u.has(n))return u.add(n),(0,P.toDisposable)(()=>{u?.delete(n),u?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};y.workingDirPickerStorageKey="pickerWorkingDir",y=he([te(0,g.IStateMainService),te(1,t.ILogService)],y),e.DialogMainService=y}),define(Z[218],x([0,1,4,2,27]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(E,h){super();this.logService=E,this.storageMainService=h,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(E,h)=>(E?E.push(h):E=[h],E),M.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(E))}))}serializeGlobalStorageEvents(E){const h=new Map,d=new Set;return E.forEach(i=>{const S=this.storageMainService.globalStorage.get(i.key);typeof S=="string"?h.set(i.key,S):d.add(i.key)}),{changed:Array.from(h.entries()),deleted:Array.from(d.values())}}listen(E,h){switch(h){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${h}`)}async call(E,h,d){const i=(0,D.reviveIdentifier)(d.workspace),S=await this.withStorageInitialized(i);switch(h){case"getItems":return Array.from(S.items.entries());case"updateItems":{const v=d;if(v.insert)for(const[m,t]of v.insert)S.set(m,t);v.delete&&v.delete.forEach(m=>S.delete(m));break}case"close":{if(i)return S.close();break}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(E){const h=E?this.storageMainService.workspaceStorage(E):this.storageMainService.globalStorage;try{await h.init()}catch(d){this.logService.error(`StorageIPC#init: Unable to init ${E?"workspace":"global"} storage due to ${d}`)}return h}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[219],x([0,1,4,2,8,28,20,87,125,6,98,30,27]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class m extends L.Disposable{constructor(y){super();this.logService=y,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const y=await this.doCreate();this.storage.dispose(),this.storage=y,this._register(y.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(y);const I=y.getBoolean(i.IS_NEW_KEY);I===void 0?y.set(i.IS_NEW_KEY,!0):I&&y.set(i.IS_NEW_KEY,!1)}catch(y){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${y}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===d.LogLevel.Trace?y=>this.logService.trace(y):void 0,logError:y=>this.logService.error(y)}}doInit(y){return y.init()}get items(){return this.storage.items}get(y,I){return this.storage.get(y,I)}set(y,I){return this.storage.set(y,I)}delete(y){return this.storage.delete(y)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends m{constructor(y,I,c){super(I);this.options=y,this.environmentService=c}async doCreate(){let y;return this.options.useInMemoryStorage?y=h.SQLiteStorageDatabase.IN_MEMORY_PATH:y=(0,D.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new E.Storage(new h.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}))}async doInit(y){await super.doInit(y),this.updateTelemetryState(y)}updateTelemetryState(y){y.get(S.instanceStorageKey,void 0)===void 0&&y.set(S.instanceStorageKey,(0,M.generateUuid)()),y.get(S.firstSessionDateStorageKey,void 0)===void 0&&y.set(S.firstSessionDateStorageKey,new Date().toUTCString());const o=y.get(S.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();y.set(S.lastSessionDateStorageKey,typeof o=="undefined"?null:o),y.set(S.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class g extends m{constructor(y,I,c,o){super(c);this.workspace=y,this.options=I,this.environmentService=o}async doCreate(){const{storageFilePath:y,wasCreated:I}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new h.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}),{hint:I?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:h.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const y=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),I=(0,D.join)(y,g.WORKSPACE_STORAGE_NAME);return await P.Promises.exists(y)?{storageFilePath:I,wasCreated:!1}:(await P.Promises.mkdir(y,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(y),{storageFilePath:I,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(y){let I;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?I={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(I={workspace:this.workspace.configPath.toString()}),I)try{const c=(0,D.join)(y,g.WORKSPACE_META_NAME);await P.Promises.exists(c)||await P.Promises.writeFile(c,JSON.stringify(I,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[100],x([0,1,42,2,47,5,22,6,219]),function(j,e,p,L,D,M,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let d=class extends L.Disposable{constructor(S,v,m){super();this.logService=S,this.environmentService=v,this.lifecycleMainService=m,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async S=>{S.workspace&&this.workspaceStorage(S.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(S=>{S.join(this.globalStorage.close());for(const[,v]of this.mapWorkspaceToStorage)S.join(v.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const S=new h.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(S.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),S}createWorkspaceStorage(S){return new h.WorkspaceStorageMain(S,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(S){let v=this.mapWorkspaceToStorage.get(S.id);return v||(this.logService.trace(`StorageMainService: creating workspace storage (${S.id})`),v=this.createWorkspaceStorage(S),this.mapWorkspaceToStorage.set(S.id,v),(0,p.once)(v.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${S.id})`),this.mapWorkspaceToStorage.delete(S.id)})),v}};d=he([te(0,E.ILogService),te(1,D.IEnvironmentService),te(2,P.ILifecycleMainService)],d),e.StorageMainService=d}),define(Z[101],x([0,1,15,7,27]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(h,d,i){for(const v of h){const m=v.openedWorkspace;if((0,D.isWorkspaceIdentifier)(m)){const t=i(m);if(t){if(t.folders.some(g=>p.extUriBiasedIgnorePathCase.isEqualOrParent(d,g.uri)))return v}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(d,m.configPath))return v}}const S=h.filter(v=>(0,D.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(d,v.openedWorkspace.uri));if(S.length)return S.sort((v,m)=>-(v.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function P(h,d){for(const i of h)if((0,D.isWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,d)||(0,D.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,d))return i}e.findWindowOnWorkspaceOrFolder=P;function E(h,d){const i=S=>d.some(v=>p.extUriBiasedIgnorePathCase.isEqual(L.URI.file(v),L.URI.file(S)));for(const S of h)if(S.config?.extensionDevelopmentPath?.some(v=>i(v)))return S}e.findWindowOnExtensionDevelopmentPath=E}),define(Z[220],x([0,1,13,2,3,15,7,19,22,6,38,36,27]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class wt extends L.Disposable{constructor(c,o,u,n,l){super();this.windowsMainService=c,this.stateMainService=o,this.lifecycleMainService=u,this.logService=n,this.configurationService=l,this._state=t(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),n&&(c.lastActiveWindow=this.toWindowState(n))}const o=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);o&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>this.toWindowState(n)));const u=b(c);this.stateMainService.setItem(wt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(u=>{const n=(0,v.isWorkspaceIdentifier)(c.openedWorkspace)&&u.workspace?.id===c.openedWorkspace.id,l=(0,v.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&u.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(u.folderUri,c.openedWorkspace.uri);(n||l)&&(u.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(c){return{workspace:(0,v.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,v.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const o=this.doGetNewWindowState(c),u=this.configurationService.getValue("window");let n;return o.hasDefaultState?n=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(n=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),n&&D.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(n=!1)),o.mode===3&&!n&&(o.mode=1),o}doGetNewWindowState(c){const o=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=c.workspace;if((0,v.isWorkspaceIdentifier)(a)){const w=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===a.id).map(k=>k.uiState);if(w.length)return w[0]}if((0,v.isSingleFolderWorkspaceIdentifier)(a)){const w=this.state.openedWindows.filter(k=>k.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(k.folderUri,a.uri)).map(k=>k.uiState);if(w.length)return w[0]}else if(c.backupPath){const w=this.state.openedWindows.filter(k=>k.backupPath===c.backupPath).map(k=>k.uiState);if(w.length)return w[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!o&&f)return f.uiState}let u;const n=p.screen.getAllDisplays();if(n.length===1)u=n[0];else{if(D.isMacintosh){const a=p.screen.getCursorScreenPoint();u=p.screen.getDisplayNearestPoint(a)}!u&&o&&(u=p.screen.getDisplayMatching(o.getBounds())),u||(u=p.screen.getPrimaryDisplay()||n[0])}let l=(0,S.defaultWindowState)();l.x=Math.round(u.bounds.x+u.bounds.width/2-l.width/2),l.y=Math.round(u.bounds.y+u.bounds.height/2-l.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")l.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")l.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const a=o.serializeWindowState();a.mode===3?l.mode=3:l=a,r=l.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const o=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;o.some(u=>u.x===c.x||u.y===c.y);)c.x+=30,c.y+=30;return c}};m.windowsStateStorageKey="windowsState",m=he([te(0,S.IWindowsMainService),te(1,i.IStateMainService),te(2,h.ILifecycleMainService),te(3,d.ILogService),te(4,E.IConfigurationService)],m),e.WindowsStateHandler=m;function t(I){const c={openedWindows:[]},o=I||{openedWindows:[]};return o.lastActiveWindow&&(c.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(c.openedWindows=o.openedWindows.map(u=>g(u))),c}e.restoreWindowsState=t;function g(I){const c={uiState:I.uiState};return I.backupPath&&(c.backupPath=I.backupPath),I.remoteAuthority&&(c.remoteAuthority=I.remoteAuthority),I.folder&&(c.folderUri=P.URI.parse(I.folder)),I.workspaceIdentifier&&(c.workspace={id:I.workspaceIdentifier.id,configPath:P.URI.parse(I.workspaceIdentifier.configURIPath)}),c}function b(I){return{lastActiveWindow:I.lastActiveWindow&&y(I.lastActiveWindow),lastPluginDevelopmentHostWindow:I.lastPluginDevelopmentHostWindow&&y(I.lastPluginDevelopmentHostWindow),openedWindows:I.openedWindows.map(c=>y(c))}}e.getWindowsStateStoreData=b;function y(I){return{workspaceIdentifier:I.workspace&&{id:I.workspace.id,configURIPath:I.workspace.configPath.toString()},folder:I.folderUri&&I.folderUri.toString(),backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.uiState}}}),define(Z[102],x([0,1,61,29,10,3,15]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function E(d){function i(){let S=d.scheme===D.Schemas.file?(0,P.originalFSPath)(d):d.toString();return M.isLinux||(S=S.toLowerCase()),(0,p.createHash)("md5").update(S).digest("hex")}return{id:i(),configPath:d}}e.getWorkspaceIdentifier=E;function h(d,i){function S(){if(d.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(d.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(d.fsPath)}catch(t){return}let m;return M.isLinux?m=i.ino:M.isMacintosh?m=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?m=Math.floor(i.birthtimeMs):m=i.birthtime.getTime()),(0,p.createHash)("md5").update(d.fsPath).update(m?String(m):"").digest("hex")}const v=S();if(typeof v=="string")return{id:v,uri:d}}e.getSingleFolderWorkspaceIdentifier=h}),define(Z[58],x([0,1,61,62,26,17,16,4,2,8,3,28,35,85,221]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(w){this.socket=w,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const k=R=>w(M.VSBuffer.wrap(R));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(w){const k=R=>{w({type:0,hadError:R,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(w){return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(w){if(!this.socket.destroyed)try{this.socket.write(w.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((w,k)=>{if(this.socket.bufferSize===0){w();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),w()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var b;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var y;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(y||(y={}));class I extends h.Disposable{constructor(w,k,R,A){super();this._onDidZlibFlush=this._register(new E.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=A,k?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",F=>{console.error(F),(0,P.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})}),this._zlibInflate.on("data",F=>{this._pendingInflateData.push(F)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{console.error(F),(0,P.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})}),this._zlibDeflate.on("data",F=>{this._pendingDeflateData.push(F)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._totalOutgoingDataBytes+=w.byteLength,this._zlibDeflate?(this._zlibDeflate.write(w.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(M.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(w,!1)}_write(w,k){let R=2;w.byteLength<126?R+=0:w.byteLength<2**16?R+=2:R+=8;const A=M.VSBuffer.alloc(R);if(k?A.writeUInt8(194,0):A.writeUInt8(130,0),w.byteLength<126)A.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){A.writeUInt8(126,1);let F=1;A.writeUInt8(w.byteLength>>>8&255,++F),A.writeUInt8(w.byteLength>>>0&255,++F)}else{A.writeUInt8(127,1);let F=1;A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(w.byteLength>>>24&255,++F),A.writeUInt8(w.byteLength>>>16&255,++F),A.writeUInt8(w.byteLength>>>8&255,++F),A.writeUInt8(w.byteLength>>>0&255,++F)}this._totalOutgoingWireBytes+=A.byteLength+w.byteLength,this.socket.write(M.VSBuffer.concat([A,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._totalIncomingWireBytes+=w.byteLength,this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),R=k.readUInt8(0),A=(R&128)>>>7,F=(R&64)>>>6,H=k.readUInt8(1),ie=(H&128)>>>7,re=H&127;this._state.state=2,this._state.readLen=2+(ie?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),R=k.readUInt8(1),A=(R&128)>>>7;let F=R&127,H=1;F===126?F=k.readUInt8(++H)*2**8+k.readUInt8(++H):F===127&&(F=k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H));let ie=0;A&&(ie=k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H)),this._state.state=3,this._state.readLen=F,this._state.mask=ie}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);c(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await E.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=I;function c(f,w){if(w===0)return;let k=f.byteLength>>>2;for(let re=0;re<k;re++){const G=f.readUInt32BE(re*4);f.writeUInt32BE(G^w,re*4)}let R=k*4,A=f.byteLength-R;const F=w>>>24&255,H=w>>>16&255,ie=w>>>8&255;A>=1&&f.writeUInt8(f.readUInt8(R)^F,R),A>=2&&f.writeUInt8(f.readUInt8(R+1)^H,R+1),A>=3&&f.writeUInt8(f.readUInt8(R+2)^ie,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function u(){const f=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,d.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):w=(0,d.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),l(w),w}e.createRandomIPCHandle=u;function n(f,w,k){const R=(0,p.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${w}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,d.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${k}-${w}.sock`):A=(0,d.join)(f,`${k}-${w}.sock`),l(A),A}e.createStaticIPCHandle=n;function l(f){const w=o[i.platform];typeof w=="number"&&f.length>=w&&console.warn(`WARNING: IPC handle "${f}" is longer than ${w} chars, try a shorter --user-data-dir`)}class s extends v.IPCServer{constructor(w){super(s.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const k=E.Event.fromNodeEventEmitter(w,"connection");return E.Event.map(k,R=>({protocol:new m.Protocol(new g(R)),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(f){return new Promise((w,k)=>{const R=(0,L.createServer)();R.on("error",k),R.listen(f,()=>{R.removeListener("error",k),w(new s(R))})})}e.serve=r;function a(f,w){return new Promise((k,R)=>{const A=(0,L.createConnection)(f,()=>{A.removeListener("error",R),k(m.Client.fromSocket(new g(A),w))});A.once("error",R)})}e.connect=a}),define(Z[222],x([0,1,58]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(h){this.driver=h}listen(h,d){throw new Error("No event found")}call(h,d,i){switch(d){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${d}`)}}e.DriverChannel=L;class D{constructor(h){this.channel=h}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(h){return this.channel.call("capturePage",h)}reloadWindow(h){return this.channel.call("reloadWindow",h)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(h,d){return this.channel.call("dispatchKeybinding",[h,d])}click(h,d,i,S){return this.channel.call("click",[h,d,i,S])}doubleClick(h,d){return this.channel.call("doubleClick",[h,d])}setValue(h,d,i){return this.channel.call("setValue",[h,d,i])}getTitle(h){return this.channel.call("getTitle",[h])}isActiveElement(h,d){return this.channel.call("isActiveElement",[h,d])}getElements(h,d,i){return this.channel.call("getElements",[h,d,i])}getElementXY(h,d,i,S){return this.channel.call("getElementXY",[h,d,i,S])}typeInEditor(h,d,i){return this.channel.call("typeInEditor",[h,d,i])}getTerminalBuffer(h,d){return this.channel.call("getTerminalBuffer",[h,d])}writeInTerminal(h,d,i){return this.channel.call("writeInTerminal",[h,d,i])}getLocaleInfo(h){return this.channel.call("getLocaleInfo",h)}getLocalizedStrings(h){return this.channel.call("getLocalizedStrings",h)}}e.DriverChannelClient=D;class M{constructor(h){this.registry=h}listen(h,d){throw new Error(`Event not found: ${d}`)}call(h,d,i){switch(d){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${d}`)}}e.WindowDriverRegistryChannel=M;async function P(E){const h=await(0,p.connect)(E,"driverClient"),d=h.getChannel("driver"),i=new D(d);return{client:h,driver:i}}e.connect=P}),define(Z[223],x([0,1,9,4,106,59,2,3,35,58,159,222,177,22,36]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function g(I){return I<21}let b=class{constructor(c,o,u,n){this.windowServer=c,this.options=o,this.windowsMainService=u,this.lifecycleMainService=n,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const o=this.windowsMainService.getWindowById(c);if(!o?.win)throw new Error("Invalid window");return(await o.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const o=this.windowsMainService.getWindowById(c);if(!o)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(o)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(c,o){await this.whenUnfrozen(c);const u=D.KeybindingParser.parseUserBinding(o);for(let n of u)await this._dispatchKeybinding(c,n)}async _dispatchKeybinding(c,o){if(o instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const u=this.windowsMainService.getWindowById(c);if(!u?.win)throw new Error("Invalid window");const n=u.win.webContents,l=new M.SimpleKeybinding(!1,!1,!1,!1,o.keyCode),r=new v.USLayoutResolvedKeybinding(l.toChord(),E.OS).getElectronAccelerator(),a=[];o.ctrlKey&&a.push("ctrl"),o.metaKey&&a.push("meta"),o.shiftKey&&a.push("shift"),o.altKey&&a.push("alt"),n.sendInputEvent({type:"keyDown",keyCode:r,modifiers:a}),g(o.keyCode)||n.sendInputEvent({type:"char",keyCode:r,modifiers:a}),n.sendInputEvent({type:"keyUp",keyCode:r,modifiers:a}),await(0,p.timeout)(100)}async click(c,o,u,n){await(await this.getWindowDriver(c)).click(o,u,n)}async doubleClick(c,o){await(await this.getWindowDriver(c)).doubleClick(o)}async setValue(c,o,u){await(await this.getWindowDriver(c)).setValue(o,u)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,o){return await(await this.getWindowDriver(c)).isActiveElement(o)}async getElements(c,o,u){return await(await this.getWindowDriver(c)).getElements(o,u)}async getElementXY(c,o,u,n){return await(await this.getWindowDriver(c)).getElementXY(o,u,n)}async typeInEditor(c,o,u){await(await this.getWindowDriver(c)).typeInEditor(o,u)}async getTerminalBuffer(c,o){return await(await this.getWindowDriver(c)).getTerminalBuffer(o)}async writeInTerminal(c,o,u){await(await this.getWindowDriver(c)).writeInTerminal(o,u)}async getLocaleInfo(c){return await(await this.getWindowDriver(c)).getLocaleInfo()}async getLocalizedStrings(c){return await(await this.getWindowDriver(c)).getLocalizedStrings()}async getWindowDriver(c){await this.whenUnfrozen(c);const o=`window:${c}`,u=new h.StaticRouter(l=>l===o),n=this.windowServer.getChannel("windowDriver",u);return new i.WindowDriverChannelClient(n)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await L.Event.toPromise(this.onDidReloadingChange.event)}};b=he([te(2,t.IWindowsMainService),te(3,m.ILifecycleMainService)],b),e.Driver=b;async function y(I,c,o,u){const n=o.driverVerbose,l=u.createInstance(b,I,{verbose:n}),s=new S.WindowDriverRegistryChannel(l);I.registerChannel("windowDriverRegistry",s);const r=await(0,d.serve)(c),a=new S.DriverChannel(l);return r.registerChannel("driver",a),(0,P.combinedDisposable)(r,I)}e.serve=y}),define(Z[24],x([0,1,46,8,58,47,163,5]),function(j,e,p,L,D,M,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(M.IEnvironmentService);class h extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([p.memoize],h.prototype,"cachedLanguagesPath",null),he([p.memoize],h.prototype,"backupHome",null),he([p.memoize],h.prototype,"backupWorkspacesPath",null),he([p.memoize],h.prototype,"mainIPCHandle",null),he([p.memoize],h.prototype,"mainLockfile",null),he([p.memoize],h.prototype,"sandbox",null),he([p.memoize],h.prototype,"driverVerbose",null),he([p.memoize],h.prototype,"disableUpdates",null),he([p.memoize],h.prototype,"disableKeytar",null),he([p.memoize],h.prototype,"codeCachePath",null),he([p.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Z[224],x([0,1,61,29,33,10,8,3,15,7,20,52,19,24,18,6,27]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class{constructor(c,o,u){this.configurationService=o,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,l)=>(0,D.isEqual)(n,l,!E.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(n){c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let o=[];try{Array.isArray(c.rootURIWorkspaces)&&(o=c.rootURIWorkspaces.map(n=>({workspace:{id:n.id,configPath:d.URI.parse(n.configURIPath)},remoteAuthority:n.remoteAuthority})))}catch(n){}this.workspaces=await this.validateWorkspaces(o);let u=[];try{Array.isArray(c.folderURIWorkspaces)&&(u=c.folderURIWorkspaces.map(n=>d.URI.parse(n)))}catch(n){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,o){this.workspaces.some(n=>c.workspace.id===n.workspace.id)||(this.workspaces.push(c),this.saveSync());const u=this.getBackupPath(c.workspace.id);return o&&this.moveBackupFolderSync(u,o),u}moveBackupFolderSync(c,o){if(L.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),L.existsSync(o))try{L.renameSync(o,c)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(c){const o=c.id,u=this.workspaces.findIndex(n=>n.workspace.id===o);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(o=>this.backupUriComparer.isEqual(c,o))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const o=this.folders.findIndex(u=>this.backupUriComparer.isEqual(c,u));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(c,o){const u=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:o}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(c){const o=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,c));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(c){return(0,P.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const o=new Set,u=[];for(let n of c){const l=n.workspace;if(!(0,b.isWorkspaceIdentifier)(l))return[];if(!o.has(l.id)){o.add(l.id);const s=this.getBackupPath(l.id);await this.doHasBackups(s)?l.configPath.scheme!==M.Schemas.file||await i.Promises.exists(l.configPath.fsPath)?u.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(c){if(!Array.isArray(c))return[];const o=[],u=new Set;for(let n of c){const l=this.backupUriComparer.getComparisonKey(n);if(!u.has(l)){u.add(l);const s=this.getBackupPath(this.getFolderHash(n));await this.doHasBackups(s)?n.scheme!==M.Schemas.file||await i.Promises.exists(n.fsPath)?o.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const o=[],u=new Set;for(let n of c){const l=n.backupFolder;if(typeof l!="string")return[];if(!u.has(l)){u.add(l);const s=this.getBackupPath(l);await this.doHasBackups(s)?o.push(n):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(c){try{await i.Promises.exists(c)&&await i.Promises.rm(c,i.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(c){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{await i.Promises.rename(c,u)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(c){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{L.renameSync(c,u)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const c=[];for(const o of this.workspaces)await this.hasBackups(o)&&c.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&c.push(o);return c}hasBackups(c){let o;return d.URI.isUri(c)?o=this.getBackupPath(this.getFolderHash(c)):(0,S.isWorkspaceBackupInfo)(c)?o=this.getBackupPath(c.workspace.id):o=c.backupFolder,this.doHasBackups(o)}async doHasBackups(c){try{const o=await i.Promises.readdir(c);for(const u of o)try{if((await i.Promises.readdir((0,P.join)(c,u))).length>0)return!0}catch(n){}}catch(o){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let o;return c.scheme===M.Schemas.file?o=E.isLinux?c.fsPath:c.fsPath.toLowerCase():o=c.toString().toLowerCase(),(0,p.createHash)("md5").update(o).digest("hex")}};y=he([te(0,m.IEnvironmentMainService),te(1,v.IConfigurationService),te(2,g.ILogService)],y),e.BackupMainService=y}),define(Z[225],x([0,1,62,58]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,M,P,E){const h=i=>E(i,void 0),d=p.createConnection({host:D,port:M},()=>{d.removeListener("error",h);const i=Buffer.alloc(16);for(let t=0;t<16;t++)i[t]=Math.round(Math.random()*256);const S=i.toString("base64");let v=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${M}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];d.write(v.join(`\r
`)+`\r
\r
`);const m=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",m),E(void 0,new L.NodeSocket(d)))};d.on("data",m)});d.once("error",h)}}}),define(Z[226],x([0,1,62,117,225,9,2,19,6,21,193,97,77]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function m(y,I,c,o,u){return new t(y,I,c,o,u).waitForReady()}class t extends P.Disposable{constructor(I,c,o,u,n){super();this.defaultTunnelHost=c,this.suggestedLocalPort=n,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=I,this._server=p.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let I=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(I,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(I=0,this._server.listen(I,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(I){I.pause();const c=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,i.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),u=o.getSocket().socket,n=o.readEntireBuffer();o.dispose(),n.byteLength>0&&I.write(n.buffer),I.on("end",()=>{this._socketsDispose.delete(I.localAddress),u.end()}),I.on("close",()=>u.end()),I.on("error",()=>{this._socketsDispose.delete(I.localAddress),u.destroy()}),u.on("end",()=>I.end()),u.on("close",()=>I.end()),u.on("error",()=>{I.destroy()}),I.pipe(u),u.pipe(I),this._socketsDispose.set(I.localAddress,()=>{I.end(),u.end()})}}let g=class extends S.AbstractTunnelService{constructor(I,c,o,u,n){super(c);this.socketFactory=I,this.signService=o,this.productService=u,this.configurationService=n}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(I,c,o,u,n,l,s){const r=this.getTunnelFromMap(c,o);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,o,u,n,l,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${o} on local port ${u}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:I,signService:this.signService,logService:this.logService,ipcLogger:null},f=m(a,this.defaultTunnelHost,c,o,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,o,f),f}}};g=he([te(1,h.ILogService),te(2,v.ISignService),te(3,d.IProductService),te(4,E.IConfigurationService)],g),e.BaseTunnelService=g;let b=class extends g{constructor(I,c,o,u){super(D.nodeSocketFactory,I,c,o,u)}};b=he([te(0,h.ILogService),te(1,v.ISignService),te(2,d.IProductService),te(3,E.IConfigurationService)],b),e.TunnelService=b}),define(Z[227],x([0,1,197,9,17,16,2,14,19,47,91,6,196,221]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends P.Disposable{constructor(b,y,I){super();this.environmentService=y,this.logService=I,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,y){this.logService.trace("RequestService#request",b.url);const{proxyUrl:I,strictSSL:c}=this;let o;try{o=await(0,i.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.logService.error("RequestService#request resolving shell environment failed",l)}const u={...process.env,...o},n=b.agent?b.agent:await(0,v.getProxyAgent)(b.url||"",u,{proxyUrl:I,strictSSL:c});return b.agent=n,b.strictSSL=c,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization}),this._request(b,y)}async getNodeRequest(b){return((0,p.parse)(b.url).protocol==="https:"?await new Promise((c,o)=>{j(["https"],c,o)}):await new Promise((c,o)=>{j(["http"],c,o)})).request}_request(b,y){return L.Promises.withAsyncBody(async(I,c)=>{let o;const u=(0,p.parse)(b.url),n=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,E.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(l.auth=b.user+":"+b.password),o=n(l,s=>{const r=(0,E.isNumber)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...b,url:s.headers.location,followRedirects:r-1},y).then(I,c);else{let a=s;s.headers["content-encoding"]==="gzip"&&(a=s.pipe((0,m.createGunzip)())),I({res:s,stream:(0,D.streamToBufferReadableStream)(a)})}}),o.on("error",c),b.timeout&&o.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),y.onCancellationRequested(()=>{o.abort(),c((0,M.canceled)())})})}async resolveProxy(b){}};t=he([te(0,h.IConfigurationService),te(1,d.INativeEnvironmentService),te(2,S.ILogService)],t),e.RequestService=t}),define(Z[228],x([0,1,13,227]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(P){return p.net.request}class M extends L.RequestService{request(E,h){return super.request({...E||{},getRawRequest:D},h)}}e.RequestMainService=M}),define(Z[229],x([0,1,13,9,4,2,10,14,86,24,22,6,49,57,65]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(y,I,c,o,u,n,l){super();this.machineId=y,this.userEnv=I,this.environmentMainService=c,this.lifecycleMainService=o,this.logService=u,this.themeMainService=n,this.protocolMainService=l,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(y,I)=>this.onWindowConnection(y,I)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(y,I)=>this.onWorkerConnection(y,I)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(y,I){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(y.sender.isDestroyed())return c.close();y.sender.postMessage("vscode:createSharedProcessMessageChannelResult",I,[c])}onWorkerConnection(y,I){this.logService.trace("SharedProcess: onWorkerConnection",I);const c=new M.DisposableStore,o=n=>{this.logService.trace(`SharedProcess: disposing worker (reason: '${n}')`,I),c.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",I)},u=p.BrowserWindow.fromId(I.reply.windowId);if(!u||u.isDestroyed()||u.webContents.isDestroyed()||!I.reply.channel){o("unavailable");return}c.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,n=>n.window.win===u)(()=>o("load"))),c.add(D.Event.fromNodeEventEmitter(u,"closed")(()=>o("closed"))),u.webContents.postMessage(I.reply.channel,I.reply.nonce,y.ports)}onWillShutdown(){const y=this.window;!y||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(y.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{y.close()}catch(I){}this.window=void 0},0))}send(y,...I){const c=this.window;if(!c||c.isDestroyed()||c.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${y}' for shared process window that is destroyed`);return}c.webContents.send(y,...I)}whenReady(){return this._whenReady||(this._whenReady=new Promise(y=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),y()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(y=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),y()}))})()),this._whenIpcReady}createWindow(){const y=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${y.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),y.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=y=>{this.logService.trace("SharedProcess#close prevented"),y.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(y,I)=>this._onDidError.fire({type:2,details:I})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(y,I,c)=>this._onDidError.fire({type:3,details:{reason:c,exitCode:I}})))}async connect(){await this.whenIpcReady;const y=(0,E.assertIsDefined)(this.window);return(0,h.connect)(y)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=he([te(2,d.IEnvironmentMainService),te(3,i.ILifecycleMainService),te(4,S.ILogService),te(5,t.IThemeMainService),te(6,m.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[230],x([0,1,9,17,8,14,7,24,18,6]),function(j,e,p,L,D,M,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(m,t,g){this.storagePath=m,this.logService=t,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}}getItem(m,t){const g=this.storage[m];return(0,M.isUndefinedOrNull)(g)?t:g}setItem(m,t){this.setItems([{key:m,data:t}])}setItems(m){let t=!1;for(const{key:g,data:b}of m)this.storage[g]!==b&&((0,M.isUndefinedOrNull)(b)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,t=!0):(this.storage[g]=b,t=!0));t&&this.save()}removeItem(m){(0,M.isUndefined)(this.storage[m])||(this.storage[m]=void 0,this.save())}async save(m){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),m)}async doSave(){if(!this.initializing)return;await this.initializing;const m=JSON.stringify(this.storage,null,4);if(m!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(m)),this.lastSavedStorageContents=m}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let S=class St{constructor(m,t,g){this.fileStorage=new i(P.URI.file((0,D.join)(m.userDataPath,St.STATE_FILE)),t,g)}async init(){return this.fileStorage.init()}getItem(m,t){return this.fileStorage.getItem(m,t)}setItem(m,t){this.fileStorage.setItem(m,t)}setItems(m){this.fileStorage.setItems(m)}removeItem(m){this.fileStorage.removeItem(m)}close(){return this.fileStorage.close()}};S.STATE_FILE="storage.json",S=he([te(0,E.IEnvironmentMainService),te(1,d.ILogService),te(2,h.IFileService)],S),e.StateMainService=S}),define(Z[78],x([0,1,9,23,4,19,24,22,6,21,51,41]),function(j,e,p,L,D,M,P,E,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function v(t,g,b){return`${b.updateUrl}/api/update/${t}/${g}/${b.commit}`}e.createUpdateURL=v;let m=class{constructor(g,b,y,I,c,o){this.lifecycleMainService=g,this.configurationService=b,this.environmentMainService=y,this.requestService=I,this.logService=c,this.productService=o,this._state=S.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),b=this.getProductQuality(g);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(S.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,p.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};m=he([te(0,E.ILifecycleMainService),te(1,M.IConfigurationService),te(2,P.IEnvironmentMainService),te(3,i.IRequestService),te(4,h.ILogService),te(5,d.IProductService)],m),e.AbstractUpdateService=m}),define(Z[231],x([0,1,13,46,4,2,19,24,22,6,21,51,30,41,78]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends t.AbstractUpdateService{constructor(y,I,c,o,u,n,l){super(y,I,o,u,n,l);this.telemetryService=c,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(y,I)=>I)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(y,I,c)=>({url:I,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(y,I,c,o)=>({releaseNotes:I,version:c,productVersion:c,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(m.State.Idle(1,c))}buildUpdateFeedUrl(y){let I;this.productService.darwinUniversalAssetId?I=this.productService.darwinUniversalAssetId:I=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(I,y,this.productService);try{p.autoUpdater.setFeedURL({url:c})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return c}doCheckForUpdates(y){this.setState(m.State.CheckingForUpdates(y)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(m.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(m.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(m.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],g.prototype,"onRawError",null),he([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],g.prototype,"onRawUpdateAvailable",null),he([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([te(0,h.ILifecycleMainService),te(1,P.IConfigurationService),te(2,v.ITelemetryService),te(3,E.IEnvironmentMainService),te(4,S.IRequestService),te(5,d.ILogService),te(6,i.IProductService)],g),e.DarwinUpdateService=g}),define(Z[232],x([0,1,44,29,9,4,8,24,22,6,30,41]),function(j,e,p,L,D,M,P,E,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let v=class{constructor(g,b,y){if(this.lifecycleMainService=g,this.logService=y,this._state=S.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,D.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};v=he([te(0,h.ILifecycleMainService),te(1,E.IEnvironmentMainService),te(2,d.ILogService)],v);let m=class extends v{constructor(g,b,y,I,c,o){super(y,I,c);this.snap=g,this.snapRevision=b,this.telemetryService=o;const u=(0,L.watch)(P.dirname(this.snap)),n=M.Event.fromNodeEventEmitter(u,"change",(a,f)=>f),l=M.Event.filter(n,a=>a==="current"),r=M.Event.debounce(l,(a,f)=>f,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{r.dispose(),u.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+P.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((y,I)=>(0,L.realpath)(`${P.dirname(this.snap)}/current`,(c,o)=>c?I(c):y(o))),b=P.basename(g);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};m=he([te(2,h.ILifecycleMainService),te(3,E.IEnvironmentMainService),te(4,d.ILogService),te(5,i.ITelemetryService)],m),e.SnapUpdateService=m}),define(Z[45],x([0,1,13,29,4,39,34,2,10,8,3,15,14,20,157,52,53,24,5,6,21,101,27,102]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,I.createDecorator)("workspacesManagementMainService");let s=class extends E.Disposable{constructor(a,f,w,k,R){super();this.environmentMainService=a,this.logService=f,this.backupMainService=w,this.dialogMainService=k,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,f=>(0,L.readFileSync)(f,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,f=>m.Promises.readFile(f,"utf8"))}doResolveLocalWorkspace(a,f){if(!!this.isWorkspacePath(a)&&a.scheme===h.Schemas.file)try{const w=f(a.fsPath);return w instanceof Promise?w.then(k=>this.doResolveWorkspace(a,k),k=>{}):this.doResolveWorkspace(a,w)}catch{return}}isWorkspacePath(a){return(0,n.isUntitledWorkspace)(a,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,f){try{const w=this.doParseStoredWorkspace(a,f),k=(0,l.getWorkspaceIdentifier)(a);return{id:k.id,configPath:k.configPath,folders:(0,n.toWorkspaceFolders)(w.folders,k.configPath,S.extUriBiasedIgnorePathCase),remoteAuthority:w.remoteAuthority,transient:w.transient}}catch(w){this.logService.warn(w.toString())}}doParseStoredWorkspace(a,f){const w=(0,M.parse)(f);if(w&&Array.isArray(w.folders))w.folders=w.folders.filter(k=>(0,n.isStoredWorkspaceFolder)(k));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return w}async createUntitledWorkspace(a,f){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(a,f),R=w.configPath.fsPath;return await m.Promises.mkdir((0,d.dirname)(R),{recursive:!0}),await m.Promises.writeFile(R,JSON.stringify(k,null,"	")),w}createUntitledWorkspaceSync(a,f){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(a,f),R=w.configPath.fsPath;return(0,L.mkdirSync)((0,d.dirname)(R),{recursive:!0}),(0,m.writeFileSync)(R,JSON.stringify(k,null,"	")),w}newUntitledWorkspace(a=[],f){const w=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,S.joinPath)(this.untitledWorkspacesHome,w),R=(0,S.joinPath)(k,n.UNTITLED_WORKSPACE_NAME),A=[];for(const F of a)A.push((0,n.getStoredWorkspaceFolder)(F.uri,!0,F.name,k,!i.isWindows,S.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:A,remoteAuthority:f}}}async getWorkspaceIdentifier(a){return(0,l.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,n.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const f=(0,S.originalFSPath)(a.configPath);try{(0,m.rimrafSync)((0,d.dirname)(f));const w=(0,d.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,L.existsSync)(w)&&(0,m.writeFileSync)((0,d.join)(w,"obsolete"),"")}catch(w){this.logService.warn(`Unable to delete untitled workspace ${f} (${w}).`)}}getUntitledWorkspacesSync(){const a=[];try{const f=(0,m.readdirSync)(this.untitledWorkspacesHome.fsPath).map(w=>(0,S.joinPath)(this.untitledWorkspacesHome,w,n.UNTITLED_WORKSPACE_NAME));for(const w of f){const k=(0,l.getWorkspaceIdentifier)(w),R=this.resolveLocalWorkspaceSync(w);R?a.push({workspace:k,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(f){f.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${f}).`)}return a}async enterWorkspace(a,f,w){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,f,w))return;const R=this.doEnterWorkspace(a,(0,l.getWorkspaceIdentifier)(w));if(!!R)return this._onDidEnterWorkspace.fire({window:a,workspace:R.workspace}),R}async isValidTargetWorkspacePath(a,f,w){if(!w)return!0;if((0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,w))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(f,w)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,S.basename)(w)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,v.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,f){if(!a.config)return;a.focus();let w;return a.config.extensionDevelopmentPath||(w=this.backupMainService.registerWorkspaceBackupSync({workspace:f,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=f,a.config.backupPath=w,{workspace:f,backupPath:w}}};s=he([te(0,y.IEnvironmentMainService),te(1,c.ILogService),te(2,g.IBackupMainService),te(3,b.IDialogMainService),te(4,o.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Z[103],x([0,1,13,31,23,3,14,7,20,19,56,5,6,99,36,27,45]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let y=class{constructor(c,o,u,n,l){this.logService=c,this.windowsMainService=o,this.urlService=u,this.workspacesManagementMainService=n,this.configurationService=l}async start(c,o){this.logService.trace("Received data from other instance: ",c,o),M.isMacintosh&&p.app.focus({steal:!0});const u=this.parseOpenUrl(c);if(u.length){let n=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(n=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),n.then(()=>{for(const{uri:l,url:s}of u)this.urlService.open(l,{originalUrl:s})})}else return this.startOpenWindow(c,o)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,L.coalesce)(c._urls.map(o=>{try{return{uri:E.URI.parse(o),url:o}}catch(u){return null}})):[]}async startOpenWindow(c,o){const u=(0,i.isLaunchedFromCli)(o)?0:4;let n=[];const l=c.wait&&c.waitMarkerFilePath?E.URI.file(c.waitMarkerFilePath):void 0,s=c.remote||void 0,r={context:u,cli:c,userEnv:o,waitMarkerFileURI:l,remoteAuthority:s};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,r);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let a=!1;if(c["new-window"]||c["unity-launch"])a=!0;else if(c["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!M.isMacintosh}if(a)n=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const f=this.windowsMainService.getLastActiveWindow();f?(this.windowsMainService.openExistingWindow(f,r),n=[f]):n=this.windowsMainService.open({...r,forceEmpty:!0})}}else n=this.windowsMainService.open({...r,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(l&&n.length===1&&n[0])return Promise.race([n[0].whenClosedOrLoaded,(0,h.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return p.BrowserWindow.getAllWindows().forEach(o=>{const u=this.windowsMainService.getWindowById(o.id);u?c.push(this.codeWindowToInfo(u)):c.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(n=>new Promise(l=>{const s=n.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${n.id}`,a={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(n):void 0};n.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:r,args:a}),p.ipcMain.once(r,(f,w)=>{w||l({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),l(w)}),setTimeout(()=>{l({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else l(void 0)})))).filter(n=>!!n)}getFolderURIs(c){const o=[],u=c.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))o.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const n=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);n&&n.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(c){const o=this.getFolderURIs(c),u=(0,P.assertIsDefined)(c.win);return this.browserWindowToInfo(u,o,c.remoteAuthority)}browserWindowToInfo(c,o=[],u){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:o,remoteAuthority:u}}};y=he([te(0,v.ILogService),te(1,t.IWindowsMainService),te(2,m.IURLService),te(3,b.IWorkspacesManagementMainService),te(4,d.IConfigurationService)],y),e.LaunchMainService=y}),define(Z[54],x([0,1,44,13,26,116,46,4,34,2,10,8,3,7,83,70,20,149,53,24,5,22,6,21,30,65,36,27,45]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n,l,s,r,a,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let k=class ut extends d.Disposable{constructor(A,F,H,ie,re,G,ee,T,V,U){super();this.sharedProcess=A,this.windowsMainService=F,this.dialogMainService=H,this.lifecycleMainService=ie,this.environmentMainService=re,this.telemetryService=G,this.logService=ee,this.productService=T,this.themeMainService=V,this.workspacesManagementMainService=U,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(B,N,_)=>_),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),E.Event.fromNodeEventEmitter(L.screen,"display-added"),E.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const F=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(A,F,H){return Array.isArray(F)?this.doOpenWindow(A,F,H):this.doOpenEmptyWindow(A,F)}async doOpenWindow(A,F,H=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:H.forceNewWindow,forceReuseWindow:H.forceReuseWindow,preferNewWindow:H.preferNewWindow,diffMode:H.diffMode,addMode:H.addMode,gotoLineMode:H.gotoLineMode,noRecentEntry:H.noRecentEntry,waitMarkerFileURI:H.waitMarkerFileURI,remoteAuthority:H.remoteAuthority||void 0})}async doOpenEmptyWindow(A,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},F)}async toggleFullScreen(A){const F=this.windowById(A);F&&F.toggleFullScreen()}async handleTitleDoubleClick(A){const F=this.windowById(A);F&&F.handleTitleDoubleClick()}async isMaximized(A){const F=this.windowById(A);return F?.win?F.win.isMaximized():!1}async maximizeWindow(A){const F=this.windowById(A);F?.win&&F.win.maximize()}async unmaximizeWindow(A){const F=this.windowById(A);F?.win&&F.win.unmaximize()}async minimizeWindow(A){const F=this.windowById(A);F?.win&&F.win.minimize()}async focusWindow(A,F){F&&typeof F.windowId=="number"&&(A=F.windowId);const H=this.windowById(A);H&&H.focus({force:F?.force??!1})}async setMinimumSize(A,F,H){const ie=this.windowById(A);if(ie?.win){const[re,G]=ie.win.getSize(),[ee,T]=ie.win.getMinimumSize(),[V,U]=[F??ee,H??T],[B,N]=[Math.max(re,V),Math.max(G,U)];(ee!==V||T!==U)&&ie.win.setMinimumSize(V,U),(re!==B||G!==N)&&ie.win.setSize(B,N)}}async saveWindowSplash(A,F){this.themeMainService.saveWindowSplash(A,F)}async installShellCommand(A){const{source:F,target:H}=await this.getShellCommandLink();try{const{symbolicLink:ie}=await b.SymlinkSupport.stat(F);if(ie&&!ie.dangling){const re=await(0,t.realpath)(F);if(H===re)return}await b.Promises.unlink(F)}catch(ie){if(ie.code!=="ENOENT")throw ie}try{await b.Promises.symlink(H,F)}catch(ie){if(ie.code!=="EACCES"&&ie.code!=="ENOENT")throw ie;const{response:re}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const G=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${H}' '${F}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(G)}catch(G){throw new Error((0,y.localize)(3,null,F))}}}async uninstallShellCommand(A){const{source:F}=await this.getShellCommandLink();try{await b.Promises.unlink(F)}catch(H){switch(H.code){case"EACCES":const{response:ie}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ie===0)try{const re=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(re)}catch(re){throw new Error((0,y.localize)(7,null,F))}break;case"ENOENT":break;default:throw H}}}async getShellCommandLink(){const A=(0,S.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(A))throw new Error((0,y.localize)(8,null,A));return{source:F,target:A}}async showMessageBox(A,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(A))}async showSaveDialog(A,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(A))}async showOpenDialog(A,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(A))}toBrowserWindow(A){const F=this.windowById(A);if(F?.win)return F.win}async pickFileFolderAndOpen(A,F){const H=await this.dialogMainService.pickFileFolder(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFileFolder",F.telemetryExtraData),this.doOpenPicked(await Promise.all(H.map(async ie=>await b.SymlinkSupport.existsDirectory(ie)?{folderUri:m.URI.file(ie)}:{fileUri:m.URI.file(ie)})),F,A))}async pickFolderAndOpen(A,F){const H=await this.dialogMainService.pickFolder(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFolder",F.telemetryExtraData),this.doOpenPicked(H.map(ie=>({folderUri:m.URI.file(ie)})),F,A))}async pickFileAndOpen(A,F){const H=await this.dialogMainService.pickFile(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openFile",F.telemetryExtraData),this.doOpenPicked(H.map(ie=>({fileUri:m.URI.file(ie)})),F,A))}async pickWorkspaceAndOpen(A,F){const H=await this.dialogMainService.pickWorkspace(F);H&&(this.sendPickerTelemetry(H,F.telemetryEventName||"openWorkspace",F.telemetryExtraData),this.doOpenPicked(H.map(ie=>({workspaceUri:m.URI.file(ie)})),F,A))}doOpenPicked(A,F,H){this.windowsMainService.open({context:3,contextWindowId:H,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:F.forceNewWindow})}sendPickerTelemetry(A,F,H){const ie=A?A.length:0;this.telemetryService.publicLog(F,{...H,outcome:ie?"success":"canceled",numberOfPaths:ie})}async showItemInFolder(A,F){L.shell.showItemInFolder(F)}async setRepresentedFilename(A,F){const H=this.windowById(A);H&&H.setRepresentedFilename(F)}async setDocumentEdited(A,F){const H=this.windowById(A);H&&H.setDocumentEdited(F)}async openExternal(A,F){return v.isLinuxSnap?this.safeSnapOpenExternal(F):L.shell.openExternal(F),!0}safeSnapOpenExternal(A){const F=process.env.GDK_PIXBUF_MODULE_FILE,H=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=H}moveItemToTrash(A,F){return L.shell.trashItem(F)}async isAdmin(){let A;return v.isWindows?A=(await new Promise((F,H)=>{j(["native-is-elevated"],F,H)}))():A=process.getuid()===0,A}async writeElevated(A,F,H,ie){const re=await new Promise((G,ee)=>{j(["sudo-prompt"],G,ee)});return new Promise((G,ee)=>{const T=[`"${this.cliPath}"`];ie?.unlock&&T.push("--file-chmod"),T.push("--file-write",`"${F.fsPath}"`,`"${H.fsPath}"`);const V={name:this.productService.nameLong.replace("-",""),icns:v.isMacintosh&&this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};re.exec(T.join(" "),V,(U,B,N)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),U?ee(U):G(void 0)})})}get cliPath(){return v.isWindows?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):v.isLinux?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,S.join)(this.environmentMainService.appRoot,"bin","code"):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}get osColorScheme(){return{highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,F,H){process.kill(F,H)}async readClipboardText(A,F){return L.clipboard.readText(F)}async writeClipboardText(A,F,H){return L.clipboard.writeText(F,H)}async readClipboardFindText(A){return L.clipboard.readFindText()}async writeClipboardFindText(A,F){return L.clipboard.writeFindText(F)}async writeClipboardBuffer(A,F,H,ie){return L.clipboard.writeBuffer(F,Buffer.from(H),ie)}async readClipboardBuffer(A,F){return L.clipboard.readBuffer(F)}async hasClipboard(A,F,H){return L.clipboard.has(F,H)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,F){const H=this.windowById(A);H&&H.updateTouchBar(F)}async notifyReady(A){const F=this.windowById(A);F&&F.setReady()}async relaunch(A,F){return this.lifecycleMainService.relaunch(F)}async reload(A,F){const H=this.windowById(A);if(H){if((0,f.isWorkspaceIdentifier)(H.openedWorkspace)){const ie=H.openedWorkspace.configPath;if(ie.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ie))?.transient)return this.openWindow(H.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(H,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,F){const H=this.windowById(F);if(H?.win)return H.win.close()}async quit(A){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(A,F){await this.lifecycleMainService.kill(F)}async resolveProxy(A,F){const ie=this.windowById(A)?.win?.webContents?.session;if(ie)return ie.resolveProxy(F)}async openDevTools(A,F){const H=this.windowById(A);H?.win&&H.win.webContents.openDevTools(F)}async toggleDevTools(A){const F=this.windowById(A);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(A,F){const H=this.windowById(A);H?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&H.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,F,H,ie){if(!v.isWindows)return;const re=await new Promise((G,ee)=>{j(["vscode-windows-registry"],G,ee)});try{return re.GetStringRegKey(F,H,ie)}catch{return}}async getPassword(A,F,H){const ie=await this.withKeytar(),re=await ie.getPassword(F,H);if(re)try{let{content:G,hasNextChunk:ee}=JSON.parse(re);if(!G||!ee)return re;let T=1;for(;ee;){const V=await ie.getPassword(F,`${H}-${T}`),U=JSON.parse(V);G+=U.content,ee=U.hasNextChunk,T++}return G}catch{return re}return re}async setPassword(A,F,H,ie){const re=await this.withKeytar(),G=3,ee=async(T,V,U)=>{let B=0,N;for(;B<G;)try{await re.setPassword(T,V,U);return}catch(_){N=_,this.logService.warn("Error attempting to set a password: ",_),B++,await new Promise(X=>setTimeout(X,200))}throw N};if(v.isWindows&&ie.length>ut.MAX_PASSWORD_LENGTH){let T=0,V=0,U=!0;for(;U;){const B=ie.substring(T,T+ut.PASSWORD_CHUNK_SIZE);T+=ut.PASSWORD_CHUNK_SIZE,U=ie.length-T>0;const N={content:B,hasNextChunk:U};await ee(F,V?`${H}-${V}`:H,JSON.stringify(N)),V++}}else await ee(F,H,ie);this._onDidChangePassword.fire({service:F,account:H})}async deletePassword(A,F,H){const re=await(await this.withKeytar()).deletePassword(F,H);return re&&this._onDidChangePassword.fire({service:F,account:H}),re}async findPassword(A,F){return(await this.withKeytar()).findPassword(F)}async findCredentials(A,F){return(await this.withKeytar()).findCredentials(F)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,F)=>{j(["keytar"],A,F)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,he([P.memoize],k.prototype,"cliPath",null),k=he([te(1,a.IWindowsMainService),te(2,I.IDialogMainService),te(3,u.ILifecycleMainService),te(4,c.IEnvironmentMainService),te(5,s.ITelemetryService),te(6,n.ILogService),te(7,l.IProductService),te(8,r.IThemeMainService),te(9,w.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Z[233],x([0,1,13,23,4,82,2,28,89,6,54,21,36]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var m;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(m||(m={}));let t=class extends P.Disposable{constructor(b,y,I,c,o){super();this.logService=b,this.windowsMainService=y,this.nativeHostMainService=I,this.encryptionMainService=c,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=m.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=D.Event.fromNodeEventEmitter(p.app,"login",(y,I,c,o,u)=>({event:y,webContents:I,req:c,authInfo:o,callback:u}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:y,req:I,callback:c}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===m.LoginDialogShown&&I.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(o?.username,o?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(b);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const y=String((0,M.hash)({scheme:b.scheme,host:b.host,port:b.port}));let I,c;try{const l=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(l){const s=JSON.parse(await this.encryptionMainService.decrypt(l));I=s.username,c=s.password}}catch(l){this.logService.error(l)}if(this.state!==m.StoredCredentialsUsed&&typeof I=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=m.StoredCredentialsUsed,{username:I,password:c};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:b,username:this.sessionCredentials?.username??I,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=m.LoginDialogShown;const n=await new Promise(l=>{const s=async(r,a,f)=>{if(a===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",s),f){const w={username:f.username,password:f.password};try{if(f.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(w));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(k){this.logService.error(k)}l({username:w.username,password:w.password})}else l(void 0)};o.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=n,n}};t=he([te(0,d.ILogService),te(1,v.IWindowsMainService),te(2,i.INativeHostMainService),te(3,h.IEncryptionMainService),te(4,S.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[234],x([0,1,13,26,34,2,10,3,84,147,74,53,24,5,103,6,54,49,21,57,66]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,m.createDecorator)("issueMainService");let u=class bt{constructor(l,s,r,a,f,w,k,R,A){this.userEnv=l,this.environmentMainService=s,this.launchMainService=r,this.logService=a,this.diagnosticsService=f,this.dialogMainService=w,this.nativeHostMainService=k,this.protocolMainService=R,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(l,"vscode:issueSystemInfoResponse",a)}),p.ipcMain.on("vscode:listProcesses",async l=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,d.localize)(0,null),rootProcess:await(0,h.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(f=>{(0,i.isRemoteDiagnosticError)(f)?s.push({name:f.hostName,rootProcess:f}):f.processes&&s.push({name:f.hostName,rootProcess:f.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(l,"vscode:listProcessesResponse",s)}),p.ipcMain.on("vscode:issueReporterClipboard",async l=>{const s={title:this.productService.nameLong,message:(0,d.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,d.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,d.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",r.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const s=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",s)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,d.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,d.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,d.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(l,s)=>{const{id:r,from:a,args:f}=s;let w;switch(a){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}w&&w.webContents.send("vscode:runAction",{id:r,from:a,args:f})}),p.ipcMain.on("vscode:openExternal",(l,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),p.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async l=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",s.windows)})}safeSend(l,s,...r){l.sender.isDestroyed()||l.sender.send(s,...r)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:l.styles.backgroundColor,title:(0,d.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:y.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:l.styles.backgroundColor,title:(0,d.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:y.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(l,s,r){const a=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:r.title,backgroundColor:r.backgroundColor||bt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return a.setMenuBarVisibility(!1),a}async getSystemStatus(){const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,s)}getWindowPosition(l,s,r){let a;const f=p.screen.getAllDisplays();if(f.length===1)a=f[0];else{if(E.isMacintosh){const R=p.screen.getCursorScreenPoint();a=p.screen.getDisplayNearestPoint(R)}!a&&l&&(a=p.screen.getDisplayMatching(l.getBounds())),a||(a=p.screen.getPrimaryDisplay()||f[0])}const w={width:s,height:r},k=a.bounds;return w.x=k.x+k.width/2-w.width/2,w.y=k.y+k.height/2-w.height/2,k.width>0&&k.height>0&&(w.x<k.x&&(w.x=k.x),w.y<k.y&&(w.y=k.y),w.x>k.x+k.width&&(w.x=k.x),w.y>k.y+k.height&&(w.y=k.y),w.width>k.width&&(w.width=k.width),w.height>k.height&&(w.height=k.height)),w}async getPerformanceInfo(){try{const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,s)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([te(1,v.IEnvironmentMainService),te(2,t.ILaunchMainService),te(3,g.ILogService),te(4,i.IDiagnosticsService),te(5,S.IDialogMainService),te(6,b.INativeHostMainService),te(7,c.IProtocolMainService),te(8,I.IProductService)],u),e.IssueMainService=u}),define(Z[235],x([0,1,23,19,24,22,6,54,21,51,30,41,78]),function(j,e,p,L,D,M,P,E,h,d,i,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let m=class extends v.AbstractUpdateService{constructor(g,b,y,I,c,o,u,n){super(g,b,I,c,o,n);this.telemetryService=y,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,v.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(S.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},p.CancellationToken.None).then(d.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const y=g?b.message||b:void 0;this.setState(S.State.Idle(1,y))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(S.State.Idle(1))}};m=he([te(0,M.ILifecycleMainService),te(1,L.IConfigurationService),te(2,i.ITelemetryService),te(3,D.IEnvironmentMainService),te(4,d.IRequestService),te(5,P.ILogService),te(6,E.INativeHostMainService),te(7,h.IProductService)],m),e.LinuxUpdateService=m}),define(Z[236],x([0,1,44,29,26,9,23,46,8,7,113,20,19,24,18,22,6,54,21,51,30,41,78]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(f,w=1e3){for(;!f();)await(0,M.timeout)(w)}let s;function r(){return typeof s=="undefined"&&(s=L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),s}let a=class extends n.AbstractUpdateService{constructor(w,k,R,A,F,H,ie,re,G){super(w,k,A,F,H,G);this.telemetryService=R,this.fileService=ie,this.nativeHostMainService=re}get cachePath(){const w=h.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return S.Promises.mkdir(w,{recursive:!0}).then(()=>w)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(w){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),r()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,n.createUpdateURL)(k,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(u.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},P.CancellationToken.None).then(c.asJson).then(k=>{const R=r();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(u.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(A=>S.Promises.exists(A).then(F=>{if(F)return Promise.resolve(A);const H=k.url,ie=k.hash,re=`${A}.tmp`;return this.requestService.request({url:H},P.CancellationToken.None).then(G=>this.fileService.writeFile(d.URI.file(re),G.stream)).then(ie?()=>(0,i.checksum)(re,k.hash):()=>{}).then(()=>S.Promises.rename(re,A)).then(()=>A)})).then(A=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},F&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(k)):this.setState(u.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const R=w?k.message||k:void 0;this.setState(u.State.Idle(r(),R))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(u.State.Idle(r()))}async getUpdatePackagePath(w){const k=await this.cachePath;return h.join(k,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const k=w?H=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(H):()=>!0,R=await this.cachePath,F=(await S.Promises.readdir(R)).filter(k).map(async H=>{try{await S.Promises.unlink(h.join(R,H))}catch(ie){}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(u.State.Updating(w));const k=await this.cachePath;this.availableUpdate.updateFilePath=h.join(k,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await S.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(r()))});const A=`${this.productService.win32MutexName}-ready`,F=await new Promise((H,ie)=>{j(["windows-mutex"],H,ie)});l(()=>F.isActive(A)).then(()=>this.setState(u.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([E.memoize],a.prototype,"cachePath",null),a=he([te(0,g.ILifecycleMainService),te(1,v.IConfigurationService),te(2,o.ITelemetryService),te(3,m.IEnvironmentMainService),te(4,c.IRequestService),te(5,b.ILogService),te(6,t.IFileService),te(7,y.INativeHostMainService),te(8,I.IProductService)],a),e.Win32UpdateService=a}),define(Z[237],x([0,1,13,9,23,4,34,2,10,8,76,3,7,153,52,19,53,24,56,204,18,22,6,21,57,100,30,207,65,66,36,27,45]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n,l,s,r,a,f,w,k,R,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(H||(H={}));let ie=class extends E.Disposable{constructor(G,ee,T,V,U,B,N,_,X,W,z,K,O,q,C){super();this.logService=ee,this.environmentMainService=T,this.fileService=V,this.configurationService=B,this.themeMainService=N,this.workspacesManagementMainService=_,this.backupMainService=X,this.telemetryService=W,this.dialogMainService=z,this.lifecycleMainService=K,this.productService=O,this.protocolMainService=q,this.windowsMainService=C,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[$,J]=this.restoreWindowState(G.state);this.windowState=$,this.logService.trace("window#ctor: using window state",$);const Q=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),le={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,k.zoomLevelToZoomFactor)(ne?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};S.isLinux?le.icon=(0,d.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(le.icon=(0,d.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(le.fullscreenable=!1),S.isMacintosh&&(le.acceptFirstMouse=!0,ne?.clickThroughInactive===!1&&(le.acceptFirstMouse=!1));const oe=S.isMacintosh&&ne?.nativeTabs===!0;oe&&(le.tabbingIdentifier=this.productService.nameShort);const se=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(se&&(le.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,S.isMacintosh||(le.frame=!1)),(0,i.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(le),(0,i.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),S.isMacintosh&&se&&this._win.setSheetOffset(22),S.isMacintosh&&J&&(!oe||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ce=>typeof ce=="number")){const ce=this.windowState;this._win.setBounds({width:ce.width,height:ce.height,x:ce.x,y:ce.y})}Q&&((0,i.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,i.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,c.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:$=>U.globalStorage.get($),store:($,J)=>U.globalStorage.set($,J)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){S.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){S.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){S.isMacintosh&&G?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function ee(){T.dispose(),V.dispose(),G()}const T=this.onDidClose(()=>ee()),V=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(U,B,N)=>this.onWindowError(3,{reason:N,exitCode:B})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),ee=U=>{for(let B=U;B;B=B.parent)if(B.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},T=U=>U.resourceType==="xhr"||ee(U.frame);this._win.webContents.session.webRequest.onBeforeRequest((U,B)=>{const N=v.URI.parse(U.url);return N.path.endsWith(".svg")&&!G.has(N.scheme)?B({cancel:!T(U)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((U,B)=>{const N=U.responseHeaders,_=N["content-type"]||N["Content-Type"];if(_&&Array.isArray(_)){const X=v.URI.parse(U.url);if(X.path.endsWith(".svg")&&G.has(X.scheme))return N["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:N});if(!X.path.includes(h.Schemas.vscodeRemoteResource)&&_.some(W=>W.toLowerCase().includes("image/svg")))return B({cancel:!T(U)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(U,B)=>{const N=await this.marketplaceHeadersPromise;B({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,N)})})}async onWindowError(G,ee){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:ee?.reason,code:ee?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const T=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,m.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(2,null))],message:(0,m.localize)(3,null),detail:(0,m.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(T.response!==1){const V=T.response===0;this.destroyWindow(V)}}else if(G===2){let T;ee?T=(0,m.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):T=(0,m.localize)(5,null);const U=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,m.localize)(7,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(8,null))],message:T,detail:(0,m.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(U)}break}}destroyWindow(G){if(this._onDidDestroy.fire(),this._win?.destroy(),G&&this.config){let ee,T;(0,A.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?ee={folderUri:this.openedWorkspace.uri}:(0,A.isWorkspaceIdentifier)(this.openedWorkspace)?ee={workspaceUri:this.openedWorkspace.configPath}:T=!0;const[V]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ee?[ee]:void 0,forceEmpty:T});V.focus()}}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const T=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||T!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=T;const V=ee||"",U=T?`${T},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${U}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:U,pacScript:""})}}addTabbedWindow(G){S.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,ee),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(h.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const T=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:ee.isReload?3:T?2:1})}updateConfiguration(G,ee){const T=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(T){const V=(0,I.isLaunchedFromCli)(T)&&!(0,I.isLaunchedFromCli)(G.userEnv),U=this.isExtensionDevelopmentHost;(V||U)&&(G.userEnv={...T,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(G["disable-extensions"]=ee.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,i.mark)("code/willOpenNewWindow"),G.perfMarks=(0,i.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&G&&(ee.verbose=G.verbose,ee.debugId=G.debugId,ee.extensionEnvironment=G.extensionEnvironment,ee["inspect-extensions"]=G["inspect-extensions"],ee["inspect-brk-extensions"]=G["inspect-brk-extensions"],ee["extensions-dir"]=G["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,A.isWorkspaceIdentifier)(G.workspace)){const ee=G.workspace.configPath;if(ee.scheme===h.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(G.workspace)){const ee=G.workspace.uri;if(ee.scheme===h.Schemas.file&&!await this.fileService.exists(ee))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let T;try{T=p.screen.getDisplayMatching(this.getBounds())}catch(B){}const V=(0,R.defaultWindowState)();return{mode:3,display:T?T.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let ee;if(!S.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?G.mode=0:G.mode=1,ee===1||ee===0){let T;ee===1?T=this.getBounds():T=this._win.getNormalBounds(),G.x=T.x,G.y=T.y,G.width=T.width,G.height=T.height}return G}restoreWindowState(G){(0,i.mark)("code/willRestoreCodeWindowState");let ee=!1;if(G)try{const T=p.screen.getAllDisplays();ee=T.length>1,G=this.validateWindowState(G,T)}catch(T){this.logService.warn(`Unexpected error validating window state: ${T}
${T.stack}`)}return(0,i.mark)("code/didRestoreCodeWindowState"),[G||(0,R.defaultWindowState)(),ee]}validateWindowState(G,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const U=this.getWorkingArea(ee[0]);if(U){let B=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!U||(G.x<U.x&&(G.x=U.x),G.y<U.y&&(G.y=U.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",U),B(),G.width>U.width&&(G.width=U.width),G.height>U.height&&(G.height=U.height),G.x>U.x+U.width-128&&(G.x=U.x+U.width-G.width),G.y>U.y+U.height-128&&(G.y=U.y+U.height-G.height),B()}return G}if(G.display&&G.mode===3){const U=ee.find(B=>B.id===G.display);if(U&&typeof U.bounds?.x=="number"&&typeof U.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,R.defaultWindowState)(3);return B.x=U.bounds.x,B.y=U.bounds.y,B}}let T,V;try{T=p.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),V=this.getWorkingArea(T)}catch(U){}if(T&&V&&G.x+G.width>V.x&&G.y+G.height>V.y&&G.x<V.x+V.width&&G.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,ee]=this._win.getPosition(),[T,V]=this._win.getSize();return{x:G,y:ee,width:T,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,ee=!0){S.isMacintosh||(G==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,m.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const ee=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,ee,...T){this.isReady?this.send(G,...T):this.ready().then(()=>{ee.isCancellationRequested||this.send(G,...T)})}send(G,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${G}' for window that is destroyed`);return}this._win.webContents.send(G,...ee)}}updateTouchBar(G){!S.isMacintosh||this.touchBarGroups.forEach((ee,T)=>{const V=G[T];ee.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!S.isMacintosh){for(let G=0;G<10;G++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const ee=this.createTouchBarGroupSegments(G),T=new p.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:T.segments[V].id,from:"touchbar"})}});return T}createTouchBarGroupSegments(G=[]){return G.map(T=>{let V;T.icon&&!f.ThemeIcon.isThemeIcon(T.icon)&&T.icon?.dark?.scheme===h.Schemas.file&&(V=p.nativeImage.createFromPath(v.URI.revive(T.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let U;return typeof T.title=="string"?U=T.title:U=T.title.value,{id:T.id,label:V?void 0:U,icon:V}})}dispose(){super.dispose(),this._win=null}};ie=he([te(1,n.ILogService),te(2,y.IEnvironmentMainService),te(3,o.IFileService),te(4,r.IStorageMainService),te(5,g.IConfigurationService),te(6,w.IThemeMainService),te(7,F.IWorkspacesManagementMainService),te(8,t.IBackupMainService),te(9,a.ITelemetryService),te(10,b.IDialogMainService),te(11,u.ILifecycleMainService),te(12,l.IProductService),te(13,s.IProtocolMainService),te(14,R.IWindowsMainService)],ie),e.CodeWindow=ie}),define(Z[67],x([0,1,13,31,9,4,34,2,10,3,15,7,20,156,5,22,6,38,27,45]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let o=class $e extends E.Disposable{constructor(f,w,k,R){super();this.stateMainService=f,this.logService=w,this.workspacesManagementMainService=k,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!d.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const w=[],k=[];for(let R of f)if((0,I.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&l(w,R.workspace)===-1&&w.push(R);else if((0,I.isRecentFolder)(R))s(w,R.folderUri)===-1&&w.push(R);else{const A=r(k,R.fileUri)>=0,F=R.fileUri.scheme===h.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,i.basename)(R.fileUri))>=0;!A&&!F&&(k.push(R),d.isWindows&&R.fileUri.scheme===h.Schemas.file&&p.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(w,k),w.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(w.length=$e.MAX_TOTAL_RECENT_ENTRIES),k.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(k.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:w,files:k}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const w=F=>{const H=n(F);for(const ie of f)if(i.extUriBiasedIgnorePathCase.isEqual(ie,H))return!1;return!0},k=this.getRecentlyOpened(),R=k.workspaces.filter(w),A=k.files.filter(w);(R.length!==k.workspaces.length||A.length!==k.files.length)&&(this.saveRecentlyOpened({files:A,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!d.isMacintosh)return;p.app.clearRecentDocuments();const f=this.getRecentlyOpened(),w=[];let k=0;for(let A=0;A<f.workspaces.length&&k<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;A++){const F=n(f.workspaces[A]);if(F.scheme===h.Schemas.file){const H=(0,i.originalFSPath)(F);await v.Promises.exists(H)&&(w.push(H),k++)}}const R=[];for(let A=0;A<f.files.length&&k<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;A++){const F=n(f.files[A]);if(F.scheme===h.Schemas.file){const H=(0,i.originalFSPath)(F);if($e.COMMON_FILES_FILTER.includes((0,i.basename)(F))||w.includes(H))continue;await v.Promises.exists(H)&&(R.push(H),k++)}}R.reverse().forEach(A=>p.app.addRecentDocument(A)),w.reverse().forEach(A=>p.app.addRecentDocument(A))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){const w=[],k=[],R=f?.config?.workspace;(0,I.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?w.push({workspace:R}):(0,I.isSingleFolderWorkspaceIdentifier)(R)&&w.push({folderUri:R.uri});const A=f?.config?.filesToOpenOrCreate;if(A)for(let F of A){const H=F.fileUri;H&&r(k,H)===-1&&k.push({fileUri:H})}return this.addEntriesFromStorage(w,k),{workspaces:w,files:k}}addEntriesFromStorage(f,w){let k=this.getRecentlyOpenedFromStorage();for(let R of k.workspaces){let A=(0,I.isRecentFolder)(R)?s(f,R.folderUri):l(f,R.workspace);A>=0?f[A].label=f[A].label||R.label:f.push(R)}for(let R of k.files){let A=r(w,R.fileUri);A>=0?w[A].label=w[A].label||R.label:w.push(R)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem($e.recentlyOpenedStorageKey);return(0,I.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const w=(0,I.toStoreData)(f);this.stateMainService.setItem($e.recentlyOpenedStorageKey,w)}updateWindowsJumpList(){if(!d.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let w=[];for(let A of p.app.getJumpListSettings().removedItems){const F=A.args;if(F){const H=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(F);H&&w.push(S.URI.parse(H[2]))}}this.removeRecentlyOpened(w);let k=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(A=>{const F=(0,I.isRecentWorkspace)(A)?A.workspace:A.folderUri,{title:H,description:ie}=this.getWindowsJumpListLabel(F,A.label);let re;return S.URI.isUri(F)?re=`--folder-uri "${F.toString()}"`:(k=!0,re=`--file-uri "${F.configPath.toString()}"`),{type:"task",title:H.substr(0,255),description:ie.substr(0,255),program:process.execPath,args:re,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&f.push({type:"custom",name:k?(0,m.localize)(2,null):(0,m.localize)(3,null),items:R})}f.push({type:"recent"});try{p.app.setJumpList(f)}catch(w){this.logService.warn("updateWindowsJumpList#setJumpList",w)}}getWindowsJumpListLabel(f,w){if(w)return{title:(0,P.splitName)(w).name,description:w};if(S.URI.isUri(f))return{title:(0,i.basename)(f),description:u(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let k=(0,i.basename)(f.configPath);return k.endsWith(I.WORKSPACE_EXTENSION)&&(k=k.substr(0,k.length-I.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,k),description:u(f.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([te(0,y.IStateMainService),te(1,b.ILogService),te(2,c.IWorkspacesManagementMainService),te(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function u(a){return a.scheme==="file"?(0,P.normalizeDriveLetter)(a.fsPath):a.toString()}function n(a){return(0,I.isRecentFolder)(a)?a.folderUri:(0,I.isRecentFile)(a)?a.fileUri:a.workspace.configPath}function l(a,f){return a.findIndex(w=>(0,I.isRecentWorkspace)(w)&&w.workspace.id===f.id)}function s(a,f){return a.findIndex(w=>(0,I.isRecentFolder)(w)&&i.extUriBiasedIgnorePathCase.isEqual(w.folderUri,f))}function r(a,f){return a.findIndex(w=>i.extUriBiasedIgnorePathCase.isEqual(w.fileUri,f))}}),define(Z[238],x([0,1,13,9,23,34,3,7,148,19,24,22,6,186,54,21,38,30,41,66,36,67]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let l=class pt{constructor(a,f,w,k,R,A,F,H,ie,re,G){this.updateService=a,this.configurationService=f,this.windowsMainService=w,this.environmentMainService=k,this.telemetryService=R,this.workspacesHistoryMainService=A,this.stateMainService=F,this.lifecycleMainService=H,this.logService=ie,this.nativeHostMainService=re,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(P.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const a=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);a&&(a.menus&&(this.menubarMenus=a.menus),a.keybindings&&(this.keybindings=a.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,F,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,F,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,F,H)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,F,H)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const a=this.productService.twitterUrl;a&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(a,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(P.language){const A=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${A}lang=${P.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(a=>this.onDidChangeWindowsCount(a)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let a=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get currentEnableNativeTabs(){if(!P.isMacintosh)return!1;let a=this.configurationService.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,f){this.menubarMenus=a.menus,this.keybindings=a.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,a),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(a){!P.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.closedLastWindow=a.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!P.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const a=p.Menu.getApplicationMenu();if(a&&this.oldMenus.push(a),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(P.isMacintosh?new p.Menu:null);return}const f=new p.Menu;let w;if(P.isMacintosh){const R=new p.Menu;w=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),f.append(w)}if(P.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:R});this.setMenuById(R,"File"),f.append(A)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),f.append(A)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),f.append(A)}if(this.shouldDrawMenu("View")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:R});this.setMenuById(R,"View"),f.append(A)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),f.append(A)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),f.append(A)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),f.append(A)}let k;if(this.shouldDrawMenu("Window")){const R=new p.Menu;k=new p.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(k&&f.append(k),this.shouldDrawMenu("Help")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),f.append(A)}f.items&&f.items.length>0?p.Menu.setApplicationMenu(f):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(a){const f=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const ee=new p.Menu;this.setMenuById(ee,"Preferences"),k=new p.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ee})}const R=new p.Menu,A=new p.MenuItem({label:h.localize(12,null),role:"services",submenu:R}),F=new p.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),H=new p.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ie=new p.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new p.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),G=[f];G.push(...w),k&&G.push(s(),k),G.push(s(),A,s(),F,H,ie,s(),re),G.forEach(ee=>a.append(ee))}shouldDrawMenu(a){if(!P.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(a){case"File":case"Help":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[a];case"Window":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[a]}}setMenu(a,f){f.forEach(w=>{if((0,m.isMenubarMenuItemSeparator)(w))a.append(s());else if((0,m.isMenubarMenuItemSubmenu)(w)){const k=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(w.label),submenu:k});this.setMenu(k,w.submenu.items),a.append(R)}else(0,m.isMenubarMenuItemRecentAction)(w)?a.append(this.createOpenRecentMenuItem(w)):(0,m.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(a),P.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?a.append(new p.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):a.append(this.createMenuItem(w.label,w.id,!1,w.checked)):a.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):a.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(a,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(a,this.menubarMenus[f].items)}insertCheckForUpdatesItems(a){const f=this.getUpdateMenuItems();f.length&&(f.forEach(w=>a.append(w)),a.append(s()))}createOpenRecentMenuItem(a){const f=E.URI.revive(a.uri),w=a.id,k=w==="openRecentFile"?{fileUri:f}:w==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new p.MenuItem(this.likeAction(w,{label:a.label,click:(R,A,F)=>{const H=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:a.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(a){return!!(a&&(!P.isMacintosh&&(a.ctrlKey||a.shiftKey)||P.isMacintosh&&(a.metaKey||a.altKey)))}createRoleMenuItem(a,f,w){const k={label:this.mnemonicLabel(a),role:w,enabled:!0};return new p.MenuItem(this.withKeybinding(f,k))}setMacWindowMenu(a){const f=new p.MenuItem({label:h.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new p.MenuItem({label:h.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new p.MenuItem({label:h.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(h.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(s()),A.push(this.createMenuItem(h.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,w,s(),R,...A,s(),k].forEach(F=>a.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:h.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:h.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:h.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(a,f,w,k){const R=this.mnemonicLabel(a),A=typeof f=="function"?f:(G,ee,T)=>{const V=G?G.userSettingsLabel:null;let U=f;Array.isArray(f)&&(U=this.isOptionClick(T)?f[1]:f[0]),V&&T.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:V}):this.runActionInRenderer({type:"commandId",commandId:U})},F=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,H=typeof k=="boolean"?k:!1,ie={label:R,click:A,enabled:F};H&&(ie.type="checkbox",ie.checked=H);let re;return typeof f=="string"?re=f:Array.isArray(f)&&(re=f[0]),P.isMacintosh&&(re==="editor.action.clipboardCutAction"?ie.role="cut":re==="editor.action.clipboardCopyAction"?ie.role="copy":re==="editor.action.clipboardPasteAction"&&(ie.role="paste"),re==="undo"?ie.click=this.makeContextAwareClickHandler(A,{inDevTools:G=>G.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?ie.click=this.makeContextAwareClickHandler(A,{inDevTools:G=>G.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(ie.click=this.makeContextAwareClickHandler(A,{inDevTools:G=>G.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(re,ie))}makeContextAwareClickHandler(a,f){return(w,k,R)=>{const A=p.BrowserWindow.getFocusedWindow();if(!A)return f.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return f.inDevTools(A.webContents.devToolsWebContents);a(w,k||A,R)}}runActionInRenderer(a){let f=p.BrowserWindow.getFocusedWindow();if(!f){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(f=k.win)}const w=f?this.windowsMainService.getWindowById(f.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",a),P.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const k={id:a.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",D.CancellationToken.None,k)}else{const k={userSettingsLabel:a.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",a)}withKeybinding(a,f){const w=typeof a=="string"?this.keybindings[a]:void 0;if(w?.label){if(w.isNative!==!1)f.accelerator=w.label,f.userSettingsLabel=w.userSettingsLabel;else if(typeof f.label=="string"){const k=f.label.indexOf("[");k>=0?f.label=`${f.label.substr(0,k)} [${w.label}]`:f.label=`${f.label} [${w.label}]`}}else f.accelerator=void 0;return f}likeAction(a,f,w=!f.accelerator){w&&(f=this.withKeybinding(a,f));const k=f.click;return f.click=(R,A,F)=>{this.reportMenuActionTelemetry(a),k&&k(R,A,F)},f}openUrl(a,f){this.nativeHostMainService.openExternal(void 0,a),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(a){this.telemetryService.publicLog2("workbenchActionExecuted",{id:a,from:n})}mnemonicLabel(a){return(0,M.mnemonicMenuLabel)(a,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=he([te(0,I.IUpdateService),te(1,d.IConfigurationService),te(2,o.IWindowsMainService),te(3,i.IEnvironmentMainService),te(4,y.ITelemetryService),te(5,u.IWorkspacesHistoryMainService),te(6,b.IStateMainService),te(7,S.ILifecycleMainService),te(8,v.ILogService),te(9,t.INativeHostMainService),te(10,g.IProductService)],l),e.Menubar=l;function s(){return new p.MenuItem({type:"separator"})}}),define(Z[239],x([0,1,5,22,6,238]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let P=class{constructor(h,d,i){this.instantiationService=h,this.lifecycleMainService=d,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(h,d){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(d,h)}};P=he([te(0,p.IInstantiationService),te(1,L.ILifecycleMainService),te(2,D.ILogService)],P),e.MenubarMainService=P}),define(Z[240],x([0,1,13,29,26,31,23,4,33,42,34,2,10,8,76,3,32,15,25,14,7,154,52,19,53,24,18,5,22,6,49,21,57,63,38,66,237,101,220,27,102,67,45]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n,l,s,r,a,f,w,k,R,A,F,H,ie,re,G,ee,T,V,U,B,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function _(K){return(0,V.isWorkspaceIdentifier)(K?.workspace)}function X(K){return(0,V.isSingleFolderWorkspaceIdentifier)(K?.workspace)}let W=class Ze extends S.Disposable{constructor(O,q,C,$,J,Q,ne,le,oe,se,ce,ge,de,Ee,Pe){super();this.machineId=O,this.initialUserEnv=q,this.logService=C,this.stateMainService=$,this.environmentMainService=J,this.lifecycleMainService=Q,this.backupMainService=ne,this.configurationService=le,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=se,this.instantiationService=ce,this.dialogMainService=ge,this.fileService=de,this.productService=Ee,this.protocolMainService=Pe,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new T.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(O=>this._onDidSignalReadyWindow.fire(O.window))),this._register(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const q=new S.DisposableStore;if(q.add(E.Event.any(O.onDidClose,O.onDidDestroy)(()=>q.dispose())),O.config.extensionDevelopmentPath)for(const C of O.config.extensionDevelopmentPath)q.add(this.protocolMainService.addValidFileRoot(o.URI.file(C)));O.config.extensionTestsPath&&q.add(this.protocolMainService.addValidFileRoot(o.URI.file(O.config.extensionTestsPath)))}}))}openEmptyWindow(O,q){let C=this.environmentMainService.args;const $=q?.remoteAuthority||void 0,J=!0,Q=q?.forceReuseWindow,ne=!Q;return this.open({...O,cli:C,forceEmpty:J,forceNewWindow:ne,forceReuseWindow:Q,remoteAuthority:$})}openExistingWindow(O,q){O.focus(),this.handleWaitMarkerFile(q,[O])}open(O){this.logService.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const q=[],C=[],$=[],J=[],Q=[];let ne,le=0;const oe=this.getPathsToOpen(O);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const de of oe)X(de)?O.addMode?q.push(de):C.push(de):_(de)?$.push(de):de.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:de.remoteAuthority}),ne.filesToOpenOrCreate.push(de)):de.backupPath?Q.push({backupFolder:(0,m.basename)(de.backupPath),remoteAuthority:de.remoteAuthority}):le++;O.diffMode&&ne&&ne.filesToOpenOrCreate.length>=2&&(ne.filesToDiff=ne.filesToOpenOrCreate.slice(0,2),ne.filesToOpenOrCreate=[]),ne&&O.waitMarkerFileURI&&(ne.filesToWait={paths:[...ne.filesToDiff,...ne.filesToOpenOrCreate],waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(J.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),$.push(...J),Q.push(...this.backupMainService.getEmptyWindowBackupPaths())):Q.length=0;const{windows:se,filesOpenedInWindow:ce}=this.doOpen(O,$,C,Q,le,ne,q);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${$.length}, foldersToOpen: ${C.length}, emptyToRestore: ${Q.length}, emptyToOpen: ${le})`),se.length>1)if(ce)ce.focus();else{const de=this.windowsStateHandler.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Ee=!0,Pe=!0;if(de){const Ie=se.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),Ee=!1,Pe=!1)}if(Ee)for(let Ie=se.length-1;Ie>=0;Ie--){const ve=se[Ie];if(!(ve.openedWorkspace&&J.some(ye=>ve.openedWorkspace&&ye.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&Q.some(ye=>ve.backupPath&&ye.backupFolder===(0,m.basename)(ve.backupPath)))){ve.focus(),Pe=!1;break}}Pe&&se[se.length-1].focus()}const ge=ne&&ne.filesToDiff.length>0;if(!se.some(de=>de.isExtensionDevelopmentHost)&&!ge&&!O.noRecentEntry){const de=[];for(const Ee of oe)_(Ee)&&!Ee.transient?de.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):X(Ee)?de.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&de.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(de)}return this.handleWaitMarkerFile(O,se),se}handleWaitMarkerFile(O,q){const C=O.waitMarkerFileURI;O.context===0&&C&&q.length===1&&q[0]&&(async()=>{await q[0].whenClosedOrLoaded;try{await this.fileService.del(C)}catch($){}})()}doOpen(O,q,C,$,J,Q,ne){const le=[];let oe;function se(ve,ye){le.push(ve),ye&&(oe=ve,Q=void 0)}let{openFolderInNewWindow:ce,openFilesInNewWindow:ge}=this.shouldOpenNewWindow(O);if(!O.initialStartup&&ne.length>0){const ve=ne[0].remoteAuthority,ye=this.getLastActiveWindowForAuthority(ve);ye&&se(this.doAddFoldersToExistingWindow(ye,ne.map(ke=>ke.workspace.uri)))}const de=C.length+q.length+$.length;if(Q&&de===0){const ve=Q.filesToOpenOrCreate[0]||Q.filesToDiff[0],ye=this.getWindows().filter(We=>Q&&z(We.remoteAuthority,Q.remoteAuthority));let ke;ve?.fileUri&&!ge&&((O.context===4||O.context===0||O.context===1)&&(ke=(0,ee.findWindowOnFile)(ye,ve.fileUri,We=>We.configPath.scheme===v.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(We.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(ye))),ke?(0,V.isWorkspaceIdentifier)(ke.openedWorkspace)?q.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,V.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?C.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):se(this.doOpenFilesInExistingWindow(O,ke,Q),!0):se(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:Q,forceNewWindow:!0,remoteAuthority:Q.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow}),!0)}const Ee=(0,M.distinct)(q,ve=>ve.workspace.id);if(Ee.length>0){const ve=(0,M.coalesce)(Ee.map(ye=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(ve.length>0){const ye=ve[0],ke=z(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;se(this.doOpenFilesInExistingWindow(O,ye,ke),!!ke),ce=!0}Ee.forEach(ye=>{if(ve.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ye.workspace.id))return;const ke=ye.remoteAuthority,We=z(Q?.remoteAuthority,ke)?Q:void 0;se(this.doOpenFolderOrWorkspace(O,ye,ce,We),!!We),ce=!0})}const Pe=(0,M.distinct)(C,ve=>y.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Pe.length>0){const ve=(0,M.coalesce)(Pe.map(ye=>(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(ve.length>0){const ye=ve[0],ke=z(Q?.remoteAuthority,ye.remoteAuthority)?Q:void 0;se(this.doOpenFilesInExistingWindow(O,ye,ke),!!ke),ce=!0}Pe.forEach(ye=>{if(ve.some(Ae=>(0,V.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ye.workspace.uri)))return;const ke=ye.remoteAuthority,We=z(Q?.remoteAuthority,ke)?Q:void 0;se(this.doOpenFolderOrWorkspace(O,ye,ce,We),!!We),ce=!0})}const Ie=(0,M.distinct)($,ve=>ve.backupFolder);if(Ie.length>0&&Ie.forEach(ve=>{const ye=ve.remoteAuthority,ke=z(Q?.remoteAuthority,ye)?Q:void 0;se(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:ke,remoteAuthority:ye,forceNewWindow:!0,forceNewTabbedWindow:O.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!ke),ce=!0}),le.length===0||Q){Q&&!J&&J++;const ve=Q?Q.remoteAuthority:O.remoteAuthority;for(let ye=0;ye<J;ye++)se(this.doOpenEmpty(O,ce,ve,Q),!!Q),ce=!0}return{windows:(0,M.distinct)(le),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(O,q,C){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),q.focus();const $={filesToOpenOrCreate:C?.filesToOpenOrCreate,filesToDiff:C?.filesToDiff,filesToWait:C?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return q.sendWhenReady("vscode:openFiles",P.CancellationToken.None,$),q}doAddFoldersToExistingWindow(O,q){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),O.focus();const C={foldersToAdd:q};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,C),O}doOpenEmpty(O,q,C,$,J){return!q&&!J&&typeof O.contextWindowId=="number"&&(J=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:C,forceNewWindow:q,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:$,windowToUse:J})}doOpenFolderOrWorkspace(O,q,C,$,J){return!C&&!J&&typeof O.contextWindowId=="number"&&(J=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({workspace:q.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:q.remoteAuthority,forceNewWindow:C,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:$,windowToUse:J})}getPathsToOpen(O){let q,C=!1,$=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(q=this.doExtractPathsFromAPI(O),C=!0):O.forceEmpty?q=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(q=this.doExtractPathsFromCLI(O.cli),q.length===0&&q.push(Object.create(null)),C=!0):(q=this.doGetPathsFromLastSession(),q.length===0&&q.push(Object.create(null)),$=!0),!O.addMode&&C){const J=q.filter(Q=>X(Q));if(J.length>1){const Q=J[0].remoteAuthority;if(J.every(ne=>z(ne.remoteAuthority,Q))){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(J.map(le=>({uri:le.workspace.uri})));q.push({workspace:ne,remoteAuthority:Q}),q=q.filter(le=>!X(le))}}}return O.initialStartup&&!$&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&q.unshift(...this.doGetPathsFromLastSession().filter(J=>_(J)||X(J)||J.backupPath)),q}doExtractPathsFromAPI(O){const q=[],C={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority};for(const $ of(0,M.coalesce)(O.urisToOpen||[])){const J=this.resolveOpenable($,C);if(J)J.label=$.label,q.push(J);else{const Q=this.resourceFromOpenable($),ne={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:Q.scheme===v.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:Q.scheme===v.Schemas.file?(0,u.localize)(3,null,(0,i.getPathLabel)(Q.fsPath,this.environmentMainService)):(0,u.localize)(4,null,Q.toString()),noLink:!0};this.dialogMainService.showMessageBox(ne,(0,c.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return q}doExtractPathsFromCLI(O){const q=[],C={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:!1},$=O["folder-uri"];if($)for(const ne of $){const le=this.cliArgToUri(ne);if(le){const oe=this.resolveOpenable({folderUri:le},C);oe&&q.push(oe)}}const J=O["file-uri"];if(J)for(const ne of J){const le=this.cliArgToUri(ne);if(le){const oe=this.resolveOpenable((0,V.hasWorkspaceFileExtension)(ne)?{workspaceUri:le}:{fileUri:le},C);oe&&q.push(oe)}}const Q=O._;for(const ne of Q){const le=C.remoteAuthority?this.doResolvePathRemote(ne,C):this.doResolveFilePath(ne,C);le&&q.push(le)}return q}cliArgToUri(O){try{const q=o.URI.parse(O);if(!q.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${O}`);return}return q}catch(q){this.logService.error(`Invalid URI input string: ${O}, ${q.message}`)}}doGetPathsFromLastSession(){const O=this.getRestoreWindowsSetting();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":const q=[];O!=="one"&&q.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&q.push(this.windowsStateHandler.state.lastActiveWindow);const C=[];for(const $ of q)if($.workspace){const J=this.resolveOpenable({workspaceUri:$.workspace.configPath},{remoteAuthority:$.remoteAuthority,rejectTransientWorkspaces:!0});_(J)&&C.push(J)}else if($.folderUri){const J=this.resolveOpenable({folderUri:$.folderUri},{remoteAuthority:$.remoteAuthority});X(J)&&C.push(J)}else O!=="folders"&&$.backupPath&&C.push({backupPath:$.backupPath,remoteAuthority:$.remoteAuthority});return C}}getRestoreWindowsSetting(){let O;return this.lifecycleMainService.wasRestarted?O="all":(O=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}resolveOpenable(O,q=Object.create(null)){let C=this.resourceFromOpenable(O);return C.scheme===v.Schemas.file?((0,re.isFileToOpen)(O)&&(q={...q,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(C.fsPath,q)):this.doResolveRemoteOpenable(O,q)}doResolveRemoteOpenable(O,q){let C=this.resourceFromOpenable(O);const $=(0,H.getRemoteAuthority)(C)||q.remoteAuthority;if(C=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(C)),(0,re.isFileToOpen)(O)){if(q.gotoLineMode){const{path:J,line:Q,column:ne}=(0,h.parseLineAndColumnAware)(C.path);return{fileUri:C.with({path:J}),selection:Q?{startLineNumber:Q,startColumn:ne||1}:void 0,remoteAuthority:$}}return{fileUri:C,remoteAuthority:$}}else if((0,re.isWorkspaceToOpen)(O))return{workspace:(0,U.getWorkspaceIdentifier)(C),remoteAuthority:$};return{workspace:(0,U.getSingleFolderWorkspaceIdentifier)(C),remoteAuthority:$}}resourceFromOpenable(O){return(0,re.isWorkspaceToOpen)(O)?O.workspaceUri:(0,re.isFolderToOpen)(O)?O.folderUri:O.fileUri}doResolveFilePath(O,q){let C,$;q.gotoLineMode&&({path:O,line:C,column:$}=(0,h.parseLineAndColumnAware)(O)),O=(0,h.sanitizeFilePath)((0,m.normalize)(O),(0,b.cwd)());try{const J=(0,L.statSync)(O);if(J.isFile()){if(!q.forceOpenWorkspaceAsFile){const Q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(o.URI.file(O));if(Q)return Q.transient&&q.rejectTransientWorkspaces?void 0:{workspace:{id:Q.id,configPath:Q.configPath},remoteAuthority:Q.remoteAuthority,exists:!0,transient:Q.transient}}return{fileUri:o.URI.file(O),selection:C?{startLineNumber:C,startColumn:$||1}:void 0,exists:!0}}else{if(J.isDirectory())return{workspace:(0,U.getSingleFolderWorkspaceIdentifier)(o.URI.file(O),J),exists:!0};if(!g.isWindows&&O==="/dev/null")return{fileUri:o.URI.file(O),exists:!0}}}catch(J){const Q=o.URI.file(O);if(this.workspacesHistoryMainService.removeRecentlyOpened([Q]),q.ignoreFileNotFound)return{fileUri:Q,exists:!1}}}doResolvePathRemote(O,q){const C=O.charCodeAt(0),$=q.remoteAuthority;let J,Q;q.gotoLineMode&&({path:O,line:J,column:Q}=(0,h.parseLineAndColumnAware)(O)),C!==47&&((0,h.isWindowsDriveLetter)(C)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,h.toSlashes)(O)),O=`/${O}`);const ne=o.URI.from({scheme:v.Schemas.vscodeRemote,authority:$,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,V.hasWorkspaceFileExtension)(O))return q.forceOpenWorkspaceAsFile?{fileUri:ne,selection:J?{startLineNumber:J,startColumn:Q||1}:void 0,remoteAuthority:q.remoteAuthority}:{workspace:(0,U.getWorkspaceIdentifier)(ne),remoteAuthority:$};if(q.gotoLineMode||m.posix.basename(O).indexOf(".")!==-1)return{fileUri:ne,selection:J?{startLineNumber:J,startColumn:Q||1}:void 0,remoteAuthority:$}}return{workspace:(0,U.getSingleFolderWorkspaceIdentifier)(ne),remoteAuthority:$}}shouldOpenNewWindow(O){const q=this.configurationService.getValue("window"),C=q?.openFoldersInNewWindow||"default",$=q?.openFilesInNewWindow||"off";let J=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(C==="on"||C==="off")&&(J=C==="on");let Q=!1;return O.forceNewWindow||O.forceReuseWindow?Q=!!O.forceNewWindow&&!O.forceReuseWindow:(g.isMacintosh?O.context===1&&(Q=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(Q=!0),!O.cli.extensionDevelopmentPath&&($==="on"||$==="off")&&(Q=$==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:Q}}openExtensionDevelopmentHostWindow(O,q){const C=(0,ee.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(C)return this.lifecycleMainService.reload(C,q.cli),C.focus(),[C];let $=q.cli["folder-uri"]||[],J=q.cli["file-uri"]||[],Q=q.cli._;if(!Q.length&&!$.length&&!J.length&&!q.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=se&&(se.workspace||se.folderUri);ce&&(o.URI.isUri(ce)?ce.scheme===v.Schemas.file?Q=[ce.fsPath]:$=[ce.toString()]:ce.configPath.scheme===v.Schemas.file?Q=[(0,y.originalFSPath)(ce.configPath)]:J=[ce.configPath.toString()])}let ne=q.remoteAuthority;for(const se of O)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=o.URI.parse(se),ge=(0,H.getRemoteAuthority)(ce);ge&&(ne?ge!==ne&&this.logService.error("more than one extension development path authority"):ne=ge)}Q=Q.filter(se=>{const ce=o.URI.file(se);return(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,H.getRemoteAuthority)(ce)===ne}),$=$.filter(se=>{const ce=this.cliArgToUri(se);return ce&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,H.getRemoteAuthority)(ce)===ne:!1}),J=J.filter(se=>{const ce=this.cliArgToUri(se);return ce&&!!(0,ee.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,H.getRemoteAuthority)(ce)===ne:!1}),q.cli._=Q,q.cli["folder-uri"]=$,q.cli["file-uri"]=J;const le=!Q.length&&!$.length&&!J.length,oe={context:q.context,cli:q.cli,forceNewWindow:!0,forceEmpty:le,userEnv:q.userEnv,noRecentEntry:!0,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:ne};return this.open(oe)}openInBrowserWindow(O){const q=this.configurationService.getValue("window"),C={...this.environmentMainService.args,...O.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,m.join)(this.environmentMainService.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.initialUserEnv,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:R.default,isInitialStartup:O.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof q?.zoomLevel=="number"?q.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:q?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let $;if(!O.forceNewWindow&&!O.forceNewTabbedWindow&&($=O.windowToUse||this.getLastActiveWindow(),$&&$.focus()),$){const J=$.config;!C.extensionDevelopmentPath&&J&&!!J.extensionDevelopmentPath&&(C.extensionDevelopmentPath=J.extensionDevelopmentPath,C.verbose=J.verbose,C["inspect-brk-extensions"]=J["inspect-brk-extensions"],C.debugId=J.debugId,C.extensionEnvironment=J.extensionEnvironment,C["inspect-extensions"]=J["inspect-extensions"],C["extensions-dir"]=J["extensions-dir"])}else{const J=this.windowsStateHandler.getNewWindowState(C);(0,t.mark)("code/willCreateCodeWindow");const Q=$=this.instantiationService.createInstance(G.CodeWindow,{state:J,extensionDevelopmentPath:C.extensionDevelopmentPath,isExtensionTestHost:!!C.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow){const le=this.getLastActiveWindow();le&&le.addTabbedWindow(Q)}Ze.WINDOWS.push(Q),this._onDidOpenWindow.fire(Q),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,d.once)(Q.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(Q)),(0,d.once)(Q.onDidClose)(()=>this.onWindowClosed(Q)),(0,d.once)(Q.onDidDestroy)(()=>this._onDidDestroyWindow.fire(Q));const ne=(0,c.assertIsDefined)(Q.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.lifecycleMainService.reload(Q)),this.lifecycleMainService.registerWindow(Q)}return C.windowId=$.id,$.isReady?this.lifecycleMainService.unload($,4).then(J=>{J||this.doOpenInBrowserWindow($,C,O)}):this.doOpenInBrowserWindow($,C,O),$}doOpenInBrowserWindow(O,q,C){if(!q.extensionDevelopmentPath)if((0,V.isWorkspaceIdentifier)(q.workspace))q.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:q.workspace,remoteAuthority:q.remoteAuthority});else if((0,V.isSingleFolderWorkspaceIdentifier)(q.workspace))q.backupPath=this.backupMainService.registerFolderBackupSync(q.workspace.uri);else{const $=C.emptyWindowBackupInfo&&C.emptyWindowBackupInfo.backupFolder;q.backupPath=this.backupMainService.registerEmptyWindowBackupSync($,q.remoteAuthority)}O.load(q)}onWindowClosed(O){const q=Ze.WINDOWS.indexOf(O);Ze.WINDOWS.splice(q,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=p.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(O){return this.doGetLastActiveWindow(this.getWindows().filter(q=>z(q.remoteAuthority,O)))}doGetLastActiveWindow(O){const q=Math.max.apply(Math,O.map(C=>C.lastFocusTime));return O.find(C=>C.lastFocusTime===q)}sendToFocused(O,...q){const C=this.getFocusedWindow()||this.getLastActiveWindow();C&&C.sendWhenReady(O,P.CancellationToken.None,...q)}sendToAll(O,q,C){for(const $ of this.getWindows())C&&C.indexOf($.id)>=0||$.sendWhenReady(O,P.CancellationToken.None,q)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(O){const q=this.getWindows().filter(C=>C.id===O);return(0,M.firstOrDefault)(q)}getWindowByWebContents(O){const q=p.BrowserWindow.fromWebContents(O);if(!!q)return this.getWindowById(q.id)}};W.WINDOWS=[],W=he([te(2,k.ILogService),te(3,ie.IStateMainService),te(4,r.IEnvironmentMainService),te(5,w.ILifecycleMainService),te(6,n.IBackupMainService),te(7,l.IConfigurationService),te(8,B.IWorkspacesHistoryMainService),te(9,N.IWorkspacesManagementMainService),te(10,f.IInstantiationService),te(11,s.IDialogMainService),te(12,a.IFileService),te(13,A.IProductService),te(14,F.IProtocolMainService)],W),e.WindowsMainService=W;function z(K,O){return K===O||K!==void 0&&O!==void 0&&(0,I.equalsIgnoreCase)(K,O)}}),define(Z[241],x([0,1,52,36,67,45]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(h,d,i,S){this.workspacesManagementMainService=h,this.windowsMainService=d,this.workspacesHistoryMainService=i,this.backupMainService=S,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,d){const i=this.windowsMainService.getWindowById(h);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),d)}createUntitledWorkspace(h,d,i){return this.workspacesManagementMainService.createUntitledWorkspace(d,i)}deleteUntitledWorkspace(h,d){return this.workspacesManagementMainService.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(h,d){return this.workspacesManagementMainService.getWorkspaceIdentifier(d)}async getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(h))}async addRecentlyOpened(h,d){return this.workspacesHistoryMainService.addRecentlyOpened(d)}async removeRecentlyOpened(h,d){return this.workspacesHistoryMainService.removeRecentlyOpened(d)}async clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=he([te(0,M.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,D.IWorkspacesHistoryMainService),te(3,p.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Z[242],x([0,1,13,29,26,17,55,16,33,42,39,34,2,10,8,3,15,14,7,28,70,121,35,124,86,233,133,52,224,19,179,161,74,53,223,89,24,56,91,169,187,90,170,18,182,96,73,5,75,234,200,103,22,6,184,239,54,21,63,229,77,38,218,100,201,30,203,205,64,41,209,231,235,232,236,99,210,211,212,213,215,36,240,216,27,67,241,45]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n,l,s,r,a,f,w,k,R,A,F,H,ie,re,G,ee,T,V,U,B,N,_,X,W,z,K,O,q,C,$,J,Q,ne,le,oe,se,ce,ge,de,Ee,Pe,Ie,ve,ye,ke,We,Ae,Ve,xe,st,Ke,ht,et,Y,ae,ue,me,be,Te,_e,Ue,Be,Ce,ze,It,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let dt=class extends v.Disposable{constructor(fe,pe,Se,we,Me,Le,De,Fe,Oe,qe){super();this.mainProcessNodeIpcServer=fe,this.userEnv=pe,this.mainInstantiationService=Se,this.logService=we,this.environmentMainService=Me,this.lifecycleMainService=Le,this.configurationService=De,this.stateMainService=Fe,this.fileService=Oe,this.productService=qe,this.configureSession(),this.registerListeners()}configureSession(){const fe=we=>we?.startsWith(`${m.Schemas.vscodeWebview}://`),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((we,Me,Le,De)=>fe(De.requestingUrl)?Le(pe.has(Me)):Le(!1)),p.session.defaultSession.setPermissionCheckHandler((we,Me,Le,De)=>fe(De.requestingUrl)?pe.has(Me):!1);const Se=p.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,E.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,E.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Se,we)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",we)}),p.app.on("activate",(Se,we)=>{this.logService.trace("app#activate"),we||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Se,we)=>{we.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),we.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let fe=[],pe;p.app.on("open-file",(Se,we)=>{this.logService.trace("app#open-file: ",we),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(we)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],pe=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Se=>{const we=this.windowsMainService?.getWindowByWebContents(Se.sender);let Me,Le;return we?.config?(Me=we.config,Le={...process.env,...we.config.userEnv}):(Me=this.environmentMainService.args,Le=process.env),this.resolveShellEnvironment(Me,Le)}),p.ipcMain.handle("vscode:writeNlsFile",(Se,we,Me)=>{const Le=this.validateNlsPath([we]);if(!Le||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Me))}),p.ipcMain.handle("vscode:readNlsFile",async(Se,...we)=>{const Me=this.validateNlsPath(we);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let pe;for(const Se of fe)typeof Se=="string"&&(typeof pe!="string"?pe=Se:pe=(0,t.join)(pe,Se));if(!(typeof pe!="string"||!(0,t.isAbsolute)(pe)||!(0,h.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return I.URI.file(pe)}onUnexpectedError(fe){if(fe){const pe={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(pe))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;g.isWindows&&fe&&p.app.setAppUserModelId(fe);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Oe){this.logService.error(Oe)}const pe=new l.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:we,sharedProcessReady:Me,sharedProcessClient:Le}=this.setupSharedProcess(Se),De=await this.initServices(Se,we,Me);if(this.environmentMainService.driverHandle){const Oe=await(0,ie.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Oe)}this._register(De.createInstance(r.ProxyAuthHandler)),De.invokeFunction(Oe=>this.initChannels(Oe,pe,Le));const Fe=De.invokeFunction(Oe=>this.openFirstWindow(Oe,pe));De.invokeFunction(Oe=>this.afterWindowOpen(Oe,we)),this.environmentMainService.args.trace&&De.invokeFunction(Oe=>this.stopTracingEventually(Oe,Fe))}async resolveMachineId(){let fe=this.stateMainService.getItem(ye.machineIdKey);return(!fe||g.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,o.getMachineId)(),this.stateMainService.setItem(ye.machineIdKey,fe)),fe}setupSharedProcess(fe){const pe=this._register(this.mainInstantiationService.createInstance(ge.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Me,"main")})(),we=(async()=>(await pe.whenReady(),Se))();return{sharedProcess:pe,sharedProcessReady:we,sharedProcessClient:Se}}async initServices(fe,pe,Se){const we=new O.ServiceCollection;switch(process.platform){case"win32":we.set(Ve.IUpdateService,new z.SyncDescriptor(et.Win32UpdateService));break;case"linux":g.isLinuxSnap?we.set(Ve.IUpdateService,new z.SyncDescriptor(ht.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(Ve.IUpdateService,new z.SyncDescriptor(Ke.LinuxUpdateService));break;case"darwin":we.set(Ve.IUpdateService,new z.SyncDescriptor(st.DarwinUpdateService));break}we.set(_e.IWindowsMainService,new z.SyncDescriptor(Ue.WindowsMainService,[fe,this.userEnv])),we.set(H.IDialogMainService,new z.SyncDescriptor(H.DialogMainService)),we.set($.ILaunchMainService,new z.SyncDescriptor($.LaunchMainService)),we.set(F.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Se.then(Le=>Le.getChannel("diagnostics"))))),we.set(q.IIssueMainService,new z.SyncDescriptor(q.IssueMainService,[this.userEnv])),we.set(re.IEncryptionMainService,new z.SyncDescriptor(re.EncryptionMainService,[fe])),we.set(C.IKeyboardLayoutMainService,new z.SyncDescriptor(C.KeyboardLayoutMainService)),we.set(oe.INativeHostMainService,new z.SyncDescriptor(oe.NativeHostMainService,[pe])),we.set(be.IWebviewManagerService,new z.SyncDescriptor(Te.WebviewMainService)),we.set(Ce.IWorkspacesService,new z.SyncDescriptor(It.WorkspacesMainService)),we.set(vt.IWorkspacesManagementMainService,new z.SyncDescriptor(vt.WorkspacesManagementMainService)),we.set(ze.IWorkspacesHistoryMainService,new z.SyncDescriptor(ze.WorkspacesHistoryMainService)),we.set(le.IMenubarMainService,new z.SyncDescriptor(le.MenubarMainService)),we.set(V.IExtensionUrlTrustService,new z.SyncDescriptor(U.ExtensionUrlTrustService)),we.set(Ie.IStorageMainService,new z.SyncDescriptor(Ie.StorageMainService)),g.isWindows?we.set(B.IExternalTerminalMainService,new z.SyncDescriptor(N.WindowsExternalTerminalService)):g.isMacintosh?we.set(B.IExternalTerminalMainService,new z.SyncDescriptor(N.MacExternalTerminalService)):g.isLinux&&we.set(B.IExternalTerminalMainService,new z.SyncDescriptor(N.LinuxExternalTerminalService));const Me=new w.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(we.set(f.IBackupMainService,Me),we.set(Y.IURLService,new z.SyncDescriptor(ue.NativeURLService)),(0,Ae.supportsTelemetry)(this.productService,this.environmentMainService)){const Le=(0,n.getDelayedChannel)(Se.then(Ge=>Ge.getChannel("telemetryAppender"))),De=new ke.TelemetryAppenderClient(Le),Fe=(0,ve.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Oe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],qe={appenders:[De],commonProperties:Fe,piiPaths:Oe,sendErrorTelemetry:!0};we.set(ye.ITelemetryService,new z.SyncDescriptor(We.TelemetryService,[qe]))}else we.set(ye.ITelemetryService,Ae.NullTelemetryService);return await Me.initialize(),this.mainInstantiationService.createChild(we)}initChannels(fe,pe,Se){const we=n.ProxyChannel.fromService(fe.get($.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",we);const Me=this.fileService.getProvider(m.Schemas.file);(0,y.assertType)(Me instanceof W.DiskFileSystemProvider);const Le=new X.DiskFileSystemProviderChannel(Me,this.logService);pe.registerChannel("localFilesystem",Le);const De=new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);pe.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(De)),Se.then(Re=>Re.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(De)));const Fe=new xe.UpdateChannel(fe.get(Ve.IUpdateService));pe.registerChannel("update",Fe);const Oe=n.ProxyChannel.fromService(fe.get(q.IIssueMainService));pe.registerChannel("issue",Oe);const qe=n.ProxyChannel.fromService(fe.get(re.IEncryptionMainService));pe.registerChannel("encryption",qe);const Ge=n.ProxyChannel.fromService(fe.get(de.ISignService));pe.registerChannel("sign",Ge);const tt=n.ProxyChannel.fromService(fe.get(C.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",tt),this.nativeHostMainService=fe.get(oe.INativeHostMainService);const Ye=n.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ye),Se.then(Re=>Re.registerChannel("nativeHost",Ye));const ft=n.ProxyChannel.fromService(fe.get(Ce.IWorkspacesService));pe.registerChannel("workspaces",ft);const Ne=n.ProxyChannel.fromService(fe.get(le.IMenubarMainService));pe.registerChannel("menubar",Ne);const ot=n.ProxyChannel.fromService(fe.get(Y.IURLService));pe.registerChannel("url",ot);const it=n.ProxyChannel.fromService(fe.get(V.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",it);const nt=n.ProxyChannel.fromService(fe.get(be.IWebviewManagerService));pe.registerChannel("webview",nt);const rt=this._register(new Pe.StorageDatabaseChannel(this.logService,fe.get(Ie.IStorageMainService)));pe.registerChannel("storage",rt),Se.then(Re=>Re.registerChannel("storage",rt));const at=n.ProxyChannel.fromService(fe.get(B.IExternalTerminalMainService));pe.registerChannel("externalTerminal",at);const Xe=new ne.LogLevelChannel(fe.get(Q.ILogService));pe.registerChannel("logLevel",Xe),Se.then(Re=>Re.registerChannel("logLevel",Xe));const Qe=new ne.LoggerChannel(fe.get(Q.ILoggerService));pe.registerChannel("logger",Qe),Se.then(Re=>Re.registerChannel("logger",Qe));const lt=new A.ElectronExtensionHostDebugBroadcastChannel(fe.get(_e.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",lt)}openFirstWindow(fe,pe){const Se=this.windowsMainService=fe.get(_e.IWindowsMainService),we=fe.get(Y.IURLService),Me=fe.get(oe.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Re=>{try{return{uri:I.URI.parse(Re),url:Re}}catch{return}}).filter(Re=>{if(!Re||this.shouldBlockURI(Re.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(Re.uri);return Je?(Le.push(Je),!1):!0}),Fe=this,Oe=this.environmentMainService,qe=this.productService;we.registerHandler({async handleURL(Re,Je){if(Re.scheme===qe.urlProtocol&&Re.path==="workspace"&&(Re=Re.with({authority:"file",path:I.URI.parse(Re.query).path,query:""})),Fe.shouldBlockURI(Re))return!0;const yt=Fe.getWindowOpenableFromProtocolLink(Re);if(yt){const[gt]=Se.open({context:5,cli:{...Oe.args},urisToOpen:[yt],gotoLineMode:!0});return gt.focus(),!0}if(g.isMacintosh&&Se.getWindowCount()===0){const[gt]=Se.open({context:5,cli:{...Oe.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ce.getRemoteAuthority)(Re)});return await gt.ready(),we.open(Re,Je)}return!1}});const Ge=this._register(new Be.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),tt=new n.StaticRouter(Re=>Ge.getActiveClientId().then(Je=>Re===Je)),Ye=new ae.URLHandlerRouter(tt),ft=pe.getChannel("urlHandler",Ye);we.registerHandler(new ae.URLHandlerChannelClient(ft)),this._register(new me.ElectronURLListener(De,we,Se,this.environmentMainService,this.productService));const Ne=this.environmentMainService.args,ot=global.macOpenFiles,it=(0,ee.isLaunchedFromCli)(process.env)?0:4,nt=Ne._.length,rt=!!Ne["folder-uri"],at=!!Ne["file-uri"],Xe=Ne["skip-add-to-recently-opened"]===!0,Qe=Ne.wait&&Ne.waitMarkerFilePath?I.URI.file(Ne.waitMarkerFilePath):void 0,lt=Ne.remote||void 0;return Le.length>0?Se.open({context:it,cli:Ne,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Ne["new-window"]&&!nt&&!rt&&!at?Se.open({context:it,cli:Ne,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Xe,waitMarkerFileURI:Qe,initialStartup:!0,remoteAuthority:lt}):ot.length&&!nt&&!rt&&!at?Se.open({context:1,cli:Ne,urisToOpen:ot.map(Re=>this.getWindowOpenableFromPathSync(Re)),noRecentEntry:Xe,waitMarkerFileURI:Qe,initialStartup:!0}):Se.open({context:it,cli:Ne,forceNewWindow:Ne["new-window"]||!nt&&Ne["unity-launch"],diffMode:Ne.diff,noRecentEntry:Xe,waitMarkerFileURI:Qe,gotoLineMode:Ne.goto,initialStartup:!0,remoteAuthority:lt})}shouldBlockURI(fe){return!!(fe.authority===m.Schemas.file&&g.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,S.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===m.Schemas.file){const pe=I.URI.file(fe.fsPath);return(0,Ce.hasWorkspaceFileExtension)(pe)?{workspaceUri:pe}:{fileUri:pe}}else if(fe.authority===m.Schemas.vscodeRemote){const pe=fe.path.indexOf(t.posix.sep,1);if(pe!==-1){const Se=fe.path.substring(1,pe),we=fe.path.substring(pe),Me=I.URI.from({scheme:m.Schemas.vscodeRemote,authority:Se,path:we,query:fe.query,fragment:fe.fragment});return(0,Ce.hasWorkspaceFileExtension)(we)?{workspaceUri:Me}:/:[\d]+$/.test(we)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:I.URI.file(fe)};if((0,Ce.hasWorkspaceFileExtension)(fe))return{workspaceUri:I.URI.file(fe)}}catch(pe){}return{fileUri:I.URI.file(fe)}}async afterWindowOpen(fe,pe){this.lifecycleMainService.phase=3;let Se=!1;(0,d.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const we=fe.get(ye.ITelemetryService);this._register(pe.onDidError(({type:De,details:Fe})=>{let Oe;switch(De){case 1:Oe="SharedProcess: detected unresponsive window";break;case 2:Oe=`SharedProcess: crashed (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:Oe=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Oe)),we.publicLog2("sharedprocesserror",{type:De,reason:Fe?.reason,code:Fe?.exitCode,visible:pe.isVisible(),shuttingdown:Se})}));const Me=this.productService.win32MutexName;if(g.isWindows&&Me)try{const De=j.__$__nodeRequire("windows-mutex").Mutex,Fe=new De(Me);(0,d.once)(this.lifecycleMainService.onWillShutdown)(()=>Fe.release())}catch(De){this.logService.error(De)}p.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(De,Fe)=>{Fe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const Le=fe.get(Ve.IUpdateService);(Le instanceof et.Win32UpdateService||Le instanceof Ke.LinuxUpdateService||Le instanceof st.DarwinUpdateService)&&Le.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Fe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,i.stripComments)(Fe))["enable-crash-reporter"]===void 0){const Ge=(0,Ae.getTelemetryLevel)(this.configurationService)>=1,tt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ge},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],Ye=Fe.substring(0,Fe.length-2).concat(`,
`,tt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ye))}}catch(De){this.logService.error(De)}}async resolveShellEnvironment(fe,pe){try{return await(0,T.resolveShellEnv)(this.logService,fe,pe)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,P.toErrorMessage)(Se))}return{}}stopTracingEventually(fe,pe){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(H.IDialogMainService);let we=!1;const Me=async De=>{if(we)return;we=!0;const Fe=await p.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Fe}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,a.localize)(4,null),detail:(0,a.localize)(5,null,Fe),buttons:[(0,S.mnemonicButtonLabel)((0,a.localize)(6,null))],defaultId:0,noLink:!0},(0,y.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Me(!0),3e4);Promise.all(pe.map(De=>De.ready())).then(()=>{clearTimeout(Le),Me(!1)})}};dt=he([te(2,K.IInstantiationService),te(3,Q.ILogService),te(4,G.IEnvironmentMainService),te(5,J.ILifecycleMainService),te(6,k.IConfigurationService),te(7,Ee.IStateMainService),te(8,_.IFileService),te(9,se.IProductService)],dt),e.CodeApplication=dt}),define(Z[248],x([0,1,13,29,31,9,55,16,33,42,34,10,8,76,3,32,25,20,35,58,242,11,19,191,202,24,56,164,18,181,96,73,174,75,22,94,6,185,95,49,21,57,188,97,226,51,228,77,199,38,230,64,65,208]),function(j,e,p,L,D,M,P,E,h,d,i,S,v,m,t,g,b,y,I,c,o,u,n,l,s,r,a,f,w,k,R,A,F,H,ie,re,G,ee,T,V,U,B,N,_,X,W,z,K,O,q,C,$,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Q{main(){try{this.startup()}catch(oe){console.error(oe.message),p.app.exit(1)}}async startup(){(0,E.setUnexpectedErrorHandler)(Ie=>console.error(Ie));const[oe,se,ce,ge,de,Ee,Pe]=this.createServices();try{try{await this.initServices(ce,ge,de)}catch(Ie){throw this.handleStartupDataDirError(ce,Pe.nameLong,Ie),Ie}await oe.invokeFunction(async Ie=>{const ve=Ie.get(G.ILogService),ye=Ie.get(ie.ILifecycleMainService),ke=Ie.get(w.IFileService),We=await this.claimInstance(ve,ce,ye,oe,Pe,!0);return y.Promises.writeFile(ce.mainLockfile,String(process.pid)).catch(Ae=>{ve.warn(`Error writing main lockfile: ${Ae.stack}`)}),Ee.logger=new T.SpdLogLogger("main",(0,v.join)(ce.logsPath,"main.log"),!0,Ee.getLevel()),(0,d.once)(ye.onWillShutdown)(Ae=>{ke.dispose(),ge.dispose(),Ae.join(y.Promises.unlink(ce.mainLockfile).catch(()=>{}))}),oe.createInstance(o.CodeApplication,We,se).startup()})}catch(Ie){oe.invokeFunction(this.quit,Ie)}}createServices(){const oe=new H.ServiceCollection,se={_serviceBrand:void 0,...V.default};oe.set(U.IProductService,se);const ce=new r.EnvironmentMainService(this.resolveArgs(),se),ge=this.patchEnvironment(ce);oe.set(r.IEnvironmentMainService,ce);const de=new re.BufferLogService,Ee=new G.MultiplexLogService([new G.ConsoleMainLogger((0,G.getLogLevel)(ce)),de]);process.once("exit",()=>Ee.dispose()),oe.set(G.ILogService,Ee);const Pe=new k.FileService(Ee);oe.set(w.IFileService,Pe);const Ie=new R.DiskFileSystemProvider(Ee);Pe.registerProvider(S.Schemas.file,Ie),oe.set(G.ILoggerService,new ee.LoggerService(Ee,Pe));const ve=new l.ConfigurationService(ce.settingsResource,Pe);oe.set(n.IConfigurationService,ve),oe.set(ie.ILifecycleMainService,new A.SyncDescriptor(ie.LifecycleMainService));const ye=new C.StateMainService(ce,Ee,Pe);return oe.set(q.IStateMainService,ye),oe.set(W.IRequestService,new A.SyncDescriptor(z.RequestMainService)),oe.set(J.IThemeMainService,new A.SyncDescriptor(J.ThemeMainService)),oe.set(K.ISignService,new A.SyncDescriptor(O.SignService)),oe.set(_.ITunnelService,new A.SyncDescriptor(X.TunnelService)),oe.set(B.IProtocolMainService,new A.SyncDescriptor(N.ProtocolMainService)),[new F.InstantiationService(oe,!0),ge,ce,ve,ye,de,se]}patchEnvironment(oe){const se={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ce=>{const ge=process.env[ce];typeof ge=="string"&&(se[ce]=ge)}),Object.assign(process.env,se),se}initServices(oe,se,ce){return M.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(ge=>ge?y.Promises.mkdir(ge,{recursive:!0}):void 0)),se.initialize(),ce.init()])}async claimInstance(oe,se,ce,ge,de,Ee){let Pe;try{(0,m.mark)("code/willStartMainServer"),Pe=await(0,c.serve)(se.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,d.once)(ce.onWillShutdown)(()=>Pe.dispose())}catch(Ie){if(Ie.code!=="EADDRINUSE")throw this.handleStartupDataDirError(se,de.nameLong,Ie),Ie;let ve;try{ve=await(0,c.connect)(se.mainIPCHandle,"main")}catch(We){if(!Ee||t.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,de.nameShort),(0,u.localize)(1,null),de.nameLong),We;try{(0,L.unlinkSync)(se.mainIPCHandle)}catch(Ae){throw oe.warn("Could not delete obsolete instance handle",Ae),Ae}return this.claimInstance(oe,se,ce,ge,de,!1)}if(se.extensionTestsLocationURI&&!se.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(We),ve.dispose(),new Error(We)}let ye;!se.args.wait&&!se.args.status&&(ye=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,de.nameShort),(0,u.localize)(3,null),de.nameLong)},1e4));const ke=I.ProxyChannel.toService(ve.getChannel("launch"),{disableMarshalling:!0});if(se.args.status)return ge.invokeFunction(async()=>{const We=new s.DiagnosticsService($.NullTelemetryService,de),Ae=await ke.getMainProcessInfo(),Ve=await ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),xe=await We.getDiagnostics(Ae,Ve);throw console.log(xe),new E.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(ke,oe),oe.trace("Sending env to running instance..."),await ke.start(se.args,process.env),ve.dispose(),ye&&clearTimeout(ye),new E.ExpectedError("Sent env to running instance. Terminating...")}if(se.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new E.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Pe}handleStartupDataDirError(oe,se,ce){if(ce.code==="EACCES"||ce.code==="EPERM"){const ge=(0,D.coalesce)([oe.userDataPath,oe.extensionsPath,c.XDG_RUNTIME_DIR]).map(de=>(0,i.getPathLabel)(de,oe));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,P.toErrorMessage)(ce),ge.join(`
`)),se)}}showStartupWarningDialog(oe,se,ce){p.dialog.showMessageBoxSync({title:ce,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,u.localize)(6,null))],message:oe,detail:se,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(oe,se){if(t.isWindows){const ce=await oe.getMainProcessId();se.trace("Sending some foreground love to the running instance:",ce);try{(await new Promise((ge,de)=>{j(["windows-foreground-love"],ge,de)})).allowSetForegroundWindow(ce)}catch(ge){se.error(ge)}}}quit(oe,se){const ce=oe.get(G.ILogService),ge=oe.get(ie.ILifecycleMainService);let de=0;se&&(se.isExpected?se.message&&ce.trace(se.message):(de=1,se.stack?ce.error(se.stack):ce.error(`Startup error: ${se.toString()}`))),ge.kill(de)}resolveArgs(){const oe=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const se=(0,f.createWaitMarkerFile)(oe.verbose);se&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",se),oe.waitMarkerFilePath=se)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const se=this.doValidatePaths(oe._,oe.goto);oe._=se}return oe}doValidatePaths(oe,se){const ce=(0,g.cwd)(),ge=oe.map(Pe=>{let Ie=String(Pe),ve;se&&(ve=(0,h.parseLineAndColumnAware)(Ie),Ie=ve.path),Ie&&(Ie=this.preparePath(ce,Ie));const ye=(0,h.sanitizeFilePath)(Ie,ce),ke=(0,v.basename)(ye);return ke&&!(0,h.isValidBasename)(ke)?null:se&&ve?(ve.path=ye,this.toPath(ve)):ye}),de=t.isWindows||t.isMacintosh,Ee=(0,D.distinct)(ge,Pe=>Pe&&de?Pe.toLowerCase():Pe||"");return(0,D.coalesce)(Ee)}preparePath(oe,se){return t.isWindows&&(se=(0,b.rtrim)(se,'"')),se=(0,b.trim)((0,b.trim)(se," "),"	"),t.isWindows&&(se=(0,v.resolve)(oe,se),se=(0,b.rtrim)(se,".")),se}toPath(oe){const se=[oe.path];return typeof oe.line=="number"&&se.push(String(oe.line)),typeof oe.column=="number"&&se.push(String(oe.column)),se.join(":")}}new Q().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc1a6699060423b8c4d2ced736ad70195378fddf/core/vs/code/electron-main/main.js.map
