/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/network","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/files/common/watcher","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","os","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/product/common/product","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/platform/log/node/spdlogLog","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","vs/base/common/performance","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(z){for(var t=[],R=0,P=z.length;R<P;R++)t[R]=Y[z[R]];return t};define(Y[56],Q([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function R(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=R}),define(Y[45],Q([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function R(C){return(T,l,g)=>{let w=null,I=null;if(typeof g.value=="function"?(w="value",I=g.value):typeof g.get=="function"&&(w="get",I=g.get),!I)throw new Error("not supported");g[w]=C(I,l)}}t.createDecorator=R;function P(C,T,l){let g=null,w=null;if(typeof l.value=="function"?(g="value",w=l.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(g="get",w=l.get),!w)throw new Error("not supported");const I=`$memoize$${T}`;l[g]=function(...h){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,h)}),this[I]}}t.memoize=P;function S(C,T,l){return R((g,w)=>{const I=`$debounce$${w}`,h=`$debounce$result$${w}`;return function(...b){this[h]||(this[h]=l?l():void 0),clearTimeout(this[I]),T&&(this[h]=T(this[h],...b),b=[this[h]]),this[I]=setTimeout(()=>{g.apply(this,b),this[h]=l?l():void 0},C)}})}t.debounce=S;function D(C,T,l){return R((g,w)=>{const I=`$throttle$timer$${w}`,h=`$throttle$result$${w}`,b=`$throttle$lastRun$${w}`,u=`$throttle$pending$${w}`;return function(...f){if(this[h]||(this[h]=l?l():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),T&&(this[h]=T(this[h],...f)),this[u])return;const m=this[b]+C;m<=Date.now()?(this[b]=Date.now(),g.apply(this,[this[h]]),this[h]=l?l():void 0):(this[u]=!0,this[I]=setTimeout(()=>{this[u]=!1,this[b]=Date.now(),g.apply(this,[this[h]]),this[h]=l?l():void 0},m-Date.now()))}})}t.throttle=D}),define(Y[57],Q([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var R;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(R=t.ScanError||(t.ScanError={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var D;(function(e){e.DEFAULT={allowTrailingComma:!0}})(D=t.ParseOptions||(t.ParseOptions={}));function C(e,i=!1){let r=0,n=e.length,a="",d=0,v=16,L=0;function E(ie){let q=0,_=0;for(;q<ie;){const J=e.charCodeAt(r);if(J>=48&&J<=57)_=_*16+J-48;else if(J>=65&&J<=70)_=_*16+J-65+10;else if(J>=97&&J<=102)_=_*16+J-97+10;else break;r++,q++}return q<ie&&(_=-1),_}function O(ie){r=ie,a="",d=0,v=16,L=0}function N(){const ie=r;if(e.charCodeAt(r)===48)r++;else for(r++;r<e.length&&g(e.charCodeAt(r));)r++;if(r<e.length&&e.charCodeAt(r)===46)if(r++,r<e.length&&g(e.charCodeAt(r)))for(r++;r<e.length&&g(e.charCodeAt(r));)r++;else return L=3,e.substring(ie,r);let q=r;if(r<e.length&&(e.charCodeAt(r)===69||e.charCodeAt(r)===101))if(r++,(r<e.length&&e.charCodeAt(r)===43||e.charCodeAt(r)===45)&&r++,r<e.length&&g(e.charCodeAt(r))){for(r++;r<e.length&&g(e.charCodeAt(r));)r++;q=r}else L=3;return e.substring(ie,q)}function G(){let ie="",q=r;for(;;){if(r>=n){ie+=e.substring(q,r),L=2;break}const _=e.charCodeAt(r);if(_===34){ie+=e.substring(q,r),r++;break}if(_===92){if(ie+=e.substring(q,r),r++,r>=n){L=2;break}switch(e.charCodeAt(r++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:const oe=E(4);oe>=0?ie+=String.fromCharCode(oe):L=4;break;default:L=5}q=r;continue}if(_>=0&&_<=31)if(l(_)){ie+=e.substring(q,r),L=2;break}else L=6;r++}return ie}function ne(){if(a="",L=0,d=r,r>=n)return d=n,v=17;let ie=e.charCodeAt(r);if(T(ie)){do r++,a+=String.fromCharCode(ie),ie=e.charCodeAt(r);while(T(ie));return v=15}if(l(ie))return r++,a+=String.fromCharCode(ie),ie===13&&e.charCodeAt(r)===10&&(r++,a+=`
`),v=14;switch(ie){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,a=G(),v=10;case 47:const q=r-1;if(e.charCodeAt(r+1)===47){for(r+=2;r<n&&!l(e.charCodeAt(r));)r++;return a=e.substring(q,r),v=12}if(e.charCodeAt(r+1)===42){r+=2;const _=n-1;let J=!1;for(;r<_;){if(e.charCodeAt(r)===42&&e.charCodeAt(r+1)===47){r+=2,J=!0;break}r++}return J||(r++,L=1),a=e.substring(q,r),v=13}return a+=String.fromCharCode(ie),r++,v=16;case 45:if(a+=String.fromCharCode(ie),r++,r===n||!g(e.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),v=11;default:for(;r<n&&ue(ie);)r++,ie=e.charCodeAt(r);if(d!==r){switch(a=e.substring(d,r),a){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return a+=String.fromCharCode(ie),r++,v=16}}function ue(ie){if(T(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let ie;do ie=ne();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>r,scan:i?ce:ne,getToken:()=>v,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>L}}t.createScanner=C;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var w;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(w||(w={}));function I(e,i){const r=[],n=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function L(E,O,N,G){d.value=E,d.offset=O,d.length=N,d.type=G,d.colonOffset=void 0,a=d}try{c(e,{onObjectBegin:(E,O)=>{if(i<=E)throw n;a=void 0,v=i>E,r.push("")},onObjectProperty:(E,O,N)=>{if(i<O||(L(E,O,N,"property"),r[r.length-1]=E,i<=O+N))throw n},onObjectEnd:(E,O)=>{if(i<=E)throw n;a=void 0,r.pop()},onArrayBegin:(E,O)=>{if(i<=E)throw n;a=void 0,r.push(0)},onArrayEnd:(E,O)=>{if(i<=E)throw n;a=void 0,r.pop()},onLiteralValue:(E,O,N)=>{if(i<O||(L(E,O,N,s(E)),i<=O+N))throw n},onSeparator:(E,O,N)=>{if(i<=O)throw n;if(E===":"&&a&&a.type==="property")a.colonOffset=O,v=!1,a=void 0;else if(E===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(v=!0,r[r.length-1]=""),a=void 0}}})}catch(E){if(E!==n)throw E}return{path:r,previousNode:a,isAtPropertyKey:v,matches:E=>{let O=0;for(let N=0;O<E.length&&N<r.length;N++)if(E[O]===r[N]||E[O]==="*")O++;else if(E[O]!=="**")return!1;return O===E.length}}}t.getLocation=I;function h(e,i=[],r=D.DEFAULT){let n=null,a=[];const d=[];function v(E){Array.isArray(a)?a.push(E):n!==null&&(a[n]=E)}return c(e,{onObjectBegin:()=>{const E={};v(E),d.push(a),a=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const E=[];v(E),d.push(a),a=E,n=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:v,onError:(E,O,N)=>{i.push({error:E,offset:O,length:N})}},r),a[0]}t.parse=h;function b(e,i=[],r=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function d(E){return n.children.push(E),E}c(e,{onObjectBegin:E=>{n=d({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,O,N)=>{n=d({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:O,length:N,parent:n})},onObjectEnd:(E,O)=>{n.length=E+O-n.offset,n=n.parent,a(E+O)},onArrayBegin:(E,O)=>{n=d({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,O)=>{n.length=E+O-n.offset,n=n.parent,a(E+O)},onLiteralValue:(E,O,N)=>{d({type:s(E),offset:O,length:N,parent:n,value:E}),a(O+N)},onSeparator:(E,O,N)=>{n.type==="property"&&(E===":"?n.colonOffset=O:E===","&&a(O))},onError:(E,O,N)=>{i.push({error:E,offset:O,length:N})}},r);const L=n.children[0];return L&&delete L.parent,L}t.parseTree=b;function u(e,i){if(!e)return;let r=e;for(let n of i)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===n){r=d.children[1],a=!0;break}if(!a)return}else{const a=n;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}t.findNodeAtLocation=u;function f(e){if(!e.parent||!e.parent.children)return[];const i=f(e.parent);if(e.parent.type==="property"){const r=e.parent.children[0].value;i.push(r)}else if(e.parent.type==="array"){const r=e.parent.children.indexOf(e);r!==-1&&i.push(r)}return i}t.getNodePath=f;function m(e){switch(e.type){case"array":return e.children.map(m);case"object":const i=Object.create(null);for(let r of e.children){const n=r.children[1];n&&(i[r.children[0].value]=m(n))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=m;function p(e,i,r=!1){return i>=e.offset&&i<e.offset+e.length||r&&i===e.offset+e.length}t.contains=p;function y(e,i,r=!1){if(p(e,i,r)){const n=e.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=i;a++){const d=y(n[a],i,r);if(d)return d}return e}}t.findNodeAtOffset=y;function c(e,i,r=D.DEFAULT){const n=C(e,!1);function a(W){return W?()=>W(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(W){return W?te=>W(te,n.getTokenOffset(),n.getTokenLength()):()=>!0}const v=a(i.onObjectBegin),L=d(i.onObjectProperty),E=a(i.onObjectEnd),O=a(i.onArrayBegin),N=a(i.onArrayEnd),G=d(i.onLiteralValue),ne=d(i.onSeparator),ue=a(i.onComment),ce=d(i.onError),ie=r&&r.disallowComments,q=r&&r.allowTrailingComma;function _(){for(;;){const W=n.scan();switch(n.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:ie||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(W){case 12:case 13:ie?J(10):ue();break;case 16:J(1);break;case 15:case 14:break;default:return W}}}function J(W,te=[],Z=[]){if(ce(W),te.length+Z.length>0){let M=n.getToken();for(;M!==17;){if(te.indexOf(M)!==-1){_();break}else if(Z.indexOf(M)!==-1)break;M=_()}}}function oe(W){const te=n.getTokenValue();return W?G(te):L(te),_(),!0}function x(){switch(n.getToken()){case 11:let W=0;try{W=JSON.parse(n.getTokenValue()),typeof W!="number"&&(J(2),W=0)}catch(te){J(2)}G(W);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return _(),!0}function F(){return n.getToken()!==10?(J(3,[],[2,5]),!1):(oe(!1),n.getToken()===6?(ne(":"),_(),K()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function j(){v(),_();let W=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(W||J(4,[],[]),ne(","),_(),n.getToken()===2&&q)break}else W&&J(6,[],[]);F()||J(4,[],[2,5]),W=!0}return E(),n.getToken()!==2?J(7,[2],[]):_(),!0}function H(){O(),_();let W=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(W||J(4,[],[]),ne(","),_(),n.getToken()===4&&q)break}else W&&J(6,[],[]);K()||J(4,[],[4,5]),W=!0}return N(),n.getToken()!==4?J(8,[4],[]):_(),!0}function K(){switch(n.getToken()){case 3:return H();case 1:return j();case 10:return oe(!0);default:return x()}}return _(),n.getToken()===17?r.allowEmptyContent?!0:(J(4,[],[]),!1):K()?(n.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}t.visit=c;function o(e,i){let r=C(e),n=[],a,d=0,v;do switch(v=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:d!==v&&n.push(e.substring(d,v)),i!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,i)),d=r.getPosition();break}while(a!==17);return n.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function z(S){const D=[];typeof S=="number"&&D.push("code/timeOrigin",S);function C(l){D.push(l,Date.now())}function T(){const l=[];for(let g=0;g<D.length;g+=2)l.push({name:D[g],startTime:D[g+1]});return l}return{mark:C,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const C of performance.getEntriesByType("mark"))D.push({name:C.name,startTime:Math.round(S+C.startTime)});return D}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function R(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=R(P))}(),define(Y[58],Q([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var R;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(R=t.Source||(t.Source={}));var P;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(P=t.TerminateResponseCode||(t.TerminateResponseCode={}));function S(D,...C){const T=C.reduce((w,I)=>(w[I]=!0,w),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(w=>!T[w]).forEach(w=>{for(let I=0;I<l.length;I++)if(w.search(l[I])!==-1){delete D[w];break}})}t.sanitizeProcessEnvironment=S}),function(z,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var R=t();for(var P in R)(typeof exports=="object"?exports:z)[P]=R[P]}}(typeof self!="undefined"?self:this,function(){return function(z){var t={};function R(P){if(t[P])return t[P].exports;var S=t[P]={i:P,l:!1,exports:{}};return z[P].call(S.exports,S,S.exports,R),S.l=!0,S.exports}return R.m=z,R.c=t,R.d=function(P,S,D){R.o(P,S)||Object.defineProperty(P,S,{enumerable:!0,get:D})},R.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},R.t=function(P,S){if(1&S&&(P=R(P)),8&S||4&S&&typeof P=="object"&&P&&P.__esModule)return P;var D=Object.create(null);if(R.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:P}),2&S&&typeof P!="string")for(var C in P)R.d(D,C,function(T){return P[T]}.bind(null,C));return D},R.n=function(P){var S=P&&P.__esModule?function(){return P.default}:function(){return P};return R.d(S,"a",S),S},R.o=function(P,S){return Object.prototype.hasOwnProperty.call(P,S)},R.p="",R(R.s=0)}([function(z,t,R){(function(P){var S;t=z.exports=Z,S=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var k=Array.prototype.slice.call(arguments,0);k.unshift("SEMVER"),console.log.apply(console,k)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var D=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],l=t.src=[],g=0,w=g++;l[w]="0|[1-9]\\d*";var I=g++;l[I]="[0-9]+";var h=g++;l[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;l[b]="("+l[w]+")\\.("+l[w]+")\\.("+l[w]+")";var u=g++;l[u]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var f=g++;l[f]="(?:"+l[w]+"|"+l[h]+")";var m=g++;l[m]="(?:"+l[I]+"|"+l[h]+")";var p=g++;l[p]="(?:-("+l[f]+"(?:\\."+l[f]+")*))";var y=g++;l[y]="(?:-?("+l[m]+"(?:\\."+l[m]+")*))";var c=g++;l[c]="[0-9A-Za-z-]+";var o=g++;l[o]="(?:\\+("+l[c]+"(?:\\."+l[c]+")*))";var s=g++,e="v?"+l[b]+l[p]+"?"+l[o]+"?";l[s]="^"+e+"$";var i="[v=\\s]*"+l[u]+l[y]+"?"+l[o]+"?",r=g++;l[r]="^"+i+"$";var n=g++;l[n]="((?:<|>)?=?)";var a=g++;l[a]=l[I]+"|x|X|\\*";var d=g++;l[d]=l[w]+"|x|X|\\*";var v=g++;l[v]="[v=\\s]*("+l[d]+")(?:\\.("+l[d]+")(?:\\.("+l[d]+")(?:"+l[p]+")?"+l[o]+"?)?)?";var L=g++;l[L]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[y]+")?"+l[o]+"?)?)?";var E=g++;l[E]="^"+l[n]+"\\s*"+l[v]+"$";var O=g++;l[O]="^"+l[n]+"\\s*"+l[L]+"$";var N=g++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=g++;l[G]="(?:~>?)";var ne=g++;l[ne]="(\\s*)"+l[G]+"\\s+",T[ne]=new RegExp(l[ne],"g");var ue=g++;l[ue]="^"+l[G]+l[v]+"$";var ce=g++;l[ce]="^"+l[G]+l[L]+"$";var ie=g++;l[ie]="(?:\\^)";var q=g++;l[q]="(\\s*)"+l[ie]+"\\s+",T[q]=new RegExp(l[q],"g");var _=g++;l[_]="^"+l[ie]+l[v]+"$";var J=g++;l[J]="^"+l[ie]+l[L]+"$";var oe=g++;l[oe]="^"+l[n]+"\\s*("+i+")$|^$";var x=g++;l[x]="^"+l[n]+"\\s*("+e+")$|^$";var F=g++;l[F]="(\\s*)"+l[n]+"\\s*("+i+"|"+l[v]+")",T[F]=new RegExp(l[F],"g");var j=g++;l[j]="^\\s*("+l[v]+")\\s+-\\s+("+l[v]+")\\s*$";var H=g++;l[H]="^\\s*("+l[L]+")\\s+-\\s+("+l[L]+")\\s*$";var K=g++;l[K]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)S(W,l[W]),T[W]||(T[W]=new RegExp(l[W]));function te(k,U){if(k instanceof Z)return k;if(typeof k!="string"||k.length>D||!(U?T[r]:T[s]).test(k))return null;try{return new Z(k,U)}catch(B){return null}}function Z(k,U){if(k instanceof Z){if(k.loose===U)return k;k=k.version}else if(typeof k!="string")throw new TypeError("Invalid Version: "+k);if(k.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof Z))return new Z(k,U);S("SemVer",k,U),this.loose=U;var B=k.trim().match(U?T[r]:T[s]);if(!B)throw new TypeError("Invalid Version: "+k);if(this.raw=k,this.major=+B[1],this.minor=+B[2],this.patch=+B[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");B[4]?this.prerelease=B[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var he=+le;if(he>=0&&he<C)return he}return le}):this.prerelease=[],this.build=B[5]?B[5].split("."):[],this.format()}t.parse=te,t.valid=function(k,U){var B=te(k,U);return B?B.version:null},t.clean=function(k,U){var B=te(k.trim().replace(/^[=v]+/,""),U);return B?B.version:null},t.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(k){return S("SemVer.compare",this.version,this.loose,k),k instanceof Z||(k=new Z(k,this.loose)),this.compareMain(k)||this.comparePre(k)},Z.prototype.compareMain=function(k){return k instanceof Z||(k=new Z(k,this.loose)),A(this.major,k.major)||A(this.minor,k.minor)||A(this.patch,k.patch)},Z.prototype.comparePre=function(k){if(k instanceof Z||(k=new Z(k,this.loose)),this.prerelease.length&&!k.prerelease.length)return-1;if(!this.prerelease.length&&k.prerelease.length)return 1;if(!this.prerelease.length&&!k.prerelease.length)return 0;var U=0;do{var B=this.prerelease[U],le=k.prerelease[U];if(S("prerelease compare",U,B,le),B===void 0&&le===void 0)return 0;if(le===void 0)return 1;if(B===void 0)return-1;if(B!==le)return A(B,le)}while(++U)},Z.prototype.inc=function(k,U){switch(k){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",U);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",U);break;case"prepatch":this.prerelease.length=0,this.inc("patch",U),this.inc("pre",U);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",U),this.inc("pre",U);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var B=this.prerelease.length;--B>=0;)typeof this.prerelease[B]=="number"&&(this.prerelease[B]++,B=-2);B===-1&&this.prerelease.push(0)}U&&(this.prerelease[0]===U?isNaN(this.prerelease[1])&&(this.prerelease=[U,0]):this.prerelease=[U,0]);break;default:throw new Error("invalid increment argument: "+k)}return this.format(),this.raw=this.version,this},t.inc=function(k,U,B,le){typeof B=="string"&&(le=B,B=void 0);try{return new Z(k,B).inc(U,le).version}catch(he){return null}},t.diff=function(k,U){if(ee(k,U))return null;var B=te(k),le=te(U);if(B.prerelease.length||le.prerelease.length){for(var he in B)if((he==="major"||he==="minor"||he==="patch")&&B[he]!==le[he])return"pre"+he;return"prerelease"}for(var he in B)if((he==="major"||he==="minor"||he==="patch")&&B[he]!==le[he])return he},t.compareIdentifiers=A;var M=/^[0-9]+$/;function A(k,U){var B=M.test(k),le=M.test(U);return B&&le&&(k=+k,U=+U),B&&!le?-1:le&&!B?1:k<U?-1:k>U?1:0}function $(k,U,B){return new Z(k,B).compare(new Z(U,B))}function V(k,U,B){return $(k,U,B)>0}function X(k,U,B){return $(k,U,B)<0}function ee(k,U,B){return $(k,U,B)===0}function se(k,U,B){return $(k,U,B)!==0}function re(k,U,B){return $(k,U,B)>=0}function me(k,U,B){return $(k,U,B)<=0}function ve(k,U,B,le){var he;switch(U){case"===":typeof k=="object"&&(k=k.version),typeof B=="object"&&(B=B.version),he=k===B;break;case"!==":typeof k=="object"&&(k=k.version),typeof B=="object"&&(B=B.version),he=k!==B;break;case"":case"=":case"==":he=ee(k,B,le);break;case"!=":he=se(k,B,le);break;case">":he=V(k,B,le);break;case">=":he=re(k,B,le);break;case"<":he=X(k,B,le);break;case"<=":he=me(k,B,le);break;default:throw new TypeError("Invalid operator: "+U)}return he}function fe(k,U){if(k instanceof fe){if(k.loose===U)return k;k=k.value}if(!(this instanceof fe))return new fe(k,U);S("comparator",k,U),this.loose=U,this.parse(k),this.semver===be?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(k,U){return A(U,k)},t.major=function(k,U){return new Z(k,U).major},t.minor=function(k,U){return new Z(k,U).minor},t.patch=function(k,U){return new Z(k,U).patch},t.compare=$,t.compareLoose=function(k,U){return $(k,U,!0)},t.rcompare=function(k,U,B){return $(U,k,B)},t.sort=function(k,U){return k.sort(function(B,le){return t.compare(B,le,U)})},t.rsort=function(k,U){return k.sort(function(B,le){return t.rcompare(B,le,U)})},t.gt=V,t.lt=X,t.eq=ee,t.neq=se,t.gte=re,t.lte=me,t.cmp=ve,t.Comparator=fe;var be={};function ye(k,U){if(k instanceof ye)return k.loose===U?k:new ye(k.raw,U);if(k instanceof fe)return new ye(k.value,U);if(!(this instanceof ye))return new ye(k,U);if(this.loose=U,this.raw=k,this.set=k.split(/\s*\|\|\s*/).map(function(B){return this.parseRange(B.trim())},this).filter(function(B){return B.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+k);this.format()}function we(k){return!k||k.toLowerCase()==="x"||k==="*"}function Fe(k,U,B,le,he,Ce,Ee,Oe,Ie,Re,Ne,De,Te){return((U=we(B)?"":we(le)?">="+B+".0.0":we(he)?">="+B+"."+le+".0":">="+U)+" "+(Oe=we(Ie)?"":we(Re)?"<"+(+Ie+1)+".0.0":we(Ne)?"<"+Ie+"."+(+Re+1)+".0":De?"<="+Ie+"."+Re+"."+Ne+"-"+De:"<="+Oe)).trim()}function Me(k,U){for(var B=0;B<k.length;B++)if(!k[B].test(U))return!1;if(U.prerelease.length){for(B=0;B<k.length;B++)if(S(k[B].semver),k[B].semver!==be&&k[B].semver.prerelease.length>0){var le=k[B].semver;if(le.major===U.major&&le.minor===U.minor&&le.patch===U.patch)return!0}return!1}return!0}function ze(k,U,B){try{U=new ye(U,B)}catch(le){return!1}return U.test(k)}function Ue(k,U,B,le){var he,Ce,Ee,Oe,Ie;switch(k=new Z(k,le),U=new ye(U,le),B){case">":he=V,Ce=me,Ee=X,Oe=">",Ie=">=";break;case"<":he=X,Ce=re,Ee=V,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(k,U,le))return!1;for(var Re=0;Re<U.set.length;++Re){var Ne=U.set[Re],De=null,Te=null;if(Ne.forEach(function(ke){ke.semver===be&&(ke=new fe(">=0.0.0")),De=De||ke,Te=Te||ke,he(ke.semver,De.semver,le)?De=ke:Ee(ke.semver,Te.semver,le)&&(Te=ke)}),De.operator===Oe||De.operator===Ie||(!Te.operator||Te.operator===Oe)&&Ce(k,Te.semver)||Te.operator===Ie&&Ee(k,Te.semver))return!1}return!0}fe.prototype.parse=function(k){var U=this.loose?T[oe]:T[x],B=k.match(U);if(!B)throw new TypeError("Invalid comparator: "+k);this.operator=B[1],this.operator==="="&&(this.operator=""),B[2]?this.semver=new Z(B[2],this.loose):this.semver=be},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(k){return S("Comparator.test",k,this.loose),this.semver===be||(typeof k=="string"&&(k=new Z(k,this.loose)),ve(k,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(k,U){if(!(k instanceof fe))throw new TypeError("a Comparator is required");var B;if(this.operator==="")return B=new ye(k.value,U),ze(this.value,B,U);if(k.operator==="")return B=new ye(this.value,U),ze(k.semver,B,U);var le=!(this.operator!==">="&&this.operator!==">"||k.operator!==">="&&k.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||k.operator!=="<="&&k.operator!=="<"),Ce=this.semver.version===k.semver.version,Ee=!(this.operator!==">="&&this.operator!=="<="||k.operator!==">="&&k.operator!=="<="),Oe=ve(this.semver,"<",k.semver,U)&&(this.operator===">="||this.operator===">")&&(k.operator==="<="||k.operator==="<"),Ie=ve(this.semver,">",k.semver,U)&&(this.operator==="<="||this.operator==="<")&&(k.operator===">="||k.operator===">");return le||he||Ce&&Ee||Oe||Ie},t.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(k){return k.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(k){var U=this.loose;k=k.trim(),S("range",k,U);var B=U?T[H]:T[j];k=k.replace(B,Fe),S("hyphen replace",k),k=k.replace(T[F],"$1$2$3"),S("comparator trim",k,T[F]),k=(k=(k=k.replace(T[ne],"$1~")).replace(T[q],"$1^")).split(/\s+/).join(" ");var le=U?T[oe]:T[x],he=k.split(" ").map(function(Ce){return function(Ee,Oe){return S("comp",Ee),Ee=function(Ie,Re){return Ie.trim().split(/\s+/).map(function(Ne){return function(De,Te){S("caret",De,Te);var ke=Te?T[J]:T[_];return De.replace(ke,function(Ae,ge,pe,Se,Pe){var Le;return S("caret",De,Ae,ge,pe,Se,Pe),we(ge)?Le="":we(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":we(Se)?Le=ge==="0"?">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+".0 <"+(+ge+1)+".0.0":Pe?(S("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+Pe+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+Pe+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+Pe+" <"+(+ge+1)+".0.0"):(S("no pr"),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+" <"+(+ge+1)+".0.0"),S("caret return",Le),Le})}(Ne,Re)}).join(" ")}(Ee,Oe),S("caret",Ee),Ee=function(Ie,Re){return Ie.trim().split(/\s+/).map(function(Ne){return function(De,Te){var ke=Te?T[ce]:T[ue];return De.replace(ke,function(Ae,ge,pe,Se,Pe){var Le;return S("tilde",De,Ae,ge,pe,Se,Pe),we(ge)?Le="":we(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":we(Se)?Le=">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":Pe?(S("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+ge+"."+pe+"."+Se+Pe+" <"+ge+"."+(+pe+1)+".0"):Le=">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0",S("tilde return",Le),Le})}(Ne,Re)}).join(" ")}(Ee,Oe),S("tildes",Ee),Ee=function(Ie,Re){return S("replaceXRanges",Ie,Re),Ie.split(/\s+/).map(function(Ne){return function(De,Te){De=De.trim();var ke=Te?T[O]:T[E];return De.replace(ke,function(Ae,ge,pe,Se,Pe,Le){S("xRange",De,Ae,ge,pe,Se,Pe,Le);var We=we(pe),Ve=We||we(Se),je=Ve||we(Pe);return ge==="="&&je&&(ge=""),We?Ae=ge===">"||ge==="<"?"<0.0.0":"*":ge&&je?(Ve&&(Se=0),je&&(Pe=0),ge===">"?(ge=">=",Ve?(pe=+pe+1,Se=0,Pe=0):je&&(Se=+Se+1,Pe=0)):ge==="<="&&(ge="<",Ve?pe=+pe+1:Se=+Se+1),Ae=ge+pe+"."+Se+"."+Pe):Ve?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(Ae=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0"),S("xRange return",Ae),Ae})}(Ne,Re)}).join(" ")}(Ee,Oe),S("xrange",Ee),Ee=function(Ie,Re){return S("replaceStars",Ie,Re),Ie.trim().replace(T[K],"")}(Ee,Oe),S("stars",Ee),Ee}(Ce,U)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Ce){return!!Ce.match(le)})),he=he.map(function(Ce){return new fe(Ce,U)})},ye.prototype.intersects=function(k,U){if(!(k instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(B){return B.every(function(le){return k.set.some(function(he){return he.every(function(Ce){return le.intersects(Ce,U)})})})})},t.toComparators=function(k,U){return new ye(k,U).set.map(function(B){return B.map(function(le){return le.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(k){if(!k)return!1;typeof k=="string"&&(k=new Z(k,this.loose));for(var U=0;U<this.set.length;U++)if(Me(this.set[U],k))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(k,U,B){var le=null,he=null;try{var Ce=new ye(U,B)}catch(Ee){return null}return k.forEach(function(Ee){Ce.test(Ee)&&(le&&he.compare(Ee)!==-1||(he=new Z(le=Ee,B)))}),le},t.minSatisfying=function(k,U,B){var le=null,he=null;try{var Ce=new ye(U,B)}catch(Ee){return null}return k.forEach(function(Ee){Ce.test(Ee)&&(le&&he.compare(Ee)!==1||(he=new Z(le=Ee,B)))}),le},t.validRange=function(k,U){try{return new ye(k,U).range||"*"}catch(B){return null}},t.ltr=function(k,U,B){return Ue(k,U,"<",B)},t.gtr=function(k,U,B){return Ue(k,U,">",B)},t.outside=Ue,t.prerelease=function(k,U){var B=te(k,U);return B&&B.prerelease.length?B.prerelease:null},t.intersects=function(k,U,B){return k=new ye(k,B),U=new ye(U,B),k.intersects(U)},t.coerce=function(k){if(k instanceof Z)return k;if(typeof k!="string")return null;var U=k.match(T[N]);return U==null?null:te((U[1]||"0")+"."+(U[2]||"0")+"."+(U[3]||"0"))}}).call(this,R(1))},function(z,t){var R,P,S=z.exports={};function D(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function T(m){if(R===setTimeout)return setTimeout(m,0);if((R===D||!R)&&setTimeout)return R=setTimeout,setTimeout(m,0);try{return R(m,0)}catch(p){try{return R.call(null,m,0)}catch(y){return R.call(this,m,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:D}catch(m){R=D}try{P=typeof clearTimeout=="function"?clearTimeout:C}catch(m){P=C}})();var l,g=[],w=!1,I=-1;function h(){w&&l&&(w=!1,l.length?g=l.concat(g):I=-1,g.length&&b())}function b(){if(!w){var m=T(h);w=!0;for(var p=g.length;p;){for(l=g,g=[];++I<p;)l&&l[I].run();I=-1,p=g.length}l=null,w=!1,function(y){if(P===clearTimeout)return clearTimeout(y);if((P===C||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(y);try{P(y)}catch(c){try{return P.call(null,y)}catch(o){return P.call(this,y)}}}(m)}}function u(m,p){this.fun=m,this.array=p}function f(){}S.nextTick=function(m){var p=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)p[y-1]=arguments[y];g.push(new u(m,p)),g.length!==1||w||T(b)},u.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=f,S.addListener=f,S.once=f,S.off=f,S.removeListener=f,S.removeAllListeners=f,S.emit=f,S.prependListener=f,S.prependOnceListener=f,S.listeners=function(m){return[]},S.binding=function(m){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(m){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Y[38],Q([0,1,8,2]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(c){const o=c;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=S;function D(c){const o=c;return o?S(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=D;function C(c,o){return new T(c,o)}t.newWriteableStream=C;class T{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,R.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(c,o){const s=[];let e;for(;(e=c.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function g(c,o,s){const e=[];let i;for(;(i=c.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const r=i;return i=void 0,r}return c.read()}}}t.peekReadable=g;function w(c,o){return new Promise((s,e)=>{const i=[];I(c,{onData:r=>{o&&i.push(r)},onError:r=>{o?e(r):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=w;function I(c,o){c.on("error",s=>o.onError(s)),c.on("end",()=>o.onEnd()),c.on("data",s=>o.onData(s))}t.listenStream=I;function h(c,o){return new Promise((s,e)=>{const i=new P.DisposableStore,r=[],n=v=>{if(r.push(v),r.length>o)return i.dispose(),c.pause(),s({stream:c,buffer:r,ended:!1})},a=v=>e(v),d=()=>s({stream:c,buffer:r,ended:!0});i.add((0,P.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),i.add((0,P.toDisposable)(()=>c.removeListener("end",d))),c.on("end",d),i.add((0,P.toDisposable)(()=>c.removeListener("data",n))),c.on("data",n)})}t.peekStream=h;function b(c,o){const s=C(o);return s.end(c),s}t.toStream=b;function u(){const c=C(()=>{throw new Error("not supported")});return c.end(),c}t.emptyStream=u;function f(c){let o=!1;return{read:()=>o?null:(o=!0,c)}}t.toReadable=f;function m(c,o,s){const e=C(s);return I(c,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=m;function p(c,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([c,i]):c)}}}t.prefixedReadable=p;function y(c,o,s){let e=!1;const i=C(s);return I(o,{onData:r=>e?i.write(r):(e=!0,i.write(s([c,r]))),onError:r=>i.error(r),onEnd:()=>{e||(e=!0,i.write(c)),i.end()}}),i}t.prefixedStream=y}),define(Y[17],Q([0,1,38]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined";let S,D;class C{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return P?new C(Buffer.allocUnsafe(n)):new C(new Uint8Array(n))}static wrap(n){return P&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new C(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&P?new C(Buffer.from(n)):(S||(S=new TextEncoder),new C(S.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let L=0,E=n.length;L<E;L++)a+=n[L].byteLength}const d=C.alloc(a);let v=0;for(let L=0,E=n.length;L<E;L++){const O=n[L];d.set(O,v),v+=O.byteLength}return d}toString(){return P?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(n,a){return new C(this.buffer.subarray(n,a))}set(n,a){n instanceof C?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return g(this.buffer,n)}writeUInt32BE(n,a){w(this.buffer,n,a)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,a){h(this.buffer,n,a)}readUInt8(n){return b(this.buffer,n)}writeUInt8(n,a){u(this.buffer,n,a)}}t.VSBuffer=C;function T(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}t.readUInt16LE=T;function l(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255}t.writeUInt16LE=l;function g(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}t.readUInt32BE=g;function w(r,n,a){r[a+3]=n,n=n>>>8,r[a+2]=n,n=n>>>8,r[a+1]=n,n=n>>>8,r[a]=n}t.writeUInt32BE=w;function I(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}t.readUInt32LE=I;function h(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255,n=n>>>8,r[a+2]=n&255,n=n>>>8,r[a+3]=n&255}t.writeUInt32LE=h;function b(r,n){return r[n]}t.readUInt8=b;function u(r,n,a){r[a]=n}t.writeUInt8=u;function f(r){return R.consumeReadable(r,n=>C.concat(n))}t.readableToBuffer=f;function m(r){return R.toReadable(r)}t.bufferToReadable=m;function p(r){return R.consumeStream(r,n=>C.concat(n))}t.streamToBuffer=p;async function y(r){return r.ended?C.concat(r.buffer):C.concat([...r.buffer,await p(r.stream)])}t.bufferedStreamToBuffer=y;function c(r){return R.toStream(r,n=>C.concat(n))}t.bufferToStream=c;function o(r){return R.transform(r,{data:n=>typeof n=="string"?C.fromString(n):C.wrap(n)},n=>C.concat(n))}t.streamToBufferReadableStream=o;function s(r){return R.newWriteableStream(n=>C.concat(n),r)}t.newWriteableBufferStream=s;function e(r,n){return R.prefixedReadable(r,n,a=>C.concat(a))}t.prefixedBufferReadable=e;function i(r,n){return R.prefixedStream(r,n,a=>C.concat(a))}t.prefixedBufferStream=i}),define(Y[18],Q([0,1,11]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const m=Array.isArray(f)?[]:{};return Object.keys(f).forEach(p=>{f[p]&&typeof f[p]=="object"?m[p]=P(f[p]):m[p]=f[p]}),m}t.deepClone=P;function S(f){if(!f||typeof f!="object")return f;const m=[f];for(;m.length>0;){const p=m.shift();Object.freeze(p);for(const y in p)if(D.call(p,y)){const c=p[y];typeof c=="object"&&!Object.isFrozen(c)&&m.push(c)}}return f}t.deepFreeze=S;const D=Object.prototype.hasOwnProperty;function C(f,m){return T(f,m,new Set)}t.cloneAndChange=C;function T(f,m,p){if((0,R.isUndefinedOrNull)(f))return f;const y=m(f);if(typeof y!="undefined")return y;if((0,R.isArray)(f)){const c=[];for(const o of f)c.push(T(o,m,p));return c}if((0,R.isObject)(f)){if(p.has(f))throw new Error("Cannot clone recursive data-structure");p.add(f);const c={};for(let o in f)D.call(f,o)&&(c[o]=T(f[o],m,p));return p.delete(f),c}return f}function l(f,m,p=!0){return(0,R.isObject)(f)?((0,R.isObject)(m)&&Object.keys(m).forEach(y=>{y in f?p&&((0,R.isObject)(f[y])&&(0,R.isObject)(m[y])?l(f[y],m[y],p):f[y]=m[y]):f[y]=m[y]}),f):m}t.mixin=l;function g(f,m){if(f===m)return!0;if(f==null||m===null||m===void 0||typeof f!=typeof m||typeof f!="object"||Array.isArray(f)!==Array.isArray(m))return!1;let p,y;if(Array.isArray(f)){if(f.length!==m.length)return!1;for(p=0;p<f.length;p++)if(!g(f[p],m[p]))return!1}else{const c=[];for(y in f)c.push(y);c.sort();const o=[];for(y in m)o.push(y);if(o.sort(),!g(c,o))return!1;for(p=0;p<c.length;p++)if(!g(f[c[p]],m[c[p]]))return!1}return!0}t.equals=g;function w(f){const m=new Set;return JSON.stringify(f,(p,y)=>{if((0,R.isObject)(y)||Array.isArray(y)){if(m.has(y))return"[Circular]";m.add(y)}return y})}t.safeStringify=w;function I(f,m,p){const y=m(f);return typeof y=="undefined"?p:y}t.getOrDefault=I;function h(f,m){const p=Object.create(null);return!f||!m||Object.keys(m).forEach(c=>{const o=f[c],s=m[c];g(o,s)||(p[c]=s)}),p}t.distinct=h;function b(f,m){const p=m.toLowerCase(),y=Object.keys(f).find(c=>c.toLowerCase()===p);return y?f[y]:f[m]}t.getCaseInsensitive=b;function u(f,m){const p=Object.create(null);for(const y of Object.keys(f))m(y,f[y])&&(p[y]=f[y]);return p}t.filter=u}),define(Y[59],Q([0,1,9]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function P(g){const w=g;return w&&typeof w.type=="string"&&typeof w.severity=="string"}t.isRemoteConsoleLog=P;function S(g){const w=[];let I;try{const h=JSON.parse(g.arguments),b=h[h.length-1];b&&b.__$stack&&(h.pop(),I=b.__$stack),w.push(...h)}catch(h){w.push("Unable to log remote console arguments",g.arguments)}return{args:w,stack:I}}t.parse=S;function D(g){if(typeof g!="string")return D(S(g).stack);const w=g;if(w){const I=C(w),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(h&&h.length===4)return{uri:R.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}t.getFirstFrame=D;function C(g){if(!g)return g;const w=g.indexOf(`
`);return w===-1?g:g.substring(0,w)}function T(g,w){const{args:I,stack:h}=S(g),b=typeof I[0]=="string"&&I.length===1;let u=C(h);u&&(u=`(${u.trim()})`);let f=[];if(typeof I[0]=="string"?u&&b?f=[`%c[${w}] %c${I[0]} %c${u}`,l("blue"),l(""),l("grey")]:f=[`%c[${w}] %c${I[0]}`,l("blue"),l(""),...I.slice(1)]:f=[`%c[${w}]%`,l("blue"),...I],u&&!b&&f.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,f)}t.log=T;function l(g){return`color: ${g}`}}),define(Y[60],Q([0,1,17,27,9]),function(z,t,R,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function D(w){return JSON.stringify(w,l)}t.stringify=D;function C(w){let I=JSON.parse(w);return I=g(I),I}t.parse=C;var T;(function(w){w[w.Uri=1]="Uri",w[w.Regexp=2]="Regexp",w[w.ScmResource=3]="ScmResource",w[w.ScmResourceGroup=4]="ScmResourceGroup",w[w.ScmProvider=5]="ScmProvider",w[w.CommentController=6]="CommentController",w[w.CommentThread=7]="CommentThread",w[w.CommentThreadReply=8]="CommentThreadReply",w[w.CommentNode=9]="CommentNode",w[w.CommentThreadNode=10]="CommentThreadNode",w[w.TimelineActionContext=11]="TimelineActionContext",w[w.NotebookCellActionContext=12]="NotebookCellActionContext",w[w.TestItemContext=13]="TestItemContext"})(T=t.MarshalledId||(t.MarshalledId={}));function l(w,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,P.regExpFlags)(I)}:I}function g(w,I=0){if(!w||I>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return S.URI.revive(w);case 2:return new RegExp(w.source,w.flags)}if(w instanceof R.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let h=0;h<w.length;++h)w[h]=g(w[h],I+1);else for(const h in w)Object.hasOwnProperty.call(w,h)&&(w[h]=g(w[h],I+1))}return w}t.revive=g}),define(Y[61],Q([0,1,46,6,7,12,19,27,9]),function(z,t,R,P,S,D,C,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(n,a,d){if(typeof n=="string"&&(n=l.URI.file(n)),d){const L=d.getWorkspaceFolder(n);if(L){const E=d.getWorkspace().folders.length>1;let O;if((0,C.isEqual)(L.uri,n)?O="":O=(0,C.relativePath)(L.uri,n),E){const N=L.name?L.name:(0,C.basename)(L.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==P.Schemas.file&&n.scheme!==P.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,R.hasDriveLetter)(n.fsPath))return(0,S.normalize)(I(n.fsPath));let v=(0,S.normalize)(n.fsPath);return!D.isWindows&&a?.userHome&&(v=b(v,a.userHome.fsPath)),v}t.getPathLabel=g;function w(n){if(!n)return;typeof n=="string"&&(n=l.URI.file(n));const a=(0,C.basename)(n)||(n.scheme===P.Schemas.file?n.fsPath:n.path);return D.isWindows&&(0,R.isRootOrDriveLetter)(a)?I(a):a}t.getBaseLabel=w;function I(n){return(0,R.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=I;let h=Object.create(null);function b(n,a){if(D.isWindows||!n||!a)return n;let d=h.original===a?h.normalized:void 0;return d||(d=`${(0,T.rtrim)(a,S.posix.sep)}${S.posix.sep}`,h={original:a,normalized:d}),(D.isLinux?n.startsWith(d):(0,T.startsWithIgnoreCase)(n,d))&&(n=`~/${n.substr(d.length)}`),n}t.tildify=b;function u(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const f="\u2026",m="\\\\",p="~";function y(n,a=S.sep){const d=new Array(n.length);let v=!1;for(let L=0;L<n.length;L++){let E=n[L];if(E===""){d[L]=`.${a}`;continue}if(!E){d[L]=E;continue}v=!0;let O="";E.indexOf(m)===0?(O=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length)):E.indexOf(a)===0?(O=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(p)===0&&(O=E.substr(0,E.indexOf(p)+p.length),E=E.substr(E.indexOf(p)+p.length));const N=E.split(a);for(let G=1;v&&G<=N.length;G++)for(let ne=N.length-G;v&&ne>=0;ne--){v=!1;let ue=N.slice(ne,ne+G).join(a);for(let ce=0;!v&&ce<n.length;ce++)if(ce!==L&&n[ce]&&n[ce].indexOf(ue)>-1){const ie=ne+G===N.length,q=ne>0&&n[ce].indexOf(a)>-1?a+ue:ue,_=n[ce].endsWith(q);v=!ie||_}if(!v){let ce="";(N[0].endsWith(":")||O!=="")&&(ne===1&&(ne=0,G++,ue=N[0]+a+ue),ne>0&&(ce=N[0]+a),ce=O+ce),ne>0&&(ce=ce+f+a),ce=ce+ue,ne+G<N.length&&(ce=ce+a+f),d[L]=ce}}v&&(d[L]=E)}return d}t.shorten=y;var c;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function o(n,a=Object.create(null)){const d=[];let v=!1,L="";for(const E of n)if(E==="$"||v&&E==="{")L&&d.push({value:L,type:c.TEXT}),L="",v=!0;else if(E==="}"&&v){const O=a[L];if(typeof O=="string")O.length&&d.push({value:O,type:c.VARIABLE});else if(O){const N=d[d.length-1];(!N||N.type!==c.SEPARATOR)&&d.push({value:O.label,type:c.SEPARATOR})}L="",v=!1}else L+=E;return L&&!v&&d.push({value:L,type:c.TEXT}),d.filter((E,O)=>{if(E.type===c.SEPARATOR){const N=d[O-1],G=d[O+1];return[N,G].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(E=>E.value).join("")}t.template=o;function s(n,a){return D.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(n,a){return D.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):D.isWindows?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=i;function r(n){const a=n.indexOf("/")!==-1?S.posix:S.win32,d=a.basename(n),v=a.dirname(n);return d.length?{name:d,parentPath:v}:{name:v,parentPath:""}}t.splitName=r}),define(Y[62],Q([0,1,127]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class P{constructor(D="utf8"){this.stringDecoder=new R.StringDecoder(D),this.remaining=null}write(D){const C=[],T=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(T.length<1)return C;let l=0,g,w=l;for(;w<T.length;)if(g=T.charCodeAt(w),g===13||g===10){if(C.push(T.substring(l,w)),w++,w<T.length){const I=g;g=T.charCodeAt(w),(I===13&&g===10||I===10&&g===13)&&w++}l=w}else w++;return this.remaining=l<T.length?T.substr(l):null,C}end(){return this.remaining}}t.LineDecoder=P}),define(Y[63],Q([0,1,47,7,27,13]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function C(w){const I=(0,P.dirname)(w);if(w===I)return w;const h=((0,P.basename)(w)||w).toLowerCase();try{const u=(0,D.readdirSync)(I).filter(f=>f.toLowerCase()===h);if(u.length===1){const f=C(I);if(f)return(0,P.join)(f,u[0])}else if(u.length>1){const f=u.indexOf(h);if(f>=0){const m=C(I);if(m)return(0,P.join)(m,u[f])}}}catch(b){}return null}t.realcaseSync=C;async function T(w){try{return await D.Promises.realpath(w)}catch(I){const h=g(w);return await D.Promises.access(h,R.constants.R_OK),h}}t.realpath=T;function l(w){try{return R.realpathSync(w)}catch(I){const h=g(w);return R.accessSync(h,R.constants.R_OK),h}}t.realpathSync=l;function g(w){return(0,S.rtrim)((0,P.normalize)(w),P.sep)}}),define(Y[64],Q([0,1,35,7,13]),function(z,t,R,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,C=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class I{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=h({useAlternateBitness:o});if(!e)return null;const i=P.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let r=-1,n=null;for(const v of await S.Promises.readdir(i)){let L=-1;if(s){const O=v.indexOf("-");if(O<0)continue;const N=v.substring(0,O);if(!D.test(N)||v.substring(O+1)!=="preview")continue;L=parseInt(N,10)}else{if(!D.test(v))continue;L=parseInt(v,10)}if(L<=r)continue;const E=P.join(i,v,"pwsh.exe");!await S.SymlinkSupport.existsFile(E)||(n=E,r=L)}if(!n)return null;const a=e.includes("x86")?" (x86)":"",d=s?" Preview":"";return new I(n,`PowerShell${d}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await S.Promises.readdir(s))if(e.test(r)){const n=P.join(s,r,"pwsh.exe");return new I(n,i)}return null}function f(){const o=P.join(R.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function m(){const o=P.join(process.env.windir,g===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*p(){let o=await b();o&&(yield o),o=await b({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=f(),o&&(yield o),o=await b({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await b({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=m(),o&&(yield o)}async function*y(){for await(const o of p())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=y;async function c(){for await(const o of y())return o;return null}t.getFirstAvailablePowerShellInstallation=c});var de=this&&this.__decorate||function(z,t,R,P){var S=arguments.length,D=S<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,R):P,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(z,t,R,P);else for(var T=z.length-1;T>=0;T--)(C=z[T])&&(D=(S<3?C(D):S>3?C(t,R,D):C(t,R))||D);return S>3&&D&&Object.defineProperty(t,R,D),D};define(Y[36],Q([0,1,20,3,17,24,45,8,10,2,60,27,11]),function(z,t,R,P,S,D,C,T,l,g,w,I,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var b;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(b=t.RequestType||(t.RequestType={}));function u(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(f=t.ResponseType||(t.ResponseType={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(p||(p={}));class y{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}class c{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(o||(o={}));function s(x){const F=S.VSBuffer.alloc(4);return F.writeUInt32BE(x,0),F}function e(x){return x.read(4).readUInt32BE(0)}function i(x){const F=S.VSBuffer.alloc(1);return F.writeUInt8(x,0),F}const r={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},n=typeof Buffer!="undefined";function a(x,F){if(typeof F=="undefined")x.write(r.Undefined);else if(typeof F=="string"){const j=S.VSBuffer.fromString(F);x.write(r.String),x.write(s(j.byteLength)),x.write(j)}else if(n&&Buffer.isBuffer(F)){const j=S.VSBuffer.wrap(F);x.write(r.Buffer),x.write(s(j.byteLength)),x.write(j)}else if(F instanceof S.VSBuffer)x.write(r.VSBuffer),x.write(s(F.byteLength)),x.write(F);else if(Array.isArray(F)){x.write(r.Array),x.write(s(F.length));for(const j of F)a(x,j)}else{const j=S.VSBuffer.fromString(JSON.stringify(F));x.write(r.Object),x.write(s(j.byteLength)),x.write(j)}}function d(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(e(x)).toString();case o.Buffer:return x.read(e(x)).buffer;case o.VSBuffer:return x.read(e(x));case o.Array:{const j=e(x),H=[];for(let K=0;K<j;K++)H.push(d(x));return H}case o.Object:return JSON.parse(x.read(e(x)).toString())}}class v{constructor(F,j,H=null,K=1e3){this.protocol=F,this.ctx=j,this.logger=H,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger&&this.logger.logOutgoing(j,0,1,m(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(j,F.id,1,m(F.type),F.data);return}}}send(F,j=void 0){const H=new c;return a(H,F),a(H,j),this.sendBuffer(H.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onRawMessage(F){const j=new y(F),H=d(j),K=d(j),W=H[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${u(W)}: ${H[2]}.${H[3]}`,K),this.onPromise({type:W,id:H[1],channelName:H[2],name:H[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${u(W)}: ${H[2]}.${H[3]}`,K),this.onEventListen({type:W,id:H[1],channelName:H[2],name:H[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${u(W)}`),this.disposeActiveRequest({type:W,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${u(W)}`),this.disposeActiveRequest({type:W,id:H[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const H=new D.CancellationTokenSource;let K;try{K=j.call(this.ctx,F.name,F.arg,H.token)}catch(Z){K=Promise.reject(Z)}const W=F.id;K.then(Z=>{this.sendResponse({id:W,data:Z,type:201}),this.activeRequests.delete(F.id)},Z=>{Z instanceof Error?this.sendResponse({id:W,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:W,data:Z,type:203}),this.activeRequests.delete(F.id)});const te=(0,g.toDisposable)(()=>H.cancel());this.activeRequests.set(F.id,te)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const H=F.id,W=j.listen(this.ctx,F.name,F.arg)(te=>this.sendResponse({id:H,data:te,type:204}));this.activeRequests.set(F.id,W)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:H})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}t.ChannelServer=v;var L;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(L=t.RequestInitiator||(t.RequestInitiator={}));class E{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(F){const j=this;return{call(H,K,W){return j.isDisposed?Promise.reject(T.canceled()):j.requestPromise(F,H,K,W)},listen(H,K){return j.isDisposed?Promise.reject(T.canceled()):j.requestEvent(F,H,K)}}}requestPromise(F,j,H,K=D.CancellationToken.None){const W=this.lastRequestId++,Z={id:W,type:100,channelName:F,name:j,arg:H};if(K.isCancellationRequested)return Promise.reject(T.canceled());let M;return new Promise(($,V)=>{if(K.isCancellationRequested)return V(T.canceled());const X=()=>{const me=ve=>{switch(ve.type){case 201:this.handlers.delete(W),$(ve.data);break;case 202:this.handlers.delete(W);const fe=new Error(ve.data.message);fe.stack=ve.data.stack,fe.name=ve.data.name,V(fe);break;case 203:this.handlers.delete(W),V(ve.data);break}};this.handlers.set(W,me),this.sendRequest(Z)};let ee=null;this.state===p.Idle?X():(ee=(0,P.createCancelablePromise)(me=>this.whenInitialized()),ee.then(()=>{ee=null,X()}));const se=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:W,type:101}),V(T.canceled())},re=K.onCancellationRequested(se);M=(0,g.combinedDisposable)((0,g.toDisposable)(se),re),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(F,j,H){const K=this.lastRequestId++,te={id:K,type:102,channelName:F,name:j,arg:H};let Z=null;const M=new l.Emitter({onFirstListenerAdd:()=>{Z=(0,P.createCancelablePromise)($=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(M),this.sendRequest(te)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(M),this.sendRequest({id:K,type:103}))}}),A=$=>M.fire($.data);return this.handlers.set(K,A),M.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(j,F.id,0,`${u(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(j,F.id,0,u(F.type));return}}}send(F,j=void 0){const H=new c;return a(H,F),a(H,j),this.sendBuffer(H.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onBuffer(F){const j=new y(F),H=d(j),K=d(j),W=H[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,m(W)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],0,m(W),K),this.onResponse({type:H[0],id:H[1],data:K})}}onResponse(F){if(F.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(F.id);j&&j(F)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}de([C.memoize],E.prototype,"onDidInitializePromise",null),t.ChannelClient=E;class O{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:H})=>{l.Event.once(j.onMessage)(W=>{const te=new y(W),Z=d(te),M=new v(j,Z),A=new E(j);this.channels.forEach((V,X)=>M.registerChannel(X,V));const $={channelServer:M,channelClient:A,ctx:Z};this._connections.add($),this._onDidAddConnection.fire($),H(()=>{M.dispose(),A.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)})})})}get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}getChannel(F,j){const H=this;return{call(K,W,te){let Z;if((0,h.isFunction)(j)){let A=(0,R.getRandomElement)(H.connections.filter(j));Z=A?Promise.resolve(A):l.Event.toPromise(l.Event.filter(H.onDidAddConnection,j))}else Z=j.routeCall(H,K,W);const M=Z.then(A=>A.channelClient.getChannel(F));return G(M).call(K,W,te)},listen(K,W){if((0,h.isFunction)(j))return H.getMulticastEvent(F,j,K,W);const te=j.routeEvent(H,K,W).then(Z=>Z.channelClient.getChannel(F));return G(te).listen(K,W)}}}getMulticastEvent(F,j,H,K){const W=this;let te=new g.DisposableStore;const Z=new l.Emitter({onFirstListenerAdd:()=>{te=new g.DisposableStore;const M=new l.EventMultiplexer,A=new Map,$=X=>{const se=X.channelClient.getChannel(F).listen(H,K),re=M.add(se);A.set(X,re)},V=X=>{const ee=A.get(X);!ee||(ee.dispose(),A.delete(X))};W.connections.filter(j).forEach($),l.Event.filter(W.onDidAddConnection,j)($,void 0,te),W.onDidRemoveConnection(V,void 0,te),M.event(Z.fire,Z,te),te.add(M)},onLastListenerRemove:()=>{te.dispose()}});return Z.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach(H=>{H.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class N{constructor(F,j,H=null){const K=new c;a(K,j),F.send(K.buffer),this.channelClient=new E(F,H),this.channelServer=new v(F,j,H)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function G(x){return{call(F,j,H){return x.then(K=>K.call(F,j,H))},listen(F,j){const H=new l.Relay;return x.then(K=>H.input=K.listen(F,j)),H.event}}}t.getDelayedChannel=G;function ne(x){let F=!1;return{call(j,H,K){return F?x.call(j,H,K):(0,P.timeout)(0).then(()=>F=!0).then(()=>x.call(j,H,K))},listen(j,H){if(F)return x.listen(j,H);const K=new l.Relay;return(0,P.timeout)(0).then(()=>F=!0).then(()=>K.input=x.listen(j,H)),K.event}}}t.getNextTickChannel=ne;class ue{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await l.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=ue;var ce;(function(x){function F(W,te){const Z=W,M=te&&te.disableMarshalling,A=new Map;for(const $ in Z)H($)&&A.set($,l.Event.buffer(Z[$],!0));return new class{listen($,V,X){const ee=A.get(V);if(ee)return ee;if(K(V)){const se=Z[V];if(typeof se=="function")return se.call(Z,X)}throw new Error(`Event not found: ${V}`)}call($,V,X){const ee=Z[V];if(typeof ee=="function"){if(!M&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,w.revive)(X[se]);return ee.apply(Z,X)}throw new Error(`Method not found: ${V}`)}}}x.fromService=F;function j(W,te){const Z=te&&te.disableMarshalling;return new Proxy({},{get(M,A){if(typeof A=="string")return te?.properties?.has(A)?te.properties.get(A):K(A)?function($){return W.listen(A,$)}:H(A)?W.listen(A):async function(...$){let V;te&&!(0,h.isUndefinedOrNull)(te.context)?V=[te.context,...$]:V=$;const X=await W.call(A,V);return Z?X:(0,w.revive)(X)};throw new Error(`Property not found: ${String(A)}`)}})}x.toService=j;function H(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}function K(W){return/^onDynamic/.test(W)&&I.isUpperAsciiLetter(W.charCodeAt(9))}})(ce=t.ProxyChannel||(t.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let F=x.toString();if(F!=="[object Object]")return F}return x}function _(x){return Array.isArray(x)?x.map(q):q(x)}function J(x,F,j,H,K,W,te){te=_(te);const Z=ie[K],M=Z[H%Z.length];let A=[`%c[${x}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(W)?(A=A.concat(te),A.push(")")):A.push(te),console.log.apply(console,A)}t.logWithColors=J;class oe{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,H,K,W){this._totalOutgoing+=F,J(this._outgoingPrefix,this._totalOutgoing,F,j,H,K,W)}logIncoming(F,j,H,K,W){this._totalIncoming+=F,J(this._incomingPrefix,this._totalIncoming,F,j,H,K,W)}}t.IPCLogger=oe}),define(Y[65],Q([0,1,3,10,2,11]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var C;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=t.StorageHint||(t.StorageHint={}));function T(I){const h=I;return h?.changed instanceof Map||h?.deleted instanceof Set}t.isStorageItemsChangeEvent=T;var l;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(l||(l={}));class g extends S.Disposable{constructor(h,b=Object.create(null)){super();this.database=h,this.options=b,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((b,u)=>this.accept(u,b)),h.deleted?.forEach(b=>this.accept(b,void 0))}accept(h,b){if(this.state===l.Closed)return;let u=!1;(0,D.isUndefinedOrNull)(b)?u=this.cache.delete(h):this.cache.get(h)!==b&&(this.cache.set(h,b),u=!0),u&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,b){const u=this.cache.get(h);return(0,D.isUndefinedOrNull)(u)?b:u}getBoolean(h,b){const u=this.get(h);return(0,D.isUndefinedOrNull)(u)?b:u==="true"}getNumber(h,b){const u=this.get(h);return(0,D.isUndefinedOrNull)(u)?b:parseInt(u,10)}async set(h,b){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(b))return this.delete(h);const u=String(b);if(this.cache.get(h)!==u)return this.cache.set(h,u),this.pendingInserts.set(h,u),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async delete(h){if(!(this.state===l.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(h){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((b,u)=>this.items.set(u,b)),h.delete&&h.delete.forEach(b=>this.items.delete(b))}async close(){}}t.InMemoryStorageDatabase=w}),define(Y[66],Q([4,5]),function(z,t){return z.create("vs/base/common/date",t)}),define(Y[67],Q([0,1,66]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const P=60,S=P*60,D=S*24,C=D*7,T=D*30,l=D*365;function g(I,h){typeof I!="number"&&(I=I.getTime());const b=Math.round((new Date().getTime()-I)/1e3);if(b<-30)return(0,R.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(b<30)return(0,R.localize)(1,null);let u;return b<P?(u=b,h?u===1?(0,R.localize)(2,null,u):(0,R.localize)(3,null,u):u===1?(0,R.localize)(4,null,u):(0,R.localize)(5,null,u)):b<S?(u=Math.floor(b/P),h?u===1?(0,R.localize)(6,null,u):(0,R.localize)(7,null,u):u===1?(0,R.localize)(8,null,u):(0,R.localize)(9,null,u)):b<D?(u=Math.floor(b/S),h?u===1?(0,R.localize)(10,null,u):(0,R.localize)(11,null,u):u===1?(0,R.localize)(12,null,u):(0,R.localize)(13,null,u)):b<C?(u=Math.floor(b/D),h?u===1?(0,R.localize)(14,null,u):(0,R.localize)(15,null,u):u===1?(0,R.localize)(16,null,u):(0,R.localize)(17,null,u)):b<T?(u=Math.floor(b/C),h?u===1?(0,R.localize)(18,null,u):(0,R.localize)(19,null,u):u===1?(0,R.localize)(20,null,u):(0,R.localize)(21,null,u)):b<l?(u=Math.floor(b/T),h?u===1?(0,R.localize)(22,null,u):(0,R.localize)(23,null,u):u===1?(0,R.localize)(24,null,u):(0,R.localize)(25,null,u)):(u=Math.floor(b/l),h?u===1?(0,R.localize)(26,null,u):(0,R.localize)(27,null,u):u===1?(0,R.localize)(28,null,u):(0,R.localize)(29,null,u))}t.fromNow=g;function w(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=w}),define(Y[68],Q([4,5]),function(z,t){return z.create("vs/base/common/errorMessage",t)}),define(Y[28],Q([0,1,20,11,68]),function(z,t,R,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function D(g,w){return w&&(g.stack||g.stacktrace)?S.localize(0,null,T(g),C(g.stack)||C(g.stacktrace)):T(g)}function C(g){return Array.isArray(g)?g.join(`
`):g}function T(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?S.localize(1,null,g.message):g.message||S.localize(2,null)}function l(g=null,w=!1){if(!g)return S.localize(3,null);if(Array.isArray(g)){const I=R.coalesce(g),h=l(I[0],w);return I.length>1?S.localize(4,null,h,I.length):h}if(P.isString(g))return g;if(g.detail){const I=g.detail;if(I.error)return D(I.error,w);if(I.exception)return D(I.exception,w)}return g.stack?D(g,w):g.message?g.message:S.localize(5,null)}t.toErrorMessage=l}),define(Y[69],Q([4,5]),function(z,t){return z.create("vs/base/node/processes",t)}),define(Y[48],Q([0,1,39,46,6,18,7,12,29,58,11,62,13,69]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function u(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(e,i){if(T.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};i&&(r.cwd=i);const n=R.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],r);return new Promise(a=>{n.once("error",d=>{a({success:!1,error:d})}),n.once("exit",(d,v)=>{a(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?u(r.status):1})}else if(T.isLinux||T.isMacintosh)try{const r=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(n=>{R.execFile(r,[e.pid.toString()],{encoding:"utf8",shell:!0},(a,d,v)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function m(e){!e||(delete e.DEBUG,T.isMacintosh&&delete e.DYLD_LIBRARY_PATH,T.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=m;function p(e=l.env){return e.comspec||"cmd.exe"}t.getWindowsShell=p;class y{constructor(i,r,n,a){if(r!==void 0&&n!==void 0&&a!==void 0)this.cmd=i,this.args=r,this.shell=n,this.options=a;else{const d=i;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(l.env).forEach(v=>{d[v]=l.env[v]}),Object.keys(this.options.env).forEach(v=>{d[v]=this.options.env[v]}),this.options.env=d}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const r=i.lastIndexOf(C.sep);return r!==-1&&(i=i.substring(r+1)),y.WellKnowCommands[i]?i:"other"}start(i){return T.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(l.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(r=>{let n,a;const d=new Promise((v,L)=>{n=v,a=L});if(r){let v=this.cmd;this.args&&(v=v+" "+this.args.join(" ")),this.childProcess=R.exec(v,this.options,(L,E,O)=>{this.childProcess=null;const N=L;N&&N.killed?a({killed:this.terminateRequested,stdout:E.toString(),stderr:O.toString()}):this.handleExec(n,i,L,E,O)})}else{let v=null;const L=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,n,i,a);const O={terminated:this.terminateRequested};w.isNumber(E)&&(O.cmdCode=E),n(O)};if(this.shell&&T.isWindows){const E=D.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let O=!1,N=!1;const G=[];let ne=this.ensureQuotes(this.cmd);G.push(ne.value),O=ne.quoted,this.args&&this.args.forEach(ce=>{ne=this.ensureQuotes(ce),G.push(ne.value),N=N&&ne.quoted});const ue=["/s","/c"];O?N?ue.push('"'+G.join(" ")+'"'):G.length>1?ue.push('"'+G[0]+'" '+G.slice(1).join(" ")):ue.push('"'+G[0]+'"'):ue.push(G.join(" ")),v=R.spawn(p(),ue,E)}else this.cmd&&(v=R.spawn(this.cmd,this.args,this.options));v&&(this.childProcess=v,this.childProcessPromise=Promise.resolve(v),this.pidResolve&&(this.pidResolve(w.isNumber(v.pid)?v.pid:-1),this.pidResolve=void 0),v.on("error",E=>{this.childProcess=null,a({terminated:this.terminateRequested,error:E})}),v.pid&&(this.childProcess.on("close",L),this.handleSpawn(v,n,i,a,!0)))}return d})}handleClose(i,r,n,a){}ensureQuotes(i){return y.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,f(i,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!T.isWindows)return i(!1);const r=R.spawn(p(),["/s","/c"]);r.on("error",n=>i(!0)),r.on("exit",n=>i(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class c extends y{constructor(i,r,n,a){super(i,r,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,r,n,a,d){[a,d].forEach((v,L)=>{const E=new I.LineDecoder;E.write(v).forEach(G=>{r({line:G,source:L===0?0:1})});const N=E.end();N&&r({line:N,source:L===0?0:1})}),i({terminated:this.terminateRequested,error:n})}handleSpawn(i,r,n,a,d){const v=new I.LineDecoder,L=new I.LineDecoder;i.stdout.on("data",E=>{v.write(E).forEach(N=>n({line:N,source:0}))}),i.stderr.on("data",E=>{L.write(E).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=v,this.stderrLineDecoder=L}handleClose(i,r,n,a){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&n({line:d,source:0});const v=this.stderrLineDecoder?this.stderrLineDecoder.end():null;v&&n({line:v,source:1})}}t.LineProcess=c;function o(e){let i=[],r=!1;const n=function(a){if(r){i.push(a);return}(!e.send(a,v=>{if(v&&console.error(v),r=!1,i.length>0){const L=i.slice(0);i=[],L.forEach(E=>n(E))}})||T.isWindows)&&(r=!0)};return{send:n}}t.createQueuedSender=o;var s;(function(e){async function i(r,n,a){if(C.isAbsolute(r))return r;if(n===void 0&&(n=l.cwd()),C.dirname(r)!=="."||(a===void 0&&w.isString(l.env.PATH)&&(a=l.env.PATH.split(C.delimiter)),a===void 0||a.length===0))return C.join(n,r);async function v(L){if(await h.Promises.exists(L)){let E;try{E=await h.Promises.stat(L)}catch(O){O.message.startsWith("EACCES")&&(E=await h.Promises.lstat(L))}return E?!E.isDirectory():!1}return!1}for(let L of a){let E;if(C.isAbsolute(L)?E=C.join(L,r):E=C.join(n,L,r),await v(E))return E;let O=E+".com";if(await v(O)||(O=E+".exe",await v(O)))return O}return C.join(n,r)}e.findExecutable=i})(s=t.win32||(t.win32={}))}),define(Y[70],Q([0,1,35,12,64,48]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function C(b,u){return b===1?P.isWindows?I():D.getWindowsShell(u):g(b,u)}t.getSystemShell=C;function T(b,u){return b===1?P.isWindows?h(u):D.getWindowsShell(u):g(b,u)}t.getSystemShellSync=T;let l=null;function g(b,u){if(P.isLinux&&b===2||P.isMacintosh&&b===3)return"/bin/bash";if(!l){let f;if(P.isWindows)f="/bin/bash";else{if(f=u.SHELL,!f)try{f=(0,R.userInfo)().shell}catch(m){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}l=f}return l}let w=null;async function I(){return w||(w=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),w}function h(b){if(w)return w;const u=P.isWindows&&parseFloat((0,R.release)())>=10,f=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${b.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?m:D.getWindowsShell(b)}}),define(Y[40],Q([0,1,39,3,17,24,59,8,10,2,18,48,36]),function(z,t,R,P,S,D,C,T,l,g,w,I,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class b extends h.ChannelServer{constructor(m){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(y){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>S.VSBuffer.wrap(Buffer.from(p,"base64")))},m);process.once("disconnect",()=>this.dispose())}}t.Server=b;class u{constructor(m,p){this.modulePath=m,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new P.Delayer(y),this.child=null,this._client=null}getChannel(m){const p=this;return{call(y,c,o){return p.requestPromise(m,y,c,o)},listen(y,c){return p.requestEvent(m,y,c)}}}requestPromise(m,p,y,c=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(m),s=(0,P.createCancelablePromise)(r=>o.call(p,y,r)),e=c.onCancellationRequested(()=>s.cancel()),i=(0,g.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{e.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(m,p,y){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let c;const o=new l.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(m).listen(p,y)(o.fire,o),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,I.removeDangerousEnvVariables)(p.env),this.child=(0,R.fork)(this.modulePath,m,p);const y=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,C.isRemoteConsoleLog)(n)){(0,C.log)(n,`IPC Library: ${this.options.serverName}`);return}y.fire(S.VSBuffer.wrap(Buffer.from(n,"base64")))});const o=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,s=n=>this.child&&this.child.connected&&o.send(n.buffer.toString("base64")),e=y.event,i={send:s,onMessage:e};this._client=new h.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(d=>(0,g.dispose)(d)),this.activeRequests.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:a})})}return this._client}getCachedChannel(m){let p=this.channels.get(m);return p||(p=this.client.getChannel(m),this.channels.set(m,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(Y[71],Q([4,5]),function(z,t){return z.create("vs/base/node/zip",t)}),define(Y[72],Q([4,5]),function(z,t){return z.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[73],Q([4,5]),function(z,t){return z.create("vs/platform/environment/node/shellEnv",t)}),define(Y[74],Q([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],Q([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],Q([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],Q([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],Q([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],Q([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],Q([4,5]),function(z,t){return z.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],Q([4,5]),function(z,t){return z.create("vs/platform/files/common/fileService",t)}),define(Y[82],Q([4,5]),function(z,t){return z.create("vs/platform/files/common/io",t)}),define(Y[83],Q([4,5]),function(z,t){return z.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],Q([4,5]),function(z,t){return z.create("vs/platform/request/common/request",t)}),define(Y[85],Q([4,5]),function(z,t){return z.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],Q([0,1,67,45,6,7,29,19,9]),function(z,t,R,P,S,D,C,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(f,m,p){this._args=f,this.paths=m,this.productService=p}get appRoot(){return(0,D.dirname)(S.FileAccess.asFileUri("",z).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?l.URI.file((0,D.join)(f,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,D.resolve)(f):(0,D.normalize)((0,D.join)(S.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,D.resolve)(f):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,D.resolve)(f);const m=C.env.VSCODE_EXTENSIONS;if(m)return m;const p=C.env.VSCODE_PORTABLE;return p?(0,D.join)(p,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(m=>/^[^:/?#]+?:\/\//.test(m)?l.URI.parse(m):l.URI.file((0,D.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?l.URI.parse(f):l.URI.file((0,D.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([P.memoize],g.prototype,"appRoot",null),de([P.memoize],g.prototype,"userHome",null),de([P.memoize],g.prototype,"userDataPath",null),de([P.memoize],g.prototype,"appSettingsHome",null),de([P.memoize],g.prototype,"tmpDir",null),de([P.memoize],g.prototype,"userRoamingDataHome",null),de([P.memoize],g.prototype,"settingsResource",null),de([P.memoize],g.prototype,"userDataSyncHome",null),de([P.memoize],g.prototype,"userDataSyncLogResource",null),de([P.memoize],g.prototype,"sync",null),de([P.memoize],g.prototype,"machineSettingsResource",null),de([P.memoize],g.prototype,"globalStorageHome",null),de([P.memoize],g.prototype,"workspaceStorageHome",null),de([P.memoize],g.prototype,"keybindingsResource",null),de([P.memoize],g.prototype,"keyboardLayoutResource",null),de([P.memoize],g.prototype,"argvResource",null),de([P.memoize],g.prototype,"snippetsHome",null),de([P.memoize],g.prototype,"isExtensionDevelopment",null),de([P.memoize],g.prototype,"untitledWorkspacesHome",null),de([P.memoize],g.prototype,"installSourcePath",null),de([P.memoize],g.prototype,"builtinExtensionsPath",null),de([P.memoize],g.prototype,"extensionsPath",null),de([P.memoize],g.prototype,"extensionDevelopmentLocationURI",null),de([P.memoize],g.prototype,"extensionDevelopmentKind",null),de([P.memoize],g.prototype,"extensionTestsLocationURI",null),de([P.memoize],g.prototype,"debugExtensionHost",null),de([P.memoize],g.prototype,"serviceMachineIdResource",null),de([P.memoize],g.prototype,"telemetryLogResource",null),de([P.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function w(u,f){return b(u["inspect-extensions"],u["inspect-brk-extensions"],5870,f,u.debugId,u.extensionEnvironment)}t.parseExtensionHostPort=w;function I(u,f){return b(u["inspect-search"],u["inspect-brk-search"],5876,f,u.extensionEnvironment)}t.parseSearchPort=I;function h(u,f){return b(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,f,u.extensionEnvironment)}t.parsePtyHostPort=h;function b(u,f,m,p,y,c){const s=Number(f||u)||(p?null:m),e=s?Boolean(!!f):!1;let i;if(c)try{i=JSON.parse(c)}catch{}return{port:s,break:e,debugId:y,env:i}}}),function(){"use strict";function z(t,R,P,S){function D(T){const l=C(T),g=[l];return t.isAbsolute(l)||g.unshift(S),t.resolve(...g)}function C(T){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,P);const w=T["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(I,"AppData","Roaming")}break;case"darwin":g=t.join(R.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,P)}return{getUserDataPath:D}}if(typeof define=="function")define(Y[87],Q([0,128,35,6,19,29]),function(t,R,P,S,D,C){const T=D.dirname(S.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(D.joinPath(T,"package.json").fsPath);return z(R,P,l.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),R=require("path"),P=require("os");module.exports=z(R,P,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[88],Q([0,1,35,86,87]),function(z,t,R,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class D extends P.AbstractNativeEnvironmentService{constructor(T,l){super(T,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,S.getUserDataPath)(T)},l)}}t.NativeEnvironmentService=D}),define(Y[89],Q([0,1,18]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function S(D,C){const T=l=>{if(typeof l!="string")return;const g=P.exec(l);if(!g)return;const w=C[g[1]]??l;return typeof w=="string"?w:typeof w.message=="string"?w.message:l};return(0,R.cloneAndChange)(D,T)}t.localizeManifest=S}),define(Y[49],Q([0,1,80]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function D(h){return h=h.trim(),h==="*"||P.test(h)}t.isValidVersionStr=D;function C(h){if(!D(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=h.match(P);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}t.parseVersion=C;function T(h){if(!h)return null;let b=h.majorBase,u=h.majorMustEqual,f=h.minorBase,m=h.minorMustEqual,p=h.patchBase,y=h.patchMustEqual;h.hasCaret&&(b===0||(m=!1),y=!1);let c=0;if(h.preRelease){const o=S.exec(h.preRelease);if(o){const[,s,e,i]=o;c=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:b,majorMustEqual:u,minorBase:f,minorMustEqual:m,patchBase:p,patchMustEqual:y,isMinimum:h.hasGreaterEquals,notBefore:c}}t.normalizeVersion=T;function l(h,b,u){let f;typeof h=="string"?f=T(C(h)):f=h;let m;b instanceof Date?m=b.getTime():typeof b=="string"&&(m=new Date(b).getTime());let p;if(typeof u=="string"?p=T(C(u)):p=u,!f||!p)return!1;let y=f.majorBase,c=f.minorBase,o=f.patchBase,s=p.majorBase,e=p.minorBase,i=p.patchBase,r=p.notBefore,n=p.majorMustEqual,a=p.minorMustEqual,d=p.patchMustEqual;return p.isMinimum?y>s?!0:y<s?!1:c>e?!0:c<e||m&&m<r?!1:o>=i:(y===1&&s===0&&(!n||!a||!d)&&(s=1,e=0,i=0,n=!0,a=!1,d=!1),y<s?!1:y>s?!n:c<e?!1:c>e?!a:o<i?!1:o>i?!d:!(m&&m<r))}t.isValidVersion=l;function g(h,b,u,f){return u.isBuiltin||typeof u.main=="undefined"?!0:I(h,b,u.engines.vscode,f)}t.isValidExtensionVersion=g;function w(h,b,u){return h==="*"||I(b,u,h)}t.isEngineValid=w;function I(h,b,u,f=[]){let m=T(C(u));if(!m)return f.push(R.localize(0,null,u)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return f.push(R.localize(1,null,u)),!1}else if(!m.majorMustEqual)return f.push(R.localize(2,null,u)),!1;return l(h,b,m)?!0:(f.push(R.localize(3,null,h,u)),!1)}}),define(Y[50],Q([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class R{constructor(S,D=[],C=!1){this.ctor=S,this.staticArguments=D,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=R}),define(Y[90],Q([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class R{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}t.Node=R;class P{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let C of this._nodes.values())C.outgoing.size===0&&D.push(C);return D}insertEdge(D,C){const T=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(C);T.outgoing.set(this._hashFn(C),l),l.incoming.set(this._hashFn(D),T)}removeNode(D){const C=this._hashFn(D);this._nodes.delete(C);for(let T of this._nodes.values())T.outgoing.delete(C),T.incoming.delete(C)}lookupOrInsertNode(D){const C=this._hashFn(D);let T=this._nodes.get(C);return T||(T=new R(D),this._nodes.set(C,T)),T}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[C,T]of this._nodes)D.push(`${C}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,C]of this._nodes){const T=new Set([D]),l=this._findCycle(C,T);if(l)return l}}_findCycle(D,C){for(let[T,l]of D.outgoing){if(C.has(T))return[...C,T].join(" -> ");C.add(T);const g=this._findCycle(l,C);if(g)return g;C.delete(T)}}}t.Graph=P}),define(Y[51],Q([0,1,15]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,R.createDecorator)("downloadService")}),define(Y[21],Q([0,1,15]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,R.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,R.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[22],Q([0,1,6,75,15]),function(z,t,R,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var D;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(D=t.TargetPlatform||(t.TargetPlatform={}));function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=C;function T(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=T;function l(c,o){switch(c){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function g(c,o){return o==="web"&&!c.includes("web")}t.isNotWebExtensionInWebTargetPlatform=g;function w(c,o,s){return g(o,s)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===s?!0:I(s).includes(c)}t.isTargetPlatformCompatible=w;function I(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=I;function h(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}t.isIExtensionIdentifier=h;var b;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(b=t.SortBy||(t.SortBy={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var f;(function(c){c.Install="install",c.Uninstall="uninstall"})(f=t.StatisticType||(t.StatisticType={}));var m;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(m=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.Malicious="Malicious",c.Incompatible="Incompatible",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(p=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class y extends Error{constructor(o,s){super(o);this.code=s,this.name=s}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),t.ExtensionsLabel=(0,P.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,P.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(Y[91],Q([0,1,39,7,73,24,28,8,12,31,70,129,3]),function(z,t,R,P,S,D,C,T,l,g,w,I,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const b=1e4;let u;async function f(p,y,c){return y["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(c)&&!y["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(c)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=h.Promises.withAsyncBody(async(o,s)=>{const e=new D.CancellationTokenSource,i=setTimeout(()=>{e.dispose(!0),s(new Error((0,S.localize)(0,null)))},b);try{o(await m(p,e.token))}catch(r){!(0,T.isPromiseCanceledError)(r)&&!e.token.isCancellationRequested?s(new Error((0,S.localize)(1,null,(0,C.toErrorMessage)(r)))):o({})}finally{clearTimeout(i),e.dispose()}})),u)}t.resolveShellEnv=f;async function m(p,y){const c=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",c);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",o);const s=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",i);const r=await(0,w.getSystemShell)(l.OS,i);return p.trace("getUnixShellEnvironment#shell",r),new Promise((n,a)=>{if(y.isCancellationRequested)return a((0,T.canceled)());const d=(0,P.basename)(r);let v,L;/^pwsh(-preview)?$/.test(d)?(v=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,L=["-Login","-Command"]):(v=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,L=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),v);const E=(0,R.spawn)(r,[...L,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});y.onCancellationRequested(()=>(E.kill(),a((0,T.canceled)()))),E.on("error",G=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(G)),a(G)});const O=[];E.stdout.on("data",G=>O.push(G));const N=[];E.stderr.on("data",G=>N.push(G)),E.on("close",(G,ne)=>{const ue=Buffer.concat(O).toString("utf8");p.trace("getUnixShellEnvironment#raw",ue);const ce=Buffer.concat(N).toString("utf8");if(ce.trim()&&p.trace("getUnixShellEnvironment#stderr",ce),G||ne)return a(new Error((0,S.localize)(2,null,G,ne)));const ie=e.exec(ue),q=ie?ie[1]:"{}";try{const _=JSON.parse(q);c?_.ELECTRON_RUN_AS_NODE=c:delete _.ELECTRON_RUN_AS_NODE,o?_.ELECTRON_NO_ATTACH_CONSOLE=o:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",_),n(_)}catch(_){p.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(_)),a(_)}})})}}),define(Y[52],Q([0,1,17,8,82,16]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function C(w,I,h,b,u,f){let m;try{await T(w,I,h,b,u,f)}catch(p){m=p}finally{m&&u.errorTransformer&&(m=u.errorTransformer(m)),typeof m!="undefined"&&h.error(m),h.end()}}t.readFileIntoStream=C;async function T(w,I,h,b,u,f){l(f);const m=await w.open(I,{create:!1});try{l(f);let p=0,y=0,c=u&&typeof u.length=="number"?u.length:void 0,o=R.VSBuffer.alloc(Math.min(u.bufferSize,typeof c=="number"?c:u.bufferSize)),s=u&&typeof u.position=="number"?u.position:0,e=0;do y=await w.read(m,s,o.buffer,e,o.byteLength-e),s+=y,e+=y,p+=y,typeof c=="number"&&(c-=y),e===o.byteLength&&(await h.write(b(o)),o=R.VSBuffer.alloc(Math.min(u.bufferSize,typeof c=="number"?c:u.bufferSize)),e=0);while(y>0&&(typeof c!="number"||c>0)&&l(f)&&g(p,u));if(e>0){let i=e;typeof c=="number"&&(i=Math.min(e,c)),h.write(b(o.slice(0,i)))}}catch(p){throw(0,D.ensureFileSystemProviderError)(p)}finally{await w.close(m)}}function l(w){if(w.isCancellationRequested)throw(0,P.canceled)();return!0}function g(w,I){if(I?.limits){if(typeof I.limits.memory=="number"&&w>I.limits.memory)throw(0,D.createFileSystemProviderError)((0,S.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&w>I.limits.size)throw(0,D.createFileSystemProviderError)((0,S.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[32],Q([0,1,2,12,9,16]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=t.WatcherService=void 0;class C extends R.Disposable{}t.WatcherService=C;function T(w){return w.map(I=>({type:I.type,resource:S.URI.file(I.path)}))}t.toFileChanges=T;function l(w){const I=new g;for(const h of w)I.processEvent(h);return I.normalize()}t.normalizeFileChanges=l;class g{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return P.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const h=this.mapPathToChange.get(this.toKey(I));let b=!1;if(h){const u=h.type,f=I.type;h.path!==I.path&&I.type===2?b=!0:u===1&&f===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(h)):u===2&&f===1?h.type=0:u===1&&f===0||(h.type=f)}else b=!0;b&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],h=[];return Array.from(this.normalized).filter(b=>b.type!==2?(I.push(b),!1):!0).sort((b,u)=>b.path.length-u.path.length).filter(b=>h.some(u=>(0,D.isParent)(b.path,u,!P.isLinux))?!1:(h.push(b.path),!0)).concat(I)}}}),define(Y[92],Q([0,1,3,2,7,63,13,130,32]),function(z,t,R,P,S,D,C,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends P.Disposable{constructor(I,h,b,u){super();this.path=I,this.onDidFilesChange=h,this.onLogMessage=b,this.verboseLogging=u,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:h}=await C.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(h)try{b=await(0,D.realpath)(b)}catch(u){if(this.onError(u),h.dangling)return}I.isDirectory()?this._register((0,T.watchFolder)(b,(u,f)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(f))})},u=>this.onError(u))):this._register((0,T.watchFile)(b,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,l.normalizeFileChanges)(h);if(this.verboseLogging)for(const u of b)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(Y[93],Q([0,1,6,36,40,32]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C extends D.WatcherService{constructor(l,g,w){super();this.onDidFilesChange=l,this.onLogMessage=g,this.verboseLogging=w,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new S.Client(R.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=C}),define(Y[94],Q([0,1,2,6,36,40,32]),function(z,t,R,P,S,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends C.WatcherService{constructor(g,w,I){super();this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=I,this.serviceDisposables=this._register(new R.MutableDisposable),this.requests=void 0,this.restartCounter=0,this.init()}init(){const g=new R.DisposableStore;this.serviceDisposables.value=g;const w=g.add(new D.Client(P.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));g.add(w.onDidProcessExit(()=>{this.restartCounter<=T.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restart(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!")})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),g.add(this.service.onDidChangeFile(I=>this.onDidFilesChange(I))),g.add(this.service.onDidLogMessage(I=>this.onLogMessage(I)))}restart(g){this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.service?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.service?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${g}`})}dispose(){return this.service=void 0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Y[95],Q([0,1,6,36,40,32]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C extends D.WatcherService{constructor(l,g,w,I={}){super();this.onDidFilesChange=l,this.onLogMessage=g,this.verboseLogging=w,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const l=this._register(new S.Client(R.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}async watch(l){this.requests=l,await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=C,C.MAX_RESTARTS=5}),define(Y[53],Q([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class R{constructor(...S){this._entries=new Map;for(let[D,C]of S)this.set(D,C)}set(S,D){const C=this._entries.get(S);return this._entries.set(S,D),C}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=R}),define(Y[96],Q([0,1,3,8,50,90,15,53]),function(z,t,R,P,S,D,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class g extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class w{constructor(u=new T.ServiceCollection,f=!1,m){this._activeInstantiations=new Set,this._services=u,this._strict=f,this._parent=m,this._services.set(C.IInstantiationService,this)}createChild(u){return new w(u,this._strict,this)}invokeFunction(u,...f){let m=h.traceInvocation(u),p=!1;try{return u({get:(c,o)=>{if(p)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,m);if(!s&&o!==C.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...f)}finally{p=!0,m.stop()}}createInstance(u,...f){let m,p;return u instanceof S.SyncDescriptor?(m=h.traceCreation(u.ctor),p=this._createInstance(u.ctor,u.staticArguments.concat(f),m)):(m=h.traceCreation(u),p=this._createInstance(u,f,m)),m.stop(),p}_createInstance(u,f=[],m){let p=C._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),y=[];for(const o of p){let s=this._getOrCreateServiceInstance(o.id,m);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);y.push(s)}let c=p.length>0?p[0].index:f.length;if(f.length!==c){console.warn(`[createInstance] First service dependency of ${u.name} at position ${c+1} conflicts with ${f.length} static arguments`);let o=c-f.length;o>0?f=f.concat(new Array(o)):f=f.slice(0,c)}return new u(...[...f,...y])}_setServiceInstance(u,f){if(this._services.get(u)instanceof S.SyncDescriptor)this._services.set(u,f);else if(this._parent)this._parent._setServiceInstance(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let f=this._services.get(u);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):f}_getOrCreateServiceInstance(u,f){let m=this._getServiceInstanceOrDescriptor(u);return m instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,m,f.branch(u,!0)):(f.branch(u,!1),m)}_safeCreateAndCacheServiceInstance(u,f,m){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,f,m)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,f,m){const p=new D.Graph(o=>o.id.toString());let y=0;const c=[{id:u,desc:f,_trace:m}];for(;c.length;){const o=c.pop();if(p.lookupOrInsertNode(o),y++>1e3)throw new g(p);for(let s of C._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};p.insertEdge(o,i),c.push(i)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}p.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,f,m=[],p,y){if(this._services.get(u)instanceof S.SyncDescriptor)return this._createServiceInstance(f,m,p,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,f,m,p,y);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(u,f=[],m,p){if(m){const y=new R.IdleValue(()=>this._createInstance(u,f,p));return new Proxy(Object.create(null),{get(c,o){if(o in c)return c[o];let s=y.value,e=s[o];return typeof e!="function"||(e=e.bind(s),c[o]=e),e},set(c,o,s){return y.value[o]=s,!0}})}else return this._createInstance(u,f,p)}}t.InstantiationService=w;var I;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(I||(I={}));class h{constructor(u,f){this.type=u,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new h(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(u){return l?new h(0,u.name):h._None}branch(u,f){let m=new h(2,u.toString());return this._dep.push([u,f,m]),m}stop(){let u=Date.now()-this._start;h._totals+=u;let f=!1;function m(y,c){let o=[],s=new Array(y+1).join("	");for(const[e,i,r]of c._dep)if(i&&r){f=!0,o.push(`${s}CREATES -> ${e}`);let n=m(y+1,r);n&&o.push(n)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(u>2||f)&&console.log(p.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Y[54],Q([0,1,15]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,R.createDecorator)("localizationsService");function P(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const D of S.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=P}),define(Y[14],Q([0,1,28,10,2,12,15]),function(z,t,R,P,S,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,C.createDecorator)("logService"),t.ILoggerService=(0,C.createDecorator)("loggerService");function T(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class g extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class w extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=e.stack,this.log(l.Error,this.format(r))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let r=0;r<e.length;r++){let n=e[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}i+=(r>0?" ":"")+n}return i}}t.AbstractMessageLogger=w;class I extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,e,...i):console.warn(`[main ${T()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class h extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=h;class b extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,R.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=b;class u extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const r of this.logServices)r.trace(e,...i)}debug(e,...i){for(const r of this.logServices)r.debug(e,...i)}info(e,...i){for(const r of this.logServices)r.info(e,...i)}warn(e,...i){for(const r of this.logServices)r.warn(e,...i)}error(e,...i){for(const r of this.logServices)r.error(e,...i)}critical(e,...i){for(const r of this.logServices)r.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class f extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=f;class m extends S.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let r=this.loggers.get(e.toString());return r||(r=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=m;class p{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=p;function y(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=c(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=y;function c(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=c;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o});var ae=this&&this.__param||function(z,t){return function(R,P){t(R,P,z)}};define(Y[97],Q([0,1,39,3,28,10,2,6,7,13,21,14]),function(z,t,R,P,S,D,C,T,l,g,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let h=class extends C.Disposable{constructor(u,f){super();this.environmentService=u,this.logService=f,this.processesLimiter=new P.Limiter(5)}async postUninstall(u){const f=this.parseScript(u,"uninstall");return f&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),m=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${m}`)))),g.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,m=>this.logService.error("Error while removing extension storage path",m))}parseScript(u,f){const m=`vscode:${f}`;if(u.location.scheme===T.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[m]=="string"){const p=u.manifest.scripts[m].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${m} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(u,f,m,p,y){return new Promise((c,o)=>{const s=this.start(u,f,m,y);let e;const i=r=>{e&&(clearTimeout(e),e=null),r?o(r):c(void 0)};s.on("error",r=>{i((0,S.toErrorMessage)(r)||"Unknown")}),s.on("exit",(r,n)=>{i(r?`post-${f} process exited with code ${r}`:void 0)}),p&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,f,m,p){const y={silent:!0,execArgv:void 0},c=(0,R.fork)(u,[`--type=extension-post-${f}`,...m],y);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const o=D.Event.fromNodeEventEmitter(c.stdout,"data"),s=D.Event.fromNodeEventEmitter(c.stderr,"data");o(r=>this.logService.info(p.identifier.id,p.manifest.version,`post-${f}`,r)),s(r=>this.logService.error(p.identifier.id,p.manifest.version,`post-${f}`,r));const e=D.Event.any(D.Event.map(o,r=>({data:`%c${r}`,format:[""]})),D.Event.map(s,r=>({data:`%c${r}`,format:["color: red"]})));return D.Event.debounce(e,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(p.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),c}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};h=de([ae(0,w.IEnvironmentService),ae(1,I.ILogService)],h),t.ExtensionsLifecycle=h}),define(Y[98],Q([0,1,20,3,8,10,2,7,32,14]),function(z,t,R,P,S,D,C,T,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class w extends C.Disposable{constructor(h){super();this.logService=h,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}watch(h,b){return b.recursive?this.watchRecursive(h,b):this.watchNonRecursive(h)}watchRecursive(h,b){const u={path:this.toFilePath(h),excludes:b.excludes},f=(0,R.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(h=>(0,S.onUnexpectedError)(h))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(h,b){return h.watch(b)}watchNonRecursive(h){const b=this.createNonRecursiveWatcher(this.toFilePath(h),f=>this._onDidChangeFile.fire((0,l.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===g.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{b.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,C.combinedDisposable)(b,u)}onWatcherLogMessage(h){h.type==="error"&&this._onDidErrorOccur.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,T.normalize)(h.fsPath)}}t.AbstractDiskFileSystemProvider=w}),define(Y[99],Q([0,1,20,3,17,24,10,131,2,100,6,132,19,38,81,16,52,14]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let y=class xe extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new f.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new f.FileChangesEvent(s,!0)))),this.watchedResources=g.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new f.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s)||(0,f.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,f.toFileSystemProviderErrorCode)(e)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,f.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),r=s?.resolveTo,n=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,d=await e.stat(o);let v;return this.toFileStat(e,o,d,void 0,!!a,(L,E)=>(v||(v=g.TernarySearchTree.forUris(()=>!i),v.set(o,!0),r&&v.fill(!0,r)),v.get(L.resource)||v.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&n?E===1:!1))}async toFileStat(o,s,e,i,r,n){const{providerExtUri:a}=this.getExtUri(o),d={resource:s,name:a.basename(s),isFile:(e.type&f.FileType.File)!=0,isDirectory:(e.type&f.FileType.Directory)!=0,isSymbolicLink:(e.type&f.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&f.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,f.etag)({mtime:e.mtime,size:e.size})};if(d.isDirectory&&n(d,i)){try{const v=await o.readdir(s),L=await P.Promises.settled(v.map(async([E,O])=>{try{const N=a.joinPath(s,E),G=r?await o.stat(N):{type:O};return await this.toFileStat(o,N,G,v.length,r,n)}catch(N){return this.logService.trace(N),null}}));d.children=(0,R.coalesce)(L)}catch(v){this.logService.trace(v),d.children=[]}return d}return d}async resolveAll(o){return P.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new f.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new f.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,r.dirname(o));let a;if((0,f.hasReadWriteCapability)(i)&&!(s instanceof S.VSBuffer))if((0,b.isReadableStream)(s)){const d=await(0,b.peekStream)(s,3);d.ended?a=S.VSBuffer.concat(d.buffer):a=d}else a=(0,b.peekReadable)(s,d=>S.VSBuffer.concat(d),3);else a=s;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&a instanceof S.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof S.VSBuffer?(0,S.bufferToReadable)(a):a)}catch(n){throw new f.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(n).toString()),(0,f.toFileOperationResult)(n),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let r;try{r=await o.stat(s)}catch(n){return}if((r.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,r),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==f.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&e.mtime<r.mtime&&e.etag!==(0,f.etag)({mtime:e.mtime,size:r.size}))throw new f.FileOperationError((0,u.localize)(7,null),3,e);return r}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,r)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(o,s,e);i(n)}catch(n){r(n)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,S.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new D.CancellationTokenSource,r=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let n;try{return typeof e?.etag=="string"&&e.etag!==f.ETAG_DISABLED&&await r,!((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasFileReadStreamCapability)(o))||(0,f.hasReadWriteCapability)(o)&&e?.preferUnbuffered?n=this.readFileUnbuffered(o,s,e):(0,f.hasFileReadStreamCapability)(o)?n=this.readFileStreamed(o,s,i.token,e):n=this.readFileBuffered(o,s,i.token,e),{...await r,value:n}}catch(a){n&&await(0,b.consumeStream)(n);const d=(0,u.localize)(8,null,this.resourceForError(s),(0,f.ensureFileSystemProviderError)(a).toString());throw a instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(d,a.stat,e):new f.FileOperationError(d,(0,f.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const r=o.readFileStream(s,i,e);return(0,b.transform)(r,{data:n=>n instanceof S.VSBuffer?n:S.VSBuffer.wrap(n),error:n=>new f.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,f.ensureFileSystemProviderError)(n).toString()),(0,f.toFileOperationResult)(n),i)},n=>S.VSBuffer.concat(n))}readFileBuffered(o,s,e,i=Object.create(null)){const r=(0,S.newWriteableBufferStream)();return(0,m.readFileIntoStream)(o,s,r,n=>n,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new f.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,f.ensureFileSystemProviderError)(n).toString()),(0,f.toFileOperationResult)(n),i)},e),r}readFileUnbuffered(o,s,e){const i=(0,b.newWriteableStream)(r=>S.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(s);typeof e?.position=="number"&&(r=r.slice(e.position)),typeof e?.length=="number"&&(r=r.slice(0,e.length)),this.validateReadFileLimits(s,r.byteLength,e),i.end(S.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new f.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==f.ETAG_DISABLED&&s.etag===e.etag)throw new f.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const r=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,o,n,s,e,i)}catch(r){return r}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=await this.doMoveCopy(i,o,r,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(o,n==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=await this.doMoveCopy(i,o,r,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(o,n==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,r,n){if(s.toString()===i.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(o,s,e,i,r,n);if(a&&!d&&n&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),r==="copy"){if(o===e&&(0,f.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:n});else{const v=await this.resolve(s);v.isDirectory?await this.doCopyFolder(o,v,e,i):await this.doCopyFile(o,s,e,i)}return r}else return o===e?(await o.rename(s,i,{overwrite:n}),r):(await this.doMoveCopy(o,s,e,i,"copy",n),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,f.hasOpenReadWriteCloseCapability)(o)&&(0,f.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,f.hasOpenReadWriteCloseCapability)(o)&&(0,f.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,f.hasReadWriteCapability)(o)&&(0,f.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,f.hasReadWriteCapability)(o)&&(0,f.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await P.Promises.settled(s.children.map(async r=>{const n=this.getExtUri(e).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),e,n):this.doCopyFile(o,r.resource,e,n)}))}async doValidateMoveCopy(o,s,e,i,r,n){let a=!1;if(o===e){const{providerExtUri:v,isPathCaseSensitive:L}=this.getExtUri(o);if(L||(a=v.isEqual(s,i)),a&&r==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&v.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const d=await this.exists(i);if(d&&!a){if(!n)throw new f.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:v}=this.getExtUri(o);if(v.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:d,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&f.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileNotFound)throw r;e.push(i.basename(s)),s=i.dirname(s)}for(let r=e.length-1;r>=0;r--){s=i.joinPath(s,e[r]);try{await o.mkdir(s)}catch(n){if((0,f.toFileSystemProviderErrorCode)(n)!==f.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let r;try{r=await e.stat(o)}catch(a){}if(r)this.throwIfFileIsReadonly(o,r);else throw new f.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,r=!!s?.recursive;await e.delete(o,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const r of o)this.watchedResources.has(r.resource)?(e||(e=[]),e.push(r)):(i||(i=[]),i.push(r));e&&this._onDidFilesChange.fire(new f.FileChangesEvent(e,!s))}if(i){const r=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(i)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;let i=!1,r=()=>{i=!0};return e.add((0,l.toDisposable)(()=>r())),this.doWatch(o,s).then(n=>{i?(0,l.dispose)(n):r=()=>(0,l.dispose)(n)},n=>this.logService.error(n)),s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:e.watch(o,s)},this.activeWatchers.set(i,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.activeWatchers.delete(i)))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,b.isReadableStream)(i)||(0,b.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,r,i):await this.doWriteReadableBufferedQueued(o,r,i)}catch(n){throw(0,f.ensureFileSystemProviderError)(n)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,r;if((0,b.isReadableBufferedStream)(e)){if(e.buffer.length>0){const n=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}if(e.ended)return;r=e.stream}else r=e;return new Promise((n,a)=>{(0,b.listenStream)(r,{onData:async d=>{r.pause();try{await this.doWriteBuffer(o,s,d,d.byteLength,i,0)}catch(v){return a(v)}i+=d.byteLength,setTimeout(()=>r.resume())},onError:d=>a(d),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,r;for(;(r=e.read())!==null;)await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(o,s,e,i,r,n){let a=0;for(;a<i;)a+=await o.write(s,r+a,e.buffer,n+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let r;i instanceof S.VSBuffer?r=i:(0,b.isReadableStream)(i)?r=await(0,S.streamToBuffer)(i):(0,b.isReadableBufferedStream)(i)?r=await(0,S.bufferedStreamToBuffer)(i):r=(0,S.readableToBuffer)(i),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let r,n;try{r=await o.open(s,{create:!1}),n=await e.open(i,{create:!0,unlock:!1});const a=S.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,v=0,L=0;do L=await o.read(r,d,a.buffer,v,a.byteLength-v),await this.doWriteBuffer(e,n,a,L,d,v),d+=L,v+=L,v===a.byteLength&&(v=0);while(L>0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await P.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof n=="number"?e.close(n):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const r=await e.open(i,{create:!0,unlock:!1});try{const n=await o.readFile(s);await this.doWriteBuffer(e,r,S.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,f.ensureFileSystemProviderError)(n)}finally{await e.close(r)}}async doPipeBufferedToUnbuffered(o,s,e,i){const r=await(0,S.streamToBuffer)(this.readFileBuffered(o,s,D.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,r)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new f.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=de([ae(0,p.ILogService)],y),t.FileService=y}),define(Y[101],Q([0,1,16,14]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(l,g,w,I){try{const h=await new Promise((b,u)=>{z(["spdlog"],b,u)});return h.setFlushOn(P.LogLevel.Trace),h.createAsyncRotatingLogger(l,g,w,I)}catch(h){console.error(h)}return null}function D(l,g,w,I){const h=z.__$__nodeRequire("spdlog");return h.setFlushOn(P.LogLevel.Trace),h.createRotatingLogger(l,g,w,I)}t.createRotatingLogger=D;function C(l,g,w){switch(g){case P.LogLevel.Trace:l.trace(w);break;case P.LogLevel.Debug:l.debug(w);break;case P.LogLevel.Info:l.info(w);break;case P.LogLevel.Warning:l.warn(w);break;case P.LogLevel.Error:l.error(w);break;case P.LogLevel.Critical:l.critical(w);break;default:throw new Error("Invalid log level")}}class T extends P.AbstractMessageLogger{constructor(g,w,I,h){super();this.name=g,this.filepath=w,this.rotating=I,this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const g=this.rotating?6:1,w=30/g*R.ByteSize.MB;return S(this.name,this.filepath,w,g).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:h,message:b}of this.buffer)C(this._logger,h,b);this.buffer=[]}})}log(g,w){this._logger?C(this._logger,g,w):this.getLevel()<=g&&this.buffer.push({level:g,message:w})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Y[102],Q([0,1,47,133,3,17,10,46,7,12,19,38,13,83,16,52,92,93,94,95,55,98,28]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f,m,p,y,c,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,P.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,e.toErrorMessage)(r)}`)}})();class i extends s.AbstractDiskFileSystemProvider{constructor(n,a){super(n);this.options=a,this.onDidChangeCapabilities=C.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:a,symbolicLink:d}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(a,d),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(n){try{const a=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),d=[];return await Promise.all(a.map(async v=>{try{let L;v.isSymbolicLink()?L=(await this.stat((0,w.joinPath)(n,v.name))).type:L=this.toType(v),d.push([v.name,L])}catch(L){this.logService.trace(L)}})),d}catch(a){throw this.toFileSystemProviderError(a)}}toType(n,a){let d;return a?.dangling?d=u.FileType.Unknown:n.isFile()?d=u.FileType.File:n.isDirectory()?d=u.FileType.Directory:d=u.FileType.Unknown,a&&(d|=u.FileType.SymbolicLink),d}async readFile(n){try{const a=this.toFilePath(n);return await h.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(n,a,d){const v=(0,I.newWriteableStream)(L=>D.VSBuffer.concat(L.map(E=>D.VSBuffer.wrap(E))).buffer);return(0,f.readFileIntoStream)(this,n,v,L=>L.buffer,{...a,bufferSize:256*1024},d),v}async writeFile(n,a,d){let v;try{const L=this.toFilePath(n);if(!d.create||!d.overwrite){if(await h.Promises.exists(L)){if(!d.overwrite)throw(0,u.createFileSystemProviderError)((0,b.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,u.createFileSystemProviderError)((0,b.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(n,{create:!0,unlock:d.unlock}),await this.write(v,0,a,0,a.byteLength)}catch(L){throw await this.toFileSystemProviderWriteError(n,L)}finally{typeof v=="number"&&await this.close(v)}}async open(n,a){try{const d=this.toFilePath(n);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:E}=await h.SymlinkSupport.stat(d);E.mode&128||await h.Promises.chmod(d,E.mode|128)}catch(E){this.logService.trace(E)}let v;if((0,u.isFileOpenForWriteOptions)(a)){if(g.isWindows)try{await h.Promises.truncate(d,0),v="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}v||(v="w")}else v="r";const L=await h.Promises.open(d,v);return this.mapHandleToPos.set(L,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(L,n),L}catch(d){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(n,d):this.toFileSystemProviderError(d)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await h.Promises.fdatasync(n)}catch(a){this.canFlush=!1,this.logService.error(a)}return await h.Promises.close(n)}catch(a){throw this.toFileSystemProviderError(a)}}async read(n,a,d,v,L){const E=this.normalizePos(n,a);let O=null;try{const N=await h.Promises.read(n,d,v,L,E);return typeof N=="number"?O=N:O=N.bytesRead,O}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(n,E,O)}}normalizePos(n,a){return a===this.mapHandleToPos.get(n)?null:a}updatePos(n,a,d){const v=this.mapHandleToPos.get(n);typeof v=="number"&&(typeof a=="number"||(typeof d=="number"?this.mapHandleToPos.set(n,v+d):this.mapHandleToPos.delete(n)))}async write(n,a,d,v,L){return(0,S.retry)(()=>this.doWrite(n,a,d,v,L),100,3)}async doWrite(n,a,d,v,L){const E=this.normalizePos(n,a);let O=null;try{const N=await h.Promises.write(n,d,v,L,E);return typeof N=="number"?O=N:O=N.bytesWritten,O}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),N)}finally{this.updatePos(n,E,O)}}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(n,a){try{const d=this.toFilePath(n);await this.doDelete(d,a)}catch(d){throw this.toFileSystemProviderError(d)}}async doDelete(n,a){a.recursive?await h.Promises.rm(n,h.RimRafMode.MOVE):await h.Promises.unlink(n)}async rename(n,a,d){const v=this.toFilePath(n),L=this.toFilePath(a);if(v!==L)try{await this.validateTargetDeleted(n,a,"move",d.overwrite),await h.Promises.move(v,L)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(2,null,(0,l.basename)(v),(0,l.basename)((0,l.dirname)(L)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(n,a,d){const v=this.toFilePath(n),L=this.toFilePath(a);if(v!==L)try{await this.validateTargetDeleted(n,a,"copy",d.overwrite),await h.Promises.copy(v,L,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(3,null,(0,l.basename)(v),(0,l.basename)((0,l.dirname)(L)),E.toString()))),this.toFileSystemProviderError(E)}}async validateTargetDeleted(n,a,d,v){const L=this.toFilePath(n),E=this.toFilePath(a);let O=!1;if(!!(this.capabilities&1024)||(O=(0,T.isEqual)(L,E,!0)),O&&d==="copy")throw(0,u.createFileSystemProviderError)((0,b.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!O&&await h.Promises.exists(E)){if(!v)throw(0,u.createFileSystemProviderError)((0,b.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(n,a,d,v){let L,E=!1;return this.options?.watcher?.usePolling?E=!1:this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?E=this.options.legacyWatcher==="on":o.default.quality==="stable"&&(E=n===1),E?g.isLinux?L=c.FileWatcher:L=p.FileWatcher:L=y.FileWatcher,new L(O=>a(O),O=>d(O),v,this.options?.watcher)}doWatch(n,a){const d=this.options?.watcher?.usePolling;if(d===!0)for(const v of a)v.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(d))for(const v of a)d.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(n,a)}createNonRecursiveWatcher(n,a,d,v){return new m.FileWatcher(n,L=>a(L),L=>d(L),v)}toFileSystemProviderError(n){if(n instanceof u.FileSystemProviderError)return n;let a;switch(n.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(n,a)}async toFileSystemProviderWriteError(n,a){let d=this.toFileSystemProviderError(a);if(n&&d.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await h.SymlinkSupport.stat(this.toFilePath(n));v.mode&128||(d=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.logService.trace(v)}return d}}t.DiskFileSystemProvider=i}),define(Y[33],Q([0,1,15]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,R.createDecorator)("productService")}),define(Y[25],Q([0,1,56,11]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(C,T){R.ok(P.isString(C)),R.ok(P.isObject(T)),R.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,T)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}t.Registry=new S}),define(Y[103],Q([0,1,10,25]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class D{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,g){this.schemasById[S(l)]=g,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new D;P.Registry.add(t.Extensions.JSONContribution,C)}),define(Y[34],Q([0,1,20,10,11,72,103,25]),function(z,t,R,P,S,D,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var g;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=T.Registry.as(C.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const s=this.doRegisterConfigurations(c,o);w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:c,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(c,!1)),w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(s))}registerDefaultConfigurations(c){const o=[],s=[];for(const e of c)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const r={type:"object",default:this.defaultValues[i],description:D.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(b(i)),this.configurationProperties[i]=r,this.defaultLanguageConfigurationOverridesNode.properties[i]=r}else{this.defaultValues[i]=e[i];const r=this.configurationProperties[i];r&&(this.updatePropertyDefaultValue(i,r),this.updateSchema(i,r))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(c){const o=[];for(const s of c)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const s=[];return c.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(c){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of c){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(c,o=!0,s,e=3){e=S.isUndefinedOrNull(c.scope)?e:c.scope;let i=[],r=c.properties;if(r)for(let a in r){if(o&&m(a)){delete r[a];continue}const d=r[a];if(this.updatePropertyDefaultValue(a,d),t.OVERRIDE_PROPERTY_PATTERN.test(a)?d.scope=void 0:(d.scope=S.isUndefinedOrNull(d.scope)?e:d.scope,d.restricted=S.isUndefinedOrNull(d.restricted)?!!s?.restrictedConfigurations?.includes(a):d.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),i.push(a)}let n=c.allOf;if(n)for(let a of n)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const o=s=>{let e=s.properties;if(e)for(const r in e)this.updateSchema(r,e[r]);let i=s.allOf;i&&i.forEach(o)};o(c)}updateSchema(c,o){switch(t.allSettings.properties[c]=o,o.scope){case 1:t.applicationSettings.properties[c]=o;break;case 2:t.machineSettings.properties[c]=o;break;case 6:t.machineOverridableSettings.properties[c]=o;break;case 3:t.windowSettings.properties[c]=o;break;case 4:t.resourceSettings.properties[c]=o;break;case 5:t.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete t.allSettings.properties[c],o.scope){case 1:delete t.applicationSettings.properties[c];break;case 2:delete t.machineSettings.properties[c];break;case 6:delete t.machineOverridableSettings.properties[c];break;case 3:delete t.windowSettings.properties[c];break;case 4:case 5:delete t.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,s={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){let s=this.defaultValues[c];S.isUndefined(s)&&(s=o.default),S.isUndefined(s)&&(s=u(o.type)),o.default=s}}const h="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(h);function b(y){return y.substring(1,y.length-1)}t.overrideIdentifierFromKey=b;function u(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const f=new I;T.Registry.add(t.Extensions.Configuration,f);function m(y){return y.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(y)?D.localize(5,null,y):f.getConfigurationProperties()[y]!==void 0?D.localize(6,null,y):null:D.localize(4,null)}t.validateProperty=m;function p(){const y=[],c=f.getConfigurationProperties();for(const o of Object.keys(c))y.push([o,c[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}t.getScopes=p}),define(Y[26],Q([0,1,18,11,9,34,15,25]),function(z,t,R,P,S,D,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,C.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}t.isConfigurationOverrides=l;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function w(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=w;function I(i,r){const n=r?i?r.keys.filter(N=>i.keys.indexOf(N)===-1):[...r.keys]:[],a=i?r?i.keys.filter(N=>r.keys.indexOf(N)===-1):[...i.keys]:[],d=[];if(r&&i){for(const N of i.keys)if(r.keys.indexOf(N)!==-1){const G=p(i.contents,N),ne=p(r.contents,N);R.equals(G,ne)||d.push(N)}}const v=[],L=N=>{const G={};for(const ne of N)for(const ue of ne.identifiers)G[s(ue)]=ne;return G},E=r?L(r.overrides):{},O=i?L(i.overrides):{};if(Object.keys(E).length)for(const N of n){const G=E[N];G&&v.push([(0,D.overrideIdentifierFromKey)(N),G.keys])}if(Object.keys(O).length)for(const N of a){const G=O[N];G&&v.push([(0,D.overrideIdentifierFromKey)(N),G.keys])}if(Object.keys(E).length&&Object.keys(O).length)for(const N of d){const G=O[N],ne=E[N];if(G&&ne){const ue=I({contents:G.contents,keys:G.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});v.push([(0,D.overrideIdentifierFromKey)(N),[...ue.added,...ue.removed,...ue.updated]])}}return{added:n,removed:a,updated:d,overrides:v}}t.compare=I;function h(i,r){const n=[];for(const a of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const d={};for(const v in i[a])d[v]=i[a][v];n.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(d),contents:b(d,r)})}return n}t.toOverrides=h;function b(i,r){const n=Object.create(null);for(let a in i)u(n,a,i[a],r);return n}t.toValuesTree=b;function u(i,r,n,a){const d=r.split("."),v=d.pop();let L=i;for(let E=0;E<d.length;E++){let O=d[E],N=L[O];switch(typeof N){case"undefined":N=L[O]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${d.slice(0,E+1).join(".")} is ${JSON.stringify(N)}`);return}L=N}if(typeof L=="object"&&L!==null)try{L[v]=n}catch(E){a(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(L)}`)}else a(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(L)}`)}t.addToValueTree=u;function f(i,r){const n=r.split(".");m(i,n)}t.removeFromValueTree=f;function m(i,r){const n=r.shift();if(r.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const a=i[n];typeof a=="object"&&!Array.isArray(a)&&(m(a,r),Object.keys(a).length===0&&delete i[n])}}function p(i,r,n){function a(L,E){let O=L;for(const N of E){if(typeof O!="object"||O===null)return;O=O[N]}return O}const d=r.split("."),v=a(i,d);return typeof v=="undefined"?n:v}t.getConfigurationValue=p;function y(i,r,n){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in i?P.isObject(i[a])&&P.isObject(r[a])?y(i[a],r[a],n):n&&(i[a]=r[a]):i[a]=r[a])})}t.merge=y;function c(){const i=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=c;function o(){const i=Object.create(null),r=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let n in r){let a=r[n].default;u(i,n,a,d=>console.error(`Conflict in default settings: ${d}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,r,n){const a=i.inspect(r),d=i.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Y[104],Q([0,1,20,10,57,2,100,18,11,9,26,34,25]),function(z,t,R,P,S,D,C,T,l,g,w,I,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class b{constructor(e={},i=[],r=[]){this._contents=e,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,w.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const r=this.getContentsForOverrideIdentifer(i);return r?e?(0,w.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=T.deepClone(this.contents),r=T.deepClone(this.overrides),n=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const d of a.overrides){const[v]=r.filter(L=>R.equals(L.identifiers,d.identifiers));v?this.mergeContents(v.contents,d.contents):r.push(T.deepClone(d))}for(const d of a.keys)n.indexOf(d)===-1&&n.push(d)}return new b(i,n,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const n of R.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[n],d=i[n];d&&(typeof a=="object"&&typeof d=="object"?(a=T.deepClone(a),this.mergeContents(a,d)):a=d),r[n]=a}return new b(r,this.keys,this.overrides)}mergeContents(e,i){for(const r of Object.keys(i)){if(r in e&&l.isObject(e[r])&&l.isObject(i[r])){this.mergeContents(e[r],i[r]);continue}e[r]=T.deepClone(i[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,w.addToValueTree)(this.contents,e,i,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,w.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let r=0;r<i;r++)e.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=b;class u extends b{constructor(){const e=(0,w.getDefaultValues)(),i=(0,w.getConfigurationKeys)(),r=[];for(const n of Object.keys(e))I.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(e[n]),contents:(0,w.toValuesTree)(e[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,r)}}t.DefaultConfigurationModel=u;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:r,keys:n,overrides:a,restricted:d}=this.doParseRaw(e,i);this._configurationModel=new b(r,n,a),this._restrictedConfigurations=d||[]}doParseContent(e){let i={},r=null,n=[],a=[],d=[];function v(E){Array.isArray(n)?n.push(E):r!==null&&(n[r]=E)}let L={onObjectBegin:()=>{let E={};v(E),a.push(n),n=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let E=[];v(E),a.push(n),n=E,r=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:v,onError:(E,O,N)=>{d.push({error:E,offset:O,length:N})}};if(e)try{S.visit(e,L),i=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return i}doParseRaw(e,i){const r=h.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,r,!0,i);e=n.raw;const a=(0,w.toValuesTree)(e,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),d=Object.keys(e),v=(0,w.toOverrides)(e,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:a,keys:d,overrides:v,restricted:n.restricted}}filter(e,i,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[]};const a={},d=[];for(let v in e)if(I.OVERRIDE_PROPERTY_PATTERN.test(v)&&r){const L=this.filter(e[v],i,!1,n);a[v]=L.raw,d.push(...L.restricted)}else{const L=i[v],E=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&d.push(v),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&L?.restricted||(a[v]=e[v]))}return{raw:a,restricted:d}}}t.ConfigurationModelParser=f;class m extends D.Disposable{constructor(e,i,r,n){super();this.userSettingsResource=e,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=m;class p{constructor(e,i,r=new b,n=new b,a=new C.ResourceMap,d=new b,v=new C.ResourceMap,L=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=d,this._memoryConfigurationByResource=v,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(e)}updateValue(e,i,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new b,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(e):n.setValue(e,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,r){const n=this.getConsolidateConfigurationModel(i,r),a=this.getFolderConfigurationModelForResource(i.resource,r),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),E=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),N=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,G=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,ne=i.overrideIdentifier?d.override(i.overrideIdentifier).getValue(e):d.getValue(e),ue=n.getValue(e),ce=R.distinct(R.flatten(n.overrides.map(ie=>ie.identifiers))).filter(ie=>n.getOverrideValue(e,ie)!==void 0);return{defaultValue:v,userValue:L,userLocalValue:E,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:G,memoryValue:ne,value:ue,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:d.getValue(e),override:i.overrideIdentifier?d.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const r=i.filter(n=>I.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,I.overrideIdentifierFromKey)(n),d=this._defaultConfiguration.getKeysForOverrideIdentifier(a),v=e.getKeysForOverrideIdentifier(a),L=[...v.filter(E=>d.indexOf(E)===-1),...d.filter(E=>v.indexOf(E)===-1),...d.filter(E=>!T.equals(this._defaultConfiguration.override(a).getValue(E),e.override(a).getValue(E)))];return[a,L]});return this.updateDefaultConfiguration(e),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,w.compare)(this.localUserConfiguration,e),d=[...i,...r,...n];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,w.compare)(this.remoteUserConfiguration,e);let d=[...i,...r,...n];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,w.compare)(this.workspaceConfiguration,e);let d=[...i,...r,...n];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const r=this.folderConfigurations.get(e),{added:n,updated:a,removed:d,overrides:v}=(0,w.compare)(r,i);let L=[...n,...a,...d];return(L.length||!r)&&this.updateFolderConfiguration(e,i),{keys:L,overrides:v}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:n,removed:a,overrides:d}=(0,w.compare)(i,void 0);return{keys:[...r,...n,...a],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let r=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const n=i.getFolder(e);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const a=this._memoryConfigurationByResource.get(e);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(i=r.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=r}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const r=i.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:r,overrides:n,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:r,overrides:n,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((d,v)=>(d.set(g.URI.revive(v[0]),this.parseConfigurationModel(v[1])),d),new C.ResourceMap);return new p(i,r,new b,n,a,new b,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new b(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=p;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const n of s)n.keys.forEach(a=>e.add(a)),n.overrides.forEach(([a,d])=>{const v=(0,C.getOrSet)(i,a,new Set);d.forEach(L=>v.add(L))});const r=[];return i.forEach((n,a)=>r.push([a,[...n.values()]])),{keys:[...e.values()],overrides:r}}t.mergeChanges=y;class c{constructor(e,i,r,n){this.change=e,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(v=>a.add(v)),e.overrides.forEach(([,v])=>v.forEach(L=>a.add(L))),this.affectedKeys=[...a.values()];const d=new b;this.affectedKeys.forEach(v=>d.setValue(v,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let r=(0,w.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(e=e[n],!e)return!1;r=r[n]}return!0}}t.ConfigurationChangeEvent=c;class o extends c{constructor(e,i,r,n){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=r,this.sourceConfig=n}}t.AllKeysConfigurationChangeEvent=o}),define(Y[105],Q([0,1,3,10,2,19,26,104,34,25]),function(z,t,R,P,S,D,C,T,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class w extends S.Disposable{constructor(h,b){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,b)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,b){const u=typeof h=="string"?h:void 0,f=(0,C.isConfigurationOverrides)(h)?h:(0,C.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(u,f,void 0)}updateValue(h,b,u,f){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(u,b,1)}onDidDefaultConfigurationChange(h){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,h);this.trigger(u,b,6)}trigger(h,b,u){const f=new T.ConfigurationChangeEvent(h,{data:b},this.configuration);f.source=u,f.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=w}),define(Y[106],Q([0,1,6]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function P(g){return g.scheme===R.Schemas.vscodeRemote?g.authority:void 0}t.getRemoteAuthority=P;function S(g){if(!g)return;const w=g.indexOf("+");return w<0?g:g.substr(0,w)}t.getRemoteName=S;function D(g){return g.scheme!==R.Schemas.file&&g.scheme!==R.Schemas.vscodeRemote}t.isVirtualResource=D;function C(g){if(g.folders.length)return g.folders.every(w=>D(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&D(g.configuration))return g.configuration}t.getVirtualWorkspaceLocation=C;function T(g){return C(g)?.scheme}t.getVirtualWorkspaceScheme=T;function l(g){return C(g)!==void 0}t.isVirtualWorkspace=l}),define(Y[41],Q([0,1,27,15,106]),function(z,t,R,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}t.getWorkspaceSupportTypeMessage=D;function C(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=C,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(T=t.ExtensionType||(t.ExtensionType={}));class l{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,u){if(typeof b=="undefined"||b===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof b=="string"||typeof u=="string"){let f=typeof b=="string"?b:b.value,m=typeof u=="string"?u:u.value;return R.equalsIgnoreCase(f,m)}return b._lower===u._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}t.ExtensionIdentifier=l;function g(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}t.isLanguagePackExtension=g;function w(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=w;function I(h,b){if(b&&h.enableProposedApi){const u=`onResolveRemoteAuthority:${(0,S.getRemoteName)(b)}`;return h.activationEvents?.indexOf(u)!==-1}return!1}t.isResolverExtension=I,t.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],Q([0,1,27,41]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(u,f){return u.uuid&&f.uuid?u.uuid===f.uuid:u.id===f.id?!0:(0,R.compareIgnoreCase)(u.id,f.id)===0}t.areSameExtensions=S;class D{constructor(f,m){this.version=m,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof D?S(this,f)&&this.version===f.version:!1}}t.ExtensionIdentifierWithVersion=D;function C(u,f){return`${u}.${f}`}t.getExtensionId=C;function T(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function l(u,f){return T(C(u,f))}t.getGalleryExtensionId=l;function g(u,f){const m=[],p=y=>{for(const c of m)if(c.some(o=>S(f(o),f(y))))return c;return null};for(const y of u){const c=p(y);c?c.push(y):m.push([y])}return m}t.groupByExtension=g;function w(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=w;function I(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=I,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function h(u){const f=new Set;for(const m of u)m.malicious&&f.add(m.id.id);return f}t.getMaliciousExtensionsSet=h;function b(u,f){const m=[],p=f.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const y=p.shift();if(y&&m.every(c=>!S(c.identifier,{id:y}))){const c=u.filter(o=>S(o.identifier,{id:y}));c.length===1&&(m.push(c[0]),p.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}t.getExtensionDependencies=b}),define(Y[107],Q([0,1,24,8,61,6,42,9,76,22,23,41]),function(z,t,R,P,S,D,C,T,l,g,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const h=y=>(0,l.localize)(0,null,y),b=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(y,c){return c?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}const f=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function m(y){const c=f.exec(y);return c&&c[1]?[(0,w.adoptToGalleryExtensionId)(c[1]),c[2]]:[(0,w.adoptToGalleryExtensionId)(y),void 0]}t.getIdAndVersion=m;let p=class{constructor(c,o){this.extensionManagementService=c,this.extensionGalleryService=o}get location(){}async listExtensions(c,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=I.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(n=>n.manifest.categories?n.manifest.categories.map(d=>d.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(n=>{s.log(n)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((n,a)=>n.identifier.id.localeCompare(a.identifier.id));let r;for(let n of e)r!==n.identifier.id&&(r=n.identifier.id,s.log(u(n.manifest,c)))}async installExtensions(c,o,s,e,i=console){const r=[],n=[];c.length&&i.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),d=(E,O)=>{const N=a.find(G=>(0,w.areSameExtensions)(G.identifier,{id:E}));if(N){if(!O&&!e)return i.log((0,l.localize)(5,null,E,N.manifest.version,E)),!1;if(O&&N.manifest.version===O)return i.log((0,l.localize)(6,null,`${E}@${O}`)),!1}return!0},v=[],L=[];for(const E of c)if(E instanceof T.URI)v.push(E);else{const[O,N]=m(E);d(O,N)&&L.push({id:O,version:N,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const E of o){const[O,N]=m(E);d(O,N)&&L.push({id:O,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(v.length&&await Promise.all(v.map(async E=>{try{const O=await this.installVSIX(E,{isBuiltin:!1,isMachineScoped:s},e,i);O&&n.push(O)}catch(O){i.error(O.message||O.stack||O),r.push(E.toString())}})),L.length){const E=await this.getGalleryExtensions(L);await Promise.all(L.map(async O=>{const N=E.get(O.id.toLowerCase());if(N)try{const G=await this.installFromGallery(O,N,a,e,i);G&&n.push(G)}catch(G){i.error(G.message||G.stack||G),r.push(O.id)}else i.error(`${h(O.version?`${O.id}@${O.version}`:O.id)}
${b}`),r.push(O.id)}))}if(r.length)throw new Error((0,l.localize)(7,null,r.join(", ")))}async installVSIX(c,o,s,e){const i=await this.extensionManagementService.getManifest(c);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(c,o),e.log((0,l.localize)(8,null,(0,S.getBaseLabel)(c))),i}catch(n){if((0,P.isPromiseCanceledError)(n))return e.log((0,l.localize)(9,null,(0,S.getBaseLabel)(c))),null;throw n}return null}async getGalleryExtensions(c){const o=new Map,s=await this.extensionGalleryService.getExtensions(c,R.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:c,version:o,installOptions:s},e,i,r,n){const a=await this.extensionGalleryService.getManifest(e,R.CancellationToken.None);if(a&&!this.validateExtensionKind(a,n))return null;const d=i.find(v=>(0,w.areSameExtensions)(v.identifier,e.identifier));if(d){if(e.version===d.manifest.version)return n.log((0,l.localize)(10,null,o?`${c}@${o}`:c)),null;n.log((0,l.localize)(11,null,c,e.version))}try{return s.isBuiltin?n.log(o?(0,l.localize)(12,null,c,o):(0,l.localize)(13,null,c)):n.log(o?(0,l.localize)(14,null,c,o):(0,l.localize)(15,null,c)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),n.log((0,l.localize)(16,null,c,e.version)),a}catch(v){if((0,P.isPromiseCanceledError)(v))return n.log((0,l.localize)(17,null,c)),null;throw v}}validateExtensionKind(c,o){return!0}async validateVSIX(c,o,s){const e={id:(0,w.getGalleryExtensionId)(c.publisher,c.name)},r=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,w.areSameExtensions)(e,n.identifier)&&(0,C.gt)(n.manifest.version,c.version));return r&&!o?(s.log((0,l.localize)(18,null,r.identifier.id,r.manifest.version,c.version)),!1):this.validateExtensionKind(c,s)}async uninstallExtensions(c,o,s=console){const e=async r=>{if(r instanceof T.URI){const n=await this.extensionManagementService.getManifest(r);return u(n)}return r},i=[];for(const r of c){const n=await e(r),d=(await this.extensionManagementService.getInstalled()).filter(v=>(0,w.areSameExtensions)(v.identifier,{id:n}));if(!d.length)throw new Error(`${this.notInstalled(n)}
${b}`);if(d.some(v=>v.type===0)){s.log((0,l.localize)(19,null,n));return}if(!o&&d.some(v=>v.isBuiltin)){s.log((0,l.localize)(20,null,n));return}s.log((0,l.localize)(21,null,n));for(const v of d)await this.extensionManagementService.uninstall(v),i.push(v);this.location?s.log((0,l.localize)(22,null,n,this.location)):s.log((0,l.localize)(23,null,n))}}async locateExtension(c,o=console){const s=await this.extensionManagementService.getInstalled();c.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===D.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(c){return this.location?(0,l.localize)(24,null,c,this.location):(0,l.localize)(25,null,c)}};p=de([ae(0,g.IExtensionManagementService),ae(1,g.IExtensionGalleryService)],p),t.ExtensionManagementCLIService=p}),define(Y[108],Q([0,1,3,8,2,12,19,42,9,31,13,21,22,23,16,14]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends S.Disposable{constructor(c,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(c.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(c,o){await this.cleanUpPromise;const s=this.getName(c),e=(0,C.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(c,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch(n){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",c.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,i.path),r}}return e}async delete(c){await this.cleanUpPromise,await this.fileService.del(c)}async rename(c,o,s){try{await w.Promises.rename(c.fsPath,o.fsPath)}catch(e){if(D.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${c} to ${o} with 'EPERM' error. Trying again...`),this.rename(c,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const c=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(c.children){const o=[],s=[];for(const r of c.children){const n=this.parse(r.name);n&&s.push([n,r])}const e=(0,b.groupByExtension)(s,([r])=>r),i=[];for(const r of e)r.sort((n,a)=>T.rcompare(n[0].version,a[0].version)),o.push(...r.slice(1).map(n=>n[1].resource)),i.push(r[0][1]);i.sort((r,n)=>r.mtime-n.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(r=>r.resource)),await R.Promises.settled(o.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(c){this.logService.error(c)}}getName(c){return this.cache?`${new b.ExtensionIdentifierWithVersion(c.identifier,c.version).key().toLowerCase()}${c.properties.targetPlatform!=="undefined"?`-${c.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(c){const o=m.exec(c);return o&&o[1]&&o[2]?new b.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};p=de([ae(0,I.INativeEnvironmentService),ae(1,u.IFileService),ae(2,h.IExtensionGalleryService),ae(3,f.ILogService)],p),t.ExtensionsDownloader=p}),define(Y[109],Q([0,1,2,7,13,41]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class C extends R.Disposable{constructor(l,g){super();this.environmentService=l,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(g.onDidUninstallExtension(w=>this.onDidUnInstallExtension(w)))}onDidInstallExtensions(l){l.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=C}),define(Y[110],Q([0,1,10,2,19,9,21,23,16,14]),function(z,t,R,P,S,D,C,T,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let w=class extends P.Disposable{constructor(h,b,u,f){super();this.extensionsManagementService=h,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(c=>c.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(y=>this.onInstallExtension(y))),this._register(h.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(h.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const m=D.URI.file(u.extensionsPath),p=new S.ExtUri(y=>!b.hasCapability(y,1024));this._register(b.watch(m)),this._register(R.Event.filter(b.onDidChangeFilesRaw,y=>y.changes.some(c=>this.doesChangeAffects(c,m,p)))(()=>this.onDidChange()))}doesChangeAffects(h,b,u){return u.isEqual(u.dirname(h.resource),b)?u.isEqual(h.resource,u.joinPath(b,".obsolete"))?!0:!(h.type!==1&&h.type!==2||u.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const b of h)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(b=>!(0,T.areSameExtensions)(b,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,T.areSameExtensions)(b,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),b=h.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(m=>(0,T.areSameExtensions)(m,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),u=this.installedExtensions.filter(f=>this.installingExtensions.some(m=>(0,T.areSameExtensions)(m,f))?!1:h.every(m=>!(0,T.areSameExtensions)(m.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=h.map(f=>f.identifier),(b.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:u})}}};w=de([ae(1,l.IFileService),ae(2,C.INativeEnvironmentService),ae(3,g.ILogService)],w),t.ExtensionsWatcher=w}),define(Y[111],Q([0,1,134,20,3,2,6,7,13,21,22,23,54,14]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends D.Disposable{constructor(p,y,c){super();this.extensionManagementService=p,this.logService=c,this.cache=this._register(new f(y,c)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),y=["en",...Object.keys(p)];return(0,P.distinct)(y)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const y=await this.cache.getLanguagePacks();Object.keys(y).some(c=>y[c]&&y[c].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(y);return!(0,P.equals)(Object.keys(p),Object.keys(c))}};u=de([ae(0,w.IExtensionManagementService),ae(1,g.INativeEnvironmentService),ae(2,b.ILogService)],u),t.LocalizationsService=u;let f=class extends D.Disposable{constructor(p,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(y=>{Object.keys(y).forEach(c=>delete y[c]),this.createLanguagePacksFromExtensions(y,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...y){for(const c of y)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,c);Object.keys(p).forEach(c=>this.updateHash(p[c]))}createLanguagePacksFromExtension(p,y){const c=y.identifier,o=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const s of o)if(y.location.scheme===C.Schemas.file&&(0,h.isValidLocalization)(s)){let e=p[s.languageId];e||(e={hash:"",extensions:[],translations:{}},p[s.languageId]=e);let i=e.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,c))[0];i?i.version=y.manifest.version:e.extensions.push({extensionIdentifier:c,version:y.manifest.version});for(const r of s.translations)e.translations[r.id]=(0,T.join)(y.location.fsPath,r.path)}}updateHash(p){if(p){const y=(0,R.createHash)("md5");for(const c of p.extensions)y.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);p.hash=y.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch(o){return{}}}).then(c=>(y=p(c),c)).then(c=>{for(const s of Object.keys(c))c[s]||delete c[s];this.languagePacks=c,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>y,c=>this.logService.error(c))})}};f=de([ae(0,g.INativeEnvironmentService),ae(1,b.ILogService)],f)}),define(Y[43],Q([0,1,17,84,34,15,25]),function(z,t,R,P,S,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,D.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=T;function l(u){return u.res.statusCode===204}async function g(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,R.streamToBuffer)(u.stream)).toString()}t.asText=g;async function w(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const m=(await(0,R.streamToBuffer)(u.stream)).toString();try{return JSON.parse(m)}catch(p){throw p.message+=`:
`+m,p}}t.asJson=w;function I(u){b(u)}t.updateProxyConfigurationsScope=I;let h;function b(u){const f=C.Registry.as(S.Extensions.Configuration),m=h;h={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[h],remove:m?[m]:[]})}b(2)}),define(Y[112],Q([0,1,24,6,16,43]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let C=class{constructor(l,g){this.requestService=l,this.fileService=g}async download(l,g,w=R.CancellationToken.None){if(l.scheme===P.Schemas.file||l.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(l,g);return}const I={type:"GET",url:l.toString()},h=await this.requestService.request(I,w);if(h.res.statusCode===200)await this.fileService.writeFile(g,h.stream);else{const b=await(0,D.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${b}`)}}};C=de([ae(0,D.IRequestService),ae(1,S.IFileService)],C),t.DownloadService=C}),define(Y[113],Q([0,1,114,11]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(C,T){return C.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:C.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function D(C,T,l={}){const g=(0,R.parse)(C),w=l.proxyUrl||S(g,T);if(!w)return null;const I=(0,R.parse)(w);if(!/^https?:$/.test(I.protocol||""))return null;const h={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,P.isBoolean)(l.strictSSL)?l.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((b,u)=>{z(["http-proxy-agent"],b,u)}))(h):new(await new Promise((b,u)=>{z(["https-proxy-agent"],b,u)}))(h)}t.getProxyAgent=D}),define(Y[115],Q([0,1,17,31]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(D,C,T){let l=T&&T.get("storage.serviceMachineId",0)||null;if(l)return l;try{const w=(await C.readFile(D.serviceMachineIdResource)).value.toString();l=(0,P.isUUID)(w)?w:null}catch(g){l=null}if(!l){l=(0,P.generateUuid)();try{await C.writeFile(D.serviceMachineIdResource,R.VSBuffer.fromString(l))}catch(g){}}return T&&T.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=S}),define(Y[116],Q([0,1,3,10,2,11,65,15]),function(z,t,R,P,S,D,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,T.createDecorator)("storageService");var g;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var w;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(w=t.StorageScope||(t.StorageScope={}));var I;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(I=t.StorageTarget||(t.StorageTarget={}));class h extends S.Disposable{constructor(m={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,p){p===l?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:p,target:this.getKeyTargets(m)[p]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,p,y){return this.getStorage(p)?.get(m,y)}getBoolean(m,p,y){return this.getStorage(p)?.getBoolean(m,y)}getNumber(m,p,y){return this.getStorage(p)?.getNumber(m,y)}store(m,p,y,c){if((0,D.isUndefinedOrNull)(p)){this.remove(m,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,y,c),this.getStorage(y)?.set(m,p)})}remove(m,p){this.withPausedEmitters(()=>{this.updateKeyTarget(m,p,void 0),this.getStorage(p)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,p){const y=[],c=this.getKeyTargets(m);for(const o of Object.keys(c))c[o]===p&&y.push(o);return y}updateKeyTarget(m,p,y){const c=this.getKeyTargets(p);typeof y=="number"?c[m]!==y&&(c[m]=y,this.getStorage(p)?.set(l,JSON.stringify(c))):typeof c[m]=="number"&&(delete c[m],this.getStorage(p)?.set(l,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const p=this.get(l,m);if(p)try{return JSON.parse(p)}catch(y){}return Object.create(null)}isNew(m){return this.getBoolean(t.IS_NEW_KEY,m)===!0}async flush(m=g.NONE){this._onWillSaveState.fire({reason:m}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const m=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return u(m,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends h{constructor(){super();this.globalStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}t.InMemoryStorageService=b;async function u(f,m,p,y){const c=a=>{try{return JSON.parse(a)}catch(d){return a}},o=new Map,s=new Map;f.forEach((a,d)=>{o.set(d,a),s.set(d,c(a))});const e=new Map,i=new Map;m.forEach((a,d)=>{e.set(d,a),i.set(d,c(a))}),console.group(`Storage: Global (path: ${p})`);let r=[];o.forEach((a,d)=>{r.push({key:d,value:a})}),console.table(r),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${y})`);let n=[];e.forEach((a,d)=>{n.push({key:d,value:a})}),console.table(n),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Y[117],Q([0,1,12,29,9,31]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function C(g){if(R.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function T(g,w,I,h,b,u,f,m,p,y){const c=Object.create(null);c["common.machineId"]=f,c.sessionID=(0,D.generateUuid)()+Date.now(),c.commitHash=b,c.version=u,c["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,R.PlatformToString)(R.platform),c["common.nodePlatform"]=P.platform,c["common.nodeArch"]=h,c["common.product"]=y||"desktop";const o=l(m||[]);o&&(c["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),R.isLinuxSnap&&(c["common.snap"]="true");const i=C(I);i&&(c["common.platformDetail"]=i);try{const r=await g.readFile(S.URI.file(p));c["common.source"]=r.value.toString().slice(0,30)}catch(r){}return c}t.resolveCommonProperties=T;function l(g){const w=P.env.USERDNSDOMAIN;if(!w)return!1;const I=w.toLowerCase();return g.some(h=>I===h)}t.verifyMicrosoftInternalDomain=l}),define(Y[30],Q([0,1,15]),function(z,t,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,R.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(P=t.TelemetryLevel||(t.TelemetryLevel={}));var S;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(S=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Y[118],Q([0,1,20,3,24,8,10,2,12,9,74,22,23,14,33,30]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let m=class extends T.Disposable{constructor(s,e,i,r){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,I.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new I.ExtensionManagementError(w.localize(0,null),I.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(s)){const r=await this.getTargetPlatform(),n=new I.ExtensionManagementError(w.localize(1,null,s.identifier.id,this.productService.nameLong,(0,I.TargetPlatformToString)(r)),I.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",s.identifier.id,n.message),y(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,n),n}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(r){throw this.logService.error((0,D.getErrorMessage)(r)),y(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,r),r}const i=await this.galleryService.getManifest(s,S.CancellationToken.None);if(i===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",s.identifier.id,r.message),y(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,r),r}if(i.version!==s.version){const r=new I.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);throw this.logService.error(r.message),y(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,r),r}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(w.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(w.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!g.URI.isUri(e)){let v=this.installingExtensions.get(new h.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(v)return this.logService.info("Extensions is already requested to install",e.identifier.id),v.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],n=[],a=this.createInstallExtensionTask(s,e,i);g.URI.isUri(e)||this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:s});let d=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const L=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:E,manifest:O}of L)if(d=d||!!O.extensionDependencies?.some(N=>(0,h.areSameExtensions)({id:N},a.identifier)),this.installingExtensions.has(new h.ExtensionIdentifierWithVersion(E.identifier,E.version).key()))this.logService.info("Extension is already requested to install",E.identifier.id);else{const N=this.createInstallExtensionTask(O,E,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(N.identifier,O.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:E}),this.logService.info("Installing extension:",N.identifier.id),r.push({task:N,manifest:O})}}catch(L){if(g.URI.isUri(a.source))(0,R.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,L.message),(0,R.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,L.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(L),L}const v=r.reduce((L,{task:E,manifest:O})=>(L.set(E.identifier.id.toLowerCase(),{task:E,manifest:O}),L),new Map);for(;v.size;){let L;const E=[...v.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(N=>v.has(N.toLowerCase())));E.length?L=v.size===1?E:E.filter(({task:O})=>!(O===a&&!d)):(this.logService.info("Found extensions with circular dependencies",E.map(({task:O})=>O.identifier.id)),L=[...v.values()]),await this.joinAllSettled(L.map(async({task:O})=>{const N=new Date().getTime();try{const G=await O.run();if(await this.joinAllSettled(this.participants.map(ne=>ne.postInstall(G,O.source,i,S.CancellationToken.None))),!g.URI.isUri(O.source)&&(y(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,void 0),l.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch(ne){}n.push({local:G,identifier:O.identifier,operation:O.operation,source:O.source})}catch(G){throw g.URI.isUri(O.source)||y(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,G),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error(G),G}finally{v.delete(O.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:L})=>this.logService.info("Extension installed successfully:",L.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:L})=>(0,h.areSameExtensions)(L,a.identifier))[0].local}catch(v){if(r.forEach(({task:L})=>L.cancel()),n.length)try{const L=await Promise.allSettled(n.map(({local:E})=>this.createUninstallExtensionTask(E,{versionOnly:!0}).run()));for(let E=0;E<L.length;E++){const O=L[E],{identifier:N}=n[E];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,D.getErrorMessage)(O.reason))}}catch(L){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(L),n.map(({identifier:E})=>E.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,D.getErrorMessage)(v)),this._onDidInstallExtensions.fire(r.map(({task:L})=>({identifier:L.identifier,operation:1,source:L.source}))),v instanceof Error&&(v.name=v&&v.code?v.code:I.ExtensionManagementErrorCode.Internal),v}finally{for(const{task:v,manifest:L}of r)if(!g.URI.isUri(v.source)){const E=new h.ExtensionIdentifierWithVersion(v.identifier,L.version).key();this.installingExtensions.delete(E)||this.logService.warn("Installation task is not found in the cache",E)}}}async joinAllSettled(s){const e=[],i=[],r=await Promise.allSettled(s);for(const n of r)n.status==="fulfilled"?e.push(n.value):i.push(n.reason);if(i.length)throw p(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const n=[s,...r.map(v=>v.identifier)],a=[],d=async(v,L)=>{const E=L.extensionDependencies||[],O=[...E];if(L.extensionPack){const N=i?r.find(G=>(0,h.areSameExtensions)(G.identifier,v)):void 0;for(const G of L.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(ne=>(0,h.areSameExtensions)({id:ne},{id:G}))||O.every(ne=>!(0,h.areSameExtensions)({id:ne},{id:G}))&&O.push(G)}if(O.length){const N=[...n,...a.map(ne=>ne.gallery.identifier)],G=O.filter(ne=>N.every(ue=>!(0,h.areSameExtensions)(ue,{id:ne})));if(G.length){const ne=await this.galleryService.query({names:G,pageSize:O.length},S.CancellationToken.None);for(const ue of ne.firstPage){if(N.find(_=>(0,h.areSameExtensions)(_,ue.identifier)))continue;if(!E.some(_=>(0,h.areSameExtensions)({id:_},ue.identifier))&&!await this.canInstall(ue)){this.logService.info("Skipping the packed extension as it cannot be installed",ue.identifier.id);continue}const ie=await this.checkAndGetCompatibleVersion(ue,!0),q=await this.galleryService.getManifest(ie,S.CancellationToken.None);if(q===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${ie.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);a.push({gallery:ie,manifest:q}),await d(ie.identifier,q)}}}};return await d(s,e),r=await this.getInstalled(),a.filter(v=>!r.some(L=>(0,h.areSameExtensions)(L.identifier,v.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new I.ExtensionManagementError(w.localize(4,null,s.identifier.id),I.ExtensionManagementErrorCode.Malicious);const i=await this.getCompatibleVersion(s,e);if(!i)throw new I.ExtensionManagementError(w.localize(5,null,s.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.Incompatible);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(s,i)&&(r=s),!r&&e&&(r=await this.galleryService.getCompatibleExtension(s,i)),r}async isMalicious(s){const e=await this.getExtensionsReport();return(0,h.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const r=(v,L)=>{const E=this.createUninstallExtensionTask(v,L);return this.uninstallingExtensions.set(E.extension.identifier.id.toLowerCase(),E),this.logService.info("Uninstalling extension:",v.identifier.id),this._onUninstallExtension.fire(v.identifier),E},n=(v,L)=>{L?this.logService.error("Failed to uninstall extension:",v.identifier.id,L.message):this.logService.info("Successfully uninstalled extension:",v.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,h.getLocalExtensionTelemetryData)(v),void 0,L),this._onDidUninstallExtension.fire({identifier:v.identifier,error:L?.code})},a=[],d=[];try{a.push(r(s,{}));const v=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const L=this.getAllPackExtensionsToUninstall(s,v);for(const E of L)this.uninstallingExtensions.has(E.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",E.identifier.id):a.push(r(E,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(L=>L.extension),v,s),await this.joinAllSettled(a.map(async L=>{try{if(await L.run(),await this.joinAllSettled(this.participants.map(E=>E.postUninstall(L.extension,e,S.CancellationToken.None))),L.extension.identifier.uuid)try{await this.galleryService.reportStatistic(L.extension.manifest.publisher,L.extension.manifest.name,L.extension.manifest.version,"uninstall")}catch(E){}n(L.extension)}catch(E){const O=E instanceof I.ExtensionManagementError?E:new I.ExtensionManagementError((0,D.getErrorMessage)(E),I.ExtensionManagementErrorCode.Internal);throw n(L.extension,O),O}finally{d.push(L)}}))}catch(v){const L=v instanceof I.ExtensionManagementError?v:new I.ExtensionManagementError((0,D.getErrorMessage)(v),I.ExtensionManagementErrorCode.Internal);for(const E of a){try{E.cancel()}catch(O){}d.includes(E)||n(E.extension,L)}throw L}finally{for(const v of a)this.uninstallingExtensions.delete(v.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",v.extension.identifier.id)}}checkForDependents(s,e,i){for(const r of s){const n=this.getDependents(r,e);if(n.length){const a=n.filter(d=>!s.some(v=>(0,h.areSameExtensions)(v.identifier,d.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?w.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?w.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):w.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?w.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?w.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):w.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const r=s.manifest.extensionPack?s.manifest.extensionPack:[];if(r.length){const n=e.filter(d=>!d.isBuiltin&&r.some(v=>(0,h.areSameExtensions)({id:v},d.identifier))),a=[];for(const d of n)a.push(...this.getAllPackExtensionsToUninstall(d,e,i));return[...n,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(r=>(0,h.areSameExtensions)({id:r},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};m=de([ae(0,I.IExtensionGalleryService),ae(1,f.ITelemetryService),ae(2,b.ILogService),ae(3,u.IProductService)],m),t.AbstractExtensionManagementService=m;function p(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=p;function y(o,s,e,i,r){const n=r?r instanceof I.ExtensionManagementError?r.code:I.ExtensionManagementErrorCode.Internal:void 0;o.publicLogError(s,{...e,success:!r,duration:i,errorcode:n})}t.reportTelemetry=y;class c{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(s=>new Promise((e,i)=>{const r=s.onCancellationRequested(()=>{r.dispose(),i((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=c}),define(Y[37],Q([0,1,18,11,26,30]),function(z,t,R,P,S,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,y){return Promise.resolve(void 0)}publicLog2(p,y){return this.publicLog(p,y)}publicLogError(p,y){return Promise.resolve(void 0)}publicLogError2(p,y){return this.publicLogError(p,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=C,t.NullTelemetryService=new C;class T{async publicLog(p,y,c){}async publicLogError(p,y,c){}}t.NullEndpointTelemetryService=T,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(m,p){return p.onDidChangeConfiguration(y=>{y.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(y.source),configurationKeys:u(y.sourceConfig)})})}t.configurationTelemetry=l;function g(m,p){return!(p.disableTelemetry||!m.enableTelemetry)}t.supportsTelemetry=g;function w(m){const p=m.getValue(D.TELEMETRY_SETTING_ID),y=m.getValue("telemetry.enableCrashReporter");if(m.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=w;function I(m){const p=Object.create(null),y=Object.create(null),c=Object.create(null);b(m,c);for(let o in c){o=o.length>150?o.substr(o.length-149):o;const s=c[o];typeof s=="number"?y[o]=s:typeof s=="boolean"?y[o]=s?1:0:typeof s=="string"?p[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(p[o]=s)}return{properties:p,measurements:y}}t.validateTelemetryData=I;function h(m){if(!m)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{m.indexOf(`${c}+`)===0&&(p=c)}),p}t.cleanRemoteAuthority=h;function b(m,p,y=0,c){if(!!m)for(let o of Object.getOwnPropertyNames(m)){const s=m[o],e=c?c+o:o;Array.isArray(s)?p[e]=(0,R.safeStringify)(s):s instanceof Date?p[e]=s.toISOString():(0,P.isObject)(s)?y<2?b(s,p,y+1,e+"."):p[e]=(0,R.safeStringify)(s):p[e]=s}}function u(m){if(!m)return[];const p=[];return f(p,"",m),p}function f(m,p,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(c=>f(m,p?`${p}.${c}`:c,y[c])):m.push(p)}}),define(Y[119],Q([0,1,20,24,8,18,12,29,9,26,21,22,23,49,16,14,33,43,115,116,30,37]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f,m,p,y,c,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=C.isWeb?"web":(0,I.getTargetPlatform)(C.platform,T.arch);var i;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(i||(i={}));function r(...M){return String(M.reduce((A,$)=>A|$,0))}var n;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},d={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(A=L){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,$=this.state.pageSize){return new E({...this.state,pageNumber:A,pageSize:$})}withFilter(A,...$){const V=[...this.state.criteria,...$.length?$.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new E({...this.state,criteria:V})}withSortBy(A){return new E({...this.state,sortBy:A})}withSortOrder(A){return new E({...this.state,sortOrder:A})}withFlags(...A){return new E({...this.state,flags:A.reduce(($,V)=>$|V,0)})}withAssetTypes(...A){return new E({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:$,pageSize:V,sortBy:X,sortOrder:ee,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:A,pageNumber:$,pageSize:V,sortBy:X,sortOrder:ee}],assetTypes:re,flags:se}}get searchText(){const A=this.state.criteria.filter($=>$.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(M,A){const $=(M||[]).filter(V=>V.statisticName===A)[0];return $?$.value:0}function N(M){const A="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,X)=>{const ee=ce(M,X.assetType);return ee&&V.push([X.assetType.substring(A.length),ee]),V},[])}function G(M){if(M.properties){const A=M.properties.filter(X=>X.key===a.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(X=>$.test(X.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return ce(M,a.Repository)}function ne(M){return{uri:`${M.fallbackAssetUri}/${a.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${a.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function ue(M){const A=ce(M,a.Icon);if(A)return A;const $=I.DefaultIconPath;return{uri:$,fallbackUri:$}}function ce(M,A){return M.files.filter(V=>V.assetType===A)[0]?{uri:`${M.assetUri}/${A}`,fallbackUri:`${M.fallbackAssetUri}/${A}`}:null}function ie(M,A){const $=M.properties?M.properties.filter(X=>X.key===A):[],V=$.length>0&&$[0].value;return V?V.split(",").map(X=>(0,h.adoptToGalleryExtensionId)(X)):[]}function q(M){const A=M.properties?M.properties.filter($=>$.key===d.Engine):[];return A.length>0&&A[0].value||""}function _(M){const A=M.properties?M.properties.filter(V=>V.key===d.LocalizedLanguages):[],$=A.length>0&&A[0].value||"";return $?$.split(","):[]}function J(M){return M.indexOf("preview")!==-1}function oe(M){return M.targetPlatform?(0,I.toTargetPlatform)(M.targetPlatform):"undefined"}function x(M){const A=(0,R.distinct)(M.versions.map(oe)),$=!!M.tags?.includes(I.WEB_EXTENSION_TAG),V=A.indexOf("web");return $?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function F(M,A){const $=(0,I.getFallbackTargetPlarforms)(A);for(let V=0;V<M.length;V++){const X=M[V];if(X.version===M[V-1]?.version){let ee=V;const se=oe(X);if(se===A)for(;ee>0&&M[ee-1].version===X.version;)ee--;else if($.includes(se))for(;ee>0&&M[ee-1].version===X.version&&oe(M[ee-1])!==A;)ee--;ee!==V&&(M.splice(V,1),M.splice(ee,0,X))}}return M}t.sortExtensionVersions=F;function j(M,A,$,V,X){const ee=x(M);let se=M.versions[0];return se=M.versions.find(re=>re.version===se.version&&(0,I.isTargetPlatformCompatible)(oe(re),ee,X))||se,H(M,se,ee,A,$,V)}function H(M,A,$,V,X,ee){const se={manifest:ce(A,a.Manifest),readme:ce(A,a.Details),changelog:ce(A,a.Changelog),license:ce(A,a.License),repository:G(A),download:ne(A),icon:ue(A),coreTranslations:N(A)};return{identifier:{id:(0,h.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:A.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,description:M.shortDescription||"",installCount:O(M.statistics,"install"),rating:O(M.statistics,"averagerating"),ratingCount:O(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:$,assets:se,properties:{dependencies:ie(A,d.Dependency),extensionPack:ie(A,d.ExtensionPack),engine:q(A),localizedLanguages:_(A),targetPlatform:oe(A)},preview:J(M.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+V,querySource:ee}}}let K=class{constructor(A,$,V,X,ee,se,re,me){this.requestService=$,this.logService=V,this.environmentService=X,this.telemetryService=ee,this.fileService=se,this.productService=re,this.configurationService=me;const ve=re.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=Z(re.version,re,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,$){const V=[];let X=new E().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,A.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:ee}=await this.queryGallery(X,e,P.CancellationToken.None);for(let se=0;se<ee.length;se++){const re=ee[se];if(!re.versions.length)continue;const me=(0,h.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),ve=A.find(fe=>(0,h.areSameExtensions)(fe,{id:me}))?.version;if(ve){const fe=re.versions.find(be=>be.version===ve);fe&&V.push(H(re,fe,x(re),se,X))}else V.push(j(re,se,X,void 0,e))}return V}async getCompatibleExtension(A,$){const V=(0,I.isIExtensionIdentifier)(A)?null:A;if(V){if((0,I.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,$))return null;if(await this.isExtensionCompatible(V,$))return V}const{id:X,uuid:ee}=V?V.identifier:A;let se=new E().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");ee?se=se.withFilter(n.ExtensionId,ee):se=se.withFilter(n.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,$,P.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const ve=x(me);if((0,I.isNotWebExtensionInWebTargetPlatform)(ve,$))return null;for(let fe of me.versions){if(!q(fe)){const be=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:d.Engine,value:be}]}}if(await this.isRawExtensionVersionCompatible(fe,ve,$))return H(me,fe,ve,0,se)}return null}async isExtensionCompatible(A,$){if(!(0,I.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,$))return!1;let V=A.properties.engine;if(!V){const X=await this.getManifest(A,P.CancellationToken.None);if(!X)throw new Error("Manifest was not found");V=X.engines.vscode}return(0,b.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,$,V){if(!(0,I.isTargetPlatformCompatible)(oe(A),$,V))return!1;const X=await this.getEngine(A);return(0,b.isEngineValid)(X,this.productService.version,this.productService.date)}async query(A,$){const V=P.CancellationToken.isCancellationToken(A)?{}:A,X=P.CancellationToken.isCancellationToken(A)?A:$;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ee=V.text||"";const se=(0,D.getOrDefault)(V,ye=>ye.pageSize,50);let re=new E().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(n.Target,"Microsoft.VisualStudio.Code");ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,Fe)=>(re=re.withFilter(n.Category,Fe||we),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,Fe)=>(re=re.withFilter(n.Tag,Fe||we),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(n.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),re=re.withFilter(n.SearchText,ee)),re=re.withSortBy(0)):V.ids?re=re.withFilter(n.ExtensionId,...V.ids):V.names?re=re.withFilter(n.ExtensionName,...V.names):re=re.withSortBy(4),typeof V.sortBy=="number"&&(re=re.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(re=re.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ve}=await this.queryGallery(re,e,X),fe=me.map((ye,we)=>j(ye,we,re,V.source,e)),be=async(ye,we)=>{if(we.isCancellationRequested)throw(0,S.canceled)();const Fe=re.withPage(ye+1),{galleryExtensions:Me}=await this.queryGallery(Fe,e,we);return Me.map((ze,Ue)=>j(ze,Ue,Fe,V.source,e))};return{firstPage:fe,total:ve,pageSize:re.pageSize,getPage:be}}async queryGallery(A,$,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,i.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,r(i.Unpublished));const X=await this.commonHeadersPromise,ee=JSON.stringify(A.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},re=new Date().getTime();let me,ve,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ee,headers:se},V),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const be=await(0,p.asJson)(me);if(be){const ye=be.results[0],we=ye.extensions;we.forEach(Me=>F(Me.versions,$));const Fe=ye.resultMetadata&&ye.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:fe}}return{galleryExtensions:[],total:fe}}catch(be){throw ve=be,be}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-re,success:!!me&&(0,p.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ve?(0,S.isPromiseCanceledError)(ve)?"canceled":(0,S.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,$,V,X){if(!this.isEnabled())return;const ee=C.isWeb?this.api(`/itemName/${A}.${$}/version/${V}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${$}/${V}/stats?statType=${X}`),se=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:ee,headers:me},P.CancellationToken.None)}catch(ve){}}async download(A,$,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,h.getGalleryExtensionTelemetryData)(A),ee=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=V===1?"install":V===2?"update":"",me=re?{uri:`${A.assets.download.uri}${l.URI.parse(A.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${A.assets.download.fallbackUri}${l.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:A.assets.download,ve=await this.getAsset(me);await this.fileService.writeFile($,ve.stream),se(new Date().getTime()-ee)}async getReadme(A,$){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},$);return await(0,p.asText)(V)||""}return""}async getManifest(A,$){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},$),X=await(0,p.asText)(V);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,$){const V=ce(A,a.Manifest);if(!V)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},ee=await this.getAsset(V,{headers:X});return await(0,p.asJson)(ee)}async getCoreTranslation(A,$){const V=A.assets.coreTranslations.filter(X=>X[0]===$.toUpperCase())[0];if(V){const X=await this.getAsset(V[1]),ee=await(0,p.asText)(X);return ee?JSON.parse(ee):null}return null}async getChangelog(A,$){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},$);return await(0,p.asText)(V)||""}return""}async getAllCompatibleVersions(A,$){let V=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?V=V.withFilter(n.ExtensionId,A.identifier.uuid):V=V.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryGallery(V,$,P.CancellationToken.None);if(!X.length)return[];const ee=x(X[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(ee,$))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,ee,$)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(A,$={},V=P.CancellationToken.None){const X=await this.commonHeadersPromise,ee={type:"GET"},se={...X,...$.headers||{}};$={...$,...ee,headers:se};const re=A.uri,me=A.fallbackUri,ve={...$,url:re};try{const fe=await this.requestService.request(ve,V);if(fe.res.statusCode===200)return fe;const be=await(0,p.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${be}`)}catch(fe){if((0,S.isPromiseCanceledError)(fe))throw fe;const be=(0,S.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:be});const ye={...$,url:me};return this.requestService.request(ye,V)}}async getEngine(A){let $=q(A);if(!$){const V=await this.getManifestFromRawExtensionVersion(A,P.CancellationToken.None);if(!V)throw new Error("Manifest was not found");$=V.engines.vscode}return $}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,p.asJson)(A),V=new Map;if($)for(const X of $.malicious){const ee=V.get(X)||{id:{id:X},malicious:!0,slow:!1};ee.malicious=!0,V.set(X,ee)}return[...V.values()]}};K=de([ae(1,p.IRequestService),ae(2,f.ILogService),ae(3,w.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,u.IFileService),ae(6,m.IProductService),ae(7,g.IConfigurationService)],K);let W=class extends K{constructor(A,$,V,X,ee,se,re,me){super(A,$,V,X,ee,se,re,me)}};W=de([ae(0,c.IStorageService),ae(1,p.IRequestService),ae(2,f.ILogService),ae(3,w.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,u.IFileService),ae(6,m.IProductService),ae(7,g.IConfigurationService)],W),t.ExtensionGalleryService=W;let te=class extends K{constructor(A,$,V,X,ee,se,re){super(void 0,A,$,V,X,ee,se,re)}};te=de([ae(0,p.IRequestService),ae(1,f.ILogService),ae(2,w.IEnvironmentService),ae(3,o.ITelemetryService),ae(4,u.IFileService),ae(5,m.IProductService),ae(6,g.IConfigurationService)],te),t.ExtensionGalleryServiceWithNoStorageService=te;async function Z(M,A,$,V,X,ee){const se={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},re=await(0,y.getServiceMachineId)($,X,ee);return(0,s.supportsTelemetry)(A,$)&&(0,s.getTelemetryLevel)(V)===3&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=Z}),define(Y[120],Q([0,1,2,18,12,27,85,26,34,55,25,30,37]),function(z,t,R,P,S,D,C,T,l,g,w,I,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let b=class{constructor(m,p){this._configurationService=p,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const c=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(m,p){this._experimentProperties[m]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,h.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let p=m.sessionID,y=m["common.instanceId"],c=m["common.machineId"],o=m["common.firstSessionDate"],s=m["common.msftInternal"];return{sessionId:p,instanceId:y,machineId:c,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(m,p,y,c){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(o=>{y=(0,P.mixin)(y,o),y=(0,P.mixin)(y,this._experimentProperties),y=(0,P.cloneAndChange)(y,s=>{if(typeof s=="string")return this._cleanupInfo(s,c)}),this._appenders.forEach(s=>s.log(m,y))},o=>{console.error(o)})}publicLog(m,p,y){return this._log(m,3,p,y)}publicLog2(m,p,y){return this.publicLog(m,p,y)}publicLogError(m,p){return this.sendErrorTelemetry?this._log(m,2,p,!0):Promise.resolve(void 0)}publicLogError2(m,p){return this.publicLogError(m,p)}_anonymizeFilePaths(m){let p=m;const y=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(m);if(!i)break;y.push([i.index,e.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(p="";;){const e=o.exec(m);if(!e)break;!c.test(e[0])&&y.every(([i,r])=>e.index<i||e.index>=r)&&(p+=m.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<m.length&&(p+=m.substr(s)),p}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const p=m.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(p)?"<REDACTED: secret>":y.test(p)?"<REDACTED: email>":m}_cleanupInfo(m,p){let y=m;p&&(y=this._anonymizeFilePaths(y));for(let c of this._cleanupPatterns)y=y.replace(c,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=de([ae(1,T.IConfigurationService)],b),t.TelemetryService=b;function u(){const f=(0,C.localize)(0,null,g.default.nameLong),m=g.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=S.isWeb?"":(0,C.localize)(3,null),y=(0,C.localize)(4,null),c=(0,C.localize)(5,null),o=(0,C.localize)(6,null),s=(0,C.localize)(7,null),e=`
|       | ${y} | ${c} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,C.localize)(8,null);return`
${f} ${m} ${p}

&nbsp;

${s}
${e}

&nbsp;

${i}
`}w.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,C.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,C.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[121],Q([0,1,8,18,37]),function(z,t,R,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function D(T){const l=await new Promise((w,I)=>{z(["applicationinsights"],w,I)});let g;return l.defaultClient?(g=new l.TelemetryClient(T),g.channel.setUseDiskRetryCaching(!0)):(l.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=l.defaultClient),T.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class C{constructor(l,g,w){this._eventPrefix=l,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof w=="function"?this._aiClient=w():this._aiClient=w,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient)),this._asyncAIClient.then(g=>{l(g)},g=>{(0,R.onUnexpectedError)(g),console.error(g)})}}log(l,g){!this._aiClient||(g=(0,P.mixin)(g,this._defaultData),g=(0,S.validateTelemetryData)(g),this._withAIClient(w=>w.trackEvent({name:this._eventPrefix+"/"+l,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=C}),define(Y[122],Q([0,1,7,13]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(D,C){const T=Object.create(null),l=(w,I)=>{const h=JSON.parse(w);T[I]=h};if(C){const w=[],I=await P.Promises.readdir(C);for(const b of I)try{(await P.Promises.stat((0,R.join)(C,b))).isDirectory()&&w.push(b)}catch{}const h=[];for(const b of w)(await P.Promises.readdir((0,R.join)(C,b))).filter(f=>f==="telemetry.json").length===1&&h.push(b);for(const b of h){const u=(await P.Promises.readFile((0,R.join)(C,b,"telemetry.json"))).toString();l(u,b)}}let g=(await P.Promises.readFile((0,R.join)(D,"telemetry-core.json"))).toString();return l(g,"vscode-core"),g=(await P.Promises.readFile((0,R.join)(D,"telemetry-extensions.json"))).toString(),l(g,"vscode-extensions"),JSON.stringify(T,null,4)}t.buildTelemetryMessage=S}),define(Y[44],Q([0,1,47,3,7,11,13,71,135,136]),function(z,t,R,P,S,D,C,T,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class w extends Error{constructor(e,i){let r=i.message;switch(e){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=e,this.cause=i}}t.ExtractError=w;function I(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,r)=>i+r,e&61440)}function h(s){if(s instanceof w)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new w(e,s)}function b(s,e,i,r,n,a){const d=S.dirname(e),v=S.join(r,d);if(!v.startsWith(r))return Promise.reject(new Error(T.localize(0,null,e)));const L=S.join(r,e);let E;return a.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(C.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!a.isCancellationRequested)try{E=(0,R.createWriteStream)(L,{mode:i}),E.once("close",()=>O()),E.once("error",N),s.once("error",N),s.pipe(E)}catch(G){N(G)}}))}function u(s,e,i,r){let n=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((d,v)=>{const L=new P.Sequencer,E=O=>{O.isCancellationRequested||(a++,s.readEntry())};s.once("error",v),s.once("close",()=>n.then(()=>{r.isCancellationRequested||s.entryCount===a?d():v(new w("Incomplete",new Error(T.localize(1,null,a,s.entryCount))))},v)),s.readEntry(),s.on("entry",O=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(O.fileName)){E(r);return}const N=O.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const ue=S.join(e,N);n=(0,P.createCancelablePromise)(ce=>C.Promises.mkdir(ue,{recursive:!0}).then(()=>E(ce)).then(void 0,v));return}const G=m(s,O),ne=I(O);n=(0,P.createCancelablePromise)(ue=>L.queue(()=>G.then(ce=>b(ce,N,ne,e,i,ue).then(()=>E(ue)))).then(null,v))})})}function f(s,e=!1){return new Promise((i,r)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(n,a)=>{n?r(h(n)):i((0,D.assertIsDefined)(a))})})}function m(s,e){return new Promise((i,r)=>{s.openReadStream(e,(n,a)=>{n?r(h(n)):i((0,D.assertIsDefined)(a))})})}function p(s,e){return new Promise((i,r)=>{const n=new g.ZipFile;e.forEach(d=>{d.contents?n.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&n.addFile(d.localPath,d.path)}),n.end();const a=(0,R.createWriteStream)(s);n.outputStream.pipe(a),n.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>i(s))})}t.zip=p;function y(s,e,i={},r){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=f(s,!0);return i.overwrite&&(a=a.then(d=>C.Promises.rm(e).then(()=>d))),a.then(d=>u(d,e,{sourcePathRegex:n},r))}t.extract=y;function c(s,e){return f(s).then(i=>new Promise((r,n)=>{i.on("entry",a=>{a.fileName===e&&m(i,a).then(d=>r(d),d=>n(d))}),i.once("close",()=>n(new Error(T.localize(2,null,e))))}))}function o(s,e){return c(s,e).then(i=>new Promise((r,n)=>{const a=[];i.once("error",n),i.on("data",d=>a.push(d)),i.on("end",()=>r(Buffer.concat(a)))}))}t.buffer=o}),define(Y[123],Q([0,1,44,78]),function(z,t,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(D){return(0,R.buffer)(D,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch(T){throw new Error((0,P.localize)(0,null))}})}t.getManifest=S}),define(Y[124],Q([0,1,20,3,8,2,6,7,12,19,42,9,31,13,44,79,21,22,23,89,16,14,33]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f,m,p,y,c,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let i=class extends D.Disposable{constructor(n,a,d,v,L){super();this.beforeRemovingExtension=n,this.fileService=a,this.logService=d,this.environmentService=v,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=v.builtinExtensionsPath,this.extensionsPath=v.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const a=[];(n===null||n===0)&&a.push(this.scanSystemExtensions().then(null,d=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(d).message,p.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&a.push(this.scanUserExtensions(!0).then(null,d=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(d).message,p.ExtensionManagementErrorCode.Internal))));try{const d=await Promise.all(a);return(0,R.flatten)(d)}catch(d){throw this.joinErrors(d)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[a,d]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return d=d.filter(v=>!a[new y.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]),n&&(d=(0,y.groupByExtension)(d,L=>L.identifier).map(L=>L.sort((E,O)=>w.rcompare(E.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",d.length),d}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,a,d,v){const L=n.key(),E=T.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),O=T.join(this.extensionsPath,L);try{await b.Promises.rm(O)}catch(G){try{await b.Promises.rm(O)}catch(ne){}throw new p.ExtensionManagementError((0,f.localize)(0,null,O,n.id),p.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,a,E,v);let N=await this.scanExtension(I.URI.file(E),1);if(!N)throw new Error((0,f.localize)(1,null,E));await this.storeMetadata(N,{...d,installedTimestamp:Date.now()});try{await this.rename(n,E,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(G){try{await b.Promises.rm(E)}catch(ne){}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(G)}. Deleted from extracted location`,E),G}try{N=await this.scanExtension(I.URI.file(O),1)}catch(G){}if(N)return N;throw new Error((0,f.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,a){return this.setMetadata(n,a),await this.storeMetadata(n,{...a,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const d=T.join(n.location.fsPath,"package.json"),v=await b.Promises.readFile(d,"utf8"),{manifest:L}=await this.parseManifest(v);return L.__metadata=a,await b.Promises.writeFile(d,JSON.stringify(L,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const a=n.map(d=>new y.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version));await this.withUninstalledExtensions(d=>{a.forEach(v=>d[v.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(v=>delete v[n.key()]);const d=(await this.scanExtensions(1)).find(v=>new y.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(n))||null;return d?(await this.storeMetadata(d,{installedTimestamp:Date.now()}),this.scanExtension(d.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(v){if(v.code!=="ENOENT")throw v}let d={};if(a)try{d=JSON.parse(a)}catch(v){}return n&&(n(d),Object.keys(d).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(d)):await b.Promises.rm(this.uninstalledPath)),d})}async removeExtension(n,a){this.logService.trace(`Deleting ${a} extension from disk`,n.identifier.id,n.location.fsPath),await b.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new y.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,a,d,v){this.logService.trace(`Started extracting the extension from ${a} to ${d}`);try{await b.Promises.rm(d)}catch(L){throw new p.ExtensionManagementError(this.joinErrors(L).message,p.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(a,d,{sourcePath:"extension",overwrite:!0},v),this.logService.info(`Extracted extension to ${d}:`,n.id)}catch(L){try{await b.Promises.rm(d)}catch(O){}let E=p.ExtensionManagementErrorCode.Extract;throw L instanceof u.ExtractError&&(L.type==="CorruptZip"?E=p.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(E=p.ExtensionManagementErrorCode.IncompleteZip)),new p.ExtensionManagementError(L.message,E)}}async rename(n,a,d,v){try{await b.Promises.rename(a,d)}catch(L){if(l.isWindows&&L&&L.code==="EPERM"&&Date.now()<v)return this.logService.info(`Failed renaming ${a} to ${d} with 'EPERM' error. Trying again...`,n.id),this.rename(n,a,d,v);throw new p.ExtensionManagementError(L.message||(0,f.localize)(3,null,a,d),L.code||p.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const a=this.scanDevSystemExtensions(),[d,v]=await Promise.all([n,a]);return[...d,...v]}async scanExtensionsInDir(n,a){const d=new P.Limiter(10),v=await this.fileService.resolve(I.URI.file(n));return v.children?(await Promise.all(v.children.filter(E=>E.isDirectory).map(E=>d.queue(async()=>a===1&&(0,g.basename)(E.resource).indexOf(".")===0?null:this.scanExtension(E.resource,a))))).filter(E=>E&&E.identifier):[]}async scanExtension(n,a){try{const d=await this.fileService.resolve(n);if(d.children){const{manifest:v,metadata:L}=await this.readManifest(n.fsPath),E=d.children.find(({name:ne})=>/^readme(\.txt|\.md|)$/i.test(ne))?.resource,O=d.children.find(({name:ne})=>/^changelog(\.txt|\.md|)$/i.test(ne))?.resource,N={id:(0,y.getGalleryExtensionId)(v.publisher,v.name)},G={type:a,identifier:N,manifest:v,location:n,readmeUrl:E,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return L&&(this.setMetadata(G,L),G.installedTimestamp=L.installedTimestamp),G}}catch(d){a!==0&&this.logService.trace(d)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(d=>n.some(v=>(0,y.areSameExtensions)(d.identifier,{id:v})))}else return[]}setMetadata(n,a){n.publisherDisplayName=a.publisherDisplayName||null,n.publisherId=a.publisherId||null,n.identifier.uuid=a.id,n.isMachineScoped=!!a.isMachineScoped,n.isBuiltin=n.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),d=new Set;for(const E of a)n[new y.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()]||d.add(E.identifier.id.toLowerCase());const v=(0,y.groupByExtension)(a,E=>E.identifier);await P.Promises.settled(v.map(async E=>{const O=E.sort((N,G)=>w.rcompare(N.manifest.version,G.manifest.version))[0];d.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const L=a.filter(E=>n[new y.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()]);await P.Promises.settled(L.map(E=>this.removeUninstalledExtension(E)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),a=[],d=(0,y.groupByExtension)(n,v=>v.identifier);a.push(...(0,R.flatten)(d.map(v=>v.sort((L,E)=>w.rcompare(L.manifest.version,E.manifest.version)).slice(1)))),await P.Promises.settled(a.map(v=>this.removeExtension(v,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const a=Array.isArray(n)?n:[n];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((d,v)=>new Error(`${d.message}${d.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(C.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const a=[b.Promises.readFile(T.join(n,"package.json"),"utf8").then(E=>this.parseManifest(E)),b.Promises.readFile(T.join(n,"package.nls.json"),"utf8").then(void 0,E=>E.code!=="ENOENT"?Promise.reject(E):"{}").then(E=>JSON.parse(E))],[{manifest:d,metadata:v},L]=await Promise.all(a);return{manifest:(0,c.localizeManifest)(d,L),metadata:v}}parseManifest(n){return new Promise((a,d)=>{try{const v=JSON.parse(n),L=v.__metadata||null;a({manifest:v,metadata:L})}catch(v){d(new Error((0,f.localize)(4,null)))}})}};i=de([ae(1,o.IFileService),ae(2,s.ILogService),ae(3,m.INativeEnvironmentService),ae(4,e.IProductService)],i),t.ExtensionsScanner=i}),define(Y[125],Q([0,1,28,8,6,7,12,29,19,42,9,31,13,44,77,51,21,118,22,23,108,97,123,109,124,110,49,16,15,14,33,30]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f,m,p,y,c,o,s,e,i,r,n,a,d,v,L,E,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let N=class extends p.AbstractExtensionManagementService{constructor(q,_,J,oe,x,F,j,H){super(q,_,J,H);this.environmentService=oe,this.downloadService=x,this.fileService=j;const K=this._register(F.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(F.createInstance(r.ExtensionsScanner,te=>K.postUninstall(te))),this.manifestCache=this._register(new i.ExtensionsManifestCache(oe,this)),this.extensionsDownloader=this._register(F.createInstance(o.ExtensionsDownloader));const W=this._register(new n.ExtensionsWatcher(this,j,oe,J));this._register(W.onDidChangeExtensionsByAnotherSource(({added:te,removed:Z})=>{te.length&&this._onDidInstallExtensions.fire(te.map(M=>({identifier:M.identifier,operation:0,local:M}))),Z.forEach(M=>this._onDidUninstallExtension.fire({identifier:M}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const q=await this.isAlpineLinux(),_=(0,y.getTargetPlatform)(q?"alpine":C.platform,T.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",_),_})()),this._targetPlatformPromise}async isAlpineLinux(){if(!C.isLinux)return!1;let q;try{q=(await this.fileService.readFile(w.URI.file("/etc/os-release"))).value.toString()}catch(_){try{q=(await this.fileService.readFile(w.URI.file("/usr/lib/os-release"))).value.toString()}catch(J){this.logService.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(J))}}return!!q&&(q.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(q){this.logService.trace("ExtensionManagementService#zip",q.identifier.id);const _=await this.collectFiles(q),J=await(0,b.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,_);return w.URI.file(J)}async unzip(q){return this.logService.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const _=await this.downloadVsix(q),J=D.resolve(_.fsPath);return(0,e.getManifest)(J)}getInstalled(q=null){return this.extensionsScanner.scanExtensions(q)}async install(q,_={}){this.logService.trace("ExtensionManagementService#install",q.toString());const J=await this.downloadVsix(q),oe=await(0,e.getManifest)(D.resolve(J.fsPath));if(oe.engines&&oe.engines.vscode&&!(0,a.isEngineValid)(oe.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,c.getGalleryExtensionId)(oe.publisher,oe.name),this.productService.version));return this.installExtension(oe,J,_)}async updateMetadata(q,_){return this.logService.trace("ExtensionManagementService#updateMetadata",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},..._}),this.manifestCache.invalidate(),q}async updateExtensionScope(q,_){return this.logService.trace("ExtensionManagementService#updateExtensionScope",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},isMachineScoped:_}),this.manifestCache.invalidate(),q}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(q){if(q.scheme===S.Schemas.file)return q;const _=(0,l.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(q,_),_}createInstallExtensionTask(q,_,J){return w.URI.isUri(_)?new ue(q,_,J,this.galleryService,this.extensionsScanner,this.logService):new ne(_,J,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(q,_){return new ce(q,_,this.extensionsScanner)}async collectFiles(q){const _=async oe=>{let x=await h.Promises.readdir(oe);x=x.map(H=>D.join(oe,H));const F=await Promise.all(x.map(H=>h.Promises.stat(H)));let j=Promise.resolve([]);return F.forEach((H,K)=>{const W=x[K];H.isFile()&&(j=j.then(te=>[...te,W])),H.isDirectory()&&(j=j.then(te=>_(W).then(Z=>[...te,...Z])))}),j};return(await _(q.location.fsPath)).map(oe=>({path:`extension/${D.relative(q.location.fsPath,oe)}`,localPath:oe}))}};N=de([ae(0,y.IExtensionGalleryService),ae(1,O.ITelemetryService),ae(2,L.ILogService),ae(3,m.INativeEnvironmentService),ae(4,f.IDownloadService),ae(5,v.IInstantiationService),ae(6,d.IFileService),ae(7,E.IProductService)],N),t.ExtensionManagementService=N;class G extends p.AbstractExtensionTask{constructor(q,_,J,oe){super();this.identifier=q,this.source=_,this.extensionsScanner=J,this.logService=oe,this._operation=1}get operation(){return this._operation}async installExtension(q,_){try{const J=await this.unsetUninstalledAndGetLocal(q.identifierWithVersion);if(J)return q.metadata?this.extensionsScanner.saveMetadataForLocalExtension(J,q.metadata):J}catch(J){throw C.isMacintosh?new y.ExtensionManagementError(u.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(u.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(q,_)}async unsetUninstalledAndGetLocal(q){if(!await this.isUninstalled(q))return null;this.logService.trace("Removing the extension from uninstalled list:",q.id);const J=await this.extensionsScanner.setInstalled(q);return this.logService.info("Removed the extension from uninstalled list:",q.id),J}async isUninstalled(q){return!!(await this.extensionsScanner.getUninstalledExtensions())[q.key()]}async extract({zipPath:q,identifierWithVersion:_,metadata:J},oe){let x=await this.extensionsScanner.extractUserExtension(_,q,J,oe);return this.logService.info("Extracting completed.",_.id),x}}class ne extends G{constructor(q,_,J,oe,x){super(q.identifier,q,oe,x);this.gallery=q,this.options=_,this.extensionsDownloader=J}async doRun(q){const J=(await this.extensionsScanner.scanExtensions(null)).find(x=>(0,c.areSameExtensions)(x.identifier,this.gallery.identifier));J&&(this._operation=2);const oe=await this.downloadInstallableExtension(this.gallery,this._operation);oe.metadata.isMachineScoped=this.options.isMachineScoped||J?.isMachineScoped,oe.metadata.isBuiltin=this.options.isBuiltin||J?.isBuiltin;try{const x=await this.installExtension(oe,q);return J&&g.neq(J.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(J),x}catch(x){throw await this.deleteDownloadedVSIX(oe.zipPath),x}}async deleteDownloadedVSIX(q){try{await this.extensionsDownloader.delete(w.URI.file(q))}catch(_){this.logService.warn("Error while deleting the downloaded vsix",q.toString(),(0,P.getErrorMessage)(_))}}async downloadInstallableExtension(q,_){const J={id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName};let oe;try{this.logService.trace("Started downloading extension:",q.identifier.id),oe=(await this.extensionsDownloader.downloadExtension(q,_)).fsPath,this.logService.info("Downloaded extension:",q.identifier.id,oe)}catch(x){throw new y.ExtensionManagementError((0,p.joinErrors)(x).message,y.ExtensionManagementErrorCode.Download)}try{const x=await(0,e.getManifest)(oe);return{zipPath:oe,identifierWithVersion:new c.ExtensionIdentifierWithVersion(q.identifier,x.version),metadata:J}}catch(x){throw await this.deleteDownloadedVSIX(oe),new y.ExtensionManagementError((0,p.joinErrors)(x).message,y.ExtensionManagementErrorCode.Invalid)}}}class ue extends G{constructor(q,_,J,oe,x,F){super({id:(0,c.getGalleryExtensionId)(q.publisher,q.name)},_,x,F);this.manifest=q,this.location=_,this.options=J,this.galleryService=oe}async doRun(q){const _=new c.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),oe=(await this.extensionsScanner.scanExtensions(1)).find(F=>(0,c.areSameExtensions)(this.identifier,F.identifier)),x=await this.getMetadata(this.identifier.id,q);if(x.isMachineScoped=this.options.isMachineScoped||oe?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||oe?.isBuiltin,oe)if(this._operation=2,_.equals(new c.ExtensionIdentifierWithVersion(oe.identifier,oe.manifest.version)))try{await this.extensionsScanner.removeExtension(oe,"existing")}catch(F){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(oe.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(oe);else{const F=await this.unsetUninstalledAndGetLocal(_);if(F)try{await this.extensionsScanner.removeExtension(F,"existing")}catch(j){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:_,metadata:x},q)}async getMetadata(q,_){try{const J=(await this.galleryService.query({names:[q],pageSize:1},_)).firstPage[0];if(J)return{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId}}catch(J){}return{}}}class ce extends p.AbstractExtensionTask{constructor(q,_,J){super();this.extension=q,this.options=_,this.extensionsScanner=J}async doRun(q){const _=[],J=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const oe=new c.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);_.push(...J.filter(x=>oe.equals(new c.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version))))}else _.push(...J.filter(oe=>(0,c.areSameExtensions)(oe.identifier,this.extension.identifier)));if(!_.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(..._),this.options.remove)for(const oe of _)try{q.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(oe)}catch(x){throw new Error(u.localize(6,null,(0,R.toErrorMessage)(x)))}}}}),define(Y[126],Q([0,1,114,3,17,8,2,11,26,21,91,14,113,137]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let u=class extends C.Disposable{constructor(m,p,y){super();this.environmentService=p,this.logService=y,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,p){this.logService.trace("RequestService#request",m.url);const{proxyUrl:y,strictSSL:c}=this;let o;try{o=await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(i){this.logService.error("RequestService#request resolving shell environment failed",i)}const s={...process.env,...o},e=m.agent?m.agent:await(0,h.getProxyAgent)(m.url||"",s,{proxyUrl:y,strictSSL:c});return m.agent=e,m.strictSSL=c,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,p)}async getNodeRequest(m){return((0,R.parse)(m.url).protocol==="https:"?await new Promise((c,o)=>{z(["https"],c,o)}):await new Promise((c,o)=>{z(["http"],c,o)})).request}_request(m,p){return P.Promises.withAsyncBody(async(y,c)=>{let o;const s=(0,R.parse)(m.url),e=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),i={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,T.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(i.auth=m.user+":"+m.password),o=e(i,r=>{const n=(0,T.isNumber)(m.followRedirects)?m.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&n>0&&r.headers.location)this._request({...m,url:r.headers.location,followRedirects:n-1},p).then(y,c);else{let a=r;r.headers["content-encoding"]==="gzip"&&(a=r.pipe((0,b.createGunzip)())),y({res:r,stream:(0,S.streamToBufferReadableStream)(a)})}}),o.on("error",c),m.timeout&&o.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&o.write(m.data),o.end(),p.onCancellationRequested(()=>{o.abort(),c((0,D.canceled)())})})}async resolveProxy(m){}};u=de([ae(0,l.IConfigurationService),ae(1,g.INativeEnvironmentService),ae(2,I.ILogService)],u),t.RequestService=u}),define(Y[138],Q([0,1,35,3,17,28,8,2,6,7,29,9,13,26,105,51,112,21,88,119,22,107,125,16,99,102,50,96,53,54,111,14,101,55,33,43,126,117,30,120,37,121,122]),function(z,t,R,P,S,D,C,T,l,g,w,I,h,b,u,f,m,p,y,c,o,s,e,i,r,n,a,d,v,L,E,O,N,G,ne,ue,ce,ie,q,_,J,oe,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class F extends T.Disposable{constructor(K){super();this.argv=K,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[K,W]=await this.initServices();return K.invokeFunction(async te=>{const Z=te.get(O.ILogService),M=te.get(i.IFileService),A=te.get(p.INativeEnvironmentService),$=te.get(o.IExtensionManagementCLIService);Z.info("CLI main",this.argv),this.registerErrorHandler(Z),await this.doRun(A,$,M),await Promise.all(W.map(V=>{(0,P.raceTimeout)(V.flush(),1e3)}))})}async initServices(){const K=new v.ServiceCollection,W={_serviceBrand:void 0,...G.default};K.set(ne.IProductService,W);const te=new y.NativeEnvironmentService(this.argv,W);K.set(p.INativeEnvironmentService,te),await Promise.all([te.appSettingsHome.fsPath,te.extensionsPath].map(se=>se?h.Promises.mkdir(se,{recursive:!0}):void 0));const Z=(0,O.getLogLevel)(te),M=[];M.push(new N.SpdLogLogger("cli",(0,g.join)(te.logsPath,"cli.log"),!0,Z)),Z===O.LogLevel.Trace&&M.push(new O.ConsoleLogger(Z));const A=this._register(new O.MultiplexLogService(M));K.set(O.ILogService,A);const $=this._register(new r.FileService(A));K.set(i.IFileService,$);const V=this._register(new n.DiskFileSystemProvider(A));$.registerProvider(l.Schemas.file,V);const X=this._register(new u.ConfigurationService(te.settingsResource,$));K.set(b.IConfigurationService,X),await X.initialize(),K.set(ue.IRequestService,new a.SyncDescriptor(ce.RequestService)),K.set(f.IDownloadService,new a.SyncDescriptor(m.DownloadService)),K.set(o.IExtensionManagementService,new a.SyncDescriptor(e.ExtensionManagementService)),K.set(o.IExtensionGalleryService,new a.SyncDescriptor(c.ExtensionGalleryServiceWithNoStorageService)),K.set(o.IExtensionManagementCLIService,new a.SyncDescriptor(s.ExtensionManagementCLIService)),K.set(L.ILocalizationsService,new a.SyncDescriptor(E.LocalizationsService));const ee=[];if((0,J.supportsTelemetry)(W,te)){W.aiConfig&&W.aiConfig.asimovKey&&ee.push(new oe.AppInsightsAppender("monacoworkbench",null,W.aiConfig.asimovKey));const{appRoot:se,extensionsPath:re,installSourcePath:me}=te,ve={appenders:ee,sendErrorTelemetry:!1,commonProperties:(async()=>{let fe;try{const be=await h.Promises.readFile((0,g.join)(te.userDataPath,"storage.json"));fe=JSON.parse(be.toString())[q.machineIdKey]}catch(be){be.code!=="ENOENT"&&A.error(be)}return(0,ie.resolveCommonProperties)($,(0,R.release)(),(0,R.hostname)(),process.arch,W.commit,W.version,fe,W.msftInternalDomains,me)})(),piiPaths:[se,re]};K.set(q.ITelemetryService,new a.SyncDescriptor(_.TelemetryService,[ve]))}else K.set(q.ITelemetryService,J.NullTelemetryService);return[new d.InstantiationService(K),ee]}registerErrorHandler(K){(0,C.setUnexpectedErrorHandler)(W=>{const te=(0,D.toErrorMessage)(W,!0);!te||K.error(`[uncaught exception in CLI]: ${te}`)}),process.on("uncaughtException",W=>(0,C.onUnexpectedError)(W)),process.on("unhandledRejection",W=>(0,C.onUnexpectedError)(W))}async doRun(K,W,te){if(this.argv["install-source"])return this.setInstallSource(K,te,this.argv["install-source"]);if(this.argv["list-extensions"])return W.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return W.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return W.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return W.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,x.buildTelemetryMessage)(K.appRoot,K.extensionsPath))}asExtensionIdOrVSIX(K){return K.map(W=>/\.vsix$/i.test(W)?I.URI.file((0,g.isAbsolute)(W)?W:(0,g.join)((0,w.cwd)(),W)):W)}async setInstallSource(K,W,te){await W.writeFile(I.URI.file(K.installSourcePath),S.VSBuffer.fromString(te.slice(0,30)))}}async function j(H){const K=new F(H);try{await K.run()}finally{K.dispose()}}t.main=j})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc1a6699060423b8c4d2ced736ad70195378fddf/core/vs/code/node/cliProcessMain.js.map
