/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(oe){for(var e=[],d=0,M=oe.length;d<M;d++)e[d]=be[oe[d]];return e};define(be[42],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,_){if(!M)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=d}),define(be[52],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const S=[];for(let n in t)d.call(t,n)&&S.push(t[n]);return S}e.values=M;function _(t,S){for(let n in t)if(d.call(t,n)&&S({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=_;function A(t,S){const n=Object.create(null);for(const m of t){const s=S(m);let u=n[s];u||(u=n[s]=[]),u.push(m)}return n}e.groupBy=A;function F(t){const S=Object.create(null);return t&&t.forEach((n,m)=>{S[m]=n}),S}e.fromMap=F;function P(t,S){const n=[],m=[];for(let s of t)S.has(s)||n.push(s);for(let s of S)t.has(s)||m.push(s);return{removed:n,added:m}}e.diffSets=P;function C(t,S){const n=[],m=[];for(let[s,u]of t)S.has(s)||n.push(u);for(let[s,u]of S)t.has(s)||m.push(u);return{removed:n,added:m}}e.diffMaps=C;class T{constructor(){this.map=new Map}add(S,n){let m=this.map.get(S);m||(m=new Set,this.map.set(S,m)),m.add(n)}delete(S,n){const m=this.map.get(S);!m||(m.delete(n),m.size===0&&this.map.delete(S))}forEach(S,n){const m=this.map.get(S);!m||m.forEach(n)}}e.SetMap=T}),define(be[53],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(F){return(P,C,T)=>{let t=null,S=null;if(typeof T.value=="function"?(t="value",S=T.value):typeof T.get=="function"&&(t="get",S=T.get),!S)throw new Error("not supported");T[t]=F(S,C)}}e.createDecorator=d;function M(F,P,C){let T=null,t=null;if(typeof C.value=="function"?(T="value",t=C.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(T="get",t=C.get),!t)throw new Error("not supported");const S=`$memoize$${P}`;C[T]=function(...n){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[S]}}e.memoize=M;function _(F,P,C){return d((T,t)=>{const S=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...m){this[n]||(this[n]=C?C():void 0),clearTimeout(this[S]),P&&(this[n]=P(this[n],...m),m=[this[n]]),this[S]=setTimeout(()=>{T.apply(this,m),this[n]=C?C():void 0},F)}})}e.debounce=_;function A(F,P,C){return d((T,t)=>{const S=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,m=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...u){if(this[n]||(this[n]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[n]=P(this[n],...u)),this[s])return;const p=this[m]+F;p<=Date.now()?(this[m]=Date.now(),T.apply(this,[this[n]]),this[n]=C?C():void 0):(this[s]=!0,this[S]=setTimeout(()=>{this[s]=!1,this[m]=Date.now(),T.apply(this,[this[n]]),this[n]=C?C():void 0},p-Date.now()))}})}e.throttle=A}),define(be[14],Ee([0,1,16]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(j,le=0){return j[j.length-(1+le)]}e.tail=M;function _(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=_;function A(j,le,re=(ve,Fe)=>ve===Fe){if(j===le)return!0;if(!j||!le||j.length!==le.length)return!1;for(let ve=0,Fe=j.length;ve<Fe;ve++)if(!re(j[ve],le[ve]))return!1;return!0}e.equals=A;function F(j,le,re){let ve=0,Fe=j.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Oe=re(j[Me],le);if(Oe<0)ve=Me+1;else if(Oe>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function P(j,le){let re=0,ve=j.length;if(ve===0)return 0;for(;re<ve;){const Fe=Math.floor((re+ve)/2);le(j[Fe])?ve=Fe:re=Fe+1}return re}e.findFirstInSorted=P;function C(j,le,re){if(j=j|0,j>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Oe=[];for(let Ke of le){const je=re(Ke,ve);je<0?Fe.push(Ke):je>0?Me.push(Ke):Oe.push(Ke)}return j<Fe.length?C(j,Fe,re):j<Fe.length+Oe.length?Oe[0]:C(j-(Fe.length+Oe.length),Me,re)}e.quickSelect=C;function T(j,le){const re=[];let ve;for(const Fe of j.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],re.push(ve)):ve.push(Fe);return re}e.groupBy=T;function t(j,le,re){const ve=[];function Fe(Ke,je,Ve){if(je===0&&Ve.length===0)return;const $=ve[ve.length-1];$&&$.start+$.deleteCount===Ke?($.deleteCount+=je,$.toInsert.push(...Ve)):ve.push({start:Ke,deleteCount:je,toInsert:Ve})}let Me=0,Oe=0;for(;;){if(Me===j.length){Fe(Me,0,le.slice(Oe));break}if(Oe===le.length){Fe(Me,j.length-Me,[]);break}const Ke=j[Me],je=le[Oe],Ve=re(Ke,je);Ve===0?(Me+=1,Oe+=1):Ve<0?(Fe(Me,1,[]),Me+=1):Ve>0&&(Fe(Me,0,[je]),Oe+=1)}return ve}e.sortedDiff=t;function S(j,le,re){const ve=t(j,le,re),Fe=[],Me=[];for(const Oe of ve)Fe.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:Fe,added:Me}}e.delta=S;function n(j,le,re){if(re===0)return[];const ve=j.slice(0,re).sort(le);return s(j,le,ve,re,j.length),ve}e.top=n;function m(j,le,re,ve,Fe){return re===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const Ke=j.length,je=j.slice(0,re).sort(le);for(let Ve=re,$=Math.min(re+ve,Ke);Ve<Ke;Ve=$,$=Math.min($+ve,Ke)){if(Ve>re&&await new Promise(Q=>setTimeout(Q)),Fe&&Fe.isCancellationRequested)throw(0,d.canceled)();s(j,le,je,Ve,$)}return je})().then(Me,Oe)})}e.topAsync=m;function s(j,le,re,ve,Fe){for(const Me=re.length;ve<Fe;ve++){const Oe=j[ve];if(le(Oe,re[Me-1])<0){re.pop();const Ke=P(re,je=>le(Oe,je)<0);re.splice(Ke,0,Oe)}}}function u(j){return j.filter(le=>!!le)}e.coalesce=u;function p(j){let le=0;for(let re=0;re<j.length;re++)j[re]&&(j[le]=j[re],le+=1);j.length=le}e.coalesceInPlace=p;function k(j,le,re){j.splice(re,0,j.splice(le,1)[0])}e.move=k;function w(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=w;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function h(j,le=re=>re){const re=new Set;return j.filter(ve=>{const Fe=le(ve);return re.has(Fe)?!1:(re.add(Fe),!0)})}e.distinct=h;function D(j){const le=Object.create(null);return re=>{const ve=j(re);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=D;function i(j,le){const re=g(j,le);if(re!==-1)return j[re]}e.findLast=i;function g(j,le){for(let re=j.length-1;re>=0;re--){const ve=j[re];if(le(ve))return re}return-1}e.lastIndex=g;function a(j,le){return j.length>0?j[0]:le}e.firstOrDefault=a;function r(j,le,re=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(j.length,le.length);Fe<Me&&re(j[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=r;function v(j){return[].concat(...j)}e.flatten=v;function l(j,le){let re=typeof le=="number"?j:0;typeof le=="number"?re=j:(re=0,le=j);const ve=[];if(re<=le)for(let Fe=re;Fe<le;Fe++)ve.push(Fe);else for(let Fe=re;Fe>le;Fe--)ve.push(Fe);return ve}e.range=l;function c(j,le,re){return j.reduce((ve,Fe)=>(ve[le(Fe)]=re?re(Fe):Fe,ve),Object.create(null))}e.index=c;function b(j,le){return j.push(le),()=>f(j,le)}e.insert=b;function f(j,le){const re=j.indexOf(le);if(re>-1)return j.splice(re,1),le}e.remove=f;function y(j,le,re){const ve=j.slice(0,le),Fe=j.slice(le);return ve.concat(re,Fe)}e.arrayInsert=y;function R(j,le){let re;if(typeof le=="number"){let ve=le;re=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else re=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Fe=Math.floor(re()*(ve+1)),Me=j[ve];j[ve]=j[Fe],j[Fe]=Me}}e.shuffle=R;function I(j,le){const re=j.indexOf(le);re>-1&&(j.splice(re,1),j.unshift(le))}e.pushToStart=I;function L(j,le){const re=j.indexOf(le);re>-1&&(j.splice(re,1),j.push(le))}e.pushToEnd=L;function E(j,le){return Array.isArray(j)?j.map(le):le(j)}e.mapArrayOrNot=E;function N(j){return Array.isArray(j)?j:[j]}e.asArray=N;function U(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=U;function B(j,le){for(const re of j){const ve=le(re);if(ve!==void 0)return ve}}e.mapFind=B;function G(j,le,re){const ve=W(j,le),Fe=j.length,Me=re.length;j.length=Fe+Me;for(let Oe=Fe-1;Oe>=ve;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+ve]=re[Oe]}e.insertInto=G;function H(j,le,re,ve){const Fe=W(j,le),Me=j.splice(Fe,re);return G(j,Fe,ve),Me}e.splice=H;function W(j,le){return le<0?Math.max(le+j.length,0):Math.min(le,j.length)}function ne(j,le){let re=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=le(Fe);Oe<re&&(re=Oe,ve=Me)}),ve}e.minIndex=ne;function V(j,le){let re=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=le(Fe);Oe>re&&(re=Oe,ve=Me)}),ve}e.maxIndex=V;class Y{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let re=this.firstIdx;for(;re<this.items.length&&le(this.items[re]);)re++;const ve=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,ve}takeFromEndWhile(le){let re=this.lastIdx;for(;re>=0&&le(this.items[re]);)re--;const ve=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,ve}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=Y}),define(be[54],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(be[102],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function F(i,g=!1){let a=0,r=i.length,v="",l=0,c=16,b=0;function f(U){let B=0,G=0;for(;B<U;){const H=i.charCodeAt(a);if(H>=48&&H<=57)G=G*16+H-48;else if(H>=65&&H<=70)G=G*16+H-65+10;else if(H>=97&&H<=102)G=G*16+H-97+10;else break;a++,B++}return B<U&&(G=-1),G}function y(U){a=U,v="",l=0,c=16,b=0}function R(){const U=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&T(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&T(i.charCodeAt(a)))for(a++;a<i.length&&T(i.charCodeAt(a));)a++;else return b=3,i.substring(U,a);let B=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&T(i.charCodeAt(a))){for(a++;a<i.length&&T(i.charCodeAt(a));)a++;B=a}else b=3;return i.substring(U,B)}function I(){let U="",B=a;for(;;){if(a>=r){U+=i.substring(B,a),b=2;break}const G=i.charCodeAt(a);if(G===34){U+=i.substring(B,a),a++;break}if(G===92){if(U+=i.substring(B,a),a++,a>=r){b=2;break}switch(i.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:const W=f(4);W>=0?U+=String.fromCharCode(W):b=4;break;default:b=5}B=a;continue}if(G>=0&&G<=31)if(C(G)){U+=i.substring(B,a),b=2;break}else b=6;a++}return U}function L(){if(v="",b=0,l=a,a>=r)return l=r,c=17;let U=i.charCodeAt(a);if(P(U)){do a++,v+=String.fromCharCode(U),U=i.charCodeAt(a);while(P(U));return c=15}if(C(U))return a++,v+=String.fromCharCode(U),U===13&&i.charCodeAt(a)===10&&(a++,v+=`
`),c=14;switch(U){case 123:return a++,c=1;case 125:return a++,c=2;case 91:return a++,c=3;case 93:return a++,c=4;case 58:return a++,c=6;case 44:return a++,c=5;case 34:return a++,v=I(),c=10;case 47:const B=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<r&&!C(i.charCodeAt(a));)a++;return v=i.substring(B,a),c=12}if(i.charCodeAt(a+1)===42){a+=2;const G=r-1;let H=!1;for(;a<G;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,b=1),v=i.substring(B,a),c=13}return v+=String.fromCharCode(U),a++,c=16;case 45:if(v+=String.fromCharCode(U),a++,a===r||!T(i.charCodeAt(a)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=R(),c=11;default:for(;a<r&&E(U);)a++,U=i.charCodeAt(a);if(l!==a){switch(v=i.substring(l,a),v){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return v+=String.fromCharCode(U),a++,c=16}}function E(U){if(P(U)||C(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let U;do U=L();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>a,scan:g?N:L,getToken:()=>c,getTokenValue:()=>v,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>b}}e.createScanner=F;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function S(i,g){const a=[],r=new Object;let v;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function b(f,y,R,I){l.value=f,l.offset=y,l.length=R,l.type=I,l.colonOffset=void 0,v=l}try{o(i,{onObjectBegin:(f,y)=>{if(g<=f)throw r;v=void 0,c=g>f,a.push("")},onObjectProperty:(f,y,R)=>{if(g<y||(b(f,y,R,"property"),a[a.length-1]=f,g<=y+R))throw r},onObjectEnd:(f,y)=>{if(g<=f)throw r;v=void 0,a.pop()},onArrayBegin:(f,y)=>{if(g<=f)throw r;v=void 0,a.push(0)},onArrayEnd:(f,y)=>{if(g<=f)throw r;v=void 0,a.pop()},onLiteralValue:(f,y,R)=>{if(g<y||(b(f,y,R,D(f)),g<=y+R))throw r},onSeparator:(f,y,R)=>{if(g<=y)throw r;if(f===":"&&v&&v.type==="property")v.colonOffset=y,c=!1,v=void 0;else if(f===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(c=!0,a[a.length-1]=""),v=void 0}}})}catch(f){if(f!==r)throw f}return{path:a,previousNode:v,isAtPropertyKey:c,matches:f=>{let y=0;for(let R=0;y<f.length&&R<a.length;R++)if(f[y]===a[R]||f[y]==="*")y++;else if(f[y]!=="**")return!1;return y===f.length}}}e.getLocation=S;function n(i,g=[],a=A.DEFAULT){let r=null,v=[];const l=[];function c(f){Array.isArray(v)?v.push(f):r!==null&&(v[r]=f)}return o(i,{onObjectBegin:()=>{const f={};c(f),l.push(v),v=f,r=null},onObjectProperty:f=>{r=f},onObjectEnd:()=>{v=l.pop()},onArrayBegin:()=>{const f=[];c(f),l.push(v),v=f,r=null},onArrayEnd:()=>{v=l.pop()},onLiteralValue:c,onError:(f,y,R)=>{g.push({error:f,offset:y,length:R})}},a),v[0]}e.parse=n;function m(i,g=[],a=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(f){r.type==="property"&&(r.length=f-r.offset,r=r.parent)}function l(f){return r.children.push(f),f}o(i,{onObjectBegin:f=>{r=l({type:"object",offset:f,length:-1,parent:r,children:[]})},onObjectProperty:(f,y,R)=>{r=l({type:"property",offset:y,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:f,offset:y,length:R,parent:r})},onObjectEnd:(f,y)=>{r.length=f+y-r.offset,r=r.parent,v(f+y)},onArrayBegin:(f,y)=>{r=l({type:"array",offset:f,length:-1,parent:r,children:[]})},onArrayEnd:(f,y)=>{r.length=f+y-r.offset,r=r.parent,v(f+y)},onLiteralValue:(f,y,R)=>{l({type:D(f),offset:y,length:R,parent:r,value:f}),v(y+R)},onSeparator:(f,y,R)=>{r.type==="property"&&(f===":"?r.colonOffset=y:f===","&&v(y))},onError:(f,y,R)=>{g.push({error:f,offset:y,length:R})}},a);const b=r.children[0];return b&&delete b.parent,b}e.parseTree=m;function s(i,g){if(!i)return;let a=i;for(let r of g)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===r){a=l.children[1],v=!0;break}if(!v)return}else{const v=r;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}e.findNodeAtLocation=s;function u(i){if(!i.parent||!i.parent.children)return[];const g=u(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;g.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&g.push(a)}return g}e.getNodePath=u;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":const g=Object.create(null);for(let a of i.children){const r=a.children[1];r&&(g[a.children[0].value]=p(r))}return g;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function k(i,g,a=!1){return g>=i.offset&&g<i.offset+i.length||a&&g===i.offset+i.length}e.contains=k;function w(i,g,a=!1){if(k(i,g,a)){const r=i.children;if(Array.isArray(r))for(let v=0;v<r.length&&r[v].offset<=g;v++){const l=w(r[v],g,a);if(l)return l}return i}}e.findNodeAtOffset=w;function o(i,g,a=A.DEFAULT){const r=F(i,!1);function v(re){return re?()=>re(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(re){return re?ve=>re(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const c=v(g.onObjectBegin),b=l(g.onObjectProperty),f=v(g.onObjectEnd),y=v(g.onArrayBegin),R=v(g.onArrayEnd),I=l(g.onLiteralValue),L=l(g.onSeparator),E=v(g.onComment),N=l(g.onError),U=a&&a.disallowComments,B=a&&a.allowTrailingComma;function G(){for(;;){const re=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:U||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(re){case 12:case 13:U?H(10):E();break;case 16:H(1);break;case 15:case 14:break;default:return re}}}function H(re,ve=[],Fe=[]){if(N(re),ve.length+Fe.length>0){let Me=r.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){G();break}else if(Fe.indexOf(Me)!==-1)break;Me=G()}}}function W(re){const ve=r.getTokenValue();return re?I(ve):b(ve),G(),!0}function ne(){switch(r.getToken()){case 11:let re=0;try{re=JSON.parse(r.getTokenValue()),typeof re!="number"&&(H(2),re=0)}catch(ve){H(2)}I(re);break;case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return G(),!0}function V(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(L(":"),G(),le()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){c(),G();let re=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),L(","),G(),r.getToken()===2&&B)break}else re&&H(6,[],[]);V()||H(4,[],[2,5]),re=!0}return f(),r.getToken()!==2?H(7,[2],[]):G(),!0}function j(){y(),G();let re=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),L(","),G(),r.getToken()===4&&B)break}else re&&H(6,[],[]);le()||H(4,[],[4,5]),re=!0}return R(),r.getToken()!==4?H(8,[4],[]):G(),!0}function le(){switch(r.getToken()){case 3:return j();case 1:return Y();case 10:return W(!0);default:return ne()}}return G(),r.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):le()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=o;function h(i,g){let a=F(i),r=[],v,l=0,c;do switch(c=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:l!==c&&r.push(i.substring(l,c)),g!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,g)),l=a.getPosition();break}while(v!==17);return r.join("")}e.stripComments=h;function D(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(be[103],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(_){this.executor=_,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(_){return new d(()=>_(this.getValue()))}}e.Lazy=d}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(Pe,Se){for(var Ce=0;Ce<Se.length;Ce++){var te=Se[Ce];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Pe,te.key,te)}}function e(Pe,Se,Ce){return Se&&oe(Pe.prototype,Se),Ce&&oe(Pe,Ce),Pe}function d(Pe,Se){if(!!Pe){if(typeof Pe=="string")return M(Pe,Se);var Ce=Object.prototype.toString.call(Pe).slice(8,-1);if(Ce==="Object"&&Pe.constructor&&(Ce=Pe.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Pe);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Pe,Se)}}function M(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ce=0,te=new Array(Se);Ce<Se;Ce++)te[Ce]=Pe[Ce];return te}function _(Pe,Se){var Ce=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ce)return(Ce=Ce.call(Pe)).next.bind(Ce);if(Array.isArray(Pe)||(Ce=d(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ce&&(Pe=Ce);var te=0;return function(){return te>=Pe.length?{done:!0}:{done:!1,value:Pe[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Pe){A.exports.defaults=Pe}A.exports={defaults:F(),getDefaults:F,changeDefaults:P};var C=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(Se){return n[Se]};function s(Pe,Se){if(Se){if(C.test(Pe))return Pe.replace(T,m)}else if(t.test(Pe))return Pe.replace(S,m);return Pe}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Pe){return Pe.replace(u,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var k=/(^|[^\[])\^/g;function w(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var Ce={replace:function(ue,me){return me=me.source||me,me=me.replace(k,"$1"),Pe=Pe.replace(ue,me),Ce},getRegex:function(){return new RegExp(Pe,Se)}};return Ce}var o=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Pe,Se,Ce){if(Pe){var te;try{te=decodeURIComponent(p(Ce)).replace(o,"").toLowerCase()}catch(ue){return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}Se&&!h.test(Ce)&&(Ce=v(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ue){return null}return Ce}var i={},g=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Pe,Se){i[" "+Pe]||(g.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=f(Pe,"/",!0)),Pe=i[" "+Pe];var Ce=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:Pe.replace(a,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:Pe.replace(r,"$1")+Se:Pe+Se}var l={exec:function(){}};function c(Pe){for(var Se=1,Ce,te;Se<arguments.length;Se++){Ce=arguments[Se];for(te in Ce)Object.prototype.hasOwnProperty.call(Ce,te)&&(Pe[te]=Ce[te])}return Pe}function b(Pe,Se){var Ce=Pe.replace(/\|/g,function(me,fe,Ie){for(var Be=!1,Ne=fe;--Ne>=0&&Ie[Ne]==="\\";)Be=!Be;return Be?"|":" |"}),te=Ce.split(/ \|/),ue=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>Se)te.splice(Se);else for(;te.length<Se;)te.push("");for(;ue<te.length;ue++)te[ue]=te[ue].trim().replace(/\\\|/g,"|");return te}function f(Pe,Se,Ce){var te=Pe.length;if(te===0)return"";for(var ue=0;ue<te;){var me=Pe.charAt(te-ue-1);if(me===Se&&!Ce)ue++;else if(me!==Se&&Ce)ue++;else break}return Pe.substr(0,te-ue)}function y(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ce=Pe.length,te=0,ue=0;ue<Ce;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===Se[0])te++;else if(Pe[ue]===Se[1]&&(te--,te<0))return ue;return-1}function R(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Pe,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=Pe),Se>>=1,Pe+=Pe;return Ce+Pe}var L={escape:s,unescape:p,edit:w,cleanUrl:D,resolveUrl:v,noopTest:l,merge:c,splitCells:b,rtrim:f,findClosingBracket:y,checkSanitizeDeprecation:R,repeatString:I},E=A.exports.defaults,N=L.rtrim,U=L.splitCells,B=L.escape,G=L.findClosingBracket;function H(Pe,Se,Ce,te){var ue=Se.href,me=Se.title?B(Se.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){te.state.inLink=!0;var Ie={type:"link",raw:Ce,href:ue,title:me,text:fe,tokens:te.inlineTokens(fe,[])};return te.state.inLink=!1,Ie}else return{type:"image",raw:Ce,href:ue,title:me,text:B(fe)}}function W(Pe,Se){var Ce=Pe.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var te=Ce[1];return Se.split(`
`).map(function(ue){var me=ue.match(/^\s+/);if(me===null)return ue;var fe=me[0];return fe.length>=te.length?ue.slice(te.length):ue}).join(`
`)}var ne=function(){function Pe(Ce){this.options=Ce||E}var Se=Pe.prototype;return Se.space=function(te){var ue=this.rules.block.newline.exec(te);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Se.code=function(te){var ue=this.rules.block.code.exec(te);if(ue){var me=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?me:N(me,`
`)}}},Se.fences=function(te){var ue=this.rules.block.fences.exec(te);if(ue){var me=ue[0],fe=W(me,ue[3]||"");return{type:"code",raw:me,lang:ue[2]?ue[2].trim():ue[2],text:fe}}},Se.heading=function(te){var ue=this.rules.block.heading.exec(te);if(ue){var me=ue[2].trim();if(/#$/.test(me)){var fe=N(me,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(me=fe.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:me,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(te){var ue=this.rules.block.hr.exec(te);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(te){var ue=this.rules.block.blockquote.exec(te);if(ue){var me=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},Se.list=function(te){var ue=this.rules.block.list.exec(te);if(ue){var me,fe,Ie,Be,Ne,qe,it,Le,de,ge,X=ue[1].trim(),z=X.length>1,we={type:"list",raw:"",ordered:z,start:z?+X.slice(0,-1):"",loose:!1,items:[]};X=z?"\\d{1,9}\\"+X.slice(-1):"\\"+X,this.options.pedantic&&(X=z?X:"[*+-]");for(var ke=new RegExp("^( {0,3}"+X+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(ue=ke.exec(te)));){de=ue[2].split(`
`),this.options.pedantic?(Be=2,ge=de[0].trimLeft()):(Be=ue[2].search(/[^ ]/),Be=ue[1].length+(Be>4?1:Be),ge=de[0].slice(Be-ue[1].length)),qe=!1,me=ue[0],!de[0]&&/^ *$/.test(de[1])&&(me=ue[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ne=1;Ne<de.length;Ne++){if(Le=de[Ne],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}if(!qe){Le.trim()||(qe=!0),Le.search(/[^ ]/)>=Be?ge+=`
`+Le.slice(Be):ge+=`
`+Le;continue}if(Le.search(/[^ ]/)>=Be||!Le.trim()){ge+=`
`+Le.slice(Be);continue}else{me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(me)&&(it=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(ge),fe&&(Ie=fe[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:me,task:!!fe,checked:Ie,loose:!1,text:ge}),we.raw+=me,te=te.slice(me.length)}we.items[we.items.length-1].raw=me.trimRight(),we.items[we.items.length-1].text=ge.trimRight(),we.raw=we.raw.trimRight();var xe=we.items.length;for(Ne=0;Ne<xe;Ne++)this.lexer.state.top=!1,we.items[Ne].tokens=this.lexer.blockTokens(we.items[Ne].text,[]),we.items[Ne].tokens.some(function(ct){return ct.type==="space"})&&(we.loose=!0,we.items[Ne].loose=!0);return we}},Se.html=function(te){var ue=this.rules.block.html.exec(te);if(ue){var me={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(me.type="paragraph",me.text=this.options.sanitizer?this.options.sanitizer(ue[0]):B(ue[0]),me.tokens=[],this.lexer.inline(me.text,me.tokens)),me}},Se.def=function(te){var ue=this.rules.block.def.exec(te);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var me=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(te){var ue=this.rules.block.table.exec(te);if(ue){var me={type:"table",header:U(ue[1]).map(function(it){return{text:it}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ue[0];var fe=me.align.length,Ie,Be,Ne,qe;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(me.align[Ie])?me.align[Ie]="right":/^ *:-+: *$/.test(me.align[Ie])?me.align[Ie]="center":/^ *:-+ *$/.test(me.align[Ie])?me.align[Ie]="left":me.align[Ie]=null;for(fe=me.rows.length,Ie=0;Ie<fe;Ie++)me.rows[Ie]=U(me.rows[Ie],me.header.length).map(function(it){return{text:it}});for(fe=me.header.length,Be=0;Be<fe;Be++)me.header[Be].tokens=[],this.lexer.inlineTokens(me.header[Be].text,me.header[Be].tokens);for(fe=me.rows.length,Be=0;Be<fe;Be++)for(qe=me.rows[Be],Ne=0;Ne<qe.length;Ne++)qe[Ne].tokens=[],this.lexer.inlineTokens(qe[Ne].text,qe[Ne].tokens);return me}}},Se.lheading=function(te){var ue=this.rules.block.lheading.exec(te);if(ue){var me={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.paragraph=function(te){var ue=this.rules.block.paragraph.exec(te);if(ue){var me={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.text=function(te){var ue=this.rules.block.text.exec(te);if(ue){var me={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.escape=function(te){var ue=this.rules.inline.escape.exec(te);if(ue)return{type:"escape",raw:ue[0],text:B(ue[1])}},Se.tag=function(te){var ue=this.rules.inline.tag.exec(te);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):B(ue[0]):ue[0]}},Se.link=function(te){var ue=this.rules.inline.link.exec(te);if(ue){var me=ue[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var fe=N(me.slice(0,-1),"\\");if((me.length-fe.length)%2==0)return}else{var Ie=G(ue[2],"()");if(Ie>-1){var Be=ue[0].indexOf("!")===0?5:4,Ne=Be+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Ne).trim(),ue[3]=""}}var qe=ue[2],it="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Le&&(qe=Le[1],it=Le[3])}else it=ue[3]?ue[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(me)?qe=qe.slice(1):qe=qe.slice(1,-1)),H(ue,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(te,ue){var me;if((me=this.rules.inline.reflink.exec(te))||(me=this.rules.inline.nolink.exec(te))){var fe=(me[2]||me[1]).replace(/\s+/g," ");if(fe=ue[fe.toLowerCase()],!fe||!fe.href){var Ie=me[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(me,fe,me[0],this.lexer)}},Se.emStrong=function(te,ue,me){me===void 0&&(me="");var fe=this.rules.inline.emStrong.lDelim.exec(te);if(!!fe&&!(fe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(me===""||this.rules.inline.punctuation.exec(me))){var Be=fe[0].length-1,Ne,qe,it=Be,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*te.length+Be);(fe=de.exec(ue))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(qe=Ne.length,fe[3]||fe[4]){it+=qe;continue}else if((fe[5]||fe[6])&&Be%3&&!((Be+qe)%3)){Le+=qe;continue}if(it-=qe,!(it>0)){if(qe=Math.min(qe,qe+it+Le),Math.min(Be,qe)%2){var ge=te.slice(1,Be+fe.index+qe);return{type:"em",raw:te.slice(0,Be+fe.index+qe+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var X=te.slice(2,Be+fe.index+qe-1);return{type:"strong",raw:te.slice(0,Be+fe.index+qe+1),text:X,tokens:this.lexer.inlineTokens(X,[])}}}}}},Se.codespan=function(te){var ue=this.rules.inline.code.exec(te);if(ue){var me=ue[2].replace(/\n/g," "),fe=/[^ ]/.test(me),Ie=/^ /.test(me)&&/ $/.test(me);return fe&&Ie&&(me=me.substring(1,me.length-1)),me=B(me,!0),{type:"codespan",raw:ue[0],text:me}}},Se.br=function(te){var ue=this.rules.inline.br.exec(te);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(te){var ue=this.rules.inline.del.exec(te);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Se.autolink=function(te,ue){var me=this.rules.inline.autolink.exec(te);if(me){var fe,Ie;return me[2]==="@"?(fe=B(this.options.mangle?ue(me[1]):me[1]),Ie="mailto:"+fe):(fe=B(me[1]),Ie=fe),{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.url=function(te,ue){var me;if(me=this.rules.inline.url.exec(te)){var fe,Ie;if(me[2]==="@")fe=B(this.options.mangle?ue(me[0]):me[0]),Ie="mailto:"+fe;else{var Be;do Be=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(Be!==me[0]);fe=B(me[0]),me[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.inlineText=function(te,ue){var me=this.rules.inline.text.exec(te);if(me){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):B(me[0]):me[0]:fe=B(this.options.smartypants?ue(me[0]):me[0]),{type:"text",raw:me[0],text:fe}}},Pe}(),V=L.noopTest,Y=L.edit,j=L.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:V,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=Y(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=Y(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=Y(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=Y(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=Y(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=Y(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=Y(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:Y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:V,paragraph:Y(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:V,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:V,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=Y(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=Y(le._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=Y(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=Y(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=Y(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=Y(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=Y(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=Y(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=Y(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=Y(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=j({},re),re.pedantic=j({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Y(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:Y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=j({},re.normal,{escape:Y(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=Y(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=j({},re.gfm,{br:Y(re.br).replace("{2,}","*").getRegex(),text:Y(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:re},Fe=ne,Me=A.exports.defaults,Oe=ve.block,Ke=ve.inline,je=L.repeatString;function Ve(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Pe){var Se="",Ce,te,ue=Pe.length;for(Ce=0;Ce<ue;Ce++)te=Pe.charCodeAt(Ce),Math.random()>.5&&(te="x"+te.toString(16)),Se+="&#"+te+";";return Se}var Q=function(){function Pe(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:Oe.normal,inline:Ke.normal};this.options.pedantic?(te.block=Oe.pedantic,te.inline=Ke.pedantic):this.options.gfm&&(te.block=Oe.gfm,this.options.breaks?te.inline=Ke.breaks:te.inline=Ke.gfm),this.tokenizer.rules=te}Pe.lex=function(te,ue){var me=new Pe(ue);return me.lex(te)},Pe.lexInline=function(te,ue){var me=new Pe(ue);return me.inlineTokens(te)};var Se=Pe.prototype;return Se.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(te,ue){var me=this;ue===void 0&&(ue=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var fe,Ie,Be,Ne;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(fe=it.call({lexer:me},te,ue))?(te=te.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.space(te)){te=te.substring(fe.raw.length),fe.type&&ue.push(fe);continue}if(fe=this.tokenizer.code(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(fe=this.tokenizer.fences(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.heading(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.hr(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.blockquote(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.list(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.html(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.def(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.lheading(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(Be=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Le=te.slice(1),de=void 0;me.options.extensions.startBlock.forEach(function(ge){de=ge.call({lexer:this},Le),typeof de=="number"&&de>=0&&(it=Math.min(it,de))}),it<Infinity&&it>=0&&(Be=te.substring(0,it+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(Be))){Ie=ue[ue.length-1],Ne&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe),Ne=Be.length!==te.length,te=te.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(te){var qe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return this.state.top=!0,ue},Se.inline=function(te,ue){this.inlineQueue.push({src:te,tokens:ue})},Se.inlineTokens=function(te,ue){var me=this;ue===void 0&&(ue=[]);var fe,Ie,Be,Ne=te,qe,it,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)de.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,qe.index)+"["+je("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"["+je("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(it||(Le=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(fe=X.call({lexer:me},te,ue))?(te=te.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.tag(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.link(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.emStrong(te,Ne,Le)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.codespan(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.br(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.del(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.autolink(te,$)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(te,$))){te=te.substring(fe.raw.length),ue.push(fe);continue}if(Be=te,this.options.extensions&&this.options.extensions.startInline&&function(){var X=Infinity,z=te.slice(1),we=void 0;me.options.extensions.startInline.forEach(function(ke){we=ke.call({lexer:this},z),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<Infinity&&X>=0&&(Be=te.substring(0,X+1))}(),fe=this.tokenizer.inlineText(Be,Ve)){te=te.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),it=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(te){var ge="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ke}}}]),Pe}(),ee=A.exports.defaults,ae=L.cleanUrl,K=L.escape,se=function(){function Pe(Ce){this.options=Ce||ee}var Se=Pe.prototype;return Se.code=function(te,ue,me){var fe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(te,fe);Ie!=null&&Ie!==te&&(me=!0,te=Ie)}return te=te.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+K(fe,!0)+'">'+(me?te:K(te,!0))+`</code></pre>
`:"<pre><code>"+(me?te:K(te,!0))+`</code></pre>
`},Se.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},Se.html=function(te){return te},Se.heading=function(te,ue,me,fe){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+fe.slug(me)+'">'+te+"</h"+ue+`>
`:"<h"+ue+">"+te+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(te,ue,me){var fe=ue?"ol":"ul",Ie=ue&&me!==1?' start="'+me+'"':"";return"<"+fe+Ie+`>
`+te+"</"+fe+`>
`},Se.listitem=function(te){return"<li>"+te+`</li>
`},Se.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(te){return"<p>"+te+`</p>
`},Se.table=function(te,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ue+`</table>
`},Se.tablerow=function(te){return`<tr>
`+te+`</tr>
`},Se.tablecell=function(te,ue){var me=ue.header?"th":"td",fe=ue.align?"<"+me+' align="'+ue.align+'">':"<"+me+">";return fe+te+"</"+me+`>
`},Se.strong=function(te){return"<strong>"+te+"</strong>"},Se.em=function(te){return"<em>"+te+"</em>"},Se.codespan=function(te){return"<code>"+te+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(te){return"<del>"+te+"</del>"},Se.link=function(te,ue,me){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return me;var fe='<a href="'+K(te)+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=">"+me+"</a>",fe},Se.image=function(te,ue,me){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return me;var fe='<img src="'+te+'" alt="'+me+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=this.options.xhtml?"/>":">",fe},Se.text=function(te){return te},Pe}(),he=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(te){return te},Se.em=function(te){return te},Se.codespan=function(te){return te},Se.del=function(te){return te},Se.html=function(te){return te},Se.text=function(te){return te},Se.link=function(te,ue,me){return""+me},Se.image=function(te,ue,me){return""+me},Se.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(te,ue){var me=te,fe=0;if(this.seen.hasOwnProperty(me)){fe=this.seen[te];do fe++,me=te+"-"+fe;while(this.seen.hasOwnProperty(me))}return ue||(this.seen[te]=fe,this.seen[me]=0),me},Se.slug=function(te,ue){ue===void 0&&(ue={});var me=this.serialize(te);return this.getNextSafeSlug(me,ue.dryrun)},Pe}(),Ue=se,He=he,Qe=Ae,et=A.exports.defaults,st=L.unescape,ye=function(){function Pe(Ce){this.options=Ce||et,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Qe}Pe.parse=function(te,ue){var me=new Pe(ue);return me.parse(te)},Pe.parseInline=function(te,ue){var me=new Pe(ue);return me.parseInline(te)};var Se=Pe.prototype;return Se.parse=function(te,ue){ue===void 0&&(ue=!0);var me="",fe,Ie,Be,Ne,qe,it,Le,de,ge,X,z,we,ke,Je,xe,ct,pt,dt,ht,ft=te.length;for(fe=0;fe<ft;fe++){if(X=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(ht=this.options.extensions.renderers[X.type].call({parser:this},X),ht!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){me+=ht||"";continue}switch(X.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(X.tokens),X.depth,st(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(de="",Le="",Ne=X.header.length,Ie=0;Ie<Ne;Ie++)Le+=this.renderer.tablecell(this.parseInline(X.header[Ie].tokens),{header:!0,align:X.align[Ie]});for(de+=this.renderer.tablerow(Le),ge="",Ne=X.rows.length,Ie=0;Ie<Ne;Ie++){for(it=X.rows[Ie],Le="",qe=it.length,Be=0;Be<qe;Be++)Le+=this.renderer.tablecell(this.parseInline(it[Be].tokens),{header:!1,align:X.align[Be]});ge+=this.renderer.tablerow(Le)}me+=this.renderer.table(de,ge);continue}case"blockquote":{ge=this.parse(X.tokens),me+=this.renderer.blockquote(ge);continue}case"list":{for(z=X.ordered,we=X.start,ke=X.loose,Ne=X.items.length,ge="",Ie=0;Ie<Ne;Ie++)xe=X.items[Ie],ct=xe.checked,pt=xe.task,Je="",xe.task&&(dt=this.renderer.checkbox(ct),ke?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=dt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=dt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:dt}):Je+=dt),Je+=this.parse(xe.tokens,ke),ge+=this.renderer.listitem(Je,pt,ct);me+=this.renderer.list(ge,z,we);continue}case"html":{me+=this.renderer.html(X.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(ge=X.tokens?this.parseInline(X.tokens):X.text;fe+1<ft&&te[fe+1].type==="text";)X=te[++fe],ge+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);me+=ue?this.renderer.paragraph(ge):ge;continue}default:{var _t='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(_t);return}else throw new Error(_t)}}}return me},Se.parseInline=function(te,ue){ue=ue||this.renderer;var me="",fe,Ie,Be,Ne=te.length;for(fe=0;fe<Ne;fe++){if(Ie=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){me+=Be||"";continue}switch(Ie.type){case"escape":{me+=ue.text(Ie.text);break}case"html":{me+=ue.html(Ie.text);break}case"link":{me+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{me+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{me+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{me+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{me+=ue.codespan(Ie.text);break}case"br":{me+=ue.br();break}case"del":{me+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{me+=ue.text(Ie.text);break}default:{var qe='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(qe);return}else throw new Error(qe)}}}return me},Pe}(),nt=Q,q=ye,Z=ne,pe=se,We=he,Ye=Ae,rt=L.merge,mt=L.checkSanitizeDeprecation,ut=L.escape,St=A.exports.getDefaults,Tt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Pe,Se,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=rt({},Xe.defaults,Se||{}),mt(Se),Ce){var te=Se.highlight,ue;try{ue=nt.lex(Pe,Se)}catch(Be){return Ce(Be)}var me=function(Ne){var qe;if(!Ne)try{Se.walkTokens&&Xe.walkTokens(ue,Se.walkTokens),qe=q.parse(ue,Se)}catch(it){Ne=it}return Se.highlight=te,Ne?Ce(Ne):Ce(null,qe)};if(!te||te.length<3||(delete Se.highlight,!ue.length))return me();var fe=0;Xe.walkTokens(ue,function(Be){Be.type==="code"&&(fe++,setTimeout(function(){te(Be.text,Be.lang,function(Ne,qe){if(Ne)return me(Ne);qe!=null&&qe!==Be.text&&(Be.text=qe,Be.escaped=!0),fe--,fe===0&&me()})},0))}),fe===0&&me();return}try{var Ie=nt.lex(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ie,Se.walkTokens),q.parse(Ie,Se)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ut(Be.message+"",!0)+"</pre>";throw Be}}Xe.options=Xe.setOptions=function(Pe){return rt(Xe.defaults,Pe),Tt(Xe.defaults),Xe},Xe.getDefaults=St,Xe.defaults=It,Xe.use=function(){for(var Pe=this,Se=arguments.length,Ce=new Array(Se),te=0;te<Se;te++)Ce[te]=arguments[te];var ue=rt.apply(void 0,[{}].concat(Ce)),me=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var qe=me.renderers?me.renderers[Ne.name]:null;qe?me.renderers[Ne.name]=function(){for(var it=arguments.length,Le=new Array(it),de=0;de<it;de++)Le[de]=arguments[de];var ge=Ne.renderer.apply(this,Le);return ge===!1&&(ge=qe.apply(this,Le)),ge}:me.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[Ne.level]?me[Ne.level].unshift(Ne.tokenizer):me[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?me.startBlock?me.startBlock.push(Ne.start):me.startBlock=[Ne.start]:Ne.level==="inline"&&(me.startInline?me.startInline.push(Ne.start):me.startInline=[Ne.start]))}Ne.childTokens&&(me.childTokens[Ne.name]=Ne.childTokens)})),Ie.renderer&&function(){var Ne=Xe.defaults.renderer||new pe,qe=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.renderer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.renderer)qe(it);ue.renderer=Ne}(),Ie.tokenizer&&function(){var Ne=Xe.defaults.tokenizer||new Z,qe=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.tokenizer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.tokenizer)qe(it);ue.tokenizer=Ne}(),Ie.walkTokens){var Be=Xe.defaults.walkTokens;ue.walkTokens=function(Ne){Ie.walkTokens.call(Pe,Ne),Be&&Be(Ne)}}fe&&(ue.extensions=me),Xe.setOptions(ue)})},Xe.walkTokens=function(Pe,Se){for(var Ce=function(){var fe=ue.value;switch(Se(fe),fe.type){case"table":{for(var Ie=_(fe.header),Be;!(Be=Ie()).done;){var Ne=Be.value;Xe.walkTokens(Ne.tokens,Se)}for(var qe=_(fe.rows),it;!(it=qe()).done;)for(var Le=it.value,de=_(Le),ge;!(ge=de()).done;){var X=ge.value;Xe.walkTokens(X.tokens,Se)}break}case"list":{Xe.walkTokens(fe.items,Se);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(z){Xe.walkTokens(fe[z],Se)}):fe.tokens&&Xe.walkTokens(fe.tokens,Se)}},te=_(Pe),ue;!(ue=te()).done;)Ce()},Xe.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=rt({},Xe.defaults,Se||{}),mt(Se);try{var Ce=nt.lexInline(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ce,Se.walkTokens),q.parseInline(Ce,Se)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ut(te.message+"",!0)+"</pre>";throw te}},Xe.Parser=q,Xe.parser=q.parse,Xe.Renderer=pe,Xe.TextRenderer=We,Xe.Lexer=nt,Xe.lexer=nt.lex,Xe.Tokenizer=Z,Xe.Slugger=Ye,Xe.parse=Xe;var vt=Xe;return vt}),define(be[76],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(F,P,C){return Math.min(Math.max(F,P),C)}e.clamp=d;function M(F,P){return(P+F%P)%P}e.rot=M;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function oe(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function F(C){A.push(C,Date.now())}function P(){const C=[];for(let T=0;T<A.length;T+=2)C.push({name:A[T],startTime:A[T+1]});return C}return{mark:F,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(_+F.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function d(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(be[34],Ee([0,1,3]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(S){const n=this._icons.get(S.id);n?S.description?n.description=S.description:console.error(`Duplicate registration of codicon ${S.id}`):(this._icons.set(S.id,S),this._onDidRegister.fire(S))}get(S){return this._icons.get(S)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const _=new M;e.iconRegistry=_;function A(t,S){return new P(t,S)}e.registerCodicon=A;function F(t){return t?t.replace(/\$\((.*?)\)/g,(S,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class P{constructor(S,n,m){this.id=S,this.definition=n,this.description=m,_.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function C(t,S){const n=["codicon","codicon-"+t];return S&&n.push("codicon-modifier-"+S),n}e.getClassNamesArray=C;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const S=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(u){if(u instanceof P)return["codicon","codicon-"+u.id];const p=S.exec(u.id);if(!p)return n(P.error);let[,k,w]=p;const o=["codicon","codicon-"+k];return w&&o.push("codicon-modifier-"+w.substr(1)),o}t.asClassNameArray=n;function m(u){return n(u).join(" ")}t.asClassName=m;function s(u){return"."+n(u).join(".")}t.asCSSSelector=s})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"})}(P=e.Codicon||(e.Codicon={}))}),define(be[104],Ee([0,1,16,6]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(o){const h=o;return h?[h.on,h.pause,h.resume,h.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=_;function A(o){const h=o;return h?_(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=A;function F(o,h){return new P(o,h)}e.newWriteableStream=F;class P{constructor(h,D){this.reducer=h,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(D=>D(h))}emitError(h){this.listeners.error.length===0?(0,d.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(D=>D(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,D){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(h,D){if(this.state.destroyed)return;let i;switch(h){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const g=i.indexOf(D);g>=0&&i.splice(g,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(o,h){const D=[];let i;for(;(i=o.read())!==null;)D.push(i);return h(D)}e.consumeReadable=C;function T(o,h,D){const i=[];let g;for(;(g=o.read())!==null&&i.length<D;)i.push(g);return g===null&&i.length>0?h(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g!="undefined"){const a=g;return g=void 0,a}return o.read()}}}e.peekReadable=T;function t(o,h){return new Promise((D,i)=>{const g=[];S(o,{onData:a=>{h&&g.push(a)},onError:a=>{h?i(a):D(void 0)},onEnd:()=>{D(h?h(g):void 0)}})})}e.consumeStream=t;function S(o,h){o.on("error",D=>h.onError(D)),o.on("end",()=>h.onEnd()),o.on("data",D=>h.onData(D))}e.listenStream=S;function n(o,h){return new Promise((D,i)=>{const g=new M.DisposableStore,a=[],r=c=>{if(a.push(c),a.length>h)return g.dispose(),o.pause(),D({stream:o,buffer:a,ended:!1})},v=c=>i(c),l=()=>D({stream:o,buffer:a,ended:!0});g.add((0,M.toDisposable)(()=>o.removeListener("error",v))),o.on("error",v),g.add((0,M.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),g.add((0,M.toDisposable)(()=>o.removeListener("data",r))),o.on("data",r)})}e.peekStream=n;function m(o,h){const D=F(h);return D.end(o),D}e.toStream=m;function s(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=s;function u(o){let h=!1;return{read:()=>h?null:(h=!0,o)}}e.toReadable=u;function p(o,h,D){const i=F(D);return S(o,{onData:g=>i.write(h.data(g)),onError:g=>i.error(h.error?h.error(g):g),onEnd:()=>i.end()}),i}e.transform=p;function k(o,h,D){let i=!1;return{read:()=>{const g=h.read();return i?g:(i=!0,g!==null?D([o,g]):o)}}}e.prefixedReadable=k;function w(o,h,D){let i=!1;const g=F(D);return S(h,{onData:a=>i?g.write(a):(i=!0,g.write(D([o,a]))),onError:a=>g.error(a),onEnd:()=>{i||(i=!0,g.write(o)),g.end()}}),g}e.prefixedStream=w}),define(be[22],Ee([0,1,104]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let _,A;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return M?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return M&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,v){return!(v?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(r)):(_||(_=new TextEncoder),new F(_.encode(r)))}static concat(r,v){if(typeof v=="undefined"){v=0;for(let b=0,f=r.length;b<f;b++)v+=r[b].byteLength}const l=F.alloc(v);let c=0;for(let b=0,f=r.length;b<f;b++){const y=r[b];l.set(y,c),c+=y.byteLength}return l}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,v){return new F(this.buffer.subarray(r,v))}set(r,v){r instanceof F?this.buffer.set(r.buffer,v):this.buffer.set(r,v)}readUInt32BE(r){return T(this.buffer,r)}writeUInt32BE(r,v){t(this.buffer,r,v)}readUInt32LE(r){return S(this.buffer,r)}writeUInt32LE(r,v){n(this.buffer,r,v)}readUInt8(r){return m(this.buffer,r)}writeUInt8(r,v){s(this.buffer,r,v)}}e.VSBuffer=F;function P(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}e.readUInt16LE=P;function C(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255}e.writeUInt16LE=C;function T(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}e.readUInt32BE=T;function t(a,r,v){a[v+3]=r,r=r>>>8,a[v+2]=r,r=r>>>8,a[v+1]=r,r=r>>>8,a[v]=r}e.writeUInt32BE=t;function S(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}e.readUInt32LE=S;function n(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255,r=r>>>8,a[v+2]=r&255,r=r>>>8,a[v+3]=r&255}e.writeUInt32LE=n;function m(a,r){return a[r]}e.readUInt8=m;function s(a,r,v){a[v]=r}e.writeUInt8=s;function u(a){return d.consumeReadable(a,r=>F.concat(r))}e.readableToBuffer=u;function p(a){return d.toReadable(a)}e.bufferToReadable=p;function k(a){return d.consumeStream(a,r=>F.concat(r))}e.streamToBuffer=k;async function w(a){return a.ended?F.concat(a.buffer):F.concat([...a.buffer,await k(a.stream)])}e.bufferedStreamToBuffer=w;function o(a){return d.toStream(a,r=>F.concat(r))}e.bufferToStream=o;function h(a){return d.transform(a,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}e.streamToBufferReadableStream=h;function D(a){return d.newWriteableStream(r=>F.concat(r),a)}e.newWriteableBufferStream=D;function i(a,r){return d.prefixedReadable(a,r,v=>F.concat(v))}e.prefixedBufferReadable=i;function g(a,r){return d.prefixedStream(a,r,v=>F.concat(v))}e.prefixedBufferStream=g});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[20],Ee([0,1,14,9]),function(oe,e,d,M){"use strict";var _,A,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(a,r,v){let l=a.get(r);return l===void 0&&(l=v,a.set(r,l)),l}e.getOrSet=P;function C(a){const r=[];return a.forEach((v,l)=>{r.push(`${l} => ${v}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=C;function T(a){const r=[];return a.forEach(v=>{r.push(v)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=T;class t{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const v=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return v-l}value(){return this._value[this._pos]}}e.StringIterator=t;class S{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class n{constructor(r=!0,v=!0){this._splitOnBackslash=r,this._caseSensitive=v}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var m;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(m||(m={}));class s{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(p||(p={}));class k{constructor(r){this._iter=r}static forUris(r=()=>!1){return new k(new s(r))}static forPaths(){return new k(new n)}static forStrings(){return new k(new t)}static forConfigKeys(){return new k(new S)}clear(){this._root=void 0}fill(r,v){if(v){const l=v.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c,r)}else{const l=r.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c[0],c[1])}}set(r,v){const l=this._iter.reset(r);let c;this._root||(this._root=new u,this._root.segment=l.value());const b=[];for(c=this._root;;){const y=l.cmp(c.segment);if(y>0)c.left||(c.left=new u,c.left.segment=l.value()),b.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new u,c.right.segment=l.value()),b.push([1,c]),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new u,c.mid.segment=l.value()),b.push([0,c]),c=c.mid;else break}const f=c.value;c.value=v,c.key=r;for(let y=b.length-1;y>=0;y--){const R=b[y][1];R.updateHeight();const I=R.balanceFactor();if(I<-1||I>1){const L=b[y][0],E=b[y+1][0];if(L===1&&E===1)b[y][1]=R.rotateLeft();else if(L===-1&&E===-1)b[y][1]=R.rotateRight();else if(L===1&&E===-1)R.right=b[y+1][1]=b[y+1][1].rotateRight(),b[y][1]=R.rotateLeft();else if(L===-1&&E===1)R.left=b[y+1][1]=b[y+1][1].rotateLeft(),b[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(b[y-1][0]){case-1:b[y-1][1].left=b[y][1];break;case 1:b[y-1][1].right=b[y][1];break;case 0:b[y-1][1].mid=b[y][1];break}else this._root=b[0][1]}}return f}get(r){return this._getNode(r)?.value}_getNode(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else break}return l}has(r){const v=this._getNode(r);return!(v?.value===void 0&&v?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,v){const l=this._iter.reset(r),c=[];let b=this._root;for(;b;){const f=l.cmp(b.segment);if(f>0)c.push([-1,b]),b=b.left;else if(f<0)c.push([1,b]),b=b.right;else if(l.hasNext())l.next(),c.push([0,b]),b=b.mid;else break}if(!!b){if(v?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const f=this._min(b.right),{key:y,value:R,segment:I}=f;this._delete(f.key,!1),b.key=y,b.value=R,b.segment=I}else{const f=b.left??b.right;if(c.length>0){const[y,R]=c[c.length-1];switch(y){case-1:R.left=f;break;case 0:R.mid=f;break;case 1:R.right=f;break}}else this._root=f}for(let f=c.length-1;f>=0;f--){const y=c[f][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=c[f+1][1]=c[f+1][1].rotateRight()),c[f][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=c[f+1][1]=c[f+1][1].rotateLeft()),c[f][1]=y.rotateRight()),f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this._root=c[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const v=this._iter.reset(r);let l=this._root,c;for(;l;){const b=v.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(v.hasNext())v.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[v,l]of this)r(l,v)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=v=>{if(!v)return!0;const l=v.balanceFactor();return l<-1||l>1?!1:r(v.left)&&r(v.right)};return r(this._root)}}e.TernarySearchTree=k;class w{constructor(r,v){this.uri=r,this.value=v}}class o{constructor(r,v){this[_]="ResourceMap",r instanceof o?(this.map=new Map(r.map),this.toKey=v??o.defaultToKey):(this.map=new Map,this.toKey=r??o.defaultToKey)}set(r,v){return this.map.set(this.toKey(r),new w(r,v)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,v){typeof v!="undefined"&&(r=r.bind(v));for(let[l,c]of this.map)r(c.value,c.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=o,o.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class D{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,v=0){const l=this._map.get(r);if(!!l)return v!==0&&this.touch(l,v),l.value}set(r,v,l=0){let c=this._map.get(r);if(c)c.value=v,l!==0&&this.touch(c,l);else{switch(c={key:r,value:v,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const v=this._map.get(r);if(!!v)return this._map.delete(r),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,v){const l=this._state;let c=this._head;for(;c;){if(v?r.bind(v)(c.value,c.key,this):r(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}values(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}entries(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let v=this._head,l=this.size;for(;v&&l>r;)this._map.delete(v.key),v=v.next,l--;this._head=v,this._size=l,v&&(v.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const v=r.next,l=r.previous;if(!v||!l)throw new Error("Invalid list");v.previous=l,l.next=v}r.next=void 0,r.previous=void 0,this._state++}touch(r,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(r===this._head)return;const l=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(v===2){if(r===this._tail)return;const l=r.next,c=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((v,l)=>{r.push([l,v])}),r}fromJSON(r){this.clear();for(const[v,l]of r)this.set(v,l)}}e.LinkedMap=D;class i extends D{constructor(r,v=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,v=2){return super.get(r,v)}peek(r){return super.get(r,0)}set(r,v){return super.set(r,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class g{constructor(r){F.set(this,void 0),Ze(this,F,r,"f")}get size(){return Re(this,F,"f").size}forEach(r,v){Re(this,F,"f").forEach(r,v)}get(r){return Re(this,F,"f").get(r)}has(r){return Re(this,F,"f").has(r)}entries(){return Re(this,F,"f").entries()}keys(){return Re(this,F,"f").keys()}values(){return Re(this,F,"f").values()}[(F=new WeakMap,Symbol.iterator)](){return Re(this,F,"f").entries()}}e.ReadonlyMapView=g}),define(be[105],Ee([0,1,20,9]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...K){return function(se,he){for(let Ae=0,Ue=K.length;Ae<Ue;Ae++){const He=K[Ae](se,he);if(He)return He}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(K,se,he){if(!he||he.length<se.length)return null;let Ae;return K?Ae=M.startsWithIgnoreCase(he,se):Ae=he.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function F(K,se){const he=se.toLowerCase().indexOf(K.toLowerCase());return he===-1?null:[{start:he,end:he+K.length}]}e.matchesContiguousSubString=F;function P(K,se){return C(K.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=P;function C(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]===se[Ae]){let Ue=null;return(Ue=C(K,se,he+1,Ae+1))?k({start:Ae,end:Ae+1},Ue):null}return C(K,se,he,Ae+1)}function T(K){return 97<=K&&K<=122}function t(K){return 65<=K&&K<=90}e.isUpper=t;function S(K){return 48<=K&&K<=57}function n(K){return K===32||K===9||K===10||K===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(K=>m.add(K.charCodeAt(0)));function s(K){return n(K)||m.has(K)}function u(K,se){return K===se||s(K)&&s(se)}function p(K){return T(K)||t(K)||S(K)}function k(K,se){return se.length===0?se=[K]:K.end===se[0].start?se[0].start=K.start:se.unshift(K),se}function w(K,se){for(let he=se;he<K.length;he++){const Ae=K.charCodeAt(he);if(t(Ae)||S(Ae)||he>0&&!p(K.charCodeAt(he-1)))return he}return K.length}function o(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]!==se[Ae].toLowerCase())return null;{let Ue=null,He=Ae+1;for(Ue=o(K,se,he+1,Ae+1);!Ue&&(He=w(se,He))<se.length;)Ue=o(K,se,he+1,He),He++;return Ue===null?null:k({start:Ae,end:Ae+1},Ue)}}function h(K){let se=0,he=0,Ae=0,Ue=0,He=0;for(let nt=0;nt<K.length;nt++)He=K.charCodeAt(nt),t(He)&&se++,T(He)&&he++,p(He)&&Ae++,S(He)&&Ue++;const Qe=se/K.length,et=he/K.length,st=Ae/K.length,ye=Ue/K.length;return{upperPercent:Qe,lowerPercent:et,alphaPercent:st,numericPercent:ye}}function D(K){const{upperPercent:se,lowerPercent:he}=K;return he===0&&se>.6}function i(K){const{upperPercent:se,lowerPercent:he,alphaPercent:Ae,numericPercent:Ue}=K;return he>.2&&se<.8&&Ae>.6&&Ue<.2}function g(K){let se=0,he=0,Ae=0,Ue=0;for(let He=0;He<K.length;He++)Ae=K.charCodeAt(He),t(Ae)&&se++,T(Ae)&&he++,n(Ae)&&Ue++;return(se===0||he===0)&&Ue===0?K.length<=30:se<=5}function a(K,se){if(!se||(se=se.trim(),se.length===0)||!g(K)||se.length>60)return null;const he=h(se);if(!i(he)){if(!D(he))return null;se=se.toLowerCase()}let Ae=null,Ue=0;for(K=K.toLowerCase();Ue<se.length&&(Ae=o(K,se,0,Ue))===null;)Ue=w(se,Ue+1);return Ae}e.matchesCamelCase=a;function r(K,se,he=!1){if(!se||se.length===0)return null;let Ae=null,Ue=0;for(K=K.toLowerCase(),se=se.toLowerCase();Ue<se.length&&(Ae=v(K,se,0,Ue,he))===null;)Ue=l(se,Ue+1);return Ae}e.matchesWords=r;function v(K,se,he,Ae,Ue){if(he===K.length)return[];if(Ae===se.length)return null;if(u(K.charCodeAt(he),se.charCodeAt(Ae))){let He=null,Qe=Ae+1;if(He=v(K,se,he+1,Ae+1,Ue),!Ue)for(;!He&&(Qe=l(se,Qe))<se.length;)He=v(K,se,he+1,Qe,Ue),Qe++;return He===null?null:k({start:Ae,end:Ae+1},He)}else return null}function l(K,se){for(let he=se;he<K.length;he++)if(s(K.charCodeAt(he))||he>0&&s(K.charCodeAt(he-1)))return he;return K.length}const c=_(e.matchesPrefix,a,F),b=_(e.matchesPrefix,a,P),f=new d.LRUCache(1e4);function y(K,se,he=!1){if(typeof K!="string"||typeof se!="string")return null;let Ae=f.get(K);Ae||(Ae=new RegExp(M.convertSimple2RegExpPattern(K),"i"),f.set(K,Ae));const Ue=Ae.exec(se);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?b(K,se):c(K,se)}e.matchesFuzzy=y;function R(K,se){const he=Ke(K,K.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?L(he):null}e.matchesFuzzy2=R;function I(K,se,he,Ae,Ue,He){const Qe=Math.min(13,K.length);for(;he<Qe;he++){const et=Ke(K,se,he,Ae,Ue,He,!1);if(et)return et}return[0,He]}e.anyScore=I;function L(K){if(typeof K=="undefined")return[];const se=[],he=K[1];for(let Ae=K.length-1;Ae>1;Ae--){const Ue=K[Ae]+he,He=se[se.length-1];He&&He.end===Ue?He.end=Ue+1:se.push({start:Ue,end:Ue+1})}return se}e.createMatches=L;const E=128;function N(){const K=[],se=[];for(let he=0;he<=E;he++)se[he]=0;for(let he=0;he<=E;he++)K.push(se.slice(0));return K}function U(K){const se=[];for(let he=0;he<=K;he++)se[he]=0;return se}const B=U(2*E),G=U(2*E),H=N(),W=N(),ne=N(),V=!1;function Y(K,se,he,Ae,Ue){function He(et,st,ye=" "){for(;et.length<st;)et=ye+et;return et}let Qe=` |   |${Ae.split("").map(et=>He(et,3)).join("|")}
`;for(let et=0;et<=he;et++)et===0?Qe+=" |":Qe+=`${se[et-1]}|`,Qe+=K[et].slice(0,Ue+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Qe}function j(K,se,he,Ae){K=K.substr(se),he=he.substr(Ae),console.log(Y(W,K,K.length,he,he.length)),console.log(Y(ne,K,K.length,he,he.length)),console.log(Y(H,K,K.length,he,he.length))}function le(K,se){if(se<0||se>=K.length)return!1;const he=K.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function re(K,se){if(se<0||se>=K.length)return!1;switch(K.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ve(K,se,he){return se[K]!==he[K]}function Fe(K,se,he,Ae,Ue,He,Qe=!1){for(;se<he&&Ue<He;)K[se]===Ae[Ue]&&(Qe&&(B[se]=Ue),se+=1),Ue+=1;return se===he}e.isPatternInWord=Fe;var Me;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Oe;(function(K){K.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}K.isDefault=se})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ke(K,se,he,Ae,Ue,He,Qe){const et=K.length>E?E:K.length,st=Ae.length>E?E:Ae.length;if(he>=et||He>=st||et-he>st-He||!Fe(se,he,et,Ue,He,st,!0))return;je(et,st,he,He,se,Ue);let ye=1,nt=1,q=he,Z=He;const pe=[!1];for(ye=1,q=he;q<et;ye++,q++){const ut=B[q],St=G[q],Tt=q+1<et?G[q+1]:st;for(nt=ut-He+1,Z=ut;Z<Tt;nt++,Z++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;Z<=St&&(It=Ve(K,se,q,he,Ae,Ue,Z,st,He,H[ye-1][nt-1]===0,pe));let vt=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,vt=It+W[ye-1][nt-1]);const Pe=Z>ut,Se=Pe?W[ye][nt-1]+(H[ye][nt-1]>0?-5:0):0,Ce=Z>ut+1&&H[ye][nt-1]>0,te=Ce?W[ye][nt-2]+(H[ye][nt-2]>0?-5:0):0;if(Ce&&(!Pe||te>=Se)&&(!Xe||te>=vt))W[ye][nt]=te,ne[ye][nt]=3,H[ye][nt]=0;else if(Pe&&(!Xe||Se>=vt))W[ye][nt]=Se,ne[ye][nt]=2,H[ye][nt]=0;else if(Xe)W[ye][nt]=vt,ne[ye][nt]=1,H[ye][nt]=H[ye-1][nt-1]+1;else throw new Error("not possible")}}if(V&&j(K,he,Ae,He),!pe[0]&&!Qe)return;ye--,nt--;const We=[W[ye][nt],He];let Ye=0,rt=0;for(;ye>=1;){let ut=nt;do{const St=ne[ye][ut];if(St===3)ut=ut-2;else if(St===2)ut=ut-1;else break}while(ut>=1);Ye>1&&se[he+ye-1]===Ue[He+nt-1]&&!ve(ut+He-1,Ae,Ue)&&Ye+1>H[ye][ut]&&(ut=nt),ut===nt?Ye++:Ye=1,rt||(rt=ut),ye--,nt=ut-1,We.push(nt)}st===et&&(We[0]+=2);const mt=rt-et;return We[0]-=mt,We}e.fuzzyScore=Ke;function je(K,se,he,Ae,Ue,He){let Qe=K-1,et=se-1;for(;Qe>=he&&et>=Ae;)Ue[Qe]===He[et]&&(G[Qe]=et,Qe--),et--}function Ve(K,se,he,Ae,Ue,He,Qe,et,st,ye,nt){if(se[he]!==He[Qe])return Number.MIN_SAFE_INTEGER;let q=1,Z=!1;return Qe===he-Ae?q=K[he]===Ue[Qe]?7:5:ve(Qe,Ue,He)&&(Qe===0||!ve(Qe-1,Ue,He))?(q=K[he]===Ue[Qe]?7:5,Z=!0):le(He,Qe)&&(Qe===0||!le(He,Qe-1))?q=5:(le(He,Qe-1)||re(He,Qe-1))&&(q=5,Z=!0),q>1&&he===Ae&&(nt[0]=!0),Z||(Z=ve(Qe,Ue,He)||le(He,Qe-1)||re(He,Qe-1)),he===Ae?Qe>st&&(q-=Z?3:5):ye?q+=Z?2:0:q+=Z?0:1,Qe+1===et&&(q-=Z?3:5),q}function $(K,se,he,Ae,Ue,He,Qe){return ee(K,se,he,Ae,Ue,He,!0,Qe)}e.fuzzyScoreGracefulAggressive=$;function Q(K,se,he,Ae,Ue,He,Qe){return ee(K,se,he,Ae,Ue,He,!1,Qe)}e.fuzzyScoreGraceful=Q;function ee(K,se,he,Ae,Ue,He,Qe,et){let st=Ke(K,se,he,Ae,Ue,He,et);if(st&&!Qe)return st;if(K.length>=3){const ye=Math.min(7,K.length-1);for(let nt=he+1;nt<ye;nt++){const q=ae(K,nt);if(q){const Z=Ke(q,q.toLowerCase(),he,Ae,Ue,He,et);Z&&(Z[0]-=3,(!st||Z[0]>st[0])&&(st=Z))}}}return st}function ae(K,se){if(se+1>=K.length)return;const he=K[se],Ae=K[se+1];if(he!==Ae)return K.slice(0,se)+Ae+he+K.slice(se+2)}}),define(be[106],Ee([0,1,34,105,9]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${A.source}`,"g");function P(u){return u.replace(F,(p,k)=>k?p:`\\${p}`)}e.escapeIcons=P;const C=new RegExp(`\\\\${A.source}`,"g");function T(u){return u.replace(C,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function S(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(t,(p,k,w,o)=>w?p:k||o||"")}e.stripIcons=S;function n(u){const p=u.indexOf(e.iconStartMarker);return p===-1?{text:u}:m(u,p)}e.parseLabelWithIcons=n;function m(u,p){const k=[];let w="";function o(l){if(l){w+=l;for(const c of l)k.push(i)}}let h=-1,D="",i=0,g,a,r=p;const v=u.length;for(o(u.substr(0,p));r<v;)g=u[r],a=u[r+1],g===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(h=r,o(D),D=e.iconStartMarker,r++):g===")"&&h!==-1?(i+=r-h+1,h=-1,D=""):h!==-1?/^[a-z0-9\-]$/i.test(g)?D+=g:(o(D),h=-1,D=""):o(g),r++;return o(D),{text:w,iconOffsets:k}}function s(u,p,k=!1){const{text:w,iconOffsets:o}=p;if(!o||o.length===0)return(0,M.matchesFuzzy)(u,w,k);const h=(0,_.ltrim)(w," "),D=w.length-h.length,i=(0,M.matchesFuzzy)(u,h,k);if(i)for(const g of i){const a=o[g.start+D]+D;g.start+=a,g.end+=a}return i}e.matchesFuzzyIconAware=s}),define(be[77],Ee([0,1,16,106]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(m="",s=!1){if(this.value=m,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(m,s=0){return this.value+=T(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(u,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,s){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function F(n){return P(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function P(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function C(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=C;function T(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function S(n){const m=[],s=n.split("|").map(p=>p.trim());n=s[0];const u=s[1];if(u){const p=/height=(\d+)/.exec(u),k=/width=(\d+)/.exec(u),w=p?p[1]:"",o=k?k[1]:"",h=isFinite(parseInt(o)),D=isFinite(parseInt(w));h&&m.push(`width="${o}"`),D&&m.push(`height="${w}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=S}),define(be[35],Ee([0,1,9]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(M||(M={})),function(_){const A="error",F="warning",P="warn",C="info",T="ignore";function t(n){return n?d.equalsIgnoreCase(A,n)?_.Error:d.equalsIgnoreCase(F,n)||d.equalsIgnoreCase(P,n)?_.Warning:d.equalsIgnoreCase(C,n)?_.Info:_.Ignore:_.Ignore}_.fromValue=t;function S(n){switch(n){case _.Error:return A;case _.Warning:return F;case _.Info:return C;default:return T}}_.toString=S}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(a){return a===47||a===92}e.isPathSeparator=F;function P(a){return a.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=P;function C(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=C;function T(a,r=d.posix.sep){if(!a)return"";const v=a.length,l=a.charCodeAt(0);if(F(l)){if(F(a.charCodeAt(1))&&!F(a.charCodeAt(2))){let b=3;const f=b;for(;b<v&&!F(a.charCodeAt(b));b++);if(f!==b&&!F(a.charCodeAt(b+1))){for(b+=1;b<v;b++)if(F(a.charCodeAt(b)))return a.slice(0,b+1).replace(/[\\/]/g,r)}}return r}else if(k(l)&&a.charCodeAt(1)===58)return F(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let c=a.indexOf("://");if(c!==-1){for(c+=3;c<v;c++)if(F(a.charCodeAt(c)))return a.slice(0,c+1)}return""}e.getRoot=T;function t(a){if(!M.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let v=2;const l=v;for(;v<a.length&&(r=a.charCodeAt(v),r!==92);v++);return!(l===v||(r=a.charCodeAt(v+1),isNaN(r)||r===92))}e.isUNC=t;const S=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(a,r=M.isWindows){const v=r?S:n;return!(!a||a.length===0||/^\s+$/.test(a)||(v.lastIndex=0,v.test(a))||r&&m.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=s;function u(a,r,v){const l=a===r;return!v||l?l:!a||!r?!1:(0,_.equalsIgnoreCase)(a,r)}e.isEqual=u;function p(a,r,v,l=d.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(v){if(!(0,_.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let b=r.length;return r.charAt(r.length-1)===l&&b--,a.charAt(b)===l}return r.charAt(r.length-1)!==l&&(r+=l),a.indexOf(r)===0}e.isEqualOrParent=p;function k(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=k;function w(a,r){return M.isWindows&&a.endsWith(":")&&(a+=d.sep),(0,d.isAbsolute)(a)||(a=(0,d.join)(r,a)),a=(0,d.normalize)(a),M.isWindows?(a=(0,_.rtrim)(a,d.sep),a.endsWith(":")&&(a+=d.sep)):(a=(0,_.rtrim)(a,d.sep),a||(a=d.sep)),a}e.sanitizeFilePath=w;function o(a){const r=(0,d.normalize)(a);return M.isWindows?a.length>3?!1:h(r)&&(a.length===2||r.charCodeAt(2)===92):r===d.posix.sep}e.isRootOrDriveLetter=o;function h(a){return M.isWindows?k(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function D(a){return h(a)?a[0]:void 0}e.getDriveLetter=D;function i(a,r,v){return r.length>a.length?-1:a===r?0:(v&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=i;function g(a){const r=a.split(":");let v,l,c;if(r.forEach(b=>{const f=Number(b);(0,A.isNumber)(f)?l===void 0?l=f:c===void 0&&(c=f):v=v?[v,b].join(":"):b}),!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:l!==void 0?l:void 0,column:c!==void 0?c:l!==void 0?1:void 0}}e.parseLineAndColumnAware=g}),define(be[23],Ee([0,1,10]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.keys(u).forEach(k=>{u[k]&&typeof u[k]=="object"?p[k]=M(u[k]):p[k]=u[k]}),p}e.deepClone=M;function _(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const k=p.shift();Object.freeze(k);for(const w in k)if(A.call(k,w)){const o=k[w];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return u}e.deepFreeze=_;const A=Object.prototype.hasOwnProperty;function F(u,p){return P(u,p,new Set)}e.cloneAndChange=F;function P(u,p,k){if((0,d.isUndefinedOrNull)(u))return u;const w=p(u);if(typeof w!="undefined")return w;if((0,d.isArray)(u)){const o=[];for(const h of u)o.push(P(h,p,k));return o}if((0,d.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const o={};for(let h in u)A.call(u,h)&&(o[h]=P(u[h],p,k));return k.delete(u),o}return u}function C(u,p,k=!0){return(0,d.isObject)(u)?((0,d.isObject)(p)&&Object.keys(p).forEach(w=>{w in u?k&&((0,d.isObject)(u[w])&&(0,d.isObject)(p[w])?C(u[w],p[w],k):u[w]=p[w]):u[w]=p[w]}),u):p}e.mixin=C;function T(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let k,w;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(k=0;k<u.length;k++)if(!T(u[k],p[k]))return!1}else{const o=[];for(w in u)o.push(w);o.sort();const h=[];for(w in p)h.push(w);if(h.sort(),!T(o,h))return!1;for(k=0;k<o.length;k++)if(!T(u[o[k]],p[o[k]]))return!1}return!0}e.equals=T;function t(u){const p=new Set;return JSON.stringify(u,(k,w)=>{if((0,d.isObject)(w)||Array.isArray(w)){if(p.has(w))return"[Circular]";p.add(w)}return w})}e.safeStringify=t;function S(u,p,k){const w=p(u);return typeof w=="undefined"?k:w}e.getOrDefault=S;function n(u,p){const k=Object.create(null);return!u||!p||Object.keys(p).forEach(o=>{const h=u[o],D=p[o];T(h,D)||(k[o]=D)}),k}e.distinct=n;function m(u,p){const k=p.toLowerCase(),w=Object.keys(u).find(o=>o.toLowerCase()===k);return w?u[w]:u[p]}e.getCaseInsensitive=m;function s(u,p){const k=Object.create(null);for(const w of Object.keys(u))p(w,u[w])&&(k[w]=u[w]);return k}e.filter=s}),define(be[55],Ee([0,1,22,9,2]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,C)}e.stringify=A;function F(t){let S=JSON.parse(t);return S=T(S),S}e.parse=F;var P;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function C(t,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,M.regExpFlags)(S)}:S}function T(t,S=0){if(!t||S>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return _.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=T(t[n],S+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=T(t[n],S+1))}return t}e.revive=T}),define(be[11],Ee([0,1,25,2]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(_=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,T,t){this._hosts[C]=T,this._ports[C]=t}setConnectionToken(C,T){this._connectionTokens[C]=T}rewrite(C){if(this._delegate)return this._delegate(C);const T=C.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const S=this._ports[T],n=this._connectionTokens[T];let m=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${t}:${S}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class F{asBrowserUri(C,T){const t=this.toUri(C,T);return t.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===_.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${_.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:_.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(C,T){const t=this.toUri(C,T);return t.scheme===_.vscodeFileResource?t.with({scheme:_.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(C,T){return M.URI.isUri(C)?C:M.URI.parse(T.toUrl(C))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=C;class T{constructor(s){this._ignorePathCasing=s}compare(s,u,p=!1){return s===u?0:(0,F.compare)(this.getComparisonKey(s,p),this.getComparisonKey(u,p))}isEqual(s,u,p=!1){return s===u?!0:!s||!u?!1:this.getComparisonKey(s,p)===this.getComparisonKey(u,p)}getComparisonKey(s,u=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,u,p=!1){if(s.scheme===u.scheme){if(s.scheme===M.Schemas.file)return d.isEqualOrParent(C(s),C(u),this._ignorePathCasing(s))&&s.query===u.query&&(p||s.fragment===u.fragment);if((0,e.isEqualAuthority)(s.authority,u.authority))return d.isEqualOrParent(s.path,u.path,this._ignorePathCasing(s),"/")&&s.query===u.query&&(p||s.fragment===u.fragment)}return!1}joinPath(s,...u){return P.URI.joinPath(s,...u)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return _.posix.basename(s.path)}extname(s){return _.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let u;return s.scheme===M.Schemas.file?u=P.URI.file(_.dirname(C(s))).path:(u=_.posix.dirname(s.path),s.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),u="/")),s.with({path:u})}normalizePath(s){if(!s.path.length)return s;let u;return s.scheme===M.Schemas.file?u=P.URI.file(_.normalize(C(s))).path:u=_.posix.normalize(s.path),s.with({path:u})}relativePath(s,u){if(s.scheme!==u.scheme||!(0,e.isEqualAuthority)(s.authority,u.authority))return;if(s.scheme===M.Schemas.file){const w=_.relative(C(s),C(u));return A.isWindows?d.toSlashes(w):w}let p=s.path||"/",k=u.path||"/";if(this._ignorePathCasing(s)){let w=0;for(const o=Math.min(p.length,k.length);w<o&&!(p.charCodeAt(w)!==k.charCodeAt(w)&&p.charAt(w).toLowerCase()!==k.charAt(w).toLowerCase());w++);p=k.substr(0,w)+p.substr(w)}return _.posix.relative(p,k)}resolvePath(s,u){if(s.scheme===M.Schemas.file){const p=P.URI.file(_.resolve(C(s),u));return s.with({authority:p.authority,path:p.path})}return u=d.toPosixPath(u),s.with({path:_.posix.resolve(s.path,u)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,u){return s===u||(0,F.equalsIgnoreCase)(s,u)}hasTrailingPathSeparator(s,u=_.sep){if(s.scheme===M.Schemas.file){const p=C(s);return p.length>d.getRoot(p).length&&p[p.length-1]===u}else{const p=s.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,u=_.sep){return(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,u=_.sep){let p=!1;if(s.scheme===M.Schemas.file){const k=C(s);p=k!==void 0&&k.length===d.getRoot(k).length&&k[k.length-1]===u}else{u="/";const k=s.path;p=k.length===1&&k.charCodeAt(k.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path+"/"}):s}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(m=>m.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(m,s){const u=[];for(let p=0;p<m.length;p++){const k=s(m[p]);m.some((w,o)=>o===p?!1:(0,e.isEqualOrParent)(k,s(w)))||u.push(m[p])}return u}e.distinctParents=t;var S;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function s(u){const p=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(o=>{const[h,D]=o.split(":");h&&D&&p.set(h,D)});const w=u.path.substring(0,u.path.indexOf(";"));return w&&p.set(m.META_DATA_MIME,w),p}m.parseMetaData=s})(S=e.DataUri||(e.DataUri={}));function n(m,s,u){if(s){let p=m.path;return p&&p[0]!==_.posix.sep&&(p=_.posix.sep+p),m.with({scheme:u,authority:s,path:p})}return m.with({scheme:u})}e.toLocalResource=n}),define(be[12],Ee([0,1,21,16,3,6,24]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(H){return!!H&&typeof H.then=="function"}e.isThenable=P;function C(H){const W=new d.CancellationTokenSource,ne=H(W.token),V=new Promise((Y,j)=>{const le=W.token.onCancellationRequested(()=>{le.dispose(),W.dispose(),j((0,M.canceled)())});Promise.resolve(ne).then(re=>{le.dispose(),W.dispose(),Y(re)},re=>{le.dispose(),W.dispose(),j(re)})});return new class{cancel(){W.cancel()}then(Y,j){return V.then(Y,j)}catch(Y){return this.then(void 0,Y)}finally(Y){return V.finally(Y)}}}e.createCancelablePromise=C;function T(H,W,ne){return Promise.race([H,new Promise(V=>W.onCancellationRequested(()=>V(ne)))])}e.raceCancellation=T;async function t(H){let W=-1;const ne=H.map((Y,j)=>Y.then(le=>(W=j,le))),V=await Promise.race(ne);return H.forEach((Y,j)=>{j!==W&&Y.cancel()}),V}e.raceCancellablePromises=t;function S(H,W,ne){let V;const Y=setTimeout(()=>{V?.(void 0),ne?.()},W);return Promise.race([H.finally(()=>clearTimeout(Y)),new Promise(j=>V=j)])}e.raceTimeout=S;function n(H){return new Promise((W,ne)=>{const V=H();P(V)?V.then(W,ne):W(V)})}e.asPromise=n;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const ne=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(ne,ne).then(V)})}return new Promise((ne,V)=>{this.queuedPromise.then(ne,V)})}return this.activePromise=W(),new Promise((ne,V)=>{this.activePromise.then(Y=>{this.activePromise=null,ne(Y)},Y=>{this.activePromise=null,V(Y)})})}}e.Throttler=m;class s{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=s;class u{constructor(){this.promiseMap=new Map}queue(W,ne){const Y=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.promiseMap.get(W)===Y&&this.promiseMap.delete(W)});return this.promiseMap.set(W,Y),Y}}e.SequencerByKey=u;class p{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,ne=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,Y)=>{this.doResolve=V,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ne),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class k{constructor(W){this.delayer=new p(W),this.throttler=new m}trigger(W,ne){return this.delayer.trigger(()=>this.throttler.queue(W),ne)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=k;class w{constructor(){this._isOpen=!1,this._promise=new Promise((W,ne)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class o extends w{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function h(H,W){return W?new Promise((ne,V)=>{const Y=setTimeout(()=>{j.dispose(),ne()},H),j=W.onCancellationRequested(()=>{clearTimeout(Y),j.dispose(),V((0,M.canceled)())})}):C(ne=>h(H,ne))}e.timeout=h;function D(H,W=0){const ne=setTimeout(H,W);return(0,A.toDisposable)(()=>clearTimeout(ne))}e.disposableTimeout=D;function i(H){const W=[];let ne=0;const V=H.length;function Y(){return ne<V?H[ne++]():null}function j(le){le!=null&&W.push(le);const re=Y();return re?re.then(j):Promise.resolve(W)}return Promise.resolve(null).then(j)}e.sequence=i;function g(H,W=V=>!!V,ne=null){let V=0;const Y=H.length,j=()=>{if(V>=Y)return Promise.resolve(ne);const le=H[V++];return Promise.resolve(le()).then(ve=>W(ve)?Promise.resolve(ve):j())};return j()}e.first=g;function a(H,W=V=>!!V,ne=null){if(H.length===0)return Promise.resolve(ne);let V=H.length;const Y=()=>{V=-1;for(const j of H)j.cancel?.()};return new Promise((j,le)=>{for(const re of H)re.then(ve=>{--V>=0&&W(ve)?(Y(),j(ve)):V===0&&j(ne)}).catch(ve=>{--V>=0&&(Y(),le(ve))})})}e.firstParallel=a;class r{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((ne,V)=>{this.outstandingPromises.push({factory:W,c:ne,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const ne=W.factory();ne.then(W.c,W.e),ne.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class v extends r{constructor(){super(1)}}e.Queue=v;class l{constructor(){this.queues=new Map}queueFor(W,ne=F.extUri){const V=ne.getComparisonKey(W);let Y=this.queues.get(V);return Y||(Y=new v,_.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(V)}),this.queues.set(V,Y)),Y}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=l;class c{constructor(W,ne){this._token=-1,typeof W=="function"&&typeof ne=="number"&&this.setIfNotSet(W,ne)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},ne)}setIfNotSet(W,ne){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},ne))}}e.TimeoutTimer=c;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setInterval(()=>{W()},ne)}}e.IntervalTimer=b;class f{constructor(W,ne){this.timeoutToken=-1,this.runner=W,this.timeout=ne,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=f;class y{constructor(W,ne){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=ne,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class R extends f{constructor(W,ne){super(W,ne);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class I extends A.Disposable{constructor(W,ne,V,Y){super();this.maxWorkChunkSize=W,this.maxPendingWork=ne,this.throttleDelay=V,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new f(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=I,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const W=setTimeout(()=>{const V=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0,clearTimeout(W))}}}:e.runWhenIdle=(H,W)=>{const ne=requestIdleCallback(H,typeof W=="number"?{timeout:W}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(ne))}}}}();class L{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(ne){this._error=ne}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function E(H,W,ne){let V;for(let Y=0;Y<ne;Y++)try{return await H()}catch(j){V=j,await h(W)}throw V}e.retry=E;class N{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,ne,V){return this._pending={taskId:W,cancel:()=>V?.(),promise:ne},ne.then(()=>this.donePending(W),()=>this.donePending(W)),ne}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let ne,V;const Y=new Promise((j,le)=>{ne=j,V=le});this._next={run:W,promise:Y,promiseResolve:ne,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=N;class U{constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,ne)=>{this.completeCallback=W,this.errorCallback=ne})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(ne=>{this.completeCallback(W),this.resolved=!0,ne()})}error(W){return new Promise(ne=>{this.errorCallback(W),this.rejected=!0,ne()})}cancel(){new Promise(W=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=B;var G;(function(H){async function W(V){let Y;const j=await Promise.all(V.map(le=>le.then(re=>re,re=>{Y||(Y=re)})));if(typeof Y!="undefined")throw Y;return j}H.settled=W;function ne(V){return new Promise(async(Y,j)=>{try{await V(Y,j)}catch(le){j(le)}})}H.withAsyncBody=ne})(G=e.Promises||(e.Promises={}))}),define(be[107],Ee([0,1,12,17]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new d.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(f,y,R=!1){const I=f||"",L=y||"",E=_.value.collator.compare(I,L);return _.value.collatorIsNumeric&&E===0&&I!==L?I<L?-1:1:E}e.compareFileNames=P;function C(f,y){const R=A.value.collator;return f=f||"",y=y||"",D(R,f,y)}e.compareFileNamesDefault=C;function T(f,y){const R=A.value.collator;return f=f||"",y=y||"",r(f,y)||D(R,f,y)}e.compareFileNamesUpper=T;function t(f,y){const R=A.value.collator;return f=f||"",y=y||"",a(f,y)||D(R,f,y)}e.compareFileNamesLower=t;function S(f,y){return f=f||"",y=y||"",f===y?0:f<y?-1:1}e.compareFileNamesUnicode=S;function n(f,y,R=!1){R||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase());const[I,L]=o(f),[E,N]=o(y);return I!==E?I<E?-1:1:L===N?0:L<N?-1:1}e.noIntlCompareFileNames=n;function m(f,y){const[R,I]=o(f),[L,E]=o(y);let N=_.value.collator.compare(I,E);if(N===0){if(_.value.collatorIsNumeric&&I!==E)return I<E?-1:1;if(N=_.value.collator.compare(R,L),_.value.collatorIsNumeric&&N===0&&R!==L)return R<L?-1:1}return N}e.compareFileExtensions=m;function s(f,y){f=f||"",y=y||"";const R=h(f),I=h(y),L=A.value.collator,E=F.value.collator;return D(E,R,I)||D(L,f,y)}e.compareFileExtensionsDefault=s;function u(f,y){f=f||"",y=y||"";const R=h(f),I=h(y),L=A.value.collator,E=F.value.collator;return D(E,R,I)||r(f,y)||D(L,f,y)}e.compareFileExtensionsUpper=u;function p(f,y){f=f||"",y=y||"";const R=h(f),I=h(y),L=A.value.collator,E=F.value.collator;return D(E,R,I)||a(f,y)||D(L,f,y)}e.compareFileExtensionsLower=p;function k(f,y){f=f||"",y=y||"";const R=h(f).toLowerCase(),I=h(y).toLowerCase();return R!==I?R<I?-1:1:f!==y?f<y?-1:1:0}e.compareFileExtensionsUnicode=k;const w=/^(.*?)(\.([^.]*))?$/;function o(f,y=!1){const R=f?w.exec(f):[];let I=[R&&R[1]||"",R&&R[3]||""];return y&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function h(f){const y=f?w.exec(f):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function D(f,y,R){let I=f.compare(y,R);return I!==0?I:y.length!==R.length?y.length<R.length?-1:1:0}function i(f){const y=f.charAt(0);return y.toLocaleUpperCase()!==y}function g(f){const y=f.charAt(0);return y.toLocaleLowerCase()!==y}function a(f,y){return i(f)&&g(y)?-1:g(f)&&i(y)?1:0}function r(f,y){return g(f)&&i(y)?-1:i(f)&&g(y)?1:0}function v(f,y,R=!1){return R||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase()),f===y?0:f<y?-1:1}function l(f,y,R=!1){const I=f.split(M.sep),L=y.split(M.sep),E=I.length-1,N=L.length-1;let U,B;for(let G=0;;G++){if(U=E===G,B=N===G,U&&B)return P(I[G],L[G],R);if(U)return-1;if(B)return 1;const H=v(I[G],L[G],R);if(H!==0)return H}}e.comparePaths=l;function c(f,y,R){const I=f.toLowerCase(),L=y.toLowerCase(),E=b(f,y,R);if(E)return E;const N=I.endsWith(R),U=L.endsWith(R);if(N!==U)return N?-1:1;const B=P(I,L);return B!==0?B:I.localeCompare(L)}e.compareAnything=c;function b(f,y,R){const I=f.toLowerCase(),L=y.toLowerCase(),E=I.startsWith(R),N=L.startsWith(R);if(E!==N)return E?-1:1;if(E&&N){if(I.length<L.length)return-1;if(I.length>L.length)return 1}return 0}e.compareByPrefix=b}),define(be[27],Ee([0,1,12,43,20,17,9]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const C="**",T="/",t="[/\\\\]",S="[^/\\\\]",n=/\//g;function m(V){switch(V){case 0:return"";case 1:return`${S}*?`;default:return`(?:${t}|${S}+${t}|${t}${S}+)*?`}}function s(V,Y){if(!V)return[];const j=[];let le=!1,re=!1,ve="";for(const Fe of V){switch(Fe){case Y:if(!le&&!re){j.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":re=!0;break;case"]":re=!1;break}ve+=Fe}return ve&&j.push(ve),j}e.splitGlobAware=s;function u(V){if(!V)return"";let Y="";const j=s(V,T);if(j.every(le=>le===C))Y=".*";else{let le=!1;j.forEach((re,ve)=>{if(re===C){le||(Y+=m(2),le=!0);return}let Fe=!1,Me="",Oe=!1,Ke="";for(const je of re){if(je!=="}"&&Fe){Me+=je;continue}if(Oe&&(je!=="]"||!Ke)){let Ve;je==="-"?Ve=je:(je==="^"||je==="!")&&!Ke?Ve="^":je===T?Ve="":Ve=F.escapeRegExpCharacters(je),Ke+=Ve;continue}switch(je){case"{":Fe=!0;continue;case"[":Oe=!0;continue;case"}":Y+=`(?:${s(Me,",").map(Q=>u(Q)).join("|")})`,Fe=!1,Me="";break;case"]":Y+="["+Ke+"]",Oe=!1,Ke="";break;case"?":Y+=S;continue;case"*":Y+=m(1);continue;default:Y+=F.escapeRegExpCharacters(je)}}ve<j.length-1&&(j[ve+1]!==C||ve+2<j.length)&&(Y+=t),le=!1})}return Y}const p=/^\*\*\/\*\.[\w\.-]+$/,k=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new _.LRUCache(1e4),g=function(){return!1},a=function(){return null};function r(V,Y){if(!V)return a;let j;typeof V!="string"?j=V.pattern:j=V,j=j.trim();const le=`${j}_${!!Y.trimForExclusions}`;let re=i.get(le);if(re)return v(re,V);let ve;if(p.test(j)){const Fe=j.substr(4);re=function(Me,Oe){return typeof Me=="string"&&Me.endsWith(Fe)?j:null}}else(ve=k.exec(l(j,Y)))?re=c(ve[1],j):(Y.trimForExclusions?o:w).test(j)?re=b(j,Y):(ve=h.exec(l(j,Y)))?re=f(ve[1].substr(1),j,!0):(ve=D.exec(l(j,Y)))?re=f(ve[1],j,!1):re=y(j);return i.set(le,re),v(re,V)}function v(V,Y){return typeof Y=="string"?V:function(j,le){return M.isEqualOrParent(j,Y.base)?V(A.relative(Y.base,j),le):null}}function l(V,Y){return Y.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function c(V,Y){const j=`/${V}`,le=`\\${V}`,re=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===V?Y:null:Fe===V||Fe.endsWith(j)||Fe.endsWith(le)?Y:null},ve=[V];return re.basenames=ve,re.patterns=[Y],re.allBasenames=ve,re}function b(V,Y){const j=ne(V.slice(1,-1).split(",").map(Me=>r(Me,Y)).filter(Me=>Me!==a),V),le=j.length;if(!le)return a;if(le===1)return j[0];const re=function(Me,Oe){for(let Ke=0,je=j.length;Ke<je;Ke++)if(j[Ke](Me,Oe))return V;return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(re.allPaths=Fe),re}function f(V,Y,j){const le=A.sep===A.posix.sep,re=le?V:V.replace(n,A.sep),ve=A.sep+re,Fe=A.posix.sep+V,Me=j?function(Oe,Ke){return typeof Oe=="string"&&(Oe===re||Oe.endsWith(ve)||!le&&(Oe===V||Oe.endsWith(Fe)))?Y:null}:function(Oe,Ke){return typeof Oe=="string"&&(Oe===re||!le&&Oe===V)?Y:null};return Me.allPaths=[(j?"*/":"./")+V],Me}function y(V){try{const Y=new RegExp(`^${u(V)}$`);return function(j){return Y.lastIndex=0,typeof j=="string"&&Y.test(j)?V:null}}catch(Y){return a}}function R(V,Y,j){return!V||typeof Y!="string"?!1:I(V)(Y,void 0,j)}e.match=R;function I(V,Y={}){if(!V)return g;if(typeof V=="string"||U(V)){const j=r(V,Y);if(j===a)return g;const le=function(re,ve){return!!j(re,ve)};return j.allBasenames&&(le.allBasenames=j.allBasenames),j.allPaths&&(le.allPaths=j.allPaths),le}return H(V,Y)}e.parse=I;function L(V){if(!V)return;let Y;return j=>(Y||(Y=(V()||Promise.resolve([])).then(le=>le?N(le):{})),Y.then(le=>!!le[j]))}e.hasSiblingPromiseFn=L;function E(V){if(!V)return;let Y;return j=>{if(!Y){const le=V();Y=le?N(le):{}}return!!Y[j]}}e.hasSiblingFn=E;function N(V){const Y={};for(const j of V)Y[j]=!0;return Y}function U(V){const Y=V;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=U;function B(V){return V.allBasenames||[]}e.getBasenameTerms=B;function G(V){return V.allPaths||[]}e.getPathTerms=G;function H(V,Y){const j=ne(Object.getOwnPropertyNames(V).map(Me=>W(Me,V[Me],Y)).filter(Me=>Me!==a)),le=j.length;if(!le)return a;if(!j.some(Me=>!!Me.requiresSiblings)){if(le===1)return j[0];const Me=function(je,Ve){for(let $=0,Q=j.length;$<Q;$++){const ee=j[$](je,Ve);if(ee)return ee}return null},Oe=j.find(je=>!!je.allBasenames);Oe&&(Me.allBasenames=Oe.allBasenames);const Ke=j.reduce((je,Ve)=>Ve.allPaths?je.concat(Ve.allPaths):je,[]);return Ke.length&&(Me.allPaths=Ke),Me}const re=function(Me,Oe,Ke){let je;for(let Ve=0,$=j.length;Ve<$;Ve++){const Q=j[Ve];Q.requiresSiblings&&Ke&&(Oe||(Oe=A.basename(Me)),je||(je=Oe.substr(0,Oe.length-A.extname(Me).length)));const ee=Q(Me,Oe,je,Ke);if(ee)return ee}return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(re.allPaths=Fe),re}function W(V,Y,j){if(Y===!1)return a;const le=r(V,j);if(le===a)return a;if(typeof Y=="boolean")return le;if(Y){const re=Y.when;if(typeof re=="string"){const ve=(Fe,Me,Oe,Ke)=>{if(!Ke||!le(Fe,Me))return null;const je=re.replace("$(basename)",Oe),Ve=Ke(je);return(0,d.isThenable)(Ve)?Ve.then($=>$?V:null):Ve?V:null};return ve.requiresSiblings=!0,ve}}return le}function ne(V,Y){const j=V.filter(Me=>!!Me.basenames);if(j.length<2)return V;const le=j.reduce((Me,Oe)=>{const Ke=Oe.basenames;return Ke?Me.concat(Ke):Me},[]);let re;if(Y){re=[];for(let Me=0,Oe=le.length;Me<Oe;Me++)re.push(Y)}else re=j.reduce((Me,Oe)=>{const Ke=Oe.patterns;return Ke?Me.concat(Ke):Me},[]);const ve=function(Me,Oe){if(typeof Me!="string")return null;if(!Oe){let je;for(je=Me.length;je>0;je--){const Ve=Me.charCodeAt(je-1);if(Ve===47||Ve===92)break}Oe=Me.substr(je)}const Ke=le.indexOf(Oe);return Ke!==-1?re[Ke]:null};ve.basenames=le,ve.patterns=re,ve.allBasenames=le;const Fe=V.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(be[78],Ee([0,1,43,11,17,25,24,9,2]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(r,v,l){if(typeof r=="string"&&(r=C.URI.file(r)),l){const b=l.getWorkspaceFolder(r);if(b){const f=l.getWorkspace().folders.length>1;let y;if((0,F.isEqual)(b.uri,r)?y="":y=(0,F.relativePath)(b.uri,r),f){const R=b.name?b.name:(0,F.basename)(b.uri);y=y?R+" \u2022 "+y:R}return y}}if(r.scheme!==M.Schemas.file&&r.scheme!==M.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(r.fsPath))return(0,_.normalize)(S(r.fsPath));let c=(0,_.normalize)(r.fsPath);return!A.isWindows&&v?.userHome&&(c=m(c,v.userHome.fsPath)),c}e.getPathLabel=T;function t(r){if(!r)return;typeof r=="string"&&(r=C.URI.file(r));const v=(0,F.basename)(r)||(r.scheme===M.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(v)?S(v):v}e.getBaseLabel=t;function S(r){return(0,d.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=S;let n=Object.create(null);function m(r,v){if(A.isWindows||!r||!v)return r;let l=n.original===v?n.normalized:void 0;return l||(l=`${(0,P.rtrim)(v,_.posix.sep)}${_.posix.sep}`,n={original:v,normalized:l}),(A.isLinux?r.startsWith(l):(0,P.startsWithIgnoreCase)(r,l))&&(r=`~/${r.substr(l.length)}`),r}e.tildify=m;function s(r,v){return r.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=s;const u="\u2026",p="\\\\",k="~";function w(r,v=_.sep){const l=new Array(r.length);let c=!1;for(let b=0;b<r.length;b++){let f=r[b];if(f===""){l[b]=`.${v}`;continue}if(!f){l[b]=f;continue}c=!0;let y="";f.indexOf(p)===0?(y=f.substr(0,f.indexOf(p)+p.length),f=f.substr(f.indexOf(p)+p.length)):f.indexOf(v)===0?(y=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length)):f.indexOf(k)===0&&(y=f.substr(0,f.indexOf(k)+k.length),f=f.substr(f.indexOf(k)+k.length));const R=f.split(v);for(let I=1;c&&I<=R.length;I++)for(let L=R.length-I;c&&L>=0;L--){c=!1;let E=R.slice(L,L+I).join(v);for(let N=0;!c&&N<r.length;N++)if(N!==b&&r[N]&&r[N].indexOf(E)>-1){const U=L+I===R.length,B=L>0&&r[N].indexOf(v)>-1?v+E:E,G=r[N].endsWith(B);c=!U||G}if(!c){let N="";(R[0].endsWith(":")||y!=="")&&(L===1&&(L=0,I++,E=R[0]+v+E),L>0&&(N=R[0]+v),N=y+N),L>0&&(N=N+u+v),N=N+E,L+I<R.length&&(N=N+v+u),l[b]=N}}c&&(l[b]=f)}return l}e.shorten=w;var o;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function h(r,v=Object.create(null)){const l=[];let c=!1,b="";for(const f of r)if(f==="$"||c&&f==="{")b&&l.push({value:b,type:o.TEXT}),b="",c=!0;else if(f==="}"&&c){const y=v[b];if(typeof y=="string")y.length&&l.push({value:y,type:o.VARIABLE});else if(y){const R=l[l.length-1];(!R||R.type!==o.SEPARATOR)&&l.push({value:y.label,type:o.SEPARATOR})}b="",c=!1}else b+=f;return b&&!c&&l.push({value:b,type:o.TEXT}),l.filter((f,y)=>{if(f.type===o.SEPARATOR){const R=l[y-1],I=l[y+1];return[R,I].every(L=>L&&(L.type===o.VARIABLE||L.type===o.TEXT)&&L.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=h;function D(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function i(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function g(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=g;function a(r){const v=r.indexOf("/")!==-1?_.posix:_.win32,l=v.basename(r),c=v.dirname(r);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=a}),define(be[79],Ee([0,1,27,11,17,24,9]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let C=[],T=[],t=[];function S(r,v=!1){const l=n(r);C.push(l),l.userConfigured?t.push(l):T.push(l),v&&!l.userConfigured&&C.forEach(c=>{c.mime===l.mime||c.userConfigured||(l.extension&&c.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&c.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&c.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&c.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=S;function n(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,d.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(_.posix.sep)>=0:!1}}function m(r){r?(C=C.filter(v=>!v.userConfigured),t=[]):(C=[],T=[],t=[])}e.clearTextMimes=m;function s(r,v){let l;if(r)switch(r.scheme){case M.Schemas.file:l=r.fsPath;break;case M.Schemas.data:l=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const c=(0,_.basename)(l),b=u(l,c,t);if(b)return[b,P.text];const f=u(l,c,T);if(f)return[f,P.text];if(v){const y=p(v);if(y)return[y,P.text]}return[P.unknown]}e.guessMimeTypes=s;function u(r,v,l){let c=null,b=null,f=null;for(let y=l.length-1;y>=0;y--){const R=l[y];if(v===R.filenameLowercase){c=R;break}if(R.filepattern&&(!b||R.filepattern.length>b.filepattern.length)){const I=R.filepatternOnPath?r:v;R.filepatternLowercase?.(I)&&(b=R)}R.extension&&(!f||R.extension.length>f.extension.length)&&v.endsWith(R.extensionLowercase)&&(f=R)}return c?c.mime:b?b.mime:f?f.mime:null}function p(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let v=C.length-1;v>=0;v--){const l=C[v];if(!l.firstline)continue;const c=r.match(l.firstline);if(c&&c.length>0)return l.mime}return null}function k(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&k(r[0]):!0}e.isUnspecific=k;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(r){const v=(0,_.extname)(r),l=w[v.toLowerCase()];return l!==void 0?l:D(r)}e.getMediaOrTextMime=h;function D(r){const v=(0,_.extname)(r);return o[v.toLowerCase()]}e.getMediaMime=D;function i(r){for(const v in o)if(o[v]===r)return v}e.getExtensionForMimeType=i;const g=/^(.+)\/(.+?)(;.+)?$/;function a(r,v){const l=g.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:v?void 0:r}e.normalizeMimeType=a}),define(be[108],Ee([0,1,2]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class _{constructor(S){this._uriTransformer=S}transformIncoming(S){const n=this._uriTransformer.transformIncoming(S);return n===S?S:M(d.URI.from(n))}transformOutgoing(S){const n=this._uriTransformer.transformOutgoing(S);return n===S?S:M(d.URI.from(n))}transformOutgoingURI(S){const n=this._uriTransformer.transformOutgoing(S);return n===S?S:d.URI.from(n)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,S,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return S.transformOutgoing(t);for(let m in t)if(Object.hasOwnProperty.call(t,m)){const s=A(t[m],S,n+1);s!==null&&(t[m]=s)}}return null}function F(t,S){const n=A(t,S,0);return n===null?t:n}e.transformOutgoingURIs=F;function P(t,S,n,m){if(!t||m>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(S.transformIncoming(t)):S.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const u=P(t[s],S,n,m+1);u!==null&&(t[s]=u)}}return null}function C(t,S){const n=P(t,S,!1,0);return n===null?t:n}e.transformIncomingURIs=C;function T(t,S){const n=P(t,S,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=T}),define(be[36],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return d.test(C)}e.isUUID=M;const _=new Uint8Array(16),A=[];for(let C=0;C<256;C++)A.push(C.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(C){for(let T=0;T<C.length;T++)C[T]=Math.floor(Math.random()*256);return C};function P(){F(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let C=0,T="";return T+=A[_[C++]],T+=A[_[C++]],T+=A[_[C++]],T+=A[_[C++]],T+="-",T+=A[_[C++]],T+=A[_[C++]],T+="-",T+=A[_[C++]],T+=A[_[C++]],T+="-",T+=A[_[C++]],T+=A[_[C++]],T+="-",T+=A[_[C++]],T+=A[_[C++]],T+=A[_[C++]],T+=A[_[C++]],T+=A[_[C++]],T+=A[_[C++]],T}e.generateUuid=P}),define(be[109],Ee([0,1,227]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class _ extends d.CharacterClassifier{constructor(P){super(0);for(let C=0,T=P.length;C<T;C++)this.set(P.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=_;function A(F){let P={};return C=>(P.hasOwnProperty(C)||(P[C]=F(C)),P[C])}e.getMapForWordSeparators=A(F=>new _(F))}),define(be[80],Ee([0,1,23]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var _;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(_=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var P;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(P=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class T{constructor(o,h){this._findMatchBrand=void 0,this.range=o,this.matches=h}}e.FindMatch=T;var t;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var S;(function(w){w[w.Disabled=0]="Disabled",w[w.EnabledForActive=1]="EnabledForActive",w[w.Enabled=2]="Enabled"})(S=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(o,h,D){this.visibleColumn=o,this.className=h,this.horizontalLine=D}}e.IndentGuide=n;class m{constructor(o,h){this.top=o,this.endColumn=h}}e.IndentGuideHorizontalLine=m;var s;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None"})(s=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class p{constructor(o,h,D,i,g,a){this.identifier=o,this.range=h,this.text=D,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=g,this._isTracked=a}}e.ValidAnnotatedEditOperation=p;class k{constructor(o,h,D){this.reverseEdits=o,this.changes=h,this.trimAutoWhitespaceLineNumbers=D}}e.ApplyEditsResult=k}),define(be[110],Ee([0,1,9,109,111,44,80]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class C{constructor(o,h,D,i){this.searchString=o,this.isRegex=h,this.matchCase=D,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=T(this.searchString):o=this.searchString.indexOf(`
`)>=0;let h=null;try{h=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!h)return null;let D=!this.isRegex&&!o;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new t(h,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=C;function T(w){if(!w||w.length===0)return!1;for(let o=0,h=w.length;o<h;o++)if(w.charCodeAt(o)===92){if(o++,o>=h)break;const i=w.charCodeAt(o);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(o,h,D){this.regex=o,this.wordSeparators=h,this.simpleSearch=D}}e.SearchData=t;function S(w,o,h){if(!h)return new F.FindMatch(w,null);let D=[];for(let i=0,g=o.length;i<g;i++)D[i]=o[i];return new F.FindMatch(w,D)}e.createFindMatch=S;class n{constructor(o){let h=[],D=0;for(let i=0,g=o.length;i<g;i++)o.charCodeAt(i)===10&&(h[D++]=i);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(o){const h=this._lineFeedsOffsets;let D=0,i=h.length-1;if(i===-1||o<=h[0])return 0;for(;D<i;){const g=D+((i-D)/2>>0);h[g]>=o?i=g-1:h[g+1]>=o?(D=g,i=g):D=g+1}return D+1}}class m{static findMatches(o,h,D,i,g){const a=h.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(o,D,new k(a.wordSeparators,a.regex),i,g):this._doFindMatchesLineByLine(o,D,a,i,g):[]}static _getMultilineMatchRange(o,h,D,i,g,a){let r,v=0;i?(v=i.findLineFeedCountBeforeOffset(g),r=h+g+v):r=h+g;let l;if(i){let y=i.findLineFeedCountBeforeOffset(g+a.length)-v;l=r+a.length+y}else l=r+a.length;const c=o.getPositionAt(r),b=o.getPositionAt(l);return new A.Range(c.lineNumber,c.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(o,h,D,i,g){const a=o.getOffsetAt(h.getStartPosition()),r=o.getValueInRange(h,1),v=o.getEOL()===`\r
`?new n(r):null,l=[];let c=0,b;for(D.reset(0);b=D.next(r);)if(l[c++]=S(this._getMultilineMatchRange(o,a,r,v,b.index,b[0]),b,i),c>=g)return l;return l}static _doFindMatchesLineByLine(o,h,D,i,g){const a=[];let r=0;if(h.startLineNumber===h.endLineNumber){const l=o.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return r=this._findMatchesInLine(D,l,h.startLineNumber,h.startColumn-1,r,a,i,g),a}const v=o.getLineContent(h.startLineNumber).substring(h.startColumn-1);r=this._findMatchesInLine(D,v,h.startLineNumber,h.startColumn-1,r,a,i,g);for(let l=h.startLineNumber+1;l<h.endLineNumber&&r<g;l++)r=this._findMatchesInLine(D,o.getLineContent(l),l,0,r,a,i,g);if(r<g){const l=o.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);r=this._findMatchesInLine(D,l,h.endLineNumber,0,r,a,i,g)}return a}static _findMatchesInLine(o,h,D,i,g,a,r,v){const l=o.wordSeparators;if(!r&&o.simpleSearch){const f=o.simpleSearch,y=f.length,R=h.length;let I=-y;for(;(I=h.indexOf(f,I+y))!==-1;)if((!l||p(l,h,R,I,y))&&(a[g++]=new F.FindMatch(new A.Range(D,I+1+i,D,I+1+y+i),null),g>=v))return g;return g}const c=new k(o.wordSeparators,o.regex);let b;c.reset(0);do if(b=c.next(h),b&&(a[g++]=S(new A.Range(D,b.index+1+i,D,b.index+1+b[0].length+i),b,r),g>=v))return g;while(b);return g}static findNextMatch(o,h,D,i){const g=h.parseSearchRequest();if(!g)return null;const a=new k(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(o,D,a,i):this._doFindNextMatchLineByLine(o,D,a,i)}static _doFindNextMatchMultiline(o,h,D,i){const g=new _.Position(h.lineNumber,1),a=o.getOffsetAt(g),r=o.getLineCount(),v=o.getValueInRange(new A.Range(g.lineNumber,g.column,r,o.getLineMaxColumn(r)),1),l=o.getEOL()===`\r
`?new n(v):null;D.reset(h.column-1);let c=D.next(v);return c?S(this._getMultilineMatchRange(o,a,v,l,c.index,c[0]),c,i):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(o,new _.Position(1,1),D,i):null}static _doFindNextMatchLineByLine(o,h,D,i){const g=o.getLineCount(),a=h.lineNumber,r=o.getLineContent(a),v=this._findFirstMatchInLine(D,r,a,h.column,i);if(v)return v;for(let l=1;l<=g;l++){const c=(a+l-1)%g,b=o.getLineContent(c+1),f=this._findFirstMatchInLine(D,b,c+1,1,i);if(f)return f}return null}static _findFirstMatchInLine(o,h,D,i,g){o.reset(i-1);const a=o.next(h);return a?S(new A.Range(D,a.index+1,D,a.index+1+a[0].length),a,g):null}static findPreviousMatch(o,h,D,i){const g=h.parseSearchRequest();if(!g)return null;const a=new k(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(o,D,a,i):this._doFindPreviousMatchLineByLine(o,D,a,i)}static _doFindPreviousMatchMultiline(o,h,D,i){const g=this._doFindMatchesMultiline(o,new A.Range(1,1,h.lineNumber,h.column),D,i,10*P);if(g.length>0)return g[g.length-1];const a=o.getLineCount();return h.lineNumber!==a||h.column!==o.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(o,new _.Position(a,o.getLineMaxColumn(a)),D,i):null}static _doFindPreviousMatchLineByLine(o,h,D,i){const g=o.getLineCount(),a=h.lineNumber,r=o.getLineContent(a).substring(0,h.column-1),v=this._findLastMatchInLine(D,r,a,i);if(v)return v;for(let l=1;l<=g;l++){const c=(g+a-l-1)%g,b=o.getLineContent(c+1),f=this._findLastMatchInLine(D,b,c+1,i);if(f)return f}return null}static _findLastMatchInLine(o,h,D,i){let g=null,a;for(o.reset(0);a=o.next(h);)g=S(new A.Range(D,a.index+1,D,a.index+1+a[0].length),a,i);return g}}e.TextModelSearch=m;function s(w,o,h,D,i){if(D===0)return!0;const g=o.charCodeAt(D-1);if(w.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=o.charCodeAt(D);if(w.get(a)!==0)return!0}return!1}function u(w,o,h,D,i){if(D+i===h)return!0;const g=o.charCodeAt(D+i);if(w.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=o.charCodeAt(D+i-1);if(w.get(a)!==0)return!0}return!1}function p(w,o,h,D,i){return s(w,o,h,D,i)&&u(w,o,h,D,i)}e.isValidMatch=p;class k{constructor(o,h){this._wordSeparators=o,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const h=o.length;let D;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(D=this._searchRegex.exec(o),!D))return null;const i=D.index,g=D[0].length;if(i===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){d.getNextCodePoint(o,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=g,!this._wordSeparators||p(this._wordSeparators,o,h,i,g))return D}while(D);return null}}e.Searcher=k}),define(be[112],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(P){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let C=0,T=P.notIn.length;C<T;C++)switch(P.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=M;class _{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)A(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),A(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),A(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),A(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&A(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=_;function A(F,P,C){F.has(P)?F.get(P).push(C):F.set(P,[C])}}),define(be[56],Ee([0,1,27,17]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,F,P,C){if(Array.isArray(A)){let T=0;for(const t of A){const S=_(t,F,P,C);if(S===10)return S;S>T&&(T=S)}return T}else{if(typeof A=="string")return C?A==="*"?5:A===P?10:0:0;if(A){const{language:T,pattern:t,scheme:S,hasAccessToAllModels:n}=A;if(!C&&!n)return 0;let m=0;if(S)if(S===F.scheme)m=10;else if(S==="*")m=5;else return 0;if(T)if(T===P)m=10;else if(T==="*")m=Math.max(m,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,M.normalize)(t.base)},s===F.fsPath||(0,d.match)(s,F.fsPath))m=10;else return 0}return m}else return 0}}e.score=_}),define(be[113],Ee([0,1,3,6]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class _{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,P){return this._map.set(F,P),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===P&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,P){let C=null,T=!1;return this._promises.set(F,P.then(t=>{this._promises.delete(F),!(T||!t)&&(C=this.register(F,t))})),(0,M.toDisposable)(()=>{T=!0,C&&C.dispose()})}getPromise(F){const P=this.get(F);if(P)return Promise.resolve(P);const C=this._promises.get(F);return C?C.then(T=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=_}),define(be[81],Ee([0,1,22,25]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(_||(_={}));function A(S){for(let n=0,m=S.length;n<m;n+=4){const s=S[n+0],u=S[n+1],p=S[n+2],k=S[n+3];S[n+0]=k,S[n+1]=p,S[n+2]=u,S[n+3]=s}}function F(S){const n=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return M.isLittleEndian()||A(n),d.VSBuffer.wrap(n)}function P(S){const n=S.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function C(S){const n=new Uint32Array(T(S));let m=0;if(n[m++]=S.id,S.type==="full")n[m++]=1,n[m++]=S.data.length,n.set(S.data,m),m+=S.data.length;else{n[m++]=2,n[m++]=S.deltas.length;for(const s of S.deltas)n[m++]=s.start,n[m++]=s.deleteCount,s.data?(n[m++]=s.data.length,n.set(s.data,m),m+=s.data.length):n[m++]=0}return F(n)}e.encodeSemanticTokensDto=C;function T(S){let n=0;if(n+=1+1,S.type==="full")n+=1+S.data.length;else{n+=1,n+=(1+1+1)*S.deltas.length;for(const m of S.deltas)m.data&&(n+=m.data.length)}return n}function t(S){const n=P(S);let m=0;const s=n[m++];if(n[m++]===1){const w=n[m++],o=n.subarray(m,m+w);return m+=w,{id:s,type:"full",data:o}}const p=n[m++];let k=[];for(let w=0;w<p;w++){const o=n[m++],h=n[m++],D=n[m++];let i;D>0&&(i=n.subarray(m,m+D),m+=D),k[w]={start:o,deleteCount:h,data:i}}return{id:s,type:"delta",deltas:k}}e.decodeSemanticTokensDto=t}),define(be[114],Ee([18,19]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(be[45],Ee([0,1,14,10,114]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,t){return t&&(T.stack||T.stacktrace)?_.localize(0,null,P(T),F(T.stack)||F(T.stacktrace)):P(T)}function F(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?_.localize(1,null,T.message):T.message||_.localize(2,null)}function C(T=null,t=!1){if(!T)return _.localize(3,null);if(Array.isArray(T)){const S=d.coalesce(T),n=C(S[0],t);return S.length>1?_.localize(4,null,n,S.length):n}if(M.isString(T))return T;if(T.detail){const S=T.detail;if(S.error)return A(S.error,t);if(S.exception)return A(S.exception,t)}return T.stack?A(T,t):T.message?T.message:_.localize(5,null)}e.toErrorMessage=C}),define(be[115],Ee([18,19]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(be[116],Ee([0,1,115,25,117]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=F;class P{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,pe){this._values[Z]=pe}}e.ValidatedEditorOptions=P;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class T{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}compute(Z,pe,We){return We}}class t{constructor(Z,pe=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(Z){return this.defaultValue}}class S{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,pe,We){return We}}function n(q,Z){return typeof q=="undefined"?Z:q==="false"?!1:Boolean(q)}e.boolean=n;class m extends S{constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return n(Z,this.defaultValue)}}function s(q,Z,pe,We){if(typeof q=="undefined")return Z;let Ye=parseInt(q,10);return isNaN(Ye)?Z:(Ye=Math.max(pe,Ye),Ye=Math.min(We,Ye),Ye|0)}e.clampedInt=s;class u extends S{constructor(Z,pe,We,Ye,rt,mt=void 0){typeof mt!="undefined"&&(mt.type="integer",mt.default=We,mt.minimum=Ye,mt.maximum=rt),super(Z,pe,We,mt),this.minimum=Ye,this.maximum=rt}static clampedInt(Z,pe,We,Ye){return s(Z,pe,We,Ye)}validate(Z){return u.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class p extends S{constructor(Z,pe,We,Ye,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=We),super(Z,pe,We,rt),this.validationFn=Ye}static clamp(Z,pe,We){return Z<pe?pe:Z>We?We:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return pe;const We=parseFloat(Z);return isNaN(We)?pe:We}validate(Z){return this.validationFn(p.float(Z,this.defaultValue))}}class k extends S{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return k.string(Z,this.defaultValue)}}function w(q,Z,pe){return typeof q!="string"||pe.indexOf(q)===-1?Z:q}e.stringSet=w;class o extends S{constructor(Z,pe,We,Ye,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Ye,rt.default=We),super(Z,pe,We,rt),this._allowedValues=Ye}validate(Z){return w(Z,this.defaultValue,this._allowedValues)}}class h extends T{constructor(Z,pe,We,Ye,rt,mt,ut=void 0){typeof ut!="undefined"&&(ut.type="string",ut.enum=rt,ut.default=Ye),super(Z,pe,We,ut),this._allowedValues=rt,this._convert=mt}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function D(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,We){return We===0?Z.accessibilitySupport:We}}class g extends T{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(q){switch(q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function c(q){switch(q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class b extends t{constructor(){super(126,[65,33])}compute(Z,pe,We){const Ye=["monaco-editor"];return pe.get(33)&&Ye.push(pe.get(33)),Z.extraEditorClassName&&Ye.push(Z.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(99)&&Ye.push("showUnused"),pe.get(124)&&Ye.push("showDeprecated"),Ye.join(" ")}}class f extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Z,pe,We){return We&&Z.emptySelectionClipboard}}class y extends T{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:d.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":w(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class R extends T{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.ON:Z:Boolean(Z)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class I extends t{constructor(){super(43)}compute(Z,pe,We){return Z.fontInfo}}class L extends S{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(Z){let pe=p.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(Z,pe,We){return Z.fontInfo.fontSize}}class E extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:E.MINIMUM_VALUE,maximum:E.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:E.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(u.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,E.MINIMUM_VALUE,E.MAXIMUM_VALUE))}}E.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],E.MINIMUM_VALUE=1,E.MAXIMUM_VALUE=1e3;class N extends T{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:d.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:w(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??w(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??w(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??w(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??w(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??w(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:k.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:k.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:k.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:k.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:k.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends T{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(52,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:d.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:u.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky)}}}var B;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class G extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(Z,pe,We){return G.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,We=Z.scrollBeyondLastLine?pe-1:0,Ye=(Z.viewLineCount+We)/(Z.pixelRatio*Z.height),rt=Math.floor(Z.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:We,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(Z,pe){const We=Z.outerWidth,Ye=Z.outerHeight,rt=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const mt=pe.stableMinimapLayoutInput,ut=mt&&Z.outerHeight===mt.outerHeight&&Z.lineHeight===mt.lineHeight&&Z.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===mt.pixelRatio&&Z.scrollBeyondLastLine===mt.scrollBeyondLastLine&&Z.minimap.enabled===mt.minimap.enabled&&Z.minimap.side===mt.minimap.side&&Z.minimap.size===mt.minimap.size&&Z.minimap.showSlider===mt.minimap.showSlider&&Z.minimap.renderCharacters===mt.minimap.renderCharacters&&Z.minimap.maxColumn===mt.minimap.maxColumn&&Z.minimap.scale===mt.minimap.scale&&Z.verticalScrollbarWidth===mt.verticalScrollbarWidth&&Z.isViewportWrapping===mt.isViewportWrapping,St=Z.lineHeight,Tt=Z.typicalHalfwidthCharacterWidth,It=Z.scrollBeyondLastLine,Xe=Z.minimap.renderCharacters;let vt=rt>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Pe=Z.minimap.maxColumn,Se=Z.minimap.size,Ce=Z.minimap.side,te=Z.verticalScrollbarWidth,ue=Z.viewLineCount,me=Z.remainingWidth,fe=Z.isViewportWrapping,Ie=Xe?2:3;let Be=Math.floor(rt*Ye);const Ne=Be/rt;let qe=!1,it=!1,Le=Ie*vt,de=vt/rt,ge=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:pt,desiredRatio:dt,minimapLineCount:ht}=G.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:It,height:Ye,lineHeight:St,pixelRatio:rt});if(ue/ht>1)qe=!0,it=!0,vt=1,Le=1,de=vt/rt;else{let _t=!1,yt=vt+1;if(Se==="fit"){const Pt=Math.ceil((ue+pt)*Le);fe&&ut&&me<=pe.stableFitRemainingWidth?(_t=!0,yt=pe.stableFitMaxMinimapScale):_t=Pt>Be}if(Se==="fill"||_t){qe=!0;const Pt=vt;Le=Math.min(St*rt,Math.max(1,Math.floor(1/dt))),fe&&ut&&me<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),vt=Math.min(yt,Math.max(1,Math.floor(Le/Ie))),vt>Pt&&(ge=Math.min(2,vt/Pt)),de=vt/rt/ge,Be=Math.ceil(Math.max(ct,ue+pt)*Le),fe?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=me,pe.stableFitMaxMinimapScale=vt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const X=Math.floor(Pe*de),z=Math.min(X,Math.max(0,Math.floor((me-te-2)*de/(Tt+de)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(rt*z);const ke=we/rt;we=Math.floor(we*ge);const Je=Xe?1:2,xe=Ce==="left"?0:We-z-te;return{renderMinimap:Je,minimapLeft:xe,minimapWidth:z,minimapHeightIsEditorHeight:qe,minimapIsSampling:it,minimapScale:vt,minimapLineHeight:Le,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:Be,minimapCanvasOuterWidth:ke,minimapCanvasOuterHeight:Ne}}static computeLayout(Z,pe){const We=pe.outerWidth|0,Ye=pe.outerHeight|0,rt=pe.lineHeight|0,mt=pe.lineNumbersDigitCount|0,ut=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,Tt=pe.pixelRatio,It=pe.viewLineCount,Xe=Z.get(121),vt=Xe==="inherit"?Z.get(120):Xe,Pe=vt==="inherit"?Z.get(116):vt,Se=Z.get(119),Ce=Z.get(2),te=pe.isDominatedByLongLines,ue=Z.get(49),me=Z.get(59).renderType!==0,fe=Z.get(60),Ie=Z.get(93),Be=Z.get(64),Ne=Z.get(91),qe=Ne.verticalScrollbarSize,it=Ne.verticalHasArrows,Le=Ne.arrowSize,de=Ne.horizontalScrollbarSize,ge=Z.get(57),X=Z.get(37);let z;if(typeof ge=="string"&&/^\d+(\.\d+)?ch$/.test(ge)){const xt=parseFloat(ge.substr(0,ge.length-2));z=u.clampedInt(xt*ut,0,0,1e3)}else z=u.clampedInt(ge,0,0,1e3);X&&(z+=16);let we=0;if(me){const xt=Math.max(mt,fe);we=Math.round(xt*St)}let ke=0;ue&&(ke=rt);let Je=0,xe=Je+ke,ct=xe+we,pt=ct+z;const dt=We-ke-we-z;let ht=!1,ft=!1,_t=-1;Ce!==2&&(vt==="inherit"&&te?(ht=!0,ft=!0):Pe==="on"||Pe==="bounded"?ft=!0:Pe==="wordWrapColumn"&&(_t=Se));const yt=G._computeMinimapLayout({outerWidth:We,outerHeight:Ye,lineHeight:rt,typicalHalfwidthCharacterWidth:ut,pixelRatio:Tt,scrollBeyondLastLine:Ie,minimap:Be,verticalScrollbarWidth:qe,viewLineCount:It,remainingWidth:dt,isViewportWrapping:ft},pe.memory||new C);yt.renderMinimap!==0&&yt.minimapLeft===0&&(Je+=yt.minimapWidth,xe+=yt.minimapWidth,ct+=yt.minimapWidth,pt+=yt.minimapWidth);const Pt=dt-yt.minimapWidth,Nt=Math.max(1,Math.floor((Pt-qe-2)/ut)),Ct=it?Le:0;return ft&&(_t=Math.max(1,Nt),Pe==="bounded"&&(_t=Math.min(_t,Se))),{width:We,height:Ye,glyphMarginLeft:Je,glyphMarginWidth:ke,lineNumbersLeft:xe,lineNumbersWidth:we,decorationsLeft:ct,decorationsWidth:z,contentLeft:pt,contentWidth:Pt,minimap:yt,viewportColumn:Nt,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:_t,verticalScrollbarWidth:qe,horizontalScrollbarHeight:de,overviewRuler:{top:Ct,width:qe,height:Ye-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=G;class H extends T{constructor(){const Z={enabled:!0};super(56,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:d.localize(42,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class W extends T{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:d.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:k.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ne extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>p.clamp(Z,0,150),{markdownDescription:d.localize(46,null)})}compute(Z,pe,We){return Z.fontInfo.lineHeight}}class V extends T{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:Z.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:d.localize(56,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:w(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(pe.side,this.defaultValue.side,["right","left"]),showSlider:w(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(pe.scale,1,1,3),maxColumn:u.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:u.clampedInt(pe.top,0,0,1e3),bottom:u.clampedInt(pe.bottom,0,0,1e3)}}}class le extends T{constructor(){const Z={enabled:!0,cycle:!1};super(75,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:d.localize(60,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class re extends t{constructor(){super(127)}compute(Z,pe,We){return Z.pixelRatio}}class ve extends T{constructor(){const Z={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:d.localize(61,null)},comments:{type:"boolean",default:Z.comments,description:d.localize(62,null)},other:{type:"boolean",default:Z.other,description:d.localize(63,null)}}}],default:Z,description:d.localize(64,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const pe=Z,We={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return We.other&&We.comments&&We.strings?!0:!We.other&&!We.comments&&!We.strings?!1:We}return this.defaultValue}}var Fe;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(Z){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(pe=4,We=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function Oe(q){const Z=q.get(86);return Z==="editable"?q.get(80):Z!=="on"}e.filterValidationDecorations=Oe;class Ke extends T{constructor(){const Z=[],pe={type:"number",description:d.localize(70,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:Z,description:d.localize(72,null)})}validate(Z){if(Array.isArray(Z)){let pe=[];for(let We of Z)if(typeof We=="number")pe.push({column:u.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ye=We;pe.push({column:u.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((We,Ye)=>We.column-Ye.column),pe}return this.defaultValue}}function je(q,Z){if(typeof q!="string")return Z;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends T{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:d.localize(83,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,We=u.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=u.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(pe.vertical,this.defaultValue.vertical),horizontal:je(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:u.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:u.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class $ extends T{constructor(){const Z={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:d.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:w(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends T{constructor(){const Z={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,description:d.localize(85,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],default:Z.bracketPairs,description:d.localize(86,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],default:Z.bracketPairsHorizontal,description:d.localize(87,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:d.localize(88,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:d.localize(89,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Z.highlightActiveIndentation,description:d.localize(90,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:ae(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ae(q,Z,pe){const We=pe.indexOf(q);return We===-1?Z:pe[We]}class K extends T{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(91,null),d.localize(92,null)],default:Z.insertMode,description:d.localize(93,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:d.localize(94,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:d.localize(95,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:d.localize(96,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:d.localize(97,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:d.localize(98,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:d.localize(99,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:d.localize(100,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:d.localize(101,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(102,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(103,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(104,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(105,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(106,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:w(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:w(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class se extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(133,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends t{constructor(){super(128,[80])}compute(Z,pe,We){return pe.get(80)?!0:Z.tabFocusMode}}var Ae;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Ae=e.WrappingIndent||(e.WrappingIndent={}));function Ue(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends t{constructor(){super(130,[129])}compute(Z,pe,We){const Ye=pe.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Qe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?st:Qe,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(134,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(135,null),""],markdownDescription:d.localize(136,null)})),accessibilitySupport:ye(new i),accessibilityPageSize:ye(new u(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(137,null)})),ariaLabel:ye(new k(4,"ariaLabel",d.localize(138,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(139,null),d.localize(140,null),""],description:d.localize(141,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(142,null),""],description:d.localize(143,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(144,null),""],description:d.localize(145,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(146,null),d.localize(147,null),""],description:d.localize(148,null)})),autoIndent:ye(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[d.localize(149,null),d.localize(150,null),d.localize(151,null),d.localize(152,null),d.localize(153,null)],description:d.localize(154,null)})),automaticLayout:ye(new m(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(155,null),d.localize(156,null),d.localize(157,null),""],description:d.localize(158,null)})),bracketPairColorization:ye(new Q),bracketPairGuides:ye(new ee),stickyTabStops:ye(new m(103,"stickyTabStops",!1,{description:d.localize(159,null)})),codeLens:ye(new m(14,"codeLens",!0,{description:d.localize(160,null)})),codeLensFontFamily:ye(new k(15,"codeLensFontFamily","",{description:d.localize(161,null)})),codeLensFontSize:ye(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(162,null)})),colorDecorators:ye(new m(17,"colorDecorators",!0,{description:d.localize(163,null)})),columnSelection:ye(new m(18,"columnSelection",!1,{description:d.localize(164,null)})),comments:ye(new g),contextmenu:ye(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new m(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(165,null)})),cursorBlinking:ye(new h(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:d.localize(166,null)})),cursorSmoothCaretAnimation:ye(new m(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(167,null)})),cursorStyle:ye(new h(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:d.localize(168,null)})),cursorSurroundingLines:ye(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(169,null)})),cursorSurroundingLinesStyle:ye(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(170,null),d.localize(171,null)],description:d.localize(172,null)})),cursorWidth:ye(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(173,null)})),disableLayerHinting:ye(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new m(30,"domReadOnly",!1)),dragAndDrop:ye(new m(31,"dragAndDrop",!0,{description:d.localize(174,null)})),emptySelectionClipboard:ye(new f),extraEditorClassName:ye(new k(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new p(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:d.localize(175,null)})),find:ye(new y),fixedOverflowWidgets:ye(new m(36,"fixedOverflowWidgets",!1)),folding:ye(new m(37,"folding",!0,{description:d.localize(176,null)})),foldingStrategy:ye(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(177,null),d.localize(178,null)],description:d.localize(179,null)})),foldingHighlight:ye(new m(39,"foldingHighlight",!0,{description:d.localize(180,null)})),foldingImportsByDefault:ye(new m(40,"foldingImportsByDefault",!1,{description:d.localize(181,null)})),unfoldOnClickAfterEndOfLine:ye(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(182,null)})),fontFamily:ye(new k(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(183,null)})),fontInfo:ye(new I),fontLigatures2:ye(new R),fontSize:ye(new L),fontWeight:ye(new E),formatOnPaste:ye(new m(47,"formatOnPaste",!1,{description:d.localize(184,null)})),formatOnType:ye(new m(48,"formatOnType",!1,{description:d.localize(185,null)})),glyphMargin:ye(new m(49,"glyphMargin",!0,{description:d.localize(186,null)})),gotoLocation:ye(new N),hideCursorInOverviewRuler:ye(new m(51,"hideCursorInOverviewRuler",!1,{description:d.localize(187,null)})),hover:ye(new U),inDiffEditor:ye(new m(53,"inDiffEditor",!1)),letterSpacing:ye(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>p.clamp(q,-5,20),{description:d.localize(188,null)})),lightbulb:ye(new H),lineDecorationsWidth:ye(new S(57,"lineDecorationsWidth",10)),lineHeight:ye(new ne),lineNumbers:ye(new Me),lineNumbersMinChars:ye(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new m(61,"linkedEditing",!1,{description:d.localize(189,null)})),links:ye(new m(62,"links",!0,{description:d.localize(190,null)})),matchBrackets:ye(new o(63,"matchBrackets","always",["always","near","never"],{description:d.localize(191,null)})),minimap:ye(new V),mouseStyle:ye(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new p(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:d.localize(192,null)})),mouseWheelZoom:ye(new m(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(193,null)})),multiCursorMergeOverlapping:ye(new m(68,"multiCursorMergeOverlapping",!0,{description:d.localize(194,null)})),multiCursorModifier:ye(new h(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[d.localize(195,null),d.localize(196,null)],markdownDescription:d.localize(197,null)})),multiCursorPaste:ye(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(198,null),d.localize(199,null)],markdownDescription:d.localize(200,null)})),occurrencesHighlight:ye(new m(71,"occurrencesHighlight",!0,{description:d.localize(201,null)})),overviewRulerBorder:ye(new m(72,"overviewRulerBorder",!0,{description:d.localize(202,null)})),overviewRulerLanes:ye(new u(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new le),peekWidgetDefaultFocus:ye(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(203,null),d.localize(204,null)],description:d.localize(205,null)})),definitionLinkOpensInPeek:ye(new m(77,"definitionLinkOpensInPeek",!1,{description:d.localize(206,null)})),quickSuggestions:ye(new ve),quickSuggestionsDelay:ye(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(207,null)})),readOnly:ye(new m(80,"readOnly",!1)),renameOnType:ye(new m(81,"renameOnType",!1,{description:d.localize(208,null),markdownDeprecationMessage:d.localize(209,null)})),renderControlCharacters:ye(new m(82,"renderControlCharacters",!1,{description:d.localize(210,null)})),renderFinalNewline:ye(new m(83,"renderFinalNewline",!0,{description:d.localize(211,null)})),renderLineHighlight:ye(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(212,null)],description:d.localize(213,null)})),renderLineHighlightOnlyWhenFocus:ye(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(214,null)})),renderValidationDecorations:ye(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(215,null),d.localize(216,null),d.localize(217,null),""],description:d.localize(218,null)})),revealHorizontalRightPadding:ye(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new m(89,"roundedSelection",!0,{description:d.localize(219,null)})),rulers:ye(new Ke),scrollbar:ye(new Ve),scrollBeyondLastColumn:ye(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(220,null)})),scrollBeyondLastLine:ye(new m(93,"scrollBeyondLastLine",!0,{description:d.localize(221,null)})),scrollPredominantAxis:ye(new m(94,"scrollPredominantAxis",!0,{description:d.localize(222,null)})),selectionClipboard:ye(new m(95,"selectionClipboard",!0,{description:d.localize(223,null),included:M.isLinux})),selectionHighlight:ye(new m(96,"selectionHighlight",!0,{description:d.localize(224,null)})),selectOnLineNumbers:ye(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(225,null),d.localize(226,null)],description:d.localize(227,null)})),showUnused:ye(new m(99,"showUnused",!0,{description:d.localize(228,null)})),showDeprecated:ye(new m(124,"showDeprecated",!0,{description:d.localize(229,null)})),inlayHints:ye(new W),snippetSuggestions:ye(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(230,null),d.localize(231,null),d.localize(232,null),d.localize(233,null)],description:d.localize(234,null)})),smartSelect:ye(new se),smoothScrolling:ye(new m(102,"smoothScrolling",!1,{description:d.localize(235,null)})),stopRenderingLineAfter:ye(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new K),inlineSuggest:ye(new $),suggestFontSize:ye(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(236,null)})),suggestLineHeight:ye(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(237,null)})),suggestOnTriggerCharacters:ye(new m(108,"suggestOnTriggerCharacters",!0,{description:d.localize(238,null)})),suggestSelection:ye(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(239,null),d.localize(240,null),d.localize(241,null)],description:d.localize(242,null)})),tabCompletion:ye(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(243,null),d.localize(244,null),d.localize(245,null)],description:d.localize(246,null)})),tabIndex:ye(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(247,null),d.localize(248,null),d.localize(249,null)],description:d.localize(250,null)})),useShadowDOM:ye(new m(113,"useShadowDOM",!0)),useTabStops:ye(new m(114,"useTabStops",!0,{description:d.localize(251,null)})),wordSeparators:ye(new k(115,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:d.localize(252,null)})),wordWrap:ye(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(253,null),d.localize(254,null),d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),wordWrapBreakAfterCharacters:ye(new k(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new k(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(258,null)})),wordWrapOverride1:ye(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new h(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ue,{enumDescriptions:[d.localize(259,null),d.localize(260,null),d.localize(261,null),d.localize(262,null)],description:d.localize(263,null)})),wrappingStrategy:ye(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(264,null),d.localize(265,null)],description:d.localize(266,null)})),editorClassName:ye(new b),pixelRatio:ye(new re),tabFocusMode:ye(new he),layoutInfo:ye(new G),wrappingInfo:ye(new He)}}),define(be[118],Ee([18,19]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[119],Ee([18,19]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[120],Ee([18,19]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(be[121],Ee([18,19]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(be[122],Ee([18,19]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(be[123],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[124],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[125],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(be[126],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[127],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[128],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[129],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[130],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(be[131],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(be[132],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[133],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[134],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[135],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[136],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var _;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[137],Ee([0,1,119]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function F(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=F;function P(n){if(!n)return null;let m=n.majorBase,s=n.majorMustEqual,u=n.minorBase,p=n.minorMustEqual,k=n.patchBase,w=n.patchMustEqual;n.hasCaret&&(m===0||(p=!1),w=!1);let o=0;if(n.preRelease){const h=_.exec(n.preRelease);if(h){const[,D,i,g]=h;o=Date.UTC(Number(D),Number(i)-1,Number(g))}}return{majorBase:m,majorMustEqual:s,minorBase:u,minorMustEqual:p,patchBase:k,patchMustEqual:w,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=P;function C(n,m,s){let u;typeof n=="string"?u=P(F(n)):u=n;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let k;if(typeof s=="string"?k=P(F(s)):k=s,!u||!k)return!1;let w=u.majorBase,o=u.minorBase,h=u.patchBase,D=k.majorBase,i=k.minorBase,g=k.patchBase,a=k.notBefore,r=k.majorMustEqual,v=k.minorMustEqual,l=k.patchMustEqual;return k.isMinimum?w>D?!0:w<D?!1:o>i?!0:o<i||p&&p<a?!1:h>=g:(w===1&&D===0&&(!r||!v||!l)&&(D=1,i=0,g=0,r=!0,v=!1,l=!1),w<D?!1:w>D?!r:o<i?!1:o>i?!v:h<g?!1:h>g?!l:!(p&&p<a))}e.isValidVersion=C;function T(n,m,s,u){return s.isBuiltin||typeof s.main=="undefined"?!0:S(n,m,s.engines.vscode,u)}e.isValidExtensionVersion=T;function t(n,m,s){return n==="*"||S(m,s,n)}e.isEngineValid=t;function S(n,m,s,u=[]){let p=P(F(s));if(!p)return u.push(d.localize(0,null,s)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(d.localize(1,null,s)),!1}else if(!p.majorMustEqual)return u.push(d.localize(2,null,s)),!1;return C(n,m,p)?!0:(u.push(d.localize(3,null,n,s)),!1)}}),define(be[82],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(_,A=[],F=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=d}),define(be[57],Ee([0,1,82]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function _(F,P,C){P instanceof d.SyncDescriptor||(P=new d.SyncDescriptor(P,[],C)),M.push([F,P])}e.registerSingleton=_;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[138],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const P=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(F);P.outgoing.set(this._hashFn(F),C),C.incoming.set(this._hashFn(A),P)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let P of this._nodes.values())P.outgoing.delete(F),P.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let P=this._nodes.get(F);return P||(P=new d(A),this._nodes.set(F,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,P]of this._nodes)A.push(`${F}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const P=new Set([A]),C=this._findCycle(F,P);if(C)return C}}_findCycle(A,F){for(let[P,C]of A.outgoing){if(F.has(P))return[...F,P].join(" -> ");F.add(P);const T=this._findCycle(C,F);if(T)return T;F.delete(P)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function C(T){return T[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=C})(d=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function M(P,C,T,t){C[d.DI_TARGET]===C?C[d.DI_DEPENDENCIES].push({id:P,index:T,optional:t}):(C[d.DI_DEPENDENCIES]=[{id:P,index:T,optional:t}],C[d.DI_TARGET]=C)}function _(P){if(d.serviceIds.has(P))return d.serviceIds.get(P);const C=function(T,t,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(C,T,S,!1)};return C.toString=()=>P,d.serviceIds.set(P,C),C}e.createDecorator=_;function A(P){return P}e.refineServiceDecorator=A;function F(P){return function(C,T,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(P,C,t,!0)}}e.optional=F}),define(be[139],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[140],Ee([0,1,3,58,6,20,76,56,139]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(T):!!u.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(p,k){let w={selector:p,provider:k,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,_.toDisposable)(()=>{if(w){let o=this._entries.indexOf(w);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const k=[];for(let w of this._entries)w._score>0&&k.push(w.provider);return k}ordered(p){const k=[];return this._orderedForEach(p,w=>k.push(w.provider)),k}orderedGroups(p){const k=[];let w,o;return this._orderedForEach(p,h=>{w&&o===h._score?w.push(h.provider):(o=h._score,w=[h.provider],k.push(w))}),k}_orderedForEach(p,k){if(!!p){this._updateScores(p);for(const w of this._entries)w._score>0&&k(w)}}_updateScores(p){let k={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===k.language&&this._lastCandidate.uri===k.uri)){this._lastCandidate=k;for(let w of this._entries)if(w._score=(0,P.score)(w.selector,p.uri,p.getLanguageId(),(0,C.shouldSynchronizeModel)(p)),T(w.selector)&&w._score>0){for(let o of this._entries)o._score=0;w._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(p,k){return p._score<k._score?1:p._score>k._score?-1:p._time<k._time?1:p._time>k._time?-1:0}}e.LanguageFeatureRegistry=t;const S=new WeakMap;let n=0;function m(u){let p=S.get(u);return p===void 0&&(p=++n,S.set(u,p)),p}class s{constructor(p,k,w=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=k,this.max=w,this._cache=new A.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((k,w)=>(0,M.doHash)(m(w),k),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const k=this._key(p),w=this._cache.get(k);return this._clamp(w?.value)}update(p,k){const w=this._key(p);let o=this._cache.get(w);return o||(o=new F.MovingAverage,this._cache.set(w,o)),o.update(k),this.get(p)}}e.LanguageFeatureRequestDelays=s}),define(be[59],Ee([0,1,2,44,140,113,34]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var C;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var T;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var t;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(t=e.StandardTokenType||(e.StandardTokenType={}));var S;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(S=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let R=this.getForeground(y),I="mtk"+R,L=this.getFontStyle(y);return L&1&&(I+=" mtki"),L&2&&(I+=" mtkb"),L&4&&(I+=" mtku"),I}static getInlineStyleFromMetadata(y,R){const I=this.getForeground(y),L=this.getFontStyle(y);let E=`color: ${R[I]};`;return L&1&&(E+="font-style: italic;"),L&2&&(E+="font-weight: bold;"),L&4&&(E+="text-decoration: underline;"),E}}e.TokenMetadata=n;var m;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(y){const R=f[y];let I=R&&F.iconRegistry.get(R);return I||(console.info("No codicon found for CompletionItemKind "+y),I=F.Codicon.symbolProperty),I.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(y,R){let I=f[y];return typeof I=="undefined"&&!R&&(I=9),I}}();var s;(function(f){f[f.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var u;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(u=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var k;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(k=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function D(f){return f&&d.URI.isUri(f.uri)&&M.Range.isIRange(f.range)&&(M.Range.isIRange(f.originSelectionRange)||M.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=D;var i;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var g;(function(f){f[f.Deprecated=1]="Deprecated"})(g=e.SymbolTag||(e.SymbolTag={}));var a;(function(f){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function I(N){return y.get(N)}f.fromString=I;function L(N){return R.get(N)}f.toString=L;function E(N,U){const B=R.get(N);let G=B&&F.iconRegistry.get("symbol-"+B);return G||(console.info("No codicon found for SymbolKind "+N),G=F.Codicon.symbolProperty),`${U?"inline":"block"} ${G.classNames}`}f.toCssClassName=E})(a=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(y){this.value=y}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var v;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new _.LanguageFeatureRegistry,e.RenameProviderRegistry=new _.LanguageFeatureRegistry,e.CompletionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new _.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new _.LanguageFeatureRegistry,e.HoverProviderRegistry=new _.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new _.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new _.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new _.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new _.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new _.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.LinkProviderRegistry=new _.LanguageFeatureRegistry,e.ColorProviderRegistry=new _.LanguageFeatureRegistry,e.SelectionRangeRegistry=new _.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var b;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[46],Ee([0,1,25,9,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",d.isMacintosh),F.set("isLinux",d.isLinux),F.set("isWindows",d.isWindows),F.set("isWeb",d.isWeb),F.set("isMacNative",d.isMacintosh&&!d.isWeb),F.set("isEdge",A.indexOf("Edg/")>=0),F.set("isFirefox",A.indexOf("Firefox")>=0),F.set("isChrome",A.indexOf("Chrome")>=0),F.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var C;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(E){return s.create(E)}static equals(E,N){return u.create(E,N)}static notEquals(E,N){return w.create(E,N)}static regex(E,N){return a.create(E,N)}static in(E,N){return p.create(E,N)}static not(E){return o.create(E)}static and(...E){return l.create(E,null)}static or(...E){return c.create(E,null,!0)}static greater(E,N){return h.create(E,N)}static less(E,N){return i.create(E,N)}static deserialize(E,N=!1){if(!!E)return this._deserializeOrExpression(E,N)}static _deserializeOrExpression(E,N){let U=E.split("||");return c.create(U.map(B=>this._deserializeAndExpression(B,N)),null,!0)}static _deserializeAndExpression(E,N){let U=E.split("&&");return l.create(U.map(B=>this._deserializeOne(B,N)),null)}static _deserializeOne(E,N){if(E=E.trim(),E.indexOf("!=")>=0){let U=E.split("!=");return w.create(U[0].trim(),this._deserializeValue(U[1],N))}if(E.indexOf("==")>=0){let U=E.split("==");return u.create(U[0].trim(),this._deserializeValue(U[1],N))}if(E.indexOf("=~")>=0){let U=E.split("=~");return a.create(U[0].trim(),this._deserializeRegexValue(U[1],N))}if(E.indexOf(" in ")>=0){let U=E.split(" in ");return p.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const U=E.split(">=");return D.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const U=E.split(">");return h.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const U=E.split("<=");return g.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const U=E.split("<");return i.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(E)?o.create(E.substr(1).trim()):s.create(E)}static _deserializeValue(E,N){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let U=/^'([^']*)'$/.exec(E);return U?U[1].trim():E}static _deserializeRegexValue(E,N){if((0,M.isFalsyOrWhitespace)(E)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=E.indexOf("/"),B=E.lastIndexOf("/");if(U===B||U<0){if(N)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let G=E.slice(U+1,B),H=E[B+1]==="i"?"i":"";try{return new RegExp(G,H)}catch(W){if(N)throw new Error(`bad regexp-value '${E}', parse error: ${W}`);return console.warn(`bad regexp-value '${E}', parse error: ${W}`),null}}}e.ContextKeyExpr=T;function t(L,E){const N=L?L.substituteConstants():void 0,U=E?E.substituteConstants():void 0;return!N&&!U?!0:!N||!U?!1:N.equals(U)}e.expressionsAreEqualWithConstantSubstitution=t;function S(L,E){return L.cmp(E)}class n{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class s{constructor(E,N){this.key=E,this.negated=N,this.type=2}static create(E,N=null){const U=F.get(E);return typeof U=="boolean"?U?m.INSTANCE:n.INSTANCE:new s(E,N)}cmp(E){return E.type!==this.type?this.type-E.type:f(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=F.get(this.key);return typeof E=="boolean"?E?m.INSTANCE:n.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class u{constructor(E,N,U){this.key=E,this.value=N,this.negated=U,this.type=4}static create(E,N,U=null){if(typeof N=="boolean")return N?s.create(E,U):o.create(E,U);const B=F.get(E);return typeof B=="boolean"?N===(B?"true":"false")?m.INSTANCE:n.INSTANCE:new u(E,N,U)}cmp(E){return E.type!==this.type?this.type-E.type:y(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=F.get(this.key);if(typeof E=="boolean"){const N=E?"true":"false";return this.value===N?m.INSTANCE:n.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class p{constructor(E,N){this.key=E,this.valueKey=N,this.type=10,this.negated=null}static create(E,N){return new p(E,N)}cmp(E){return E.type!==this.type?this.type-E.type:y(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const N=E.getValue(this.valueKey),U=E.getValue(this.key);return Array.isArray(N)?N.indexOf(U)>=0:typeof U=="string"&&typeof N=="object"&&N!==null?P.call(N,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=k.create(this)),this.negated}}e.ContextKeyInExpr=p;class k{constructor(E){this._actual=E,this.type=11}static create(E){return new k(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new k(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=k;class w{constructor(E,N,U){this.key=E,this.value=N,this.negated=U,this.type=5}static create(E,N,U=null){if(typeof N=="boolean")return N?o.create(E,U):s.create(E,U);const B=F.get(E);return typeof B=="boolean"?N===(B?"true":"false")?n.INSTANCE:m.INSTANCE:new w(E,N,U)}cmp(E){return E.type!==this.type?this.type-E.type:y(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=F.get(this.key);if(typeof E=="boolean"){const N=E?"true":"false";return this.value===N?n.INSTANCE:m.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class o{constructor(E,N){this.key=E,this.negated=N,this.type=3}static create(E,N=null){const U=F.get(E);return typeof U=="boolean"?U?n.INSTANCE:m.INSTANCE:new o(E,N)}cmp(E){return E.type!==this.type?this.type-E.type:f(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=F.get(this.key);return typeof E=="boolean"?E?n.INSTANCE:m.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;class h{constructor(E,N,U){this.key=E,this.value=N,this.negated=U,this.type=12}static create(E,N,U=null){return new h(E,N,U)}cmp(E){return E.type!==this.type?this.type-E.type:y(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return parseFloat(E.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=h;class D{constructor(E,N,U){this.key=E,this.value=N,this.negated=U,this.type=13}static create(E,N,U=null){return new D(E,N,U)}cmp(E){return E.type!==this.type?this.type-E.type:y(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return parseFloat(E.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=D;class i{constructor(E,N,U){this.key=E,this.value=N,this.negated=U,this.type=14}static create(E,N,U=null){return new i(E,N,U)}cmp(E){return E.type!==this.type?this.type-E.type:y(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return parseFloat(E.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class g{constructor(E,N,U){this.key=E,this.value=N,this.negated=U,this.type=15}static create(E,N,U=null){return new g(E,N,U)}cmp(E){return E.type!==this.type?this.type-E.type:y(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return parseFloat(E.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=g;class a{constructor(E,N){this.key=E,this.regexp=N,this.type=7,this.negated=null}static create(E,N){return new a(E,N)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const N=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return N<U?-1:N>U?1:0}equals(E){if(E.type===this.type){const N=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return this.key===E.key&&N===U}return!1}substituteConstants(){return this}evaluate(E){let N=E.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class r{constructor(E){this._actual=E,this.type=8}static create(E){return new r(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new r(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function v(L){let E=null;for(let N=0,U=L.length;N<U;N++){const B=L[N].substituteConstants();if(L[N]!==B&&E===null){E=[];for(let G=0;G<N;G++)E[G]=L[G]}E!==null&&(E[N]=B)}return E===null?L:E}class l{constructor(E,N){this.expr=E,this.negated=N,this.type=6}static create(E,N){return l._normalizeArr(E,N)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let N=0,U=this.expr.length;N<U;N++){const B=S(this.expr[N],E.expr[N]);if(B!==0)return B}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let N=0,U=this.expr.length;N<U;N++)if(!this.expr[N].equals(E.expr[N]))return!1;return!0}return!1}substituteConstants(){const E=v(this.expr);return E===this.expr?this:l.create(E,this.negated)}evaluate(E){for(let N=0,U=this.expr.length;N<U;N++)if(!this.expr[N].evaluate(E))return!1;return!0}static _normalizeArr(E,N){const U=[];let B=!1;for(const G of E)if(!!G){if(G.type===1){B=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){U.push(...G.expr);continue}U.push(G)}if(U.length===0&&B)return m.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(S);for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];for(;U.length>1;){const G=U[U.length-1];if(G.type!==9)break;U.pop();const H=U.pop(),W=U.length===0,ne=c.create(G.expr.map(V=>l.create([V,H],null)),null,W);ne&&(U.push(ne),U.sort(S))}return U.length===1?U[0]:new l(U,N)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let N of this.expr)E.push(...N.keys());return E}map(E){return new l(this.expr.map(N=>N.map(E)),null)}negate(){if(!this.negated){const E=[];for(let N of this.expr)E.push(N.negate());this.negated=c.create(E,this,!0)}return this.negated}}class c{constructor(E,N){this.expr=E,this.negated=N,this.type=9}static create(E,N,U){return c._normalizeArr(E,N,U)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let N=0,U=this.expr.length;N<U;N++){const B=S(this.expr[N],E.expr[N]);if(B!==0)return B}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let N=0,U=this.expr.length;N<U;N++)if(!this.expr[N].equals(E.expr[N]))return!1;return!0}return!1}substituteConstants(){const E=v(this.expr);return E===this.expr?this:c.create(E,this.negated,!1)}evaluate(E){for(let N=0,U=this.expr.length;N<U;N++)if(this.expr[N].evaluate(E))return!0;return!1}static _normalizeArr(E,N,U){let B=[],G=!1;if(E){for(let H=0,W=E.length;H<W;H++){const ne=E[H];if(!!ne){if(ne.type===0){G=!0;continue}if(ne.type===1)return m.INSTANCE;if(ne.type===9){B=B.concat(ne.expr);continue}B.push(ne)}}if(B.length===0&&G)return n.INSTANCE;B.sort(S)}if(B.length!==0){if(B.length===1)return B[0];for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];if(U){for(let H=0;H<B.length;H++)for(let W=H+1;W<B.length;W++)R(B[H],B[W])&&(B.splice(W,1),W--);if(B.length===1)return B[0]}return new c(B,N)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let N of this.expr)E.push(...N.keys());return E}map(E){return new c(this.expr.map(N=>N.map(E)),null)}negate(){if(!this.negated){let E=[];for(let N of this.expr)E.push(N.negate());for(;E.length>1;){const N=E.shift(),U=E.shift(),B=[];for(const H of I(N))for(const W of I(U))B.push(l.create([H,W],null));const G=E.length===0;E.unshift(c.create(B,null,G))}this.negated=E[0]}return this.negated}}class b extends s{constructor(E,N,U){super(E,null);this._defaultValue=N,typeof U=="object"?b._info.push({...U,key:E}):U!==!0&&b._info.push({key:E,description:U,type:N!=null?typeof N:void 0})}static all(){return b._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return u.create(this.key,E)}notEqualsTo(E){return w.create(this.key,E)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(L,E){return L<E?-1:L>E?1:0}function y(L,E,N,U){return L<N?-1:L>N?1:E<U?-1:E>U?1:0}function R(L,E){if(E.type===6&&L.type!==9&&L.type!==6){for(const B of E.expr)if(L.equals(B))return!0}const N=L.negate(),U=I(N).concat(I(E));U.sort(S);for(let B=0;B<U.length;B++){const H=U[B].negate();for(let W=B+1;W<U.length;W++){const ne=U[W];if(H.equals(ne))return!0}}return!1}e.implies=R;function I(L){return L.type===9?L.expr:[L]}}),define(be[141],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(be[60],Ee([0,1,20,17,9,10,2,120,4]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function T(B){return B.create===!0}e.isFileOpenForWriteOptions=T;var t;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var S;(function(B){B[B.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var n;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=m;function s(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=s;function u(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function p(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=p;var k;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(G,H){super(G);this.code=H}}e.FileSystemProviderError=w;function o(B,G){const H=new w(B.toString(),G);return D(H,G),H}e.createFileSystemProviderError=o;function h(B){return B||o((0,P.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=h;function D(B,G){return B.name=G?`${G} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=D;function i(B){if(!B)return k.Unknown;if(B instanceof w)return B.code;const G=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!G)return k.Unknown;switch(G[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=i;function g(B){if(B instanceof b)return B.fileOperationResult;switch(i(B)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=g;var a;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(G,H,W){this.resource=G,this.operation=H,this.target=W}isOperation(G){return this.operation===G}}e.FileOperationEvent=r;var v;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class l{constructor(G,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const ne of G){const V=W.get(ne.type);V?V.push([ne.resource,ne]):W.set(ne.type,[[ne.resource,ne]])}for(const[ne,V]of W)switch(ne){case 1:this.added=d.TernarySearchTree.forUris(()=>H),this.added.fill(V);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>H),this.updated.fill(V);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>H),this.deleted.fill(V);break}}contains(G,...H){return this.doContains(G,{includeChildren:!1},...H)}affects(G,...H){return this.doContains(G,{includeChildren:!0},...H)}doContains(G,H,...W){if(!G)return!1;const ne=W.length>0;return!!((!ne||W.includes(1))&&(this.added?.get(G)||H.includeChildren&&this.added?.findSuperstr(G))||(!ne||W.includes(0))&&(this.updated?.get(G)||H.includeChildren&&this.updated?.findSuperstr(G))||(!ne||W.includes(2))&&(this.deleted?.findSubstr(G)||H.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function c(B,G,H){return!B||!G||B===G||G.length>B.length?!1:(G.charAt(G.length-1)!==M.sep&&(G+=M.sep),H?(0,_.startsWithIgnoreCase)(B,G):B.indexOf(G)===0)}e.isParent=c;class b extends Error{constructor(G,H,W){super(G);this.fileOperationResult=H,this.options=W}}e.FileOperationError=b;class f extends b{constructor(G,H,W){super(G,2,W);this.stat=H}}e.NotModifiedSinceFileOperationError=f;var y;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function I(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=I;async function L(B,G){if(!G.hasProvider(F.URI.from({scheme:B.scheme})))return new Promise(H=>{const W=G.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===B.scheme&&ne.added&&(W.dispose(),H())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class E{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<E.KB?(0,P.localize)(1,null,G.toFixed(0)):G<E.MB?(0,P.localize)(2,null,(G/E.KB).toFixed(2)):G<E.GB?(0,P.localize)(3,null,(G/E.MB).toFixed(2)):G<E.TB?(0,P.localize)(4,null,(G/E.GB).toFixed(2)):(0,P.localize)(5,null,(G/E.TB).toFixed(2))}}e.ByteSize=E,E.KB=1024,E.MB=E.KB*E.KB,E.GB=E.MB*E.KB,E.TB=E.GB*E.KB;var N;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function U(B){return{maxFileSize:B===0?300*E.MB:16*E.GB,maxHeapSize:B===0?700*E.MB:2*700*E.MB}}e.getPlatformLimits=U}),define(be[61],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(..._){this._entries=new Map;for(let[A,F]of _)this.set(A,F)}set(_,A){const F=this._entries.get(_);return this._entries.set(_,A),F}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=d}),define(be[142],Ee([0,1,12,16,82,138,4,61]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class T extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new P.ServiceCollection,u=!1,p){this._activeInstantiations=new Set,this._services=s,this._strict=u,this._parent=p,this._services.set(F.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...u){let p=n.traceInvocation(s),k=!1;try{return s({get:(o,h)=>{if(k)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const D=this._getOrCreateServiceInstance(o,p);if(!D&&h!==F.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return D}},...u)}finally{k=!0,p.stop()}}createInstance(s,...u){let p,k;return s instanceof _.SyncDescriptor?(p=n.traceCreation(s.ctor),k=this._createInstance(s.ctor,s.staticArguments.concat(u),p)):(p=n.traceCreation(s),k=this._createInstance(s,u,p)),p.stop(),k}_createInstance(s,u=[],p){let k=F._util.getServiceDependencies(s).sort((h,D)=>h.index-D.index),w=[];for(const h of k){let D=this._getOrCreateServiceInstance(h.id,p);if(!D&&this._strict&&!h.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${h.id}.`);w.push(D)}let o=k.length>0?k[0].index:u.length;if(u.length!==o){console.warn(`[createInstance] First service dependency of ${s.name} at position ${o+1} conflicts with ${u.length} static arguments`);let h=o-u.length;h>0?u=u.concat(new Array(h)):u=u.slice(0,o)}return new s(...[...u,...w])}_setServiceInstance(s,u){if(this._services.get(s)instanceof _.SyncDescriptor)this._services.set(s,u);else if(this._parent)this._parent._setServiceInstance(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let u=this._services.get(s);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):u}_getOrCreateServiceInstance(s,u){let p=this._getServiceInstanceOrDescriptor(s);return p instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,p,u.branch(s,!0)):(u.branch(s,!1),p)}_safeCreateAndCacheServiceInstance(s,u,p){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,u,p)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,u,p){const k=new A.Graph(h=>h.id.toString());let w=0;const o=[{id:s,desc:u,_trace:p}];for(;o.length;){const h=o.pop();if(k.lookupOrInsertNode(h),w++>1e3)throw new T(k);for(let D of F._util.getServiceDependencies(h.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(D.id);if(!i&&!D.optional&&console.warn(`[createInstance] ${s} depends on ${D.id} which is NOT registered.`),i instanceof _.SyncDescriptor){const g={id:D.id,desc:i,_trace:h._trace.branch(D.id,!0)};k.insertEdge(h,g),o.push(g)}}}for(;;){const h=k.roots();if(h.length===0){if(!k.isEmpty())throw new T(k);break}for(const{data:D}of h){if(this._getServiceInstanceOrDescriptor(D.id)instanceof _.SyncDescriptor){const g=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,g)}k.removeNode(D)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,u,p=[],k,w){if(this._services.get(s)instanceof _.SyncDescriptor)return this._createServiceInstance(u,p,k,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,u,p,k,w);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(s,u=[],p,k){if(p){const w=new d.IdleValue(()=>this._createInstance(s,u,k));return new Proxy(Object.create(null),{get(o,h){if(h in o)return o[h];let D=w.value,i=D[h];return typeof i!="function"||(i=i.bind(D),o[h]=i),i},set(o,h,D){return w.value[h]=D,!0}})}else return this._createInstance(s,u,k)}}e.InstantiationService=t;var S;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(S||(S={}));class n{constructor(s,u){this.type=s,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return C?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return C?new n(0,s.name):n._None}branch(s,u){let p=new n(2,s.toString());return this._dep.push([s,u,p]),p}stop(){let s=Date.now()-this._start;n._totals+=s;let u=!1;function p(w,o){let h=[],D=new Array(w+1).join("	");for(const[i,g,a]of o._dep)if(g&&a){u=!0,h.push(`${D}CREATES -> ${i}`);let r=p(w+1,a);r&&h.push(r)}else h.push(`${D}uses -> ${i}`);return h.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||u)&&console.log(k.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,45,3,6,25,4]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;class T extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...g){this.checkLogLevel(C.Trace)&&this.log(C.Trace,this.format([i,...g]))}debug(i,...g){this.checkLogLevel(C.Debug)&&this.log(C.Debug,this.format([i,...g]))}info(i,...g){this.checkLogLevel(C.Info)&&this.log(C.Info,this.format([i,...g]))}warn(i,...g){this.checkLogLevel(C.Warning)&&this.log(C.Warning,this.format([i,...g]))}error(i,...g){if(this.checkLogLevel(C.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(C.Error,this.format(a))}else this.log(C.Error,this.format([i,...g]))}critical(i,...g){this.checkLogLevel(C.Critical)&&this.log(C.Critical,this.format([i,...g]))}flush(){}format(i){let g="";for(let a=0;a<i.length;a++){let r=i[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch(v){}g+=(a>0?" ":"")+r}return g}}e.AbstractMessageLogger=t;class S extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...g){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}debug(i,...g){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}info(i,...g){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}warn(i,...g){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...g):console.warn(`[main ${P()}]`,i,...g))}error(i,...g){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...g):console.error(`[main ${P()}]`,i,...g))}critical(i,...g){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...g):console.error(`[main ${P()}]`,i,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class n extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...g){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",i,...g)}debug(i,...g){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...g)}info(i,...g){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",i,...g)}warn(i,...g){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",i,...g)}error(i,...g){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",i,...g)}critical(i,...g){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...g)}dispose(){}flush(){}}e.ConsoleLogger=n;class m extends T{constructor(i,g=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(g)}trace(i,...g){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(i),...g])}debug(i,...g){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(i),...g])}info(i,...g){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(i),...g])}warn(i,...g){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(i),...g])}error(i,...g){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(i),...g])}critical(i,...g){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(i),...g])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class s extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const g of this.logServices)g.setLevel(i);super.setLevel(i)}trace(i,...g){for(const a of this.logServices)a.trace(i,...g)}debug(i,...g){for(const a of this.logServices)a.debug(i,...g)}info(i,...g){for(const a of this.logServices)a.info(i,...g)}warn(i,...g){for(const a of this.logServices)a.warn(i,...g)}error(i,...g){for(const a of this.logServices)a.error(i,...g)}critical(i,...g){for(const a of this.logServices)a.critical(i,...g)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class u extends _.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...g){this.logger.trace(i,...g)}debug(i,...g){this.logger.debug(i,...g)}info(i,...g){this.logger.info(i,...g)}warn(i,...g){this.logger.warn(i,...g)}error(i,...g){this.logger.error(i,...g)}critical(i,...g){this.logger.critical(i,...g)}flush(){this.logger.flush()}}e.LogService=u;class p extends _.Disposable{constructor(i,g){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(g(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,g){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,g?.always?C.Trace:this.logLevel,g),this.loggers.set(i.toString(),a),g?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class k{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return C.Info}trace(i,...g){}debug(i,...g){}info(i,...g){}warn(i,...g){}error(i,...g){}critical(i,...g){}dispose(){}flush(){}}e.NullLogService=k;function w(D){if(D.verbose)return C.Trace;if(typeof D.logLevel=="string"){const i=o(D.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function o(D){switch(D){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=o;function h(D){switch(D){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=h}),define(be[83],Ee([0,1,35,121,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var F;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function T(s,u){return u-s}C.compare=T;const t=Object.create(null);t[C.Error]=(0,M.localize)(0,null),t[C.Warning]=(0,M.localize)(1,null),t[C.Info]=(0,M.localize)(2,null);function S(s){return t[s]||""}C.toString=S;function n(s){switch(s){case d.default.Error:return C.Error;case d.default.Warning:return C.Warning;case d.default.Info:return C.Info;case d.default.Ignore:return C.Hint}}C.fromSeverity=n;function m(s){switch(s){case C.Error:return d.default.Error;case C.Warning:return d.default.Warning;case C.Info:return d.default.Info;case C.Hint:return d.default.Ignore}}C.toSeverity=m}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const T="";function t(n){return S(n,!0)}C.makeKey=t;function S(n,m){let s=[T];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(T),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(T),n.severity!==void 0&&n.severity!==null?s.push(F.toString(n.severity)):s.push(T),n.message&&m?s.push(n.message.replace("\xA6","\\\xA6")):s.push(T),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(T),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(T),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(T),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(T),s.push(T),s.join("\xA6")}C.makeKeyOptionalMessage=S})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(be[143],Ee([0,1,3,35,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=C}),define(be[144],Ee([0,1,6,9,2,4]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function F(P,C){return _.URI.isUri(P)?(0,M.equalsIgnoreCase)(P.scheme,C):(0,M.startsWithIgnoreCase)(P,C+":")}e.matchesScheme=F});var $e=this&&this.__decorate||function(oe,e,d,M){var _=arguments.length,A=_<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,d,M);else for(var P=oe.length-1;P>=0;P--)(F=oe[P])&&(A=(_<3?F(A):_>3?F(e,d,A):F(e,d))||A);return _>3&&A&&Object.defineProperty(e,d,A),A},ze=this&&this.__param||function(oe,e){return function(d,M){e(d,M,oe)}};define(be[145],Ee([0,1,12,21,6,4]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(S){this.callback=S}get value(){return this._value}report(S){this._value=S,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends _.Disposable{constructor(S,n){super();this.deferred=new d.DeferredPromise,n.withProgress(S,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};C=$e([ze(1,e.IProgressService)],C),e.UnmanagedProgress=C;class T extends _.Disposable{constructor(S){super();this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(S){this.stop();const n=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(F,P){d.ok(M.isString(F)),d.ok(M.isObject(P)),d.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,P)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new _}),define(be[84],Ee([0,1,3,28]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,T){this.schemasById[_(C)]=T,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,14,3,10,118,84,28]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=P.Registry.as(F.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,h=!0){this.registerConfigurations([o],h)}registerConfigurations(o,h=!0){const D=this.doRegisterConfigurations(o,h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterConfigurations(o){const h=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}updateConfigurations({add:o,remove:h}){const D=[];D.push(...this.doDeregisterConfigurations(h)),D.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,d.distinct)(D))}registerDefaultConfigurations(o){const h=[],D=[];for(const i of o)for(const g in i)if(h.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]={...this.defaultValues[g]||{},...i[g]};const a={type:"object",default:this.defaultValues[g],description:A.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};D.push(m(g)),this.configurationProperties[g]=a,this.defaultLanguageConfigurationOverridesNode.properties[g]=a}else{this.defaultValues[g]=i[g];const a=this.configurationProperties[g];a&&(this.updatePropertyDefaultValue(g,a),this.updateSchema(g,a))}this.registerOverrideIdentifiers(D),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(o){const h=[];for(const D of o)for(const i in D)if(h.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const h of o)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,h){const D=[];return o.forEach(i=>{D.push(...this.validateAndRegisterProperties(i,h,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),D}doDeregisterConfigurations(o){const h=[],D=i=>{if(i.properties)for(const g in i.properties)h.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,i.properties[g]);i.allOf&&i.allOf.forEach(g=>D(g))};for(const i of o){D(i);const g=this.configurationContributors.indexOf(i);g!==-1&&this.configurationContributors.splice(g,1)}return h}validateAndRegisterProperties(o,h=!0,D,i=3){i=_.isUndefinedOrNull(o.scope)?i:o.scope;let g=[],a=o.properties;if(a)for(let v in a){if(h&&p(v)){delete a[v];continue}const l=a[v];if(this.updatePropertyDefaultValue(v,l),e.OVERRIDE_PROPERTY_PATTERN.test(v)?l.scope=void 0:(l.scope=_.isUndefinedOrNull(l.scope)?i:l.scope,l.restricted=_.isUndefinedOrNull(l.restricted)?!!D?.restrictedConfigurations?.includes(v):l.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.excludedConfigurationProperties[v]=a[v],delete a[v];continue}else this.configurationProperties[v]=a[v];!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),g.push(v)}let r=o.allOf;if(r)for(let v of r)g.push(...this.validateAndRegisterProperties(v,h,D,i));return g}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const h=D=>{let i=D.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);let g=D.allOf;g&&g.forEach(h)};h(o)}updateSchema(o,h){switch(e.allSettings.properties[o]=h,h.scope){case 1:e.applicationSettings.properties[o]=h;break;case 2:e.machineSettings.properties[o]=h;break;case 6:e.machineOverridableSettings.properties[o]=h;break;case 3:e.windowSettings.properties[o]=h;break;case 4:e.resourceSettings.properties[o]=h;break;case 5:e.resourceSettings.properties[o]=h,this.resourceLanguageSettingsSchema.properties[o]=h;break}}removeFromSchema(o,h){switch(delete e.allSettings.properties[o],h.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const h=`[${o}]`,D={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,D),e.allSettings.properties[h]=D,e.applicationSettings.properties[h]=D,e.machineSettings.properties[h]=D,e.machineOverridableSettings.properties[h]=D,e.windowSettings.properties[h]=D,e.resourceSettings.properties[h]=D}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,h){let D=this.defaultValues[o];_.isUndefined(D)&&(D=h.default),_.isUndefined(D)&&(D=s(h.type)),h.default=D}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=m;function s(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const u=new S;P.Registry.add(e.Extensions.Configuration,u);function p(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?A.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?A.localize(6,null,w):null:A.localize(4,null)}e.validateProperty=p;function k(){const w=[],o=u.getConfigurationProperties();for(const h of Object.keys(o))w.push([h,o[h].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=k}),define(be[85],Ee([0,1,23,10,2,62,4,28]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof _.URI)}e.isConfigurationOverrides=C;var T;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function S(g,a){const r=a?g?a.keys.filter(R=>g.keys.indexOf(R)===-1):[...a.keys]:[],v=g?a?g.keys.filter(R=>a.keys.indexOf(R)===-1):[...g.keys]:[],l=[];if(a&&g){for(const R of g.keys)if(a.keys.indexOf(R)!==-1){const I=k(g.contents,R),L=k(a.contents,R);d.equals(I,L)||l.push(R)}}const c=[],b=R=>{const I={};for(const L of R)for(const E of L.identifiers)I[D(E)]=L;return I},f=a?b(a.overrides):{},y=g?b(g.overrides):{};if(Object.keys(f).length)for(const R of r){const I=f[R];I&&c.push([(0,A.overrideIdentifierFromKey)(R),I.keys])}if(Object.keys(y).length)for(const R of v){const I=y[R];I&&c.push([(0,A.overrideIdentifierFromKey)(R),I.keys])}if(Object.keys(f).length&&Object.keys(y).length)for(const R of l){const I=y[R],L=f[R];if(I&&L){const E=S({contents:I.contents,keys:I.keys,overrides:[]},{contents:L.contents,keys:L.keys,overrides:[]});c.push([(0,A.overrideIdentifierFromKey)(R),[...E.added,...E.removed,...E.updated]])}}return{added:r,removed:v,updated:l,overrides:c}}e.compare=S;function n(g,a){const r=[];for(const v of Object.keys(g))if(A.OVERRIDE_PROPERTY_PATTERN.test(v)){const l={};for(const c in g[v])l[c]=g[v][c];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(v).trim()],keys:Object.keys(l),contents:m(l,a)})}return r}e.toOverrides=n;function m(g,a){const r=Object.create(null);for(let v in g)s(r,v,g[v],a);return r}e.toValuesTree=m;function s(g,a,r,v){const l=a.split("."),c=l.pop();let b=g;for(let f=0;f<l.length;f++){let y=l[f],R=b[y];switch(typeof R){case"undefined":R=b[y]=Object.create(null);break;case"object":break;default:v(`Ignoring ${a} as ${l.slice(0,f+1).join(".")} is ${JSON.stringify(R)}`);return}b=R}if(typeof b=="object"&&b!==null)try{b[c]=r}catch(f){v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}else v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=s;function u(g,a){const r=a.split(".");p(g,r)}e.removeFromValueTree=u;function p(g,a){const r=a.shift();if(a.length===0){delete g[r];return}if(Object.keys(g).indexOf(r)!==-1){const v=g[r];typeof v=="object"&&!Array.isArray(v)&&(p(v,a),Object.keys(v).length===0&&delete g[r])}}function k(g,a,r){function v(b,f){let y=b;for(const R of f){if(typeof y!="object"||y===null)return;y=y[R]}return y}const l=a.split("."),c=v(g,l);return typeof c=="undefined"?r:c}e.getConfigurationValue=k;function w(g,a,r){Object.keys(a).forEach(v=>{v!=="__proto__"&&(v in g?M.isObject(g[v])&&M.isObject(a[v])?w(g[v],a[v],r):r&&(g[v]=a[v]):g[v]=a[v])})}e.merge=w;function o(){const g=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(g)}e.getConfigurationKeys=o;function h(){const g=Object.create(null),a=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in a){let v=a[r].default;s(g,r,v,l=>console.error(`Conflict in default settings: ${l}`))}return g}e.getDefaultValues=h;function D(g){return`[${g}]`}e.keyFromOverrideIdentifier=D;function i(g,a,r){const v=g.inspect(a),l=g.inspect(r);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:v.defaultValue}e.getMigratedSettingValue=i}),define(be[146],Ee([0,1,14,3,102,6,20,23,10,2,85,62,28]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(i={},g=[],a=[]){this._contents=i,this._keys=g,this._overrides=a,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,g){const a=this.getContentsForOverrideIdentifer(g);return a?i?(0,t.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.keys;return[]}override(i){let g=this.overrideConfigurations.get(i);return g||(g=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,g)),g}merge(...i){const g=P.deepClone(this.contents),a=P.deepClone(this.overrides),r=[...this.keys];for(const v of i){this.mergeContents(g,v.contents);for(const l of v.overrides){const[c]=a.filter(b=>d.equals(b.identifiers,l.identifiers));c?this.mergeContents(c.contents,l.contents):a.push(P.deepClone(l))}for(const l of v.keys)r.indexOf(l)===-1&&r.push(l)}return new m(g,r,a)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const g=this.getContentsForOverrideIdentifer(i);if(!g||typeof g!="object"||!Object.keys(g).length)return this;let a={};for(const r of d.distinct([...Object.keys(this.contents),...Object.keys(g)])){let v=this.contents[r],l=g[r];l&&(typeof v=="object"&&typeof l=="object"?(v=P.deepClone(v),this.mergeContents(v,l)):v=l),a[r]=v}return new m(a,this.keys,this.overrides)}mergeContents(i,g){for(const a of Object.keys(g)){if(a in i&&C.isObject(i[a])&&C.isObject(g[a])){this.mergeContents(i[a],g[a]);continue}i[a]=P.deepClone(g[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,g){this.addKey(i),(0,t.addToValueTree)(this.contents,i,g,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let g=this.keys.length;for(let a=0;a<g;a++)i.indexOf(this.keys[a])===0&&(g=a);this.keys.splice(g,1,i)}removeKey(i){let g=this.keys.indexOf(i);return g!==-1?(this.keys.splice(g,1),!0):!1}}e.ConfigurationModel=m;class s extends m{constructor(){const i=(0,t.getDefaultValues)(),g=(0,t.getConfigurationKeys)(),a=[];for(const r of Object.keys(i))S.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,S.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],v=>console.error(`Conflict in default settings file: ${v}`))});super(i,g,a)}}e.DefaultConfigurationModel=s;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,g){if(!C.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,g)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,g){this._raw=i;const{contents:a,keys:r,overrides:v,restricted:l}=this.doParseRaw(i,g);this._configurationModel=new m(a,r,v),this._restrictedConfigurations=l||[]}doParseContent(i){let g={},a=null,r=[],v=[],l=[];function c(f){Array.isArray(r)?r.push(f):a!==null&&(r[a]=f)}let b={onObjectBegin:()=>{let f={};c(f),v.push(r),r=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{r=v.pop()},onArrayBegin:()=>{let f=[];c(f),v.push(r),r=f,a=null},onArrayEnd:()=>{r=v.pop()},onLiteralValue:c,onError:(f,y,R)=>{l.push({error:f,offset:y,length:R})}};if(i)try{_.visit(i,b),g=r[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return g}doParseRaw(i,g){const a=n.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,g);i=r.raw;const v=(0,t.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(i),c=(0,t.toOverrides)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:v,keys:l,overrides:c,restricted:r.restricted}}filter(i,g,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const v={},l=[];for(let c in i)if(S.OVERRIDE_PROPERTY_PATTERN.test(c)&&a){const b=this.filter(i[c],g,!1,r);v[c]=b.raw,l.push(...b.restricted)}else{const b=g[c],f=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(c),(f===void 0||r.scopes===void 0||r.scopes.includes(f))&&(r.skipRestricted&&b?.restricted||(v[c]=i[c]))}return{raw:v,restricted:l}}}e.ConfigurationModelParser=u;class p extends A.Disposable{constructor(i,g,a,r){super();this.userSettingsResource=i,this.scopes=g,this.fileService=r,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class k{constructor(i,g,a=new m,r=new m,v=new F.ResourceMap,l=new m,c=new F.ResourceMap,b=!0){this._defaultConfiguration=i,this._localUserConfiguration=g,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=v,this._memoryConfiguration=l,this._memoryConfigurationByResource=c,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,g,a){return this.getConsolidateConfigurationModel(g,a).getValue(i)}updateValue(i,g,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new m,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,g===void 0?r.removeValue(i):r.setValue(i,g),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,g,a){const r=this.getConsolidateConfigurationModel(g,a),v=this.getFolderConfigurationModelForResource(g.resource,a),l=g.resource?this._memoryConfigurationByResource.get(g.resource)||this._memoryConfiguration:this._memoryConfiguration,c=g.overrideIdentifier?this._defaultConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),b=g.overrideIdentifier?this.userConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),f=g.overrideIdentifier?this.localUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),y=g.overrideIdentifier?this.remoteUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),R=a?g.overrideIdentifier?this._workspaceConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,I=v?g.overrideIdentifier?v.freeze().override(g.overrideIdentifier).getValue(i):v.freeze().getValue(i):void 0,L=g.overrideIdentifier?l.override(g.overrideIdentifier).getValue(i):l.getValue(i),E=r.getValue(i),N=d.distinct(d.flatten(r.overrides.map(U=>U.identifiers))).filter(U=>r.getOverrideValue(i,U)!==void 0);return{defaultValue:c,userValue:b,userLocalValue:f,userRemoteValue:y,workspaceValue:R,workspaceFolderValue:I,memoryValue:L,value:E,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspaceFolder:I!==void 0?{value:v?.freeze().getValue(i),override:g.overrideIdentifier?v?.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:l.getValue(i),override:g.overrideIdentifier?l.getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(i){const g=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:g?g.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,g){this._folderConfigurations.set(i,g),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,g){const a=g.filter(r=>S.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const v=(0,S.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(v),c=i.getKeysForOverrideIdentifier(v),b=[...c.filter(f=>l.indexOf(f)===-1),...l.filter(f=>c.indexOf(f)===-1),...l.filter(f=>!P.equals(this._defaultConfiguration.override(v).getValue(f),i.override(v).getValue(f)))];return[v,b]});return this.updateDefaultConfiguration(i),{keys:g,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.localUserConfiguration,i),l=[...g,...a,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateRemoteUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.remoteUserConfiguration,i);let l=[...g,...a,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateWorkspaceConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.workspaceConfiguration,i);let l=[...g,...a,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:v}}compareAndUpdateFolderConfiguration(i,g){const a=this.folderConfigurations.get(i),{added:r,updated:v,removed:l,overrides:c}=(0,t.compare)(a,g);let b=[...r,...v,...l];return(b.length||!a)&&this.updateFolderConfiguration(i,g),{keys:b,overrides:c}}compareAndDeleteFolderConfiguration(i){const g=this.folderConfigurations.get(i);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:v,overrides:l}=(0,t.compare)(g,void 0);return{keys:[...a,...r,...v],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,g){let a=this.getConsolidatedConfigurationModelForResource(i,g);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},g){let a=this.getWorkspaceConsolidatedConfiguration();if(g&&i){const r=g.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const v=this._memoryConfigurationByResource.get(i);v&&(a=a.merge(v))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let g=this._foldersConsolidatedConfigurations.get(i);if(!g){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(g=a.merge(r),this._freeze&&(g=g.freeze()),this._foldersConsolidatedConfigurations.set(i,g)):g=a}return g}getFolderConfigurationModelForResource(i,g){if(g&&i){const a=g.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,g)=>{const{contents:a,overrides:r,keys:v}=this._folderConfigurations.get(g);return i.push([g,{contents:a,overrides:r,keys:v}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(g=>i.add(g)),this.userConfiguration.freeze().keys.forEach(g=>i.add(g)),this._workspaceConfiguration.freeze().keys.forEach(g=>i.add(g)),this._folderConfigurations.forEach(g=>g.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const g=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>g.add(r))),[...g.values()]}static parse(i){const g=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),v=i.folders.reduce((l,c)=>(l.set(T.URI.revive(c[0]),this.parseConfigurationModel(c[1])),l),new F.ResourceMap);return new k(g,a,new m,r,v,new m,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new m(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=k;function w(...D){if(D.length===0)return{keys:[],overrides:[]};if(D.length===1)return D[0];const i=new Set,g=new Map;for(const r of D)r.keys.forEach(v=>i.add(v)),r.overrides.forEach(([v,l])=>{const c=(0,F.getOrSet)(g,v,new Set);l.forEach(b=>c.add(b))});const a=[];return g.forEach((r,v)=>a.push([v,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=w;class o{constructor(i,g,a,r){this.change=i,this.previous=g,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const v=new Set;i.keys.forEach(c=>v.add(c)),i.overrides.forEach(([,c])=>c.forEach(b=>v.add(b))),this.affectedKeys=[...v.values()];const l=new m;this.affectedKeys.forEach(c=>l.setValue(c,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,g){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(g){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,g,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,g,this.currentWorkspace);return!P.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,g){let a=(0,t.toValuesTree)({[g]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=o;class h extends o{constructor(i,g,a,r){super({keys:i.allKeys(),overrides:[]},void 0,i,g);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=h}),define(be[86],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(F,P=M.Unknown,C){super(F);this._message=F,this._code=P,this._detail=C,this.isHandled=P===M.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(F){return F instanceof _&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof _&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof _&&F.isHandled}}e.RemoteAuthorityResolverError=_}),define(be[63],Ee([0,1,11]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=M;function _(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=_;function A(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function F(T){if(T.folders.length)return T.folders.every(t=>A(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=F;function P(T){return F(T)?.scheme}e.getVirtualWorkspaceScheme=P;function C(T){return F(T)!==void 0}e.isVirtualWorkspace=C}),define(be[26],Ee([0,1,9,4,63]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,s){if(typeof m=="undefined"||m===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof m=="string"||typeof s=="string"){let u=typeof m=="string"?m:m.value,p=typeof s=="string"?s:s.value;return d.equalsIgnoreCase(u,p)}return m._lower===s._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=C;function T(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function t(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function S(n,m){if(m&&n.enableProposedApi){const s=`onResolveRemoteAuthority:${(0,_.getRemoteName)(m)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[147],Ee([0,1,9,26]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(s,u){return s.uuid&&u.uuid?s.uuid===u.uuid:s.id===u.id?!0:(0,d.compareIgnoreCase)(s.id,u.id)===0}e.areSameExtensions=_;class A{constructor(u,p){this.version=p,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof A?_(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=A;function F(s,u){return`${s}.${u}`}e.getExtensionId=F;function P(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(s,u){return P(F(s,u))}e.getGalleryExtensionId=C;function T(s,u){const p=[],k=w=>{for(const o of p)if(o.some(h=>_(u(h),u(w))))return o;return null};for(const w of s){const o=k(w);o?o.push(w):p.push([w])}return p}e.groupByExtension=T;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function S(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(s){const u=new Set;for(const p of s)p.malicious&&u.add(p.id.id);return u}e.getMaliciousExtensionsSet=n;function m(s,u){const p=[],k=u.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const w=k.shift();if(w&&p.every(o=>!_(o.identifier,{id:w}))){const o=s.filter(h=>_(h.identifier,{id:w}));o.length===1&&(p.push(o[0]),k.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=m}),define(be[148],Ee([0,1,3,25,4,15]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService");var F;(function(s){s.Http="http",s.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=S;function n(s,u){return u?u!==1&&s<1024:!M.isWindows&&s<1024}e.isPortPrivileged=n;let m=class{constructor(u){this.logService=u,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,p){return this._tunnelProvider=u,u?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],p=Array.from(this._tunnels.values());for(let k of p){const w=Array.from(k.values());for(let o of w){const h=await o.value;h&&u.push(h)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:p}of u.values())await p.then(k=>k?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,p,k,w,o=!1,h=P.Private,D){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${k} on local port ${w}.`),!u)return;p||(p="localhost");const i=this.retainOrCreateTunnel(u,p,k,w,o,h,D);return i?i.then(g=>{if(!g){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,k);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(g);return(g.tunnelRemoteHost!==p||g.tunnelRemotePort!==k)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const p=this._tunnels.get(u.tunnelRemoteHost);if(p){const k=p.get(u.tunnelRemotePort);k&&(k.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,k))}}}}async tryDisposeTunnel(u,p,k){if(k.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${p}.`);const w=k.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(p),w}}async closeTunnel(u,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${p} `);const k=this._tunnels.get(u);if(k&&k.has(p)){const w=k.get(p);w.refcount=0,await this.tryDisposeTunnel(u,p,w)}}addTunnelToMap(u,p,k){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(p,{refcount:1,value:k})}async removeEmptyTunnelFromMap(u,p){const k=this._tunnels.get(u);k&&(await k.get(p)||k.delete(p),k.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,p){let k=[u];t(u)?(k.push(...e.LOCALHOST_ADDRESSES),k.push(...e.ALL_INTERFACES_ADDRESSES)):S(u)&&k.push(...e.ALL_INTERFACES_ADDRESSES);const w=k.map(o=>this._tunnels.get(o));for(const o of w){const h=o?.get(p);if(h)return h}}canTunnel(u){return!!T(u)}createWithProvider(u,p,k,w,o,h,D){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${k} on local port ${w}.`);const g={elevationRequired:o?n(w===void 0?k:w):!1},a={remoteAddress:{host:p,port:k},localAddressPort:w,privacy:h,public:h!==P.Private,protocol:D},r=u.forwardPort(a,g);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(p,k,r),r}};m=$e([ze(0,A.ILogService)],m),e.AbstractTunnelService=m}),define(be[149],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,F=5){let P;return P=A(C=>{const T=typeof C=="string"?C:C.data;let t=this._terminalBufferMap.get(_);if(t){t.data.push(T);return}const S=setTimeout(()=>this.flushBuffer(_),F);t={data:[T],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(_),P.dispose()}},this._terminalBufferMap.set(_,t)}),P}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=d}),define(be[150],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(be[47],Ee([0,1,34,3,6,4,28,150]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var C;(function(p){function k(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=k})(C=e.ThemeColor||(e.ThemeColor={}));function T(p){return{id:p}}e.themeColorFromId=T;var t;(function(p){function k(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color=="undefined"||C.isThemeColor(g.color))}p.isThemeIcon=k;const w=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(g){const a=w.exec(g);if(!a)return;let[,r]=a;return{id:r}}p.fromString=o;function h(g,a){let r=g.id;const v=r.lastIndexOf("~");return v!==-1&&(r=r.substring(0,v)),a&&(r=`${r}~${a}`),{id:r}}p.modify=h;function D(g,a){return g.id===a.id&&g.color?.id===a.color?.id}p.isEqual=D;function i(g,a){return{id:g.id,color:a?T(a):void 0}}p.asThemeIcon=i,p.asClassNameArray=d.CSSIcon.asClassNameArray,p.asClassName=d.CSSIcon.asClassName,p.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function S(p){switch(p){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,_.toDisposable)(()=>{const w=this.themingParticipants.indexOf(k);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;F.Registry.add(e.Extensions.ThemingContribution,m);function s(p){return m.onColorThemeChange(p)}e.registerThemingParticipant=s;class u extends _.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,w){let o=this.theme.getColor(k);return o&&w&&(o=w(o,this.theme)),o?o.toString():null}}e.Themable=u}),define(be[151],Ee([0,1,12,34,3,122,84,28,47]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,w,o,h){const D=this.iconsById[k];if(D){if(o&&!D.description){D.description=o,this.iconSchema.properties[k].markdownDescription=`${o} $(${k})`;const a=this.iconReferenceSchema.enum.indexOf(k);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=o),this._onDidChange.fire()}return D}let i={id:k,description:o,defaults:w,deprecationMessage:h};this.iconsById[k]=i;let g={$ref:"#/definitions/icons"};return h&&(g.deprecationMessage=h),o&&(g.markdownDescription=`${o}: $(${k})`),this.iconSchema.properties[k]=g,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const w=this.iconReferenceSchema.enum.indexOf(k);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,w){const o=this.iconFontsById[k];if(o)return o;let h={id:k,definition:w};return this.iconFontsById[k]=h,this._onDidChange.fire(),h}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFonts(){return Object.keys(this.iconFontsById).map(k=>this.iconFontsById[k])}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(D,i)=>D.id.localeCompare(i.id),w=D=>{for(;C.ThemeIcon.isThemeIcon(D.defaults);)D=this.iconsById[D.defaults.id];return`codicon codicon-${D?D.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(D=>this.iconsById[D]);for(const D of h.filter(i=>!!i.description).sort(k))o.push(`|<i class="${w(D)}"></i>|${D.id}|${C.ThemeIcon.isThemeIcon(D.defaults)?D.defaults.id:D.id}|${D.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const D of h.filter(i=>!C.ThemeIcon.isThemeIcon(i.defaults)).sort(k))o.push(`|<i class="${w(D)}"></i>|${D.id}|`);return o.join(`
`)}}const t=new T;P.Registry.add(e.Extensions.IconContribution,t);function S(p,k,w,o){return t.registerIcon(p,k,w,o)}e.registerIcon=S;function n(){return t}e.getIconRegistry=n;function m(){for(const p of M.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let s=P.Registry.as(F.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const u=new d.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=S("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=S("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=S("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=C.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[48],Ee([0,1,20,24,2,4]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function P(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function C(n){const m=n;return!!(m&&typeof m=="object"&&_.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=C;class T{constructor(m,s,u,p,k){this._id=m,this._transient=u,this._configuration=p,this._ignorePathCasing=k,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class t{constructor(m,s){this.raw=s,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function S(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=S}),define(be[64],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P):this._providerInfo.set(P,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(be[152],Ee([0,1,12]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,P,C){this._deferredPromises=new Map,this._id=F,this._shared=P,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const S of T.values())S.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,P){let C=this._value[F];return typeof C=="undefined"&&(C=P),C}update(F,P){this._value[F]=P;let C=this._deferredPromises.get(F);if(C!==void 0)return C.p;const T=new d.DeferredPromise;return this._deferredPromises.set(F,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class _ extends M{constructor(F,P){super(F.identifier.value,!0,P);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=_}),define(be[153],Ee([0,1,3,2,15]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,T){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptModelChanged(C.value,T)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const T=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));T.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=$e([ze(0,_.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[13],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[154],Ee([0,1,26,3]),function(oe,e,d,M){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,C){_.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(P.identifier),Ze(this,_,C,"f"),Re(this,_,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Re(this,_,"f").get(this._id,P)}store(P,C){return Re(this,_,"f").store(this._id,P,C)}delete(P){return Re(this,_,"f").delete(this._id,P)}}e.ExtensionSecrets=A,_=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(be[49],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,_=(w,o)=>{const h={controllerId:o};return M.set(w,h),h};e.createPrivateApiFor=_;const A=w=>M.get(w);e.getPrivateApiFor=A;const F=(w,o,h,D)=>{let i=h;return{enumerable:!0,configurable:!1,get(){return i},set(g){if(!D(i,g)){const a=i;i=g,w.listener?.({op:3,key:o,value:g,previous:a})}}}},P=(w,o)=>w===o,C={range:(w,o)=>w===o?!0:!w||!o?!1:w.isEqual(o),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(w,o)=>!(w.length!==o.length||w.some(h=>!o.find(D=>h.id===D.id)))},T=Object.keys(C),t=(w,o)=>({range:F(w,"range",void 0,C.range),label:F(w,"label",o,C.label),description:F(w,"description",void 0,C.description),canResolveChildren:F(w,"canResolveChildren",!1,C.canResolveChildren),busy:F(w,"busy",!1,C.busy),error:F(w,"error",void 0,C.error),tags:F(w,"tags",[],C.tags)}),S=(w,o)=>{const h=new Map;for(const D of T)C[D](w[D],o[D])||h.set(D,o[D]);return h};e.diffTestItems=S;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class s extends Error{constructor(o,h,D){super(`TestItem with ID "${o}" is from controller "${h}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=s;const u=w=>{const o=(0,e.getPrivateApiFor)(w);let h=new Map;return{get size(){return h.size},forEach(D,i){for(const g of h.values())D.call(i,g,this)},replace(D){const i=new Map,g=new Set(h.keys()),a={op:4,ops:[]};for(const r of D){if(!(r instanceof p))throw new m(r.id);const v=(0,e.getPrivateApiFor)(r).controllerId;if(v!==o.controllerId)throw new s(r.id,v,o.controllerId);if(i.has(r.id))throw new n(r.id);i.set(r.id,r),g.delete(r.id),a.ops.push({op:0,item:r})}for(const r of g.keys())a.ops.push({op:1,id:r});o.listener?.(a),h=i},add(D){if(!(D instanceof p))throw new m(D.id);h.set(D.id,D),o.listener?.({op:0,item:D})},delete(D){h.delete(D)&&o.listener?.({op:1,id:D})},get(D){return h.get(D)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class p{constructor(o,h,D,i){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const g=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof k?void 0:g.parent}},children:{value:u(this),enumerable:!0,writable:!1},...t(g,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class k extends p{constructor(o,h){super(o,o,h,void 0)}}e.TestItemRootImpl=k}),define(be[65],Ee([0,1,4,148,3,13]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(C){function T(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:S.protocol}}C.fromApiTunnel=T;function t(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==M.TunnelPrivacyId.ConstantPrivate&&S.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}C.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,t){return{dispose:()=>{}}}async $providePortAttributes(T,t,S,n,m){return[]}async $forwardPort(T,t){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=$e([ze(0,A.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[7],Ee([0,1,14,16,77,20,79,9,10,2,36,60,86]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n){"use strict";var m,s,u,p,k,w,o,h,D,i,g,a,r,v,l,c,b,f,y,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(x){function O(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(O,x),Object.setPrototypeOf(O.prototype,x.prototype),O}let L=k=class{constructor(O){m.set(this,void 0),Ze(this,m,O,"f")}static from(...O){let ie=O;return new k(function(){if(ie){for(const _e of ie)_e&&typeof _e.dispose=="function"&&_e.dispose();ie=void 0}})}dispose(){typeof Re(this,m,"f")=="function"&&(Re(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,L=k=$e([I],L),e.Disposable=L;let E=w=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof w)return!0;let{line:ie,character:_e}=O;return typeof ie=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&ie===0?this:new w(this.line+_e,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),_e===this.line&&ie===this.character?this:new w(_e,ie)}toJSON(){return{line:this.line,character:this.character}}};E=w=$e([I],E),e.Position=E;let N=o=class{constructor(O,ie,_e,Ge){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new E(O,ie),ot=new E(_e,Ge)):O instanceof E&&ie instanceof E&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");tt.isBefore(ot)?(this._start=tt,this._end=ot):(this._start=ot,this._end=tt)}static isRange(O){return O instanceof o?!0:O?E.isPosition(O.start)&&E.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof o?this.contains(O._start)&&this.contains(O._end):O instanceof E?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=E.Max(O.start,this._start),_e=E.Min(O.end,this._end);if(!ie.isAfter(_e))return new o(ie,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=E.Min(O.start,this._start),_e=E.Max(O.end,this.end);return new o(ie,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return O?E.isPosition(O)?_e=O:(_e=O.start||this.start,ie=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&ie.isEqual(this.end)?this:new o(_e,ie)}toJSON(){return[this.start,this.end]}};N=o=$e([I],N),e.Range=N;let U=h=class extends N{constructor(O,ie,_e,Ge){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new E(O,ie),ot=new E(_e,Ge)):O instanceof E&&ie instanceof E&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");super(tt,ot);this._anchor=tt,this._active=ot}static isSelection(O){return O instanceof h?!0:O?N.isRange(O)&&E.isPosition(O.anchor)&&E.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=h=$e([I],U),e.Selection=U;class B{constructor(O,ie,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=_e}}e.ResolvedAuthority=B;class G extends Error{constructor(O,ie=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=ie,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable(O,ie){return new G(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new G(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var H;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var W;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ne=D=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof D?!0:O?N.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new D(O,ie)}static insert(O,ie){return D.replace(new N(O,O),ie)}static delete(O){return D.replace(O,"")}static setEndOfLine(O){const ie=new D(new N(new E(0,0),new E(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!N.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ne=D=$e([I],ne),e.TextEdit=ne;var V;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,_e,Ge){this._edits.push({_type:1,from:O,to:ie,options:_e,metadata:Ge})}createFile(O,ie,_e){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:_e})}deleteFile(O,ie,_e){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:_e})}replaceNotebookMetadata(O,ie,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,_e,Ge,tt){let ot,lt,Dt=[],Rt;if(Ht.isNotebookRange(ie)&&Te.isNotebookCellDataArray(_e)&&!Te.isNotebookCellDataArray(Ge)?(ot=ie.start,lt=ie.end,Dt=_e,Rt=Ge):typeof ie=="number"&&typeof _e=="number"&&Te.isNotebookCellDataArray(Ge)&&(ot=ie,lt=_e,Dt=Ge,Rt=tt),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:lt-ot,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(O,ie,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:_e}})}replace(O,ie,_e,Ge){this._edits.push({_type:2,uri:O,edit:new ne(ie,_e),metadata:Ge})}insert(O,ie,_e,Ge){this.replace(O,new N(ie,ie),_e,Ge)}delete(O,ie,_e){this.replace(O,ie,"",_e)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const _e of ie)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&ie.push(_e.edit);return ie}entries(){const O=new A.ResourceMap;for(let ie of this._edits)if(ie._type===2){let _e=O.get(ie.uri);_e||(_e=[ie.uri,[]],O.set(ie.uri,_e)),_e[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=$e([I],Y),e.WorkspaceEdit=Y;let j=i=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof i?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=i._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const _e=new i;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=i._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const _e=new i;_e._tabstop=this._tabstop,ie(_e),this._tabstop=_e._tabstop,ie=_e.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};j=i=$e([I],j),e.SnippetString=j;var le;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(le=e.DiagnosticTag||(e.DiagnosticTag={}));var re;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(re=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ve=g=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof N)this.range=ie;else if(ie instanceof E)this.range=new N(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof g?!0:O?N.isRange(O.range)&&T.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ve=g=$e([I],ve),e.Location=ve;let Fe=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&N.isRange(O.location.range)&&T.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};Fe=$e([I],Fe),e.DiagnosticRelatedInformation=Fe;let Me=class{constructor(O,ie,_e=re.Error){if(!N.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=_e}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,d.equals)(O.tags,ie.tags)&&(0,d.equals)(O.relatedInformation,ie.relatedInformation,Fe.isEqual)}};Me=$e([I],Me),e.Diagnostic=Me;let Oe=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};Oe=$e([I],Oe),e.Hover=Oe;var Ke;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(O,ie=Ke.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Ke[this.kind]}}};je=$e([I],je),e.DocumentHighlight=je;var Ve;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var $;(function(x){x[x.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let Q=a=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.kind=ie,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof ve?this.location=Ge:_e instanceof N&&(this.location=new ve(Ge,_e)),a.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};Q=a=$e([I],Q),e.SymbolInformation=Q;let ee=r=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.detail=ie,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};ee=r=$e([I],ee),e.DocumentSymbol=ee;var ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let K=class{constructor(O,ie){this.title=O,this.kind=ie}};K=$e([I],K),e.CodeAction=K;let se=v=class{constructor(O){this.value=O}append(O){return new v(this.value?this.value+v.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+v.sep)}};se.sep=".",se=v=$e([I],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let he=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=$e([I],he),e.SelectionRange=he;class Ae{constructor(O,ie,_e,Ge,tt,ot){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.CallHierarchyItem=Ae;class Ue{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=Ue;class He{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=He;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};et=$e([I],et),e.CodeLens=et;let st=l=class{constructor(O,ie=!1){s.set(this,void 0),Ze(this,s,new _.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof l?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Re(this,s,"f").value}set value(O){Re(this,s,"f").value=O}get isTrusted(){return Re(this,s,"f").isTrusted}set isTrusted(O){Re(this,s,"f").isTrusted=O}get supportThemeIcons(){return Re(this,s,"f").supportThemeIcons}set supportThemeIcons(O){Re(this,s,"f").supportThemeIcons=O}get supportHtml(){return Re(this,s,"f").supportHtml}set supportHtml(O){Re(this,s,"f").supportHtml=O}appendText(O){return Re(this,s,"f").appendText(O),this}appendMarkdown(O){return Re(this,s,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Re(this,s,"f").appendCodeblock(ie??"",O),this}};s=new WeakMap,st=l=$e([I],st),e.MarkdownString=st;let ye=class{constructor(O,ie){this.label=O,this.documentation=ie}};ye=$e([I],ye),e.ParameterInformation=ye;let nt=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};nt=$e([I],nt),e.SignatureInformation=nt;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=$e([I],q),e.SignatureHelp=q;var Z;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(O,ie,_e){this.text=O,this.position=ie,this.kind=_e}};We=$e([I],We),e.InlayHint=We;var Ye;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var mt;(function(x){x[x.Deprecated=1]="Deprecated"})(mt=e.CompletionItemTag||(e.CompletionItemTag={}));let ut=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ut=$e([I],ut),e.CompletionItem=ut;let St=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};St=$e([I],St),e.CompletionList=St;let Tt=class{constructor(O,ie,_e){this.text=O,this.range=ie,this.command=_e}};Tt=$e([I],Tt),e.InlineSuggestion=Tt;let It=class{constructor(O){this.items=O}};It=$e([I],It),e.InlineSuggestions=It;var Xe;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var vt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(vt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var te;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var me;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function O(ie){switch(ie){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=O}(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let fe=class{constructor(O,ie){if(ie&&!T.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!N.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};fe=$e([I],fe),e.DocumentLink=fe;let Ie=class{constructor(O,ie,_e,Ge){this.red=O,this.green=ie,this.blue=_e,this.alpha=Ge}};Ie=$e([I],Ie),e.Color=Ie;let Be=class{constructor(O,ie){if(ie&&!(ie instanceof Ie))throw(0,M.illegalArgument)("color");if(!N.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Be=$e([I],Be),e.ColorInformation=Be;let Ne=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};Ne=$e([I],Ne),e.ColorPresentation=Ne;var qe;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(qe=e.ColorFormat||(e.ColorFormat={}));var it;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Le{constructor(O,ie,_e){if(this.startIndex=O,this.length=ie,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Le;var de;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(de=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=ge;var X;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(X=e.TaskRevealKind||(e.TaskRevealKind={}));var z;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(z=e.TaskPanelKind||(e.TaskPanelKind={}));let we=c=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};we.Clean=new c("clean","Clean"),we.Build=new c("build","Build"),we.Rebuild=new c("rebuild","Rebuild"),we.Test=new c("test","Test"),we=c=$e([I],we),e.TaskGroup=we;function ke(x){let O="";for(let ie=0;ie<x.length;ie++)O+=x[ie].replace(/,/g,",,")+",";return O}let Je=class{constructor(O,ie,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=_e):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return ke(O)}};Je=$e([I],Je),e.ProcessExecution=Je;let xe=class{constructor(O,ie,_e){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return ke(O)}};xe=$e([I],xe),e.ShellExecution=xe;var ct;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class dt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,t.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=dt;let ht=b=class{constructor(O,ie,_e,Ge,tt,ot){this.__deprecated=!1,this._definition=this.definition=O;let lt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=_e,this.execution=Ge,lt=tt,this.__deprecated=!0):ie===pt.Global||ie===pt.Workspace?(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot):(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Je?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,t.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(b.EmptyType===ie||b.ProcessType===ie||b.ShellType===ie||b.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=b=$e([I],ht),e.Task=ht;var ft;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(O,ie=yt.None){this.collapsibleState=ie,T.URI.isUri(O)?this.resourceUri=O:this.label=O}};_t=$e([I],_t),e.TreeItem=_t;var yt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(O,ie){this.id=O,this.color=ie}};Pt=$e([I],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Nt=class{constructor(O){this.id=O}};Nt=$e([I],Nt),e.ThemeColor=Nt;var Ct;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Ct=e.ConfigurationTarget||(e.ConfigurationTarget={}));let xt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!T.URI.isUri(O)&&!T.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=T.URI.file(O),this.base=O):T.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};xt=$e([I],xt),e.RelativePattern=xt;let $t=class{constructor(O,ie,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,t.generateUuid)()),this._id}};$t=$e([I],$t),e.Breakpoint=$t;let bt=class extends $t{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};bt=$e([I],bt),e.SourceBreakpoint=bt;let Qt=class extends $t{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);this.functionName=O}};Qt=$e([I],Qt),e.FunctionBreakpoint=Qt;let zt=class extends $t{constructor(O,ie,_e,Ge,tt,ot,lt){super(Ge,tt,ot,lt);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=_e}};zt=$e([I],zt),e.DataBreakpoint=zt;let ii=class{constructor(O,ie,_e){this.command=O,this.args=ie||[],this.options=_e}};ii=$e([I],ii),e.DebugAdapterExecutable=ii;let ni=class{constructor(O,ie){this.port=O,this.host=ie}};ni=$e([I],ni),e.DebugAdapterServer=ni;let At=class{constructor(O){this.path=O}};At=$e([I],At),e.DebugAdapterNamedPipeServer=At;let Yt=class{constructor(O){this.implementation=O}};Yt=$e([I],Yt),e.DebugAdapterInlineImplementation=Yt;let ri=class{constructor(O,ie){this.range=O,this.expression=ie}};ri=$e([I],ri),e.EvaluatableExpression=ri;var Jt;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ie){this.range=O,this.text=ie}};Wt=$e([I],Wt),e.InlineValueText=Wt;let gt=class{constructor(O,ie,_e=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=_e}};gt=$e([I],gt),e.InlineValueVariableLookup=gt;let si=class{constructor(O,ie){this.range=O,this.expression=ie}};si=$e([I],si),e.InlineValueEvaluatableExpression=si;let Mt=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};Mt=$e([I],Mt),e.InlineValueContext=Mt;var Vt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Xt=f=class extends Error{constructor(O,ie=S.FileSystemProviderErrorCode.Unknown,_e){super(T.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new f(O,S.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(O){return new f(O,S.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(O){return new f(O,S.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(O){return new f(O,S.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(O){return new f(O,S.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(O){return new f(O,S.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};Xt=f=$e([I],Xt),e.FileSystemError=Xt;let oi=class{constructor(O,ie,_e){this.start=O,this.end=ie,this.kind=_e}};oi=$e([I],oi),e.FoldingRange=oi;var di;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(di=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(hi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=Zt;function bi(x){return typeof x=="undefined"||(0,C.isStringArray)(x)}class jt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,_e=O.tokenTypes.length;ie<_e;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,_e=O.tokenModifiers.length;ie<_e;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,_e,Ge,tt){if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,ie,_e,Ge,tt);if(N.isRange(O)&&typeof ie=="string"&&bi(_e))return this._push(O,ie,_e);throw(0,M.illegalArgument)()}_push(O,ie,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,tt=O.start.character,ot=O.end.character-O.start.character,lt=this._tokenTypeStrToInt.get(ie);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Lt>>>0}this._pushEncoded(Ge,tt,ot,lt,Dt)}_pushEncoded(O,ie,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Lt=0;for(let Ot=0;Ot<Dt;Ot++){let Bt=this._data[5*Ot],ui=this._data[5*Ot+1];Bt===0?(Bt=Rt,ui+=Lt):Bt+=Rt,this._data[5*Ot]=Bt,this._data[5*Ot+1]=ui,Rt=Bt,Lt=ui}}let ot=O,lt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const _e=O.length/5|0;for(let lt=0;lt<_e;lt++)ie[lt]=lt;ie.sort((lt,Dt)=>{const Rt=O[5*lt],Lt=O[5*Dt];if(Rt===Lt){const Ot=O[5*lt+1],Bt=O[5*Dt+1];return Ot-Bt}return Rt-Lt});const Ge=new Uint32Array(O.length);let tt=0,ot=0;for(let lt=0;lt<_e;lt++){const Dt=5*ie[lt],Rt=O[Dt+0],Lt=O[Dt+1],Ot=O[Dt+2],Bt=O[Dt+3],ui=O[Dt+4],Bi=Rt-tt,Gi=Bi===0?Lt-ot:Lt,ci=5*lt;Ge[ci+0]=Bi,Ge[ci+1]=Gi,Ge[ci+2]=Ot,Ge[ci+3]=Bt,Ge[ci+4]=ui,tt=Rt,ot=Lt}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(jt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=jt;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class Ei{constructor(O,ie,_e){this.start=O,this.deleteCount=ie,this.data=_e}}e.SemanticTokensEdit=Ei;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var Gt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=$e([I],ei),e.QuickInputButtons=ei;var Si;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,_e){this.badge=O,this.tooltip=ie,this.color=_e}static validate(O){if(O.badge){let ie=(0,P.nextCharLength)(O.badge,0);if(ie<O.badge.length&&(ie+=(0,P.nextCharLength)(O.badge,ie)),O.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let Kt=class{constructor(O){this.kind=O}};Kt=$e([I],Kt),e.ColorTheme=Kt;var fi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(fi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof Ht?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,_e=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(_e=O.end),ie===this._start&&_e===this._end?this:new Ht(ie,_e)}}e.NotebookRange=Ht;class Te{constructor(O,ie,_e,Ge,tt,ot,lt){this.kind=O,this.value=ie,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=ot,this.executionSummary=lt,Te.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Te.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Te;class ai{constructor(O){this.cells=O}}e.NotebookData=ai;class Ft{constructor(O,ie){this.data=O,this.mime=ie;const _e=(0,F.normalizeMimeType)(ie,!0);if(!_e)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Ft.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Ft(O,ie)}static text(O,ie=F.Mimes.text){const _e=Re(Ft,u,"f",p).encode(String(O));return new Ft(_e,ie)}static json(O,ie="application/json"){const _e=JSON.stringify(O,void 0,"	");return Ft.text(_e,ie)}}e.NotebookCellOutputItem=Ft,u=Ft,p={value:new TextEncoder};class wt{constructor(O,ie,_e){this.items=wt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=_e):(this.id=(0,t.generateUuid)(),this.metadata=ie??_e)}static isNotebookCellOutput(O){return O instanceof wt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<O.length;tt++){const ot=O[tt],lt=(0,F.normalizeMimeType)(ot.mime);if(!_e.has(lt)){_e.add(lt);continue}Ge.add(tt),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ge.size===0?O:O.filter((tt,ot)=>!Ge.has(ot))}}e.NotebookCellOutput=wt;var Ci;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ci=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ii{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=Ii;var Pi;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(O,ie=[]){this.uri=O,this.provides=(0,d.asArray)(ie)}}e.NotebookRendererScript=Ti;let li=class{constructor(O,ie){this.label=O,this.timestamp=ie}};li=$e([I],li),e.TimelineItem=li;var pi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(pi=e.ExtensionMode||(e.ExtensionMode={}));var Ai;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Ai=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Fi;class Mi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Li;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Li=e.TestResultState||(e.TestResultState={}));var J;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(J=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ce=class{constructor(O=void 0,ie=void 0,_e=void 0){this.include=O,this.exclude=ie,this.profile=_e}};ce=$e([I],ce),e.TestRunRequest=ce;let De=y=class{constructor(O){this.message=O}static diff(O,ie,_e){const Ge=new y(O);return Ge.expectedOutput=ie,Ge.actualOutput=_e,Ge}};De=y=$e([I],De),e.TestMessage=De;let at=class{constructor(O){this.id=O}};at=$e([I],at),e.TestTag=at;let Et=class{constructor(O,ie){this.covered=O,this.total=ie}};Et=$e([I],Et),e.CoveredCount=Et;let kt=R=class{constructor(O,ie,_e,Ge){this.uri=O,this.statementCoverage=ie,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,ie){const _e=new Et(0,0),Ge=new Et(0,0),tt=new Et(0,0);for(const lt of ie)if("branches"in lt){_e.total+=1,_e.covered+=lt.executionCount>0?1:0;for(const Dt of lt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const ot=new R(O,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return ot.detailedCoverage=ie,ot}};kt=R=$e([I],kt),e.FileCoverage=kt;let Oi=class{constructor(O,ie,_e=[]){this.executionCount=O,this.location=ie,this.branches=_e}};Oi=$e([I],Oi),e.StatementCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=$e([I],Ni),e.BranchCoverage=Ni;let xi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};xi=$e([I],xi),e.FunctionCoverage=xi;var zi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(O,ie,_e,Ge,tt,ot){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.TypeHierarchyItem=qi}),define(be[88],Ee([0,1,42,11,9,228,117,7,14]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(s,u){u?T.set(s,u):T.delete(s)}e.setWordDefinitionFor=t;function S(s){return T.get(s)}e.getWordDefinitionFor=S;class n extends A.MirrorTextModel{constructor(u,p,k,w,o,h,D,i){super(p,k,w,o);this._proxy=u,this._languageId=h,this._isDirty=D,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,C.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===M.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(p){return p?u._getTextInRange(p):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(p){return u._lineAt(p)},offsetAt(p){return u._offsetAt(p)},positionAt(p){return u._positionAt(p)},validateRange(p){return u._validateRange(p)},validatePosition(p){return u._validatePosition(p)},getWordRangeAtPosition(p,k){return u._getWordRangeAtPosition(p,k)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,d.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,d.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const p=this._validateRange(u);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const k=this._eol,w=p.start.line,o=p.end.line,h=[];h.push(this._lines[w].substring(p.start.character));for(let D=w+1;D<o;D++)h.push(this._lines[D]);return h.push(this._lines[o].substring(0,p.end.character)),h.join(k)}_lineAt(u){let p;if(u instanceof P.Position?p=u.line:typeof u=="number"&&(p=u),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new m(p,this._lines[p],p===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(u),k=this._lines[p.index].length;return new P.Position(p.index,Math.min(p.remainder,k))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const p=this._validatePosition(u.start),k=this._validatePosition(u.end);return p===u.start&&k===u.end?u:new P.Range(p.line,p.character,k.line,k.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:p,character:k}=u,w=!1;if(p<0)p=0,k=0,w=!0;else if(p>=this._lines.length)p=this._lines.length-1,k=this._lines[p].length,w=!0;else{const o=this._lines[p].length;k<0?(k=0,w=!0):k>o&&(k=o,w=!0)}return w?new P.Position(p,k):u}_getWordRangeAtPosition(u,p){const k=this._validatePosition(u);if(!p)p=S(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const w=(0,F.getWordAtText)(k.character+1,(0,F.ensureValidWordDefinition)(p),this._lines[k.line],0);if(w)return new P.Range(k.line,w.startColumn-1,k.line,w.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(u,p,k){this._line=u,this._text=p,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[155],Ee([0,1,7,3,229,6,56,20,2,36]),function(oe,e,d,M,_,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,m,s,u){this._notebook=s,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(k=>{const w=this._cellUris.get(k.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(k=>p(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const n=[],m=[];for(const s of this._notebook.getCells())s.kind===d.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),m.push(s.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let w="";for(const o of this._cells)w+=o.document.getText()+`
`;return w=w.slice(0,-1),w}if(n.isEmpty)return"";const m=this.locationAt(n.start),s=this.locationAt(n.end),u=this._cellUris.get(m.uri),p=this._cellUris.get(s.uri);if(u===void 0||p===void 0)return"";if(u===p)return this._cells[u].document.getText(new d.Range(m.range.start,s.range.end));const k=[this._cells[u].document.getText(new d.Range(m.range.start,new d.Position(this._cells[u].document.lineCount,0)))];for(let w=u+1;w<p;w++)k.push(this._cells[w].document.getText());return k.push(this._cells[p].document.getText(new d.Range(new d.Position(0,0),s.range.end))),k.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(m.index-1),u=this._cells[m.index].document.offsetAt(n.with(m.remainder));return s+u}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(u)}const m=this._cellUris.get(n.uri);if(m!==void 0){const s=this._cellLines.getPrefixSum(m-1);return new d.Position(s+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let s=m;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const u=new d.Position(m.remainder,n.start.character),p=new d.Position(s.remainder,n.end.character),k=new d.Range(u,p),w=this._cells[m.index];return new d.Location(w.document.uri,w.document.validateRange(k))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(m,s)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),s=new d.Position(m.remainder,n.character),u=this._cells[m.index].document.validatePosition(s),p=this._cellLines.getPrefixSum(m.index-1);return new d.Position(p+u.line,u.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[156],Ee([0,1,7,13,3]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?d.ColorThemeKind.Light:P==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[66],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[157],Ee([0,1,22]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(C){let T=this.buffers.indexOf(C);return T<0&&(T=this.buffers.length,this.buffers.push(C)),T}}function _(P,C){if(C.serializeBuffersForPostMessage){const T=new M,t=(m,s)=>{if(s instanceof ArrayBuffer){const u=T.add(s);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(s)){const u=A(s);if(u){const p=T.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:u,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},S=JSON.stringify(P,t),n=T.buffers.map(m=>{const s=new Uint8Array(m);return d.VSBuffer.wrap(s)});return{message:S,buffers:n}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=_;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(P,C){const T=C.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),t=C.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const s=m,{index:u}=s,p=T[u];if(s.view)switch(s.view.type){case 1:return new Int8Array(p,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return m}:void 0;return{message:JSON.parse(P,t),arrayBuffers:T}}e.deserializeWebviewMessage=F}),define(be[158],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function _(F){const P={items:new Map};return F.types.forEach((C,T)=>{P.items.set(C,{asString:async()=>F.items[T].asString})}),P}M.toITreeDataTransfer=_;async function A(F){const P={types:[],items:[]},C=Array.from(F.items.entries());for(const T of C)P.types.push(T[0]),P.items.push({asString:await T[1].asString()});return P}M.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[67],Ee([0,1,11,2]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(P,C){return P.scheme===d.Schemas.http||P.scheme===d.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===d.Schemas.file&&(P=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:C.authority,path:P.path})),M.URI.from({scheme:d.Schemas.https,authority:`${P.scheme}+${A(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=_;function A(P){return P.replace(/./g,C=>{const T=C.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?C:"-"+T.toString(16).padStart(4,"0")})}function F(P){return P.replace(/-([0-9a-f]{4})/g,(C,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=F}),define(be[159],Ee([0,1,3,6,67]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(P,C,T){this._proxy=P,this._editors=C,this._initData=T,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const t=C.getVisibleTextEditors();for(const S of this._insets.values())t.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,T,t,S){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===P){n=o;break}if(!n)throw new Error("not a visible editor");const m=this,s=this._handlePool++,u=new d.Emitter,p=new d.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,_.asWebviewUri)(o,m._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(o){this._options=o,m._proxy.$setOptions(s,o)}get options(){return this._options}set html(o){this._html=o,m._proxy.$setHtml(s,o)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(o){return m._proxy.$postMessage(s,o)}},w=new class{constructor(){this.editor=P,this.line=C,this.height=T,this.webview=k,this.onDidDispose=p.event}dispose(){m._insets.has(s)&&(m._insets.delete(s),m._proxy.$disposeEditorInset(s),p.fire(),p.dispose(),u.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,C+1,T,t||{},S.identifier,S.extensionLocation),this._insets.set(s,{editor:P,inset:w,onDidReceiveMessage:u}),w}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const T=this._insets.get(P);T&&T.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=A}),define(be[160],Ee([0,1,130,10,2,6,4,46,28,14,11]),function(oe,e,d,M,_,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function S(L,E,N){for(const U of N.visibleEditorPanes)if(U.group.id===E&&L.matches(U.input))return U.getViewState()}e.findViewStateForEditor=S;function n(L){if(h(L))return!1;const E=L;return _.URI.isUri(E?.resource)}e.isResourceEditorInput=n;function m(L){if(h(L))return!1;const E=L;return E?.original!==void 0&&E.modified!==void 0}e.isResourceDiffEditorInput=m;function s(L){if(h(L)||m(L))return!1;const E=L;return E?.primary!==void 0&&E.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function u(L){if(h(L))return!1;const E=L;return E?E.resource===void 0||E.resource.scheme===t.Schemas.untitled||E.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var p;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(p=e.Verbosity||(e.Verbosity={}));var k;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(k=e.SaveReason||(e.SaveReason={}));var w;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends A.Disposable{}e.AbstractEditorInput=o;function h(L){return L instanceof o}e.isEditorInput=h;function D(L){const E=L;return _.URI.isUri(E?.preferredResource)}function i(L){const E=L;return h(E?.primary)&&h(E?.secondary)}e.isSideBySideEditorInput=i;function g(L){const E=L;return h(E?.modified)&&h(E?.original)}e.isDiffEditorInput=g;function a(L){return h(L?.editor)}e.isEditorInputWithOptions=a;function r(L){const E=L;return a(L)&&E?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function v(L){const E=L;return typeof E?.groupId=="number"&&h(E.editor)}e.isEditorIdentifier=v;var l;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var c;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(c=e.SideBySideEditor||(e.SideBySideEditor={}));class b{getOriginalUri(E,N){if(!E)return;if(N?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(E);if(B&&G){if(N?.supportSideBySide===c.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===c.ANY)return this.getOriginalUri(B,{filterByScheme:N.filterByScheme})??this.getOriginalUri(G,{filterByScheme:N.filterByScheme});E=N.supportSideBySide===c.PRIMARY?B:G}}if(m(E)||s(E))return;const U=D(E)?E.preferredResource:E.resource;return!U||!N||!N.filterByScheme?U:this.filterUri(U,N.filterByScheme)}getSideEditors(E){return i(E)||s(E)?{primary:E.primary,secondary:E.secondary}:g(E)||m(E)?{primary:E.modified,secondary:E.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(E,N){if(!E)return;if(N?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(E);if(B&&G){if(N?.supportSideBySide===c.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===c.ANY)return this.getCanonicalUri(B,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:N.filterByScheme});E=N.supportSideBySide===c.PRIMARY?B:G}}if(m(E)||s(E))return;const U=E.resource;return!U||!N||!N.filterByScheme?U:this.filterUri(U,N.filterByScheme)}filterUri(E,N){if(Array.isArray(N)){if(N.some(U=>E.scheme===U))return E}else if(N===E.scheme)return E}}e.EditorResourceAccessor=new b;var f;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(E){const N=this.instantiationService=E.get(F.IInstantiationService);for(const[U,B]of this.editorSerializerConstructors)this.createEditorSerializer(U,B,N);this.editorSerializerConstructors.clear()}createEditorSerializer(E,N,U){const B=U.createInstance(N);this.editorSerializerInstances.set(E,B)}registerFileEditorFactory(E){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=E}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(E,N){if(this.editorSerializerConstructors.has(E)||this.editorSerializerInstances.has(E))throw new Error(`A editor serializer with type ID '${E}' was already registered.`);return this.instantiationService?this.createEditorSerializer(E,N,this.instantiationService):this.editorSerializerConstructors.set(E,N),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(E),this.editorSerializerInstances.delete(E)})}getEditorSerializer(E){return this.editorSerializerInstances.get(typeof E=="string"?E:E.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new y);async function R(L,E){if(!L||!L.length)return[];const N=await Promise.all(L.map(async U=>{const B=_.URI.revive(U.fileUri);if(!B||!await E.canHandleResource(B))return;const H=typeof U.exists=="boolean"?U.exists:await E.exists(B);if(!H&&U.openOnlyIfExists)return;const W={selection:H?U.selection:void 0,pinned:!0,override:U.editorOverrideId};let ne;return H?ne={resource:B,options:W}:ne={resource:B,options:W,forceUntitled:!0},ne}));return(0,T.coalesce)(N)}e.pathsToEditors=R;var I;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(I=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[161],Ee([0,1,3,46,131,4,6,20,28,14,52,23,34,151]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",n.Codicon.window,(0,_.localize)(0,null));var s;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var u;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function p(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;function k(v){return`viewContainer.${v}.enabled`}e.getEnabledViewContainerContextKey=k;class w extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,b){const f=this.get(l.id);if(f)return f;const y=l;return y.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,P.getOrSet)(this.viewContainers,c,[]).push(y),b?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:c}),y}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const b=this.viewContainers.get(c),f=b?.indexOf(l);if(f!==-1){b?.splice(f,1),b.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}C.Registry.add(s.ViewContainersRegistry,new w);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function h(v,l){const c=v.group??o.More,b=l.group??o.More;return c!==b?c.localeCompare(b):(v.order??5)-(l.order??5)}class D extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:b})=>this.addViews(c,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const b=this.removeViews(l,c);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:c})}moveViews(l,c){for(const b of this._views.keys())if(b!==c){const f=this.removeViews(l,b);f.length&&(this.addViews(f,c),this._onDidChangeContainer.fire({views:f,from:b,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const b=(this._views.get(c)||[]).filter(f=>f.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(f=>f.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const b=new Map;for(const[f,y]of c)this._viewWelcomeContents.add(l,y),b.set(f,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,y),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,b=>c.push(b)),c.sort(h)}addViews(l,c){let b=this._views.get(c);b||(b=[],this._views.set(c,b),this._viewContainers.push(c));for(const f of l){if(this.getView(f.id)!==null)throw new Error((0,_.localize)(1,null,f.id));b.push(f)}}removeViews(l,c){const b=this._views.get(c);if(!b)return[];const f=[],y=[];for(const R of b)l.includes(R)?f.push(R):y.push(R);return f.length&&(y.length?this._views.set(c,y):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),f}}C.Registry.add(s.ViewsRegistry,new D),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,_.localize)(2,null));function i(v){return`view.${v}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var g;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(g=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,S.mixin)(this,l),this._hasResolve=!!c,this.resolve=async b=>{if(c&&!this.resolved){const f=await c(b);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[162],Ee([0,1,3,12,132]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,T,t){const S={command:P};if(C&&Object.keys(C).length>0&&(S.arguments=C),this.internalSend("request",S),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(S.seq);if(m){this.pendingRequests.delete(S.seq);const s={type:"response",seq:0,request_seq:S.seq,success:!1,command:P,message:(0,_.localize)(0,null,t,P)};m(s)}},t)}return T&&this.pendingRequests.set(S.seq,T),S.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,M.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const C=P,T=this.pendingRequests.get(C.request_seq);T&&(this.pendingRequests.delete(C.request_seq),T(C));break}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,T)=>P.set(T,C)),await(0,M.timeout)(500),P.forEach((C,T)=>{C({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[163],Ee([0,1,9,2,17,23,11]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(a,r,v){return a.replace(P,function(l,c){return r&&c.length>0&&c[0]!=="_"?l:v&&v.hasOwnProperty(c)?v[c]:l})}e.formatPII=C;function T(a){const r={};for(const v of Object.keys(a))v.startsWith("!")||(r[v]=a[v]);return r}e.filterExceptionsFromTelemetry=T;function t(a){return a.configuration.request==="attach"&&!S(a)&&(!a.parentSession||t(a.parentSession))}e.isSessionAttach=t;function S(a){let r=a.configuration.type;if(!!r)return r==="vslsShare"&&(r=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(r,"extensionhost")||(0,d.equalsIgnoreCase)(r,"pwa-extensionhost")?a:a.parentSession?S(a.parentSession):void 0}e.getExtensionHostDebugSession=S;function n(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=n;function m(a,r,v){let l,c=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,f=null;for(;f=b.exec(a);){let y=f.index+1,R=y+f[0].length;if(y<=r&&R>=v){l=f[0],c=y;break}}if(l){let y=/\w+/g,R=null;for(;(R=y.exec(l))&&!(R.index+1+c+R[0].length>=v););R&&(l=l.substring(0,y.lastIndex))}return l?{start:c,end:c+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(a){return!!(a&&a.match(s))}e.isUri=u;function p(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(u(a.path))return M.URI.parse(a.path);if((0,_.isAbsolute)(a.path))return M.URI.file(a.path)}return a.path}function k(a){if(typeof a.path=="object"){const r=M.URI.revive(a.path);if(r)return r.scheme===F.Schemas.file?r.fsPath:r.toString()}return a.path}function w(a,r){const v=r?p:k,l=(0,A.deepClone)(a);return h(l,(c,b)=>{c&&b&&(b.path=v(b))}),l}e.convertToDAPaths=w;function o(a,r){const v=r?p:k,l=(0,A.deepClone)(a);return h(l,(c,b)=>{!c&&b&&(b.path=v(b))}),l}e.convertToVSCPaths=o;function h(a,r){switch(a.type){case"event":const v=a;switch(v.event){case"output":r(!1,v.body.source);break;case"loadedSource":r(!1,v.body.source);break;case"breakpoint":r(!1,v.body.breakpoint.source);break;default:break}break;case"request":const l=a;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>r(!1,b));break;default:break}break;case"response":const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(b=>r(!1,b.source));break;case"loadedSources":c.body.sources.forEach(b=>r(!1,b));break;case"scopes":c.body.scopes.forEach(b=>r(!1,b.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(b=>r(!1,b.source));break;case"setBreakpoints":c.body.breakpoints.forEach(b=>r(!1,b.source));break;default:break}break}}function D(a){return a.filter(r=>!r.presentation?.hidden).sort((r,v)=>r.presentation?v.presentation?r.presentation.group?v.presentation.group?r.presentation.group!==v.presentation.group?r.presentation.group.localeCompare(v.presentation.group):i(r.presentation.order,v.presentation.order):-1:v.presentation.group?1:i(r.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=D;function i(a,r){return typeof a!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:a-r}async function g(a,r){const v=a.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorMode});if(v!=="none"&&(await r.saveAll(),v==="allEditorsInActiveGroup")){const l=r.activeEditorPane;l&&await r.save({editor:l.input,groupId:l.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(be[89],Ee([0,1,27,164,79,11,17,25,46]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var T;(function(y){y[y.Markup=1]="Markup",y[y.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var t;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(t=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(y){y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(y){y.Always="always",y.Never="never",y.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",y[y.ChangeCellMime=13]="ChangeCellMime",y[y.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata",y[y.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var k;(function(y){y.scheme=A.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function I(B,G){return B.with({scheme:y.scheme,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==A.Schemas.file?B.scheme:""}`})}y.generate=I;function L(B){if(B.scheme!==y.scheme)return;const G=R.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parse=L;function E(B){if(B.scheme!==A.Schemas.vscodeNotebookCellMetadata)return;const G=R.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parseCellMetadataUri=E;function N(B,G,H){return B.with({scheme:H,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==A.Schemas.file?B.scheme:""}`})}y.generateCellUri=N;function U(B,G){if(B.scheme!==G)return;const H=R.exec(B.fragment);return H?{handle:Number(H[1]),notebook:B.with({scheme:B.fragment.substr(H[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parseCellUri=U})(k=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(y){return w.get(y)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function h(y){return w.get(y)?.supportedByCore??!1}e.mimeTypeSupportedByCore=h;function D(y){return w.get(y)?.mergeable??!1}e.mimeTypeIsMergeable=D;const i=y=>P.isWindows?y.replace(/\//g,"\\"):y;class g{constructor(R=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=R.map(L=>({pattern:L,matches:d.parse(i(L))}))}sort(R){const I=new Map(M.Iterable.map(R,E=>[E,i(E)]));let L=[];for(const{matches:E}of this.order)for(const[N,U]of I)if(E(U)){L.push(N),I.delete(N);break}return I.size&&(L=L.concat([...I.keys()].sort((E,N)=>this.defaultOrder.indexOf(E)-this.defaultOrder.indexOf(N)))),L}prioritize(R,I){const L=this.findIndex(R);if(L===-1){this.order.unshift({pattern:R,matches:d.parse(i(R))});return}const E=I.map(N=>this.findIndex(N,L)).filter(N=>N!==-1);this.order.splice(L+1,0,...E.map(N=>this.order[N]));for(const N of E.sort())this.order.splice(N,1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,I=this.order.length){const L=i(R);for(let E=0;E<I;E++)if(this.order[E].matches(L))return E;return-1}}e.MimeTypeDisplayOrder=g;function a(y,R,I,L=(E,N)=>E===N){const E=[];function N(G,H,W){if(H===0&&W.length===0)return;const ne=E[E.length-1];ne&&ne.start+ne.deleteCount===G?(ne.deleteCount+=H,ne.toInsert.push(...W)):E.push({start:G,deleteCount:H,toInsert:W})}let U=0,B=0;for(;;){if(U===y.length){N(U,0,R.slice(B));break}if(B===R.length){N(U,y.length-U,[]);break}const G=y[U],H=R[B];if(L(G,H)){U+=1,B+=1;continue}I(H)?(N(U,1,[]),U+=1):(N(U,0,[H]),B+=1)}return E}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(y){y.default="default",y.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function v(y){const R=y;return!!((typeof R.include=="string"||d.isRelativePattern(R.include))&&(typeof R.exclude=="string"||d.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=v;function l(y,R,I){if(Array.isArray(y.viewType)&&y.viewType.indexOf(R)>=0||y.viewType===R)return!0;if(y.filenamePattern){let L=v(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,E=v(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(d.match(L,(0,F.basename)(I.fsPath).toLowerCase()))return!(E&&d.match(E,(0,F.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class c{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)R[I]=this.textModel.cells[I].getHashValue();return R}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(R){return`${f._prefix}${R}`}static parse(R){if(R.startsWith(f._prefix))return R.substr(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState",_[_.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,134,4,46]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=d;function M(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(S){S[S.Error=0]="Error",S[S.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var A;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(S,n)=>{n.expand!==void 0&&(S.expand=n.expand),n.item!==void 0&&(S.item=S.item?Object.assign(S.item,n.item):n.item)};e.applyTestItemUpdate=F;var P;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var C;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire",S[S.AddTag=5]="AddTag",S[S.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const u=s[1];if(u.parent){if(this.items.has(u.parent)){const p=this.items.get(u.parent);p.children.add(u.item.extId);const k=this.createItem(u,p);this.items.set(u.item.extId,k),m.add(k)}}else{const p=this.createItem(u);this.roots.add(p),this.items.set(u.item.extId,p),m.add(p)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=s[1],p=this.items.get(u.extId);if(!p)break;u.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,u),m.update(p);break}case 2:{const u=this.items.get(s[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const p=[[s[1]]];for(;p.length;)for(const k of p.pop()){const w=this.items.get(k);w&&(p.push(w.children),this.items.delete(k),m.remove(w,w!==u),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(be[68],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class _{constructor(F,P=F.length){if(this.path=F,this.viewEnd=P,F.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,P,C=F.parent){if(F.id===P)return new _([P]);let T=[F.id];for(let t=C;t&&t.id!==P;t=t.parent)T.push(t.id);return T.push(P),new _(T.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new _(F.split("\0"))}static join(F,P){return new _([...F.path,P])}static joinToString(F,P){return F.toString()+"\0"+P}static compare(F,P){return F===P?0:P.startsWith(F+"\0")?2:F.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new _(this.path,F)}compare(F){if(typeof F=="string")return _.compare(this.toString(),F);for(let P=0;P<F.viewEnd&&P<this.viewEnd;P++)if(F.path[P]!==this.path[P])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=_}),define(be[168],Ee([0,1,17,91,10,23,25,78,135]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(S,n,m){this._contributedVariables=new Map,this._context=S,this._labelService=n,m&&(this._envVariablesPromise=m.then(s=>this.prepareEnv(s)))}prepareEnv(S){if(F.isWindows){const n=Object.create(null);return Object.keys(S).forEach(m=>{n[m.toLowerCase()]=S[m]}),n}return S}resolveWithEnvironment(S,n,m){return this.recursiveResolve(this.prepareEnv(S),n?n.uri:void 0,m)}async resolveAsync(S,n){return this.recursiveResolve(await this._envVariablesPromise,S?S.uri:void 0,n)}async resolveAnyBase(S,n,m,s){const u=A.deepClone(n);return F.isWindows&&u.windows?Object.keys(u.windows).forEach(p=>u[p]=u.windows[p]):F.isMacintosh&&u.osx?Object.keys(u.osx).forEach(p=>u[p]=u.osx[p]):F.isLinux&&u.linux&&Object.keys(u.linux).forEach(p=>u[p]=u.linux[p]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,S?S.uri:void 0,u,m,s)}async resolveAnyAsync(S,n,m){return this.resolveAnyBase(S,n,m)}async resolveAnyMap(S,n,m){const s=new Map;return{newConfig:await this.resolveAnyBase(S,n,m,s),resolvedVariables:s}}resolveWithInteractionReplace(S,n,m,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,n,m,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,n){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,n)}recursiveResolve(S,n,m,s,u){if(_.isString(m))return this.resolveString(S,n,m,s,u);if(_.isArray(m))return m.map(p=>this.recursiveResolve(S,n,p,s,u));if(_.isObject(m)){let p=Object.create(null);return Object.keys(m).forEach(k=>{const w=this.resolveString(S,n,k,s,u);p[w]=this.recursiveResolve(S,n,m[k],s,u)}),p}return m}resolveString(S,n,m,s,u){return m.replace(T.VARIABLE_REGEXP,(k,w)=>{if(w.includes(T.VARIABLE_LHS))return k;let o=this.evaluateSingleVariable(S,k,w,n,s);return u&&u.set(w,o),o!==k&&_.isString(o)&&o.match(T.VARIABLE_REGEXP)&&(o=this.resolveString(S,n,o,s,u)),o})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}evaluateSingleVariable(S,n,m,s,u){let p;const k=m.split(":");k.length>1&&(m=k[0],p=k[1]);const w=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,C.localize)(0,null,n))},o=()=>{const D=w();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,C.localize)(1,null,n,d.basename(D)))},h=()=>{if(p){const D=this._context.getFolderUri(p);if(D)return D;throw new Error((0,C.localize)(2,null,n,p))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(m){case"env":if(p){if(S){const D=S[F.isWindows?p.toLowerCase():p];if(_.isString(D))return D}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(p){const D=this._context.getConfigurationValue(s,p);if(_.isUndefinedOrNull(D))throw new Error((0,C.localize)(6,null,n,p));if(_.isObject(D))throw new Error((0,C.localize)(7,null,n,p));return D}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,p,u,"command");case"input":return this.resolveFromMap(n,p,u,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return s||p?(0,P.normalizeDriveLetter)(this.fsPath(h())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(h()));case"lineNumber":const D=this._context.getLineNumber();if(D)return D;throw new Error((0,C.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,C.localize)(10,null,n));case"file":return w();case"fileWorkspaceFolder":return o();case"relativeFile":return s||p?d.relative(this.fsPath(h()),w()):w();case"relativeFileDirname":const g=d.dirname(w());if(s||p){const l=d.relative(this.fsPath(h()),g);return l.length===0?".":l}return g;case"fileDirname":return d.dirname(w());case"fileExtname":return d.extname(w());case"fileBasename":return d.basename(w());case"fileBasenameNoExtension":const a=d.basename(w());return a.slice(0,a.length-d.extname(a).length);case"fileDirnameBasename":return d.basename(d.dirname(w()));case"execPath":const r=this._context.getExecPath();return r||n;case"execInstallFolder":const v=this._context.getAppRoot();return v||n;case"pathSeparator":return d.sep;default:try{const l=p?`${m}:${p}`:m;return this.resolveFromMap(n,l,u,void 0)}catch(l){return n}}}}resolveFromMap(S,n,m,s){if(n&&m){const u=s===void 0?m[n]:m[s+":"+n];if(typeof u=="string")return u;throw new Error((0,C.localize)(11,null,S))}return S}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,160]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var _;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var P;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function T(u){const p=u;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=T;var t;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(S=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function m(u){const p=u;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=m;function s(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(be[169],Ee([0,1,4,92]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const F=A;return typeof A=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=_}),define(be[8],Ee([0,1,14,22,77,230,55,23,10,2,44,59,136,83,49,89,68,169,7]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(de){function ge(z){const{selectionStartLineNumber:we,selectionStartColumn:ke,positionLineNumber:Je,positionColumn:xe}=z,ct=new w.Position(we-1,ke-1),pt=new w.Position(Je-1,xe-1);return new w.Selection(ct,pt)}de.to=ge;function X(z){const{anchor:we,active:ke}=z;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=X})(o=e.Selection||(e.Selection={}));var h;(function(de){function ge(z){if(!z)return;const{start:we,end:ke}=z;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=ge;function X(z){if(!z)return;const{startLineNumber:we,startColumn:ke,endLineNumber:Je,endColumn:xe}=z;return new w.Range(we-1,ke-1,Je-1,xe-1)}de.to=X})(h=e.Range||(e.Range={}));var D;(function(de){function ge(X){switch(X){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}de.to=ge})(D=e.TokenType||(e.TokenType={}));var i;(function(de){function ge(z){return new w.Position(z.lineNumber-1,z.column-1)}de.to=ge;function X(z){return{lineNumber:z.line+1,column:z.character+1}}de.from=X})(i=e.Position||(e.Position={}));var g;(function(de){function ge(we,ke){return(0,d.coalesce)((0,d.asArray)(we).map(Je=>X(Je,ke)))}de.from=ge;function X(we,ke){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:z(we.scheme,ke),pattern:typeof we.pattern=="undefined"?void 0:rt.from(we.pattern),exclusive:we.exclusive}}function z(we,ke){return ke&&typeof we=="string"?ke.transformOutgoingScheme(we):we}})(g=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(de){function ge(z){switch(z){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}de.from=ge;function X(z){switch(z){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}de.to=X})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(de){function ge(z){let we;return z.code&&((0,C.isString)(z.code)||(0,C.isNumber)(z.code)?we=String(z.code):we={value:String(z.code.value),target:z.code.target}),{...h.from(z.range),message:z.message,source:z.source,code:we,severity:l.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(v.from),tags:Array.isArray(z.tags)?(0,d.coalesce)(z.tags.map(a.from)):void 0}}de.from=ge;function X(z){const we=new w.Diagnostic(h.to(z),z.message,l.to(z.severity));return we.source=z.source,we.code=(0,C.isString)(z.code)?z.code:z.code?.value,we.relatedInformation=z.relatedInformation&&z.relatedInformation.map(v.to),we.tags=z.tags&&(0,d.coalesce)(z.tags.map(a.to)),we}de.to=X})(r=e.Diagnostic||(e.Diagnostic={}));var v;(function(de){function ge(z){return{...h.from(z.location.range),message:z.message,resource:z.location.uri}}de.from=ge;function X(z){return new w.DiagnosticRelatedInformation(new w.Location(z.resource,h.to(z)),z.message)}de.to=X})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(de){function ge(z){switch(z){case w.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}de.from=ge;function X(z){switch(z){case m.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}de.to=X})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(de){function ge(z){return typeof z=="number"&&z>=w.ViewColumn.One?z-1:z===w.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}de.from=ge;function X(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=X})(c=e.ViewColumn||(e.ViewColumn={}));function b(de){return typeof de.range!="undefined"}function f(de){return de.length===0?!0:!!b(de[0])}e.isDecorationOptionsArr=f;var y;(function(de){function ge(xe){return xe.map(de.from)}de.fromMany=ge;function X(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function z(xe){let ct;if(X(xe)){const{language:ft,value:_t}=xe;ct={value:"```"+ft+`
`+_t+"\n```\n"}}else w.MarkdownString.isMarkdownString(xe)?ct={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ct={value:xe}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const dt=ft=>{try{let _t=T.URI.parse(ft,!0);_t=_t.with({query:we(_t.query,pt)}),pt[ft]=_t}catch(_t){}return""},ht=new A.Renderer;return ht.link=dt,ht.image=ft=>dt(_.parseHrefAndDimensions(ft).href),A(ct.value,{renderer:ht}),ct}de.from=z;function we(xe,ct){if(!xe)return xe;let pt;try{pt=(0,F.parse)(xe)}catch(ht){}if(!pt)return xe;let dt=!1;return pt=(0,P.cloneAndChange)(pt,ht=>{if(T.URI.isUri(ht)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ht,dt=!0,ft}else return}),dt?JSON.stringify(pt):xe}function ke(xe){const ct=new w.MarkdownString(xe.value,xe.supportThemeIcons);return ct.isTrusted=xe.isTrusted,ct.supportHtml=xe.supportHtml,ct}de.to=ke;function Je(xe){if(!!xe)return typeof xe=="string"?xe:de.from(xe)}de.fromStrict=Je})(y=e.MarkdownString||(e.MarkdownString={}));function R(de){return f(de)?de.map(ge=>({range:h.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?y.fromMany(ge.hoverMessage):ge.hoverMessage?y.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):de.map(ge=>({range:h.from(ge)}))}e.fromRangeOrRangeWithMessage=R;function I(de){return typeof de=="undefined"?de:typeof de=="string"?T.URI.file(de):de}e.pathOrURIToURI=I;var L;(function(de){function ge(X){return typeof X=="undefined"?X:{contentText:X.contentText,contentIconPath:X.contentIconPath?I(X.contentIconPath):void 0,border:X.border,borderColor:X.borderColor,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,color:X.color,backgroundColor:X.backgroundColor,margin:X.margin,width:X.width,height:X.height}}de.from=ge})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(de){function ge(X){return typeof X=="undefined"?X:{backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?I(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?L.from(X.before):void 0,after:X.after?L.from(X.after):void 0}}de.from=ge})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(de){function ge(X){if(typeof X=="undefined")return X;switch(X){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=ge})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(de){function ge(X){return{isWholeLine:X.isWholeLine,rangeBehavior:X.rangeBehavior?N.from(X.rangeBehavior):void 0,overviewRulerLane:X.overviewRulerLane,light:X.light?E.from(X.light):void 0,dark:X.dark?E.from(X.dark):void 0,backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?I(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?L.from(X.before):void 0,after:X.after?L.from(X.after):void 0}}de.from=ge})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(de){function ge(z){return{text:z.newText,eol:z.newEol&&q.from(z.newEol),range:h.from(z.range)}}de.from=ge;function X(z){const we=new w.TextEdit(h.to(z.range),z.text);return we.newEol=typeof z.eol=="undefined"?void 0:q.to(z.eol),we}de.to=X})(B=e.TextEdit||(e.TextEdit={}));var G;(function(de){function ge(z,we,ke){const Je={edits:[]};if(z instanceof w.WorkspaceEdit)for(let xe of z._allEntries())if(xe._type===1)Je.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ct=we?.getDocument(xe.uri);Je.edits.push({_type:2,resource:xe.uri,edit:B.from(xe.edit),modelVersionId:ct?.version,metadata:xe.metadata})}else xe._type===3?Je.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Je.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Xe.from)}});return Je}de.from=ge;function X(z){const we=new w.WorkspaceEdit;for(const ke of z.edits)ke.edit?we.replace(T.URI.revive(ke.resource),h.to(ke.edit.range),ke.edit.text):we.renameFile(T.URI.revive(ke.oldUri),T.URI.revive(ke.newUri),ke.options);return we}de.to=X})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(de){const ge=Object.create(null);ge[w.SymbolKind.File]=0,ge[w.SymbolKind.Module]=1,ge[w.SymbolKind.Namespace]=2,ge[w.SymbolKind.Package]=3,ge[w.SymbolKind.Class]=4,ge[w.SymbolKind.Method]=5,ge[w.SymbolKind.Property]=6,ge[w.SymbolKind.Field]=7,ge[w.SymbolKind.Constructor]=8,ge[w.SymbolKind.Enum]=9,ge[w.SymbolKind.Interface]=10,ge[w.SymbolKind.Function]=11,ge[w.SymbolKind.Variable]=12,ge[w.SymbolKind.Constant]=13,ge[w.SymbolKind.String]=14,ge[w.SymbolKind.Number]=15,ge[w.SymbolKind.Boolean]=16,ge[w.SymbolKind.Array]=17,ge[w.SymbolKind.Object]=18,ge[w.SymbolKind.Key]=19,ge[w.SymbolKind.Null]=20,ge[w.SymbolKind.EnumMember]=21,ge[w.SymbolKind.Struct]=22,ge[w.SymbolKind.Event]=23,ge[w.SymbolKind.Operator]=24,ge[w.SymbolKind.TypeParameter]=25;function X(we){return typeof ge[we]=="number"?ge[we]:6}de.from=X;function z(we){for(const ke in ge)if(ge[ke]===we)return Number(ke);return w.SymbolKind.Property}de.to=z})(H=e.SymbolKind||(e.SymbolKind={}));var W;(function(de){function ge(z){switch(z){case w.SymbolTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return w.SymbolTag.Deprecated}}de.to=X})(W=e.SymbolTag||(e.SymbolTag={}));var ne;(function(de){function ge(z){return{name:z.name,kind:H.from(z.kind),tags:z.tags&&z.tags.map(W.from),containerName:z.containerName,location:re.from(z.location)}}de.from=ge;function X(z){const we=new w.SymbolInformation(z.name,H.to(z.kind),z.containerName,re.to(z.location));return we.tags=z.tags&&z.tags.map(W.to),we}de.to=X})(ne=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(de){function ge(z){const we={name:z.name||"!!MISSING: name!!",detail:z.detail,range:h.from(z.range),selectionRange:h.from(z.selectionRange),kind:H.from(z.kind),tags:z.tags?.map(W.from)??[]};return z.children&&(we.children=z.children.map(ge)),we}de.from=ge;function X(z){const we=new w.DocumentSymbol(z.name,z.detail,H.to(z.kind),h.to(z.range),h.to(z.selectionRange));return(0,d.isNonEmptyArray)(z.tags)&&(we.tags=z.tags.map(W.to)),z.children&&(we.children=z.children.map(X)),we}de.to=X})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(de){function ge(z){const we=new w.CallHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),h.to(z.range),h.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,name:z.name,detail:z.detail,kind:H.from(z.kind),uri:z.uri,range:h.from(z.range),selectionRange:h.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(de){function ge(X){return new w.CallHierarchyIncomingCall(Y.to(X.from),X.fromRanges.map(z=>h.to(z)))}de.to=ge})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var le;(function(de){function ge(X){return new w.CallHierarchyOutgoingCall(Y.to(X.to),X.fromRanges.map(z=>h.to(z)))}de.to=ge})(le=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var re;(function(de){function ge(z){return{range:z.range&&h.from(z.range),uri:z.uri}}de.from=ge;function X(z){return new w.Location(T.URI.revive(z.uri),h.to(z.range))}de.to=X})(re=e.location||(e.location={}));var ve;(function(de){function ge(z){const we=z,ke=z;return{originSelectionRange:we.originSelectionRange?h.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:ke.uri,range:h.from(we.targetRange?we.targetRange:ke.range),targetSelectionRange:we.targetSelectionRange?h.from(we.targetSelectionRange):void 0}}de.from=ge;function X(z){return{targetUri:T.URI.revive(z.uri),targetRange:h.to(z.range),targetSelectionRange:z.targetSelectionRange?h.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?h.to(z.originSelectionRange):void 0}}de.to=X})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(de){function ge(z){return{range:h.from(z.range),contents:y.fromMany(z.contents)}}de.from=ge;function X(z){return new w.Hover(z.contents.map(y.to),h.to(z.range))}de.to=X})(Fe=e.Hover||(e.Hover={}));var Me;(function(de){function ge(z){return{range:h.from(z.range),expression:z.expression}}de.from=ge;function X(z){return new w.EvaluatableExpression(h.to(z.range),z.expression)}de.to=X})(Me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Oe;(function(de){function ge(z){if(z instanceof w.InlineValueText)return{type:"text",range:h.from(z.range),text:z.text};if(z instanceof w.InlineValueVariableLookup)return{type:"variable",range:h.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}de.from=ge;function X(z){switch(z.type){case"text":return{range:h.to(z.range),text:z.text};case"variable":return{range:h.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:h.to(z.range),expression:z.expression}}}de.to=X})(Oe=e.InlineValue||(e.InlineValue={}));var Ke;(function(de){function ge(z){return{frameId:z.frameId,stoppedLocation:h.from(z.stoppedLocation)}}de.from=ge;function X(z){return new w.InlineValueContext(z.frameId,h.to(z.stoppedLocation))}de.to=X})(Ke=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(de){function ge(z){return{range:h.from(z.range),kind:z.kind}}de.from=ge;function X(z){return new w.DocumentHighlight(h.to(z.range),z.kind)}de.to=X})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Ve;(function(de){function ge(X){switch(X){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}de.to=ge})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(de){function ge(X){return{triggerKind:Ve.to(X.triggerKind),triggerCharacter:X.triggerCharacter}}de.to=ge})($=e.CompletionContext||(e.CompletionContext={}));var Q;(function(de){function ge(z){switch(z){case w.CompletionItemTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return w.CompletionItemTag.Deprecated}}de.to=X})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(de){const ge=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function X(ke){return ge.get(ke)??9}de.from=X;const z=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function we(ke){return z.get(ke)??w.CompletionItemKind.Property}de.to=we})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function ge(X,z){const we=new w.CompletionItem(X.label);return we.insertText=X.insertText,we.kind=ee.to(X.kind),we.tags=X.tags?.map(Q.to),we.detail=X.detail,we.documentation=_.isMarkdownString(X.documentation)?y.to(X.documentation):X.documentation,we.sortText=X.sortText,we.filterText=X.filterText,we.preselect=X.preselect,we.commitCharacters=X.commitCharacters,t.Range.isIRange(X.range)?we.range=h.to(X.range):typeof X.range=="object"&&(we.range={inserting:h.to(X.range.insert),replacing:h.to(X.range.replace)}),we.keepWhitespace=typeof X.insertTextRules=="undefined"?!1:Boolean(X.insertTextRules&1),typeof X.insertTextRules!="undefined"&&X.insertTextRules&4?we.insertText=new w.SnippetString(X.insertText):(we.insertText=X.insertText,we.textEdit=we.range instanceof w.Range?new w.TextEdit(we.range,we.insertText):void 0),X.additionalTextEdits&&X.additionalTextEdits.length>0&&(we.additionalTextEdits=X.additionalTextEdits.map(ke=>B.to(ke))),we.command=z&&X.command?z.fromInternal(X.command):void 0,we}de.to=ge})(ae=e.CompletionItem||(e.CompletionItem={}));var K;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?y.fromStrict(z.documentation):void 0}}de.from=ge;function X(z){return{label:z.label,documentation:_.isMarkdownString(z.documentation)?y.to(z.documentation):z.documentation}}de.to=X})(K=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?y.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(K.from):[],activeParameter:z.activeParameter}}de.from=ge;function X(z){return{label:z.label,documentation:_.isMarkdownString(z.documentation)?y.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(K.to):[],activeParameter:z.activeParameter}}de.to=X})(se=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function ge(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.from):[]}}de.from=ge;function X(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.to):[]}}de.to=X})(he=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(de){function ge(z){return{text:z.text,position:i.from(z.position),kind:Ue.from(z.kind??w.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}de.from=ge;function X(z){const we=new w.InlayHint(z.text,i.to(z.position),Ue.to(z.kind));return we.whitespaceAfter=z.whitespaceAfter,we.whitespaceBefore=z.whitespaceBefore,we}de.to=X})(Ae=e.InlayHint||(e.InlayHint={}));var Ue;(function(de){function ge(z){return z}de.from=ge;function X(z){return z}de.to=X})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(de){function ge(z){return{range:h.from(z.range),url:z.target,tooltip:z.tooltip}}de.from=ge;function X(z){let we;if(z.url)try{we=typeof z.url=="string"?T.URI.parse(z.url,!0):T.URI.revive(z.url)}catch(ke){}return new w.DocumentLink(h.to(z.range),we)}de.to=X})(He=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function ge(z){const we=new w.ColorPresentation(z.label);return z.textEdit&&(we.textEdit=B.to(z.textEdit)),z.additionalTextEdits&&(we.additionalTextEdits=z.additionalTextEdits.map(ke=>B.to(ke))),we}de.to=ge;function X(z){return{label:z.label,textEdit:z.textEdit?B.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(we=>B.from(we)):void 0}}de.from=X})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(de){function ge(z){return new w.Color(z[0],z[1],z[2],z[3])}de.to=ge;function X(z){return[z.red,z.green,z.blue,z.alpha]}de.from=X})(et=e.Color||(e.Color={}));var st;(function(de){function ge(z){return{range:h.from(z.range)}}de.from=ge;function X(z){return new w.SelectionRange(h.to(z.range))}de.to=X})(st=e.SelectionRange||(e.SelectionRange={}));var ye;(function(de){function ge(X){switch(X){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}de.to=ge})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(de){function ge(z){switch(z){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}de.from=ge;function X(z){switch(z){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}de.to=X})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(de){function ge(z){if(z===w.EndOfLine.CRLF)return 1;if(z===w.EndOfLine.LF)return 0}de.from=ge;function X(z){if(z===1)return w.EndOfLine.CRLF;if(z===0)return w.EndOfLine.LF}de.to=X})(q=e.EndOfLine||(e.EndOfLine={}));var Z;(function(de){function ge(X){if(typeof X=="object")return X.viewId;switch(X){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=ge})(Z=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(de){function ge(X){const z={start:X.start+1,end:X.end+1};return X.kind&&(z.kind=We.from(X.kind)),z}de.from=ge})(pe=e.FoldingRange||(e.FoldingRange={}));var We;(function(de){function ge(X){if(X)switch(X){case w.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}de.from=ge})(We=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ye;(function(de){function ge(X){if(X)return{pinned:typeof X.preview=="boolean"?!X.preview:void 0,inactive:X.background,preserveFocus:X.preserveFocus,selection:typeof X.selection=="object"?h.from(X.selection):void 0,override:typeof X.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=ge})(Ye=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(de){function ge(z){return z instanceof w.RelativePattern||typeof z=="string"?z:X(z)?new w.RelativePattern(z.base,z.pattern):z}de.from=ge;function X(z){const we=z;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var mt;(function(de){function ge(X){if(X){if(Array.isArray(X))return X.map(ge);if(typeof X=="string")return X;{const z=X;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:rt.from(z.pattern),exclusive:z.exclusive}}}else return}de.from=ge})(mt=e.LanguageSelector||(e.LanguageSelector={}));var ut;(function(de){function ge(z){return{start:z.start,end:z.end}}de.from=ge;function X(z){return new w.NotebookRange(z.start,z.end)}de.to=X})(ut=e.NotebookRange||(e.NotebookRange={}));var St;(function(de){function ge(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}de.to=ge;function X(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}de.from=X})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Tt;(function(de){function ge(z){switch(z){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}de.from=ge;function X(z){switch(z){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}de.to=X})(Tt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(de){function ge(z){const we={metadata:z.metadata??Object.create(null),cells:[]};for(let ke of z.cells)w.NotebookCellData.validate(ke),we.cells.push(Xe.from(ke));return we}de.from=ge;function X(z){const we=new w.NotebookData(z.cells.map(Xe.to));return(0,C.isEmptyObject)(z.metadata)||(we.metadata=z.metadata),we}de.to=X})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function ge(z){return{cellKind:Tt.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:St.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Pe.from):[]}}de.from=ge;function X(z){return new w.NotebookCellData(Tt.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Pe.to):void 0,z.metadata,z.internalMetadata?St.to(z.internalMetadata):void 0)}de.to=X})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(de){function ge(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}de.from=ge;function X(z){return new w.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}de.to=X})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(de){function ge(z){return{outputId:z.id,items:z.items.map(vt.from),metadata:z.metadata}}de.from=ge;function X(z){const we=z.items.map(vt.to);return new w.NotebookCellOutput(we,z.outputId,z.metadata)}de.to=X})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(de){function ge(ke){if(ke!=null){if(ke instanceof w.RelativePattern||typeof ke=="string")return ke;if(we(ke))return new w.RelativePattern(ke.base,ke.pattern);if(z(ke))return{include:rt.from(ke.include)||void 0,exclude:rt.from(ke.exclude)||void 0}}}de.from=ge;function X(ke){return typeof ke=="string"?ke:we(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=X;function z(ke){const Je=ke,xe=rt.from(Je.include);if(!(xe&&xe instanceof w.RelativePattern||typeof xe=="string"))return!1;const ct=rt.from(Je.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function we(ke){const Je=ke;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(de){function ge(X){return{backgroundColor:X.backgroundColor,borderColor:X.borderColor,top:X.top?L.from(X.top):void 0}}de.from=ge})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var te;(function(de){function ge(X,z,we){const ke=typeof X.command=="string"?{title:"",command:X.command}:X.command;return{alignment:X.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(ke,we),text:X.text,tooltip:X.tooltip,accessibilityInformation:X.accessibilityInformation,priority:X.priority}}de.from=ge})(te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function ge(X){return{transientOutputs:X?.transientOutputs??!1,transientCellMetadata:X?.transientCellMetadata??{},transientDocumentMetadata:X?.transientDocumentMetadata??{}}}de.from=ge})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var me;(function(de){function ge(z){return{uri:z.uri,provides:z.provides}}de.from=ge;function X(z){return new w.NotebookRendererScript(T.URI.revive(z.uri),z.provides)}de.to=X})(me=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function ge(z){return{message:y.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?re.from(z.location):void 0}}de.from=ge;function X(z){const we=new w.TestMessage(typeof z.message=="string"?z.message:y.to(z.message));return we.actualOutput=z.actual,we.expectedOutput=z.expected,we.location=z.location?re.to(z.location):void 0,we}de.to=X})(fe=e.TestMessage||(e.TestMessage={}));var Ie;(function(de){let ge;(function(X){X.Delimiter="\0"})(ge||(ge={})),de.namespace=(X,z)=>X+"\0"+z,de.denamespace=X=>{const z=X.indexOf("\0");return{ctrlId:X.slice(0,z),tagId:X.slice(z+1)}}})(Ie=e.TestTag||(e.TestTag={}));var Be;(function(de){function ge(ke){const Je=(0,s.getPrivateApiFor)(ke).controllerId;return{extId:p.TestId.fromExtHostTestItem(ke,Je).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(xe=>Ie.namespace(Je,xe.id)),range:h.from(ke.range)||null,description:ke.description||null,error:ke.error&&y.fromStrict(ke.error)||null}}de.from=ge;function X(ke){return{parent:void 0,error:void 0,id:p.TestId.fromString(ke.extId).localId,label:ke.label,uri:T.URI.revive(ke.uri),tags:(ke.tags||[]).map(Je=>{const{tagId:xe}=Ie.denamespace(Je);return new w.TestTag(xe)}),range:h.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=X;function z(ke){const Je=p.TestId.fromString(ke.extId),xe=new s.TestItemImpl(Je.controllerId,Je.localId,ke.label,T.URI.revive(ke.uri));return xe.range=h.to(ke.range||void 0),xe.description=ke.description||void 0,xe}function we(ke){let Je;for(const xe of ke.tests){const ct=z(xe.item);(0,s.getPrivateApiFor)(ct).parent=Je,Je=ct}return Je}de.toItemFromContext=we})(Be=e.TestItem||(e.TestItem={})),function(de){function ge(z){return{id:z.id}}de.from=ge;function X(z){return new w.TestTag(z.id)}de.to=X}(Ie=e.TestTag||(e.TestTag={}));var Ne;(function(de){const ge=(z,we)=>{const ke={...Be.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(xe=>xe.type===0).map(fe.to)})),children:z.children.map(Je=>we.get(Je)).filter(C.isDefined).map(Je=>ge(Je,we))};for(const Je of ke.children)Je.parent=ke;return ke};function X(z){const we=[],ke=new Map;for(const Je of z.items)ke.set(Je.item.extId,Je),z.request.targets.some(xe=>xe.controllerId===Je.controllerId&&xe.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:z.completedAt,results:we.map(Je=>ge(Je,ke))}}de.to=X})(Ne=e.TestResults||(e.TestResults={}));var qe;(function(de){function ge(ke){return{covered:ke.covered,total:ke.covered}}function X(ke){return"line"in ke?i.from(ke):h.from(ke)}function z(ke){return"branches"in ke?{count:ke.executionCount,location:X(ke.location),type:1,branches:ke.branches.length?ke.branches.map(Je=>({count:Je.executionCount,location:Je.location&&X(Je.location)})):void 0}:{type:0,count:ke.executionCount,location:X(ke.location)}}de.fromDetailed=z;function we(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(z)}}de.fromFile=we})(qe=e.TestCoverage||(e.TestCoverage={}));var it;(function(de){function ge(X){switch(X){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}de.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function ge(z){const we=new w.TypeHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),h.to(z.range),h.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,kind:H.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:h.from(z.range),selectionRange:h.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,t,S,n={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=S,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,S,n)=>{const s={dispose:this._callbacks.push([t,S,T])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(T,t){const S=d.URI.revive(T);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let u of[...this._callbacks]){if(n)break;const p=this._documents.getDocument(S),k=await this._deliverEventAsyncAndBlameBadListeners(u,{document:p,reason:A.TextDocumentSaveReason.to(t)});s.push(k)}}finally{clearTimeout(m)}return s}_deliverEventAsyncAndBlameBadListeners([T,t,S],n){const m=this._badListeners.get(T);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,T,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const u=this._badListeners.get(T);this._badListeners.set(T,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,S,n){const m=[],s=Date.now(),{document:u,reason:p}=n,{version:k}=u,w=Object.freeze({document:u,reason:p,waitUntil(o){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{t.apply(S,[w])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,h)=>{const D=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(D),o(i)}).catch(i=>{clearTimeout(D),h(i)})}).then(o=>{const h={edits:[]};for(const D of o)if(Array.isArray(D)&&D.every(i=>i instanceof _.TextEdit))for(const{newText:i,newEol:g,range:a}of D)h.edits.push({_type:2,resource:u.uri,edit:{range:a&&A.Range.from(a),text:i,eol:g&&A.EndOfLine.from(g)}});if(h.edits.length!==0)return k===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(be[171],Ee([0,1,3,27,2,8,7]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(t,S,n,m,s){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),s&&(this._config+=4);const u=(0,M.parse)(S),p=t(k=>{if(!n)for(let w of k.created){const o=_.URI.revive(w);u(o.fsPath)&&this._onDidCreate.fire(o)}if(!m)for(let w of k.changed){const o=_.URI.revive(w);u(o.fsPath)&&this._onDidChange.fire(o)}if(!s)for(let w of k.deleted){const o=_.URI.revive(w);u(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(t,S,n){this._logService=S,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,S,n,m){return new P(this._onFileSystemEvent.event,t,S,n,m)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,S){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(n=>({oldUri:_.URI.revive(n.source),newUri:_.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(n=>_.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:S.map(n=>_.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,S){return(n,m,s)=>{const u=function(k){n.call(m,k)};return u.extension=t,S.event(u,void 0,s)}}async $onWillRunFileOperation(t,S,n,m){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(s=>({oldUri:_.URI.revive(s.source),newUri:_.URI.revive(s.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(s=>_.URI.revive(s.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(s=>_.URI.revive(s.target))},n,m)}}async _fireWillEvent(t,S,n,m){const s=new Set,u=[];if(await t.fireAsync(S,m,async(k,w)=>{const o=Date.now(),h=await Promise.resolve(k);h instanceof F.WorkspaceEdit&&(u.push(h),s.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||u.length===0)return;const p={edits:[]};for(let k of u){let{edits:w}=A.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(w)}return{edit:p,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=C}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(n,m,s,u){this.start=n,this.deletedCount=m,this.deletedItems=s,this.items=u}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(s=>s.apiCell)}))}}class T{constructor(n,m,s){this.notebook=n,this._extHostDocument=m,this._cellData=s,this.handle=s.handle,this.uri=_.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,m,s){const u=s.map(A.NotebookCellOutputItem.to),p=this._outputs.find(k=>k.id===n);p&&(m||(p.items.length=0),p.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=T;class t{constructor(n,m,s,u,p,k){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=s,this._emitter=u,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=k.viewType,this._metadata=Object.freeze(k.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,k.cells]],!0),this._versionId=k.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const s of n.rawEvents)s.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===P.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,s=n.end|0;return m<0&&(m=0),s>this._cells.length&&(s=this._cells.length),n.with({start:m,end:s})}_getCells(n){n=this._validateRange(n);const m=[];for(let s=n.start;s<n.end;s++)m.push(this._cells[s]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const s=[],u=[],p=[];n.reverse().forEach(k=>{const o=k[2].map(i=>{const g=new T(this,this._textDocumentsAndEditors,i);return m||u.push(T.asModelAddData(this.apiNotebook,i)),g}),h=new C(k[0],k[1],[],o),D=this._cells.splice(k[0],k[1],...o);for(const i of D)p.push(i.uri),h.deletedItems.push(i.apiCell);s.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:p}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(s)}))}_moveCell(n,m){const s=this._cells.splice(n,1);this._cells.splice(m,0,...s);const u=[new C(n,1,s.map(p=>p.apiCell),[]),new C(m,0,[],s)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(u)}))}_setCellOutputs(n,m){const s=this._cells[n];s.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,m,s,u){const p=this._cells[n];p.setOutputItems(m,s,u),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(n,m){const s=this._cells[n];s.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(s.uri,m)}_changeCellMime(n,m){const s=this._cells[n];s.apiCell.mime=m}_changeCellMetadata(n,m){const s=this._cells[n],u=s.apiCell.metadata;s.setMetadata(m);const p=s.apiCell.metadata;(0,M.equals)(u,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,m){const s=this._cells[n],u=s.internalMetadata;if(s.setInternalMetadata(m),u.runState!==m.runState){const p=m.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:p}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:T})}replaceCells(C,T,t){this._throwIfFinalized(),!(C===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:C,count:T-C,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(C,T,t,S,n,m){this.id=C,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=S,this._viewColumn=m}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");C._selections=T,C._trySetSelections(T)},get visibleRanges(){return C._visibleRanges},revealRange(T,t){C._proxy.$tryRevealRange(C.id,M.NotebookRange.from(T),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(T){const t=new A(this.document.version);return T(t),C._applyEdit(t.finalize())},setDecorations(T,t){return C.setDecorations(T,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(M.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let S=0;S<C.cellEdits.length;S++){if(t<0){T.push(C.cellEdits[S]),t++;continue}const m=T[t],s=C.cellEdits[S];if(m.editType===1&&s.editType===1&&m.index===s.index){m.cells.push(...C.cellEdits[S].cells),m.count+=C.cellEdits[S].count;continue}T.push(C.cellEdits[S]),t++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,T)}setDecorations(C,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return T.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(T),C.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,145,125,21,53,16]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,s){const u=this._handles++,{title:p,location:k,cancellable:w}=m,o={label:(0,_.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(u,{location:d.ProgressLocation.from(k),title:p,source:o,cancellable:w},n).catch(P.onUnexpectedExternalError),this._withProgress(u,s,!!w)}_withProgress(n,m,s){let u;s&&(u=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,u));const p=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let k;try{k=m(new t(this._proxy,n),s&&u?u.token:A.CancellationToken.None)}catch(w){throw p(n),w}return k.then(w=>p(n),w=>p(n)),k}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function T(S,n){return S.message=n.message,typeof n.increment=="number"&&(typeof S.increment=="number"?S.increment+=n.increment:S.increment=n.increment),S}class t extends M.Progress{constructor(n,m){super(s=>this.throttledReport(s));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}$e([(0,F.throttle)(100,(S,n)=>T(S,n),()=>Object.create(null))],t.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,54,8,7]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(n,m,s){const u=P._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,u,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new _.IdGenerator("TextEditorDecorationType");class C{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let s=null;if(n instanceof F.Position)s=new F.Range(n,n);else if(n instanceof F.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof F.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,s){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:m,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class T{constructor(n,m,s,u){this._proxy=n,this._id=m,this._accept(s),this._logService=u;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(k){p._setTabSize(k)},get insertSpaces(){return p._insertSpaces},set insertSpaces(k){p._setInsertSpaces(k)},get cursorStyle(){return p._cursorStyle},set cursorStyle(k){p._setCursorStyle(k)},get lineNumbers(){return p._lineNumbers},set lineNumbers(k){p._setLineNumbers(k)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let s=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(s=!0,m.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,s=!0,m.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(s=!0,m.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,s=!0,m.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(n){n.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=T;class t{constructor(n,m,s,u,p,k,w,o){this.id=n,this._proxy=m,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new T(this._proxy,this.id,k,s),this._visibleRanges=w,this._viewColumn=o;const h=this;this.value=Object.freeze({get document(){return u.getValue()},set document(D){throw(0,M.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(D){if(!(D instanceof F.Selection))throw(0,M.illegalArgument)("selection");h._selections=[D],h._trySetSelection()},get selections(){return h._selections},set selections(D){if(!Array.isArray(D)||D.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");h._selections=D,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(D){throw(0,M.readonly)("visibleRanges")},get options(){return h._options.value},set options(D){h._disposed||h._options.assign(D)},get viewColumn(){return h._viewColumn},set viewColumn(D){throw(0,M.readonly)("viewColumn")},edit(D,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new C(u.getValue(),i);return D(g),h._applyEdit(g)},insertSnippet(D,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=h._selections.map(r=>A.Range.from(r));else if(i instanceof F.Position){const{lineNumber:r,column:v}=A.Position.from(i);a=[{startLineNumber:r,startColumn:v,endLineNumber:r,endColumn:v}]}else if(i instanceof F.Range)a=[A.Range.from(i)];else{a=[];for(const r of i)if(r instanceof F.Range)a.push(A.Range.from(r));else{const{lineNumber:v,column:l}=A.Position.from(r);a.push({startLineNumber:v,startColumn:l,endLineNumber:v,endColumn:l})}}return m.$tryInsertSnippet(n,D.value,a,g)},setDecorations(D,i){const g=i.length===0;g&&!h._hasDecorationsForKey.has(D.key)||(g?h._hasDecorationsForKey.delete(D.key):h._hasDecorationsForKey.add(D.key),h._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return m.$trySetDecorations(n,D.key,A.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let r=0,v=i.length;r<v;r++){const l=i[r];a[4*r]=l.start.line+1,a[4*r+1]=l.start.character+1,a[4*r+2]=l.end.line+1,a[4*r+3]=l.end.character+1}return m.$trySetDecorationsFast(n,D.key,a)}}))},revealRange(D,i){h._runOnProxy(()=>m.$tryRevealRange(n,A.Range.from(D),i||F.TextEditorRevealType.Default))},show(D){m.$tryShowEditor(n,A.ViewColumn.from(D))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const s=m.edits.map(p=>p.range);s.sort((p,k)=>p.end.line===k.end.line?p.end.character===k.end.character?p.start.line===k.start.line?p.start.character-k.start.character:p.start.line-k.start.line:p.end.character-k.end.character:p.end.line-k.end.line);for(let p=0,k=s.length-1;p<k;p++){const w=s[p].end;if(s[p+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=m.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,u,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,128,24,2,3,6,161,12,7,10,14,8,21,158]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(w,o){if((0,t.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let h;return Array.isArray(w.highlights)&&(h=w.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),h=h.length?h:void 0),{label:w.label,highlights:h}}}class p{constructor(o,h,D){this._proxy=o,this.commands=h,this.logService=D,this.treeViews=new Map;function i(g){return g&&g.$treeViewId&&g.$treeItemHandle}h.registerArgumentProcessor({processArgument:g=>i(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(a=>i(a)?this.convertArgument(a):a):g})}registerTreeDataProvider(o,h,D){const i=this.createTreeView(o,{treeDataProvider:h},D);return{dispose:()=>i.dispose()}}createTreeView(o,h,D){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=h.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:i}),a=this.createExtHostTreeView(o,h,D);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(r){a.message=r},get title(){return a.title},set title(r){a.title=r},get description(){return a.description},set description(r){a.description=r},reveal:(r,v)=>a.reveal(r,v),dispose:async()=>{await g,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,h){const D=this.treeViews.get(o);return D?D.getChildren(h):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,h,D){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const g=s.TreeDataTransferConverter.toITreeDataTransfer(h);if(g.items.has(P.TREE_ITEM_DATA_TRANSFER_TYPE)){const r=JSON.parse(await g.items.get(P.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(v=>i.getExtensionElement(v)).filter(v=>!!v);r.length>0?g.items.set(P.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(r)}):g.items.delete(P.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(g,D)}async $hasResolve(o){const h=this.treeViews.get(o);if(!h)throw new Error((0,d.localize)(2,null,o));return h.hasResolve}$resolve(o,h,D){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(h,D)}$setExpanded(o,h,D){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(h,D)}$setSelection(o,h){const D=this.treeViews.get(o);if(!D)throw new Error((0,d.localize)(5,null,o));D.setSelection(h)}$setVisible(o,h){const D=this.treeViews.get(o);if(!D)throw new Error((0,d.localize)(6,null,o));D.setVisible(h)}createExtHostTreeView(o,h,D){const i=new k(o,h,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(o,i),i}convertArgument(o){const h=this.treeViews.get(o.$treeViewId);return h?h.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=p;class k extends F.Disposable{constructor(o,h,D,i,g,a){super();if(this.viewId=o,this.proxy=D,this.commands=i,this.logService=g,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,a.contributes&&a.contributes.views)for(const l in a.contributes.views)for(const c of a.contributes.views[l])c.id===o&&(this._title=c.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,v;this._register(A.Event.debounce(this._onDidChangeData.event,(l,c)=>(l||(l={message:!1,elements:[]}),c.element!==!1&&(r||(r=new Promise(b=>v=b),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(c.element)?l.elements.push(...c.element):l.elements.push(c.element)),c.message&&(l.message=!0),l),200,!0)(({message:l,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=v;return r=null,this.refresh(c).then(()=>b())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const h=o?this.getExtensionElement(o):void 0;if(o&&!h)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(o);return D||(D=await this.fetchChildrenNodes(h)),D?D.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,h){h=h||{select:!0,focus:!1};const D=(0,t.isUndefinedOrNull)(h.select)?!0:h.select,i=(0,t.isUndefinedOrNull)(h.focus)?!1:h.focus,g=(0,t.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(a=>this.resolveTreeNode(o,a[a.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:a.map(v=>v.item)},{select:D,focus:i,expand:g})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:i,expand:g})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,h){const D=this.getExtensionElement(o);D&&(h?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(o){(0,S.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,h){const D=this.getExtensionElement(h);if(!!D)return(0,C.asPromise)(()=>this.dndController?.onDrop(o,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,h){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(o);if(D){const i=this.nodes.get(D);if(i){const g=await this.dataProvider.resolveTreeItem(i.extensionItem,D,h)??i.extensionItem;return i.item.tooltip=this.getTooltip(g.tooltip),i.item.command=this.getCommand(i.disposableStore,g.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(h=>h?this.resolveUnknownParentChain(h).then(D=>this.resolveTreeNode(h,D[D.length-1]).then(i=>(D.push(i),D))):Promise.resolve([]))}resolveParent(o){const h=this.nodes.get(o);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,h){const D=this.nodes.get(o);return D?Promise.resolve(D):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,h,!0)).then(i=>this.getChildren(h?h.item.handle:void 0).then(()=>{const g=this.getExtensionElement(i);if(g){const a=this.nodes.get(g);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let h;if(typeof o=="string"){const D=this.getExtensionElement(o);h=D?this.nodes.get(D):void 0}else h=o;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const h=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(h.token.isCancellationRequested)return;const g=await Promise.all((0,S.coalesce)(i||[]).map(async a=>{const r=await this.dataProvider.getTreeItem(a);return r&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(a,r,D):null}));return h.token.isCancellationRequested?void 0:(0,S.coalesce)(g)}finally{h.dispose()}}refresh(o){if(o.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(o);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const h=new Set,D=o.map(g=>this.nodes.get(g));for(const g of D)if(g&&!h.has(g.item.handle)){let a=g;for(;a&&a.parent&&D.findIndex(r=>a&&a.parent&&r&&r.item.handle===a.parent.item.handle)===-1;){const r=this.elements.get(a.parent.item.handle);a=r?this.nodes.get(r):void 0}a&&!a.parent&&h.add(g.item.handle)}const i=[];return h.forEach(g=>{const a=this.elements.get(g);if(a){const r=this.nodes.get(a);r&&(!r.parent||!h.has(r.parent.item.handle))&&i.push(g)}}),i}refreshHandles(o){const h={};return Promise.all(o.map(D=>this.refreshNode(D).then(i=>{i&&(h[D]=i.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(o){const h=this.getExtensionElement(o);if(h){const D=this.nodes.get(h);if(D)return this.clearChildren(h),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(i=>{if(i){const g=this.createTreeNode(h,i,D.parent);return this.updateNodeCache(h,g,D,D.parent),D.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,h,D){const i=this.createTreeNode(o,h,D);if(h.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,h.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,D),i}getTooltip(o){return T.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,h){return h?this.commands.toInternal(h,o):void 0}createTreeNode(o,h,D){const i=new F.DisposableStore,g=this.createHandle(o,h,D),a=this.getLightIconPath(h);return{item:{handle:g,parentHandle:D?D.item.handle:void 0,label:u(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(i,h.command),contextValue:h.contextValue,icon:a,iconDark:this.getDarkIconPath(h)||a,themeIcon:this.getThemeIcon(h),collapsibleState:(0,t.isUndefinedOrNull)(h.collapsibleState)?T.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:D,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof T.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:h,label:D,resourceUri:i},g,a){if(h)return`${k.ID_HANDLE_PREFIX}/${h}`;const r=u(D,this.extension),v=g?g.item.handle:k.LABEL_HANDLE_PREFIX;let l=r?r.label:i?(0,M.basename)(i):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const c=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,b=this.getChildrenNodes(g)||[];let f,y=0;do{if(f=`${v}/${y}:${l}`,a||!this.elements.has(f)||c===f)break;y++}while(y<=b.length);return f}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon))return typeof o.iconPath=="string"||_.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return _.URI.isUri(o)?o:_.URI.file(o)}addNodeToCache(o,h){this.elements.set(h.item.handle,o),this.nodes.set(o,h)}updateNodeCache(o,h,D,i){this.elements.delete(h.item.handle),this.nodes.delete(o),h.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(o,h);const g=this.getChildrenNodes(i)||[],a=g.filter(r=>r.item.handle===D.item.handle)[0];a&&g.splice(g.indexOf(a),1,h)}addNodeToParentCache(o,h){h?(h.children||(h.children=[]),h.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const h=this.nodes.get(o);if(h){if(h.children)for(const D of h.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}h.children=void 0}}else this.clearAll()}clear(o){const h=this.nodes.get(o);if(h){if(h.children)for(const D of h.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,12,3,6,10,49,8,90,68]),function(oe,e,d,M,_,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends _.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||m>s.expandLevels)&&(s.expandLevels=m),s.expand===1){const u=this.resolveChildren(s);return u.isOpen()?this.expandChildren(s,m-1):u.wait().then(()=>this.expandChildren(s,m-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,m-1)):this.expandChildren(s,m-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const w of m.ops)this.onTestItemEvent(n,w);break;case 3:const{key:s,value:u,previous:p}=m,k=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,p,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:P.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:P.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[s]:u??null}}]);break}break;default:(0,A.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=T.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),u=(0,F.getPrivateApiFor)(n);u.parent&&u.parent!==m?.actual&&u.parent.children.delete(n.id);let p=this.tree.get(s.toString());if(!p){p={fullId:s,actual:n,parent:m?s.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(n,m),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:P.TestItem.from(n)}]),this.connectItemAndChildren(n,p,m);return}if(p.actual===n){this.connectItem(n,p,m);return}const k=p.actual.children,w=p.actual,o=(0,F.diffTestItems)(w,n);(0,F.getPrivateApiFor)(w).listener=void 0,p.actual=n,p.expand=0;for(const[h,D]of o)this.onTestItemEvent(p,{op:3,key:h,value:D,previous:w[h]});this.connectItemAndChildren(n,p,m);for(const h of k)n.children.get(h.id)||this.removeItem(T.TestId.joinToString(s,h.id))}diffTagRefs(n,m,s){const u=new Set(m.map(p=>p.id));for(const p of n)u.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:s,item:{tags:n.map(p=>P.TestTag.namespace(this.controllerId,p.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,P.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,F.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,s){this.setItemParent(n,s);const u=(0,F.getPrivateApiFor)(n);u.parent=s?.actual,u.listener=p=>this.onTestItemEvent(m,p),this.updateExpandability(m)}connectItemAndChildren(n,m,s){this.connectItem(n,m,s);for(const u of n.children)this.upsertItem(u,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const s=[];for(const u of n.actual.children){const p=this.expand(T.TestId.joinToString(n.fullId,u.id),m);(0,d.isThenable)(p)&&s.push(p)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const p=new d.Barrier;return p.open(),p}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new d.Barrier,s=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=p.stack||p.message||String(p))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(p){s(p)}return(0,d.isThenable)(u)?u.catch(s).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[m];for(;s.length;){const u=s.pop();if(!!u){(0,F.getPrivateApiFor)(u.actual).listener=void 0;for(const p of u.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(u.fullId.toString());for(const p of u.actual.children)s.push(this.tree.get(T.TestId.joinToString(u.fullId,p.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,141]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let S of t.activationEvents)S==="onUri"&&(S=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(t)}}keepOnly(t){const S=new Set;t.forEach(n=>S.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>S.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,S){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(S=S.concat(n.map(m=>m.identifier)),S.length>0){const m=new Set;S.forEach(s=>m.add(d.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!m.has(d.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,k){this.addNode(p),this.addNode(k),this._arcs.has(p)?this._arcs.get(p).push(k):this._arcs.set(p,[k])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,k){const w=S.getArcs(p);for(let o=0;o<w.length;o++)if(!k.has(w[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let p of t){const k=d.ExtensionIdentifier.toKey(p.identifier);if(n.set(k,p),p.extensionDependencies)for(let w of p.extensionDependencies){const o=d.ExtensionIdentifier.toKey(w);S.addArc(k,o)}}let m=new Set;S.getNodes().filter(p=>S.getArcs(p).length===0).forEach(p=>m.add(p));let s=S.getNodes().filter(p=>!m.has(p)),u;do{u=!1;for(let p=0;p<s.length;p++){const k=s[p];S.hasOnlyGoodArcs(k,m)&&(s.splice(p,1),p--,m.add(k),u=!0)}}while(u);return s.map(p=>n.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const S=this._activationMap.get(t);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const S=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return S||void 0}}e.ExtensionDescriptionRegistry=F;var P;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(P||(P={}));function C(T,t){const S=T.isBuiltin?0:T.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(S!==n)return S-n;const m=_.posix.basename(T.extensionLocation.path),s=_.posix.basename(t.extensionLocation.path);return m<s?-1:m>s?1:0}}),define(be[178],Ee([0,1,22]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function A(P){const C=d.VSBuffer.alloc(1);switch(P){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=A;function F(P,C){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,26,147]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var P;(function(h){h[h.None=0]="None",h[h.LocalProcess=1]="LocalProcess",h[h.LocalWebWorker=2]="LocalWebWorker",h[h.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(h){switch(h){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class T{constructor(D){this.dependency=D}}e.MissingExtensionDependency=T;var t;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function S(h){switch(h){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=S;class n{constructor(D,i,g,a){this.codeLoadingTime=D,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=a}}e.ActivationTimes=n;class m{constructor(D,i){this.description=D,this.value=i}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var s;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(h){h.enableProposedApi||p(h)}e.checkProposedApiEnabled=u;function p(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=p;function k(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=k;function w(h,D){return{identifier:new A.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!D,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid}}e.toExtensionDescription=w;class o{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(D){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(D){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(D,i){return Promise.resolve()}_onWillActivateExtension(D){}_onDidActivateExtension(D,i,g,a,r){}_onDidActivateExtensionError(D,i){}_onExtensionRuntimeError(D,i){}_onExtensionHostExit(D){}}e.NullExtensionService=o}),define(be[179],Ee([0,1,26,30,15]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class F{constructor(s,u,p,k){this.startup=s,this.codeLoadingTime=u,this.activateCallTime=p,this.activateResolvedTime=k}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class P{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,u){return s===-1||u===-1?-1:u-s}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class C{constructor(s,u,p,k,w,o){this.activationFailed=s,this.activationFailedError=u,this.activationTimes=p,this.module=k,this.exports=w,this.subscriptions=o}}e.ActivatedExtension=C;class T extends C{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends C{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class S extends C{constructor(s){super(!0,s,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let n=class{constructor(s,u,p,k,w){this._logService=w,this._registry=s,this._resolvedExtensionsSet=new Set,u.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,p.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const u=d.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(u)}getActivatedExtension(s){const u=d.ExtensionIdentifier.toKey(s),p=this._activatedExtensions.get(u);if(!p)throw new Error("Extension `"+s.value+"` is not known or not activated");return p}activateByEvent(s,u){if(this._alreadyActivatedEvents[s])return A;const p=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(p.map(k=>({id:k.identifier,reason:{startup:u,extensionId:k.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,u){const p=this._registry.getExtensionDescription(s);if(!p)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:p.identifier,reason:u}])}_handleActivateRequest(s,u,p){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(s.id))){u[d.ExtensionIdentifier.toKey(s.id)]=s;return}const k=this._registry.getExtensionDescription(s.id);if(!k){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,h,new M.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(s.id),new S(h));return}const w=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let o=!0;for(let h=0,D=w.length;h<D;h++){const i=w[h];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const g=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(g&&!g.activationFailed)continue;if(g&&g.activationFailed){const l=k.displayName||k.identifier.value,c=this._registry.getExtensionDescription(i),b=c&&c.displayName||i,f=new Error(`Cannot activate the '${l}' extension because its dependency '${b}' failed to activate`);f.detail=g.activationFailedError,this._host.onExtensionActivationError(k.identifier,f,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(k.identifier),new S(f));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){if(!a.main&&!a.browser)continue;o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}const r=k.displayName||k.identifier.value,v=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(k.identifier,v,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(k.identifier),new S(v));return}o?u[d.ExtensionIdentifier.toKey(k.identifier)]=s:p.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(w=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(w.id))),s.length===0))return Promise.resolve(void 0);const u=Object.create(null),p=[];for(let w=0,o=s.length;w<o;w++)this._handleActivateRequest(s[w],u,p);for(let w=0,o=p.length;w<o;w++){const h=d.ExtensionIdentifier.toKey(p[w].id);u[h]&&delete u[h]}const k=Object.keys(u).map(w=>u[w]);return p.length===0?Promise.all(k.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(k).then(w=>this._activateExtensions(p))}_activateExtension(s,u){const p=d.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const k=this._activatingExtensions.get(p);if(k)return k;const w=this._host.actualActivateExtension(s,u).then(void 0,o=>{const h=new Error;return o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${s.value}' failed: ${o.message}.`:h.message=`Activating extension '${s.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this._host.onExtensionActivationError(s,h,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(o),new S(o)}).then(o=>{this._activatedExtensions.set(p,o),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,w),w}};n=$e([ze(4,_.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,F)=>{this._actualOk=A,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,F){return this._ensureActual().then(A,F)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function _(C){const T=new d(!0,C);return M[T.nid]=T,T}e.createMainContextProxyIdentifier=_;function A(C){const T=new d(!1,C);return M[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function F(C){return M[C].sid}e.getStringIdentifierForProxy=F;class P{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=P}),define(be[5],Ee([0,1,55,2,38]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var S;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(S=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function h(i,g){return Object.defineProperty(i,o.name,{value:g,enumerable:!0}),i}o.mixin=h;function D(i){return i[o.name]}o.of=D})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(h){return h._id=m._n++,h}}e.IdObject=m,m._n=0;var s;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function k(o){if(o&&o.edits)for(const h of o.edits)typeof h.resource=="object"?h.resource=M.URI.revive(h.resource):(h.newUri=M.URI.revive(h.newUri),h.oldUri=M.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,d.revive)(h.metadata));return o}e.reviveWorkspaceEditDto=k;var w;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,_.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,_.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,_.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,_.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,T){return this._proxy.$setPassword(P,C,T)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,13]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(C,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(_.MainContext.MainThreadTelemetry)}report(C,T,t){const S=this.getUsageKey(C,T);this._reportedUsages.has(S)||(this._reportedUsages.add(S),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:C}))}getUsageKey(C,T){return`${C}-${T.identifier.value}`}};F=$e([ze(0,A.IExtHostRpcService),ze(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,T){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,T,t,S={}){const n=A.ExtensionIdentifier.toKey(C.identifier),m=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let u=m.find(p=>p.scopes===s);if(u)return u.result;{const p=this._getSession(C,n,T,t,S);u={scopes:s,result:p},m.push(u),this._inFlightRequests.set(n,m);try{await p}finally{const k=m.findIndex(w=>w.scopes===s);k>-1&&(m.splice(k),this._inFlightRequests.set(n,m))}return p}}async _getSession(C,T,t,S,n={}){await this._proxy.$ensureProvider(t);const m=C.displayName||C.name;return this._proxy.$getSession(t,S,T,m,n)}async removeSession(C,T){const t=this._authenticationProviders.get(C);return t?t.provider.removeSession(T):this._proxy.$removeSession(C,T)}registerAuthenticationProvider(C,T,t,S){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:T,provider:t,options:S??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===C)||this._providers.push({id:C,label:T});const n=t.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(C,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,T,S?.supportsMultipleAccounts??!1),new _.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const m=this._providers.findIndex(s=>s.id===C);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,T){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,T){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,T){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,T){return this._onDidChangeSessions.fire({provider:{id:C,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[182],Ee([0,1,5,13,8]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,C){this._extHostDocumentsAndEditors=C,this._proxy=P.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const C=_.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const F=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(P){return F.$writeText(P)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,14,15,55,44,111,2,6,4,13,49,22,38,45]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{constructor(v,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadCommands),this._logService=l,this.converter=new D(this,c=>{const b=this._apiCommands.get(c);return b?.result===g.Void?b:void 0},l),this._argumentProcessors=[{processArgument(c){return(0,T.revive)(c)}},{processArgument(c){return(0,A.cloneAndChange)(c,function(b){if(t.Range.isIRange(b))return _.Range.to(b);if(S.Position.isIPosition(b))return _.Position.to(b);if(t.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return _.location.to(b);if(b instanceof k.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const l=this.registerCommand(!1,v.id,async(...c)=>{const b=v.args.map((y,R)=>{if(!y.validate(c[R]))throw new Error(`Invalid argument '${y.name}' when running '${v.id}', received: ${c[R]}`);return y.convert(c[R])}),f=await this.executeCommand(v.internalId,...b);return v.result.convert(f,c,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new M.Disposable(()=>{l.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,l,c,b,f,y){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:c,thisArg:b,description:f,extension:y}),v&&this._proxy.$registerCommand(l),new M.Disposable(()=>{this._commands.delete(l)&&v&&this._proxy.$unregisterCommand(l)})}executeCommand(v,...l){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,l,!0)}async _doExecuteCommand(v,l,c){if(this._commands.has(v))return this._executeContributedCommand(v,l,!1);{let b=!1;const f=(0,A.cloneAndChange)(l,function(y){if(y instanceof M.Position)return _.Position.from(y);if(y instanceof M.Range)return _.Range.from(y);if(y instanceof M.Location)return _.location.from(y);if(M.NotebookRange.isNotebookRange(y))return _.NotebookRange.from(y);if(y instanceof ArrayBuffer)return b=!0,k.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return b=!0,k.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await this._proxy.$executeCommand(v,b?new w.SerializableObjectWithBuffers(f):f,c);return(0,T.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(v,l,!1);throw y}}}async _executeContributedCommand(v,l,c){const b=this._commands.get(v);if(!b)throw new Error("Unknown command");let{callback:f,thisArg:y,description:R}=b;if(R)for(let I=0;I<R.args.length;I++)try{(0,d.validateConstraint)(l[I],R.args[I].constraint)}catch(L){throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${R.args[I].name}' - ${R.args[I].description}`)}try{return await f.apply(y,l)}catch(I){if(v===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...l);L&&(v=L.command)}throw this._logService.error(I,v,b.extension?.identifier),c?new class extends Error{constructor(){super((0,o.toErrorMessage)(I));this.id=v,this.source=b.extension?.displayName??b.extension?.name}}:I}}$executeContributedCommand(v,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",v),this._commands.has(v)?(l=l.map(c=>this._argumentProcessors.reduce((b,f)=>f.processArgument(b),c)),this._executeContributedCommand(v,l,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this._proxy.$getCommands().then(l=>(v&&(l=l.filter(c=>c[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(let[l,c]of this._commands){let{description:b}=c;b&&(v[l]=b)}return Promise.resolve(v)}};h=$e([ze(0,u.IExtHostRpcService),ze(1,C.ILogService)],h),e.ExtHostCommands=h,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class D{constructor(v,l,c){this._commands=v,this._lookupApiCommand=l,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,l){if(!v)return;const c={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return c;const b=this._lookupApiCommand(v.command);if(b)c.id=b.internalId,c.arguments=b.args.map((f,y)=>f.convert(v.arguments&&v.arguments[y]));else if((0,P.isNonEmptyArray)(v.arguments)){const f=++this._cachIdPool;this._cache.set(f,v),l.add((0,m.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),c.$ident=f,c.id=this.delegatingCommandId,c.arguments=[f],this._logService.trace("CommandsConverter#CREATE",v.command,f)}return c}fromInternal(v){const l=F.ObjectIdentifier.of(v);return typeof l=="number"?this._cache.get(l):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const l=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=D;class i{constructor(v,l,c,b){this.name=v,this.description=l,this.validate=c,this.convert=b}optional(){return new i(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,l){return new i(v??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),i.Position=new i("position","A position in a text document",r=>M.Position.isPosition(r),_.Position.from),i.Range=new i("range","A range in a text document",r=>M.Range.isRange(r),_.Range.from),i.Selection=new i("selection","A selection in a text document",r=>M.Selection.isSelection(r),_.Selection.from),i.Number=new i("number","",r=>typeof r=="number",r=>r),i.String=new i("string","",r=>typeof r=="string",r=>r),i.CallHierarchyItem=new i("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,_.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,_.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",r=>r instanceof p.TestItemImpl,_.TestItem.from);class g{constructor(v,l){this.description=v,this.convert=l}}e.ApiCommandResult=g,g.Void=new g("no result",r=>r);class a{constructor(v,l,c,b,f){this.id=v,this.internalId=l,this.description=c,this.args=b,this.result=f}}e.ApiCommand=a}),define(be[184],Ee([0,1,8,7,59,39,14,81]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,F.isFalsyOrEmpty)(n))return;class s extends M.SymbolInformation{static to(p){const k=new s(p.name,d.SymbolKind.to(p.kind),p.containerName||"",new M.Location(m[0],d.Range.to(p.range)));return k.detail=p.detail,k.range=k.location.range,k.selectionRange=d.Range.to(p.selectionRange),k.children=p.children?p.children.map(s.to):[],k}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>M.Position.isPosition(m)),n=>n.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let s;for(const u of m.reverse())s=new M.SelectionRange(d.Range.to(u),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const m=[];if(Array.isArray(n))for(let s of n)m.push(...s[1].map(d.WorkspaceSymbol.to));return m})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:d.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range.optional()],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,s)=>{if(!n)return new M.CompletionList([]);const u=n.suggestions.map(p=>d.CompletionItem.to(p,s));return new M.CompletionList(u,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,s)=>t(u=>new M.CodeLens(d.Range.to(u.range),u.command&&s.fromInternal(u.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,s)=>t(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(u.command)}else{const p=new M.CodeAction(u.title,u.kind?new M.CodeActionKind(u.kind):void 0);return u.edit&&(p.edit=d.WorkspaceEdit.to(u.edit)),u.command&&(p.command=s.fromInternal(u.command)),p.isPreferred=u.isPreferred,p}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new M.ColorInformation(d.Range.to(m.range),d.Color.to(m.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>d.NotebookExclusiveDocumentPattern.to(m))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(m){C.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=T;function t(n){return m=>{if(Array.isArray(m))return m.map(n)}}function S(n){if(!Array.isArray(n))return;const m=[];for(const s of n)_.isLocationLink(s)?m.push(d.DefinitionLink.to(s)):m.push(d.location.to(s));return m}}),define(be[185],Ee([0,1,12,53,3,6,2,59,26,8,7,5]),function(oe,e,d,M,_,A,F,P,C,T,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,s,u){const p=m.getProxy(S.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const v=this._commentControllers.get(r.handle);return v||r}else if(r&&r.$mid===7){const v=this._commentControllers.get(r.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.commentUniqueId,b=l.getCommentByUniqueId(c);return b||r}else if(r&&r.$mid===10){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.text,b=r.commentUniqueId,f=l.getCommentByUniqueId(b);return f?(f.body=c,f):r}return r}})}createCommentController(r,v,l){const c=k.handlePool++,b=new o(r,c,v,l);this._commentControllers.set(b.handle,b);const f=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(r.identifier))||[];return f.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(r.identifier),f),b.value}$createCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$createCommentThreadTemplate(v,l)}async $updateCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$updateCommentThreadTemplate(v,l)}$deleteCommentThread(r,v){const l=this._commentControllers.get(r);l&&l.$deleteCommentThread(v)}$provideCommentingRanges(r,v,l){const c=this._commentControllers.get(r);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const b=u.getDocument(F.URI.revive(v));return(0,d.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(b,l)).then(f=>f?f.map(y=>T.Range.from(y)):void 0)}$toggleReaction(r,v,l,c,b){const f=this._commentControllers.get(r);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const y=f.getCommentThread(v);if(y){const R=y.getCommentByUniqueId(c.uniqueIdInThread);if(f!==void 0&&R&&f.reactionHandler)return f.reactionHandler(R,i(b))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class w{constructor(r,v,l,c,b,f,y){this._commentControllerHandle=v,this._id=l,this._uri=c,this._range=b,this._comments=f,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),p.$createCommentThread(v,this.handle,this._id,this._uri,T.Range.from(this._range),y),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(v,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(I){R.range=I},get comments(){return R.comments},set comments(I){R.comments=I},get collapsibleState(){return R.collapsibleState},set collapsibleState(I){R.collapsibleState=I},get canReply(){return R.canReply},set canReply(I){R.canReply=I},get contextValue(){return R.contextValue},set contextValue(I){R.contextValue=I},get label(){return R.label},set label(I){R.label=I},dispose:()=>{R.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),v={};r("range")&&(v.range=T.Range.from(this._range)),r("label")&&(v.label=this.label),r("contextValue")&&(v.contextValue=this.contextValue),r("comments")&&(v.comments=this._comments.map(l=>h(this,l,this._commentsMap))),r("collapsibleState")&&(v.collapseState=g(this._collapseState)),r("canReply")&&(v.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(r){for(let v of this._commentsMap){let l=v[0],c=v[1];if(r===c)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}w._handlePool=0,$e([(0,M.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(r,v,l,c){this._extension=r,this._handle=v,this._id=l,this._label=c,this._threads=new Map,p.$registerCommentController(this.handle,l,c);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(f){b.options=f},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(f){b.commentingRangeProvider=f},get reactionHandler(){return b.reactionHandler},set reactionHandler(f){b.reactionHandler=f},createCommentThread(f,y,R){return b.createCommentThread(f,y,R).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,v,l,c){if(typeof r=="string"){const b=new w(this.id,this.handle,r,v,l,c,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new w(this.id,this.handle,void 0,r,v,l,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(r,v){const l=new w(this.id,this.handle,void 0,F.URI.revive(r),T.Range.to(v),[],this._extension.identifier);return l.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(r,v){let l=this._threads.get(r);l&&(l.range=T.Range.to(v))}$deleteCommentThread(r){let v=this._threads.get(r);v&&v.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function h(a,r,v){let l=v.get(r);l||(l=++a.commentHandle,v.set(r,l));const c=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:l,body:T.MarkdownString.from(r.body),userName:r.author.name,userIconPath:c,label:r.label,commentReactions:r.reactions?r.reactions.map(b=>D(b)):void 0}}function D(a){return{label:a.label,iconPath:a.iconPath?T.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?F.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function g(a){if(a!==void 0)switch(a){case t.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new k}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,13,15,14,9,17]),function(oe,e,d,M,_,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class vi{constructor(m,s){this._logService=s,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,s){const u=vi._handlePool++;this._provider.set(u,{provider:m,extensionId:s}),this._proxy.$registerDecorationProvider(u,s.value);const p=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(u,null);return}let w=(0,C.asArray)(k);if(w.length<=vi._maxEventSize){this._proxy.$onDidChange(u,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,w.length);const o=w.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),h=(0,C.groupBy)(o,(i,g)=>i.rank-g.rank||(0,T.compare)(i.uri.path,g.uri.path));let D=[];e:for(let i of h){let g;for(let a of i){let r=(0,t.dirname)(a.uri.path);if(g!==r&&(g=r,D.push(a.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(u,D)});return new _.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(m,s,u){if(!this._provider.has(m))return Object.create(null);const p=Object.create(null),{provider:k,extensionId:w}=this._provider.get(m);return await Promise.all(s.map(async o=>{try{const{uri:h,id:D}=o,i=await Promise.resolve(k.provideFileDecoration(d.URI.revive(h),u));if(!i)return;try{_.FileDecoration.validate(i),p[D]=[i.propagate,i.tooltip,i.badge,i.color]}catch(g){this._logService.warn(`INVALID decoration from extension '${w.value}': ${g}`)}}catch(h){this._logService.error(h)}})),p}};S._handlePool=0,S._maxEventSize=250,S=$e([ze(0,F.IExtHostRpcService),ze(1,P.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[186],Ee([0,1,123,83,2,5,7,8,3,15,20,37]),function(oe,e,d,M,_,A,F,P,C,T,t,S){"use strict";var n,m,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(w,o,h,D,i,g){this._name=w,this._owner=o,this._maxDiagnosticsPerFile=h,n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Ze(this,s,new t.ResourceMap(a=>D.getComparisonKey(a)),"f"),Ze(this,n,i,"f"),Ze(this,m,g,"f")}dispose(){this._isDisposed||(Re(this,m,"f").fire([...Re(this,s,"f").keys()]),Re(this,n,"f")&&Re(this,n,"f").$clear(this._owner),Re(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,o){if(!w){this.clear();return}this._checkDisposed();let h=[];if(_.URI.isUri(w)){if(!o){this.delete(w);return}Re(this,s,"f").set(w,o.slice()),h=[w]}else if(Array.isArray(w)){h=[];let i;w=[...w].sort(u._compareIndexedTuplesByUri);for(const g of w){const[a,r]=g;if((!i||a.toString()!==i.toString())&&(i&&Re(this,s,"f").get(i).length===0&&Re(this,s,"f").delete(i),i=a,h.push(a),Re(this,s,"f").set(a,[])),r){const v=Re(this,s,"f").get(a);v&&v.push(...r)}else{const v=Re(this,s,"f").get(a);v&&(v.length=0)}}}if(Re(this,m,"f").fire(h),!Re(this,n,"f"))return;const D=[];for(let i of h){let g=[];const a=Re(this,s,"f").get(i);if(a)if(a.length>this._maxDiagnosticsPerFile){g=[];const r=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(let l of a)if(l.severity===r[v]&&g.push(P.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;g.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=a.map(r=>P.Diagnostic.from(r));D.push([i,g])}Re(this,n,"f").$changeMany(this._owner,D)}delete(w){this._checkDisposed(),Re(this,m,"f").fire([w]),Re(this,s,"f").delete(w),Re(this,n,"f")&&Re(this,n,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Re(this,m,"f").fire([...Re(this,s,"f").keys()]),Re(this,s,"f").clear(),Re(this,n,"f")&&Re(this,n,"f").$clear(this._owner)}forEach(w,o){this._checkDisposed();for(let h of Re(this,s,"f").keys())w.apply(o,[h,this.get(h),this])}get(w){this._checkDisposed();const o=Re(this,s,"f").get(w);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Re(this,s,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,o){return w[0].toString()<o[0].toString()?-1:w[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=u,n=new WeakMap,m=new WeakMap,s=new WeakMap;let p=class ti{constructor(w,o,h){this._logService=o,this._fileSystemInfoService=h,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=w.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(w){const o=new t.ResourceMap;for(const h of w)o.set(h,h);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(w,o){const{_collections:h,_proxy:D,_onDidChangeDiagnostics:i,_logService:g,_fileSystemInfoService:a}=this,r=new class{$changeMany(c,b){D.$changeMany(c,b),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,c,b.length===0?"CLEARING":b)}$clear(c){D.$clear(c),g.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,c)}dispose(){D.dispose()}};let v;if(!o)o="_generated_diagnostic_collection_name_#"+ti._idPool++,v=o;else if(!h.has(o))v=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do v=o+ti._idPool++;while(h.has(v))}return new class extends u{constructor(){super(o,v,ti._maxDiagnosticsPerFile,a.extUri,r,i);h.set(v,this)}dispose(){super.dispose(),h.delete(v)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const o=new Map,h=[];for(const D of this._collections.values())D.forEach((i,g)=>{let a=o.get(i.toString());typeof a=="undefined"&&(a=h.length,o.set(i.toString(),a),h.push([i,[]])),h[a][1]=h[a][1].concat(...g)});return h}}_getDiagnostics(w){let o=[];for(let h of this._collections.values())h.has(w)&&(o=o.concat(h.get(w)));return o}$acceptMarkersChange(w){if(!this._mirrorCollection){const o="_generated_mirror",h=new u(o,o,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,h),this._mirrorCollection=h}for(const[o,h]of w)this._mirrorCollection.set(_.URI.revive(o),h.map(P.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=$e([ze(1,T.ILogService),ze(2,S.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(be[187],Ee([0,1,2,5]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(P=>P?P.map(C=>d.URI.revive(C)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(P=>P?d.URI.revive(P):void 0)}}e.ExtHostDialogs=_}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(S,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,n){if(Object.keys(F.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const m=T._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,S);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(u=>{if(u.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(m,u).then(p=>{if(!p&&typeof p!="string")return;const k=this._documentsAndEditors.getDocument(u);if(!k)return;const w=(0,C.splitLines)(p);if(!k.equalLines(w))return this._proxy.$onVirtualDocumentChange(u,p)},d.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(S,n){const m=this._documentContentProviders.get(S);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(n),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(oe,e,d,M,_,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(m,s){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const p of u)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const p of u)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const s=this._documentsAndEditors.getDocument(m);if(s)return s}getDocument(m){const s=this.getDocumentData(m);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return s.document}ensureDocumentData(m){const s=this._documentsAndEditors.getDocument(m);if(s)return Promise.resolve(s);let u=this._documentLoader.get(m.toString());return u||(u=this._proxy.$tryOpenDocument(m).then(p=>{this._documentLoader.delete(m.toString());const k=_.URI.revive(p);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(k))},p=>(this._documentLoader.delete(m.toString()),Promise.reject(p))),this._documentLoader.set(m.toString(),u)),u}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(s=>_.URI.revive(s))}$acceptModelModeChanged(m,s){const u=_.URI.revive(m),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(s),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(m){const s=_.URI.revive(m),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(m,s){const u=_.URI.revive(m),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");p._acceptIsDirty(s),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,s,u){const p=_.URI.revive(m),k=this._documentsAndEditors.getDocument(p);if(!k)throw new Error("unknown document");k._acceptIsDirty(u),k.onEvents(s);let w;s.isUndoing?w=t.TextDocumentChangeReason.Undo:s.isRedoing&&(w=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:k.document,contentChanges:s.changes.map(o=>({range:P.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:w}))}setWordDefinitionFor(m,s){(0,F.setWordDefinitionFor)(m,s)}}e.ExtHostDocuments=S}),define(be[50],Ee([0,1,42,3,6,2,4,5,88,13,94,8,15,20,11,164,103]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(h,D){this._extHostRpc=h,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const D=[],i=[],g=[];if(h.removedDocuments)for(const a of h.removedDocuments){const r=A.URI.revive(a),v=this._documents.get(r);v?.unref()&&(this._documents.delete(r),D.push(v.value))}if(h.addedDocuments)for(const a of h.addedDocuments){const r=A.URI.revive(a.uri);let v=this._documents.get(r);if(v&&r.scheme!==s.Schemas.vscodeNotebookCell&&r.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);v||(v=new k(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(r,v),i.push(v.value)),v.ref()}if(h.removedEditors)for(const a of h.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&g.push(r)}if(h.addedEditors)for(const a of h.addedEditors){const r=A.URI.revive(a.documentUri);d.ok(this._documents.has(r),`document '${r}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const v=this._documents.get(r).value,l=new t.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>v.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(c=>S.Range.to(c)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,l)}h.newActiveEditor!==void 0&&(d.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,_.dispose)(D),(0,_.dispose)(g),h.removedDocuments&&this._onDidRemoveDocuments.fire(D),h.addedDocuments&&this._onDidAddDocuments.fire(i),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return h?D:D?.value}allEditors(){return[...this._editors.values()]}};w=$e([ze(0,T.IExtHostRpcService),ze(1,n.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[71],Ee([0,1,8,5,2,3,4,13,12]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let T=class{constructor(S){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=S.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(S){let n=-1;this._tabs=S.map((s,u)=>(s.isActive&&(n=u),Object.freeze({label:s.label,viewColumn:d.ViewColumn.to(s.viewColumn),index:u,resource:_.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:p,viewId:k})=>({resource:_.URI.revive(p),viewId:k})),viewId:s.editorId,isActive:s.isActive,move:async(p,k)=>{this._proxy.$moveTab(s,p,d.ViewColumn.from(k)),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,u)=>s.viewColumn===u.viewColumn?s.index-u.index:s.viewColumn-u.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=$e([ze(0,P.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(be[190],Ee([0,1,2,5,6,7,8,232,9,22]),function(oe,e,d,M,_,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const s=this._schemes.indexOf(m);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),s=[];let u,p,k=14,w=14;for(const o of m){let h=u?(0,C.commonPrefixLength)(u,o):0;for(h===0?p=1:p=w;h<o.length;h++)h+1===o.length?(k=w,w=9):w+=1,s.push([p,o.toUpperCase().charCodeAt(h),w]),s.push([p,o.toLowerCase().charCodeAt(h),w]),p=w;u=o,w=k}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new P.StateMachine(s)}}provideDocumentLinks(m){this._initStateMachine();const s=[],u=P.LinkComputer.computeLinks({getLineContent(p){return m.lineAt(p-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const p of u){const k=F.DocumentLink.to(p);k.target&&s.push(k)}return s}}class S{constructor(m,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,s,u,p={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const k=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(k,u);let w=2;p.isCaseSensitive&&(w+=1024),p.isReadonly&&(w+=2048),typeof u.copy=="function"&&(w+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(k,s,w).catch(h=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${s}`),console.error(h)});const o=u.onDidChangeFile(h=>{const D=[];for(const i of h){let{uri:g,type:a}=i;if(g.scheme!==s)continue;let r;switch(a){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}D.push({resource:g,type:r})}this._proxy.$onFileSystemChange(k,D)});return(0,_.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(m){const{type:s,ctime:u,mtime:p,size:k,permissions:w}=m;return{type:s,ctime:u,mtime:p,size:k,permissions:w}}$stat(m,s){return Promise.resolve(this._getFsProvider(m).stat(d.URI.revive(s))).then(u=>S._asIStat(u))}$readdir(m,s){return Promise.resolve(this._getFsProvider(m).readDirectory(d.URI.revive(s)))}$readFile(m,s){return Promise.resolve(this._getFsProvider(m).readFile(d.URI.revive(s))).then(u=>T.VSBuffer.wrap(u))}$writeFile(m,s,u,p){return Promise.resolve(this._getFsProvider(m).writeFile(d.URI.revive(s),u.buffer,p))}$delete(m,s,u){return Promise.resolve(this._getFsProvider(m).delete(d.URI.revive(s),u))}$rename(m,s,u,p){return Promise.resolve(this._getFsProvider(m).rename(d.URI.revive(s),d.URI.revive(u),p))}$copy(m,s,u,p){const k=this._getFsProvider(m);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(d.URI.revive(s),d.URI.revive(u),p))}$mkdir(m,s){return Promise.resolve(this._getFsProvider(m).createDirectory(d.URI.revive(s)))}$watch(m,s,u,p){const k=this._getFsProvider(m).watch(d.URI.revive(u),p);this._watches.set(s,k)}$unwatch(m,s){const u=this._watches.get(s);u&&(u.dispose(),this._watches.delete(s))}$open(m,s,u){const p=this._getFsProvider(m);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(d.URI.revive(s),u))}$close(m,s){const u=this._getFsProvider(m);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(s))}$read(m,s,u,p){const k=this._getFsProvider(m);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const w=T.VSBuffer.alloc(p);return Promise.resolve(k.read(s,u,w.buffer,0,p)).then(o=>w.slice(0,o))}$write(m,s,u,p){const k=this._getFsProvider(m);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(s,u,p.buffer,0,p.byteLength))}_getFsProvider(m){const s=this._fsProvider.get(m);if(!s){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return s}}e.ExtHostFileSystem=S}),define(be[72],Ee([0,1,5,60,7,22,4,13,37]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Ut{constructor(S,n){const m=S.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return m.$stat(s).catch(Ut._handleError)},readDirectory(s){return m.$readdir(s).catch(Ut._handleError)},createDirectory(s){return m.$mkdir(s).catch(Ut._handleError)},async readFile(s){return m.$readFile(s).then(u=>u.buffer).catch(Ut._handleError)},writeFile(s,u){return m.$writeFile(s,A.VSBuffer.wrap(u)).catch(Ut._handleError)},delete(s,u){return m.$delete(s,{recursive:!1,useTrash:!1,...u}).catch(Ut._handleError)},rename(s,u,p){return m.$rename(s,u,{overwrite:!1,...p}).catch(Ut._handleError)},copy(s,u,p){return m.$copy(s,u,{overwrite:!1,...p}).catch(Ut._handleError)},isWritableFileSystem(s){const u=n.getCapabilities(s);if(typeof u=="number")return!(u&2048)}})}static _handleError(S){if(!(S instanceof Error))throw new _.FileSystemError(String(S));if(S.name==="ENOPRO")throw _.FileSystemError.Unavailable(S.message);switch(S.name){case M.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(S.message);case M.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(S.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(S.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(S.message);case M.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(S.message);case M.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(S.message);default:throw new _.FileSystemError(S.message,S.name)}}};T=$e([ze(0,P.IExtHostRpcService),ze(1,C.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(F,P,C,T){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=T;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new M.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new M.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new M.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new M.ApiCommandResult("Notebook and input URI",S=>{if(S.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(S.notebookEditorId);return{notebookUri:d.URI.revive(S.notebookUri),inputUri:d.URI.revive(S.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(S.notebookUri),inputUri:d.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,P,C,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=_}),define(be[192],Ee([0,1,6,5]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,F),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=_}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,14,10,233,6,81,54,64,194,16,3]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentSymbols($,Q){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentSymbols(ee,Q);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(_.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree($){$=$.slice(0).sort((ae,K)=>{let se=ae.location.range.start.compareTo(K.location.range.start);return se===0&&(se=K.location.range.end.compareTo(ae.location.range.end)),se});const Q=[],ee=[];for(const ae of $){const K={name:ae.name||"!!MISSING: name!!",kind:_.SymbolKind.from(ae.kind),tags:ae.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:_.Range.from(ae.location.range),selectionRange:_.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(K),Q.push(K);break}const se=ee[ee.length-1];if(C.Range.containsRange(se.range,K.range)&&!C.Range.equalsRange(se.range,K.range)){se.children&&se.children.push(K),ee.push(K);break}ee.pop()}}return Q}}class h{constructor($,Q,ee){this._documents=$,this._commands=Q,this._provider=ee,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,Q){const ee=this._documents.getDocument($),ae=await this._provider.provideCodeLenses(ee,Q);if(!ae||Q.isCancellationRequested)return;const K=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(K,se);const he={cacheId:K,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)he.lenses.push({cacheId:[K,Ae],range:_.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,se)});return he}async resolveCodeLens($,Q){const ee=$.cacheId&&this._cache.get(...$.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,Q),ae||(ae=ee),Q.isCancellationRequested)return;const K=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!K)return $.command=this._commands.toInternal(ae.command??h._badCmd,K),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function D(Ve){return Array.isArray(Ve)?Ve.map(_.DefinitionLink.from):Ve?[_.DefinitionLink.from(Ve)]:[]}class i{constructor($,Q){this._documents=$,this._provider=Q}async provideDefinition($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideDefinition(ae,K,ee);return D(se)}}class g{constructor($,Q){this._documents=$,this._provider=Q}async provideDeclaration($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideDeclaration(ae,K,ee);return D(se)}}class a{constructor($,Q){this._documents=$,this._provider=Q}async provideImplementation($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideImplementation(ae,K,ee);return D(se)}}class r{constructor($,Q){this._documents=$,this._provider=Q}async provideTypeDefinition($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideTypeDefinition(ae,K,ee);return D(se)}}class v{constructor($,Q){this._documents=$,this._provider=Q}async provideHover($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideHover(ae,K,ee);if(!(!se||(0,T.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(K)),se.range||(se.range=new A.Range(K,K)),_.Hover.from(se)}}class l{constructor($,Q){this._documents=$,this._provider=Q}async provideEvaluatableExpression($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideEvaluatableExpression(ae,K,ee);if(se)return _.EvaluatableExpression.from(se)}}class c{constructor($,Q){this._documents=$,this._provider=Q}async provideInlineValues($,Q,ee,ae){const K=this._documents.getDocument($),se=await this._provider.provideInlineValues(K,_.Range.to(Q),_.InlineValueContext.to(ee),ae);if(Array.isArray(se))return se.map(he=>_.InlineValue.from(he))}}class b{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentHighlights($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideDocumentHighlights(ae,K,ee);if(Array.isArray(se))return se.map(_.DocumentHighlight.from)}}class f{constructor($,Q){this._documents=$,this._provider=Q}async provideLinkedEditingRanges($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.provideLinkedEditingRanges(ae,K,ee);if(se&&Array.isArray(se.ranges))return{ranges:(0,T.coalesce)(se.ranges.map(_.Range.from)),wordPattern:se.wordPattern}}}class y{constructor($,Q){this._documents=$,this._provider=Q}async provideReferences($,Q,ee,ae){const K=this._documents.getDocument($),se=_.Position.to(Q),he=await this._provider.provideReferences(K,se,ee,ae);if(Array.isArray(he))return he.map(_.location.from)}}class R{constructor($,Q,ee,ae,K,se,he){this._documents=$,this._commands=Q,this._diagnostics=ee,this._provider=ae,this._logService=K,this._extension=se,this._apiDeprecation=he,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,Q,ee,ae){const K=this._documents.getDocument($),se=S.Selection.isISelection(Q)?_.Selection.to(Q):_.Range.to(Q),he=[];for(const st of this._diagnostics.getDiagnostics($))if(se.intersection(st.range)&&he.push(st)>R._maxCodeActionsPerFile)break;const Ae={diagnostics:he,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:_.CodeActionTriggerKind.to(ee.trigger)},Ue=await this._provider.provideCodeActions(K,se,Ae,ae);if(!(0,T.isNonEmptyArray)(Ue)||ae.isCancellationRequested)return;const He=this._cache.add(Ue),Qe=new n.DisposableStore;this._disposables.set(He,Qe);const et=[];for(let st=0;st<Ue.length;st++){const ye=Ue[st];!ye||(R._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Qe)})):(Ae.only&&(ye.kind?Ae.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,st],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Qe),diagnostics:ye.diagnostics&&ye.diagnostics.map(_.Diagnostic.from),edit:ye.edit&&_.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction($,Q){const[ee,ae]=$,K=this._cache.get(ee,ae);if(!K||R._isCommand(K)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(K,Q)??K;return se?.edit?_.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}R._maxCodeActionsPerFile=1e3;class I{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentFormattingEdits($,Q,ee){const ae=this._documents.getDocument($),K=await this._provider.provideDocumentFormattingEdits(ae,Q,ee);if(Array.isArray(K))return K.map(_.TextEdit.from)}}class L{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentRangeFormattingEdits($,Q,ee,ae){const K=this._documents.getDocument($),se=_.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(K,se,ee,ae);if(Array.isArray(he))return he.map(_.TextEdit.from)}}class E{constructor($,Q){this._documents=$,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,Q,ee,ae,K){const se=this._documents.getDocument($),he=_.Position.to(Q),Ae=await this._provider.provideOnTypeFormattingEdits(se,he,ee,ae,K);if(Array.isArray(Ae))return Ae.map(_.TextEdit.from)}}class N{constructor($,Q){this._provider=$,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,Q){const ee=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols($,Q);if((0,T.isNonEmptyArray)(ae))for(const K of ae){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const se=F.IdObject.mixin(_.WorkspaceSymbol.from(K));this._symbolCache.set(se._id,K),ee.symbols.push(se)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol($,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const ee=this._symbolCache.get($._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,Q);return ae&&(0,M.mixin)($,_.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols($){const Q=this._resultCache.get($);if(Q){for(let[ee,ae]=Q;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete($)}}}class U{constructor($,Q,ee){this._documents=$,this._provider=Q,this._logService=ee}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,Q,ee,ae){const K=this._documents.getDocument($),se=_.Position.to(Q);try{const he=await this._provider.provideRenameEdits(K,se,ee,ae);return he?_.WorkspaceEdit.from(he):void 0}catch(he){const Ae=U._asMessage(he);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation($,Q,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument($),K=_.Position.to(Q);try{const se=await this._provider.prepareRename(ae,K,ee);let he,Ae;if(A.Range.isRange(se)?(he=se,Ae=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Ae=se.placeholder),!he||!Ae)return;if(he.start.line>K.line||he.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(he),text:Ae}}catch(se){const he=U._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class B{constructor($,Q){this.resultId=$,this.tokens=Q}}class G{constructor($,Q){this._documents=$,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,Q,ee){const ae=this._documents.getDocument($),K=Q!==0?this._previousResults.get(Q):null;let se=typeof K?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,K.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return K&&this._previousResults.delete(Q),se?(se=G._fixProvidedSemanticTokens(se),this._send(G._convertToEdits(K,se),se)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return G._isSemanticTokens($)?G._isCorrectSemanticTokens($)?$:new A.SemanticTokens(new Uint32Array($.data),$.resultId):G._isSemanticTokensEdits($)?G._isCorrectSemanticTokensEdits($)?$:new A.SemanticTokensEdits($.edits.map(Q=>new A.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const Q of $.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,Q){if(!G._isSemanticTokens(Q)||!$||!$.tokens)return Q;const ee=$.tokens,ae=ee.length,K=Q.data,se=K.length;let he=0;const Ae=Math.min(ae,se);for(;he<Ae&&ee[he]===K[he];)he++;if(he===ae&&he===se)return new A.SemanticTokensEdits([],Q.resultId);let Ue=0;const He=Ae-he;for(;Ue<He&&ee[ae-Ue-1]===K[se-Ue-1];)Ue++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Ue,data:K.subarray(he,se-Ue)}],Q.resultId)}_send($,Q){if(G._isSemanticTokens($)){const ee=this._nextResultId++;return this._previousResults.set(ee,new B($.resultId,$.data)),(0,m.encodeSemanticTokensDto)({id:ee,type:"full",data:$.data})}if(G._isSemanticTokensEdits($)){const ee=this._nextResultId++;return G._isSemanticTokens(Q)?this._previousResults.set(ee,new B(Q.resultId,Q.data)):this._previousResults.set(ee,new B($.resultId)),(0,m.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:($.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=G;class H{constructor($,Q){this._documents=$,this._provider=Q}async provideDocumentRangeSemanticTokens($,Q,ee){const ae=this._documents.getDocument($),K=await this._provider.provideDocumentRangeSemanticTokens(ae,_.Range.to(Q),ee);return K?this._send(K):null}_send($){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class W{constructor($,Q,ee,ae,K){this._documents=$,this._commands=Q,this._provider=ee,this._apiDeprecation=ae,this._extension=K,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,Q,ee,ae){const K=this._documents.getDocument($),se=_.Position.to(Q),he=K.getWordRangeAtPosition(se)||new A.Range(se,se),Ae=he.with({end:se}),Ue=new p.StopWatch(!0),He=await this._provider.provideCompletionItems(K,se,ae,_.CompletionContext.to(ee));if(!He||ae.isCancellationRequested)return;const Qe=Array.isArray(He)?new A.CompletionList(He):He,et=W.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const ye=[],nt={x:et,b:ye,a:{replace:_.Range.from(he),insert:_.Range.from(Ae)},c:Qe.isIncomplete||void 0,d:Ue.elapsed()};for(let q=0;q<Qe.items.length;q++){const Z=Qe.items[q],pe=this._convertCompletionItem(Z,[et,q],Ae,he);ye.push(pe)}return nt}async resolveCompletionItem($,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...$);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,Q);if(!!ae)return this._convertCompletionItem(ae,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,Q,ee,ae){const K=this._disposables.get(Q[0]);if(!K)throw Error("DisposableStore is missing...");const se={x:Q,a:$.label,b:$.kind!==void 0?_.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(_.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:_.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal($.command,K)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=$.textEdit.newText):typeof $.insertText=="string"?se.h=$.insertText:$.insertText instanceof A.SnippetString&&(se.h=$.insertText.value,se.i|=4);let he;return $.textEdit?he=$.textEdit.range:$.range&&(he=$.range),A.Range.isRange(he)?se.j=_.Range.from(he):he&&(!ee?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:_.Range.from(he.inserting),replace:_.Range.from(he.replacing)}),se}}class ne{constructor($,Q,ee){this._documents=$,this._provider=Q,this._commands=ee,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,Q,ee,ae){const K=this._documents.getDocument($),se=_.Position.to(Q),he=await this._provider.provideInlineCompletionItems(K,se,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:_.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(he)?{items:he}:he,Ue=this._cache.add(Ae.items);let He;return{pid:Ue,items:Ae.items.map((Qe,et)=>{let st;return Qe.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ue,He)),st=this._commands.toInternal(Qe.command,He)),{text:Qe.text,range:Qe.range?_.Range.from(Qe.range):void 0,command:st,idx:et}})}}disposeCompletions($){this._cache.delete($);const Q=this._disposables.get($);Q&&Q.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,Q){const ee=this._cache.get($,Q);ee&&V.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class V{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let Q=V.map.get($);return Q||(Q=new V,V.map.set($,Q)),Q}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=V,V.map=new WeakMap;class Y{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp($,Q,ee,ae){const K=this._documents.getDocument($),se=_.Position.to(Q),he=this.reviveContext(ee),Ae=await this._provider.provideSignatureHelp(K,se,ae,he);if(Ae){const Ue=this._cache.add([Ae]);return{..._.SignatureHelp.from(Ae),id:Ue}}}reviveContext($){let Q;if($.activeSignatureHelp){const ee=_.SignatureHelp.to($.activeSignatureHelp),ae=this._cache.get($.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...$,activeSignatureHelp:Q}}releaseSignatureHelp($){this._cache.delete($)}}class j{constructor($,Q){this._documents=$,this._provider=Q}async provideInlayHints($,Q,ee){const ae=this._documents.getDocument($),K=await this._provider.provideInlayHints(ae,_.Range.to(Q),ee);return K?{hints:K.map(_.InlayHint.from)}:void 0}}class le{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new u.Cache("DocumentLink")}async provideLinks($,Q){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentLinks(ee,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(_.DocumentLink.from)};{const K=this._cache.add(ae),se={links:[],id:K};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Ae=_.DocumentLink.from(ae[he]);Ae.cacheId=[K,he],se.links.push(Ae)}return se}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...$);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,Q);if(!(!ae||!le._validateLink(ae)))return _.DocumentLink.from(ae)}releaseLinks($){this._cache.delete($)}}class re{constructor($,Q){this._documents=$,this._provider=Q}async provideColors($,Q){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentColors(ee,Q);return Array.isArray(ae)?ae.map(se=>({color:_.Color.from(se.color),range:_.Range.from(se.range)})):[]}async provideColorPresentations($,Q,ee){const ae=this._documents.getDocument($),K=_.Range.to(Q.range),se=_.Color.to(Q.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:K},ee);if(!!Array.isArray(he))return he.map(_.ColorPresentation.from)}}class ve{constructor($,Q){this._documents=$,this._provider=Q}async provideFoldingRanges($,Q,ee){const ae=this._documents.getDocument($),K=await this._provider.provideFoldingRanges(ae,Q,ee);if(!!Array.isArray(K))return K.map(_.FoldingRange.from)}}class Fe{constructor($,Q,ee){this._documents=$,this._provider=Q,this._logService=ee}async provideSelectionRanges($,Q,ee){const ae=this._documents.getDocument($),K=Q.map(_.Position.to),se=await this._provider.provideSelectionRanges(ae,K,ee);if(!(0,T.isNonEmptyArray)(se))return[];if(se.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ae=0;Ae<K.length;Ae++){const Ue=[];he.push(Ue);let He=K[Ae],Qe=se[Ae];for(;;){if(!Qe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(_.SelectionRange.from(Qe)),!Qe.parent)break;He=Qe.range,Qe=Qe.parent}}return he}}class Me{constructor($,Q){this._documents=$,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.prepareCallHierarchy(ae,K,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo($,Q,ee){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!K)return K.map(se=>({from:this._cacheAndConvertItem($,se.from),fromRanges:se.fromRanges.map(he=>_.Range.from(he))}))}async provideCallsFrom($,Q,ee){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!K)return K.map(se=>({to:this._cacheAndConvertItem($,se.to),fromRanges:se.fromRanges.map(he=>_.Range.from(he))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,Q){const ee=this._cache.get($),ae=_.CallHierarchyItem.from(Q,$,ee.size.toString(36));return ee.set(ae._itemId,Q),ae}_itemFromCache($,Q){return this._cache.get($)?.get(Q)}}class Oe{constructor($,Q){this._documents=$,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,Q,ee){const ae=this._documents.getDocument($),K=_.Position.to(Q),se=await this._provider.prepareTypeHierarchy(ae,K,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes($,Q,ee){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!K)return K.map(se=>this._cacheAndConvertItem($,se))}async provideSubtypes($,Q,ee){const ae=this._itemFromCache($,Q);if(!ae)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!K)return K.map(se=>this._cacheAndConvertItem($,se))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,Q){const ee=this._cache.get($),ae=_.TypeHierarchyItem.from(Q,$,ee.size.toString(36));return ee.set(ae._itemId,Q),ae}_itemFromCache($,Q){return this._cache.get($)?.get(Q)}}class Ke{constructor($,Q){this.adapter=$,this.extension=Q}}class je{constructor($,Q,ee,ae,K,se,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=$.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=K,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector($){return _.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new A.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return je._handlePool++}_withAdapter($,Q,ee,ae,K=!1){const se=this._adapter.get($);if(!se)return Promise.resolve(ae);if(se.adapter instanceof Q){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Ae=ee(se.adapter,se.extension),Ue=se.extension;return Ue&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),He=>{K&&He instanceof k.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(He))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,Q){const ee=this._nextHandle();return this._adapter.set(ee,new Ke($,Q)),ee}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,Q,ee,ae){const K=this._addNewAdapter(new o(this._documents,ee),$),se=ae&&ae.label||je._extLabel($);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(Q),se),this._createDisposable(K)}$provideDocumentSymbols($,Q,ee){return this._withAdapter($,o,ae=>ae.provideDocumentSymbols(d.URI.revive(Q),ee),void 0)}registerCodeLensProvider($,Q,ee){const ae=this._nextHandle(),K=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new h(this._documents,this._commands.converter,ee),$)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),K);let se=this._createDisposable(ae);if(K!==void 0){const he=ee.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(K));se=A.Disposable.from(se,he)}return se}$provideCodeLenses($,Q,ee){return this._withAdapter($,h,ae=>ae.provideCodeLenses(d.URI.revive(Q),ee),void 0)}$resolveCodeLens($,Q,ee){return this._withAdapter($,h,ae=>ae.resolveCodeLens(Q,ee),void 0)}$releaseCodeLenses($,Q){this._withAdapter($,h,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider($,Q,ee){const ae=this._addNewAdapter(new i(this._documents,ee),$);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition($,Q,ee,ae){return this._withAdapter($,i,K=>K.provideDefinition(d.URI.revive(Q),ee,ae),[])}registerDeclarationProvider($,Q,ee){const ae=this._addNewAdapter(new g(this._documents,ee),$);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration($,Q,ee,ae){return this._withAdapter($,g,K=>K.provideDeclaration(d.URI.revive(Q),ee,ae),[])}registerImplementationProvider($,Q,ee){const ae=this._addNewAdapter(new a(this._documents,ee),$);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation($,Q,ee,ae){return this._withAdapter($,a,K=>K.provideImplementation(d.URI.revive(Q),ee,ae),[])}registerTypeDefinitionProvider($,Q,ee){const ae=this._addNewAdapter(new r(this._documents,ee),$);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition($,Q,ee,ae){return this._withAdapter($,r,K=>K.provideTypeDefinition(d.URI.revive(Q),ee,ae),[])}registerHoverProvider($,Q,ee,ae){const K=this._addNewAdapter(new v(this._documents,ee),$);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideHover($,Q,ee,ae){return this._withAdapter($,v,K=>K.provideHover(d.URI.revive(Q),ee,ae),void 0)}registerEvaluatableExpressionProvider($,Q,ee,ae){const K=this._addNewAdapter(new l(this._documents,ee),$);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideEvaluatableExpression($,Q,ee,ae){return this._withAdapter($,l,K=>K.provideEvaluatableExpression(d.URI.revive(Q),ee,ae),void 0)}registerInlineValuesProvider($,Q,ee,ae){const K=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new c(this._documents,ee),$);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),K);let he=this._createDisposable(se);if(K!==void 0){const Ae=ee.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(K));he=A.Disposable.from(he,Ae)}return he}$provideInlineValues($,Q,ee,ae,K){return this._withAdapter($,c,se=>se.provideInlineValues(d.URI.revive(Q),ee,ae,K),void 0)}registerDocumentHighlightProvider($,Q,ee){const ae=this._addNewAdapter(new b(this._documents,ee),$);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights($,Q,ee,ae){return this._withAdapter($,b,K=>K.provideDocumentHighlights(d.URI.revive(Q),ee,ae),void 0)}registerLinkedEditingRangeProvider($,Q,ee){const ae=this._addNewAdapter(new f(this._documents,ee),$);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges($,Q,ee,ae){return this._withAdapter($,f,async K=>{const se=await K.provideLinkedEditingRanges(d.URI.revive(Q),ee,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?je._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider($,Q,ee){const ae=this._addNewAdapter(new y(this._documents,ee),$);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences($,Q,ee,ae,K){return this._withAdapter($,y,se=>se.provideReferences(d.URI.revive(Q),ee,ae,K),void 0)}registerCodeActionProvider($,Q,ee,ae){const K=new n.DisposableStore,se=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,K)}))},je._extLabel($),Boolean(ee.resolveCodeAction)),K.add(this._createDisposable(se)),K}$provideCodeActions($,Q,ee,ae,K){return this._withAdapter($,R,se=>se.provideCodeActions(d.URI.revive(Q),ee,ae,K),void 0)}$resolveCodeAction($,Q,ee){return this._withAdapter($,R,ae=>ae.resolveCodeAction(Q,ee),void 0)}$releaseCodeActions($,Q){this._withAdapter($,R,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider($,Q,ee){const ae=this._addNewAdapter(new I(this._documents,ee),$);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentFormattingEdits($,Q,ee,ae){return this._withAdapter($,I,K=>K.provideDocumentFormattingEdits(d.URI.revive(Q),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider($,Q,ee){const ae=this._addNewAdapter(new L(this._documents,ee),$);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits($,Q,ee,ae,K){return this._withAdapter($,L,se=>se.provideDocumentRangeFormattingEdits(d.URI.revive(Q),ee,ae,K),void 0)}registerOnTypeFormattingEditProvider($,Q,ee,ae){const K=this._addNewAdapter(new E(this._documents,ee),$);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(Q),ae,$.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits($,Q,ee,ae,K,se){return this._withAdapter($,E,he=>he.provideOnTypeFormattingEdits(d.URI.revive(Q),ee,ae,K,se),void 0)}registerWorkspaceSymbolProvider($,Q){const ee=this._addNewAdapter(new N(Q,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols($,Q,ee){return this._withAdapter($,N,ae=>ae.provideWorkspaceSymbols(Q,ee),{symbols:[]})}$resolveWorkspaceSymbol($,Q,ee){return this._withAdapter($,N,ae=>ae.resolveWorkspaceSymbol(Q,ee),void 0)}$releaseWorkspaceSymbols($,Q){this._withAdapter($,N,ee=>ee.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider($,Q,ee){const ae=this._addNewAdapter(new U(this._documents,ee,this._logService),$);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),U.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits($,Q,ee,ae,K){return this._withAdapter($,U,se=>se.provideRenameEdits(d.URI.revive(Q),ee,ae,K),void 0)}$resolveRenameLocation($,Q,ee,ae){return this._withAdapter($,U,K=>K.resolveRenameLocation(d.URI.revive(Q),ee,ae),void 0)}registerDocumentSemanticTokensProvider($,Q,ee,ae){const K=this._nextHandle(),se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Ke(new G(this._documents,ee),$)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(Q),ae,se);let he=this._createDisposable(K);if(se){const Ae=ee.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=A.Disposable.from(he,Ae)}return he}$provideDocumentSemanticTokens($,Q,ee,ae){return this._withAdapter($,G,K=>K.provideDocumentSemanticTokens(d.URI.revive(Q),ee,ae),null,!0)}$releaseDocumentSemanticTokens($,Q){this._withAdapter($,G,ee=>ee.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider($,Q,ee,ae){const K=this._addNewAdapter(new H(this._documents,ee),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(Q),ae),this._createDisposable(K)}$provideDocumentRangeSemanticTokens($,Q,ee,ae){return this._withAdapter($,H,K=>K.provideDocumentRangeSemanticTokens(d.URI.revive(Q),ee,ae),null,!0)}registerCompletionItemProvider($,Q,ee,ae){const K=this._addNewAdapter(new W(this._documents,this._commands.converter,ee,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(Q),ae,W.supportsResolving(ee),`${$.identifier.value}(${ae.join("")})`),this._createDisposable(K)}$provideCompletionItems($,Q,ee,ae,K){return this._withAdapter($,W,se=>se.provideCompletionItems(d.URI.revive(Q),ee,ae,K),void 0)}$resolveCompletionItem($,Q,ee){return this._withAdapter($,W,ae=>ae.resolveCompletionItem(Q,ee),void 0)}$releaseCompletionItems($,Q){this._withAdapter($,W,ee=>ee.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider($,Q,ee){const ae=this._addNewAdapter(new ne(this._documents,ee,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions($,Q,ee,ae,K){return this._withAdapter($,ne,se=>se.provideInlineCompletions(d.URI.revive(Q),ee,ae,K),void 0)}$handleInlineCompletionDidShow($,Q,ee){this._withAdapter($,ne,async ae=>{ae.handleDidShowCompletionItem(Q,ee)},void 0)}$freeInlineCompletionsList($,Q){this._withAdapter($,ne,async ee=>{ee.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider($,Q,ee,ae){const K=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new Y(this._documents,ee),$);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),K),this._createDisposable(se)}$provideSignatureHelp($,Q,ee,ae,K){return this._withAdapter($,Y,se=>se.provideSignatureHelp(d.URI.revive(Q),ee,ae,K),void 0)}$releaseSignatureHelp($,Q){this._withAdapter($,Y,ee=>ee.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider($,Q,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new j(this._documents,ee),$);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(Q),ae);let se=this._createDisposable(K);if(ae!==void 0){const he=ee.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,he)}return se}$provideInlayHints($,Q,ee,ae){return this._withAdapter($,j,K=>K.provideInlayHints(d.URI.revive(Q),ee,ae),void 0)}registerDocumentLinkProvider($,Q,ee){const ae=this._addNewAdapter(new le(this._documents,ee),$);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks($,Q,ee){return this._withAdapter($,le,ae=>ae.provideLinks(d.URI.revive(Q),ee),void 0)}$resolveDocumentLink($,Q,ee){return this._withAdapter($,le,ae=>ae.resolveLink(Q,ee),void 0)}$releaseDocumentLinks($,Q){this._withAdapter($,le,ee=>ee.releaseLinks(Q),void 0)}registerColorProvider($,Q,ee){const ae=this._addNewAdapter(new re(this._documents,ee),$);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors($,Q,ee){return this._withAdapter($,re,ae=>ae.provideColors(d.URI.revive(Q),ee),[])}$provideColorPresentations($,Q,ee,ae){return this._withAdapter($,re,K=>K.provideColorPresentations(d.URI.revive(Q),ee,ae),void 0)}registerFoldingRangeProvider($,Q,ee){const ae=this._nextHandle(),K=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new ve(this._documents,ee),$)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),K);let se=this._createDisposable(ae);if(K!==void 0){const he=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));se=A.Disposable.from(se,he)}return se}$provideFoldingRanges($,Q,ee,ae){return this._withAdapter($,ve,K=>K.provideFoldingRanges(d.URI.revive(Q),ee,ae),void 0)}registerSelectionRangeProvider($,Q,ee){const ae=this._addNewAdapter(new Fe(this._documents,ee,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges($,Q,ee,ae){return this._withAdapter($,Fe,K=>K.provideSelectionRanges(d.URI.revive(Q),ee,ae),[])}registerCallHierarchyProvider($,Q,ee){const ae=this._addNewAdapter(new Me(this._documents,ee),$);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy($,Q,ee,ae){return this._withAdapter($,Me,K=>Promise.resolve(K.prepareSession(d.URI.revive(Q),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls($,Q,ee,ae){return this._withAdapter($,Me,K=>K.provideCallsTo(Q,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls($,Q,ee,ae){return this._withAdapter($,Me,K=>K.provideCallsFrom(Q,ee,ae),void 0)}$releaseCallHierarchy($,Q){this._withAdapter($,Me,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}registerTypeHierarchyProvider($,Q,ee){const ae=this._addNewAdapter(new Oe(this._documents,ee),$);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy($,Q,ee,ae){return this._withAdapter($,Oe,K=>Promise.resolve(K.prepareSession(d.URI.revive(Q),ee,ae)),void 0)}$provideTypeHierarchySupertypes($,Q,ee,ae){return this._withAdapter($,Oe,K=>K.provideSupertypes(Q,ee,ae),void 0)}$provideTypeHierarchySubtypes($,Q,ee,ae){return this._withAdapter($,Oe,K=>K.provideSubtypes(Q,ee,ae),void 0)}$releaseTypeHierarchy($,Q){this._withAdapter($,Oe,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,P.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:je._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?je._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?je._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:je._serializeRegExp($.beforeText),afterText:$.afterText?je._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?je._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(je._serializeOnEnterRule)}setLanguageConfiguration($,Q,ee){let{wordPattern:ae}=ee;if(ae&&(0,P.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const K=this._nextHandle(),se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?je._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?je._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?je._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,Q,se),this._createDisposable(K)}$setWordDefinitions($){for(const Q of $)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,12,6]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(t,S,n,m){this._documents=S,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,S){await this._proxy.$changeLanguage(t,S);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,S){const n=t.version,m=M.Position.from(S),s=await this._proxy.$tokensAtPosition(t.uri,m),u={type:_.StandardTokenType.Other,range:t.getWordRangeAtPosition(S)??new _.Range(S.line,S.character,S.line,S.character)};if(!s)return u;const p={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!p.range.contains(S)||n!==t.version?u:p}createLanguageStatusItem(t,S,n){const m=this._handlePool++,s=this._proxy,u=this._ids,p=`${t.identifier.value}/${S}`;if(u.has(p))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);u.add(p);const k={selector:n,id:S,name:t.displayName??t.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let w,o=new P.DisposableStore;const h=()=>{w?.dispose(),w=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(m,{id:p,name:k.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(k.selector,this._uriTransformer),label:k.text,detail:k.detail??"",severity:k.severity===_.LanguageStatusSeverity.Error?A.default.Error:k.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:k.command&&this._commands.toInternal(k.command,o),accessibilityInfo:k.accessibilityInformation})},0)},D={dispose(){o.dispose(),w?.dispose(),s.$removeLanguageStatus(m),u.delete(p)},get id(){return k.id},get name(){return k.name},set name(i){k.name=i,h()},get selector(){return k.selector},set selector(i){k.selector=i,h()},get text(){return k.text},set text(i){k.text=i,h()},get detail(){return k.detail},set detail(i){k.detail=i,h()},get severity(){return k.severity},set severity(i){k.severity=i,h()},get accessibilityInformation(){return k.accessibilityInformation},set accessibilityInformation(i){k.accessibilityInformation=i,h()},get command(){return k.command},set command(i){k.command=i,h()}};return h(),D}}e.ExtHostLanguages=C}),define(be[196],Ee([0,1,5,15,30]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let F=class{constructor(C,T){this._logService=T,this._proxy=C.getProxy(d.MainContext.MainThreadMessageService)}showMessage(C,T,t,S,n){const m={extension:C};let s;typeof S=="string"||A(S)?s=[S,...n]:(m.modal=S?.modal,m.useCustom=S?.useCustom,m.detail=S?.detail,s=n),m.useCustom&&(0,_.checkProposedApiEnabled)(C);const u=[];for(let p=0;p<s.length;p++){const k=s[p];if(typeof k=="string")u.push({title:k,handle:p,isCloseAffordance:!1});else if(typeof k=="object"){let{title:w,isCloseAffordance:o}=k;u.push({title:w,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(T,t,m,u).then(p=>{if(typeof p=="number")return s[p]})}};F=$e([ze(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,64,5,8,7,38,172,93]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(o,h,D,i,g){this._textDocumentsAndEditors=D,this._textDocuments=i,this._extensionStoragePaths=g,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(S.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(S.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(S.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const r=a.notebookEditor?.notebookUri,v=a.cell.handle,c=this._documents.get(r)?.getCell(v);if(c)return c.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const h=this._editors.get(o);if(!h)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(o){for(const[h,D]of this._editors)if(D.apiEditor===o)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,h){const D=this._documents.get(o);if(!D&&!h)throw new Error(`NO notebook document for '${o}'`);return D}_getProviderData(o){const h=this._notebookContentProviders.get(o);if(!h)throw new Error(`NO provider for '${o}'`);return h}registerNotebookContentProvider(o,h,D,i,g){if((0,P.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:o,provider:D});let a;return D.onDidChangeNotebookContentOptions&&(a=D.onDidChangeNotebookContentOptions(()=>{const r=n.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(h,r)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(o,g)),new m.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(o,h){if(!h)return;const D=h.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(h.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:h.displayName,filenamePattern:D,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,h,D){const i=k._notebookStatusBarItemProviderHandlePool++,g=typeof D.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,g,h);let a;return g!==void 0&&(a=D.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(g))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,g),a&&a.dispose()})}async createNotebookDocument(o){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return T.URI.revive(h)}async openNotebookDocument(o){const h=this._documents.get(o);if(h)return h.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(T.URI.revive(D));return(0,C.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,h){T.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let D;typeof h=="object"?D={position:n.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(n.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:D={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,D),g=i&&this._editors.get(i)?.apiEditor;if(g)return g;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,h,D,i){const g=this._notebookStatusBarItemProviders.get(o),a=T.URI.revive(h),r=this._documents.get(a);if(!r||!g)return;const v=r.getCellFromIndex(D);if(!v)return;const l=await g.provideCellStatusBarItems(v.apiCell,i);if(!l)return;const c=new A.DisposableStore,b=this._statusBarCache.add([c]),y=(Array.isArray(l)?l:[l]).map(R=>n.NotebookStatusBarItem.from(R,this._commandsConverter,c));return{cacheId:b,items:y}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,h,D,i,g){if((0,P.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,D),this._notebookProxy.$registerNotebookSerializer(a,{id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(o,g)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(o,h,D){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const g=await i.deserializeNotebook(h.buffer,D);return new s.SerializableObjectWithBuffers(n.NotebookData.from(g))}async $notebookToData(o,h,D){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const g=await i.serializeNotebook(n.NotebookData.to(h.value),D);return d.VSBuffer.wrap(g)}async $openNotebook(o,h,D,i,g){const{provider:a}=this._getProviderData(o),r=await a.openNotebook(T.URI.revive(h),{backupId:D,untitledDocumentData:i?.buffer},g);return new s.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,h,D){const i=this.getNotebookDocument(T.URI.revive(h)),{provider:g}=this._getProviderData(o);return await g.saveNotebook(i.apiNotebook,D),!0}async $saveNotebookAs(o,h,D,i){const g=this.getNotebookDocument(T.URI.revive(h)),{provider:a}=this._getProviderData(o);return await a.saveNotebookAs(T.URI.revive(D),g.apiNotebook,i),!0}async $backupNotebook(o,h,D){const i=this.getNotebookDocument(T.URI.revive(h)),g=this._getProviderData(o),a=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension),r=String((0,_.hash)([i.uri.toString(),this._backupIdPool++])),v=T.URI.joinPath(a,r),l=await g.provider.backupNotebook(i.apiNotebook,{destination:v},D);return i.updateBackup(l),l.id}_createExtHostEditor(o,h,D){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const i=new p.ExtHostNotebookEditor(h,this._notebookEditorsProxy,o,D.visibleRanges.map(n.NotebookRange.to),D.selections.map(n.NotebookRange.to),typeof D.viewColumn=="number"?n.ViewColumn.to(D.viewColumn):void 0);this._editors.set(h,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const D of o.value.removedDocuments){const i=T.URI.revive(D),g=this._documents.get(i);g&&(g.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(o.value.addedDocuments){const D=[];for(const i of o.value.addedDocuments){const g=T.URI.revive(i.uri);if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const a=this,r=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){a._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){a._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){a._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){a._onDidChangeCellExecutionState.fire(v)}},g,i);D.push(...i.cells.map(v=>u.ExtHostCell.asModelAddData(r.apiNotebook,v))),this._documents.get(g)?.dispose(),this._documents.set(g,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(o.value.addedEditors)for(const D of o.value.addedEditors){if(this._editors.has(D.id))return;const i=T.URI.revive(D.documentUri),g=this._documents.get(i);g&&this._createExtHostEditor(g,D.id,D)}const h=[];if(o.value.removedEditors)for(const D of o.value.removedEditors){const i=this._editors.get(D);i&&(this._editors.delete(D),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),h.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const D=new Set;this._visibleNotebookEditors.forEach(i=>D.add(i.id));for(const i of this._editors.values()){const g=D.has(i.id);i._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,54,15,5,13,8]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(S,n){const m=C._Keys.nextId();S.$registerNotebookEditorDecorationType(m,P.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){S.$removeNotebookEditorDecorationType(m)}}}}C._Keys=new M.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(S,n,m){this._logService=S,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(S){return new C(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),S).value}$acceptEditorPropertiesChanged(S,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,n);const m=this._notebooksAndEditors.getEditorById(S);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(P.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(P.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const n in S)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(P.ViewColumn.to(S[n]))}};T=$e([ze(0,_.ILogService),ze(1,F.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(be[199],Ee([0,1,14,12,21,3,6,20,2,26,15,5,39,8,7,67,165,30,38]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(a,r,v,l,c){this._initData=r,this._extHostNotebook=v,this._commands=l,this._logService=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(S.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",f=>!0,f=>{if(f&&"notebookEditor"in f&&"id"in f){const y=this._extHostNotebook.getIdByEditor(f.notebookEditor);return{id:f.id,extension:f.extension,notebookEditorId:y}}else if(f&&"notebookEditor"in f){const y=this._extHostNotebook.getIdByEditor(f.notebookEditor);if(y===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${f.notebookEditor.document.uri.toString()}`);return{notebookEditorId:y}}return f})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(a,r,v,l,c,b){for(let Y of this._kernelData.values())if(Y.controller.id===r&&T.ExtensionIdentifier.equals(a.identifier,Y.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const f=this._handlePool++,y=this;this._logService.trace(`NotebookController[${f}], CREATED by ${a.identifier.value}, ${r}`);const R=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${a.identifier}'`);let I=!1;const L=new F.DisposableStore,E=new A.Emitter,N=new A.Emitter,U={id:`${a.identifier.value}/${r}`,notebookType:v,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:l||a.identifier.value,preloads:b?b.map(m.NotebookRendererScript.from):[]};let B=c??R,G;this._proxy.$addKernel(f,U).catch(Y=>{console.log(Y),I=!0});let H=0;const W=()=>{if(I)return;const Y=++H;Promise.resolve().then(()=>{Y===H&&this._proxy.$updateKernel(f,U)})},ne=new P.ResourceMap,V={get id(){return r},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:E.event,get label(){return U.label},set label(Y){U.label=Y??a.displayName??a.name,W()},get detail(){return U.detail??""},set detail(Y){U.detail=Y,W()},get description(){return U.description??""},set description(Y){U.description=Y,W()},get kind(){return(0,k.checkProposedApiEnabled)(a),U.kind??""},set kind(Y){(0,k.checkProposedApiEnabled)(a),U.kind=Y,W()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(Y){U.supportedLanguages=Y,W()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){U.supportsExecutionOrder=Y,W()},get rendererScripts(){return U.preloads?U.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(Y){B=Y??R},get interruptHandler(){return G},set interruptHandler(Y){G=Y,U.supportsInterrupt=Boolean(Y),W()},createNotebookCellExecution(Y){if(I)throw new Error("notebook controller is DISPOSED");if(!ne.has(Y.notebook.uri))throw y._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return y._createNotebookCellExecution(Y)},dispose:()=>{I||(this._logService.trace(`NotebookController[${f}], DISPOSED`),I=!0,this._kernelData.delete(f),L.dispose(),E.dispose(),N.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(Y,j){y._proxy.$updateNotebookPriority(f,Y.uri,j)},onDidReceiveMessage:N.event,postMessage(Y,j){return(0,k.checkProposedApiEnabled)(a),y._proxy.$postMessage(f,j&&y._extHostNotebook.getIdByEditor(j),Y)},asWebviewUri(Y){return(0,k.checkProposedApiEnabled)(a),(0,u.asWebviewUri)(Y,y._initData.remote)}};return this._kernelData.set(f,{extensionId:a.identifier,controller:V,onDidReceiveMessage:N,onDidChangeSelection:E,associatedNotebooks:ne}),V}$acceptNotebookAssociation(a,r,v){const l=this._kernelData.get(a);if(l){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));v?l.associatedNotebooks.set(c.uri,!0):l.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,c.uri.toString(),v),l.onDidChangeSelection.fire({selected:v,notebook:c.apiNotebook})}}async $executeCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)),b=[];for(let f of v){const y=c.getCell(f);y&&b.push(y.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,c.uri.toString(),b.length),await l.controller.executeHandler.call(l.controller,b,c.apiNotebook,l.controller)}catch(f){this._logService.error(`NotebookController[${a}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,c.apiNotebook);else for(let b of v){const f=c.getCell(b);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:v}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const l=new D(v.notebook,v,this._proxy);this._activeExecutions.set(v.uri,l);const c=l.onDidChangeState(()=>{l.state===h.Resolved&&(l.dispose(),c.dispose(),this._activeExecutions.delete(v.uri))});return l.asApiObject()}};o=$e([ze(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var h;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(h||(h={}));class D extends F.Disposable{constructor(a,r,v){super();this._document=a,this._cell=r,this._proxy=v,this._handle=D.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new i(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const v=s.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return v===r.items?m.NotebookCellOutput.from(r):m.NotebookCellOutput.from({items:v,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,v){const l=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,d.asArray)(a));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:v,outputs:c})}async updateOutputItems(a,r,v){return a=s.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(a),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(m.NotebookCellOutputItem.from),outputId:r.id,append:v})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(v){a._executionOrder=v,a.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(v){if(a._state===h.Resolved||a._state===h.Started)throw new Error("Cannot call start again");a._state=h.Started,a._onDidChangeState.fire(),a.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:v})},end(v,l){if(a._state===h.Resolved)throw new Error("Cannot call resolve twice");a._state=h.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:l,lastRunSuccess:v}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(v){return a.verifyStateForOutput(),a.updateOutputs([],v,!1)},appendOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!0)},replaceOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!1)},appendOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!0)},replaceOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!1)}})}}D.HANDLE=0;class i{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(P,C){this._extHostNotebook=C,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,C,T){const t=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(C)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(P,C){if(!P.contributes?.notebookRenderer?.some(n=>n.id===C))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${C})`);const T=!!P.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,m,s)=>{const u=T?n:p=>{const k={};t.set(k,p.editor),n({editor:k,message:p.message})};return this.getOrCreateEmitterFor(C).event(u,m,s)},postMessage:(n,m)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,m]=[m,n]);const s=T?m:t.get(m),u=s&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(u?.id,C,n)}}}getOrCreateEmitterFor(P){let C=this._rendererMessageEmitters.get(P);return C||(C=new d.Emitter({onLastListenerRemove:()=>{C?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,C),C)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,13]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class C extends _.Disposable{constructor(s,u,p,k,w){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=w,this._id=w.$register(this.name,u,p,k),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(u=>this._proxy.$clear(u,s))}show(s,u){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof s=="boolean"?s:u)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=C;class T extends C{constructor(s,u,p){super(s,!1,void 0,u,p)}append(s){super.append(s),this._id.then(u=>this._proxy.$append(u,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends C{constructor(s,u,p){super(s,!0,u,void 0,p)}append(s){throw new Error("Not supported")}}class S{constructor(s,u){this.name=s,this._channel=u}append(s){this._channel.then(u=>u.append(s))}appendLine(s){this._channel.then(u=>u.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,u){this._channel.then(p=>p.show(s,u))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=S;let n=class{constructor(s){this._proxy=s.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new T(s,u.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new t(s,u,this._proxy)}};n=$e([ze(0,P.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,12,21,3,6,5,2,7,16,14,35,47]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(s,u,p){const k=s.getProxy(F.MainContext.MainThreadQuickOpen);class w{constructor(l,c){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=c}showQuickPick(l,c,b,f=M.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(l),R=++this._instances,I=k.$show(R,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},f),L={},E=I.then(()=>L);return Promise.race([E,y]).then(N=>{if(N!==L)return y.then(U=>{const B=[];for(let G=0;G<U.length;G++){const H=U[G];let W,ne,V,Y,j;typeof H=="string"?W=H:(W=H.label,ne=H.description,V=H.detail,Y=H.picked,j=H.alwaysShow),B.push({label:W,description:ne,handle:G,detail:V,picked:Y,alwaysShow:j})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{b.onDidSelectItem(U[G])}),k.$setItems(R,B),I.then(G=>{if(typeof G=="number")return U[G];if(Array.isArray(G))return G.map(H=>U[H])})})}).then(void 0,N=>{if(!(0,T.isPromiseCanceledError)(N))return k.$setError(R,N),Promise.reject(N)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,c=M.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,k.$input(l,typeof this._validateInput=="function",c).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(l){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,c=M.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(l,c){const b=new a(l,c,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(l){const c=new r(l,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(l,c){const b=this._sessions.get(l);b&&b._fireDidChangeValue(c)}$onDidAccept(l){const c=this._sessions.get(l);c&&c._fireDidAccept()}$onDidChangeActive(l,c){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){const b=this._sessions.get(l);b&&b._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,b){const f=this._sessions.get(l);f instanceof a&&f._fireDidTriggerItemButton(c,b)}$onDidHide(l){const c=this._sessions.get(l);c&&c._fireDidHide()}}class o{constructor(l,c){this._extensionId=l,this._onDidDispose=c,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((c,b)=>{const f=c===C.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(f,c)}),this.update({buttons:l.map((c,b)=>({...g(c),tooltip:c.tooltip,handle:c===C.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const c=this._handlesToButtons.get(l);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),k.$dispose(this._id))}update(l){if(!this._disposed){for(const c of Object.keys(l)){const b=l[c];this._pendingUpdate[c]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){k.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function h(v){if(v instanceof C.ThemeIcon)return{id:v.id};const l=i(v),c=D(v);return{dark:typeof l=="string"?P.URI.file(l):l,light:typeof c=="string"?P.URI.file(c):c}}function D(v){return typeof v=="object"&&"light"in v?v.light:v}function i(v){return typeof v=="object"&&"dark"in v?v.dark:v}function g(v){const l=h(v.iconPath);let c,b;return"id"in l?b=n.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:b}}class a extends o{constructor(l,c,b){super(l,b);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,b)=>{this._handlesToItems.set(b,c),this._itemsToHandles.set(c,b)}),this.update({items:l.map((c,b)=>({label:c.label,description:c.description,handle:b,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((f,y)=>({...g(f),tooltip:f.tooltip,handle:y})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(l,c){const b=this._handlesToItems.get(l);if(!b||!b.buttons||!b.buttons.length)return;const f=b.buttons[c];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:b})}}class r extends o{constructor(l,c){super(l,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?S.default.Error:S.default.Ignore})}}return new w(u,p)}e.createExtHostQuickOpen=m}),define(be[202],Ee([0,1,2,3,53,6,12,5,14,107,15,26,30,47,8]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(l){if(l)return typeof l.iconPath=="string"?d.URI.file(l.iconPath):d.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function p(l,c){if(!l.iconPath&&!c.iconPath)return 0;if(l.iconPath){if(!c.iconPath)return 1}else return-1;const b=typeof l.iconPath=="string"?l.iconPath:d.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,f=typeof c.iconPath=="string"?c.iconPath:d.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,T.comparePaths)(b,f)}function k(l,c){let b=0;if(l.strikeThrough!==c.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==c.faded)return l.faded?1:-1;if(l.tooltip!==c.tooltip)return(l.tooltip||"").localeCompare(c.tooltip||"");if(b=p(l,c),b!==0)return b;if(l.light&&c.light)b=p(l.light,c.light);else{if(l.light)return 1;if(c.light)return-1}if(b!==0)return b;if(l.dark&&c.dark)b=p(l.dark,c.dark);else{if(l.dark)return 1;if(c.dark)return-1}return b}function w(l,c){if(l.command!==c.command)return l.command<c.command?-1:1;if(l.title!==c.title)return l.title<c.title?-1:1;if(l.tooltip!==c.tooltip){if(l.tooltip!==void 0&&c.tooltip!==void 0)return l.tooltip<c.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(l.arguments===c.arguments)return 0;if(l.arguments)if(c.arguments){if(l.arguments.length!==c.arguments.length)return l.arguments.length-c.arguments.length}else return 1;else return-1;for(let b=0;b<l.arguments.length;b++){const f=l.arguments[b],y=c.arguments[b];if(f!==y)return f<y?-1:1}return 0}function o(l,c){let b=(0,T.comparePaths)(l.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(b!==0)return b;if(l.command&&c.command)b=w(l.command,c.command);else{if(l.command)return 1;if(c.command)return-1}if(b!==0)return b;if(l.decorations&&c.decorations)b=k(l.decorations,c.decorations);else{if(l.decorations)return 1;if(c.decorations)return-1}return b}function h(l,c){for(let b=0;b<l.length;b++)if(l[b]!==c[b])return!1;return!0}function D(l,c){return l.command===c.command&&l.title===c.title&&l.tooltip===c.tooltip&&(l.arguments&&c.arguments?h(l.arguments,c.arguments):l.arguments===c.arguments)}function i(l,c){return(0,C.equals)(l,c,D)}class g{constructor(c,b,f){this._extension=c,this._proxy=b,this._sourceControlHandle=f,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,n.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,b){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,b)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=g;class a{constructor(c,b,f,y,R){this._proxy=c,this._commands=b,this._sourceControlHandle=f,this._id=y,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,b){const f=this._resourceStatesCommandsMap.get(c);return f?(0,F.asPromise)(()=>this._commands.executeCommand(f.command,...f.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(o),f=(0,C.sortedDiff)(this._resourceSnapshot,c,o).map(I=>{const L=I.toInsert.map(E=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,E);const U=E.resourceUri;let B;if(E.command)if(E.command.command==="vscode.open"||E.command.command==="vscode.diff"){const ve=new A.DisposableStore;B=this._commands.converter.toInternal(E.command,ve),this._resourceStatesDisposablesMap.set(N,ve)}else this._resourceStatesCommandsMap.set(N,E.command);const G=u(E.decorations),H=E.decorations&&u(E.decorations.light)||G,W=E.decorations&&u(E.decorations.dark)||G,ne=[H,W],V=E.decorations&&E.decorations.tooltip||"",Y=E.decorations&&!!E.decorations.strikeThrough,j=E.decorations&&!!E.decorations.faded,le=E.contextValue||"";return{rawResource:[N,U,ne,V,Y,j,le,B],handle:N}});return{start:I.start,deleteCount:I.deleteCount,toInsert:L}}),y=f.map(({start:I,deleteCount:L,toInsert:E})=>[I,L,E.map(N=>N.rawResource)]),R=f.reverse();for(const{start:I,deleteCount:L,toInsert:E}of R){const N=E.map(B=>B.handle),U=this._handlesSnapshot.splice(I,L,...N);for(const B of U)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=c,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class r{constructor(c,b,f,y,R,I){this._extension=c,this._proxy=b,this._commands=f,this._id=y,this._label=R,this._rootUri=I,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,y,R,I)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=c;const b=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=c;const b=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&i(this._statusBarCommands,c))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=c;const b=(c||[]).map(f=>this._commands.converter.toInternal(f,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(c,b){const f=new a(this._proxy,this._commands,this.handle,c,b),y=M.Event.once(f.onDidDispose)(()=>this.createdResourceGroups.delete(f));return this.createdResourceGroups.set(f,y),this.eventuallyAddResourceGroups(),f}eventuallyAddResourceGroups(){const c=[],b=[];for(const[f,y]of this.createdResourceGroups){y.dispose();const R=f.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(f),this.eventuallyUpdateResourceStates()});M.Event.once(f.onDidDispose)(()=>{this.updatedResourceGroups.delete(f),R.dispose(),this._groups.delete(f.handle),this._proxy.$unregisterGroup(this.handle,f.handle)}),c.push([f.handle,f.id,f.label,f.features]);const I=f._takeResourceStateSnapshot();I.length>0&&b.push([f.handle,I]),this._groups.set(f.handle,f)}this._proxy.$registerGroups(this.handle,c,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(b=>{const f=b._takeResourceStateSnapshot();f.length!==0&&c.push([b.handle,f])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,$e([(0,_.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),$e([(0,_.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let v=class Ui{constructor(c,b,f){this._commands=b,this.logService=f,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=c.getProxy(P.MainContext.MainThreadSCM),this._telemetry=c.getProxy(P.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===3){const R=this._sourceControls.get(y.sourceControlHandle);if(!R)return y;const I=R.getResourceGroup(y.groupHandle);return I?I.getResourceState(y.handle):y}else if(y&&y.$mid===4){const R=this._sourceControls.get(y.sourceControlHandle);return R?R.getResourceGroup(y.groupHandle):y}else if(y&&y.$mid===5){const R=this._sourceControls.get(y.handle);return R||y}return y}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,b,f,y){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,b,f,y),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const R=Ui._handlePool++,I=new r(c,this._proxy,this._commands,b,f,y);this._sourceControls.set(R,I);const L=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(c.identifier))||[];return L.push(I),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(c.identifier),L),I}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const b=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(c.identifier)),f=b&&b[b.length-1];return f&&f.inputBox}$provideOriginalResource(c,b,f){const y=d.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,y.toString());const R=this._sourceControls.get(c);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(y,f)).then(I=>I||null)}$onInputBoxValueChange(c,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const f=this._sourceControls.get(c);return f&&f.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(c,b,f,y){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,b,f);const R=this._sourceControls.get(c);if(!R)return Promise.resolve(void 0);const I=R.getResourceGroup(b);return I?I.$executeResourceCommand(f,y):Promise.resolve(void 0)}$validateInput(c,b,f){this.logService.trace("ExtHostSCM#$validateInput",c);const y=this._sourceControls.get(c);return!y||!y.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>y.inputBox.validateInput(b,f)).then(R=>{if(!R)return Promise.resolve(void 0);const I=s.MarkdownString.fromStrict(R.message);return I?Promise.resolve([I,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};v._handlePool=0,v=$e([ze(2,t.ILogService)],v),e.ExtHostSCM=v});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[203],Ee([0,1,7,5,126,6,8,10]),function(oe,e,d,M,_,A,F,P){"use strict";var C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(s,u,p,k,w=d.StatusBarAlignment.Left,o){C.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ze(this,C,s,"f"),Ze(this,T,u,"f"),this._entryId=t.ID_GEN++,this._extension=p,this._id=k,this._alignment=w,this._priority=this.validatePriority(o)}validatePriority(s){if(!!(0,P.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!t.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Re(this,T,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Re(this,T,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Re(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let u;this._name?u=this._name:u=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const k=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Re(this,C,"f").$setEntry(this._entryId,s,u,this._text,k,this._command?.internal,p,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,C=new WeakMap,T=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class S{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const u={message:s};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const p=this._messages.indexOf(u);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,u){this._proxy=s.getProxy(M.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new S(this)}createStatusBarEntry(s,u,p,k){return new t(this._proxy,this._commands,s,u,p,k)}setStatusBarMessage(s,u){const p=this._statusMessage.setMessage(s);let k;return typeof u=="number"?k=setTimeout(()=>p.dispose(),u):typeof u!="undefined"&&u.then(()=>p.dispose(),()=>p.dispose()),new d.Disposable(()=>{p.dispose(),clearTimeout(k)})}}e.ExtHostStatusBar=n}),define(be[73],Ee([0,1,5,3,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}getValue(P,C,T){return this._proxy.$getValue(P,C).then(t=>t||T)}setValue(P,C,T){return this._proxy.$setValue(P,C,T)}$acceptValue(P,C,T){this._onDidChangeStorage.fire({shared:P,key:C,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(be[74],Ee([0,1,4,29,15,72,2]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,t,S){this._logService=t,this._extHostFileSystem=S,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(T){return F.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(T){if(this._value)return F.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return F.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=$e([ze(0,M.IExtHostInitDataService),ze(1,_.ILogService),ze(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(be[40],Ee([0,1,3,5,4,2,13,6,7,127,16,167,21,36,149,47,10,12]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class w{constructor(l,c,b,f){this._proxy=l,this._id=c,this._creationOptions=b,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(R,I=!0){y._checkDisposed(),y._proxy.$sendText(y._id,R,I)},show(R){y._checkDisposed(),y._proxy.$show(y._id,R)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(l,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,p.withNullAsUndefined)(l.shellPath),shellArgs:(0,p.withNullAsUndefined)(l.shellArgs),cwd:(0,p.withNullAsUndefined)(l.cwd),env:(0,p.withNullAsUndefined)(l.env),icon:(0,p.withNullAsUndefined)(a(l.iconPath)),color:u.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,p.withNullAsUndefined)(l.message),strictEnv:(0,p.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(l.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,c,b,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:u.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(l,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,c){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,c){return l===this._cols&&c===this._rows||l===0||c===0?!1:(this._cols=l,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=w;class o{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(l){return Promise.resolve("")}async updateProperty(l,c){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,c){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:c})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let h=1,D=class extends P.Disposable{constructor(l,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[b,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,c){const b=new w(this._proxy,(0,m.generateUuid)(),l,l.name),f=new o(l.pty);return b.createExtensionTerminal(l.location,this._serializeParentTerminal(l,c).resolvedExtHostIdentifier,a(l.iconPath),r(l.color)).then(y=>{const R=this._setupExtHostProcessListeners(y,f);this._terminalProcessDisposables[y]=R}),this._terminals.push(b),b.value}_serializeParentTerminal(l,c){if(c=c||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const b=l.location.parentTerminal;if(b){const f=this._terminals.find(y=>y.value===b);f&&(c.resolvedExtHostIdentifier=f._id)}}else l.location&&typeof l.location!="object"?c.location=l.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(l,c){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const f=new o(c),y=this._setupExtHostProcessListeners(l,f);this._terminalProcessDisposables[l]=y}async $acceptActiveTerminalChanged(l){const c=this._activeTerminal;if(l===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(l);b&&(this._activeTerminal=b,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,c){const b=this._getTerminalById(l);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:c})}async $acceptTerminalDimensions(l,c,b){const f=this._getTerminalById(l);f&&f.setDimensions(c,b)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(l,c,b){this._terminalProcesses.get(l)?.resize(c,b)}async $acceptTerminalTitleChange(l,c){const b=this._getTerminalById(l);b&&(b.name=c)}async $acceptTerminalClosed(l,c){const b=this._getTerminalObjectIndexById(this._terminals,l);if(b!==null){const f=this._terminals.splice(b,1)[0];f.setExitCode(c),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(l,c,b,f){if(c){const I=this._getTerminalObjectIndexById(this._terminals,c);if(I!==null){this._terminals[I]._id=l,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const y={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:A.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},R=new w(this._proxy,l,y,b);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(l,c){const b=this._getTerminalById(l);b&&b._setProcessId(c)}async $startExtensionTerminal(l,c){const b=this._getTerminalById(l);if(!b)return{message:(0,T.localize)(0,null,l)};b.isOpen||await new Promise(y=>{const R=this.onDidOpenTerminal(async I=>{I===b.value&&(R.dispose(),y())})});const f=this._terminalProcesses.get(l);f?f.startSendingEvents(c):this._extensionTerminalAwaitingStart[l]={initialDimensions:c}}_setupExtHostProcessListeners(l,c){const b=new P.DisposableStore;b.add(c.onProcessReady(y=>this._proxy.$sendProcessReady(l,y.pid,y.cwd))),b.add(c.onProcessTitleChanged(y=>this._proxy.$sendProcessTitle(l,y))),this._bufferer.startBuffering(l,c.onProcessData),b.add(c.onProcessExit(y=>this._onProcessExit(l,y))),c.onProcessOverrideDimensions&&b.add(c.onProcessOverrideDimensions(y=>this._proxy.$sendOverrideDimensions(l,y))),this._terminalProcesses.set(l,c);const f=this._extensionTerminalAwaitingStart[l];return f&&c instanceof o&&(c.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),b}$acceptProcessAckDataEvent(l,c){this._terminalProcesses.get(l)?.acknowledgeDataEvent(c)}$acceptProcessInput(l,c){this._terminalProcesses.get(l)?.input(c)}$acceptTerminalInteraction(l){const c=this._getTerminalById(l);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(l,c,b){try{this._terminalProcesses.get(l)?.resize(c,b)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(l,c){this._terminalProcesses.get(l)?.shutdown(c)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(l,c))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(c=>this._proxy.$sendProcessCwd(l,c))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,c,b){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,b),this._proxy.$registerProfileProvider(c,l.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(l,c){const b=new n.CancellationTokenSource().token,f=await this._profileProviders.get(l)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,c);return}this.createTerminalFromOptions(f.options,c)}}async $provideLinks(l,c){const b=this._getTerminalById(l);if(!b)return[];this._terminalLinkCache.delete(l);const f=this._terminalLinkCancellationSource.get(l);f&&f.dispose(!0);const y=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,y);const R=[],I={terminal:b.value,line:c},L=[];for(const U of this._linkProviders)L.push(k.Promises.withAsyncBody(async B=>{y.token.onCancellationRequested(()=>B({provider:U,links:[]}));const G=await U.provideTerminalLinks(I,y.token)||[];y.token.isCancellationRequested||B({provider:U,links:G})}));const E=await Promise.all(L);if(y.token.isCancellationRequested)return[];const N=new Map;for(const U of E)U&&U.links.length>0&&R.push(...U.links.map(B=>{const G={id:h++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return N.set(G.id,{provider:U.provider,link:B}),G}));return this._terminalLinkCache.set(l,N),R}$activateLink(l,c){const b=this._terminalLinkCache.get(l)?.get(c);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(l,c){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const b=this._terminalProcessDisposables[l];b&&(b.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,c)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,c){const b=this._getTerminalObjectIndexById(l,c);return b!==null?l[b]:null}_getTerminalObjectIndexById(l,c){let b=null;return l.some((f,y)=>f._id===c?(b=y,!0):!1),b}getEnvironmentVariableCollection(l){let c=this._environmentVariableCollections.get(l.identifier.value);return c||(c=new i,this._setEnvironmentVariableCollection(l.identifier.value,c)),c}_syncEnvironmentVariableCollection(l,c){const b=(0,S.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(l,c.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(l){l.forEach(c=>{const b=c[0],f=new i(c[1]);this._setEnvironmentVariableCollection(b,f)})}$acceptDefaultProfile(l,c){this._defaultProfile=l,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(l,c){this._environmentVariableCollections.set(l,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,c)})}};D=$e([ze(1,F.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class i{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,c){const b=this.map.get(l);(!b||b.value!==c.value||b.type!==c.type)&&(this.map.set(l,c),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,c){this.map.forEach((b,f)=>l.call(c,f,b,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let g=class extends D{constructor(l){super(!1,l)}createTerminal(l,c,b){throw new t.NotSupportedError}createTerminalFromOptions(l,c){throw new t.NotSupportedError}};g=$e([ze(0,F.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function a(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function r(v){return u.ThemeColor.isThemeColor(v)?v:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[204],Ee([0,1,14,22,21,3,234,58,6,23,10,36,5,13,49,8,7,175,90,68]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(I,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new g(this.proxy),L.registerArgumentProcessor({processArgument:E=>E?.$mid===13?u.TestItem.toItemFromContext(E):E})}createTestController(I,L){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const E=new C.DisposableStore,N=E.add(new k.SingleUseTestCollection(I));N.root.label=L;const U=new Map,B=this.proxy,G={items:N.root.children,get label(){return L},set label(W){L=W,N.root.label=W,B.$updateControllerLabel(I,L)},get id(){return I},createRunProfile:(W,ne,V,Y,j)=>{let le=(0,P.hash)(W);for(;U.has(le);)le++;const re=new f(this.proxy,I,le,W,ne,V,Y,j);return U.set(le,re),re},createTestItem(W,ne,V){return new s.TestItemImpl(I,W,ne,V)},createTestRun:(W,ne,V=!0)=>this.runTracker.createTestRun(I,N,W,ne,V),set resolveHandler(W){N.resolveHandler=W},get resolveHandler(){return N.resolveHandler},dispose:()=>{E.dispose()}};G.createRunConfiguration=G.createRunProfile,B.$registerTestController(I,L),E.add((0,C.toDisposable)(()=>B.$unregisterTestController(I)));const H={controller:G,collection:N,profiles:U};return this.controllers.set(I,H),E.add((0,C.toDisposable)(()=>this.controllers.delete(I))),E.add(N.onDidGenerateDiff(W=>B.$publishDiff(I,W))),G}createTestObserver(){return this.observer.checkout()}async runTests(I,L=_.CancellationToken.None){const E=a(I);if(!E)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.controllers.get(E.controllerId);if(!N)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:I.include?.map(U=>U.id)??[N.collection.root.id],profileGroup:y[E.kind],profileId:E.profileId,controllerId:E.controllerId}],exclude:I.exclude?.map(U=>U.id)},L)}$provideFileCoverage(I,L,E){return(0,d.mapFind)(this.runTracker.trackers,U=>U.id===I?U.getCoverage(L):void 0)?.provideFileCoverage(E)??Promise.resolve([])}$resolveFileCoverage(I,L,E,N){return(0,d.mapFind)(this.runTracker.trackers,B=>B.id===I?B.getCoverage(L):void 0)?.resolveFileCoverage(E,N)??Promise.resolve([])}$configureRunProfile(I,L){this.controllers.get(I)?.profiles.get(L)?.configureHandler?.()}$publishTestResults(I){this.results=Object.freeze(I.map(L=>(0,T.deepFreeze)(u.TestResults.to(L))).concat(this.results).sort((L,E)=>E.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,L){const E=this.controllers.get(o.TestId.fromString(I).controllerId)?.collection;E&&(await E.expand(I,L<0?Infinity:L),E.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,L){const E=this.controllers.get(I.controllerId);if(!E)return;const{collection:N,profiles:U}=E,B=U.get(I.profileId);if(!B)return;const G=I.testIds.map(V=>N.tree.get(V)).filter(t.isDefined),H=I.excludeExtIds.map(V=>E.collection.tree.get(V)).filter(t.isDefined).filter(V=>G.some(Y=>Y.fullId.compare(V.fullId)===2));if(!G.length)return;const W=new p.TestRunRequest(G.some(V=>V.actual instanceof s.TestItemRootImpl)?void 0:G.map(V=>V.actual),H.map(V=>V.actual),B),ne=this.runTracker.prepareForMainThreadTestRun(W,r.fromInternal(I,E.collection),L);try{await B.runHandler(W,L)}finally{ne.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(ne.onEnd),ne.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};D=$e([ze(0,m.IExtHostRpcService)],D),e.ExtHostTesting=D;class i extends C.Disposable{constructor(I,L,E){super();this.dto=I,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(E)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:N}of this.tasks.values())N.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const L=this.dto.id,E=this.dto.controllerId,N=(0,S.generateUuid)(),U=new v(this.proxy,L,N),B=ne=>(V,...Y)=>{if(H){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),ne(V,...Y))},G=(ne,V)=>{const Y=V instanceof Array?V.map(u.TestMessage.from):[u.TestMessage.from(V)];if(ne.uri&&ne.range){const j={range:u.Range.from(ne.range),uri:ne.uri};for(const le of Y)le.location=le.location||j}this.proxy.$appendTestMessagesInRun(L,N,o.TestId.fromExtHostTestItem(ne,E).toString(),Y)};let H=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return U.coverageProvider},set coverageProvider(ne){U.coverageProvider=ne},enqueued:B(ne=>{this.proxy.$updateTestStateInRun(L,N,o.TestId.fromExtHostTestItem(ne,E).toString(),1)}),skipped:B(ne=>{this.proxy.$updateTestStateInRun(L,N,o.TestId.fromExtHostTestItem(ne,E).toString(),5)}),started:B(ne=>{this.proxy.$updateTestStateInRun(L,N,o.TestId.fromExtHostTestItem(ne,E).toString(),2)}),errored:B((ne,V,Y)=>{G(ne,V),this.proxy.$updateTestStateInRun(L,N,o.TestId.fromExtHostTestItem(ne,E).toString(),6,Y)}),failed:B((ne,V,Y)=>{G(ne,V),this.proxy.$updateTestStateInRun(L,N,o.TestId.fromExtHostTestItem(ne,E).toString(),4,Y)}),passed:B((ne,V)=>{this.proxy.$updateTestStateInRun(L,N,o.TestId.fromExtHostTestItem(ne,this.dto.controllerId).toString(),3,V)}),appendOutput:(ne,V,Y)=>{H||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(L,N,M.VSBuffer.fromString(ne),V&&u.location.from(V),Y&&o.TestId.fromExtHostTestItem(Y,E).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(L,N),this.tasks.delete(N),this.isRunning||this.dispose())}};return this.tasks.set(N,{run:W,coverage:U}),this.proxy.$startedTestRunTask(L,{id:N,name:I,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof s.TestItemImpl))throw new s.InvalidTestItemError(I.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const L=[],E=this.dto.colllection.root;for(;;){const N=u.TestItem.from(I);if(L.unshift(N),this.sharedTestIds.has(N.extId)||(this.sharedTestIds.add(N.extId),I===E))break;I=I.parent||E}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class g{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,L,E){return this.getTracker(I,L,E)}cancelRunById(I){for(const L of this.tracked.values())if(L.id===I){L.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,L,E,N,U){const B=this.tracked.get(E);if(B)return B.createRun(N);const G=r.fromPublic(I,L,E,U),H=a(E);this.proxy.$startedExtensionTestRun({controllerId:I,profile:H&&{group:y[H.kind],id:H.profileId},exclude:E.exclude?.map(ne=>ne.id)??[],id:G.id,include:E.include?.map(ne=>ne.id)??[L.root.id],persist:U});const W=this.getTracker(E,G);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(G.id)),W.createRun(N)}getTracker(I,L,E){const N=new i(L,this.proxy,E);return this.tracked.set(I,N),N.onEnd(()=>this.tracked.delete(I)),N}}e.TestRunCoordinator=g;const a=R=>{if(!!R.profile){if(!(R.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class r{constructor(I,L,E,N,U,B){this.controllerId=I,this.id=L,this.isPersisted=U,this.colllection=B,this.includePrefix=E.map(G=>G+"\0"),this.excludePrefix=N.map(G=>G+"\0")}static fromPublic(I,L,E,N){return new r(I,(0,S.generateUuid)(),E.include?.map(U=>o.TestId.fromExtHostTestItem(U,I).toString())??[I],E.exclude?.map(U=>o.TestId.fromExtHostTestItem(U,I).toString())??[],N,L)}static fromInternal(I,L){return new r(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,L)}isIncluded(I){const L=o.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const E of this.excludePrefix)if(L===E||L.startsWith(E))return!1;for(const E of this.includePrefix)if(L===E||L.startsWith(E))return!0;return!1}}e.TestRunDto=r;class v{constructor(I,L,E){this.proxy=I,this.runId=L,this.taskId=E}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(I,L){const E=await this.fileCoverage;let N=E?.[I];return!this._coverageProvider||!E||!N?[]:(N.detailedCoverage||(N=E[I]=await this._coverageProvider.resolveFileCoverage?.(N,L)??N),N.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class l extends w.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,u.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:L,removed:E}=this;return{get added(){return[...I].map(N=>N.revived)},get updated(){return[...L].map(N=>N.revived)},get removed(){return[...E].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,L){return{...I,revived:u.TestItem.toPlain(I.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=c;class b{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(L=>L.revived)},dispose:(0,F.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class f{constructor(I,L,E,N,U,B,G=!1,H=void 0){this.controllerId=L,this.profileId=E,this._label=N,this.kind=U,this.runHandler=B,this._isDefault=G,this._tag=H,h.set(this,void 0),Ze(this,h,I,"f");const W=y[U];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Re(this,h,"f").$publishTestRunProfile({profileId:E,controllerId:L,tag:H?u.TestTag.namespace(this.controllerId,H.id):null,label:N,group:W,isDefault:G,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?u.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){Re(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,h=new WeakMap;const y={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,14,5,94,8,7]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(t,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const S=this._extHostDocumentsAndEditors.allEditors();return t?S:S.map(n=>n.value)}async showTextDocument(t,S,n){let m;typeof S=="number"?m={position:F.ViewColumn.from(S),preserveFocus:n}:typeof S=="object"?m={position:F.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?F.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:m={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,m),u=s&&this._extHostDocumentsAndEditors.getEditor(s);if(u)return u.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,S){return new A.TextEditorDecorationType(this._proxy,t,S).value}$acceptEditorPropertiesChanged(t,S){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(S.options&&n._acceptOptions(S.options),S.selections){const m=S.selections.selections.map(F.Selection.to);n._acceptSelections(m)}if(S.visibleRanges){const m=M.coalesce(S.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(m)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...S.options,lineNumbers:F.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const m=P.TextEditorSelectionChangeKind.fromValue(S.selections.source),s=S.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:m})}if(S.visibleRanges){const m=M.coalesce(S.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(t){for(const S in t){const n=this._extHostDocumentsAndEditors.getEditor(S);if(!n)throw new Error("Unknown text editor");const m=F.ViewColumn.to(t[S]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=C}),define(be[206],Ee([0,1,2,4,5,6,7]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class P{constructor(t,S){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(m))?.get(n.handle)}return n}})}async $getTimeline(t,S,n,m,s){return this._providers.get(t)?.provideTimeline(d.URI.revive(S),n,m,s)}registerTimelineProvider(t,S,n,m){const s=new A.DisposableStore,u=this.convertTimelineItem(S.id,m,s).bind(this);let p;S.onDidChange&&(p=S.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:S.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...S,scheme:t,onDidChange:void 0,async provideTimeline(w,o,h,D){D?.resetCache&&(s.clear(),k.get(S.id)?.clear());const i=await S.provideTimeline(w,o,h);if(i==null)return;const g=u(w,D);return{...i,source:S.id,items:i.items.map(g)}},dispose(){for(const w of k.values())w.get(S.id)?.clear();p?.dispose(),s.dispose()}})}convertTimelineItem(t,S,n){return(m,s)=>{let u;if(s?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const k=C(m);u=p.get(k),u===void 0&&(u=new Map,p.set(k,u))}return p=>{const{iconPath:k,...w}=p,o=`${t}|${p.id??p.timestamp}`;u?.set(o,p);let h,D,i;return p.iconPath&&(k instanceof F.ThemeIcon?i={id:k.id,color:k.color}:d.URI.isUri(k)?(h=k,D=k):{light:h,dark:D}=k),{...w,id:w.id??void 0,handle:o,source:t,command:p.command?S.toInternal(p.command,n):void 0,icon:h,iconDark:D,themeIcon:i,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=P;function C(T){return T?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(C){this._openers=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,T,t,S){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const n=S.schemes.find(m=>!F.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,S.schemes,C,S.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(C,T,t){const S=this._openers.get(C);if(!S)throw new Error(`Unknown opener with id: ${C}`);const n=_.URI.revive(T);return S.canOpenExternalUri(n,t)}async $openUri(C,T,t){const S=this._openers.get(C);if(!S)throw new Error(`Unknown opener id: '${C}'`);return S.openExternalUri(_.URI.revive(T.resolvedUri),{sourceUri:_.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(F.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const S=P.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(T)),this.handlers.set(S,t),this._proxy.$registerUriHandler(S,T),(0,_.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(T)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(T,t){const S=this.handlers.get(T);if(!S)return Promise.resolve(void 0);try{S.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(T){return M.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[51],Ee([0,1,3,11,2,137,157,67,5]),function(oe,e,d,M,_,A,F,P,C){"use strict";var T,t,S,n,m,s,u,p,k,w,o,h;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(b,f,y,R,I,L,E){T.set(this,void 0),t.set(this,void 0),S.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,""),p.set(this,void 0),k.set(this,!1),w.set(this,!1),o.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,h.set(this,new d.Emitter),this._onDidDispose=Re(this,h,"f").event,Ze(this,T,b,"f"),Ze(this,t,f,"f"),Ze(this,p,y,"f"),Ze(this,n,R,"f"),Ze(this,m,I,"f"),Ze(this,s,L,"f"),Ze(this,o,i(L),"f"),Ze(this,S,E,"f")}dispose(){Ze(this,k,!0,"f"),Re(this,h,"f").fire(),Re(this,h,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,w,!0,"f"),(0,P.asWebviewUri)(b,Re(this,n,"f").remote)}get cspSource(){const b=Re(this,s,"f").extensionLocation;if(b.scheme===M.Schemas.https||b.scheme===M.Schemas.http){let f=b.toString();return f.endsWith("/")||(f+="/"),f+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Re(this,u,"f")}set html(b){this.assertNotDisposed(),Re(this,u,"f")!==b&&(Ze(this,u,b,"f"),!Re(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,w,!0,"f"),Re(this,S,"f").report("Webview vscode-resource: uris",Re(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,t,"f").$setHtml(Re(this,T,"f"),b))}get options(){return this.assertNotDisposed(),Re(this,p,"f")}set options(b){this.assertNotDisposed(),Re(this,t,"f").$setOptions(Re(this,T,"f"),r(Re(this,s,"f"),Re(this,m,"f"),b)),Ze(this,p,b,"f")}async postMessage(b){if(Re(this,k,"f"))return!1;const f=(0,F.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Re(this,o,"f")});return Re(this,t,"f").$postMessage(Re(this,T,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Re(this,k,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,T=new WeakMap,t=new WeakMap,S=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,k=new WeakMap,w=new WeakMap,o=new WeakMap,h=new WeakMap;function i(c){try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class g{constructor(b,f,y,R,I){this.initData=f,this.workspace=y,this._logService=R,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,f,...y){const R=this.getWebview(b);if(R){const{message:I}=(0,F.deserializeWebviewMessage)(f,y);R._onMessageEmitter.fire(I)}}$onMissingCsp(b,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,f,y){const R=new D(b,this._webviewProxy,v(f),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(b,R),R._onDidDispose(()=>{this._webviews.delete(b)}),R}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=g;function a(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=a;function r(c,b,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||l(c,b)}}e.serializeWebviewOptions=r;function v(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(b=>_.URI.from(b))}}e.reviveOptions=v;function l(c,b){return[...(b?.getWorkspaceFolders()||[]).map(f=>f.uri),c.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,51,64,5,7]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(i,g){this.document=i,this._storagePath=g,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,g){await this.getEdit(i).undo(),g||this.disposeBackup()}async redo(i,g){await this.getEdit(i).redo(),g||this.disposeBackup()}disposeEdits(i){for(const g of i)this._edits.delete(g)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=h(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const g=this._edits.get(i,0);if(!g)throw new Error("No edit found");return g}}class s{constructor(){this._documents=new Map}get(i,g){return this._documents.get(this.key(i,g))}add(i,g,a){const r=this.key(i,g.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${g.uri}`);const v=new m(g,a);return this._documents.set(r,v),v}delete(i,g){const a=this.key(i,g.uri);this._documents.delete(a)}key(i,g){return`${i}@@@${g}`}}var u;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(u||(u={}));class p{constructor(){this._providers=new Map}addTextProvider(i,g,a){return this.add(0,i,g,a)}addCustomProvider(i,g,a){return this.add(1,i,g,a)}get(i){return this._providers.get(i)}add(i,g,a,r){if(this._providers.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this._providers.set(g,{type:i,extension:a,provider:r}),new n.Disposable(()=>this._providers.delete(g))}}class k{constructor(i,g,a,r,v){this._extHostDocuments=g,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=v,this._editorProviders=new p,this._documents=new s,this._proxy=i.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,g,a,r){const v=new _.DisposableStore;return w(a)?(v.add(this._editorProviders.addTextProvider(g,i,a)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(v.add(this._editorProviders.addCustomProvider(g,i,a)),this.supportEditing(a)&&v.add(a.onDidChangeCustomDocument(l=>{const c=this.getCustomDocumentEntry(g,l.document.uri);if(o(l)){const b=c.addEdit(l);this._proxy.$onDidEdit(l.document.uri,g,b,l.label)}else this._proxy.$onContentChange(l.document.uri,g)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(v,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(g)}))}async $createCustomDocument(i,g,a,r,v){const l=this._editorProviders.get(g);if(!l)throw new Error(`No provider found for '${g}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${g}'`);const c=P.URI.revive(i),b=await l.provider.openCustomDocument(c,{backupId:a,untitledDocumentData:r?.buffer},v);let f;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(g,b,f),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(i,g){const a=this._editorProviders.get(g);if(!a)throw new Error(`No provider found for '${g}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${g}'`);const r=P.URI.revive(i),{document:v}=this.getCustomDocumentEntry(g,r);this._documents.delete(g,v),v.dispose()}async $resolveWebviewEditor(i,g,a,r,v,l){const c=this._editorProviders.get(a);if(!c)throw new Error(`No provider found for '${a}'`);const b=C.ViewColumn.to(v),f=this._extHostWebview.createNewWebview(g,r.webviewOptions,c.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(g,a,r.title,b,r.panelOptions,f),R=P.URI.revive(i);switch(c.type){case 1:{const{document:I}=this.getCustomDocumentEntry(a,R);return c.provider.resolveCustomEditor(I,y,l)}case 0:{const I=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(I,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,g,a){this.getCustomDocumentEntry(g,i).disposeEdits(a)}async $onMoveCustomEditor(i,g,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const v=this._extHostWebviewPanels.getWebviewPanel(i);if(!v)throw new Error("No webview found");const l=P.URI.revive(g),c=this._extHostDocuments.getDocument(l);await r.provider.moveCustomTextEditor(c,v,d.CancellationToken.None)}async $undo(i,g,a,r){return this.getCustomDocumentEntry(g,i).undo(a,r)}async $redo(i,g,a,r){return this.getCustomDocumentEntry(g,i).redo(a,r)}async $revert(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(i,g,a,r){const v=this.getCustomDocumentEntry(g,i);return this.getCustomEditorProvider(g).saveCustomDocumentAs(v.document,P.URI.revive(a),r)}async $backup(i,g,a){const r=this.getCustomDocumentEntry(g,i),l=await this.getCustomEditorProvider(g).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(l),l.id}getCustomDocumentEntry(i,g){const a=this._documents.get(i,P.URI.revive(g));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(i){const a=this._editorProviders.get(i)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function w(D){return typeof D.resolveCustomTextEditor=="function"}function o(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function h(D){const i=D.scheme===A.Schemas.file||D.scheme===A.Schemas.untitled?D.fsPath:D.toString();return(0,M.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[210],Ee([0,1,3,6,2,36,8,51,5,7]),function(oe,e,d,M,_,A,F,P,C,T){"use strict";var t,S,n,m,s,u,p,k,w,o,h,D,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class g extends M.Disposable{constructor(l,c,b,f,y,R,I){super();t.set(this,void 0),S.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),p.set(this,void 0),k.set(this,void 0),w.set(this,!0),o.set(this,!0),h.set(this,!1),D.set(this,this._register(new d.Emitter)),this.onDidDispose=Re(this,D,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Re(this,i,"f").event,Ze(this,t,l,"f"),Ze(this,S,c,"f"),Ze(this,n,b,"f"),Ze(this,s,R,"f"),Ze(this,k,y,"f"),Ze(this,u,f,"f"),Ze(this,m,I,"f")}dispose(){Re(this,h,"f")||(Ze(this,h,!0,"f"),Re(this,D,"f").fire(),Re(this,S,"f").$disposeWebview(Re(this,t,"f")),Re(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Re(this,m,"f")}get viewType(){return this.assertNotDisposed(),Re(this,n,"f")}get title(){return this.assertNotDisposed(),Re(this,u,"f")}set title(l){this.assertNotDisposed(),Re(this,u,"f")!==l&&(Ze(this,u,l,"f"),Re(this,S,"f").$setTitle(Re(this,t,"f"),l))}get iconPath(){return this.assertNotDisposed(),Re(this,p,"f")}set iconPath(l){this.assertNotDisposed(),Re(this,p,"f")!==l&&(Ze(this,p,l,"f"),Re(this,S,"f").$setIconPath(Re(this,t,"f"),_.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Re(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Re(this,k,"f")=="number"&&Re(this,k,"f")<0))return Re(this,k,"f")}get active(){return this.assertNotDisposed(),Re(this,o,"f")}get visible(){return this.assertNotDisposed(),Re(this,w,"f")}_updateViewState(l){Re(this,h,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Ze(this,o,l.active,"f"),Ze(this,w,l.visible,"f"),Ze(this,k,l.viewColumn,"f"),Re(this,i,"f").fire({webviewPanel:this}))}reveal(l,c){this.assertNotDisposed(),Re(this,S,"f").$reveal(Re(this,t,"f"),{viewColumn:l?F.ViewColumn.from(l):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Re(this,h,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,S=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,k=new WeakMap,w=new WeakMap,o=new WeakMap,h=new WeakMap,D=new WeakMap,i=new WeakMap;class a{constructor(l,c,b){this.webviews=c,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(l,c,b,f,y={}){const R=typeof f=="object"?f.viewColumn:f,I={viewColumn:F.ViewColumn.from(R),preserveFocus:typeof f=="object"&&!!f.preserveFocus},L=(0,P.shouldSerializeBuffersForPostMessage)(l),E=a.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(l),E,c,{title:b,panelOptions:r(y),webviewOptions:(0,P.serializeWebviewOptions)(l,this.workspace,y),serializeBuffersForPostMessage:L},I);const N=this.webviews.createNewWebview(E,y,l);return this.createNewWebviewPanel(E,c,b,R,y,N)}$onDidChangeWebviewPanelViewStates(l){const c=Object.keys(l);c.sort((b,f)=>{const y=l[b],R=l[f];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const b of c){const f=this.getWebviewPanel(b);if(!f)continue;const y=l[b];f._updateViewState({active:y.active,visible:y.visible,viewColumn:F.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,c,b){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:b,extension:l}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(l)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(l,c,b,f){const y=this._serializers.get(c);if(!y)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:I}=y,L=this.webviews.createNewWebview(l,b.webviewOptions,I),E=this.createNewWebviewPanel(l,c,b.title,f,b.panelOptions,L);await R.deserializeWebviewPanel(E,b.state)}createNewWebviewPanel(l,c,b,f,y,R){const I=new g(l,this._proxy,c,b,f,y,R);return this._webviewPanels.set(l,I),I}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=a;function r(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[211],Ee([0,1,3,6,51,5,7]),function(oe,e,d,M,_,A,F){"use strict";var P,C,T,t,S,n,m,s,u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends M.Disposable{constructor(h,D,i,g,a,r){super();P.set(this,void 0),C.set(this,void 0),T.set(this,void 0),t.set(this,void 0),S.set(this,!1),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Re(this,u,"f").event,p.set(this,this._register(new d.Emitter)),this.onDidDispose=Re(this,p,"f").event,Ze(this,T,i,"f"),Ze(this,m,g,"f"),Ze(this,P,h,"f"),Ze(this,C,D,"f"),Ze(this,t,a,"f"),Ze(this,n,r,"f")}dispose(){Re(this,S,"f")||(Ze(this,S,!0,"f"),Re(this,p,"f").fire(),Re(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Re(this,m,"f")}set title(h){this.assertNotDisposed(),Re(this,m,"f")!==h&&(Ze(this,m,h,"f"),Re(this,C,"f").$setWebviewViewTitle(Re(this,P,"f"),h))}get description(){return this.assertNotDisposed(),Re(this,s,"f")}set description(h){this.assertNotDisposed(),Re(this,s,"f")!==h&&(Ze(this,s,h,"f"),Re(this,C,"f").$setWebviewViewDescription(Re(this,P,"f"),h))}get visible(){return Re(this,n,"f")}get webview(){return Re(this,t,"f")}get viewType(){return Re(this,T,"f")}_setVisible(h){h===Re(this,n,"f")||Re(this,S,"f")||(Ze(this,n,h,"f"),Re(this,u,"f").fire())}show(h){this.assertNotDisposed(),Re(this,C,"f").$show(Re(this,P,"f"),!!h)}assertNotDisposed(){if(Re(this,S,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,T=new WeakMap,t=new WeakMap,S=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap;class w{constructor(h,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,D,i,g){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:i,extension:h}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(h),D,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(h,D,i,g,a){const r=this._viewProviders.get(D);if(!r)throw new Error(`No view provider found for '${D}'`);const{provider:v,extension:l}=r,c=this._extHostWebview.createNewWebview(h,{},l),b=new k(h,this._proxy,D,i,c,!0);this._webviewViews.set(h,b),await v.resolveWebviewView(b,{state:g},a)}async $onDidChangeWebviewViewVisibility(h,D){this.getWebviewView(h)._setVisible(D)}async $disposeWebviewView(h){const D=this.getWebviewView(h);this._webviewViews.delete(h),D.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const D=this._webviewViews.get(h);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=w}),define(be[97],Ee([0,1,3,5,2,11,9,4,13]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class $i{constructor(S){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=S.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,n){let m;if(typeof S=="string"){m=S;try{S=_.URI.parse(S)}catch(s){return Promise.reject(`Invalid uri - '${S}'`)}}return(0,F.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,m,n)}async asExternalUri(S,n){if((0,F.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(S,n);return _.URI.from(m)}};T.InitialState={focused:!0},T=$e([ze(0,C.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,13]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends d.AbstractLogger{constructor(C,T){super();this._proxy=C.getProxy(M.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(C){this.setLevel(C)}trace(C,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(C,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(C,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(C,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(C,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(C,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};F=$e([ze(0,A.IExtHostRpcService),ze(1,_.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[213],Ee([0,1,12,22,21,16,3,6,108,180,38]),function(oe,e,d,M,_,A,F,P,C,T,t){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(y,R){try{return JSON.stringify(y,R)}catch(I){return"null"}}const m="$$ref$$",s={[m]:-1};class u{constructor(R,I){this.jsonString=R,this.referencedBuffers=I}}function p(y,R=null,I=!1){const L=[];return{jsonString:(I?n:JSON.stringify)(y,(N,U)=>{if(typeof U=="undefined")return s;if(typeof U=="object"){if(U instanceof M.VSBuffer){const B=L.push(U)-1;return{[m]:B}}if(R)return R(N,U)}return U}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=p;function k(y,R,I){return JSON.parse(y,(L,E)=>{if(E){const N=E[m];if(typeof N=="number")return R[N];if(I&&E.$mid===1)return I.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=k;function w(y,R){return JSON.stringify(y,R)}function o(y){return y?(R,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var h;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},g=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class r extends P.Disposable{constructor(R,I=null,L=null){super();this[S]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=I,this._uriTransformer=L,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,N=t.ProxyIdentifier.count;E<N;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,C.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:I,sid:L}=R;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,L)),this._proxies[I]}_createProxy(R,I){let L={get:(E,N)=>(typeof N=="string"&&!E[N]&&N.charCodeAt(0)===36&&(E[N]=(...U)=>this._remoteCall(R,N,U)),N===a?I:E[N])};return new Proxy(Object.create(null),L)}set(R,I){return this._locals[R.nid]=I,I}assertRegistered(R){for(let I=0,L=R.length;I<L;I++){const E=R[I];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const I=R.byteLength,L=v.read(R,0),E=L.readUInt8(),N=L.readUInt32();switch(E){case 1:case 2:{let{rpcId:U,method:B,args:G}=c.deserializeRequestJSONArgs(L);this._uriTransformer&&(G=(0,C.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(I,N,U,B,G,E===2);break}case 3:case 4:{let{rpcId:U,method:B,args:G}=c.deserializeRequestMixedArgs(L);this._uriTransformer&&(G=(0,C.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(I,N,U,B,G,E===4);break}case 5:{this._logger&&this._logger.logIncoming(I,N,0,"ack"),this._onDidReceiveAcknowledge(N);break}case 6:{this._receiveCancel(I,N);break}case 7:{this._receiveReply(I,N,void 0);break}case 9:{let U=c.deserializeReplyOKJSON(L);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(I,N,U);break}case 10:{const U=c.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(I,N,U);break}case 8:{let U=c.deserializeReplyOKVSBuffer(L);this._receiveReply(I,N,U);break}case 11:{let U=c.deserializeReplyErrError(L);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(I,N,U);break}case 12:{this._receiveReplyErr(I,N,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,I,L,E,N,U){this._logger&&this._logger.logIncoming(R,I,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(L)}.${E}(`,N);const B=String(I);let G,H;if(U){const ne=new _.CancellationTokenSource;N.push(ne.token),G=this._invokeHandler(L,E,N),H=()=>ne.cancel()}else G=this._invokeHandler(L,E,N),H=i;this._cancelInvokedHandlers[B]=H;const W=c.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing(W.byteLength,I,1,"ack"),this._protocol.send(W),G.then(ne=>{delete this._cancelInvokedHandlers[B];const V=c.serializeReplyOK(I,ne,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,I,1,"reply:",ne),this._protocol.send(V)},ne=>{delete this._cancelInvokedHandlers[B];const V=c.serializeReplyErr(I,ne);this._logger&&this._logger.logOutgoing(V.byteLength,I,1,"replyErr:",ne),this._protocol.send(V)})}_receiveCancel(R,I){this._logger&&this._logger.logIncoming(R,I,1,"receiveCancel");const L=String(I);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(R,I,L){this._logger&&this._logger.logIncoming(R,I,0,"receiveReply:",L);const E=String(I);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const N=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],N.resolveOk(L)}_receiveReplyErr(R,I,L){this._logger&&this._logger.logIncoming(R,I,0,"receiveReplyErr:",L);const E=String(I);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const N=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let U;L&&(L.$isError?(U=new Error,U.name=L.name,U.message=L.message,U.stack=L.stack):U=L),N.resolveErr(U)}_invokeHandler(R,I,L){try{return Promise.resolve(this._doInvokeHandler(R,I,L))}catch(E){return Promise.reject(E)}}_doInvokeHandler(R,I,L){const E=this._locals[R];if(!E)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(R));let N=E[I];if(typeof N!="function")throw new Error("Unknown method "+I+" on actor "+(0,t.getStringIdentifierForProxy)(R));return N.apply(E,L)}_remoteCall(R,I,L){if(this._isDisposed)return Promise.reject(A.canceled());let E=null;if(L.length>0&&_.CancellationToken.isCancellationToken(L[L.length-1])&&(E=L.pop()),E&&E.isCancellationRequested)return Promise.reject(A.canceled());const N=c.serializeRequestArguments(L,this._uriReplacer),U=++this._lastMessageId,B=String(U),G=new T.LazyPromise;E&&E.onCancellationRequested(()=>{const W=c.serializeCancel(U);this._logger&&this._logger.logOutgoing(W.byteLength,U,0,"cancel"),this._protocol.send(c.serializeCancel(U))}),this._pendingRPCReplies[B]=G,this._onWillSendRequest(U);const H=c.serializeRequest(U,R,I,N,!!E);return this._logger&&this._logger.logOutgoing(H.byteLength,U,0,`request: ${(0,t.getStringIdentifierForProxy)(R)}.${I}(`,L),this._protocol.send(H),G}}e.RPCProtocol=r,S=g,r.UNRESPONSIVE_TIME=3*1e3;class v{constructor(R,I){this._buff=R,this._offset=I}static alloc(R,I,L){let E=new v(M.VSBuffer.alloc(L+1+4),0);return E.writeUInt8(R),E.writeUInt32(I),E}static read(R,I){return new v(R,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,I}static sizeMixedArray(R){let I=0;I+=1;for(let L=0,E=R.length;L<E;L++){const N=R[L];switch(I+=1,N.type){case 1:I+=this.sizeLongString(N.value);break;case 2:I+=this.sizeVSBuffer(N.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(N.value);for(let U=0;U<N.buffers.length;++U)I+=this.sizeVSBuffer(N.buffers[U]);break;case 4:break}}return I}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let I=0,L=R.length;I<L;I++){const E=R[I];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let N=0;N<E.buffers.length;++N)this.writeBuffer(E.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(R);for(let L=0;L<R;L++)switch(this.readUInt8()){case 1:I[L]=this.readLongString();break;case 2:I[L]=this.readVSBuffer();break;case 3:const N=this.readUInt32(),U=this.readLongString(),B=[];for(let G=0;G<N;++G)B.push(this.readVSBuffer());I[L]=new t.SerializableObjectWithBuffers(k(U,B,null));break;case 4:I[L]=void 0;break}return I}}v.sizeUInt32=4;var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class c{static _useMixedArgSerialization(R){for(let I=0,L=R.length;I<L;I++)if(R[I]instanceof M.VSBuffer||R[I]instanceof t.SerializableObjectWithBuffers||typeof R[I]=="undefined")return!0;return!1}static serializeRequestArguments(R,I){if(this._useMixedArgSerialization(R)){const L=[];for(let E=0,N=R.length;E<N;E++){const U=R[E];if(U instanceof M.VSBuffer)L[E]={type:2,value:U};else if(typeof U=="undefined")L[E]={type:4};else if(U instanceof t.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:G}=p(U.value,I);L[E]={type:3,value:M.VSBuffer.fromString(B),buffers:G}}else L[E]={type:1,value:M.VSBuffer.fromString(w(U,I))}}return{type:1,args:L}}return{type:0,args:w(R,I)}}static serializeRequest(R,I,L,E,N){switch(E.type){case 0:return this._requestJSONArgs(R,I,L,E.args,N);case 1:return this._requestMixedArgs(R,I,L,E.args,N)}}static _requestJSONArgs(R,I,L,E,N){const U=M.VSBuffer.fromString(L),B=M.VSBuffer.fromString(E);let G=0;G+=v.sizeUInt8(),G+=v.sizeShortString(U),G+=v.sizeLongString(B);let H=v.alloc(N?2:1,R,G);return H.writeUInt8(I),H.writeShortString(U),H.writeLongString(B),H.buffer}static deserializeRequestJSONArgs(R){const I=R.readUInt8(),L=R.readShortString(),E=R.readLongString();return{rpcId:I,method:L,args:JSON.parse(E)}}static _requestMixedArgs(R,I,L,E,N){const U=M.VSBuffer.fromString(L);let B=0;B+=v.sizeUInt8(),B+=v.sizeShortString(U),B+=v.sizeMixedArray(E);let G=v.alloc(N?4:3,R,B);return G.writeUInt8(I),G.writeShortString(U),G.writeMixedArray(E),G.buffer}static deserializeRequestMixedArgs(R){const I=R.readUInt8(),L=R.readShortString(),E=R.readMixedArray(),N=new Array(E.length);for(let U=0,B=E.length;U<B;U++){const G=E[U];typeof G=="string"?N[U]=JSON.parse(G):N[U]=G}return{rpcId:I,method:L,args:N}}static serializeAcknowledged(R){return v.alloc(5,R,0).buffer}static serializeCancel(R){return v.alloc(6,R,0).buffer}static serializeReplyOK(R,I,L){if(typeof I=="undefined")return this._serializeReplyOKEmpty(R);if(I instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,I);if(I instanceof t.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:N}=p(I.value,L,!0);return this._serializeReplyOKJSONWithBuffers(R,E,N)}else return this._serializeReplyOKJSON(R,n(I,L))}static _serializeReplyOKEmpty(R){return v.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,I){let L=0;L+=v.sizeVSBuffer(I);let E=v.alloc(8,R,L);return E.writeVSBuffer(I),E.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,I){const L=M.VSBuffer.fromString(I);let E=0;E+=v.sizeLongString(L);let N=v.alloc(9,R,E);return N.writeLongString(L),N.buffer}static _serializeReplyOKJSONWithBuffers(R,I,L){const E=M.VSBuffer.fromString(I);let N=0;N+=v.sizeUInt32,N+=v.sizeLongString(E);for(const B of L)N+=v.sizeVSBuffer(B);let U=v.alloc(10,R,N);U.writeUInt32(L.length),U.writeLongString(E);for(const B of L)U.writeBuffer(B);return U.buffer}static deserializeReplyOKJSON(R){const I=R.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(R,I){const L=R.readUInt32(),E=R.readLongString(),N=[];for(let U=0;U<L;++U)N.push(R.readVSBuffer());return new t.SerializableObjectWithBuffers(k(E,N,I))}static serializeReplyErr(R,I){return I?this._serializeReplyErrEror(R,I):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,I){const L=M.VSBuffer.fromString(n(A.transformErrorForSerialization(I),null));let E=0;E+=v.sizeLongString(L);let N=v.alloc(11,R,E);return N.writeLongString(L),N.buffer}static deserializeReplyErrError(R){const I=R.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(R){return v.alloc(12,R,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var f;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(f||(f={}))}),define(be[214],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const F=P=>{self.removeEventListener("message",F);const C=P.data;Object.defineProperties(self,{postMessage:{value(T,t){C.postMessage(T,t)}},onmessage:{get(){return C.onmessage},set(T){C.onmessage=T}}}),C.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(A,F,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${d})('${F}'))`,T=new Blob([C],{type:"application/javascript"}),t=URL.createObjectURL(T),S=new MessageChannel,n=t,m={type:"_newWorker",id:n,port:S.port2,url:t,options:P};A(m,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};S.port1.postMessage(s),URL.revokeObjectURL(t),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(s){S.port1.onmessage=s}},onmessageerror:{get(){return S.port1.onmessageerror},set(s){S.port1.onmessageerror=s}}}),S.port1.addEventListener("messageerror",s=>{const u=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(u)}),S.port1.addEventListener("message",s=>{const u=new MessageEvent("message",{data:s.data});this.dispatchEvent(u)}),S.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,63,48,176,215]),function(oe,e,d,M,_,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let S=class Wi{constructor(m,s,u,p){this.localUserHome=m,this.remoteAgentService=s,this.environmentService=u,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||_.OS)(),this.resolveUserHome=(async()=>{const k=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=k?.userHome||m})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,s){if(m.remoteAuthority)return d.Schemas.vscodeRemote;const u=(0,P.getVirtualWorkspaceScheme)(s.getWorkspace());if(u)return u;const p=s.getWorkspace().folders[0];if(p)return p.uri.scheme;const k=s.getWorkspace().configuration;return k?k.scheme:d.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let s="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(s=m.substring(2),m="/"):(s=m.substring(2,p),m=m.substring(p)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:s,path:m,query:"",fragment:""})}};S=$e([ze(1,t.IRemoteAgentService),ze(2,T.IWorkbenchEnvironmentService),ze(3,C.IWorkspaceContextService)],S),e.AbstractPathService=S}),define(be[98],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(F,P){this.line=F,this.character=P}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,P){return new d(0,0)}with(F){return new d(0,0)}}e.Position=d;class M{constructor(F,P,C,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(F,P),this.end=new d(C,T)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,14,27,23,43,9,4,17,16,98,10]),function(oe,e,d,M,_,A,F,P,C,T,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",s=(n.length+m.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function k(W){return!!W.preview}e.resultIsMatch=k;function w(W){return!!W.resource}e.isFileMatch=w;function o(W){return!!W.message}e.isProgressMessage=o;var h;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=D;class i{constructor(ne,V,Y){this.ranges=V;const j=Array.isArray(V)?V:[V];if(Y&&Y.matchLines===1&&g(j)){ne=(0,F.getNLines)(ne,Y.matchLines);let le="",re=0,ve=0;const Fe=Math.floor(Y.charsPerLine/5),Me=[];for(const Oe of j){const Ke=Math.max(Oe.startColumn-Fe,0),je=Oe.startColumn+Y.charsPerLine;if(Ke>ve+Fe+s){const Ve=n+(Ke-ve)+m;le+=Ve+ne.slice(Ke,je),re+=Ke-(ve+Ve.length)}else le+=ne.slice(ve,je);Me.push(new r(0,Oe.startColumn-re,Oe.endColumn-re)),ve=je}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(V)?V[0].startLineNumber:V.startLineNumber;this.preview={text:ne,matches:(0,d.mapArrayOrNot)(V,re=>new a(re.startLineNumber-le,re.startColumn,re.endLineNumber-le,re.endColumn))}}}}e.TextSearchMatch=i;function g(W){const ne=W[0].startLineNumber;for(const V of W)if(V.startLineNumber!==ne||V.endLineNumber!==ne)return!1;return!0}class a{constructor(ne,V,Y,j){this.startLineNumber=ne,this.startColumn=V,this.endLineNumber=Y,this.endColumn=j}}e.SearchRange=a;class r extends a{constructor(ne,V,Y){super(ne,V,ne,Y)}}e.OneLineRange=r;var v;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function l(W,ne=!0){const V=W&&W.files&&W.files.exclude,Y=ne&&W&&W.search&&W.search.exclude;if(!V&&!Y)return;if(!V||!Y)return V||Y;let j=Object.create(null);return j=_.mixin(j,_.deepClone(V)),j=_.mixin(j,_.deepClone(Y),!0),j}e.getExcludes=l;function c(W,ne){return W.excludePattern&&M.match(W.excludePattern,ne)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&M.match(W.includePattern,ne)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(V=>{const Y=V.folder.fsPath;if(A.isEqualOrParent(ne,Y)){const j=C.relative(Y,ne);return!V.includePattern||!!M.match(V.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var b;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(ne,V){super(ne);this.code=V}}e.SearchError=f;function y(W){const ne=W.message;if((0,T.isPromiseCanceledError)(W))return new f(ne,b.canceled);try{const V=JSON.parse(ne);return new f(V.message,V.code)}catch(V){return new f(ne,b.other)}}e.deserializeSearchError=y;function R(W){const ne={message:W.message,code:W.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=R;function I(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=I;function L(W){return W.type==="success"}e.isSerializedSearchSuccess=L;function E(W){return!!W.path}e.isSerializedFileMatch=E;function N(W,ne){const V=W.searchPath?W.searchPath:W.relativePath;return(0,F.fuzzyContains)(V,ne)}e.isFilePatternMatch=N;class U{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function B(W,ne){const V={...W||{},...ne||{}};return Object.keys(V).filter(Y=>{const j=V[Y];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=B;class G{constructor(ne,V){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...V.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Y=ne.includePattern;V.includePattern&&(Y?Y={...Y,...V.includePattern}:Y=V.includePattern),Y&&(this._parsedIncludeExpression=M.parse(Y))}matchesExcludesSync(ne,V,Y){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,Y))}includedInQuerySync(ne,V,Y){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,Y)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,V,Y))}includedInQuery(ne,V,Y){const j=this._parsedExcludeExpression(ne,V,Y),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,V,Y):!0;return(0,S.isPromise)(j)?j.then(re=>re?!1:le()):le()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=G;function H(W){for(const ne in W)if(typeof W[ne]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,14,12,21,3,20,11,76,24,9,10,2,129,4,15,143,48,37,29,13,7,41,5]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o,h,D,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(R,I,L){return new T.ExtUri(E=>c(E,L)).isEqual(R,I)}function r(R,I,L){return a(R.uri,I.uri,L)?0:(0,t.compare)(R.uri.toString(),I.uri.toString())}function v(R,I,L){return R.index!==I.index?R.index<I.index?-1:1:a(R.uri,I.uri,L)?(0,t.compare)(R.name,I.name):(0,t.compare)(R.uri.toString(),I.uri.toString())}function l(R,I,L,E){const N=R.slice(0).sort((B,G)=>L(B,G,E)),U=I.slice(0).sort((B,G)=>L(B,G,E));return(0,d.delta)(N,U,(B,G)=>L(B,G,E))}function c(R,I){const L=I.getCapabilities(R.scheme);return!(L&&L&1024)}class b extends k.Workspace{constructor(I,L,E,N,U,B,G){super(I,E.map(H=>new k.WorkspaceFolder(H)),N,U,G);this._name=L,this._isUntitled=B,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(G),E.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(I,L,E,N){if(!I)return{workspace:null,added:[],removed:[]};const{id:U,name:B,folders:G,configuration:H,transient:W,isUntitled:ne}=I,V=[],Y=L;L?G.forEach((ve,Fe)=>{const Me=n.URI.revive(ve.uri),Oe=b._findFolder(E||L,Me,N);Oe?(Oe.name=ve.name,Oe.index=ve.index,V.push(Oe)):V.push({uri:Me,name:ve.name,index:Fe})}):V.push(...G.map(({uri:ve,name:Fe,index:Me})=>({uri:n.URI.revive(ve),name:Fe,index:Me}))),V.sort((ve,Fe)=>ve.index<Fe.index?-1:1);const j=new b(U,B,V,!!W,H?n.URI.revive(H):null,!!ne,ve=>c(ve,N)),{added:le,removed:re}=l(Y?Y.workspaceFolders:[],j.workspaceFolders,r,N);return{workspace:j,added:le,removed:re}}static _findFolder(I,L,E){for(let N=0;N<I.folders.length;N++){const U=I.workspaceFolders[N];if(a(U.uri,L,E))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(I,L){return L&&this._structure.get(I)&&(I=(0,T.dirname)(I)),this._structure.findSubstr(I)}resolveWorkspaceFolder(I){return this._structure.get(I)}}let f=class{constructor(I,L,E,N){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=N,this._extHostFileSystemInfo=E,this._requestIdProvider=new C.Counter,this._barrier=new M.Barrier,this._proxy=I.getProxy(g.MainContext.MainThreadWorkspace),this._messageService=I.getProxy(g.MainContext.MainThreadMessageService);const U=L.workspace;this._confirmedWorkspace=U?new b(U.id,U.name,[],!!U.transient,U.configuration?n.URI.revive(U.configuration):null,!!U.isUntitled,B=>c(B,E)):void 0}$initializeWorkspace(I,L){this._trusted=L,this.$acceptWorkspaceData(I),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:P.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(I,L,E,...N){const U=[];if(Array.isArray(N)&&N.forEach(ne=>{n.URI.isUri(ne.uri)&&!U.some(V=>a(V.uri,ne.uri,this._extHostFileSystemInfo))&&U.push({uri:ne.uri,name:ne.name||(0,T.basenameOrAuthority)(ne.uri)})}),this._unconfirmedWorkspace||[L,E].some(ne=>typeof ne!="number"||ne<0)||E===0&&U.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+E>B.length)return!1;const G=B.slice(0);G.splice(L,E,...U.map(ne=>({uri:ne.uri,name:ne.name||(0,T.basenameOrAuthority)(ne.uri),index:void 0})));for(let ne=0;ne<G.length;ne++){const V=G[ne];if(G.some((Y,j)=>j!==ne&&a(V.uri,Y.uri,this._extHostFileSystemInfo)))return!1}G.forEach((ne,V)=>ne.index=V);const{added:H,removed:W}=l(B,G,v,this._extHostFileSystemInfo);if(H.length===0&&W.length===0)return!1;if(this._proxy){const ne=I.displayName||I.name;this._proxy.$updateWorkspaceFolders(ne,L,E,U).then(void 0,V=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,m.localize)(0,null,ne,V.toString()),{extension:I},[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(I,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,L)}async getWorkspaceFolder2(I,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,L)}async resolveWorkspaceFolder(I){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(I)}getPath(){if(!this._actualWorkspace)return;const{folders:I}=this._actualWorkspace;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,L){let E,N="";if(typeof I=="string"?(E=n.URI.file(I),N=I):typeof I!="undefined"&&(E=I,N=I.fsPath),!E)return N;const U=this.getWorkspaceFolder(E,!0);if(!U)return N;typeof L=="undefined"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let B=(0,T.relativePath)(U.uri,E);return L&&U.name&&(B=`${U.name}/${B}`),B}trySetWorkspaceFolders(I){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:I,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:L,added:E,removed:N}=b.toExtHostWorkspace(I,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:E,removed:N}))}findFiles(I,L,E,N,U=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let B;if(L===null?B=!1:L&&(typeof L=="string"?B=L:B=L.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:H}=y(I);return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(G),(0,S.withUndefinedAsNull)(H),(0,S.withUndefinedAsNull)(B),(0,S.withUndefinedAsNull)(E),U).then(W=>Array.isArray(W)?W.map(ne=>n.URI.revive(ne)):[])}async findTextInFiles(I,L,E,N,U=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),G=typeof L.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:H,folder:W}=y(L.include),ne=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,V={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:H,excludePattern:ne},Y=!1;if(this._activeSearchCallbacks[B]=j=>{if(Y)return;const le=n.URI.revive(j.resource);j.results.forEach(re=>{(0,i.resultIsMatch)(re)?E({uri:le,preview:{text:re.preview.text,matches:(0,d.mapArrayOrNot)(re.preview.matches,ve=>new D.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(re.ranges,ve=>new D.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):E({uri:le,text:re.text,lineNumber:re.lineNumber})})},U.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(I,(0,S.withUndefinedAsNull)(W),V,B,U);return delete this._activeSearchCallbacks[B],j||{}}catch(j){throw delete this._activeSearchCallbacks[B],j}}$handleTextSearchResult(I,L){this._activeSearchCallbacks[L]&&this._activeSearchCallbacks[L](I)}saveAll(I){return this._proxy.$saveAll(I)}resolveProxy(I){return this._proxy.$resolveProxy(I)}get trusted(){return this._trusted}requestWorkspaceTrust(I){return this._proxy.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};f=$e([ze(0,h.IExtHostRpcService),ze(1,o.IExtHostInitDataService),ze(2,w.IExtHostFileSystemInfo),ze(3,u.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function y(R){let I,L;return R&&(typeof R=="string"?I=R:(I=R.pattern,L=R.baseFolder||n.URI.file(R.base))),{includePattern:I,folder:L}}}),define(be[32],Ee([0,1,23,3,31,5,7,146,62,10,12,4,13,15,2]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(g,a){if(a){const r=a.split(".");let v=g;for(let l=0;v&&l<r.length;l++)v=v[r[l]];return v}}function p(g){return g instanceof s.URI}function k(g){return g&&g.uri instanceof s.URI&&g.languageId&&typeof g.languageId=="string"}function w(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function o(g){return g&&g.uri instanceof s.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function h(g){if(p(g))return{resource:g};if(k(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(w(g))return{overrideIdentifier:g.languageId};if(o(g))return{resource:g.uri};if(g===null)return{resource:null}}let D=class{constructor(a,r,v){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=v,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,r))}};D=$e([ze(0,n.IExtHostRpcService),ze(1,_.IExtHostWorkspace),ze(2,m.ILogService)],D),e.ExtHostConfiguration=D;class i{constructor(a,r,v,l){this._onDidChangeConfiguration=new M.Emitter,this._proxy=a,this._logService=l,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,v))}getConfiguration(a,r,v){const l=h(r)||{},c=this._toReadonlyValue(a?u(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,l,v?.identifier);function b(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(y){return typeof u(c,y)!="undefined"},get:(y,R)=>{this._validateConfigurationAccess(a?`${a}.${y}`:y,l,v?.identifier);let I=u(c,y);if(typeof I=="undefined")I=R;else{let L;const E=(N,U)=>{let B;const G=()=>{L=L||(0,d.deepClone)(c),B=B||u(L,U)};return(0,T.isObject)(N)?new Proxy(N,{get:(H,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return G(),()=>B;if(L)return B=B||u(L,U),B[W];const ne=H[W];return typeof W=="string"?E(ne,`${U}.${W}`):ne},set:(H,W,ne)=>(G(),B&&(B[W]=ne),!0),deleteProperty:(H,W)=>(G(),B&&delete B[W],!0),defineProperty:(H,W,ne)=>(G(),B&&Object.defineProperty(B,W,ne),!0)}):N};I=E(I,y)}return I},update:(y,R,I,L)=>{y=a?`${a}.${y}`:y;const E=b(I);return R!==void 0?this._proxy.$updateConfigurationOption(E,y,R,l,L):this._proxy.$removeConfigurationOption(E,y,l,L)},inspect:y=>{y=a?`${a}.${y}`:y;const R=(0,d.deepClone)(this._configuration.inspect(y,l,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,d.mixin)(f,c,!1),Object.freeze(f)}_toReadonlyValue(a){const r=v=>(0,T.isObject)(v)?new Proxy(v,{get:(l,c)=>r(l[c]),set:(l,c,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(l,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(l,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return r(a)}_validateConfigurationAccess(a,r,v){const l=C.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),c=v?`[${v.value}] `:"";if(l===4){typeof r?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){r?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const v=new P.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,c)=>v.affectsConfiguration(l,h(c))})}_toMap(a){return a.reduce((r,v)=>(r.set(v[0],v[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[99],Ee([0,1,2,12,3,5,7,31,50,32,21,40,13,29,4,11,25,15,70,166,16]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o,h){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(U){function B(H){if(H!=null)return H}U.from=B;function G(H){if(H!=null)return H}U.to=G})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var g;(function(U){function B(H){if(H!=null)return H}U.from=B;function G(H){if(H!=null)return H}U.to=G})(g=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(U){function B(H){if(H!=null)return H}U.from=B;function G(H){if(H!=null)return H}U.to=G})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(U){function B(W){if(W){const ne=W;return ne&&!!ne.process}else return!1}U.is=B;function G(W){if(W==null)return;const ne={process:W.process,args:W.args};return W.options&&(ne.options=a.from(W.options)),ne}U.from=G;function H(W){if(W!=null)return new F.ProcessExecution(W.process,W.args,W.options)}U.to=H})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function(U){function B(H){if(H!=null)return H}U.from=B;function G(H){if(H!=null)return H}U.to=G})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(U){function B(W){if(W){const ne=W;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}U.is=B;function G(W){if(W==null)return;const ne={};return W.commandLine!==void 0?ne.commandLine=W.commandLine:(ne.command=W.command,ne.args=W.args),W.options&&(ne.options=v.from(W.options)),ne}U.from=G;function H(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new F.ShellExecution(W.commandLine,W.options):new F.ShellExecution(W.command,W.args?W.args:[],W.options)}U.to=H})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(U){function B(W){if(W){let ne=W;return ne&&ne.customExecution==="customExecution"}else return!1}U.is=B;function G(W){return{customExecution:"customExecution"}}U.from=G;function H(W,ne){return ne.get(W)}U.to=H})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(U){function B(G,H){let W;return G.scope!==void 0&&typeof G.scope!="number"?W=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===F.TaskScope.Workspace&&H&&H.workspaceFile?W=H.workspaceFile:W=o.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:W}}U.from=B})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(U){function B(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}U.from=B})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(U){function B(W,ne){if(W==null)return[];const V=[];for(let Y of W){const j=G(Y,ne);j&&V.push(j)}return V}U.fromMany=B;function G(W,ne){if(W==null)return;let V;W.execution instanceof F.ProcessExecution?V=r.from(W.execution):W.execution instanceof F.ShellExecution?V=l.from(W.execution):W.execution&&W.execution instanceof F.CustomExecution&&(V=c.from(W.execution));const Y=i.from(W.definition);let j;return W.scope?typeof W.scope=="number"?j=W.scope:j=W.scope.uri:j=F.TaskScope.Workspace,!Y||!j?void 0:{_id:W._id,definition:Y,name:W.name,source:{extensionId:ne.identifier.value,label:W.source,scope:j},execution:V,isBackground:W.isBackground,group:f.from(W.group),presentationOptions:g.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}U.from=G;async function H(W,ne,V){if(W==null)return;let Y;r.is(W.execution)?Y=r.to(W.execution):l.is(W.execution)?Y=l.to(W.execution):c.is(W.execution)&&(Y=c.to(W._id,V));const j=i.to(W.definition);let le;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?le=W.source.scope:le=await ne.resolveWorkspaceFolder(d.URI.revive(W.source.scope)):le=F.TaskScope.Workspace),!j||!le)return;const re=new F.Task(j,le,W.name,W.source.label,Y,W.problemMatchers);return W.isBackground!==void 0&&(re.isBackground=W.isBackground),W.group!==void 0&&(re.group=F.TaskGroup.from(W.group._id),re.group&&W.group.isDefault&&(re.group=new F.TaskGroup(re.group.id,re.group.label),W.group.isDefault&&(re.group.isDefault=W.group.isDefault))),W.presentationOptions&&(re.presentationOptions=g.to(W.presentationOptions)),W._id&&(re._id=W._id),W.detail&&(re.detail=W.detail),re}U.to=H})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function(U){function B(H){return H}U.from=B;function G(H){if(!!H)return Object.assign(Object.create(null),H)}U.to=G})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(B,G,H){this._id=G,this._task=H,D.set(this,void 0),Ze(this,D,B,"f")}get task(){return this._task}terminate(){Re(this,D,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}D=new WeakMap;var L;(function(U){function B(G){return{id:G._id,task:void 0}}U.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor(B,G,H,W,ne,V,Y,j){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=W,this._configurationService=ne,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,G,H){if(!H)return new F.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:G,provider:H,extension:B}),this._proxy.$registerTaskProvider(W,G),new F.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(B,G){this._proxy.$registerTaskSystem(B,G)}fetchTasks(B){return this._proxy.$fetchTasks(R.from(B)).then(async G=>{const H=[];for(let W of G){const ne=await y.to(W,this._workspaceProvider,this._providedCustomExecutions2);ne&&H.push(ne)}return H})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(G=>B.push(G)),B}terminateTask(B){if(!(B instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,G,H){const W=this._providedCustomExecutions2.get(B.id);if(W){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,W),this._terminalService.attachPtyToTerminal(G,await W.callback(H))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const G=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:G,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:B.exitCode})}$provideTasks(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));const W=[],ne=(0,M.asPromise)(()=>H.provider.provideTasks(t.CancellationToken.None)).then(V=>this.provideTasksInternal(G,W,H,V));return new Promise(V=>{ne.then(Y=>{Promise.all(W).then(()=>{V(Y)})})})}async $resolveTask(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));if(G.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${H.type}].`);const W=await y.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const ne=await H.provider.resolveTask(W,t.CancellationToken.None);if(!ne)return;this.checkDeprecation(ne,H);const V=y.from(ne,H.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(V.execution)&&await this.addCustomExecution(V,ne,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,G,H){const W=await this._proxy.$createTaskId(B);!H&&!this._providedCustomExecutions2.has(W)&&this._notProvidedCustomExecutions.add(W),this._providedCustomExecutions2.set(W,G.execution)}async getTaskExecution(B,G){if(typeof B=="string"){const ne=this._taskExecutionPromises.get(B);if(!ne)throw new Error("Unexpected: The specified task is missing an execution");return ne}let H=this._taskExecutionPromises.get(B.id);if(H)return H;const W=new Promise(async(ne,V)=>{const Y=G||await y.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);Y?ne(new I(this,B.id,Y)):V("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,W),W.then(ne=>(this._taskExecutions.set(B.id,ne),ne),ne=>Promise.reject(ne))}checkDeprecation(B,G){B._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let H=this._notProvidedCustomExecutions.values(),W=H.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=H.next()}};E=$e([ze(0,n.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,C.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,S.IExtHostTerminalService),ze(6,k.ILogService),ze(7,w.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let N=class extends E{constructor(B,G,H,W,ne,V,Y,j){super(B,G,H,W,ne,V,Y,j);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(B,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const H=y.from(G,B);if(H===void 0)throw new Error("Task is not valid");if(c.is(H.execution))await this.addCustomExecution(H,G,!1);else throw new h.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),G);return this._proxy.$executeTask(H).catch(ne=>{throw new Error(ne)}),W}provideTasksInternal(B,G,H,W){const ne=[];if(W)for(let V of W){this.checkDeprecation(V,H),(!V.definition||!B[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=y.from(V,H.extension);Y&&c.is(Y.execution)?(ne.push(Y),G.push(this.addCustomExecution(Y,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:H.extension}}async resolveTaskInternal(B){if(c.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,G,H){}};N=$e([ze(0,n.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,C.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,S.IExtHostTerminalService),ze(6,k.ILogService),ze(7,w.IExtHostApiDeprecationService)],N),e.WorkerExtHostTask=N,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,14,52,27,78,20,11,17,24,9,10,2,110,133,85,48,92,216,41]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(b,f,y,R){this.configurationService=b,this.workspaceContextService=f,this.editorGroupsService=y,this.pathService=R}text(b,f,y={}){b=this.getContentPattern(b,y);const R=this.configurationService.getValue(),I=f&&f.some(E=>!this.configurationService.getValue({resource:E}).search.useRipgrep);return{...this.commonQuery(f?.map(p.toWorkspaceFolder),y),type:2,contentPattern:b,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:R.search.usePCRE2||I||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(b,f){const y=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const R={...b,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(b,f)&&(R.isCaseSensitive=!0),this.isMultiline(b)&&(R.isMultiline=!0),R}file(b,f={}){return{...this.commonQuery(b,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(b,f){return b?(b=Array.isArray(b)?b.map(r):r(b),f?this.parseSearchPaths(b):{pattern:i(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],f={}){const y=this.handleIncludeExclude(f.includePattern,f.expandPatterns),R=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),I=b.length>1,L=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,f,R)):b.map(U=>this.getFolderQueryForRoot(U,f,R,I))).filter(U=>!!U),E={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:R.pattern,includePattern:y.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const B=d.coalesce(d.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(W=>W.resource)))).filter(H=>(0,o.pathIncludedInQuery)(E,H.fsPath)),G=this.commonQueryFromFileList(B);return{...E,...G}}const N=f.extraFileResources&&f.extraFileResources.filter(U=>(0,o.pathIncludedInQuery)(E,U.fsPath));return E.extraFileResources=N&&N.length?N:void 0,E}commonQueryFromFileList(b){const f=[],y=new F.ResourceMap,R={};let I=!1;return b.forEach(L=>{if(L.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const N=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:C.dirname(L.fsPath)});let U=y.get(N);U||(I=!0,U={folder:N,includePattern:{}},f.push(U),y.set(N,U));const B=C.relative(N.fsPath,L.fsPath);(0,S.assertIsDefined)(U.includePattern)[B.replace(/\\/g,"/")]=!0}else L.fsPath&&(I=!0,R[L.fsPath]=!0)}),{folderQueries:f,includePattern:R,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(b,f){if(f.isSmartCase){if(b.isRegExp){if(t.containsUppercaseCharacter(b.pattern,!0))return!0}else if(t.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const f=G=>C.isAbsolute(G)||/^\.\.?([\/\\]|$)/.test(G),R=(Array.isArray(b)?b:g(b)).map(G=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(G,H.scheme===P.Schemas.file?H.fsPath:H.path):G}),I=M.groupBy(R,G=>f(G)?"searchPaths":"exprSegments"),L=(I.exprSegments||[]).map(G=>t.rtrim(G,"/")).map(G=>t.rtrim(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),a(G))),E={},N=this.expandSearchPathPatterns(I.searchPaths||[]);N&&N.length&&(E.searchPaths=N);const U=d.flatten(L),B=i(...U);return B&&(E.pattern=B),E}getExcludesForFolder(b,f){return f.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const f=d.flatten(b.map(R=>{let{pathPortion:I,globPortion:L}=D(R);L&&(L=v(L));const E=this.expandOneSearchPath(I);return d.flatten(E.map(N=>this.resolveOneSearchPathPattern(N,L)))})),y=new Map;return f.forEach(R=>{const I=R.searchPath.toString(),L=y.get(I);L?R.pattern&&(L.pattern=L.pattern||{},L.pattern[R.pattern]=!0):y.set(I,{searchPath:R.searchPath,pattern:R.pattern?i(R.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==P.Schemas.file?[{searchPath:f[0].uri.with({path:b})}]:[{searchPath:n.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=r(b),b.startsWith("../")||b===".."){const R=C.posix.resolve(f.path,b);return[{searchPath:f.with({path:R})}]}const y=v(b);return[{searchPath:f,pattern:y}]}else{if(b==="./"||b===".\\")return[];{const f=b.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(I=>{const L=f.match(new RegExp(`^${t.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return L?{match:L,folder:I}:null}).filter(S.isDefined);if(R.length)return R.map(I=>{const L=I.match[1];return{searchPath:I.folder.uri,pattern:L&&v(L)}});{const I=b.match(/\.[\/\\](.+)[\/\\]?/),L=I?I[1]:b,E=s.localize(0,null,L);throw new Error(E)}}}}resolveOneSearchPathPattern(b,f){const y=b.pattern&&f?`${b.pattern}/${f}`:b.pattern||f,R=[{searchPath:b.searchPath,pattern:y}];return y&&!y.endsWith("**")&&R.push({searchPath:b.searchPath,pattern:y+"/**"}),R}getFolderQueryForSearchPath(b,f,y){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),f,y,!1);return R?{...R,includePattern:b.pattern}:null}getFolderQueryForRoot(b,f,y,R){let I;const L=n.URI.isUri(b)?b:b.uri;if(y.searchPaths){const G=y.searchPaths.filter(H=>(0,T.isEqual)(H.searchPath,L))[0];if(G&&!G.pattern)return null;G&&(I=G.pattern)}const E=this.configurationService.getValue({resource:L}),U={...this.getExcludesForFolder(E,f)||{},...I||{}},B=n.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:L,folderName:R?B:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:E.files&&E.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!E.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!E.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!E.search.followSymlinks}}};h=$e([ze(0,u.IConfigurationService),ze(1,p.IWorkspaceContextService),ze(2,k.IEditorGroupsService),ze(3,w.IPathService)],h),e.QueryBuilder=h;function D(c){const b=c.match(/[\*\{\}\(\)\[\]\?]/);if(b){const f=b.index,y=c.substr(0,f).match(/[/|\\][^/\\]*$/);if(y){let R=c.substr(0,y.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:c.substr((y.index||0)+1)}}}return{pathPortion:c}}function i(...c){return c.length?c.reduce((b,f)=>(b[f]=!0,b),Object.create(null)):void 0}function g(c){return _.splitGlobAware(c,",").map(b=>b.trim()).filter(b=>!!b.length)}function a(c){return[`**/${c}/**`,`**/${c}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function r(c){return c.replace(/\\/g,"/")}function v(c){return r(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(c,b){c=d.distinct(c,R=>R.toString());const f=[],y=b.getWorkspace();return c&&c.forEach(R=>{let I;if(b.getWorkbenchState()===2)I=(0,T.relativePath)(y.folders[0].uri,R),I&&I!=="."&&(I="./"+I);else{const L=b.getWorkspaceFolder(R);if(L){const E=L.name;if(y.folders.filter(U=>U.name===E).length===1){const U=(0,T.relativePath)(L.uri,R);U===""?I=`./${L.name}`:I=`./${L.name}/${U}`}else I=R.fsPath}}I&&f.push(I)}),f}e.resolveResourcesForSearchIncludes=l}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,48]),function(oe,e,d,M,_,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function S(u,p){const k=p.activationEvents;if(!k)return Promise.resolve(void 0);const w=[],o=[];for(const r of k)if(/^workspaceContains:/.test(r)){const v=r.substr("workspaceContains:".length);v.indexOf("*")>=0||v.indexOf("?")>=0||u.forceUsingSearch?o.push(v):w.push(v)}if(w.length===0&&o.length===0)return Promise.resolve(void 0);let h;const D=new Promise((r,v)=>{h=r}),i=r=>h({activationEvent:r}),g=Promise.all(w.map(r=>n(u,r,i))).then(()=>{}),a=m(u,p.identifier,o,i);return Promise.all([g,a]).then(()=>{h(void 0)}),D}e.checkActivateWorkspaceContainsExtension=S;async function n(u,p,k){for(const w of u.folders)if(await u.exists(d.joinPath(M.URI.revive(w),p))){k(`workspaceContains:${p}`);return}}async function m(u,p,k,w){if(k.length===0)return Promise.resolve(void 0);const o=new _.CancellationTokenSource,h=u.checkExists(u.folders,k,o.token),D=setTimeout(async()=>{o.cancel(),w(`workspaceContainsTimeout:${k.join(",")}`)},t);let i=!1;try{i=await h}catch(g){A.isPromiseCanceledError(g)||A.onUnexpectedError(g)}o.dispose(),clearTimeout(D),i&&w(`workspaceContains:${k.join(",")}`)}function s(u,p,k,w){const o=u.get(F.IInstantiationService),h=u.get(C.ISearchService),i=o.createInstance(P.QueryBuilder).file(p.map(g=>(0,T.toWorkspaceFolder)(M.URI.revive(g))),{_reason:"checkExists",includePattern:k,exists:!0});return h.fileSearch(i,w).then(g=>!!g.limitHit,g=>A.isPromiseCanceledError(g)?!1:Promise.reject(g))}e.checkGlobFileExists=s});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[33],Ee([0,1,124,17,75,24,12,6,20,2,15,5,32,179,73,31,30,177,16,26,22,152,7,86,4,29,74,13,61,65,40,3,218,69,154,11]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o,h,D,i,g,a,r,v,l,c,b,f,y,R,I,L,E){"use strict";var N,U,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let G=class Hi extends P.Disposable{constructor(V,Y,j,le,re,ve,Fe,Me,Oe,Ke){super();this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=j,this._initData=Fe,this._extHostWorkspace=le,this._extHostConfiguration=re,this._logService=ve,this._extHostTunnelService=Oe,this._extHostTerminalService=Ke,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=Me,this._instaService=V.createChild(new c.ServiceCollection([s.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Ve=>je.add(o.ExtensionIdentifier.toKey(Ve))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,$,Q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,w.transformErrorForSerialization($),Q)},actualActivateExtension:async(Ve,$)=>{if(je.has(o.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,$),new m.HostExtension;const Q=this._registry.getExtensionDescription(Ve);return this._activateExtension(Q,$)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){w.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this._deactivate(re))}catch(Y){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Y){return this._activator.activateByEvent(V,Y)}_activateById(V,Y){return this._activator.activateById(V,Y)}activateByIdWithErrors(V,Y){return this._activateById(V,Y).then(()=>{const j=this._activator.getActivatedExtension(V);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==E.Schemas.file)return V;const Y=await this._hostUtils.realpath(V.fsPath);return T.URI.file(Y)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=C.TernarySearchTree.forUris(Y=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Y));for(const Y of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Y)){const j=await this._realPathExtensionUri(Y.extensionLocation);V.set(j,Y)}return V})()),this._extensionPathIndex}_deactivate(V){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Y;const j=this._activator.getActivatedExtension(V);if(!j)return Y;try{typeof j.module.deactivate=="function"&&(Y=Promise.resolve(j.module.deactivate()).then(void 0,le=>(this._logService.error(le),Promise.resolve(void 0))))}catch(le){this._logService.error(le)}try{(0,P.dispose)(j.subscriptions)}catch(le){this._logService.error(le)}return Y}async _activateExtension(V,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Y).then(j=>{const le=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,Y),this._logExtensionActivationTimes(V,Y,"success",le),j},j=>{throw this._logExtensionActivationTimes(V,Y,"failure"),j})}_logExtensionActivationTimes(V,Y,j,le){const re=H(V,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...re,...le||{},outcome:j})}_doActivateExtension(V,Y){const j=H(V,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const le=this._getEntryPoint(V);if(!le)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${V.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this._logService.flush();const re=new m.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,le),re),this._loadExtensionContext(V)]).then(ve=>(_.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Hi._callActivate(this._logService,V.identifier,ve[0],ve[1],re))).then(ve=>(_.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),ve))}_loadExtensionContext(V){const Y=new D.ExtensionGlobalMemento(V,this._storage),j=new D.ExtensionMemento(V.identifier.value,!1,this._storage),le=new L.ExtensionSecrets(V,this._secretState),re=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Y.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let Me;return Object.freeze({globalState:Y,workspaceState:j,secrets:le,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Oe){return M.join(V.extensionLocation.fsPath,Oe)},get storagePath(){return Fe._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(V).fsPath},get logPath(){return M.join(Fe._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return T.URI.joinPath(Fe._initData.logsLocation,V.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(V)},get globalStorageUri(){return Fe._storagePath.globalValue(V)},get extensionMode(){return re},get extension(){return Me===void 0&&(Me=new W(Fe,V.identifier,V,ve)),Me},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(V),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,Y,j,le,re){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Y,j,le,re).then(ve=>new m.ActivatedExtension(!1,null,re.build(),j,ve,le.subscriptions))}static _callActivateOptional(V,Y,j,le,re){if(typeof j.activate=="function")try{re.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const ve=typeof global=="object"?global:self,Fe=j.activate.apply(ve,[le]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(Fe).then(Me=>(re.activateResolveStop(),Me))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(j)}_activateOneStartupFinished(V,Y){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Y}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Y of V.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(V,Y)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,re=>{this._logService.error(re)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(re=>this._handleWorkspaceContainsEagerExtensions(re.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(Y),le=Promise.all([V,j]).then(()=>{});return Promise.race([le,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),le}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(V,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Y){if(this.isActivated(Y.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,le={folders:V.map(ve=>ve.uri),forceUsingSearch:j,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Fe,Me)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Fe,Me)},re=await(0,R.checkActivateWorkspaceContainsExtension)(le,Y);if(!!re)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:re.activationEvent}).then(void 0,ve=>this._logService.error(ve))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Y}=this._initData.environment;if(!V||!Y)throw new Error(d.localize(0,null));const j=await this._loadCommonJSModule(null,Y,new m.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(d.localize(1,null,Y.toString()));return new Promise((le,re)=>{const ve=(Oe,Ke)=>{Oe?re(Oe):le(typeof Ke=="number"&&Ke>0?1:0)},Fe=(0,A.originalFSPath)(Y),Me=j.run(Fe,ve);Me&&Me.then&&Me.then(()=>{le(0)}).catch(Oe=>{re(Oe.toString())})})}async $extensionTestsExit(V){this._logService.info(`Extension host terminating: test runner requested exit with code ${V}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,Y){return this._resolvers[V]=Y,(0,P.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Y=V.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const j=V.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(V,Y){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(V);if(!le)return{type:"error",error:{code:g.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(le)),_.mark(`code/extHost/willResolveAuthority/${j}`);const re=await le.resolve(V,{resolveAttempt:Y});_.mark(`code/extHost/didResolveAuthorityOK/${j}`);const ve={authority:V,host:re.host,port:re.port,connectionToken:re.connectionToken},Fe={extensionHostEnv:re.extensionHostEnv,isTrusted:re.isTrusted};return{type:"ok",value:{authority:ve,options:Fe,tunnelInformation:{environmentTunnels:re.environmentTunnels}}}}catch(re){if(_.mark(`code/extHost/didResolveAuthorityError/${j}`),re instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:re._code,message:re._message,detail:re._detail}};throw re}}async $getCanonicalURI(V,Y){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(V);if(!le)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const re=T.URI.revive(Y);if(typeof le.getCanonicalURI=="undefined")return re;const ve=await(0,F.asPromise)(()=>le.getCanonicalURI(re));return ve||re}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Y){return Y===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(V,!1))}async $activate(V,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Y),!0):!1}async $deltaExtensions(V,Y){V.forEach(le=>le.extensionLocation=T.URI.revive(le.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(Y.map(async le=>{const re=this._registry.getExtensionDescription(le);re&&j.delete(await this._realPathExtensionUri(re.extensionLocation))})),await Promise.all(V.map(async le=>{const re=await this._realPathExtensionUri(le.extensionLocation);j.set(re,le)})),this._registry.deltaExtensions(V,Y),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Y=h.VSBuffer.alloc(V),j=Math.random()%256;for(let le=0;le<V;le++)Y.writeUInt8(j,le);return Y}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};G=$e([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,l.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,r.IExtHostInitDataService),ze(7,v.IExtensionStoragePaths),ze(8,b.IExtHostTunnelService),ze(9,f.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function H(ne,V){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor(V,Y,j,le){N.set(this,void 0),U.set(this,void 0),B.set(this,void 0),Ze(this,N,V,"f"),Ze(this,U,Y,"f"),Ze(this,B,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=le}get isActive(){return Re(this,N,"f").isActivated(Re(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return Re(this,N,"f").getExtensionExports(Re(this,B,"f"))}activate(){return Re(this,N,"f").activateByIdWithErrors(Re(this,B,"f"),{startup:!1,extensionId:Re(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,N=new WeakMap,U=new WeakMap,B=new WeakMap}),define(be[100],Ee([0,1,17,2,3,12,5,7,162,31,33,50,168,32,163,13,4,10,91,71]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let h=class{constructor(c,b,f,y,R,I){this._workspaceService=b,this._extensionService=f,this._editorsService=y,this._configurationService=R,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=c.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(E=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,b){const f=c;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let y=`debug:${encodeURIComponent(f.path||"")}`,R="?";return b&&(y+=`${R}session=${encodeURIComponent(b.id)}`,R="&"),y+=`${R}ref=${f.sourceReference}`,M.URI.parse(y)}else{if(f.path)return M.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const b=[];for(const f of c.getAllExtensionDescriptions())if(f.contributes){const y=f.contributes.debuggers;if(y&&y.length>0)for(const R of y)(0,s.isDebuggerMainContribution)(R)&&b.push(R.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(b=>c.push(b)),c}addBreakpoints(c){this.startBreakpoints();const b=c.filter(R=>{const I=R.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,R),!0)});this.fireBreakpointChanges(b,[],[]);const f=[],y=new Map;for(const R of b)if(R instanceof P.SourceBreakpoint){let I=y.get(R.location.uri.toString());I||(I={type:"sourceMulti",uri:R.location.uri,lines:[]},y.set(R.location.uri.toString(),I),f.push(I)),I.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof P.FunctionBreakpoint&&f.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(c){this.startBreakpoints();const b=c.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],b,[]);const f=b.filter(I=>I instanceof P.SourceBreakpoint).map(I=>I.id),y=b.filter(I=>I instanceof P.FunctionBreakpoint).map(I=>I.id),R=b.filter(I=>I instanceof P.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(f,y,R)}startDebugging(c,b,f){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,b,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,b,f){if(!b)return new P.Disposable(()=>{});const y=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:y,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,f,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,y),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(c,b,f){if(!f)return new P.Disposable(()=>{});if(!this.definesDebugType(c,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:y,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,y),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(c,b){if(!b)return new P.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:f,factory:b}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(y=>y.factory!==b)})}async $runInTerminal(c,b){return Promise.resolve(void 0)}async $substituteVariables(c,b){if(!this._variableResolver){const[R,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,I)}let f;const y=await this.getFolder(c);return y&&(f={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,b)}createDebugAdapter(c,b){if(c.type==="implementation")return new r(c.implementation)}createSignService(){}async $startDASession(c,b){const f=this,y=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(y.type),y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.convertToDto(R),L=this.createDebugAdapter(I,y);if(!L)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const E=L;return this._debugAdapters.set(c,E),this.getDebugAdapterTrackers(y).then(N=>(N&&this._debugAdaptersTrackers.set(c,N),E.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const B=U,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(B.arguments.value);G.body={signature:H},E.sendResponse(G)}else throw new Error("no signer")}catch(H){G.success=!1,G.message=H.message,E.sendResponse(G)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(U),U=(0,s.convertToVSCPaths)(U,!0),f._debugServiceProxy.$acceptDAMessage(c,U)}),E.onError(U=>{N&&N.onError&&N.onError(U),this._debugServiceProxy.$acceptDAError(c,U.name,U.message,U.stack)}),E.onExit(U=>{N&&N.onExit&&N.onExit((0,k.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,k.withNullAsUndefined)(U),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),E.startSession()))})}$sendDAMessage(c,b){b=(0,s.convertToDAPaths)(b,!1);const f=this._debugAdaptersTrackers.get(c);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(b);const y=this._debugAdapters.get(c);y&&y.sendMessage(b)}$stopDASession(c){const b=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),b&&b.onWillStopSession&&b.onWillStopSession();const f=this._debugAdapters.get(c);return this._debugAdapters.delete(c),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const b=[],f=[],y=[];if(c.added)for(const R of c.added){const I=R.id;if(I&&!this._breakpoints.has(I)){let L;if(R.type==="function")L=new P.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")L=new P.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const E=M.URI.revive(R.uri);L=new P.SourceBreakpoint(new P.Location(E,new P.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}L._id=I,this._breakpoints.set(I,L),b.push(L)}}if(c.removed)for(const R of c.removed){const I=this._breakpoints.get(R);I&&(this._breakpoints.delete(R),f.push(I))}if(c.changed){for(const R of c.changed)if(R.id){const I=this._breakpoints.get(R.id);if(I){if(I instanceof P.FunctionBreakpoint&&R.type==="function"){const L=I;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.functionName=R.functionName}else if(I instanceof P.SourceBreakpoint&&R.type==="source"){const L=I;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.location=new P.Location(M.URI.revive(R.uri),new P.Position(R.line,R.character))}y.push(I)}}}this.fireBreakpointChanges(b,f,y)}$provideDebugConfigurations(c,b,f){return(0,A.asPromise)(async()=>{const y=this.getConfigProviderByHandle(c);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(b);return y.provideDebugConfigurations(R,f)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(c,b,f,y){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(b);return R.resolveDebugConfiguration(I,f,y)})}$resolveDebugConfigurationWithSubstitutedVariables(c,b,f,y){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(b);return R.resolveDebugConfigurationWithSubstitutedVariables(I,f,y)})}async $provideDebugAdapter(c,b){const f=this.getAdapterDescriptorFactoryByHandle(c);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.getSession(b);return this.getAdapterDescriptor(f,y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(c){const b=await this.getSession(c);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(c){const b=await this.getSession(c);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,b){const f=await this.getSession(c);f&&f._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(c,b){const y={session:await this.getSession(c),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(y)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const b=this._adapterFactories.filter(f=>f.type===c);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(c){const b=this._adapterFactories.filter(f=>f.handle===c);if(b.length>0)return b[0].factory}getConfigProviderByHandle(c){const b=this._configProviders.filter(f=>f.handle===c);if(b.length>0)return b[0].provider}definesDebugType(c,b){if(c.contributes){const f=c.contributes.debuggers;if(f&&f.length>0){for(const y of f)if(y.label&&y.type&&y.type===b)return!0}}return!1}getDebugAdapterTrackers(c){const f=c.configuration.type,y=this._trackerFactories.filter(R=>R.type===f||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(c)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then(R=>{const I=R.filter(L=>!!L);if(I.length>0)return new a(I)}),new Promise((R,I)=>{const L=setTimeout(()=>{clearTimeout(L),I(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(c,b){const f=b.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new P.DebugAdapterServer(f));if(c){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,R))).then(I=>{if(I)return I})}const y=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,y))}daExecutableFromPackage(c,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,b,f){(c.length>0||b.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:b,changed:f}))}async getSession(c){if(c)if(typeof c=="string"){const b=this._debugSessions.get(c);if(b)return b}else{let b=this._debugSessions.get(c.id);if(!b){const f=await this.getFolder(c.folderUri),y=c.parent?this._debugSessions.get(c.parent):void 0;b=new D(this._debugServiceProxy,c.id,c.type,c.name,f,c.configuration,y),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(c){if(c){const b=M.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};h=$e([ze(0,u.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,S.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class D{constructor(c,b,f,y,R,I,L){this._debugServiceProxy=c,this._id=b,this._type=f,this._name=y,this._workspaceFolder=R,this._configuration=I,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,b)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=D;class i{constructor(c){this.value=Object.freeze({append(b){c.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=i;class g extends n.AbstractVariableResolverService{constructor(c,b,f,y,R){function I(){if(b){const L=b.activeEditor();if(L)return L.document.uri;const E=y.tabs.filter(N=>N.isActive);if(E.length>0){const N=E[0].resource;return N&&(N.primary||N.secondary)?N.primary??N.secondary:E[0].resource}}}super({getFolderUri:L=>{const E=c.filter(N=>N.name===L);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(L,E)=>f.getConfiguration(void 0,L).get(E),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=I();if(L)return d.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const L=I();if(L){const E=R.getWorkspaceFolder(L);if(E)return d.normalize(E.uri.fsPath)}}},getSelectedText:()=>{if(b){const L=b.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(b){const L=b.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=g;class a{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(b=>b.onError?b.onError(c):void 0)}onExit(c,b){this.trackers.forEach(f=>f.onExit?f.onExit(c,b):void 0)}}class r extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let v=class extends h{constructor(c,b,f,y,R,I){super(c,b,f,y,R,I)}createVariableResolver(c,b,f){return new g(c,b,f,this._editorTabs)}};v=$e([ze(0,u.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,S.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],v),e.WorkerExtHostDebugService=v}),define(be[219],Ee([0,1,75,2,5,32,30,26,13,29,4,33,91,15]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(o,h,D,i,g,a,r){this._apiFactory=o,this._extensionRegistry=h,this._instaService=D,this._extHostConfiguration=i,this._extHostExtensionService=g,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,h,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(p,h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(k,h,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let h of o.nodeModuleName)this._factories.set(h,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(h=>o.alternativeModuleName(h))}};s=$e([ze(2,t.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,S.IExtHostExtensionService),ze(5,T.IExtHostInitDataService),ze(6,m.ILogService)],s),e.RequireInterceptor=s;class u{constructor(o,h,D,i,g){this._apiFactory=o,this._extensionPaths=h,this._extensionRegistry=D,this._configProvider=i,this._logService=g,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,h){const D=this._extensionPaths.findSubstr(h);if(D){let i=this._extApiImpl.get(P.ExtensionIdentifier.toKey(D.identifier));return i||(i=this._apiFactory(D,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(D.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((g,a)=>i+=`	${a} -> ${g.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(o,h,D){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=h.getProxy(_.MainContext.MainThreadTelemetry);const{environment:i}=D,g=h.getProxy(_.MainContext.MainThreadKeytar);if(i.appRoot){let a=i.appRoot.fsPath;n.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,r)=>g.$getPassword(a,r),setPassword:(a,r,v)=>g.$setPassword(a,r,v),deletePassword:(a,r)=>g.$deletePassword(a,r),findPassword:a=>g.$findPassword(a),findCredentials(a){return g.$findCredentials(a)}}}load(o,h){const D=this._extensionPaths.findSubstr(h);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:D?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const h=o.length;if(h<=7||!this.alternativeNames)return;const D=h-7;if((o.charAt(D)==="/"||o.charAt(D)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};p=$e([ze(1,C.IExtHostRpcService),ze(2,T.IExtHostInitDataService)],p);let k=class{constructor(o,h,D){this._extensionPaths=o,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=D.getProxy(_.MainContext.MainThreadTelemetry);const i=D.getProxy(_.MainContext.MainThreadWindow);this._impl=(g,a)=>{const r=M.URI.parse(g);return a?this.callOriginal(g,a):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,g,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?i.$openUri(r,g,{}):this.callOriginal(g,a)}}load(o,h,D){const i=this._extensionPaths.findSubstr(h);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=D(o),this._impl}callOriginal(o,h){return this.sendNoForwardTelemetry(),this._original(o,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};k=$e([ze(2,C.IExtHostRpcService)],k)}),define(be[220],Ee([0,1,12,16,75,6,2,5,213,15,57,61,29,142,13,66,33,40]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(h,D,i,g){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new C.RPCProtocol(h,null,g),D=w._transform(D,this._rpcProtocol);const a=new S.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());a.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...D}),a.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),a.set(u.IURITransformerService,new u.URITransformerService(g)),a.set(p.IHostUtils,i);const r=new m.InstantiationService(a,!0),v=r.invokeFunction(f=>f.get(k.IExtHostTerminalService));this._disposables.add(v),this._logService=r.invokeFunction(f=>f.get(T.ILogService)),_.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=r.invokeFunction(f=>f.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(y,R)=>{let I="",L,E;for(const N of R)I+=`
	at ${N.toString()}`,E=N.getFileName(),!L&&E&&(L=f.findSubstr(F.URI.file(E)));return l.set(y,L),`${y.name||"Error"}: ${y.message||""}${I}`}});const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(f=>{const y=M.transformErrorForSerialization(f),R=l.get(f);R?c.$onExtensionRuntimeError(R.identifier,y):b.$onUnexpectedError(y)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),D]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,D){h.extensions.forEach(g=>g.extensionLocation=F.URI.revive(D.transformIncomingURIs(g.extensionLocation))),h.environment.appRoot=F.URI.revive(D.transformIncomingURIs(h.environment.appRoot));const i=h.environment.extensionDevelopmentLocationURI;return i&&(h.environment.extensionDevelopmentLocationURI=i.map(g=>F.URI.revive(D.transformIncomingURIs(g)))),h.environment.extensionTestsLocationURI=F.URI.revive(D.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=F.URI.revive(D.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=F.URI.revive(D.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=F.URI.revive(D.transformIncomingURIs(h.logsLocation)),h.logFile=F.URI.revive(D.transformIncomingURIs(h.logFile)),h.workspace=D.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=w}),define(be[221],Ee([0,1,17,21,45,27,24,194,41]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(n,m,s){this.config=n,this.provider=m,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((s,u)=>{const p=k=>{this.resultCount++,n(k)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const w=k.toString(),o=d.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,o)||this.matchFile(p,{base:k,basename:o})}),Promise.all(m.map(k=>this.searchInFolder(k,p))).then(k=>{s({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{u(new Error((0,_.toErrorMessage)(k)))})})}async searchInFolder(n,m){const s=new M.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),p=this.initDirectoryTree(),k=new C.QueryGlobTester(this.config,n),w=!k.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(s),o=P.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,s.token),D=o.elapsed(),i=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(g=>{const a=d.posix.relative(n.folder.path,g.path);if(w){const r=d.basename(g.path);this.matchFile(m,{base:n.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(p,n.folder,a,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,k,m),{providerTime:D,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const m=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,s,u){if(s===this.filePattern){const k=d.basename(this.filePattern);this.matchFile(u,{base:m,relativePath:this.filePattern,basename:k})}function p(k){const w=d.basename(k),o=d.dirname(k);let h=n[o];h||(h=n[o]=[],p(o)),h.push({base:m,relativePath:k,basename:w})}p(s)}matchDirectoryTree({rootEntries:n,pathToEntries:m},s,u){const p=this,k=this.filePattern;function w(o){const h=A.hasSiblingFn(()=>o.map(D=>D.basename));for(let D=0,i=o.length;D<i;D++){const g=o[D],{relativePath:a,basename:r}=g;if(s.matchesExcludesSync(a,r,k!==r?h:void 0))continue;const v=m[a];if(v)w(v);else{if(a===k)continue;p.matchFile(u,g)}if(p.isLimitHit)break}}w(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class t{constructor(){this.sessions=new Map}fileSearch(n,m,s,u){const p=this.getSessionTokenSource(n.cacheKey),k=new T(n,m,p&&p.token);let w=0;const o=h=>{w+=h.length,s(h.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(k,t.BATCH_SIZE,o,u).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:h.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,s,u){u.onCancellationRequested(()=>{n.cancel()});const p=w=>{w&&(k.push(w),m>0&&k.length>=m&&(s(k),k=[]))};let k=[];return n.search(p).then(w=>(k.length&&s(k),w),w=>(k.length&&s(k),Promise.reject(w)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,14,21,45,27,11,17,24,10,2,41]),function(oe,e,d,M,_,A,F,P,C,T,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,h,D,i){this.query=o,this.provider=h,this.fileUtils=D,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,h){const D=this.query.folderQueries||[],i=new M.CancellationTokenSource;return h.onCancellationRequested(()=>i.cancel()),new Promise((g,a)=>{this.collector=new s(o);let r=!1;const v=(l,c)=>{if(!r&&!this.isLimitHit){const b=this.resultSize(l);p(l)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,r=!0,i.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const f=this.resultSize(l);this.resultCount+=f,(f>0||!p(l))&&this.collector.add(l,c)}};Promise.all(D.map((l,c)=>this.searchInFolder(l,b=>v(b,c),i.token))).then(l=>{i.dispose(),this.collector.flush();const c=l.some(b=>!!b&&!!b.limitHit);g({limitHit:this.isLimitHit||c,messages:(0,d.flatten)(l.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},l=>{i.dispose();const c=(0,_.toErrorMessage)(l);a(new Error(c))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,h){const D=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:D.slice(0,h),preview:{matches:i.slice(0,h),text:o.preview.text},uri:o.uri}}async searchInFolder(o,h,D){const i=new S.QueryGlobTester(this.query,o),g=[],a={report:l=>{if(!this.validateProviderResult(l))return;const c=o.folder.scheme===F.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(l.uri))):void 0,b=C.relativePath(o.folder,l.uri);if(b){const f=i.includedInQuery(b,P.basename(b),c);(0,T.isPromise)(f)?g.push(f.then(y=>{y&&h(l)})):f&&h(l)}}},r=this.getSearchOptionsForFolder(o),v=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,a,D);return g.length&&await Promise.all(g),v}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const h=(0,S.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),D=(0,S.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:D,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class s{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,h=>this.sendItems(h))}add(o,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!C.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(u(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=s;function u(w){return p(w)?{preview:{matches:(0,d.mapArrayOrNot)(w.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:w.preview.text},ranges:(0,d.mapArrayOrNot)(w.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function p(w){return!!w.preview}e.extensionResultIsMatch=p;class k{constructor(o,h){this.maxBatchSize=o,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,h){!o||this.addItemToBatch(o,h)}addItems(o,h){!o||this.addItemsToBatch(o,h)}addItemToBatch(o,h){this.batch.push(o),this.batchSize+=h,this.onUpdate()}addItemsToBatch(o,h){this.batch=this.batch.concat(o),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,13,66,15,2,222]),function(oe,e,d,M,_,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let S=class{constructor(u,p,k){this.extHostRpc=u,this._uriTransformer=p,this._logService=k,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,p){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const k=this._handlePool++;return this._textSearchProvider.set(k,p),this._proxy.$registerTextSearchProvider(k,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(u,p){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const k=this._handlePool++;return this._fileSearchProvider.set(k,p),this._proxy.$registerFileSearchProvider(k,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(u,p,k,w){const o=n(k),h=this._fileSearchProvider.get(u);if(h)return this._fileSearchManager.fileSearch(o,h,D=>{this._proxy.$handleFileMatch(u,p,D.map(i=>i.resource))},w);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,p,k,w){const o=this._textSearchProvider.get(u);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const h=n(k);return this.createTextSearchManager(h,o).search(i=>this._proxy.$handleTextMatch(u,p,i),w)}$enableExtensionHostSearch(){}createTextSearchManager(u,p){return new t.TextSearchManager(u,p,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};S=$e([ze(0,F.IExtHostRpcService),ze(1,P.IURITransformerService),ze(2,C.ILogService)],S),e.ExtHostSearch=S;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(m),extraFileResources:s.extraFileResources&&s.extraFileResources.map(u=>T.URI.revive(u))}}e.reviveQuery=n;function m(s){return{...s,folder:T.URI.revive(s.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,116,80,112,56,60,5,184,183,39,185,32,186,187,188,170,189,50,33,190,171,193,195,196,96,173,201,202,203,73,40,205,174,8,7,208,51,97,31,30,52,159,192,63,95,99,100,101,15,66,13,29,197,156,65,70,181,206,155,74,72,211,209,210,182,37,204,207,69,71,87,199,98,200,11,144,198,153,191]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o,h,D,i,g,a,r,v,l,c,b,f,y,R,I,L,E,N,U,B,G,H,W,ne,V,Y,j,le,re,ve,Fe,Me,Oe,Ke,je,Ve,$,Q,ee,ae,K,se,he,Ae,Ue,He,Qe,et,st,ye,nt,q,Z,pe,We,Ye,rt,mt,ut,St,Tt,It,Xe,vt,Pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(te){const ue=te.get(ee.IExtHostInitDataService),me=te.get(Z.IExtHostFileSystemInfo),fe=te.get(et.IExtHostConsumerFileSystem),Ie=te.get(a.IExtHostExtensionService),Be=te.get(Y.IExtHostWorkspace),Ne=te.get(mt.IExtHostTelemetry),qe=te.get(k.IExtHostConfiguration),it=te.get($.IURITransformerService),Le=te.get(Q.IExtHostRpcService),de=te.get(E.IExtHostStorage),ge=te.get(Qe.IExtensionStoragePaths),X=te.get(Ve.ILogService),z=te.get(se.IExtHostTunnelService),we=te.get(he.IExtHostApiDeprecationService),ke=te.get(V.IExtHostWindow),Je=te.get(Ye.IExtHostSecretState),xe=te.get(rt.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,me),Le.set(n.ExtHostContext.ExtHostLogService,X),Le.set(n.ExtHostContext.ExtHostWorkspace,Be),Le.set(n.ExtHostContext.ExtHostConfiguration,qe),Le.set(n.ExtHostContext.ExtHostExtensionService,Ie),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,z),Le.set(n.ExtHostContext.ExtHostWindow,ke),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Ne),Le.set(n.ExtHostContext.ExtHostEditorTabs,xe);const ct=Le.set(n.ExtHostContext.ExtHostDecorations,te.get(Me.IExtHostDecorations)),pt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,te.get(g.IExtHostDocumentsAndEditors)),dt=Le.set(n.ExtHostContext.ExtHostCommands,te.get(u.IExtHostCommands)),ht=Le.set(n.ExtHostContext.ExtHostTerminalService,te.get(N.IExtHostTerminalService)),ft=Le.set(n.ExtHostContext.ExtHostDebugService,te.get(Ke.IExtHostDebugService)),_t=Le.set(n.ExtHostContext.ExtHostSearch,te.get(je.IExtHostSearch)),yt=Le.set(n.ExtHostContext.ExtHostTask,te.get(Oe.IExtHostTask)),Pt=Le.set(n.ExtHostContext.ExtHostOutputService,te.get(f.IExtHostOutputService)),Nt=Le.set(n.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(Le)),Ct=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,pt)),xt=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Le,pt,X)),$t=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new D.ExtHostDocumentSaveParticipant(X,Ct,Le.getProxy(n.MainContext.MainThreadBulkEdits))),bt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,dt,pt,Ct,ge)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(X,bt)),zt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new vt.ExtHostNotebookEditors(X,Le,bt)),ii=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new ut.ExtHostNotebookKernels(Le,ue,bt,dt,X)),ni=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Tt.ExtHostNotebookRenderers(Le,bt)),At=Le.set(n.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Le,pt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),dt,X)),ri=Le.set(n.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),At,ue)),Jt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Le,X,me)),Wt=Le.set(n.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Le,Ct,dt.converter,it)),gt=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Le,it,Ct,dt,Jt,X,we)),si=Le.set(n.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Le,gt)),Mt=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Le,X,pt)),Vt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Le,Be,dt)),Xt=Le.set(n.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(Le,dt,X)),oi=Le.set(n.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Le,dt,Ct)),di=Le.set(n.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),wi=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),hi=Le.set(n.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Le)),Zt=Le.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(Le)),bi=Le.set(n.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(Le,dt)),jt=Le.set(n.ExtHostContext.ExtHostWebviews,new ne.ExtHostWebviews(Le,{remote:ue.remote},Be,X,we)),qt=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new nt.ExtHostWebviewPanels(Le,jt,Be)),Ei=Le.set(n.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Le,Ct,ge,jt,qt)),_i=Le.set(n.ExtHostContext.ExtHostWebviewViews,new st.ExtHostWebviewViews(Le,jt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new pe.ExtHostTesting(Le,dt)),yi=Le.set(n.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(Le,bt,pt,dt));const ei=(0,le.values)(n.ExtHostContext);Le.assertRegistered(ei);const Si=new q.ExtHostBulkEdits(Le,pt),Di=new s.ExtHostClipboard(Le),Kt=new b.ExtHostMessageService(Le,X),fi=new o.ExtHostDialogs(Le),Ht=new L.ExtHostStatusBar(Le,dt.converter);return m.ExtHostApiCommands.register(dt),function(Te,ai,Ft){const wt=function(){let J=!Te.isUnderDevelopment;function ce(De){J||(X.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function De(at){if(Array.isArray(at))at.forEach(De);else if(typeof at=="string")ce(at);else{const Et=at;typeof Et.scheme=="undefined"&&ce(at),!Te.enableProposedApi&&typeof Et.exclusive=="boolean"&&(0,j.throwProposedApiError)(Te)}return at}}(),Ci={getSession(J,ce,De){return(De?.forceNewSession||De?.silent)&&(0,j.checkProposedApiEnabled)(Te),Zt.getSession(Te,J,ce,De)},async hasSession(J,ce){return(0,j.checkProposedApiEnabled)(Te),!!await Zt.getSession(Te,J,ce,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(J,ce,De,at){return Zt.registerAuthenticationProvider(J,ce,De,at)}},ki={registerCommand(J,ce,De){return dt.registerCommand(!0,J,ce,De,void 0,Te)},registerTextEditorCommand(J,ce,De){return dt.registerCommand(!0,J,(...at)=>{const Et=At.getActiveTextEditor();if(!Et){X.warn("Cannot execute "+J+" because there is no active text editor.");return}return Et.edit(kt=>{ce.apply(De,[Et,kt,...at])}).then(kt=>{kt||X.warn("Edits from command "+J+" were not applied.")},kt=>{X.warn("An error occurred while running command "+J,kt)})},void 0,void 0,Te)},registerDiffInformationCommand:(J,ce,De)=>((0,j.checkProposedApiEnabled)(Te),dt.registerCommand(!0,J,async(...at)=>{const Et=pt.activeEditor(!0);if(!Et){X.warn("Cannot execute "+J+" because there is no active text editor.");return}const kt=await At.getDiffInformation(Et.id);ce.apply(De,[kt,...at])},void 0,void 0,Te)),executeCommand(J,...ce){return dt.executeCommand(J,...ce)},getCommands(J=!1){return dt.getCommands(J)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return ht.getDefaultShell(!1)},get isTelemetryEnabled(){return Ne.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ne.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ce){return ke.openUri(J,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ue.environment.appUriScheme)return Nt.createAppUri(J);try{return await ke.asExternalUri(J,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(J,It.Schemas.http)||(0,Xe.matchesScheme)(J,It.Schemas.https))return J;throw ce}},get remoteName(){return(0,Fe.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,j.checkProposedApiEnabled)(Te),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ii={createTestController(J,ce){return Gt.createTestController(J,ce)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Te),Gt.createTestObserver()},runTests(J){return(0,j.checkProposedApiEnabled)(Te),Gt.runTests(J)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Te),Gt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Te),Gt.results}},Pi={getExtension(J){const ce=ai.getExtensionDescription(J);if(ce)return new a.Extension(Ie,Te.identifier,ce,gi)},get all(){return ai.getAllExtensionDescriptions().map(J=>new a.Extension(Ie,Te.identifier,J,gi))},get onDidChange(){return ai.onDidChange}},Ti={createDiagnosticCollection(J){return Jt.createDiagnosticCollection(Te.identifier,J)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:J=>Jt.getDiagnostics(J),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(J,ce){return Wt.changeLanguage(J.uri,ce)},match(J,ce){return(0,t.score)(G.LanguageSelector.from(J),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(J,ce,De){return gt.registerCodeActionProvider(Te,wt(J),ce,De)},registerCodeLensProvider(J,ce){return gt.registerCodeLensProvider(Te,wt(J),ce)},registerDefinitionProvider(J,ce){return gt.registerDefinitionProvider(Te,wt(J),ce)},registerDeclarationProvider(J,ce){return gt.registerDeclarationProvider(Te,wt(J),ce)},registerImplementationProvider(J,ce){return gt.registerImplementationProvider(Te,wt(J),ce)},registerTypeDefinitionProvider(J,ce){return gt.registerTypeDefinitionProvider(Te,wt(J),ce)},registerHoverProvider(J,ce){return gt.registerHoverProvider(Te,wt(J),ce,Te.identifier)},registerEvaluatableExpressionProvider(J,ce){return gt.registerEvaluatableExpressionProvider(Te,wt(J),ce,Te.identifier)},registerInlineValuesProvider(J,ce){return gt.registerInlineValuesProvider(Te,wt(J),ce,Te.identifier)},registerDocumentHighlightProvider(J,ce){return gt.registerDocumentHighlightProvider(Te,wt(J),ce)},registerLinkedEditingRangeProvider(J,ce){return gt.registerLinkedEditingRangeProvider(Te,wt(J),ce)},registerReferenceProvider(J,ce){return gt.registerReferenceProvider(Te,wt(J),ce)},registerRenameProvider(J,ce){return gt.registerRenameProvider(Te,wt(J),ce)},registerDocumentSymbolProvider(J,ce,De){return gt.registerDocumentSymbolProvider(Te,wt(J),ce,De)},registerWorkspaceSymbolProvider(J){return gt.registerWorkspaceSymbolProvider(Te,J)},registerDocumentFormattingEditProvider(J,ce){return gt.registerDocumentFormattingEditProvider(Te,wt(J),ce)},registerDocumentRangeFormattingEditProvider(J,ce){return gt.registerDocumentRangeFormattingEditProvider(Te,wt(J),ce)},registerOnTypeFormattingEditProvider(J,ce,De,...at){return gt.registerOnTypeFormattingEditProvider(Te,wt(J),ce,[De].concat(at))},registerDocumentSemanticTokensProvider(J,ce,De){return gt.registerDocumentSemanticTokensProvider(Te,wt(J),ce,De)},registerDocumentRangeSemanticTokensProvider(J,ce,De){return gt.registerDocumentRangeSemanticTokensProvider(Te,wt(J),ce,De)},registerSignatureHelpProvider(J,ce,De,...at){return typeof De=="object"?gt.registerSignatureHelpProvider(Te,wt(J),ce,De):gt.registerSignatureHelpProvider(Te,wt(J),ce,typeof De=="undefined"?[]:[De,...at])},registerCompletionItemProvider(J,ce,...De){return gt.registerCompletionItemProvider(Te,wt(J),ce,De)},registerInlineCompletionItemProvider(J,ce){return(0,j.checkProposedApiEnabled)(Te),gt.registerInlineCompletionsProvider(Te,wt(J),ce)},registerDocumentLinkProvider(J,ce){return gt.registerDocumentLinkProvider(Te,wt(J),ce)},registerColorProvider(J,ce){return gt.registerColorProvider(Te,wt(J),ce)},registerFoldingRangeProvider(J,ce){return gt.registerFoldingRangeProvider(Te,wt(J),ce)},registerSelectionRangeProvider(J,ce){return gt.registerSelectionRangeProvider(Te,J,ce)},registerCallHierarchyProvider(J,ce){return gt.registerCallHierarchyProvider(Te,J,ce)},registerTypeHierarchyProvider(J,ce){return gt.registerTypeHierarchyProvider(Te,J,ce)},setLanguageConfiguration:(J,ce)=>gt.setLanguageConfiguration(Te,J,ce),getTokenInformationAtPosition(J,ce){return(0,j.checkProposedApiEnabled)(Te),Wt.tokenAtPosition(J,ce)},registerInlayHintsProvider(J,ce){return(0,j.checkProposedApiEnabled)(Te),gt.registerInlayHintsProvider(Te,J,ce)},createLanguageStatusItem(J,ce){return(0,j.checkProposedApiEnabled)(Te),Wt.createLanguageStatusItem(Te,J,ce)}},li={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(J,ce,De){const at=await(F.URI.isUri(J)?Promise.resolve(pi.openTextDocument(J)):Promise.resolve(J));return At.showTextDocument(at,ce,De)},createTextEditorDecorationType(J){return At.createTextEditorDecorationType(Te,J)},onDidChangeActiveTextEditor(J,ce,De){return At.onDidChangeActiveTextEditor(J,ce,De)},onDidChangeVisibleTextEditors(J,ce,De){return At.onDidChangeVisibleTextEditors(J,ce,De)},onDidChangeTextEditorSelection(J,ce,De){return At.onDidChangeTextEditorSelection(J,ce,De)},onDidChangeTextEditorOptions(J,ce,De){return At.onDidChangeTextEditorOptions(J,ce,De)},onDidChangeTextEditorVisibleRanges(J,ce,De){return At.onDidChangeTextEditorVisibleRanges(J,ce,De)},onDidChangeTextEditorViewColumn(J,ce,De){return At.onDidChangeTextEditorViewColumn(J,ce,De)},onDidCloseTerminal(J,ce,De){return ht.onDidCloseTerminal(J,ce,De)},onDidOpenTerminal(J,ce,De){return ht.onDidOpenTerminal(J,ce,De)},onDidChangeActiveTerminal(J,ce,De){return ht.onDidChangeActiveTerminal(J,ce,De)},onDidChangeTerminalDimensions(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),ht.onDidChangeTerminalDimensions(J,ce,De)},onDidChangeTerminalState(J,ce,De){return ht.onDidChangeTerminalState(J,ce,De)},onDidWriteTerminalData(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),ht.onDidWriteTerminalData(J,ce,De)},get state(){return ke.state},onDidChangeWindowState(J,ce,De){return ke.onDidChangeWindowState(J,ce,De)},showInformationMessage(J,...ce){return Kt.showMessage(Te,A.default.Info,J,ce[0],ce.slice(1))},showWarningMessage(J,...ce){return Kt.showMessage(Te,A.default.Warning,J,ce[0],ce.slice(1))},showErrorMessage(J,...ce){return Kt.showMessage(Te,A.default.Error,J,ce[0],ce.slice(1))},showQuickPick(J,ce,De){return Vt.showQuickPick(J,!!Te.enableProposedApi,ce,De)},showWorkspaceFolderPick(J){return Vt.showWorkspaceFolderPick(J)},showInputBox(J,ce){return Vt.showInput(J,ce)},showOpenDialog(J){return fi.showOpenDialog(J)},showSaveDialog(J){return fi.showSaveDialog(J)},createStatusBarItem(J,ce,De){let at,Et,kt;return typeof J=="string"?(at=J,Et=ce,kt=De):(Et=J,kt=ce),Ht.createStatusBarEntry(Te,at,Et,kt)},setStatusBarMessage(J,ce){return Ht.setStatusBarMessage(J,ce)},withScmProgress(J){return we.report("window.withScmProgress",Te,"Use 'withProgress' instead."),di.withProgress(Te,{location:H.ProgressLocation.SourceControl},(ce,De)=>J({report(at){}}))},withProgress(J,ce){return di.withProgress(Te,J,ce)},createOutputChannel(J){return Pt.createOutputChannel(J,Te)},createWebviewPanel(J,ce,De,at){return qt.createWebviewPanel(Te,J,ce,De,at)},createWebviewTextEditorInset(J,ce,De,at){return(0,j.checkProposedApiEnabled)(Te),ri.createWebviewEditorInset(J,ce,De,at,Te)},createTerminal(J,ce,De){return typeof J=="object"?("location"in J&&(0,j.checkProposedApiEnabled)(Te),"pty"in J?ht.createExtensionTerminal(J):ht.createTerminalFromOptions(J)):ht.createTerminal(J,ce,De)},registerTerminalLinkProvider(J){return ht.registerLinkProvider(J)},registerTerminalProfileProvider(J,ce){return ht.registerProfileProvider(Te,J,ce)},registerTreeDataProvider(J,ce){return Yt.registerTreeDataProvider(J,ce,Te)},createTreeView(J,ce){return Yt.createTreeView(J,ce,Te)},registerWebviewPanelSerializer:(J,ce)=>qt.registerWebviewPanelSerializer(Te,J,ce),registerCustomEditorProvider:(J,ce,De={})=>Ei.registerCustomEditorProvider(Te,J,ce,De),registerFileDecorationProvider(J){return ct.registerFileDecorationProvider(J,Te.identifier)},registerUriHandler(J){return Nt.registerUriHandler(Te.identifier,J)},createQuickPick(){return Vt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Vt.createInputBox(Te.identifier)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(J,ce,De){return hi.onDidChangeActiveColorTheme(J,ce,De)},registerWebviewViewProvider(J,ce,De){return _i.registerWebviewViewProvider(Te,J,ce,De?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Te),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeActiveNotebookEditor(J,ce,De)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),zt.onDidChangeNotebookEditorSelection(J,ce,De)},onDidChangeNotebookEditorVisibleRanges(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),zt.onDidChangeNotebookEditorVisibleRanges(J,ce,De)},showNotebookDocument(J,ce){return(0,j.checkProposedApiEnabled)(Te),bt.showNotebookDocument(J,ce)},registerExternalUriOpener(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),yi.registerExternalUriOpener(Te.identifier,J,ce,De)},get tabs(){return(0,j.checkProposedApiEnabled)(Te),xe.tabs},get activeTab(){return(0,j.checkProposedApiEnabled)(Te),xe.activeTab},get onDidChangeTabs(){return(0,j.checkProposedApiEnabled)(Te),xe.onDidChangeTabs},get onDidChangeActiveTab(){return(0,j.checkProposedApiEnabled)(Te),xe.onDidChangeActiveTab},getInlineCompletionItemController(J){return(0,j.checkProposedApiEnabled)(Te),l.InlineCompletionController.get(J)}},pi={get rootPath(){return we.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(J){throw M.readonly()},getWorkspaceFolder(J){return Be.getWorkspaceFolder(J)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(J){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(J){throw M.readonly()},updateWorkspaceFolders:(J,ce,...De)=>Be.updateWorkspaceFolders(Te,J,ce||0,...De),onDidChangeWorkspaceFolders:function(J,ce,De){return Be.onDidChangeWorkspace(J,ce,De)},asRelativePath:(J,ce)=>Be.getRelativePath(J,ce),findFiles:(J,ce,De,at)=>Be.findFiles(G.GlobPattern.from(J),G.GlobPattern.from(ce),De,Te.identifier,at),findTextInFiles:(J,ce,De,at)=>{let Et,kt;return typeof ce=="object"?(Et=ce,kt=De):(Et={},kt=ce,at=De),Be.findTextInFiles(J,Et||{},kt,Te.identifier,at)},saveAll:J=>Be.saveAll(J),applyEdit(J){return Si.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ce,De,at)=>Mt.createFileSystemWatcher(G.GlobPattern.from(J),ce,De,at),get textDocuments(){return Ct.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw M.readonly()},openTextDocument(J){let ce;const De=J;if(typeof J=="string")ce=Promise.resolve(F.URI.file(J));else if(F.URI.isUri(J))ce=Promise.resolve(J);else if(!De||typeof De=="object")ce=Ct.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(at=>Ct.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(J,ce,De)=>Ct.onDidAddDocument(J,ce,De),onDidCloseTextDocument:(J,ce,De)=>Ct.onDidRemoveDocument(J,ce,De),onDidChangeTextDocument:(J,ce,De)=>Ct.onDidChangeDocument(J,ce,De),onDidSaveTextDocument:(J,ce,De)=>Ct.onDidSaveDocument(J,ce,De),onWillSaveTextDocument:(J,ce,De)=>$t.getOnWillSaveTextDocumentEvent(Te)(J,ce,De),get notebookDocuments(){return bt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ce){let De;if(F.URI.isUri(J))De=J,await bt.openNotebookDocument(J);else if(typeof J=="string")De=F.URI.revive(await bt.createNotebookDocument({viewType:J,content:ce}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ce,De,at){return bt.registerNotebookSerializer(Te,J,ce,De,Te.enableProposedApi?at:void 0)},registerNotebookContentProvider:(J,ce,De,at)=>((0,j.checkProposedApiEnabled)(Te),bt.registerNotebookContentProvider(Te,J,ce,De,Te.enableProposedApi?at:void 0)),onDidChangeConfiguration:(J,ce,De)=>Ft.onDidChangeConfiguration(J,ce,De),getConfiguration(J,ce){return ce=arguments.length===1?void 0:ce,Ft.getConfiguration(J,ce,Te)},registerTextDocumentContentProvider(J,ce){return xt.registerTextDocumentContentProvider(J,ce)},registerTaskProvider:(J,ce)=>(we.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Te,J,ce)),registerFileSystemProvider(J,ce,De){return si.registerFileSystemProvider(Te.identifier,J,ce,De)},get fs(){return fe.value},registerFileSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),_t.registerFileSearchProvider(J,ce)),registerTextSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),_t.registerTextSearchProvider(J,ce)),registerRemoteAuthorityResolver:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),Ie.registerRemoteAuthorityResolver(J,ce)),registerResourceLabelFormatter:J=>((0,j.checkProposedApiEnabled)(Te),wi.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ce,De)=>Mt.onDidCreateFile(J,ce,De),onDidDeleteFiles:(J,ce,De)=>Mt.onDidDeleteFile(J,ce,De),onDidRenameFiles:(J,ce,De)=>Mt.onDidRenameFile(J,ce,De),onWillCreateFiles:(J,ce,De)=>Mt.getOnWillCreateFileEvent(Te)(J,ce,De),onWillDeleteFiles:(J,ce,De)=>Mt.getOnWillDeleteFileEvent(Te)(J,ce,De),onWillRenameFiles:(J,ce,De)=>Mt.getOnWillRenameFileEvent(Te)(J,ce,De),openTunnel:J=>((0,j.checkProposedApiEnabled)(Te),z.openTunnel(Te,J).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,j.checkProposedApiEnabled)(Te),z.getTunnels()},onDidChangeTunnels:(J,ce,De)=>((0,j.checkProposedApiEnabled)(Te),z.onDidChangeTunnels(J,ce,De)),registerPortAttributesProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),z.registerPortsAttributesProvider(J,ce)),registerTimelineProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),bi.registerTimelineProvider(J,ce,Te.identifier,dt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:J=>((0,j.checkProposedApiEnabled)(Te),Be.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ce,De)=>Be.onDidGrantWorkspaceTrust(J,ce,De)},Ai={get inputBox(){return we.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Te)},createSourceControl(J,ce,De){return Xt.createSourceControl(Te,J,ce,De)}},Ri={createCommentController(J,ce){return oi.createCommentController(Te,J,ce)}},Fi={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(J,ce,De){return ft.onDidStartDebugSession(J,ce,De)},onDidTerminateDebugSession(J,ce,De){return ft.onDidTerminateDebugSession(J,ce,De)},onDidChangeActiveDebugSession(J,ce,De){return ft.onDidChangeActiveDebugSession(J,ce,De)},onDidReceiveDebugSessionCustomEvent(J,ce,De){return ft.onDidReceiveDebugSessionCustomEvent(J,ce,De)},onDidChangeBreakpoints(J,ce,De){return ft.onDidChangeBreakpoints(J,ce,De)},registerDebugConfigurationProvider(J,ce,De){return ft.registerDebugConfigurationProvider(J,ce,De||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ce){return ft.registerDebugAdapterDescriptorFactory(Te,J,ce)},registerDebugAdapterTrackerFactory(J,ce){return ft.registerDebugAdapterTrackerFactory(J,ce)},startDebugging(J,ce,De){return!De||typeof De=="object"&&"configuration"in De?ft.startDebugging(J,ce,{parentSession:De}):ft.startDebugging(J,ce,De||{})},stopDebugging(J){return ft.stopDebugging(J)},addBreakpoints(J){return ft.addBreakpoints(J)},removeBreakpoints(J){return ft.removeBreakpoints(J)},asDebugSourceUri(J,ce){return ft.asDebugSourceUri(J,ce)}},Mi={registerTaskProvider:(J,ce)=>yt.registerTaskProvider(Te,J,ce),fetchTasks:J=>yt.fetchTasks(J),executeTask:J=>yt.executeTask(Te,J),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(J,ce,De)=>yt.onDidStartTask(J,ce,De),onDidEndTask:(J,ce,De)=>yt.onDidEndTask(J,ce,De),onDidStartTaskProcess:(J,ce,De)=>yt.onDidStartTaskProcess(J,ce,De),onDidEndTaskProcess:(J,ce,De)=>yt.onDidEndTaskProcess(J,ce,De)},Li={createNotebookController(J,ce,De,at,Et){return ii.createNotebookController(Te,J,ce,De,at,Te.enableProposedApi?Et:void 0)},registerNotebookCellStatusBarItemProvider:(J,ce)=>bt.registerNotebookCellStatusBarItemProvider(Te,J,ce),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Te),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,j.checkProposedApiEnabled)(Te),zt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ni.createRendererMessaging(Te,J)},onDidChangeNotebookDocumentMetadata(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),Qt.onDidChangeNotebookDocumentMetadata(J,ce,De)},onDidChangeNotebookCells(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeNotebookCells(J,ce,De)},onDidChangeNotebookCellExecutionState(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeNotebookCellExecutionState(J,ce,De)},onDidChangeCellOutputs(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeCellOutputs(J,ce,De)},onDidChangeCellMetadata(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeCellMetadata(J,ce,De)},createConcatTextDocument(J,ce){return(0,j.checkProposedApiEnabled)(Te),new He.ExtHostNotebookConcatDocument(bt,Ct,J,ce)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:Ti,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:li,workspace:pi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:T.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:St.TextSearchCompleteMessageType,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[224],Ee([0,1,57,96,31,95,32,39,50,40,99,100,101,73,65,70,97,72,37,69,87,71]),function(oe,e,d,M,_,A,F,P,C,T,t,S,n,m,s,u,p,k,w,o,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,d.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,d.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,d.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,d.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,d.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,d.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,d.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,12,5,11]),function(oe,e,d,M,_,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(s){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(k,...w)=>{w.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=w.slice(0,-1).join(","),h=w.pop().toString();return`(function anonymous(${o}) {${h}
})`}});function p(...k){return u?self.eval(u.createScript("",...k)):new Function(...k)}s.create=p})(T||(T={}));class t extends _.RequireInterceptor{_installInterceptor(){}getModule(u,p){for(let k of this._alternatives){let w=k(u);if(w){u=w;break}}if(this._factories.has(u))return this._factories.get(u).load(u,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class S extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);m(u,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,p,k){p=p.with({path:n(p.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const w=await fetch(C.FileAccess.asBrowserUri(p).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),w.status!==200)throw new Error(w.statusText);const o=await w.text(),h=`${p.toString(!0)}#vscode-extension`,D=`${o}
//# sourceURL=${h}`;let i;try{i=T.create(S._ttpExtensionScripts?.createScript("module")??"module",S._ttpExtensionScripts?.createScript("exports")??"exports",S._ttpExtensionScripts?.createScript("require")??"require",S._ttpExtensionScripts?.createScript(D)??D)}catch(v){throw console.error(u?`Loading code for extension ${u.value} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}const g={},a={exports:g},r=v=>{const l=this._fakeModules.getModule(v,p);if(l===void 0)throw new Error(`Cannot load module '${v}'`);return l};try{return k.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),i(a,g,r),a.exports!==g?a.exports:g}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),k.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+u;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=S,S._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,u){return s.endsWith(u)?s:s+u}function m(s,u){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(o,h){const D=console[o];console[o]=function(){s.$logExtensionHostMessage({type:"__$console",severity:h,arguments:w(arguments)}),u&&D.apply(console,arguments)}}const k=1e5;function w(o){const h=[],D=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const g=o[i];g.stack?o[i]=g.stack:o[i]=g.toString()}D.push(o[i])}try{const i=JSON.stringify(D,function(g,a){if(a&&typeof a=="object"){if(h.indexOf(a)!==-1)return"[Circular]";h.push(a)}return a});return i.length>k?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,74,225,212]),function(oe,e,d,M,_,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(_.IExtHostExtensionService,F.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,P.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[235],Ee([0,1,22,3,178,220,214,17,75,11,2,224,226]),function(oe,e,d,M,_,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(o,h){return o instanceof Request||/^file:/i.test(String(o))&&(o=T.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),m(o,h)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,h,D,i,g){return/^file:/i.test(h.toString())&&(h=T.FileAccess.asBrowserUri(t.URI.parse(h.toString())).toString(!0)),super.open(o,h,D??!0,i,g)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:D=>D}),h=self.Worker;Worker=function(D,i){/^file:/i.test(D.toString())&&(D=T.FileAccess.asBrowserUri(t.URI.parse(D.toString())).toString(!0));const a=`(${function(c){function b(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const f=fetch.bind(self);self.fetch=function(I,L){return I instanceof Request?f(I,L):f(b(I),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,L,E,N,U){return super.open(I,b(L),E??!0,N,U)}};const y=importScripts.bind(self);self.importScripts=(...I)=>{y(...I.map(b))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:I=>I}):void 0;y(R?R.createScriptURL(c):c)}.toString()}('${D}'))`;i=i||{},i.name=i.name||P.basename(D.toString());const r=new Blob([a],{type:"application/javascript"}),v=URL.createObjectURL(r);return new h(o?o.createScriptURL(v):v,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,h){super(n,o,{name:P.basename(o.toString()),...h})}};const s=new class{constructor(){this.pid=void 0}exit(o){S()}async exists(o){return!0}async realpath(o){return o}};class u{constructor(){const h=new MessageChannel,D=new M.Emitter;let i=!1;n(h.port2,[h.port2]),h.port1.onmessage=g=>{const{data:a}=g;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const r=d.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,_.isMessageOfType)(r,2)){i=!0,k("received terminate message from renderer");return}D.fire(r)},this.protocol={onMessage:D.event,send:g=>{if(!i){const a=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);h.port1.postMessage(a,[a])}}}}}function p(o){return new Promise(h=>{const D=o.onMessage(i=>{D.dispose();const g=JSON.parse(i.toString());o.send((0,_.createMessageOfType)(0)),h({protocol:o,initData:g})});o.send((0,_.createMessageOfType)(1))})}let k=o=>S();function w(){const o=new u;C.mark("code/extHost/willConnectToRenderer"),p(o.protocol).then(h=>{C.mark("code/extHost/didWaitForInitData");const D=new A.ExtensionHostMain(h.protocol,h.initData,s,null);k=i=>D.terminate(i)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc1a6699060423b8c4d2ced736ad70195378fddf/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
